/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/import/chips/p9/common/include/p9n2_quad_scom_addresses.H $ */
/*                                                                        */
/* OpenPOWER sbe Project                                                  */
/*                                                                        */
/* Contributors Listed Below - COPYRIGHT 2017                             */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
///
/// @file p9_quad_scom_addresses.H
/// @brief  Defines constants for scom addresses
///
// *HWP HWP Owner: Ben Gass <bgass@us.ibm.com>
// *HWP FW Owner: Thi Tran <thi@us.ibm.com>
// *HWP Team: SOA
// *HWP Level: 1
// *HWP Consumed by: FSP:HB:HS:OCC:SBE:CME:SGPE:PGPE:FPPE:IPPE

/*---------------------------------------------------------------
 *
 *---------------------------------------------------------------
 *
 *---------------------------------------------------------------
 */


#ifndef __P9N2_QUAD_SCOM_ADDRESSES_H
#define __P9N2_QUAD_SCOM_ADDRESSES_H

#include <stdint.h>


static const uint64_t P9N2_C_ADDR_TRAP_REG                                         = 0x20010003ull;

static const uint64_t P9N2_C_0_ADDR_TRAP_REG                                       = 0x20010003ull;

static const uint64_t P9N2_C_1_ADDR_TRAP_REG                                       = 0x21010003ull;

static const uint64_t P9N2_C_2_ADDR_TRAP_REG                                       = 0x22010003ull;

static const uint64_t P9N2_C_3_ADDR_TRAP_REG                                       = 0x23010003ull;

static const uint64_t P9N2_C_4_ADDR_TRAP_REG                                       = 0x24010003ull;

static const uint64_t P9N2_C_5_ADDR_TRAP_REG                                       = 0x25010003ull;

static const uint64_t P9N2_C_6_ADDR_TRAP_REG                                       = 0x26010003ull;

static const uint64_t P9N2_C_7_ADDR_TRAP_REG                                       = 0x27010003ull;

static const uint64_t P9N2_C_8_ADDR_TRAP_REG                                       = 0x28010003ull;

static const uint64_t P9N2_C_9_ADDR_TRAP_REG                                       = 0x29010003ull;

static const uint64_t P9N2_C_10_ADDR_TRAP_REG                                      = 0x2A010003ull;

static const uint64_t P9N2_C_11_ADDR_TRAP_REG                                      = 0x2B010003ull;

static const uint64_t P9N2_C_12_ADDR_TRAP_REG                                      = 0x2C010003ull;

static const uint64_t P9N2_C_13_ADDR_TRAP_REG                                      = 0x2D010003ull;

static const uint64_t P9N2_C_14_ADDR_TRAP_REG                                      = 0x2E010003ull;

static const uint64_t P9N2_C_15_ADDR_TRAP_REG                                      = 0x2F010003ull;

static const uint64_t P9N2_C_16_ADDR_TRAP_REG                                      = 0x30010003ull;

static const uint64_t P9N2_C_17_ADDR_TRAP_REG                                      = 0x31010003ull;

static const uint64_t P9N2_C_18_ADDR_TRAP_REG                                      = 0x32010003ull;

static const uint64_t P9N2_C_19_ADDR_TRAP_REG                                      = 0x33010003ull;

static const uint64_t P9N2_C_20_ADDR_TRAP_REG                                      = 0x34010003ull;

static const uint64_t P9N2_C_21_ADDR_TRAP_REG                                      = 0x35010003ull;

static const uint64_t P9N2_C_22_ADDR_TRAP_REG                                      = 0x36010003ull;

static const uint64_t P9N2_C_23_ADDR_TRAP_REG                                      = 0x37010003ull;

static const uint64_t P9N2_EQ_ADDR_TRAP_REG                                        = 0x10010003ull;

static const uint64_t P9N2_EQ_0_ADDR_TRAP_REG                                      = 0x10010003ull;

static const uint64_t P9N2_EQ_1_ADDR_TRAP_REG                                      = 0x11010003ull;

static const uint64_t P9N2_EQ_2_ADDR_TRAP_REG                                      = 0x12010003ull;

static const uint64_t P9N2_EQ_3_ADDR_TRAP_REG                                      = 0x13010003ull;

static const uint64_t P9N2_EQ_4_ADDR_TRAP_REG                                      = 0x14010003ull;

static const uint64_t P9N2_EQ_5_ADDR_TRAP_REG                                      = 0x15010003ull;

static const uint64_t P9N2_EX_ADDR_TRAP_REG                                        = 0x20010003ull;
//DUPS: 21010003,
static const uint64_t P9N2_EX_0_ADDR_TRAP_REG                                      = 0x20010003ull;
//DUPS: 21010003,
static const uint64_t P9N2_EX_1_ADDR_TRAP_REG                                      = 0x22010003ull;
//DUPS: 23010003,
static const uint64_t P9N2_EX_2_ADDR_TRAP_REG                                      = 0x24010003ull;
//DUPS: 25010003,
static const uint64_t P9N2_EX_3_ADDR_TRAP_REG                                      = 0x26010003ull;
//DUPS: 27010003,
static const uint64_t P9N2_EX_4_ADDR_TRAP_REG                                      = 0x28010003ull;
//DUPS: 29010003,
static const uint64_t P9N2_EX_5_ADDR_TRAP_REG                                      = 0x2A010003ull;
//DUPS: 2B010003,
static const uint64_t P9N2_EX_6_ADDR_TRAP_REG                                      = 0x2C010003ull;
//DUPS: 2D010003,
static const uint64_t P9N2_EX_7_ADDR_TRAP_REG                                      = 0x2F010003ull;
//DUPS: 2F010003,
static const uint64_t P9N2_EX_8_ADDR_TRAP_REG                                      = 0x30010003ull;
//DUPS: 31010003,
static const uint64_t P9N2_EX_9_ADDR_TRAP_REG                                      = 0x32010003ull;
//DUPS: 33010003,
static const uint64_t P9N2_EX_10_ADDR_TRAP_REG                                     = 0x34010003ull;
//DUPS: 35010003,
static const uint64_t P9N2_EX_11_ADDR_TRAP_REG                                     = 0x36010003ull;
//DUPS: 37010003,

static const uint64_t P9N2_C_ASSIST_INTERRUPT_REG                                  = 0x200F0011ull;

static const uint64_t P9N2_C_0_ASSIST_INTERRUPT_REG                                = 0x200F0011ull;

static const uint64_t P9N2_C_1_ASSIST_INTERRUPT_REG                                = 0x210F0011ull;

static const uint64_t P9N2_C_2_ASSIST_INTERRUPT_REG                                = 0x220F0011ull;

static const uint64_t P9N2_C_3_ASSIST_INTERRUPT_REG                                = 0x230F0011ull;

static const uint64_t P9N2_C_4_ASSIST_INTERRUPT_REG                                = 0x240F0011ull;

static const uint64_t P9N2_C_5_ASSIST_INTERRUPT_REG                                = 0x250F0011ull;

static const uint64_t P9N2_C_6_ASSIST_INTERRUPT_REG                                = 0x260F0011ull;

static const uint64_t P9N2_C_7_ASSIST_INTERRUPT_REG                                = 0x270F0011ull;

static const uint64_t P9N2_C_8_ASSIST_INTERRUPT_REG                                = 0x280F0011ull;

static const uint64_t P9N2_C_9_ASSIST_INTERRUPT_REG                                = 0x290F0011ull;

static const uint64_t P9N2_C_10_ASSIST_INTERRUPT_REG                               = 0x2A0F0011ull;

static const uint64_t P9N2_C_11_ASSIST_INTERRUPT_REG                               = 0x2B0F0011ull;

static const uint64_t P9N2_C_12_ASSIST_INTERRUPT_REG                               = 0x2C0F0011ull;

static const uint64_t P9N2_C_13_ASSIST_INTERRUPT_REG                               = 0x2D0F0011ull;

static const uint64_t P9N2_C_14_ASSIST_INTERRUPT_REG                               = 0x2E0F0011ull;

static const uint64_t P9N2_C_15_ASSIST_INTERRUPT_REG                               = 0x2F0F0011ull;

static const uint64_t P9N2_C_16_ASSIST_INTERRUPT_REG                               = 0x300F0011ull;

static const uint64_t P9N2_C_17_ASSIST_INTERRUPT_REG                               = 0x310F0011ull;

static const uint64_t P9N2_C_18_ASSIST_INTERRUPT_REG                               = 0x320F0011ull;

static const uint64_t P9N2_C_19_ASSIST_INTERRUPT_REG                               = 0x330F0011ull;

static const uint64_t P9N2_C_20_ASSIST_INTERRUPT_REG                               = 0x340F0011ull;

static const uint64_t P9N2_C_21_ASSIST_INTERRUPT_REG                               = 0x350F0011ull;

static const uint64_t P9N2_C_22_ASSIST_INTERRUPT_REG                               = 0x360F0011ull;

static const uint64_t P9N2_C_23_ASSIST_INTERRUPT_REG                               = 0x370F0011ull;

static const uint64_t P9N2_EQ_ASSIST_INTERRUPT_REG                                 = 0x100F0011ull;

static const uint64_t P9N2_EQ_0_ASSIST_INTERRUPT_REG                               = 0x100F0011ull;

static const uint64_t P9N2_EQ_1_ASSIST_INTERRUPT_REG                               = 0x110F0011ull;

static const uint64_t P9N2_EQ_2_ASSIST_INTERRUPT_REG                               = 0x120F0011ull;

static const uint64_t P9N2_EQ_3_ASSIST_INTERRUPT_REG                               = 0x130F0011ull;

static const uint64_t P9N2_EQ_4_ASSIST_INTERRUPT_REG                               = 0x140F0011ull;

static const uint64_t P9N2_EQ_5_ASSIST_INTERRUPT_REG                               = 0x150F0011ull;

static const uint64_t P9N2_EX_ASSIST_INTERRUPT_REG                                 = 0x200F0011ull;
//DUPS: 210F0011,
static const uint64_t P9N2_EX_0_ASSIST_INTERRUPT_REG                               = 0x200F0011ull;
//DUPS: 210F0011,
static const uint64_t P9N2_EX_1_ASSIST_INTERRUPT_REG                               = 0x220F0011ull;
//DUPS: 220F0011,
static const uint64_t P9N2_EX_2_ASSIST_INTERRUPT_REG                               = 0x240F0011ull;
//DUPS: 250F0011,
static const uint64_t P9N2_EX_3_ASSIST_INTERRUPT_REG                               = 0x260F0011ull;
//DUPS: 270F0011,
static const uint64_t P9N2_EX_4_ASSIST_INTERRUPT_REG                               = 0x280F0011ull;
//DUPS: 290F0011,
static const uint64_t P9N2_EX_5_ASSIST_INTERRUPT_REG                               = 0x2A0F0011ull;
//DUPS: 2B0F0011,
static const uint64_t P9N2_EX_6_ASSIST_INTERRUPT_REG                               = 0x2C0F0011ull;
//DUPS: 2D0F0011,
static const uint64_t P9N2_EX_7_ASSIST_INTERRUPT_REG                               = 0x2E0F0011ull;
//DUPS: 2F0F0011,
static const uint64_t P9N2_EX_8_ASSIST_INTERRUPT_REG                               = 0x300F0011ull;
//DUPS: 310F0011,
static const uint64_t P9N2_EX_9_ASSIST_INTERRUPT_REG                               = 0x320F0011ull;
//DUPS: 330F0011,
static const uint64_t P9N2_EX_10_ASSIST_INTERRUPT_REG                              = 0x340F0011ull;
//DUPS: 350F0011,
static const uint64_t P9N2_EX_11_ASSIST_INTERRUPT_REG                              = 0x360F0011ull;
//DUPS: 370F0011,

static const uint64_t P9N2_C_ATOMIC_LOCK_MASK_LATCH_REG                            = 0x20010007ull;

static const uint64_t P9N2_C_0_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x20010007ull;

static const uint64_t P9N2_C_1_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x21010007ull;

static const uint64_t P9N2_C_2_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x22010007ull;

static const uint64_t P9N2_C_3_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x23010007ull;

static const uint64_t P9N2_C_4_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x24010007ull;

static const uint64_t P9N2_C_5_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x25010007ull;

static const uint64_t P9N2_C_6_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x26010007ull;

static const uint64_t P9N2_C_7_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x27010007ull;

static const uint64_t P9N2_C_8_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x28010007ull;

static const uint64_t P9N2_C_9_ATOMIC_LOCK_MASK_LATCH_REG                          = 0x29010007ull;

static const uint64_t P9N2_C_10_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2A010007ull;

static const uint64_t P9N2_C_11_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2B010007ull;

static const uint64_t P9N2_C_12_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2C010007ull;

static const uint64_t P9N2_C_13_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2D010007ull;

static const uint64_t P9N2_C_14_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2E010007ull;

static const uint64_t P9N2_C_15_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2F010007ull;

static const uint64_t P9N2_C_16_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x30010007ull;

static const uint64_t P9N2_C_17_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x31010007ull;

static const uint64_t P9N2_C_18_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x32010007ull;

static const uint64_t P9N2_C_19_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x33010007ull;

static const uint64_t P9N2_C_20_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x34010007ull;

static const uint64_t P9N2_C_21_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x35010007ull;

static const uint64_t P9N2_C_22_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x36010007ull;

static const uint64_t P9N2_C_23_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x37010007ull;

static const uint64_t P9N2_EQ_ATOMIC_LOCK_MASK_LATCH_REG                           = 0x10010007ull;

static const uint64_t P9N2_EQ_0_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x10010007ull;

static const uint64_t P9N2_EQ_1_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x11010007ull;

static const uint64_t P9N2_EQ_2_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x12010007ull;

static const uint64_t P9N2_EQ_3_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x13010007ull;

static const uint64_t P9N2_EQ_4_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x14010007ull;

static const uint64_t P9N2_EQ_5_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x15010007ull;

static const uint64_t P9N2_EX_ATOMIC_LOCK_MASK_LATCH_REG                           = 0x20010007ull;
//DUPS: 21010007,
static const uint64_t P9N2_EX_0_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x20010007ull;
//DUPS: 21010007,
static const uint64_t P9N2_EX_1_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x22010007ull;
//DUPS: 23010007,
static const uint64_t P9N2_EX_2_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x24010007ull;
//DUPS: 25010007,
static const uint64_t P9N2_EX_3_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x26010007ull;
//DUPS: 27010007,
static const uint64_t P9N2_EX_4_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x28010007ull;
//DUPS: 29010007,
static const uint64_t P9N2_EX_5_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2A010007ull;
//DUPS: 2B010007,
static const uint64_t P9N2_EX_6_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2C010007ull;
//DUPS: 2D010007,
static const uint64_t P9N2_EX_7_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x2F010007ull;
//DUPS: 2F010007,
static const uint64_t P9N2_EX_8_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x30010007ull;
//DUPS: 31010007,
static const uint64_t P9N2_EX_9_ATOMIC_LOCK_MASK_LATCH_REG                         = 0x32010007ull;
//DUPS: 33010007,
static const uint64_t P9N2_EX_10_ATOMIC_LOCK_MASK_LATCH_REG                        = 0x34010007ull;
//DUPS: 35010007,
static const uint64_t P9N2_EX_11_ATOMIC_LOCK_MASK_LATCH_REG                        = 0x36010007ull;
//DUPS: 37010007,

static const uint64_t P9N2_C_ATOMIC_LOCK_REG                                       = 0x200F03FFull;

static const uint64_t P9N2_C_0_ATOMIC_LOCK_REG                                     = 0x200F03FFull;

static const uint64_t P9N2_C_1_ATOMIC_LOCK_REG                                     = 0x210F03FFull;

static const uint64_t P9N2_C_2_ATOMIC_LOCK_REG                                     = 0x220F03FFull;

static const uint64_t P9N2_C_3_ATOMIC_LOCK_REG                                     = 0x230F03FFull;

static const uint64_t P9N2_C_4_ATOMIC_LOCK_REG                                     = 0x240F03FFull;

static const uint64_t P9N2_C_5_ATOMIC_LOCK_REG                                     = 0x250F03FFull;

static const uint64_t P9N2_C_6_ATOMIC_LOCK_REG                                     = 0x260F03FFull;

static const uint64_t P9N2_C_7_ATOMIC_LOCK_REG                                     = 0x270F03FFull;

static const uint64_t P9N2_C_8_ATOMIC_LOCK_REG                                     = 0x280F03FFull;

static const uint64_t P9N2_C_9_ATOMIC_LOCK_REG                                     = 0x290F03FFull;

static const uint64_t P9N2_C_10_ATOMIC_LOCK_REG                                    = 0x2A0F03FFull;

static const uint64_t P9N2_C_11_ATOMIC_LOCK_REG                                    = 0x2B0F03FFull;

static const uint64_t P9N2_C_12_ATOMIC_LOCK_REG                                    = 0x2C0F03FFull;

static const uint64_t P9N2_C_13_ATOMIC_LOCK_REG                                    = 0x2D0F03FFull;

static const uint64_t P9N2_C_14_ATOMIC_LOCK_REG                                    = 0x2E0F03FFull;

static const uint64_t P9N2_C_15_ATOMIC_LOCK_REG                                    = 0x2F0F03FFull;

static const uint64_t P9N2_C_16_ATOMIC_LOCK_REG                                    = 0x300F03FFull;

static const uint64_t P9N2_C_17_ATOMIC_LOCK_REG                                    = 0x310F03FFull;

static const uint64_t P9N2_C_18_ATOMIC_LOCK_REG                                    = 0x320F03FFull;

static const uint64_t P9N2_C_19_ATOMIC_LOCK_REG                                    = 0x330F03FFull;

static const uint64_t P9N2_C_20_ATOMIC_LOCK_REG                                    = 0x340F03FFull;

static const uint64_t P9N2_C_21_ATOMIC_LOCK_REG                                    = 0x350F03FFull;

static const uint64_t P9N2_C_22_ATOMIC_LOCK_REG                                    = 0x360F03FFull;

static const uint64_t P9N2_C_23_ATOMIC_LOCK_REG                                    = 0x370F03FFull;

static const uint64_t P9N2_EQ_ATOMIC_LOCK_REG                                      = 0x100F03FFull;

static const uint64_t P9N2_EQ_0_ATOMIC_LOCK_REG                                    = 0x100F03FFull;

static const uint64_t P9N2_EQ_1_ATOMIC_LOCK_REG                                    = 0x110F03FFull;

static const uint64_t P9N2_EQ_2_ATOMIC_LOCK_REG                                    = 0x120F03FFull;

static const uint64_t P9N2_EQ_3_ATOMIC_LOCK_REG                                    = 0x130F03FFull;

static const uint64_t P9N2_EQ_4_ATOMIC_LOCK_REG                                    = 0x140F03FFull;

static const uint64_t P9N2_EQ_5_ATOMIC_LOCK_REG                                    = 0x150F03FFull;

static const uint64_t P9N2_EX_ATOMIC_LOCK_REG                                      = 0x200F03FFull;
//DUPS: 210F03FF,
static const uint64_t P9N2_EX_0_ATOMIC_LOCK_REG                                    = 0x200F03FFull;
//DUPS: 210F03FF,
static const uint64_t P9N2_EX_1_ATOMIC_LOCK_REG                                    = 0x220F03FFull;
//DUPS: 220F03FF,
static const uint64_t P9N2_EX_2_ATOMIC_LOCK_REG                                    = 0x240F03FFull;
//DUPS: 250F03FF,
static const uint64_t P9N2_EX_3_ATOMIC_LOCK_REG                                    = 0x260F03FFull;
//DUPS: 270F03FF,
static const uint64_t P9N2_EX_4_ATOMIC_LOCK_REG                                    = 0x280F03FFull;
//DUPS: 290F03FF,
static const uint64_t P9N2_EX_5_ATOMIC_LOCK_REG                                    = 0x2A0F03FFull;
//DUPS: 2B0F03FF,
static const uint64_t P9N2_EX_6_ATOMIC_LOCK_REG                                    = 0x2C0F03FFull;
//DUPS: 2D0F03FF,
static const uint64_t P9N2_EX_7_ATOMIC_LOCK_REG                                    = 0x2E0F03FFull;
//DUPS: 2F0F03FF,
static const uint64_t P9N2_EX_8_ATOMIC_LOCK_REG                                    = 0x300F03FFull;
//DUPS: 310F03FF,
static const uint64_t P9N2_EX_9_ATOMIC_LOCK_REG                                    = 0x320F03FFull;
//DUPS: 330F03FF,
static const uint64_t P9N2_EX_10_ATOMIC_LOCK_REG                                   = 0x340F03FFull;
//DUPS: 350F03FF,
static const uint64_t P9N2_EX_11_ATOMIC_LOCK_REG                                   = 0x360F03FFull;
//DUPS: 370F03FF,

static const uint64_t P9N2_C_ATTN_INTERRUPT_REG                                    = 0x200F001Aull;

static const uint64_t P9N2_C_0_ATTN_INTERRUPT_REG                                  = 0x200F001Aull;

static const uint64_t P9N2_C_1_ATTN_INTERRUPT_REG                                  = 0x210F001Aull;

static const uint64_t P9N2_C_2_ATTN_INTERRUPT_REG                                  = 0x220F001Aull;

static const uint64_t P9N2_C_3_ATTN_INTERRUPT_REG                                  = 0x230F001Aull;

static const uint64_t P9N2_C_4_ATTN_INTERRUPT_REG                                  = 0x240F001Aull;

static const uint64_t P9N2_C_5_ATTN_INTERRUPT_REG                                  = 0x250F001Aull;

static const uint64_t P9N2_C_6_ATTN_INTERRUPT_REG                                  = 0x260F001Aull;

static const uint64_t P9N2_C_7_ATTN_INTERRUPT_REG                                  = 0x270F001Aull;

static const uint64_t P9N2_C_8_ATTN_INTERRUPT_REG                                  = 0x280F001Aull;

static const uint64_t P9N2_C_9_ATTN_INTERRUPT_REG                                  = 0x290F001Aull;

static const uint64_t P9N2_C_10_ATTN_INTERRUPT_REG                                 = 0x2A0F001Aull;

static const uint64_t P9N2_C_11_ATTN_INTERRUPT_REG                                 = 0x2B0F001Aull;

static const uint64_t P9N2_C_12_ATTN_INTERRUPT_REG                                 = 0x2C0F001Aull;

static const uint64_t P9N2_C_13_ATTN_INTERRUPT_REG                                 = 0x2D0F001Aull;

static const uint64_t P9N2_C_14_ATTN_INTERRUPT_REG                                 = 0x2E0F001Aull;

static const uint64_t P9N2_C_15_ATTN_INTERRUPT_REG                                 = 0x2F0F001Aull;

static const uint64_t P9N2_C_16_ATTN_INTERRUPT_REG                                 = 0x300F001Aull;

static const uint64_t P9N2_C_17_ATTN_INTERRUPT_REG                                 = 0x310F001Aull;

static const uint64_t P9N2_C_18_ATTN_INTERRUPT_REG                                 = 0x320F001Aull;

static const uint64_t P9N2_C_19_ATTN_INTERRUPT_REG                                 = 0x330F001Aull;

static const uint64_t P9N2_C_20_ATTN_INTERRUPT_REG                                 = 0x340F001Aull;

static const uint64_t P9N2_C_21_ATTN_INTERRUPT_REG                                 = 0x350F001Aull;

static const uint64_t P9N2_C_22_ATTN_INTERRUPT_REG                                 = 0x360F001Aull;

static const uint64_t P9N2_C_23_ATTN_INTERRUPT_REG                                 = 0x370F001Aull;

static const uint64_t P9N2_EQ_ATTN_INTERRUPT_REG                                   = 0x100F001Aull;

static const uint64_t P9N2_EQ_0_ATTN_INTERRUPT_REG                                 = 0x100F001Aull;

static const uint64_t P9N2_EQ_1_ATTN_INTERRUPT_REG                                 = 0x110F001Aull;

static const uint64_t P9N2_EQ_2_ATTN_INTERRUPT_REG                                 = 0x120F001Aull;

static const uint64_t P9N2_EQ_3_ATTN_INTERRUPT_REG                                 = 0x130F001Aull;

static const uint64_t P9N2_EQ_4_ATTN_INTERRUPT_REG                                 = 0x140F001Aull;

static const uint64_t P9N2_EQ_5_ATTN_INTERRUPT_REG                                 = 0x150F001Aull;

static const uint64_t P9N2_EX_ATTN_INTERRUPT_REG                                   = 0x200F001Aull;
//DUPS: 210F001A,
static const uint64_t P9N2_EX_0_ATTN_INTERRUPT_REG                                 = 0x200F001Aull;
//DUPS: 210F001A,
static const uint64_t P9N2_EX_1_ATTN_INTERRUPT_REG                                 = 0x220F001Aull;
//DUPS: 220F001A,
static const uint64_t P9N2_EX_2_ATTN_INTERRUPT_REG                                 = 0x240F001Aull;
//DUPS: 250F001A,
static const uint64_t P9N2_EX_3_ATTN_INTERRUPT_REG                                 = 0x260F001Aull;
//DUPS: 270F001A,
static const uint64_t P9N2_EX_4_ATTN_INTERRUPT_REG                                 = 0x280F001Aull;
//DUPS: 290F001A,
static const uint64_t P9N2_EX_5_ATTN_INTERRUPT_REG                                 = 0x2A0F001Aull;
//DUPS: 2B0F001A,
static const uint64_t P9N2_EX_6_ATTN_INTERRUPT_REG                                 = 0x2C0F001Aull;
//DUPS: 2D0F001A,
static const uint64_t P9N2_EX_7_ATTN_INTERRUPT_REG                                 = 0x2E0F001Aull;
//DUPS: 2F0F001A,
static const uint64_t P9N2_EX_8_ATTN_INTERRUPT_REG                                 = 0x300F001Aull;
//DUPS: 310F001A,
static const uint64_t P9N2_EX_9_ATTN_INTERRUPT_REG                                 = 0x320F001Aull;
//DUPS: 330F001A,
static const uint64_t P9N2_EX_10_ATTN_INTERRUPT_REG                                = 0x340F001Aull;
//DUPS: 350F001A,
static const uint64_t P9N2_EX_11_ATTN_INTERRUPT_REG                                = 0x360F001Aull;
//DUPS: 370F001A,

static const uint64_t P9N2_C_BIST                                                  = 0x2003000Bull;

static const uint64_t P9N2_C_0_BIST                                                = 0x2003000Bull;

static const uint64_t P9N2_C_1_BIST                                                = 0x2103000Bull;

static const uint64_t P9N2_C_2_BIST                                                = 0x2203000Bull;

static const uint64_t P9N2_C_3_BIST                                                = 0x2303000Bull;

static const uint64_t P9N2_C_4_BIST                                                = 0x2403000Bull;

static const uint64_t P9N2_C_5_BIST                                                = 0x2503000Bull;

static const uint64_t P9N2_C_6_BIST                                                = 0x2603000Bull;

static const uint64_t P9N2_C_7_BIST                                                = 0x2703000Bull;

static const uint64_t P9N2_C_8_BIST                                                = 0x2803000Bull;

static const uint64_t P9N2_C_9_BIST                                                = 0x2903000Bull;

static const uint64_t P9N2_C_10_BIST                                               = 0x2A03000Bull;

static const uint64_t P9N2_C_11_BIST                                               = 0x2B03000Bull;

static const uint64_t P9N2_C_12_BIST                                               = 0x2C03000Bull;

static const uint64_t P9N2_C_13_BIST                                               = 0x2D03000Bull;

static const uint64_t P9N2_C_14_BIST                                               = 0x2E03000Bull;

static const uint64_t P9N2_C_15_BIST                                               = 0x2F03000Bull;

static const uint64_t P9N2_C_16_BIST                                               = 0x3003000Bull;

static const uint64_t P9N2_C_17_BIST                                               = 0x3103000Bull;

static const uint64_t P9N2_C_18_BIST                                               = 0x3203000Bull;

static const uint64_t P9N2_C_19_BIST                                               = 0x3303000Bull;

static const uint64_t P9N2_C_20_BIST                                               = 0x3403000Bull;

static const uint64_t P9N2_C_21_BIST                                               = 0x3503000Bull;

static const uint64_t P9N2_C_22_BIST                                               = 0x3603000Bull;

static const uint64_t P9N2_C_23_BIST                                               = 0x3703000Bull;

static const uint64_t P9N2_EQ_BIST                                                 = 0x1003000Bull;

static const uint64_t P9N2_EQ_0_BIST                                               = 0x1003000Bull;

static const uint64_t P9N2_EQ_1_BIST                                               = 0x1103000Bull;

static const uint64_t P9N2_EQ_2_BIST                                               = 0x1203000Bull;

static const uint64_t P9N2_EQ_3_BIST                                               = 0x1303000Bull;

static const uint64_t P9N2_EQ_4_BIST                                               = 0x1403000Bull;

static const uint64_t P9N2_EQ_5_BIST                                               = 0x1503000Bull;

static const uint64_t P9N2_EX_BIST                                                 = 0x2003000Bull;
//DUPS: 2103000B,
static const uint64_t P9N2_EX_0_BIST                                               = 0x2003000Bull;
//DUPS: 2103000B,
static const uint64_t P9N2_EX_1_BIST                                               = 0x2203000Bull;
//DUPS: 2303000B,
static const uint64_t P9N2_EX_2_BIST                                               = 0x2403000Bull;
//DUPS: 2503000B,
static const uint64_t P9N2_EX_3_BIST                                               = 0x2603000Bull;
//DUPS: 2703000B,
static const uint64_t P9N2_EX_4_BIST                                               = 0x2803000Bull;
//DUPS: 2903000B,
static const uint64_t P9N2_EX_5_BIST                                               = 0x2A03000Bull;
//DUPS: 2B03000B,
static const uint64_t P9N2_EX_6_BIST                                               = 0x2C03000Bull;
//DUPS: 2D03000B,
static const uint64_t P9N2_EX_7_BIST                                               = 0x2F03000Bull;
//DUPS: 2F03000B,
static const uint64_t P9N2_EX_8_BIST                                               = 0x3003000Bull;
//DUPS: 3103000B,
static const uint64_t P9N2_EX_9_BIST                                               = 0x3203000Bull;
//DUPS: 3303000B,
static const uint64_t P9N2_EX_10_BIST                                              = 0x3403000Bull;
//DUPS: 3503000B,
static const uint64_t P9N2_EX_11_BIST                                              = 0x3603000Bull;
//DUPS: 3703000B,

static const uint64_t P9N2_C_CC_ATOMIC_LOCK_REG                                    = 0x200303FFull;

static const uint64_t P9N2_C_0_CC_ATOMIC_LOCK_REG                                  = 0x200303FFull;

static const uint64_t P9N2_C_1_CC_ATOMIC_LOCK_REG                                  = 0x210303FFull;

static const uint64_t P9N2_C_2_CC_ATOMIC_LOCK_REG                                  = 0x220303FFull;

static const uint64_t P9N2_C_3_CC_ATOMIC_LOCK_REG                                  = 0x230303FFull;

static const uint64_t P9N2_C_4_CC_ATOMIC_LOCK_REG                                  = 0x240303FFull;

static const uint64_t P9N2_C_5_CC_ATOMIC_LOCK_REG                                  = 0x250303FFull;

static const uint64_t P9N2_C_6_CC_ATOMIC_LOCK_REG                                  = 0x260303FFull;

static const uint64_t P9N2_C_7_CC_ATOMIC_LOCK_REG                                  = 0x270303FFull;

static const uint64_t P9N2_C_8_CC_ATOMIC_LOCK_REG                                  = 0x280303FFull;

static const uint64_t P9N2_C_9_CC_ATOMIC_LOCK_REG                                  = 0x290303FFull;

static const uint64_t P9N2_C_10_CC_ATOMIC_LOCK_REG                                 = 0x2A0303FFull;

static const uint64_t P9N2_C_11_CC_ATOMIC_LOCK_REG                                 = 0x2B0303FFull;

static const uint64_t P9N2_C_12_CC_ATOMIC_LOCK_REG                                 = 0x2C0303FFull;

static const uint64_t P9N2_C_13_CC_ATOMIC_LOCK_REG                                 = 0x2D0303FFull;

static const uint64_t P9N2_C_14_CC_ATOMIC_LOCK_REG                                 = 0x2E0303FFull;

static const uint64_t P9N2_C_15_CC_ATOMIC_LOCK_REG                                 = 0x2F0303FFull;

static const uint64_t P9N2_C_16_CC_ATOMIC_LOCK_REG                                 = 0x300303FFull;

static const uint64_t P9N2_C_17_CC_ATOMIC_LOCK_REG                                 = 0x310303FFull;

static const uint64_t P9N2_C_18_CC_ATOMIC_LOCK_REG                                 = 0x320303FFull;

static const uint64_t P9N2_C_19_CC_ATOMIC_LOCK_REG                                 = 0x330303FFull;

static const uint64_t P9N2_C_20_CC_ATOMIC_LOCK_REG                                 = 0x340303FFull;

static const uint64_t P9N2_C_21_CC_ATOMIC_LOCK_REG                                 = 0x350303FFull;

static const uint64_t P9N2_C_22_CC_ATOMIC_LOCK_REG                                 = 0x360303FFull;

static const uint64_t P9N2_C_23_CC_ATOMIC_LOCK_REG                                 = 0x370303FFull;

static const uint64_t P9N2_EQ_CC_ATOMIC_LOCK_REG                                   = 0x100303FFull;

static const uint64_t P9N2_EQ_0_CC_ATOMIC_LOCK_REG                                 = 0x100303FFull;

static const uint64_t P9N2_EQ_1_CC_ATOMIC_LOCK_REG                                 = 0x110303FFull;

static const uint64_t P9N2_EQ_2_CC_ATOMIC_LOCK_REG                                 = 0x120303FFull;

static const uint64_t P9N2_EQ_3_CC_ATOMIC_LOCK_REG                                 = 0x130303FFull;

static const uint64_t P9N2_EQ_4_CC_ATOMIC_LOCK_REG                                 = 0x140303FFull;

static const uint64_t P9N2_EQ_5_CC_ATOMIC_LOCK_REG                                 = 0x150303FFull;

static const uint64_t P9N2_EX_CC_ATOMIC_LOCK_REG                                   = 0x200303FFull;
//DUPS: 210303FF,
static const uint64_t P9N2_EX_0_CC_ATOMIC_LOCK_REG                                 = 0x200303FFull;
//DUPS: 210303FF,
static const uint64_t P9N2_EX_1_CC_ATOMIC_LOCK_REG                                 = 0x220303FFull;
//DUPS: 230303FF,
static const uint64_t P9N2_EX_2_CC_ATOMIC_LOCK_REG                                 = 0x240303FFull;
//DUPS: 250303FF,
static const uint64_t P9N2_EX_3_CC_ATOMIC_LOCK_REG                                 = 0x260303FFull;
//DUPS: 270303FF,
static const uint64_t P9N2_EX_4_CC_ATOMIC_LOCK_REG                                 = 0x280303FFull;
//DUPS: 290303FF,
static const uint64_t P9N2_EX_5_CC_ATOMIC_LOCK_REG                                 = 0x2A0303FFull;
//DUPS: 2B0303FF,
static const uint64_t P9N2_EX_6_CC_ATOMIC_LOCK_REG                                 = 0x2C0303FFull;
//DUPS: 2D0303FF,
static const uint64_t P9N2_EX_7_CC_ATOMIC_LOCK_REG                                 = 0x2F0303FFull;
//DUPS: 2F0303FF,
static const uint64_t P9N2_EX_8_CC_ATOMIC_LOCK_REG                                 = 0x300303FFull;
//DUPS: 310303FF,
static const uint64_t P9N2_EX_9_CC_ATOMIC_LOCK_REG                                 = 0x320303FFull;
//DUPS: 330303FF,
static const uint64_t P9N2_EX_10_CC_ATOMIC_LOCK_REG                                = 0x340303FFull;
//DUPS: 350303FF,
static const uint64_t P9N2_EX_11_CC_ATOMIC_LOCK_REG                                = 0x360303FFull;
//DUPS: 370303FF,

static const uint64_t P9N2_C_CC_PROTECT_MODE_REG                                   = 0x200303FEull;

static const uint64_t P9N2_C_0_CC_PROTECT_MODE_REG                                 = 0x200303FEull;

static const uint64_t P9N2_C_1_CC_PROTECT_MODE_REG                                 = 0x210303FEull;

static const uint64_t P9N2_C_2_CC_PROTECT_MODE_REG                                 = 0x220303FEull;

static const uint64_t P9N2_C_3_CC_PROTECT_MODE_REG                                 = 0x230303FEull;

static const uint64_t P9N2_C_4_CC_PROTECT_MODE_REG                                 = 0x240303FEull;

static const uint64_t P9N2_C_5_CC_PROTECT_MODE_REG                                 = 0x250303FEull;

static const uint64_t P9N2_C_6_CC_PROTECT_MODE_REG                                 = 0x260303FEull;

static const uint64_t P9N2_C_7_CC_PROTECT_MODE_REG                                 = 0x270303FEull;

static const uint64_t P9N2_C_8_CC_PROTECT_MODE_REG                                 = 0x280303FEull;

static const uint64_t P9N2_C_9_CC_PROTECT_MODE_REG                                 = 0x290303FEull;

static const uint64_t P9N2_C_10_CC_PROTECT_MODE_REG                                = 0x2A0303FEull;

static const uint64_t P9N2_C_11_CC_PROTECT_MODE_REG                                = 0x2B0303FEull;

static const uint64_t P9N2_C_12_CC_PROTECT_MODE_REG                                = 0x2C0303FEull;

static const uint64_t P9N2_C_13_CC_PROTECT_MODE_REG                                = 0x2D0303FEull;

static const uint64_t P9N2_C_14_CC_PROTECT_MODE_REG                                = 0x2E0303FEull;

static const uint64_t P9N2_C_15_CC_PROTECT_MODE_REG                                = 0x2F0303FEull;

static const uint64_t P9N2_C_16_CC_PROTECT_MODE_REG                                = 0x300303FEull;

static const uint64_t P9N2_C_17_CC_PROTECT_MODE_REG                                = 0x310303FEull;

static const uint64_t P9N2_C_18_CC_PROTECT_MODE_REG                                = 0x320303FEull;

static const uint64_t P9N2_C_19_CC_PROTECT_MODE_REG                                = 0x330303FEull;

static const uint64_t P9N2_C_20_CC_PROTECT_MODE_REG                                = 0x340303FEull;

static const uint64_t P9N2_C_21_CC_PROTECT_MODE_REG                                = 0x350303FEull;

static const uint64_t P9N2_C_22_CC_PROTECT_MODE_REG                                = 0x360303FEull;

static const uint64_t P9N2_C_23_CC_PROTECT_MODE_REG                                = 0x370303FEull;

static const uint64_t P9N2_EQ_CC_PROTECT_MODE_REG                                  = 0x100303FEull;

static const uint64_t P9N2_EQ_0_CC_PROTECT_MODE_REG                                = 0x100303FEull;

static const uint64_t P9N2_EQ_1_CC_PROTECT_MODE_REG                                = 0x110303FEull;

static const uint64_t P9N2_EQ_2_CC_PROTECT_MODE_REG                                = 0x120303FEull;

static const uint64_t P9N2_EQ_3_CC_PROTECT_MODE_REG                                = 0x130303FEull;

static const uint64_t P9N2_EQ_4_CC_PROTECT_MODE_REG                                = 0x140303FEull;

static const uint64_t P9N2_EQ_5_CC_PROTECT_MODE_REG                                = 0x150303FEull;

static const uint64_t P9N2_EX_CC_PROTECT_MODE_REG                                  = 0x200303FEull;
//DUPS: 210303FE,
static const uint64_t P9N2_EX_0_CC_PROTECT_MODE_REG                                = 0x200303FEull;
//DUPS: 210303FE,
static const uint64_t P9N2_EX_1_CC_PROTECT_MODE_REG                                = 0x220303FEull;
//DUPS: 230303FE,
static const uint64_t P9N2_EX_2_CC_PROTECT_MODE_REG                                = 0x240303FEull;
//DUPS: 250303FE,
static const uint64_t P9N2_EX_3_CC_PROTECT_MODE_REG                                = 0x260303FEull;
//DUPS: 270303FE,
static const uint64_t P9N2_EX_4_CC_PROTECT_MODE_REG                                = 0x280303FEull;
//DUPS: 290303FE,
static const uint64_t P9N2_EX_5_CC_PROTECT_MODE_REG                                = 0x2A0303FEull;
//DUPS: 2B0303FE,
static const uint64_t P9N2_EX_6_CC_PROTECT_MODE_REG                                = 0x2C0303FEull;
//DUPS: 2D0303FE,
static const uint64_t P9N2_EX_7_CC_PROTECT_MODE_REG                                = 0x2F0303FEull;
//DUPS: 2F0303FE,
static const uint64_t P9N2_EX_8_CC_PROTECT_MODE_REG                                = 0x300303FEull;
//DUPS: 310303FE,
static const uint64_t P9N2_EX_9_CC_PROTECT_MODE_REG                                = 0x320303FEull;
//DUPS: 330303FE,
static const uint64_t P9N2_EX_10_CC_PROTECT_MODE_REG                               = 0x340303FEull;
//DUPS: 350303FE,
static const uint64_t P9N2_EX_11_CC_PROTECT_MODE_REG                               = 0x360303FEull;
//DUPS: 370303FE,

static const uint64_t P9N2_C_CLK_REGION                                            = 0x20030006ull;

static const uint64_t P9N2_C_0_CLK_REGION                                          = 0x20030006ull;

static const uint64_t P9N2_C_1_CLK_REGION                                          = 0x21030006ull;

static const uint64_t P9N2_C_2_CLK_REGION                                          = 0x22030006ull;

static const uint64_t P9N2_C_3_CLK_REGION                                          = 0x23030006ull;

static const uint64_t P9N2_C_4_CLK_REGION                                          = 0x24030006ull;

static const uint64_t P9N2_C_5_CLK_REGION                                          = 0x25030006ull;

static const uint64_t P9N2_C_6_CLK_REGION                                          = 0x26030006ull;

static const uint64_t P9N2_C_7_CLK_REGION                                          = 0x27030006ull;

static const uint64_t P9N2_C_8_CLK_REGION                                          = 0x28030006ull;

static const uint64_t P9N2_C_9_CLK_REGION                                          = 0x29030006ull;

static const uint64_t P9N2_C_10_CLK_REGION                                         = 0x2A030006ull;

static const uint64_t P9N2_C_11_CLK_REGION                                         = 0x2B030006ull;

static const uint64_t P9N2_C_12_CLK_REGION                                         = 0x2C030006ull;

static const uint64_t P9N2_C_13_CLK_REGION                                         = 0x2D030006ull;

static const uint64_t P9N2_C_14_CLK_REGION                                         = 0x2E030006ull;

static const uint64_t P9N2_C_15_CLK_REGION                                         = 0x2F030006ull;

static const uint64_t P9N2_C_16_CLK_REGION                                         = 0x30030006ull;

static const uint64_t P9N2_C_17_CLK_REGION                                         = 0x31030006ull;

static const uint64_t P9N2_C_18_CLK_REGION                                         = 0x32030006ull;

static const uint64_t P9N2_C_19_CLK_REGION                                         = 0x33030006ull;

static const uint64_t P9N2_C_20_CLK_REGION                                         = 0x34030006ull;

static const uint64_t P9N2_C_21_CLK_REGION                                         = 0x35030006ull;

static const uint64_t P9N2_C_22_CLK_REGION                                         = 0x36030006ull;

static const uint64_t P9N2_C_23_CLK_REGION                                         = 0x37030006ull;

static const uint64_t P9N2_EQ_CLK_REGION                                           = 0x10030006ull;

static const uint64_t P9N2_EQ_0_CLK_REGION                                         = 0x10030006ull;

static const uint64_t P9N2_EQ_1_CLK_REGION                                         = 0x11030006ull;

static const uint64_t P9N2_EQ_2_CLK_REGION                                         = 0x12030006ull;

static const uint64_t P9N2_EQ_3_CLK_REGION                                         = 0x13030006ull;

static const uint64_t P9N2_EQ_4_CLK_REGION                                         = 0x14030006ull;

static const uint64_t P9N2_EQ_5_CLK_REGION                                         = 0x15030006ull;

static const uint64_t P9N2_EX_CLK_REGION                                           = 0x20030006ull;
//DUPS: 21030006,
static const uint64_t P9N2_EX_0_CLK_REGION                                         = 0x20030006ull;
//DUPS: 21030006,
static const uint64_t P9N2_EX_1_CLK_REGION                                         = 0x22030006ull;
//DUPS: 23030006,
static const uint64_t P9N2_EX_2_CLK_REGION                                         = 0x24030006ull;
//DUPS: 25030006,
static const uint64_t P9N2_EX_3_CLK_REGION                                         = 0x26030006ull;
//DUPS: 27030006,
static const uint64_t P9N2_EX_4_CLK_REGION                                         = 0x28030006ull;
//DUPS: 29030006,
static const uint64_t P9N2_EX_5_CLK_REGION                                         = 0x2A030006ull;
//DUPS: 2B030006,
static const uint64_t P9N2_EX_6_CLK_REGION                                         = 0x2C030006ull;
//DUPS: 2D030006,
static const uint64_t P9N2_EX_7_CLK_REGION                                         = 0x2F030006ull;
//DUPS: 2F030006,
static const uint64_t P9N2_EX_8_CLK_REGION                                         = 0x30030006ull;
//DUPS: 31030006,
static const uint64_t P9N2_EX_9_CLK_REGION                                         = 0x32030006ull;
//DUPS: 33030006,
static const uint64_t P9N2_EX_10_CLK_REGION                                        = 0x34030006ull;
//DUPS: 35030006,
static const uint64_t P9N2_EX_11_CLK_REGION                                        = 0x36030006ull;
//DUPS: 37030006,

static const uint64_t P9N2_C_CLOCK_STAT_ARY                                        = 0x2003000Aull;

static const uint64_t P9N2_C_0_CLOCK_STAT_ARY                                      = 0x2003000Aull;

static const uint64_t P9N2_C_1_CLOCK_STAT_ARY                                      = 0x2103000Aull;

static const uint64_t P9N2_C_2_CLOCK_STAT_ARY                                      = 0x2203000Aull;

static const uint64_t P9N2_C_3_CLOCK_STAT_ARY                                      = 0x2303000Aull;

static const uint64_t P9N2_C_4_CLOCK_STAT_ARY                                      = 0x2403000Aull;

static const uint64_t P9N2_C_5_CLOCK_STAT_ARY                                      = 0x2503000Aull;

static const uint64_t P9N2_C_6_CLOCK_STAT_ARY                                      = 0x2603000Aull;

static const uint64_t P9N2_C_7_CLOCK_STAT_ARY                                      = 0x2703000Aull;

static const uint64_t P9N2_C_8_CLOCK_STAT_ARY                                      = 0x2803000Aull;

static const uint64_t P9N2_C_9_CLOCK_STAT_ARY                                      = 0x2903000Aull;

static const uint64_t P9N2_C_10_CLOCK_STAT_ARY                                     = 0x2A03000Aull;

static const uint64_t P9N2_C_11_CLOCK_STAT_ARY                                     = 0x2B03000Aull;

static const uint64_t P9N2_C_12_CLOCK_STAT_ARY                                     = 0x2C03000Aull;

static const uint64_t P9N2_C_13_CLOCK_STAT_ARY                                     = 0x2D03000Aull;

static const uint64_t P9N2_C_14_CLOCK_STAT_ARY                                     = 0x2E03000Aull;

static const uint64_t P9N2_C_15_CLOCK_STAT_ARY                                     = 0x2F03000Aull;

static const uint64_t P9N2_C_16_CLOCK_STAT_ARY                                     = 0x3003000Aull;

static const uint64_t P9N2_C_17_CLOCK_STAT_ARY                                     = 0x3103000Aull;

static const uint64_t P9N2_C_18_CLOCK_STAT_ARY                                     = 0x3203000Aull;

static const uint64_t P9N2_C_19_CLOCK_STAT_ARY                                     = 0x3303000Aull;

static const uint64_t P9N2_C_20_CLOCK_STAT_ARY                                     = 0x3403000Aull;

static const uint64_t P9N2_C_21_CLOCK_STAT_ARY                                     = 0x3503000Aull;

static const uint64_t P9N2_C_22_CLOCK_STAT_ARY                                     = 0x3603000Aull;

static const uint64_t P9N2_C_23_CLOCK_STAT_ARY                                     = 0x3703000Aull;

static const uint64_t P9N2_EQ_CLOCK_STAT_ARY                                       = 0x1003000Aull;

static const uint64_t P9N2_EQ_0_CLOCK_STAT_ARY                                     = 0x1003000Aull;

static const uint64_t P9N2_EQ_1_CLOCK_STAT_ARY                                     = 0x1103000Aull;

static const uint64_t P9N2_EQ_2_CLOCK_STAT_ARY                                     = 0x1203000Aull;

static const uint64_t P9N2_EQ_3_CLOCK_STAT_ARY                                     = 0x1303000Aull;

static const uint64_t P9N2_EQ_4_CLOCK_STAT_ARY                                     = 0x1403000Aull;

static const uint64_t P9N2_EQ_5_CLOCK_STAT_ARY                                     = 0x1503000Aull;

static const uint64_t P9N2_EX_CLOCK_STAT_ARY                                       = 0x2003000Aull;
//DUPS: 2103000A,
static const uint64_t P9N2_EX_0_CLOCK_STAT_ARY                                     = 0x2003000Aull;
//DUPS: 2103000A,
static const uint64_t P9N2_EX_1_CLOCK_STAT_ARY                                     = 0x2203000Aull;
//DUPS: 2303000A,
static const uint64_t P9N2_EX_2_CLOCK_STAT_ARY                                     = 0x2403000Aull;
//DUPS: 2503000A,
static const uint64_t P9N2_EX_3_CLOCK_STAT_ARY                                     = 0x2603000Aull;
//DUPS: 2703000A,
static const uint64_t P9N2_EX_4_CLOCK_STAT_ARY                                     = 0x2803000Aull;
//DUPS: 2903000A,
static const uint64_t P9N2_EX_5_CLOCK_STAT_ARY                                     = 0x2A03000Aull;
//DUPS: 2B03000A,
static const uint64_t P9N2_EX_6_CLOCK_STAT_ARY                                     = 0x2C03000Aull;
//DUPS: 2D03000A,
static const uint64_t P9N2_EX_7_CLOCK_STAT_ARY                                     = 0x2F03000Aull;
//DUPS: 2F03000A,
static const uint64_t P9N2_EX_8_CLOCK_STAT_ARY                                     = 0x3003000Aull;
//DUPS: 3103000A,
static const uint64_t P9N2_EX_9_CLOCK_STAT_ARY                                     = 0x3203000Aull;
//DUPS: 3303000A,
static const uint64_t P9N2_EX_10_CLOCK_STAT_ARY                                    = 0x3403000Aull;
//DUPS: 3503000A,
static const uint64_t P9N2_EX_11_CLOCK_STAT_ARY                                    = 0x3603000Aull;
//DUPS: 3703000A,

static const uint64_t P9N2_C_CLOCK_STAT_NSL                                        = 0x20030009ull;

static const uint64_t P9N2_C_0_CLOCK_STAT_NSL                                      = 0x20030009ull;

static const uint64_t P9N2_C_1_CLOCK_STAT_NSL                                      = 0x21030009ull;

static const uint64_t P9N2_C_2_CLOCK_STAT_NSL                                      = 0x22030009ull;

static const uint64_t P9N2_C_3_CLOCK_STAT_NSL                                      = 0x23030009ull;

static const uint64_t P9N2_C_4_CLOCK_STAT_NSL                                      = 0x24030009ull;

static const uint64_t P9N2_C_5_CLOCK_STAT_NSL                                      = 0x25030009ull;

static const uint64_t P9N2_C_6_CLOCK_STAT_NSL                                      = 0x26030009ull;

static const uint64_t P9N2_C_7_CLOCK_STAT_NSL                                      = 0x27030009ull;

static const uint64_t P9N2_C_8_CLOCK_STAT_NSL                                      = 0x28030009ull;

static const uint64_t P9N2_C_9_CLOCK_STAT_NSL                                      = 0x29030009ull;

static const uint64_t P9N2_C_10_CLOCK_STAT_NSL                                     = 0x2A030009ull;

static const uint64_t P9N2_C_11_CLOCK_STAT_NSL                                     = 0x2B030009ull;

static const uint64_t P9N2_C_12_CLOCK_STAT_NSL                                     = 0x2C030009ull;

static const uint64_t P9N2_C_13_CLOCK_STAT_NSL                                     = 0x2D030009ull;

static const uint64_t P9N2_C_14_CLOCK_STAT_NSL                                     = 0x2E030009ull;

static const uint64_t P9N2_C_15_CLOCK_STAT_NSL                                     = 0x2F030009ull;

static const uint64_t P9N2_C_16_CLOCK_STAT_NSL                                     = 0x30030009ull;

static const uint64_t P9N2_C_17_CLOCK_STAT_NSL                                     = 0x31030009ull;

static const uint64_t P9N2_C_18_CLOCK_STAT_NSL                                     = 0x32030009ull;

static const uint64_t P9N2_C_19_CLOCK_STAT_NSL                                     = 0x33030009ull;

static const uint64_t P9N2_C_20_CLOCK_STAT_NSL                                     = 0x34030009ull;

static const uint64_t P9N2_C_21_CLOCK_STAT_NSL                                     = 0x35030009ull;

static const uint64_t P9N2_C_22_CLOCK_STAT_NSL                                     = 0x36030009ull;

static const uint64_t P9N2_C_23_CLOCK_STAT_NSL                                     = 0x37030009ull;

static const uint64_t P9N2_EQ_CLOCK_STAT_NSL                                       = 0x10030009ull;

static const uint64_t P9N2_EQ_0_CLOCK_STAT_NSL                                     = 0x10030009ull;

static const uint64_t P9N2_EQ_1_CLOCK_STAT_NSL                                     = 0x11030009ull;

static const uint64_t P9N2_EQ_2_CLOCK_STAT_NSL                                     = 0x12030009ull;

static const uint64_t P9N2_EQ_3_CLOCK_STAT_NSL                                     = 0x13030009ull;

static const uint64_t P9N2_EQ_4_CLOCK_STAT_NSL                                     = 0x14030009ull;

static const uint64_t P9N2_EQ_5_CLOCK_STAT_NSL                                     = 0x15030009ull;

static const uint64_t P9N2_EX_CLOCK_STAT_NSL                                       = 0x20030009ull;
//DUPS: 21030009,
static const uint64_t P9N2_EX_0_CLOCK_STAT_NSL                                     = 0x20030009ull;
//DUPS: 21030009,
static const uint64_t P9N2_EX_1_CLOCK_STAT_NSL                                     = 0x22030009ull;
//DUPS: 23030009,
static const uint64_t P9N2_EX_2_CLOCK_STAT_NSL                                     = 0x24030009ull;
//DUPS: 25030009,
static const uint64_t P9N2_EX_3_CLOCK_STAT_NSL                                     = 0x26030009ull;
//DUPS: 27030009,
static const uint64_t P9N2_EX_4_CLOCK_STAT_NSL                                     = 0x28030009ull;
//DUPS: 29030009,
static const uint64_t P9N2_EX_5_CLOCK_STAT_NSL                                     = 0x2A030009ull;
//DUPS: 2B030009,
static const uint64_t P9N2_EX_6_CLOCK_STAT_NSL                                     = 0x2C030009ull;
//DUPS: 2D030009,
static const uint64_t P9N2_EX_7_CLOCK_STAT_NSL                                     = 0x2F030009ull;
//DUPS: 2F030009,
static const uint64_t P9N2_EX_8_CLOCK_STAT_NSL                                     = 0x30030009ull;
//DUPS: 31030009,
static const uint64_t P9N2_EX_9_CLOCK_STAT_NSL                                     = 0x32030009ull;
//DUPS: 33030009,
static const uint64_t P9N2_EX_10_CLOCK_STAT_NSL                                    = 0x34030009ull;
//DUPS: 35030009,
static const uint64_t P9N2_EX_11_CLOCK_STAT_NSL                                    = 0x36030009ull;
//DUPS: 37030009,

static const uint64_t P9N2_C_CLOCK_STAT_SL                                         = 0x20030008ull;

static const uint64_t P9N2_C_0_CLOCK_STAT_SL                                       = 0x20030008ull;

static const uint64_t P9N2_C_1_CLOCK_STAT_SL                                       = 0x21030008ull;

static const uint64_t P9N2_C_2_CLOCK_STAT_SL                                       = 0x22030008ull;

static const uint64_t P9N2_C_3_CLOCK_STAT_SL                                       = 0x23030008ull;

static const uint64_t P9N2_C_4_CLOCK_STAT_SL                                       = 0x24030008ull;

static const uint64_t P9N2_C_5_CLOCK_STAT_SL                                       = 0x25030008ull;

static const uint64_t P9N2_C_6_CLOCK_STAT_SL                                       = 0x26030008ull;

static const uint64_t P9N2_C_7_CLOCK_STAT_SL                                       = 0x27030008ull;

static const uint64_t P9N2_C_8_CLOCK_STAT_SL                                       = 0x28030008ull;

static const uint64_t P9N2_C_9_CLOCK_STAT_SL                                       = 0x29030008ull;

static const uint64_t P9N2_C_10_CLOCK_STAT_SL                                      = 0x2A030008ull;

static const uint64_t P9N2_C_11_CLOCK_STAT_SL                                      = 0x2B030008ull;

static const uint64_t P9N2_C_12_CLOCK_STAT_SL                                      = 0x2C030008ull;

static const uint64_t P9N2_C_13_CLOCK_STAT_SL                                      = 0x2D030008ull;

static const uint64_t P9N2_C_14_CLOCK_STAT_SL                                      = 0x2E030008ull;

static const uint64_t P9N2_C_15_CLOCK_STAT_SL                                      = 0x2F030008ull;

static const uint64_t P9N2_C_16_CLOCK_STAT_SL                                      = 0x30030008ull;

static const uint64_t P9N2_C_17_CLOCK_STAT_SL                                      = 0x31030008ull;

static const uint64_t P9N2_C_18_CLOCK_STAT_SL                                      = 0x32030008ull;

static const uint64_t P9N2_C_19_CLOCK_STAT_SL                                      = 0x33030008ull;

static const uint64_t P9N2_C_20_CLOCK_STAT_SL                                      = 0x34030008ull;

static const uint64_t P9N2_C_21_CLOCK_STAT_SL                                      = 0x35030008ull;

static const uint64_t P9N2_C_22_CLOCK_STAT_SL                                      = 0x36030008ull;

static const uint64_t P9N2_C_23_CLOCK_STAT_SL                                      = 0x37030008ull;

static const uint64_t P9N2_EQ_CLOCK_STAT_SL                                        = 0x10030008ull;

static const uint64_t P9N2_EQ_0_CLOCK_STAT_SL                                      = 0x10030008ull;

static const uint64_t P9N2_EQ_1_CLOCK_STAT_SL                                      = 0x11030008ull;

static const uint64_t P9N2_EQ_2_CLOCK_STAT_SL                                      = 0x12030008ull;

static const uint64_t P9N2_EQ_3_CLOCK_STAT_SL                                      = 0x13030008ull;

static const uint64_t P9N2_EQ_4_CLOCK_STAT_SL                                      = 0x14030008ull;

static const uint64_t P9N2_EQ_5_CLOCK_STAT_SL                                      = 0x15030008ull;

static const uint64_t P9N2_EX_CLOCK_STAT_SL                                        = 0x20030008ull;
//DUPS: 21030008,
static const uint64_t P9N2_EX_0_CLOCK_STAT_SL                                      = 0x20030008ull;
//DUPS: 21030008,
static const uint64_t P9N2_EX_1_CLOCK_STAT_SL                                      = 0x22030008ull;
//DUPS: 23030008,
static const uint64_t P9N2_EX_2_CLOCK_STAT_SL                                      = 0x24030008ull;
//DUPS: 25030008,
static const uint64_t P9N2_EX_3_CLOCK_STAT_SL                                      = 0x26030008ull;
//DUPS: 27030008,
static const uint64_t P9N2_EX_4_CLOCK_STAT_SL                                      = 0x28030008ull;
//DUPS: 29030008,
static const uint64_t P9N2_EX_5_CLOCK_STAT_SL                                      = 0x2A030008ull;
//DUPS: 2B030008,
static const uint64_t P9N2_EX_6_CLOCK_STAT_SL                                      = 0x2C030008ull;
//DUPS: 2D030008,
static const uint64_t P9N2_EX_7_CLOCK_STAT_SL                                      = 0x2F030008ull;
//DUPS: 2F030008,
static const uint64_t P9N2_EX_8_CLOCK_STAT_SL                                      = 0x30030008ull;
//DUPS: 31030008,
static const uint64_t P9N2_EX_9_CLOCK_STAT_SL                                      = 0x32030008ull;
//DUPS: 33030008,
static const uint64_t P9N2_EX_10_CLOCK_STAT_SL                                     = 0x34030008ull;
//DUPS: 35030008,
static const uint64_t P9N2_EX_11_CLOCK_STAT_SL                                     = 0x36030008ull;
//DUPS: 37030008,

static const uint64_t P9N2_EX_CME_LCL_DBG_PPE                                      = 0x109010120ull;

static const uint64_t P9N2_EX_CME_LCL_DBG_PPE1                                     = 0x109010138ull;

static const uint64_t P9N2_EX_CME_LCL_DBG_PPE2                                     = 0x109010130ull;

static const uint64_t P9N2_EX_0_CME_LCL_DBG_PPE                                    = 0x109010120ull;

static const uint64_t P9N2_EX_0_CME_LCL_DBG_PPE1                                   = 0x109010138ull;

static const uint64_t P9N2_EX_0_CME_LCL_DBG_PPE2                                   = 0x109010130ull;

static const uint64_t P9N2_EX_1_CME_LCL_DBG_PPE                                    = 0x109020120ull;

static const uint64_t P9N2_EX_1_CME_LCL_DBG_PPE1                                   = 0x109020138ull;

static const uint64_t P9N2_EX_1_CME_LCL_DBG_PPE2                                   = 0x109020130ull;

static const uint64_t P9N2_EX_2_CME_LCL_DBG_PPE                                    = 0x10A010120ull;

static const uint64_t P9N2_EX_2_CME_LCL_DBG_PPE1                                   = 0x10A010138ull;

static const uint64_t P9N2_EX_2_CME_LCL_DBG_PPE2                                   = 0x10A010130ull;

static const uint64_t P9N2_EX_3_CME_LCL_DBG_PPE                                    = 0x10A020120ull;

static const uint64_t P9N2_EX_3_CME_LCL_DBG_PPE1                                   = 0x10A020138ull;

static const uint64_t P9N2_EX_3_CME_LCL_DBG_PPE2                                   = 0x10A020130ull;

static const uint64_t P9N2_EX_4_CME_LCL_DBG_PPE                                    = 0x10B010120ull;

static const uint64_t P9N2_EX_4_CME_LCL_DBG_PPE1                                   = 0x10B010138ull;

static const uint64_t P9N2_EX_4_CME_LCL_DBG_PPE2                                   = 0x10B010130ull;

static const uint64_t P9N2_EX_5_CME_LCL_DBG_PPE                                    = 0x10B020120ull;

static const uint64_t P9N2_EX_5_CME_LCL_DBG_PPE1                                   = 0x10B020138ull;

static const uint64_t P9N2_EX_5_CME_LCL_DBG_PPE2                                   = 0x10B020130ull;

static const uint64_t P9N2_EX_6_CME_LCL_DBG_PPE                                    = 0x10C010120ull;

static const uint64_t P9N2_EX_6_CME_LCL_DBG_PPE1                                   = 0x10C010138ull;

static const uint64_t P9N2_EX_6_CME_LCL_DBG_PPE2                                   = 0x10C010130ull;

static const uint64_t P9N2_EX_7_CME_LCL_DBG_PPE                                    = 0x10C020120ull;

static const uint64_t P9N2_EX_7_CME_LCL_DBG_PPE1                                   = 0x10C020138ull;

static const uint64_t P9N2_EX_7_CME_LCL_DBG_PPE2                                   = 0x10C020130ull;

static const uint64_t P9N2_EX_8_CME_LCL_DBG_PPE                                    = 0x10D010120ull;

static const uint64_t P9N2_EX_8_CME_LCL_DBG_PPE1                                   = 0x10D010138ull;

static const uint64_t P9N2_EX_8_CME_LCL_DBG_PPE2                                   = 0x10D010130ull;

static const uint64_t P9N2_EX_9_CME_LCL_DBG_PPE                                    = 0x10D020120ull;

static const uint64_t P9N2_EX_9_CME_LCL_DBG_PPE1                                   = 0x10D020138ull;

static const uint64_t P9N2_EX_9_CME_LCL_DBG_PPE2                                   = 0x10D020130ull;

static const uint64_t P9N2_EX_10_CME_LCL_DBG_PPE                                   = 0x10E010120ull;

static const uint64_t P9N2_EX_10_CME_LCL_DBG_PPE1                                  = 0x10E010138ull;

static const uint64_t P9N2_EX_10_CME_LCL_DBG_PPE2                                  = 0x10E010130ull;

static const uint64_t P9N2_EX_11_CME_LCL_DBG_PPE                                   = 0x10E020120ull;

static const uint64_t P9N2_EX_11_CME_LCL_DBG_PPE1                                  = 0x10E020138ull;

static const uint64_t P9N2_EX_11_CME_LCL_DBG_PPE2                                  = 0x10E020130ull;


static const uint64_t P9N2_EQ_CME_LCL_EIMR                                         = 0x10012026ull;
//DUPS: 10012026,
static const uint64_t P9N2_EQ_0_CME_LCL_EIMR                                       = 0x10012026ull;
//DUPS: 10012026,
static const uint64_t P9N2_EQ_1_CME_LCL_EIMR                                       = 0x11012026ull;
//DUPS: 11012026,
static const uint64_t P9N2_EQ_2_CME_LCL_EIMR                                       = 0x12012026ull;
//DUPS: 12012026,
static const uint64_t P9N2_EQ_3_CME_LCL_EIMR                                       = 0x13012026ull;
//DUPS: 13012026,
static const uint64_t P9N2_EQ_4_CME_LCL_EIMR                                       = 0x14012026ull;
//DUPS: 14012026,
static const uint64_t P9N2_EQ_5_CME_LCL_EIMR                                       = 0x15012026ull;
//DUPS: 15012026,
static const uint64_t P9N2_EX_CME_LCL_EIMR_PPE                                     = 0x109010020ull;

static const uint64_t P9N2_EX_CME_LCL_EIMR_PPE1                                    = 0x109010038ull;

static const uint64_t P9N2_EX_CME_LCL_EIMR_PPE2                                    = 0x109010030ull;

static const uint64_t P9N2_EX_CME_LCL_EIMR_SCOM                                    = 0x10012026ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIMR_PPE                                   = 0x109010020ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIMR_PPE1                                  = 0x109010038ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIMR_PPE2                                  = 0x109010030ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIMR_SCOM                                  = 0x10012026ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIMR_PPE                                   = 0x109020020ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIMR_PPE1                                  = 0x109020038ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIMR_PPE2                                  = 0x109020030ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIMR_SCOM                                  = 0x10012426ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIMR_PPE                                   = 0x10A010020ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIMR_PPE1                                  = 0x10A010038ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIMR_PPE2                                  = 0x10A010030ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIMR_SCOM                                  = 0x11012026ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIMR_PPE                                   = 0x10A020020ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIMR_PPE1                                  = 0x10A020038ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIMR_PPE2                                  = 0x10A020030ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIMR_SCOM                                  = 0x11012426ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIMR_PPE                                   = 0x10B010020ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIMR_PPE1                                  = 0x10B010038ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIMR_PPE2                                  = 0x10B010030ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIMR_SCOM                                  = 0x12012026ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIMR_PPE                                   = 0x10B020020ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIMR_PPE1                                  = 0x10B020038ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIMR_PPE2                                  = 0x10B020030ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIMR_SCOM                                  = 0x12012426ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIMR_PPE                                   = 0x10C010020ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIMR_PPE1                                  = 0x10C010038ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIMR_PPE2                                  = 0x10C010030ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIMR_SCOM                                  = 0x13012026ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIMR_PPE                                   = 0x10C020020ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIMR_PPE1                                  = 0x10C020038ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIMR_PPE2                                  = 0x10C020030ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIMR_SCOM                                  = 0x13012426ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIMR_PPE                                   = 0x10D010020ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIMR_PPE1                                  = 0x10D010038ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIMR_PPE2                                  = 0x10D010030ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIMR_SCOM                                  = 0x14012026ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIMR_PPE                                   = 0x10D020020ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIMR_PPE1                                  = 0x10D020038ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIMR_PPE2                                  = 0x10D020030ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIMR_SCOM                                  = 0x14012426ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIMR_PPE                                  = 0x10E010020ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIMR_PPE1                                 = 0x10E010038ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIMR_PPE2                                 = 0x10E010030ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIMR_SCOM                                 = 0x15012026ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIMR_PPE                                  = 0x10E020020ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIMR_PPE1                                 = 0x10E020038ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIMR_PPE2                                 = 0x10E020030ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIMR_SCOM                                 = 0x15012426ull;


static const uint64_t P9N2_EQ_CME_LCL_EINR                                         = 0x1001202Aull;
//DUPS: 1001202A,
static const uint64_t P9N2_EQ_0_CME_LCL_EINR                                       = 0x1001202Aull;
//DUPS: 1001202A,
static const uint64_t P9N2_EQ_1_CME_LCL_EINR                                       = 0x1101202Aull;
//DUPS: 1101202A,
static const uint64_t P9N2_EQ_2_CME_LCL_EINR                                       = 0x1201202Aull;
//DUPS: 1201202A,
static const uint64_t P9N2_EQ_3_CME_LCL_EINR                                       = 0x1301202Aull;
//DUPS: 1301202A,
static const uint64_t P9N2_EQ_4_CME_LCL_EINR                                       = 0x1401202Aull;
//DUPS: 1401202A,
static const uint64_t P9N2_EQ_5_CME_LCL_EINR                                       = 0x1501202Aull;
//DUPS: 1501202A,
static const uint64_t P9N2_EX_CME_LCL_EINR_PPE                                     = 0x1090100A0ull;

static const uint64_t P9N2_EX_CME_LCL_EINR_SCOM                                    = 0x1001202Aull;

static const uint64_t P9N2_EX_0_CME_LCL_EINR_PPE                                   = 0x1090100A0ull;

static const uint64_t P9N2_EX_0_CME_LCL_EINR_SCOM                                  = 0x1001202Aull;

static const uint64_t P9N2_EX_1_CME_LCL_EINR_PPE                                   = 0x1090200A0ull;

static const uint64_t P9N2_EX_1_CME_LCL_EINR_SCOM                                  = 0x1001242Aull;

static const uint64_t P9N2_EX_2_CME_LCL_EINR_PPE                                   = 0x10A0100A0ull;

static const uint64_t P9N2_EX_2_CME_LCL_EINR_SCOM                                  = 0x1101202Aull;

static const uint64_t P9N2_EX_3_CME_LCL_EINR_PPE                                   = 0x10A0200A0ull;

static const uint64_t P9N2_EX_3_CME_LCL_EINR_SCOM                                  = 0x1101242Aull;

static const uint64_t P9N2_EX_4_CME_LCL_EINR_PPE                                   = 0x10B0100A0ull;

static const uint64_t P9N2_EX_4_CME_LCL_EINR_SCOM                                  = 0x1201202Aull;

static const uint64_t P9N2_EX_5_CME_LCL_EINR_PPE                                   = 0x10B0200A0ull;

static const uint64_t P9N2_EX_5_CME_LCL_EINR_SCOM                                  = 0x1201242Aull;

static const uint64_t P9N2_EX_6_CME_LCL_EINR_PPE                                   = 0x10C0100A0ull;

static const uint64_t P9N2_EX_6_CME_LCL_EINR_SCOM                                  = 0x1301202Aull;

static const uint64_t P9N2_EX_7_CME_LCL_EINR_PPE                                   = 0x10C0200A0ull;

static const uint64_t P9N2_EX_7_CME_LCL_EINR_SCOM                                  = 0x1301242Aull;

static const uint64_t P9N2_EX_8_CME_LCL_EINR_PPE                                   = 0x10D0100A0ull;

static const uint64_t P9N2_EX_8_CME_LCL_EINR_SCOM                                  = 0x1401202Aull;

static const uint64_t P9N2_EX_9_CME_LCL_EINR_PPE                                   = 0x10D0200A0ull;

static const uint64_t P9N2_EX_9_CME_LCL_EINR_SCOM                                  = 0x1401242Aull;

static const uint64_t P9N2_EX_10_CME_LCL_EINR_PPE                                  = 0x10E0100A0ull;

static const uint64_t P9N2_EX_10_CME_LCL_EINR_SCOM                                 = 0x1501202Aull;

static const uint64_t P9N2_EX_11_CME_LCL_EINR_PPE                                  = 0x10E0200A0ull;

static const uint64_t P9N2_EX_11_CME_LCL_EINR_SCOM                                 = 0x1501242Aull;


static const uint64_t P9N2_EQ_CME_LCL_EIPR                                         = 0x10012027ull;
//DUPS: 10012027,
static const uint64_t P9N2_EQ_0_CME_LCL_EIPR                                       = 0x10012027ull;
//DUPS: 10012027,
static const uint64_t P9N2_EQ_1_CME_LCL_EIPR                                       = 0x11012027ull;
//DUPS: 11012027,
static const uint64_t P9N2_EQ_2_CME_LCL_EIPR                                       = 0x12012027ull;
//DUPS: 12012027,
static const uint64_t P9N2_EQ_3_CME_LCL_EIPR                                       = 0x13012027ull;
//DUPS: 13012027,
static const uint64_t P9N2_EQ_4_CME_LCL_EIPR                                       = 0x14012027ull;
//DUPS: 14012027,
static const uint64_t P9N2_EQ_5_CME_LCL_EIPR                                       = 0x15012027ull;
//DUPS: 15012027,
static const uint64_t P9N2_EX_CME_LCL_EIPR_PPE                                     = 0x109010040ull;

static const uint64_t P9N2_EX_CME_LCL_EIPR_PPE1                                    = 0x109010058ull;

static const uint64_t P9N2_EX_CME_LCL_EIPR_PPE2                                    = 0x109010050ull;

static const uint64_t P9N2_EX_CME_LCL_EIPR_SCOM                                    = 0x10012027ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIPR_PPE                                   = 0x109010040ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIPR_PPE1                                  = 0x109010058ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIPR_PPE2                                  = 0x109010050ull;

static const uint64_t P9N2_EX_0_CME_LCL_EIPR_SCOM                                  = 0x10012027ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIPR_PPE                                   = 0x109020040ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIPR_PPE1                                  = 0x109020058ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIPR_PPE2                                  = 0x109020050ull;

static const uint64_t P9N2_EX_1_CME_LCL_EIPR_SCOM                                  = 0x10012427ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIPR_PPE                                   = 0x10A010040ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIPR_PPE1                                  = 0x10A010058ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIPR_PPE2                                  = 0x10A010050ull;

static const uint64_t P9N2_EX_2_CME_LCL_EIPR_SCOM                                  = 0x11012027ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIPR_PPE                                   = 0x10A020040ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIPR_PPE1                                  = 0x10A020058ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIPR_PPE2                                  = 0x10A020050ull;

static const uint64_t P9N2_EX_3_CME_LCL_EIPR_SCOM                                  = 0x11012427ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIPR_PPE                                   = 0x10B010040ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIPR_PPE1                                  = 0x10B010058ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIPR_PPE2                                  = 0x10B010050ull;

static const uint64_t P9N2_EX_4_CME_LCL_EIPR_SCOM                                  = 0x12012027ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIPR_PPE                                   = 0x10B020040ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIPR_PPE1                                  = 0x10B020058ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIPR_PPE2                                  = 0x10B020050ull;

static const uint64_t P9N2_EX_5_CME_LCL_EIPR_SCOM                                  = 0x12012427ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIPR_PPE                                   = 0x10C010040ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIPR_PPE1                                  = 0x10C010058ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIPR_PPE2                                  = 0x10C010050ull;

static const uint64_t P9N2_EX_6_CME_LCL_EIPR_SCOM                                  = 0x13012027ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIPR_PPE                                   = 0x10C020040ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIPR_PPE1                                  = 0x10C020058ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIPR_PPE2                                  = 0x10C020050ull;

static const uint64_t P9N2_EX_7_CME_LCL_EIPR_SCOM                                  = 0x13012427ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIPR_PPE                                   = 0x10D010040ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIPR_PPE1                                  = 0x10D010058ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIPR_PPE2                                  = 0x10D010050ull;

static const uint64_t P9N2_EX_8_CME_LCL_EIPR_SCOM                                  = 0x14012027ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIPR_PPE                                   = 0x10D020040ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIPR_PPE1                                  = 0x10D020058ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIPR_PPE2                                  = 0x10D020050ull;

static const uint64_t P9N2_EX_9_CME_LCL_EIPR_SCOM                                  = 0x14012427ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIPR_PPE                                  = 0x10E010040ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIPR_PPE1                                 = 0x10E010058ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIPR_PPE2                                 = 0x10E010050ull;

static const uint64_t P9N2_EX_10_CME_LCL_EIPR_SCOM                                 = 0x15012027ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIPR_PPE                                  = 0x10E020040ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIPR_PPE1                                 = 0x10E020058ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIPR_PPE2                                 = 0x10E020050ull;

static const uint64_t P9N2_EX_11_CME_LCL_EIPR_SCOM                                 = 0x15012427ull;


static const uint64_t P9N2_EQ_CME_LCL_EISR                                         = 0x10012025ull;
//DUPS: 10012025,
static const uint64_t P9N2_EQ_0_CME_LCL_EISR                                       = 0x10012025ull;
//DUPS: 10012025,
static const uint64_t P9N2_EQ_1_CME_LCL_EISR                                       = 0x11012025ull;
//DUPS: 11012025,
static const uint64_t P9N2_EQ_2_CME_LCL_EISR                                       = 0x12012025ull;
//DUPS: 12012025,
static const uint64_t P9N2_EQ_3_CME_LCL_EISR                                       = 0x13012025ull;
//DUPS: 13012025,
static const uint64_t P9N2_EQ_4_CME_LCL_EISR                                       = 0x14012025ull;
//DUPS: 14012025,
static const uint64_t P9N2_EQ_5_CME_LCL_EISR                                       = 0x15012025ull;
//DUPS: 15012025,
static const uint64_t P9N2_EX_CME_LCL_EISR_PPE                                     = 0x109010000ull;

static const uint64_t P9N2_EX_CME_LCL_EISR_PPE1                                    = 0x109010018ull;

static const uint64_t P9N2_EX_CME_LCL_EISR_PPE2                                    = 0x109010010ull;

static const uint64_t P9N2_EX_CME_LCL_EISR_SCOM                                    = 0x10012025ull;

static const uint64_t P9N2_EX_0_CME_LCL_EISR_PPE                                   = 0x109010000ull;

static const uint64_t P9N2_EX_0_CME_LCL_EISR_PPE1                                  = 0x109010018ull;

static const uint64_t P9N2_EX_0_CME_LCL_EISR_PPE2                                  = 0x109010010ull;

static const uint64_t P9N2_EX_0_CME_LCL_EISR_SCOM                                  = 0x10012025ull;

static const uint64_t P9N2_EX_1_CME_LCL_EISR_PPE                                   = 0x109020000ull;

static const uint64_t P9N2_EX_1_CME_LCL_EISR_PPE1                                  = 0x109020018ull;

static const uint64_t P9N2_EX_1_CME_LCL_EISR_PPE2                                  = 0x109020010ull;

static const uint64_t P9N2_EX_1_CME_LCL_EISR_SCOM                                  = 0x10012425ull;

static const uint64_t P9N2_EX_2_CME_LCL_EISR_PPE                                   = 0x10A010000ull;

static const uint64_t P9N2_EX_2_CME_LCL_EISR_PPE1                                  = 0x10A010018ull;

static const uint64_t P9N2_EX_2_CME_LCL_EISR_PPE2                                  = 0x10A010010ull;

static const uint64_t P9N2_EX_2_CME_LCL_EISR_SCOM                                  = 0x11012025ull;

static const uint64_t P9N2_EX_3_CME_LCL_EISR_PPE                                   = 0x10A020000ull;

static const uint64_t P9N2_EX_3_CME_LCL_EISR_PPE1                                  = 0x10A020018ull;

static const uint64_t P9N2_EX_3_CME_LCL_EISR_PPE2                                  = 0x10A020010ull;

static const uint64_t P9N2_EX_3_CME_LCL_EISR_SCOM                                  = 0x11012425ull;

static const uint64_t P9N2_EX_4_CME_LCL_EISR_PPE                                   = 0x10B010000ull;

static const uint64_t P9N2_EX_4_CME_LCL_EISR_PPE1                                  = 0x10B010018ull;

static const uint64_t P9N2_EX_4_CME_LCL_EISR_PPE2                                  = 0x10B010010ull;

static const uint64_t P9N2_EX_4_CME_LCL_EISR_SCOM                                  = 0x12012025ull;

static const uint64_t P9N2_EX_5_CME_LCL_EISR_PPE                                   = 0x10B020000ull;

static const uint64_t P9N2_EX_5_CME_LCL_EISR_PPE1                                  = 0x10B020018ull;

static const uint64_t P9N2_EX_5_CME_LCL_EISR_PPE2                                  = 0x10B020010ull;

static const uint64_t P9N2_EX_5_CME_LCL_EISR_SCOM                                  = 0x12012425ull;

static const uint64_t P9N2_EX_6_CME_LCL_EISR_PPE                                   = 0x10C010000ull;

static const uint64_t P9N2_EX_6_CME_LCL_EISR_PPE1                                  = 0x10C010018ull;

static const uint64_t P9N2_EX_6_CME_LCL_EISR_PPE2                                  = 0x10C010010ull;

static const uint64_t P9N2_EX_6_CME_LCL_EISR_SCOM                                  = 0x13012025ull;

static const uint64_t P9N2_EX_7_CME_LCL_EISR_PPE                                   = 0x10C020000ull;

static const uint64_t P9N2_EX_7_CME_LCL_EISR_PPE1                                  = 0x10C020018ull;

static const uint64_t P9N2_EX_7_CME_LCL_EISR_PPE2                                  = 0x10C020010ull;

static const uint64_t P9N2_EX_7_CME_LCL_EISR_SCOM                                  = 0x13012425ull;

static const uint64_t P9N2_EX_8_CME_LCL_EISR_PPE                                   = 0x10D010000ull;

static const uint64_t P9N2_EX_8_CME_LCL_EISR_PPE1                                  = 0x10D010018ull;

static const uint64_t P9N2_EX_8_CME_LCL_EISR_PPE2                                  = 0x10D010010ull;

static const uint64_t P9N2_EX_8_CME_LCL_EISR_SCOM                                  = 0x14012025ull;

static const uint64_t P9N2_EX_9_CME_LCL_EISR_PPE                                   = 0x10D020000ull;

static const uint64_t P9N2_EX_9_CME_LCL_EISR_PPE1                                  = 0x10D020018ull;

static const uint64_t P9N2_EX_9_CME_LCL_EISR_PPE2                                  = 0x10D020010ull;

static const uint64_t P9N2_EX_9_CME_LCL_EISR_SCOM                                  = 0x14012425ull;

static const uint64_t P9N2_EX_10_CME_LCL_EISR_PPE                                  = 0x10E010000ull;

static const uint64_t P9N2_EX_10_CME_LCL_EISR_PPE1                                 = 0x10E010018ull;

static const uint64_t P9N2_EX_10_CME_LCL_EISR_PPE2                                 = 0x10E010010ull;

static const uint64_t P9N2_EX_10_CME_LCL_EISR_SCOM                                 = 0x15012025ull;

static const uint64_t P9N2_EX_11_CME_LCL_EISR_PPE                                  = 0x10E020000ull;

static const uint64_t P9N2_EX_11_CME_LCL_EISR_PPE1                                 = 0x10E020018ull;

static const uint64_t P9N2_EX_11_CME_LCL_EISR_PPE2                                 = 0x10E020010ull;

static const uint64_t P9N2_EX_11_CME_LCL_EISR_SCOM                                 = 0x15012425ull;


static const uint64_t P9N2_EQ_CME_LCL_EISTR                                        = 0x10012029ull;
//DUPS: 10012029,
static const uint64_t P9N2_EQ_0_CME_LCL_EISTR                                      = 0x10012029ull;
//DUPS: 10012029,
static const uint64_t P9N2_EQ_1_CME_LCL_EISTR                                      = 0x11012029ull;
//DUPS: 11012029,
static const uint64_t P9N2_EQ_2_CME_LCL_EISTR                                      = 0x12012029ull;
//DUPS: 12012029,
static const uint64_t P9N2_EQ_3_CME_LCL_EISTR                                      = 0x13012029ull;
//DUPS: 13012029,
static const uint64_t P9N2_EQ_4_CME_LCL_EISTR                                      = 0x14012029ull;
//DUPS: 14012029,
static const uint64_t P9N2_EQ_5_CME_LCL_EISTR                                      = 0x15012029ull;
//DUPS: 15012029,
static const uint64_t P9N2_EX_CME_LCL_EISTR_PPE                                    = 0x109010080ull;

static const uint64_t P9N2_EX_CME_LCL_EISTR_SCOM                                   = 0x10012029ull;

static const uint64_t P9N2_EX_0_CME_LCL_EISTR_PPE                                  = 0x109010080ull;

static const uint64_t P9N2_EX_0_CME_LCL_EISTR_SCOM                                 = 0x10012029ull;

static const uint64_t P9N2_EX_1_CME_LCL_EISTR_PPE                                  = 0x109020080ull;

static const uint64_t P9N2_EX_1_CME_LCL_EISTR_SCOM                                 = 0x10012429ull;

static const uint64_t P9N2_EX_2_CME_LCL_EISTR_PPE                                  = 0x10A010080ull;

static const uint64_t P9N2_EX_2_CME_LCL_EISTR_SCOM                                 = 0x11012029ull;

static const uint64_t P9N2_EX_3_CME_LCL_EISTR_PPE                                  = 0x10A020080ull;

static const uint64_t P9N2_EX_3_CME_LCL_EISTR_SCOM                                 = 0x11012429ull;

static const uint64_t P9N2_EX_4_CME_LCL_EISTR_PPE                                  = 0x10B010080ull;

static const uint64_t P9N2_EX_4_CME_LCL_EISTR_SCOM                                 = 0x12012029ull;

static const uint64_t P9N2_EX_5_CME_LCL_EISTR_PPE                                  = 0x10B020080ull;

static const uint64_t P9N2_EX_5_CME_LCL_EISTR_SCOM                                 = 0x12012429ull;

static const uint64_t P9N2_EX_6_CME_LCL_EISTR_PPE                                  = 0x10C010080ull;

static const uint64_t P9N2_EX_6_CME_LCL_EISTR_SCOM                                 = 0x13012029ull;

static const uint64_t P9N2_EX_7_CME_LCL_EISTR_PPE                                  = 0x10C020080ull;

static const uint64_t P9N2_EX_7_CME_LCL_EISTR_SCOM                                 = 0x13012429ull;

static const uint64_t P9N2_EX_8_CME_LCL_EISTR_PPE                                  = 0x10D010080ull;

static const uint64_t P9N2_EX_8_CME_LCL_EISTR_SCOM                                 = 0x14012029ull;

static const uint64_t P9N2_EX_9_CME_LCL_EISTR_PPE                                  = 0x10D020080ull;

static const uint64_t P9N2_EX_9_CME_LCL_EISTR_SCOM                                 = 0x14012429ull;

static const uint64_t P9N2_EX_10_CME_LCL_EISTR_PPE                                 = 0x10E010080ull;

static const uint64_t P9N2_EX_10_CME_LCL_EISTR_SCOM                                = 0x15012029ull;

static const uint64_t P9N2_EX_11_CME_LCL_EISTR_PPE                                 = 0x10E020080ull;

static const uint64_t P9N2_EX_11_CME_LCL_EISTR_SCOM                                = 0x15012429ull;


static const uint64_t P9N2_EQ_CME_LCL_EITR                                         = 0x10012028ull;
//DUPS: 10012028,
static const uint64_t P9N2_EQ_0_CME_LCL_EITR                                       = 0x10012028ull;
//DUPS: 10012028,
static const uint64_t P9N2_EQ_1_CME_LCL_EITR                                       = 0x11012028ull;
//DUPS: 11012028,
static const uint64_t P9N2_EQ_2_CME_LCL_EITR                                       = 0x12012028ull;
//DUPS: 12012028,
static const uint64_t P9N2_EQ_3_CME_LCL_EITR                                       = 0x13012028ull;
//DUPS: 13012028,
static const uint64_t P9N2_EQ_4_CME_LCL_EITR                                       = 0x14012028ull;
//DUPS: 14012028,
static const uint64_t P9N2_EQ_5_CME_LCL_EITR                                       = 0x15012028ull;
//DUPS: 15012028,
static const uint64_t P9N2_EX_CME_LCL_EITR_PPE                                     = 0x109010060ull;

static const uint64_t P9N2_EX_CME_LCL_EITR_PPE1                                    = 0x109010078ull;

static const uint64_t P9N2_EX_CME_LCL_EITR_PPE2                                    = 0x109010070ull;

static const uint64_t P9N2_EX_CME_LCL_EITR_SCOM                                    = 0x10012028ull;

static const uint64_t P9N2_EX_0_CME_LCL_EITR_PPE                                   = 0x109010060ull;

static const uint64_t P9N2_EX_0_CME_LCL_EITR_PPE1                                  = 0x109010078ull;

static const uint64_t P9N2_EX_0_CME_LCL_EITR_PPE2                                  = 0x109010070ull;

static const uint64_t P9N2_EX_0_CME_LCL_EITR_SCOM                                  = 0x10012028ull;

static const uint64_t P9N2_EX_1_CME_LCL_EITR_PPE                                   = 0x109020060ull;

static const uint64_t P9N2_EX_1_CME_LCL_EITR_PPE1                                  = 0x109020078ull;

static const uint64_t P9N2_EX_1_CME_LCL_EITR_PPE2                                  = 0x109020070ull;

static const uint64_t P9N2_EX_1_CME_LCL_EITR_SCOM                                  = 0x10012428ull;

static const uint64_t P9N2_EX_2_CME_LCL_EITR_PPE                                   = 0x10A010060ull;

static const uint64_t P9N2_EX_2_CME_LCL_EITR_PPE1                                  = 0x10A010078ull;

static const uint64_t P9N2_EX_2_CME_LCL_EITR_PPE2                                  = 0x10A010070ull;

static const uint64_t P9N2_EX_2_CME_LCL_EITR_SCOM                                  = 0x11012028ull;

static const uint64_t P9N2_EX_3_CME_LCL_EITR_PPE                                   = 0x10A020060ull;

static const uint64_t P9N2_EX_3_CME_LCL_EITR_PPE1                                  = 0x10A020078ull;

static const uint64_t P9N2_EX_3_CME_LCL_EITR_PPE2                                  = 0x10A020070ull;

static const uint64_t P9N2_EX_3_CME_LCL_EITR_SCOM                                  = 0x11012428ull;

static const uint64_t P9N2_EX_4_CME_LCL_EITR_PPE                                   = 0x10B010060ull;

static const uint64_t P9N2_EX_4_CME_LCL_EITR_PPE1                                  = 0x10B010078ull;

static const uint64_t P9N2_EX_4_CME_LCL_EITR_PPE2                                  = 0x10B010070ull;

static const uint64_t P9N2_EX_4_CME_LCL_EITR_SCOM                                  = 0x12012028ull;

static const uint64_t P9N2_EX_5_CME_LCL_EITR_PPE                                   = 0x10B020060ull;

static const uint64_t P9N2_EX_5_CME_LCL_EITR_PPE1                                  = 0x10B020078ull;

static const uint64_t P9N2_EX_5_CME_LCL_EITR_PPE2                                  = 0x10B020070ull;

static const uint64_t P9N2_EX_5_CME_LCL_EITR_SCOM                                  = 0x12012428ull;

static const uint64_t P9N2_EX_6_CME_LCL_EITR_PPE                                   = 0x10C010060ull;

static const uint64_t P9N2_EX_6_CME_LCL_EITR_PPE1                                  = 0x10C010078ull;

static const uint64_t P9N2_EX_6_CME_LCL_EITR_PPE2                                  = 0x10C010070ull;

static const uint64_t P9N2_EX_6_CME_LCL_EITR_SCOM                                  = 0x13012028ull;

static const uint64_t P9N2_EX_7_CME_LCL_EITR_PPE                                   = 0x10C020060ull;

static const uint64_t P9N2_EX_7_CME_LCL_EITR_PPE1                                  = 0x10C020078ull;

static const uint64_t P9N2_EX_7_CME_LCL_EITR_PPE2                                  = 0x10C020070ull;

static const uint64_t P9N2_EX_7_CME_LCL_EITR_SCOM                                  = 0x13012428ull;

static const uint64_t P9N2_EX_8_CME_LCL_EITR_PPE                                   = 0x10D010060ull;

static const uint64_t P9N2_EX_8_CME_LCL_EITR_PPE1                                  = 0x10D010078ull;

static const uint64_t P9N2_EX_8_CME_LCL_EITR_PPE2                                  = 0x10D010070ull;

static const uint64_t P9N2_EX_8_CME_LCL_EITR_SCOM                                  = 0x14012028ull;

static const uint64_t P9N2_EX_9_CME_LCL_EITR_PPE                                   = 0x10D020060ull;

static const uint64_t P9N2_EX_9_CME_LCL_EITR_PPE1                                  = 0x10D020078ull;

static const uint64_t P9N2_EX_9_CME_LCL_EITR_PPE2                                  = 0x10D020070ull;

static const uint64_t P9N2_EX_9_CME_LCL_EITR_SCOM                                  = 0x14012428ull;

static const uint64_t P9N2_EX_10_CME_LCL_EITR_PPE                                  = 0x10E010060ull;

static const uint64_t P9N2_EX_10_CME_LCL_EITR_PPE1                                 = 0x10E010078ull;

static const uint64_t P9N2_EX_10_CME_LCL_EITR_PPE2                                 = 0x10E010070ull;

static const uint64_t P9N2_EX_10_CME_LCL_EITR_SCOM                                 = 0x15012028ull;

static const uint64_t P9N2_EX_11_CME_LCL_EITR_PPE                                  = 0x10E020060ull;

static const uint64_t P9N2_EX_11_CME_LCL_EITR_PPE1                                 = 0x10E020078ull;

static const uint64_t P9N2_EX_11_CME_LCL_EITR_PPE2                                 = 0x10E020070ull;

static const uint64_t P9N2_EX_11_CME_LCL_EITR_SCOM                                 = 0x15012428ull;


static const uint64_t P9N2_EX_CME_LCL_ICCR_PPE                                     = 0x109010700ull;

static const uint64_t P9N2_EX_CME_LCL_ICCR_PPE1                                    = 0x109010718ull;

static const uint64_t P9N2_EX_CME_LCL_ICCR_PPE2                                    = 0x109010710ull;

static const uint64_t P9N2_EX_0_CME_LCL_ICCR_PPE                                   = 0x109010700ull;

static const uint64_t P9N2_EX_0_CME_LCL_ICCR_PPE1                                  = 0x109010718ull;

static const uint64_t P9N2_EX_0_CME_LCL_ICCR_PPE2                                  = 0x109010710ull;

static const uint64_t P9N2_EX_1_CME_LCL_ICCR_PPE                                   = 0x109020700ull;

static const uint64_t P9N2_EX_1_CME_LCL_ICCR_PPE1                                  = 0x109020718ull;

static const uint64_t P9N2_EX_1_CME_LCL_ICCR_PPE2                                  = 0x109020710ull;

static const uint64_t P9N2_EX_2_CME_LCL_ICCR_PPE                                   = 0x10A010700ull;

static const uint64_t P9N2_EX_2_CME_LCL_ICCR_PPE1                                  = 0x10A010718ull;

static const uint64_t P9N2_EX_2_CME_LCL_ICCR_PPE2                                  = 0x10A010710ull;

static const uint64_t P9N2_EX_3_CME_LCL_ICCR_PPE                                   = 0x10A020700ull;

static const uint64_t P9N2_EX_3_CME_LCL_ICCR_PPE1                                  = 0x10A020718ull;

static const uint64_t P9N2_EX_3_CME_LCL_ICCR_PPE2                                  = 0x10A020710ull;

static const uint64_t P9N2_EX_4_CME_LCL_ICCR_PPE                                   = 0x10B010700ull;

static const uint64_t P9N2_EX_4_CME_LCL_ICCR_PPE1                                  = 0x10B010718ull;

static const uint64_t P9N2_EX_4_CME_LCL_ICCR_PPE2                                  = 0x10B010710ull;

static const uint64_t P9N2_EX_5_CME_LCL_ICCR_PPE                                   = 0x10B020700ull;

static const uint64_t P9N2_EX_5_CME_LCL_ICCR_PPE1                                  = 0x10B020718ull;

static const uint64_t P9N2_EX_5_CME_LCL_ICCR_PPE2                                  = 0x10B020710ull;

static const uint64_t P9N2_EX_6_CME_LCL_ICCR_PPE                                   = 0x10C010700ull;

static const uint64_t P9N2_EX_6_CME_LCL_ICCR_PPE1                                  = 0x10C010718ull;

static const uint64_t P9N2_EX_6_CME_LCL_ICCR_PPE2                                  = 0x10C010710ull;

static const uint64_t P9N2_EX_7_CME_LCL_ICCR_PPE                                   = 0x10C020700ull;

static const uint64_t P9N2_EX_7_CME_LCL_ICCR_PPE1                                  = 0x10C020718ull;

static const uint64_t P9N2_EX_7_CME_LCL_ICCR_PPE2                                  = 0x10C020710ull;

static const uint64_t P9N2_EX_8_CME_LCL_ICCR_PPE                                   = 0x10D010700ull;

static const uint64_t P9N2_EX_8_CME_LCL_ICCR_PPE1                                  = 0x10D010718ull;

static const uint64_t P9N2_EX_8_CME_LCL_ICCR_PPE2                                  = 0x10D010710ull;

static const uint64_t P9N2_EX_9_CME_LCL_ICCR_PPE                                   = 0x10D020700ull;

static const uint64_t P9N2_EX_9_CME_LCL_ICCR_PPE1                                  = 0x10D020718ull;

static const uint64_t P9N2_EX_9_CME_LCL_ICCR_PPE2                                  = 0x10D020710ull;

static const uint64_t P9N2_EX_10_CME_LCL_ICCR_PPE                                  = 0x10E010700ull;

static const uint64_t P9N2_EX_10_CME_LCL_ICCR_PPE1                                 = 0x10E010718ull;

static const uint64_t P9N2_EX_10_CME_LCL_ICCR_PPE2                                 = 0x10E010710ull;

static const uint64_t P9N2_EX_11_CME_LCL_ICCR_PPE                                  = 0x10E020700ull;

static const uint64_t P9N2_EX_11_CME_LCL_ICCR_PPE1                                 = 0x10E020718ull;

static const uint64_t P9N2_EX_11_CME_LCL_ICCR_PPE2                                 = 0x10E020710ull;


static const uint64_t P9N2_EQ_CME_LCL_ICRR                                         = 0x1001204Dull;
//DUPS: 1001204D,
static const uint64_t P9N2_EQ_0_CME_LCL_ICRR                                       = 0x1001204Dull;
//DUPS: 1001204D,
static const uint64_t P9N2_EQ_1_CME_LCL_ICRR                                       = 0x1101204Dull;
//DUPS: 1101204D,
static const uint64_t P9N2_EQ_2_CME_LCL_ICRR                                       = 0x1201204Dull;
//DUPS: 1201204D,
static const uint64_t P9N2_EQ_3_CME_LCL_ICRR                                       = 0x1301204Dull;
//DUPS: 1301204D,
static const uint64_t P9N2_EQ_4_CME_LCL_ICRR                                       = 0x1401204Dull;
//DUPS: 1401204D,
static const uint64_t P9N2_EQ_5_CME_LCL_ICRR                                       = 0x1501204Dull;
//DUPS: 1501204D,
static const uint64_t P9N2_EX_CME_LCL_ICRR_PPE                                     = 0x109010740ull;

static const uint64_t P9N2_EX_CME_LCL_ICRR_SCOM                                    = 0x1001204Dull;

static const uint64_t P9N2_EX_0_CME_LCL_ICRR_PPE                                   = 0x109010740ull;

static const uint64_t P9N2_EX_0_CME_LCL_ICRR_SCOM                                  = 0x1001204Dull;

static const uint64_t P9N2_EX_1_CME_LCL_ICRR_PPE                                   = 0x109020740ull;

static const uint64_t P9N2_EX_1_CME_LCL_ICRR_SCOM                                  = 0x1001244Dull;

static const uint64_t P9N2_EX_2_CME_LCL_ICRR_PPE                                   = 0x10A010740ull;

static const uint64_t P9N2_EX_2_CME_LCL_ICRR_SCOM                                  = 0x1101204Dull;

static const uint64_t P9N2_EX_3_CME_LCL_ICRR_PPE                                   = 0x10A020740ull;

static const uint64_t P9N2_EX_3_CME_LCL_ICRR_SCOM                                  = 0x1101244Dull;

static const uint64_t P9N2_EX_4_CME_LCL_ICRR_PPE                                   = 0x10B010740ull;

static const uint64_t P9N2_EX_4_CME_LCL_ICRR_SCOM                                  = 0x1201204Dull;

static const uint64_t P9N2_EX_5_CME_LCL_ICRR_PPE                                   = 0x10B020740ull;

static const uint64_t P9N2_EX_5_CME_LCL_ICRR_SCOM                                  = 0x1201244Dull;

static const uint64_t P9N2_EX_6_CME_LCL_ICRR_PPE                                   = 0x10C010740ull;

static const uint64_t P9N2_EX_6_CME_LCL_ICRR_SCOM                                  = 0x1301204Dull;

static const uint64_t P9N2_EX_7_CME_LCL_ICRR_PPE                                   = 0x10C020740ull;

static const uint64_t P9N2_EX_7_CME_LCL_ICRR_SCOM                                  = 0x1301244Dull;

static const uint64_t P9N2_EX_8_CME_LCL_ICRR_PPE                                   = 0x10D010740ull;

static const uint64_t P9N2_EX_8_CME_LCL_ICRR_SCOM                                  = 0x1401204Dull;

static const uint64_t P9N2_EX_9_CME_LCL_ICRR_PPE                                   = 0x10D020740ull;

static const uint64_t P9N2_EX_9_CME_LCL_ICRR_SCOM                                  = 0x1401244Dull;

static const uint64_t P9N2_EX_10_CME_LCL_ICRR_PPE                                  = 0x10E010740ull;

static const uint64_t P9N2_EX_10_CME_LCL_ICRR_SCOM                                 = 0x1501204Dull;

static const uint64_t P9N2_EX_11_CME_LCL_ICRR_PPE                                  = 0x10E020740ull;

static const uint64_t P9N2_EX_11_CME_LCL_ICRR_SCOM                                 = 0x1501244Dull;


static const uint64_t P9N2_EX_CME_LCL_ICSR_PPE                                     = 0x109010720ull;

static const uint64_t P9N2_EX_0_CME_LCL_ICSR_PPE                                   = 0x109010720ull;

static const uint64_t P9N2_EX_1_CME_LCL_ICSR_PPE                                   = 0x109020720ull;

static const uint64_t P9N2_EX_2_CME_LCL_ICSR_PPE                                   = 0x10A010720ull;

static const uint64_t P9N2_EX_3_CME_LCL_ICSR_PPE                                   = 0x10A020720ull;

static const uint64_t P9N2_EX_4_CME_LCL_ICSR_PPE                                   = 0x10B010720ull;

static const uint64_t P9N2_EX_5_CME_LCL_ICSR_PPE                                   = 0x10B020720ull;

static const uint64_t P9N2_EX_6_CME_LCL_ICSR_PPE                                   = 0x10C010720ull;

static const uint64_t P9N2_EX_7_CME_LCL_ICSR_PPE                                   = 0x10C020720ull;

static const uint64_t P9N2_EX_8_CME_LCL_ICSR_PPE                                   = 0x10D010720ull;

static const uint64_t P9N2_EX_9_CME_LCL_ICSR_PPE                                   = 0x10D020720ull;

static const uint64_t P9N2_EX_10_CME_LCL_ICSR_PPE                                  = 0x10E010720ull;

static const uint64_t P9N2_EX_11_CME_LCL_ICSR_PPE                                  = 0x10E020720ull;


static const uint64_t P9N2_EX_CME_LCL_PECESR0_PPE                                  = 0x109010280ull;

static const uint64_t P9N2_EX_0_CME_LCL_PECESR0_PPE                                = 0x109010280ull;

static const uint64_t P9N2_EX_1_CME_LCL_PECESR0_PPE                                = 0x109020280ull;

static const uint64_t P9N2_EX_2_CME_LCL_PECESR0_PPE                                = 0x10A010280ull;

static const uint64_t P9N2_EX_3_CME_LCL_PECESR0_PPE                                = 0x10A020280ull;

static const uint64_t P9N2_EX_4_CME_LCL_PECESR0_PPE                                = 0x10B010280ull;

static const uint64_t P9N2_EX_5_CME_LCL_PECESR0_PPE                                = 0x10B020280ull;

static const uint64_t P9N2_EX_6_CME_LCL_PECESR0_PPE                                = 0x10C010280ull;

static const uint64_t P9N2_EX_7_CME_LCL_PECESR0_PPE                                = 0x10C020280ull;

static const uint64_t P9N2_EX_8_CME_LCL_PECESR0_PPE                                = 0x10D010280ull;

static const uint64_t P9N2_EX_9_CME_LCL_PECESR0_PPE                                = 0x10D020280ull;

static const uint64_t P9N2_EX_10_CME_LCL_PECESR0_PPE                               = 0x10E010280ull;

static const uint64_t P9N2_EX_11_CME_LCL_PECESR0_PPE                               = 0x10E020280ull;


static const uint64_t P9N2_EX_CME_LCL_PECESR1_PPE                                  = 0x1090102A0ull;

static const uint64_t P9N2_EX_0_CME_LCL_PECESR1_PPE                                = 0x1090102A0ull;

static const uint64_t P9N2_EX_1_CME_LCL_PECESR1_PPE                                = 0x1090202A0ull;

static const uint64_t P9N2_EX_2_CME_LCL_PECESR1_PPE                                = 0x10A0102A0ull;

static const uint64_t P9N2_EX_3_CME_LCL_PECESR1_PPE                                = 0x10A0202A0ull;

static const uint64_t P9N2_EX_4_CME_LCL_PECESR1_PPE                                = 0x10B0102A0ull;

static const uint64_t P9N2_EX_5_CME_LCL_PECESR1_PPE                                = 0x10B0202A0ull;

static const uint64_t P9N2_EX_6_CME_LCL_PECESR1_PPE                                = 0x10C0102A0ull;

static const uint64_t P9N2_EX_7_CME_LCL_PECESR1_PPE                                = 0x10C0202A0ull;

static const uint64_t P9N2_EX_8_CME_LCL_PECESR1_PPE                                = 0x10D0102A0ull;

static const uint64_t P9N2_EX_9_CME_LCL_PECESR1_PPE                                = 0x10D0202A0ull;

static const uint64_t P9N2_EX_10_CME_LCL_PECESR1_PPE                               = 0x10E0102A0ull;

static const uint64_t P9N2_EX_11_CME_LCL_PECESR1_PPE                               = 0x10E0202A0ull;


static const uint64_t P9N2_EQ_CME_LCL_SISR                                         = 0x1001204Cull;
//DUPS: 1001204C,
static const uint64_t P9N2_EQ_0_CME_LCL_SISR                                       = 0x1001204Cull;
//DUPS: 1001204C,
static const uint64_t P9N2_EQ_1_CME_LCL_SISR                                       = 0x1101204Cull;
//DUPS: 1101204C,
static const uint64_t P9N2_EQ_2_CME_LCL_SISR                                       = 0x1201204Cull;
//DUPS: 1201204C,
static const uint64_t P9N2_EQ_3_CME_LCL_SISR                                       = 0x1301204Cull;
//DUPS: 1301204C,
static const uint64_t P9N2_EQ_4_CME_LCL_SISR                                       = 0x1401204Cull;
//DUPS: 1401204C,
static const uint64_t P9N2_EQ_5_CME_LCL_SISR                                       = 0x1501204Cull;
//DUPS: 1501204C,
static const uint64_t P9N2_EX_CME_LCL_SISR_PPE                                     = 0x109010520ull;

static const uint64_t P9N2_EX_CME_LCL_SISR_SCOM                                    = 0x1001204Cull;

static const uint64_t P9N2_EX_0_CME_LCL_SISR_PPE                                   = 0x109010520ull;

static const uint64_t P9N2_EX_0_CME_LCL_SISR_SCOM                                  = 0x1001204Cull;

static const uint64_t P9N2_EX_1_CME_LCL_SISR_PPE                                   = 0x109020520ull;

static const uint64_t P9N2_EX_1_CME_LCL_SISR_SCOM                                  = 0x1001244Cull;

static const uint64_t P9N2_EX_2_CME_LCL_SISR_PPE                                   = 0x10A010520ull;

static const uint64_t P9N2_EX_2_CME_LCL_SISR_SCOM                                  = 0x1101204Cull;

static const uint64_t P9N2_EX_3_CME_LCL_SISR_PPE                                   = 0x10A020520ull;

static const uint64_t P9N2_EX_3_CME_LCL_SISR_SCOM                                  = 0x1101244Cull;

static const uint64_t P9N2_EX_4_CME_LCL_SISR_PPE                                   = 0x10B010520ull;

static const uint64_t P9N2_EX_4_CME_LCL_SISR_SCOM                                  = 0x1201204Cull;

static const uint64_t P9N2_EX_5_CME_LCL_SISR_PPE                                   = 0x10B020520ull;

static const uint64_t P9N2_EX_5_CME_LCL_SISR_SCOM                                  = 0x1201244Cull;

static const uint64_t P9N2_EX_6_CME_LCL_SISR_PPE                                   = 0x10C010520ull;

static const uint64_t P9N2_EX_6_CME_LCL_SISR_SCOM                                  = 0x1301204Cull;

static const uint64_t P9N2_EX_7_CME_LCL_SISR_PPE                                   = 0x10C020520ull;

static const uint64_t P9N2_EX_7_CME_LCL_SISR_SCOM                                  = 0x1301244Cull;

static const uint64_t P9N2_EX_8_CME_LCL_SISR_PPE                                   = 0x10D010520ull;

static const uint64_t P9N2_EX_8_CME_LCL_SISR_SCOM                                  = 0x1401204Cull;

static const uint64_t P9N2_EX_9_CME_LCL_SISR_PPE                                   = 0x10D020520ull;

static const uint64_t P9N2_EX_9_CME_LCL_SISR_SCOM                                  = 0x1401244Cull;

static const uint64_t P9N2_EX_10_CME_LCL_SISR_PPE                                  = 0x10E010520ull;

static const uint64_t P9N2_EX_10_CME_LCL_SISR_SCOM                                 = 0x1501204Cull;

static const uint64_t P9N2_EX_11_CME_LCL_SISR_PPE                                  = 0x10E020520ull;

static const uint64_t P9N2_EX_11_CME_LCL_SISR_SCOM                                 = 0x1501244Cull;


static const uint64_t P9N2_EX_CME_LCL_TSEL_PPE                                     = 0x109010100ull;

static const uint64_t P9N2_EX_0_CME_LCL_TSEL_PPE                                   = 0x109010100ull;

static const uint64_t P9N2_EX_1_CME_LCL_TSEL_PPE                                   = 0x109020100ull;

static const uint64_t P9N2_EX_2_CME_LCL_TSEL_PPE                                   = 0x10A010100ull;

static const uint64_t P9N2_EX_3_CME_LCL_TSEL_PPE                                   = 0x10A020100ull;

static const uint64_t P9N2_EX_4_CME_LCL_TSEL_PPE                                   = 0x10B010100ull;

static const uint64_t P9N2_EX_5_CME_LCL_TSEL_PPE                                   = 0x10B020100ull;

static const uint64_t P9N2_EX_6_CME_LCL_TSEL_PPE                                   = 0x10C010100ull;

static const uint64_t P9N2_EX_7_CME_LCL_TSEL_PPE                                   = 0x10C020100ull;

static const uint64_t P9N2_EX_8_CME_LCL_TSEL_PPE                                   = 0x10D010100ull;

static const uint64_t P9N2_EX_9_CME_LCL_TSEL_PPE                                   = 0x10D020100ull;

static const uint64_t P9N2_EX_10_CME_LCL_TSEL_PPE                                  = 0x10E010100ull;

static const uint64_t P9N2_EX_11_CME_LCL_TSEL_PPE                                  = 0x10E020100ull;


static const uint64_t P9N2_EQ_CME_SCOM_AFSR                                        = 0x10012033ull;
//DUPS: 10012033,
static const uint64_t P9N2_EQ_0_CME_SCOM_AFSR                                      = 0x10012033ull;
//DUPS: 10012033,
static const uint64_t P9N2_EQ_1_CME_SCOM_AFSR                                      = 0x11012033ull;
//DUPS: 11012033,
static const uint64_t P9N2_EQ_2_CME_SCOM_AFSR                                      = 0x12012033ull;
//DUPS: 12012033,
static const uint64_t P9N2_EQ_3_CME_SCOM_AFSR                                      = 0x13012033ull;
//DUPS: 13012033,
static const uint64_t P9N2_EQ_4_CME_SCOM_AFSR                                      = 0x14012033ull;
//DUPS: 14012033,
static const uint64_t P9N2_EQ_5_CME_SCOM_AFSR                                      = 0x15012033ull;
//DUPS: 15012033,
static const uint64_t P9N2_EX_CME_SCOM_AFSR_PPE                                    = 0x109010160ull;

static const uint64_t P9N2_EX_CME_SCOM_AFSR_SCOM                                   = 0x10012033ull;

static const uint64_t P9N2_EX_0_CME_SCOM_AFSR_PPE                                  = 0x109010160ull;

static const uint64_t P9N2_EX_0_CME_SCOM_AFSR_SCOM                                 = 0x10012033ull;

static const uint64_t P9N2_EX_1_CME_SCOM_AFSR_PPE                                  = 0x109020160ull;

static const uint64_t P9N2_EX_1_CME_SCOM_AFSR_SCOM                                 = 0x10012433ull;

static const uint64_t P9N2_EX_2_CME_SCOM_AFSR_PPE                                  = 0x10A010160ull;

static const uint64_t P9N2_EX_2_CME_SCOM_AFSR_SCOM                                 = 0x11012033ull;

static const uint64_t P9N2_EX_3_CME_SCOM_AFSR_PPE                                  = 0x10A020160ull;

static const uint64_t P9N2_EX_3_CME_SCOM_AFSR_SCOM                                 = 0x11012433ull;

static const uint64_t P9N2_EX_4_CME_SCOM_AFSR_PPE                                  = 0x10B010160ull;

static const uint64_t P9N2_EX_4_CME_SCOM_AFSR_SCOM                                 = 0x12012033ull;

static const uint64_t P9N2_EX_5_CME_SCOM_AFSR_PPE                                  = 0x10B020160ull;

static const uint64_t P9N2_EX_5_CME_SCOM_AFSR_SCOM                                 = 0x12012433ull;

static const uint64_t P9N2_EX_6_CME_SCOM_AFSR_PPE                                  = 0x10C010160ull;

static const uint64_t P9N2_EX_6_CME_SCOM_AFSR_SCOM                                 = 0x13012033ull;

static const uint64_t P9N2_EX_7_CME_SCOM_AFSR_PPE                                  = 0x10C020160ull;

static const uint64_t P9N2_EX_7_CME_SCOM_AFSR_SCOM                                 = 0x13012433ull;

static const uint64_t P9N2_EX_8_CME_SCOM_AFSR_PPE                                  = 0x10D010160ull;

static const uint64_t P9N2_EX_8_CME_SCOM_AFSR_SCOM                                 = 0x14012033ull;

static const uint64_t P9N2_EX_9_CME_SCOM_AFSR_PPE                                  = 0x10D020160ull;

static const uint64_t P9N2_EX_9_CME_SCOM_AFSR_SCOM                                 = 0x14012433ull;

static const uint64_t P9N2_EX_10_CME_SCOM_AFSR_PPE                                 = 0x10E010160ull;

static const uint64_t P9N2_EX_10_CME_SCOM_AFSR_SCOM                                = 0x15012033ull;

static const uint64_t P9N2_EX_11_CME_SCOM_AFSR_PPE                                 = 0x10E020160ull;

static const uint64_t P9N2_EX_11_CME_SCOM_AFSR_SCOM                                = 0x15012433ull;


static const uint64_t P9N2_EQ_CME_SCOM_AFTR                                        = 0x10012034ull;
//DUPS: 10012034,
static const uint64_t P9N2_EQ_0_CME_SCOM_AFTR                                      = 0x10012034ull;
//DUPS: 10012034,
static const uint64_t P9N2_EQ_1_CME_SCOM_AFTR                                      = 0x11012034ull;
//DUPS: 11012034,
static const uint64_t P9N2_EQ_2_CME_SCOM_AFTR                                      = 0x12012034ull;
//DUPS: 12012034,
static const uint64_t P9N2_EQ_3_CME_SCOM_AFTR                                      = 0x13012034ull;
//DUPS: 13012034,
static const uint64_t P9N2_EQ_4_CME_SCOM_AFTR                                      = 0x14012034ull;
//DUPS: 14012034,
static const uint64_t P9N2_EQ_5_CME_SCOM_AFTR                                      = 0x15012034ull;
//DUPS: 15012034,
static const uint64_t P9N2_EX_CME_SCOM_AFTR_PPE                                    = 0x109010180ull;

static const uint64_t P9N2_EX_CME_SCOM_AFTR_SCOM                                   = 0x10012034ull;

static const uint64_t P9N2_EX_0_CME_SCOM_AFTR_PPE                                  = 0x109010180ull;

static const uint64_t P9N2_EX_0_CME_SCOM_AFTR_SCOM                                 = 0x10012034ull;

static const uint64_t P9N2_EX_1_CME_SCOM_AFTR_PPE                                  = 0x109020180ull;

static const uint64_t P9N2_EX_1_CME_SCOM_AFTR_SCOM                                 = 0x10012434ull;

static const uint64_t P9N2_EX_2_CME_SCOM_AFTR_PPE                                  = 0x10A010180ull;

static const uint64_t P9N2_EX_2_CME_SCOM_AFTR_SCOM                                 = 0x11012034ull;

static const uint64_t P9N2_EX_3_CME_SCOM_AFTR_PPE                                  = 0x10A020180ull;

static const uint64_t P9N2_EX_3_CME_SCOM_AFTR_SCOM                                 = 0x11012434ull;

static const uint64_t P9N2_EX_4_CME_SCOM_AFTR_PPE                                  = 0x10B010180ull;

static const uint64_t P9N2_EX_4_CME_SCOM_AFTR_SCOM                                 = 0x12012034ull;

static const uint64_t P9N2_EX_5_CME_SCOM_AFTR_PPE                                  = 0x10B020180ull;

static const uint64_t P9N2_EX_5_CME_SCOM_AFTR_SCOM                                 = 0x12012434ull;

static const uint64_t P9N2_EX_6_CME_SCOM_AFTR_PPE                                  = 0x10C010180ull;

static const uint64_t P9N2_EX_6_CME_SCOM_AFTR_SCOM                                 = 0x13012034ull;

static const uint64_t P9N2_EX_7_CME_SCOM_AFTR_PPE                                  = 0x10C020180ull;

static const uint64_t P9N2_EX_7_CME_SCOM_AFTR_SCOM                                 = 0x13012434ull;

static const uint64_t P9N2_EX_8_CME_SCOM_AFTR_PPE                                  = 0x10D010180ull;

static const uint64_t P9N2_EX_8_CME_SCOM_AFTR_SCOM                                 = 0x14012034ull;

static const uint64_t P9N2_EX_9_CME_SCOM_AFTR_PPE                                  = 0x10D020180ull;

static const uint64_t P9N2_EX_9_CME_SCOM_AFTR_SCOM                                 = 0x14012434ull;

static const uint64_t P9N2_EX_10_CME_SCOM_AFTR_PPE                                 = 0x10E010180ull;

static const uint64_t P9N2_EX_10_CME_SCOM_AFTR_SCOM                                = 0x15012034ull;

static const uint64_t P9N2_EX_11_CME_SCOM_AFTR_PPE                                 = 0x10E020180ull;

static const uint64_t P9N2_EX_11_CME_SCOM_AFTR_SCOM                                = 0x15012434ull;


static const uint64_t P9N2_EQ_CME_SCOM_BCEBAR0                                     = 0x10012030ull;
//DUPS: 10012030,
static const uint64_t P9N2_EQ_0_CME_SCOM_BCEBAR0                                   = 0x10012030ull;
//DUPS: 10012030,
static const uint64_t P9N2_EQ_1_CME_SCOM_BCEBAR0                                   = 0x11012030ull;
//DUPS: 11012030,
static const uint64_t P9N2_EQ_2_CME_SCOM_BCEBAR0                                   = 0x12012030ull;
//DUPS: 12012030,
static const uint64_t P9N2_EQ_3_CME_SCOM_BCEBAR0                                   = 0x13012030ull;
//DUPS: 13012030,
static const uint64_t P9N2_EQ_4_CME_SCOM_BCEBAR0                                   = 0x14012030ull;
//DUPS: 14012030,
static const uint64_t P9N2_EQ_5_CME_SCOM_BCEBAR0                                   = 0x15012030ull;
//DUPS: 15012030,
static const uint64_t P9N2_EX_CME_SCOM_BCEBAR0                                     = 0x10012030ull;

static const uint64_t P9N2_EX_0_CME_SCOM_BCEBAR0                                   = 0x10012030ull;

static const uint64_t P9N2_EX_1_CME_SCOM_BCEBAR0                                   = 0x10012430ull;

static const uint64_t P9N2_EX_2_CME_SCOM_BCEBAR0                                   = 0x11012030ull;

static const uint64_t P9N2_EX_3_CME_SCOM_BCEBAR0                                   = 0x11012430ull;

static const uint64_t P9N2_EX_4_CME_SCOM_BCEBAR0                                   = 0x12012030ull;

static const uint64_t P9N2_EX_5_CME_SCOM_BCEBAR0                                   = 0x12012430ull;

static const uint64_t P9N2_EX_6_CME_SCOM_BCEBAR0                                   = 0x13012030ull;

static const uint64_t P9N2_EX_7_CME_SCOM_BCEBAR0                                   = 0x13012430ull;

static const uint64_t P9N2_EX_8_CME_SCOM_BCEBAR0                                   = 0x14012030ull;

static const uint64_t P9N2_EX_9_CME_SCOM_BCEBAR0                                   = 0x14012430ull;

static const uint64_t P9N2_EX_10_CME_SCOM_BCEBAR0                                  = 0x15012030ull;

static const uint64_t P9N2_EX_11_CME_SCOM_BCEBAR0                                  = 0x15012430ull;


static const uint64_t P9N2_EQ_CME_SCOM_BCEBAR1                                     = 0x10012031ull;
//DUPS: 10012031,
static const uint64_t P9N2_EQ_0_CME_SCOM_BCEBAR1                                   = 0x10012031ull;
//DUPS: 10012031,
static const uint64_t P9N2_EQ_1_CME_SCOM_BCEBAR1                                   = 0x11012031ull;
//DUPS: 11012031,
static const uint64_t P9N2_EQ_2_CME_SCOM_BCEBAR1                                   = 0x12012031ull;
//DUPS: 12012031,
static const uint64_t P9N2_EQ_3_CME_SCOM_BCEBAR1                                   = 0x13012031ull;
//DUPS: 13012031,
static const uint64_t P9N2_EQ_4_CME_SCOM_BCEBAR1                                   = 0x14012031ull;
//DUPS: 14012031,
static const uint64_t P9N2_EQ_5_CME_SCOM_BCEBAR1                                   = 0x15012031ull;
//DUPS: 15012031,
static const uint64_t P9N2_EX_CME_SCOM_BCEBAR1                                     = 0x10012031ull;

static const uint64_t P9N2_EX_0_CME_SCOM_BCEBAR1                                   = 0x10012031ull;

static const uint64_t P9N2_EX_1_CME_SCOM_BCEBAR1                                   = 0x10012431ull;

static const uint64_t P9N2_EX_2_CME_SCOM_BCEBAR1                                   = 0x11012031ull;

static const uint64_t P9N2_EX_3_CME_SCOM_BCEBAR1                                   = 0x11012431ull;

static const uint64_t P9N2_EX_4_CME_SCOM_BCEBAR1                                   = 0x12012031ull;

static const uint64_t P9N2_EX_5_CME_SCOM_BCEBAR1                                   = 0x12012431ull;

static const uint64_t P9N2_EX_6_CME_SCOM_BCEBAR1                                   = 0x13012031ull;

static const uint64_t P9N2_EX_7_CME_SCOM_BCEBAR1                                   = 0x13012431ull;

static const uint64_t P9N2_EX_8_CME_SCOM_BCEBAR1                                   = 0x14012031ull;

static const uint64_t P9N2_EX_9_CME_SCOM_BCEBAR1                                   = 0x14012431ull;

static const uint64_t P9N2_EX_10_CME_SCOM_BCEBAR1                                  = 0x15012031ull;

static const uint64_t P9N2_EX_11_CME_SCOM_BCEBAR1                                  = 0x15012431ull;


static const uint64_t P9N2_EQ_CME_SCOM_BCECSR                                      = 0x1001200Full;
//DUPS: 1001200F,
static const uint64_t P9N2_EQ_0_CME_SCOM_BCECSR                                    = 0x1001200Full;
//DUPS: 1001200F,
static const uint64_t P9N2_EQ_1_CME_SCOM_BCECSR                                    = 0x1101200Full;
//DUPS: 1101200F,
static const uint64_t P9N2_EQ_2_CME_SCOM_BCECSR                                    = 0x1201200Full;
//DUPS: 1201200F,
static const uint64_t P9N2_EQ_3_CME_SCOM_BCECSR                                    = 0x1301200Full;
//DUPS: 1301200F,
static const uint64_t P9N2_EQ_4_CME_SCOM_BCECSR                                    = 0x1401200Full;
//DUPS: 1401200F,
static const uint64_t P9N2_EQ_5_CME_SCOM_BCECSR                                    = 0x1501200Full;
//DUPS: 1501200F,
static const uint64_t P9N2_EX_CME_SCOM_BCECSR_PPE                                  = 0x1090101E0ull;

static const uint64_t P9N2_EX_CME_SCOM_BCECSR_SCOM                                 = 0x1001200Full;

static const uint64_t P9N2_EX_0_CME_SCOM_BCECSR_PPE                                = 0x1090101E0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_BCECSR_SCOM                               = 0x1001200Full;

static const uint64_t P9N2_EX_1_CME_SCOM_BCECSR_PPE                                = 0x1090201E0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_BCECSR_SCOM                               = 0x1001240Full;

static const uint64_t P9N2_EX_2_CME_SCOM_BCECSR_PPE                                = 0x10A0101E0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_BCECSR_SCOM                               = 0x1101200Full;

static const uint64_t P9N2_EX_3_CME_SCOM_BCECSR_PPE                                = 0x10A0201E0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_BCECSR_SCOM                               = 0x1101240Full;

static const uint64_t P9N2_EX_4_CME_SCOM_BCECSR_PPE                                = 0x10B0101E0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_BCECSR_SCOM                               = 0x1201200Full;

static const uint64_t P9N2_EX_5_CME_SCOM_BCECSR_PPE                                = 0x10B0201E0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_BCECSR_SCOM                               = 0x1201240Full;

static const uint64_t P9N2_EX_6_CME_SCOM_BCECSR_PPE                                = 0x10C0101E0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_BCECSR_SCOM                               = 0x1301200Full;

static const uint64_t P9N2_EX_7_CME_SCOM_BCECSR_PPE                                = 0x10C0201E0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_BCECSR_SCOM                               = 0x1301240Full;

static const uint64_t P9N2_EX_8_CME_SCOM_BCECSR_PPE                                = 0x10D0101E0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_BCECSR_SCOM                               = 0x1401200Full;

static const uint64_t P9N2_EX_9_CME_SCOM_BCECSR_PPE                                = 0x10D0201E0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_BCECSR_SCOM                               = 0x1401240Full;

static const uint64_t P9N2_EX_10_CME_SCOM_BCECSR_PPE                               = 0x10E0101E0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_BCECSR_SCOM                              = 0x1501200Full;

static const uint64_t P9N2_EX_11_CME_SCOM_BCECSR_PPE                               = 0x10E0201E0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_BCECSR_SCOM                              = 0x1501240Full;


static const uint64_t P9N2_EQ_CME_SCOM_CIDSR                                       = 0x1001202Eull;
//DUPS: 1001202E,
static const uint64_t P9N2_EQ_0_CME_SCOM_CIDSR                                     = 0x1001202Eull;
//DUPS: 1001202E,
static const uint64_t P9N2_EQ_1_CME_SCOM_CIDSR                                     = 0x1101202Eull;
//DUPS: 1101202E,
static const uint64_t P9N2_EQ_2_CME_SCOM_CIDSR                                     = 0x1201202Eull;
//DUPS: 1201202E,
static const uint64_t P9N2_EQ_3_CME_SCOM_CIDSR                                     = 0x1301202Eull;
//DUPS: 1301202E,
static const uint64_t P9N2_EQ_4_CME_SCOM_CIDSR                                     = 0x1401202Eull;
//DUPS: 1401202E,
static const uint64_t P9N2_EQ_5_CME_SCOM_CIDSR                                     = 0x1501202Eull;
//DUPS: 1501202E,
static const uint64_t P9N2_EX_CME_SCOM_CIDSR_PPE                                   = 0x1090106C0ull;

static const uint64_t P9N2_EX_CME_SCOM_CIDSR_SCOM                                  = 0x1001202Eull;

static const uint64_t P9N2_EX_0_CME_SCOM_CIDSR_PPE                                 = 0x1090106C0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_CIDSR_SCOM                                = 0x1001202Eull;

static const uint64_t P9N2_EX_1_CME_SCOM_CIDSR_PPE                                 = 0x1090206C0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_CIDSR_SCOM                                = 0x1001242Eull;

static const uint64_t P9N2_EX_2_CME_SCOM_CIDSR_PPE                                 = 0x10A0106C0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_CIDSR_SCOM                                = 0x1101202Eull;

static const uint64_t P9N2_EX_3_CME_SCOM_CIDSR_PPE                                 = 0x10A0206C0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_CIDSR_SCOM                                = 0x1101242Eull;

static const uint64_t P9N2_EX_4_CME_SCOM_CIDSR_PPE                                 = 0x10B0106C0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_CIDSR_SCOM                                = 0x1201202Eull;

static const uint64_t P9N2_EX_5_CME_SCOM_CIDSR_PPE                                 = 0x10B0206C0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_CIDSR_SCOM                                = 0x1201242Eull;

static const uint64_t P9N2_EX_6_CME_SCOM_CIDSR_PPE                                 = 0x10C0106C0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_CIDSR_SCOM                                = 0x1301202Eull;

static const uint64_t P9N2_EX_7_CME_SCOM_CIDSR_PPE                                 = 0x10C0206C0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_CIDSR_SCOM                                = 0x1301242Eull;

static const uint64_t P9N2_EX_8_CME_SCOM_CIDSR_PPE                                 = 0x10D0106C0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_CIDSR_SCOM                                = 0x1401202Eull;

static const uint64_t P9N2_EX_9_CME_SCOM_CIDSR_PPE                                 = 0x10D0206C0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_CIDSR_SCOM                                = 0x1401242Eull;

static const uint64_t P9N2_EX_10_CME_SCOM_CIDSR_PPE                                = 0x10E0106C0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_CIDSR_SCOM                               = 0x1501202Eull;

static const uint64_t P9N2_EX_11_CME_SCOM_CIDSR_PPE                                = 0x10E0206C0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_CIDSR_SCOM                               = 0x1501242Eull;


static const uint64_t P9N2_EQ_CME_SCOM_EIIR                                        = 0x1001202Bull;
//DUPS: 1001202B,
static const uint64_t P9N2_EQ_0_CME_SCOM_EIIR                                      = 0x1001202Bull;
//DUPS: 1001202B,
static const uint64_t P9N2_EQ_1_CME_SCOM_EIIR                                      = 0x1101202Bull;
//DUPS: 1101202B,
static const uint64_t P9N2_EQ_2_CME_SCOM_EIIR                                      = 0x1201202Bull;
//DUPS: 1201202B,
static const uint64_t P9N2_EQ_3_CME_SCOM_EIIR                                      = 0x1301202Bull;
//DUPS: 1301202B,
static const uint64_t P9N2_EQ_4_CME_SCOM_EIIR                                      = 0x1401202Bull;
//DUPS: 1401202B,
static const uint64_t P9N2_EQ_5_CME_SCOM_EIIR                                      = 0x1501202Bull;
//DUPS: 1501202B,
static const uint64_t P9N2_EX_CME_SCOM_EIIR                                        = 0x1001202Bull;

static const uint64_t P9N2_EX_0_CME_SCOM_EIIR                                      = 0x1001202Bull;

static const uint64_t P9N2_EX_1_CME_SCOM_EIIR                                      = 0x1001242Bull;

static const uint64_t P9N2_EX_2_CME_SCOM_EIIR                                      = 0x1101202Bull;

static const uint64_t P9N2_EX_3_CME_SCOM_EIIR                                      = 0x1101242Bull;

static const uint64_t P9N2_EX_4_CME_SCOM_EIIR                                      = 0x1201202Bull;

static const uint64_t P9N2_EX_5_CME_SCOM_EIIR                                      = 0x1201242Bull;

static const uint64_t P9N2_EX_6_CME_SCOM_EIIR                                      = 0x1301202Bull;

static const uint64_t P9N2_EX_7_CME_SCOM_EIIR                                      = 0x1301242Bull;

static const uint64_t P9N2_EX_8_CME_SCOM_EIIR                                      = 0x1401202Bull;

static const uint64_t P9N2_EX_9_CME_SCOM_EIIR                                      = 0x1401242Bull;

static const uint64_t P9N2_EX_10_CME_SCOM_EIIR                                     = 0x1501202Bull;

static const uint64_t P9N2_EX_11_CME_SCOM_EIIR                                     = 0x1501242Bull;


static const uint64_t P9N2_EQ_CME_SCOM_FLAGS                                       = 0x10012020ull;
//DUPS: 10012020,
static const uint64_t P9N2_EQ_CME_SCOM_FLAGS_CLEAR                                 = 0x10012021ull;
//DUPS: 10012021,
static const uint64_t P9N2_EQ_CME_SCOM_FLAGS_OR                                    = 0x10012022ull;
//DUPS: 10012022,
static const uint64_t P9N2_EQ_0_CME_SCOM_FLAGS                                     = 0x10012020ull;
//DUPS: 10012020,
static const uint64_t P9N2_EQ_0_CME_SCOM_FLAGS_CLEAR                               = 0x10012021ull;
//DUPS: 10012021,
static const uint64_t P9N2_EQ_0_CME_SCOM_FLAGS_OR                                  = 0x10012022ull;
//DUPS: 10012022,
static const uint64_t P9N2_EQ_1_CME_SCOM_FLAGS                                     = 0x11012020ull;
//DUPS: 11012020,
static const uint64_t P9N2_EQ_1_CME_SCOM_FLAGS_CLEAR                               = 0x11012021ull;
//DUPS: 11012021,
static const uint64_t P9N2_EQ_1_CME_SCOM_FLAGS_OR                                  = 0x11012022ull;
//DUPS: 11012022,
static const uint64_t P9N2_EQ_2_CME_SCOM_FLAGS                                     = 0x12012020ull;
//DUPS: 12012020,
static const uint64_t P9N2_EQ_2_CME_SCOM_FLAGS_CLEAR                               = 0x12012021ull;
//DUPS: 12012021,
static const uint64_t P9N2_EQ_2_CME_SCOM_FLAGS_OR                                  = 0x12012022ull;
//DUPS: 12012022,
static const uint64_t P9N2_EQ_3_CME_SCOM_FLAGS                                     = 0x13012020ull;
//DUPS: 13012020,
static const uint64_t P9N2_EQ_3_CME_SCOM_FLAGS_CLEAR                               = 0x13012021ull;
//DUPS: 13012021,
static const uint64_t P9N2_EQ_3_CME_SCOM_FLAGS_OR                                  = 0x13012022ull;
//DUPS: 13012022,
static const uint64_t P9N2_EQ_4_CME_SCOM_FLAGS                                     = 0x14012020ull;
//DUPS: 14012020,
static const uint64_t P9N2_EQ_4_CME_SCOM_FLAGS_CLEAR                               = 0x14012021ull;
//DUPS: 14012021,
static const uint64_t P9N2_EQ_4_CME_SCOM_FLAGS_OR                                  = 0x14012022ull;
//DUPS: 14012022,
static const uint64_t P9N2_EQ_5_CME_SCOM_FLAGS                                     = 0x15012020ull;
//DUPS: 15012020,
static const uint64_t P9N2_EQ_5_CME_SCOM_FLAGS_CLEAR                               = 0x15012021ull;
//DUPS: 15012021,
static const uint64_t P9N2_EQ_5_CME_SCOM_FLAGS_OR                                  = 0x15012022ull;
//DUPS: 15012022,
static const uint64_t P9N2_EX_CME_SCOM_FLAGS_PPE                                   = 0x109010400ull;

static const uint64_t P9N2_EX_CME_SCOM_FLAGS_PPE1                                  = 0x109010418ull;

static const uint64_t P9N2_EX_CME_SCOM_FLAGS_PPE2                                  = 0x109010410ull;

static const uint64_t P9N2_EX_CME_SCOM_FLAGS_SCOM                                  = 0x10012020ull;

static const uint64_t P9N2_EX_CME_SCOM_FLAGS_SCOM1                                 = 0x10012021ull;

static const uint64_t P9N2_EX_CME_SCOM_FLAGS_SCOM2                                 = 0x10012022ull;

static const uint64_t P9N2_EX_0_CME_SCOM_FLAGS_PPE                                 = 0x109010400ull;

static const uint64_t P9N2_EX_0_CME_SCOM_FLAGS_PPE1                                = 0x109010418ull;

static const uint64_t P9N2_EX_0_CME_SCOM_FLAGS_PPE2                                = 0x109010410ull;

static const uint64_t P9N2_EX_0_CME_SCOM_FLAGS_SCOM                                = 0x10012020ull;

static const uint64_t P9N2_EX_0_CME_SCOM_FLAGS_SCOM1                               = 0x10012021ull;

static const uint64_t P9N2_EX_0_CME_SCOM_FLAGS_SCOM2                               = 0x10012022ull;

static const uint64_t P9N2_EX_1_CME_SCOM_FLAGS_PPE                                 = 0x109020400ull;

static const uint64_t P9N2_EX_1_CME_SCOM_FLAGS_PPE1                                = 0x109020418ull;

static const uint64_t P9N2_EX_1_CME_SCOM_FLAGS_PPE2                                = 0x109020410ull;

static const uint64_t P9N2_EX_1_CME_SCOM_FLAGS_SCOM                                = 0x10012420ull;

static const uint64_t P9N2_EX_1_CME_SCOM_FLAGS_SCOM1                               = 0x10012421ull;

static const uint64_t P9N2_EX_1_CME_SCOM_FLAGS_SCOM2                               = 0x10012422ull;

static const uint64_t P9N2_EX_2_CME_SCOM_FLAGS_PPE                                 = 0x10A010400ull;

static const uint64_t P9N2_EX_2_CME_SCOM_FLAGS_PPE1                                = 0x10A010418ull;

static const uint64_t P9N2_EX_2_CME_SCOM_FLAGS_PPE2                                = 0x10A010410ull;

static const uint64_t P9N2_EX_2_CME_SCOM_FLAGS_SCOM                                = 0x11012020ull;

static const uint64_t P9N2_EX_2_CME_SCOM_FLAGS_SCOM1                               = 0x11012021ull;

static const uint64_t P9N2_EX_2_CME_SCOM_FLAGS_SCOM2                               = 0x11012022ull;

static const uint64_t P9N2_EX_3_CME_SCOM_FLAGS_PPE                                 = 0x10A020400ull;

static const uint64_t P9N2_EX_3_CME_SCOM_FLAGS_PPE1                                = 0x10A020418ull;

static const uint64_t P9N2_EX_3_CME_SCOM_FLAGS_PPE2                                = 0x10A020410ull;

static const uint64_t P9N2_EX_3_CME_SCOM_FLAGS_SCOM                                = 0x11012420ull;

static const uint64_t P9N2_EX_3_CME_SCOM_FLAGS_SCOM1                               = 0x11012421ull;

static const uint64_t P9N2_EX_3_CME_SCOM_FLAGS_SCOM2                               = 0x11012422ull;

static const uint64_t P9N2_EX_4_CME_SCOM_FLAGS_PPE                                 = 0x10B010400ull;

static const uint64_t P9N2_EX_4_CME_SCOM_FLAGS_PPE1                                = 0x10B010418ull;

static const uint64_t P9N2_EX_4_CME_SCOM_FLAGS_PPE2                                = 0x10B010410ull;

static const uint64_t P9N2_EX_4_CME_SCOM_FLAGS_SCOM                                = 0x12012020ull;

static const uint64_t P9N2_EX_4_CME_SCOM_FLAGS_SCOM1                               = 0x12012021ull;

static const uint64_t P9N2_EX_4_CME_SCOM_FLAGS_SCOM2                               = 0x12012022ull;

static const uint64_t P9N2_EX_5_CME_SCOM_FLAGS_PPE                                 = 0x10B020400ull;

static const uint64_t P9N2_EX_5_CME_SCOM_FLAGS_PPE1                                = 0x10B020418ull;

static const uint64_t P9N2_EX_5_CME_SCOM_FLAGS_PPE2                                = 0x10B020410ull;

static const uint64_t P9N2_EX_5_CME_SCOM_FLAGS_SCOM                                = 0x12012420ull;

static const uint64_t P9N2_EX_5_CME_SCOM_FLAGS_SCOM1                               = 0x12012421ull;

static const uint64_t P9N2_EX_5_CME_SCOM_FLAGS_SCOM2                               = 0x12012422ull;

static const uint64_t P9N2_EX_6_CME_SCOM_FLAGS_PPE                                 = 0x10C010400ull;

static const uint64_t P9N2_EX_6_CME_SCOM_FLAGS_PPE1                                = 0x10C010418ull;

static const uint64_t P9N2_EX_6_CME_SCOM_FLAGS_PPE2                                = 0x10C010410ull;

static const uint64_t P9N2_EX_6_CME_SCOM_FLAGS_SCOM                                = 0x13012020ull;

static const uint64_t P9N2_EX_6_CME_SCOM_FLAGS_SCOM1                               = 0x13012021ull;

static const uint64_t P9N2_EX_6_CME_SCOM_FLAGS_SCOM2                               = 0x13012022ull;

static const uint64_t P9N2_EX_7_CME_SCOM_FLAGS_PPE                                 = 0x10C020400ull;

static const uint64_t P9N2_EX_7_CME_SCOM_FLAGS_PPE1                                = 0x10C020418ull;

static const uint64_t P9N2_EX_7_CME_SCOM_FLAGS_PPE2                                = 0x10C020410ull;

static const uint64_t P9N2_EX_7_CME_SCOM_FLAGS_SCOM                                = 0x13012420ull;

static const uint64_t P9N2_EX_7_CME_SCOM_FLAGS_SCOM1                               = 0x13012421ull;

static const uint64_t P9N2_EX_7_CME_SCOM_FLAGS_SCOM2                               = 0x13012422ull;

static const uint64_t P9N2_EX_8_CME_SCOM_FLAGS_PPE                                 = 0x10D010400ull;

static const uint64_t P9N2_EX_8_CME_SCOM_FLAGS_PPE1                                = 0x10D010418ull;

static const uint64_t P9N2_EX_8_CME_SCOM_FLAGS_PPE2                                = 0x10D010410ull;

static const uint64_t P9N2_EX_8_CME_SCOM_FLAGS_SCOM                                = 0x14012020ull;

static const uint64_t P9N2_EX_8_CME_SCOM_FLAGS_SCOM1                               = 0x14012021ull;

static const uint64_t P9N2_EX_8_CME_SCOM_FLAGS_SCOM2                               = 0x14012022ull;

static const uint64_t P9N2_EX_9_CME_SCOM_FLAGS_PPE                                 = 0x10D020400ull;

static const uint64_t P9N2_EX_9_CME_SCOM_FLAGS_PPE1                                = 0x10D020418ull;

static const uint64_t P9N2_EX_9_CME_SCOM_FLAGS_PPE2                                = 0x10D020410ull;

static const uint64_t P9N2_EX_9_CME_SCOM_FLAGS_SCOM                                = 0x14012420ull;

static const uint64_t P9N2_EX_9_CME_SCOM_FLAGS_SCOM1                               = 0x14012421ull;

static const uint64_t P9N2_EX_9_CME_SCOM_FLAGS_SCOM2                               = 0x14012422ull;

static const uint64_t P9N2_EX_10_CME_SCOM_FLAGS_PPE                                = 0x10E010400ull;

static const uint64_t P9N2_EX_10_CME_SCOM_FLAGS_PPE1                               = 0x10E010418ull;

static const uint64_t P9N2_EX_10_CME_SCOM_FLAGS_PPE2                               = 0x10E010410ull;

static const uint64_t P9N2_EX_10_CME_SCOM_FLAGS_SCOM                               = 0x15012020ull;

static const uint64_t P9N2_EX_10_CME_SCOM_FLAGS_SCOM1                              = 0x15012021ull;

static const uint64_t P9N2_EX_10_CME_SCOM_FLAGS_SCOM2                              = 0x15012022ull;

static const uint64_t P9N2_EX_11_CME_SCOM_FLAGS_PPE                                = 0x10E020400ull;

static const uint64_t P9N2_EX_11_CME_SCOM_FLAGS_PPE1                               = 0x10E020418ull;

static const uint64_t P9N2_EX_11_CME_SCOM_FLAGS_PPE2                               = 0x10E020410ull;

static const uint64_t P9N2_EX_11_CME_SCOM_FLAGS_SCOM                               = 0x15012420ull;

static const uint64_t P9N2_EX_11_CME_SCOM_FLAGS_SCOM1                              = 0x15012421ull;

static const uint64_t P9N2_EX_11_CME_SCOM_FLAGS_SCOM2                              = 0x15012422ull;


static const uint64_t P9N2_EQ_CME_SCOM_IDCR                                        = 0x1001202Dull;
//DUPS: 1001202D,
static const uint64_t P9N2_EQ_0_CME_SCOM_IDCR                                      = 0x1001202Dull;
//DUPS: 1001202D,
static const uint64_t P9N2_EQ_1_CME_SCOM_IDCR                                      = 0x1101202Dull;
//DUPS: 1101202D,
static const uint64_t P9N2_EQ_2_CME_SCOM_IDCR                                      = 0x1201202Dull;
//DUPS: 1201202D,
static const uint64_t P9N2_EQ_3_CME_SCOM_IDCR                                      = 0x1301202Dull;
//DUPS: 1301202D,
static const uint64_t P9N2_EQ_4_CME_SCOM_IDCR                                      = 0x1401202Dull;
//DUPS: 1401202D,
static const uint64_t P9N2_EQ_5_CME_SCOM_IDCR                                      = 0x1501202Dull;
//DUPS: 1501202D,
static const uint64_t P9N2_EX_CME_SCOM_IDCR_PPE                                    = 0x1090106A0ull;

static const uint64_t P9N2_EX_CME_SCOM_IDCR_SCOM                                   = 0x1001202Dull;

static const uint64_t P9N2_EX_0_CME_SCOM_IDCR_PPE                                  = 0x1090106A0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_IDCR_SCOM                                 = 0x1001202Dull;

static const uint64_t P9N2_EX_1_CME_SCOM_IDCR_PPE                                  = 0x1090206A0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_IDCR_SCOM                                 = 0x1001242Dull;

static const uint64_t P9N2_EX_2_CME_SCOM_IDCR_PPE                                  = 0x10A0106A0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_IDCR_SCOM                                 = 0x1101202Dull;

static const uint64_t P9N2_EX_3_CME_SCOM_IDCR_PPE                                  = 0x10A0206A0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_IDCR_SCOM                                 = 0x1101242Dull;

static const uint64_t P9N2_EX_4_CME_SCOM_IDCR_PPE                                  = 0x10B0106A0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_IDCR_SCOM                                 = 0x1201202Dull;

static const uint64_t P9N2_EX_5_CME_SCOM_IDCR_PPE                                  = 0x10B0206A0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_IDCR_SCOM                                 = 0x1201242Dull;

static const uint64_t P9N2_EX_6_CME_SCOM_IDCR_PPE                                  = 0x10C0106A0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_IDCR_SCOM                                 = 0x1301202Dull;

static const uint64_t P9N2_EX_7_CME_SCOM_IDCR_PPE                                  = 0x10C0206A0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_IDCR_SCOM                                 = 0x1301242Dull;

static const uint64_t P9N2_EX_8_CME_SCOM_IDCR_PPE                                  = 0x10D0106A0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_IDCR_SCOM                                 = 0x1401202Dull;

static const uint64_t P9N2_EX_9_CME_SCOM_IDCR_PPE                                  = 0x10D0206A0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_IDCR_SCOM                                 = 0x1401242Dull;

static const uint64_t P9N2_EX_10_CME_SCOM_IDCR_PPE                                 = 0x10E0106A0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_IDCR_SCOM                                = 0x1501202Dull;

static const uint64_t P9N2_EX_11_CME_SCOM_IDCR_PPE                                 = 0x10E0206A0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_IDCR_SCOM                                = 0x1501242Dull;


static const uint64_t P9N2_EQ_CME_SCOM_LFIR                                        = 0x10012000ull;
//DUPS: 10012000,
static const uint64_t P9N2_EQ_CME_SCOM_LFIR_AND                                    = 0x10012001ull;
//DUPS: 10012001,
static const uint64_t P9N2_EQ_CME_SCOM_LFIR_OR                                     = 0x10012002ull;
//DUPS: 10012002,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIR                                      = 0x10012000ull;
//DUPS: 10012000,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIR_AND                                  = 0x10012001ull;
//DUPS: 10012001,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIR_OR                                   = 0x10012002ull;
//DUPS: 10012002,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIR                                      = 0x11012000ull;
//DUPS: 11012000,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIR_AND                                  = 0x11012001ull;
//DUPS: 11012001,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIR_OR                                   = 0x11012002ull;
//DUPS: 11012002,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIR                                      = 0x12012000ull;
//DUPS: 12012000,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIR_AND                                  = 0x12012001ull;
//DUPS: 12012001,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIR_OR                                   = 0x12012002ull;
//DUPS: 12012002,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIR                                      = 0x13012000ull;
//DUPS: 13012000,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIR_AND                                  = 0x13012001ull;
//DUPS: 13012001,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIR_OR                                   = 0x13012002ull;
//DUPS: 13012002,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIR                                      = 0x14012000ull;
//DUPS: 14012000,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIR_AND                                  = 0x14012001ull;
//DUPS: 14012001,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIR_OR                                   = 0x14012002ull;
//DUPS: 14012002,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIR                                      = 0x15012000ull;
//DUPS: 15012000,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIR_AND                                  = 0x15012001ull;
//DUPS: 15012001,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIR_OR                                   = 0x15012002ull;
//DUPS: 15012002,
static const uint64_t P9N2_EX_CME_SCOM_LFIR                                        = 0x10012000ull;

static const uint64_t P9N2_EX_CME_SCOM_LFIR_AND                                    = 0x10012001ull;

static const uint64_t P9N2_EX_CME_SCOM_LFIR_OR                                     = 0x10012002ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIR                                      = 0x10012000ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIR_AND                                  = 0x10012001ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIR_OR                                   = 0x10012002ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIR                                      = 0x10012400ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIR_AND                                  = 0x10012401ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIR_OR                                   = 0x10012402ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIR                                      = 0x11012000ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIR_AND                                  = 0x11012001ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIR_OR                                   = 0x11012002ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIR                                      = 0x11012400ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIR_AND                                  = 0x11012401ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIR_OR                                   = 0x11012402ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIR                                      = 0x12012000ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIR_AND                                  = 0x12012001ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIR_OR                                   = 0x12012002ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIR                                      = 0x12012400ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIR_AND                                  = 0x12012401ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIR_OR                                   = 0x12012402ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIR                                      = 0x13012000ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIR_AND                                  = 0x13012001ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIR_OR                                   = 0x13012002ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIR                                      = 0x13012400ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIR_AND                                  = 0x13012401ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIR_OR                                   = 0x13012402ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIR                                      = 0x14012000ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIR_AND                                  = 0x14012001ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIR_OR                                   = 0x14012002ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIR                                      = 0x14012400ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIR_AND                                  = 0x14012401ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIR_OR                                   = 0x14012402ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIR                                     = 0x15012000ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIR_AND                                 = 0x15012001ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIR_OR                                  = 0x15012002ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIR                                     = 0x15012400ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIR_AND                                 = 0x15012401ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIR_OR                                  = 0x15012402ull;


static const uint64_t P9N2_EQ_CME_SCOM_LFIRACT0                                    = 0x10012006ull;
//DUPS: 10012006,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIRACT0                                  = 0x10012006ull;
//DUPS: 10012006,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIRACT0                                  = 0x11012006ull;
//DUPS: 11012006,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIRACT0                                  = 0x12012006ull;
//DUPS: 12012006,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIRACT0                                  = 0x13012006ull;
//DUPS: 13012006,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIRACT0                                  = 0x14012006ull;
//DUPS: 14012006,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIRACT0                                  = 0x15012006ull;
//DUPS: 15012006,
static const uint64_t P9N2_EX_CME_SCOM_LFIRACT0                                    = 0x10012006ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIRACT0                                  = 0x10012006ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIRACT0                                  = 0x10012406ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIRACT0                                  = 0x11012006ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIRACT0                                  = 0x11012406ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIRACT0                                  = 0x12012006ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIRACT0                                  = 0x12012406ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIRACT0                                  = 0x13012006ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIRACT0                                  = 0x13012406ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIRACT0                                  = 0x14012006ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIRACT0                                  = 0x14012406ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIRACT0                                 = 0x15012006ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIRACT0                                 = 0x15012406ull;


static const uint64_t P9N2_EQ_CME_SCOM_LFIRACT1                                    = 0x10012007ull;
//DUPS: 10012007,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIRACT1                                  = 0x10012007ull;
//DUPS: 10012007,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIRACT1                                  = 0x11012007ull;
//DUPS: 11012007,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIRACT1                                  = 0x12012007ull;
//DUPS: 12012007,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIRACT1                                  = 0x13012007ull;
//DUPS: 13012007,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIRACT1                                  = 0x14012007ull;
//DUPS: 14012007,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIRACT1                                  = 0x15012007ull;
//DUPS: 15012007,
static const uint64_t P9N2_EX_CME_SCOM_LFIRACT1                                    = 0x10012007ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIRACT1                                  = 0x10012007ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIRACT1                                  = 0x10012407ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIRACT1                                  = 0x11012007ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIRACT1                                  = 0x11012407ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIRACT1                                  = 0x12012007ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIRACT1                                  = 0x12012407ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIRACT1                                  = 0x13012007ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIRACT1                                  = 0x13012407ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIRACT1                                  = 0x14012007ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIRACT1                                  = 0x14012407ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIRACT1                                 = 0x15012007ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIRACT1                                 = 0x15012407ull;


static const uint64_t P9N2_EQ_CME_SCOM_LFIRMASK                                    = 0x10012003ull;
//DUPS: 10012003,
static const uint64_t P9N2_EQ_CME_SCOM_LFIRMASK_AND                                = 0x10012004ull;
//DUPS: 10012004,
static const uint64_t P9N2_EQ_CME_SCOM_LFIRMASK_OR                                 = 0x10012005ull;
//DUPS: 10012005,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIRMASK                                  = 0x10012003ull;
//DUPS: 10012003,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIRMASK_AND                              = 0x10012004ull;
//DUPS: 10012004,
static const uint64_t P9N2_EQ_0_CME_SCOM_LFIRMASK_OR                               = 0x10012005ull;
//DUPS: 10012005,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIRMASK                                  = 0x11012003ull;
//DUPS: 11012003,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIRMASK_AND                              = 0x11012004ull;
//DUPS: 11012004,
static const uint64_t P9N2_EQ_1_CME_SCOM_LFIRMASK_OR                               = 0x11012005ull;
//DUPS: 11012005,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIRMASK                                  = 0x12012003ull;
//DUPS: 12012003,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIRMASK_AND                              = 0x12012004ull;
//DUPS: 12012004,
static const uint64_t P9N2_EQ_2_CME_SCOM_LFIRMASK_OR                               = 0x12012005ull;
//DUPS: 12012005,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIRMASK                                  = 0x13012003ull;
//DUPS: 13012003,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIRMASK_AND                              = 0x13012004ull;
//DUPS: 13012004,
static const uint64_t P9N2_EQ_3_CME_SCOM_LFIRMASK_OR                               = 0x13012005ull;
//DUPS: 13012005,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIRMASK                                  = 0x14012003ull;
//DUPS: 14012003,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIRMASK_AND                              = 0x14012004ull;
//DUPS: 14012004,
static const uint64_t P9N2_EQ_4_CME_SCOM_LFIRMASK_OR                               = 0x14012005ull;
//DUPS: 14012005,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIRMASK                                  = 0x15012003ull;
//DUPS: 15012003,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIRMASK_AND                              = 0x15012004ull;
//DUPS: 15012004,
static const uint64_t P9N2_EQ_5_CME_SCOM_LFIRMASK_OR                               = 0x15012005ull;
//DUPS: 15012005,
static const uint64_t P9N2_EX_CME_SCOM_LFIRMASK                                    = 0x10012003ull;

static const uint64_t P9N2_EX_CME_SCOM_LFIRMASK_AND                                = 0x10012004ull;

static const uint64_t P9N2_EX_CME_SCOM_LFIRMASK_OR                                 = 0x10012005ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIRMASK                                  = 0x10012003ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIRMASK_AND                              = 0x10012004ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LFIRMASK_OR                               = 0x10012005ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIRMASK                                  = 0x10012403ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIRMASK_AND                              = 0x10012404ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LFIRMASK_OR                               = 0x10012405ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIRMASK                                  = 0x11012003ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIRMASK_AND                              = 0x11012004ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LFIRMASK_OR                               = 0x11012005ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIRMASK                                  = 0x11012403ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIRMASK_AND                              = 0x11012404ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LFIRMASK_OR                               = 0x11012405ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIRMASK                                  = 0x12012003ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIRMASK_AND                              = 0x12012004ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LFIRMASK_OR                               = 0x12012005ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIRMASK                                  = 0x12012403ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIRMASK_AND                              = 0x12012404ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LFIRMASK_OR                               = 0x12012405ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIRMASK                                  = 0x13012003ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIRMASK_AND                              = 0x13012004ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LFIRMASK_OR                               = 0x13012005ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIRMASK                                  = 0x13012403ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIRMASK_AND                              = 0x13012404ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LFIRMASK_OR                               = 0x13012405ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIRMASK                                  = 0x14012003ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIRMASK_AND                              = 0x14012004ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LFIRMASK_OR                               = 0x14012005ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIRMASK                                  = 0x14012403ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIRMASK_AND                              = 0x14012404ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LFIRMASK_OR                               = 0x14012405ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIRMASK                                 = 0x15012003ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIRMASK_AND                             = 0x15012004ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LFIRMASK_OR                              = 0x15012005ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIRMASK                                 = 0x15012403ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIRMASK_AND                             = 0x15012404ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LFIRMASK_OR                              = 0x15012405ull;


static const uint64_t P9N2_EQ_CME_SCOM_LMCR_SCOM                                   = 0x1001203Aull;
//DUPS: 1001203A,
static const uint64_t P9N2_EQ_CME_SCOM_LMCR_SCOM1                                  = 0x1001203Bull;
//DUPS: 1001203B,
static const uint64_t P9N2_EQ_CME_SCOM_LMCR_SCOM2                                  = 0x1001203Cull;
//DUPS: 1001203C,
static const uint64_t P9N2_EQ_0_CME_SCOM_LMCR_SCOM                                 = 0x1001203Aull;
//DUPS: 1001203A,
static const uint64_t P9N2_EQ_0_CME_SCOM_LMCR_SCOM1                                = 0x1001203Bull;
//DUPS: 1001203B,
static const uint64_t P9N2_EQ_0_CME_SCOM_LMCR_SCOM2                                = 0x1001203Cull;
//DUPS: 1001203C,
static const uint64_t P9N2_EQ_1_CME_SCOM_LMCR_SCOM                                 = 0x1101203Aull;
//DUPS: 1101203A,
static const uint64_t P9N2_EQ_1_CME_SCOM_LMCR_SCOM1                                = 0x1101203Bull;
//DUPS: 1101203B,
static const uint64_t P9N2_EQ_1_CME_SCOM_LMCR_SCOM2                                = 0x1101203Cull;
//DUPS: 1101203C,
static const uint64_t P9N2_EQ_2_CME_SCOM_LMCR_SCOM                                 = 0x1201203Aull;
//DUPS: 1201203A,
static const uint64_t P9N2_EQ_2_CME_SCOM_LMCR_SCOM1                                = 0x1201203Bull;
//DUPS: 1201203B,
static const uint64_t P9N2_EQ_2_CME_SCOM_LMCR_SCOM2                                = 0x1201203Cull;
//DUPS: 1201203C,
static const uint64_t P9N2_EQ_3_CME_SCOM_LMCR_SCOM                                 = 0x1301203Aull;
//DUPS: 1301203A,
static const uint64_t P9N2_EQ_3_CME_SCOM_LMCR_SCOM1                                = 0x1301203Bull;
//DUPS: 1301203B,
static const uint64_t P9N2_EQ_3_CME_SCOM_LMCR_SCOM2                                = 0x1301203Cull;
//DUPS: 1301203C,
static const uint64_t P9N2_EQ_4_CME_SCOM_LMCR_SCOM                                 = 0x1401203Aull;
//DUPS: 1401203A,
static const uint64_t P9N2_EQ_4_CME_SCOM_LMCR_SCOM1                                = 0x1401203Bull;
//DUPS: 1401203B,
static const uint64_t P9N2_EQ_4_CME_SCOM_LMCR_SCOM2                                = 0x1401203Cull;
//DUPS: 1401203C,
static const uint64_t P9N2_EQ_5_CME_SCOM_LMCR_SCOM                                 = 0x1501203Aull;
//DUPS: 1501203A,
static const uint64_t P9N2_EQ_5_CME_SCOM_LMCR_SCOM1                                = 0x1501203Bull;
//DUPS: 1501203B,
static const uint64_t P9N2_EQ_5_CME_SCOM_LMCR_SCOM2                                = 0x1501203Cull;
//DUPS: 1501203C,
static const uint64_t P9N2_EX_CME_SCOM_LMCR_PPE                                    = 0x1090101A0ull;

static const uint64_t P9N2_EX_CME_SCOM_LMCR_PPE1                                   = 0x1090101B8ull;

static const uint64_t P9N2_EX_CME_SCOM_LMCR_PPE2                                   = 0x1090101B0ull;

static const uint64_t P9N2_EX_CME_SCOM_LMCR_SCOM                                   = 0x1001203Aull;

static const uint64_t P9N2_EX_CME_SCOM_LMCR_SCOM1                                  = 0x1001203Bull;

static const uint64_t P9N2_EX_CME_SCOM_LMCR_SCOM2                                  = 0x1001203Cull;

static const uint64_t P9N2_EX_0_CME_SCOM_LMCR_PPE                                  = 0x1090101A0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LMCR_PPE1                                 = 0x1090101B8ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LMCR_PPE2                                 = 0x1090101B0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_LMCR_SCOM                                 = 0x1001203Aull;

static const uint64_t P9N2_EX_0_CME_SCOM_LMCR_SCOM1                                = 0x1001203Bull;

static const uint64_t P9N2_EX_0_CME_SCOM_LMCR_SCOM2                                = 0x1001203Cull;

static const uint64_t P9N2_EX_1_CME_SCOM_LMCR_PPE                                  = 0x1090201A0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LMCR_PPE1                                 = 0x1090201B8ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LMCR_PPE2                                 = 0x1090201B0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_LMCR_SCOM                                 = 0x1001243Aull;

static const uint64_t P9N2_EX_1_CME_SCOM_LMCR_SCOM1                                = 0x1001243Bull;

static const uint64_t P9N2_EX_1_CME_SCOM_LMCR_SCOM2                                = 0x1001243Cull;

static const uint64_t P9N2_EX_2_CME_SCOM_LMCR_PPE                                  = 0x10A0101A0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LMCR_PPE1                                 = 0x10A0101B8ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LMCR_PPE2                                 = 0x10A0101B0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_LMCR_SCOM                                 = 0x1101203Aull;

static const uint64_t P9N2_EX_2_CME_SCOM_LMCR_SCOM1                                = 0x1101203Bull;

static const uint64_t P9N2_EX_2_CME_SCOM_LMCR_SCOM2                                = 0x1101203Cull;

static const uint64_t P9N2_EX_3_CME_SCOM_LMCR_PPE                                  = 0x10A0201A0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LMCR_PPE1                                 = 0x10A0201B8ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LMCR_PPE2                                 = 0x10A0201B0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_LMCR_SCOM                                 = 0x1101243Aull;

static const uint64_t P9N2_EX_3_CME_SCOM_LMCR_SCOM1                                = 0x1101243Bull;

static const uint64_t P9N2_EX_3_CME_SCOM_LMCR_SCOM2                                = 0x1101243Cull;

static const uint64_t P9N2_EX_4_CME_SCOM_LMCR_PPE                                  = 0x10B0101A0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LMCR_PPE1                                 = 0x10B0101B8ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LMCR_PPE2                                 = 0x10B0101B0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_LMCR_SCOM                                 = 0x1201203Aull;

static const uint64_t P9N2_EX_4_CME_SCOM_LMCR_SCOM1                                = 0x1201203Bull;

static const uint64_t P9N2_EX_4_CME_SCOM_LMCR_SCOM2                                = 0x1201203Cull;

static const uint64_t P9N2_EX_5_CME_SCOM_LMCR_PPE                                  = 0x10B0201A0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LMCR_PPE1                                 = 0x10B0201B8ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LMCR_PPE2                                 = 0x10B0201B0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_LMCR_SCOM                                 = 0x1201243Aull;

static const uint64_t P9N2_EX_5_CME_SCOM_LMCR_SCOM1                                = 0x1201243Bull;

static const uint64_t P9N2_EX_5_CME_SCOM_LMCR_SCOM2                                = 0x1201243Cull;

static const uint64_t P9N2_EX_6_CME_SCOM_LMCR_PPE                                  = 0x10C0101A0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LMCR_PPE1                                 = 0x10C0101B8ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LMCR_PPE2                                 = 0x10C0101B0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_LMCR_SCOM                                 = 0x1301203Aull;

static const uint64_t P9N2_EX_6_CME_SCOM_LMCR_SCOM1                                = 0x1301203Bull;

static const uint64_t P9N2_EX_6_CME_SCOM_LMCR_SCOM2                                = 0x1301203Cull;

static const uint64_t P9N2_EX_7_CME_SCOM_LMCR_PPE                                  = 0x10C0201A0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LMCR_PPE1                                 = 0x10C0201B8ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LMCR_PPE2                                 = 0x10C0201B0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_LMCR_SCOM                                 = 0x1301243Aull;

static const uint64_t P9N2_EX_7_CME_SCOM_LMCR_SCOM1                                = 0x1301243Bull;

static const uint64_t P9N2_EX_7_CME_SCOM_LMCR_SCOM2                                = 0x1301243Cull;

static const uint64_t P9N2_EX_8_CME_SCOM_LMCR_PPE                                  = 0x10D0101A0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LMCR_PPE1                                 = 0x10D0101B8ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LMCR_PPE2                                 = 0x10D0101B0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_LMCR_SCOM                                 = 0x1401203Aull;

static const uint64_t P9N2_EX_8_CME_SCOM_LMCR_SCOM1                                = 0x1401203Bull;

static const uint64_t P9N2_EX_8_CME_SCOM_LMCR_SCOM2                                = 0x1401203Cull;

static const uint64_t P9N2_EX_9_CME_SCOM_LMCR_PPE                                  = 0x10D0201A0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LMCR_PPE1                                 = 0x10D0201B8ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LMCR_PPE2                                 = 0x10D0201B0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_LMCR_SCOM                                 = 0x1401243Aull;

static const uint64_t P9N2_EX_9_CME_SCOM_LMCR_SCOM1                                = 0x1401243Bull;

static const uint64_t P9N2_EX_9_CME_SCOM_LMCR_SCOM2                                = 0x1401243Cull;

static const uint64_t P9N2_EX_10_CME_SCOM_LMCR_PPE                                 = 0x10E0101A0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LMCR_PPE1                                = 0x10E0101B8ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LMCR_PPE2                                = 0x10E0101B0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_LMCR_SCOM                                = 0x1501203Aull;

static const uint64_t P9N2_EX_10_CME_SCOM_LMCR_SCOM1                               = 0x1501203Bull;

static const uint64_t P9N2_EX_10_CME_SCOM_LMCR_SCOM2                               = 0x1501203Cull;

static const uint64_t P9N2_EX_11_CME_SCOM_LMCR_PPE                                 = 0x10E0201A0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LMCR_PPE1                                = 0x10E0201B8ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LMCR_PPE2                                = 0x10E0201B0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_LMCR_SCOM                                = 0x1501243Aull;

static const uint64_t P9N2_EX_11_CME_SCOM_LMCR_SCOM1                               = 0x1501243Bull;

static const uint64_t P9N2_EX_11_CME_SCOM_LMCR_SCOM2                               = 0x1501243Cull;


static const uint64_t P9N2_EQ_CME_SCOM_PMCRS0                                      = 0x10012042ull;
//DUPS: 10012042,
static const uint64_t P9N2_EQ_0_CME_SCOM_PMCRS0                                    = 0x10012042ull;
//DUPS: 10012042,
static const uint64_t P9N2_EQ_1_CME_SCOM_PMCRS0                                    = 0x11012042ull;
//DUPS: 11012042,
static const uint64_t P9N2_EQ_2_CME_SCOM_PMCRS0                                    = 0x12012042ull;
//DUPS: 12012042,
static const uint64_t P9N2_EQ_3_CME_SCOM_PMCRS0                                    = 0x13012042ull;
//DUPS: 13012042,
static const uint64_t P9N2_EQ_4_CME_SCOM_PMCRS0                                    = 0x14012042ull;
//DUPS: 14012042,
static const uint64_t P9N2_EQ_5_CME_SCOM_PMCRS0                                    = 0x15012042ull;
//DUPS: 15012042,
static const uint64_t P9N2_EX_CME_SCOM_PMCRS0_PPE                                  = 0x109010240ull;

static const uint64_t P9N2_EX_CME_SCOM_PMCRS0_SCOM                                 = 0x10012042ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMCRS0_PPE                                = 0x109010240ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMCRS0_SCOM                               = 0x10012042ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMCRS0_PPE                                = 0x109020240ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMCRS0_SCOM                               = 0x10012442ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMCRS0_PPE                                = 0x10A010240ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMCRS0_SCOM                               = 0x11012042ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMCRS0_PPE                                = 0x10A020240ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMCRS0_SCOM                               = 0x11012442ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMCRS0_PPE                                = 0x10B010240ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMCRS0_SCOM                               = 0x12012042ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMCRS0_PPE                                = 0x10B020240ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMCRS0_SCOM                               = 0x12012442ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMCRS0_PPE                                = 0x10C010240ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMCRS0_SCOM                               = 0x13012042ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMCRS0_PPE                                = 0x10C020240ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMCRS0_SCOM                               = 0x13012442ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMCRS0_PPE                                = 0x10D010240ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMCRS0_SCOM                               = 0x14012042ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMCRS0_PPE                                = 0x10D020240ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMCRS0_SCOM                               = 0x14012442ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMCRS0_PPE                               = 0x10E010240ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMCRS0_SCOM                              = 0x15012042ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMCRS0_PPE                               = 0x10E020240ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMCRS0_SCOM                              = 0x15012442ull;


static const uint64_t P9N2_EQ_CME_SCOM_PMCRS1                                      = 0x10012043ull;
//DUPS: 10012043,
static const uint64_t P9N2_EQ_0_CME_SCOM_PMCRS1                                    = 0x10012043ull;
//DUPS: 10012043,
static const uint64_t P9N2_EQ_1_CME_SCOM_PMCRS1                                    = 0x11012043ull;
//DUPS: 11012043,
static const uint64_t P9N2_EQ_2_CME_SCOM_PMCRS1                                    = 0x12012043ull;
//DUPS: 12012043,
static const uint64_t P9N2_EQ_3_CME_SCOM_PMCRS1                                    = 0x13012043ull;
//DUPS: 13012043,
static const uint64_t P9N2_EQ_4_CME_SCOM_PMCRS1                                    = 0x14012043ull;
//DUPS: 14012043,
static const uint64_t P9N2_EQ_5_CME_SCOM_PMCRS1                                    = 0x15012043ull;
//DUPS: 15012043,
static const uint64_t P9N2_EX_CME_SCOM_PMCRS1_PPE                                  = 0x109010260ull;

static const uint64_t P9N2_EX_CME_SCOM_PMCRS1_SCOM                                 = 0x10012043ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMCRS1_PPE                                = 0x109010260ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMCRS1_SCOM                               = 0x10012043ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMCRS1_PPE                                = 0x109020260ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMCRS1_SCOM                               = 0x10012443ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMCRS1_PPE                                = 0x10A010260ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMCRS1_SCOM                               = 0x11012043ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMCRS1_PPE                                = 0x10A020260ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMCRS1_SCOM                               = 0x11012443ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMCRS1_PPE                                = 0x10B010260ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMCRS1_SCOM                               = 0x12012043ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMCRS1_PPE                                = 0x10B020260ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMCRS1_SCOM                               = 0x12012443ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMCRS1_PPE                                = 0x10C010260ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMCRS1_SCOM                               = 0x13012043ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMCRS1_PPE                                = 0x10C020260ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMCRS1_SCOM                               = 0x13012443ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMCRS1_PPE                                = 0x10D010260ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMCRS1_SCOM                               = 0x14012043ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMCRS1_PPE                                = 0x10D020260ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMCRS1_SCOM                               = 0x14012443ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMCRS1_PPE                               = 0x10E010260ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMCRS1_SCOM                              = 0x15012043ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMCRS1_PPE                               = 0x10E020260ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMCRS1_SCOM                              = 0x15012443ull;


static const uint64_t P9N2_EQ_CME_SCOM_PMSRS0                                      = 0x10012040ull;
//DUPS: 10012040,
static const uint64_t P9N2_EQ_0_CME_SCOM_PMSRS0                                    = 0x10012040ull;
//DUPS: 10012040,
static const uint64_t P9N2_EQ_1_CME_SCOM_PMSRS0                                    = 0x11012040ull;
//DUPS: 11012040,
static const uint64_t P9N2_EQ_2_CME_SCOM_PMSRS0                                    = 0x12012040ull;
//DUPS: 12012040,
static const uint64_t P9N2_EQ_3_CME_SCOM_PMSRS0                                    = 0x13012040ull;
//DUPS: 13012040,
static const uint64_t P9N2_EQ_4_CME_SCOM_PMSRS0                                    = 0x14012040ull;
//DUPS: 14012040,
static const uint64_t P9N2_EQ_5_CME_SCOM_PMSRS0                                    = 0x15012040ull;
//DUPS: 15012040,
static const uint64_t P9N2_EX_CME_SCOM_PMSRS0_PPE                                  = 0x109010200ull;

static const uint64_t P9N2_EX_CME_SCOM_PMSRS0_SCOM                                 = 0x10012040ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMSRS0_PPE                                = 0x109010200ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMSRS0_SCOM                               = 0x10012040ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMSRS0_PPE                                = 0x109020200ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMSRS0_SCOM                               = 0x10012440ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMSRS0_PPE                                = 0x10A010200ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMSRS0_SCOM                               = 0x11012040ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMSRS0_PPE                                = 0x10A020200ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMSRS0_SCOM                               = 0x11012440ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMSRS0_PPE                                = 0x10B010200ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMSRS0_SCOM                               = 0x12012040ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMSRS0_PPE                                = 0x10B020200ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMSRS0_SCOM                               = 0x12012440ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMSRS0_PPE                                = 0x10C010200ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMSRS0_SCOM                               = 0x13012040ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMSRS0_PPE                                = 0x10C020200ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMSRS0_SCOM                               = 0x13012440ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMSRS0_PPE                                = 0x10D010200ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMSRS0_SCOM                               = 0x14012040ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMSRS0_PPE                                = 0x10D020200ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMSRS0_SCOM                               = 0x14012440ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMSRS0_PPE                               = 0x10E010200ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMSRS0_SCOM                              = 0x15012040ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMSRS0_PPE                               = 0x10E020200ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMSRS0_SCOM                              = 0x15012440ull;


static const uint64_t P9N2_EQ_CME_SCOM_PMSRS1                                      = 0x10012041ull;
//DUPS: 10012041,
static const uint64_t P9N2_EQ_0_CME_SCOM_PMSRS1                                    = 0x10012041ull;
//DUPS: 10012041,
static const uint64_t P9N2_EQ_1_CME_SCOM_PMSRS1                                    = 0x11012041ull;
//DUPS: 11012041,
static const uint64_t P9N2_EQ_2_CME_SCOM_PMSRS1                                    = 0x12012041ull;
//DUPS: 12012041,
static const uint64_t P9N2_EQ_3_CME_SCOM_PMSRS1                                    = 0x13012041ull;
//DUPS: 13012041,
static const uint64_t P9N2_EQ_4_CME_SCOM_PMSRS1                                    = 0x14012041ull;
//DUPS: 14012041,
static const uint64_t P9N2_EQ_5_CME_SCOM_PMSRS1                                    = 0x15012041ull;
//DUPS: 15012041,
static const uint64_t P9N2_EX_CME_SCOM_PMSRS1_PPE                                  = 0x109010220ull;

static const uint64_t P9N2_EX_CME_SCOM_PMSRS1_SCOM                                 = 0x10012041ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMSRS1_PPE                                = 0x109010220ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PMSRS1_SCOM                               = 0x10012041ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMSRS1_PPE                                = 0x109020220ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PMSRS1_SCOM                               = 0x10012441ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMSRS1_PPE                                = 0x10A010220ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PMSRS1_SCOM                               = 0x11012041ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMSRS1_PPE                                = 0x10A020220ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PMSRS1_SCOM                               = 0x11012441ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMSRS1_PPE                                = 0x10B010220ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PMSRS1_SCOM                               = 0x12012041ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMSRS1_PPE                                = 0x10B020220ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PMSRS1_SCOM                               = 0x12012441ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMSRS1_PPE                                = 0x10C010220ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PMSRS1_SCOM                               = 0x13012041ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMSRS1_PPE                                = 0x10C020220ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PMSRS1_SCOM                               = 0x13012441ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMSRS1_PPE                                = 0x10D010220ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PMSRS1_SCOM                               = 0x14012041ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMSRS1_PPE                                = 0x10D020220ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PMSRS1_SCOM                               = 0x14012441ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMSRS1_PPE                               = 0x10E010220ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PMSRS1_SCOM                              = 0x15012041ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMSRS1_PPE                               = 0x10E020220ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PMSRS1_SCOM                              = 0x15012441ull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS00                                     = 0x10012044ull;
//DUPS: 10012044,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS00                                   = 0x10012044ull;
//DUPS: 10012044,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS00                                   = 0x11012044ull;
//DUPS: 11012044,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS00                                   = 0x12012044ull;
//DUPS: 12012044,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS00                                   = 0x13012044ull;
//DUPS: 13012044,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS00                                   = 0x14012044ull;
//DUPS: 14012044,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS00                                   = 0x15012044ull;
//DUPS: 15012044,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS00_PPE                                 = 0x109010300ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS00_SCOM                                = 0x10012044ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS00_PPE                               = 0x109010300ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS00_SCOM                              = 0x10012044ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS00_PPE                               = 0x109020300ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS00_SCOM                              = 0x10012444ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS00_PPE                               = 0x10A010300ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS00_SCOM                              = 0x11012044ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS00_PPE                               = 0x10A020300ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS00_SCOM                              = 0x11012444ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS00_PPE                               = 0x10B010300ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS00_SCOM                              = 0x12012044ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS00_PPE                               = 0x10B020300ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS00_SCOM                              = 0x12012444ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS00_PPE                               = 0x10C010300ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS00_SCOM                              = 0x13012044ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS00_PPE                               = 0x10C020300ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS00_SCOM                              = 0x13012444ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS00_PPE                               = 0x10D010300ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS00_SCOM                              = 0x14012044ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS00_PPE                               = 0x10D020300ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS00_SCOM                              = 0x14012444ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS00_PPE                              = 0x10E010300ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS00_SCOM                             = 0x15012044ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS00_PPE                              = 0x10E020300ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS00_SCOM                             = 0x15012444ull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS01                                     = 0x10012045ull;
//DUPS: 10012045,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS01                                   = 0x10012045ull;
//DUPS: 10012045,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS01                                   = 0x11012045ull;
//DUPS: 11012045,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS01                                   = 0x12012045ull;
//DUPS: 12012045,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS01                                   = 0x13012045ull;
//DUPS: 13012045,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS01                                   = 0x14012045ull;
//DUPS: 14012045,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS01                                   = 0x15012045ull;
//DUPS: 15012045,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS01_PPE                                 = 0x109010320ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS01_SCOM                                = 0x10012045ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS01_PPE                               = 0x109010320ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS01_SCOM                              = 0x10012045ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS01_PPE                               = 0x109020320ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS01_SCOM                              = 0x10012445ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS01_PPE                               = 0x10A010320ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS01_SCOM                              = 0x11012045ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS01_PPE                               = 0x10A020320ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS01_SCOM                              = 0x11012445ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS01_PPE                               = 0x10B010320ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS01_SCOM                              = 0x12012045ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS01_PPE                               = 0x10B020320ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS01_SCOM                              = 0x12012445ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS01_PPE                               = 0x10C010320ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS01_SCOM                              = 0x13012045ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS01_PPE                               = 0x10C020320ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS01_SCOM                              = 0x13012445ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS01_PPE                               = 0x10D010320ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS01_SCOM                              = 0x14012045ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS01_PPE                               = 0x10D020320ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS01_SCOM                              = 0x14012445ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS01_PPE                              = 0x10E010320ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS01_SCOM                             = 0x15012045ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS01_PPE                              = 0x10E020320ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS01_SCOM                             = 0x15012445ull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS02                                     = 0x10012046ull;
//DUPS: 10012046,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS02                                   = 0x10012046ull;
//DUPS: 10012046,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS02                                   = 0x11012046ull;
//DUPS: 11012046,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS02                                   = 0x12012046ull;
//DUPS: 12012046,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS02                                   = 0x13012046ull;
//DUPS: 13012046,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS02                                   = 0x14012046ull;
//DUPS: 14012046,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS02                                   = 0x15012046ull;
//DUPS: 15012046,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS02_PPE                                 = 0x109010340ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS02_SCOM                                = 0x10012046ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS02_PPE                               = 0x109010340ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS02_SCOM                              = 0x10012046ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS02_PPE                               = 0x109020340ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS02_SCOM                              = 0x10012446ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS02_PPE                               = 0x10A010340ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS02_SCOM                              = 0x11012046ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS02_PPE                               = 0x10A020340ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS02_SCOM                              = 0x11012446ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS02_PPE                               = 0x10B010340ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS02_SCOM                              = 0x12012046ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS02_PPE                               = 0x10B020340ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS02_SCOM                              = 0x12012446ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS02_PPE                               = 0x10C010340ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS02_SCOM                              = 0x13012046ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS02_PPE                               = 0x10C020340ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS02_SCOM                              = 0x13012446ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS02_PPE                               = 0x10D010340ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS02_SCOM                              = 0x14012046ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS02_PPE                               = 0x10D020340ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS02_SCOM                              = 0x14012446ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS02_PPE                              = 0x10E010340ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS02_SCOM                             = 0x15012046ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS02_PPE                              = 0x10E020340ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS02_SCOM                             = 0x15012446ull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS03                                     = 0x10012047ull;
//DUPS: 10012047,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS03                                   = 0x10012047ull;
//DUPS: 10012047,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS03                                   = 0x11012047ull;
//DUPS: 11012047,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS03                                   = 0x12012047ull;
//DUPS: 12012047,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS03                                   = 0x13012047ull;
//DUPS: 13012047,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS03                                   = 0x14012047ull;
//DUPS: 14012047,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS03                                   = 0x15012047ull;
//DUPS: 15012047,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS03_PPE                                 = 0x109010360ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS03_SCOM                                = 0x10012047ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS03_PPE                               = 0x109010360ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS03_SCOM                              = 0x10012047ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS03_PPE                               = 0x109020360ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS03_SCOM                              = 0x10012447ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS03_PPE                               = 0x10A010360ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS03_SCOM                              = 0x11012047ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS03_PPE                               = 0x10A020360ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS03_SCOM                              = 0x11012447ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS03_PPE                               = 0x10B010360ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS03_SCOM                              = 0x12012047ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS03_PPE                               = 0x10B020360ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS03_SCOM                              = 0x12012447ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS03_PPE                               = 0x10C010360ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS03_SCOM                              = 0x13012047ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS03_PPE                               = 0x10C020360ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS03_SCOM                              = 0x13012447ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS03_PPE                               = 0x10D010360ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS03_SCOM                              = 0x14012047ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS03_PPE                               = 0x10D020360ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS03_SCOM                              = 0x14012447ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS03_PPE                              = 0x10E010360ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS03_SCOM                             = 0x15012047ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS03_PPE                              = 0x10E020360ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS03_SCOM                             = 0x15012447ull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS10                                     = 0x10012048ull;
//DUPS: 10012048,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS10                                   = 0x10012048ull;
//DUPS: 10012048,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS10                                   = 0x11012048ull;
//DUPS: 11012048,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS10                                   = 0x12012048ull;
//DUPS: 12012048,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS10                                   = 0x13012048ull;
//DUPS: 13012048,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS10                                   = 0x14012048ull;
//DUPS: 14012048,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS10                                   = 0x15012048ull;
//DUPS: 15012048,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS10_PPE                                 = 0x109010380ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS10_SCOM                                = 0x10012048ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS10_PPE                               = 0x109010380ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS10_SCOM                              = 0x10012048ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS10_PPE                               = 0x109020380ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS10_SCOM                              = 0x10012448ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS10_PPE                               = 0x10A010380ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS10_SCOM                              = 0x11012048ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS10_PPE                               = 0x10A020380ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS10_SCOM                              = 0x11012448ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS10_PPE                               = 0x10B010380ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS10_SCOM                              = 0x12012048ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS10_PPE                               = 0x10B020380ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS10_SCOM                              = 0x12012448ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS10_PPE                               = 0x10C010380ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS10_SCOM                              = 0x13012048ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS10_PPE                               = 0x10C020380ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS10_SCOM                              = 0x13012448ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS10_PPE                               = 0x10D010380ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS10_SCOM                              = 0x14012048ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS10_PPE                               = 0x10D020380ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS10_SCOM                              = 0x14012448ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS10_PPE                              = 0x10E010380ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS10_SCOM                             = 0x15012048ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS10_PPE                              = 0x10E020380ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS10_SCOM                             = 0x15012448ull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS11                                     = 0x10012049ull;
//DUPS: 10012049,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS11                                   = 0x10012049ull;
//DUPS: 10012049,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS11                                   = 0x11012049ull;
//DUPS: 11012049,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS11                                   = 0x12012049ull;
//DUPS: 12012049,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS11                                   = 0x13012049ull;
//DUPS: 13012049,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS11                                   = 0x14012049ull;
//DUPS: 14012049,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS11                                   = 0x15012049ull;
//DUPS: 15012049,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS11_PPE                                 = 0x1090103A0ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS11_SCOM                                = 0x10012049ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS11_PPE                               = 0x1090103A0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS11_SCOM                              = 0x10012049ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS11_PPE                               = 0x1090203A0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS11_SCOM                              = 0x10012449ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS11_PPE                               = 0x10A0103A0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS11_SCOM                              = 0x11012049ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS11_PPE                               = 0x10A0203A0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS11_SCOM                              = 0x11012449ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS11_PPE                               = 0x10B0103A0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS11_SCOM                              = 0x12012049ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS11_PPE                               = 0x10B0203A0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS11_SCOM                              = 0x12012449ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS11_PPE                               = 0x10C0103A0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS11_SCOM                              = 0x13012049ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS11_PPE                               = 0x10C0203A0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS11_SCOM                              = 0x13012449ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS11_PPE                               = 0x10D0103A0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS11_SCOM                              = 0x14012049ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS11_PPE                               = 0x10D0203A0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS11_SCOM                              = 0x14012449ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS11_PPE                              = 0x10E0103A0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS11_SCOM                             = 0x15012049ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS11_PPE                              = 0x10E0203A0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS11_SCOM                             = 0x15012449ull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS12                                     = 0x1001204Aull;
//DUPS: 1001204A,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS12                                   = 0x1001204Aull;
//DUPS: 1001204A,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS12                                   = 0x1101204Aull;
//DUPS: 1101204A,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS12                                   = 0x1201204Aull;
//DUPS: 1201204A,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS12                                   = 0x1301204Aull;
//DUPS: 1301204A,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS12                                   = 0x1401204Aull;
//DUPS: 1401204A,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS12                                   = 0x1501204Aull;
//DUPS: 1501204A,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS12_PPE                                 = 0x1090103C0ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS12_SCOM                                = 0x1001204Aull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS12_PPE                               = 0x1090103C0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS12_SCOM                              = 0x1001204Aull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS12_PPE                               = 0x1090203C0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS12_SCOM                              = 0x1001244Aull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS12_PPE                               = 0x10A0103C0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS12_SCOM                              = 0x1101204Aull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS12_PPE                               = 0x10A0203C0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS12_SCOM                              = 0x1101244Aull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS12_PPE                               = 0x10B0103C0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS12_SCOM                              = 0x1201204Aull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS12_PPE                               = 0x10B0203C0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS12_SCOM                              = 0x1201244Aull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS12_PPE                               = 0x10C0103C0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS12_SCOM                              = 0x1301204Aull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS12_PPE                               = 0x10C0203C0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS12_SCOM                              = 0x1301244Aull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS12_PPE                               = 0x10D0103C0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS12_SCOM                              = 0x1401204Aull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS12_PPE                               = 0x10D0203C0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS12_SCOM                              = 0x1401244Aull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS12_PPE                              = 0x10E0103C0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS12_SCOM                             = 0x1501204Aull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS12_PPE                              = 0x10E0203C0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS12_SCOM                             = 0x1501244Aull;


static const uint64_t P9N2_EQ_CME_SCOM_PSCRS13                                     = 0x1001204Bull;
//DUPS: 1001204B,
static const uint64_t P9N2_EQ_0_CME_SCOM_PSCRS13                                   = 0x1001204Bull;
//DUPS: 1001204B,
static const uint64_t P9N2_EQ_1_CME_SCOM_PSCRS13                                   = 0x1101204Bull;
//DUPS: 1101204B,
static const uint64_t P9N2_EQ_2_CME_SCOM_PSCRS13                                   = 0x1201204Bull;
//DUPS: 1201204B,
static const uint64_t P9N2_EQ_3_CME_SCOM_PSCRS13                                   = 0x1301204Bull;
//DUPS: 1301204B,
static const uint64_t P9N2_EQ_4_CME_SCOM_PSCRS13                                   = 0x1401204Bull;
//DUPS: 1401204B,
static const uint64_t P9N2_EQ_5_CME_SCOM_PSCRS13                                   = 0x1501204Bull;
//DUPS: 1501204B,
static const uint64_t P9N2_EX_CME_SCOM_PSCRS13_PPE                                 = 0x1090103E0ull;

static const uint64_t P9N2_EX_CME_SCOM_PSCRS13_SCOM                                = 0x1001204Bull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS13_PPE                               = 0x1090103E0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_PSCRS13_SCOM                              = 0x1001204Bull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS13_PPE                               = 0x1090203E0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_PSCRS13_SCOM                              = 0x1001244Bull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS13_PPE                               = 0x10A0103E0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_PSCRS13_SCOM                              = 0x1101204Bull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS13_PPE                               = 0x10A0203E0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_PSCRS13_SCOM                              = 0x1101244Bull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS13_PPE                               = 0x10B0103E0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_PSCRS13_SCOM                              = 0x1201204Bull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS13_PPE                               = 0x10B0203E0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_PSCRS13_SCOM                              = 0x1201244Bull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS13_PPE                               = 0x10C0103E0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_PSCRS13_SCOM                              = 0x1301204Bull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS13_PPE                               = 0x10C0203E0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_PSCRS13_SCOM                              = 0x1301244Bull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS13_PPE                               = 0x10D0103E0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_PSCRS13_SCOM                              = 0x1401204Bull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS13_PPE                               = 0x10D0203E0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_PSCRS13_SCOM                              = 0x1401244Bull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS13_PPE                              = 0x10E0103E0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_PSCRS13_SCOM                             = 0x1501204Bull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS13_PPE                              = 0x10E0203E0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_PSCRS13_SCOM                             = 0x1501244Bull;


static const uint64_t P9N2_EQ_CME_SCOM_QFMR                                        = 0x10012032ull;
//DUPS: 10012032,
static const uint64_t P9N2_EQ_0_CME_SCOM_QFMR                                      = 0x10012032ull;
//DUPS: 10012032,
static const uint64_t P9N2_EQ_1_CME_SCOM_QFMR                                      = 0x11012032ull;
//DUPS: 11012032,
static const uint64_t P9N2_EQ_2_CME_SCOM_QFMR                                      = 0x12012032ull;
//DUPS: 12012032,
static const uint64_t P9N2_EQ_3_CME_SCOM_QFMR                                      = 0x13012032ull;
//DUPS: 13012032,
static const uint64_t P9N2_EQ_4_CME_SCOM_QFMR                                      = 0x14012032ull;
//DUPS: 14012032,
static const uint64_t P9N2_EQ_5_CME_SCOM_QFMR                                      = 0x15012032ull;
//DUPS: 15012032,
static const uint64_t P9N2_EX_CME_SCOM_QFMR_PPE                                    = 0x109010140ull;

static const uint64_t P9N2_EX_CME_SCOM_QFMR_SCOM                                   = 0x10012032ull;

static const uint64_t P9N2_EX_0_CME_SCOM_QFMR_PPE                                  = 0x109010140ull;

static const uint64_t P9N2_EX_0_CME_SCOM_QFMR_SCOM                                 = 0x10012032ull;

static const uint64_t P9N2_EX_1_CME_SCOM_QFMR_PPE                                  = 0x109020140ull;

static const uint64_t P9N2_EX_1_CME_SCOM_QFMR_SCOM                                 = 0x10012432ull;

static const uint64_t P9N2_EX_2_CME_SCOM_QFMR_PPE                                  = 0x10A010140ull;

static const uint64_t P9N2_EX_2_CME_SCOM_QFMR_SCOM                                 = 0x11012032ull;

static const uint64_t P9N2_EX_3_CME_SCOM_QFMR_PPE                                  = 0x10A020140ull;

static const uint64_t P9N2_EX_3_CME_SCOM_QFMR_SCOM                                 = 0x11012432ull;

static const uint64_t P9N2_EX_4_CME_SCOM_QFMR_PPE                                  = 0x10B010140ull;

static const uint64_t P9N2_EX_4_CME_SCOM_QFMR_SCOM                                 = 0x12012032ull;

static const uint64_t P9N2_EX_5_CME_SCOM_QFMR_PPE                                  = 0x10B020140ull;

static const uint64_t P9N2_EX_5_CME_SCOM_QFMR_SCOM                                 = 0x12012432ull;

static const uint64_t P9N2_EX_6_CME_SCOM_QFMR_PPE                                  = 0x10C010140ull;

static const uint64_t P9N2_EX_6_CME_SCOM_QFMR_SCOM                                 = 0x13012032ull;

static const uint64_t P9N2_EX_7_CME_SCOM_QFMR_PPE                                  = 0x10C020140ull;

static const uint64_t P9N2_EX_7_CME_SCOM_QFMR_SCOM                                 = 0x13012432ull;

static const uint64_t P9N2_EX_8_CME_SCOM_QFMR_PPE                                  = 0x10D010140ull;

static const uint64_t P9N2_EX_8_CME_SCOM_QFMR_SCOM                                 = 0x14012032ull;

static const uint64_t P9N2_EX_9_CME_SCOM_QFMR_PPE                                  = 0x10D020140ull;

static const uint64_t P9N2_EX_9_CME_SCOM_QFMR_SCOM                                 = 0x14012432ull;

static const uint64_t P9N2_EX_10_CME_SCOM_QFMR_PPE                                 = 0x10E010140ull;

static const uint64_t P9N2_EX_10_CME_SCOM_QFMR_SCOM                                = 0x15012032ull;

static const uint64_t P9N2_EX_11_CME_SCOM_QFMR_PPE                                 = 0x10E020140ull;

static const uint64_t P9N2_EX_11_CME_SCOM_QFMR_SCOM                                = 0x15012432ull;


static const uint64_t P9N2_EQ_CME_SCOM_QIDSR                                       = 0x1001202Full;
//DUPS: 1001202F,
static const uint64_t P9N2_EQ_0_CME_SCOM_QIDSR                                     = 0x1001202Full;
//DUPS: 1001202F,
static const uint64_t P9N2_EQ_1_CME_SCOM_QIDSR                                     = 0x1101202Full;
//DUPS: 1101202F,
static const uint64_t P9N2_EQ_2_CME_SCOM_QIDSR                                     = 0x1201202Full;
//DUPS: 1201202F,
static const uint64_t P9N2_EQ_3_CME_SCOM_QIDSR                                     = 0x1301202Full;
//DUPS: 1301202F,
static const uint64_t P9N2_EQ_4_CME_SCOM_QIDSR                                     = 0x1401202Full;
//DUPS: 1401202F,
static const uint64_t P9N2_EQ_5_CME_SCOM_QIDSR                                     = 0x1501202Full;
//DUPS: 1501202F,
static const uint64_t P9N2_EX_CME_SCOM_QIDSR_PPE                                   = 0x1090106E0ull;

static const uint64_t P9N2_EX_CME_SCOM_QIDSR_SCOM                                  = 0x1001202Full;

static const uint64_t P9N2_EX_0_CME_SCOM_QIDSR_PPE                                 = 0x1090106E0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_QIDSR_SCOM                                = 0x1001202Full;

static const uint64_t P9N2_EX_1_CME_SCOM_QIDSR_PPE                                 = 0x1090206E0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_QIDSR_SCOM                                = 0x1001242Full;

static const uint64_t P9N2_EX_2_CME_SCOM_QIDSR_PPE                                 = 0x10A0106E0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_QIDSR_SCOM                                = 0x1101202Full;

static const uint64_t P9N2_EX_3_CME_SCOM_QIDSR_PPE                                 = 0x10A0206E0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_QIDSR_SCOM                                = 0x1101242Full;

static const uint64_t P9N2_EX_4_CME_SCOM_QIDSR_PPE                                 = 0x10B0106E0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_QIDSR_SCOM                                = 0x1201202Full;

static const uint64_t P9N2_EX_5_CME_SCOM_QIDSR_PPE                                 = 0x10B0206E0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_QIDSR_SCOM                                = 0x1201242Full;

static const uint64_t P9N2_EX_6_CME_SCOM_QIDSR_PPE                                 = 0x10C0106E0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_QIDSR_SCOM                                = 0x1301202Full;

static const uint64_t P9N2_EX_7_CME_SCOM_QIDSR_PPE                                 = 0x10C0206E0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_QIDSR_SCOM                                = 0x1301242Full;

static const uint64_t P9N2_EX_8_CME_SCOM_QIDSR_PPE                                 = 0x10D0106E0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_QIDSR_SCOM                                = 0x1401202Full;

static const uint64_t P9N2_EX_9_CME_SCOM_QIDSR_PPE                                 = 0x10D0206E0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_QIDSR_SCOM                                = 0x1401242Full;

static const uint64_t P9N2_EX_10_CME_SCOM_QIDSR_PPE                                = 0x10E0106E0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_QIDSR_SCOM                               = 0x1501202Full;

static const uint64_t P9N2_EX_11_CME_SCOM_QIDSR_PPE                                = 0x10E0206E0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_QIDSR_SCOM                               = 0x1501242Full;


static const uint64_t P9N2_EQ_CME_SCOM_SICR_SCOM                                   = 0x1001203Dull;
//DUPS: 1001203D,
static const uint64_t P9N2_EQ_CME_SCOM_SICR_SCOM1                                  = 0x1001203Eull;
//DUPS: 1001203E,
static const uint64_t P9N2_EQ_CME_SCOM_SICR_SCOM2                                  = 0x1001203Full;
//DUPS: 1001203F,
static const uint64_t P9N2_EQ_0_CME_SCOM_SICR_SCOM                                 = 0x1001203Dull;
//DUPS: 1001203D,
static const uint64_t P9N2_EQ_0_CME_SCOM_SICR_SCOM1                                = 0x1001203Eull;
//DUPS: 1001203E,
static const uint64_t P9N2_EQ_0_CME_SCOM_SICR_SCOM2                                = 0x1001203Full;
//DUPS: 1001203F,
static const uint64_t P9N2_EQ_1_CME_SCOM_SICR_SCOM                                 = 0x1101203Dull;
//DUPS: 1101203D,
static const uint64_t P9N2_EQ_1_CME_SCOM_SICR_SCOM1                                = 0x1101203Eull;
//DUPS: 1101203E,
static const uint64_t P9N2_EQ_1_CME_SCOM_SICR_SCOM2                                = 0x1101203Full;
//DUPS: 1101203F,
static const uint64_t P9N2_EQ_2_CME_SCOM_SICR_SCOM                                 = 0x1201203Dull;
//DUPS: 1201203D,
static const uint64_t P9N2_EQ_2_CME_SCOM_SICR_SCOM1                                = 0x1201203Eull;
//DUPS: 1201203E,
static const uint64_t P9N2_EQ_2_CME_SCOM_SICR_SCOM2                                = 0x1201203Full;
//DUPS: 1201203F,
static const uint64_t P9N2_EQ_3_CME_SCOM_SICR_SCOM                                 = 0x1301203Dull;
//DUPS: 1301203D,
static const uint64_t P9N2_EQ_3_CME_SCOM_SICR_SCOM1                                = 0x1301203Eull;
//DUPS: 1301203E,
static const uint64_t P9N2_EQ_3_CME_SCOM_SICR_SCOM2                                = 0x1301203Full;
//DUPS: 1301203F,
static const uint64_t P9N2_EQ_4_CME_SCOM_SICR_SCOM                                 = 0x1401203Dull;
//DUPS: 1401203D,
static const uint64_t P9N2_EQ_4_CME_SCOM_SICR_SCOM1                                = 0x1401203Eull;
//DUPS: 1401203E,
static const uint64_t P9N2_EQ_4_CME_SCOM_SICR_SCOM2                                = 0x1401203Full;
//DUPS: 1401203F,
static const uint64_t P9N2_EQ_5_CME_SCOM_SICR_SCOM                                 = 0x1501203Dull;
//DUPS: 1501203D,
static const uint64_t P9N2_EQ_5_CME_SCOM_SICR_SCOM1                                = 0x1501203Eull;
//DUPS: 1501203E,
static const uint64_t P9N2_EQ_5_CME_SCOM_SICR_SCOM2                                = 0x1501203Full;
//DUPS: 1501203F,
static const uint64_t P9N2_EX_CME_SCOM_SICR_PPE                                    = 0x109010500ull;

static const uint64_t P9N2_EX_CME_SCOM_SICR_PPE1                                   = 0x109010518ull;

static const uint64_t P9N2_EX_CME_SCOM_SICR_PPE2                                   = 0x109010510ull;

static const uint64_t P9N2_EX_CME_SCOM_SICR_SCOM                                   = 0x1001203Dull;

static const uint64_t P9N2_EX_CME_SCOM_SICR_SCOM1                                  = 0x1001203Eull;

static const uint64_t P9N2_EX_CME_SCOM_SICR_SCOM2                                  = 0x1001203Full;

static const uint64_t P9N2_EX_0_CME_SCOM_SICR_PPE                                  = 0x109010500ull;

static const uint64_t P9N2_EX_0_CME_SCOM_SICR_PPE1                                 = 0x109010518ull;

static const uint64_t P9N2_EX_0_CME_SCOM_SICR_PPE2                                 = 0x109010510ull;

static const uint64_t P9N2_EX_0_CME_SCOM_SICR_SCOM                                 = 0x1001203Dull;

static const uint64_t P9N2_EX_0_CME_SCOM_SICR_SCOM1                                = 0x1001203Eull;

static const uint64_t P9N2_EX_0_CME_SCOM_SICR_SCOM2                                = 0x1001203Full;

static const uint64_t P9N2_EX_1_CME_SCOM_SICR_PPE                                  = 0x109020500ull;

static const uint64_t P9N2_EX_1_CME_SCOM_SICR_PPE1                                 = 0x109020518ull;

static const uint64_t P9N2_EX_1_CME_SCOM_SICR_PPE2                                 = 0x109020510ull;

static const uint64_t P9N2_EX_1_CME_SCOM_SICR_SCOM                                 = 0x1001243Dull;

static const uint64_t P9N2_EX_1_CME_SCOM_SICR_SCOM1                                = 0x1001243Eull;

static const uint64_t P9N2_EX_1_CME_SCOM_SICR_SCOM2                                = 0x1001243Full;

static const uint64_t P9N2_EX_2_CME_SCOM_SICR_PPE                                  = 0x10A010500ull;

static const uint64_t P9N2_EX_2_CME_SCOM_SICR_PPE1                                 = 0x10A010518ull;

static const uint64_t P9N2_EX_2_CME_SCOM_SICR_PPE2                                 = 0x10A010510ull;

static const uint64_t P9N2_EX_2_CME_SCOM_SICR_SCOM                                 = 0x1101203Dull;

static const uint64_t P9N2_EX_2_CME_SCOM_SICR_SCOM1                                = 0x1101203Eull;

static const uint64_t P9N2_EX_2_CME_SCOM_SICR_SCOM2                                = 0x1101203Full;

static const uint64_t P9N2_EX_3_CME_SCOM_SICR_PPE                                  = 0x10A020500ull;

static const uint64_t P9N2_EX_3_CME_SCOM_SICR_PPE1                                 = 0x10A020518ull;

static const uint64_t P9N2_EX_3_CME_SCOM_SICR_PPE2                                 = 0x10A020510ull;

static const uint64_t P9N2_EX_3_CME_SCOM_SICR_SCOM                                 = 0x1101243Dull;

static const uint64_t P9N2_EX_3_CME_SCOM_SICR_SCOM1                                = 0x1101243Eull;

static const uint64_t P9N2_EX_3_CME_SCOM_SICR_SCOM2                                = 0x1101243Full;

static const uint64_t P9N2_EX_4_CME_SCOM_SICR_PPE                                  = 0x10B010500ull;

static const uint64_t P9N2_EX_4_CME_SCOM_SICR_PPE1                                 = 0x10B010518ull;

static const uint64_t P9N2_EX_4_CME_SCOM_SICR_PPE2                                 = 0x10B010510ull;

static const uint64_t P9N2_EX_4_CME_SCOM_SICR_SCOM                                 = 0x1201203Dull;

static const uint64_t P9N2_EX_4_CME_SCOM_SICR_SCOM1                                = 0x1201203Eull;

static const uint64_t P9N2_EX_4_CME_SCOM_SICR_SCOM2                                = 0x1201203Full;

static const uint64_t P9N2_EX_5_CME_SCOM_SICR_PPE                                  = 0x10B020500ull;

static const uint64_t P9N2_EX_5_CME_SCOM_SICR_PPE1                                 = 0x10B020518ull;

static const uint64_t P9N2_EX_5_CME_SCOM_SICR_PPE2                                 = 0x10B020510ull;

static const uint64_t P9N2_EX_5_CME_SCOM_SICR_SCOM                                 = 0x1201243Dull;

static const uint64_t P9N2_EX_5_CME_SCOM_SICR_SCOM1                                = 0x1201243Eull;

static const uint64_t P9N2_EX_5_CME_SCOM_SICR_SCOM2                                = 0x1201243Full;

static const uint64_t P9N2_EX_6_CME_SCOM_SICR_PPE                                  = 0x10C010500ull;

static const uint64_t P9N2_EX_6_CME_SCOM_SICR_PPE1                                 = 0x10C010518ull;

static const uint64_t P9N2_EX_6_CME_SCOM_SICR_PPE2                                 = 0x10C010510ull;

static const uint64_t P9N2_EX_6_CME_SCOM_SICR_SCOM                                 = 0x1301203Dull;

static const uint64_t P9N2_EX_6_CME_SCOM_SICR_SCOM1                                = 0x1301203Eull;

static const uint64_t P9N2_EX_6_CME_SCOM_SICR_SCOM2                                = 0x1301203Full;

static const uint64_t P9N2_EX_7_CME_SCOM_SICR_PPE                                  = 0x10C020500ull;

static const uint64_t P9N2_EX_7_CME_SCOM_SICR_PPE1                                 = 0x10C020518ull;

static const uint64_t P9N2_EX_7_CME_SCOM_SICR_PPE2                                 = 0x10C020510ull;

static const uint64_t P9N2_EX_7_CME_SCOM_SICR_SCOM                                 = 0x1301243Dull;

static const uint64_t P9N2_EX_7_CME_SCOM_SICR_SCOM1                                = 0x1301243Eull;

static const uint64_t P9N2_EX_7_CME_SCOM_SICR_SCOM2                                = 0x1301243Full;

static const uint64_t P9N2_EX_8_CME_SCOM_SICR_PPE                                  = 0x10D010500ull;

static const uint64_t P9N2_EX_8_CME_SCOM_SICR_PPE1                                 = 0x10D010518ull;

static const uint64_t P9N2_EX_8_CME_SCOM_SICR_PPE2                                 = 0x10D010510ull;

static const uint64_t P9N2_EX_8_CME_SCOM_SICR_SCOM                                 = 0x1401203Dull;

static const uint64_t P9N2_EX_8_CME_SCOM_SICR_SCOM1                                = 0x1401203Eull;

static const uint64_t P9N2_EX_8_CME_SCOM_SICR_SCOM2                                = 0x1401203Full;

static const uint64_t P9N2_EX_9_CME_SCOM_SICR_PPE                                  = 0x10D020500ull;

static const uint64_t P9N2_EX_9_CME_SCOM_SICR_PPE1                                 = 0x10D020518ull;

static const uint64_t P9N2_EX_9_CME_SCOM_SICR_PPE2                                 = 0x10D020510ull;

static const uint64_t P9N2_EX_9_CME_SCOM_SICR_SCOM                                 = 0x1401243Dull;

static const uint64_t P9N2_EX_9_CME_SCOM_SICR_SCOM1                                = 0x1401243Eull;

static const uint64_t P9N2_EX_9_CME_SCOM_SICR_SCOM2                                = 0x1401243Full;

static const uint64_t P9N2_EX_10_CME_SCOM_SICR_PPE                                 = 0x10E010500ull;

static const uint64_t P9N2_EX_10_CME_SCOM_SICR_PPE1                                = 0x10E010518ull;

static const uint64_t P9N2_EX_10_CME_SCOM_SICR_PPE2                                = 0x10E010510ull;

static const uint64_t P9N2_EX_10_CME_SCOM_SICR_SCOM                                = 0x1501203Dull;

static const uint64_t P9N2_EX_10_CME_SCOM_SICR_SCOM1                               = 0x1501203Eull;

static const uint64_t P9N2_EX_10_CME_SCOM_SICR_SCOM2                               = 0x1501203Full;

static const uint64_t P9N2_EX_11_CME_SCOM_SICR_PPE                                 = 0x10E020500ull;

static const uint64_t P9N2_EX_11_CME_SCOM_SICR_PPE1                                = 0x10E020518ull;

static const uint64_t P9N2_EX_11_CME_SCOM_SICR_PPE2                                = 0x10E020510ull;

static const uint64_t P9N2_EX_11_CME_SCOM_SICR_SCOM                                = 0x1501243Dull;

static const uint64_t P9N2_EX_11_CME_SCOM_SICR_SCOM1                               = 0x1501243Eull;

static const uint64_t P9N2_EX_11_CME_SCOM_SICR_SCOM2                               = 0x1501243Full;


static const uint64_t P9N2_EQ_CME_SCOM_SRTCH0                                      = 0x10012023ull;
//DUPS: 10012023,
static const uint64_t P9N2_EQ_0_CME_SCOM_SRTCH0                                    = 0x10012023ull;
//DUPS: 10012023,
static const uint64_t P9N2_EQ_1_CME_SCOM_SRTCH0                                    = 0x11012023ull;
//DUPS: 11012023,
static const uint64_t P9N2_EQ_2_CME_SCOM_SRTCH0                                    = 0x12012023ull;
//DUPS: 12012023,
static const uint64_t P9N2_EQ_3_CME_SCOM_SRTCH0                                    = 0x13012023ull;
//DUPS: 13012023,
static const uint64_t P9N2_EQ_4_CME_SCOM_SRTCH0                                    = 0x14012023ull;
//DUPS: 14012023,
static const uint64_t P9N2_EQ_5_CME_SCOM_SRTCH0                                    = 0x15012023ull;
//DUPS: 15012023,
static const uint64_t P9N2_EX_CME_SCOM_SRTCH0_PPE                                  = 0x109010420ull;

static const uint64_t P9N2_EX_CME_SCOM_SRTCH0_SCOM                                 = 0x10012023ull;

static const uint64_t P9N2_EX_0_CME_SCOM_SRTCH0_PPE                                = 0x109010420ull;

static const uint64_t P9N2_EX_0_CME_SCOM_SRTCH0_SCOM                               = 0x10012023ull;

static const uint64_t P9N2_EX_1_CME_SCOM_SRTCH0_PPE                                = 0x109020420ull;

static const uint64_t P9N2_EX_1_CME_SCOM_SRTCH0_SCOM                               = 0x10012423ull;

static const uint64_t P9N2_EX_2_CME_SCOM_SRTCH0_PPE                                = 0x10A010420ull;

static const uint64_t P9N2_EX_2_CME_SCOM_SRTCH0_SCOM                               = 0x11012023ull;

static const uint64_t P9N2_EX_3_CME_SCOM_SRTCH0_PPE                                = 0x10A020420ull;

static const uint64_t P9N2_EX_3_CME_SCOM_SRTCH0_SCOM                               = 0x11012423ull;

static const uint64_t P9N2_EX_4_CME_SCOM_SRTCH0_PPE                                = 0x10B010420ull;

static const uint64_t P9N2_EX_4_CME_SCOM_SRTCH0_SCOM                               = 0x12012023ull;

static const uint64_t P9N2_EX_5_CME_SCOM_SRTCH0_PPE                                = 0x10B020420ull;

static const uint64_t P9N2_EX_5_CME_SCOM_SRTCH0_SCOM                               = 0x12012423ull;

static const uint64_t P9N2_EX_6_CME_SCOM_SRTCH0_PPE                                = 0x10C010420ull;

static const uint64_t P9N2_EX_6_CME_SCOM_SRTCH0_SCOM                               = 0x13012023ull;

static const uint64_t P9N2_EX_7_CME_SCOM_SRTCH0_PPE                                = 0x10C020420ull;

static const uint64_t P9N2_EX_7_CME_SCOM_SRTCH0_SCOM                               = 0x13012423ull;

static const uint64_t P9N2_EX_8_CME_SCOM_SRTCH0_PPE                                = 0x10D010420ull;

static const uint64_t P9N2_EX_8_CME_SCOM_SRTCH0_SCOM                               = 0x14012023ull;

static const uint64_t P9N2_EX_9_CME_SCOM_SRTCH0_PPE                                = 0x10D020420ull;

static const uint64_t P9N2_EX_9_CME_SCOM_SRTCH0_SCOM                               = 0x14012423ull;

static const uint64_t P9N2_EX_10_CME_SCOM_SRTCH0_PPE                               = 0x10E010420ull;

static const uint64_t P9N2_EX_10_CME_SCOM_SRTCH0_SCOM                              = 0x15012023ull;

static const uint64_t P9N2_EX_11_CME_SCOM_SRTCH0_PPE                               = 0x10E020420ull;

static const uint64_t P9N2_EX_11_CME_SCOM_SRTCH0_SCOM                              = 0x15012423ull;


static const uint64_t P9N2_EQ_CME_SCOM_SRTCH1                                      = 0x10012024ull;
//DUPS: 10012024,
static const uint64_t P9N2_EQ_0_CME_SCOM_SRTCH1                                    = 0x10012024ull;
//DUPS: 10012024,
static const uint64_t P9N2_EQ_1_CME_SCOM_SRTCH1                                    = 0x11012024ull;
//DUPS: 11012024,
static const uint64_t P9N2_EQ_2_CME_SCOM_SRTCH1                                    = 0x12012024ull;
//DUPS: 12012024,
static const uint64_t P9N2_EQ_3_CME_SCOM_SRTCH1                                    = 0x13012024ull;
//DUPS: 13012024,
static const uint64_t P9N2_EQ_4_CME_SCOM_SRTCH1                                    = 0x14012024ull;
//DUPS: 14012024,
static const uint64_t P9N2_EQ_5_CME_SCOM_SRTCH1                                    = 0x15012024ull;
//DUPS: 15012024,
static const uint64_t P9N2_EX_CME_SCOM_SRTCH1_PPE                                  = 0x109010440ull;

static const uint64_t P9N2_EX_CME_SCOM_SRTCH1_SCOM                                 = 0x10012024ull;

static const uint64_t P9N2_EX_0_CME_SCOM_SRTCH1_PPE                                = 0x109010440ull;

static const uint64_t P9N2_EX_0_CME_SCOM_SRTCH1_SCOM                               = 0x10012024ull;

static const uint64_t P9N2_EX_1_CME_SCOM_SRTCH1_PPE                                = 0x109020440ull;

static const uint64_t P9N2_EX_1_CME_SCOM_SRTCH1_SCOM                               = 0x10012424ull;

static const uint64_t P9N2_EX_2_CME_SCOM_SRTCH1_PPE                                = 0x10A010440ull;

static const uint64_t P9N2_EX_2_CME_SCOM_SRTCH1_SCOM                               = 0x11012024ull;

static const uint64_t P9N2_EX_3_CME_SCOM_SRTCH1_PPE                                = 0x10A020440ull;

static const uint64_t P9N2_EX_3_CME_SCOM_SRTCH1_SCOM                               = 0x11012424ull;

static const uint64_t P9N2_EX_4_CME_SCOM_SRTCH1_PPE                                = 0x10B010440ull;

static const uint64_t P9N2_EX_4_CME_SCOM_SRTCH1_SCOM                               = 0x12012024ull;

static const uint64_t P9N2_EX_5_CME_SCOM_SRTCH1_PPE                                = 0x10B020440ull;

static const uint64_t P9N2_EX_5_CME_SCOM_SRTCH1_SCOM                               = 0x12012424ull;

static const uint64_t P9N2_EX_6_CME_SCOM_SRTCH1_PPE                                = 0x10C010440ull;

static const uint64_t P9N2_EX_6_CME_SCOM_SRTCH1_SCOM                               = 0x13012024ull;

static const uint64_t P9N2_EX_7_CME_SCOM_SRTCH1_PPE                                = 0x10C020440ull;

static const uint64_t P9N2_EX_7_CME_SCOM_SRTCH1_SCOM                               = 0x13012424ull;

static const uint64_t P9N2_EX_8_CME_SCOM_SRTCH1_PPE                                = 0x10D010440ull;

static const uint64_t P9N2_EX_8_CME_SCOM_SRTCH1_SCOM                               = 0x14012024ull;

static const uint64_t P9N2_EX_9_CME_SCOM_SRTCH1_PPE                                = 0x10D020440ull;

static const uint64_t P9N2_EX_9_CME_SCOM_SRTCH1_SCOM                               = 0x14012424ull;

static const uint64_t P9N2_EX_10_CME_SCOM_SRTCH1_PPE                               = 0x10E010440ull;

static const uint64_t P9N2_EX_10_CME_SCOM_SRTCH1_SCOM                              = 0x15012024ull;

static const uint64_t P9N2_EX_11_CME_SCOM_SRTCH1_PPE                               = 0x10E020440ull;

static const uint64_t P9N2_EX_11_CME_SCOM_SRTCH1_SCOM                              = 0x15012424ull;


static const uint64_t P9N2_EQ_CME_SCOM_VCCR                                        = 0x1001202Cull;
//DUPS: 1001202C,
static const uint64_t P9N2_EQ_0_CME_SCOM_VCCR                                      = 0x1001202Cull;
//DUPS: 1001202C,
static const uint64_t P9N2_EQ_1_CME_SCOM_VCCR                                      = 0x1101202Cull;
//DUPS: 1101202C,
static const uint64_t P9N2_EQ_2_CME_SCOM_VCCR                                      = 0x1201202Cull;
//DUPS: 1201202C,
static const uint64_t P9N2_EQ_3_CME_SCOM_VCCR                                      = 0x1301202Cull;
//DUPS: 1301202C,
static const uint64_t P9N2_EQ_4_CME_SCOM_VCCR                                      = 0x1401202Cull;
//DUPS: 1401202C,
static const uint64_t P9N2_EQ_5_CME_SCOM_VCCR                                      = 0x1501202Cull;
//DUPS: 1501202C,
static const uint64_t P9N2_EX_CME_SCOM_VCCR_PPE                                    = 0x109010680ull;

static const uint64_t P9N2_EX_CME_SCOM_VCCR_SCOM                                   = 0x1001202Cull;

static const uint64_t P9N2_EX_0_CME_SCOM_VCCR_PPE                                  = 0x109010680ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VCCR_SCOM                                 = 0x1001202Cull;

static const uint64_t P9N2_EX_1_CME_SCOM_VCCR_PPE                                  = 0x109020680ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VCCR_SCOM                                 = 0x1001242Cull;

static const uint64_t P9N2_EX_2_CME_SCOM_VCCR_PPE                                  = 0x10A010680ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VCCR_SCOM                                 = 0x1101202Cull;

static const uint64_t P9N2_EX_3_CME_SCOM_VCCR_PPE                                  = 0x10A020680ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VCCR_SCOM                                 = 0x1101242Cull;

static const uint64_t P9N2_EX_4_CME_SCOM_VCCR_PPE                                  = 0x10B010680ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VCCR_SCOM                                 = 0x1201202Cull;

static const uint64_t P9N2_EX_5_CME_SCOM_VCCR_PPE                                  = 0x10B020680ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VCCR_SCOM                                 = 0x1201242Cull;

static const uint64_t P9N2_EX_6_CME_SCOM_VCCR_PPE                                  = 0x10C010680ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VCCR_SCOM                                 = 0x1301202Cull;

static const uint64_t P9N2_EX_7_CME_SCOM_VCCR_PPE                                  = 0x10C020680ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VCCR_SCOM                                 = 0x1301242Cull;

static const uint64_t P9N2_EX_8_CME_SCOM_VCCR_PPE                                  = 0x10D010680ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VCCR_SCOM                                 = 0x1401202Cull;

static const uint64_t P9N2_EX_9_CME_SCOM_VCCR_PPE                                  = 0x10D020680ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VCCR_SCOM                                 = 0x1401242Cull;

static const uint64_t P9N2_EX_10_CME_SCOM_VCCR_PPE                                 = 0x10E010680ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VCCR_SCOM                                = 0x1501202Cull;

static const uint64_t P9N2_EX_11_CME_SCOM_VCCR_PPE                                 = 0x10E020680ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VCCR_SCOM                                = 0x1501242Cull;


static const uint64_t P9N2_EQ_CME_SCOM_VCTR                                        = 0x10012039ull;
//DUPS: 10012039,
static const uint64_t P9N2_EQ_0_CME_SCOM_VCTR                                      = 0x10012039ull;
//DUPS: 10012039,
static const uint64_t P9N2_EQ_1_CME_SCOM_VCTR                                      = 0x11012039ull;
//DUPS: 11012039,
static const uint64_t P9N2_EQ_2_CME_SCOM_VCTR                                      = 0x12012039ull;
//DUPS: 12012039,
static const uint64_t P9N2_EQ_3_CME_SCOM_VCTR                                      = 0x13012039ull;
//DUPS: 13012039,
static const uint64_t P9N2_EQ_4_CME_SCOM_VCTR                                      = 0x14012039ull;
//DUPS: 14012039,
static const uint64_t P9N2_EQ_5_CME_SCOM_VCTR                                      = 0x15012039ull;
//DUPS: 15012039,
static const uint64_t P9N2_EX_CME_SCOM_VCTR                                        = 0x10012039ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VCTR                                      = 0x10012039ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VCTR                                      = 0x10012439ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VCTR                                      = 0x11012039ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VCTR                                      = 0x11012439ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VCTR                                      = 0x12012039ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VCTR                                      = 0x12012439ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VCTR                                      = 0x13012039ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VCTR                                      = 0x13012439ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VCTR                                      = 0x14012039ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VCTR                                      = 0x14012439ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VCTR                                     = 0x15012039ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VCTR                                     = 0x15012439ull;


static const uint64_t P9N2_EQ_CME_SCOM_VDCR                                        = 0x10012035ull;
//DUPS: 10012035,
static const uint64_t P9N2_EQ_0_CME_SCOM_VDCR                                      = 0x10012035ull;
//DUPS: 10012035,
static const uint64_t P9N2_EQ_1_CME_SCOM_VDCR                                      = 0x11012035ull;
//DUPS: 11012035,
static const uint64_t P9N2_EQ_2_CME_SCOM_VDCR                                      = 0x12012035ull;
//DUPS: 12012035,
static const uint64_t P9N2_EQ_3_CME_SCOM_VDCR                                      = 0x13012035ull;
//DUPS: 13012035,
static const uint64_t P9N2_EQ_4_CME_SCOM_VDCR                                      = 0x14012035ull;
//DUPS: 14012035,
static const uint64_t P9N2_EQ_5_CME_SCOM_VDCR                                      = 0x15012035ull;
//DUPS: 15012035,
static const uint64_t P9N2_EX_CME_SCOM_VDCR_PPE                                    = 0x109010600ull;

static const uint64_t P9N2_EX_CME_SCOM_VDCR_SCOM                                   = 0x10012035ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VDCR_PPE                                  = 0x109010600ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VDCR_SCOM                                 = 0x10012035ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VDCR_PPE                                  = 0x109020600ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VDCR_SCOM                                 = 0x10012435ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VDCR_PPE                                  = 0x10A010600ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VDCR_SCOM                                 = 0x11012035ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VDCR_PPE                                  = 0x10A020600ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VDCR_SCOM                                 = 0x11012435ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VDCR_PPE                                  = 0x10B010600ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VDCR_SCOM                                 = 0x12012035ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VDCR_PPE                                  = 0x10B020600ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VDCR_SCOM                                 = 0x12012435ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VDCR_PPE                                  = 0x10C010600ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VDCR_SCOM                                 = 0x13012035ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VDCR_PPE                                  = 0x10C020600ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VDCR_SCOM                                 = 0x13012435ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VDCR_PPE                                  = 0x10D010600ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VDCR_SCOM                                 = 0x14012035ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VDCR_PPE                                  = 0x10D020600ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VDCR_SCOM                                 = 0x14012435ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VDCR_PPE                                 = 0x10E010600ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VDCR_SCOM                                = 0x15012035ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VDCR_PPE                                 = 0x10E020600ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VDCR_SCOM                                = 0x15012435ull;


static const uint64_t P9N2_EQ_CME_SCOM_VDSR                                        = 0x10012037ull;
//DUPS: 10012037,
static const uint64_t P9N2_EQ_0_CME_SCOM_VDSR                                      = 0x10012037ull;
//DUPS: 10012037,
static const uint64_t P9N2_EQ_1_CME_SCOM_VDSR                                      = 0x11012037ull;
//DUPS: 11012037,
static const uint64_t P9N2_EQ_2_CME_SCOM_VDSR                                      = 0x12012037ull;
//DUPS: 12012037,
static const uint64_t P9N2_EQ_3_CME_SCOM_VDSR                                      = 0x13012037ull;
//DUPS: 13012037,
static const uint64_t P9N2_EQ_4_CME_SCOM_VDSR                                      = 0x14012037ull;
//DUPS: 14012037,
static const uint64_t P9N2_EQ_5_CME_SCOM_VDSR                                      = 0x15012037ull;
//DUPS: 15012037,
static const uint64_t P9N2_EX_CME_SCOM_VDSR_PPE                                    = 0x109010640ull;

static const uint64_t P9N2_EX_CME_SCOM_VDSR_SCOM                                   = 0x10012037ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VDSR_PPE                                  = 0x109010640ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VDSR_SCOM                                 = 0x10012037ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VDSR_PPE                                  = 0x109020640ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VDSR_SCOM                                 = 0x10012437ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VDSR_PPE                                  = 0x10A010640ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VDSR_SCOM                                 = 0x11012037ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VDSR_PPE                                  = 0x10A020640ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VDSR_SCOM                                 = 0x11012437ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VDSR_PPE                                  = 0x10B010640ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VDSR_SCOM                                 = 0x12012037ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VDSR_PPE                                  = 0x10B020640ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VDSR_SCOM                                 = 0x12012437ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VDSR_PPE                                  = 0x10C010640ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VDSR_SCOM                                 = 0x13012037ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VDSR_PPE                                  = 0x10C020640ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VDSR_SCOM                                 = 0x13012437ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VDSR_PPE                                  = 0x10D010640ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VDSR_SCOM                                 = 0x14012037ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VDSR_PPE                                  = 0x10D020640ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VDSR_SCOM                                 = 0x14012437ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VDSR_PPE                                 = 0x10E010640ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VDSR_SCOM                                = 0x15012037ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VDSR_PPE                                 = 0x10E020640ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VDSR_SCOM                                = 0x15012437ull;


static const uint64_t P9N2_EQ_CME_SCOM_VECR                                        = 0x10012038ull;
//DUPS: 10012038,
static const uint64_t P9N2_EQ_0_CME_SCOM_VECR                                      = 0x10012038ull;
//DUPS: 10012038,
static const uint64_t P9N2_EQ_1_CME_SCOM_VECR                                      = 0x11012038ull;
//DUPS: 11012038,
static const uint64_t P9N2_EQ_2_CME_SCOM_VECR                                      = 0x12012038ull;
//DUPS: 12012038,
static const uint64_t P9N2_EQ_3_CME_SCOM_VECR                                      = 0x13012038ull;
//DUPS: 13012038,
static const uint64_t P9N2_EQ_4_CME_SCOM_VECR                                      = 0x14012038ull;
//DUPS: 14012038,
static const uint64_t P9N2_EQ_5_CME_SCOM_VECR                                      = 0x15012038ull;
//DUPS: 15012038,
static const uint64_t P9N2_EX_CME_SCOM_VECR_PPE                                    = 0x109010660ull;

static const uint64_t P9N2_EX_CME_SCOM_VECR_SCOM                                   = 0x10012038ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VECR_PPE                                  = 0x109010660ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VECR_SCOM                                 = 0x10012038ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VECR_PPE                                  = 0x109020660ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VECR_SCOM                                 = 0x10012438ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VECR_PPE                                  = 0x10A010660ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VECR_SCOM                                 = 0x11012038ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VECR_PPE                                  = 0x10A020660ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VECR_SCOM                                 = 0x11012438ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VECR_PPE                                  = 0x10B010660ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VECR_SCOM                                 = 0x12012038ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VECR_PPE                                  = 0x10B020660ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VECR_SCOM                                 = 0x12012438ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VECR_PPE                                  = 0x10C010660ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VECR_SCOM                                 = 0x13012038ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VECR_PPE                                  = 0x10C020660ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VECR_SCOM                                 = 0x13012438ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VECR_PPE                                  = 0x10D010660ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VECR_SCOM                                 = 0x14012038ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VECR_PPE                                  = 0x10D020660ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VECR_SCOM                                 = 0x14012438ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VECR_PPE                                 = 0x10E010660ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VECR_SCOM                                = 0x15012038ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VECR_PPE                                 = 0x10E020660ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VECR_SCOM                                = 0x15012438ull;


static const uint64_t P9N2_EQ_CME_SCOM_VNCR                                        = 0x10012036ull;
//DUPS: 10012036,
static const uint64_t P9N2_EQ_0_CME_SCOM_VNCR                                      = 0x10012036ull;
//DUPS: 10012036,
static const uint64_t P9N2_EQ_1_CME_SCOM_VNCR                                      = 0x11012036ull;
//DUPS: 11012036,
static const uint64_t P9N2_EQ_2_CME_SCOM_VNCR                                      = 0x12012036ull;
//DUPS: 12012036,
static const uint64_t P9N2_EQ_3_CME_SCOM_VNCR                                      = 0x13012036ull;
//DUPS: 13012036,
static const uint64_t P9N2_EQ_4_CME_SCOM_VNCR                                      = 0x14012036ull;
//DUPS: 14012036,
static const uint64_t P9N2_EQ_5_CME_SCOM_VNCR                                      = 0x15012036ull;
//DUPS: 15012036,
static const uint64_t P9N2_EX_CME_SCOM_VNCR_PPE                                    = 0x109010620ull;

static const uint64_t P9N2_EX_CME_SCOM_VNCR_SCOM                                   = 0x10012036ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VNCR_PPE                                  = 0x109010620ull;

static const uint64_t P9N2_EX_0_CME_SCOM_VNCR_SCOM                                 = 0x10012036ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VNCR_PPE                                  = 0x109020620ull;

static const uint64_t P9N2_EX_1_CME_SCOM_VNCR_SCOM                                 = 0x10012436ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VNCR_PPE                                  = 0x10A010620ull;

static const uint64_t P9N2_EX_2_CME_SCOM_VNCR_SCOM                                 = 0x11012036ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VNCR_PPE                                  = 0x10A020620ull;

static const uint64_t P9N2_EX_3_CME_SCOM_VNCR_SCOM                                 = 0x11012436ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VNCR_PPE                                  = 0x10B010620ull;

static const uint64_t P9N2_EX_4_CME_SCOM_VNCR_SCOM                                 = 0x12012036ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VNCR_PPE                                  = 0x10B020620ull;

static const uint64_t P9N2_EX_5_CME_SCOM_VNCR_SCOM                                 = 0x12012436ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VNCR_PPE                                  = 0x10C010620ull;

static const uint64_t P9N2_EX_6_CME_SCOM_VNCR_SCOM                                 = 0x13012036ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VNCR_PPE                                  = 0x10C020620ull;

static const uint64_t P9N2_EX_7_CME_SCOM_VNCR_SCOM                                 = 0x13012436ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VNCR_PPE                                  = 0x10D010620ull;

static const uint64_t P9N2_EX_8_CME_SCOM_VNCR_SCOM                                 = 0x14012036ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VNCR_PPE                                  = 0x10D020620ull;

static const uint64_t P9N2_EX_9_CME_SCOM_VNCR_SCOM                                 = 0x14012436ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VNCR_PPE                                 = 0x10E010620ull;

static const uint64_t P9N2_EX_10_CME_SCOM_VNCR_SCOM                                = 0x15012036ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VNCR_PPE                                 = 0x10E020620ull;

static const uint64_t P9N2_EX_11_CME_SCOM_VNCR_SCOM                                = 0x15012436ull;


static const uint64_t P9N2_EQ_CME_SCOM_XIPCBMD0                                    = 0x1001201Cull;
//DUPS: 1001201C,
static const uint64_t P9N2_EQ_0_CME_SCOM_XIPCBMD0                                  = 0x1001201Cull;
//DUPS: 1001201C,
static const uint64_t P9N2_EQ_1_CME_SCOM_XIPCBMD0                                  = 0x1101201Cull;
//DUPS: 1101201C,
static const uint64_t P9N2_EQ_2_CME_SCOM_XIPCBMD0                                  = 0x1201201Cull;
//DUPS: 1201201C,
static const uint64_t P9N2_EQ_3_CME_SCOM_XIPCBMD0                                  = 0x1301201Cull;
//DUPS: 1301201C,
static const uint64_t P9N2_EQ_4_CME_SCOM_XIPCBMD0                                  = 0x1401201Cull;
//DUPS: 1401201C,
static const uint64_t P9N2_EQ_5_CME_SCOM_XIPCBMD0                                  = 0x1501201Cull;
//DUPS: 1501201C,
static const uint64_t P9N2_EX_CME_SCOM_XIPCBMD0_PPE                                = 0x109010580ull;

static const uint64_t P9N2_EX_CME_SCOM_XIPCBMD0_SCOM                               = 0x1001201Cull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMD0_PPE                              = 0x109010580ull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMD0_SCOM                             = 0x1001201Cull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMD0_PPE                              = 0x109020580ull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMD0_SCOM                             = 0x1001241Cull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMD0_PPE                              = 0x10A010580ull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMD0_SCOM                             = 0x1101201Cull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMD0_PPE                              = 0x10A020580ull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMD0_SCOM                             = 0x1101241Cull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMD0_PPE                              = 0x10B010580ull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMD0_SCOM                             = 0x1201201Cull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMD0_PPE                              = 0x10B020580ull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMD0_SCOM                             = 0x1201241Cull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMD0_PPE                              = 0x10C010580ull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMD0_SCOM                             = 0x1301201Cull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMD0_PPE                              = 0x10C020580ull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMD0_SCOM                             = 0x1301241Cull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMD0_PPE                              = 0x10D010580ull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMD0_SCOM                             = 0x1401201Cull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMD0_PPE                              = 0x10D020580ull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMD0_SCOM                             = 0x1401241Cull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMD0_PPE                             = 0x10E010580ull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMD0_SCOM                            = 0x1501201Cull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMD0_PPE                             = 0x10E020580ull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMD0_SCOM                            = 0x1501241Cull;


static const uint64_t P9N2_EQ_CME_SCOM_XIPCBMD1                                    = 0x1001201Dull;
//DUPS: 1001201D,
static const uint64_t P9N2_EQ_0_CME_SCOM_XIPCBMD1                                  = 0x1001201Dull;
//DUPS: 1001201D,
static const uint64_t P9N2_EQ_1_CME_SCOM_XIPCBMD1                                  = 0x1101201Dull;
//DUPS: 1101201D,
static const uint64_t P9N2_EQ_2_CME_SCOM_XIPCBMD1                                  = 0x1201201Dull;
//DUPS: 1201201D,
static const uint64_t P9N2_EQ_3_CME_SCOM_XIPCBMD1                                  = 0x1301201Dull;
//DUPS: 1301201D,
static const uint64_t P9N2_EQ_4_CME_SCOM_XIPCBMD1                                  = 0x1401201Dull;
//DUPS: 1401201D,
static const uint64_t P9N2_EQ_5_CME_SCOM_XIPCBMD1                                  = 0x1501201Dull;
//DUPS: 1501201D,
static const uint64_t P9N2_EX_CME_SCOM_XIPCBMD1_PPE                                = 0x1090105A0ull;

static const uint64_t P9N2_EX_CME_SCOM_XIPCBMD1_SCOM                               = 0x1001201Dull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMD1_PPE                              = 0x1090105A0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMD1_SCOM                             = 0x1001201Dull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMD1_PPE                              = 0x1090205A0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMD1_SCOM                             = 0x1001241Dull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMD1_PPE                              = 0x10A0105A0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMD1_SCOM                             = 0x1101201Dull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMD1_PPE                              = 0x10A0205A0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMD1_SCOM                             = 0x1101241Dull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMD1_PPE                              = 0x10B0105A0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMD1_SCOM                             = 0x1201201Dull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMD1_PPE                              = 0x10B0205A0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMD1_SCOM                             = 0x1201241Dull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMD1_PPE                              = 0x10C0105A0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMD1_SCOM                             = 0x1301201Dull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMD1_PPE                              = 0x10C0205A0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMD1_SCOM                             = 0x1301241Dull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMD1_PPE                              = 0x10D0105A0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMD1_SCOM                             = 0x1401201Dull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMD1_PPE                              = 0x10D0205A0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMD1_SCOM                             = 0x1401241Dull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMD1_PPE                             = 0x10E0105A0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMD1_SCOM                            = 0x1501201Dull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMD1_PPE                             = 0x10E0205A0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMD1_SCOM                            = 0x1501241Dull;


static const uint64_t P9N2_EQ_CME_SCOM_XIPCBMI0                                    = 0x1001201Eull;
//DUPS: 1001201E,
static const uint64_t P9N2_EQ_0_CME_SCOM_XIPCBMI0                                  = 0x1001201Eull;
//DUPS: 1001201E,
static const uint64_t P9N2_EQ_1_CME_SCOM_XIPCBMI0                                  = 0x1101201Eull;
//DUPS: 1101201E,
static const uint64_t P9N2_EQ_2_CME_SCOM_XIPCBMI0                                  = 0x1201201Eull;
//DUPS: 1201201E,
static const uint64_t P9N2_EQ_3_CME_SCOM_XIPCBMI0                                  = 0x1301201Eull;
//DUPS: 1301201E,
static const uint64_t P9N2_EQ_4_CME_SCOM_XIPCBMI0                                  = 0x1401201Eull;
//DUPS: 1401201E,
static const uint64_t P9N2_EQ_5_CME_SCOM_XIPCBMI0                                  = 0x1501201Eull;
//DUPS: 1501201E,
static const uint64_t P9N2_EX_CME_SCOM_XIPCBMI0_PPE                                = 0x1090105C0ull;

static const uint64_t P9N2_EX_CME_SCOM_XIPCBMI0_SCOM                               = 0x1001201Eull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMI0_PPE                              = 0x1090105C0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMI0_SCOM                             = 0x1001201Eull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMI0_PPE                              = 0x1090205C0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMI0_SCOM                             = 0x1001241Eull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMI0_PPE                              = 0x10A0105C0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMI0_SCOM                             = 0x1101201Eull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMI0_PPE                              = 0x10A0205C0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMI0_SCOM                             = 0x1101241Eull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMI0_PPE                              = 0x10B0105C0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMI0_SCOM                             = 0x1201201Eull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMI0_PPE                              = 0x10B0205C0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMI0_SCOM                             = 0x1201241Eull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMI0_PPE                              = 0x10C0105C0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMI0_SCOM                             = 0x1301201Eull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMI0_PPE                              = 0x10C0205C0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMI0_SCOM                             = 0x1301241Eull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMI0_PPE                              = 0x10D0105C0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMI0_SCOM                             = 0x1401201Eull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMI0_PPE                              = 0x10D0205C0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMI0_SCOM                             = 0x1401241Eull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMI0_PPE                             = 0x10E0105C0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMI0_SCOM                            = 0x1501201Eull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMI0_PPE                             = 0x10E0205C0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMI0_SCOM                            = 0x1501241Eull;


static const uint64_t P9N2_EQ_CME_SCOM_XIPCBMI1                                    = 0x1001201Full;
//DUPS: 1001201F,
static const uint64_t P9N2_EQ_0_CME_SCOM_XIPCBMI1                                  = 0x1001201Full;
//DUPS: 1001201F,
static const uint64_t P9N2_EQ_1_CME_SCOM_XIPCBMI1                                  = 0x1101201Full;
//DUPS: 1101201F,
static const uint64_t P9N2_EQ_2_CME_SCOM_XIPCBMI1                                  = 0x1201201Full;
//DUPS: 1201201F,
static const uint64_t P9N2_EQ_3_CME_SCOM_XIPCBMI1                                  = 0x1301201Full;
//DUPS: 1301201F,
static const uint64_t P9N2_EQ_4_CME_SCOM_XIPCBMI1                                  = 0x1401201Full;
//DUPS: 1401201F,
static const uint64_t P9N2_EQ_5_CME_SCOM_XIPCBMI1                                  = 0x1501201Full;
//DUPS: 1501201F,
static const uint64_t P9N2_EX_CME_SCOM_XIPCBMI1_PPE                                = 0x1090105E0ull;

static const uint64_t P9N2_EX_CME_SCOM_XIPCBMI1_SCOM                               = 0x1001201Full;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMI1_PPE                              = 0x1090105E0ull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBMI1_SCOM                             = 0x1001201Full;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMI1_PPE                              = 0x1090205E0ull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBMI1_SCOM                             = 0x1001241Full;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMI1_PPE                              = 0x10A0105E0ull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBMI1_SCOM                             = 0x1101201Full;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMI1_PPE                              = 0x10A0205E0ull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBMI1_SCOM                             = 0x1101241Full;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMI1_PPE                              = 0x10B0105E0ull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBMI1_SCOM                             = 0x1201201Full;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMI1_PPE                              = 0x10B0205E0ull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBMI1_SCOM                             = 0x1201241Full;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMI1_PPE                              = 0x10C0105E0ull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBMI1_SCOM                             = 0x1301201Full;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMI1_PPE                              = 0x10C0205E0ull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBMI1_SCOM                             = 0x1301241Full;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMI1_PPE                              = 0x10D0105E0ull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBMI1_SCOM                             = 0x1401201Full;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMI1_PPE                              = 0x10D0205E0ull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBMI1_SCOM                             = 0x1401241Full;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMI1_PPE                             = 0x10E0105E0ull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBMI1_SCOM                            = 0x1501201Full;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMI1_PPE                             = 0x10E0205E0ull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBMI1_SCOM                            = 0x1501241Full;


static const uint64_t P9N2_EQ_CME_SCOM_XIPCBQ0                                     = 0x1001201Aull;
//DUPS: 1001201A,
static const uint64_t P9N2_EQ_0_CME_SCOM_XIPCBQ0                                   = 0x1001201Aull;
//DUPS: 1001201A,
static const uint64_t P9N2_EQ_1_CME_SCOM_XIPCBQ0                                   = 0x1101201Aull;
//DUPS: 1101201A,
static const uint64_t P9N2_EQ_2_CME_SCOM_XIPCBQ0                                   = 0x1201201Aull;
//DUPS: 1201201A,
static const uint64_t P9N2_EQ_3_CME_SCOM_XIPCBQ0                                   = 0x1301201Aull;
//DUPS: 1301201A,
static const uint64_t P9N2_EQ_4_CME_SCOM_XIPCBQ0                                   = 0x1401201Aull;
//DUPS: 1401201A,
static const uint64_t P9N2_EQ_5_CME_SCOM_XIPCBQ0                                   = 0x1501201Aull;
//DUPS: 1501201A,
static const uint64_t P9N2_EX_CME_SCOM_XIPCBQ0                                     = 0x1001201Aull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBQ0                                   = 0x1001201Aull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBQ0                                   = 0x1001241Aull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBQ0                                   = 0x1101201Aull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBQ0                                   = 0x1101241Aull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBQ0                                   = 0x1201201Aull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBQ0                                   = 0x1201241Aull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBQ0                                   = 0x1301201Aull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBQ0                                   = 0x1301241Aull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBQ0                                   = 0x1401201Aull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBQ0                                   = 0x1401241Aull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBQ0                                  = 0x1501201Aull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBQ0                                  = 0x1501241Aull;


static const uint64_t P9N2_EQ_CME_SCOM_XIPCBQ1                                     = 0x1001201Bull;
//DUPS: 1001201B,
static const uint64_t P9N2_EQ_0_CME_SCOM_XIPCBQ1                                   = 0x1001201Bull;
//DUPS: 1001201B,
static const uint64_t P9N2_EQ_1_CME_SCOM_XIPCBQ1                                   = 0x1101201Bull;
//DUPS: 1101201B,
static const uint64_t P9N2_EQ_2_CME_SCOM_XIPCBQ1                                   = 0x1201201Bull;
//DUPS: 1201201B,
static const uint64_t P9N2_EQ_3_CME_SCOM_XIPCBQ1                                   = 0x1301201Bull;
//DUPS: 1301201B,
static const uint64_t P9N2_EQ_4_CME_SCOM_XIPCBQ1                                   = 0x1401201Bull;
//DUPS: 1401201B,
static const uint64_t P9N2_EQ_5_CME_SCOM_XIPCBQ1                                   = 0x1501201Bull;
//DUPS: 1501201B,
static const uint64_t P9N2_EX_CME_SCOM_XIPCBQ1                                     = 0x1001201Bull;

static const uint64_t P9N2_EX_0_CME_SCOM_XIPCBQ1                                   = 0x1001201Bull;

static const uint64_t P9N2_EX_1_CME_SCOM_XIPCBQ1                                   = 0x1001241Bull;

static const uint64_t P9N2_EX_2_CME_SCOM_XIPCBQ1                                   = 0x1101201Bull;

static const uint64_t P9N2_EX_3_CME_SCOM_XIPCBQ1                                   = 0x1101241Bull;

static const uint64_t P9N2_EX_4_CME_SCOM_XIPCBQ1                                   = 0x1201201Bull;

static const uint64_t P9N2_EX_5_CME_SCOM_XIPCBQ1                                   = 0x1201241Bull;

static const uint64_t P9N2_EX_6_CME_SCOM_XIPCBQ1                                   = 0x1301201Bull;

static const uint64_t P9N2_EX_7_CME_SCOM_XIPCBQ1                                   = 0x1301241Bull;

static const uint64_t P9N2_EX_8_CME_SCOM_XIPCBQ1                                   = 0x1401201Bull;

static const uint64_t P9N2_EX_9_CME_SCOM_XIPCBQ1                                   = 0x1401241Bull;

static const uint64_t P9N2_EX_10_CME_SCOM_XIPCBQ1                                  = 0x1501201Bull;

static const uint64_t P9N2_EX_11_CME_SCOM_XIPCBQ1                                  = 0x1501241Bull;


static const uint64_t P9N2_EQ_CME_SCOM_XISIB                                       = 0x10012016ull;
//DUPS: 10012016,
static const uint64_t P9N2_EQ_0_CME_SCOM_XISIB                                     = 0x10012016ull;
//DUPS: 10012016,
static const uint64_t P9N2_EQ_1_CME_SCOM_XISIB                                     = 0x11012016ull;
//DUPS: 11012016,
static const uint64_t P9N2_EQ_2_CME_SCOM_XISIB                                     = 0x12012016ull;
//DUPS: 12012016,
static const uint64_t P9N2_EQ_3_CME_SCOM_XISIB                                     = 0x13012016ull;
//DUPS: 13012016,
static const uint64_t P9N2_EQ_4_CME_SCOM_XISIB                                     = 0x14012016ull;
//DUPS: 14012016,
static const uint64_t P9N2_EQ_5_CME_SCOM_XISIB                                     = 0x15012016ull;
//DUPS: 15012016,
static const uint64_t P9N2_EX_CME_SCOM_XISIB                                       = 0x10012016ull;

static const uint64_t P9N2_EX_0_CME_SCOM_XISIB                                     = 0x10012016ull;

static const uint64_t P9N2_EX_1_CME_SCOM_XISIB                                     = 0x10012416ull;

static const uint64_t P9N2_EX_2_CME_SCOM_XISIB                                     = 0x11012016ull;

static const uint64_t P9N2_EX_3_CME_SCOM_XISIB                                     = 0x11012416ull;

static const uint64_t P9N2_EX_4_CME_SCOM_XISIB                                     = 0x12012016ull;

static const uint64_t P9N2_EX_5_CME_SCOM_XISIB                                     = 0x12012416ull;

static const uint64_t P9N2_EX_6_CME_SCOM_XISIB                                     = 0x13012016ull;

static const uint64_t P9N2_EX_7_CME_SCOM_XISIB                                     = 0x13012416ull;

static const uint64_t P9N2_EX_8_CME_SCOM_XISIB                                     = 0x14012016ull;

static const uint64_t P9N2_EX_9_CME_SCOM_XISIB                                     = 0x14012416ull;

static const uint64_t P9N2_EX_10_CME_SCOM_XISIB                                    = 0x15012016ull;

static const uint64_t P9N2_EX_11_CME_SCOM_XISIB                                    = 0x15012416ull;


static const uint64_t P9N2_C_CONTROL_REG                                           = 0x20050012ull;

static const uint64_t P9N2_C_0_CONTROL_REG                                         = 0x20050012ull;

static const uint64_t P9N2_C_1_CONTROL_REG                                         = 0x21050012ull;

static const uint64_t P9N2_C_2_CONTROL_REG                                         = 0x22050012ull;

static const uint64_t P9N2_C_3_CONTROL_REG                                         = 0x23050012ull;

static const uint64_t P9N2_C_4_CONTROL_REG                                         = 0x24050012ull;

static const uint64_t P9N2_C_5_CONTROL_REG                                         = 0x25050012ull;

static const uint64_t P9N2_C_6_CONTROL_REG                                         = 0x26050012ull;

static const uint64_t P9N2_C_7_CONTROL_REG                                         = 0x27050012ull;

static const uint64_t P9N2_C_8_CONTROL_REG                                         = 0x28050012ull;

static const uint64_t P9N2_C_9_CONTROL_REG                                         = 0x29050012ull;

static const uint64_t P9N2_C_10_CONTROL_REG                                        = 0x2A050012ull;

static const uint64_t P9N2_C_11_CONTROL_REG                                        = 0x2B050012ull;

static const uint64_t P9N2_C_12_CONTROL_REG                                        = 0x2C050012ull;

static const uint64_t P9N2_C_13_CONTROL_REG                                        = 0x2D050012ull;

static const uint64_t P9N2_C_14_CONTROL_REG                                        = 0x2E050012ull;

static const uint64_t P9N2_C_15_CONTROL_REG                                        = 0x2F050012ull;

static const uint64_t P9N2_C_16_CONTROL_REG                                        = 0x30050012ull;

static const uint64_t P9N2_C_17_CONTROL_REG                                        = 0x31050012ull;

static const uint64_t P9N2_C_18_CONTROL_REG                                        = 0x32050012ull;

static const uint64_t P9N2_C_19_CONTROL_REG                                        = 0x33050012ull;

static const uint64_t P9N2_C_20_CONTROL_REG                                        = 0x34050012ull;

static const uint64_t P9N2_C_21_CONTROL_REG                                        = 0x35050012ull;

static const uint64_t P9N2_C_22_CONTROL_REG                                        = 0x36050012ull;

static const uint64_t P9N2_C_23_CONTROL_REG                                        = 0x37050012ull;

static const uint64_t P9N2_EQ_CONTROL_REG                                          = 0x10050012ull;

static const uint64_t P9N2_EQ_0_CONTROL_REG                                        = 0x10050012ull;

static const uint64_t P9N2_EQ_1_CONTROL_REG                                        = 0x11050012ull;

static const uint64_t P9N2_EQ_2_CONTROL_REG                                        = 0x12050012ull;

static const uint64_t P9N2_EQ_3_CONTROL_REG                                        = 0x13050012ull;

static const uint64_t P9N2_EQ_4_CONTROL_REG                                        = 0x14050012ull;

static const uint64_t P9N2_EQ_5_CONTROL_REG                                        = 0x15050012ull;

static const uint64_t P9N2_EX_CONTROL_REG                                          = 0x20050012ull;
//DUPS: 21050012,
static const uint64_t P9N2_EX_0_CONTROL_REG                                        = 0x20050012ull;
//DUPS: 21050012,
static const uint64_t P9N2_EX_1_CONTROL_REG                                        = 0x22050012ull;
//DUPS: 23050012,
static const uint64_t P9N2_EX_2_CONTROL_REG                                        = 0x24050012ull;
//DUPS: 25050012,
static const uint64_t P9N2_EX_3_CONTROL_REG                                        = 0x26050012ull;
//DUPS: 27050012,
static const uint64_t P9N2_EX_4_CONTROL_REG                                        = 0x28050012ull;
//DUPS: 29050012,
static const uint64_t P9N2_EX_5_CONTROL_REG                                        = 0x2A050012ull;
//DUPS: 2B050012,
static const uint64_t P9N2_EX_6_CONTROL_REG                                        = 0x2C050012ull;
//DUPS: 2D050012,
static const uint64_t P9N2_EX_7_CONTROL_REG                                        = 0x2F050012ull;
//DUPS: 2F050012,
static const uint64_t P9N2_EX_8_CONTROL_REG                                        = 0x30050012ull;
//DUPS: 31050012,
static const uint64_t P9N2_EX_9_CONTROL_REG                                        = 0x32050012ull;
//DUPS: 33050012,
static const uint64_t P9N2_EX_10_CONTROL_REG                                       = 0x34050012ull;
//DUPS: 35050012,
static const uint64_t P9N2_EX_11_CONTROL_REG                                       = 0x36050012ull;
//DUPS: 37050012,

static const uint64_t P9N2_C_CORE_ACTION0                                          = 0x20010A46ull;

static const uint64_t P9N2_C_0_CORE_ACTION0                                        = 0x20010A46ull;

static const uint64_t P9N2_C_1_CORE_ACTION0                                        = 0x21010A46ull;

static const uint64_t P9N2_C_2_CORE_ACTION0                                        = 0x22010A46ull;

static const uint64_t P9N2_C_3_CORE_ACTION0                                        = 0x23010A46ull;

static const uint64_t P9N2_C_4_CORE_ACTION0                                        = 0x24010A46ull;

static const uint64_t P9N2_C_5_CORE_ACTION0                                        = 0x25010A46ull;

static const uint64_t P9N2_C_6_CORE_ACTION0                                        = 0x26010A46ull;

static const uint64_t P9N2_C_7_CORE_ACTION0                                        = 0x27010A46ull;

static const uint64_t P9N2_C_8_CORE_ACTION0                                        = 0x28010A46ull;

static const uint64_t P9N2_C_9_CORE_ACTION0                                        = 0x29010A46ull;

static const uint64_t P9N2_C_10_CORE_ACTION0                                       = 0x2A010A46ull;

static const uint64_t P9N2_C_11_CORE_ACTION0                                       = 0x2B010A46ull;

static const uint64_t P9N2_C_12_CORE_ACTION0                                       = 0x2C010A46ull;

static const uint64_t P9N2_C_13_CORE_ACTION0                                       = 0x2D010A46ull;

static const uint64_t P9N2_C_14_CORE_ACTION0                                       = 0x2E010A46ull;

static const uint64_t P9N2_C_15_CORE_ACTION0                                       = 0x2F010A46ull;

static const uint64_t P9N2_C_16_CORE_ACTION0                                       = 0x30010A46ull;

static const uint64_t P9N2_C_17_CORE_ACTION0                                       = 0x31010A46ull;

static const uint64_t P9N2_C_18_CORE_ACTION0                                       = 0x32010A46ull;

static const uint64_t P9N2_C_19_CORE_ACTION0                                       = 0x33010A46ull;

static const uint64_t P9N2_C_20_CORE_ACTION0                                       = 0x34010A46ull;

static const uint64_t P9N2_C_21_CORE_ACTION0                                       = 0x35010A46ull;

static const uint64_t P9N2_C_22_CORE_ACTION0                                       = 0x36010A46ull;

static const uint64_t P9N2_C_23_CORE_ACTION0                                       = 0x37010A46ull;

static const uint64_t P9N2_EX_0_L2_CORE_ACTION0                                    = 0x20010A46ull;
//DUPS: 21010A46,
static const uint64_t P9N2_EX_10_L2_CORE_ACTION0                                   = 0x34010A46ull;
//DUPS: 35010A46,
static const uint64_t P9N2_EX_11_L2_CORE_ACTION0                                   = 0x36010A46ull;
//DUPS: 37010A46,
static const uint64_t P9N2_EX_1_L2_CORE_ACTION0                                    = 0x22010A46ull;
//DUPS: 23010A46,
static const uint64_t P9N2_EX_2_L2_CORE_ACTION0                                    = 0x24010A46ull;
//DUPS: 25010A46,
static const uint64_t P9N2_EX_3_L2_CORE_ACTION0                                    = 0x26010A46ull;
//DUPS: 27010A46,
static const uint64_t P9N2_EX_4_L2_CORE_ACTION0                                    = 0x28010A46ull;
//DUPS: 29010A46,
static const uint64_t P9N2_EX_5_L2_CORE_ACTION0                                    = 0x2A010A46ull;
//DUPS: 2B010A46,
static const uint64_t P9N2_EX_6_L2_CORE_ACTION0                                    = 0x2C010A46ull;
//DUPS: 2D010A46,
static const uint64_t P9N2_EX_7_L2_CORE_ACTION0                                    = 0x2F010A46ull;
//DUPS: 2F010A46,
static const uint64_t P9N2_EX_8_L2_CORE_ACTION0                                    = 0x30010A46ull;
//DUPS: 31010A46,
static const uint64_t P9N2_EX_9_L2_CORE_ACTION0                                    = 0x32010A46ull;
//DUPS: 33010A46,
static const uint64_t P9N2_EX_L2_CORE_ACTION0                                      = 0x20010A46ull;
//DUPS: 21010A46,

static const uint64_t P9N2_C_CORE_ACTION1                                          = 0x20010A47ull;

static const uint64_t P9N2_C_0_CORE_ACTION1                                        = 0x20010A47ull;

static const uint64_t P9N2_C_1_CORE_ACTION1                                        = 0x21010A47ull;

static const uint64_t P9N2_C_2_CORE_ACTION1                                        = 0x22010A47ull;

static const uint64_t P9N2_C_3_CORE_ACTION1                                        = 0x23010A47ull;

static const uint64_t P9N2_C_4_CORE_ACTION1                                        = 0x24010A47ull;

static const uint64_t P9N2_C_5_CORE_ACTION1                                        = 0x25010A47ull;

static const uint64_t P9N2_C_6_CORE_ACTION1                                        = 0x26010A47ull;

static const uint64_t P9N2_C_7_CORE_ACTION1                                        = 0x27010A47ull;

static const uint64_t P9N2_C_8_CORE_ACTION1                                        = 0x28010A47ull;

static const uint64_t P9N2_C_9_CORE_ACTION1                                        = 0x29010A47ull;

static const uint64_t P9N2_C_10_CORE_ACTION1                                       = 0x2A010A47ull;

static const uint64_t P9N2_C_11_CORE_ACTION1                                       = 0x2B010A47ull;

static const uint64_t P9N2_C_12_CORE_ACTION1                                       = 0x2C010A47ull;

static const uint64_t P9N2_C_13_CORE_ACTION1                                       = 0x2D010A47ull;

static const uint64_t P9N2_C_14_CORE_ACTION1                                       = 0x2E010A47ull;

static const uint64_t P9N2_C_15_CORE_ACTION1                                       = 0x2F010A47ull;

static const uint64_t P9N2_C_16_CORE_ACTION1                                       = 0x30010A47ull;

static const uint64_t P9N2_C_17_CORE_ACTION1                                       = 0x31010A47ull;

static const uint64_t P9N2_C_18_CORE_ACTION1                                       = 0x32010A47ull;

static const uint64_t P9N2_C_19_CORE_ACTION1                                       = 0x33010A47ull;

static const uint64_t P9N2_C_20_CORE_ACTION1                                       = 0x34010A47ull;

static const uint64_t P9N2_C_21_CORE_ACTION1                                       = 0x35010A47ull;

static const uint64_t P9N2_C_22_CORE_ACTION1                                       = 0x36010A47ull;

static const uint64_t P9N2_C_23_CORE_ACTION1                                       = 0x37010A47ull;

static const uint64_t P9N2_EX_0_L2_CORE_ACTION1                                    = 0x20010A47ull;
//DUPS: 21010A47,
static const uint64_t P9N2_EX_10_L2_CORE_ACTION1                                   = 0x34010A47ull;
//DUPS: 35010A47,
static const uint64_t P9N2_EX_11_L2_CORE_ACTION1                                   = 0x36010A47ull;
//DUPS: 37010A47,
static const uint64_t P9N2_EX_1_L2_CORE_ACTION1                                    = 0x22010A47ull;
//DUPS: 23010A47,
static const uint64_t P9N2_EX_2_L2_CORE_ACTION1                                    = 0x24010A47ull;
//DUPS: 25010A47,
static const uint64_t P9N2_EX_3_L2_CORE_ACTION1                                    = 0x26010A47ull;
//DUPS: 27010A47,
static const uint64_t P9N2_EX_4_L2_CORE_ACTION1                                    = 0x28010A47ull;
//DUPS: 29010A47,
static const uint64_t P9N2_EX_5_L2_CORE_ACTION1                                    = 0x2A010A47ull;
//DUPS: 2B010A47,
static const uint64_t P9N2_EX_6_L2_CORE_ACTION1                                    = 0x2C010A47ull;
//DUPS: 2D010A47,
static const uint64_t P9N2_EX_7_L2_CORE_ACTION1                                    = 0x2F010A47ull;
//DUPS: 2F010A47,
static const uint64_t P9N2_EX_8_L2_CORE_ACTION1                                    = 0x30010A47ull;
//DUPS: 31010A47,
static const uint64_t P9N2_EX_9_L2_CORE_ACTION1                                    = 0x32010A47ull;
//DUPS: 33010A47,
static const uint64_t P9N2_EX_L2_CORE_ACTION1                                      = 0x20010A47ull;
//DUPS: 21010A47,

static const uint64_t P9N2_C_CORE_FIR                                              = 0x20010A40ull;

static const uint64_t P9N2_C_CORE_FIR_AND                                          = 0x20010A41ull;

static const uint64_t P9N2_C_CORE_FIR_OR                                           = 0x20010A42ull;

static const uint64_t P9N2_C_0_CORE_FIR                                            = 0x20010A40ull;

static const uint64_t P9N2_C_0_CORE_FIR_AND                                        = 0x20010A41ull;

static const uint64_t P9N2_C_0_CORE_FIR_OR                                         = 0x20010A42ull;

static const uint64_t P9N2_C_1_CORE_FIR                                            = 0x21010A40ull;

static const uint64_t P9N2_C_1_CORE_FIR_AND                                        = 0x21010A41ull;

static const uint64_t P9N2_C_1_CORE_FIR_OR                                         = 0x21010A42ull;

static const uint64_t P9N2_C_2_CORE_FIR                                            = 0x22010A40ull;

static const uint64_t P9N2_C_2_CORE_FIR_AND                                        = 0x22010A41ull;

static const uint64_t P9N2_C_2_CORE_FIR_OR                                         = 0x22010A42ull;

static const uint64_t P9N2_C_3_CORE_FIR                                            = 0x23010A40ull;

static const uint64_t P9N2_C_3_CORE_FIR_AND                                        = 0x23010A41ull;

static const uint64_t P9N2_C_3_CORE_FIR_OR                                         = 0x23010A42ull;

static const uint64_t P9N2_C_4_CORE_FIR                                            = 0x24010A40ull;

static const uint64_t P9N2_C_4_CORE_FIR_AND                                        = 0x24010A41ull;

static const uint64_t P9N2_C_4_CORE_FIR_OR                                         = 0x24010A42ull;

static const uint64_t P9N2_C_5_CORE_FIR                                            = 0x25010A40ull;

static const uint64_t P9N2_C_5_CORE_FIR_AND                                        = 0x25010A41ull;

static const uint64_t P9N2_C_5_CORE_FIR_OR                                         = 0x25010A42ull;

static const uint64_t P9N2_C_6_CORE_FIR                                            = 0x26010A40ull;

static const uint64_t P9N2_C_6_CORE_FIR_AND                                        = 0x26010A41ull;

static const uint64_t P9N2_C_6_CORE_FIR_OR                                         = 0x26010A42ull;

static const uint64_t P9N2_C_7_CORE_FIR                                            = 0x27010A40ull;

static const uint64_t P9N2_C_7_CORE_FIR_AND                                        = 0x27010A41ull;

static const uint64_t P9N2_C_7_CORE_FIR_OR                                         = 0x27010A42ull;

static const uint64_t P9N2_C_8_CORE_FIR                                            = 0x28010A40ull;

static const uint64_t P9N2_C_8_CORE_FIR_AND                                        = 0x28010A41ull;

static const uint64_t P9N2_C_8_CORE_FIR_OR                                         = 0x28010A42ull;

static const uint64_t P9N2_C_9_CORE_FIR                                            = 0x29010A40ull;

static const uint64_t P9N2_C_9_CORE_FIR_AND                                        = 0x29010A41ull;

static const uint64_t P9N2_C_9_CORE_FIR_OR                                         = 0x29010A42ull;

static const uint64_t P9N2_C_10_CORE_FIR                                           = 0x2A010A40ull;

static const uint64_t P9N2_C_10_CORE_FIR_AND                                       = 0x2A010A41ull;

static const uint64_t P9N2_C_10_CORE_FIR_OR                                        = 0x2A010A42ull;

static const uint64_t P9N2_C_11_CORE_FIR                                           = 0x2B010A40ull;

static const uint64_t P9N2_C_11_CORE_FIR_AND                                       = 0x2B010A41ull;

static const uint64_t P9N2_C_11_CORE_FIR_OR                                        = 0x2B010A42ull;

static const uint64_t P9N2_C_12_CORE_FIR                                           = 0x2C010A40ull;

static const uint64_t P9N2_C_12_CORE_FIR_AND                                       = 0x2C010A41ull;

static const uint64_t P9N2_C_12_CORE_FIR_OR                                        = 0x2C010A42ull;

static const uint64_t P9N2_C_13_CORE_FIR                                           = 0x2D010A40ull;

static const uint64_t P9N2_C_13_CORE_FIR_AND                                       = 0x2D010A41ull;

static const uint64_t P9N2_C_13_CORE_FIR_OR                                        = 0x2D010A42ull;

static const uint64_t P9N2_C_14_CORE_FIR                                           = 0x2E010A40ull;

static const uint64_t P9N2_C_14_CORE_FIR_AND                                       = 0x2E010A41ull;

static const uint64_t P9N2_C_14_CORE_FIR_OR                                        = 0x2E010A42ull;

static const uint64_t P9N2_C_15_CORE_FIR                                           = 0x2F010A40ull;

static const uint64_t P9N2_C_15_CORE_FIR_AND                                       = 0x2F010A41ull;

static const uint64_t P9N2_C_15_CORE_FIR_OR                                        = 0x2F010A42ull;

static const uint64_t P9N2_C_16_CORE_FIR                                           = 0x30010A40ull;

static const uint64_t P9N2_C_16_CORE_FIR_AND                                       = 0x30010A41ull;

static const uint64_t P9N2_C_16_CORE_FIR_OR                                        = 0x30010A42ull;

static const uint64_t P9N2_C_17_CORE_FIR                                           = 0x31010A40ull;

static const uint64_t P9N2_C_17_CORE_FIR_AND                                       = 0x31010A41ull;

static const uint64_t P9N2_C_17_CORE_FIR_OR                                        = 0x31010A42ull;

static const uint64_t P9N2_C_18_CORE_FIR                                           = 0x32010A40ull;

static const uint64_t P9N2_C_18_CORE_FIR_AND                                       = 0x32010A41ull;

static const uint64_t P9N2_C_18_CORE_FIR_OR                                        = 0x32010A42ull;

static const uint64_t P9N2_C_19_CORE_FIR                                           = 0x33010A40ull;

static const uint64_t P9N2_C_19_CORE_FIR_AND                                       = 0x33010A41ull;

static const uint64_t P9N2_C_19_CORE_FIR_OR                                        = 0x33010A42ull;

static const uint64_t P9N2_C_20_CORE_FIR                                           = 0x34010A40ull;

static const uint64_t P9N2_C_20_CORE_FIR_AND                                       = 0x34010A41ull;

static const uint64_t P9N2_C_20_CORE_FIR_OR                                        = 0x34010A42ull;

static const uint64_t P9N2_C_21_CORE_FIR                                           = 0x35010A40ull;

static const uint64_t P9N2_C_21_CORE_FIR_AND                                       = 0x35010A41ull;

static const uint64_t P9N2_C_21_CORE_FIR_OR                                        = 0x35010A42ull;

static const uint64_t P9N2_C_22_CORE_FIR                                           = 0x36010A40ull;

static const uint64_t P9N2_C_22_CORE_FIR_AND                                       = 0x36010A41ull;

static const uint64_t P9N2_C_22_CORE_FIR_OR                                        = 0x36010A42ull;

static const uint64_t P9N2_C_23_CORE_FIR                                           = 0x37010A40ull;

static const uint64_t P9N2_C_23_CORE_FIR_AND                                       = 0x37010A41ull;

static const uint64_t P9N2_C_23_CORE_FIR_OR                                        = 0x37010A42ull;

static const uint64_t P9N2_EX_0_L2_CORE_FIR                                        = 0x20010A40ull;
//DUPS: 21010A40,
static const uint64_t P9N2_EX_0_L2_CORE_FIR_AND                                    = 0x20010A41ull;
//DUPS: 21010A41,
static const uint64_t P9N2_EX_0_L2_CORE_FIR_OR                                     = 0x20010A42ull;
//DUPS: 21010A42,
static const uint64_t P9N2_EX_10_L2_CORE_FIR                                       = 0x34010A40ull;
//DUPS: 35010A40,
static const uint64_t P9N2_EX_10_L2_CORE_FIR_AND                                   = 0x34010A41ull;
//DUPS: 35010A41,
static const uint64_t P9N2_EX_10_L2_CORE_FIR_OR                                    = 0x34010A42ull;
//DUPS: 35010A42,
static const uint64_t P9N2_EX_11_L2_CORE_FIR                                       = 0x36010A40ull;
//DUPS: 37010A40,
static const uint64_t P9N2_EX_11_L2_CORE_FIR_AND                                   = 0x36010A41ull;
//DUPS: 37010A41,
static const uint64_t P9N2_EX_11_L2_CORE_FIR_OR                                    = 0x36010A42ull;
//DUPS: 37010A42,
static const uint64_t P9N2_EX_1_L2_CORE_FIR                                        = 0x22010A40ull;
//DUPS: 23010A40,
static const uint64_t P9N2_EX_1_L2_CORE_FIR_AND                                    = 0x22010A41ull;
//DUPS: 23010A41,
static const uint64_t P9N2_EX_1_L2_CORE_FIR_OR                                     = 0x22010A42ull;
//DUPS: 23010A42,
static const uint64_t P9N2_EX_2_L2_CORE_FIR                                        = 0x24010A40ull;
//DUPS: 25010A40,
static const uint64_t P9N2_EX_2_L2_CORE_FIR_AND                                    = 0x24010A41ull;
//DUPS: 25010A41,
static const uint64_t P9N2_EX_2_L2_CORE_FIR_OR                                     = 0x24010A42ull;
//DUPS: 25010A42,
static const uint64_t P9N2_EX_3_L2_CORE_FIR                                        = 0x26010A40ull;
//DUPS: 27010A40,
static const uint64_t P9N2_EX_3_L2_CORE_FIR_AND                                    = 0x26010A41ull;
//DUPS: 27010A41,
static const uint64_t P9N2_EX_3_L2_CORE_FIR_OR                                     = 0x26010A42ull;
//DUPS: 27010A42,
static const uint64_t P9N2_EX_4_L2_CORE_FIR                                        = 0x28010A40ull;
//DUPS: 29010A40,
static const uint64_t P9N2_EX_4_L2_CORE_FIR_AND                                    = 0x28010A41ull;
//DUPS: 29010A41,
static const uint64_t P9N2_EX_4_L2_CORE_FIR_OR                                     = 0x28010A42ull;
//DUPS: 29010A42,
static const uint64_t P9N2_EX_5_L2_CORE_FIR                                        = 0x2A010A40ull;
//DUPS: 2B010A40,
static const uint64_t P9N2_EX_5_L2_CORE_FIR_AND                                    = 0x2A010A41ull;
//DUPS: 2B010A41,
static const uint64_t P9N2_EX_5_L2_CORE_FIR_OR                                     = 0x2A010A42ull;
//DUPS: 2B010A42,
static const uint64_t P9N2_EX_6_L2_CORE_FIR                                        = 0x2C010A40ull;
//DUPS: 2D010A40,
static const uint64_t P9N2_EX_6_L2_CORE_FIR_AND                                    = 0x2C010A41ull;
//DUPS: 2D010A41,
static const uint64_t P9N2_EX_6_L2_CORE_FIR_OR                                     = 0x2C010A42ull;
//DUPS: 2D010A42,
static const uint64_t P9N2_EX_7_L2_CORE_FIR                                        = 0x2F010A40ull;
//DUPS: 2F010A40,
static const uint64_t P9N2_EX_7_L2_CORE_FIR_AND                                    = 0x2F010A41ull;
//DUPS: 2F010A41,
static const uint64_t P9N2_EX_7_L2_CORE_FIR_OR                                     = 0x2F010A42ull;
//DUPS: 2F010A42,
static const uint64_t P9N2_EX_8_L2_CORE_FIR                                        = 0x30010A40ull;
//DUPS: 31010A40,
static const uint64_t P9N2_EX_8_L2_CORE_FIR_AND                                    = 0x30010A41ull;
//DUPS: 31010A41,
static const uint64_t P9N2_EX_8_L2_CORE_FIR_OR                                     = 0x30010A42ull;
//DUPS: 31010A42,
static const uint64_t P9N2_EX_9_L2_CORE_FIR                                        = 0x32010A40ull;
//DUPS: 33010A40,
static const uint64_t P9N2_EX_9_L2_CORE_FIR_AND                                    = 0x32010A41ull;
//DUPS: 33010A41,
static const uint64_t P9N2_EX_9_L2_CORE_FIR_OR                                     = 0x32010A42ull;
//DUPS: 33010A42,
static const uint64_t P9N2_EX_L2_CORE_FIR                                          = 0x20010A40ull;
//DUPS: 21010A40,
static const uint64_t P9N2_EX_L2_CORE_FIR_AND                                      = 0x20010A41ull;
//DUPS: 21010A41,
static const uint64_t P9N2_EX_L2_CORE_FIR_OR                                       = 0x20010A42ull;
//DUPS: 21010A42,

static const uint64_t P9N2_C_CORE_FIRMASK                                          = 0x20010A43ull;

static const uint64_t P9N2_C_CORE_FIRMASK_AND                                      = 0x20010A44ull;

static const uint64_t P9N2_C_CORE_FIRMASK_OR                                       = 0x20010A45ull;

static const uint64_t P9N2_C_0_CORE_FIRMASK                                        = 0x20010A43ull;

static const uint64_t P9N2_C_0_CORE_FIRMASK_AND                                    = 0x20010A44ull;

static const uint64_t P9N2_C_0_CORE_FIRMASK_OR                                     = 0x20010A45ull;

static const uint64_t P9N2_C_1_CORE_FIRMASK                                        = 0x21010A43ull;

static const uint64_t P9N2_C_1_CORE_FIRMASK_AND                                    = 0x21010A44ull;

static const uint64_t P9N2_C_1_CORE_FIRMASK_OR                                     = 0x21010A45ull;

static const uint64_t P9N2_C_2_CORE_FIRMASK                                        = 0x22010A43ull;

static const uint64_t P9N2_C_2_CORE_FIRMASK_AND                                    = 0x22010A44ull;

static const uint64_t P9N2_C_2_CORE_FIRMASK_OR                                     = 0x22010A45ull;

static const uint64_t P9N2_C_3_CORE_FIRMASK                                        = 0x23010A43ull;

static const uint64_t P9N2_C_3_CORE_FIRMASK_AND                                    = 0x23010A44ull;

static const uint64_t P9N2_C_3_CORE_FIRMASK_OR                                     = 0x23010A45ull;

static const uint64_t P9N2_C_4_CORE_FIRMASK                                        = 0x24010A43ull;

static const uint64_t P9N2_C_4_CORE_FIRMASK_AND                                    = 0x24010A44ull;

static const uint64_t P9N2_C_4_CORE_FIRMASK_OR                                     = 0x24010A45ull;

static const uint64_t P9N2_C_5_CORE_FIRMASK                                        = 0x25010A43ull;

static const uint64_t P9N2_C_5_CORE_FIRMASK_AND                                    = 0x25010A44ull;

static const uint64_t P9N2_C_5_CORE_FIRMASK_OR                                     = 0x25010A45ull;

static const uint64_t P9N2_C_6_CORE_FIRMASK                                        = 0x26010A43ull;

static const uint64_t P9N2_C_6_CORE_FIRMASK_AND                                    = 0x26010A44ull;

static const uint64_t P9N2_C_6_CORE_FIRMASK_OR                                     = 0x26010A45ull;

static const uint64_t P9N2_C_7_CORE_FIRMASK                                        = 0x27010A43ull;

static const uint64_t P9N2_C_7_CORE_FIRMASK_AND                                    = 0x27010A44ull;

static const uint64_t P9N2_C_7_CORE_FIRMASK_OR                                     = 0x27010A45ull;

static const uint64_t P9N2_C_8_CORE_FIRMASK                                        = 0x28010A43ull;

static const uint64_t P9N2_C_8_CORE_FIRMASK_AND                                    = 0x28010A44ull;

static const uint64_t P9N2_C_8_CORE_FIRMASK_OR                                     = 0x28010A45ull;

static const uint64_t P9N2_C_9_CORE_FIRMASK                                        = 0x29010A43ull;

static const uint64_t P9N2_C_9_CORE_FIRMASK_AND                                    = 0x29010A44ull;

static const uint64_t P9N2_C_9_CORE_FIRMASK_OR                                     = 0x29010A45ull;

static const uint64_t P9N2_C_10_CORE_FIRMASK                                       = 0x2A010A43ull;

static const uint64_t P9N2_C_10_CORE_FIRMASK_AND                                   = 0x2A010A44ull;

static const uint64_t P9N2_C_10_CORE_FIRMASK_OR                                    = 0x2A010A45ull;

static const uint64_t P9N2_C_11_CORE_FIRMASK                                       = 0x2B010A43ull;

static const uint64_t P9N2_C_11_CORE_FIRMASK_AND                                   = 0x2B010A44ull;

static const uint64_t P9N2_C_11_CORE_FIRMASK_OR                                    = 0x2B010A45ull;

static const uint64_t P9N2_C_12_CORE_FIRMASK                                       = 0x2C010A43ull;

static const uint64_t P9N2_C_12_CORE_FIRMASK_AND                                   = 0x2C010A44ull;

static const uint64_t P9N2_C_12_CORE_FIRMASK_OR                                    = 0x2C010A45ull;

static const uint64_t P9N2_C_13_CORE_FIRMASK                                       = 0x2D010A43ull;

static const uint64_t P9N2_C_13_CORE_FIRMASK_AND                                   = 0x2D010A44ull;

static const uint64_t P9N2_C_13_CORE_FIRMASK_OR                                    = 0x2D010A45ull;

static const uint64_t P9N2_C_14_CORE_FIRMASK                                       = 0x2E010A43ull;

static const uint64_t P9N2_C_14_CORE_FIRMASK_AND                                   = 0x2E010A44ull;

static const uint64_t P9N2_C_14_CORE_FIRMASK_OR                                    = 0x2E010A45ull;

static const uint64_t P9N2_C_15_CORE_FIRMASK                                       = 0x2F010A43ull;

static const uint64_t P9N2_C_15_CORE_FIRMASK_AND                                   = 0x2F010A44ull;

static const uint64_t P9N2_C_15_CORE_FIRMASK_OR                                    = 0x2F010A45ull;

static const uint64_t P9N2_C_16_CORE_FIRMASK                                       = 0x30010A43ull;

static const uint64_t P9N2_C_16_CORE_FIRMASK_AND                                   = 0x30010A44ull;

static const uint64_t P9N2_C_16_CORE_FIRMASK_OR                                    = 0x30010A45ull;

static const uint64_t P9N2_C_17_CORE_FIRMASK                                       = 0x31010A43ull;

static const uint64_t P9N2_C_17_CORE_FIRMASK_AND                                   = 0x31010A44ull;

static const uint64_t P9N2_C_17_CORE_FIRMASK_OR                                    = 0x31010A45ull;

static const uint64_t P9N2_C_18_CORE_FIRMASK                                       = 0x32010A43ull;

static const uint64_t P9N2_C_18_CORE_FIRMASK_AND                                   = 0x32010A44ull;

static const uint64_t P9N2_C_18_CORE_FIRMASK_OR                                    = 0x32010A45ull;

static const uint64_t P9N2_C_19_CORE_FIRMASK                                       = 0x33010A43ull;

static const uint64_t P9N2_C_19_CORE_FIRMASK_AND                                   = 0x33010A44ull;

static const uint64_t P9N2_C_19_CORE_FIRMASK_OR                                    = 0x33010A45ull;

static const uint64_t P9N2_C_20_CORE_FIRMASK                                       = 0x34010A43ull;

static const uint64_t P9N2_C_20_CORE_FIRMASK_AND                                   = 0x34010A44ull;

static const uint64_t P9N2_C_20_CORE_FIRMASK_OR                                    = 0x34010A45ull;

static const uint64_t P9N2_C_21_CORE_FIRMASK                                       = 0x35010A43ull;

static const uint64_t P9N2_C_21_CORE_FIRMASK_AND                                   = 0x35010A44ull;

static const uint64_t P9N2_C_21_CORE_FIRMASK_OR                                    = 0x35010A45ull;

static const uint64_t P9N2_C_22_CORE_FIRMASK                                       = 0x36010A43ull;

static const uint64_t P9N2_C_22_CORE_FIRMASK_AND                                   = 0x36010A44ull;

static const uint64_t P9N2_C_22_CORE_FIRMASK_OR                                    = 0x36010A45ull;

static const uint64_t P9N2_C_23_CORE_FIRMASK                                       = 0x37010A43ull;

static const uint64_t P9N2_C_23_CORE_FIRMASK_AND                                   = 0x37010A44ull;

static const uint64_t P9N2_C_23_CORE_FIRMASK_OR                                    = 0x37010A45ull;

static const uint64_t P9N2_EX_0_L2_CORE_FIRMASK                                    = 0x20010A43ull;
//DUPS: 21010A43,
static const uint64_t P9N2_EX_0_L2_CORE_FIRMASK_AND                                = 0x20010A44ull;
//DUPS: 21010A44,
static const uint64_t P9N2_EX_0_L2_CORE_FIRMASK_OR                                 = 0x20010A45ull;
//DUPS: 21010A45,
static const uint64_t P9N2_EX_10_L2_CORE_FIRMASK                                   = 0x34010A43ull;
//DUPS: 35010A43,
static const uint64_t P9N2_EX_10_L2_CORE_FIRMASK_AND                               = 0x34010A44ull;
//DUPS: 35010A44,
static const uint64_t P9N2_EX_10_L2_CORE_FIRMASK_OR                                = 0x34010A45ull;
//DUPS: 35010A45,
static const uint64_t P9N2_EX_11_L2_CORE_FIRMASK                                   = 0x36010A43ull;
//DUPS: 37010A43,
static const uint64_t P9N2_EX_11_L2_CORE_FIRMASK_AND                               = 0x36010A44ull;
//DUPS: 37010A44,
static const uint64_t P9N2_EX_11_L2_CORE_FIRMASK_OR                                = 0x36010A45ull;
//DUPS: 37010A45,
static const uint64_t P9N2_EX_1_L2_CORE_FIRMASK                                    = 0x22010A43ull;
//DUPS: 23010A43,
static const uint64_t P9N2_EX_1_L2_CORE_FIRMASK_AND                                = 0x22010A44ull;
//DUPS: 23010A44,
static const uint64_t P9N2_EX_1_L2_CORE_FIRMASK_OR                                 = 0x22010A45ull;
//DUPS: 23010A45,
static const uint64_t P9N2_EX_2_L2_CORE_FIRMASK                                    = 0x24010A43ull;
//DUPS: 25010A43,
static const uint64_t P9N2_EX_2_L2_CORE_FIRMASK_AND                                = 0x24010A44ull;
//DUPS: 25010A44,
static const uint64_t P9N2_EX_2_L2_CORE_FIRMASK_OR                                 = 0x24010A45ull;
//DUPS: 25010A45,
static const uint64_t P9N2_EX_3_L2_CORE_FIRMASK                                    = 0x26010A43ull;
//DUPS: 27010A43,
static const uint64_t P9N2_EX_3_L2_CORE_FIRMASK_AND                                = 0x26010A44ull;
//DUPS: 27010A44,
static const uint64_t P9N2_EX_3_L2_CORE_FIRMASK_OR                                 = 0x26010A45ull;
//DUPS: 27010A45,
static const uint64_t P9N2_EX_4_L2_CORE_FIRMASK                                    = 0x28010A43ull;
//DUPS: 29010A43,
static const uint64_t P9N2_EX_4_L2_CORE_FIRMASK_AND                                = 0x28010A44ull;
//DUPS: 29010A44,
static const uint64_t P9N2_EX_4_L2_CORE_FIRMASK_OR                                 = 0x28010A45ull;
//DUPS: 29010A45,
static const uint64_t P9N2_EX_5_L2_CORE_FIRMASK                                    = 0x2A010A43ull;
//DUPS: 2B010A43,
static const uint64_t P9N2_EX_5_L2_CORE_FIRMASK_AND                                = 0x2A010A44ull;
//DUPS: 2B010A44,
static const uint64_t P9N2_EX_5_L2_CORE_FIRMASK_OR                                 = 0x2A010A45ull;
//DUPS: 2B010A45,
static const uint64_t P9N2_EX_6_L2_CORE_FIRMASK                                    = 0x2C010A43ull;
//DUPS: 2D010A43,
static const uint64_t P9N2_EX_6_L2_CORE_FIRMASK_AND                                = 0x2C010A44ull;
//DUPS: 2D010A44,
static const uint64_t P9N2_EX_6_L2_CORE_FIRMASK_OR                                 = 0x2C010A45ull;
//DUPS: 2D010A45,
static const uint64_t P9N2_EX_7_L2_CORE_FIRMASK                                    = 0x2F010A43ull;
//DUPS: 2F010A43,
static const uint64_t P9N2_EX_7_L2_CORE_FIRMASK_AND                                = 0x2F010A44ull;
//DUPS: 2F010A44,
static const uint64_t P9N2_EX_7_L2_CORE_FIRMASK_OR                                 = 0x2F010A45ull;
//DUPS: 2F010A45,
static const uint64_t P9N2_EX_8_L2_CORE_FIRMASK                                    = 0x30010A43ull;
//DUPS: 31010A43,
static const uint64_t P9N2_EX_8_L2_CORE_FIRMASK_AND                                = 0x30010A44ull;
//DUPS: 31010A44,
static const uint64_t P9N2_EX_8_L2_CORE_FIRMASK_OR                                 = 0x30010A45ull;
//DUPS: 31010A45,
static const uint64_t P9N2_EX_9_L2_CORE_FIRMASK                                    = 0x32010A43ull;
//DUPS: 33010A43,
static const uint64_t P9N2_EX_9_L2_CORE_FIRMASK_AND                                = 0x32010A44ull;
//DUPS: 33010A44,
static const uint64_t P9N2_EX_9_L2_CORE_FIRMASK_OR                                 = 0x32010A45ull;
//DUPS: 33010A45,
static const uint64_t P9N2_EX_L2_CORE_FIRMASK                                      = 0x20010A43ull;
//DUPS: 21010A43,
static const uint64_t P9N2_EX_L2_CORE_FIRMASK_AND                                  = 0x20010A44ull;
//DUPS: 21010A44,
static const uint64_t P9N2_EX_L2_CORE_FIRMASK_OR                                   = 0x20010A45ull;
//DUPS: 21010A45,

static const uint64_t P9N2_C_CORE_FUSES                                            = 0x20010AA7ull;

static const uint64_t P9N2_C_0_CORE_FUSES                                          = 0x20010AA7ull;

static const uint64_t P9N2_C_1_CORE_FUSES                                          = 0x21010AA7ull;

static const uint64_t P9N2_C_2_CORE_FUSES                                          = 0x22010AA7ull;

static const uint64_t P9N2_C_3_CORE_FUSES                                          = 0x23010AA7ull;

static const uint64_t P9N2_C_4_CORE_FUSES                                          = 0x24010AA7ull;

static const uint64_t P9N2_C_5_CORE_FUSES                                          = 0x25010AA7ull;

static const uint64_t P9N2_C_6_CORE_FUSES                                          = 0x26010AA7ull;

static const uint64_t P9N2_C_7_CORE_FUSES                                          = 0x27010AA7ull;

static const uint64_t P9N2_C_8_CORE_FUSES                                          = 0x28010AA7ull;

static const uint64_t P9N2_C_9_CORE_FUSES                                          = 0x29010AA7ull;

static const uint64_t P9N2_C_10_CORE_FUSES                                         = 0x2A010AA7ull;

static const uint64_t P9N2_C_11_CORE_FUSES                                         = 0x2B010AA7ull;

static const uint64_t P9N2_C_12_CORE_FUSES                                         = 0x2C010AA7ull;

static const uint64_t P9N2_C_13_CORE_FUSES                                         = 0x2D010AA7ull;

static const uint64_t P9N2_C_14_CORE_FUSES                                         = 0x2E010AA7ull;

static const uint64_t P9N2_C_15_CORE_FUSES                                         = 0x2F010AA7ull;

static const uint64_t P9N2_C_16_CORE_FUSES                                         = 0x30010AA7ull;

static const uint64_t P9N2_C_17_CORE_FUSES                                         = 0x31010AA7ull;

static const uint64_t P9N2_C_18_CORE_FUSES                                         = 0x32010AA7ull;

static const uint64_t P9N2_C_19_CORE_FUSES                                         = 0x33010AA7ull;

static const uint64_t P9N2_C_20_CORE_FUSES                                         = 0x34010AA7ull;

static const uint64_t P9N2_C_21_CORE_FUSES                                         = 0x35010AA7ull;

static const uint64_t P9N2_C_22_CORE_FUSES                                         = 0x36010AA7ull;

static const uint64_t P9N2_C_23_CORE_FUSES                                         = 0x37010AA7ull;

static const uint64_t P9N2_EX_0_L2_CORE_FUSES                                      = 0x20010AA7ull;
//DUPS: 21010AA7,
static const uint64_t P9N2_EX_10_L2_CORE_FUSES                                     = 0x34010AA7ull;
//DUPS: 35010AA7,
static const uint64_t P9N2_EX_11_L2_CORE_FUSES                                     = 0x36010AA7ull;
//DUPS: 37010AA7,
static const uint64_t P9N2_EX_1_L2_CORE_FUSES                                      = 0x22010AA7ull;
//DUPS: 23010AA7,
static const uint64_t P9N2_EX_2_L2_CORE_FUSES                                      = 0x24010AA7ull;
//DUPS: 25010AA7,
static const uint64_t P9N2_EX_3_L2_CORE_FUSES                                      = 0x26010AA7ull;
//DUPS: 27010AA7,
static const uint64_t P9N2_EX_4_L2_CORE_FUSES                                      = 0x28010AA7ull;
//DUPS: 29010AA7,
static const uint64_t P9N2_EX_5_L2_CORE_FUSES                                      = 0x2A010AA7ull;
//DUPS: 2B010AA7,
static const uint64_t P9N2_EX_6_L2_CORE_FUSES                                      = 0x2C010AA7ull;
//DUPS: 2D010AA7,
static const uint64_t P9N2_EX_7_L2_CORE_FUSES                                      = 0x2F010AA7ull;
//DUPS: 2F010AA7,
static const uint64_t P9N2_EX_8_L2_CORE_FUSES                                      = 0x30010AA7ull;
//DUPS: 31010AA7,
static const uint64_t P9N2_EX_9_L2_CORE_FUSES                                      = 0x32010AA7ull;
//DUPS: 33010AA7,
static const uint64_t P9N2_EX_L2_CORE_FUSES                                        = 0x20010AA7ull;
//DUPS: 21010AA7,

static const uint64_t P9N2_C_CORE_THREAD_STATE                                     = 0x20010AB3ull;

static const uint64_t P9N2_C_0_CORE_THREAD_STATE                                   = 0x20010AB3ull;

static const uint64_t P9N2_C_1_CORE_THREAD_STATE                                   = 0x21010AB3ull;

static const uint64_t P9N2_C_2_CORE_THREAD_STATE                                   = 0x22010AB3ull;

static const uint64_t P9N2_C_3_CORE_THREAD_STATE                                   = 0x23010AB3ull;

static const uint64_t P9N2_C_4_CORE_THREAD_STATE                                   = 0x24010AB3ull;

static const uint64_t P9N2_C_5_CORE_THREAD_STATE                                   = 0x25010AB3ull;

static const uint64_t P9N2_C_6_CORE_THREAD_STATE                                   = 0x26010AB3ull;

static const uint64_t P9N2_C_7_CORE_THREAD_STATE                                   = 0x27010AB3ull;

static const uint64_t P9N2_C_8_CORE_THREAD_STATE                                   = 0x28010AB3ull;

static const uint64_t P9N2_C_9_CORE_THREAD_STATE                                   = 0x29010AB3ull;

static const uint64_t P9N2_C_10_CORE_THREAD_STATE                                  = 0x2A010AB3ull;

static const uint64_t P9N2_C_11_CORE_THREAD_STATE                                  = 0x2B010AB3ull;

static const uint64_t P9N2_C_12_CORE_THREAD_STATE                                  = 0x2C010AB3ull;

static const uint64_t P9N2_C_13_CORE_THREAD_STATE                                  = 0x2D010AB3ull;

static const uint64_t P9N2_C_14_CORE_THREAD_STATE                                  = 0x2E010AB3ull;

static const uint64_t P9N2_C_15_CORE_THREAD_STATE                                  = 0x2F010AB3ull;

static const uint64_t P9N2_C_16_CORE_THREAD_STATE                                  = 0x30010AB3ull;

static const uint64_t P9N2_C_17_CORE_THREAD_STATE                                  = 0x31010AB3ull;

static const uint64_t P9N2_C_18_CORE_THREAD_STATE                                  = 0x32010AB3ull;

static const uint64_t P9N2_C_19_CORE_THREAD_STATE                                  = 0x33010AB3ull;

static const uint64_t P9N2_C_20_CORE_THREAD_STATE                                  = 0x34010AB3ull;

static const uint64_t P9N2_C_21_CORE_THREAD_STATE                                  = 0x35010AB3ull;

static const uint64_t P9N2_C_22_CORE_THREAD_STATE                                  = 0x36010AB3ull;

static const uint64_t P9N2_C_23_CORE_THREAD_STATE                                  = 0x37010AB3ull;

static const uint64_t P9N2_EX_0_L2_CORE_THREAD_STATE                               = 0x20010AB3ull;
//DUPS: 20010AB3,
static const uint64_t P9N2_EX_10_L2_CORE_THREAD_STATE                              = 0x34010AB3ull;
//DUPS: 34010AB3,
static const uint64_t P9N2_EX_11_L2_CORE_THREAD_STATE                              = 0x36010AB3ull;
//DUPS: 36010AB3,
static const uint64_t P9N2_EX_1_L2_CORE_THREAD_STATE                               = 0x22010AB3ull;
//DUPS: 22010AB3,
static const uint64_t P9N2_EX_2_L2_CORE_THREAD_STATE                               = 0x24010AB3ull;
//DUPS: 24010AB3,
static const uint64_t P9N2_EX_3_L2_CORE_THREAD_STATE                               = 0x26010AB3ull;
//DUPS: 26010AB3,
static const uint64_t P9N2_EX_4_L2_CORE_THREAD_STATE                               = 0x28010AB3ull;
//DUPS: 28010AB3,
static const uint64_t P9N2_EX_5_L2_CORE_THREAD_STATE                               = 0x2B010AB3ull;
//DUPS: 2A010AB3,
static const uint64_t P9N2_EX_6_L2_CORE_THREAD_STATE                               = 0x2D010AB3ull;
//DUPS: 2C010AB3,
static const uint64_t P9N2_EX_7_L2_CORE_THREAD_STATE                               = 0x2F010AB3ull;
//DUPS: 2E010AB3,
static const uint64_t P9N2_EX_8_L2_CORE_THREAD_STATE                               = 0x30010AB3ull;
//DUPS: 30010AB3,
static const uint64_t P9N2_EX_9_L2_CORE_THREAD_STATE                               = 0x32010AB3ull;
//DUPS: 32010AB3,
static const uint64_t P9N2_EX_L2_CORE_THREAD_STATE                                 = 0x20010AB3ull;
//DUPS: 20010AB3,

static const uint64_t P9N2_C_CORE_WOF                                              = 0x20010A48ull;

static const uint64_t P9N2_C_0_CORE_WOF                                            = 0x20010A48ull;

static const uint64_t P9N2_C_1_CORE_WOF                                            = 0x21010A48ull;

static const uint64_t P9N2_C_2_CORE_WOF                                            = 0x22010A48ull;

static const uint64_t P9N2_C_3_CORE_WOF                                            = 0x23010A48ull;

static const uint64_t P9N2_C_4_CORE_WOF                                            = 0x24010A48ull;

static const uint64_t P9N2_C_5_CORE_WOF                                            = 0x25010A48ull;

static const uint64_t P9N2_C_6_CORE_WOF                                            = 0x26010A48ull;

static const uint64_t P9N2_C_7_CORE_WOF                                            = 0x27010A48ull;

static const uint64_t P9N2_C_8_CORE_WOF                                            = 0x28010A48ull;

static const uint64_t P9N2_C_9_CORE_WOF                                            = 0x29010A48ull;

static const uint64_t P9N2_C_10_CORE_WOF                                           = 0x2A010A48ull;

static const uint64_t P9N2_C_11_CORE_WOF                                           = 0x2B010A48ull;

static const uint64_t P9N2_C_12_CORE_WOF                                           = 0x2C010A48ull;

static const uint64_t P9N2_C_13_CORE_WOF                                           = 0x2D010A48ull;

static const uint64_t P9N2_C_14_CORE_WOF                                           = 0x2E010A48ull;

static const uint64_t P9N2_C_15_CORE_WOF                                           = 0x2F010A48ull;

static const uint64_t P9N2_C_16_CORE_WOF                                           = 0x30010A48ull;

static const uint64_t P9N2_C_17_CORE_WOF                                           = 0x31010A48ull;

static const uint64_t P9N2_C_18_CORE_WOF                                           = 0x32010A48ull;

static const uint64_t P9N2_C_19_CORE_WOF                                           = 0x33010A48ull;

static const uint64_t P9N2_C_20_CORE_WOF                                           = 0x34010A48ull;

static const uint64_t P9N2_C_21_CORE_WOF                                           = 0x35010A48ull;

static const uint64_t P9N2_C_22_CORE_WOF                                           = 0x36010A48ull;

static const uint64_t P9N2_C_23_CORE_WOF                                           = 0x37010A48ull;

static const uint64_t P9N2_EX_CORE_WOF                                             = 0x20010A48ull;
//DUPS: 21010A48,
static const uint64_t P9N2_EX_0_CORE_WOF                                           = 0x20010A48ull;
//DUPS: 21010A48,
static const uint64_t P9N2_EX_1_CORE_WOF                                           = 0x22010A48ull;
//DUPS: 23010A48,
static const uint64_t P9N2_EX_2_CORE_WOF                                           = 0x24010A48ull;
//DUPS: 25010A48,
static const uint64_t P9N2_EX_3_CORE_WOF                                           = 0x26010A48ull;
//DUPS: 27010A48,
static const uint64_t P9N2_EX_4_CORE_WOF                                           = 0x28010A48ull;
//DUPS: 29010A48,
static const uint64_t P9N2_EX_5_CORE_WOF                                           = 0x2A010A48ull;
//DUPS: 2B010A48,
static const uint64_t P9N2_EX_6_CORE_WOF                                           = 0x2C010A48ull;
//DUPS: 2D010A48,
static const uint64_t P9N2_EX_7_CORE_WOF                                           = 0x2F010A48ull;
//DUPS: 2F010A48,
static const uint64_t P9N2_EX_8_CORE_WOF                                           = 0x30010A48ull;
//DUPS: 31010A48,
static const uint64_t P9N2_EX_9_CORE_WOF                                           = 0x32010A48ull;
//DUPS: 33010A48,
static const uint64_t P9N2_EX_10_CORE_WOF                                          = 0x34010A48ull;
//DUPS: 35010A48,
static const uint64_t P9N2_EX_11_CORE_WOF                                          = 0x36010A48ull;
//DUPS: 37010A48,

static const uint64_t P9N2_C_CPLT_CONF0                                            = 0x20000008ull;

static const uint64_t P9N2_C_CPLT_CONF0_OR                                         = 0x20000018ull;

static const uint64_t P9N2_C_CPLT_CONF0_CLEAR                                      = 0x20000028ull;

static const uint64_t P9N2_C_0_CPLT_CONF0                                          = 0x20000008ull;

static const uint64_t P9N2_C_0_CPLT_CONF0_OR                                       = 0x20000018ull;

static const uint64_t P9N2_C_0_CPLT_CONF0_CLEAR                                    = 0x20000028ull;

static const uint64_t P9N2_C_1_CPLT_CONF0                                          = 0x21000008ull;

static const uint64_t P9N2_C_1_CPLT_CONF0_OR                                       = 0x21000018ull;

static const uint64_t P9N2_C_1_CPLT_CONF0_CLEAR                                    = 0x21000028ull;

static const uint64_t P9N2_C_2_CPLT_CONF0                                          = 0x22000008ull;

static const uint64_t P9N2_C_2_CPLT_CONF0_OR                                       = 0x22000018ull;

static const uint64_t P9N2_C_2_CPLT_CONF0_CLEAR                                    = 0x22000028ull;

static const uint64_t P9N2_C_3_CPLT_CONF0                                          = 0x23000008ull;

static const uint64_t P9N2_C_3_CPLT_CONF0_OR                                       = 0x23000018ull;

static const uint64_t P9N2_C_3_CPLT_CONF0_CLEAR                                    = 0x23000028ull;

static const uint64_t P9N2_C_4_CPLT_CONF0                                          = 0x24000008ull;

static const uint64_t P9N2_C_4_CPLT_CONF0_OR                                       = 0x24000018ull;

static const uint64_t P9N2_C_4_CPLT_CONF0_CLEAR                                    = 0x24000028ull;

static const uint64_t P9N2_C_5_CPLT_CONF0                                          = 0x25000008ull;

static const uint64_t P9N2_C_5_CPLT_CONF0_OR                                       = 0x25000018ull;

static const uint64_t P9N2_C_5_CPLT_CONF0_CLEAR                                    = 0x25000028ull;

static const uint64_t P9N2_C_6_CPLT_CONF0                                          = 0x26000008ull;

static const uint64_t P9N2_C_6_CPLT_CONF0_OR                                       = 0x26000018ull;

static const uint64_t P9N2_C_6_CPLT_CONF0_CLEAR                                    = 0x26000028ull;

static const uint64_t P9N2_C_7_CPLT_CONF0                                          = 0x27000008ull;

static const uint64_t P9N2_C_7_CPLT_CONF0_OR                                       = 0x27000018ull;

static const uint64_t P9N2_C_7_CPLT_CONF0_CLEAR                                    = 0x27000028ull;

static const uint64_t P9N2_C_8_CPLT_CONF0                                          = 0x28000008ull;

static const uint64_t P9N2_C_8_CPLT_CONF0_OR                                       = 0x28000018ull;

static const uint64_t P9N2_C_8_CPLT_CONF0_CLEAR                                    = 0x28000028ull;

static const uint64_t P9N2_C_9_CPLT_CONF0                                          = 0x29000008ull;

static const uint64_t P9N2_C_9_CPLT_CONF0_OR                                       = 0x29000018ull;

static const uint64_t P9N2_C_9_CPLT_CONF0_CLEAR                                    = 0x29000028ull;

static const uint64_t P9N2_C_10_CPLT_CONF0                                         = 0x2A000008ull;

static const uint64_t P9N2_C_10_CPLT_CONF0_OR                                      = 0x2A000018ull;

static const uint64_t P9N2_C_10_CPLT_CONF0_CLEAR                                   = 0x2A000028ull;

static const uint64_t P9N2_C_11_CPLT_CONF0                                         = 0x2B000008ull;

static const uint64_t P9N2_C_11_CPLT_CONF0_OR                                      = 0x2B000018ull;

static const uint64_t P9N2_C_11_CPLT_CONF0_CLEAR                                   = 0x2B000028ull;

static const uint64_t P9N2_C_12_CPLT_CONF0                                         = 0x2C000008ull;

static const uint64_t P9N2_C_12_CPLT_CONF0_OR                                      = 0x2C000018ull;

static const uint64_t P9N2_C_12_CPLT_CONF0_CLEAR                                   = 0x2C000028ull;

static const uint64_t P9N2_C_13_CPLT_CONF0                                         = 0x2D000008ull;

static const uint64_t P9N2_C_13_CPLT_CONF0_OR                                      = 0x2D000018ull;

static const uint64_t P9N2_C_13_CPLT_CONF0_CLEAR                                   = 0x2D000028ull;

static const uint64_t P9N2_C_14_CPLT_CONF0                                         = 0x2E000008ull;

static const uint64_t P9N2_C_14_CPLT_CONF0_OR                                      = 0x2E000018ull;

static const uint64_t P9N2_C_14_CPLT_CONF0_CLEAR                                   = 0x2E000028ull;

static const uint64_t P9N2_C_15_CPLT_CONF0                                         = 0x2F000008ull;

static const uint64_t P9N2_C_15_CPLT_CONF0_OR                                      = 0x2F000018ull;

static const uint64_t P9N2_C_15_CPLT_CONF0_CLEAR                                   = 0x2F000028ull;

static const uint64_t P9N2_C_16_CPLT_CONF0                                         = 0x30000008ull;

static const uint64_t P9N2_C_16_CPLT_CONF0_OR                                      = 0x30000018ull;

static const uint64_t P9N2_C_16_CPLT_CONF0_CLEAR                                   = 0x30000028ull;

static const uint64_t P9N2_C_17_CPLT_CONF0                                         = 0x31000008ull;

static const uint64_t P9N2_C_17_CPLT_CONF0_OR                                      = 0x31000018ull;

static const uint64_t P9N2_C_17_CPLT_CONF0_CLEAR                                   = 0x31000028ull;

static const uint64_t P9N2_C_18_CPLT_CONF0                                         = 0x32000008ull;

static const uint64_t P9N2_C_18_CPLT_CONF0_OR                                      = 0x32000018ull;

static const uint64_t P9N2_C_18_CPLT_CONF0_CLEAR                                   = 0x32000028ull;

static const uint64_t P9N2_C_19_CPLT_CONF0                                         = 0x33000008ull;

static const uint64_t P9N2_C_19_CPLT_CONF0_OR                                      = 0x33000018ull;

static const uint64_t P9N2_C_19_CPLT_CONF0_CLEAR                                   = 0x33000028ull;

static const uint64_t P9N2_C_20_CPLT_CONF0                                         = 0x34000008ull;

static const uint64_t P9N2_C_20_CPLT_CONF0_OR                                      = 0x34000018ull;

static const uint64_t P9N2_C_20_CPLT_CONF0_CLEAR                                   = 0x34000028ull;

static const uint64_t P9N2_C_21_CPLT_CONF0                                         = 0x35000008ull;

static const uint64_t P9N2_C_21_CPLT_CONF0_OR                                      = 0x35000018ull;

static const uint64_t P9N2_C_21_CPLT_CONF0_CLEAR                                   = 0x35000028ull;

static const uint64_t P9N2_C_22_CPLT_CONF0                                         = 0x36000008ull;

static const uint64_t P9N2_C_22_CPLT_CONF0_OR                                      = 0x36000018ull;

static const uint64_t P9N2_C_22_CPLT_CONF0_CLEAR                                   = 0x36000028ull;

static const uint64_t P9N2_C_23_CPLT_CONF0                                         = 0x37000008ull;

static const uint64_t P9N2_C_23_CPLT_CONF0_OR                                      = 0x37000018ull;

static const uint64_t P9N2_C_23_CPLT_CONF0_CLEAR                                   = 0x37000028ull;

static const uint64_t P9N2_EQ_CPLT_CONF0                                           = 0x10000008ull;

static const uint64_t P9N2_EQ_CPLT_CONF0_OR                                        = 0x10000018ull;

static const uint64_t P9N2_EQ_CPLT_CONF0_CLEAR                                     = 0x10000028ull;

static const uint64_t P9N2_EQ_0_CPLT_CONF0                                         = 0x10000008ull;

static const uint64_t P9N2_EQ_0_CPLT_CONF0_OR                                      = 0x10000018ull;

static const uint64_t P9N2_EQ_0_CPLT_CONF0_CLEAR                                   = 0x10000028ull;

static const uint64_t P9N2_EQ_1_CPLT_CONF0                                         = 0x11000008ull;

static const uint64_t P9N2_EQ_1_CPLT_CONF0_OR                                      = 0x11000018ull;

static const uint64_t P9N2_EQ_1_CPLT_CONF0_CLEAR                                   = 0x11000028ull;

static const uint64_t P9N2_EQ_2_CPLT_CONF0                                         = 0x12000008ull;

static const uint64_t P9N2_EQ_2_CPLT_CONF0_OR                                      = 0x12000018ull;

static const uint64_t P9N2_EQ_2_CPLT_CONF0_CLEAR                                   = 0x12000028ull;

static const uint64_t P9N2_EQ_3_CPLT_CONF0                                         = 0x13000008ull;

static const uint64_t P9N2_EQ_3_CPLT_CONF0_OR                                      = 0x13000018ull;

static const uint64_t P9N2_EQ_3_CPLT_CONF0_CLEAR                                   = 0x13000028ull;

static const uint64_t P9N2_EQ_4_CPLT_CONF0                                         = 0x14000008ull;

static const uint64_t P9N2_EQ_4_CPLT_CONF0_OR                                      = 0x14000018ull;

static const uint64_t P9N2_EQ_4_CPLT_CONF0_CLEAR                                   = 0x14000028ull;

static const uint64_t P9N2_EQ_5_CPLT_CONF0                                         = 0x15000008ull;

static const uint64_t P9N2_EQ_5_CPLT_CONF0_OR                                      = 0x15000018ull;

static const uint64_t P9N2_EQ_5_CPLT_CONF0_CLEAR                                   = 0x15000028ull;

static const uint64_t P9N2_EX_CPLT_CONF0                                           = 0x20000008ull;
//DUPS: 21000008,
static const uint64_t P9N2_EX_CPLT_CONF0_OR                                        = 0x20000018ull;
//DUPS: 21000018,
static const uint64_t P9N2_EX_CPLT_CONF0_CLEAR                                     = 0x20000028ull;
//DUPS: 21000028,
static const uint64_t P9N2_EX_0_CPLT_CONF0                                         = 0x20000008ull;
//DUPS: 21000008,
static const uint64_t P9N2_EX_0_CPLT_CONF0_OR                                      = 0x20000018ull;
//DUPS: 21000018,
static const uint64_t P9N2_EX_0_CPLT_CONF0_CLEAR                                   = 0x20000028ull;
//DUPS: 21000028,
static const uint64_t P9N2_EX_1_CPLT_CONF0                                         = 0x22000008ull;
//DUPS: 23000008,
static const uint64_t P9N2_EX_1_CPLT_CONF0_OR                                      = 0x22000018ull;
//DUPS: 23000018,
static const uint64_t P9N2_EX_1_CPLT_CONF0_CLEAR                                   = 0x22000028ull;
//DUPS: 23000028,
static const uint64_t P9N2_EX_2_CPLT_CONF0                                         = 0x24000008ull;
//DUPS: 25000008,
static const uint64_t P9N2_EX_2_CPLT_CONF0_OR                                      = 0x24000018ull;
//DUPS: 25000018,
static const uint64_t P9N2_EX_2_CPLT_CONF0_CLEAR                                   = 0x24000028ull;
//DUPS: 25000028,
static const uint64_t P9N2_EX_3_CPLT_CONF0                                         = 0x26000008ull;
//DUPS: 27000008,
static const uint64_t P9N2_EX_3_CPLT_CONF0_OR                                      = 0x26000018ull;
//DUPS: 27000018,
static const uint64_t P9N2_EX_3_CPLT_CONF0_CLEAR                                   = 0x26000028ull;
//DUPS: 27000028,
static const uint64_t P9N2_EX_4_CPLT_CONF0                                         = 0x28000008ull;
//DUPS: 29000008,
static const uint64_t P9N2_EX_4_CPLT_CONF0_OR                                      = 0x28000018ull;
//DUPS: 29000018,
static const uint64_t P9N2_EX_4_CPLT_CONF0_CLEAR                                   = 0x28000028ull;
//DUPS: 29000028,
static const uint64_t P9N2_EX_5_CPLT_CONF0                                         = 0x2A000008ull;
//DUPS: 2B000008,
static const uint64_t P9N2_EX_5_CPLT_CONF0_OR                                      = 0x2A000018ull;
//DUPS: 2B000018,
static const uint64_t P9N2_EX_5_CPLT_CONF0_CLEAR                                   = 0x2A000028ull;
//DUPS: 2B000028,
static const uint64_t P9N2_EX_6_CPLT_CONF0                                         = 0x2C000008ull;
//DUPS: 2D000008,
static const uint64_t P9N2_EX_6_CPLT_CONF0_OR                                      = 0x2C000018ull;
//DUPS: 2D000018,
static const uint64_t P9N2_EX_6_CPLT_CONF0_CLEAR                                   = 0x2C000028ull;
//DUPS: 2D000028,
static const uint64_t P9N2_EX_7_CPLT_CONF0                                         = 0x2F000008ull;
//DUPS: 2F000008,
static const uint64_t P9N2_EX_7_CPLT_CONF0_OR                                      = 0x2F000018ull;
//DUPS: 2F000018,
static const uint64_t P9N2_EX_7_CPLT_CONF0_CLEAR                                   = 0x2F000028ull;
//DUPS: 2F000028,
static const uint64_t P9N2_EX_8_CPLT_CONF0                                         = 0x30000008ull;
//DUPS: 31000008,
static const uint64_t P9N2_EX_8_CPLT_CONF0_OR                                      = 0x30000018ull;
//DUPS: 31000018,
static const uint64_t P9N2_EX_8_CPLT_CONF0_CLEAR                                   = 0x30000028ull;
//DUPS: 31000028,
static const uint64_t P9N2_EX_9_CPLT_CONF0                                         = 0x32000008ull;
//DUPS: 33000008,
static const uint64_t P9N2_EX_9_CPLT_CONF0_OR                                      = 0x32000018ull;
//DUPS: 33000018,
static const uint64_t P9N2_EX_9_CPLT_CONF0_CLEAR                                   = 0x32000028ull;
//DUPS: 33000028,
static const uint64_t P9N2_EX_10_CPLT_CONF0                                        = 0x34000008ull;
//DUPS: 35000008,
static const uint64_t P9N2_EX_10_CPLT_CONF0_OR                                     = 0x34000018ull;
//DUPS: 35000018,
static const uint64_t P9N2_EX_10_CPLT_CONF0_CLEAR                                  = 0x34000028ull;
//DUPS: 35000028,
static const uint64_t P9N2_EX_11_CPLT_CONF0                                        = 0x36000008ull;
//DUPS: 37000008,
static const uint64_t P9N2_EX_11_CPLT_CONF0_OR                                     = 0x36000018ull;
//DUPS: 37000018,
static const uint64_t P9N2_EX_11_CPLT_CONF0_CLEAR                                  = 0x36000028ull;
//DUPS: 37000028,

static const uint64_t P9N2_C_CPLT_CONF1                                            = 0x20000009ull;

static const uint64_t P9N2_C_CPLT_CONF1_OR                                         = 0x20000019ull;

static const uint64_t P9N2_C_CPLT_CONF1_CLEAR                                      = 0x20000029ull;

static const uint64_t P9N2_C_0_CPLT_CONF1                                          = 0x20000009ull;

static const uint64_t P9N2_C_0_CPLT_CONF1_OR                                       = 0x20000019ull;

static const uint64_t P9N2_C_0_CPLT_CONF1_CLEAR                                    = 0x20000029ull;

static const uint64_t P9N2_C_1_CPLT_CONF1                                          = 0x21000009ull;

static const uint64_t P9N2_C_1_CPLT_CONF1_OR                                       = 0x21000019ull;

static const uint64_t P9N2_C_1_CPLT_CONF1_CLEAR                                    = 0x21000029ull;

static const uint64_t P9N2_C_2_CPLT_CONF1                                          = 0x22000009ull;

static const uint64_t P9N2_C_2_CPLT_CONF1_OR                                       = 0x22000019ull;

static const uint64_t P9N2_C_2_CPLT_CONF1_CLEAR                                    = 0x22000029ull;

static const uint64_t P9N2_C_3_CPLT_CONF1                                          = 0x23000009ull;

static const uint64_t P9N2_C_3_CPLT_CONF1_OR                                       = 0x23000019ull;

static const uint64_t P9N2_C_3_CPLT_CONF1_CLEAR                                    = 0x23000029ull;

static const uint64_t P9N2_C_4_CPLT_CONF1                                          = 0x24000009ull;

static const uint64_t P9N2_C_4_CPLT_CONF1_OR                                       = 0x24000019ull;

static const uint64_t P9N2_C_4_CPLT_CONF1_CLEAR                                    = 0x24000029ull;

static const uint64_t P9N2_C_5_CPLT_CONF1                                          = 0x25000009ull;

static const uint64_t P9N2_C_5_CPLT_CONF1_OR                                       = 0x25000019ull;

static const uint64_t P9N2_C_5_CPLT_CONF1_CLEAR                                    = 0x25000029ull;

static const uint64_t P9N2_C_6_CPLT_CONF1                                          = 0x26000009ull;

static const uint64_t P9N2_C_6_CPLT_CONF1_OR                                       = 0x26000019ull;

static const uint64_t P9N2_C_6_CPLT_CONF1_CLEAR                                    = 0x26000029ull;

static const uint64_t P9N2_C_7_CPLT_CONF1                                          = 0x27000009ull;

static const uint64_t P9N2_C_7_CPLT_CONF1_OR                                       = 0x27000019ull;

static const uint64_t P9N2_C_7_CPLT_CONF1_CLEAR                                    = 0x27000029ull;

static const uint64_t P9N2_C_8_CPLT_CONF1                                          = 0x28000009ull;

static const uint64_t P9N2_C_8_CPLT_CONF1_OR                                       = 0x28000019ull;

static const uint64_t P9N2_C_8_CPLT_CONF1_CLEAR                                    = 0x28000029ull;

static const uint64_t P9N2_C_9_CPLT_CONF1                                          = 0x29000009ull;

static const uint64_t P9N2_C_9_CPLT_CONF1_OR                                       = 0x29000019ull;

static const uint64_t P9N2_C_9_CPLT_CONF1_CLEAR                                    = 0x29000029ull;

static const uint64_t P9N2_C_10_CPLT_CONF1                                         = 0x2A000009ull;

static const uint64_t P9N2_C_10_CPLT_CONF1_OR                                      = 0x2A000019ull;

static const uint64_t P9N2_C_10_CPLT_CONF1_CLEAR                                   = 0x2A000029ull;

static const uint64_t P9N2_C_11_CPLT_CONF1                                         = 0x2B000009ull;

static const uint64_t P9N2_C_11_CPLT_CONF1_OR                                      = 0x2B000019ull;

static const uint64_t P9N2_C_11_CPLT_CONF1_CLEAR                                   = 0x2B000029ull;

static const uint64_t P9N2_C_12_CPLT_CONF1                                         = 0x2C000009ull;

static const uint64_t P9N2_C_12_CPLT_CONF1_OR                                      = 0x2C000019ull;

static const uint64_t P9N2_C_12_CPLT_CONF1_CLEAR                                   = 0x2C000029ull;

static const uint64_t P9N2_C_13_CPLT_CONF1                                         = 0x2D000009ull;

static const uint64_t P9N2_C_13_CPLT_CONF1_OR                                      = 0x2D000019ull;

static const uint64_t P9N2_C_13_CPLT_CONF1_CLEAR                                   = 0x2D000029ull;

static const uint64_t P9N2_C_14_CPLT_CONF1                                         = 0x2E000009ull;

static const uint64_t P9N2_C_14_CPLT_CONF1_OR                                      = 0x2E000019ull;

static const uint64_t P9N2_C_14_CPLT_CONF1_CLEAR                                   = 0x2E000029ull;

static const uint64_t P9N2_C_15_CPLT_CONF1                                         = 0x2F000009ull;

static const uint64_t P9N2_C_15_CPLT_CONF1_OR                                      = 0x2F000019ull;

static const uint64_t P9N2_C_15_CPLT_CONF1_CLEAR                                   = 0x2F000029ull;

static const uint64_t P9N2_C_16_CPLT_CONF1                                         = 0x30000009ull;

static const uint64_t P9N2_C_16_CPLT_CONF1_OR                                      = 0x30000019ull;

static const uint64_t P9N2_C_16_CPLT_CONF1_CLEAR                                   = 0x30000029ull;

static const uint64_t P9N2_C_17_CPLT_CONF1                                         = 0x31000009ull;

static const uint64_t P9N2_C_17_CPLT_CONF1_OR                                      = 0x31000019ull;

static const uint64_t P9N2_C_17_CPLT_CONF1_CLEAR                                   = 0x31000029ull;

static const uint64_t P9N2_C_18_CPLT_CONF1                                         = 0x32000009ull;

static const uint64_t P9N2_C_18_CPLT_CONF1_OR                                      = 0x32000019ull;

static const uint64_t P9N2_C_18_CPLT_CONF1_CLEAR                                   = 0x32000029ull;

static const uint64_t P9N2_C_19_CPLT_CONF1                                         = 0x33000009ull;

static const uint64_t P9N2_C_19_CPLT_CONF1_OR                                      = 0x33000019ull;

static const uint64_t P9N2_C_19_CPLT_CONF1_CLEAR                                   = 0x33000029ull;

static const uint64_t P9N2_C_20_CPLT_CONF1                                         = 0x34000009ull;

static const uint64_t P9N2_C_20_CPLT_CONF1_OR                                      = 0x34000019ull;

static const uint64_t P9N2_C_20_CPLT_CONF1_CLEAR                                   = 0x34000029ull;

static const uint64_t P9N2_C_21_CPLT_CONF1                                         = 0x35000009ull;

static const uint64_t P9N2_C_21_CPLT_CONF1_OR                                      = 0x35000019ull;

static const uint64_t P9N2_C_21_CPLT_CONF1_CLEAR                                   = 0x35000029ull;

static const uint64_t P9N2_C_22_CPLT_CONF1                                         = 0x36000009ull;

static const uint64_t P9N2_C_22_CPLT_CONF1_OR                                      = 0x36000019ull;

static const uint64_t P9N2_C_22_CPLT_CONF1_CLEAR                                   = 0x36000029ull;

static const uint64_t P9N2_C_23_CPLT_CONF1                                         = 0x37000009ull;

static const uint64_t P9N2_C_23_CPLT_CONF1_OR                                      = 0x37000019ull;

static const uint64_t P9N2_C_23_CPLT_CONF1_CLEAR                                   = 0x37000029ull;

static const uint64_t P9N2_EQ_CPLT_CONF1                                           = 0x10000009ull;

static const uint64_t P9N2_EQ_CPLT_CONF1_OR                                        = 0x10000019ull;

static const uint64_t P9N2_EQ_CPLT_CONF1_CLEAR                                     = 0x10000029ull;

static const uint64_t P9N2_EQ_0_CPLT_CONF1                                         = 0x10000009ull;

static const uint64_t P9N2_EQ_0_CPLT_CONF1_OR                                      = 0x10000019ull;

static const uint64_t P9N2_EQ_0_CPLT_CONF1_CLEAR                                   = 0x10000029ull;

static const uint64_t P9N2_EQ_1_CPLT_CONF1                                         = 0x11000009ull;

static const uint64_t P9N2_EQ_1_CPLT_CONF1_OR                                      = 0x11000019ull;

static const uint64_t P9N2_EQ_1_CPLT_CONF1_CLEAR                                   = 0x11000029ull;

static const uint64_t P9N2_EQ_2_CPLT_CONF1                                         = 0x12000009ull;

static const uint64_t P9N2_EQ_2_CPLT_CONF1_OR                                      = 0x12000019ull;

static const uint64_t P9N2_EQ_2_CPLT_CONF1_CLEAR                                   = 0x12000029ull;

static const uint64_t P9N2_EQ_3_CPLT_CONF1                                         = 0x13000009ull;

static const uint64_t P9N2_EQ_3_CPLT_CONF1_OR                                      = 0x13000019ull;

static const uint64_t P9N2_EQ_3_CPLT_CONF1_CLEAR                                   = 0x13000029ull;

static const uint64_t P9N2_EQ_4_CPLT_CONF1                                         = 0x14000009ull;

static const uint64_t P9N2_EQ_4_CPLT_CONF1_OR                                      = 0x14000019ull;

static const uint64_t P9N2_EQ_4_CPLT_CONF1_CLEAR                                   = 0x14000029ull;

static const uint64_t P9N2_EQ_5_CPLT_CONF1                                         = 0x15000009ull;

static const uint64_t P9N2_EQ_5_CPLT_CONF1_OR                                      = 0x15000019ull;

static const uint64_t P9N2_EQ_5_CPLT_CONF1_CLEAR                                   = 0x15000029ull;

static const uint64_t P9N2_EX_CPLT_CONF1                                           = 0x20000009ull;
//DUPS: 21000009,
static const uint64_t P9N2_EX_CPLT_CONF1_OR                                        = 0x20000019ull;
//DUPS: 21000019,
static const uint64_t P9N2_EX_CPLT_CONF1_CLEAR                                     = 0x20000029ull;
//DUPS: 21000029,
static const uint64_t P9N2_EX_0_CPLT_CONF1                                         = 0x20000009ull;
//DUPS: 21000009,
static const uint64_t P9N2_EX_0_CPLT_CONF1_OR                                      = 0x20000019ull;
//DUPS: 21000019,
static const uint64_t P9N2_EX_0_CPLT_CONF1_CLEAR                                   = 0x20000029ull;
//DUPS: 21000029,
static const uint64_t P9N2_EX_1_CPLT_CONF1                                         = 0x22000009ull;
//DUPS: 23000009,
static const uint64_t P9N2_EX_1_CPLT_CONF1_OR                                      = 0x22000019ull;
//DUPS: 23000019,
static const uint64_t P9N2_EX_1_CPLT_CONF1_CLEAR                                   = 0x22000029ull;
//DUPS: 23000029,
static const uint64_t P9N2_EX_2_CPLT_CONF1                                         = 0x24000009ull;
//DUPS: 25000009,
static const uint64_t P9N2_EX_2_CPLT_CONF1_OR                                      = 0x24000019ull;
//DUPS: 25000019,
static const uint64_t P9N2_EX_2_CPLT_CONF1_CLEAR                                   = 0x24000029ull;
//DUPS: 25000029,
static const uint64_t P9N2_EX_3_CPLT_CONF1                                         = 0x26000009ull;
//DUPS: 27000009,
static const uint64_t P9N2_EX_3_CPLT_CONF1_OR                                      = 0x26000019ull;
//DUPS: 27000019,
static const uint64_t P9N2_EX_3_CPLT_CONF1_CLEAR                                   = 0x26000029ull;
//DUPS: 27000029,
static const uint64_t P9N2_EX_4_CPLT_CONF1                                         = 0x28000009ull;
//DUPS: 29000009,
static const uint64_t P9N2_EX_4_CPLT_CONF1_OR                                      = 0x28000019ull;
//DUPS: 29000019,
static const uint64_t P9N2_EX_4_CPLT_CONF1_CLEAR                                   = 0x28000029ull;
//DUPS: 29000029,
static const uint64_t P9N2_EX_5_CPLT_CONF1                                         = 0x2A000009ull;
//DUPS: 2B000009,
static const uint64_t P9N2_EX_5_CPLT_CONF1_OR                                      = 0x2A000019ull;
//DUPS: 2B000019,
static const uint64_t P9N2_EX_5_CPLT_CONF1_CLEAR                                   = 0x2A000029ull;
//DUPS: 2B000029,
static const uint64_t P9N2_EX_6_CPLT_CONF1                                         = 0x2C000009ull;
//DUPS: 2D000009,
static const uint64_t P9N2_EX_6_CPLT_CONF1_OR                                      = 0x2C000019ull;
//DUPS: 2D000019,
static const uint64_t P9N2_EX_6_CPLT_CONF1_CLEAR                                   = 0x2C000029ull;
//DUPS: 2D000029,
static const uint64_t P9N2_EX_7_CPLT_CONF1                                         = 0x2F000009ull;
//DUPS: 2F000009,
static const uint64_t P9N2_EX_7_CPLT_CONF1_OR                                      = 0x2F000019ull;
//DUPS: 2F000019,
static const uint64_t P9N2_EX_7_CPLT_CONF1_CLEAR                                   = 0x2F000029ull;
//DUPS: 2F000029,
static const uint64_t P9N2_EX_8_CPLT_CONF1                                         = 0x30000009ull;
//DUPS: 31000009,
static const uint64_t P9N2_EX_8_CPLT_CONF1_OR                                      = 0x30000019ull;
//DUPS: 31000019,
static const uint64_t P9N2_EX_8_CPLT_CONF1_CLEAR                                   = 0x30000029ull;
//DUPS: 31000029,
static const uint64_t P9N2_EX_9_CPLT_CONF1                                         = 0x32000009ull;
//DUPS: 33000009,
static const uint64_t P9N2_EX_9_CPLT_CONF1_OR                                      = 0x32000019ull;
//DUPS: 33000019,
static const uint64_t P9N2_EX_9_CPLT_CONF1_CLEAR                                   = 0x32000029ull;
//DUPS: 33000029,
static const uint64_t P9N2_EX_10_CPLT_CONF1                                        = 0x34000009ull;
//DUPS: 35000009,
static const uint64_t P9N2_EX_10_CPLT_CONF1_OR                                     = 0x34000019ull;
//DUPS: 35000019,
static const uint64_t P9N2_EX_10_CPLT_CONF1_CLEAR                                  = 0x34000029ull;
//DUPS: 35000029,
static const uint64_t P9N2_EX_11_CPLT_CONF1                                        = 0x36000009ull;
//DUPS: 37000009,
static const uint64_t P9N2_EX_11_CPLT_CONF1_OR                                     = 0x36000019ull;
//DUPS: 37000019,
static const uint64_t P9N2_EX_11_CPLT_CONF1_CLEAR                                  = 0x36000029ull;
//DUPS: 37000029,

static const uint64_t P9N2_C_CPLT_CTRL0                                            = 0x20000000ull;

static const uint64_t P9N2_C_CPLT_CTRL0_OR                                         = 0x20000010ull;

static const uint64_t P9N2_C_CPLT_CTRL0_CLEAR                                      = 0x20000020ull;

static const uint64_t P9N2_C_0_CPLT_CTRL0                                          = 0x20000000ull;

static const uint64_t P9N2_C_0_CPLT_CTRL0_OR                                       = 0x20000010ull;

static const uint64_t P9N2_C_0_CPLT_CTRL0_CLEAR                                    = 0x20000020ull;

static const uint64_t P9N2_C_1_CPLT_CTRL0                                          = 0x21000000ull;

static const uint64_t P9N2_C_1_CPLT_CTRL0_OR                                       = 0x21000010ull;

static const uint64_t P9N2_C_1_CPLT_CTRL0_CLEAR                                    = 0x21000020ull;

static const uint64_t P9N2_C_2_CPLT_CTRL0                                          = 0x22000000ull;

static const uint64_t P9N2_C_2_CPLT_CTRL0_OR                                       = 0x22000010ull;

static const uint64_t P9N2_C_2_CPLT_CTRL0_CLEAR                                    = 0x22000020ull;

static const uint64_t P9N2_C_3_CPLT_CTRL0                                          = 0x23000000ull;

static const uint64_t P9N2_C_3_CPLT_CTRL0_OR                                       = 0x23000010ull;

static const uint64_t P9N2_C_3_CPLT_CTRL0_CLEAR                                    = 0x23000020ull;

static const uint64_t P9N2_C_4_CPLT_CTRL0                                          = 0x24000000ull;

static const uint64_t P9N2_C_4_CPLT_CTRL0_OR                                       = 0x24000010ull;

static const uint64_t P9N2_C_4_CPLT_CTRL0_CLEAR                                    = 0x24000020ull;

static const uint64_t P9N2_C_5_CPLT_CTRL0                                          = 0x25000000ull;

static const uint64_t P9N2_C_5_CPLT_CTRL0_OR                                       = 0x25000010ull;

static const uint64_t P9N2_C_5_CPLT_CTRL0_CLEAR                                    = 0x25000020ull;

static const uint64_t P9N2_C_6_CPLT_CTRL0                                          = 0x26000000ull;

static const uint64_t P9N2_C_6_CPLT_CTRL0_OR                                       = 0x26000010ull;

static const uint64_t P9N2_C_6_CPLT_CTRL0_CLEAR                                    = 0x26000020ull;

static const uint64_t P9N2_C_7_CPLT_CTRL0                                          = 0x27000000ull;

static const uint64_t P9N2_C_7_CPLT_CTRL0_OR                                       = 0x27000010ull;

static const uint64_t P9N2_C_7_CPLT_CTRL0_CLEAR                                    = 0x27000020ull;

static const uint64_t P9N2_C_8_CPLT_CTRL0                                          = 0x28000000ull;

static const uint64_t P9N2_C_8_CPLT_CTRL0_OR                                       = 0x28000010ull;

static const uint64_t P9N2_C_8_CPLT_CTRL0_CLEAR                                    = 0x28000020ull;

static const uint64_t P9N2_C_9_CPLT_CTRL0                                          = 0x29000000ull;

static const uint64_t P9N2_C_9_CPLT_CTRL0_OR                                       = 0x29000010ull;

static const uint64_t P9N2_C_9_CPLT_CTRL0_CLEAR                                    = 0x29000020ull;

static const uint64_t P9N2_C_10_CPLT_CTRL0                                         = 0x2A000000ull;

static const uint64_t P9N2_C_10_CPLT_CTRL0_OR                                      = 0x2A000010ull;

static const uint64_t P9N2_C_10_CPLT_CTRL0_CLEAR                                   = 0x2A000020ull;

static const uint64_t P9N2_C_11_CPLT_CTRL0                                         = 0x2B000000ull;

static const uint64_t P9N2_C_11_CPLT_CTRL0_OR                                      = 0x2B000010ull;

static const uint64_t P9N2_C_11_CPLT_CTRL0_CLEAR                                   = 0x2B000020ull;

static const uint64_t P9N2_C_12_CPLT_CTRL0                                         = 0x2C000000ull;

static const uint64_t P9N2_C_12_CPLT_CTRL0_OR                                      = 0x2C000010ull;

static const uint64_t P9N2_C_12_CPLT_CTRL0_CLEAR                                   = 0x2C000020ull;

static const uint64_t P9N2_C_13_CPLT_CTRL0                                         = 0x2D000000ull;

static const uint64_t P9N2_C_13_CPLT_CTRL0_OR                                      = 0x2D000010ull;

static const uint64_t P9N2_C_13_CPLT_CTRL0_CLEAR                                   = 0x2D000020ull;

static const uint64_t P9N2_C_14_CPLT_CTRL0                                         = 0x2E000000ull;

static const uint64_t P9N2_C_14_CPLT_CTRL0_OR                                      = 0x2E000010ull;

static const uint64_t P9N2_C_14_CPLT_CTRL0_CLEAR                                   = 0x2E000020ull;

static const uint64_t P9N2_C_15_CPLT_CTRL0                                         = 0x2F000000ull;

static const uint64_t P9N2_C_15_CPLT_CTRL0_OR                                      = 0x2F000010ull;

static const uint64_t P9N2_C_15_CPLT_CTRL0_CLEAR                                   = 0x2F000020ull;

static const uint64_t P9N2_C_16_CPLT_CTRL0                                         = 0x30000000ull;

static const uint64_t P9N2_C_16_CPLT_CTRL0_OR                                      = 0x30000010ull;

static const uint64_t P9N2_C_16_CPLT_CTRL0_CLEAR                                   = 0x30000020ull;

static const uint64_t P9N2_C_17_CPLT_CTRL0                                         = 0x31000000ull;

static const uint64_t P9N2_C_17_CPLT_CTRL0_OR                                      = 0x31000010ull;

static const uint64_t P9N2_C_17_CPLT_CTRL0_CLEAR                                   = 0x31000020ull;

static const uint64_t P9N2_C_18_CPLT_CTRL0                                         = 0x32000000ull;

static const uint64_t P9N2_C_18_CPLT_CTRL0_OR                                      = 0x32000010ull;

static const uint64_t P9N2_C_18_CPLT_CTRL0_CLEAR                                   = 0x32000020ull;

static const uint64_t P9N2_C_19_CPLT_CTRL0                                         = 0x33000000ull;

static const uint64_t P9N2_C_19_CPLT_CTRL0_OR                                      = 0x33000010ull;

static const uint64_t P9N2_C_19_CPLT_CTRL0_CLEAR                                   = 0x33000020ull;

static const uint64_t P9N2_C_20_CPLT_CTRL0                                         = 0x34000000ull;

static const uint64_t P9N2_C_20_CPLT_CTRL0_OR                                      = 0x34000010ull;

static const uint64_t P9N2_C_20_CPLT_CTRL0_CLEAR                                   = 0x34000020ull;

static const uint64_t P9N2_C_21_CPLT_CTRL0                                         = 0x35000000ull;

static const uint64_t P9N2_C_21_CPLT_CTRL0_OR                                      = 0x35000010ull;

static const uint64_t P9N2_C_21_CPLT_CTRL0_CLEAR                                   = 0x35000020ull;

static const uint64_t P9N2_C_22_CPLT_CTRL0                                         = 0x36000000ull;

static const uint64_t P9N2_C_22_CPLT_CTRL0_OR                                      = 0x36000010ull;

static const uint64_t P9N2_C_22_CPLT_CTRL0_CLEAR                                   = 0x36000020ull;

static const uint64_t P9N2_C_23_CPLT_CTRL0                                         = 0x37000000ull;

static const uint64_t P9N2_C_23_CPLT_CTRL0_OR                                      = 0x37000010ull;

static const uint64_t P9N2_C_23_CPLT_CTRL0_CLEAR                                   = 0x37000020ull;

static const uint64_t P9N2_EQ_CPLT_CTRL0                                           = 0x10000000ull;

static const uint64_t P9N2_EQ_CPLT_CTRL0_OR                                        = 0x10000010ull;

static const uint64_t P9N2_EQ_CPLT_CTRL0_CLEAR                                     = 0x10000020ull;

static const uint64_t P9N2_EQ_0_CPLT_CTRL0                                         = 0x10000000ull;

static const uint64_t P9N2_EQ_0_CPLT_CTRL0_OR                                      = 0x10000010ull;

static const uint64_t P9N2_EQ_0_CPLT_CTRL0_CLEAR                                   = 0x10000020ull;

static const uint64_t P9N2_EQ_1_CPLT_CTRL0                                         = 0x11000000ull;

static const uint64_t P9N2_EQ_1_CPLT_CTRL0_OR                                      = 0x11000010ull;

static const uint64_t P9N2_EQ_1_CPLT_CTRL0_CLEAR                                   = 0x11000020ull;

static const uint64_t P9N2_EQ_2_CPLT_CTRL0                                         = 0x12000000ull;

static const uint64_t P9N2_EQ_2_CPLT_CTRL0_OR                                      = 0x12000010ull;

static const uint64_t P9N2_EQ_2_CPLT_CTRL0_CLEAR                                   = 0x12000020ull;

static const uint64_t P9N2_EQ_3_CPLT_CTRL0                                         = 0x13000000ull;

static const uint64_t P9N2_EQ_3_CPLT_CTRL0_OR                                      = 0x13000010ull;

static const uint64_t P9N2_EQ_3_CPLT_CTRL0_CLEAR                                   = 0x13000020ull;

static const uint64_t P9N2_EQ_4_CPLT_CTRL0                                         = 0x14000000ull;

static const uint64_t P9N2_EQ_4_CPLT_CTRL0_OR                                      = 0x14000010ull;

static const uint64_t P9N2_EQ_4_CPLT_CTRL0_CLEAR                                   = 0x14000020ull;

static const uint64_t P9N2_EQ_5_CPLT_CTRL0                                         = 0x15000000ull;

static const uint64_t P9N2_EQ_5_CPLT_CTRL0_OR                                      = 0x15000010ull;

static const uint64_t P9N2_EQ_5_CPLT_CTRL0_CLEAR                                   = 0x15000020ull;

static const uint64_t P9N2_EX_CPLT_CTRL0                                           = 0x20000000ull;
//DUPS: 21000000,
static const uint64_t P9N2_EX_CPLT_CTRL0_OR                                        = 0x20000010ull;
//DUPS: 21000010,
static const uint64_t P9N2_EX_CPLT_CTRL0_CLEAR                                     = 0x20000020ull;
//DUPS: 21000020,
static const uint64_t P9N2_EX_0_CPLT_CTRL0                                         = 0x20000000ull;
//DUPS: 21000000,
static const uint64_t P9N2_EX_0_CPLT_CTRL0_OR                                      = 0x20000010ull;
//DUPS: 21000010,
static const uint64_t P9N2_EX_0_CPLT_CTRL0_CLEAR                                   = 0x20000020ull;
//DUPS: 21000020,
static const uint64_t P9N2_EX_1_CPLT_CTRL0                                         = 0x22000000ull;
//DUPS: 23000000,
static const uint64_t P9N2_EX_1_CPLT_CTRL0_OR                                      = 0x22000010ull;
//DUPS: 23000010,
static const uint64_t P9N2_EX_1_CPLT_CTRL0_CLEAR                                   = 0x22000020ull;
//DUPS: 23000020,
static const uint64_t P9N2_EX_2_CPLT_CTRL0                                         = 0x24000000ull;
//DUPS: 25000000,
static const uint64_t P9N2_EX_2_CPLT_CTRL0_OR                                      = 0x24000010ull;
//DUPS: 25000010,
static const uint64_t P9N2_EX_2_CPLT_CTRL0_CLEAR                                   = 0x24000020ull;
//DUPS: 25000020,
static const uint64_t P9N2_EX_3_CPLT_CTRL0                                         = 0x26000000ull;
//DUPS: 27000000,
static const uint64_t P9N2_EX_3_CPLT_CTRL0_OR                                      = 0x26000010ull;
//DUPS: 27000010,
static const uint64_t P9N2_EX_3_CPLT_CTRL0_CLEAR                                   = 0x26000020ull;
//DUPS: 27000020,
static const uint64_t P9N2_EX_4_CPLT_CTRL0                                         = 0x28000000ull;
//DUPS: 29000000,
static const uint64_t P9N2_EX_4_CPLT_CTRL0_OR                                      = 0x28000010ull;
//DUPS: 29000010,
static const uint64_t P9N2_EX_4_CPLT_CTRL0_CLEAR                                   = 0x28000020ull;
//DUPS: 29000020,
static const uint64_t P9N2_EX_5_CPLT_CTRL0                                         = 0x2A000000ull;
//DUPS: 2B000000,
static const uint64_t P9N2_EX_5_CPLT_CTRL0_OR                                      = 0x2A000010ull;
//DUPS: 2B000010,
static const uint64_t P9N2_EX_5_CPLT_CTRL0_CLEAR                                   = 0x2A000020ull;
//DUPS: 2B000020,
static const uint64_t P9N2_EX_6_CPLT_CTRL0                                         = 0x2C000000ull;
//DUPS: 2D000000,
static const uint64_t P9N2_EX_6_CPLT_CTRL0_OR                                      = 0x2C000010ull;
//DUPS: 2D000010,
static const uint64_t P9N2_EX_6_CPLT_CTRL0_CLEAR                                   = 0x2C000020ull;
//DUPS: 2D000020,
static const uint64_t P9N2_EX_7_CPLT_CTRL0                                         = 0x2E000000ull;
//DUPS: 2F000000,
static const uint64_t P9N2_EX_7_CPLT_CTRL0_OR                                      = 0x2F000010ull;
//DUPS: 2F000010,
static const uint64_t P9N2_EX_7_CPLT_CTRL0_CLEAR                                   = 0x2F000020ull;
//DUPS: 2F000020,
static const uint64_t P9N2_EX_8_CPLT_CTRL0                                         = 0x30000000ull;
//DUPS: 31000000,
static const uint64_t P9N2_EX_8_CPLT_CTRL0_OR                                      = 0x30000010ull;
//DUPS: 31000010,
static const uint64_t P9N2_EX_8_CPLT_CTRL0_CLEAR                                   = 0x30000020ull;
//DUPS: 31000020,
static const uint64_t P9N2_EX_9_CPLT_CTRL0                                         = 0x32000000ull;
//DUPS: 33000000,
static const uint64_t P9N2_EX_9_CPLT_CTRL0_OR                                      = 0x32000010ull;
//DUPS: 33000010,
static const uint64_t P9N2_EX_9_CPLT_CTRL0_CLEAR                                   = 0x32000020ull;
//DUPS: 33000020,
static const uint64_t P9N2_EX_10_CPLT_CTRL0                                        = 0x34000000ull;
//DUPS: 35000000,
static const uint64_t P9N2_EX_10_CPLT_CTRL0_OR                                     = 0x34000010ull;
//DUPS: 35000010,
static const uint64_t P9N2_EX_10_CPLT_CTRL0_CLEAR                                  = 0x34000020ull;
//DUPS: 35000020,
static const uint64_t P9N2_EX_11_CPLT_CTRL0                                        = 0x36000000ull;
//DUPS: 37000000,
static const uint64_t P9N2_EX_11_CPLT_CTRL0_OR                                     = 0x36000010ull;
//DUPS: 37000010,
static const uint64_t P9N2_EX_11_CPLT_CTRL0_CLEAR                                  = 0x36000020ull;
//DUPS: 37000020,

static const uint64_t P9N2_C_CPLT_CTRL1                                            = 0x20000001ull;

static const uint64_t P9N2_C_CPLT_CTRL1_OR                                         = 0x20000011ull;

static const uint64_t P9N2_C_CPLT_CTRL1_CLEAR                                      = 0x20000021ull;

static const uint64_t P9N2_C_0_CPLT_CTRL1                                          = 0x20000001ull;

static const uint64_t P9N2_C_0_CPLT_CTRL1_OR                                       = 0x20000011ull;

static const uint64_t P9N2_C_0_CPLT_CTRL1_CLEAR                                    = 0x20000021ull;

static const uint64_t P9N2_C_1_CPLT_CTRL1                                          = 0x21000001ull;

static const uint64_t P9N2_C_1_CPLT_CTRL1_OR                                       = 0x21000011ull;

static const uint64_t P9N2_C_1_CPLT_CTRL1_CLEAR                                    = 0x21000021ull;

static const uint64_t P9N2_C_2_CPLT_CTRL1                                          = 0x22000001ull;

static const uint64_t P9N2_C_2_CPLT_CTRL1_OR                                       = 0x22000011ull;

static const uint64_t P9N2_C_2_CPLT_CTRL1_CLEAR                                    = 0x22000021ull;

static const uint64_t P9N2_C_3_CPLT_CTRL1                                          = 0x23000001ull;

static const uint64_t P9N2_C_3_CPLT_CTRL1_OR                                       = 0x23000011ull;

static const uint64_t P9N2_C_3_CPLT_CTRL1_CLEAR                                    = 0x23000021ull;

static const uint64_t P9N2_C_4_CPLT_CTRL1                                          = 0x24000001ull;

static const uint64_t P9N2_C_4_CPLT_CTRL1_OR                                       = 0x24000011ull;

static const uint64_t P9N2_C_4_CPLT_CTRL1_CLEAR                                    = 0x24000021ull;

static const uint64_t P9N2_C_5_CPLT_CTRL1                                          = 0x25000001ull;

static const uint64_t P9N2_C_5_CPLT_CTRL1_OR                                       = 0x25000011ull;

static const uint64_t P9N2_C_5_CPLT_CTRL1_CLEAR                                    = 0x25000021ull;

static const uint64_t P9N2_C_6_CPLT_CTRL1                                          = 0x26000001ull;

static const uint64_t P9N2_C_6_CPLT_CTRL1_OR                                       = 0x26000011ull;

static const uint64_t P9N2_C_6_CPLT_CTRL1_CLEAR                                    = 0x26000021ull;

static const uint64_t P9N2_C_7_CPLT_CTRL1                                          = 0x27000001ull;

static const uint64_t P9N2_C_7_CPLT_CTRL1_OR                                       = 0x27000011ull;

static const uint64_t P9N2_C_7_CPLT_CTRL1_CLEAR                                    = 0x27000021ull;

static const uint64_t P9N2_C_8_CPLT_CTRL1                                          = 0x28000001ull;

static const uint64_t P9N2_C_8_CPLT_CTRL1_OR                                       = 0x28000011ull;

static const uint64_t P9N2_C_8_CPLT_CTRL1_CLEAR                                    = 0x28000021ull;

static const uint64_t P9N2_C_9_CPLT_CTRL1                                          = 0x29000001ull;

static const uint64_t P9N2_C_9_CPLT_CTRL1_OR                                       = 0x29000011ull;

static const uint64_t P9N2_C_9_CPLT_CTRL1_CLEAR                                    = 0x29000021ull;

static const uint64_t P9N2_C_10_CPLT_CTRL1                                         = 0x2A000001ull;

static const uint64_t P9N2_C_10_CPLT_CTRL1_OR                                      = 0x2A000011ull;

static const uint64_t P9N2_C_10_CPLT_CTRL1_CLEAR                                   = 0x2A000021ull;

static const uint64_t P9N2_C_11_CPLT_CTRL1                                         = 0x2B000001ull;

static const uint64_t P9N2_C_11_CPLT_CTRL1_OR                                      = 0x2B000011ull;

static const uint64_t P9N2_C_11_CPLT_CTRL1_CLEAR                                   = 0x2B000021ull;

static const uint64_t P9N2_C_12_CPLT_CTRL1                                         = 0x2C000001ull;

static const uint64_t P9N2_C_12_CPLT_CTRL1_OR                                      = 0x2C000011ull;

static const uint64_t P9N2_C_12_CPLT_CTRL1_CLEAR                                   = 0x2C000021ull;

static const uint64_t P9N2_C_13_CPLT_CTRL1                                         = 0x2D000001ull;

static const uint64_t P9N2_C_13_CPLT_CTRL1_OR                                      = 0x2D000011ull;

static const uint64_t P9N2_C_13_CPLT_CTRL1_CLEAR                                   = 0x2D000021ull;

static const uint64_t P9N2_C_14_CPLT_CTRL1                                         = 0x2E000001ull;

static const uint64_t P9N2_C_14_CPLT_CTRL1_OR                                      = 0x2E000011ull;

static const uint64_t P9N2_C_14_CPLT_CTRL1_CLEAR                                   = 0x2E000021ull;

static const uint64_t P9N2_C_15_CPLT_CTRL1                                         = 0x2F000001ull;

static const uint64_t P9N2_C_15_CPLT_CTRL1_OR                                      = 0x2F000011ull;

static const uint64_t P9N2_C_15_CPLT_CTRL1_CLEAR                                   = 0x2F000021ull;

static const uint64_t P9N2_C_16_CPLT_CTRL1                                         = 0x30000001ull;

static const uint64_t P9N2_C_16_CPLT_CTRL1_OR                                      = 0x30000011ull;

static const uint64_t P9N2_C_16_CPLT_CTRL1_CLEAR                                   = 0x30000021ull;

static const uint64_t P9N2_C_17_CPLT_CTRL1                                         = 0x31000001ull;

static const uint64_t P9N2_C_17_CPLT_CTRL1_OR                                      = 0x31000011ull;

static const uint64_t P9N2_C_17_CPLT_CTRL1_CLEAR                                   = 0x31000021ull;

static const uint64_t P9N2_C_18_CPLT_CTRL1                                         = 0x32000001ull;

static const uint64_t P9N2_C_18_CPLT_CTRL1_OR                                      = 0x32000011ull;

static const uint64_t P9N2_C_18_CPLT_CTRL1_CLEAR                                   = 0x32000021ull;

static const uint64_t P9N2_C_19_CPLT_CTRL1                                         = 0x33000001ull;

static const uint64_t P9N2_C_19_CPLT_CTRL1_OR                                      = 0x33000011ull;

static const uint64_t P9N2_C_19_CPLT_CTRL1_CLEAR                                   = 0x33000021ull;

static const uint64_t P9N2_C_20_CPLT_CTRL1                                         = 0x34000001ull;

static const uint64_t P9N2_C_20_CPLT_CTRL1_OR                                      = 0x34000011ull;

static const uint64_t P9N2_C_20_CPLT_CTRL1_CLEAR                                   = 0x34000021ull;

static const uint64_t P9N2_C_21_CPLT_CTRL1                                         = 0x35000001ull;

static const uint64_t P9N2_C_21_CPLT_CTRL1_OR                                      = 0x35000011ull;

static const uint64_t P9N2_C_21_CPLT_CTRL1_CLEAR                                   = 0x35000021ull;

static const uint64_t P9N2_C_22_CPLT_CTRL1                                         = 0x36000001ull;

static const uint64_t P9N2_C_22_CPLT_CTRL1_OR                                      = 0x36000011ull;

static const uint64_t P9N2_C_22_CPLT_CTRL1_CLEAR                                   = 0x36000021ull;

static const uint64_t P9N2_C_23_CPLT_CTRL1                                         = 0x37000001ull;

static const uint64_t P9N2_C_23_CPLT_CTRL1_OR                                      = 0x37000011ull;

static const uint64_t P9N2_C_23_CPLT_CTRL1_CLEAR                                   = 0x37000021ull;

static const uint64_t P9N2_EQ_CPLT_CTRL1                                           = 0x10000001ull;

static const uint64_t P9N2_EQ_CPLT_CTRL1_OR                                        = 0x10000011ull;

static const uint64_t P9N2_EQ_CPLT_CTRL1_CLEAR                                     = 0x10000021ull;

static const uint64_t P9N2_EQ_0_CPLT_CTRL1                                         = 0x10000001ull;

static const uint64_t P9N2_EQ_0_CPLT_CTRL1_OR                                      = 0x10000011ull;

static const uint64_t P9N2_EQ_0_CPLT_CTRL1_CLEAR                                   = 0x10000021ull;

static const uint64_t P9N2_EQ_1_CPLT_CTRL1                                         = 0x11000001ull;

static const uint64_t P9N2_EQ_1_CPLT_CTRL1_OR                                      = 0x11000011ull;

static const uint64_t P9N2_EQ_1_CPLT_CTRL1_CLEAR                                   = 0x11000021ull;

static const uint64_t P9N2_EQ_2_CPLT_CTRL1                                         = 0x12000001ull;

static const uint64_t P9N2_EQ_2_CPLT_CTRL1_OR                                      = 0x12000011ull;

static const uint64_t P9N2_EQ_2_CPLT_CTRL1_CLEAR                                   = 0x12000021ull;

static const uint64_t P9N2_EQ_3_CPLT_CTRL1                                         = 0x13000001ull;

static const uint64_t P9N2_EQ_3_CPLT_CTRL1_OR                                      = 0x13000011ull;

static const uint64_t P9N2_EQ_3_CPLT_CTRL1_CLEAR                                   = 0x13000021ull;

static const uint64_t P9N2_EQ_4_CPLT_CTRL1                                         = 0x14000001ull;

static const uint64_t P9N2_EQ_4_CPLT_CTRL1_OR                                      = 0x14000011ull;

static const uint64_t P9N2_EQ_4_CPLT_CTRL1_CLEAR                                   = 0x14000021ull;

static const uint64_t P9N2_EQ_5_CPLT_CTRL1                                         = 0x15000001ull;

static const uint64_t P9N2_EQ_5_CPLT_CTRL1_OR                                      = 0x15000011ull;

static const uint64_t P9N2_EQ_5_CPLT_CTRL1_CLEAR                                   = 0x15000021ull;

static const uint64_t P9N2_EX_CPLT_CTRL1                                           = 0x20000001ull;
//DUPS: 21000001,
static const uint64_t P9N2_EX_CPLT_CTRL1_OR                                        = 0x20000011ull;
//DUPS: 21000011,
static const uint64_t P9N2_EX_CPLT_CTRL1_CLEAR                                     = 0x20000021ull;
//DUPS: 21000021,
static const uint64_t P9N2_EX_0_CPLT_CTRL1                                         = 0x20000001ull;
//DUPS: 21000001,
static const uint64_t P9N2_EX_0_CPLT_CTRL1_OR                                      = 0x20000011ull;
//DUPS: 21000011,
static const uint64_t P9N2_EX_0_CPLT_CTRL1_CLEAR                                   = 0x20000021ull;
//DUPS: 21000021,
static const uint64_t P9N2_EX_1_CPLT_CTRL1                                         = 0x22000001ull;
//DUPS: 23000001,
static const uint64_t P9N2_EX_1_CPLT_CTRL1_OR                                      = 0x22000011ull;
//DUPS: 23000011,
static const uint64_t P9N2_EX_1_CPLT_CTRL1_CLEAR                                   = 0x22000021ull;
//DUPS: 23000021,
static const uint64_t P9N2_EX_2_CPLT_CTRL1                                         = 0x24000001ull;
//DUPS: 25000001,
static const uint64_t P9N2_EX_2_CPLT_CTRL1_OR                                      = 0x24000011ull;
//DUPS: 25000011,
static const uint64_t P9N2_EX_2_CPLT_CTRL1_CLEAR                                   = 0x24000021ull;
//DUPS: 25000021,
static const uint64_t P9N2_EX_3_CPLT_CTRL1                                         = 0x26000001ull;
//DUPS: 27000001,
static const uint64_t P9N2_EX_3_CPLT_CTRL1_OR                                      = 0x26000011ull;
//DUPS: 27000011,
static const uint64_t P9N2_EX_3_CPLT_CTRL1_CLEAR                                   = 0x26000021ull;
//DUPS: 27000021,
static const uint64_t P9N2_EX_4_CPLT_CTRL1                                         = 0x28000001ull;
//DUPS: 29000001,
static const uint64_t P9N2_EX_4_CPLT_CTRL1_OR                                      = 0x28000011ull;
//DUPS: 29000011,
static const uint64_t P9N2_EX_4_CPLT_CTRL1_CLEAR                                   = 0x28000021ull;
//DUPS: 29000021,
static const uint64_t P9N2_EX_5_CPLT_CTRL1                                         = 0x2A000001ull;
//DUPS: 2B000001,
static const uint64_t P9N2_EX_5_CPLT_CTRL1_OR                                      = 0x2A000011ull;
//DUPS: 2B000011,
static const uint64_t P9N2_EX_5_CPLT_CTRL1_CLEAR                                   = 0x2A000021ull;
//DUPS: 2B000021,
static const uint64_t P9N2_EX_6_CPLT_CTRL1                                         = 0x2C000001ull;
//DUPS: 2D000001,
static const uint64_t P9N2_EX_6_CPLT_CTRL1_OR                                      = 0x2C000011ull;
//DUPS: 2D000011,
static const uint64_t P9N2_EX_6_CPLT_CTRL1_CLEAR                                   = 0x2C000021ull;
//DUPS: 2D000021,
static const uint64_t P9N2_EX_7_CPLT_CTRL1                                         = 0x2F000001ull;
//DUPS: 2F000001,
static const uint64_t P9N2_EX_7_CPLT_CTRL1_OR                                      = 0x2F000011ull;
//DUPS: 2F000011,
static const uint64_t P9N2_EX_7_CPLT_CTRL1_CLEAR                                   = 0x2F000021ull;
//DUPS: 2F000021,
static const uint64_t P9N2_EX_8_CPLT_CTRL1                                         = 0x30000001ull;
//DUPS: 31000001,
static const uint64_t P9N2_EX_8_CPLT_CTRL1_OR                                      = 0x30000011ull;
//DUPS: 31000011,
static const uint64_t P9N2_EX_8_CPLT_CTRL1_CLEAR                                   = 0x30000021ull;
//DUPS: 31000021,
static const uint64_t P9N2_EX_9_CPLT_CTRL1                                         = 0x32000001ull;
//DUPS: 33000001,
static const uint64_t P9N2_EX_9_CPLT_CTRL1_OR                                      = 0x32000011ull;
//DUPS: 33000011,
static const uint64_t P9N2_EX_9_CPLT_CTRL1_CLEAR                                   = 0x32000021ull;
//DUPS: 33000021,
static const uint64_t P9N2_EX_10_CPLT_CTRL1                                        = 0x34000001ull;
//DUPS: 35000001,
static const uint64_t P9N2_EX_10_CPLT_CTRL1_OR                                     = 0x34000011ull;
//DUPS: 35000011,
static const uint64_t P9N2_EX_10_CPLT_CTRL1_CLEAR                                  = 0x34000021ull;
//DUPS: 35000021,
static const uint64_t P9N2_EX_11_CPLT_CTRL1                                        = 0x36000001ull;
//DUPS: 37000001,
static const uint64_t P9N2_EX_11_CPLT_CTRL1_OR                                     = 0x36000011ull;
//DUPS: 37000011,
static const uint64_t P9N2_EX_11_CPLT_CTRL1_CLEAR                                  = 0x36000021ull;
//DUPS: 37000021,

static const uint64_t P9N2_C_CPLT_MASK0                                            = 0x20000101ull;

static const uint64_t P9N2_C_0_CPLT_MASK0                                          = 0x20000101ull;

static const uint64_t P9N2_C_1_CPLT_MASK0                                          = 0x21000101ull;

static const uint64_t P9N2_C_2_CPLT_MASK0                                          = 0x22000101ull;

static const uint64_t P9N2_C_3_CPLT_MASK0                                          = 0x23000101ull;

static const uint64_t P9N2_C_4_CPLT_MASK0                                          = 0x24000101ull;

static const uint64_t P9N2_C_5_CPLT_MASK0                                          = 0x25000101ull;

static const uint64_t P9N2_C_6_CPLT_MASK0                                          = 0x26000101ull;

static const uint64_t P9N2_C_7_CPLT_MASK0                                          = 0x27000101ull;

static const uint64_t P9N2_C_8_CPLT_MASK0                                          = 0x28000101ull;

static const uint64_t P9N2_C_9_CPLT_MASK0                                          = 0x29000101ull;

static const uint64_t P9N2_C_10_CPLT_MASK0                                         = 0x2A000101ull;

static const uint64_t P9N2_C_11_CPLT_MASK0                                         = 0x2B000101ull;

static const uint64_t P9N2_C_12_CPLT_MASK0                                         = 0x2C000101ull;

static const uint64_t P9N2_C_13_CPLT_MASK0                                         = 0x2D000101ull;

static const uint64_t P9N2_C_14_CPLT_MASK0                                         = 0x2E000101ull;

static const uint64_t P9N2_C_15_CPLT_MASK0                                         = 0x2F000101ull;

static const uint64_t P9N2_C_16_CPLT_MASK0                                         = 0x30000101ull;

static const uint64_t P9N2_C_17_CPLT_MASK0                                         = 0x31000101ull;

static const uint64_t P9N2_C_18_CPLT_MASK0                                         = 0x32000101ull;

static const uint64_t P9N2_C_19_CPLT_MASK0                                         = 0x33000101ull;

static const uint64_t P9N2_C_20_CPLT_MASK0                                         = 0x34000101ull;

static const uint64_t P9N2_C_21_CPLT_MASK0                                         = 0x35000101ull;

static const uint64_t P9N2_C_22_CPLT_MASK0                                         = 0x36000101ull;

static const uint64_t P9N2_C_23_CPLT_MASK0                                         = 0x37000101ull;

static const uint64_t P9N2_EQ_CPLT_MASK0                                           = 0x10000101ull;

static const uint64_t P9N2_EQ_0_CPLT_MASK0                                         = 0x10000101ull;

static const uint64_t P9N2_EQ_1_CPLT_MASK0                                         = 0x11000101ull;

static const uint64_t P9N2_EQ_2_CPLT_MASK0                                         = 0x12000101ull;

static const uint64_t P9N2_EQ_3_CPLT_MASK0                                         = 0x13000101ull;

static const uint64_t P9N2_EQ_4_CPLT_MASK0                                         = 0x14000101ull;

static const uint64_t P9N2_EQ_5_CPLT_MASK0                                         = 0x15000101ull;

static const uint64_t P9N2_EX_CPLT_MASK0                                           = 0x20000101ull;
//DUPS: 21000101,
static const uint64_t P9N2_EX_0_CPLT_MASK0                                         = 0x20000101ull;
//DUPS: 21000101,
static const uint64_t P9N2_EX_1_CPLT_MASK0                                         = 0x22000101ull;
//DUPS: 23000101,
static const uint64_t P9N2_EX_2_CPLT_MASK0                                         = 0x24000101ull;
//DUPS: 25000101,
static const uint64_t P9N2_EX_3_CPLT_MASK0                                         = 0x26000101ull;
//DUPS: 27000101,
static const uint64_t P9N2_EX_4_CPLT_MASK0                                         = 0x28000101ull;
//DUPS: 29000101,
static const uint64_t P9N2_EX_5_CPLT_MASK0                                         = 0x2A000101ull;
//DUPS: 2B000101,
static const uint64_t P9N2_EX_6_CPLT_MASK0                                         = 0x2C000101ull;
//DUPS: 2D000101,
static const uint64_t P9N2_EX_7_CPLT_MASK0                                         = 0x2F000101ull;
//DUPS: 2F000101,
static const uint64_t P9N2_EX_8_CPLT_MASK0                                         = 0x30000101ull;
//DUPS: 31000101,
static const uint64_t P9N2_EX_9_CPLT_MASK0                                         = 0x32000101ull;
//DUPS: 33000101,
static const uint64_t P9N2_EX_10_CPLT_MASK0                                        = 0x34000101ull;
//DUPS: 35000101,
static const uint64_t P9N2_EX_11_CPLT_MASK0                                        = 0x36000101ull;
//DUPS: 37000101,

static const uint64_t P9N2_C_CPLT_STAT0                                            = 0x20000100ull;

static const uint64_t P9N2_C_0_CPLT_STAT0                                          = 0x20000100ull;

static const uint64_t P9N2_C_1_CPLT_STAT0                                          = 0x21000100ull;

static const uint64_t P9N2_C_2_CPLT_STAT0                                          = 0x22000100ull;

static const uint64_t P9N2_C_3_CPLT_STAT0                                          = 0x23000100ull;

static const uint64_t P9N2_C_4_CPLT_STAT0                                          = 0x24000100ull;

static const uint64_t P9N2_C_5_CPLT_STAT0                                          = 0x25000100ull;

static const uint64_t P9N2_C_6_CPLT_STAT0                                          = 0x26000100ull;

static const uint64_t P9N2_C_7_CPLT_STAT0                                          = 0x27000100ull;

static const uint64_t P9N2_C_8_CPLT_STAT0                                          = 0x28000100ull;

static const uint64_t P9N2_C_9_CPLT_STAT0                                          = 0x29000100ull;

static const uint64_t P9N2_C_10_CPLT_STAT0                                         = 0x2A000100ull;

static const uint64_t P9N2_C_11_CPLT_STAT0                                         = 0x2B000100ull;

static const uint64_t P9N2_C_12_CPLT_STAT0                                         = 0x2C000100ull;

static const uint64_t P9N2_C_13_CPLT_STAT0                                         = 0x2D000100ull;

static const uint64_t P9N2_C_14_CPLT_STAT0                                         = 0x2E000100ull;

static const uint64_t P9N2_C_15_CPLT_STAT0                                         = 0x2F000100ull;

static const uint64_t P9N2_C_16_CPLT_STAT0                                         = 0x30000100ull;

static const uint64_t P9N2_C_17_CPLT_STAT0                                         = 0x31000100ull;

static const uint64_t P9N2_C_18_CPLT_STAT0                                         = 0x32000100ull;

static const uint64_t P9N2_C_19_CPLT_STAT0                                         = 0x33000100ull;

static const uint64_t P9N2_C_20_CPLT_STAT0                                         = 0x34000100ull;

static const uint64_t P9N2_C_21_CPLT_STAT0                                         = 0x35000100ull;

static const uint64_t P9N2_C_22_CPLT_STAT0                                         = 0x36000100ull;

static const uint64_t P9N2_C_23_CPLT_STAT0                                         = 0x37000100ull;

static const uint64_t P9N2_EQ_CPLT_STAT0                                           = 0x10000100ull;

static const uint64_t P9N2_EQ_0_CPLT_STAT0                                         = 0x10000100ull;

static const uint64_t P9N2_EQ_1_CPLT_STAT0                                         = 0x11000100ull;

static const uint64_t P9N2_EQ_2_CPLT_STAT0                                         = 0x12000100ull;

static const uint64_t P9N2_EQ_3_CPLT_STAT0                                         = 0x13000100ull;

static const uint64_t P9N2_EQ_4_CPLT_STAT0                                         = 0x14000100ull;

static const uint64_t P9N2_EQ_5_CPLT_STAT0                                         = 0x15000100ull;

static const uint64_t P9N2_EX_CPLT_STAT0                                           = 0x20000100ull;
//DUPS: 21000100,
static const uint64_t P9N2_EX_0_CPLT_STAT0                                         = 0x20000100ull;
//DUPS: 21000100,
static const uint64_t P9N2_EX_1_CPLT_STAT0                                         = 0x22000100ull;
//DUPS: 23000100,
static const uint64_t P9N2_EX_2_CPLT_STAT0                                         = 0x24000100ull;
//DUPS: 25000100,
static const uint64_t P9N2_EX_3_CPLT_STAT0                                         = 0x26000100ull;
//DUPS: 27000100,
static const uint64_t P9N2_EX_4_CPLT_STAT0                                         = 0x28000100ull;
//DUPS: 29000100,
static const uint64_t P9N2_EX_5_CPLT_STAT0                                         = 0x2A000100ull;
//DUPS: 2B000100,
static const uint64_t P9N2_EX_6_CPLT_STAT0                                         = 0x2C000100ull;
//DUPS: 2D000100,
static const uint64_t P9N2_EX_7_CPLT_STAT0                                         = 0x2F000100ull;
//DUPS: 2F000100,
static const uint64_t P9N2_EX_8_CPLT_STAT0                                         = 0x30000100ull;
//DUPS: 31000100,
static const uint64_t P9N2_EX_9_CPLT_STAT0                                         = 0x32000100ull;
//DUPS: 33000100,
static const uint64_t P9N2_EX_10_CPLT_STAT0                                        = 0x34000100ull;
//DUPS: 35000100,
static const uint64_t P9N2_EX_11_CPLT_STAT0                                        = 0x36000100ull;
//DUPS: 37000100,

static const uint64_t P9N2_C_CPPM_CACCR                                            = 0x200F0168ull;

static const uint64_t P9N2_C_CPPM_CACCR_CLEAR                                      = 0x200F0169ull;

static const uint64_t P9N2_C_CPPM_CACCR_OR                                         = 0x200F016Aull;

static const uint64_t P9N2_C_0_CPPM_CACCR                                          = 0x200F0168ull;

static const uint64_t P9N2_C_0_CPPM_CACCR_CLEAR                                    = 0x200F0169ull;

static const uint64_t P9N2_C_0_CPPM_CACCR_OR                                       = 0x200F016Aull;

static const uint64_t P9N2_C_1_CPPM_CACCR                                          = 0x210F0168ull;

static const uint64_t P9N2_C_1_CPPM_CACCR_CLEAR                                    = 0x210F0169ull;

static const uint64_t P9N2_C_1_CPPM_CACCR_OR                                       = 0x210F016Aull;

static const uint64_t P9N2_C_2_CPPM_CACCR                                          = 0x220F0168ull;

static const uint64_t P9N2_C_2_CPPM_CACCR_CLEAR                                    = 0x220F0169ull;

static const uint64_t P9N2_C_2_CPPM_CACCR_OR                                       = 0x220F016Aull;

static const uint64_t P9N2_C_3_CPPM_CACCR                                          = 0x230F0168ull;

static const uint64_t P9N2_C_3_CPPM_CACCR_CLEAR                                    = 0x230F0169ull;

static const uint64_t P9N2_C_3_CPPM_CACCR_OR                                       = 0x230F016Aull;

static const uint64_t P9N2_C_4_CPPM_CACCR                                          = 0x240F0168ull;

static const uint64_t P9N2_C_4_CPPM_CACCR_CLEAR                                    = 0x240F0169ull;

static const uint64_t P9N2_C_4_CPPM_CACCR_OR                                       = 0x240F016Aull;

static const uint64_t P9N2_C_5_CPPM_CACCR                                          = 0x250F0168ull;

static const uint64_t P9N2_C_5_CPPM_CACCR_CLEAR                                    = 0x250F0169ull;

static const uint64_t P9N2_C_5_CPPM_CACCR_OR                                       = 0x250F016Aull;

static const uint64_t P9N2_C_6_CPPM_CACCR                                          = 0x260F0168ull;

static const uint64_t P9N2_C_6_CPPM_CACCR_CLEAR                                    = 0x260F0169ull;

static const uint64_t P9N2_C_6_CPPM_CACCR_OR                                       = 0x260F016Aull;

static const uint64_t P9N2_C_7_CPPM_CACCR                                          = 0x270F0168ull;

static const uint64_t P9N2_C_7_CPPM_CACCR_CLEAR                                    = 0x270F0169ull;

static const uint64_t P9N2_C_7_CPPM_CACCR_OR                                       = 0x270F016Aull;

static const uint64_t P9N2_C_8_CPPM_CACCR                                          = 0x280F0168ull;

static const uint64_t P9N2_C_8_CPPM_CACCR_CLEAR                                    = 0x280F0169ull;

static const uint64_t P9N2_C_8_CPPM_CACCR_OR                                       = 0x280F016Aull;

static const uint64_t P9N2_C_9_CPPM_CACCR                                          = 0x290F0168ull;

static const uint64_t P9N2_C_9_CPPM_CACCR_CLEAR                                    = 0x290F0169ull;

static const uint64_t P9N2_C_9_CPPM_CACCR_OR                                       = 0x290F016Aull;

static const uint64_t P9N2_C_10_CPPM_CACCR                                         = 0x2A0F0168ull;

static const uint64_t P9N2_C_10_CPPM_CACCR_CLEAR                                   = 0x2A0F0169ull;

static const uint64_t P9N2_C_10_CPPM_CACCR_OR                                      = 0x2A0F016Aull;

static const uint64_t P9N2_C_11_CPPM_CACCR                                         = 0x2B0F0168ull;

static const uint64_t P9N2_C_11_CPPM_CACCR_CLEAR                                   = 0x2B0F0169ull;

static const uint64_t P9N2_C_11_CPPM_CACCR_OR                                      = 0x2B0F016Aull;

static const uint64_t P9N2_C_12_CPPM_CACCR                                         = 0x2C0F0168ull;

static const uint64_t P9N2_C_12_CPPM_CACCR_CLEAR                                   = 0x2C0F0169ull;

static const uint64_t P9N2_C_12_CPPM_CACCR_OR                                      = 0x2C0F016Aull;

static const uint64_t P9N2_C_13_CPPM_CACCR                                         = 0x2D0F0168ull;

static const uint64_t P9N2_C_13_CPPM_CACCR_CLEAR                                   = 0x2D0F0169ull;

static const uint64_t P9N2_C_13_CPPM_CACCR_OR                                      = 0x2D0F016Aull;

static const uint64_t P9N2_C_14_CPPM_CACCR                                         = 0x2E0F0168ull;

static const uint64_t P9N2_C_14_CPPM_CACCR_CLEAR                                   = 0x2E0F0169ull;

static const uint64_t P9N2_C_14_CPPM_CACCR_OR                                      = 0x2E0F016Aull;

static const uint64_t P9N2_C_15_CPPM_CACCR                                         = 0x2F0F0168ull;

static const uint64_t P9N2_C_15_CPPM_CACCR_CLEAR                                   = 0x2F0F0169ull;

static const uint64_t P9N2_C_15_CPPM_CACCR_OR                                      = 0x2F0F016Aull;

static const uint64_t P9N2_C_16_CPPM_CACCR                                         = 0x300F0168ull;

static const uint64_t P9N2_C_16_CPPM_CACCR_CLEAR                                   = 0x300F0169ull;

static const uint64_t P9N2_C_16_CPPM_CACCR_OR                                      = 0x300F016Aull;

static const uint64_t P9N2_C_17_CPPM_CACCR                                         = 0x310F0168ull;

static const uint64_t P9N2_C_17_CPPM_CACCR_CLEAR                                   = 0x310F0169ull;

static const uint64_t P9N2_C_17_CPPM_CACCR_OR                                      = 0x310F016Aull;

static const uint64_t P9N2_C_18_CPPM_CACCR                                         = 0x320F0168ull;

static const uint64_t P9N2_C_18_CPPM_CACCR_CLEAR                                   = 0x320F0169ull;

static const uint64_t P9N2_C_18_CPPM_CACCR_OR                                      = 0x320F016Aull;

static const uint64_t P9N2_C_19_CPPM_CACCR                                         = 0x330F0168ull;

static const uint64_t P9N2_C_19_CPPM_CACCR_CLEAR                                   = 0x330F0169ull;

static const uint64_t P9N2_C_19_CPPM_CACCR_OR                                      = 0x330F016Aull;

static const uint64_t P9N2_C_20_CPPM_CACCR                                         = 0x340F0168ull;

static const uint64_t P9N2_C_20_CPPM_CACCR_CLEAR                                   = 0x340F0169ull;

static const uint64_t P9N2_C_20_CPPM_CACCR_OR                                      = 0x340F016Aull;

static const uint64_t P9N2_C_21_CPPM_CACCR                                         = 0x350F0168ull;

static const uint64_t P9N2_C_21_CPPM_CACCR_CLEAR                                   = 0x350F0169ull;

static const uint64_t P9N2_C_21_CPPM_CACCR_OR                                      = 0x350F016Aull;

static const uint64_t P9N2_C_22_CPPM_CACCR                                         = 0x360F0168ull;

static const uint64_t P9N2_C_22_CPPM_CACCR_CLEAR                                   = 0x360F0169ull;

static const uint64_t P9N2_C_22_CPPM_CACCR_OR                                      = 0x360F016Aull;

static const uint64_t P9N2_C_23_CPPM_CACCR                                         = 0x370F0168ull;

static const uint64_t P9N2_C_23_CPPM_CACCR_CLEAR                                   = 0x370F0169ull;

static const uint64_t P9N2_C_23_CPPM_CACCR_OR                                      = 0x370F016Aull;

static const uint64_t P9N2_EX_CPPM_CACCR                                           = 0x200F0168ull;
//DUPS: 210F0168,
static const uint64_t P9N2_EX_CPPM_CACCR_CLEAR                                     = 0x200F0169ull;
//DUPS: 210F0169,
static const uint64_t P9N2_EX_CPPM_CACCR_OR                                        = 0x200F016Aull;
//DUPS: 210F016A,
static const uint64_t P9N2_EX_0_CPPM_CACCR                                         = 0x200F0168ull;
//DUPS: 210F0168,
static const uint64_t P9N2_EX_0_CPPM_CACCR_CLEAR                                   = 0x200F0169ull;
//DUPS: 210F0169,
static const uint64_t P9N2_EX_0_CPPM_CACCR_OR                                      = 0x200F016Aull;
//DUPS: 210F016A,
static const uint64_t P9N2_EX_1_CPPM_CACCR                                         = 0x220F0168ull;
//DUPS: 220F0168,
static const uint64_t P9N2_EX_1_CPPM_CACCR_CLEAR                                   = 0x220F0169ull;
//DUPS: 220F0169,
static const uint64_t P9N2_EX_1_CPPM_CACCR_OR                                      = 0x220F016Aull;
//DUPS: 220F016A,
static const uint64_t P9N2_EX_2_CPPM_CACCR                                         = 0x240F0168ull;
//DUPS: 250F0168,
static const uint64_t P9N2_EX_2_CPPM_CACCR_CLEAR                                   = 0x240F0169ull;
//DUPS: 250F0169,
static const uint64_t P9N2_EX_2_CPPM_CACCR_OR                                      = 0x240F016Aull;
//DUPS: 250F016A,
static const uint64_t P9N2_EX_3_CPPM_CACCR                                         = 0x260F0168ull;
//DUPS: 270F0168,
static const uint64_t P9N2_EX_3_CPPM_CACCR_CLEAR                                   = 0x260F0169ull;
//DUPS: 270F0169,
static const uint64_t P9N2_EX_3_CPPM_CACCR_OR                                      = 0x260F016Aull;
//DUPS: 270F016A,
static const uint64_t P9N2_EX_4_CPPM_CACCR                                         = 0x280F0168ull;
//DUPS: 290F0168,
static const uint64_t P9N2_EX_4_CPPM_CACCR_CLEAR                                   = 0x280F0169ull;
//DUPS: 290F0169,
static const uint64_t P9N2_EX_4_CPPM_CACCR_OR                                      = 0x280F016Aull;
//DUPS: 290F016A,
static const uint64_t P9N2_EX_5_CPPM_CACCR                                         = 0x2A0F0168ull;
//DUPS: 2B0F0168,
static const uint64_t P9N2_EX_5_CPPM_CACCR_CLEAR                                   = 0x2A0F0169ull;
//DUPS: 2B0F0169,
static const uint64_t P9N2_EX_5_CPPM_CACCR_OR                                      = 0x2A0F016Aull;
//DUPS: 2B0F016A,
static const uint64_t P9N2_EX_6_CPPM_CACCR                                         = 0x2C0F0168ull;
//DUPS: 2D0F0168,
static const uint64_t P9N2_EX_6_CPPM_CACCR_CLEAR                                   = 0x2C0F0169ull;
//DUPS: 2D0F0169,
static const uint64_t P9N2_EX_6_CPPM_CACCR_OR                                      = 0x2C0F016Aull;
//DUPS: 2D0F016A,
static const uint64_t P9N2_EX_7_CPPM_CACCR                                         = 0x2E0F0168ull;
//DUPS: 2F0F0168,
static const uint64_t P9N2_EX_7_CPPM_CACCR_CLEAR                                   = 0x2E0F0169ull;
//DUPS: 2F0F0169,
static const uint64_t P9N2_EX_7_CPPM_CACCR_OR                                      = 0x2E0F016Aull;
//DUPS: 2F0F016A,
static const uint64_t P9N2_EX_8_CPPM_CACCR                                         = 0x300F0168ull;
//DUPS: 310F0168,
static const uint64_t P9N2_EX_8_CPPM_CACCR_CLEAR                                   = 0x300F0169ull;
//DUPS: 310F0169,
static const uint64_t P9N2_EX_8_CPPM_CACCR_OR                                      = 0x300F016Aull;
//DUPS: 310F016A,
static const uint64_t P9N2_EX_9_CPPM_CACCR                                         = 0x320F0168ull;
//DUPS: 330F0168,
static const uint64_t P9N2_EX_9_CPPM_CACCR_CLEAR                                   = 0x320F0169ull;
//DUPS: 330F0169,
static const uint64_t P9N2_EX_9_CPPM_CACCR_OR                                      = 0x320F016Aull;
//DUPS: 330F016A,
static const uint64_t P9N2_EX_10_CPPM_CACCR                                        = 0x340F0168ull;
//DUPS: 350F0168,
static const uint64_t P9N2_EX_10_CPPM_CACCR_CLEAR                                  = 0x340F0169ull;
//DUPS: 350F0169,
static const uint64_t P9N2_EX_10_CPPM_CACCR_OR                                     = 0x340F016Aull;
//DUPS: 350F016A,
static const uint64_t P9N2_EX_11_CPPM_CACCR                                        = 0x360F0168ull;
//DUPS: 370F0168,
static const uint64_t P9N2_EX_11_CPPM_CACCR_CLEAR                                  = 0x360F0169ull;
//DUPS: 370F0169,
static const uint64_t P9N2_EX_11_CPPM_CACCR_OR                                     = 0x360F016Aull;
//DUPS: 370F016A,

static const uint64_t P9N2_C_CPPM_CACSR                                            = 0x200F016Bull;

static const uint64_t P9N2_C_0_CPPM_CACSR                                          = 0x200F016Bull;

static const uint64_t P9N2_C_1_CPPM_CACSR                                          = 0x210F016Bull;

static const uint64_t P9N2_C_2_CPPM_CACSR                                          = 0x220F016Bull;

static const uint64_t P9N2_C_3_CPPM_CACSR                                          = 0x230F016Bull;

static const uint64_t P9N2_C_4_CPPM_CACSR                                          = 0x240F016Bull;

static const uint64_t P9N2_C_5_CPPM_CACSR                                          = 0x250F016Bull;

static const uint64_t P9N2_C_6_CPPM_CACSR                                          = 0x260F016Bull;

static const uint64_t P9N2_C_7_CPPM_CACSR                                          = 0x270F016Bull;

static const uint64_t P9N2_C_8_CPPM_CACSR                                          = 0x280F016Bull;

static const uint64_t P9N2_C_9_CPPM_CACSR                                          = 0x290F016Bull;

static const uint64_t P9N2_C_10_CPPM_CACSR                                         = 0x2A0F016Bull;

static const uint64_t P9N2_C_11_CPPM_CACSR                                         = 0x2B0F016Bull;

static const uint64_t P9N2_C_12_CPPM_CACSR                                         = 0x2C0F016Bull;

static const uint64_t P9N2_C_13_CPPM_CACSR                                         = 0x2D0F016Bull;

static const uint64_t P9N2_C_14_CPPM_CACSR                                         = 0x2E0F016Bull;

static const uint64_t P9N2_C_15_CPPM_CACSR                                         = 0x2F0F016Bull;

static const uint64_t P9N2_C_16_CPPM_CACSR                                         = 0x300F016Bull;

static const uint64_t P9N2_C_17_CPPM_CACSR                                         = 0x310F016Bull;

static const uint64_t P9N2_C_18_CPPM_CACSR                                         = 0x320F016Bull;

static const uint64_t P9N2_C_19_CPPM_CACSR                                         = 0x330F016Bull;

static const uint64_t P9N2_C_20_CPPM_CACSR                                         = 0x340F016Bull;

static const uint64_t P9N2_C_21_CPPM_CACSR                                         = 0x350F016Bull;

static const uint64_t P9N2_C_22_CPPM_CACSR                                         = 0x360F016Bull;

static const uint64_t P9N2_C_23_CPPM_CACSR                                         = 0x370F016Bull;

static const uint64_t P9N2_EX_CPPM_CACSR                                           = 0x200F016Bull;
//DUPS: 210F016B,
static const uint64_t P9N2_EX_0_CPPM_CACSR                                         = 0x200F016Bull;
//DUPS: 210F016B,
static const uint64_t P9N2_EX_1_CPPM_CACSR                                         = 0x220F016Bull;
//DUPS: 220F016B,
static const uint64_t P9N2_EX_2_CPPM_CACSR                                         = 0x240F016Bull;
//DUPS: 250F016B,
static const uint64_t P9N2_EX_3_CPPM_CACSR                                         = 0x260F016Bull;
//DUPS: 270F016B,
static const uint64_t P9N2_EX_4_CPPM_CACSR                                         = 0x280F016Bull;
//DUPS: 290F016B,
static const uint64_t P9N2_EX_5_CPPM_CACSR                                         = 0x2A0F016Bull;
//DUPS: 2B0F016B,
static const uint64_t P9N2_EX_6_CPPM_CACSR                                         = 0x2C0F016Bull;
//DUPS: 2D0F016B,
static const uint64_t P9N2_EX_7_CPPM_CACSR                                         = 0x2E0F016Bull;
//DUPS: 2F0F016B,
static const uint64_t P9N2_EX_8_CPPM_CACSR                                         = 0x300F016Bull;
//DUPS: 310F016B,
static const uint64_t P9N2_EX_9_CPPM_CACSR                                         = 0x320F016Bull;
//DUPS: 330F016B,
static const uint64_t P9N2_EX_10_CPPM_CACSR                                        = 0x340F016Bull;
//DUPS: 350F016B,
static const uint64_t P9N2_EX_11_CPPM_CACSR                                        = 0x360F016Bull;
//DUPS: 370F016B,

static const uint64_t P9N2_C_CPPM_CIIR                                             = 0x200F01ADull;

static const uint64_t P9N2_C_0_CPPM_CIIR                                           = 0x200F01ADull;

static const uint64_t P9N2_C_1_CPPM_CIIR                                           = 0x210F01ADull;

static const uint64_t P9N2_C_2_CPPM_CIIR                                           = 0x220F01ADull;

static const uint64_t P9N2_C_3_CPPM_CIIR                                           = 0x230F01ADull;

static const uint64_t P9N2_C_4_CPPM_CIIR                                           = 0x240F01ADull;

static const uint64_t P9N2_C_5_CPPM_CIIR                                           = 0x250F01ADull;

static const uint64_t P9N2_C_6_CPPM_CIIR                                           = 0x260F01ADull;

static const uint64_t P9N2_C_7_CPPM_CIIR                                           = 0x270F01ADull;

static const uint64_t P9N2_C_8_CPPM_CIIR                                           = 0x280F01ADull;

static const uint64_t P9N2_C_9_CPPM_CIIR                                           = 0x290F01ADull;

static const uint64_t P9N2_C_10_CPPM_CIIR                                          = 0x2A0F01ADull;

static const uint64_t P9N2_C_11_CPPM_CIIR                                          = 0x2B0F01ADull;

static const uint64_t P9N2_C_12_CPPM_CIIR                                          = 0x2C0F01ADull;

static const uint64_t P9N2_C_13_CPPM_CIIR                                          = 0x2D0F01ADull;

static const uint64_t P9N2_C_14_CPPM_CIIR                                          = 0x2E0F01ADull;

static const uint64_t P9N2_C_15_CPPM_CIIR                                          = 0x2F0F01ADull;

static const uint64_t P9N2_C_16_CPPM_CIIR                                          = 0x300F01ADull;

static const uint64_t P9N2_C_17_CPPM_CIIR                                          = 0x310F01ADull;

static const uint64_t P9N2_C_18_CPPM_CIIR                                          = 0x320F01ADull;

static const uint64_t P9N2_C_19_CPPM_CIIR                                          = 0x330F01ADull;

static const uint64_t P9N2_C_20_CPPM_CIIR                                          = 0x340F01ADull;

static const uint64_t P9N2_C_21_CPPM_CIIR                                          = 0x350F01ADull;

static const uint64_t P9N2_C_22_CPPM_CIIR                                          = 0x360F01ADull;

static const uint64_t P9N2_C_23_CPPM_CIIR                                          = 0x370F01ADull;

static const uint64_t P9N2_EX_CPPM_CIIR                                            = 0x200F01ADull;
//DUPS: 210F01AD,
static const uint64_t P9N2_EX_0_CPPM_CIIR                                          = 0x200F01ADull;
//DUPS: 210F01AD,
static const uint64_t P9N2_EX_1_CPPM_CIIR                                          = 0x220F01ADull;
//DUPS: 220F01AD,
static const uint64_t P9N2_EX_2_CPPM_CIIR                                          = 0x240F01ADull;
//DUPS: 250F01AD,
static const uint64_t P9N2_EX_3_CPPM_CIIR                                          = 0x260F01ADull;
//DUPS: 270F01AD,
static const uint64_t P9N2_EX_4_CPPM_CIIR                                          = 0x280F01ADull;
//DUPS: 290F01AD,
static const uint64_t P9N2_EX_5_CPPM_CIIR                                          = 0x2A0F01ADull;
//DUPS: 2B0F01AD,
static const uint64_t P9N2_EX_6_CPPM_CIIR                                          = 0x2C0F01ADull;
//DUPS: 2D0F01AD,
static const uint64_t P9N2_EX_7_CPPM_CIIR                                          = 0x2E0F01ADull;
//DUPS: 2F0F01AD,
static const uint64_t P9N2_EX_8_CPPM_CIIR                                          = 0x300F01ADull;
//DUPS: 310F01AD,
static const uint64_t P9N2_EX_9_CPPM_CIIR                                          = 0x320F01ADull;
//DUPS: 330F01AD,
static const uint64_t P9N2_EX_10_CPPM_CIIR                                         = 0x340F01ADull;
//DUPS: 350F01AD,
static const uint64_t P9N2_EX_11_CPPM_CIIR                                         = 0x360F01ADull;
//DUPS: 370F01AD,

static const uint64_t P9N2_C_CPPM_CISR                                             = 0x200F01AEull;

static const uint64_t P9N2_C_0_CPPM_CISR                                           = 0x200F01AEull;

static const uint64_t P9N2_C_1_CPPM_CISR                                           = 0x210F01AEull;

static const uint64_t P9N2_C_2_CPPM_CISR                                           = 0x220F01AEull;

static const uint64_t P9N2_C_3_CPPM_CISR                                           = 0x230F01AEull;

static const uint64_t P9N2_C_4_CPPM_CISR                                           = 0x240F01AEull;

static const uint64_t P9N2_C_5_CPPM_CISR                                           = 0x250F01AEull;

static const uint64_t P9N2_C_6_CPPM_CISR                                           = 0x260F01AEull;

static const uint64_t P9N2_C_7_CPPM_CISR                                           = 0x270F01AEull;

static const uint64_t P9N2_C_8_CPPM_CISR                                           = 0x280F01AEull;

static const uint64_t P9N2_C_9_CPPM_CISR                                           = 0x290F01AEull;

static const uint64_t P9N2_C_10_CPPM_CISR                                          = 0x2A0F01AEull;

static const uint64_t P9N2_C_11_CPPM_CISR                                          = 0x2B0F01AEull;

static const uint64_t P9N2_C_12_CPPM_CISR                                          = 0x2C0F01AEull;

static const uint64_t P9N2_C_13_CPPM_CISR                                          = 0x2D0F01AEull;

static const uint64_t P9N2_C_14_CPPM_CISR                                          = 0x2E0F01AEull;

static const uint64_t P9N2_C_15_CPPM_CISR                                          = 0x2F0F01AEull;

static const uint64_t P9N2_C_16_CPPM_CISR                                          = 0x300F01AEull;

static const uint64_t P9N2_C_17_CPPM_CISR                                          = 0x310F01AEull;

static const uint64_t P9N2_C_18_CPPM_CISR                                          = 0x320F01AEull;

static const uint64_t P9N2_C_19_CPPM_CISR                                          = 0x330F01AEull;

static const uint64_t P9N2_C_20_CPPM_CISR                                          = 0x340F01AEull;

static const uint64_t P9N2_C_21_CPPM_CISR                                          = 0x350F01AEull;

static const uint64_t P9N2_C_22_CPPM_CISR                                          = 0x360F01AEull;

static const uint64_t P9N2_C_23_CPPM_CISR                                          = 0x370F01AEull;

static const uint64_t P9N2_EX_CPPM_CISR                                            = 0x200F01AEull;
//DUPS: 210F01AE,
static const uint64_t P9N2_EX_0_CPPM_CISR                                          = 0x200F01AEull;
//DUPS: 210F01AE,
static const uint64_t P9N2_EX_1_CPPM_CISR                                          = 0x220F01AEull;
//DUPS: 220F01AE,
static const uint64_t P9N2_EX_2_CPPM_CISR                                          = 0x240F01AEull;
//DUPS: 250F01AE,
static const uint64_t P9N2_EX_3_CPPM_CISR                                          = 0x260F01AEull;
//DUPS: 270F01AE,
static const uint64_t P9N2_EX_4_CPPM_CISR                                          = 0x280F01AEull;
//DUPS: 290F01AE,
static const uint64_t P9N2_EX_5_CPPM_CISR                                          = 0x2A0F01AEull;
//DUPS: 2B0F01AE,
static const uint64_t P9N2_EX_6_CPPM_CISR                                          = 0x2C0F01AEull;
//DUPS: 2D0F01AE,
static const uint64_t P9N2_EX_7_CPPM_CISR                                          = 0x2E0F01AEull;
//DUPS: 2F0F01AE,
static const uint64_t P9N2_EX_8_CPPM_CISR                                          = 0x300F01AEull;
//DUPS: 310F01AE,
static const uint64_t P9N2_EX_9_CPPM_CISR                                          = 0x320F01AEull;
//DUPS: 330F01AE,
static const uint64_t P9N2_EX_10_CPPM_CISR                                         = 0x340F01AEull;
//DUPS: 350F01AE,
static const uint64_t P9N2_EX_11_CPPM_CISR                                         = 0x360F01AEull;
//DUPS: 370F01AE,

static const uint64_t P9N2_C_CPPM_CIVRMLCR                                         = 0x200F01B7ull;

static const uint64_t P9N2_C_0_CPPM_CIVRMLCR                                       = 0x200F01B7ull;

static const uint64_t P9N2_C_1_CPPM_CIVRMLCR                                       = 0x210F01B7ull;

static const uint64_t P9N2_C_2_CPPM_CIVRMLCR                                       = 0x220F01B7ull;

static const uint64_t P9N2_C_3_CPPM_CIVRMLCR                                       = 0x230F01B7ull;

static const uint64_t P9N2_C_4_CPPM_CIVRMLCR                                       = 0x240F01B7ull;

static const uint64_t P9N2_C_5_CPPM_CIVRMLCR                                       = 0x250F01B7ull;

static const uint64_t P9N2_C_6_CPPM_CIVRMLCR                                       = 0x260F01B7ull;

static const uint64_t P9N2_C_7_CPPM_CIVRMLCR                                       = 0x270F01B7ull;

static const uint64_t P9N2_C_8_CPPM_CIVRMLCR                                       = 0x280F01B7ull;

static const uint64_t P9N2_C_9_CPPM_CIVRMLCR                                       = 0x290F01B7ull;

static const uint64_t P9N2_C_10_CPPM_CIVRMLCR                                      = 0x2A0F01B7ull;

static const uint64_t P9N2_C_11_CPPM_CIVRMLCR                                      = 0x2B0F01B7ull;

static const uint64_t P9N2_C_12_CPPM_CIVRMLCR                                      = 0x2C0F01B7ull;

static const uint64_t P9N2_C_13_CPPM_CIVRMLCR                                      = 0x2D0F01B7ull;

static const uint64_t P9N2_C_14_CPPM_CIVRMLCR                                      = 0x2E0F01B7ull;

static const uint64_t P9N2_C_15_CPPM_CIVRMLCR                                      = 0x2F0F01B7ull;

static const uint64_t P9N2_C_16_CPPM_CIVRMLCR                                      = 0x300F01B7ull;

static const uint64_t P9N2_C_17_CPPM_CIVRMLCR                                      = 0x310F01B7ull;

static const uint64_t P9N2_C_18_CPPM_CIVRMLCR                                      = 0x320F01B7ull;

static const uint64_t P9N2_C_19_CPPM_CIVRMLCR                                      = 0x330F01B7ull;

static const uint64_t P9N2_C_20_CPPM_CIVRMLCR                                      = 0x340F01B7ull;

static const uint64_t P9N2_C_21_CPPM_CIVRMLCR                                      = 0x350F01B7ull;

static const uint64_t P9N2_C_22_CPPM_CIVRMLCR                                      = 0x360F01B7ull;

static const uint64_t P9N2_C_23_CPPM_CIVRMLCR                                      = 0x370F01B7ull;

static const uint64_t P9N2_EX_CPPM_CIVRMLCR                                        = 0x200F01B7ull;
//DUPS: 210F01B7,
static const uint64_t P9N2_EX_0_CPPM_CIVRMLCR                                      = 0x200F01B7ull;
//DUPS: 210F01B7,
static const uint64_t P9N2_EX_1_CPPM_CIVRMLCR                                      = 0x220F01B7ull;
//DUPS: 220F01B7,
static const uint64_t P9N2_EX_2_CPPM_CIVRMLCR                                      = 0x240F01B7ull;
//DUPS: 250F01B7,
static const uint64_t P9N2_EX_3_CPPM_CIVRMLCR                                      = 0x260F01B7ull;
//DUPS: 270F01B7,
static const uint64_t P9N2_EX_4_CPPM_CIVRMLCR                                      = 0x280F01B7ull;
//DUPS: 290F01B7,
static const uint64_t P9N2_EX_5_CPPM_CIVRMLCR                                      = 0x2A0F01B7ull;
//DUPS: 2B0F01B7,
static const uint64_t P9N2_EX_6_CPPM_CIVRMLCR                                      = 0x2C0F01B7ull;
//DUPS: 2D0F01B7,
static const uint64_t P9N2_EX_7_CPPM_CIVRMLCR                                      = 0x2E0F01B7ull;
//DUPS: 2F0F01B7,
static const uint64_t P9N2_EX_8_CPPM_CIVRMLCR                                      = 0x300F01B7ull;
//DUPS: 310F01B7,
static const uint64_t P9N2_EX_9_CPPM_CIVRMLCR                                      = 0x320F01B7ull;
//DUPS: 330F01B7,
static const uint64_t P9N2_EX_10_CPPM_CIVRMLCR                                     = 0x340F01B7ull;
//DUPS: 350F01B7,
static const uint64_t P9N2_EX_11_CPPM_CIVRMLCR                                     = 0x360F01B7ull;
//DUPS: 370F01B7,

static const uint64_t P9N2_C_CPPM_CMEDATA                                          = 0x200F01A8ull;

static const uint64_t P9N2_C_CPPM_CMEDATA_CLEAR                                    = 0x200F01A9ull;

static const uint64_t P9N2_C_CPPM_CMEDATA_OR                                       = 0x200F01AAull;

static const uint64_t P9N2_C_0_CPPM_CMEDATA                                        = 0x200F01A8ull;

static const uint64_t P9N2_C_0_CPPM_CMEDATA_CLEAR                                  = 0x200F01A9ull;

static const uint64_t P9N2_C_0_CPPM_CMEDATA_OR                                     = 0x200F01AAull;

static const uint64_t P9N2_C_1_CPPM_CMEDATA                                        = 0x210F01A8ull;

static const uint64_t P9N2_C_1_CPPM_CMEDATA_CLEAR                                  = 0x210F01A9ull;

static const uint64_t P9N2_C_1_CPPM_CMEDATA_OR                                     = 0x210F01AAull;

static const uint64_t P9N2_C_2_CPPM_CMEDATA                                        = 0x220F01A8ull;

static const uint64_t P9N2_C_2_CPPM_CMEDATA_CLEAR                                  = 0x220F01A9ull;

static const uint64_t P9N2_C_2_CPPM_CMEDATA_OR                                     = 0x220F01AAull;

static const uint64_t P9N2_C_3_CPPM_CMEDATA                                        = 0x230F01A8ull;

static const uint64_t P9N2_C_3_CPPM_CMEDATA_CLEAR                                  = 0x230F01A9ull;

static const uint64_t P9N2_C_3_CPPM_CMEDATA_OR                                     = 0x230F01AAull;

static const uint64_t P9N2_C_4_CPPM_CMEDATA                                        = 0x240F01A8ull;

static const uint64_t P9N2_C_4_CPPM_CMEDATA_CLEAR                                  = 0x240F01A9ull;

static const uint64_t P9N2_C_4_CPPM_CMEDATA_OR                                     = 0x240F01AAull;

static const uint64_t P9N2_C_5_CPPM_CMEDATA                                        = 0x250F01A8ull;

static const uint64_t P9N2_C_5_CPPM_CMEDATA_CLEAR                                  = 0x250F01A9ull;

static const uint64_t P9N2_C_5_CPPM_CMEDATA_OR                                     = 0x250F01AAull;

static const uint64_t P9N2_C_6_CPPM_CMEDATA                                        = 0x260F01A8ull;

static const uint64_t P9N2_C_6_CPPM_CMEDATA_CLEAR                                  = 0x260F01A9ull;

static const uint64_t P9N2_C_6_CPPM_CMEDATA_OR                                     = 0x260F01AAull;

static const uint64_t P9N2_C_7_CPPM_CMEDATA                                        = 0x270F01A8ull;

static const uint64_t P9N2_C_7_CPPM_CMEDATA_CLEAR                                  = 0x270F01A9ull;

static const uint64_t P9N2_C_7_CPPM_CMEDATA_OR                                     = 0x270F01AAull;

static const uint64_t P9N2_C_8_CPPM_CMEDATA                                        = 0x280F01A8ull;

static const uint64_t P9N2_C_8_CPPM_CMEDATA_CLEAR                                  = 0x280F01A9ull;

static const uint64_t P9N2_C_8_CPPM_CMEDATA_OR                                     = 0x280F01AAull;

static const uint64_t P9N2_C_9_CPPM_CMEDATA                                        = 0x290F01A8ull;

static const uint64_t P9N2_C_9_CPPM_CMEDATA_CLEAR                                  = 0x290F01A9ull;

static const uint64_t P9N2_C_9_CPPM_CMEDATA_OR                                     = 0x290F01AAull;

static const uint64_t P9N2_C_10_CPPM_CMEDATA                                       = 0x2A0F01A8ull;

static const uint64_t P9N2_C_10_CPPM_CMEDATA_CLEAR                                 = 0x2A0F01A9ull;

static const uint64_t P9N2_C_10_CPPM_CMEDATA_OR                                    = 0x2A0F01AAull;

static const uint64_t P9N2_C_11_CPPM_CMEDATA                                       = 0x2B0F01A8ull;

static const uint64_t P9N2_C_11_CPPM_CMEDATA_CLEAR                                 = 0x2B0F01A9ull;

static const uint64_t P9N2_C_11_CPPM_CMEDATA_OR                                    = 0x2B0F01AAull;

static const uint64_t P9N2_C_12_CPPM_CMEDATA                                       = 0x2C0F01A8ull;

static const uint64_t P9N2_C_12_CPPM_CMEDATA_CLEAR                                 = 0x2C0F01A9ull;

static const uint64_t P9N2_C_12_CPPM_CMEDATA_OR                                    = 0x2C0F01AAull;

static const uint64_t P9N2_C_13_CPPM_CMEDATA                                       = 0x2D0F01A8ull;

static const uint64_t P9N2_C_13_CPPM_CMEDATA_CLEAR                                 = 0x2D0F01A9ull;

static const uint64_t P9N2_C_13_CPPM_CMEDATA_OR                                    = 0x2D0F01AAull;

static const uint64_t P9N2_C_14_CPPM_CMEDATA                                       = 0x2E0F01A8ull;

static const uint64_t P9N2_C_14_CPPM_CMEDATA_CLEAR                                 = 0x2E0F01A9ull;

static const uint64_t P9N2_C_14_CPPM_CMEDATA_OR                                    = 0x2E0F01AAull;

static const uint64_t P9N2_C_15_CPPM_CMEDATA                                       = 0x2F0F01A8ull;

static const uint64_t P9N2_C_15_CPPM_CMEDATA_CLEAR                                 = 0x2F0F01A9ull;

static const uint64_t P9N2_C_15_CPPM_CMEDATA_OR                                    = 0x2F0F01AAull;

static const uint64_t P9N2_C_16_CPPM_CMEDATA                                       = 0x300F01A8ull;

static const uint64_t P9N2_C_16_CPPM_CMEDATA_CLEAR                                 = 0x300F01A9ull;

static const uint64_t P9N2_C_16_CPPM_CMEDATA_OR                                    = 0x300F01AAull;

static const uint64_t P9N2_C_17_CPPM_CMEDATA                                       = 0x310F01A8ull;

static const uint64_t P9N2_C_17_CPPM_CMEDATA_CLEAR                                 = 0x310F01A9ull;

static const uint64_t P9N2_C_17_CPPM_CMEDATA_OR                                    = 0x310F01AAull;

static const uint64_t P9N2_C_18_CPPM_CMEDATA                                       = 0x320F01A8ull;

static const uint64_t P9N2_C_18_CPPM_CMEDATA_CLEAR                                 = 0x320F01A9ull;

static const uint64_t P9N2_C_18_CPPM_CMEDATA_OR                                    = 0x320F01AAull;

static const uint64_t P9N2_C_19_CPPM_CMEDATA                                       = 0x330F01A8ull;

static const uint64_t P9N2_C_19_CPPM_CMEDATA_CLEAR                                 = 0x330F01A9ull;

static const uint64_t P9N2_C_19_CPPM_CMEDATA_OR                                    = 0x330F01AAull;

static const uint64_t P9N2_C_20_CPPM_CMEDATA                                       = 0x340F01A8ull;

static const uint64_t P9N2_C_20_CPPM_CMEDATA_CLEAR                                 = 0x340F01A9ull;

static const uint64_t P9N2_C_20_CPPM_CMEDATA_OR                                    = 0x340F01AAull;

static const uint64_t P9N2_C_21_CPPM_CMEDATA                                       = 0x350F01A8ull;

static const uint64_t P9N2_C_21_CPPM_CMEDATA_CLEAR                                 = 0x350F01A9ull;

static const uint64_t P9N2_C_21_CPPM_CMEDATA_OR                                    = 0x350F01AAull;

static const uint64_t P9N2_C_22_CPPM_CMEDATA                                       = 0x360F01A8ull;

static const uint64_t P9N2_C_22_CPPM_CMEDATA_CLEAR                                 = 0x360F01A9ull;

static const uint64_t P9N2_C_22_CPPM_CMEDATA_OR                                    = 0x360F01AAull;

static const uint64_t P9N2_C_23_CPPM_CMEDATA                                       = 0x370F01A8ull;

static const uint64_t P9N2_C_23_CPPM_CMEDATA_CLEAR                                 = 0x370F01A9ull;

static const uint64_t P9N2_C_23_CPPM_CMEDATA_OR                                    = 0x370F01AAull;

static const uint64_t P9N2_EX_CPPM_CMEDATA                                         = 0x200F01A8ull;
//DUPS: 210F01A8,
static const uint64_t P9N2_EX_CPPM_CMEDATA_CLEAR                                   = 0x200F01A9ull;
//DUPS: 210F01A9,
static const uint64_t P9N2_EX_CPPM_CMEDATA_OR                                      = 0x200F01AAull;
//DUPS: 210F01AA,
static const uint64_t P9N2_EX_0_CPPM_CMEDATA                                       = 0x200F01A8ull;
//DUPS: 210F01A8,
static const uint64_t P9N2_EX_0_CPPM_CMEDATA_CLEAR                                 = 0x200F01A9ull;
//DUPS: 210F01A9,
static const uint64_t P9N2_EX_0_CPPM_CMEDATA_OR                                    = 0x200F01AAull;
//DUPS: 210F01AA,
static const uint64_t P9N2_EX_1_CPPM_CMEDATA                                       = 0x220F01A8ull;
//DUPS: 220F01A8,
static const uint64_t P9N2_EX_1_CPPM_CMEDATA_CLEAR                                 = 0x220F01A9ull;
//DUPS: 220F01A9,
static const uint64_t P9N2_EX_1_CPPM_CMEDATA_OR                                    = 0x220F01AAull;
//DUPS: 220F01AA,
static const uint64_t P9N2_EX_2_CPPM_CMEDATA                                       = 0x240F01A8ull;
//DUPS: 250F01A8,
static const uint64_t P9N2_EX_2_CPPM_CMEDATA_CLEAR                                 = 0x240F01A9ull;
//DUPS: 250F01A9,
static const uint64_t P9N2_EX_2_CPPM_CMEDATA_OR                                    = 0x240F01AAull;
//DUPS: 250F01AA,
static const uint64_t P9N2_EX_3_CPPM_CMEDATA                                       = 0x260F01A8ull;
//DUPS: 270F01A8,
static const uint64_t P9N2_EX_3_CPPM_CMEDATA_CLEAR                                 = 0x260F01A9ull;
//DUPS: 270F01A9,
static const uint64_t P9N2_EX_3_CPPM_CMEDATA_OR                                    = 0x260F01AAull;
//DUPS: 270F01AA,
static const uint64_t P9N2_EX_4_CPPM_CMEDATA                                       = 0x280F01A8ull;
//DUPS: 290F01A8,
static const uint64_t P9N2_EX_4_CPPM_CMEDATA_CLEAR                                 = 0x280F01A9ull;
//DUPS: 290F01A9,
static const uint64_t P9N2_EX_4_CPPM_CMEDATA_OR                                    = 0x280F01AAull;
//DUPS: 290F01AA,
static const uint64_t P9N2_EX_5_CPPM_CMEDATA                                       = 0x2A0F01A8ull;
//DUPS: 2B0F01A8,
static const uint64_t P9N2_EX_5_CPPM_CMEDATA_CLEAR                                 = 0x2A0F01A9ull;
//DUPS: 2B0F01A9,
static const uint64_t P9N2_EX_5_CPPM_CMEDATA_OR                                    = 0x2A0F01AAull;
//DUPS: 2B0F01AA,
static const uint64_t P9N2_EX_6_CPPM_CMEDATA                                       = 0x2C0F01A8ull;
//DUPS: 2D0F01A8,
static const uint64_t P9N2_EX_6_CPPM_CMEDATA_CLEAR                                 = 0x2C0F01A9ull;
//DUPS: 2D0F01A9,
static const uint64_t P9N2_EX_6_CPPM_CMEDATA_OR                                    = 0x2C0F01AAull;
//DUPS: 2D0F01AA,
static const uint64_t P9N2_EX_7_CPPM_CMEDATA                                       = 0x2E0F01A8ull;
//DUPS: 2F0F01A8,
static const uint64_t P9N2_EX_7_CPPM_CMEDATA_CLEAR                                 = 0x2E0F01A9ull;
//DUPS: 2F0F01A9,
static const uint64_t P9N2_EX_7_CPPM_CMEDATA_OR                                    = 0x2E0F01AAull;
//DUPS: 2F0F01AA,
static const uint64_t P9N2_EX_8_CPPM_CMEDATA                                       = 0x300F01A8ull;
//DUPS: 310F01A8,
static const uint64_t P9N2_EX_8_CPPM_CMEDATA_CLEAR                                 = 0x300F01A9ull;
//DUPS: 310F01A9,
static const uint64_t P9N2_EX_8_CPPM_CMEDATA_OR                                    = 0x300F01AAull;
//DUPS: 310F01AA,
static const uint64_t P9N2_EX_9_CPPM_CMEDATA                                       = 0x320F01A8ull;
//DUPS: 330F01A8,
static const uint64_t P9N2_EX_9_CPPM_CMEDATA_CLEAR                                 = 0x320F01A9ull;
//DUPS: 330F01A9,
static const uint64_t P9N2_EX_9_CPPM_CMEDATA_OR                                    = 0x320F01AAull;
//DUPS: 330F01AA,
static const uint64_t P9N2_EX_10_CPPM_CMEDATA                                      = 0x340F01A8ull;
//DUPS: 350F01A8,
static const uint64_t P9N2_EX_10_CPPM_CMEDATA_CLEAR                                = 0x340F01A9ull;
//DUPS: 350F01A9,
static const uint64_t P9N2_EX_10_CPPM_CMEDATA_OR                                   = 0x340F01AAull;
//DUPS: 350F01AA,
static const uint64_t P9N2_EX_11_CPPM_CMEDATA                                      = 0x360F01A8ull;
//DUPS: 370F01A8,
static const uint64_t P9N2_EX_11_CPPM_CMEDATA_CLEAR                                = 0x360F01A9ull;
//DUPS: 370F01A9,
static const uint64_t P9N2_EX_11_CPPM_CMEDATA_OR                                   = 0x360F01AAull;
//DUPS: 370F01AA,

static const uint64_t P9N2_C_CPPM_CMEDB0                                           = 0x200F0190ull;

static const uint64_t P9N2_C_CPPM_CMEDB0_CLEAR                                     = 0x200F0191ull;

static const uint64_t P9N2_C_CPPM_CMEDB0_OR                                        = 0x200F0192ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB0                                         = 0x200F0190ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB0_CLEAR                                   = 0x200F0191ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB0_OR                                      = 0x200F0192ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB0                                         = 0x210F0190ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB0_CLEAR                                   = 0x210F0191ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB0_OR                                      = 0x210F0192ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB0                                         = 0x220F0190ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB0_CLEAR                                   = 0x220F0191ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB0_OR                                      = 0x220F0192ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB0                                         = 0x230F0190ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB0_CLEAR                                   = 0x230F0191ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB0_OR                                      = 0x230F0192ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB0                                         = 0x240F0190ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB0_CLEAR                                   = 0x240F0191ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB0_OR                                      = 0x240F0192ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB0                                         = 0x250F0190ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB0_CLEAR                                   = 0x250F0191ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB0_OR                                      = 0x250F0192ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB0                                         = 0x260F0190ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB0_CLEAR                                   = 0x260F0191ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB0_OR                                      = 0x260F0192ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB0                                         = 0x270F0190ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB0_CLEAR                                   = 0x270F0191ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB0_OR                                      = 0x270F0192ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB0                                         = 0x280F0190ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB0_CLEAR                                   = 0x280F0191ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB0_OR                                      = 0x280F0192ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB0                                         = 0x290F0190ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB0_CLEAR                                   = 0x290F0191ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB0_OR                                      = 0x290F0192ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB0                                        = 0x2A0F0190ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB0_CLEAR                                  = 0x2A0F0191ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB0_OR                                     = 0x2A0F0192ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB0                                        = 0x2B0F0190ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB0_CLEAR                                  = 0x2B0F0191ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB0_OR                                     = 0x2B0F0192ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB0                                        = 0x2C0F0190ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB0_CLEAR                                  = 0x2C0F0191ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB0_OR                                     = 0x2C0F0192ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB0                                        = 0x2D0F0190ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB0_CLEAR                                  = 0x2D0F0191ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB0_OR                                     = 0x2D0F0192ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB0                                        = 0x2E0F0190ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB0_CLEAR                                  = 0x2E0F0191ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB0_OR                                     = 0x2E0F0192ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB0                                        = 0x2F0F0190ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB0_CLEAR                                  = 0x2F0F0191ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB0_OR                                     = 0x2F0F0192ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB0                                        = 0x300F0190ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB0_CLEAR                                  = 0x300F0191ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB0_OR                                     = 0x300F0192ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB0                                        = 0x310F0190ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB0_CLEAR                                  = 0x310F0191ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB0_OR                                     = 0x310F0192ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB0                                        = 0x320F0190ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB0_CLEAR                                  = 0x320F0191ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB0_OR                                     = 0x320F0192ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB0                                        = 0x330F0190ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB0_CLEAR                                  = 0x330F0191ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB0_OR                                     = 0x330F0192ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB0                                        = 0x340F0190ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB0_CLEAR                                  = 0x340F0191ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB0_OR                                     = 0x340F0192ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB0                                        = 0x350F0190ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB0_CLEAR                                  = 0x350F0191ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB0_OR                                     = 0x350F0192ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB0                                        = 0x360F0190ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB0_CLEAR                                  = 0x360F0191ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB0_OR                                     = 0x360F0192ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB0                                        = 0x370F0190ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB0_CLEAR                                  = 0x370F0191ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB0_OR                                     = 0x370F0192ull;

static const uint64_t P9N2_EX_CPPM_CMEDB0                                          = 0x200F0190ull;
//DUPS: 210F0190,
static const uint64_t P9N2_EX_CPPM_CMEDB0_CLEAR                                    = 0x200F0191ull;
//DUPS: 210F0191,
static const uint64_t P9N2_EX_CPPM_CMEDB0_OR                                       = 0x200F0192ull;
//DUPS: 210F0192,
static const uint64_t P9N2_EX_0_CPPM_CMEDB0                                        = 0x200F0190ull;
//DUPS: 210F0190,
static const uint64_t P9N2_EX_0_CPPM_CMEDB0_CLEAR                                  = 0x200F0191ull;
//DUPS: 210F0191,
static const uint64_t P9N2_EX_0_CPPM_CMEDB0_OR                                     = 0x200F0192ull;
//DUPS: 210F0192,
static const uint64_t P9N2_EX_1_CPPM_CMEDB0                                        = 0x220F0190ull;
//DUPS: 220F0190,
static const uint64_t P9N2_EX_1_CPPM_CMEDB0_CLEAR                                  = 0x220F0191ull;
//DUPS: 220F0191,
static const uint64_t P9N2_EX_1_CPPM_CMEDB0_OR                                     = 0x220F0192ull;
//DUPS: 220F0192,
static const uint64_t P9N2_EX_2_CPPM_CMEDB0                                        = 0x240F0190ull;
//DUPS: 250F0190,
static const uint64_t P9N2_EX_2_CPPM_CMEDB0_CLEAR                                  = 0x240F0191ull;
//DUPS: 250F0191,
static const uint64_t P9N2_EX_2_CPPM_CMEDB0_OR                                     = 0x240F0192ull;
//DUPS: 250F0192,
static const uint64_t P9N2_EX_3_CPPM_CMEDB0                                        = 0x260F0190ull;
//DUPS: 270F0190,
static const uint64_t P9N2_EX_3_CPPM_CMEDB0_CLEAR                                  = 0x260F0191ull;
//DUPS: 270F0191,
static const uint64_t P9N2_EX_3_CPPM_CMEDB0_OR                                     = 0x260F0192ull;
//DUPS: 270F0192,
static const uint64_t P9N2_EX_4_CPPM_CMEDB0                                        = 0x280F0190ull;
//DUPS: 290F0190,
static const uint64_t P9N2_EX_4_CPPM_CMEDB0_CLEAR                                  = 0x280F0191ull;
//DUPS: 290F0191,
static const uint64_t P9N2_EX_4_CPPM_CMEDB0_OR                                     = 0x280F0192ull;
//DUPS: 290F0192,
static const uint64_t P9N2_EX_5_CPPM_CMEDB0                                        = 0x2A0F0190ull;
//DUPS: 2B0F0190,
static const uint64_t P9N2_EX_5_CPPM_CMEDB0_CLEAR                                  = 0x2A0F0191ull;
//DUPS: 2B0F0191,
static const uint64_t P9N2_EX_5_CPPM_CMEDB0_OR                                     = 0x2A0F0192ull;
//DUPS: 2B0F0192,
static const uint64_t P9N2_EX_6_CPPM_CMEDB0                                        = 0x2C0F0190ull;
//DUPS: 2D0F0190,
static const uint64_t P9N2_EX_6_CPPM_CMEDB0_CLEAR                                  = 0x2C0F0191ull;
//DUPS: 2D0F0191,
static const uint64_t P9N2_EX_6_CPPM_CMEDB0_OR                                     = 0x2C0F0192ull;
//DUPS: 2D0F0192,
static const uint64_t P9N2_EX_7_CPPM_CMEDB0                                        = 0x2E0F0190ull;
//DUPS: 2F0F0190,
static const uint64_t P9N2_EX_7_CPPM_CMEDB0_CLEAR                                  = 0x2E0F0191ull;
//DUPS: 2F0F0191,
static const uint64_t P9N2_EX_7_CPPM_CMEDB0_OR                                     = 0x2E0F0192ull;
//DUPS: 2F0F0192,
static const uint64_t P9N2_EX_8_CPPM_CMEDB0                                        = 0x300F0190ull;
//DUPS: 310F0190,
static const uint64_t P9N2_EX_8_CPPM_CMEDB0_CLEAR                                  = 0x300F0191ull;
//DUPS: 310F0191,
static const uint64_t P9N2_EX_8_CPPM_CMEDB0_OR                                     = 0x300F0192ull;
//DUPS: 310F0192,
static const uint64_t P9N2_EX_9_CPPM_CMEDB0                                        = 0x320F0190ull;
//DUPS: 330F0190,
static const uint64_t P9N2_EX_9_CPPM_CMEDB0_CLEAR                                  = 0x320F0191ull;
//DUPS: 330F0191,
static const uint64_t P9N2_EX_9_CPPM_CMEDB0_OR                                     = 0x320F0192ull;
//DUPS: 330F0192,
static const uint64_t P9N2_EX_10_CPPM_CMEDB0                                       = 0x340F0190ull;
//DUPS: 350F0190,
static const uint64_t P9N2_EX_10_CPPM_CMEDB0_CLEAR                                 = 0x340F0191ull;
//DUPS: 350F0191,
static const uint64_t P9N2_EX_10_CPPM_CMEDB0_OR                                    = 0x340F0192ull;
//DUPS: 350F0192,
static const uint64_t P9N2_EX_11_CPPM_CMEDB0                                       = 0x360F0190ull;
//DUPS: 370F0190,
static const uint64_t P9N2_EX_11_CPPM_CMEDB0_CLEAR                                 = 0x360F0191ull;
//DUPS: 370F0191,
static const uint64_t P9N2_EX_11_CPPM_CMEDB0_OR                                    = 0x360F0192ull;
//DUPS: 370F0192,

static const uint64_t P9N2_C_CPPM_CMEDB1                                           = 0x200F0194ull;

static const uint64_t P9N2_C_CPPM_CMEDB1_CLEAR                                     = 0x200F0195ull;

static const uint64_t P9N2_C_CPPM_CMEDB1_OR                                        = 0x200F0196ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB1                                         = 0x200F0194ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB1_CLEAR                                   = 0x200F0195ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB1_OR                                      = 0x200F0196ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB1                                         = 0x210F0194ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB1_CLEAR                                   = 0x210F0195ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB1_OR                                      = 0x210F0196ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB1                                         = 0x220F0194ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB1_CLEAR                                   = 0x220F0195ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB1_OR                                      = 0x220F0196ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB1                                         = 0x230F0194ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB1_CLEAR                                   = 0x230F0195ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB1_OR                                      = 0x230F0196ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB1                                         = 0x240F0194ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB1_CLEAR                                   = 0x240F0195ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB1_OR                                      = 0x240F0196ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB1                                         = 0x250F0194ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB1_CLEAR                                   = 0x250F0195ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB1_OR                                      = 0x250F0196ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB1                                         = 0x260F0194ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB1_CLEAR                                   = 0x260F0195ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB1_OR                                      = 0x260F0196ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB1                                         = 0x270F0194ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB1_CLEAR                                   = 0x270F0195ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB1_OR                                      = 0x270F0196ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB1                                         = 0x280F0194ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB1_CLEAR                                   = 0x280F0195ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB1_OR                                      = 0x280F0196ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB1                                         = 0x290F0194ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB1_CLEAR                                   = 0x290F0195ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB1_OR                                      = 0x290F0196ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB1                                        = 0x2A0F0194ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB1_CLEAR                                  = 0x2A0F0195ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB1_OR                                     = 0x2A0F0196ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB1                                        = 0x2B0F0194ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB1_CLEAR                                  = 0x2B0F0195ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB1_OR                                     = 0x2B0F0196ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB1                                        = 0x2C0F0194ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB1_CLEAR                                  = 0x2C0F0195ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB1_OR                                     = 0x2C0F0196ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB1                                        = 0x2D0F0194ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB1_CLEAR                                  = 0x2D0F0195ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB1_OR                                     = 0x2D0F0196ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB1                                        = 0x2E0F0194ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB1_CLEAR                                  = 0x2E0F0195ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB1_OR                                     = 0x2E0F0196ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB1                                        = 0x2F0F0194ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB1_CLEAR                                  = 0x2F0F0195ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB1_OR                                     = 0x2F0F0196ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB1                                        = 0x300F0194ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB1_CLEAR                                  = 0x300F0195ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB1_OR                                     = 0x300F0196ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB1                                        = 0x310F0194ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB1_CLEAR                                  = 0x310F0195ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB1_OR                                     = 0x310F0196ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB1                                        = 0x320F0194ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB1_CLEAR                                  = 0x320F0195ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB1_OR                                     = 0x320F0196ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB1                                        = 0x330F0194ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB1_CLEAR                                  = 0x330F0195ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB1_OR                                     = 0x330F0196ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB1                                        = 0x340F0194ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB1_CLEAR                                  = 0x340F0195ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB1_OR                                     = 0x340F0196ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB1                                        = 0x350F0194ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB1_CLEAR                                  = 0x350F0195ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB1_OR                                     = 0x350F0196ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB1                                        = 0x360F0194ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB1_CLEAR                                  = 0x360F0195ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB1_OR                                     = 0x360F0196ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB1                                        = 0x370F0194ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB1_CLEAR                                  = 0x370F0195ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB1_OR                                     = 0x370F0196ull;

static const uint64_t P9N2_EX_CPPM_CMEDB1                                          = 0x200F0194ull;
//DUPS: 210F0194,
static const uint64_t P9N2_EX_CPPM_CMEDB1_CLEAR                                    = 0x200F0195ull;
//DUPS: 210F0195,
static const uint64_t P9N2_EX_CPPM_CMEDB1_OR                                       = 0x200F0196ull;
//DUPS: 210F0196,
static const uint64_t P9N2_EX_0_CPPM_CMEDB1                                        = 0x200F0194ull;
//DUPS: 210F0194,
static const uint64_t P9N2_EX_0_CPPM_CMEDB1_CLEAR                                  = 0x200F0195ull;
//DUPS: 210F0195,
static const uint64_t P9N2_EX_0_CPPM_CMEDB1_OR                                     = 0x200F0196ull;
//DUPS: 210F0196,
static const uint64_t P9N2_EX_1_CPPM_CMEDB1                                        = 0x220F0194ull;
//DUPS: 220F0194,
static const uint64_t P9N2_EX_1_CPPM_CMEDB1_CLEAR                                  = 0x220F0195ull;
//DUPS: 220F0195,
static const uint64_t P9N2_EX_1_CPPM_CMEDB1_OR                                     = 0x220F0196ull;
//DUPS: 220F0196,
static const uint64_t P9N2_EX_2_CPPM_CMEDB1                                        = 0x240F0194ull;
//DUPS: 250F0194,
static const uint64_t P9N2_EX_2_CPPM_CMEDB1_CLEAR                                  = 0x240F0195ull;
//DUPS: 250F0195,
static const uint64_t P9N2_EX_2_CPPM_CMEDB1_OR                                     = 0x240F0196ull;
//DUPS: 250F0196,
static const uint64_t P9N2_EX_3_CPPM_CMEDB1                                        = 0x260F0194ull;
//DUPS: 270F0194,
static const uint64_t P9N2_EX_3_CPPM_CMEDB1_CLEAR                                  = 0x260F0195ull;
//DUPS: 270F0195,
static const uint64_t P9N2_EX_3_CPPM_CMEDB1_OR                                     = 0x260F0196ull;
//DUPS: 270F0196,
static const uint64_t P9N2_EX_4_CPPM_CMEDB1                                        = 0x280F0194ull;
//DUPS: 290F0194,
static const uint64_t P9N2_EX_4_CPPM_CMEDB1_CLEAR                                  = 0x280F0195ull;
//DUPS: 290F0195,
static const uint64_t P9N2_EX_4_CPPM_CMEDB1_OR                                     = 0x280F0196ull;
//DUPS: 290F0196,
static const uint64_t P9N2_EX_5_CPPM_CMEDB1                                        = 0x2A0F0194ull;
//DUPS: 2B0F0194,
static const uint64_t P9N2_EX_5_CPPM_CMEDB1_CLEAR                                  = 0x2A0F0195ull;
//DUPS: 2B0F0195,
static const uint64_t P9N2_EX_5_CPPM_CMEDB1_OR                                     = 0x2A0F0196ull;
//DUPS: 2B0F0196,
static const uint64_t P9N2_EX_6_CPPM_CMEDB1                                        = 0x2C0F0194ull;
//DUPS: 2D0F0194,
static const uint64_t P9N2_EX_6_CPPM_CMEDB1_CLEAR                                  = 0x2C0F0195ull;
//DUPS: 2D0F0195,
static const uint64_t P9N2_EX_6_CPPM_CMEDB1_OR                                     = 0x2C0F0196ull;
//DUPS: 2D0F0196,
static const uint64_t P9N2_EX_7_CPPM_CMEDB1                                        = 0x2E0F0194ull;
//DUPS: 2F0F0194,
static const uint64_t P9N2_EX_7_CPPM_CMEDB1_CLEAR                                  = 0x2E0F0195ull;
//DUPS: 2F0F0195,
static const uint64_t P9N2_EX_7_CPPM_CMEDB1_OR                                     = 0x2E0F0196ull;
//DUPS: 2F0F0196,
static const uint64_t P9N2_EX_8_CPPM_CMEDB1                                        = 0x300F0194ull;
//DUPS: 310F0194,
static const uint64_t P9N2_EX_8_CPPM_CMEDB1_CLEAR                                  = 0x300F0195ull;
//DUPS: 310F0195,
static const uint64_t P9N2_EX_8_CPPM_CMEDB1_OR                                     = 0x300F0196ull;
//DUPS: 310F0196,
static const uint64_t P9N2_EX_9_CPPM_CMEDB1                                        = 0x320F0194ull;
//DUPS: 330F0194,
static const uint64_t P9N2_EX_9_CPPM_CMEDB1_CLEAR                                  = 0x320F0195ull;
//DUPS: 330F0195,
static const uint64_t P9N2_EX_9_CPPM_CMEDB1_OR                                     = 0x320F0196ull;
//DUPS: 330F0196,
static const uint64_t P9N2_EX_10_CPPM_CMEDB1                                       = 0x340F0194ull;
//DUPS: 350F0194,
static const uint64_t P9N2_EX_10_CPPM_CMEDB1_CLEAR                                 = 0x340F0195ull;
//DUPS: 350F0195,
static const uint64_t P9N2_EX_10_CPPM_CMEDB1_OR                                    = 0x340F0196ull;
//DUPS: 350F0196,
static const uint64_t P9N2_EX_11_CPPM_CMEDB1                                       = 0x360F0194ull;
//DUPS: 370F0194,
static const uint64_t P9N2_EX_11_CPPM_CMEDB1_CLEAR                                 = 0x360F0195ull;
//DUPS: 370F0195,
static const uint64_t P9N2_EX_11_CPPM_CMEDB1_OR                                    = 0x360F0196ull;
//DUPS: 370F0196,

static const uint64_t P9N2_C_CPPM_CMEDB2                                           = 0x200F0198ull;

static const uint64_t P9N2_C_CPPM_CMEDB2_CLEAR                                     = 0x200F0199ull;

static const uint64_t P9N2_C_CPPM_CMEDB2_OR                                        = 0x200F019Aull;

static const uint64_t P9N2_C_0_CPPM_CMEDB2                                         = 0x200F0198ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB2_CLEAR                                   = 0x200F0199ull;

static const uint64_t P9N2_C_0_CPPM_CMEDB2_OR                                      = 0x200F019Aull;

static const uint64_t P9N2_C_1_CPPM_CMEDB2                                         = 0x210F0198ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB2_CLEAR                                   = 0x210F0199ull;

static const uint64_t P9N2_C_1_CPPM_CMEDB2_OR                                      = 0x210F019Aull;

static const uint64_t P9N2_C_2_CPPM_CMEDB2                                         = 0x220F0198ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB2_CLEAR                                   = 0x220F0199ull;

static const uint64_t P9N2_C_2_CPPM_CMEDB2_OR                                      = 0x220F019Aull;

static const uint64_t P9N2_C_3_CPPM_CMEDB2                                         = 0x230F0198ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB2_CLEAR                                   = 0x230F0199ull;

static const uint64_t P9N2_C_3_CPPM_CMEDB2_OR                                      = 0x230F019Aull;

static const uint64_t P9N2_C_4_CPPM_CMEDB2                                         = 0x240F0198ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB2_CLEAR                                   = 0x240F0199ull;

static const uint64_t P9N2_C_4_CPPM_CMEDB2_OR                                      = 0x240F019Aull;

static const uint64_t P9N2_C_5_CPPM_CMEDB2                                         = 0x250F0198ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB2_CLEAR                                   = 0x250F0199ull;

static const uint64_t P9N2_C_5_CPPM_CMEDB2_OR                                      = 0x250F019Aull;

static const uint64_t P9N2_C_6_CPPM_CMEDB2                                         = 0x260F0198ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB2_CLEAR                                   = 0x260F0199ull;

static const uint64_t P9N2_C_6_CPPM_CMEDB2_OR                                      = 0x260F019Aull;

static const uint64_t P9N2_C_7_CPPM_CMEDB2                                         = 0x270F0198ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB2_CLEAR                                   = 0x270F0199ull;

static const uint64_t P9N2_C_7_CPPM_CMEDB2_OR                                      = 0x270F019Aull;

static const uint64_t P9N2_C_8_CPPM_CMEDB2                                         = 0x280F0198ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB2_CLEAR                                   = 0x280F0199ull;

static const uint64_t P9N2_C_8_CPPM_CMEDB2_OR                                      = 0x280F019Aull;

static const uint64_t P9N2_C_9_CPPM_CMEDB2                                         = 0x290F0198ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB2_CLEAR                                   = 0x290F0199ull;

static const uint64_t P9N2_C_9_CPPM_CMEDB2_OR                                      = 0x290F019Aull;

static const uint64_t P9N2_C_10_CPPM_CMEDB2                                        = 0x2A0F0198ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB2_CLEAR                                  = 0x2A0F0199ull;

static const uint64_t P9N2_C_10_CPPM_CMEDB2_OR                                     = 0x2A0F019Aull;

static const uint64_t P9N2_C_11_CPPM_CMEDB2                                        = 0x2B0F0198ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB2_CLEAR                                  = 0x2B0F0199ull;

static const uint64_t P9N2_C_11_CPPM_CMEDB2_OR                                     = 0x2B0F019Aull;

static const uint64_t P9N2_C_12_CPPM_CMEDB2                                        = 0x2C0F0198ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB2_CLEAR                                  = 0x2C0F0199ull;

static const uint64_t P9N2_C_12_CPPM_CMEDB2_OR                                     = 0x2C0F019Aull;

static const uint64_t P9N2_C_13_CPPM_CMEDB2                                        = 0x2D0F0198ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB2_CLEAR                                  = 0x2D0F0199ull;

static const uint64_t P9N2_C_13_CPPM_CMEDB2_OR                                     = 0x2D0F019Aull;

static const uint64_t P9N2_C_14_CPPM_CMEDB2                                        = 0x2E0F0198ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB2_CLEAR                                  = 0x2E0F0199ull;

static const uint64_t P9N2_C_14_CPPM_CMEDB2_OR                                     = 0x2E0F019Aull;

static const uint64_t P9N2_C_15_CPPM_CMEDB2                                        = 0x2F0F0198ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB2_CLEAR                                  = 0x2F0F0199ull;

static const uint64_t P9N2_C_15_CPPM_CMEDB2_OR                                     = 0x2F0F019Aull;

static const uint64_t P9N2_C_16_CPPM_CMEDB2                                        = 0x300F0198ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB2_CLEAR                                  = 0x300F0199ull;

static const uint64_t P9N2_C_16_CPPM_CMEDB2_OR                                     = 0x300F019Aull;

static const uint64_t P9N2_C_17_CPPM_CMEDB2                                        = 0x310F0198ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB2_CLEAR                                  = 0x310F0199ull;

static const uint64_t P9N2_C_17_CPPM_CMEDB2_OR                                     = 0x310F019Aull;

static const uint64_t P9N2_C_18_CPPM_CMEDB2                                        = 0x320F0198ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB2_CLEAR                                  = 0x320F0199ull;

static const uint64_t P9N2_C_18_CPPM_CMEDB2_OR                                     = 0x320F019Aull;

static const uint64_t P9N2_C_19_CPPM_CMEDB2                                        = 0x330F0198ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB2_CLEAR                                  = 0x330F0199ull;

static const uint64_t P9N2_C_19_CPPM_CMEDB2_OR                                     = 0x330F019Aull;

static const uint64_t P9N2_C_20_CPPM_CMEDB2                                        = 0x340F0198ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB2_CLEAR                                  = 0x340F0199ull;

static const uint64_t P9N2_C_20_CPPM_CMEDB2_OR                                     = 0x340F019Aull;

static const uint64_t P9N2_C_21_CPPM_CMEDB2                                        = 0x350F0198ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB2_CLEAR                                  = 0x350F0199ull;

static const uint64_t P9N2_C_21_CPPM_CMEDB2_OR                                     = 0x350F019Aull;

static const uint64_t P9N2_C_22_CPPM_CMEDB2                                        = 0x360F0198ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB2_CLEAR                                  = 0x360F0199ull;

static const uint64_t P9N2_C_22_CPPM_CMEDB2_OR                                     = 0x360F019Aull;

static const uint64_t P9N2_C_23_CPPM_CMEDB2                                        = 0x370F0198ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB2_CLEAR                                  = 0x370F0199ull;

static const uint64_t P9N2_C_23_CPPM_CMEDB2_OR                                     = 0x370F019Aull;

static const uint64_t P9N2_EX_CPPM_CMEDB2                                          = 0x200F0198ull;
//DUPS: 210F0198,
static const uint64_t P9N2_EX_CPPM_CMEDB2_CLEAR                                    = 0x200F0199ull;
//DUPS: 210F0199,
static const uint64_t P9N2_EX_CPPM_CMEDB2_OR                                       = 0x200F019Aull;
//DUPS: 210F019A,
static const uint64_t P9N2_EX_0_CPPM_CMEDB2                                        = 0x200F0198ull;
//DUPS: 210F0198,
static const uint64_t P9N2_EX_0_CPPM_CMEDB2_CLEAR                                  = 0x200F0199ull;
//DUPS: 210F0199,
static const uint64_t P9N2_EX_0_CPPM_CMEDB2_OR                                     = 0x200F019Aull;
//DUPS: 210F019A,
static const uint64_t P9N2_EX_1_CPPM_CMEDB2                                        = 0x220F0198ull;
//DUPS: 220F0198,
static const uint64_t P9N2_EX_1_CPPM_CMEDB2_CLEAR                                  = 0x220F0199ull;
//DUPS: 220F0199,
static const uint64_t P9N2_EX_1_CPPM_CMEDB2_OR                                     = 0x220F019Aull;
//DUPS: 220F019A,
static const uint64_t P9N2_EX_2_CPPM_CMEDB2                                        = 0x240F0198ull;
//DUPS: 250F0198,
static const uint64_t P9N2_EX_2_CPPM_CMEDB2_CLEAR                                  = 0x240F0199ull;
//DUPS: 250F0199,
static const uint64_t P9N2_EX_2_CPPM_CMEDB2_OR                                     = 0x240F019Aull;
//DUPS: 250F019A,
static const uint64_t P9N2_EX_3_CPPM_CMEDB2                                        = 0x260F0198ull;
//DUPS: 270F0198,
static const uint64_t P9N2_EX_3_CPPM_CMEDB2_CLEAR                                  = 0x260F0199ull;
//DUPS: 270F0199,
static const uint64_t P9N2_EX_3_CPPM_CMEDB2_OR                                     = 0x260F019Aull;
//DUPS: 270F019A,
static const uint64_t P9N2_EX_4_CPPM_CMEDB2                                        = 0x280F0198ull;
//DUPS: 290F0198,
static const uint64_t P9N2_EX_4_CPPM_CMEDB2_CLEAR                                  = 0x280F0199ull;
//DUPS: 290F0199,
static const uint64_t P9N2_EX_4_CPPM_CMEDB2_OR                                     = 0x280F019Aull;
//DUPS: 290F019A,
static const uint64_t P9N2_EX_5_CPPM_CMEDB2                                        = 0x2A0F0198ull;
//DUPS: 2B0F0198,
static const uint64_t P9N2_EX_5_CPPM_CMEDB2_CLEAR                                  = 0x2A0F0199ull;
//DUPS: 2B0F0199,
static const uint64_t P9N2_EX_5_CPPM_CMEDB2_OR                                     = 0x2A0F019Aull;
//DUPS: 2B0F019A,
static const uint64_t P9N2_EX_6_CPPM_CMEDB2                                        = 0x2C0F0198ull;
//DUPS: 2D0F0198,
static const uint64_t P9N2_EX_6_CPPM_CMEDB2_CLEAR                                  = 0x2C0F0199ull;
//DUPS: 2D0F0199,
static const uint64_t P9N2_EX_6_CPPM_CMEDB2_OR                                     = 0x2C0F019Aull;
//DUPS: 2D0F019A,
static const uint64_t P9N2_EX_7_CPPM_CMEDB2                                        = 0x2E0F0198ull;
//DUPS: 2F0F0198,
static const uint64_t P9N2_EX_7_CPPM_CMEDB2_CLEAR                                  = 0x2E0F0199ull;
//DUPS: 2F0F0199,
static const uint64_t P9N2_EX_7_CPPM_CMEDB2_OR                                     = 0x2E0F019Aull;
//DUPS: 2F0F019A,
static const uint64_t P9N2_EX_8_CPPM_CMEDB2                                        = 0x300F0198ull;
//DUPS: 310F0198,
static const uint64_t P9N2_EX_8_CPPM_CMEDB2_CLEAR                                  = 0x300F0199ull;
//DUPS: 310F0199,
static const uint64_t P9N2_EX_8_CPPM_CMEDB2_OR                                     = 0x300F019Aull;
//DUPS: 310F019A,
static const uint64_t P9N2_EX_9_CPPM_CMEDB2                                        = 0x320F0198ull;
//DUPS: 330F0198,
static const uint64_t P9N2_EX_9_CPPM_CMEDB2_CLEAR                                  = 0x320F0199ull;
//DUPS: 330F0199,
static const uint64_t P9N2_EX_9_CPPM_CMEDB2_OR                                     = 0x320F019Aull;
//DUPS: 330F019A,
static const uint64_t P9N2_EX_10_CPPM_CMEDB2                                       = 0x340F0198ull;
//DUPS: 350F0198,
static const uint64_t P9N2_EX_10_CPPM_CMEDB2_CLEAR                                 = 0x340F0199ull;
//DUPS: 350F0199,
static const uint64_t P9N2_EX_10_CPPM_CMEDB2_OR                                    = 0x340F019Aull;
//DUPS: 350F019A,
static const uint64_t P9N2_EX_11_CPPM_CMEDB2                                       = 0x360F0198ull;
//DUPS: 370F0198,
static const uint64_t P9N2_EX_11_CPPM_CMEDB2_CLEAR                                 = 0x360F0199ull;
//DUPS: 370F0199,
static const uint64_t P9N2_EX_11_CPPM_CMEDB2_OR                                    = 0x360F019Aull;
//DUPS: 370F019A,

static const uint64_t P9N2_C_CPPM_CMEDB3                                           = 0x200F019Cull;

static const uint64_t P9N2_C_CPPM_CMEDB3_CLEAR                                     = 0x200F019Dull;

static const uint64_t P9N2_C_CPPM_CMEDB3_OR                                        = 0x200F019Eull;

static const uint64_t P9N2_C_0_CPPM_CMEDB3                                         = 0x200F019Cull;

static const uint64_t P9N2_C_0_CPPM_CMEDB3_CLEAR                                   = 0x200F019Dull;

static const uint64_t P9N2_C_0_CPPM_CMEDB3_OR                                      = 0x200F019Eull;

static const uint64_t P9N2_C_1_CPPM_CMEDB3                                         = 0x210F019Cull;

static const uint64_t P9N2_C_1_CPPM_CMEDB3_CLEAR                                   = 0x210F019Dull;

static const uint64_t P9N2_C_1_CPPM_CMEDB3_OR                                      = 0x210F019Eull;

static const uint64_t P9N2_C_2_CPPM_CMEDB3                                         = 0x220F019Cull;

static const uint64_t P9N2_C_2_CPPM_CMEDB3_CLEAR                                   = 0x220F019Dull;

static const uint64_t P9N2_C_2_CPPM_CMEDB3_OR                                      = 0x220F019Eull;

static const uint64_t P9N2_C_3_CPPM_CMEDB3                                         = 0x230F019Cull;

static const uint64_t P9N2_C_3_CPPM_CMEDB3_CLEAR                                   = 0x230F019Dull;

static const uint64_t P9N2_C_3_CPPM_CMEDB3_OR                                      = 0x230F019Eull;

static const uint64_t P9N2_C_4_CPPM_CMEDB3                                         = 0x240F019Cull;

static const uint64_t P9N2_C_4_CPPM_CMEDB3_CLEAR                                   = 0x240F019Dull;

static const uint64_t P9N2_C_4_CPPM_CMEDB3_OR                                      = 0x240F019Eull;

static const uint64_t P9N2_C_5_CPPM_CMEDB3                                         = 0x250F019Cull;

static const uint64_t P9N2_C_5_CPPM_CMEDB3_CLEAR                                   = 0x250F019Dull;

static const uint64_t P9N2_C_5_CPPM_CMEDB3_OR                                      = 0x250F019Eull;

static const uint64_t P9N2_C_6_CPPM_CMEDB3                                         = 0x260F019Cull;

static const uint64_t P9N2_C_6_CPPM_CMEDB3_CLEAR                                   = 0x260F019Dull;

static const uint64_t P9N2_C_6_CPPM_CMEDB3_OR                                      = 0x260F019Eull;

static const uint64_t P9N2_C_7_CPPM_CMEDB3                                         = 0x270F019Cull;

static const uint64_t P9N2_C_7_CPPM_CMEDB3_CLEAR                                   = 0x270F019Dull;

static const uint64_t P9N2_C_7_CPPM_CMEDB3_OR                                      = 0x270F019Eull;

static const uint64_t P9N2_C_8_CPPM_CMEDB3                                         = 0x280F019Cull;

static const uint64_t P9N2_C_8_CPPM_CMEDB3_CLEAR                                   = 0x280F019Dull;

static const uint64_t P9N2_C_8_CPPM_CMEDB3_OR                                      = 0x280F019Eull;

static const uint64_t P9N2_C_9_CPPM_CMEDB3                                         = 0x290F019Cull;

static const uint64_t P9N2_C_9_CPPM_CMEDB3_CLEAR                                   = 0x290F019Dull;

static const uint64_t P9N2_C_9_CPPM_CMEDB3_OR                                      = 0x290F019Eull;

static const uint64_t P9N2_C_10_CPPM_CMEDB3                                        = 0x2A0F019Cull;

static const uint64_t P9N2_C_10_CPPM_CMEDB3_CLEAR                                  = 0x2A0F019Dull;

static const uint64_t P9N2_C_10_CPPM_CMEDB3_OR                                     = 0x2A0F019Eull;

static const uint64_t P9N2_C_11_CPPM_CMEDB3                                        = 0x2B0F019Cull;

static const uint64_t P9N2_C_11_CPPM_CMEDB3_CLEAR                                  = 0x2B0F019Dull;

static const uint64_t P9N2_C_11_CPPM_CMEDB3_OR                                     = 0x2B0F019Eull;

static const uint64_t P9N2_C_12_CPPM_CMEDB3                                        = 0x2C0F019Cull;

static const uint64_t P9N2_C_12_CPPM_CMEDB3_CLEAR                                  = 0x2C0F019Dull;

static const uint64_t P9N2_C_12_CPPM_CMEDB3_OR                                     = 0x2C0F019Eull;

static const uint64_t P9N2_C_13_CPPM_CMEDB3                                        = 0x2D0F019Cull;

static const uint64_t P9N2_C_13_CPPM_CMEDB3_CLEAR                                  = 0x2D0F019Dull;

static const uint64_t P9N2_C_13_CPPM_CMEDB3_OR                                     = 0x2D0F019Eull;

static const uint64_t P9N2_C_14_CPPM_CMEDB3                                        = 0x2E0F019Cull;

static const uint64_t P9N2_C_14_CPPM_CMEDB3_CLEAR                                  = 0x2E0F019Dull;

static const uint64_t P9N2_C_14_CPPM_CMEDB3_OR                                     = 0x2E0F019Eull;

static const uint64_t P9N2_C_15_CPPM_CMEDB3                                        = 0x2F0F019Cull;

static const uint64_t P9N2_C_15_CPPM_CMEDB3_CLEAR                                  = 0x2F0F019Dull;

static const uint64_t P9N2_C_15_CPPM_CMEDB3_OR                                     = 0x2F0F019Eull;

static const uint64_t P9N2_C_16_CPPM_CMEDB3                                        = 0x300F019Cull;

static const uint64_t P9N2_C_16_CPPM_CMEDB3_CLEAR                                  = 0x300F019Dull;

static const uint64_t P9N2_C_16_CPPM_CMEDB3_OR                                     = 0x300F019Eull;

static const uint64_t P9N2_C_17_CPPM_CMEDB3                                        = 0x310F019Cull;

static const uint64_t P9N2_C_17_CPPM_CMEDB3_CLEAR                                  = 0x310F019Dull;

static const uint64_t P9N2_C_17_CPPM_CMEDB3_OR                                     = 0x310F019Eull;

static const uint64_t P9N2_C_18_CPPM_CMEDB3                                        = 0x320F019Cull;

static const uint64_t P9N2_C_18_CPPM_CMEDB3_CLEAR                                  = 0x320F019Dull;

static const uint64_t P9N2_C_18_CPPM_CMEDB3_OR                                     = 0x320F019Eull;

static const uint64_t P9N2_C_19_CPPM_CMEDB3                                        = 0x330F019Cull;

static const uint64_t P9N2_C_19_CPPM_CMEDB3_CLEAR                                  = 0x330F019Dull;

static const uint64_t P9N2_C_19_CPPM_CMEDB3_OR                                     = 0x330F019Eull;

static const uint64_t P9N2_C_20_CPPM_CMEDB3                                        = 0x340F019Cull;

static const uint64_t P9N2_C_20_CPPM_CMEDB3_CLEAR                                  = 0x340F019Dull;

static const uint64_t P9N2_C_20_CPPM_CMEDB3_OR                                     = 0x340F019Eull;

static const uint64_t P9N2_C_21_CPPM_CMEDB3                                        = 0x350F019Cull;

static const uint64_t P9N2_C_21_CPPM_CMEDB3_CLEAR                                  = 0x350F019Dull;

static const uint64_t P9N2_C_21_CPPM_CMEDB3_OR                                     = 0x350F019Eull;

static const uint64_t P9N2_C_22_CPPM_CMEDB3                                        = 0x360F019Cull;

static const uint64_t P9N2_C_22_CPPM_CMEDB3_CLEAR                                  = 0x360F019Dull;

static const uint64_t P9N2_C_22_CPPM_CMEDB3_OR                                     = 0x360F019Eull;

static const uint64_t P9N2_C_23_CPPM_CMEDB3                                        = 0x370F019Cull;

static const uint64_t P9N2_C_23_CPPM_CMEDB3_CLEAR                                  = 0x370F019Dull;

static const uint64_t P9N2_C_23_CPPM_CMEDB3_OR                                     = 0x370F019Eull;

static const uint64_t P9N2_EX_CPPM_CMEDB3                                          = 0x200F019Cull;
//DUPS: 210F019C,
static const uint64_t P9N2_EX_CPPM_CMEDB3_CLEAR                                    = 0x200F019Dull;
//DUPS: 210F019D,
static const uint64_t P9N2_EX_CPPM_CMEDB3_OR                                       = 0x200F019Eull;
//DUPS: 210F019E,
static const uint64_t P9N2_EX_0_CPPM_CMEDB3                                        = 0x200F019Cull;
//DUPS: 210F019C,
static const uint64_t P9N2_EX_0_CPPM_CMEDB3_CLEAR                                  = 0x200F019Dull;
//DUPS: 210F019D,
static const uint64_t P9N2_EX_0_CPPM_CMEDB3_OR                                     = 0x200F019Eull;
//DUPS: 210F019E,
static const uint64_t P9N2_EX_1_CPPM_CMEDB3                                        = 0x220F019Cull;
//DUPS: 220F019C,
static const uint64_t P9N2_EX_1_CPPM_CMEDB3_CLEAR                                  = 0x220F019Dull;
//DUPS: 220F019D,
static const uint64_t P9N2_EX_1_CPPM_CMEDB3_OR                                     = 0x220F019Eull;
//DUPS: 220F019E,
static const uint64_t P9N2_EX_2_CPPM_CMEDB3                                        = 0x240F019Cull;
//DUPS: 250F019C,
static const uint64_t P9N2_EX_2_CPPM_CMEDB3_CLEAR                                  = 0x240F019Dull;
//DUPS: 250F019D,
static const uint64_t P9N2_EX_2_CPPM_CMEDB3_OR                                     = 0x240F019Eull;
//DUPS: 250F019E,
static const uint64_t P9N2_EX_3_CPPM_CMEDB3                                        = 0x260F019Cull;
//DUPS: 270F019C,
static const uint64_t P9N2_EX_3_CPPM_CMEDB3_CLEAR                                  = 0x260F019Dull;
//DUPS: 270F019D,
static const uint64_t P9N2_EX_3_CPPM_CMEDB3_OR                                     = 0x260F019Eull;
//DUPS: 270F019E,
static const uint64_t P9N2_EX_4_CPPM_CMEDB3                                        = 0x280F019Cull;
//DUPS: 290F019C,
static const uint64_t P9N2_EX_4_CPPM_CMEDB3_CLEAR                                  = 0x280F019Dull;
//DUPS: 290F019D,
static const uint64_t P9N2_EX_4_CPPM_CMEDB3_OR                                     = 0x280F019Eull;
//DUPS: 290F019E,
static const uint64_t P9N2_EX_5_CPPM_CMEDB3                                        = 0x2A0F019Cull;
//DUPS: 2B0F019C,
static const uint64_t P9N2_EX_5_CPPM_CMEDB3_CLEAR                                  = 0x2A0F019Dull;
//DUPS: 2B0F019D,
static const uint64_t P9N2_EX_5_CPPM_CMEDB3_OR                                     = 0x2A0F019Eull;
//DUPS: 2B0F019E,
static const uint64_t P9N2_EX_6_CPPM_CMEDB3                                        = 0x2C0F019Cull;
//DUPS: 2D0F019C,
static const uint64_t P9N2_EX_6_CPPM_CMEDB3_CLEAR                                  = 0x2C0F019Dull;
//DUPS: 2D0F019D,
static const uint64_t P9N2_EX_6_CPPM_CMEDB3_OR                                     = 0x2C0F019Eull;
//DUPS: 2D0F019E,
static const uint64_t P9N2_EX_7_CPPM_CMEDB3                                        = 0x2E0F019Cull;
//DUPS: 2F0F019C,
static const uint64_t P9N2_EX_7_CPPM_CMEDB3_CLEAR                                  = 0x2E0F019Dull;
//DUPS: 2F0F019D,
static const uint64_t P9N2_EX_7_CPPM_CMEDB3_OR                                     = 0x2E0F019Eull;
//DUPS: 2F0F019E,
static const uint64_t P9N2_EX_8_CPPM_CMEDB3                                        = 0x300F019Cull;
//DUPS: 310F019C,
static const uint64_t P9N2_EX_8_CPPM_CMEDB3_CLEAR                                  = 0x300F019Dull;
//DUPS: 310F019D,
static const uint64_t P9N2_EX_8_CPPM_CMEDB3_OR                                     = 0x300F019Eull;
//DUPS: 310F019E,
static const uint64_t P9N2_EX_9_CPPM_CMEDB3                                        = 0x320F019Cull;
//DUPS: 330F019C,
static const uint64_t P9N2_EX_9_CPPM_CMEDB3_CLEAR                                  = 0x320F019Dull;
//DUPS: 330F019D,
static const uint64_t P9N2_EX_9_CPPM_CMEDB3_OR                                     = 0x320F019Eull;
//DUPS: 330F019E,
static const uint64_t P9N2_EX_10_CPPM_CMEDB3                                       = 0x340F019Cull;
//DUPS: 350F019C,
static const uint64_t P9N2_EX_10_CPPM_CMEDB3_CLEAR                                 = 0x340F019Dull;
//DUPS: 350F019D,
static const uint64_t P9N2_EX_10_CPPM_CMEDB3_OR                                    = 0x340F019Eull;
//DUPS: 350F019E,
static const uint64_t P9N2_EX_11_CPPM_CMEDB3                                       = 0x360F019Cull;
//DUPS: 370F019C,
static const uint64_t P9N2_EX_11_CPPM_CMEDB3_CLEAR                                 = 0x360F019Dull;
//DUPS: 370F019D,
static const uint64_t P9N2_EX_11_CPPM_CMEDB3_OR                                    = 0x360F019Eull;
//DUPS: 370F019E,

static const uint64_t P9N2_C_CPPM_CMEMSG                                           = 0x200F01ABull;

static const uint64_t P9N2_C_0_CPPM_CMEMSG                                         = 0x200F01ABull;

static const uint64_t P9N2_C_1_CPPM_CMEMSG                                         = 0x210F01ABull;

static const uint64_t P9N2_C_2_CPPM_CMEMSG                                         = 0x220F01ABull;

static const uint64_t P9N2_C_3_CPPM_CMEMSG                                         = 0x230F01ABull;

static const uint64_t P9N2_C_4_CPPM_CMEMSG                                         = 0x240F01ABull;

static const uint64_t P9N2_C_5_CPPM_CMEMSG                                         = 0x250F01ABull;

static const uint64_t P9N2_C_6_CPPM_CMEMSG                                         = 0x260F01ABull;

static const uint64_t P9N2_C_7_CPPM_CMEMSG                                         = 0x270F01ABull;

static const uint64_t P9N2_C_8_CPPM_CMEMSG                                         = 0x280F01ABull;

static const uint64_t P9N2_C_9_CPPM_CMEMSG                                         = 0x290F01ABull;

static const uint64_t P9N2_C_10_CPPM_CMEMSG                                        = 0x2A0F01ABull;

static const uint64_t P9N2_C_11_CPPM_CMEMSG                                        = 0x2B0F01ABull;

static const uint64_t P9N2_C_12_CPPM_CMEMSG                                        = 0x2C0F01ABull;

static const uint64_t P9N2_C_13_CPPM_CMEMSG                                        = 0x2D0F01ABull;

static const uint64_t P9N2_C_14_CPPM_CMEMSG                                        = 0x2E0F01ABull;

static const uint64_t P9N2_C_15_CPPM_CMEMSG                                        = 0x2F0F01ABull;

static const uint64_t P9N2_C_16_CPPM_CMEMSG                                        = 0x300F01ABull;

static const uint64_t P9N2_C_17_CPPM_CMEMSG                                        = 0x310F01ABull;

static const uint64_t P9N2_C_18_CPPM_CMEMSG                                        = 0x320F01ABull;

static const uint64_t P9N2_C_19_CPPM_CMEMSG                                        = 0x330F01ABull;

static const uint64_t P9N2_C_20_CPPM_CMEMSG                                        = 0x340F01ABull;

static const uint64_t P9N2_C_21_CPPM_CMEMSG                                        = 0x350F01ABull;

static const uint64_t P9N2_C_22_CPPM_CMEMSG                                        = 0x360F01ABull;

static const uint64_t P9N2_C_23_CPPM_CMEMSG                                        = 0x370F01ABull;

static const uint64_t P9N2_EX_CPPM_CMEMSG                                          = 0x200F01ABull;
//DUPS: 210F01AB,
static const uint64_t P9N2_EX_0_CPPM_CMEMSG                                        = 0x200F01ABull;
//DUPS: 210F01AB,
static const uint64_t P9N2_EX_1_CPPM_CMEMSG                                        = 0x220F01ABull;
//DUPS: 220F01AB,
static const uint64_t P9N2_EX_2_CPPM_CMEMSG                                        = 0x240F01ABull;
//DUPS: 250F01AB,
static const uint64_t P9N2_EX_3_CPPM_CMEMSG                                        = 0x260F01ABull;
//DUPS: 270F01AB,
static const uint64_t P9N2_EX_4_CPPM_CMEMSG                                        = 0x280F01ABull;
//DUPS: 290F01AB,
static const uint64_t P9N2_EX_5_CPPM_CMEMSG                                        = 0x2A0F01ABull;
//DUPS: 2B0F01AB,
static const uint64_t P9N2_EX_6_CPPM_CMEMSG                                        = 0x2C0F01ABull;
//DUPS: 2D0F01AB,
static const uint64_t P9N2_EX_7_CPPM_CMEMSG                                        = 0x2E0F01ABull;
//DUPS: 2F0F01AB,
static const uint64_t P9N2_EX_8_CPPM_CMEMSG                                        = 0x300F01ABull;
//DUPS: 310F01AB,
static const uint64_t P9N2_EX_9_CPPM_CMEMSG                                        = 0x320F01ABull;
//DUPS: 330F01AB,
static const uint64_t P9N2_EX_10_CPPM_CMEMSG                                       = 0x340F01ABull;
//DUPS: 350F01AB,
static const uint64_t P9N2_EX_11_CPPM_CMEMSG                                       = 0x360F01ABull;
//DUPS: 370F01AB,

static const uint64_t P9N2_C_CPPM_CPMMR_SCOM                                       = 0x200F0106ull;

static const uint64_t P9N2_C_CPPM_CPMMR_SCOM1                                      = 0x200F0107ull;

static const uint64_t P9N2_C_CPPM_CPMMR_SCOM2                                      = 0x200F0108ull;

static const uint64_t P9N2_C_0_CPPM_CPMMR_SCOM                                     = 0x200F0106ull;

static const uint64_t P9N2_C_0_CPPM_CPMMR_SCOM1                                    = 0x200F0107ull;

static const uint64_t P9N2_C_0_CPPM_CPMMR_SCOM2                                    = 0x200F0108ull;

static const uint64_t P9N2_C_1_CPPM_CPMMR_SCOM                                     = 0x210F0106ull;

static const uint64_t P9N2_C_1_CPPM_CPMMR_SCOM1                                    = 0x210F0107ull;

static const uint64_t P9N2_C_1_CPPM_CPMMR_SCOM2                                    = 0x210F0108ull;

static const uint64_t P9N2_C_2_CPPM_CPMMR_SCOM                                     = 0x220F0106ull;

static const uint64_t P9N2_C_2_CPPM_CPMMR_SCOM1                                    = 0x220F0107ull;

static const uint64_t P9N2_C_2_CPPM_CPMMR_SCOM2                                    = 0x220F0108ull;

static const uint64_t P9N2_C_3_CPPM_CPMMR_SCOM                                     = 0x230F0106ull;

static const uint64_t P9N2_C_3_CPPM_CPMMR_SCOM1                                    = 0x230F0107ull;

static const uint64_t P9N2_C_3_CPPM_CPMMR_SCOM2                                    = 0x230F0108ull;

static const uint64_t P9N2_C_4_CPPM_CPMMR_SCOM                                     = 0x240F0106ull;

static const uint64_t P9N2_C_4_CPPM_CPMMR_SCOM1                                    = 0x240F0107ull;

static const uint64_t P9N2_C_4_CPPM_CPMMR_SCOM2                                    = 0x240F0108ull;

static const uint64_t P9N2_C_5_CPPM_CPMMR_SCOM                                     = 0x250F0106ull;

static const uint64_t P9N2_C_5_CPPM_CPMMR_SCOM1                                    = 0x250F0107ull;

static const uint64_t P9N2_C_5_CPPM_CPMMR_SCOM2                                    = 0x250F0108ull;

static const uint64_t P9N2_C_6_CPPM_CPMMR_SCOM                                     = 0x260F0106ull;

static const uint64_t P9N2_C_6_CPPM_CPMMR_SCOM1                                    = 0x260F0107ull;

static const uint64_t P9N2_C_6_CPPM_CPMMR_SCOM2                                    = 0x260F0108ull;

static const uint64_t P9N2_C_7_CPPM_CPMMR_SCOM                                     = 0x270F0106ull;

static const uint64_t P9N2_C_7_CPPM_CPMMR_SCOM1                                    = 0x270F0107ull;

static const uint64_t P9N2_C_7_CPPM_CPMMR_SCOM2                                    = 0x270F0108ull;

static const uint64_t P9N2_C_8_CPPM_CPMMR_SCOM                                     = 0x280F0106ull;

static const uint64_t P9N2_C_8_CPPM_CPMMR_SCOM1                                    = 0x280F0107ull;

static const uint64_t P9N2_C_8_CPPM_CPMMR_SCOM2                                    = 0x280F0108ull;

static const uint64_t P9N2_C_9_CPPM_CPMMR_SCOM                                     = 0x290F0106ull;

static const uint64_t P9N2_C_9_CPPM_CPMMR_SCOM1                                    = 0x290F0107ull;

static const uint64_t P9N2_C_9_CPPM_CPMMR_SCOM2                                    = 0x290F0108ull;

static const uint64_t P9N2_C_10_CPPM_CPMMR_SCOM                                    = 0x2A0F0106ull;

static const uint64_t P9N2_C_10_CPPM_CPMMR_SCOM1                                   = 0x2A0F0107ull;

static const uint64_t P9N2_C_10_CPPM_CPMMR_SCOM2                                   = 0x2A0F0108ull;

static const uint64_t P9N2_C_11_CPPM_CPMMR_SCOM                                    = 0x2B0F0106ull;

static const uint64_t P9N2_C_11_CPPM_CPMMR_SCOM1                                   = 0x2B0F0107ull;

static const uint64_t P9N2_C_11_CPPM_CPMMR_SCOM2                                   = 0x2B0F0108ull;

static const uint64_t P9N2_C_12_CPPM_CPMMR_SCOM                                    = 0x2C0F0106ull;

static const uint64_t P9N2_C_12_CPPM_CPMMR_SCOM1                                   = 0x2C0F0107ull;

static const uint64_t P9N2_C_12_CPPM_CPMMR_SCOM2                                   = 0x2C0F0108ull;

static const uint64_t P9N2_C_13_CPPM_CPMMR_SCOM                                    = 0x2D0F0106ull;

static const uint64_t P9N2_C_13_CPPM_CPMMR_SCOM1                                   = 0x2D0F0107ull;

static const uint64_t P9N2_C_13_CPPM_CPMMR_SCOM2                                   = 0x2D0F0108ull;

static const uint64_t P9N2_C_14_CPPM_CPMMR_SCOM                                    = 0x2E0F0106ull;

static const uint64_t P9N2_C_14_CPPM_CPMMR_SCOM1                                   = 0x2E0F0107ull;

static const uint64_t P9N2_C_14_CPPM_CPMMR_SCOM2                                   = 0x2E0F0108ull;

static const uint64_t P9N2_C_15_CPPM_CPMMR_SCOM                                    = 0x2F0F0106ull;

static const uint64_t P9N2_C_15_CPPM_CPMMR_SCOM1                                   = 0x2F0F0107ull;

static const uint64_t P9N2_C_15_CPPM_CPMMR_SCOM2                                   = 0x2F0F0108ull;

static const uint64_t P9N2_C_16_CPPM_CPMMR_SCOM                                    = 0x300F0106ull;

static const uint64_t P9N2_C_16_CPPM_CPMMR_SCOM1                                   = 0x300F0107ull;

static const uint64_t P9N2_C_16_CPPM_CPMMR_SCOM2                                   = 0x300F0108ull;

static const uint64_t P9N2_C_17_CPPM_CPMMR_SCOM                                    = 0x310F0106ull;

static const uint64_t P9N2_C_17_CPPM_CPMMR_SCOM1                                   = 0x310F0107ull;

static const uint64_t P9N2_C_17_CPPM_CPMMR_SCOM2                                   = 0x310F0108ull;

static const uint64_t P9N2_C_18_CPPM_CPMMR_SCOM                                    = 0x320F0106ull;

static const uint64_t P9N2_C_18_CPPM_CPMMR_SCOM1                                   = 0x320F0107ull;

static const uint64_t P9N2_C_18_CPPM_CPMMR_SCOM2                                   = 0x320F0108ull;

static const uint64_t P9N2_C_19_CPPM_CPMMR_SCOM                                    = 0x330F0106ull;

static const uint64_t P9N2_C_19_CPPM_CPMMR_SCOM1                                   = 0x330F0107ull;

static const uint64_t P9N2_C_19_CPPM_CPMMR_SCOM2                                   = 0x330F0108ull;

static const uint64_t P9N2_C_20_CPPM_CPMMR_SCOM                                    = 0x340F0106ull;

static const uint64_t P9N2_C_20_CPPM_CPMMR_SCOM1                                   = 0x340F0107ull;

static const uint64_t P9N2_C_20_CPPM_CPMMR_SCOM2                                   = 0x340F0108ull;

static const uint64_t P9N2_C_21_CPPM_CPMMR_SCOM                                    = 0x350F0106ull;

static const uint64_t P9N2_C_21_CPPM_CPMMR_SCOM1                                   = 0x350F0107ull;

static const uint64_t P9N2_C_21_CPPM_CPMMR_SCOM2                                   = 0x350F0108ull;

static const uint64_t P9N2_C_22_CPPM_CPMMR_SCOM                                    = 0x360F0106ull;

static const uint64_t P9N2_C_22_CPPM_CPMMR_SCOM1                                   = 0x360F0107ull;

static const uint64_t P9N2_C_22_CPPM_CPMMR_SCOM2                                   = 0x360F0108ull;

static const uint64_t P9N2_C_23_CPPM_CPMMR_SCOM                                    = 0x370F0106ull;

static const uint64_t P9N2_C_23_CPPM_CPMMR_SCOM1                                   = 0x370F0107ull;

static const uint64_t P9N2_C_23_CPPM_CPMMR_SCOM2                                   = 0x370F0108ull;

static const uint64_t P9N2_EX_CPPM_CPMMR_SCOM                                      = 0x200F0106ull;
//DUPS: 210F0106,
static const uint64_t P9N2_EX_CPPM_CPMMR_SCOM1                                     = 0x200F0107ull;
//DUPS: 210F0107,
static const uint64_t P9N2_EX_CPPM_CPMMR_SCOM2                                     = 0x200F0108ull;
//DUPS: 210F0108,
static const uint64_t P9N2_EX_0_CPPM_CPMMR_SCOM                                    = 0x200F0106ull;
//DUPS: 210F0106,
static const uint64_t P9N2_EX_0_CPPM_CPMMR_SCOM1                                   = 0x200F0107ull;
//DUPS: 210F0107,
static const uint64_t P9N2_EX_0_CPPM_CPMMR_SCOM2                                   = 0x200F0108ull;
//DUPS: 210F0108,
static const uint64_t P9N2_EX_1_CPPM_CPMMR_SCOM                                    = 0x220F0106ull;
//DUPS: 220F0106,
static const uint64_t P9N2_EX_1_CPPM_CPMMR_SCOM1                                   = 0x220F0107ull;
//DUPS: 220F0107,
static const uint64_t P9N2_EX_1_CPPM_CPMMR_SCOM2                                   = 0x220F0108ull;
//DUPS: 220F0108,
static const uint64_t P9N2_EX_2_CPPM_CPMMR_SCOM                                    = 0x240F0106ull;
//DUPS: 250F0106,
static const uint64_t P9N2_EX_2_CPPM_CPMMR_SCOM1                                   = 0x240F0107ull;
//DUPS: 250F0107,
static const uint64_t P9N2_EX_2_CPPM_CPMMR_SCOM2                                   = 0x240F0108ull;
//DUPS: 250F0108,
static const uint64_t P9N2_EX_3_CPPM_CPMMR_SCOM                                    = 0x260F0106ull;
//DUPS: 270F0106,
static const uint64_t P9N2_EX_3_CPPM_CPMMR_SCOM1                                   = 0x260F0107ull;
//DUPS: 270F0107,
static const uint64_t P9N2_EX_3_CPPM_CPMMR_SCOM2                                   = 0x260F0108ull;
//DUPS: 270F0108,
static const uint64_t P9N2_EX_4_CPPM_CPMMR_SCOM                                    = 0x280F0106ull;
//DUPS: 290F0106,
static const uint64_t P9N2_EX_4_CPPM_CPMMR_SCOM1                                   = 0x280F0107ull;
//DUPS: 290F0107,
static const uint64_t P9N2_EX_4_CPPM_CPMMR_SCOM2                                   = 0x280F0108ull;
//DUPS: 290F0108,
static const uint64_t P9N2_EX_5_CPPM_CPMMR_SCOM                                    = 0x2A0F0106ull;
//DUPS: 2B0F0106,
static const uint64_t P9N2_EX_5_CPPM_CPMMR_SCOM1                                   = 0x2A0F0107ull;
//DUPS: 2B0F0107,
static const uint64_t P9N2_EX_5_CPPM_CPMMR_SCOM2                                   = 0x2A0F0108ull;
//DUPS: 2B0F0108,
static const uint64_t P9N2_EX_6_CPPM_CPMMR_SCOM                                    = 0x2C0F0106ull;
//DUPS: 2D0F0106,
static const uint64_t P9N2_EX_6_CPPM_CPMMR_SCOM1                                   = 0x2C0F0107ull;
//DUPS: 2D0F0107,
static const uint64_t P9N2_EX_6_CPPM_CPMMR_SCOM2                                   = 0x2C0F0108ull;
//DUPS: 2D0F0108,
static const uint64_t P9N2_EX_7_CPPM_CPMMR_SCOM                                    = 0x2E0F0106ull;
//DUPS: 2F0F0106,
static const uint64_t P9N2_EX_7_CPPM_CPMMR_SCOM1                                   = 0x2E0F0107ull;
//DUPS: 2F0F0107,
static const uint64_t P9N2_EX_7_CPPM_CPMMR_SCOM2                                   = 0x2E0F0108ull;
//DUPS: 2F0F0108,
static const uint64_t P9N2_EX_8_CPPM_CPMMR_SCOM                                    = 0x300F0106ull;
//DUPS: 310F0106,
static const uint64_t P9N2_EX_8_CPPM_CPMMR_SCOM1                                   = 0x300F0107ull;
//DUPS: 310F0107,
static const uint64_t P9N2_EX_8_CPPM_CPMMR_SCOM2                                   = 0x300F0108ull;
//DUPS: 310F0108,
static const uint64_t P9N2_EX_9_CPPM_CPMMR_SCOM                                    = 0x320F0106ull;
//DUPS: 330F0106,
static const uint64_t P9N2_EX_9_CPPM_CPMMR_SCOM1                                   = 0x320F0107ull;
//DUPS: 330F0107,
static const uint64_t P9N2_EX_9_CPPM_CPMMR_SCOM2                                   = 0x320F0108ull;
//DUPS: 330F0108,
static const uint64_t P9N2_EX_10_CPPM_CPMMR_SCOM                                   = 0x340F0106ull;
//DUPS: 350F0106,
static const uint64_t P9N2_EX_10_CPPM_CPMMR_SCOM1                                  = 0x340F0107ull;
//DUPS: 350F0107,
static const uint64_t P9N2_EX_10_CPPM_CPMMR_SCOM2                                  = 0x340F0108ull;
//DUPS: 350F0108,
static const uint64_t P9N2_EX_11_CPPM_CPMMR_SCOM                                   = 0x360F0106ull;
//DUPS: 370F0106,
static const uint64_t P9N2_EX_11_CPPM_CPMMR_SCOM1                                  = 0x360F0107ull;
//DUPS: 370F0107,
static const uint64_t P9N2_EX_11_CPPM_CPMMR_SCOM2                                  = 0x360F0108ull;
//DUPS: 370F0108,

static const uint64_t P9N2_C_CPPM_CSAR                                             = 0x200F0138ull;

static const uint64_t P9N2_C_CPPM_CSAR_CLEAR                                       = 0x200F0139ull;

static const uint64_t P9N2_C_CPPM_CSAR_OR                                          = 0x200F013Aull;

static const uint64_t P9N2_C_0_CPPM_CSAR                                           = 0x200F0138ull;

static const uint64_t P9N2_C_0_CPPM_CSAR_CLEAR                                     = 0x200F0139ull;

static const uint64_t P9N2_C_0_CPPM_CSAR_OR                                        = 0x200F013Aull;

static const uint64_t P9N2_C_1_CPPM_CSAR                                           = 0x210F0138ull;

static const uint64_t P9N2_C_1_CPPM_CSAR_CLEAR                                     = 0x210F0139ull;

static const uint64_t P9N2_C_1_CPPM_CSAR_OR                                        = 0x210F013Aull;

static const uint64_t P9N2_C_2_CPPM_CSAR                                           = 0x220F0138ull;

static const uint64_t P9N2_C_2_CPPM_CSAR_CLEAR                                     = 0x220F0139ull;

static const uint64_t P9N2_C_2_CPPM_CSAR_OR                                        = 0x220F013Aull;

static const uint64_t P9N2_C_3_CPPM_CSAR                                           = 0x230F0138ull;

static const uint64_t P9N2_C_3_CPPM_CSAR_CLEAR                                     = 0x230F0139ull;

static const uint64_t P9N2_C_3_CPPM_CSAR_OR                                        = 0x230F013Aull;

static const uint64_t P9N2_C_4_CPPM_CSAR                                           = 0x240F0138ull;

static const uint64_t P9N2_C_4_CPPM_CSAR_CLEAR                                     = 0x240F0139ull;

static const uint64_t P9N2_C_4_CPPM_CSAR_OR                                        = 0x240F013Aull;

static const uint64_t P9N2_C_5_CPPM_CSAR                                           = 0x250F0138ull;

static const uint64_t P9N2_C_5_CPPM_CSAR_CLEAR                                     = 0x250F0139ull;

static const uint64_t P9N2_C_5_CPPM_CSAR_OR                                        = 0x250F013Aull;

static const uint64_t P9N2_C_6_CPPM_CSAR                                           = 0x260F0138ull;

static const uint64_t P9N2_C_6_CPPM_CSAR_CLEAR                                     = 0x260F0139ull;

static const uint64_t P9N2_C_6_CPPM_CSAR_OR                                        = 0x260F013Aull;

static const uint64_t P9N2_C_7_CPPM_CSAR                                           = 0x270F0138ull;

static const uint64_t P9N2_C_7_CPPM_CSAR_CLEAR                                     = 0x270F0139ull;

static const uint64_t P9N2_C_7_CPPM_CSAR_OR                                        = 0x270F013Aull;

static const uint64_t P9N2_C_8_CPPM_CSAR                                           = 0x280F0138ull;

static const uint64_t P9N2_C_8_CPPM_CSAR_CLEAR                                     = 0x280F0139ull;

static const uint64_t P9N2_C_8_CPPM_CSAR_OR                                        = 0x280F013Aull;

static const uint64_t P9N2_C_9_CPPM_CSAR                                           = 0x290F0138ull;

static const uint64_t P9N2_C_9_CPPM_CSAR_CLEAR                                     = 0x290F0139ull;

static const uint64_t P9N2_C_9_CPPM_CSAR_OR                                        = 0x290F013Aull;

static const uint64_t P9N2_C_10_CPPM_CSAR                                          = 0x2A0F0138ull;

static const uint64_t P9N2_C_10_CPPM_CSAR_CLEAR                                    = 0x2A0F0139ull;

static const uint64_t P9N2_C_10_CPPM_CSAR_OR                                       = 0x2A0F013Aull;

static const uint64_t P9N2_C_11_CPPM_CSAR                                          = 0x2B0F0138ull;

static const uint64_t P9N2_C_11_CPPM_CSAR_CLEAR                                    = 0x2B0F0139ull;

static const uint64_t P9N2_C_11_CPPM_CSAR_OR                                       = 0x2B0F013Aull;

static const uint64_t P9N2_C_12_CPPM_CSAR                                          = 0x2C0F0138ull;

static const uint64_t P9N2_C_12_CPPM_CSAR_CLEAR                                    = 0x2C0F0139ull;

static const uint64_t P9N2_C_12_CPPM_CSAR_OR                                       = 0x2C0F013Aull;

static const uint64_t P9N2_C_13_CPPM_CSAR                                          = 0x2D0F0138ull;

static const uint64_t P9N2_C_13_CPPM_CSAR_CLEAR                                    = 0x2D0F0139ull;

static const uint64_t P9N2_C_13_CPPM_CSAR_OR                                       = 0x2D0F013Aull;

static const uint64_t P9N2_C_14_CPPM_CSAR                                          = 0x2E0F0138ull;

static const uint64_t P9N2_C_14_CPPM_CSAR_CLEAR                                    = 0x2E0F0139ull;

static const uint64_t P9N2_C_14_CPPM_CSAR_OR                                       = 0x2E0F013Aull;

static const uint64_t P9N2_C_15_CPPM_CSAR                                          = 0x2F0F0138ull;

static const uint64_t P9N2_C_15_CPPM_CSAR_CLEAR                                    = 0x2F0F0139ull;

static const uint64_t P9N2_C_15_CPPM_CSAR_OR                                       = 0x2F0F013Aull;

static const uint64_t P9N2_C_16_CPPM_CSAR                                          = 0x300F0138ull;

static const uint64_t P9N2_C_16_CPPM_CSAR_CLEAR                                    = 0x300F0139ull;

static const uint64_t P9N2_C_16_CPPM_CSAR_OR                                       = 0x300F013Aull;

static const uint64_t P9N2_C_17_CPPM_CSAR                                          = 0x310F0138ull;

static const uint64_t P9N2_C_17_CPPM_CSAR_CLEAR                                    = 0x310F0139ull;

static const uint64_t P9N2_C_17_CPPM_CSAR_OR                                       = 0x310F013Aull;

static const uint64_t P9N2_C_18_CPPM_CSAR                                          = 0x320F0138ull;

static const uint64_t P9N2_C_18_CPPM_CSAR_CLEAR                                    = 0x320F0139ull;

static const uint64_t P9N2_C_18_CPPM_CSAR_OR                                       = 0x320F013Aull;

static const uint64_t P9N2_C_19_CPPM_CSAR                                          = 0x330F0138ull;

static const uint64_t P9N2_C_19_CPPM_CSAR_CLEAR                                    = 0x330F0139ull;

static const uint64_t P9N2_C_19_CPPM_CSAR_OR                                       = 0x330F013Aull;

static const uint64_t P9N2_C_20_CPPM_CSAR                                          = 0x340F0138ull;

static const uint64_t P9N2_C_20_CPPM_CSAR_CLEAR                                    = 0x340F0139ull;

static const uint64_t P9N2_C_20_CPPM_CSAR_OR                                       = 0x340F013Aull;

static const uint64_t P9N2_C_21_CPPM_CSAR                                          = 0x350F0138ull;

static const uint64_t P9N2_C_21_CPPM_CSAR_CLEAR                                    = 0x350F0139ull;

static const uint64_t P9N2_C_21_CPPM_CSAR_OR                                       = 0x350F013Aull;

static const uint64_t P9N2_C_22_CPPM_CSAR                                          = 0x360F0138ull;

static const uint64_t P9N2_C_22_CPPM_CSAR_CLEAR                                    = 0x360F0139ull;

static const uint64_t P9N2_C_22_CPPM_CSAR_OR                                       = 0x360F013Aull;

static const uint64_t P9N2_C_23_CPPM_CSAR                                          = 0x370F0138ull;

static const uint64_t P9N2_C_23_CPPM_CSAR_CLEAR                                    = 0x370F0139ull;

static const uint64_t P9N2_C_23_CPPM_CSAR_OR                                       = 0x370F013Aull;

static const uint64_t P9N2_EX_CPPM_CSAR                                            = 0x200F0138ull;
//DUPS: 210F0138,
static const uint64_t P9N2_EX_CPPM_CSAR_CLEAR                                      = 0x200F0139ull;
//DUPS: 210F0139,
static const uint64_t P9N2_EX_CPPM_CSAR_OR                                         = 0x200F013Aull;
//DUPS: 210F013A,
static const uint64_t P9N2_EX_0_CPPM_CSAR                                          = 0x200F0138ull;
//DUPS: 210F0138,
static const uint64_t P9N2_EX_0_CPPM_CSAR_CLEAR                                    = 0x200F0139ull;
//DUPS: 210F0139,
static const uint64_t P9N2_EX_0_CPPM_CSAR_OR                                       = 0x200F013Aull;
//DUPS: 210F013A,
static const uint64_t P9N2_EX_1_CPPM_CSAR                                          = 0x220F0138ull;
//DUPS: 220F0138,
static const uint64_t P9N2_EX_1_CPPM_CSAR_CLEAR                                    = 0x220F0139ull;
//DUPS: 220F0139,
static const uint64_t P9N2_EX_1_CPPM_CSAR_OR                                       = 0x220F013Aull;
//DUPS: 220F013A,
static const uint64_t P9N2_EX_2_CPPM_CSAR                                          = 0x240F0138ull;
//DUPS: 250F0138,
static const uint64_t P9N2_EX_2_CPPM_CSAR_CLEAR                                    = 0x240F0139ull;
//DUPS: 250F0139,
static const uint64_t P9N2_EX_2_CPPM_CSAR_OR                                       = 0x240F013Aull;
//DUPS: 250F013A,
static const uint64_t P9N2_EX_3_CPPM_CSAR                                          = 0x260F0138ull;
//DUPS: 270F0138,
static const uint64_t P9N2_EX_3_CPPM_CSAR_CLEAR                                    = 0x260F0139ull;
//DUPS: 270F0139,
static const uint64_t P9N2_EX_3_CPPM_CSAR_OR                                       = 0x260F013Aull;
//DUPS: 270F013A,
static const uint64_t P9N2_EX_4_CPPM_CSAR                                          = 0x280F0138ull;
//DUPS: 290F0138,
static const uint64_t P9N2_EX_4_CPPM_CSAR_CLEAR                                    = 0x280F0139ull;
//DUPS: 290F0139,
static const uint64_t P9N2_EX_4_CPPM_CSAR_OR                                       = 0x280F013Aull;
//DUPS: 290F013A,
static const uint64_t P9N2_EX_5_CPPM_CSAR                                          = 0x2A0F0138ull;
//DUPS: 2B0F0138,
static const uint64_t P9N2_EX_5_CPPM_CSAR_CLEAR                                    = 0x2A0F0139ull;
//DUPS: 2B0F0139,
static const uint64_t P9N2_EX_5_CPPM_CSAR_OR                                       = 0x2A0F013Aull;
//DUPS: 2B0F013A,
static const uint64_t P9N2_EX_6_CPPM_CSAR                                          = 0x2C0F0138ull;
//DUPS: 2D0F0138,
static const uint64_t P9N2_EX_6_CPPM_CSAR_CLEAR                                    = 0x2C0F0139ull;
//DUPS: 2D0F0139,
static const uint64_t P9N2_EX_6_CPPM_CSAR_OR                                       = 0x2C0F013Aull;
//DUPS: 2D0F013A,
static const uint64_t P9N2_EX_7_CPPM_CSAR                                          = 0x2E0F0138ull;
//DUPS: 2F0F0138,
static const uint64_t P9N2_EX_7_CPPM_CSAR_CLEAR                                    = 0x2E0F0139ull;
//DUPS: 2F0F0139,
static const uint64_t P9N2_EX_7_CPPM_CSAR_OR                                       = 0x2E0F013Aull;
//DUPS: 2F0F013A,
static const uint64_t P9N2_EX_8_CPPM_CSAR                                          = 0x300F0138ull;
//DUPS: 310F0138,
static const uint64_t P9N2_EX_8_CPPM_CSAR_CLEAR                                    = 0x300F0139ull;
//DUPS: 310F0139,
static const uint64_t P9N2_EX_8_CPPM_CSAR_OR                                       = 0x300F013Aull;
//DUPS: 310F013A,
static const uint64_t P9N2_EX_9_CPPM_CSAR                                          = 0x320F0138ull;
//DUPS: 330F0138,
static const uint64_t P9N2_EX_9_CPPM_CSAR_CLEAR                                    = 0x320F0139ull;
//DUPS: 330F0139,
static const uint64_t P9N2_EX_9_CPPM_CSAR_OR                                       = 0x320F013Aull;
//DUPS: 330F013A,
static const uint64_t P9N2_EX_10_CPPM_CSAR                                         = 0x340F0138ull;
//DUPS: 350F0138,
static const uint64_t P9N2_EX_10_CPPM_CSAR_CLEAR                                   = 0x340F0139ull;
//DUPS: 350F0139,
static const uint64_t P9N2_EX_10_CPPM_CSAR_OR                                      = 0x340F013Aull;
//DUPS: 350F013A,
static const uint64_t P9N2_EX_11_CPPM_CSAR                                         = 0x360F0138ull;
//DUPS: 370F0138,
static const uint64_t P9N2_EX_11_CPPM_CSAR_CLEAR                                   = 0x360F0139ull;
//DUPS: 370F0139,
static const uint64_t P9N2_EX_11_CPPM_CSAR_OR                                      = 0x360F013Aull;
//DUPS: 370F013A,

static const uint64_t P9N2_C_CPPM_ERR                                              = 0x200F0121ull;

static const uint64_t P9N2_C_0_CPPM_ERR                                            = 0x200F0121ull;

static const uint64_t P9N2_C_1_CPPM_ERR                                            = 0x210F0121ull;

static const uint64_t P9N2_C_2_CPPM_ERR                                            = 0x220F0121ull;

static const uint64_t P9N2_C_3_CPPM_ERR                                            = 0x230F0121ull;

static const uint64_t P9N2_C_4_CPPM_ERR                                            = 0x240F0121ull;

static const uint64_t P9N2_C_5_CPPM_ERR                                            = 0x250F0121ull;

static const uint64_t P9N2_C_6_CPPM_ERR                                            = 0x260F0121ull;

static const uint64_t P9N2_C_7_CPPM_ERR                                            = 0x270F0121ull;

static const uint64_t P9N2_C_8_CPPM_ERR                                            = 0x280F0121ull;

static const uint64_t P9N2_C_9_CPPM_ERR                                            = 0x290F0121ull;

static const uint64_t P9N2_C_10_CPPM_ERR                                           = 0x2A0F0121ull;

static const uint64_t P9N2_C_11_CPPM_ERR                                           = 0x2B0F0121ull;

static const uint64_t P9N2_C_12_CPPM_ERR                                           = 0x2C0F0121ull;

static const uint64_t P9N2_C_13_CPPM_ERR                                           = 0x2D0F0121ull;

static const uint64_t P9N2_C_14_CPPM_ERR                                           = 0x2E0F0121ull;

static const uint64_t P9N2_C_15_CPPM_ERR                                           = 0x2F0F0121ull;

static const uint64_t P9N2_C_16_CPPM_ERR                                           = 0x300F0121ull;

static const uint64_t P9N2_C_17_CPPM_ERR                                           = 0x310F0121ull;

static const uint64_t P9N2_C_18_CPPM_ERR                                           = 0x320F0121ull;

static const uint64_t P9N2_C_19_CPPM_ERR                                           = 0x330F0121ull;

static const uint64_t P9N2_C_20_CPPM_ERR                                           = 0x340F0121ull;

static const uint64_t P9N2_C_21_CPPM_ERR                                           = 0x350F0121ull;

static const uint64_t P9N2_C_22_CPPM_ERR                                           = 0x360F0121ull;

static const uint64_t P9N2_C_23_CPPM_ERR                                           = 0x370F0121ull;

static const uint64_t P9N2_EX_CPPM_ERR                                             = 0x200F0121ull;
//DUPS: 210F0121,
static const uint64_t P9N2_EX_0_CPPM_ERR                                           = 0x200F0121ull;
//DUPS: 210F0121,
static const uint64_t P9N2_EX_1_CPPM_ERR                                           = 0x220F0121ull;
//DUPS: 220F0121,
static const uint64_t P9N2_EX_2_CPPM_ERR                                           = 0x240F0121ull;
//DUPS: 250F0121,
static const uint64_t P9N2_EX_3_CPPM_ERR                                           = 0x260F0121ull;
//DUPS: 270F0121,
static const uint64_t P9N2_EX_4_CPPM_ERR                                           = 0x280F0121ull;
//DUPS: 290F0121,
static const uint64_t P9N2_EX_5_CPPM_ERR                                           = 0x2A0F0121ull;
//DUPS: 2B0F0121,
static const uint64_t P9N2_EX_6_CPPM_ERR                                           = 0x2C0F0121ull;
//DUPS: 2D0F0121,
static const uint64_t P9N2_EX_7_CPPM_ERR                                           = 0x2E0F0121ull;
//DUPS: 2F0F0121,
static const uint64_t P9N2_EX_8_CPPM_ERR                                           = 0x300F0121ull;
//DUPS: 310F0121,
static const uint64_t P9N2_EX_9_CPPM_ERR                                           = 0x320F0121ull;
//DUPS: 330F0121,
static const uint64_t P9N2_EX_10_CPPM_ERR                                          = 0x340F0121ull;
//DUPS: 350F0121,
static const uint64_t P9N2_EX_11_CPPM_ERR                                          = 0x360F0121ull;
//DUPS: 370F0121,

static const uint64_t P9N2_C_CPPM_ERRMSK                                           = 0x200F0122ull;

static const uint64_t P9N2_C_0_CPPM_ERRMSK                                         = 0x200F0122ull;

static const uint64_t P9N2_C_1_CPPM_ERRMSK                                         = 0x210F0122ull;

static const uint64_t P9N2_C_2_CPPM_ERRMSK                                         = 0x220F0122ull;

static const uint64_t P9N2_C_3_CPPM_ERRMSK                                         = 0x230F0122ull;

static const uint64_t P9N2_C_4_CPPM_ERRMSK                                         = 0x240F0122ull;

static const uint64_t P9N2_C_5_CPPM_ERRMSK                                         = 0x250F0122ull;

static const uint64_t P9N2_C_6_CPPM_ERRMSK                                         = 0x260F0122ull;

static const uint64_t P9N2_C_7_CPPM_ERRMSK                                         = 0x270F0122ull;

static const uint64_t P9N2_C_8_CPPM_ERRMSK                                         = 0x280F0122ull;

static const uint64_t P9N2_C_9_CPPM_ERRMSK                                         = 0x290F0122ull;

static const uint64_t P9N2_C_10_CPPM_ERRMSK                                        = 0x2A0F0122ull;

static const uint64_t P9N2_C_11_CPPM_ERRMSK                                        = 0x2B0F0122ull;

static const uint64_t P9N2_C_12_CPPM_ERRMSK                                        = 0x2C0F0122ull;

static const uint64_t P9N2_C_13_CPPM_ERRMSK                                        = 0x2D0F0122ull;

static const uint64_t P9N2_C_14_CPPM_ERRMSK                                        = 0x2E0F0122ull;

static const uint64_t P9N2_C_15_CPPM_ERRMSK                                        = 0x2F0F0122ull;

static const uint64_t P9N2_C_16_CPPM_ERRMSK                                        = 0x300F0122ull;

static const uint64_t P9N2_C_17_CPPM_ERRMSK                                        = 0x310F0122ull;

static const uint64_t P9N2_C_18_CPPM_ERRMSK                                        = 0x320F0122ull;

static const uint64_t P9N2_C_19_CPPM_ERRMSK                                        = 0x330F0122ull;

static const uint64_t P9N2_C_20_CPPM_ERRMSK                                        = 0x340F0122ull;

static const uint64_t P9N2_C_21_CPPM_ERRMSK                                        = 0x350F0122ull;

static const uint64_t P9N2_C_22_CPPM_ERRMSK                                        = 0x360F0122ull;

static const uint64_t P9N2_C_23_CPPM_ERRMSK                                        = 0x370F0122ull;

static const uint64_t P9N2_EX_CPPM_ERRMSK                                          = 0x200F0122ull;
//DUPS: 210F0122,
static const uint64_t P9N2_EX_0_CPPM_ERRMSK                                        = 0x200F0122ull;
//DUPS: 210F0122,
static const uint64_t P9N2_EX_1_CPPM_ERRMSK                                        = 0x220F0122ull;
//DUPS: 220F0122,
static const uint64_t P9N2_EX_2_CPPM_ERRMSK                                        = 0x240F0122ull;
//DUPS: 250F0122,
static const uint64_t P9N2_EX_3_CPPM_ERRMSK                                        = 0x260F0122ull;
//DUPS: 270F0122,
static const uint64_t P9N2_EX_4_CPPM_ERRMSK                                        = 0x280F0122ull;
//DUPS: 290F0122,
static const uint64_t P9N2_EX_5_CPPM_ERRMSK                                        = 0x2A0F0122ull;
//DUPS: 2B0F0122,
static const uint64_t P9N2_EX_6_CPPM_ERRMSK                                        = 0x2C0F0122ull;
//DUPS: 2D0F0122,
static const uint64_t P9N2_EX_7_CPPM_ERRMSK                                        = 0x2E0F0122ull;
//DUPS: 2F0F0122,
static const uint64_t P9N2_EX_8_CPPM_ERRMSK                                        = 0x300F0122ull;
//DUPS: 310F0122,
static const uint64_t P9N2_EX_9_CPPM_ERRMSK                                        = 0x320F0122ull;
//DUPS: 330F0122,
static const uint64_t P9N2_EX_10_CPPM_ERRMSK                                       = 0x340F0122ull;
//DUPS: 350F0122,
static const uint64_t P9N2_EX_11_CPPM_ERRMSK                                       = 0x360F0122ull;
//DUPS: 370F0122,

static const uint64_t P9N2_C_CPPM_IPPMCMD                                          = 0x200F01C0ull;

static const uint64_t P9N2_C_0_CPPM_IPPMCMD                                        = 0x200F01C0ull;

static const uint64_t P9N2_C_1_CPPM_IPPMCMD                                        = 0x210F01C0ull;

static const uint64_t P9N2_C_2_CPPM_IPPMCMD                                        = 0x220F01C0ull;

static const uint64_t P9N2_C_3_CPPM_IPPMCMD                                        = 0x230F01C0ull;

static const uint64_t P9N2_C_4_CPPM_IPPMCMD                                        = 0x240F01C0ull;

static const uint64_t P9N2_C_5_CPPM_IPPMCMD                                        = 0x250F01C0ull;

static const uint64_t P9N2_C_6_CPPM_IPPMCMD                                        = 0x260F01C0ull;

static const uint64_t P9N2_C_7_CPPM_IPPMCMD                                        = 0x270F01C0ull;

static const uint64_t P9N2_C_8_CPPM_IPPMCMD                                        = 0x280F01C0ull;

static const uint64_t P9N2_C_9_CPPM_IPPMCMD                                        = 0x290F01C0ull;

static const uint64_t P9N2_C_10_CPPM_IPPMCMD                                       = 0x2A0F01C0ull;

static const uint64_t P9N2_C_11_CPPM_IPPMCMD                                       = 0x2B0F01C0ull;

static const uint64_t P9N2_C_12_CPPM_IPPMCMD                                       = 0x2C0F01C0ull;

static const uint64_t P9N2_C_13_CPPM_IPPMCMD                                       = 0x2D0F01C0ull;

static const uint64_t P9N2_C_14_CPPM_IPPMCMD                                       = 0x2E0F01C0ull;

static const uint64_t P9N2_C_15_CPPM_IPPMCMD                                       = 0x2F0F01C0ull;

static const uint64_t P9N2_C_16_CPPM_IPPMCMD                                       = 0x300F01C0ull;

static const uint64_t P9N2_C_17_CPPM_IPPMCMD                                       = 0x310F01C0ull;

static const uint64_t P9N2_C_18_CPPM_IPPMCMD                                       = 0x320F01C0ull;

static const uint64_t P9N2_C_19_CPPM_IPPMCMD                                       = 0x330F01C0ull;

static const uint64_t P9N2_C_20_CPPM_IPPMCMD                                       = 0x340F01C0ull;

static const uint64_t P9N2_C_21_CPPM_IPPMCMD                                       = 0x350F01C0ull;

static const uint64_t P9N2_C_22_CPPM_IPPMCMD                                       = 0x360F01C0ull;

static const uint64_t P9N2_C_23_CPPM_IPPMCMD                                       = 0x370F01C0ull;

static const uint64_t P9N2_EX_CPPM_IPPMCMD                                         = 0x200F01C0ull;
//DUPS: 210F01C0,
static const uint64_t P9N2_EX_0_CPPM_IPPMCMD                                       = 0x200F01C0ull;
//DUPS: 210F01C0,
static const uint64_t P9N2_EX_1_CPPM_IPPMCMD                                       = 0x220F01C0ull;
//DUPS: 220F01C0,
static const uint64_t P9N2_EX_2_CPPM_IPPMCMD                                       = 0x240F01C0ull;
//DUPS: 250F01C0,
static const uint64_t P9N2_EX_3_CPPM_IPPMCMD                                       = 0x260F01C0ull;
//DUPS: 270F01C0,
static const uint64_t P9N2_EX_4_CPPM_IPPMCMD                                       = 0x280F01C0ull;
//DUPS: 290F01C0,
static const uint64_t P9N2_EX_5_CPPM_IPPMCMD                                       = 0x2A0F01C0ull;
//DUPS: 2B0F01C0,
static const uint64_t P9N2_EX_6_CPPM_IPPMCMD                                       = 0x2C0F01C0ull;
//DUPS: 2D0F01C0,
static const uint64_t P9N2_EX_7_CPPM_IPPMCMD                                       = 0x2E0F01C0ull;
//DUPS: 2F0F01C0,
static const uint64_t P9N2_EX_8_CPPM_IPPMCMD                                       = 0x300F01C0ull;
//DUPS: 310F01C0,
static const uint64_t P9N2_EX_9_CPPM_IPPMCMD                                       = 0x320F01C0ull;
//DUPS: 330F01C0,
static const uint64_t P9N2_EX_10_CPPM_IPPMCMD                                      = 0x340F01C0ull;
//DUPS: 350F01C0,
static const uint64_t P9N2_EX_11_CPPM_IPPMCMD                                      = 0x360F01C0ull;
//DUPS: 370F01C0,

static const uint64_t P9N2_C_CPPM_IPPMRDATA                                        = 0x200F01C3ull;

static const uint64_t P9N2_C_0_CPPM_IPPMRDATA                                      = 0x200F01C3ull;

static const uint64_t P9N2_C_1_CPPM_IPPMRDATA                                      = 0x210F01C3ull;

static const uint64_t P9N2_C_2_CPPM_IPPMRDATA                                      = 0x220F01C3ull;

static const uint64_t P9N2_C_3_CPPM_IPPMRDATA                                      = 0x230F01C3ull;

static const uint64_t P9N2_C_4_CPPM_IPPMRDATA                                      = 0x240F01C3ull;

static const uint64_t P9N2_C_5_CPPM_IPPMRDATA                                      = 0x250F01C3ull;

static const uint64_t P9N2_C_6_CPPM_IPPMRDATA                                      = 0x260F01C3ull;

static const uint64_t P9N2_C_7_CPPM_IPPMRDATA                                      = 0x270F01C3ull;

static const uint64_t P9N2_C_8_CPPM_IPPMRDATA                                      = 0x280F01C3ull;

static const uint64_t P9N2_C_9_CPPM_IPPMRDATA                                      = 0x290F01C3ull;

static const uint64_t P9N2_C_10_CPPM_IPPMRDATA                                     = 0x2A0F01C3ull;

static const uint64_t P9N2_C_11_CPPM_IPPMRDATA                                     = 0x2B0F01C3ull;

static const uint64_t P9N2_C_12_CPPM_IPPMRDATA                                     = 0x2C0F01C3ull;

static const uint64_t P9N2_C_13_CPPM_IPPMRDATA                                     = 0x2D0F01C3ull;

static const uint64_t P9N2_C_14_CPPM_IPPMRDATA                                     = 0x2E0F01C3ull;

static const uint64_t P9N2_C_15_CPPM_IPPMRDATA                                     = 0x2F0F01C3ull;

static const uint64_t P9N2_C_16_CPPM_IPPMRDATA                                     = 0x300F01C3ull;

static const uint64_t P9N2_C_17_CPPM_IPPMRDATA                                     = 0x310F01C3ull;

static const uint64_t P9N2_C_18_CPPM_IPPMRDATA                                     = 0x320F01C3ull;

static const uint64_t P9N2_C_19_CPPM_IPPMRDATA                                     = 0x330F01C3ull;

static const uint64_t P9N2_C_20_CPPM_IPPMRDATA                                     = 0x340F01C3ull;

static const uint64_t P9N2_C_21_CPPM_IPPMRDATA                                     = 0x350F01C3ull;

static const uint64_t P9N2_C_22_CPPM_IPPMRDATA                                     = 0x360F01C3ull;

static const uint64_t P9N2_C_23_CPPM_IPPMRDATA                                     = 0x370F01C3ull;

static const uint64_t P9N2_EX_CPPM_IPPMRDATA                                       = 0x200F01C3ull;
//DUPS: 210F01C3,
static const uint64_t P9N2_EX_0_CPPM_IPPMRDATA                                     = 0x200F01C3ull;
//DUPS: 210F01C3,
static const uint64_t P9N2_EX_1_CPPM_IPPMRDATA                                     = 0x220F01C3ull;
//DUPS: 220F01C3,
static const uint64_t P9N2_EX_2_CPPM_IPPMRDATA                                     = 0x240F01C3ull;
//DUPS: 250F01C3,
static const uint64_t P9N2_EX_3_CPPM_IPPMRDATA                                     = 0x260F01C3ull;
//DUPS: 270F01C3,
static const uint64_t P9N2_EX_4_CPPM_IPPMRDATA                                     = 0x280F01C3ull;
//DUPS: 290F01C3,
static const uint64_t P9N2_EX_5_CPPM_IPPMRDATA                                     = 0x2A0F01C3ull;
//DUPS: 2B0F01C3,
static const uint64_t P9N2_EX_6_CPPM_IPPMRDATA                                     = 0x2C0F01C3ull;
//DUPS: 2D0F01C3,
static const uint64_t P9N2_EX_7_CPPM_IPPMRDATA                                     = 0x2E0F01C3ull;
//DUPS: 2F0F01C3,
static const uint64_t P9N2_EX_8_CPPM_IPPMRDATA                                     = 0x300F01C3ull;
//DUPS: 310F01C3,
static const uint64_t P9N2_EX_9_CPPM_IPPMRDATA                                     = 0x320F01C3ull;
//DUPS: 330F01C3,
static const uint64_t P9N2_EX_10_CPPM_IPPMRDATA                                    = 0x340F01C3ull;
//DUPS: 350F01C3,
static const uint64_t P9N2_EX_11_CPPM_IPPMRDATA                                    = 0x360F01C3ull;
//DUPS: 370F01C3,

static const uint64_t P9N2_C_CPPM_IPPMSTAT                                         = 0x200F01C1ull;

static const uint64_t P9N2_C_0_CPPM_IPPMSTAT                                       = 0x200F01C1ull;

static const uint64_t P9N2_C_1_CPPM_IPPMSTAT                                       = 0x210F01C1ull;

static const uint64_t P9N2_C_2_CPPM_IPPMSTAT                                       = 0x220F01C1ull;

static const uint64_t P9N2_C_3_CPPM_IPPMSTAT                                       = 0x230F01C1ull;

static const uint64_t P9N2_C_4_CPPM_IPPMSTAT                                       = 0x240F01C1ull;

static const uint64_t P9N2_C_5_CPPM_IPPMSTAT                                       = 0x250F01C1ull;

static const uint64_t P9N2_C_6_CPPM_IPPMSTAT                                       = 0x260F01C1ull;

static const uint64_t P9N2_C_7_CPPM_IPPMSTAT                                       = 0x270F01C1ull;

static const uint64_t P9N2_C_8_CPPM_IPPMSTAT                                       = 0x280F01C1ull;

static const uint64_t P9N2_C_9_CPPM_IPPMSTAT                                       = 0x290F01C1ull;

static const uint64_t P9N2_C_10_CPPM_IPPMSTAT                                      = 0x2A0F01C1ull;

static const uint64_t P9N2_C_11_CPPM_IPPMSTAT                                      = 0x2B0F01C1ull;

static const uint64_t P9N2_C_12_CPPM_IPPMSTAT                                      = 0x2C0F01C1ull;

static const uint64_t P9N2_C_13_CPPM_IPPMSTAT                                      = 0x2D0F01C1ull;

static const uint64_t P9N2_C_14_CPPM_IPPMSTAT                                      = 0x2E0F01C1ull;

static const uint64_t P9N2_C_15_CPPM_IPPMSTAT                                      = 0x2F0F01C1ull;

static const uint64_t P9N2_C_16_CPPM_IPPMSTAT                                      = 0x300F01C1ull;

static const uint64_t P9N2_C_17_CPPM_IPPMSTAT                                      = 0x310F01C1ull;

static const uint64_t P9N2_C_18_CPPM_IPPMSTAT                                      = 0x320F01C1ull;

static const uint64_t P9N2_C_19_CPPM_IPPMSTAT                                      = 0x330F01C1ull;

static const uint64_t P9N2_C_20_CPPM_IPPMSTAT                                      = 0x340F01C1ull;

static const uint64_t P9N2_C_21_CPPM_IPPMSTAT                                      = 0x350F01C1ull;

static const uint64_t P9N2_C_22_CPPM_IPPMSTAT                                      = 0x360F01C1ull;

static const uint64_t P9N2_C_23_CPPM_IPPMSTAT                                      = 0x370F01C1ull;

static const uint64_t P9N2_EX_CPPM_IPPMSTAT                                        = 0x200F01C1ull;
//DUPS: 210F01C1,
static const uint64_t P9N2_EX_0_CPPM_IPPMSTAT                                      = 0x200F01C1ull;
//DUPS: 210F01C1,
static const uint64_t P9N2_EX_1_CPPM_IPPMSTAT                                      = 0x220F01C1ull;
//DUPS: 220F01C1,
static const uint64_t P9N2_EX_2_CPPM_IPPMSTAT                                      = 0x240F01C1ull;
//DUPS: 250F01C1,
static const uint64_t P9N2_EX_3_CPPM_IPPMSTAT                                      = 0x260F01C1ull;
//DUPS: 270F01C1,
static const uint64_t P9N2_EX_4_CPPM_IPPMSTAT                                      = 0x280F01C1ull;
//DUPS: 290F01C1,
static const uint64_t P9N2_EX_5_CPPM_IPPMSTAT                                      = 0x2A0F01C1ull;
//DUPS: 2B0F01C1,
static const uint64_t P9N2_EX_6_CPPM_IPPMSTAT                                      = 0x2C0F01C1ull;
//DUPS: 2D0F01C1,
static const uint64_t P9N2_EX_7_CPPM_IPPMSTAT                                      = 0x2E0F01C1ull;
//DUPS: 2F0F01C1,
static const uint64_t P9N2_EX_8_CPPM_IPPMSTAT                                      = 0x300F01C1ull;
//DUPS: 310F01C1,
static const uint64_t P9N2_EX_9_CPPM_IPPMSTAT                                      = 0x320F01C1ull;
//DUPS: 330F01C1,
static const uint64_t P9N2_EX_10_CPPM_IPPMSTAT                                     = 0x340F01C1ull;
//DUPS: 350F01C1,
static const uint64_t P9N2_EX_11_CPPM_IPPMSTAT                                     = 0x360F01C1ull;
//DUPS: 370F01C1,

static const uint64_t P9N2_C_CPPM_IPPMWDATA                                        = 0x200F01C2ull;

static const uint64_t P9N2_C_0_CPPM_IPPMWDATA                                      = 0x200F01C2ull;

static const uint64_t P9N2_C_1_CPPM_IPPMWDATA                                      = 0x210F01C2ull;

static const uint64_t P9N2_C_2_CPPM_IPPMWDATA                                      = 0x220F01C2ull;

static const uint64_t P9N2_C_3_CPPM_IPPMWDATA                                      = 0x230F01C2ull;

static const uint64_t P9N2_C_4_CPPM_IPPMWDATA                                      = 0x240F01C2ull;

static const uint64_t P9N2_C_5_CPPM_IPPMWDATA                                      = 0x250F01C2ull;

static const uint64_t P9N2_C_6_CPPM_IPPMWDATA                                      = 0x260F01C2ull;

static const uint64_t P9N2_C_7_CPPM_IPPMWDATA                                      = 0x270F01C2ull;

static const uint64_t P9N2_C_8_CPPM_IPPMWDATA                                      = 0x280F01C2ull;

static const uint64_t P9N2_C_9_CPPM_IPPMWDATA                                      = 0x290F01C2ull;

static const uint64_t P9N2_C_10_CPPM_IPPMWDATA                                     = 0x2A0F01C2ull;

static const uint64_t P9N2_C_11_CPPM_IPPMWDATA                                     = 0x2B0F01C2ull;

static const uint64_t P9N2_C_12_CPPM_IPPMWDATA                                     = 0x2C0F01C2ull;

static const uint64_t P9N2_C_13_CPPM_IPPMWDATA                                     = 0x2D0F01C2ull;

static const uint64_t P9N2_C_14_CPPM_IPPMWDATA                                     = 0x2E0F01C2ull;

static const uint64_t P9N2_C_15_CPPM_IPPMWDATA                                     = 0x2F0F01C2ull;

static const uint64_t P9N2_C_16_CPPM_IPPMWDATA                                     = 0x300F01C2ull;

static const uint64_t P9N2_C_17_CPPM_IPPMWDATA                                     = 0x310F01C2ull;

static const uint64_t P9N2_C_18_CPPM_IPPMWDATA                                     = 0x320F01C2ull;

static const uint64_t P9N2_C_19_CPPM_IPPMWDATA                                     = 0x330F01C2ull;

static const uint64_t P9N2_C_20_CPPM_IPPMWDATA                                     = 0x340F01C2ull;

static const uint64_t P9N2_C_21_CPPM_IPPMWDATA                                     = 0x350F01C2ull;

static const uint64_t P9N2_C_22_CPPM_IPPMWDATA                                     = 0x360F01C2ull;

static const uint64_t P9N2_C_23_CPPM_IPPMWDATA                                     = 0x370F01C2ull;

static const uint64_t P9N2_EX_CPPM_IPPMWDATA                                       = 0x200F01C2ull;
//DUPS: 210F01C2,
static const uint64_t P9N2_EX_0_CPPM_IPPMWDATA                                     = 0x200F01C2ull;
//DUPS: 210F01C2,
static const uint64_t P9N2_EX_1_CPPM_IPPMWDATA                                     = 0x220F01C2ull;
//DUPS: 220F01C2,
static const uint64_t P9N2_EX_2_CPPM_IPPMWDATA                                     = 0x240F01C2ull;
//DUPS: 250F01C2,
static const uint64_t P9N2_EX_3_CPPM_IPPMWDATA                                     = 0x260F01C2ull;
//DUPS: 270F01C2,
static const uint64_t P9N2_EX_4_CPPM_IPPMWDATA                                     = 0x280F01C2ull;
//DUPS: 290F01C2,
static const uint64_t P9N2_EX_5_CPPM_IPPMWDATA                                     = 0x2A0F01C2ull;
//DUPS: 2B0F01C2,
static const uint64_t P9N2_EX_6_CPPM_IPPMWDATA                                     = 0x2C0F01C2ull;
//DUPS: 2D0F01C2,
static const uint64_t P9N2_EX_7_CPPM_IPPMWDATA                                     = 0x2E0F01C2ull;
//DUPS: 2F0F01C2,
static const uint64_t P9N2_EX_8_CPPM_IPPMWDATA                                     = 0x300F01C2ull;
//DUPS: 310F01C2,
static const uint64_t P9N2_EX_9_CPPM_IPPMWDATA                                     = 0x320F01C2ull;
//DUPS: 330F01C2,
static const uint64_t P9N2_EX_10_CPPM_IPPMWDATA                                    = 0x340F01C2ull;
//DUPS: 350F01C2,
static const uint64_t P9N2_EX_11_CPPM_IPPMWDATA                                    = 0x360F01C2ull;
//DUPS: 370F01C2,

static const uint64_t P9N2_C_CPPM_NC0INDIR_SCOM                                    = 0x200F0130ull;

static const uint64_t P9N2_C_CPPM_NC0INDIR_SCOM1                                   = 0x200F0131ull;

static const uint64_t P9N2_C_CPPM_NC0INDIR_SCOM2                                   = 0x200F0132ull;

static const uint64_t P9N2_C_0_CPPM_NC0INDIR_SCOM                                  = 0x200F0130ull;

static const uint64_t P9N2_C_0_CPPM_NC0INDIR_SCOM1                                 = 0x200F0131ull;

static const uint64_t P9N2_C_0_CPPM_NC0INDIR_SCOM2                                 = 0x200F0132ull;

static const uint64_t P9N2_C_1_CPPM_NC0INDIR_SCOM                                  = 0x210F0130ull;

static const uint64_t P9N2_C_1_CPPM_NC0INDIR_SCOM1                                 = 0x210F0131ull;

static const uint64_t P9N2_C_1_CPPM_NC0INDIR_SCOM2                                 = 0x210F0132ull;

static const uint64_t P9N2_C_2_CPPM_NC0INDIR_SCOM                                  = 0x220F0130ull;

static const uint64_t P9N2_C_2_CPPM_NC0INDIR_SCOM1                                 = 0x220F0131ull;

static const uint64_t P9N2_C_2_CPPM_NC0INDIR_SCOM2                                 = 0x220F0132ull;

static const uint64_t P9N2_C_3_CPPM_NC0INDIR_SCOM                                  = 0x230F0130ull;

static const uint64_t P9N2_C_3_CPPM_NC0INDIR_SCOM1                                 = 0x230F0131ull;

static const uint64_t P9N2_C_3_CPPM_NC0INDIR_SCOM2                                 = 0x230F0132ull;

static const uint64_t P9N2_C_4_CPPM_NC0INDIR_SCOM                                  = 0x240F0130ull;

static const uint64_t P9N2_C_4_CPPM_NC0INDIR_SCOM1                                 = 0x240F0131ull;

static const uint64_t P9N2_C_4_CPPM_NC0INDIR_SCOM2                                 = 0x240F0132ull;

static const uint64_t P9N2_C_5_CPPM_NC0INDIR_SCOM                                  = 0x250F0130ull;

static const uint64_t P9N2_C_5_CPPM_NC0INDIR_SCOM1                                 = 0x250F0131ull;

static const uint64_t P9N2_C_5_CPPM_NC0INDIR_SCOM2                                 = 0x250F0132ull;

static const uint64_t P9N2_C_6_CPPM_NC0INDIR_SCOM                                  = 0x260F0130ull;

static const uint64_t P9N2_C_6_CPPM_NC0INDIR_SCOM1                                 = 0x260F0131ull;

static const uint64_t P9N2_C_6_CPPM_NC0INDIR_SCOM2                                 = 0x260F0132ull;

static const uint64_t P9N2_C_7_CPPM_NC0INDIR_SCOM                                  = 0x270F0130ull;

static const uint64_t P9N2_C_7_CPPM_NC0INDIR_SCOM1                                 = 0x270F0131ull;

static const uint64_t P9N2_C_7_CPPM_NC0INDIR_SCOM2                                 = 0x270F0132ull;

static const uint64_t P9N2_C_8_CPPM_NC0INDIR_SCOM                                  = 0x280F0130ull;

static const uint64_t P9N2_C_8_CPPM_NC0INDIR_SCOM1                                 = 0x280F0131ull;

static const uint64_t P9N2_C_8_CPPM_NC0INDIR_SCOM2                                 = 0x280F0132ull;

static const uint64_t P9N2_C_9_CPPM_NC0INDIR_SCOM                                  = 0x290F0130ull;

static const uint64_t P9N2_C_9_CPPM_NC0INDIR_SCOM1                                 = 0x290F0131ull;

static const uint64_t P9N2_C_9_CPPM_NC0INDIR_SCOM2                                 = 0x290F0132ull;

static const uint64_t P9N2_C_10_CPPM_NC0INDIR_SCOM                                 = 0x2A0F0130ull;

static const uint64_t P9N2_C_10_CPPM_NC0INDIR_SCOM1                                = 0x2A0F0131ull;

static const uint64_t P9N2_C_10_CPPM_NC0INDIR_SCOM2                                = 0x2A0F0132ull;

static const uint64_t P9N2_C_11_CPPM_NC0INDIR_SCOM                                 = 0x2B0F0130ull;

static const uint64_t P9N2_C_11_CPPM_NC0INDIR_SCOM1                                = 0x2B0F0131ull;

static const uint64_t P9N2_C_11_CPPM_NC0INDIR_SCOM2                                = 0x2B0F0132ull;

static const uint64_t P9N2_C_12_CPPM_NC0INDIR_SCOM                                 = 0x2C0F0130ull;

static const uint64_t P9N2_C_12_CPPM_NC0INDIR_SCOM1                                = 0x2C0F0131ull;

static const uint64_t P9N2_C_12_CPPM_NC0INDIR_SCOM2                                = 0x2C0F0132ull;

static const uint64_t P9N2_C_13_CPPM_NC0INDIR_SCOM                                 = 0x2D0F0130ull;

static const uint64_t P9N2_C_13_CPPM_NC0INDIR_SCOM1                                = 0x2D0F0131ull;

static const uint64_t P9N2_C_13_CPPM_NC0INDIR_SCOM2                                = 0x2D0F0132ull;

static const uint64_t P9N2_C_14_CPPM_NC0INDIR_SCOM                                 = 0x2E0F0130ull;

static const uint64_t P9N2_C_14_CPPM_NC0INDIR_SCOM1                                = 0x2E0F0131ull;

static const uint64_t P9N2_C_14_CPPM_NC0INDIR_SCOM2                                = 0x2E0F0132ull;

static const uint64_t P9N2_C_15_CPPM_NC0INDIR_SCOM                                 = 0x2F0F0130ull;

static const uint64_t P9N2_C_15_CPPM_NC0INDIR_SCOM1                                = 0x2F0F0131ull;

static const uint64_t P9N2_C_15_CPPM_NC0INDIR_SCOM2                                = 0x2F0F0132ull;

static const uint64_t P9N2_C_16_CPPM_NC0INDIR_SCOM                                 = 0x300F0130ull;

static const uint64_t P9N2_C_16_CPPM_NC0INDIR_SCOM1                                = 0x300F0131ull;

static const uint64_t P9N2_C_16_CPPM_NC0INDIR_SCOM2                                = 0x300F0132ull;

static const uint64_t P9N2_C_17_CPPM_NC0INDIR_SCOM                                 = 0x310F0130ull;

static const uint64_t P9N2_C_17_CPPM_NC0INDIR_SCOM1                                = 0x310F0131ull;

static const uint64_t P9N2_C_17_CPPM_NC0INDIR_SCOM2                                = 0x310F0132ull;

static const uint64_t P9N2_C_18_CPPM_NC0INDIR_SCOM                                 = 0x320F0130ull;

static const uint64_t P9N2_C_18_CPPM_NC0INDIR_SCOM1                                = 0x320F0131ull;

static const uint64_t P9N2_C_18_CPPM_NC0INDIR_SCOM2                                = 0x320F0132ull;

static const uint64_t P9N2_C_19_CPPM_NC0INDIR_SCOM                                 = 0x330F0130ull;

static const uint64_t P9N2_C_19_CPPM_NC0INDIR_SCOM1                                = 0x330F0131ull;

static const uint64_t P9N2_C_19_CPPM_NC0INDIR_SCOM2                                = 0x330F0132ull;

static const uint64_t P9N2_C_20_CPPM_NC0INDIR_SCOM                                 = 0x340F0130ull;

static const uint64_t P9N2_C_20_CPPM_NC0INDIR_SCOM1                                = 0x340F0131ull;

static const uint64_t P9N2_C_20_CPPM_NC0INDIR_SCOM2                                = 0x340F0132ull;

static const uint64_t P9N2_C_21_CPPM_NC0INDIR_SCOM                                 = 0x350F0130ull;

static const uint64_t P9N2_C_21_CPPM_NC0INDIR_SCOM1                                = 0x350F0131ull;

static const uint64_t P9N2_C_21_CPPM_NC0INDIR_SCOM2                                = 0x350F0132ull;

static const uint64_t P9N2_C_22_CPPM_NC0INDIR_SCOM                                 = 0x360F0130ull;

static const uint64_t P9N2_C_22_CPPM_NC0INDIR_SCOM1                                = 0x360F0131ull;

static const uint64_t P9N2_C_22_CPPM_NC0INDIR_SCOM2                                = 0x360F0132ull;

static const uint64_t P9N2_C_23_CPPM_NC0INDIR_SCOM                                 = 0x370F0130ull;

static const uint64_t P9N2_C_23_CPPM_NC0INDIR_SCOM1                                = 0x370F0131ull;

static const uint64_t P9N2_C_23_CPPM_NC0INDIR_SCOM2                                = 0x370F0132ull;

static const uint64_t P9N2_EX_CPPM_NC0INDIR_SCOM                                   = 0x200F0130ull;
//DUPS: 210F0130,
static const uint64_t P9N2_EX_CPPM_NC0INDIR_SCOM1                                  = 0x200F0131ull;
//DUPS: 210F0131,
static const uint64_t P9N2_EX_CPPM_NC0INDIR_SCOM2                                  = 0x200F0132ull;
//DUPS: 210F0132,
static const uint64_t P9N2_EX_0_CPPM_NC0INDIR_SCOM                                 = 0x200F0130ull;
//DUPS: 210F0130,
static const uint64_t P9N2_EX_0_CPPM_NC0INDIR_SCOM1                                = 0x200F0131ull;
//DUPS: 210F0131,
static const uint64_t P9N2_EX_0_CPPM_NC0INDIR_SCOM2                                = 0x200F0132ull;
//DUPS: 210F0132,
static const uint64_t P9N2_EX_1_CPPM_NC0INDIR_SCOM                                 = 0x220F0130ull;
//DUPS: 220F0130,
static const uint64_t P9N2_EX_1_CPPM_NC0INDIR_SCOM1                                = 0x220F0131ull;
//DUPS: 220F0131,
static const uint64_t P9N2_EX_1_CPPM_NC0INDIR_SCOM2                                = 0x220F0132ull;
//DUPS: 220F0132,
static const uint64_t P9N2_EX_2_CPPM_NC0INDIR_SCOM                                 = 0x240F0130ull;
//DUPS: 250F0130,
static const uint64_t P9N2_EX_2_CPPM_NC0INDIR_SCOM1                                = 0x240F0131ull;
//DUPS: 250F0131,
static const uint64_t P9N2_EX_2_CPPM_NC0INDIR_SCOM2                                = 0x240F0132ull;
//DUPS: 250F0132,
static const uint64_t P9N2_EX_3_CPPM_NC0INDIR_SCOM                                 = 0x260F0130ull;
//DUPS: 270F0130,
static const uint64_t P9N2_EX_3_CPPM_NC0INDIR_SCOM1                                = 0x260F0131ull;
//DUPS: 270F0131,
static const uint64_t P9N2_EX_3_CPPM_NC0INDIR_SCOM2                                = 0x260F0132ull;
//DUPS: 270F0132,
static const uint64_t P9N2_EX_4_CPPM_NC0INDIR_SCOM                                 = 0x280F0130ull;
//DUPS: 290F0130,
static const uint64_t P9N2_EX_4_CPPM_NC0INDIR_SCOM1                                = 0x280F0131ull;
//DUPS: 290F0131,
static const uint64_t P9N2_EX_4_CPPM_NC0INDIR_SCOM2                                = 0x280F0132ull;
//DUPS: 290F0132,
static const uint64_t P9N2_EX_5_CPPM_NC0INDIR_SCOM                                 = 0x2A0F0130ull;
//DUPS: 2B0F0130,
static const uint64_t P9N2_EX_5_CPPM_NC0INDIR_SCOM1                                = 0x2A0F0131ull;
//DUPS: 2B0F0131,
static const uint64_t P9N2_EX_5_CPPM_NC0INDIR_SCOM2                                = 0x2A0F0132ull;
//DUPS: 2B0F0132,
static const uint64_t P9N2_EX_6_CPPM_NC0INDIR_SCOM                                 = 0x2C0F0130ull;
//DUPS: 2D0F0130,
static const uint64_t P9N2_EX_6_CPPM_NC0INDIR_SCOM1                                = 0x2C0F0131ull;
//DUPS: 2D0F0131,
static const uint64_t P9N2_EX_6_CPPM_NC0INDIR_SCOM2                                = 0x2C0F0132ull;
//DUPS: 2D0F0132,
static const uint64_t P9N2_EX_7_CPPM_NC0INDIR_SCOM                                 = 0x2E0F0130ull;
//DUPS: 2F0F0130,
static const uint64_t P9N2_EX_7_CPPM_NC0INDIR_SCOM1                                = 0x2E0F0131ull;
//DUPS: 2F0F0131,
static const uint64_t P9N2_EX_7_CPPM_NC0INDIR_SCOM2                                = 0x2E0F0132ull;
//DUPS: 2F0F0132,
static const uint64_t P9N2_EX_8_CPPM_NC0INDIR_SCOM                                 = 0x300F0130ull;
//DUPS: 310F0130,
static const uint64_t P9N2_EX_8_CPPM_NC0INDIR_SCOM1                                = 0x300F0131ull;
//DUPS: 310F0131,
static const uint64_t P9N2_EX_8_CPPM_NC0INDIR_SCOM2                                = 0x300F0132ull;
//DUPS: 310F0132,
static const uint64_t P9N2_EX_9_CPPM_NC0INDIR_SCOM                                 = 0x320F0130ull;
//DUPS: 330F0130,
static const uint64_t P9N2_EX_9_CPPM_NC0INDIR_SCOM1                                = 0x320F0131ull;
//DUPS: 330F0131,
static const uint64_t P9N2_EX_9_CPPM_NC0INDIR_SCOM2                                = 0x320F0132ull;
//DUPS: 330F0132,
static const uint64_t P9N2_EX_10_CPPM_NC0INDIR_SCOM                                = 0x340F0130ull;
//DUPS: 350F0130,
static const uint64_t P9N2_EX_10_CPPM_NC0INDIR_SCOM1                               = 0x340F0131ull;
//DUPS: 350F0131,
static const uint64_t P9N2_EX_10_CPPM_NC0INDIR_SCOM2                               = 0x340F0132ull;
//DUPS: 350F0132,
static const uint64_t P9N2_EX_11_CPPM_NC0INDIR_SCOM                                = 0x360F0130ull;
//DUPS: 370F0130,
static const uint64_t P9N2_EX_11_CPPM_NC0INDIR_SCOM1                               = 0x360F0131ull;
//DUPS: 370F0131,
static const uint64_t P9N2_EX_11_CPPM_NC0INDIR_SCOM2                               = 0x360F0132ull;
//DUPS: 370F0132,

static const uint64_t P9N2_C_CPPM_NC1INDIR_SCOM                                    = 0x200F0133ull;

static const uint64_t P9N2_C_CPPM_NC1INDIR_SCOM1                                   = 0x200F0134ull;

static const uint64_t P9N2_C_CPPM_NC1INDIR_SCOM2                                   = 0x200F0135ull;

static const uint64_t P9N2_C_0_CPPM_NC1INDIR_SCOM                                  = 0x200F0133ull;

static const uint64_t P9N2_C_0_CPPM_NC1INDIR_SCOM1                                 = 0x200F0134ull;

static const uint64_t P9N2_C_0_CPPM_NC1INDIR_SCOM2                                 = 0x200F0135ull;

static const uint64_t P9N2_C_1_CPPM_NC1INDIR_SCOM                                  = 0x210F0133ull;

static const uint64_t P9N2_C_1_CPPM_NC1INDIR_SCOM1                                 = 0x210F0134ull;

static const uint64_t P9N2_C_1_CPPM_NC1INDIR_SCOM2                                 = 0x210F0135ull;

static const uint64_t P9N2_C_2_CPPM_NC1INDIR_SCOM                                  = 0x220F0133ull;

static const uint64_t P9N2_C_2_CPPM_NC1INDIR_SCOM1                                 = 0x220F0134ull;

static const uint64_t P9N2_C_2_CPPM_NC1INDIR_SCOM2                                 = 0x220F0135ull;

static const uint64_t P9N2_C_3_CPPM_NC1INDIR_SCOM                                  = 0x230F0133ull;

static const uint64_t P9N2_C_3_CPPM_NC1INDIR_SCOM1                                 = 0x230F0134ull;

static const uint64_t P9N2_C_3_CPPM_NC1INDIR_SCOM2                                 = 0x230F0135ull;

static const uint64_t P9N2_C_4_CPPM_NC1INDIR_SCOM                                  = 0x240F0133ull;

static const uint64_t P9N2_C_4_CPPM_NC1INDIR_SCOM1                                 = 0x240F0134ull;

static const uint64_t P9N2_C_4_CPPM_NC1INDIR_SCOM2                                 = 0x240F0135ull;

static const uint64_t P9N2_C_5_CPPM_NC1INDIR_SCOM                                  = 0x250F0133ull;

static const uint64_t P9N2_C_5_CPPM_NC1INDIR_SCOM1                                 = 0x250F0134ull;

static const uint64_t P9N2_C_5_CPPM_NC1INDIR_SCOM2                                 = 0x250F0135ull;

static const uint64_t P9N2_C_6_CPPM_NC1INDIR_SCOM                                  = 0x260F0133ull;

static const uint64_t P9N2_C_6_CPPM_NC1INDIR_SCOM1                                 = 0x260F0134ull;

static const uint64_t P9N2_C_6_CPPM_NC1INDIR_SCOM2                                 = 0x260F0135ull;

static const uint64_t P9N2_C_7_CPPM_NC1INDIR_SCOM                                  = 0x270F0133ull;

static const uint64_t P9N2_C_7_CPPM_NC1INDIR_SCOM1                                 = 0x270F0134ull;

static const uint64_t P9N2_C_7_CPPM_NC1INDIR_SCOM2                                 = 0x270F0135ull;

static const uint64_t P9N2_C_8_CPPM_NC1INDIR_SCOM                                  = 0x280F0133ull;

static const uint64_t P9N2_C_8_CPPM_NC1INDIR_SCOM1                                 = 0x280F0134ull;

static const uint64_t P9N2_C_8_CPPM_NC1INDIR_SCOM2                                 = 0x280F0135ull;

static const uint64_t P9N2_C_9_CPPM_NC1INDIR_SCOM                                  = 0x290F0133ull;

static const uint64_t P9N2_C_9_CPPM_NC1INDIR_SCOM1                                 = 0x290F0134ull;

static const uint64_t P9N2_C_9_CPPM_NC1INDIR_SCOM2                                 = 0x290F0135ull;

static const uint64_t P9N2_C_10_CPPM_NC1INDIR_SCOM                                 = 0x2A0F0133ull;

static const uint64_t P9N2_C_10_CPPM_NC1INDIR_SCOM1                                = 0x2A0F0134ull;

static const uint64_t P9N2_C_10_CPPM_NC1INDIR_SCOM2                                = 0x2A0F0135ull;

static const uint64_t P9N2_C_11_CPPM_NC1INDIR_SCOM                                 = 0x2B0F0133ull;

static const uint64_t P9N2_C_11_CPPM_NC1INDIR_SCOM1                                = 0x2B0F0134ull;

static const uint64_t P9N2_C_11_CPPM_NC1INDIR_SCOM2                                = 0x2B0F0135ull;

static const uint64_t P9N2_C_12_CPPM_NC1INDIR_SCOM                                 = 0x2C0F0133ull;

static const uint64_t P9N2_C_12_CPPM_NC1INDIR_SCOM1                                = 0x2C0F0134ull;

static const uint64_t P9N2_C_12_CPPM_NC1INDIR_SCOM2                                = 0x2C0F0135ull;

static const uint64_t P9N2_C_13_CPPM_NC1INDIR_SCOM                                 = 0x2D0F0133ull;

static const uint64_t P9N2_C_13_CPPM_NC1INDIR_SCOM1                                = 0x2D0F0134ull;

static const uint64_t P9N2_C_13_CPPM_NC1INDIR_SCOM2                                = 0x2D0F0135ull;

static const uint64_t P9N2_C_14_CPPM_NC1INDIR_SCOM                                 = 0x2E0F0133ull;

static const uint64_t P9N2_C_14_CPPM_NC1INDIR_SCOM1                                = 0x2E0F0134ull;

static const uint64_t P9N2_C_14_CPPM_NC1INDIR_SCOM2                                = 0x2E0F0135ull;

static const uint64_t P9N2_C_15_CPPM_NC1INDIR_SCOM                                 = 0x2F0F0133ull;

static const uint64_t P9N2_C_15_CPPM_NC1INDIR_SCOM1                                = 0x2F0F0134ull;

static const uint64_t P9N2_C_15_CPPM_NC1INDIR_SCOM2                                = 0x2F0F0135ull;

static const uint64_t P9N2_C_16_CPPM_NC1INDIR_SCOM                                 = 0x300F0133ull;

static const uint64_t P9N2_C_16_CPPM_NC1INDIR_SCOM1                                = 0x300F0134ull;

static const uint64_t P9N2_C_16_CPPM_NC1INDIR_SCOM2                                = 0x300F0135ull;

static const uint64_t P9N2_C_17_CPPM_NC1INDIR_SCOM                                 = 0x310F0133ull;

static const uint64_t P9N2_C_17_CPPM_NC1INDIR_SCOM1                                = 0x310F0134ull;

static const uint64_t P9N2_C_17_CPPM_NC1INDIR_SCOM2                                = 0x310F0135ull;

static const uint64_t P9N2_C_18_CPPM_NC1INDIR_SCOM                                 = 0x320F0133ull;

static const uint64_t P9N2_C_18_CPPM_NC1INDIR_SCOM1                                = 0x320F0134ull;

static const uint64_t P9N2_C_18_CPPM_NC1INDIR_SCOM2                                = 0x320F0135ull;

static const uint64_t P9N2_C_19_CPPM_NC1INDIR_SCOM                                 = 0x330F0133ull;

static const uint64_t P9N2_C_19_CPPM_NC1INDIR_SCOM1                                = 0x330F0134ull;

static const uint64_t P9N2_C_19_CPPM_NC1INDIR_SCOM2                                = 0x330F0135ull;

static const uint64_t P9N2_C_20_CPPM_NC1INDIR_SCOM                                 = 0x340F0133ull;

static const uint64_t P9N2_C_20_CPPM_NC1INDIR_SCOM1                                = 0x340F0134ull;

static const uint64_t P9N2_C_20_CPPM_NC1INDIR_SCOM2                                = 0x340F0135ull;

static const uint64_t P9N2_C_21_CPPM_NC1INDIR_SCOM                                 = 0x350F0133ull;

static const uint64_t P9N2_C_21_CPPM_NC1INDIR_SCOM1                                = 0x350F0134ull;

static const uint64_t P9N2_C_21_CPPM_NC1INDIR_SCOM2                                = 0x350F0135ull;

static const uint64_t P9N2_C_22_CPPM_NC1INDIR_SCOM                                 = 0x360F0133ull;

static const uint64_t P9N2_C_22_CPPM_NC1INDIR_SCOM1                                = 0x360F0134ull;

static const uint64_t P9N2_C_22_CPPM_NC1INDIR_SCOM2                                = 0x360F0135ull;

static const uint64_t P9N2_C_23_CPPM_NC1INDIR_SCOM                                 = 0x370F0133ull;

static const uint64_t P9N2_C_23_CPPM_NC1INDIR_SCOM1                                = 0x370F0134ull;

static const uint64_t P9N2_C_23_CPPM_NC1INDIR_SCOM2                                = 0x370F0135ull;

static const uint64_t P9N2_EX_CPPM_NC1INDIR_SCOM                                   = 0x200F0133ull;
//DUPS: 210F0133,
static const uint64_t P9N2_EX_CPPM_NC1INDIR_SCOM1                                  = 0x200F0134ull;
//DUPS: 210F0134,
static const uint64_t P9N2_EX_CPPM_NC1INDIR_SCOM2                                  = 0x200F0135ull;
//DUPS: 210F0135,
static const uint64_t P9N2_EX_0_CPPM_NC1INDIR_SCOM                                 = 0x200F0133ull;
//DUPS: 210F0133,
static const uint64_t P9N2_EX_0_CPPM_NC1INDIR_SCOM1                                = 0x200F0134ull;
//DUPS: 210F0134,
static const uint64_t P9N2_EX_0_CPPM_NC1INDIR_SCOM2                                = 0x200F0135ull;
//DUPS: 210F0135,
static const uint64_t P9N2_EX_1_CPPM_NC1INDIR_SCOM                                 = 0x220F0133ull;
//DUPS: 220F0133,
static const uint64_t P9N2_EX_1_CPPM_NC1INDIR_SCOM1                                = 0x220F0134ull;
//DUPS: 220F0134,
static const uint64_t P9N2_EX_1_CPPM_NC1INDIR_SCOM2                                = 0x220F0135ull;
//DUPS: 220F0135,
static const uint64_t P9N2_EX_2_CPPM_NC1INDIR_SCOM                                 = 0x240F0133ull;
//DUPS: 250F0133,
static const uint64_t P9N2_EX_2_CPPM_NC1INDIR_SCOM1                                = 0x240F0134ull;
//DUPS: 250F0134,
static const uint64_t P9N2_EX_2_CPPM_NC1INDIR_SCOM2                                = 0x240F0135ull;
//DUPS: 250F0135,
static const uint64_t P9N2_EX_3_CPPM_NC1INDIR_SCOM                                 = 0x260F0133ull;
//DUPS: 270F0133,
static const uint64_t P9N2_EX_3_CPPM_NC1INDIR_SCOM1                                = 0x260F0134ull;
//DUPS: 270F0134,
static const uint64_t P9N2_EX_3_CPPM_NC1INDIR_SCOM2                                = 0x260F0135ull;
//DUPS: 270F0135,
static const uint64_t P9N2_EX_4_CPPM_NC1INDIR_SCOM                                 = 0x280F0133ull;
//DUPS: 290F0133,
static const uint64_t P9N2_EX_4_CPPM_NC1INDIR_SCOM1                                = 0x280F0134ull;
//DUPS: 290F0134,
static const uint64_t P9N2_EX_4_CPPM_NC1INDIR_SCOM2                                = 0x280F0135ull;
//DUPS: 290F0135,
static const uint64_t P9N2_EX_5_CPPM_NC1INDIR_SCOM                                 = 0x2A0F0133ull;
//DUPS: 2B0F0133,
static const uint64_t P9N2_EX_5_CPPM_NC1INDIR_SCOM1                                = 0x2A0F0134ull;
//DUPS: 2B0F0134,
static const uint64_t P9N2_EX_5_CPPM_NC1INDIR_SCOM2                                = 0x2A0F0135ull;
//DUPS: 2B0F0135,
static const uint64_t P9N2_EX_6_CPPM_NC1INDIR_SCOM                                 = 0x2C0F0133ull;
//DUPS: 2D0F0133,
static const uint64_t P9N2_EX_6_CPPM_NC1INDIR_SCOM1                                = 0x2C0F0134ull;
//DUPS: 2D0F0134,
static const uint64_t P9N2_EX_6_CPPM_NC1INDIR_SCOM2                                = 0x2C0F0135ull;
//DUPS: 2D0F0135,
static const uint64_t P9N2_EX_7_CPPM_NC1INDIR_SCOM                                 = 0x2E0F0133ull;
//DUPS: 2F0F0133,
static const uint64_t P9N2_EX_7_CPPM_NC1INDIR_SCOM1                                = 0x2E0F0134ull;
//DUPS: 2F0F0134,
static const uint64_t P9N2_EX_7_CPPM_NC1INDIR_SCOM2                                = 0x2E0F0135ull;
//DUPS: 2F0F0135,
static const uint64_t P9N2_EX_8_CPPM_NC1INDIR_SCOM                                 = 0x300F0133ull;
//DUPS: 310F0133,
static const uint64_t P9N2_EX_8_CPPM_NC1INDIR_SCOM1                                = 0x300F0134ull;
//DUPS: 310F0134,
static const uint64_t P9N2_EX_8_CPPM_NC1INDIR_SCOM2                                = 0x300F0135ull;
//DUPS: 310F0135,
static const uint64_t P9N2_EX_9_CPPM_NC1INDIR_SCOM                                 = 0x320F0133ull;
//DUPS: 330F0133,
static const uint64_t P9N2_EX_9_CPPM_NC1INDIR_SCOM1                                = 0x320F0134ull;
//DUPS: 330F0134,
static const uint64_t P9N2_EX_9_CPPM_NC1INDIR_SCOM2                                = 0x320F0135ull;
//DUPS: 330F0135,
static const uint64_t P9N2_EX_10_CPPM_NC1INDIR_SCOM                                = 0x340F0133ull;
//DUPS: 350F0133,
static const uint64_t P9N2_EX_10_CPPM_NC1INDIR_SCOM1                               = 0x340F0134ull;
//DUPS: 350F0134,
static const uint64_t P9N2_EX_10_CPPM_NC1INDIR_SCOM2                               = 0x340F0135ull;
//DUPS: 350F0135,
static const uint64_t P9N2_EX_11_CPPM_NC1INDIR_SCOM                                = 0x360F0133ull;
//DUPS: 370F0133,
static const uint64_t P9N2_EX_11_CPPM_NC1INDIR_SCOM1                               = 0x360F0134ull;
//DUPS: 370F0134,
static const uint64_t P9N2_EX_11_CPPM_NC1INDIR_SCOM2                               = 0x360F0135ull;
//DUPS: 370F0135,

static const uint64_t P9N2_C_CPPM_PECES                                            = 0x200F01AFull;

static const uint64_t P9N2_C_0_CPPM_PECES                                          = 0x200F01AFull;

static const uint64_t P9N2_C_1_CPPM_PECES                                          = 0x210F01AFull;

static const uint64_t P9N2_C_2_CPPM_PECES                                          = 0x220F01AFull;

static const uint64_t P9N2_C_3_CPPM_PECES                                          = 0x230F01AFull;

static const uint64_t P9N2_C_4_CPPM_PECES                                          = 0x240F01AFull;

static const uint64_t P9N2_C_5_CPPM_PECES                                          = 0x250F01AFull;

static const uint64_t P9N2_C_6_CPPM_PECES                                          = 0x260F01AFull;

static const uint64_t P9N2_C_7_CPPM_PECES                                          = 0x270F01AFull;

static const uint64_t P9N2_C_8_CPPM_PECES                                          = 0x280F01AFull;

static const uint64_t P9N2_C_9_CPPM_PECES                                          = 0x290F01AFull;

static const uint64_t P9N2_C_10_CPPM_PECES                                         = 0x2A0F01AFull;

static const uint64_t P9N2_C_11_CPPM_PECES                                         = 0x2B0F01AFull;

static const uint64_t P9N2_C_12_CPPM_PECES                                         = 0x2C0F01AFull;

static const uint64_t P9N2_C_13_CPPM_PECES                                         = 0x2D0F01AFull;

static const uint64_t P9N2_C_14_CPPM_PECES                                         = 0x2E0F01AFull;

static const uint64_t P9N2_C_15_CPPM_PECES                                         = 0x2F0F01AFull;

static const uint64_t P9N2_C_16_CPPM_PECES                                         = 0x300F01AFull;

static const uint64_t P9N2_C_17_CPPM_PECES                                         = 0x310F01AFull;

static const uint64_t P9N2_C_18_CPPM_PECES                                         = 0x320F01AFull;

static const uint64_t P9N2_C_19_CPPM_PECES                                         = 0x330F01AFull;

static const uint64_t P9N2_C_20_CPPM_PECES                                         = 0x340F01AFull;

static const uint64_t P9N2_C_21_CPPM_PECES                                         = 0x350F01AFull;

static const uint64_t P9N2_C_22_CPPM_PECES                                         = 0x360F01AFull;

static const uint64_t P9N2_C_23_CPPM_PECES                                         = 0x370F01AFull;

static const uint64_t P9N2_EX_CPPM_PECES                                           = 0x200F01AFull;
//DUPS: 210F01AF,
static const uint64_t P9N2_EX_0_CPPM_PECES                                         = 0x200F01AFull;
//DUPS: 210F01AF,
static const uint64_t P9N2_EX_1_CPPM_PECES                                         = 0x220F01AFull;
//DUPS: 220F01AF,
static const uint64_t P9N2_EX_2_CPPM_PECES                                         = 0x240F01AFull;
//DUPS: 250F01AF,
static const uint64_t P9N2_EX_3_CPPM_PECES                                         = 0x260F01AFull;
//DUPS: 270F01AF,
static const uint64_t P9N2_EX_4_CPPM_PECES                                         = 0x280F01AFull;
//DUPS: 290F01AF,
static const uint64_t P9N2_EX_5_CPPM_PECES                                         = 0x2A0F01AFull;
//DUPS: 2B0F01AF,
static const uint64_t P9N2_EX_6_CPPM_PECES                                         = 0x2C0F01AFull;
//DUPS: 2D0F01AF,
static const uint64_t P9N2_EX_7_CPPM_PECES                                         = 0x2E0F01AFull;
//DUPS: 2F0F01AF,
static const uint64_t P9N2_EX_8_CPPM_PECES                                         = 0x300F01AFull;
//DUPS: 310F01AF,
static const uint64_t P9N2_EX_9_CPPM_PECES                                         = 0x320F01AFull;
//DUPS: 330F01AF,
static const uint64_t P9N2_EX_10_CPPM_PECES                                        = 0x340F01AFull;
//DUPS: 350F01AF,
static const uint64_t P9N2_EX_11_CPPM_PECES                                        = 0x360F01AFull;
//DUPS: 370F01AF,

static const uint64_t P9N2_C_CPPM_PERRSUM                                          = 0x200F0120ull;

static const uint64_t P9N2_C_0_CPPM_PERRSUM                                        = 0x200F0120ull;

static const uint64_t P9N2_C_1_CPPM_PERRSUM                                        = 0x210F0120ull;

static const uint64_t P9N2_C_2_CPPM_PERRSUM                                        = 0x220F0120ull;

static const uint64_t P9N2_C_3_CPPM_PERRSUM                                        = 0x230F0120ull;

static const uint64_t P9N2_C_4_CPPM_PERRSUM                                        = 0x240F0120ull;

static const uint64_t P9N2_C_5_CPPM_PERRSUM                                        = 0x250F0120ull;

static const uint64_t P9N2_C_6_CPPM_PERRSUM                                        = 0x260F0120ull;

static const uint64_t P9N2_C_7_CPPM_PERRSUM                                        = 0x270F0120ull;

static const uint64_t P9N2_C_8_CPPM_PERRSUM                                        = 0x280F0120ull;

static const uint64_t P9N2_C_9_CPPM_PERRSUM                                        = 0x290F0120ull;

static const uint64_t P9N2_C_10_CPPM_PERRSUM                                       = 0x2A0F0120ull;

static const uint64_t P9N2_C_11_CPPM_PERRSUM                                       = 0x2B0F0120ull;

static const uint64_t P9N2_C_12_CPPM_PERRSUM                                       = 0x2C0F0120ull;

static const uint64_t P9N2_C_13_CPPM_PERRSUM                                       = 0x2D0F0120ull;

static const uint64_t P9N2_C_14_CPPM_PERRSUM                                       = 0x2E0F0120ull;

static const uint64_t P9N2_C_15_CPPM_PERRSUM                                       = 0x2F0F0120ull;

static const uint64_t P9N2_C_16_CPPM_PERRSUM                                       = 0x300F0120ull;

static const uint64_t P9N2_C_17_CPPM_PERRSUM                                       = 0x310F0120ull;

static const uint64_t P9N2_C_18_CPPM_PERRSUM                                       = 0x320F0120ull;

static const uint64_t P9N2_C_19_CPPM_PERRSUM                                       = 0x330F0120ull;

static const uint64_t P9N2_C_20_CPPM_PERRSUM                                       = 0x340F0120ull;

static const uint64_t P9N2_C_21_CPPM_PERRSUM                                       = 0x350F0120ull;

static const uint64_t P9N2_C_22_CPPM_PERRSUM                                       = 0x360F0120ull;

static const uint64_t P9N2_C_23_CPPM_PERRSUM                                       = 0x370F0120ull;

static const uint64_t P9N2_EX_CPPM_PERRSUM                                         = 0x200F0120ull;
//DUPS: 210F0120,
static const uint64_t P9N2_EX_0_CPPM_PERRSUM                                       = 0x200F0120ull;
//DUPS: 210F0120,
static const uint64_t P9N2_EX_1_CPPM_PERRSUM                                       = 0x220F0120ull;
//DUPS: 220F0120,
static const uint64_t P9N2_EX_2_CPPM_PERRSUM                                       = 0x240F0120ull;
//DUPS: 250F0120,
static const uint64_t P9N2_EX_3_CPPM_PERRSUM                                       = 0x260F0120ull;
//DUPS: 270F0120,
static const uint64_t P9N2_EX_4_CPPM_PERRSUM                                       = 0x280F0120ull;
//DUPS: 290F0120,
static const uint64_t P9N2_EX_5_CPPM_PERRSUM                                       = 0x2A0F0120ull;
//DUPS: 2B0F0120,
static const uint64_t P9N2_EX_6_CPPM_PERRSUM                                       = 0x2C0F0120ull;
//DUPS: 2D0F0120,
static const uint64_t P9N2_EX_7_CPPM_PERRSUM                                       = 0x2E0F0120ull;
//DUPS: 2F0F0120,
static const uint64_t P9N2_EX_8_CPPM_PERRSUM                                       = 0x300F0120ull;
//DUPS: 310F0120,
static const uint64_t P9N2_EX_9_CPPM_PERRSUM                                       = 0x320F0120ull;
//DUPS: 330F0120,
static const uint64_t P9N2_EX_10_CPPM_PERRSUM                                      = 0x340F0120ull;
//DUPS: 350F0120,
static const uint64_t P9N2_EX_11_CPPM_PERRSUM                                      = 0x360F0120ull;
//DUPS: 370F0120,

static const uint64_t P9N2_EQ_CSAR                                                 = 0x1001200Dull;
//DUPS: 1001200D,
static const uint64_t P9N2_EQ_0_CSAR                                               = 0x1001200Dull;
//DUPS: 1001200D,
static const uint64_t P9N2_EQ_1_CSAR                                               = 0x1101200Dull;
//DUPS: 1101200D,
static const uint64_t P9N2_EQ_2_CSAR                                               = 0x1201200Dull;
//DUPS: 1201200D,
static const uint64_t P9N2_EQ_3_CSAR                                               = 0x1301200Dull;
//DUPS: 1301200D,
static const uint64_t P9N2_EQ_4_CSAR                                               = 0x1401200Dull;
//DUPS: 1401200D,
static const uint64_t P9N2_EQ_5_CSAR                                               = 0x1501200Dull;
//DUPS: 1501200D,
static const uint64_t P9N2_EX_CSAR                                                 = 0x1001200Dull;

static const uint64_t P9N2_EX_0_CSAR                                               = 0x1001200Dull;

static const uint64_t P9N2_EX_1_CSAR                                               = 0x1001240Dull;

static const uint64_t P9N2_EX_2_CSAR                                               = 0x1101200Dull;

static const uint64_t P9N2_EX_3_CSAR                                               = 0x1101240Dull;

static const uint64_t P9N2_EX_4_CSAR                                               = 0x1201200Dull;

static const uint64_t P9N2_EX_5_CSAR                                               = 0x1201240Dull;

static const uint64_t P9N2_EX_6_CSAR                                               = 0x1301200Dull;

static const uint64_t P9N2_EX_7_CSAR                                               = 0x1301240Dull;

static const uint64_t P9N2_EX_8_CSAR                                               = 0x1401200Dull;

static const uint64_t P9N2_EX_9_CSAR                                               = 0x1401240Dull;

static const uint64_t P9N2_EX_10_CSAR                                              = 0x1501200Dull;

static const uint64_t P9N2_EX_11_CSAR                                              = 0x1501240Dull;


static const uint64_t P9N2_EQ_CSCR                                                 = 0x1001200Aull;
//DUPS: 1001200A,
static const uint64_t P9N2_EQ_CSCR_CLEAR                                           = 0x1001200Bull;
//DUPS: 1001200B,
static const uint64_t P9N2_EQ_CSCR_OR                                              = 0x1001200Cull;
//DUPS: 1001200C,
static const uint64_t P9N2_EQ_0_CSCR                                               = 0x1001200Aull;
//DUPS: 1001200A,
static const uint64_t P9N2_EQ_0_CSCR_CLEAR                                         = 0x1001200Bull;
//DUPS: 1001200B,
static const uint64_t P9N2_EQ_0_CSCR_OR                                            = 0x1001200Cull;
//DUPS: 1001200C,
static const uint64_t P9N2_EQ_1_CSCR                                               = 0x1101200Aull;
//DUPS: 1101200A,
static const uint64_t P9N2_EQ_1_CSCR_CLEAR                                         = 0x1101200Bull;
//DUPS: 1101200B,
static const uint64_t P9N2_EQ_1_CSCR_OR                                            = 0x1101200Cull;
//DUPS: 1101200C,
static const uint64_t P9N2_EQ_2_CSCR                                               = 0x1201200Aull;
//DUPS: 1201200A,
static const uint64_t P9N2_EQ_2_CSCR_CLEAR                                         = 0x1201200Bull;
//DUPS: 1201200B,
static const uint64_t P9N2_EQ_2_CSCR_OR                                            = 0x1201200Cull;
//DUPS: 1201200C,
static const uint64_t P9N2_EQ_3_CSCR                                               = 0x1301200Aull;
//DUPS: 1301200A,
static const uint64_t P9N2_EQ_3_CSCR_CLEAR                                         = 0x1301200Bull;
//DUPS: 1301200B,
static const uint64_t P9N2_EQ_3_CSCR_OR                                            = 0x1301200Cull;
//DUPS: 1301200C,
static const uint64_t P9N2_EQ_4_CSCR                                               = 0x1401200Aull;
//DUPS: 1401200A,
static const uint64_t P9N2_EQ_4_CSCR_CLEAR                                         = 0x1401200Bull;
//DUPS: 1401200B,
static const uint64_t P9N2_EQ_4_CSCR_OR                                            = 0x1401200Cull;
//DUPS: 1401200C,
static const uint64_t P9N2_EQ_5_CSCR                                               = 0x1501200Aull;
//DUPS: 1501200A,
static const uint64_t P9N2_EQ_5_CSCR_CLEAR                                         = 0x1501200Bull;
//DUPS: 1501200B,
static const uint64_t P9N2_EQ_5_CSCR_OR                                            = 0x1501200Cull;
//DUPS: 1501200C,
static const uint64_t P9N2_EX_CSCR                                                 = 0x1001200Aull;

static const uint64_t P9N2_EX_CSCR_CLEAR                                           = 0x1001200Bull;

static const uint64_t P9N2_EX_CSCR_OR                                              = 0x1001200Cull;

static const uint64_t P9N2_EX_0_CSCR                                               = 0x1001200Aull;

static const uint64_t P9N2_EX_0_CSCR_CLEAR                                         = 0x1001200Bull;

static const uint64_t P9N2_EX_0_CSCR_OR                                            = 0x1001200Cull;

static const uint64_t P9N2_EX_1_CSCR                                               = 0x1001240Aull;

static const uint64_t P9N2_EX_1_CSCR_CLEAR                                         = 0x1001240Bull;

static const uint64_t P9N2_EX_1_CSCR_OR                                            = 0x1001240Cull;

static const uint64_t P9N2_EX_2_CSCR                                               = 0x1101200Aull;

static const uint64_t P9N2_EX_2_CSCR_CLEAR                                         = 0x1101200Bull;

static const uint64_t P9N2_EX_2_CSCR_OR                                            = 0x1101200Cull;

static const uint64_t P9N2_EX_3_CSCR                                               = 0x1101240Aull;

static const uint64_t P9N2_EX_3_CSCR_CLEAR                                         = 0x1101240Bull;

static const uint64_t P9N2_EX_3_CSCR_OR                                            = 0x1101240Cull;

static const uint64_t P9N2_EX_4_CSCR                                               = 0x1201200Aull;

static const uint64_t P9N2_EX_4_CSCR_CLEAR                                         = 0x1201200Bull;

static const uint64_t P9N2_EX_4_CSCR_OR                                            = 0x1201200Cull;

static const uint64_t P9N2_EX_5_CSCR                                               = 0x1201240Aull;

static const uint64_t P9N2_EX_5_CSCR_CLEAR                                         = 0x1201240Bull;

static const uint64_t P9N2_EX_5_CSCR_OR                                            = 0x1201240Cull;

static const uint64_t P9N2_EX_6_CSCR                                               = 0x1301200Aull;

static const uint64_t P9N2_EX_6_CSCR_CLEAR                                         = 0x1301200Bull;

static const uint64_t P9N2_EX_6_CSCR_OR                                            = 0x1301200Cull;

static const uint64_t P9N2_EX_7_CSCR                                               = 0x1301240Aull;

static const uint64_t P9N2_EX_7_CSCR_CLEAR                                         = 0x1301240Bull;

static const uint64_t P9N2_EX_7_CSCR_OR                                            = 0x1301240Cull;

static const uint64_t P9N2_EX_8_CSCR                                               = 0x1401200Aull;

static const uint64_t P9N2_EX_8_CSCR_CLEAR                                         = 0x1401200Bull;

static const uint64_t P9N2_EX_8_CSCR_OR                                            = 0x1401200Cull;

static const uint64_t P9N2_EX_9_CSCR                                               = 0x1401240Aull;

static const uint64_t P9N2_EX_9_CSCR_CLEAR                                         = 0x1401240Bull;

static const uint64_t P9N2_EX_9_CSCR_OR                                            = 0x1401240Cull;

static const uint64_t P9N2_EX_10_CSCR                                              = 0x1501200Aull;

static const uint64_t P9N2_EX_10_CSCR_CLEAR                                        = 0x1501200Bull;

static const uint64_t P9N2_EX_10_CSCR_OR                                           = 0x1501200Cull;

static const uint64_t P9N2_EX_11_CSCR                                              = 0x1501240Aull;

static const uint64_t P9N2_EX_11_CSCR_CLEAR                                        = 0x1501240Bull;

static const uint64_t P9N2_EX_11_CSCR_OR                                           = 0x1501240Cull;


static const uint64_t P9N2_EQ_CSDR                                                 = 0x1001200Eull;
//DUPS: 1001200E,
static const uint64_t P9N2_EQ_0_CSDR                                               = 0x1001200Eull;
//DUPS: 1001200E,
static const uint64_t P9N2_EQ_1_CSDR                                               = 0x1101200Eull;
//DUPS: 1101200E,
static const uint64_t P9N2_EQ_2_CSDR                                               = 0x1201200Eull;
//DUPS: 1201200E,
static const uint64_t P9N2_EQ_3_CSDR                                               = 0x1301200Eull;
//DUPS: 1301200E,
static const uint64_t P9N2_EQ_4_CSDR                                               = 0x1401200Eull;
//DUPS: 1401200E,
static const uint64_t P9N2_EQ_5_CSDR                                               = 0x1501200Eull;
//DUPS: 1501200E,
static const uint64_t P9N2_EX_CSDR                                                 = 0x1001200Eull;

static const uint64_t P9N2_EX_0_CSDR                                               = 0x1001200Eull;

static const uint64_t P9N2_EX_1_CSDR                                               = 0x1001240Eull;

static const uint64_t P9N2_EX_2_CSDR                                               = 0x1101200Eull;

static const uint64_t P9N2_EX_3_CSDR                                               = 0x1101240Eull;

static const uint64_t P9N2_EX_4_CSDR                                               = 0x1201200Eull;

static const uint64_t P9N2_EX_5_CSDR                                               = 0x1201240Eull;

static const uint64_t P9N2_EX_6_CSDR                                               = 0x1301200Eull;

static const uint64_t P9N2_EX_7_CSDR                                               = 0x1301240Eull;

static const uint64_t P9N2_EX_8_CSDR                                               = 0x1401200Eull;

static const uint64_t P9N2_EX_9_CSDR                                               = 0x1401240Eull;

static const uint64_t P9N2_EX_10_CSDR                                              = 0x1501200Eull;

static const uint64_t P9N2_EX_11_CSDR                                              = 0x1501240Eull;


static const uint64_t P9N2_C_CTRL                                                  = 0x20010A85ull;

static const uint64_t P9N2_C_0_CTRL                                                = 0x20010A85ull;

static const uint64_t P9N2_C_1_CTRL                                                = 0x21010A85ull;

static const uint64_t P9N2_C_2_CTRL                                                = 0x22010A85ull;

static const uint64_t P9N2_C_3_CTRL                                                = 0x23010A85ull;

static const uint64_t P9N2_C_4_CTRL                                                = 0x24010A85ull;

static const uint64_t P9N2_C_5_CTRL                                                = 0x25010A85ull;

static const uint64_t P9N2_C_6_CTRL                                                = 0x26010A85ull;

static const uint64_t P9N2_C_7_CTRL                                                = 0x27010A85ull;

static const uint64_t P9N2_C_8_CTRL                                                = 0x28010A85ull;

static const uint64_t P9N2_C_9_CTRL                                                = 0x29010A85ull;

static const uint64_t P9N2_C_10_CTRL                                               = 0x2A010A85ull;

static const uint64_t P9N2_C_11_CTRL                                               = 0x2B010A85ull;

static const uint64_t P9N2_C_12_CTRL                                               = 0x2C010A85ull;

static const uint64_t P9N2_C_13_CTRL                                               = 0x2D010A85ull;

static const uint64_t P9N2_C_14_CTRL                                               = 0x2E010A85ull;

static const uint64_t P9N2_C_15_CTRL                                               = 0x2F010A85ull;

static const uint64_t P9N2_C_16_CTRL                                               = 0x30010A85ull;

static const uint64_t P9N2_C_17_CTRL                                               = 0x31010A85ull;

static const uint64_t P9N2_C_18_CTRL                                               = 0x32010A85ull;

static const uint64_t P9N2_C_19_CTRL                                               = 0x33010A85ull;

static const uint64_t P9N2_C_20_CTRL                                               = 0x34010A85ull;

static const uint64_t P9N2_C_21_CTRL                                               = 0x35010A85ull;

static const uint64_t P9N2_C_22_CTRL                                               = 0x36010A85ull;

static const uint64_t P9N2_C_23_CTRL                                               = 0x37010A85ull;

static const uint64_t P9N2_EX_0_L2_CTRL                                            = 0x20010A85ull;
//DUPS: 20010A85,
static const uint64_t P9N2_EX_10_L2_CTRL                                           = 0x34010A85ull;
//DUPS: 34010A85,
static const uint64_t P9N2_EX_11_L2_CTRL                                           = 0x36010A85ull;
//DUPS: 36010A85,
static const uint64_t P9N2_EX_1_L2_CTRL                                            = 0x22010A85ull;
//DUPS: 22010A85,
static const uint64_t P9N2_EX_2_L2_CTRL                                            = 0x24010A85ull;
//DUPS: 24010A85,
static const uint64_t P9N2_EX_3_L2_CTRL                                            = 0x26010A85ull;
//DUPS: 26010A85,
static const uint64_t P9N2_EX_4_L2_CTRL                                            = 0x28010A85ull;
//DUPS: 28010A85,
static const uint64_t P9N2_EX_5_L2_CTRL                                            = 0x2B010A85ull;
//DUPS: 2A010A85,
static const uint64_t P9N2_EX_6_L2_CTRL                                            = 0x2D010A85ull;
//DUPS: 2C010A85,
static const uint64_t P9N2_EX_7_L2_CTRL                                            = 0x2F010A85ull;
//DUPS: 2E010A85,
static const uint64_t P9N2_EX_8_L2_CTRL                                            = 0x30010A85ull;
//DUPS: 30010A85,
static const uint64_t P9N2_EX_9_L2_CTRL                                            = 0x32010A85ull;
//DUPS: 32010A85,
static const uint64_t P9N2_EX_L2_CTRL                                              = 0x20010A85ull;
//DUPS: 20010A85,

static const uint64_t P9N2_C_CTRL_ATOMIC_LOCK_REG                                  = 0x200003FFull;

static const uint64_t P9N2_C_0_CTRL_ATOMIC_LOCK_REG                                = 0x200003FFull;

static const uint64_t P9N2_C_1_CTRL_ATOMIC_LOCK_REG                                = 0x210003FFull;

static const uint64_t P9N2_C_2_CTRL_ATOMIC_LOCK_REG                                = 0x220003FFull;

static const uint64_t P9N2_C_3_CTRL_ATOMIC_LOCK_REG                                = 0x230003FFull;

static const uint64_t P9N2_C_4_CTRL_ATOMIC_LOCK_REG                                = 0x240003FFull;

static const uint64_t P9N2_C_5_CTRL_ATOMIC_LOCK_REG                                = 0x250003FFull;

static const uint64_t P9N2_C_6_CTRL_ATOMIC_LOCK_REG                                = 0x260003FFull;

static const uint64_t P9N2_C_7_CTRL_ATOMIC_LOCK_REG                                = 0x270003FFull;

static const uint64_t P9N2_C_8_CTRL_ATOMIC_LOCK_REG                                = 0x280003FFull;

static const uint64_t P9N2_C_9_CTRL_ATOMIC_LOCK_REG                                = 0x290003FFull;

static const uint64_t P9N2_C_10_CTRL_ATOMIC_LOCK_REG                               = 0x2A0003FFull;

static const uint64_t P9N2_C_11_CTRL_ATOMIC_LOCK_REG                               = 0x2B0003FFull;

static const uint64_t P9N2_C_12_CTRL_ATOMIC_LOCK_REG                               = 0x2C0003FFull;

static const uint64_t P9N2_C_13_CTRL_ATOMIC_LOCK_REG                               = 0x2D0003FFull;

static const uint64_t P9N2_C_14_CTRL_ATOMIC_LOCK_REG                               = 0x2E0003FFull;

static const uint64_t P9N2_C_15_CTRL_ATOMIC_LOCK_REG                               = 0x2F0003FFull;

static const uint64_t P9N2_C_16_CTRL_ATOMIC_LOCK_REG                               = 0x300003FFull;

static const uint64_t P9N2_C_17_CTRL_ATOMIC_LOCK_REG                               = 0x310003FFull;

static const uint64_t P9N2_C_18_CTRL_ATOMIC_LOCK_REG                               = 0x320003FFull;

static const uint64_t P9N2_C_19_CTRL_ATOMIC_LOCK_REG                               = 0x330003FFull;

static const uint64_t P9N2_C_20_CTRL_ATOMIC_LOCK_REG                               = 0x340003FFull;

static const uint64_t P9N2_C_21_CTRL_ATOMIC_LOCK_REG                               = 0x350003FFull;

static const uint64_t P9N2_C_22_CTRL_ATOMIC_LOCK_REG                               = 0x360003FFull;

static const uint64_t P9N2_C_23_CTRL_ATOMIC_LOCK_REG                               = 0x370003FFull;

static const uint64_t P9N2_EQ_CTRL_ATOMIC_LOCK_REG                                 = 0x100003FFull;

static const uint64_t P9N2_EQ_0_CTRL_ATOMIC_LOCK_REG                               = 0x100003FFull;

static const uint64_t P9N2_EQ_1_CTRL_ATOMIC_LOCK_REG                               = 0x110003FFull;

static const uint64_t P9N2_EQ_2_CTRL_ATOMIC_LOCK_REG                               = 0x120003FFull;

static const uint64_t P9N2_EQ_3_CTRL_ATOMIC_LOCK_REG                               = 0x130003FFull;

static const uint64_t P9N2_EQ_4_CTRL_ATOMIC_LOCK_REG                               = 0x140003FFull;

static const uint64_t P9N2_EQ_5_CTRL_ATOMIC_LOCK_REG                               = 0x150003FFull;

static const uint64_t P9N2_EX_CTRL_ATOMIC_LOCK_REG                                 = 0x200003FFull;
//DUPS: 210003FF,
static const uint64_t P9N2_EX_0_CTRL_ATOMIC_LOCK_REG                               = 0x200003FFull;
//DUPS: 210003FF,
static const uint64_t P9N2_EX_1_CTRL_ATOMIC_LOCK_REG                               = 0x220003FFull;
//DUPS: 230003FF,
static const uint64_t P9N2_EX_2_CTRL_ATOMIC_LOCK_REG                               = 0x240003FFull;
//DUPS: 250003FF,
static const uint64_t P9N2_EX_3_CTRL_ATOMIC_LOCK_REG                               = 0x260003FFull;
//DUPS: 270003FF,
static const uint64_t P9N2_EX_4_CTRL_ATOMIC_LOCK_REG                               = 0x280003FFull;
//DUPS: 290003FF,
static const uint64_t P9N2_EX_5_CTRL_ATOMIC_LOCK_REG                               = 0x2A0003FFull;
//DUPS: 2B0003FF,
static const uint64_t P9N2_EX_6_CTRL_ATOMIC_LOCK_REG                               = 0x2C0003FFull;
//DUPS: 2D0003FF,
static const uint64_t P9N2_EX_7_CTRL_ATOMIC_LOCK_REG                               = 0x2F0003FFull;
//DUPS: 2F0003FF,
static const uint64_t P9N2_EX_8_CTRL_ATOMIC_LOCK_REG                               = 0x300003FFull;
//DUPS: 310003FF,
static const uint64_t P9N2_EX_9_CTRL_ATOMIC_LOCK_REG                               = 0x320003FFull;
//DUPS: 330003FF,
static const uint64_t P9N2_EX_10_CTRL_ATOMIC_LOCK_REG                              = 0x340003FFull;
//DUPS: 350003FF,
static const uint64_t P9N2_EX_11_CTRL_ATOMIC_LOCK_REG                              = 0x360003FFull;
//DUPS: 370003FF,

static const uint64_t P9N2_C_CTRL_PROTECT_MODE_REG                                 = 0x200003FEull;

static const uint64_t P9N2_C_0_CTRL_PROTECT_MODE_REG                               = 0x200003FEull;

static const uint64_t P9N2_C_1_CTRL_PROTECT_MODE_REG                               = 0x210003FEull;

static const uint64_t P9N2_C_2_CTRL_PROTECT_MODE_REG                               = 0x220003FEull;

static const uint64_t P9N2_C_3_CTRL_PROTECT_MODE_REG                               = 0x230003FEull;

static const uint64_t P9N2_C_4_CTRL_PROTECT_MODE_REG                               = 0x240003FEull;

static const uint64_t P9N2_C_5_CTRL_PROTECT_MODE_REG                               = 0x250003FEull;

static const uint64_t P9N2_C_6_CTRL_PROTECT_MODE_REG                               = 0x260003FEull;

static const uint64_t P9N2_C_7_CTRL_PROTECT_MODE_REG                               = 0x270003FEull;

static const uint64_t P9N2_C_8_CTRL_PROTECT_MODE_REG                               = 0x280003FEull;

static const uint64_t P9N2_C_9_CTRL_PROTECT_MODE_REG                               = 0x290003FEull;

static const uint64_t P9N2_C_10_CTRL_PROTECT_MODE_REG                              = 0x2A0003FEull;

static const uint64_t P9N2_C_11_CTRL_PROTECT_MODE_REG                              = 0x2B0003FEull;

static const uint64_t P9N2_C_12_CTRL_PROTECT_MODE_REG                              = 0x2C0003FEull;

static const uint64_t P9N2_C_13_CTRL_PROTECT_MODE_REG                              = 0x2D0003FEull;

static const uint64_t P9N2_C_14_CTRL_PROTECT_MODE_REG                              = 0x2E0003FEull;

static const uint64_t P9N2_C_15_CTRL_PROTECT_MODE_REG                              = 0x2F0003FEull;

static const uint64_t P9N2_C_16_CTRL_PROTECT_MODE_REG                              = 0x300003FEull;

static const uint64_t P9N2_C_17_CTRL_PROTECT_MODE_REG                              = 0x310003FEull;

static const uint64_t P9N2_C_18_CTRL_PROTECT_MODE_REG                              = 0x320003FEull;

static const uint64_t P9N2_C_19_CTRL_PROTECT_MODE_REG                              = 0x330003FEull;

static const uint64_t P9N2_C_20_CTRL_PROTECT_MODE_REG                              = 0x340003FEull;

static const uint64_t P9N2_C_21_CTRL_PROTECT_MODE_REG                              = 0x350003FEull;

static const uint64_t P9N2_C_22_CTRL_PROTECT_MODE_REG                              = 0x360003FEull;

static const uint64_t P9N2_C_23_CTRL_PROTECT_MODE_REG                              = 0x370003FEull;

static const uint64_t P9N2_EQ_CTRL_PROTECT_MODE_REG                                = 0x100003FEull;

static const uint64_t P9N2_EQ_0_CTRL_PROTECT_MODE_REG                              = 0x100003FEull;

static const uint64_t P9N2_EQ_1_CTRL_PROTECT_MODE_REG                              = 0x110003FEull;

static const uint64_t P9N2_EQ_2_CTRL_PROTECT_MODE_REG                              = 0x120003FEull;

static const uint64_t P9N2_EQ_3_CTRL_PROTECT_MODE_REG                              = 0x130003FEull;

static const uint64_t P9N2_EQ_4_CTRL_PROTECT_MODE_REG                              = 0x140003FEull;

static const uint64_t P9N2_EQ_5_CTRL_PROTECT_MODE_REG                              = 0x150003FEull;

static const uint64_t P9N2_EX_CTRL_PROTECT_MODE_REG                                = 0x200003FEull;
//DUPS: 210003FE,
static const uint64_t P9N2_EX_0_CTRL_PROTECT_MODE_REG                              = 0x200003FEull;
//DUPS: 210003FE,
static const uint64_t P9N2_EX_1_CTRL_PROTECT_MODE_REG                              = 0x220003FEull;
//DUPS: 230003FE,
static const uint64_t P9N2_EX_2_CTRL_PROTECT_MODE_REG                              = 0x240003FEull;
//DUPS: 250003FE,
static const uint64_t P9N2_EX_3_CTRL_PROTECT_MODE_REG                              = 0x260003FEull;
//DUPS: 270003FE,
static const uint64_t P9N2_EX_4_CTRL_PROTECT_MODE_REG                              = 0x280003FEull;
//DUPS: 290003FE,
static const uint64_t P9N2_EX_5_CTRL_PROTECT_MODE_REG                              = 0x2A0003FEull;
//DUPS: 2B0003FE,
static const uint64_t P9N2_EX_6_CTRL_PROTECT_MODE_REG                              = 0x2C0003FEull;
//DUPS: 2D0003FE,
static const uint64_t P9N2_EX_7_CTRL_PROTECT_MODE_REG                              = 0x2F0003FEull;
//DUPS: 2F0003FE,
static const uint64_t P9N2_EX_8_CTRL_PROTECT_MODE_REG                              = 0x300003FEull;
//DUPS: 310003FE,
static const uint64_t P9N2_EX_9_CTRL_PROTECT_MODE_REG                              = 0x320003FEull;
//DUPS: 330003FE,
static const uint64_t P9N2_EX_10_CTRL_PROTECT_MODE_REG                             = 0x340003FEull;
//DUPS: 350003FE,
static const uint64_t P9N2_EX_11_CTRL_PROTECT_MODE_REG                             = 0x360003FEull;
//DUPS: 370003FE,

static const uint64_t P9N2_C_DBG_CBS_CC                                            = 0x20030013ull;

static const uint64_t P9N2_C_0_DBG_CBS_CC                                          = 0x20030013ull;

static const uint64_t P9N2_C_1_DBG_CBS_CC                                          = 0x21030013ull;

static const uint64_t P9N2_C_2_DBG_CBS_CC                                          = 0x22030013ull;

static const uint64_t P9N2_C_3_DBG_CBS_CC                                          = 0x23030013ull;

static const uint64_t P9N2_C_4_DBG_CBS_CC                                          = 0x24030013ull;

static const uint64_t P9N2_C_5_DBG_CBS_CC                                          = 0x25030013ull;

static const uint64_t P9N2_C_6_DBG_CBS_CC                                          = 0x26030013ull;

static const uint64_t P9N2_C_7_DBG_CBS_CC                                          = 0x27030013ull;

static const uint64_t P9N2_C_8_DBG_CBS_CC                                          = 0x28030013ull;

static const uint64_t P9N2_C_9_DBG_CBS_CC                                          = 0x29030013ull;

static const uint64_t P9N2_C_10_DBG_CBS_CC                                         = 0x2A030013ull;

static const uint64_t P9N2_C_11_DBG_CBS_CC                                         = 0x2B030013ull;

static const uint64_t P9N2_C_12_DBG_CBS_CC                                         = 0x2C030013ull;

static const uint64_t P9N2_C_13_DBG_CBS_CC                                         = 0x2D030013ull;

static const uint64_t P9N2_C_14_DBG_CBS_CC                                         = 0x2E030013ull;

static const uint64_t P9N2_C_15_DBG_CBS_CC                                         = 0x2F030013ull;

static const uint64_t P9N2_C_16_DBG_CBS_CC                                         = 0x30030013ull;

static const uint64_t P9N2_C_17_DBG_CBS_CC                                         = 0x31030013ull;

static const uint64_t P9N2_C_18_DBG_CBS_CC                                         = 0x32030013ull;

static const uint64_t P9N2_C_19_DBG_CBS_CC                                         = 0x33030013ull;

static const uint64_t P9N2_C_20_DBG_CBS_CC                                         = 0x34030013ull;

static const uint64_t P9N2_C_21_DBG_CBS_CC                                         = 0x35030013ull;

static const uint64_t P9N2_C_22_DBG_CBS_CC                                         = 0x36030013ull;

static const uint64_t P9N2_C_23_DBG_CBS_CC                                         = 0x37030013ull;

static const uint64_t P9N2_EQ_DBG_CBS_CC                                           = 0x10030013ull;

static const uint64_t P9N2_EQ_0_DBG_CBS_CC                                         = 0x10030013ull;

static const uint64_t P9N2_EQ_1_DBG_CBS_CC                                         = 0x11030013ull;

static const uint64_t P9N2_EQ_2_DBG_CBS_CC                                         = 0x12030013ull;

static const uint64_t P9N2_EQ_3_DBG_CBS_CC                                         = 0x13030013ull;

static const uint64_t P9N2_EQ_4_DBG_CBS_CC                                         = 0x14030013ull;

static const uint64_t P9N2_EQ_5_DBG_CBS_CC                                         = 0x15030013ull;

static const uint64_t P9N2_EX_DBG_CBS_CC                                           = 0x20030013ull;
//DUPS: 21030013,
static const uint64_t P9N2_EX_0_DBG_CBS_CC                                         = 0x20030013ull;
//DUPS: 21030013,
static const uint64_t P9N2_EX_1_DBG_CBS_CC                                         = 0x22030013ull;
//DUPS: 23030013,
static const uint64_t P9N2_EX_2_DBG_CBS_CC                                         = 0x24030013ull;
//DUPS: 25030013,
static const uint64_t P9N2_EX_3_DBG_CBS_CC                                         = 0x26030013ull;
//DUPS: 27030013,
static const uint64_t P9N2_EX_4_DBG_CBS_CC                                         = 0x28030013ull;
//DUPS: 29030013,
static const uint64_t P9N2_EX_5_DBG_CBS_CC                                         = 0x2A030013ull;
//DUPS: 2B030013,
static const uint64_t P9N2_EX_6_DBG_CBS_CC                                         = 0x2C030013ull;
//DUPS: 2D030013,
static const uint64_t P9N2_EX_7_DBG_CBS_CC                                         = 0x2F030013ull;
//DUPS: 2F030013,
static const uint64_t P9N2_EX_8_DBG_CBS_CC                                         = 0x30030013ull;
//DUPS: 31030013,
static const uint64_t P9N2_EX_9_DBG_CBS_CC                                         = 0x32030013ull;
//DUPS: 33030013,
static const uint64_t P9N2_EX_10_DBG_CBS_CC                                        = 0x34030013ull;
//DUPS: 35030013,
static const uint64_t P9N2_EX_11_DBG_CBS_CC                                        = 0x36030013ull;
//DUPS: 37030013,

static const uint64_t P9N2_C_DBG_INST1_COND_REG_1                                  = 0x200107C1ull;

static const uint64_t P9N2_C_0_DBG_INST1_COND_REG_1                                = 0x200107C1ull;

static const uint64_t P9N2_C_1_DBG_INST1_COND_REG_1                                = 0x210107C1ull;

static const uint64_t P9N2_C_2_DBG_INST1_COND_REG_1                                = 0x220107C1ull;

static const uint64_t P9N2_C_3_DBG_INST1_COND_REG_1                                = 0x230107C1ull;

static const uint64_t P9N2_C_4_DBG_INST1_COND_REG_1                                = 0x240107C1ull;

static const uint64_t P9N2_C_5_DBG_INST1_COND_REG_1                                = 0x250107C1ull;

static const uint64_t P9N2_C_6_DBG_INST1_COND_REG_1                                = 0x260107C1ull;

static const uint64_t P9N2_C_7_DBG_INST1_COND_REG_1                                = 0x270107C1ull;

static const uint64_t P9N2_C_8_DBG_INST1_COND_REG_1                                = 0x280107C1ull;

static const uint64_t P9N2_C_9_DBG_INST1_COND_REG_1                                = 0x290107C1ull;

static const uint64_t P9N2_C_10_DBG_INST1_COND_REG_1                               = 0x2A0107C1ull;

static const uint64_t P9N2_C_11_DBG_INST1_COND_REG_1                               = 0x2B0107C1ull;

static const uint64_t P9N2_C_12_DBG_INST1_COND_REG_1                               = 0x2C0107C1ull;

static const uint64_t P9N2_C_13_DBG_INST1_COND_REG_1                               = 0x2D0107C1ull;

static const uint64_t P9N2_C_14_DBG_INST1_COND_REG_1                               = 0x2E0107C1ull;

static const uint64_t P9N2_C_15_DBG_INST1_COND_REG_1                               = 0x2F0107C1ull;

static const uint64_t P9N2_C_16_DBG_INST1_COND_REG_1                               = 0x300107C1ull;

static const uint64_t P9N2_C_17_DBG_INST1_COND_REG_1                               = 0x310107C1ull;

static const uint64_t P9N2_C_18_DBG_INST1_COND_REG_1                               = 0x320107C1ull;

static const uint64_t P9N2_C_19_DBG_INST1_COND_REG_1                               = 0x330107C1ull;

static const uint64_t P9N2_C_20_DBG_INST1_COND_REG_1                               = 0x340107C1ull;

static const uint64_t P9N2_C_21_DBG_INST1_COND_REG_1                               = 0x350107C1ull;

static const uint64_t P9N2_C_22_DBG_INST1_COND_REG_1                               = 0x360107C1ull;

static const uint64_t P9N2_C_23_DBG_INST1_COND_REG_1                               = 0x370107C1ull;

static const uint64_t P9N2_EQ_DBG_INST1_COND_REG_1                                 = 0x100107C1ull;

static const uint64_t P9N2_EQ_0_DBG_INST1_COND_REG_1                               = 0x100107C1ull;

static const uint64_t P9N2_EQ_1_DBG_INST1_COND_REG_1                               = 0x110107C1ull;

static const uint64_t P9N2_EQ_2_DBG_INST1_COND_REG_1                               = 0x120107C1ull;

static const uint64_t P9N2_EQ_3_DBG_INST1_COND_REG_1                               = 0x130107C1ull;

static const uint64_t P9N2_EQ_4_DBG_INST1_COND_REG_1                               = 0x140107C1ull;

static const uint64_t P9N2_EQ_5_DBG_INST1_COND_REG_1                               = 0x150107C1ull;

static const uint64_t P9N2_EX_DBG_INST1_COND_REG_1                                 = 0x200107C1ull;
//DUPS: 210107C1,
static const uint64_t P9N2_EX_0_DBG_INST1_COND_REG_1                               = 0x200107C1ull;
//DUPS: 210107C1,
static const uint64_t P9N2_EX_1_DBG_INST1_COND_REG_1                               = 0x220107C1ull;
//DUPS: 230107C1,
static const uint64_t P9N2_EX_2_DBG_INST1_COND_REG_1                               = 0x240107C1ull;
//DUPS: 250107C1,
static const uint64_t P9N2_EX_3_DBG_INST1_COND_REG_1                               = 0x260107C1ull;
//DUPS: 270107C1,
static const uint64_t P9N2_EX_4_DBG_INST1_COND_REG_1                               = 0x280107C1ull;
//DUPS: 290107C1,
static const uint64_t P9N2_EX_5_DBG_INST1_COND_REG_1                               = 0x2A0107C1ull;
//DUPS: 2B0107C1,
static const uint64_t P9N2_EX_6_DBG_INST1_COND_REG_1                               = 0x2C0107C1ull;
//DUPS: 2D0107C1,
static const uint64_t P9N2_EX_7_DBG_INST1_COND_REG_1                               = 0x2F0107C1ull;
//DUPS: 2F0107C1,
static const uint64_t P9N2_EX_8_DBG_INST1_COND_REG_1                               = 0x300107C1ull;
//DUPS: 310107C1,
static const uint64_t P9N2_EX_9_DBG_INST1_COND_REG_1                               = 0x320107C1ull;
//DUPS: 330107C1,
static const uint64_t P9N2_EX_10_DBG_INST1_COND_REG_1                              = 0x340107C1ull;
//DUPS: 350107C1,
static const uint64_t P9N2_EX_11_DBG_INST1_COND_REG_1                              = 0x360107C1ull;
//DUPS: 370107C1,

static const uint64_t P9N2_C_DBG_INST1_COND_REG_2                                  = 0x200107C2ull;

static const uint64_t P9N2_C_0_DBG_INST1_COND_REG_2                                = 0x200107C2ull;

static const uint64_t P9N2_C_1_DBG_INST1_COND_REG_2                                = 0x210107C2ull;

static const uint64_t P9N2_C_2_DBG_INST1_COND_REG_2                                = 0x220107C2ull;

static const uint64_t P9N2_C_3_DBG_INST1_COND_REG_2                                = 0x230107C2ull;

static const uint64_t P9N2_C_4_DBG_INST1_COND_REG_2                                = 0x240107C2ull;

static const uint64_t P9N2_C_5_DBG_INST1_COND_REG_2                                = 0x250107C2ull;

static const uint64_t P9N2_C_6_DBG_INST1_COND_REG_2                                = 0x260107C2ull;

static const uint64_t P9N2_C_7_DBG_INST1_COND_REG_2                                = 0x270107C2ull;

static const uint64_t P9N2_C_8_DBG_INST1_COND_REG_2                                = 0x280107C2ull;

static const uint64_t P9N2_C_9_DBG_INST1_COND_REG_2                                = 0x290107C2ull;

static const uint64_t P9N2_C_10_DBG_INST1_COND_REG_2                               = 0x2A0107C2ull;

static const uint64_t P9N2_C_11_DBG_INST1_COND_REG_2                               = 0x2B0107C2ull;

static const uint64_t P9N2_C_12_DBG_INST1_COND_REG_2                               = 0x2C0107C2ull;

static const uint64_t P9N2_C_13_DBG_INST1_COND_REG_2                               = 0x2D0107C2ull;

static const uint64_t P9N2_C_14_DBG_INST1_COND_REG_2                               = 0x2E0107C2ull;

static const uint64_t P9N2_C_15_DBG_INST1_COND_REG_2                               = 0x2F0107C2ull;

static const uint64_t P9N2_C_16_DBG_INST1_COND_REG_2                               = 0x300107C2ull;

static const uint64_t P9N2_C_17_DBG_INST1_COND_REG_2                               = 0x310107C2ull;

static const uint64_t P9N2_C_18_DBG_INST1_COND_REG_2                               = 0x320107C2ull;

static const uint64_t P9N2_C_19_DBG_INST1_COND_REG_2                               = 0x330107C2ull;

static const uint64_t P9N2_C_20_DBG_INST1_COND_REG_2                               = 0x340107C2ull;

static const uint64_t P9N2_C_21_DBG_INST1_COND_REG_2                               = 0x350107C2ull;

static const uint64_t P9N2_C_22_DBG_INST1_COND_REG_2                               = 0x360107C2ull;

static const uint64_t P9N2_C_23_DBG_INST1_COND_REG_2                               = 0x370107C2ull;

static const uint64_t P9N2_EQ_DBG_INST1_COND_REG_2                                 = 0x100107C2ull;

static const uint64_t P9N2_EQ_0_DBG_INST1_COND_REG_2                               = 0x100107C2ull;

static const uint64_t P9N2_EQ_1_DBG_INST1_COND_REG_2                               = 0x110107C2ull;

static const uint64_t P9N2_EQ_2_DBG_INST1_COND_REG_2                               = 0x120107C2ull;

static const uint64_t P9N2_EQ_3_DBG_INST1_COND_REG_2                               = 0x130107C2ull;

static const uint64_t P9N2_EQ_4_DBG_INST1_COND_REG_2                               = 0x140107C2ull;

static const uint64_t P9N2_EQ_5_DBG_INST1_COND_REG_2                               = 0x150107C2ull;

static const uint64_t P9N2_EX_DBG_INST1_COND_REG_2                                 = 0x200107C2ull;
//DUPS: 210107C2,
static const uint64_t P9N2_EX_0_DBG_INST1_COND_REG_2                               = 0x200107C2ull;
//DUPS: 210107C2,
static const uint64_t P9N2_EX_1_DBG_INST1_COND_REG_2                               = 0x220107C2ull;
//DUPS: 230107C2,
static const uint64_t P9N2_EX_2_DBG_INST1_COND_REG_2                               = 0x240107C2ull;
//DUPS: 250107C2,
static const uint64_t P9N2_EX_3_DBG_INST1_COND_REG_2                               = 0x260107C2ull;
//DUPS: 270107C2,
static const uint64_t P9N2_EX_4_DBG_INST1_COND_REG_2                               = 0x280107C2ull;
//DUPS: 290107C2,
static const uint64_t P9N2_EX_5_DBG_INST1_COND_REG_2                               = 0x2A0107C2ull;
//DUPS: 2B0107C2,
static const uint64_t P9N2_EX_6_DBG_INST1_COND_REG_2                               = 0x2C0107C2ull;
//DUPS: 2D0107C2,
static const uint64_t P9N2_EX_7_DBG_INST1_COND_REG_2                               = 0x2F0107C2ull;
//DUPS: 2F0107C2,
static const uint64_t P9N2_EX_8_DBG_INST1_COND_REG_2                               = 0x300107C2ull;
//DUPS: 310107C2,
static const uint64_t P9N2_EX_9_DBG_INST1_COND_REG_2                               = 0x320107C2ull;
//DUPS: 330107C2,
static const uint64_t P9N2_EX_10_DBG_INST1_COND_REG_2                              = 0x340107C2ull;
//DUPS: 350107C2,
static const uint64_t P9N2_EX_11_DBG_INST1_COND_REG_2                              = 0x360107C2ull;
//DUPS: 370107C2,

static const uint64_t P9N2_C_DBG_INST1_COND_REG_3                                  = 0x200107C3ull;

static const uint64_t P9N2_C_0_DBG_INST1_COND_REG_3                                = 0x200107C3ull;

static const uint64_t P9N2_C_1_DBG_INST1_COND_REG_3                                = 0x210107C3ull;

static const uint64_t P9N2_C_2_DBG_INST1_COND_REG_3                                = 0x220107C3ull;

static const uint64_t P9N2_C_3_DBG_INST1_COND_REG_3                                = 0x230107C3ull;

static const uint64_t P9N2_C_4_DBG_INST1_COND_REG_3                                = 0x240107C3ull;

static const uint64_t P9N2_C_5_DBG_INST1_COND_REG_3                                = 0x250107C3ull;

static const uint64_t P9N2_C_6_DBG_INST1_COND_REG_3                                = 0x260107C3ull;

static const uint64_t P9N2_C_7_DBG_INST1_COND_REG_3                                = 0x270107C3ull;

static const uint64_t P9N2_C_8_DBG_INST1_COND_REG_3                                = 0x280107C3ull;

static const uint64_t P9N2_C_9_DBG_INST1_COND_REG_3                                = 0x290107C3ull;

static const uint64_t P9N2_C_10_DBG_INST1_COND_REG_3                               = 0x2A0107C3ull;

static const uint64_t P9N2_C_11_DBG_INST1_COND_REG_3                               = 0x2B0107C3ull;

static const uint64_t P9N2_C_12_DBG_INST1_COND_REG_3                               = 0x2C0107C3ull;

static const uint64_t P9N2_C_13_DBG_INST1_COND_REG_3                               = 0x2D0107C3ull;

static const uint64_t P9N2_C_14_DBG_INST1_COND_REG_3                               = 0x2E0107C3ull;

static const uint64_t P9N2_C_15_DBG_INST1_COND_REG_3                               = 0x2F0107C3ull;

static const uint64_t P9N2_C_16_DBG_INST1_COND_REG_3                               = 0x300107C3ull;

static const uint64_t P9N2_C_17_DBG_INST1_COND_REG_3                               = 0x310107C3ull;

static const uint64_t P9N2_C_18_DBG_INST1_COND_REG_3                               = 0x320107C3ull;

static const uint64_t P9N2_C_19_DBG_INST1_COND_REG_3                               = 0x330107C3ull;

static const uint64_t P9N2_C_20_DBG_INST1_COND_REG_3                               = 0x340107C3ull;

static const uint64_t P9N2_C_21_DBG_INST1_COND_REG_3                               = 0x350107C3ull;

static const uint64_t P9N2_C_22_DBG_INST1_COND_REG_3                               = 0x360107C3ull;

static const uint64_t P9N2_C_23_DBG_INST1_COND_REG_3                               = 0x370107C3ull;

static const uint64_t P9N2_EQ_DBG_INST1_COND_REG_3                                 = 0x100107C3ull;

static const uint64_t P9N2_EQ_0_DBG_INST1_COND_REG_3                               = 0x100107C3ull;

static const uint64_t P9N2_EQ_1_DBG_INST1_COND_REG_3                               = 0x110107C3ull;

static const uint64_t P9N2_EQ_2_DBG_INST1_COND_REG_3                               = 0x120107C3ull;

static const uint64_t P9N2_EQ_3_DBG_INST1_COND_REG_3                               = 0x130107C3ull;

static const uint64_t P9N2_EQ_4_DBG_INST1_COND_REG_3                               = 0x140107C3ull;

static const uint64_t P9N2_EQ_5_DBG_INST1_COND_REG_3                               = 0x150107C3ull;

static const uint64_t P9N2_EX_DBG_INST1_COND_REG_3                                 = 0x200107C3ull;
//DUPS: 210107C3,
static const uint64_t P9N2_EX_0_DBG_INST1_COND_REG_3                               = 0x200107C3ull;
//DUPS: 210107C3,
static const uint64_t P9N2_EX_1_DBG_INST1_COND_REG_3                               = 0x220107C3ull;
//DUPS: 230107C3,
static const uint64_t P9N2_EX_2_DBG_INST1_COND_REG_3                               = 0x240107C3ull;
//DUPS: 250107C3,
static const uint64_t P9N2_EX_3_DBG_INST1_COND_REG_3                               = 0x260107C3ull;
//DUPS: 270107C3,
static const uint64_t P9N2_EX_4_DBG_INST1_COND_REG_3                               = 0x280107C3ull;
//DUPS: 290107C3,
static const uint64_t P9N2_EX_5_DBG_INST1_COND_REG_3                               = 0x2A0107C3ull;
//DUPS: 2B0107C3,
static const uint64_t P9N2_EX_6_DBG_INST1_COND_REG_3                               = 0x2C0107C3ull;
//DUPS: 2D0107C3,
static const uint64_t P9N2_EX_7_DBG_INST1_COND_REG_3                               = 0x2F0107C3ull;
//DUPS: 2F0107C3,
static const uint64_t P9N2_EX_8_DBG_INST1_COND_REG_3                               = 0x300107C3ull;
//DUPS: 310107C3,
static const uint64_t P9N2_EX_9_DBG_INST1_COND_REG_3                               = 0x320107C3ull;
//DUPS: 330107C3,
static const uint64_t P9N2_EX_10_DBG_INST1_COND_REG_3                              = 0x340107C3ull;
//DUPS: 350107C3,
static const uint64_t P9N2_EX_11_DBG_INST1_COND_REG_3                              = 0x360107C3ull;
//DUPS: 370107C3,

static const uint64_t P9N2_C_DBG_INST2_COND_REG_1                                  = 0x200107C4ull;

static const uint64_t P9N2_C_0_DBG_INST2_COND_REG_1                                = 0x200107C4ull;

static const uint64_t P9N2_C_1_DBG_INST2_COND_REG_1                                = 0x210107C4ull;

static const uint64_t P9N2_C_2_DBG_INST2_COND_REG_1                                = 0x220107C4ull;

static const uint64_t P9N2_C_3_DBG_INST2_COND_REG_1                                = 0x230107C4ull;

static const uint64_t P9N2_C_4_DBG_INST2_COND_REG_1                                = 0x240107C4ull;

static const uint64_t P9N2_C_5_DBG_INST2_COND_REG_1                                = 0x250107C4ull;

static const uint64_t P9N2_C_6_DBG_INST2_COND_REG_1                                = 0x260107C4ull;

static const uint64_t P9N2_C_7_DBG_INST2_COND_REG_1                                = 0x270107C4ull;

static const uint64_t P9N2_C_8_DBG_INST2_COND_REG_1                                = 0x280107C4ull;

static const uint64_t P9N2_C_9_DBG_INST2_COND_REG_1                                = 0x290107C4ull;

static const uint64_t P9N2_C_10_DBG_INST2_COND_REG_1                               = 0x2A0107C4ull;

static const uint64_t P9N2_C_11_DBG_INST2_COND_REG_1                               = 0x2B0107C4ull;

static const uint64_t P9N2_C_12_DBG_INST2_COND_REG_1                               = 0x2C0107C4ull;

static const uint64_t P9N2_C_13_DBG_INST2_COND_REG_1                               = 0x2D0107C4ull;

static const uint64_t P9N2_C_14_DBG_INST2_COND_REG_1                               = 0x2E0107C4ull;

static const uint64_t P9N2_C_15_DBG_INST2_COND_REG_1                               = 0x2F0107C4ull;

static const uint64_t P9N2_C_16_DBG_INST2_COND_REG_1                               = 0x300107C4ull;

static const uint64_t P9N2_C_17_DBG_INST2_COND_REG_1                               = 0x310107C4ull;

static const uint64_t P9N2_C_18_DBG_INST2_COND_REG_1                               = 0x320107C4ull;

static const uint64_t P9N2_C_19_DBG_INST2_COND_REG_1                               = 0x330107C4ull;

static const uint64_t P9N2_C_20_DBG_INST2_COND_REG_1                               = 0x340107C4ull;

static const uint64_t P9N2_C_21_DBG_INST2_COND_REG_1                               = 0x350107C4ull;

static const uint64_t P9N2_C_22_DBG_INST2_COND_REG_1                               = 0x360107C4ull;

static const uint64_t P9N2_C_23_DBG_INST2_COND_REG_1                               = 0x370107C4ull;

static const uint64_t P9N2_EQ_DBG_INST2_COND_REG_1                                 = 0x100107C4ull;

static const uint64_t P9N2_EQ_0_DBG_INST2_COND_REG_1                               = 0x100107C4ull;

static const uint64_t P9N2_EQ_1_DBG_INST2_COND_REG_1                               = 0x110107C4ull;

static const uint64_t P9N2_EQ_2_DBG_INST2_COND_REG_1                               = 0x120107C4ull;

static const uint64_t P9N2_EQ_3_DBG_INST2_COND_REG_1                               = 0x130107C4ull;

static const uint64_t P9N2_EQ_4_DBG_INST2_COND_REG_1                               = 0x140107C4ull;

static const uint64_t P9N2_EQ_5_DBG_INST2_COND_REG_1                               = 0x150107C4ull;

static const uint64_t P9N2_EX_DBG_INST2_COND_REG_1                                 = 0x200107C4ull;
//DUPS: 210107C4,
static const uint64_t P9N2_EX_0_DBG_INST2_COND_REG_1                               = 0x200107C4ull;
//DUPS: 210107C4,
static const uint64_t P9N2_EX_1_DBG_INST2_COND_REG_1                               = 0x220107C4ull;
//DUPS: 230107C4,
static const uint64_t P9N2_EX_2_DBG_INST2_COND_REG_1                               = 0x240107C4ull;
//DUPS: 250107C4,
static const uint64_t P9N2_EX_3_DBG_INST2_COND_REG_1                               = 0x260107C4ull;
//DUPS: 270107C4,
static const uint64_t P9N2_EX_4_DBG_INST2_COND_REG_1                               = 0x280107C4ull;
//DUPS: 290107C4,
static const uint64_t P9N2_EX_5_DBG_INST2_COND_REG_1                               = 0x2A0107C4ull;
//DUPS: 2B0107C4,
static const uint64_t P9N2_EX_6_DBG_INST2_COND_REG_1                               = 0x2C0107C4ull;
//DUPS: 2D0107C4,
static const uint64_t P9N2_EX_7_DBG_INST2_COND_REG_1                               = 0x2F0107C4ull;
//DUPS: 2F0107C4,
static const uint64_t P9N2_EX_8_DBG_INST2_COND_REG_1                               = 0x300107C4ull;
//DUPS: 310107C4,
static const uint64_t P9N2_EX_9_DBG_INST2_COND_REG_1                               = 0x320107C4ull;
//DUPS: 330107C4,
static const uint64_t P9N2_EX_10_DBG_INST2_COND_REG_1                              = 0x340107C4ull;
//DUPS: 350107C4,
static const uint64_t P9N2_EX_11_DBG_INST2_COND_REG_1                              = 0x360107C4ull;
//DUPS: 370107C4,

static const uint64_t P9N2_C_DBG_INST2_COND_REG_2                                  = 0x200107C5ull;

static const uint64_t P9N2_C_0_DBG_INST2_COND_REG_2                                = 0x200107C5ull;

static const uint64_t P9N2_C_1_DBG_INST2_COND_REG_2                                = 0x210107C5ull;

static const uint64_t P9N2_C_2_DBG_INST2_COND_REG_2                                = 0x220107C5ull;

static const uint64_t P9N2_C_3_DBG_INST2_COND_REG_2                                = 0x230107C5ull;

static const uint64_t P9N2_C_4_DBG_INST2_COND_REG_2                                = 0x240107C5ull;

static const uint64_t P9N2_C_5_DBG_INST2_COND_REG_2                                = 0x250107C5ull;

static const uint64_t P9N2_C_6_DBG_INST2_COND_REG_2                                = 0x260107C5ull;

static const uint64_t P9N2_C_7_DBG_INST2_COND_REG_2                                = 0x270107C5ull;

static const uint64_t P9N2_C_8_DBG_INST2_COND_REG_2                                = 0x280107C5ull;

static const uint64_t P9N2_C_9_DBG_INST2_COND_REG_2                                = 0x290107C5ull;

static const uint64_t P9N2_C_10_DBG_INST2_COND_REG_2                               = 0x2A0107C5ull;

static const uint64_t P9N2_C_11_DBG_INST2_COND_REG_2                               = 0x2B0107C5ull;

static const uint64_t P9N2_C_12_DBG_INST2_COND_REG_2                               = 0x2C0107C5ull;

static const uint64_t P9N2_C_13_DBG_INST2_COND_REG_2                               = 0x2D0107C5ull;

static const uint64_t P9N2_C_14_DBG_INST2_COND_REG_2                               = 0x2E0107C5ull;

static const uint64_t P9N2_C_15_DBG_INST2_COND_REG_2                               = 0x2F0107C5ull;

static const uint64_t P9N2_C_16_DBG_INST2_COND_REG_2                               = 0x300107C5ull;

static const uint64_t P9N2_C_17_DBG_INST2_COND_REG_2                               = 0x310107C5ull;

static const uint64_t P9N2_C_18_DBG_INST2_COND_REG_2                               = 0x320107C5ull;

static const uint64_t P9N2_C_19_DBG_INST2_COND_REG_2                               = 0x330107C5ull;

static const uint64_t P9N2_C_20_DBG_INST2_COND_REG_2                               = 0x340107C5ull;

static const uint64_t P9N2_C_21_DBG_INST2_COND_REG_2                               = 0x350107C5ull;

static const uint64_t P9N2_C_22_DBG_INST2_COND_REG_2                               = 0x360107C5ull;

static const uint64_t P9N2_C_23_DBG_INST2_COND_REG_2                               = 0x370107C5ull;

static const uint64_t P9N2_EQ_DBG_INST2_COND_REG_2                                 = 0x100107C5ull;

static const uint64_t P9N2_EQ_0_DBG_INST2_COND_REG_2                               = 0x100107C5ull;

static const uint64_t P9N2_EQ_1_DBG_INST2_COND_REG_2                               = 0x110107C5ull;

static const uint64_t P9N2_EQ_2_DBG_INST2_COND_REG_2                               = 0x120107C5ull;

static const uint64_t P9N2_EQ_3_DBG_INST2_COND_REG_2                               = 0x130107C5ull;

static const uint64_t P9N2_EQ_4_DBG_INST2_COND_REG_2                               = 0x140107C5ull;

static const uint64_t P9N2_EQ_5_DBG_INST2_COND_REG_2                               = 0x150107C5ull;

static const uint64_t P9N2_EX_DBG_INST2_COND_REG_2                                 = 0x200107C5ull;
//DUPS: 210107C5,
static const uint64_t P9N2_EX_0_DBG_INST2_COND_REG_2                               = 0x200107C5ull;
//DUPS: 210107C5,
static const uint64_t P9N2_EX_1_DBG_INST2_COND_REG_2                               = 0x220107C5ull;
//DUPS: 230107C5,
static const uint64_t P9N2_EX_2_DBG_INST2_COND_REG_2                               = 0x240107C5ull;
//DUPS: 250107C5,
static const uint64_t P9N2_EX_3_DBG_INST2_COND_REG_2                               = 0x260107C5ull;
//DUPS: 270107C5,
static const uint64_t P9N2_EX_4_DBG_INST2_COND_REG_2                               = 0x280107C5ull;
//DUPS: 290107C5,
static const uint64_t P9N2_EX_5_DBG_INST2_COND_REG_2                               = 0x2A0107C5ull;
//DUPS: 2B0107C5,
static const uint64_t P9N2_EX_6_DBG_INST2_COND_REG_2                               = 0x2C0107C5ull;
//DUPS: 2D0107C5,
static const uint64_t P9N2_EX_7_DBG_INST2_COND_REG_2                               = 0x2F0107C5ull;
//DUPS: 2F0107C5,
static const uint64_t P9N2_EX_8_DBG_INST2_COND_REG_2                               = 0x300107C5ull;
//DUPS: 310107C5,
static const uint64_t P9N2_EX_9_DBG_INST2_COND_REG_2                               = 0x320107C5ull;
//DUPS: 330107C5,
static const uint64_t P9N2_EX_10_DBG_INST2_COND_REG_2                              = 0x340107C5ull;
//DUPS: 350107C5,
static const uint64_t P9N2_EX_11_DBG_INST2_COND_REG_2                              = 0x360107C5ull;
//DUPS: 370107C5,

static const uint64_t P9N2_C_DBG_INST2_COND_REG_3                                  = 0x200107C6ull;

static const uint64_t P9N2_C_0_DBG_INST2_COND_REG_3                                = 0x200107C6ull;

static const uint64_t P9N2_C_1_DBG_INST2_COND_REG_3                                = 0x210107C6ull;

static const uint64_t P9N2_C_2_DBG_INST2_COND_REG_3                                = 0x220107C6ull;

static const uint64_t P9N2_C_3_DBG_INST2_COND_REG_3                                = 0x230107C6ull;

static const uint64_t P9N2_C_4_DBG_INST2_COND_REG_3                                = 0x240107C6ull;

static const uint64_t P9N2_C_5_DBG_INST2_COND_REG_3                                = 0x250107C6ull;

static const uint64_t P9N2_C_6_DBG_INST2_COND_REG_3                                = 0x260107C6ull;

static const uint64_t P9N2_C_7_DBG_INST2_COND_REG_3                                = 0x270107C6ull;

static const uint64_t P9N2_C_8_DBG_INST2_COND_REG_3                                = 0x280107C6ull;

static const uint64_t P9N2_C_9_DBG_INST2_COND_REG_3                                = 0x290107C6ull;

static const uint64_t P9N2_C_10_DBG_INST2_COND_REG_3                               = 0x2A0107C6ull;

static const uint64_t P9N2_C_11_DBG_INST2_COND_REG_3                               = 0x2B0107C6ull;

static const uint64_t P9N2_C_12_DBG_INST2_COND_REG_3                               = 0x2C0107C6ull;

static const uint64_t P9N2_C_13_DBG_INST2_COND_REG_3                               = 0x2D0107C6ull;

static const uint64_t P9N2_C_14_DBG_INST2_COND_REG_3                               = 0x2E0107C6ull;

static const uint64_t P9N2_C_15_DBG_INST2_COND_REG_3                               = 0x2F0107C6ull;

static const uint64_t P9N2_C_16_DBG_INST2_COND_REG_3                               = 0x300107C6ull;

static const uint64_t P9N2_C_17_DBG_INST2_COND_REG_3                               = 0x310107C6ull;

static const uint64_t P9N2_C_18_DBG_INST2_COND_REG_3                               = 0x320107C6ull;

static const uint64_t P9N2_C_19_DBG_INST2_COND_REG_3                               = 0x330107C6ull;

static const uint64_t P9N2_C_20_DBG_INST2_COND_REG_3                               = 0x340107C6ull;

static const uint64_t P9N2_C_21_DBG_INST2_COND_REG_3                               = 0x350107C6ull;

static const uint64_t P9N2_C_22_DBG_INST2_COND_REG_3                               = 0x360107C6ull;

static const uint64_t P9N2_C_23_DBG_INST2_COND_REG_3                               = 0x370107C6ull;

static const uint64_t P9N2_EQ_DBG_INST2_COND_REG_3                                 = 0x100107C6ull;

static const uint64_t P9N2_EQ_0_DBG_INST2_COND_REG_3                               = 0x100107C6ull;

static const uint64_t P9N2_EQ_1_DBG_INST2_COND_REG_3                               = 0x110107C6ull;

static const uint64_t P9N2_EQ_2_DBG_INST2_COND_REG_3                               = 0x120107C6ull;

static const uint64_t P9N2_EQ_3_DBG_INST2_COND_REG_3                               = 0x130107C6ull;

static const uint64_t P9N2_EQ_4_DBG_INST2_COND_REG_3                               = 0x140107C6ull;

static const uint64_t P9N2_EQ_5_DBG_INST2_COND_REG_3                               = 0x150107C6ull;

static const uint64_t P9N2_EX_DBG_INST2_COND_REG_3                                 = 0x200107C6ull;
//DUPS: 210107C6,
static const uint64_t P9N2_EX_0_DBG_INST2_COND_REG_3                               = 0x200107C6ull;
//DUPS: 210107C6,
static const uint64_t P9N2_EX_1_DBG_INST2_COND_REG_3                               = 0x220107C6ull;
//DUPS: 230107C6,
static const uint64_t P9N2_EX_2_DBG_INST2_COND_REG_3                               = 0x240107C6ull;
//DUPS: 250107C6,
static const uint64_t P9N2_EX_3_DBG_INST2_COND_REG_3                               = 0x260107C6ull;
//DUPS: 270107C6,
static const uint64_t P9N2_EX_4_DBG_INST2_COND_REG_3                               = 0x280107C6ull;
//DUPS: 290107C6,
static const uint64_t P9N2_EX_5_DBG_INST2_COND_REG_3                               = 0x2A0107C6ull;
//DUPS: 2B0107C6,
static const uint64_t P9N2_EX_6_DBG_INST2_COND_REG_3                               = 0x2C0107C6ull;
//DUPS: 2D0107C6,
static const uint64_t P9N2_EX_7_DBG_INST2_COND_REG_3                               = 0x2F0107C6ull;
//DUPS: 2F0107C6,
static const uint64_t P9N2_EX_8_DBG_INST2_COND_REG_3                               = 0x300107C6ull;
//DUPS: 310107C6,
static const uint64_t P9N2_EX_9_DBG_INST2_COND_REG_3                               = 0x320107C6ull;
//DUPS: 330107C6,
static const uint64_t P9N2_EX_10_DBG_INST2_COND_REG_3                              = 0x340107C6ull;
//DUPS: 350107C6,
static const uint64_t P9N2_EX_11_DBG_INST2_COND_REG_3                              = 0x360107C6ull;
//DUPS: 370107C6,

static const uint64_t P9N2_C_DBG_MODE_REG                                          = 0x200107C0ull;

static const uint64_t P9N2_C_0_DBG_MODE_REG                                        = 0x200107C0ull;

static const uint64_t P9N2_C_1_DBG_MODE_REG                                        = 0x210107C0ull;

static const uint64_t P9N2_C_2_DBG_MODE_REG                                        = 0x220107C0ull;

static const uint64_t P9N2_C_3_DBG_MODE_REG                                        = 0x230107C0ull;

static const uint64_t P9N2_C_4_DBG_MODE_REG                                        = 0x240107C0ull;

static const uint64_t P9N2_C_5_DBG_MODE_REG                                        = 0x250107C0ull;

static const uint64_t P9N2_C_6_DBG_MODE_REG                                        = 0x260107C0ull;

static const uint64_t P9N2_C_7_DBG_MODE_REG                                        = 0x270107C0ull;

static const uint64_t P9N2_C_8_DBG_MODE_REG                                        = 0x280107C0ull;

static const uint64_t P9N2_C_9_DBG_MODE_REG                                        = 0x290107C0ull;

static const uint64_t P9N2_C_10_DBG_MODE_REG                                       = 0x2A0107C0ull;

static const uint64_t P9N2_C_11_DBG_MODE_REG                                       = 0x2B0107C0ull;

static const uint64_t P9N2_C_12_DBG_MODE_REG                                       = 0x2C0107C0ull;

static const uint64_t P9N2_C_13_DBG_MODE_REG                                       = 0x2D0107C0ull;

static const uint64_t P9N2_C_14_DBG_MODE_REG                                       = 0x2E0107C0ull;

static const uint64_t P9N2_C_15_DBG_MODE_REG                                       = 0x2F0107C0ull;

static const uint64_t P9N2_C_16_DBG_MODE_REG                                       = 0x300107C0ull;

static const uint64_t P9N2_C_17_DBG_MODE_REG                                       = 0x310107C0ull;

static const uint64_t P9N2_C_18_DBG_MODE_REG                                       = 0x320107C0ull;

static const uint64_t P9N2_C_19_DBG_MODE_REG                                       = 0x330107C0ull;

static const uint64_t P9N2_C_20_DBG_MODE_REG                                       = 0x340107C0ull;

static const uint64_t P9N2_C_21_DBG_MODE_REG                                       = 0x350107C0ull;

static const uint64_t P9N2_C_22_DBG_MODE_REG                                       = 0x360107C0ull;

static const uint64_t P9N2_C_23_DBG_MODE_REG                                       = 0x370107C0ull;

static const uint64_t P9N2_EQ_DBG_MODE_REG                                         = 0x100107C0ull;

static const uint64_t P9N2_EQ_0_DBG_MODE_REG                                       = 0x100107C0ull;

static const uint64_t P9N2_EQ_1_DBG_MODE_REG                                       = 0x110107C0ull;

static const uint64_t P9N2_EQ_2_DBG_MODE_REG                                       = 0x120107C0ull;

static const uint64_t P9N2_EQ_3_DBG_MODE_REG                                       = 0x130107C0ull;

static const uint64_t P9N2_EQ_4_DBG_MODE_REG                                       = 0x140107C0ull;

static const uint64_t P9N2_EQ_5_DBG_MODE_REG                                       = 0x150107C0ull;

static const uint64_t P9N2_EX_DBG_MODE_REG                                         = 0x200107C0ull;
//DUPS: 210107C0,
static const uint64_t P9N2_EX_0_DBG_MODE_REG                                       = 0x200107C0ull;
//DUPS: 210107C0,
static const uint64_t P9N2_EX_1_DBG_MODE_REG                                       = 0x220107C0ull;
//DUPS: 230107C0,
static const uint64_t P9N2_EX_2_DBG_MODE_REG                                       = 0x240107C0ull;
//DUPS: 250107C0,
static const uint64_t P9N2_EX_3_DBG_MODE_REG                                       = 0x260107C0ull;
//DUPS: 270107C0,
static const uint64_t P9N2_EX_4_DBG_MODE_REG                                       = 0x280107C0ull;
//DUPS: 290107C0,
static const uint64_t P9N2_EX_5_DBG_MODE_REG                                       = 0x2A0107C0ull;
//DUPS: 2B0107C0,
static const uint64_t P9N2_EX_6_DBG_MODE_REG                                       = 0x2C0107C0ull;
//DUPS: 2D0107C0,
static const uint64_t P9N2_EX_7_DBG_MODE_REG                                       = 0x2F0107C0ull;
//DUPS: 2F0107C0,
static const uint64_t P9N2_EX_8_DBG_MODE_REG                                       = 0x300107C0ull;
//DUPS: 310107C0,
static const uint64_t P9N2_EX_9_DBG_MODE_REG                                       = 0x320107C0ull;
//DUPS: 330107C0,
static const uint64_t P9N2_EX_10_DBG_MODE_REG                                      = 0x340107C0ull;
//DUPS: 350107C0,
static const uint64_t P9N2_EX_11_DBG_MODE_REG                                      = 0x360107C0ull;
//DUPS: 370107C0,

static const uint64_t P9N2_C_DBG_TRACE_MODE_REG_2                                  = 0x200107CFull;

static const uint64_t P9N2_C_0_DBG_TRACE_MODE_REG_2                                = 0x200107CFull;

static const uint64_t P9N2_C_1_DBG_TRACE_MODE_REG_2                                = 0x210107CFull;

static const uint64_t P9N2_C_2_DBG_TRACE_MODE_REG_2                                = 0x220107CFull;

static const uint64_t P9N2_C_3_DBG_TRACE_MODE_REG_2                                = 0x230107CFull;

static const uint64_t P9N2_C_4_DBG_TRACE_MODE_REG_2                                = 0x240107CFull;

static const uint64_t P9N2_C_5_DBG_TRACE_MODE_REG_2                                = 0x250107CFull;

static const uint64_t P9N2_C_6_DBG_TRACE_MODE_REG_2                                = 0x260107CFull;

static const uint64_t P9N2_C_7_DBG_TRACE_MODE_REG_2                                = 0x270107CFull;

static const uint64_t P9N2_C_8_DBG_TRACE_MODE_REG_2                                = 0x280107CFull;

static const uint64_t P9N2_C_9_DBG_TRACE_MODE_REG_2                                = 0x290107CFull;

static const uint64_t P9N2_C_10_DBG_TRACE_MODE_REG_2                               = 0x2A0107CFull;

static const uint64_t P9N2_C_11_DBG_TRACE_MODE_REG_2                               = 0x2B0107CFull;

static const uint64_t P9N2_C_12_DBG_TRACE_MODE_REG_2                               = 0x2C0107CFull;

static const uint64_t P9N2_C_13_DBG_TRACE_MODE_REG_2                               = 0x2D0107CFull;

static const uint64_t P9N2_C_14_DBG_TRACE_MODE_REG_2                               = 0x2E0107CFull;

static const uint64_t P9N2_C_15_DBG_TRACE_MODE_REG_2                               = 0x2F0107CFull;

static const uint64_t P9N2_C_16_DBG_TRACE_MODE_REG_2                               = 0x300107CFull;

static const uint64_t P9N2_C_17_DBG_TRACE_MODE_REG_2                               = 0x310107CFull;

static const uint64_t P9N2_C_18_DBG_TRACE_MODE_REG_2                               = 0x320107CFull;

static const uint64_t P9N2_C_19_DBG_TRACE_MODE_REG_2                               = 0x330107CFull;

static const uint64_t P9N2_C_20_DBG_TRACE_MODE_REG_2                               = 0x340107CFull;

static const uint64_t P9N2_C_21_DBG_TRACE_MODE_REG_2                               = 0x350107CFull;

static const uint64_t P9N2_C_22_DBG_TRACE_MODE_REG_2                               = 0x360107CFull;

static const uint64_t P9N2_C_23_DBG_TRACE_MODE_REG_2                               = 0x370107CFull;

static const uint64_t P9N2_EQ_DBG_TRACE_MODE_REG_2                                 = 0x100107CFull;

static const uint64_t P9N2_EQ_0_DBG_TRACE_MODE_REG_2                               = 0x100107CFull;

static const uint64_t P9N2_EQ_1_DBG_TRACE_MODE_REG_2                               = 0x110107CFull;

static const uint64_t P9N2_EQ_2_DBG_TRACE_MODE_REG_2                               = 0x120107CFull;

static const uint64_t P9N2_EQ_3_DBG_TRACE_MODE_REG_2                               = 0x130107CFull;

static const uint64_t P9N2_EQ_4_DBG_TRACE_MODE_REG_2                               = 0x140107CFull;

static const uint64_t P9N2_EQ_5_DBG_TRACE_MODE_REG_2                               = 0x150107CFull;

static const uint64_t P9N2_EX_DBG_TRACE_MODE_REG_2                                 = 0x200107CFull;
//DUPS: 210107CF,
static const uint64_t P9N2_EX_0_DBG_TRACE_MODE_REG_2                               = 0x200107CFull;
//DUPS: 210107CF,
static const uint64_t P9N2_EX_1_DBG_TRACE_MODE_REG_2                               = 0x220107CFull;
//DUPS: 230107CF,
static const uint64_t P9N2_EX_2_DBG_TRACE_MODE_REG_2                               = 0x240107CFull;
//DUPS: 250107CF,
static const uint64_t P9N2_EX_3_DBG_TRACE_MODE_REG_2                               = 0x260107CFull;
//DUPS: 270107CF,
static const uint64_t P9N2_EX_4_DBG_TRACE_MODE_REG_2                               = 0x280107CFull;
//DUPS: 290107CF,
static const uint64_t P9N2_EX_5_DBG_TRACE_MODE_REG_2                               = 0x2A0107CFull;
//DUPS: 2B0107CF,
static const uint64_t P9N2_EX_6_DBG_TRACE_MODE_REG_2                               = 0x2C0107CFull;
//DUPS: 2D0107CF,
static const uint64_t P9N2_EX_7_DBG_TRACE_MODE_REG_2                               = 0x2F0107CFull;
//DUPS: 2F0107CF,
static const uint64_t P9N2_EX_8_DBG_TRACE_MODE_REG_2                               = 0x300107CFull;
//DUPS: 310107CF,
static const uint64_t P9N2_EX_9_DBG_TRACE_MODE_REG_2                               = 0x320107CFull;
//DUPS: 330107CF,
static const uint64_t P9N2_EX_10_DBG_TRACE_MODE_REG_2                              = 0x340107CFull;
//DUPS: 350107CF,
static const uint64_t P9N2_EX_11_DBG_TRACE_MODE_REG_2                              = 0x360107CFull;
//DUPS: 370107CF,

static const uint64_t P9N2_C_DBG_TRACE_REG_0                                       = 0x200107CDull;

static const uint64_t P9N2_C_0_DBG_TRACE_REG_0                                     = 0x200107CDull;

static const uint64_t P9N2_C_1_DBG_TRACE_REG_0                                     = 0x210107CDull;

static const uint64_t P9N2_C_2_DBG_TRACE_REG_0                                     = 0x220107CDull;

static const uint64_t P9N2_C_3_DBG_TRACE_REG_0                                     = 0x230107CDull;

static const uint64_t P9N2_C_4_DBG_TRACE_REG_0                                     = 0x240107CDull;

static const uint64_t P9N2_C_5_DBG_TRACE_REG_0                                     = 0x250107CDull;

static const uint64_t P9N2_C_6_DBG_TRACE_REG_0                                     = 0x260107CDull;

static const uint64_t P9N2_C_7_DBG_TRACE_REG_0                                     = 0x270107CDull;

static const uint64_t P9N2_C_8_DBG_TRACE_REG_0                                     = 0x280107CDull;

static const uint64_t P9N2_C_9_DBG_TRACE_REG_0                                     = 0x290107CDull;

static const uint64_t P9N2_C_10_DBG_TRACE_REG_0                                    = 0x2A0107CDull;

static const uint64_t P9N2_C_11_DBG_TRACE_REG_0                                    = 0x2B0107CDull;

static const uint64_t P9N2_C_12_DBG_TRACE_REG_0                                    = 0x2C0107CDull;

static const uint64_t P9N2_C_13_DBG_TRACE_REG_0                                    = 0x2D0107CDull;

static const uint64_t P9N2_C_14_DBG_TRACE_REG_0                                    = 0x2E0107CDull;

static const uint64_t P9N2_C_15_DBG_TRACE_REG_0                                    = 0x2F0107CDull;

static const uint64_t P9N2_C_16_DBG_TRACE_REG_0                                    = 0x300107CDull;

static const uint64_t P9N2_C_17_DBG_TRACE_REG_0                                    = 0x310107CDull;

static const uint64_t P9N2_C_18_DBG_TRACE_REG_0                                    = 0x320107CDull;

static const uint64_t P9N2_C_19_DBG_TRACE_REG_0                                    = 0x330107CDull;

static const uint64_t P9N2_C_20_DBG_TRACE_REG_0                                    = 0x340107CDull;

static const uint64_t P9N2_C_21_DBG_TRACE_REG_0                                    = 0x350107CDull;

static const uint64_t P9N2_C_22_DBG_TRACE_REG_0                                    = 0x360107CDull;

static const uint64_t P9N2_C_23_DBG_TRACE_REG_0                                    = 0x370107CDull;

static const uint64_t P9N2_EQ_DBG_TRACE_REG_0                                      = 0x100107CDull;

static const uint64_t P9N2_EQ_0_DBG_TRACE_REG_0                                    = 0x100107CDull;

static const uint64_t P9N2_EQ_1_DBG_TRACE_REG_0                                    = 0x110107CDull;

static const uint64_t P9N2_EQ_2_DBG_TRACE_REG_0                                    = 0x120107CDull;

static const uint64_t P9N2_EQ_3_DBG_TRACE_REG_0                                    = 0x130107CDull;

static const uint64_t P9N2_EQ_4_DBG_TRACE_REG_0                                    = 0x140107CDull;

static const uint64_t P9N2_EQ_5_DBG_TRACE_REG_0                                    = 0x150107CDull;

static const uint64_t P9N2_EX_DBG_TRACE_REG_0                                      = 0x200107CDull;
//DUPS: 210107CD,
static const uint64_t P9N2_EX_0_DBG_TRACE_REG_0                                    = 0x200107CDull;
//DUPS: 210107CD,
static const uint64_t P9N2_EX_1_DBG_TRACE_REG_0                                    = 0x220107CDull;
//DUPS: 230107CD,
static const uint64_t P9N2_EX_2_DBG_TRACE_REG_0                                    = 0x240107CDull;
//DUPS: 250107CD,
static const uint64_t P9N2_EX_3_DBG_TRACE_REG_0                                    = 0x260107CDull;
//DUPS: 270107CD,
static const uint64_t P9N2_EX_4_DBG_TRACE_REG_0                                    = 0x280107CDull;
//DUPS: 290107CD,
static const uint64_t P9N2_EX_5_DBG_TRACE_REG_0                                    = 0x2A0107CDull;
//DUPS: 2B0107CD,
static const uint64_t P9N2_EX_6_DBG_TRACE_REG_0                                    = 0x2C0107CDull;
//DUPS: 2D0107CD,
static const uint64_t P9N2_EX_7_DBG_TRACE_REG_0                                    = 0x2F0107CDull;
//DUPS: 2F0107CD,
static const uint64_t P9N2_EX_8_DBG_TRACE_REG_0                                    = 0x300107CDull;
//DUPS: 310107CD,
static const uint64_t P9N2_EX_9_DBG_TRACE_REG_0                                    = 0x320107CDull;
//DUPS: 330107CD,
static const uint64_t P9N2_EX_10_DBG_TRACE_REG_0                                   = 0x340107CDull;
//DUPS: 350107CD,
static const uint64_t P9N2_EX_11_DBG_TRACE_REG_0                                   = 0x360107CDull;
//DUPS: 370107CD,

static const uint64_t P9N2_C_DBG_TRACE_REG_1                                       = 0x200107CEull;

static const uint64_t P9N2_C_0_DBG_TRACE_REG_1                                     = 0x200107CEull;

static const uint64_t P9N2_C_1_DBG_TRACE_REG_1                                     = 0x210107CEull;

static const uint64_t P9N2_C_2_DBG_TRACE_REG_1                                     = 0x220107CEull;

static const uint64_t P9N2_C_3_DBG_TRACE_REG_1                                     = 0x230107CEull;

static const uint64_t P9N2_C_4_DBG_TRACE_REG_1                                     = 0x240107CEull;

static const uint64_t P9N2_C_5_DBG_TRACE_REG_1                                     = 0x250107CEull;

static const uint64_t P9N2_C_6_DBG_TRACE_REG_1                                     = 0x260107CEull;

static const uint64_t P9N2_C_7_DBG_TRACE_REG_1                                     = 0x270107CEull;

static const uint64_t P9N2_C_8_DBG_TRACE_REG_1                                     = 0x280107CEull;

static const uint64_t P9N2_C_9_DBG_TRACE_REG_1                                     = 0x290107CEull;

static const uint64_t P9N2_C_10_DBG_TRACE_REG_1                                    = 0x2A0107CEull;

static const uint64_t P9N2_C_11_DBG_TRACE_REG_1                                    = 0x2B0107CEull;

static const uint64_t P9N2_C_12_DBG_TRACE_REG_1                                    = 0x2C0107CEull;

static const uint64_t P9N2_C_13_DBG_TRACE_REG_1                                    = 0x2D0107CEull;

static const uint64_t P9N2_C_14_DBG_TRACE_REG_1                                    = 0x2E0107CEull;

static const uint64_t P9N2_C_15_DBG_TRACE_REG_1                                    = 0x2F0107CEull;

static const uint64_t P9N2_C_16_DBG_TRACE_REG_1                                    = 0x300107CEull;

static const uint64_t P9N2_C_17_DBG_TRACE_REG_1                                    = 0x310107CEull;

static const uint64_t P9N2_C_18_DBG_TRACE_REG_1                                    = 0x320107CEull;

static const uint64_t P9N2_C_19_DBG_TRACE_REG_1                                    = 0x330107CEull;

static const uint64_t P9N2_C_20_DBG_TRACE_REG_1                                    = 0x340107CEull;

static const uint64_t P9N2_C_21_DBG_TRACE_REG_1                                    = 0x350107CEull;

static const uint64_t P9N2_C_22_DBG_TRACE_REG_1                                    = 0x360107CEull;

static const uint64_t P9N2_C_23_DBG_TRACE_REG_1                                    = 0x370107CEull;

static const uint64_t P9N2_EQ_DBG_TRACE_REG_1                                      = 0x100107CEull;

static const uint64_t P9N2_EQ_0_DBG_TRACE_REG_1                                    = 0x100107CEull;

static const uint64_t P9N2_EQ_1_DBG_TRACE_REG_1                                    = 0x110107CEull;

static const uint64_t P9N2_EQ_2_DBG_TRACE_REG_1                                    = 0x120107CEull;

static const uint64_t P9N2_EQ_3_DBG_TRACE_REG_1                                    = 0x130107CEull;

static const uint64_t P9N2_EQ_4_DBG_TRACE_REG_1                                    = 0x140107CEull;

static const uint64_t P9N2_EQ_5_DBG_TRACE_REG_1                                    = 0x150107CEull;

static const uint64_t P9N2_EX_DBG_TRACE_REG_1                                      = 0x200107CEull;
//DUPS: 210107CE,
static const uint64_t P9N2_EX_0_DBG_TRACE_REG_1                                    = 0x200107CEull;
//DUPS: 210107CE,
static const uint64_t P9N2_EX_1_DBG_TRACE_REG_1                                    = 0x220107CEull;
//DUPS: 230107CE,
static const uint64_t P9N2_EX_2_DBG_TRACE_REG_1                                    = 0x240107CEull;
//DUPS: 250107CE,
static const uint64_t P9N2_EX_3_DBG_TRACE_REG_1                                    = 0x260107CEull;
//DUPS: 270107CE,
static const uint64_t P9N2_EX_4_DBG_TRACE_REG_1                                    = 0x280107CEull;
//DUPS: 290107CE,
static const uint64_t P9N2_EX_5_DBG_TRACE_REG_1                                    = 0x2A0107CEull;
//DUPS: 2B0107CE,
static const uint64_t P9N2_EX_6_DBG_TRACE_REG_1                                    = 0x2C0107CEull;
//DUPS: 2D0107CE,
static const uint64_t P9N2_EX_7_DBG_TRACE_REG_1                                    = 0x2F0107CEull;
//DUPS: 2F0107CE,
static const uint64_t P9N2_EX_8_DBG_TRACE_REG_1                                    = 0x300107CEull;
//DUPS: 310107CE,
static const uint64_t P9N2_EX_9_DBG_TRACE_REG_1                                    = 0x320107CEull;
//DUPS: 330107CE,
static const uint64_t P9N2_EX_10_DBG_TRACE_REG_1                                   = 0x340107CEull;
//DUPS: 350107CE,
static const uint64_t P9N2_EX_11_DBG_TRACE_REG_1                                   = 0x360107CEull;
//DUPS: 370107CE,

static const uint64_t P9N2_C_DEBUG_TRACE_CONTROL                                   = 0x200107D0ull;

static const uint64_t P9N2_C_0_DEBUG_TRACE_CONTROL                                 = 0x200107D0ull;

static const uint64_t P9N2_C_1_DEBUG_TRACE_CONTROL                                 = 0x210107D0ull;

static const uint64_t P9N2_C_2_DEBUG_TRACE_CONTROL                                 = 0x220107D0ull;

static const uint64_t P9N2_C_3_DEBUG_TRACE_CONTROL                                 = 0x230107D0ull;

static const uint64_t P9N2_C_4_DEBUG_TRACE_CONTROL                                 = 0x240107D0ull;

static const uint64_t P9N2_C_5_DEBUG_TRACE_CONTROL                                 = 0x250107D0ull;

static const uint64_t P9N2_C_6_DEBUG_TRACE_CONTROL                                 = 0x260107D0ull;

static const uint64_t P9N2_C_7_DEBUG_TRACE_CONTROL                                 = 0x270107D0ull;

static const uint64_t P9N2_C_8_DEBUG_TRACE_CONTROL                                 = 0x280107D0ull;

static const uint64_t P9N2_C_9_DEBUG_TRACE_CONTROL                                 = 0x290107D0ull;

static const uint64_t P9N2_C_10_DEBUG_TRACE_CONTROL                                = 0x2A0107D0ull;

static const uint64_t P9N2_C_11_DEBUG_TRACE_CONTROL                                = 0x2B0107D0ull;

static const uint64_t P9N2_C_12_DEBUG_TRACE_CONTROL                                = 0x2C0107D0ull;

static const uint64_t P9N2_C_13_DEBUG_TRACE_CONTROL                                = 0x2D0107D0ull;

static const uint64_t P9N2_C_14_DEBUG_TRACE_CONTROL                                = 0x2E0107D0ull;

static const uint64_t P9N2_C_15_DEBUG_TRACE_CONTROL                                = 0x2F0107D0ull;

static const uint64_t P9N2_C_16_DEBUG_TRACE_CONTROL                                = 0x300107D0ull;

static const uint64_t P9N2_C_17_DEBUG_TRACE_CONTROL                                = 0x310107D0ull;

static const uint64_t P9N2_C_18_DEBUG_TRACE_CONTROL                                = 0x320107D0ull;

static const uint64_t P9N2_C_19_DEBUG_TRACE_CONTROL                                = 0x330107D0ull;

static const uint64_t P9N2_C_20_DEBUG_TRACE_CONTROL                                = 0x340107D0ull;

static const uint64_t P9N2_C_21_DEBUG_TRACE_CONTROL                                = 0x350107D0ull;

static const uint64_t P9N2_C_22_DEBUG_TRACE_CONTROL                                = 0x360107D0ull;

static const uint64_t P9N2_C_23_DEBUG_TRACE_CONTROL                                = 0x370107D0ull;

static const uint64_t P9N2_EQ_DEBUG_TRACE_CONTROL                                  = 0x100107D0ull;

static const uint64_t P9N2_EQ_0_DEBUG_TRACE_CONTROL                                = 0x100107D0ull;

static const uint64_t P9N2_EQ_1_DEBUG_TRACE_CONTROL                                = 0x110107D0ull;

static const uint64_t P9N2_EQ_2_DEBUG_TRACE_CONTROL                                = 0x120107D0ull;

static const uint64_t P9N2_EQ_3_DEBUG_TRACE_CONTROL                                = 0x130107D0ull;

static const uint64_t P9N2_EQ_4_DEBUG_TRACE_CONTROL                                = 0x140107D0ull;

static const uint64_t P9N2_EQ_5_DEBUG_TRACE_CONTROL                                = 0x150107D0ull;

static const uint64_t P9N2_EX_DEBUG_TRACE_CONTROL                                  = 0x200107D0ull;
//DUPS: 210107D0,
static const uint64_t P9N2_EX_0_DEBUG_TRACE_CONTROL                                = 0x200107D0ull;
//DUPS: 210107D0,
static const uint64_t P9N2_EX_1_DEBUG_TRACE_CONTROL                                = 0x220107D0ull;
//DUPS: 230107D0,
static const uint64_t P9N2_EX_2_DEBUG_TRACE_CONTROL                                = 0x240107D0ull;
//DUPS: 250107D0,
static const uint64_t P9N2_EX_3_DEBUG_TRACE_CONTROL                                = 0x260107D0ull;
//DUPS: 270107D0,
static const uint64_t P9N2_EX_4_DEBUG_TRACE_CONTROL                                = 0x280107D0ull;
//DUPS: 290107D0,
static const uint64_t P9N2_EX_5_DEBUG_TRACE_CONTROL                                = 0x2A0107D0ull;
//DUPS: 2B0107D0,
static const uint64_t P9N2_EX_6_DEBUG_TRACE_CONTROL                                = 0x2C0107D0ull;
//DUPS: 2D0107D0,
static const uint64_t P9N2_EX_7_DEBUG_TRACE_CONTROL                                = 0x2F0107D0ull;
//DUPS: 2F0107D0,
static const uint64_t P9N2_EX_8_DEBUG_TRACE_CONTROL                                = 0x300107D0ull;
//DUPS: 310107D0,
static const uint64_t P9N2_EX_9_DEBUG_TRACE_CONTROL                                = 0x320107D0ull;
//DUPS: 330107D0,
static const uint64_t P9N2_EX_10_DEBUG_TRACE_CONTROL                               = 0x340107D0ull;
//DUPS: 350107D0,
static const uint64_t P9N2_EX_11_DEBUG_TRACE_CONTROL                               = 0x360107D0ull;
//DUPS: 370107D0,

static const uint64_t P9N2_C_DIRECT_CONTROLS                                       = 0x20010A9Cull;

static const uint64_t P9N2_C_0_DIRECT_CONTROLS                                     = 0x20010A9Cull;

static const uint64_t P9N2_C_1_DIRECT_CONTROLS                                     = 0x21010A9Cull;

static const uint64_t P9N2_C_2_DIRECT_CONTROLS                                     = 0x22010A9Cull;

static const uint64_t P9N2_C_3_DIRECT_CONTROLS                                     = 0x23010A9Cull;

static const uint64_t P9N2_C_4_DIRECT_CONTROLS                                     = 0x24010A9Cull;

static const uint64_t P9N2_C_5_DIRECT_CONTROLS                                     = 0x25010A9Cull;

static const uint64_t P9N2_C_6_DIRECT_CONTROLS                                     = 0x26010A9Cull;

static const uint64_t P9N2_C_7_DIRECT_CONTROLS                                     = 0x27010A9Cull;

static const uint64_t P9N2_C_8_DIRECT_CONTROLS                                     = 0x28010A9Cull;

static const uint64_t P9N2_C_9_DIRECT_CONTROLS                                     = 0x29010A9Cull;

static const uint64_t P9N2_C_10_DIRECT_CONTROLS                                    = 0x2A010A9Cull;

static const uint64_t P9N2_C_11_DIRECT_CONTROLS                                    = 0x2B010A9Cull;

static const uint64_t P9N2_C_12_DIRECT_CONTROLS                                    = 0x2C010A9Cull;

static const uint64_t P9N2_C_13_DIRECT_CONTROLS                                    = 0x2D010A9Cull;

static const uint64_t P9N2_C_14_DIRECT_CONTROLS                                    = 0x2E010A9Cull;

static const uint64_t P9N2_C_15_DIRECT_CONTROLS                                    = 0x2F010A9Cull;

static const uint64_t P9N2_C_16_DIRECT_CONTROLS                                    = 0x30010A9Cull;

static const uint64_t P9N2_C_17_DIRECT_CONTROLS                                    = 0x31010A9Cull;

static const uint64_t P9N2_C_18_DIRECT_CONTROLS                                    = 0x32010A9Cull;

static const uint64_t P9N2_C_19_DIRECT_CONTROLS                                    = 0x33010A9Cull;

static const uint64_t P9N2_C_20_DIRECT_CONTROLS                                    = 0x34010A9Cull;

static const uint64_t P9N2_C_21_DIRECT_CONTROLS                                    = 0x35010A9Cull;

static const uint64_t P9N2_C_22_DIRECT_CONTROLS                                    = 0x36010A9Cull;

static const uint64_t P9N2_C_23_DIRECT_CONTROLS                                    = 0x37010A9Cull;

static const uint64_t P9N2_EX_0_L2_DIRECT_CONTROLS                                 = 0x20010A9Cull;
//DUPS: 20010A9C,
static const uint64_t P9N2_EX_10_L2_DIRECT_CONTROLS                                = 0x34010A9Cull;
//DUPS: 34010A9C,
static const uint64_t P9N2_EX_11_L2_DIRECT_CONTROLS                                = 0x36010A9Cull;
//DUPS: 36010A9C,
static const uint64_t P9N2_EX_1_L2_DIRECT_CONTROLS                                 = 0x22010A9Cull;
//DUPS: 22010A9C,
static const uint64_t P9N2_EX_2_L2_DIRECT_CONTROLS                                 = 0x24010A9Cull;
//DUPS: 24010A9C,
static const uint64_t P9N2_EX_3_L2_DIRECT_CONTROLS                                 = 0x26010A9Cull;
//DUPS: 26010A9C,
static const uint64_t P9N2_EX_4_L2_DIRECT_CONTROLS                                 = 0x28010A9Cull;
//DUPS: 28010A9C,
static const uint64_t P9N2_EX_5_L2_DIRECT_CONTROLS                                 = 0x2B010A9Cull;
//DUPS: 2A010A9C,
static const uint64_t P9N2_EX_6_L2_DIRECT_CONTROLS                                 = 0x2D010A9Cull;
//DUPS: 2C010A9C,
static const uint64_t P9N2_EX_7_L2_DIRECT_CONTROLS                                 = 0x2F010A9Cull;
//DUPS: 2E010A9C,
static const uint64_t P9N2_EX_8_L2_DIRECT_CONTROLS                                 = 0x30010A9Cull;
//DUPS: 30010A9C,
static const uint64_t P9N2_EX_9_L2_DIRECT_CONTROLS                                 = 0x32010A9Cull;
//DUPS: 32010A9C,
static const uint64_t P9N2_EX_L2_DIRECT_CONTROLS                                   = 0x20010A9Cull;
//DUPS: 20010A9C,

static const uint64_t P9N2_EQ_DRAM_REF_REG                                         = 0x10011C0Full;
//DUPS: 10011C0F,
static const uint64_t P9N2_EQ_0_DRAM_REF_REG                                       = 0x10011C0Full;
//DUPS: 10011C0F,
static const uint64_t P9N2_EQ_1_DRAM_REF_REG                                       = 0x11011C0Full;
//DUPS: 11011C0F,
static const uint64_t P9N2_EQ_2_DRAM_REF_REG                                       = 0x12011C0Full;
//DUPS: 12011C0F,
static const uint64_t P9N2_EQ_3_DRAM_REF_REG                                       = 0x13011C0Full;
//DUPS: 13011C0F,
static const uint64_t P9N2_EQ_4_DRAM_REF_REG                                       = 0x14011C0Full;
//DUPS: 14011C0F,
static const uint64_t P9N2_EQ_5_DRAM_REF_REG                                       = 0x15011C0Full;
//DUPS: 15011C0F,
static const uint64_t P9N2_EX_DRAM_REF_REG                                         = 0x1001180Full;

static const uint64_t P9N2_EX_0_DRAM_REF_REG                                       = 0x1001180Full;

static const uint64_t P9N2_EX_1_DRAM_REF_REG                                       = 0x10011C0Full;

static const uint64_t P9N2_EX_2_DRAM_REF_REG                                       = 0x1101180Full;

static const uint64_t P9N2_EX_3_DRAM_REF_REG                                       = 0x11011C0Full;

static const uint64_t P9N2_EX_4_DRAM_REF_REG                                       = 0x1201180Full;

static const uint64_t P9N2_EX_5_DRAM_REF_REG                                       = 0x12011C0Full;

static const uint64_t P9N2_EX_6_DRAM_REF_REG                                       = 0x1301180Full;

static const uint64_t P9N2_EX_7_DRAM_REF_REG                                       = 0x13011C0Full;

static const uint64_t P9N2_EX_8_DRAM_REF_REG                                       = 0x1401180Full;

static const uint64_t P9N2_EX_9_DRAM_REF_REG                                       = 0x14011C0Full;

static const uint64_t P9N2_EX_10_DRAM_REF_REG                                      = 0x1501180Full;

static const uint64_t P9N2_EX_11_DRAM_REF_REG                                      = 0x15011C0Full;


static const uint64_t P9N2_C_DTS_RESULT0                                           = 0x20050000ull;

static const uint64_t P9N2_C_0_DTS_RESULT0                                         = 0x20050000ull;

static const uint64_t P9N2_C_1_DTS_RESULT0                                         = 0x21050000ull;

static const uint64_t P9N2_C_2_DTS_RESULT0                                         = 0x22050000ull;

static const uint64_t P9N2_C_3_DTS_RESULT0                                         = 0x23050000ull;

static const uint64_t P9N2_C_4_DTS_RESULT0                                         = 0x24050000ull;

static const uint64_t P9N2_C_5_DTS_RESULT0                                         = 0x25050000ull;

static const uint64_t P9N2_C_6_DTS_RESULT0                                         = 0x26050000ull;

static const uint64_t P9N2_C_7_DTS_RESULT0                                         = 0x27050000ull;

static const uint64_t P9N2_C_8_DTS_RESULT0                                         = 0x28050000ull;

static const uint64_t P9N2_C_9_DTS_RESULT0                                         = 0x29050000ull;

static const uint64_t P9N2_C_10_DTS_RESULT0                                        = 0x2A050000ull;

static const uint64_t P9N2_C_11_DTS_RESULT0                                        = 0x2B050000ull;

static const uint64_t P9N2_C_12_DTS_RESULT0                                        = 0x2C050000ull;

static const uint64_t P9N2_C_13_DTS_RESULT0                                        = 0x2D050000ull;

static const uint64_t P9N2_C_14_DTS_RESULT0                                        = 0x2E050000ull;

static const uint64_t P9N2_C_15_DTS_RESULT0                                        = 0x2F050000ull;

static const uint64_t P9N2_C_16_DTS_RESULT0                                        = 0x30050000ull;

static const uint64_t P9N2_C_17_DTS_RESULT0                                        = 0x31050000ull;

static const uint64_t P9N2_C_18_DTS_RESULT0                                        = 0x32050000ull;

static const uint64_t P9N2_C_19_DTS_RESULT0                                        = 0x33050000ull;

static const uint64_t P9N2_C_20_DTS_RESULT0                                        = 0x34050000ull;

static const uint64_t P9N2_C_21_DTS_RESULT0                                        = 0x35050000ull;

static const uint64_t P9N2_C_22_DTS_RESULT0                                        = 0x36050000ull;

static const uint64_t P9N2_C_23_DTS_RESULT0                                        = 0x37050000ull;

static const uint64_t P9N2_EQ_DTS_RESULT0                                          = 0x10050000ull;

static const uint64_t P9N2_EQ_0_DTS_RESULT0                                        = 0x10050000ull;

static const uint64_t P9N2_EQ_1_DTS_RESULT0                                        = 0x11050000ull;

static const uint64_t P9N2_EQ_2_DTS_RESULT0                                        = 0x12050000ull;

static const uint64_t P9N2_EQ_3_DTS_RESULT0                                        = 0x13050000ull;

static const uint64_t P9N2_EQ_4_DTS_RESULT0                                        = 0x14050000ull;

static const uint64_t P9N2_EQ_5_DTS_RESULT0                                        = 0x15050000ull;

static const uint64_t P9N2_EX_DTS_RESULT0                                          = 0x20050000ull;
//DUPS: 21050000,
static const uint64_t P9N2_EX_0_DTS_RESULT0                                        = 0x20050000ull;
//DUPS: 21050000,
static const uint64_t P9N2_EX_1_DTS_RESULT0                                        = 0x22050000ull;
//DUPS: 23050000,
static const uint64_t P9N2_EX_2_DTS_RESULT0                                        = 0x24050000ull;
//DUPS: 25050000,
static const uint64_t P9N2_EX_3_DTS_RESULT0                                        = 0x26050000ull;
//DUPS: 27050000,
static const uint64_t P9N2_EX_4_DTS_RESULT0                                        = 0x28050000ull;
//DUPS: 29050000,
static const uint64_t P9N2_EX_5_DTS_RESULT0                                        = 0x2A050000ull;
//DUPS: 2B050000,
static const uint64_t P9N2_EX_6_DTS_RESULT0                                        = 0x2C050000ull;
//DUPS: 2D050000,
static const uint64_t P9N2_EX_7_DTS_RESULT0                                        = 0x2F050000ull;
//DUPS: 2F050000,
static const uint64_t P9N2_EX_8_DTS_RESULT0                                        = 0x30050000ull;
//DUPS: 31050000,
static const uint64_t P9N2_EX_9_DTS_RESULT0                                        = 0x32050000ull;
//DUPS: 33050000,
static const uint64_t P9N2_EX_10_DTS_RESULT0                                       = 0x34050000ull;
//DUPS: 35050000,
static const uint64_t P9N2_EX_11_DTS_RESULT0                                       = 0x36050000ull;
//DUPS: 37050000,

static const uint64_t P9N2_C_DTS_TRC_RESULT                                        = 0x20050003ull;

static const uint64_t P9N2_C_0_DTS_TRC_RESULT                                      = 0x20050003ull;

static const uint64_t P9N2_C_1_DTS_TRC_RESULT                                      = 0x21050003ull;

static const uint64_t P9N2_C_2_DTS_TRC_RESULT                                      = 0x22050003ull;

static const uint64_t P9N2_C_3_DTS_TRC_RESULT                                      = 0x23050003ull;

static const uint64_t P9N2_C_4_DTS_TRC_RESULT                                      = 0x24050003ull;

static const uint64_t P9N2_C_5_DTS_TRC_RESULT                                      = 0x25050003ull;

static const uint64_t P9N2_C_6_DTS_TRC_RESULT                                      = 0x26050003ull;

static const uint64_t P9N2_C_7_DTS_TRC_RESULT                                      = 0x27050003ull;

static const uint64_t P9N2_C_8_DTS_TRC_RESULT                                      = 0x28050003ull;

static const uint64_t P9N2_C_9_DTS_TRC_RESULT                                      = 0x29050003ull;

static const uint64_t P9N2_C_10_DTS_TRC_RESULT                                     = 0x2A050003ull;

static const uint64_t P9N2_C_11_DTS_TRC_RESULT                                     = 0x2B050003ull;

static const uint64_t P9N2_C_12_DTS_TRC_RESULT                                     = 0x2C050003ull;

static const uint64_t P9N2_C_13_DTS_TRC_RESULT                                     = 0x2D050003ull;

static const uint64_t P9N2_C_14_DTS_TRC_RESULT                                     = 0x2E050003ull;

static const uint64_t P9N2_C_15_DTS_TRC_RESULT                                     = 0x2F050003ull;

static const uint64_t P9N2_C_16_DTS_TRC_RESULT                                     = 0x30050003ull;

static const uint64_t P9N2_C_17_DTS_TRC_RESULT                                     = 0x31050003ull;

static const uint64_t P9N2_C_18_DTS_TRC_RESULT                                     = 0x32050003ull;

static const uint64_t P9N2_C_19_DTS_TRC_RESULT                                     = 0x33050003ull;

static const uint64_t P9N2_C_20_DTS_TRC_RESULT                                     = 0x34050003ull;

static const uint64_t P9N2_C_21_DTS_TRC_RESULT                                     = 0x35050003ull;

static const uint64_t P9N2_C_22_DTS_TRC_RESULT                                     = 0x36050003ull;

static const uint64_t P9N2_C_23_DTS_TRC_RESULT                                     = 0x37050003ull;

static const uint64_t P9N2_EQ_DTS_TRC_RESULT                                       = 0x10050003ull;

static const uint64_t P9N2_EQ_0_DTS_TRC_RESULT                                     = 0x10050003ull;

static const uint64_t P9N2_EQ_1_DTS_TRC_RESULT                                     = 0x11050003ull;

static const uint64_t P9N2_EQ_2_DTS_TRC_RESULT                                     = 0x12050003ull;

static const uint64_t P9N2_EQ_3_DTS_TRC_RESULT                                     = 0x13050003ull;

static const uint64_t P9N2_EQ_4_DTS_TRC_RESULT                                     = 0x14050003ull;

static const uint64_t P9N2_EQ_5_DTS_TRC_RESULT                                     = 0x15050003ull;

static const uint64_t P9N2_EX_DTS_TRC_RESULT                                       = 0x20050003ull;
//DUPS: 21050003,
static const uint64_t P9N2_EX_0_DTS_TRC_RESULT                                     = 0x20050003ull;
//DUPS: 21050003,
static const uint64_t P9N2_EX_1_DTS_TRC_RESULT                                     = 0x22050003ull;
//DUPS: 23050003,
static const uint64_t P9N2_EX_2_DTS_TRC_RESULT                                     = 0x24050003ull;
//DUPS: 25050003,
static const uint64_t P9N2_EX_3_DTS_TRC_RESULT                                     = 0x26050003ull;
//DUPS: 27050003,
static const uint64_t P9N2_EX_4_DTS_TRC_RESULT                                     = 0x28050003ull;
//DUPS: 29050003,
static const uint64_t P9N2_EX_5_DTS_TRC_RESULT                                     = 0x2A050003ull;
//DUPS: 2B050003,
static const uint64_t P9N2_EX_6_DTS_TRC_RESULT                                     = 0x2C050003ull;
//DUPS: 2D050003,
static const uint64_t P9N2_EX_7_DTS_TRC_RESULT                                     = 0x2F050003ull;
//DUPS: 2F050003,
static const uint64_t P9N2_EX_8_DTS_TRC_RESULT                                     = 0x30050003ull;
//DUPS: 31050003,
static const uint64_t P9N2_EX_9_DTS_TRC_RESULT                                     = 0x32050003ull;
//DUPS: 33050003,
static const uint64_t P9N2_EX_10_DTS_TRC_RESULT                                    = 0x34050003ull;
//DUPS: 35050003,
static const uint64_t P9N2_EX_11_DTS_TRC_RESULT                                    = 0x36050003ull;
//DUPS: 37050003,

static const uint64_t P9N2_EQ_EDRAM_BANK_FAIL_SCOM_RD                              = 0x10011C1Bull;
//DUPS: 10011C1B,
static const uint64_t P9N2_EQ_0_EDRAM_BANK_FAIL_SCOM_RD                            = 0x10011C1Bull;
//DUPS: 10011C1B,
static const uint64_t P9N2_EQ_1_EDRAM_BANK_FAIL_SCOM_RD                            = 0x11011C1Bull;
//DUPS: 11011C1B,
static const uint64_t P9N2_EQ_2_EDRAM_BANK_FAIL_SCOM_RD                            = 0x12011C1Bull;
//DUPS: 12011C1B,
static const uint64_t P9N2_EQ_3_EDRAM_BANK_FAIL_SCOM_RD                            = 0x13011C1Bull;
//DUPS: 13011C1B,
static const uint64_t P9N2_EQ_4_EDRAM_BANK_FAIL_SCOM_RD                            = 0x14011C1Bull;
//DUPS: 14011C1B,
static const uint64_t P9N2_EQ_5_EDRAM_BANK_FAIL_SCOM_RD                            = 0x15011C1Bull;
//DUPS: 15011C1B,
static const uint64_t P9N2_EX_0_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x1001181Bull;

static const uint64_t P9N2_EX_10_L3_EDRAM_BANK_FAIL_SCOM_RD                        = 0x1501181Bull;

static const uint64_t P9N2_EX_11_L3_EDRAM_BANK_FAIL_SCOM_RD                        = 0x15011C1Bull;

static const uint64_t P9N2_EX_1_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x10011C1Bull;

static const uint64_t P9N2_EX_2_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x1101181Bull;

static const uint64_t P9N2_EX_3_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x11011C1Bull;

static const uint64_t P9N2_EX_4_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x1201181Bull;

static const uint64_t P9N2_EX_5_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x12011C1Bull;

static const uint64_t P9N2_EX_6_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x1301181Bull;

static const uint64_t P9N2_EX_7_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x13011C1Bull;

static const uint64_t P9N2_EX_8_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x1401181Bull;

static const uint64_t P9N2_EX_9_L3_EDRAM_BANK_FAIL_SCOM_RD                         = 0x14011C1Bull;

static const uint64_t P9N2_EX_L3_EDRAM_BANK_FAIL_SCOM_RD                           = 0x1001181Bull;


static const uint64_t P9N2_EQ_EDRAM_BANK_SOFT_DIS                                  = 0x10011C0Bull;
//DUPS: 10011C0B,
static const uint64_t P9N2_EQ_0_EDRAM_BANK_SOFT_DIS                                = 0x10011C0Bull;
//DUPS: 10011C0B,
static const uint64_t P9N2_EQ_1_EDRAM_BANK_SOFT_DIS                                = 0x11011C0Bull;
//DUPS: 11011C0B,
static const uint64_t P9N2_EQ_2_EDRAM_BANK_SOFT_DIS                                = 0x12011C0Bull;
//DUPS: 12011C0B,
static const uint64_t P9N2_EQ_3_EDRAM_BANK_SOFT_DIS                                = 0x13011C0Bull;
//DUPS: 13011C0B,
static const uint64_t P9N2_EQ_4_EDRAM_BANK_SOFT_DIS                                = 0x14011C0Bull;
//DUPS: 14011C0B,
static const uint64_t P9N2_EQ_5_EDRAM_BANK_SOFT_DIS                                = 0x15011C0Bull;
//DUPS: 15011C0B,
static const uint64_t P9N2_EX_0_L3_EDRAM_BANK_SOFT_DIS                             = 0x1001180Bull;

static const uint64_t P9N2_EX_10_L3_EDRAM_BANK_SOFT_DIS                            = 0x1501180Bull;

static const uint64_t P9N2_EX_11_L3_EDRAM_BANK_SOFT_DIS                            = 0x15011C0Bull;

static const uint64_t P9N2_EX_1_L3_EDRAM_BANK_SOFT_DIS                             = 0x10011C0Bull;

static const uint64_t P9N2_EX_2_L3_EDRAM_BANK_SOFT_DIS                             = 0x1101180Bull;

static const uint64_t P9N2_EX_3_L3_EDRAM_BANK_SOFT_DIS                             = 0x11011C0Bull;

static const uint64_t P9N2_EX_4_L3_EDRAM_BANK_SOFT_DIS                             = 0x1201180Bull;

static const uint64_t P9N2_EX_5_L3_EDRAM_BANK_SOFT_DIS                             = 0x12011C0Bull;

static const uint64_t P9N2_EX_6_L3_EDRAM_BANK_SOFT_DIS                             = 0x1301180Bull;

static const uint64_t P9N2_EX_7_L3_EDRAM_BANK_SOFT_DIS                             = 0x13011C0Bull;

static const uint64_t P9N2_EX_8_L3_EDRAM_BANK_SOFT_DIS                             = 0x1401180Bull;

static const uint64_t P9N2_EX_9_L3_EDRAM_BANK_SOFT_DIS                             = 0x14011C0Bull;

static const uint64_t P9N2_EX_L3_EDRAM_BANK_SOFT_DIS                               = 0x1001180Bull;


static const uint64_t P9N2_EQ_EDRAM_REG                                            = 0x10011C0Cull;
//DUPS: 10011C0C,
static const uint64_t P9N2_EQ_0_EDRAM_REG                                          = 0x10011C0Cull;
//DUPS: 10011C0C,
static const uint64_t P9N2_EQ_1_EDRAM_REG                                          = 0x11011C0Cull;
//DUPS: 11011C0C,
static const uint64_t P9N2_EQ_2_EDRAM_REG                                          = 0x12011C0Cull;
//DUPS: 12011C0C,
static const uint64_t P9N2_EQ_3_EDRAM_REG                                          = 0x13011C0Cull;
//DUPS: 13011C0C,
static const uint64_t P9N2_EQ_4_EDRAM_REG                                          = 0x14011C0Cull;
//DUPS: 14011C0C,
static const uint64_t P9N2_EQ_5_EDRAM_REG                                          = 0x15011C0Cull;
//DUPS: 15011C0C,
static const uint64_t P9N2_EX_0_L3_EDRAM_REG                                       = 0x1001180Cull;

static const uint64_t P9N2_EX_10_L3_EDRAM_REG                                      = 0x1501180Cull;

static const uint64_t P9N2_EX_11_L3_EDRAM_REG                                      = 0x15011C0Cull;

static const uint64_t P9N2_EX_1_L3_EDRAM_REG                                       = 0x10011C0Cull;

static const uint64_t P9N2_EX_2_L3_EDRAM_REG                                       = 0x1101180Cull;

static const uint64_t P9N2_EX_3_L3_EDRAM_REG                                       = 0x11011C0Cull;

static const uint64_t P9N2_EX_4_L3_EDRAM_REG                                       = 0x1201180Cull;

static const uint64_t P9N2_EX_5_L3_EDRAM_REG                                       = 0x12011C0Cull;

static const uint64_t P9N2_EX_6_L3_EDRAM_REG                                       = 0x1301180Cull;

static const uint64_t P9N2_EX_7_L3_EDRAM_REG                                       = 0x13011C0Cull;

static const uint64_t P9N2_EX_8_L3_EDRAM_REG                                       = 0x1401180Cull;

static const uint64_t P9N2_EX_9_L3_EDRAM_REG                                       = 0x14011C0Cull;

static const uint64_t P9N2_EX_L3_EDRAM_REG                                         = 0x1001180Cull;


static const uint64_t P9N2_C_EDRAM_STATUS                                          = 0x200F0029ull;

static const uint64_t P9N2_C_0_EDRAM_STATUS                                        = 0x200F0029ull;

static const uint64_t P9N2_C_1_EDRAM_STATUS                                        = 0x210F0029ull;

static const uint64_t P9N2_C_2_EDRAM_STATUS                                        = 0x220F0029ull;

static const uint64_t P9N2_C_3_EDRAM_STATUS                                        = 0x230F0029ull;

static const uint64_t P9N2_C_4_EDRAM_STATUS                                        = 0x240F0029ull;

static const uint64_t P9N2_C_5_EDRAM_STATUS                                        = 0x250F0029ull;

static const uint64_t P9N2_C_6_EDRAM_STATUS                                        = 0x260F0029ull;

static const uint64_t P9N2_C_7_EDRAM_STATUS                                        = 0x270F0029ull;

static const uint64_t P9N2_C_8_EDRAM_STATUS                                        = 0x280F0029ull;

static const uint64_t P9N2_C_9_EDRAM_STATUS                                        = 0x290F0029ull;

static const uint64_t P9N2_C_10_EDRAM_STATUS                                       = 0x2A0F0029ull;

static const uint64_t P9N2_C_11_EDRAM_STATUS                                       = 0x2B0F0029ull;

static const uint64_t P9N2_C_12_EDRAM_STATUS                                       = 0x2C0F0029ull;

static const uint64_t P9N2_C_13_EDRAM_STATUS                                       = 0x2D0F0029ull;

static const uint64_t P9N2_C_14_EDRAM_STATUS                                       = 0x2E0F0029ull;

static const uint64_t P9N2_C_15_EDRAM_STATUS                                       = 0x2F0F0029ull;

static const uint64_t P9N2_C_16_EDRAM_STATUS                                       = 0x300F0029ull;

static const uint64_t P9N2_C_17_EDRAM_STATUS                                       = 0x310F0029ull;

static const uint64_t P9N2_C_18_EDRAM_STATUS                                       = 0x320F0029ull;

static const uint64_t P9N2_C_19_EDRAM_STATUS                                       = 0x330F0029ull;

static const uint64_t P9N2_C_20_EDRAM_STATUS                                       = 0x340F0029ull;

static const uint64_t P9N2_C_21_EDRAM_STATUS                                       = 0x350F0029ull;

static const uint64_t P9N2_C_22_EDRAM_STATUS                                       = 0x360F0029ull;

static const uint64_t P9N2_C_23_EDRAM_STATUS                                       = 0x370F0029ull;

static const uint64_t P9N2_EQ_EDRAM_STATUS                                         = 0x100F0029ull;

static const uint64_t P9N2_EQ_0_EDRAM_STATUS                                       = 0x100F0029ull;

static const uint64_t P9N2_EQ_1_EDRAM_STATUS                                       = 0x110F0029ull;

static const uint64_t P9N2_EQ_2_EDRAM_STATUS                                       = 0x120F0029ull;

static const uint64_t P9N2_EQ_3_EDRAM_STATUS                                       = 0x130F0029ull;

static const uint64_t P9N2_EQ_4_EDRAM_STATUS                                       = 0x140F0029ull;

static const uint64_t P9N2_EQ_5_EDRAM_STATUS                                       = 0x150F0029ull;

static const uint64_t P9N2_EX_EDRAM_STATUS                                         = 0x200F0029ull;
//DUPS: 210F0029,
static const uint64_t P9N2_EX_0_EDRAM_STATUS                                       = 0x200F0029ull;
//DUPS: 210F0029,
static const uint64_t P9N2_EX_1_EDRAM_STATUS                                       = 0x220F0029ull;
//DUPS: 220F0029,
static const uint64_t P9N2_EX_2_EDRAM_STATUS                                       = 0x240F0029ull;
//DUPS: 250F0029,
static const uint64_t P9N2_EX_3_EDRAM_STATUS                                       = 0x260F0029ull;
//DUPS: 270F0029,
static const uint64_t P9N2_EX_4_EDRAM_STATUS                                       = 0x280F0029ull;
//DUPS: 290F0029,
static const uint64_t P9N2_EX_5_EDRAM_STATUS                                       = 0x2A0F0029ull;
//DUPS: 2B0F0029,
static const uint64_t P9N2_EX_6_EDRAM_STATUS                                       = 0x2C0F0029ull;
//DUPS: 2D0F0029,
static const uint64_t P9N2_EX_7_EDRAM_STATUS                                       = 0x2E0F0029ull;
//DUPS: 2F0F0029,
static const uint64_t P9N2_EX_8_EDRAM_STATUS                                       = 0x300F0029ull;
//DUPS: 310F0029,
static const uint64_t P9N2_EX_9_EDRAM_STATUS                                       = 0x320F0029ull;
//DUPS: 330F0029,
static const uint64_t P9N2_EX_10_EDRAM_STATUS                                      = 0x340F0029ull;
//DUPS: 350F0029,
static const uint64_t P9N2_EX_11_EDRAM_STATUS                                      = 0x360F0029ull;
//DUPS: 370F0029,

static const uint64_t P9N2_EQ_ED_RD_ERR_STAT_REG0                                  = 0x10011C19ull;
//DUPS: 10011C19,
static const uint64_t P9N2_EQ_0_ED_RD_ERR_STAT_REG0                                = 0x10011C19ull;
//DUPS: 10011C19,
static const uint64_t P9N2_EQ_1_ED_RD_ERR_STAT_REG0                                = 0x11011C19ull;
//DUPS: 11011C19,
static const uint64_t P9N2_EQ_2_ED_RD_ERR_STAT_REG0                                = 0x12011C19ull;
//DUPS: 12011C19,
static const uint64_t P9N2_EQ_3_ED_RD_ERR_STAT_REG0                                = 0x13011C19ull;
//DUPS: 13011C19,
static const uint64_t P9N2_EQ_4_ED_RD_ERR_STAT_REG0                                = 0x14011C19ull;
//DUPS: 14011C19,
static const uint64_t P9N2_EQ_5_ED_RD_ERR_STAT_REG0                                = 0x15011C19ull;
//DUPS: 15011C19,
static const uint64_t P9N2_EX_ED_RD_ERR_STAT_REG0                                  = 0x10011819ull;

static const uint64_t P9N2_EX_0_ED_RD_ERR_STAT_REG0                                = 0x10011819ull;

static const uint64_t P9N2_EX_1_ED_RD_ERR_STAT_REG0                                = 0x10011C19ull;

static const uint64_t P9N2_EX_2_ED_RD_ERR_STAT_REG0                                = 0x11011819ull;

static const uint64_t P9N2_EX_3_ED_RD_ERR_STAT_REG0                                = 0x11011C19ull;

static const uint64_t P9N2_EX_4_ED_RD_ERR_STAT_REG0                                = 0x12011819ull;

static const uint64_t P9N2_EX_5_ED_RD_ERR_STAT_REG0                                = 0x12011C19ull;

static const uint64_t P9N2_EX_6_ED_RD_ERR_STAT_REG0                                = 0x13011819ull;

static const uint64_t P9N2_EX_7_ED_RD_ERR_STAT_REG0                                = 0x13011C19ull;

static const uint64_t P9N2_EX_8_ED_RD_ERR_STAT_REG0                                = 0x14011819ull;

static const uint64_t P9N2_EX_9_ED_RD_ERR_STAT_REG0                                = 0x14011C19ull;

static const uint64_t P9N2_EX_10_ED_RD_ERR_STAT_REG0                               = 0x15011819ull;

static const uint64_t P9N2_EX_11_ED_RD_ERR_STAT_REG0                               = 0x15011C19ull;


static const uint64_t P9N2_EQ_ED_RD_ERR_STAT_REG1                                  = 0x10011C1Aull;
//DUPS: 10011C1A,
static const uint64_t P9N2_EQ_0_ED_RD_ERR_STAT_REG1                                = 0x10011C1Aull;
//DUPS: 10011C1A,
static const uint64_t P9N2_EQ_1_ED_RD_ERR_STAT_REG1                                = 0x11011C1Aull;
//DUPS: 11011C1A,
static const uint64_t P9N2_EQ_2_ED_RD_ERR_STAT_REG1                                = 0x12011C1Aull;
//DUPS: 12011C1A,
static const uint64_t P9N2_EQ_3_ED_RD_ERR_STAT_REG1                                = 0x13011C1Aull;
//DUPS: 13011C1A,
static const uint64_t P9N2_EQ_4_ED_RD_ERR_STAT_REG1                                = 0x14011C1Aull;
//DUPS: 14011C1A,
static const uint64_t P9N2_EQ_5_ED_RD_ERR_STAT_REG1                                = 0x15011C1Aull;
//DUPS: 15011C1A,
static const uint64_t P9N2_EX_0_L3_ED_RD_ERR_STAT_REG1                             = 0x1001181Aull;

static const uint64_t P9N2_EX_10_L3_ED_RD_ERR_STAT_REG1                            = 0x1501181Aull;

static const uint64_t P9N2_EX_11_L3_ED_RD_ERR_STAT_REG1                            = 0x15011C1Aull;

static const uint64_t P9N2_EX_1_L3_ED_RD_ERR_STAT_REG1                             = 0x10011C1Aull;

static const uint64_t P9N2_EX_2_L3_ED_RD_ERR_STAT_REG1                             = 0x1101181Aull;

static const uint64_t P9N2_EX_3_L3_ED_RD_ERR_STAT_REG1                             = 0x11011C1Aull;

static const uint64_t P9N2_EX_4_L3_ED_RD_ERR_STAT_REG1                             = 0x1201181Aull;

static const uint64_t P9N2_EX_5_L3_ED_RD_ERR_STAT_REG1                             = 0x12011C1Aull;

static const uint64_t P9N2_EX_6_L3_ED_RD_ERR_STAT_REG1                             = 0x1301181Aull;

static const uint64_t P9N2_EX_7_L3_ED_RD_ERR_STAT_REG1                             = 0x13011C1Aull;

static const uint64_t P9N2_EX_8_L3_ED_RD_ERR_STAT_REG1                             = 0x1401181Aull;

static const uint64_t P9N2_EX_9_L3_ED_RD_ERR_STAT_REG1                             = 0x14011C1Aull;

static const uint64_t P9N2_EX_L3_ED_RD_ERR_STAT_REG1                               = 0x1001181Aull;


static const uint64_t P9N2_C_ERROR_REG                                             = 0x200F001Full;

static const uint64_t P9N2_C_0_ERROR_REG                                           = 0x200F001Full;

static const uint64_t P9N2_C_1_ERROR_REG                                           = 0x210F001Full;

static const uint64_t P9N2_C_2_ERROR_REG                                           = 0x220F001Full;

static const uint64_t P9N2_C_3_ERROR_REG                                           = 0x230F001Full;

static const uint64_t P9N2_C_4_ERROR_REG                                           = 0x240F001Full;

static const uint64_t P9N2_C_5_ERROR_REG                                           = 0x250F001Full;

static const uint64_t P9N2_C_6_ERROR_REG                                           = 0x260F001Full;

static const uint64_t P9N2_C_7_ERROR_REG                                           = 0x270F001Full;

static const uint64_t P9N2_C_8_ERROR_REG                                           = 0x280F001Full;

static const uint64_t P9N2_C_9_ERROR_REG                                           = 0x290F001Full;

static const uint64_t P9N2_C_10_ERROR_REG                                          = 0x2A0F001Full;

static const uint64_t P9N2_C_11_ERROR_REG                                          = 0x2B0F001Full;

static const uint64_t P9N2_C_12_ERROR_REG                                          = 0x2C0F001Full;

static const uint64_t P9N2_C_13_ERROR_REG                                          = 0x2D0F001Full;

static const uint64_t P9N2_C_14_ERROR_REG                                          = 0x2E0F001Full;

static const uint64_t P9N2_C_15_ERROR_REG                                          = 0x2F0F001Full;

static const uint64_t P9N2_C_16_ERROR_REG                                          = 0x300F001Full;

static const uint64_t P9N2_C_17_ERROR_REG                                          = 0x310F001Full;

static const uint64_t P9N2_C_18_ERROR_REG                                          = 0x320F001Full;

static const uint64_t P9N2_C_19_ERROR_REG                                          = 0x330F001Full;

static const uint64_t P9N2_C_20_ERROR_REG                                          = 0x340F001Full;

static const uint64_t P9N2_C_21_ERROR_REG                                          = 0x350F001Full;

static const uint64_t P9N2_C_22_ERROR_REG                                          = 0x360F001Full;

static const uint64_t P9N2_C_23_ERROR_REG                                          = 0x370F001Full;

static const uint64_t P9N2_EQ_ERROR_REG                                            = 0x100F001Full;

static const uint64_t P9N2_EQ_0_ERROR_REG                                          = 0x100F001Full;

static const uint64_t P9N2_EQ_1_ERROR_REG                                          = 0x110F001Full;

static const uint64_t P9N2_EQ_2_ERROR_REG                                          = 0x120F001Full;

static const uint64_t P9N2_EQ_3_ERROR_REG                                          = 0x130F001Full;

static const uint64_t P9N2_EQ_4_ERROR_REG                                          = 0x140F001Full;

static const uint64_t P9N2_EQ_5_ERROR_REG                                          = 0x150F001Full;

static const uint64_t P9N2_EX_ERROR_REG                                            = 0x200F001Full;
//DUPS: 210F001F,
static const uint64_t P9N2_EX_0_ERROR_REG                                          = 0x200F001Full;
//DUPS: 210F001F,
static const uint64_t P9N2_EX_1_ERROR_REG                                          = 0x220F001Full;
//DUPS: 220F001F,
static const uint64_t P9N2_EX_2_ERROR_REG                                          = 0x240F001Full;
//DUPS: 250F001F,
static const uint64_t P9N2_EX_3_ERROR_REG                                          = 0x260F001Full;
//DUPS: 270F001F,
static const uint64_t P9N2_EX_4_ERROR_REG                                          = 0x280F001Full;
//DUPS: 290F001F,
static const uint64_t P9N2_EX_5_ERROR_REG                                          = 0x2A0F001Full;
//DUPS: 2B0F001F,
static const uint64_t P9N2_EX_6_ERROR_REG                                          = 0x2C0F001Full;
//DUPS: 2D0F001F,
static const uint64_t P9N2_EX_7_ERROR_REG                                          = 0x2E0F001Full;
//DUPS: 2F0F001F,
static const uint64_t P9N2_EX_8_ERROR_REG                                          = 0x300F001Full;
//DUPS: 310F001F,
static const uint64_t P9N2_EX_9_ERROR_REG                                          = 0x320F001Full;
//DUPS: 330F001F,
static const uint64_t P9N2_EX_10_ERROR_REG                                         = 0x340F001Full;
//DUPS: 350F001F,
static const uint64_t P9N2_EX_11_ERROR_REG                                         = 0x360F001Full;
//DUPS: 370F001F,

static const uint64_t P9N2_C_ERROR_STATUS                                          = 0x2003000Full;

static const uint64_t P9N2_C_0_ERROR_STATUS                                        = 0x2003000Full;

static const uint64_t P9N2_C_1_ERROR_STATUS                                        = 0x2103000Full;

static const uint64_t P9N2_C_2_ERROR_STATUS                                        = 0x2203000Full;

static const uint64_t P9N2_C_3_ERROR_STATUS                                        = 0x2303000Full;

static const uint64_t P9N2_C_4_ERROR_STATUS                                        = 0x2403000Full;

static const uint64_t P9N2_C_5_ERROR_STATUS                                        = 0x2503000Full;

static const uint64_t P9N2_C_6_ERROR_STATUS                                        = 0x2603000Full;

static const uint64_t P9N2_C_7_ERROR_STATUS                                        = 0x2703000Full;

static const uint64_t P9N2_C_8_ERROR_STATUS                                        = 0x2803000Full;

static const uint64_t P9N2_C_9_ERROR_STATUS                                        = 0x2903000Full;

static const uint64_t P9N2_C_10_ERROR_STATUS                                       = 0x2A03000Full;

static const uint64_t P9N2_C_11_ERROR_STATUS                                       = 0x2B03000Full;

static const uint64_t P9N2_C_12_ERROR_STATUS                                       = 0x2C03000Full;

static const uint64_t P9N2_C_13_ERROR_STATUS                                       = 0x2D03000Full;

static const uint64_t P9N2_C_14_ERROR_STATUS                                       = 0x2E03000Full;

static const uint64_t P9N2_C_15_ERROR_STATUS                                       = 0x2F03000Full;

static const uint64_t P9N2_C_16_ERROR_STATUS                                       = 0x3003000Full;

static const uint64_t P9N2_C_17_ERROR_STATUS                                       = 0x3103000Full;

static const uint64_t P9N2_C_18_ERROR_STATUS                                       = 0x3203000Full;

static const uint64_t P9N2_C_19_ERROR_STATUS                                       = 0x3303000Full;

static const uint64_t P9N2_C_20_ERROR_STATUS                                       = 0x3403000Full;

static const uint64_t P9N2_C_21_ERROR_STATUS                                       = 0x3503000Full;

static const uint64_t P9N2_C_22_ERROR_STATUS                                       = 0x3603000Full;

static const uint64_t P9N2_C_23_ERROR_STATUS                                       = 0x3703000Full;

static const uint64_t P9N2_EQ_ERROR_STATUS                                         = 0x1003000Full;

static const uint64_t P9N2_EQ_0_ERROR_STATUS                                       = 0x1003000Full;

static const uint64_t P9N2_EQ_1_ERROR_STATUS                                       = 0x1103000Full;

static const uint64_t P9N2_EQ_2_ERROR_STATUS                                       = 0x1203000Full;

static const uint64_t P9N2_EQ_3_ERROR_STATUS                                       = 0x1303000Full;

static const uint64_t P9N2_EQ_4_ERROR_STATUS                                       = 0x1403000Full;

static const uint64_t P9N2_EQ_5_ERROR_STATUS                                       = 0x1503000Full;

static const uint64_t P9N2_EX_ERROR_STATUS                                         = 0x2003000Full;
//DUPS: 2103000F,
static const uint64_t P9N2_EX_0_ERROR_STATUS                                       = 0x2003000Full;
//DUPS: 2103000F,
static const uint64_t P9N2_EX_1_ERROR_STATUS                                       = 0x2203000Full;
//DUPS: 2303000F,
static const uint64_t P9N2_EX_2_ERROR_STATUS                                       = 0x2403000Full;
//DUPS: 2503000F,
static const uint64_t P9N2_EX_3_ERROR_STATUS                                       = 0x2603000Full;
//DUPS: 2703000F,
static const uint64_t P9N2_EX_4_ERROR_STATUS                                       = 0x2803000Full;
//DUPS: 2903000F,
static const uint64_t P9N2_EX_5_ERROR_STATUS                                       = 0x2A03000Full;
//DUPS: 2B03000F,
static const uint64_t P9N2_EX_6_ERROR_STATUS                                       = 0x2C03000Full;
//DUPS: 2D03000F,
static const uint64_t P9N2_EX_7_ERROR_STATUS                                       = 0x2F03000Full;
//DUPS: 2F03000F,
static const uint64_t P9N2_EX_8_ERROR_STATUS                                       = 0x3003000Full;
//DUPS: 3103000F,
static const uint64_t P9N2_EX_9_ERROR_STATUS                                       = 0x3203000Full;
//DUPS: 3303000F,
static const uint64_t P9N2_EX_10_ERROR_STATUS                                      = 0x3403000Full;
//DUPS: 3503000F,
static const uint64_t P9N2_EX_11_ERROR_STATUS                                      = 0x3603000Full;
//DUPS: 3703000F,

static const uint64_t P9N2_C_ERR_INJ_REG                                           = 0x20010C04ull;
//DUPS: 20010CBF,
static const uint64_t P9N2_C_0_ERR_INJ_REG                                         = 0x20010C04ull;
//DUPS: 20010CBF,
static const uint64_t P9N2_C_1_ERR_INJ_REG                                         = 0x21010C04ull;
//DUPS: 21010CBF,
static const uint64_t P9N2_C_2_ERR_INJ_REG                                         = 0x22010C04ull;
//DUPS: 22010CBF,
static const uint64_t P9N2_C_3_ERR_INJ_REG                                         = 0x23010C04ull;
//DUPS: 23010CBF,
static const uint64_t P9N2_C_4_ERR_INJ_REG                                         = 0x24010C04ull;
//DUPS: 24010CBF,
static const uint64_t P9N2_C_5_ERR_INJ_REG                                         = 0x25010C04ull;
//DUPS: 25010CBF,
static const uint64_t P9N2_C_6_ERR_INJ_REG                                         = 0x26010C04ull;
//DUPS: 26010CBF,
static const uint64_t P9N2_C_7_ERR_INJ_REG                                         = 0x27010C04ull;
//DUPS: 27010CBF,
static const uint64_t P9N2_C_8_ERR_INJ_REG                                         = 0x28010C04ull;
//DUPS: 28010CBF,
static const uint64_t P9N2_C_9_ERR_INJ_REG                                         = 0x29010C04ull;
//DUPS: 29010CBF,
static const uint64_t P9N2_C_10_ERR_INJ_REG                                        = 0x2A010C04ull;
//DUPS: 2A010CBF,
static const uint64_t P9N2_C_11_ERR_INJ_REG                                        = 0x2B010C04ull;
//DUPS: 2B010CBF,
static const uint64_t P9N2_C_12_ERR_INJ_REG                                        = 0x2C010C04ull;
//DUPS: 2C010CBF,
static const uint64_t P9N2_C_13_ERR_INJ_REG                                        = 0x2D010C04ull;
//DUPS: 2D010CBF,
static const uint64_t P9N2_C_14_ERR_INJ_REG                                        = 0x2E010C04ull;
//DUPS: 2E010CBF,
static const uint64_t P9N2_C_15_ERR_INJ_REG                                        = 0x2F010C04ull;
//DUPS: 2F010CBF,
static const uint64_t P9N2_C_16_ERR_INJ_REG                                        = 0x30010C04ull;
//DUPS: 30010CBF,
static const uint64_t P9N2_C_17_ERR_INJ_REG                                        = 0x31010C04ull;
//DUPS: 31010CBF,
static const uint64_t P9N2_C_18_ERR_INJ_REG                                        = 0x32010C04ull;
//DUPS: 32010CBF,
static const uint64_t P9N2_C_19_ERR_INJ_REG                                        = 0x33010C04ull;
//DUPS: 33010CBF,
static const uint64_t P9N2_C_20_ERR_INJ_REG                                        = 0x34010C04ull;
//DUPS: 34010CBF,
static const uint64_t P9N2_C_21_ERR_INJ_REG                                        = 0x35010C04ull;
//DUPS: 35010CBF,
static const uint64_t P9N2_C_22_ERR_INJ_REG                                        = 0x36010C04ull;
//DUPS: 36010CBF,
static const uint64_t P9N2_C_23_ERR_INJ_REG                                        = 0x37010C04ull;
//DUPS: 37010CBF,
static const uint64_t P9N2_EQ_ERR_INJ_REG                                          = 0x10010C0Cull;
//DUPS: 1001180D, 10010C0C, 10011C0D,
static const uint64_t P9N2_EQ_0_ERR_INJ_REG                                        = 0x10010C0Cull;
//DUPS: 1001180D, 10010C0C, 10011C0D,
static const uint64_t P9N2_EQ_1_ERR_INJ_REG                                        = 0x11010C0Cull;
//DUPS: 1101180D, 11010C0C, 11011C0D,
static const uint64_t P9N2_EQ_2_ERR_INJ_REG                                        = 0x12010C0Cull;
//DUPS: 1201180D, 12010C0C, 12011C0D,
static const uint64_t P9N2_EQ_3_ERR_INJ_REG                                        = 0x13010C0Cull;
//DUPS: 1301180D, 13010C0C, 13011C0D,
static const uint64_t P9N2_EQ_4_ERR_INJ_REG                                        = 0x14010C0Cull;
//DUPS: 1401180D, 14010C0C, 14011C0D,
static const uint64_t P9N2_EQ_5_ERR_INJ_REG                                        = 0x15010C0Cull;
//DUPS: 1501180D, 15010C0C, 15011C0D,
static const uint64_t P9N2_EX_ERR_INJ_REG                                          = 0x20010CBFull;
//DUPS: 21010CBF,
static const uint64_t P9N2_EX_0_ERR_INJ_REG                                        = 0x20010CBFull;
//DUPS: 21010CBF,
static const uint64_t P9N2_EX_1_ERR_INJ_REG                                        = 0x22010CBFull;
//DUPS: 23010CBF,
static const uint64_t P9N2_EX_2_ERR_INJ_REG                                        = 0x24010CBFull;
//DUPS: 25010CBF,
static const uint64_t P9N2_EX_3_ERR_INJ_REG                                        = 0x26010CBFull;
//DUPS: 27010CBF,
static const uint64_t P9N2_EX_4_ERR_INJ_REG                                        = 0x28010CBFull;
//DUPS: 29010CBF,
static const uint64_t P9N2_EX_5_ERR_INJ_REG                                        = 0x2A010CBFull;
//DUPS: 2B010CBF,
static const uint64_t P9N2_EX_6_ERR_INJ_REG                                        = 0x2C010CBFull;
//DUPS: 2D010CBF,
static const uint64_t P9N2_EX_7_ERR_INJ_REG                                        = 0x2F010CBFull;
//DUPS: 2F010CBF,
static const uint64_t P9N2_EX_8_ERR_INJ_REG                                        = 0x30010CBFull;
//DUPS: 31010CBF,
static const uint64_t P9N2_EX_9_ERR_INJ_REG                                        = 0x32010CBFull;
//DUPS: 33010CBF,
static const uint64_t P9N2_EX_0_L2_ERR_INJ_REG                                     = 0x20010C04ull;
//DUPS: 21010C04, 1001080C,
static const uint64_t P9N2_EX_0_L3_ERR_INJ_REG                                     = 0x1001180Dull;

static const uint64_t P9N2_EX_10_ERR_INJ_REG                                       = 0x34010CBFull;
//DUPS: 35010CBF,
static const uint64_t P9N2_EX_11_ERR_INJ_REG                                       = 0x36010CBFull;
//DUPS: 37010CBF,
static const uint64_t P9N2_EX_10_L2_ERR_INJ_REG                                    = 0x34010C04ull;
//DUPS: 35010C04, 1501080C,
static const uint64_t P9N2_EX_10_L3_ERR_INJ_REG                                    = 0x1501180Dull;

static const uint64_t P9N2_EX_11_L2_ERR_INJ_REG                                    = 0x15010C0Cull;
//DUPS: 37010C04, 15010C0C,
static const uint64_t P9N2_EX_11_L3_ERR_INJ_REG                                    = 0x15011C0Dull;

static const uint64_t P9N2_EX_1_L2_ERR_INJ_REG                                     = 0x10010C0Cull;
//DUPS: 23010C04, 10010C0C,
static const uint64_t P9N2_EX_1_L3_ERR_INJ_REG                                     = 0x10011C0Dull;

static const uint64_t P9N2_EX_2_L2_ERR_INJ_REG                                     = 0x24010C04ull;
//DUPS: 25010C04, 1101080C,
static const uint64_t P9N2_EX_2_L3_ERR_INJ_REG                                     = 0x1101180Dull;

static const uint64_t P9N2_EX_3_L2_ERR_INJ_REG                                     = 0x11010C0Cull;
//DUPS: 27010C04, 11010C0C,
static const uint64_t P9N2_EX_3_L3_ERR_INJ_REG                                     = 0x11011C0Dull;

static const uint64_t P9N2_EX_4_L2_ERR_INJ_REG                                     = 0x28010C04ull;
//DUPS: 29010C04, 1201080C,
static const uint64_t P9N2_EX_4_L3_ERR_INJ_REG                                     = 0x1201180Dull;

static const uint64_t P9N2_EX_5_L2_ERR_INJ_REG                                     = 0x2A010C04ull;
//DUPS: 2B010C04, 12010C0C,
static const uint64_t P9N2_EX_5_L3_ERR_INJ_REG                                     = 0x12011C0Dull;

static const uint64_t P9N2_EX_6_L2_ERR_INJ_REG                                     = 0x2C010C04ull;
//DUPS: 2D010C04, 1301080C,
static const uint64_t P9N2_EX_6_L3_ERR_INJ_REG                                     = 0x1301180Dull;

static const uint64_t P9N2_EX_7_L2_ERR_INJ_REG                                     = 0x2F010C04ull;
//DUPS: 2F010C04, 13010C0C,
static const uint64_t P9N2_EX_7_L3_ERR_INJ_REG                                     = 0x13011C0Dull;

static const uint64_t P9N2_EX_8_L2_ERR_INJ_REG                                     = 0x30010C04ull;
//DUPS: 31010C04, 1401080C,
static const uint64_t P9N2_EX_8_L3_ERR_INJ_REG                                     = 0x1401180Dull;

static const uint64_t P9N2_EX_9_L2_ERR_INJ_REG                                     = 0x14010C0Cull;
//DUPS: 33010C04, 14010C0C,
static const uint64_t P9N2_EX_9_L3_ERR_INJ_REG                                     = 0x14011C0Dull;

static const uint64_t P9N2_EX_L2_ERR_INJ_REG                                       = 0x20010C04ull;
//DUPS: 21010C04, 1001080C,
static const uint64_t P9N2_EX_L3_ERR_INJ_REG                                       = 0x1001180Dull;


static const uint64_t P9N2_EQ_ERR_RPT0                                             = 0x10010C12ull;
//DUPS: 10010C12,
static const uint64_t P9N2_EQ_0_ERR_RPT0                                           = 0x10010C12ull;
//DUPS: 10010C12,
static const uint64_t P9N2_EQ_1_ERR_RPT0                                           = 0x11010C12ull;
//DUPS: 11010C12,
static const uint64_t P9N2_EQ_2_ERR_RPT0                                           = 0x12010C12ull;
//DUPS: 12010C12,
static const uint64_t P9N2_EQ_3_ERR_RPT0                                           = 0x13010C12ull;
//DUPS: 13010C12,
static const uint64_t P9N2_EQ_4_ERR_RPT0                                           = 0x14010C12ull;
//DUPS: 14010C12,
static const uint64_t P9N2_EQ_5_ERR_RPT0                                           = 0x15010C12ull;
//DUPS: 15010C12,
static const uint64_t P9N2_EX_0_L2_ERR_RPT0                                        = 0x10010812ull;

static const uint64_t P9N2_EX_10_L2_ERR_RPT0                                       = 0x15010812ull;

static const uint64_t P9N2_EX_11_L2_ERR_RPT0                                       = 0x15010C12ull;

static const uint64_t P9N2_EX_1_L2_ERR_RPT0                                        = 0x10010C12ull;

static const uint64_t P9N2_EX_2_L2_ERR_RPT0                                        = 0x11010812ull;

static const uint64_t P9N2_EX_3_L2_ERR_RPT0                                        = 0x11010C12ull;

static const uint64_t P9N2_EX_4_L2_ERR_RPT0                                        = 0x12010812ull;

static const uint64_t P9N2_EX_5_L2_ERR_RPT0                                        = 0x12010C12ull;

static const uint64_t P9N2_EX_6_L2_ERR_RPT0                                        = 0x13010812ull;

static const uint64_t P9N2_EX_7_L2_ERR_RPT0                                        = 0x13010C12ull;

static const uint64_t P9N2_EX_8_L2_ERR_RPT0                                        = 0x14010812ull;

static const uint64_t P9N2_EX_9_L2_ERR_RPT0                                        = 0x14010C12ull;

static const uint64_t P9N2_EX_L2_ERR_RPT0                                          = 0x10010812ull;


static const uint64_t P9N2_EQ_ERR_RPT1                                             = 0x10010C13ull;
//DUPS: 10010C13,
static const uint64_t P9N2_EQ_0_ERR_RPT1                                           = 0x10010C13ull;
//DUPS: 10010C13,
static const uint64_t P9N2_EQ_1_ERR_RPT1                                           = 0x11010C13ull;
//DUPS: 11010C13,
static const uint64_t P9N2_EQ_2_ERR_RPT1                                           = 0x12010C13ull;
//DUPS: 12010C13,
static const uint64_t P9N2_EQ_3_ERR_RPT1                                           = 0x13010C13ull;
//DUPS: 13010C13,
static const uint64_t P9N2_EQ_4_ERR_RPT1                                           = 0x14010C13ull;
//DUPS: 14010C13,
static const uint64_t P9N2_EQ_5_ERR_RPT1                                           = 0x15010C13ull;
//DUPS: 15010C13,
static const uint64_t P9N2_EX_0_L2_ERR_RPT1                                        = 0x10010813ull;

static const uint64_t P9N2_EX_10_L2_ERR_RPT1                                       = 0x15010813ull;

static const uint64_t P9N2_EX_11_L2_ERR_RPT1                                       = 0x15010C13ull;

static const uint64_t P9N2_EX_1_L2_ERR_RPT1                                        = 0x10010C13ull;

static const uint64_t P9N2_EX_2_L2_ERR_RPT1                                        = 0x11010813ull;

static const uint64_t P9N2_EX_3_L2_ERR_RPT1                                        = 0x11010C13ull;

static const uint64_t P9N2_EX_4_L2_ERR_RPT1                                        = 0x12010813ull;

static const uint64_t P9N2_EX_5_L2_ERR_RPT1                                        = 0x12010C13ull;

static const uint64_t P9N2_EX_6_L2_ERR_RPT1                                        = 0x13010813ull;

static const uint64_t P9N2_EX_7_L2_ERR_RPT1                                        = 0x13010C13ull;

static const uint64_t P9N2_EX_8_L2_ERR_RPT1                                        = 0x14010813ull;

static const uint64_t P9N2_EX_9_L2_ERR_RPT1                                        = 0x14010C13ull;

static const uint64_t P9N2_EX_L2_ERR_RPT1                                          = 0x10010813ull;


static const uint64_t P9N2_EQ_ERR_RPT_REG                                          = 0x1001100Eull;
//DUPS: 1001140E,
static const uint64_t P9N2_EQ_0_ERR_RPT_REG                                        = 0x1001100Eull;
//DUPS: 1001140E,
static const uint64_t P9N2_EQ_1_ERR_RPT_REG                                        = 0x1101100Eull;
//DUPS: 1101140E,
static const uint64_t P9N2_EQ_2_ERR_RPT_REG                                        = 0x1201100Eull;
//DUPS: 1201140E,
static const uint64_t P9N2_EQ_3_ERR_RPT_REG                                        = 0x1301100Eull;
//DUPS: 1301140E,
static const uint64_t P9N2_EQ_4_ERR_RPT_REG                                        = 0x1401100Eull;
//DUPS: 1401140E,
static const uint64_t P9N2_EQ_5_ERR_RPT_REG                                        = 0x1501100Eull;
//DUPS: 1501140E,
static const uint64_t P9N2_EX_ERR_RPT_REG                                          = 0x1001100Eull;

static const uint64_t P9N2_EX_0_ERR_RPT_REG                                        = 0x1001100Eull;

static const uint64_t P9N2_EX_1_ERR_RPT_REG                                        = 0x1001140Eull;

static const uint64_t P9N2_EX_2_ERR_RPT_REG                                        = 0x1101100Eull;

static const uint64_t P9N2_EX_3_ERR_RPT_REG                                        = 0x1101140Eull;

static const uint64_t P9N2_EX_4_ERR_RPT_REG                                        = 0x1201100Eull;

static const uint64_t P9N2_EX_5_ERR_RPT_REG                                        = 0x1201140Eull;

static const uint64_t P9N2_EX_6_ERR_RPT_REG                                        = 0x1301100Eull;

static const uint64_t P9N2_EX_7_ERR_RPT_REG                                        = 0x1301140Eull;

static const uint64_t P9N2_EX_8_ERR_RPT_REG                                        = 0x1401100Eull;

static const uint64_t P9N2_EX_9_ERR_RPT_REG                                        = 0x1401140Eull;

static const uint64_t P9N2_EX_10_ERR_RPT_REG                                       = 0x1501100Eull;

static const uint64_t P9N2_EX_11_ERR_RPT_REG                                       = 0x1501140Eull;


static const uint64_t P9N2_C_ERR_STATUS_REG                                        = 0x20050013ull;

static const uint64_t P9N2_C_0_ERR_STATUS_REG                                      = 0x20050013ull;

static const uint64_t P9N2_C_1_ERR_STATUS_REG                                      = 0x21050013ull;

static const uint64_t P9N2_C_2_ERR_STATUS_REG                                      = 0x22050013ull;

static const uint64_t P9N2_C_3_ERR_STATUS_REG                                      = 0x23050013ull;

static const uint64_t P9N2_C_4_ERR_STATUS_REG                                      = 0x24050013ull;

static const uint64_t P9N2_C_5_ERR_STATUS_REG                                      = 0x25050013ull;

static const uint64_t P9N2_C_6_ERR_STATUS_REG                                      = 0x26050013ull;

static const uint64_t P9N2_C_7_ERR_STATUS_REG                                      = 0x27050013ull;

static const uint64_t P9N2_C_8_ERR_STATUS_REG                                      = 0x28050013ull;

static const uint64_t P9N2_C_9_ERR_STATUS_REG                                      = 0x29050013ull;

static const uint64_t P9N2_C_10_ERR_STATUS_REG                                     = 0x2A050013ull;

static const uint64_t P9N2_C_11_ERR_STATUS_REG                                     = 0x2B050013ull;

static const uint64_t P9N2_C_12_ERR_STATUS_REG                                     = 0x2C050013ull;

static const uint64_t P9N2_C_13_ERR_STATUS_REG                                     = 0x2D050013ull;

static const uint64_t P9N2_C_14_ERR_STATUS_REG                                     = 0x2E050013ull;

static const uint64_t P9N2_C_15_ERR_STATUS_REG                                     = 0x2F050013ull;

static const uint64_t P9N2_C_16_ERR_STATUS_REG                                     = 0x30050013ull;

static const uint64_t P9N2_C_17_ERR_STATUS_REG                                     = 0x31050013ull;

static const uint64_t P9N2_C_18_ERR_STATUS_REG                                     = 0x32050013ull;

static const uint64_t P9N2_C_19_ERR_STATUS_REG                                     = 0x33050013ull;

static const uint64_t P9N2_C_20_ERR_STATUS_REG                                     = 0x34050013ull;

static const uint64_t P9N2_C_21_ERR_STATUS_REG                                     = 0x35050013ull;

static const uint64_t P9N2_C_22_ERR_STATUS_REG                                     = 0x36050013ull;

static const uint64_t P9N2_C_23_ERR_STATUS_REG                                     = 0x37050013ull;

static const uint64_t P9N2_EQ_ERR_STATUS_REG                                       = 0x10050013ull;

static const uint64_t P9N2_EQ_0_ERR_STATUS_REG                                     = 0x10050013ull;

static const uint64_t P9N2_EQ_1_ERR_STATUS_REG                                     = 0x11050013ull;

static const uint64_t P9N2_EQ_2_ERR_STATUS_REG                                     = 0x12050013ull;

static const uint64_t P9N2_EQ_3_ERR_STATUS_REG                                     = 0x13050013ull;

static const uint64_t P9N2_EQ_4_ERR_STATUS_REG                                     = 0x14050013ull;

static const uint64_t P9N2_EQ_5_ERR_STATUS_REG                                     = 0x15050013ull;

static const uint64_t P9N2_EX_ERR_STATUS_REG                                       = 0x20050013ull;
//DUPS: 21050013,
static const uint64_t P9N2_EX_0_ERR_STATUS_REG                                     = 0x20050013ull;
//DUPS: 21050013,
static const uint64_t P9N2_EX_1_ERR_STATUS_REG                                     = 0x22050013ull;
//DUPS: 23050013,
static const uint64_t P9N2_EX_2_ERR_STATUS_REG                                     = 0x24050013ull;
//DUPS: 25050013,
static const uint64_t P9N2_EX_3_ERR_STATUS_REG                                     = 0x26050013ull;
//DUPS: 27050013,
static const uint64_t P9N2_EX_4_ERR_STATUS_REG                                     = 0x28050013ull;
//DUPS: 29050013,
static const uint64_t P9N2_EX_5_ERR_STATUS_REG                                     = 0x2A050013ull;
//DUPS: 2B050013,
static const uint64_t P9N2_EX_6_ERR_STATUS_REG                                     = 0x2C050013ull;
//DUPS: 2D050013,
static const uint64_t P9N2_EX_7_ERR_STATUS_REG                                     = 0x2F050013ull;
//DUPS: 2F050013,
static const uint64_t P9N2_EX_8_ERR_STATUS_REG                                     = 0x30050013ull;
//DUPS: 31050013,
static const uint64_t P9N2_EX_9_ERR_STATUS_REG                                     = 0x32050013ull;
//DUPS: 33050013,
static const uint64_t P9N2_EX_10_ERR_STATUS_REG                                    = 0x34050013ull;
//DUPS: 35050013,
static const uint64_t P9N2_EX_11_ERR_STATUS_REG                                    = 0x36050013ull;
//DUPS: 37050013,

static const uint64_t P9N2_EQ_FIR_ACTION0_REG                                      = 0x10010C06ull;
//DUPS: 10011806, 10011006, 10010C06, 10011C06, 10011406,
static const uint64_t P9N2_EQ_0_FIR_ACTION0_REG                                    = 0x10010C06ull;
//DUPS: 10011806, 10011006, 10010C06, 10011C06, 10011406,
static const uint64_t P9N2_EQ_1_FIR_ACTION0_REG                                    = 0x11010C06ull;
//DUPS: 11011806, 11011006, 11010C06, 11011C06, 11011406,
static const uint64_t P9N2_EQ_2_FIR_ACTION0_REG                                    = 0x12010C06ull;
//DUPS: 12011806, 12011006, 12010C06, 12011C06, 12011406,
static const uint64_t P9N2_EQ_3_FIR_ACTION0_REG                                    = 0x13010C06ull;
//DUPS: 13011806, 13011006, 13010C06, 13011C06, 13011406,
static const uint64_t P9N2_EQ_4_FIR_ACTION0_REG                                    = 0x14010C06ull;
//DUPS: 14011806, 14011006, 14010C06, 14011C06, 14011406,
static const uint64_t P9N2_EQ_5_FIR_ACTION0_REG                                    = 0x15010C06ull;
//DUPS: 15011806, 15011006, 15010C06, 15011C06, 15011406,
static const uint64_t P9N2_EX_FIR_ACTION0_REG                                      = 0x10011006ull;

static const uint64_t P9N2_EX_0_FIR_ACTION0_REG                                    = 0x10011006ull;

static const uint64_t P9N2_EX_1_FIR_ACTION0_REG                                    = 0x10011406ull;

static const uint64_t P9N2_EX_2_FIR_ACTION0_REG                                    = 0x11011006ull;

static const uint64_t P9N2_EX_3_FIR_ACTION0_REG                                    = 0x11011406ull;

static const uint64_t P9N2_EX_4_FIR_ACTION0_REG                                    = 0x12011006ull;

static const uint64_t P9N2_EX_5_FIR_ACTION0_REG                                    = 0x12011406ull;

static const uint64_t P9N2_EX_6_FIR_ACTION0_REG                                    = 0x13011006ull;

static const uint64_t P9N2_EX_7_FIR_ACTION0_REG                                    = 0x13011406ull;

static const uint64_t P9N2_EX_8_FIR_ACTION0_REG                                    = 0x14011006ull;

static const uint64_t P9N2_EX_9_FIR_ACTION0_REG                                    = 0x14011406ull;

static const uint64_t P9N2_EX_0_L2_FIR_ACTION0_REG                                 = 0x10010806ull;

static const uint64_t P9N2_EX_0_L3_FIR_ACTION0_REG                                 = 0x10011806ull;

static const uint64_t P9N2_EX_10_FIR_ACTION0_REG                                   = 0x15011006ull;

static const uint64_t P9N2_EX_11_FIR_ACTION0_REG                                   = 0x15011406ull;

static const uint64_t P9N2_EX_10_L2_FIR_ACTION0_REG                                = 0x15010806ull;

static const uint64_t P9N2_EX_10_L3_FIR_ACTION0_REG                                = 0x15011806ull;

static const uint64_t P9N2_EX_11_L2_FIR_ACTION0_REG                                = 0x15010C06ull;

static const uint64_t P9N2_EX_11_L3_FIR_ACTION0_REG                                = 0x15011C06ull;

static const uint64_t P9N2_EX_1_L2_FIR_ACTION0_REG                                 = 0x10010C06ull;

static const uint64_t P9N2_EX_1_L3_FIR_ACTION0_REG                                 = 0x10011C06ull;

static const uint64_t P9N2_EX_2_L2_FIR_ACTION0_REG                                 = 0x11010806ull;

static const uint64_t P9N2_EX_2_L3_FIR_ACTION0_REG                                 = 0x11011806ull;

static const uint64_t P9N2_EX_3_L2_FIR_ACTION0_REG                                 = 0x11010C06ull;

static const uint64_t P9N2_EX_3_L3_FIR_ACTION0_REG                                 = 0x11011C06ull;

static const uint64_t P9N2_EX_4_L2_FIR_ACTION0_REG                                 = 0x12010806ull;

static const uint64_t P9N2_EX_4_L3_FIR_ACTION0_REG                                 = 0x12011806ull;

static const uint64_t P9N2_EX_5_L2_FIR_ACTION0_REG                                 = 0x12010C06ull;

static const uint64_t P9N2_EX_5_L3_FIR_ACTION0_REG                                 = 0x12011C06ull;

static const uint64_t P9N2_EX_6_L2_FIR_ACTION0_REG                                 = 0x13010806ull;

static const uint64_t P9N2_EX_6_L3_FIR_ACTION0_REG                                 = 0x13011806ull;

static const uint64_t P9N2_EX_7_L2_FIR_ACTION0_REG                                 = 0x13010C06ull;

static const uint64_t P9N2_EX_7_L3_FIR_ACTION0_REG                                 = 0x13011C06ull;

static const uint64_t P9N2_EX_8_L2_FIR_ACTION0_REG                                 = 0x14010806ull;

static const uint64_t P9N2_EX_8_L3_FIR_ACTION0_REG                                 = 0x14011806ull;

static const uint64_t P9N2_EX_9_L2_FIR_ACTION0_REG                                 = 0x14010C06ull;

static const uint64_t P9N2_EX_9_L3_FIR_ACTION0_REG                                 = 0x14011C06ull;

static const uint64_t P9N2_EX_L2_FIR_ACTION0_REG                                   = 0x10010806ull;

static const uint64_t P9N2_EX_L3_FIR_ACTION0_REG                                   = 0x10011806ull;


static const uint64_t P9N2_EQ_FIR_ACTION1_REG                                      = 0x10010C07ull;
//DUPS: 10011807, 10011007, 10010C07, 10011C07, 10011407,
static const uint64_t P9N2_EQ_0_FIR_ACTION1_REG                                    = 0x10010C07ull;
//DUPS: 10011807, 10011007, 10010C07, 10011C07, 10011407,
static const uint64_t P9N2_EQ_1_FIR_ACTION1_REG                                    = 0x11010C07ull;
//DUPS: 11011807, 11011007, 11010C07, 11011C07, 11011407,
static const uint64_t P9N2_EQ_2_FIR_ACTION1_REG                                    = 0x12010C07ull;
//DUPS: 12011807, 12011007, 12010C07, 12011C07, 12011407,
static const uint64_t P9N2_EQ_3_FIR_ACTION1_REG                                    = 0x13010C07ull;
//DUPS: 13011807, 13011007, 13010C07, 13011C07, 13011407,
static const uint64_t P9N2_EQ_4_FIR_ACTION1_REG                                    = 0x14010C07ull;
//DUPS: 14011807, 14011007, 14010C07, 14011C07, 14011407,
static const uint64_t P9N2_EQ_5_FIR_ACTION1_REG                                    = 0x15010C07ull;
//DUPS: 15011807, 15011007, 15010C07, 15011C07, 15011407,
static const uint64_t P9N2_EX_FIR_ACTION1_REG                                      = 0x10011007ull;

static const uint64_t P9N2_EX_0_FIR_ACTION1_REG                                    = 0x10011007ull;

static const uint64_t P9N2_EX_1_FIR_ACTION1_REG                                    = 0x10011407ull;

static const uint64_t P9N2_EX_2_FIR_ACTION1_REG                                    = 0x11011007ull;

static const uint64_t P9N2_EX_3_FIR_ACTION1_REG                                    = 0x11011407ull;

static const uint64_t P9N2_EX_4_FIR_ACTION1_REG                                    = 0x12011007ull;

static const uint64_t P9N2_EX_5_FIR_ACTION1_REG                                    = 0x12011407ull;

static const uint64_t P9N2_EX_6_FIR_ACTION1_REG                                    = 0x13011007ull;

static const uint64_t P9N2_EX_7_FIR_ACTION1_REG                                    = 0x13011407ull;

static const uint64_t P9N2_EX_8_FIR_ACTION1_REG                                    = 0x14011007ull;

static const uint64_t P9N2_EX_9_FIR_ACTION1_REG                                    = 0x14011407ull;

static const uint64_t P9N2_EX_0_L2_FIR_ACTION1_REG                                 = 0x10010807ull;

static const uint64_t P9N2_EX_0_L3_FIR_ACTION1_REG                                 = 0x10011807ull;

static const uint64_t P9N2_EX_10_FIR_ACTION1_REG                                   = 0x15011007ull;

static const uint64_t P9N2_EX_11_FIR_ACTION1_REG                                   = 0x15011407ull;

static const uint64_t P9N2_EX_10_L2_FIR_ACTION1_REG                                = 0x15010807ull;

static const uint64_t P9N2_EX_10_L3_FIR_ACTION1_REG                                = 0x15011807ull;

static const uint64_t P9N2_EX_11_L2_FIR_ACTION1_REG                                = 0x15010C07ull;

static const uint64_t P9N2_EX_11_L3_FIR_ACTION1_REG                                = 0x15011C07ull;

static const uint64_t P9N2_EX_1_L2_FIR_ACTION1_REG                                 = 0x10010C07ull;

static const uint64_t P9N2_EX_1_L3_FIR_ACTION1_REG                                 = 0x10011C07ull;

static const uint64_t P9N2_EX_2_L2_FIR_ACTION1_REG                                 = 0x11010807ull;

static const uint64_t P9N2_EX_2_L3_FIR_ACTION1_REG                                 = 0x11011807ull;

static const uint64_t P9N2_EX_3_L2_FIR_ACTION1_REG                                 = 0x11010C07ull;

static const uint64_t P9N2_EX_3_L3_FIR_ACTION1_REG                                 = 0x11011C07ull;

static const uint64_t P9N2_EX_4_L2_FIR_ACTION1_REG                                 = 0x12010807ull;

static const uint64_t P9N2_EX_4_L3_FIR_ACTION1_REG                                 = 0x12011807ull;

static const uint64_t P9N2_EX_5_L2_FIR_ACTION1_REG                                 = 0x12010C07ull;

static const uint64_t P9N2_EX_5_L3_FIR_ACTION1_REG                                 = 0x12011C07ull;

static const uint64_t P9N2_EX_6_L2_FIR_ACTION1_REG                                 = 0x13010807ull;

static const uint64_t P9N2_EX_6_L3_FIR_ACTION1_REG                                 = 0x13011807ull;

static const uint64_t P9N2_EX_7_L2_FIR_ACTION1_REG                                 = 0x13010C07ull;

static const uint64_t P9N2_EX_7_L3_FIR_ACTION1_REG                                 = 0x13011C07ull;

static const uint64_t P9N2_EX_8_L2_FIR_ACTION1_REG                                 = 0x14010807ull;

static const uint64_t P9N2_EX_8_L3_FIR_ACTION1_REG                                 = 0x14011807ull;

static const uint64_t P9N2_EX_9_L2_FIR_ACTION1_REG                                 = 0x14010C07ull;

static const uint64_t P9N2_EX_9_L3_FIR_ACTION1_REG                                 = 0x14011C07ull;

static const uint64_t P9N2_EX_L2_FIR_ACTION1_REG                                   = 0x10010807ull;

static const uint64_t P9N2_EX_L3_FIR_ACTION1_REG                                   = 0x10011807ull;


static const uint64_t P9N2_C_FIR_ERR_INJ                                           = 0x20010A4Dull;

static const uint64_t P9N2_C_0_FIR_ERR_INJ                                         = 0x20010A4Dull;

static const uint64_t P9N2_C_1_FIR_ERR_INJ                                         = 0x21010A4Dull;

static const uint64_t P9N2_C_2_FIR_ERR_INJ                                         = 0x22010A4Dull;

static const uint64_t P9N2_C_3_FIR_ERR_INJ                                         = 0x23010A4Dull;

static const uint64_t P9N2_C_4_FIR_ERR_INJ                                         = 0x24010A4Dull;

static const uint64_t P9N2_C_5_FIR_ERR_INJ                                         = 0x25010A4Dull;

static const uint64_t P9N2_C_6_FIR_ERR_INJ                                         = 0x26010A4Dull;

static const uint64_t P9N2_C_7_FIR_ERR_INJ                                         = 0x27010A4Dull;

static const uint64_t P9N2_C_8_FIR_ERR_INJ                                         = 0x28010A4Dull;

static const uint64_t P9N2_C_9_FIR_ERR_INJ                                         = 0x29010A4Dull;

static const uint64_t P9N2_C_10_FIR_ERR_INJ                                        = 0x2A010A4Dull;

static const uint64_t P9N2_C_11_FIR_ERR_INJ                                        = 0x2B010A4Dull;

static const uint64_t P9N2_C_12_FIR_ERR_INJ                                        = 0x2C010A4Dull;

static const uint64_t P9N2_C_13_FIR_ERR_INJ                                        = 0x2D010A4Dull;

static const uint64_t P9N2_C_14_FIR_ERR_INJ                                        = 0x2E010A4Dull;

static const uint64_t P9N2_C_15_FIR_ERR_INJ                                        = 0x2F010A4Dull;

static const uint64_t P9N2_C_16_FIR_ERR_INJ                                        = 0x30010A4Dull;

static const uint64_t P9N2_C_17_FIR_ERR_INJ                                        = 0x31010A4Dull;

static const uint64_t P9N2_C_18_FIR_ERR_INJ                                        = 0x32010A4Dull;

static const uint64_t P9N2_C_19_FIR_ERR_INJ                                        = 0x33010A4Dull;

static const uint64_t P9N2_C_20_FIR_ERR_INJ                                        = 0x34010A4Dull;

static const uint64_t P9N2_C_21_FIR_ERR_INJ                                        = 0x35010A4Dull;

static const uint64_t P9N2_C_22_FIR_ERR_INJ                                        = 0x36010A4Dull;

static const uint64_t P9N2_C_23_FIR_ERR_INJ                                        = 0x37010A4Dull;

static const uint64_t P9N2_EX_0_L2_FIR_ERR_INJ                                     = 0x20010A4Dull;
//DUPS: 21010A4D,
static const uint64_t P9N2_EX_10_L2_FIR_ERR_INJ                                    = 0x34010A4Dull;
//DUPS: 35010A4D,
static const uint64_t P9N2_EX_11_L2_FIR_ERR_INJ                                    = 0x36010A4Dull;
//DUPS: 37010A4D,
static const uint64_t P9N2_EX_1_L2_FIR_ERR_INJ                                     = 0x22010A4Dull;
//DUPS: 23010A4D,
static const uint64_t P9N2_EX_2_L2_FIR_ERR_INJ                                     = 0x24010A4Dull;
//DUPS: 25010A4D,
static const uint64_t P9N2_EX_3_L2_FIR_ERR_INJ                                     = 0x26010A4Dull;
//DUPS: 27010A4D,
static const uint64_t P9N2_EX_4_L2_FIR_ERR_INJ                                     = 0x28010A4Dull;
//DUPS: 29010A4D,
static const uint64_t P9N2_EX_5_L2_FIR_ERR_INJ                                     = 0x2A010A4Dull;
//DUPS: 2B010A4D,
static const uint64_t P9N2_EX_6_L2_FIR_ERR_INJ                                     = 0x2C010A4Dull;
//DUPS: 2D010A4D,
static const uint64_t P9N2_EX_7_L2_FIR_ERR_INJ                                     = 0x2F010A4Dull;
//DUPS: 2F010A4D,
static const uint64_t P9N2_EX_8_L2_FIR_ERR_INJ                                     = 0x30010A4Dull;
//DUPS: 31010A4D,
static const uint64_t P9N2_EX_9_L2_FIR_ERR_INJ                                     = 0x32010A4Dull;
//DUPS: 33010A4D,
static const uint64_t P9N2_EX_L2_FIR_ERR_INJ                                       = 0x20010A4Dull;
//DUPS: 21010A4D,

static const uint64_t P9N2_C_FIR_HOLD_OUT                                          = 0x20010A51ull;

static const uint64_t P9N2_C_0_FIR_HOLD_OUT                                        = 0x20010A51ull;

static const uint64_t P9N2_C_1_FIR_HOLD_OUT                                        = 0x21010A51ull;

static const uint64_t P9N2_C_2_FIR_HOLD_OUT                                        = 0x22010A51ull;

static const uint64_t P9N2_C_3_FIR_HOLD_OUT                                        = 0x23010A51ull;

static const uint64_t P9N2_C_4_FIR_HOLD_OUT                                        = 0x24010A51ull;

static const uint64_t P9N2_C_5_FIR_HOLD_OUT                                        = 0x25010A51ull;

static const uint64_t P9N2_C_6_FIR_HOLD_OUT                                        = 0x26010A51ull;

static const uint64_t P9N2_C_7_FIR_HOLD_OUT                                        = 0x27010A51ull;

static const uint64_t P9N2_C_8_FIR_HOLD_OUT                                        = 0x28010A51ull;

static const uint64_t P9N2_C_9_FIR_HOLD_OUT                                        = 0x29010A51ull;

static const uint64_t P9N2_C_10_FIR_HOLD_OUT                                       = 0x2A010A51ull;

static const uint64_t P9N2_C_11_FIR_HOLD_OUT                                       = 0x2B010A51ull;

static const uint64_t P9N2_C_12_FIR_HOLD_OUT                                       = 0x2C010A51ull;

static const uint64_t P9N2_C_13_FIR_HOLD_OUT                                       = 0x2D010A51ull;

static const uint64_t P9N2_C_14_FIR_HOLD_OUT                                       = 0x2E010A51ull;

static const uint64_t P9N2_C_15_FIR_HOLD_OUT                                       = 0x2F010A51ull;

static const uint64_t P9N2_C_16_FIR_HOLD_OUT                                       = 0x30010A51ull;

static const uint64_t P9N2_C_17_FIR_HOLD_OUT                                       = 0x31010A51ull;

static const uint64_t P9N2_C_18_FIR_HOLD_OUT                                       = 0x32010A51ull;

static const uint64_t P9N2_C_19_FIR_HOLD_OUT                                       = 0x33010A51ull;

static const uint64_t P9N2_C_20_FIR_HOLD_OUT                                       = 0x34010A51ull;

static const uint64_t P9N2_C_21_FIR_HOLD_OUT                                       = 0x35010A51ull;

static const uint64_t P9N2_C_22_FIR_HOLD_OUT                                       = 0x36010A51ull;

static const uint64_t P9N2_C_23_FIR_HOLD_OUT                                       = 0x37010A51ull;

static const uint64_t P9N2_EX_0_L2_FIR_HOLD_OUT                                    = 0x20010A51ull;
//DUPS: 21010A51,
static const uint64_t P9N2_EX_10_L2_FIR_HOLD_OUT                                   = 0x34010A51ull;
//DUPS: 35010A51,
static const uint64_t P9N2_EX_11_L2_FIR_HOLD_OUT                                   = 0x36010A51ull;
//DUPS: 37010A51,
static const uint64_t P9N2_EX_1_L2_FIR_HOLD_OUT                                    = 0x22010A51ull;
//DUPS: 23010A51,
static const uint64_t P9N2_EX_2_L2_FIR_HOLD_OUT                                    = 0x24010A51ull;
//DUPS: 25010A51,
static const uint64_t P9N2_EX_3_L2_FIR_HOLD_OUT                                    = 0x26010A51ull;
//DUPS: 27010A51,
static const uint64_t P9N2_EX_4_L2_FIR_HOLD_OUT                                    = 0x28010A51ull;
//DUPS: 29010A51,
static const uint64_t P9N2_EX_5_L2_FIR_HOLD_OUT                                    = 0x2A010A51ull;
//DUPS: 2B010A51,
static const uint64_t P9N2_EX_6_L2_FIR_HOLD_OUT                                    = 0x2C010A51ull;
//DUPS: 2D010A51,
static const uint64_t P9N2_EX_7_L2_FIR_HOLD_OUT                                    = 0x2F010A51ull;
//DUPS: 2F010A51,
static const uint64_t P9N2_EX_8_L2_FIR_HOLD_OUT                                    = 0x30010A51ull;
//DUPS: 31010A51,
static const uint64_t P9N2_EX_9_L2_FIR_HOLD_OUT                                    = 0x32010A51ull;
//DUPS: 33010A51,
static const uint64_t P9N2_EX_L2_FIR_HOLD_OUT                                      = 0x20010A51ull;
//DUPS: 21010A51,

static const uint64_t P9N2_C_FIR_MASK                                              = 0x20040002ull;

static const uint64_t P9N2_C_0_FIR_MASK                                            = 0x20040002ull;

static const uint64_t P9N2_C_1_FIR_MASK                                            = 0x21040002ull;

static const uint64_t P9N2_C_2_FIR_MASK                                            = 0x22040002ull;

static const uint64_t P9N2_C_3_FIR_MASK                                            = 0x23040002ull;

static const uint64_t P9N2_C_4_FIR_MASK                                            = 0x24040002ull;

static const uint64_t P9N2_C_5_FIR_MASK                                            = 0x25040002ull;

static const uint64_t P9N2_C_6_FIR_MASK                                            = 0x26040002ull;

static const uint64_t P9N2_C_7_FIR_MASK                                            = 0x27040002ull;

static const uint64_t P9N2_C_8_FIR_MASK                                            = 0x28040002ull;

static const uint64_t P9N2_C_9_FIR_MASK                                            = 0x29040002ull;

static const uint64_t P9N2_C_10_FIR_MASK                                           = 0x2A040002ull;

static const uint64_t P9N2_C_11_FIR_MASK                                           = 0x2B040002ull;

static const uint64_t P9N2_C_12_FIR_MASK                                           = 0x2C040002ull;

static const uint64_t P9N2_C_13_FIR_MASK                                           = 0x2D040002ull;

static const uint64_t P9N2_C_14_FIR_MASK                                           = 0x2E040002ull;

static const uint64_t P9N2_C_15_FIR_MASK                                           = 0x2F040002ull;

static const uint64_t P9N2_C_16_FIR_MASK                                           = 0x30040002ull;

static const uint64_t P9N2_C_17_FIR_MASK                                           = 0x31040002ull;

static const uint64_t P9N2_C_18_FIR_MASK                                           = 0x32040002ull;

static const uint64_t P9N2_C_19_FIR_MASK                                           = 0x33040002ull;

static const uint64_t P9N2_C_20_FIR_MASK                                           = 0x34040002ull;

static const uint64_t P9N2_C_21_FIR_MASK                                           = 0x35040002ull;

static const uint64_t P9N2_C_22_FIR_MASK                                           = 0x36040002ull;

static const uint64_t P9N2_C_23_FIR_MASK                                           = 0x37040002ull;

static const uint64_t P9N2_EQ_FIR_MASK                                             = 0x10040002ull;

static const uint64_t P9N2_EQ_0_FIR_MASK                                           = 0x10040002ull;

static const uint64_t P9N2_EQ_1_FIR_MASK                                           = 0x11040002ull;

static const uint64_t P9N2_EQ_2_FIR_MASK                                           = 0x12040002ull;

static const uint64_t P9N2_EQ_3_FIR_MASK                                           = 0x13040002ull;

static const uint64_t P9N2_EQ_4_FIR_MASK                                           = 0x14040002ull;

static const uint64_t P9N2_EQ_5_FIR_MASK                                           = 0x15040002ull;

static const uint64_t P9N2_EX_FIR_MASK                                             = 0x20040002ull;
//DUPS: 21040002,
static const uint64_t P9N2_EX_0_FIR_MASK                                           = 0x20040002ull;
//DUPS: 21040002,
static const uint64_t P9N2_EX_1_FIR_MASK                                           = 0x22040002ull;
//DUPS: 23040002,
static const uint64_t P9N2_EX_2_FIR_MASK                                           = 0x24040002ull;
//DUPS: 25040002,
static const uint64_t P9N2_EX_3_FIR_MASK                                           = 0x26040002ull;
//DUPS: 27040002,
static const uint64_t P9N2_EX_4_FIR_MASK                                           = 0x28040002ull;
//DUPS: 29040002,
static const uint64_t P9N2_EX_5_FIR_MASK                                           = 0x2A040002ull;
//DUPS: 2B040002,
static const uint64_t P9N2_EX_6_FIR_MASK                                           = 0x2C040002ull;
//DUPS: 2D040002,
static const uint64_t P9N2_EX_7_FIR_MASK                                           = 0x2F040002ull;
//DUPS: 2F040002,
static const uint64_t P9N2_EX_8_FIR_MASK                                           = 0x30040002ull;
//DUPS: 31040002,
static const uint64_t P9N2_EX_9_FIR_MASK                                           = 0x32040002ull;
//DUPS: 33040002,
static const uint64_t P9N2_EX_10_FIR_MASK                                          = 0x34040002ull;
//DUPS: 35040002,
static const uint64_t P9N2_EX_11_FIR_MASK                                          = 0x36040002ull;
//DUPS: 37040002,

static const uint64_t P9N2_EQ_FIR_MASK_REG                                         = 0x10010C03ull;
//DUPS: 10011803, 10011003, 10010C03, 10011C03, 10011403,
static const uint64_t P9N2_EQ_FIR_MASK_REG_AND                                     = 0x10010C04ull;
//DUPS: 10011804, 10011004, 10010C04, 10011C04, 10011404,
static const uint64_t P9N2_EQ_FIR_MASK_REG_OR                                      = 0x10010C05ull;
//DUPS: 10011805, 10011005, 10010C05, 10011C05, 10011405,
static const uint64_t P9N2_EQ_0_FIR_MASK_REG                                       = 0x10010C03ull;
//DUPS: 10011803, 10011003, 10010C03, 10011C03, 10011403,
static const uint64_t P9N2_EQ_0_FIR_MASK_REG_AND                                   = 0x10010C04ull;
//DUPS: 10011804, 10011004, 10010C04, 10011C04, 10011404,
static const uint64_t P9N2_EQ_0_FIR_MASK_REG_OR                                    = 0x10010C05ull;
//DUPS: 10011805, 10011005, 10010C05, 10011C05, 10011405,
static const uint64_t P9N2_EQ_1_FIR_MASK_REG                                       = 0x11010C03ull;
//DUPS: 11011803, 11011003, 11010C03, 11011C03, 11011403,
static const uint64_t P9N2_EQ_1_FIR_MASK_REG_AND                                   = 0x11010C04ull;
//DUPS: 11011804, 11011004, 11010C04, 11011C04, 11011404,
static const uint64_t P9N2_EQ_1_FIR_MASK_REG_OR                                    = 0x11010C05ull;
//DUPS: 11011805, 11011005, 11010C05, 11011C05, 11011405,
static const uint64_t P9N2_EQ_2_FIR_MASK_REG                                       = 0x12010C03ull;
//DUPS: 12011803, 12011003, 12010C03, 12011C03, 12011403,
static const uint64_t P9N2_EQ_2_FIR_MASK_REG_AND                                   = 0x12010C04ull;
//DUPS: 12011804, 12011004, 12010C04, 12011C04, 12011404,
static const uint64_t P9N2_EQ_2_FIR_MASK_REG_OR                                    = 0x12010C05ull;
//DUPS: 12011805, 12011005, 12010C05, 12011C05, 12011405,
static const uint64_t P9N2_EQ_3_FIR_MASK_REG                                       = 0x13010C03ull;
//DUPS: 13011803, 13011003, 13010C03, 13011C03, 13011403,
static const uint64_t P9N2_EQ_3_FIR_MASK_REG_AND                                   = 0x13010C04ull;
//DUPS: 13011804, 13011004, 13010C04, 13011C04, 13011404,
static const uint64_t P9N2_EQ_3_FIR_MASK_REG_OR                                    = 0x13010C05ull;
//DUPS: 13011805, 13011005, 13010C05, 13011C05, 13011405,
static const uint64_t P9N2_EQ_4_FIR_MASK_REG                                       = 0x14010C03ull;
//DUPS: 14011803, 14011003, 14010C03, 14011C03, 14011403,
static const uint64_t P9N2_EQ_4_FIR_MASK_REG_AND                                   = 0x14010C04ull;
//DUPS: 14011804, 14011004, 14010C04, 14011C04, 14011404,
static const uint64_t P9N2_EQ_4_FIR_MASK_REG_OR                                    = 0x14010C05ull;
//DUPS: 14011805, 14011005, 14010C05, 14011C05, 14011405,
static const uint64_t P9N2_EQ_5_FIR_MASK_REG                                       = 0x15010C03ull;
//DUPS: 15011803, 15011003, 15010C03, 15011C03, 15011403,
static const uint64_t P9N2_EQ_5_FIR_MASK_REG_AND                                   = 0x15010C04ull;
//DUPS: 15011804, 15011004, 15010C04, 15011C04, 15011404,
static const uint64_t P9N2_EQ_5_FIR_MASK_REG_OR                                    = 0x15010C05ull;
//DUPS: 15011805, 15011005, 15010C05, 15011C05, 15011405,
static const uint64_t P9N2_EX_FIR_MASK_REG                                         = 0x10011003ull;

static const uint64_t P9N2_EX_FIR_MASK_REG_AND                                     = 0x10011004ull;

static const uint64_t P9N2_EX_FIR_MASK_REG_OR                                      = 0x10011005ull;

static const uint64_t P9N2_EX_0_FIR_MASK_REG                                       = 0x10011003ull;

static const uint64_t P9N2_EX_0_FIR_MASK_REG_AND                                   = 0x10011004ull;

static const uint64_t P9N2_EX_0_FIR_MASK_REG_OR                                    = 0x10011005ull;

static const uint64_t P9N2_EX_1_FIR_MASK_REG                                       = 0x10011403ull;

static const uint64_t P9N2_EX_1_FIR_MASK_REG_AND                                   = 0x10011404ull;

static const uint64_t P9N2_EX_1_FIR_MASK_REG_OR                                    = 0x10011405ull;

static const uint64_t P9N2_EX_2_FIR_MASK_REG                                       = 0x11011003ull;

static const uint64_t P9N2_EX_2_FIR_MASK_REG_AND                                   = 0x11011004ull;

static const uint64_t P9N2_EX_2_FIR_MASK_REG_OR                                    = 0x11011005ull;

static const uint64_t P9N2_EX_3_FIR_MASK_REG                                       = 0x11011403ull;

static const uint64_t P9N2_EX_3_FIR_MASK_REG_AND                                   = 0x11011404ull;

static const uint64_t P9N2_EX_3_FIR_MASK_REG_OR                                    = 0x11011405ull;

static const uint64_t P9N2_EX_4_FIR_MASK_REG                                       = 0x12011003ull;

static const uint64_t P9N2_EX_4_FIR_MASK_REG_AND                                   = 0x12011004ull;

static const uint64_t P9N2_EX_4_FIR_MASK_REG_OR                                    = 0x12011005ull;

static const uint64_t P9N2_EX_5_FIR_MASK_REG                                       = 0x12011403ull;

static const uint64_t P9N2_EX_5_FIR_MASK_REG_AND                                   = 0x12011404ull;

static const uint64_t P9N2_EX_5_FIR_MASK_REG_OR                                    = 0x12011405ull;

static const uint64_t P9N2_EX_6_FIR_MASK_REG                                       = 0x13011003ull;

static const uint64_t P9N2_EX_6_FIR_MASK_REG_AND                                   = 0x13011004ull;

static const uint64_t P9N2_EX_6_FIR_MASK_REG_OR                                    = 0x13011005ull;

static const uint64_t P9N2_EX_7_FIR_MASK_REG                                       = 0x13011403ull;

static const uint64_t P9N2_EX_7_FIR_MASK_REG_AND                                   = 0x13011404ull;

static const uint64_t P9N2_EX_7_FIR_MASK_REG_OR                                    = 0x13011405ull;

static const uint64_t P9N2_EX_8_FIR_MASK_REG                                       = 0x14011003ull;

static const uint64_t P9N2_EX_8_FIR_MASK_REG_AND                                   = 0x14011004ull;

static const uint64_t P9N2_EX_8_FIR_MASK_REG_OR                                    = 0x14011005ull;

static const uint64_t P9N2_EX_9_FIR_MASK_REG                                       = 0x14011403ull;

static const uint64_t P9N2_EX_9_FIR_MASK_REG_AND                                   = 0x14011404ull;

static const uint64_t P9N2_EX_9_FIR_MASK_REG_OR                                    = 0x14011405ull;

static const uint64_t P9N2_EX_0_L2_FIR_MASK_REG                                    = 0x10010803ull;

static const uint64_t P9N2_EX_0_L2_FIR_MASK_REG_AND                                = 0x10010804ull;

static const uint64_t P9N2_EX_0_L2_FIR_MASK_REG_OR                                 = 0x10010805ull;

static const uint64_t P9N2_EX_0_L3_FIR_MASK_REG                                    = 0x10011803ull;

static const uint64_t P9N2_EX_0_L3_FIR_MASK_REG_AND                                = 0x10011804ull;

static const uint64_t P9N2_EX_0_L3_FIR_MASK_REG_OR                                 = 0x10011805ull;

static const uint64_t P9N2_EX_10_FIR_MASK_REG                                      = 0x15011003ull;

static const uint64_t P9N2_EX_10_FIR_MASK_REG_AND                                  = 0x15011004ull;

static const uint64_t P9N2_EX_10_FIR_MASK_REG_OR                                   = 0x15011005ull;

static const uint64_t P9N2_EX_11_FIR_MASK_REG                                      = 0x15011403ull;

static const uint64_t P9N2_EX_11_FIR_MASK_REG_AND                                  = 0x15011404ull;

static const uint64_t P9N2_EX_11_FIR_MASK_REG_OR                                   = 0x15011405ull;

static const uint64_t P9N2_EX_10_L2_FIR_MASK_REG                                   = 0x15010803ull;

static const uint64_t P9N2_EX_10_L2_FIR_MASK_REG_AND                               = 0x15010804ull;

static const uint64_t P9N2_EX_10_L2_FIR_MASK_REG_OR                                = 0x15010805ull;

static const uint64_t P9N2_EX_10_L3_FIR_MASK_REG                                   = 0x15011803ull;

static const uint64_t P9N2_EX_10_L3_FIR_MASK_REG_AND                               = 0x15011804ull;

static const uint64_t P9N2_EX_10_L3_FIR_MASK_REG_OR                                = 0x15011805ull;

static const uint64_t P9N2_EX_11_L2_FIR_MASK_REG                                   = 0x15010C03ull;

static const uint64_t P9N2_EX_11_L2_FIR_MASK_REG_AND                               = 0x15010C04ull;

static const uint64_t P9N2_EX_11_L2_FIR_MASK_REG_OR                                = 0x15010C05ull;

static const uint64_t P9N2_EX_11_L3_FIR_MASK_REG                                   = 0x15011C03ull;

static const uint64_t P9N2_EX_11_L3_FIR_MASK_REG_AND                               = 0x15011C04ull;

static const uint64_t P9N2_EX_11_L3_FIR_MASK_REG_OR                                = 0x15011C05ull;

static const uint64_t P9N2_EX_1_L2_FIR_MASK_REG                                    = 0x10010C03ull;

static const uint64_t P9N2_EX_1_L2_FIR_MASK_REG_AND                                = 0x10010C04ull;

static const uint64_t P9N2_EX_1_L2_FIR_MASK_REG_OR                                 = 0x10010C05ull;

static const uint64_t P9N2_EX_1_L3_FIR_MASK_REG                                    = 0x10011C03ull;

static const uint64_t P9N2_EX_1_L3_FIR_MASK_REG_AND                                = 0x10011C04ull;

static const uint64_t P9N2_EX_1_L3_FIR_MASK_REG_OR                                 = 0x10011C05ull;

static const uint64_t P9N2_EX_2_L2_FIR_MASK_REG                                    = 0x11010803ull;

static const uint64_t P9N2_EX_2_L2_FIR_MASK_REG_AND                                = 0x11010804ull;

static const uint64_t P9N2_EX_2_L2_FIR_MASK_REG_OR                                 = 0x11010805ull;

static const uint64_t P9N2_EX_2_L3_FIR_MASK_REG                                    = 0x11011803ull;

static const uint64_t P9N2_EX_2_L3_FIR_MASK_REG_AND                                = 0x11011804ull;

static const uint64_t P9N2_EX_2_L3_FIR_MASK_REG_OR                                 = 0x11011805ull;

static const uint64_t P9N2_EX_3_L2_FIR_MASK_REG                                    = 0x11010C03ull;

static const uint64_t P9N2_EX_3_L2_FIR_MASK_REG_AND                                = 0x11010C04ull;

static const uint64_t P9N2_EX_3_L2_FIR_MASK_REG_OR                                 = 0x11010C05ull;

static const uint64_t P9N2_EX_3_L3_FIR_MASK_REG                                    = 0x11011C03ull;

static const uint64_t P9N2_EX_3_L3_FIR_MASK_REG_AND                                = 0x11011C04ull;

static const uint64_t P9N2_EX_3_L3_FIR_MASK_REG_OR                                 = 0x11011C05ull;

static const uint64_t P9N2_EX_4_L2_FIR_MASK_REG                                    = 0x12010803ull;

static const uint64_t P9N2_EX_4_L2_FIR_MASK_REG_AND                                = 0x12010804ull;

static const uint64_t P9N2_EX_4_L2_FIR_MASK_REG_OR                                 = 0x12010805ull;

static const uint64_t P9N2_EX_4_L3_FIR_MASK_REG                                    = 0x12011803ull;

static const uint64_t P9N2_EX_4_L3_FIR_MASK_REG_AND                                = 0x12011804ull;

static const uint64_t P9N2_EX_4_L3_FIR_MASK_REG_OR                                 = 0x12011805ull;

static const uint64_t P9N2_EX_5_L2_FIR_MASK_REG                                    = 0x12010C03ull;

static const uint64_t P9N2_EX_5_L2_FIR_MASK_REG_AND                                = 0x12010C04ull;

static const uint64_t P9N2_EX_5_L2_FIR_MASK_REG_OR                                 = 0x12010C05ull;

static const uint64_t P9N2_EX_5_L3_FIR_MASK_REG                                    = 0x12011C03ull;

static const uint64_t P9N2_EX_5_L3_FIR_MASK_REG_AND                                = 0x12011C04ull;

static const uint64_t P9N2_EX_5_L3_FIR_MASK_REG_OR                                 = 0x12011C05ull;

static const uint64_t P9N2_EX_6_L2_FIR_MASK_REG                                    = 0x13010803ull;

static const uint64_t P9N2_EX_6_L2_FIR_MASK_REG_AND                                = 0x13010804ull;

static const uint64_t P9N2_EX_6_L2_FIR_MASK_REG_OR                                 = 0x13010805ull;

static const uint64_t P9N2_EX_6_L3_FIR_MASK_REG                                    = 0x13011803ull;

static const uint64_t P9N2_EX_6_L3_FIR_MASK_REG_AND                                = 0x13011804ull;

static const uint64_t P9N2_EX_6_L3_FIR_MASK_REG_OR                                 = 0x13011805ull;

static const uint64_t P9N2_EX_7_L2_FIR_MASK_REG                                    = 0x13010C03ull;

static const uint64_t P9N2_EX_7_L2_FIR_MASK_REG_AND                                = 0x13010C04ull;

static const uint64_t P9N2_EX_7_L2_FIR_MASK_REG_OR                                 = 0x13010C05ull;

static const uint64_t P9N2_EX_7_L3_FIR_MASK_REG                                    = 0x13011C03ull;

static const uint64_t P9N2_EX_7_L3_FIR_MASK_REG_AND                                = 0x13011C04ull;

static const uint64_t P9N2_EX_7_L3_FIR_MASK_REG_OR                                 = 0x13011C05ull;

static const uint64_t P9N2_EX_8_L2_FIR_MASK_REG                                    = 0x14010803ull;

static const uint64_t P9N2_EX_8_L2_FIR_MASK_REG_AND                                = 0x14010804ull;

static const uint64_t P9N2_EX_8_L2_FIR_MASK_REG_OR                                 = 0x14010805ull;

static const uint64_t P9N2_EX_8_L3_FIR_MASK_REG                                    = 0x14011803ull;

static const uint64_t P9N2_EX_8_L3_FIR_MASK_REG_AND                                = 0x14011804ull;

static const uint64_t P9N2_EX_8_L3_FIR_MASK_REG_OR                                 = 0x14011805ull;

static const uint64_t P9N2_EX_9_L2_FIR_MASK_REG                                    = 0x14010C03ull;

static const uint64_t P9N2_EX_9_L2_FIR_MASK_REG_AND                                = 0x14010C04ull;

static const uint64_t P9N2_EX_9_L2_FIR_MASK_REG_OR                                 = 0x14010C05ull;

static const uint64_t P9N2_EX_9_L3_FIR_MASK_REG                                    = 0x14011C03ull;

static const uint64_t P9N2_EX_9_L3_FIR_MASK_REG_AND                                = 0x14011C04ull;

static const uint64_t P9N2_EX_9_L3_FIR_MASK_REG_OR                                 = 0x14011C05ull;

static const uint64_t P9N2_EX_L2_FIR_MASK_REG                                      = 0x10010803ull;

static const uint64_t P9N2_EX_L2_FIR_MASK_REG_AND                                  = 0x10010804ull;

static const uint64_t P9N2_EX_L2_FIR_MASK_REG_OR                                   = 0x10010805ull;

static const uint64_t P9N2_EX_L3_FIR_MASK_REG                                      = 0x10011803ull;

static const uint64_t P9N2_EX_L3_FIR_MASK_REG_AND                                  = 0x10011804ull;

static const uint64_t P9N2_EX_L3_FIR_MASK_REG_OR                                   = 0x10011805ull;


static const uint64_t P9N2_EQ_FIR_REG                                              = 0x10010C00ull;
//DUPS: 10011800, 10011000, 10010C00, 10011C00, 10011400,
static const uint64_t P9N2_EQ_FIR_REG_AND                                          = 0x10010C01ull;
//DUPS: 10011801, 10011001, 10010C01, 10011C01, 10011401,
static const uint64_t P9N2_EQ_FIR_REG_OR                                           = 0x10010C02ull;
//DUPS: 10011802, 10011002, 10010C02, 10011C02, 10011402,
static const uint64_t P9N2_EQ_0_FIR_REG                                            = 0x10010C00ull;
//DUPS: 10011800, 10011000, 10010C00, 10011C00, 10011400,
static const uint64_t P9N2_EQ_0_FIR_REG_AND                                        = 0x10010C01ull;
//DUPS: 10011801, 10011001, 10010C01, 10011C01, 10011401,
static const uint64_t P9N2_EQ_0_FIR_REG_OR                                         = 0x10010C02ull;
//DUPS: 10011802, 10011002, 10010C02, 10011C02, 10011402,
static const uint64_t P9N2_EQ_1_FIR_REG                                            = 0x11010C00ull;
//DUPS: 11011800, 11011000, 11010C00, 11011C00, 11011400,
static const uint64_t P9N2_EQ_1_FIR_REG_AND                                        = 0x11010C01ull;
//DUPS: 11011801, 11011001, 11010C01, 11011C01, 11011401,
static const uint64_t P9N2_EQ_1_FIR_REG_OR                                         = 0x11010C02ull;
//DUPS: 11011802, 11011002, 11010C02, 11011C02, 11011402,
static const uint64_t P9N2_EQ_2_FIR_REG                                            = 0x12010C00ull;
//DUPS: 12011800, 12011000, 12010C00, 12011C00, 12011400,
static const uint64_t P9N2_EQ_2_FIR_REG_AND                                        = 0x12010C01ull;
//DUPS: 12011801, 12011001, 12010C01, 12011C01, 12011401,
static const uint64_t P9N2_EQ_2_FIR_REG_OR                                         = 0x12010C02ull;
//DUPS: 12011802, 12011002, 12010C02, 12011C02, 12011402,
static const uint64_t P9N2_EQ_3_FIR_REG                                            = 0x13010C00ull;
//DUPS: 13011800, 13011000, 13010C00, 13011C00, 13011400,
static const uint64_t P9N2_EQ_3_FIR_REG_AND                                        = 0x13010C01ull;
//DUPS: 13011801, 13011001, 13010C01, 13011C01, 13011401,
static const uint64_t P9N2_EQ_3_FIR_REG_OR                                         = 0x13010C02ull;
//DUPS: 13011802, 13011002, 13010C02, 13011C02, 13011402,
static const uint64_t P9N2_EQ_4_FIR_REG                                            = 0x14010C00ull;
//DUPS: 14011800, 14011000, 14010C00, 14011C00, 14011400,
static const uint64_t P9N2_EQ_4_FIR_REG_AND                                        = 0x14010C01ull;
//DUPS: 14011801, 14011001, 14010C01, 14011C01, 14011401,
static const uint64_t P9N2_EQ_4_FIR_REG_OR                                         = 0x14010C02ull;
//DUPS: 14011802, 14011002, 14010C02, 14011C02, 14011402,
static const uint64_t P9N2_EQ_5_FIR_REG                                            = 0x15010C00ull;
//DUPS: 15011800, 15011000, 15010C00, 15011C00, 15011400,
static const uint64_t P9N2_EQ_5_FIR_REG_AND                                        = 0x15010C01ull;
//DUPS: 15011801, 15011001, 15010C01, 15011C01, 15011401,
static const uint64_t P9N2_EQ_5_FIR_REG_OR                                         = 0x15010C02ull;
//DUPS: 15011802, 15011002, 15010C02, 15011C02, 15011402,
static const uint64_t P9N2_EX_FIR_REG                                              = 0x10011000ull;

static const uint64_t P9N2_EX_FIR_REG_AND                                          = 0x10011001ull;

static const uint64_t P9N2_EX_FIR_REG_OR                                           = 0x10011002ull;

static const uint64_t P9N2_EX_0_FIR_REG                                            = 0x10011000ull;

static const uint64_t P9N2_EX_0_FIR_REG_AND                                        = 0x10011001ull;

static const uint64_t P9N2_EX_0_FIR_REG_OR                                         = 0x10011002ull;

static const uint64_t P9N2_EX_1_FIR_REG                                            = 0x10011400ull;

static const uint64_t P9N2_EX_1_FIR_REG_AND                                        = 0x10011401ull;

static const uint64_t P9N2_EX_1_FIR_REG_OR                                         = 0x10011402ull;

static const uint64_t P9N2_EX_2_FIR_REG                                            = 0x11011000ull;

static const uint64_t P9N2_EX_2_FIR_REG_AND                                        = 0x11011001ull;

static const uint64_t P9N2_EX_2_FIR_REG_OR                                         = 0x11011002ull;

static const uint64_t P9N2_EX_3_FIR_REG                                            = 0x11011400ull;

static const uint64_t P9N2_EX_3_FIR_REG_AND                                        = 0x11011401ull;

static const uint64_t P9N2_EX_3_FIR_REG_OR                                         = 0x11011402ull;

static const uint64_t P9N2_EX_4_FIR_REG                                            = 0x12011000ull;

static const uint64_t P9N2_EX_4_FIR_REG_AND                                        = 0x12011001ull;

static const uint64_t P9N2_EX_4_FIR_REG_OR                                         = 0x12011002ull;

static const uint64_t P9N2_EX_5_FIR_REG                                            = 0x12011400ull;

static const uint64_t P9N2_EX_5_FIR_REG_AND                                        = 0x12011401ull;

static const uint64_t P9N2_EX_5_FIR_REG_OR                                         = 0x12011402ull;

static const uint64_t P9N2_EX_6_FIR_REG                                            = 0x13011000ull;

static const uint64_t P9N2_EX_6_FIR_REG_AND                                        = 0x13011001ull;

static const uint64_t P9N2_EX_6_FIR_REG_OR                                         = 0x13011002ull;

static const uint64_t P9N2_EX_7_FIR_REG                                            = 0x13011400ull;

static const uint64_t P9N2_EX_7_FIR_REG_AND                                        = 0x13011401ull;

static const uint64_t P9N2_EX_7_FIR_REG_OR                                         = 0x13011402ull;

static const uint64_t P9N2_EX_8_FIR_REG                                            = 0x14011000ull;

static const uint64_t P9N2_EX_8_FIR_REG_AND                                        = 0x14011001ull;

static const uint64_t P9N2_EX_8_FIR_REG_OR                                         = 0x14011002ull;

static const uint64_t P9N2_EX_9_FIR_REG                                            = 0x14011400ull;

static const uint64_t P9N2_EX_9_FIR_REG_AND                                        = 0x14011401ull;

static const uint64_t P9N2_EX_9_FIR_REG_OR                                         = 0x14011402ull;

static const uint64_t P9N2_EX_0_L2_FIR_REG                                         = 0x10010800ull;

static const uint64_t P9N2_EX_0_L2_FIR_REG_AND                                     = 0x10010801ull;

static const uint64_t P9N2_EX_0_L2_FIR_REG_OR                                      = 0x10010802ull;

static const uint64_t P9N2_EX_0_L3_FIR_REG                                         = 0x10011800ull;

static const uint64_t P9N2_EX_0_L3_FIR_REG_AND                                     = 0x10011801ull;

static const uint64_t P9N2_EX_0_L3_FIR_REG_OR                                      = 0x10011802ull;

static const uint64_t P9N2_EX_10_FIR_REG                                           = 0x15011000ull;

static const uint64_t P9N2_EX_10_FIR_REG_AND                                       = 0x15011001ull;

static const uint64_t P9N2_EX_10_FIR_REG_OR                                        = 0x15011002ull;

static const uint64_t P9N2_EX_11_FIR_REG                                           = 0x15011400ull;

static const uint64_t P9N2_EX_11_FIR_REG_AND                                       = 0x15011401ull;

static const uint64_t P9N2_EX_11_FIR_REG_OR                                        = 0x15011402ull;

static const uint64_t P9N2_EX_10_L2_FIR_REG                                        = 0x15010800ull;

static const uint64_t P9N2_EX_10_L2_FIR_REG_AND                                    = 0x15010801ull;

static const uint64_t P9N2_EX_10_L2_FIR_REG_OR                                     = 0x15010802ull;

static const uint64_t P9N2_EX_10_L3_FIR_REG                                        = 0x15011800ull;

static const uint64_t P9N2_EX_10_L3_FIR_REG_AND                                    = 0x15011801ull;

static const uint64_t P9N2_EX_10_L3_FIR_REG_OR                                     = 0x15011802ull;

static const uint64_t P9N2_EX_11_L2_FIR_REG                                        = 0x15010C00ull;

static const uint64_t P9N2_EX_11_L2_FIR_REG_AND                                    = 0x15010C01ull;

static const uint64_t P9N2_EX_11_L2_FIR_REG_OR                                     = 0x15010C02ull;

static const uint64_t P9N2_EX_11_L3_FIR_REG                                        = 0x15011C00ull;

static const uint64_t P9N2_EX_11_L3_FIR_REG_AND                                    = 0x15011C01ull;

static const uint64_t P9N2_EX_11_L3_FIR_REG_OR                                     = 0x15011C02ull;

static const uint64_t P9N2_EX_1_L2_FIR_REG                                         = 0x10010C00ull;

static const uint64_t P9N2_EX_1_L2_FIR_REG_AND                                     = 0x10010C01ull;

static const uint64_t P9N2_EX_1_L2_FIR_REG_OR                                      = 0x10010C02ull;

static const uint64_t P9N2_EX_1_L3_FIR_REG                                         = 0x10011C00ull;

static const uint64_t P9N2_EX_1_L3_FIR_REG_AND                                     = 0x10011C01ull;

static const uint64_t P9N2_EX_1_L3_FIR_REG_OR                                      = 0x10011C02ull;

static const uint64_t P9N2_EX_2_L2_FIR_REG                                         = 0x11010800ull;

static const uint64_t P9N2_EX_2_L2_FIR_REG_AND                                     = 0x11010801ull;

static const uint64_t P9N2_EX_2_L2_FIR_REG_OR                                      = 0x11010802ull;

static const uint64_t P9N2_EX_2_L3_FIR_REG                                         = 0x11011800ull;

static const uint64_t P9N2_EX_2_L3_FIR_REG_AND                                     = 0x11011801ull;

static const uint64_t P9N2_EX_2_L3_FIR_REG_OR                                      = 0x11011802ull;

static const uint64_t P9N2_EX_3_L2_FIR_REG                                         = 0x11010C00ull;

static const uint64_t P9N2_EX_3_L2_FIR_REG_AND                                     = 0x11010C01ull;

static const uint64_t P9N2_EX_3_L2_FIR_REG_OR                                      = 0x11010C02ull;

static const uint64_t P9N2_EX_3_L3_FIR_REG                                         = 0x11011C00ull;

static const uint64_t P9N2_EX_3_L3_FIR_REG_AND                                     = 0x11011C01ull;

static const uint64_t P9N2_EX_3_L3_FIR_REG_OR                                      = 0x11011C02ull;

static const uint64_t P9N2_EX_4_L2_FIR_REG                                         = 0x12010800ull;

static const uint64_t P9N2_EX_4_L2_FIR_REG_AND                                     = 0x12010801ull;

static const uint64_t P9N2_EX_4_L2_FIR_REG_OR                                      = 0x12010802ull;

static const uint64_t P9N2_EX_4_L3_FIR_REG                                         = 0x12011800ull;

static const uint64_t P9N2_EX_4_L3_FIR_REG_AND                                     = 0x12011801ull;

static const uint64_t P9N2_EX_4_L3_FIR_REG_OR                                      = 0x12011802ull;

static const uint64_t P9N2_EX_5_L2_FIR_REG                                         = 0x12010C00ull;

static const uint64_t P9N2_EX_5_L2_FIR_REG_AND                                     = 0x12010C01ull;

static const uint64_t P9N2_EX_5_L2_FIR_REG_OR                                      = 0x12010C02ull;

static const uint64_t P9N2_EX_5_L3_FIR_REG                                         = 0x12011C00ull;

static const uint64_t P9N2_EX_5_L3_FIR_REG_AND                                     = 0x12011C01ull;

static const uint64_t P9N2_EX_5_L3_FIR_REG_OR                                      = 0x12011C02ull;

static const uint64_t P9N2_EX_6_L2_FIR_REG                                         = 0x13010800ull;

static const uint64_t P9N2_EX_6_L2_FIR_REG_AND                                     = 0x13010801ull;

static const uint64_t P9N2_EX_6_L2_FIR_REG_OR                                      = 0x13010802ull;

static const uint64_t P9N2_EX_6_L3_FIR_REG                                         = 0x13011800ull;

static const uint64_t P9N2_EX_6_L3_FIR_REG_AND                                     = 0x13011801ull;

static const uint64_t P9N2_EX_6_L3_FIR_REG_OR                                      = 0x13011802ull;

static const uint64_t P9N2_EX_7_L2_FIR_REG                                         = 0x13010C00ull;

static const uint64_t P9N2_EX_7_L2_FIR_REG_AND                                     = 0x13010C01ull;

static const uint64_t P9N2_EX_7_L2_FIR_REG_OR                                      = 0x13010C02ull;

static const uint64_t P9N2_EX_7_L3_FIR_REG                                         = 0x13011C00ull;

static const uint64_t P9N2_EX_7_L3_FIR_REG_AND                                     = 0x13011C01ull;

static const uint64_t P9N2_EX_7_L3_FIR_REG_OR                                      = 0x13011C02ull;

static const uint64_t P9N2_EX_8_L2_FIR_REG                                         = 0x14010800ull;

static const uint64_t P9N2_EX_8_L2_FIR_REG_AND                                     = 0x14010801ull;

static const uint64_t P9N2_EX_8_L2_FIR_REG_OR                                      = 0x14010802ull;

static const uint64_t P9N2_EX_8_L3_FIR_REG                                         = 0x14011800ull;

static const uint64_t P9N2_EX_8_L3_FIR_REG_AND                                     = 0x14011801ull;

static const uint64_t P9N2_EX_8_L3_FIR_REG_OR                                      = 0x14011802ull;

static const uint64_t P9N2_EX_9_L2_FIR_REG                                         = 0x14010C00ull;

static const uint64_t P9N2_EX_9_L2_FIR_REG_AND                                     = 0x14010C01ull;

static const uint64_t P9N2_EX_9_L2_FIR_REG_OR                                      = 0x14010C02ull;

static const uint64_t P9N2_EX_9_L3_FIR_REG                                         = 0x14011C00ull;

static const uint64_t P9N2_EX_9_L3_FIR_REG_AND                                     = 0x14011C01ull;

static const uint64_t P9N2_EX_9_L3_FIR_REG_OR                                      = 0x14011C02ull;

static const uint64_t P9N2_EX_L2_FIR_REG                                           = 0x10010800ull;

static const uint64_t P9N2_EX_L2_FIR_REG_AND                                       = 0x10010801ull;

static const uint64_t P9N2_EX_L2_FIR_REG_OR                                        = 0x10010802ull;

static const uint64_t P9N2_EX_L3_FIR_REG                                           = 0x10011800ull;

static const uint64_t P9N2_EX_L3_FIR_REG_AND                                       = 0x10011801ull;

static const uint64_t P9N2_EX_L3_FIR_REG_OR                                        = 0x10011802ull;


static const uint64_t P9N2_C_GXSTOP0_MASK_REG                                      = 0x20040014ull;

static const uint64_t P9N2_C_0_GXSTOP0_MASK_REG                                    = 0x20040014ull;

static const uint64_t P9N2_C_1_GXSTOP0_MASK_REG                                    = 0x21040014ull;

static const uint64_t P9N2_C_2_GXSTOP0_MASK_REG                                    = 0x22040014ull;

static const uint64_t P9N2_C_3_GXSTOP0_MASK_REG                                    = 0x23040014ull;

static const uint64_t P9N2_C_4_GXSTOP0_MASK_REG                                    = 0x24040014ull;

static const uint64_t P9N2_C_5_GXSTOP0_MASK_REG                                    = 0x25040014ull;

static const uint64_t P9N2_C_6_GXSTOP0_MASK_REG                                    = 0x26040014ull;

static const uint64_t P9N2_C_7_GXSTOP0_MASK_REG                                    = 0x27040014ull;

static const uint64_t P9N2_C_8_GXSTOP0_MASK_REG                                    = 0x28040014ull;

static const uint64_t P9N2_C_9_GXSTOP0_MASK_REG                                    = 0x29040014ull;

static const uint64_t P9N2_C_10_GXSTOP0_MASK_REG                                   = 0x2A040014ull;

static const uint64_t P9N2_C_11_GXSTOP0_MASK_REG                                   = 0x2B040014ull;

static const uint64_t P9N2_C_12_GXSTOP0_MASK_REG                                   = 0x2C040014ull;

static const uint64_t P9N2_C_13_GXSTOP0_MASK_REG                                   = 0x2D040014ull;

static const uint64_t P9N2_C_14_GXSTOP0_MASK_REG                                   = 0x2E040014ull;

static const uint64_t P9N2_C_15_GXSTOP0_MASK_REG                                   = 0x2F040014ull;

static const uint64_t P9N2_C_16_GXSTOP0_MASK_REG                                   = 0x30040014ull;

static const uint64_t P9N2_C_17_GXSTOP0_MASK_REG                                   = 0x31040014ull;

static const uint64_t P9N2_C_18_GXSTOP0_MASK_REG                                   = 0x32040014ull;

static const uint64_t P9N2_C_19_GXSTOP0_MASK_REG                                   = 0x33040014ull;

static const uint64_t P9N2_C_20_GXSTOP0_MASK_REG                                   = 0x34040014ull;

static const uint64_t P9N2_C_21_GXSTOP0_MASK_REG                                   = 0x35040014ull;

static const uint64_t P9N2_C_22_GXSTOP0_MASK_REG                                   = 0x36040014ull;

static const uint64_t P9N2_C_23_GXSTOP0_MASK_REG                                   = 0x37040014ull;

static const uint64_t P9N2_EQ_GXSTOP0_MASK_REG                                     = 0x10040014ull;

static const uint64_t P9N2_EQ_0_GXSTOP0_MASK_REG                                   = 0x10040014ull;

static const uint64_t P9N2_EQ_1_GXSTOP0_MASK_REG                                   = 0x11040014ull;

static const uint64_t P9N2_EQ_2_GXSTOP0_MASK_REG                                   = 0x12040014ull;

static const uint64_t P9N2_EQ_3_GXSTOP0_MASK_REG                                   = 0x13040014ull;

static const uint64_t P9N2_EQ_4_GXSTOP0_MASK_REG                                   = 0x14040014ull;

static const uint64_t P9N2_EQ_5_GXSTOP0_MASK_REG                                   = 0x15040014ull;

static const uint64_t P9N2_EX_GXSTOP0_MASK_REG                                     = 0x20040014ull;
//DUPS: 21040014,
static const uint64_t P9N2_EX_0_GXSTOP0_MASK_REG                                   = 0x20040014ull;
//DUPS: 21040014,
static const uint64_t P9N2_EX_1_GXSTOP0_MASK_REG                                   = 0x22040014ull;
//DUPS: 23040014,
static const uint64_t P9N2_EX_2_GXSTOP0_MASK_REG                                   = 0x24040014ull;
//DUPS: 25040014,
static const uint64_t P9N2_EX_3_GXSTOP0_MASK_REG                                   = 0x26040014ull;
//DUPS: 27040014,
static const uint64_t P9N2_EX_4_GXSTOP0_MASK_REG                                   = 0x28040014ull;
//DUPS: 29040014,
static const uint64_t P9N2_EX_5_GXSTOP0_MASK_REG                                   = 0x2A040014ull;
//DUPS: 2B040014,
static const uint64_t P9N2_EX_6_GXSTOP0_MASK_REG                                   = 0x2C040014ull;
//DUPS: 2D040014,
static const uint64_t P9N2_EX_7_GXSTOP0_MASK_REG                                   = 0x2F040014ull;
//DUPS: 2F040014,
static const uint64_t P9N2_EX_8_GXSTOP0_MASK_REG                                   = 0x30040014ull;
//DUPS: 31040014,
static const uint64_t P9N2_EX_9_GXSTOP0_MASK_REG                                   = 0x32040014ull;
//DUPS: 33040014,
static const uint64_t P9N2_EX_10_GXSTOP0_MASK_REG                                  = 0x34040014ull;
//DUPS: 35040014,
static const uint64_t P9N2_EX_11_GXSTOP0_MASK_REG                                  = 0x36040014ull;
//DUPS: 37040014,

static const uint64_t P9N2_C_GXSTOP1_MASK_REG                                      = 0x20040015ull;

static const uint64_t P9N2_C_0_GXSTOP1_MASK_REG                                    = 0x20040015ull;

static const uint64_t P9N2_C_1_GXSTOP1_MASK_REG                                    = 0x21040015ull;

static const uint64_t P9N2_C_2_GXSTOP1_MASK_REG                                    = 0x22040015ull;

static const uint64_t P9N2_C_3_GXSTOP1_MASK_REG                                    = 0x23040015ull;

static const uint64_t P9N2_C_4_GXSTOP1_MASK_REG                                    = 0x24040015ull;

static const uint64_t P9N2_C_5_GXSTOP1_MASK_REG                                    = 0x25040015ull;

static const uint64_t P9N2_C_6_GXSTOP1_MASK_REG                                    = 0x26040015ull;

static const uint64_t P9N2_C_7_GXSTOP1_MASK_REG                                    = 0x27040015ull;

static const uint64_t P9N2_C_8_GXSTOP1_MASK_REG                                    = 0x28040015ull;

static const uint64_t P9N2_C_9_GXSTOP1_MASK_REG                                    = 0x29040015ull;

static const uint64_t P9N2_C_10_GXSTOP1_MASK_REG                                   = 0x2A040015ull;

static const uint64_t P9N2_C_11_GXSTOP1_MASK_REG                                   = 0x2B040015ull;

static const uint64_t P9N2_C_12_GXSTOP1_MASK_REG                                   = 0x2C040015ull;

static const uint64_t P9N2_C_13_GXSTOP1_MASK_REG                                   = 0x2D040015ull;

static const uint64_t P9N2_C_14_GXSTOP1_MASK_REG                                   = 0x2E040015ull;

static const uint64_t P9N2_C_15_GXSTOP1_MASK_REG                                   = 0x2F040015ull;

static const uint64_t P9N2_C_16_GXSTOP1_MASK_REG                                   = 0x30040015ull;

static const uint64_t P9N2_C_17_GXSTOP1_MASK_REG                                   = 0x31040015ull;

static const uint64_t P9N2_C_18_GXSTOP1_MASK_REG                                   = 0x32040015ull;

static const uint64_t P9N2_C_19_GXSTOP1_MASK_REG                                   = 0x33040015ull;

static const uint64_t P9N2_C_20_GXSTOP1_MASK_REG                                   = 0x34040015ull;

static const uint64_t P9N2_C_21_GXSTOP1_MASK_REG                                   = 0x35040015ull;

static const uint64_t P9N2_C_22_GXSTOP1_MASK_REG                                   = 0x36040015ull;

static const uint64_t P9N2_C_23_GXSTOP1_MASK_REG                                   = 0x37040015ull;

static const uint64_t P9N2_EQ_GXSTOP1_MASK_REG                                     = 0x10040015ull;

static const uint64_t P9N2_EQ_0_GXSTOP1_MASK_REG                                   = 0x10040015ull;

static const uint64_t P9N2_EQ_1_GXSTOP1_MASK_REG                                   = 0x11040015ull;

static const uint64_t P9N2_EQ_2_GXSTOP1_MASK_REG                                   = 0x12040015ull;

static const uint64_t P9N2_EQ_3_GXSTOP1_MASK_REG                                   = 0x13040015ull;

static const uint64_t P9N2_EQ_4_GXSTOP1_MASK_REG                                   = 0x14040015ull;

static const uint64_t P9N2_EQ_5_GXSTOP1_MASK_REG                                   = 0x15040015ull;

static const uint64_t P9N2_EX_GXSTOP1_MASK_REG                                     = 0x20040015ull;
//DUPS: 21040015,
static const uint64_t P9N2_EX_0_GXSTOP1_MASK_REG                                   = 0x20040015ull;
//DUPS: 21040015,
static const uint64_t P9N2_EX_1_GXSTOP1_MASK_REG                                   = 0x22040015ull;
//DUPS: 23040015,
static const uint64_t P9N2_EX_2_GXSTOP1_MASK_REG                                   = 0x24040015ull;
//DUPS: 25040015,
static const uint64_t P9N2_EX_3_GXSTOP1_MASK_REG                                   = 0x26040015ull;
//DUPS: 27040015,
static const uint64_t P9N2_EX_4_GXSTOP1_MASK_REG                                   = 0x28040015ull;
//DUPS: 29040015,
static const uint64_t P9N2_EX_5_GXSTOP1_MASK_REG                                   = 0x2A040015ull;
//DUPS: 2B040015,
static const uint64_t P9N2_EX_6_GXSTOP1_MASK_REG                                   = 0x2C040015ull;
//DUPS: 2D040015,
static const uint64_t P9N2_EX_7_GXSTOP1_MASK_REG                                   = 0x2F040015ull;
//DUPS: 2F040015,
static const uint64_t P9N2_EX_8_GXSTOP1_MASK_REG                                   = 0x30040015ull;
//DUPS: 31040015,
static const uint64_t P9N2_EX_9_GXSTOP1_MASK_REG                                   = 0x32040015ull;
//DUPS: 33040015,
static const uint64_t P9N2_EX_10_GXSTOP1_MASK_REG                                  = 0x34040015ull;
//DUPS: 35040015,
static const uint64_t P9N2_EX_11_GXSTOP1_MASK_REG                                  = 0x36040015ull;
//DUPS: 37040015,

static const uint64_t P9N2_C_GXSTOP2_MASK_REG                                      = 0x20040016ull;

static const uint64_t P9N2_C_0_GXSTOP2_MASK_REG                                    = 0x20040016ull;

static const uint64_t P9N2_C_1_GXSTOP2_MASK_REG                                    = 0x21040016ull;

static const uint64_t P9N2_C_2_GXSTOP2_MASK_REG                                    = 0x22040016ull;

static const uint64_t P9N2_C_3_GXSTOP2_MASK_REG                                    = 0x23040016ull;

static const uint64_t P9N2_C_4_GXSTOP2_MASK_REG                                    = 0x24040016ull;

static const uint64_t P9N2_C_5_GXSTOP2_MASK_REG                                    = 0x25040016ull;

static const uint64_t P9N2_C_6_GXSTOP2_MASK_REG                                    = 0x26040016ull;

static const uint64_t P9N2_C_7_GXSTOP2_MASK_REG                                    = 0x27040016ull;

static const uint64_t P9N2_C_8_GXSTOP2_MASK_REG                                    = 0x28040016ull;

static const uint64_t P9N2_C_9_GXSTOP2_MASK_REG                                    = 0x29040016ull;

static const uint64_t P9N2_C_10_GXSTOP2_MASK_REG                                   = 0x2A040016ull;

static const uint64_t P9N2_C_11_GXSTOP2_MASK_REG                                   = 0x2B040016ull;

static const uint64_t P9N2_C_12_GXSTOP2_MASK_REG                                   = 0x2C040016ull;

static const uint64_t P9N2_C_13_GXSTOP2_MASK_REG                                   = 0x2D040016ull;

static const uint64_t P9N2_C_14_GXSTOP2_MASK_REG                                   = 0x2E040016ull;

static const uint64_t P9N2_C_15_GXSTOP2_MASK_REG                                   = 0x2F040016ull;

static const uint64_t P9N2_C_16_GXSTOP2_MASK_REG                                   = 0x30040016ull;

static const uint64_t P9N2_C_17_GXSTOP2_MASK_REG                                   = 0x31040016ull;

static const uint64_t P9N2_C_18_GXSTOP2_MASK_REG                                   = 0x32040016ull;

static const uint64_t P9N2_C_19_GXSTOP2_MASK_REG                                   = 0x33040016ull;

static const uint64_t P9N2_C_20_GXSTOP2_MASK_REG                                   = 0x34040016ull;

static const uint64_t P9N2_C_21_GXSTOP2_MASK_REG                                   = 0x35040016ull;

static const uint64_t P9N2_C_22_GXSTOP2_MASK_REG                                   = 0x36040016ull;

static const uint64_t P9N2_C_23_GXSTOP2_MASK_REG                                   = 0x37040016ull;

static const uint64_t P9N2_EQ_GXSTOP2_MASK_REG                                     = 0x10040016ull;

static const uint64_t P9N2_EQ_0_GXSTOP2_MASK_REG                                   = 0x10040016ull;

static const uint64_t P9N2_EQ_1_GXSTOP2_MASK_REG                                   = 0x11040016ull;

static const uint64_t P9N2_EQ_2_GXSTOP2_MASK_REG                                   = 0x12040016ull;

static const uint64_t P9N2_EQ_3_GXSTOP2_MASK_REG                                   = 0x13040016ull;

static const uint64_t P9N2_EQ_4_GXSTOP2_MASK_REG                                   = 0x14040016ull;

static const uint64_t P9N2_EQ_5_GXSTOP2_MASK_REG                                   = 0x15040016ull;

static const uint64_t P9N2_EX_GXSTOP2_MASK_REG                                     = 0x20040016ull;
//DUPS: 21040016,
static const uint64_t P9N2_EX_0_GXSTOP2_MASK_REG                                   = 0x20040016ull;
//DUPS: 21040016,
static const uint64_t P9N2_EX_1_GXSTOP2_MASK_REG                                   = 0x22040016ull;
//DUPS: 23040016,
static const uint64_t P9N2_EX_2_GXSTOP2_MASK_REG                                   = 0x24040016ull;
//DUPS: 25040016,
static const uint64_t P9N2_EX_3_GXSTOP2_MASK_REG                                   = 0x26040016ull;
//DUPS: 27040016,
static const uint64_t P9N2_EX_4_GXSTOP2_MASK_REG                                   = 0x28040016ull;
//DUPS: 29040016,
static const uint64_t P9N2_EX_5_GXSTOP2_MASK_REG                                   = 0x2A040016ull;
//DUPS: 2B040016,
static const uint64_t P9N2_EX_6_GXSTOP2_MASK_REG                                   = 0x2C040016ull;
//DUPS: 2D040016,
static const uint64_t P9N2_EX_7_GXSTOP2_MASK_REG                                   = 0x2F040016ull;
//DUPS: 2F040016,
static const uint64_t P9N2_EX_8_GXSTOP2_MASK_REG                                   = 0x30040016ull;
//DUPS: 31040016,
static const uint64_t P9N2_EX_9_GXSTOP2_MASK_REG                                   = 0x32040016ull;
//DUPS: 33040016,
static const uint64_t P9N2_EX_10_GXSTOP2_MASK_REG                                  = 0x34040016ull;
//DUPS: 35040016,
static const uint64_t P9N2_EX_11_GXSTOP2_MASK_REG                                  = 0x36040016ull;
//DUPS: 37040016,

static const uint64_t P9N2_C_GXSTOP_TRIG_REG                                       = 0x20040013ull;

static const uint64_t P9N2_C_0_GXSTOP_TRIG_REG                                     = 0x20040013ull;

static const uint64_t P9N2_C_1_GXSTOP_TRIG_REG                                     = 0x21040013ull;

static const uint64_t P9N2_C_2_GXSTOP_TRIG_REG                                     = 0x22040013ull;

static const uint64_t P9N2_C_3_GXSTOP_TRIG_REG                                     = 0x23040013ull;

static const uint64_t P9N2_C_4_GXSTOP_TRIG_REG                                     = 0x24040013ull;

static const uint64_t P9N2_C_5_GXSTOP_TRIG_REG                                     = 0x25040013ull;

static const uint64_t P9N2_C_6_GXSTOP_TRIG_REG                                     = 0x26040013ull;

static const uint64_t P9N2_C_7_GXSTOP_TRIG_REG                                     = 0x27040013ull;

static const uint64_t P9N2_C_8_GXSTOP_TRIG_REG                                     = 0x28040013ull;

static const uint64_t P9N2_C_9_GXSTOP_TRIG_REG                                     = 0x29040013ull;

static const uint64_t P9N2_C_10_GXSTOP_TRIG_REG                                    = 0x2A040013ull;

static const uint64_t P9N2_C_11_GXSTOP_TRIG_REG                                    = 0x2B040013ull;

static const uint64_t P9N2_C_12_GXSTOP_TRIG_REG                                    = 0x2C040013ull;

static const uint64_t P9N2_C_13_GXSTOP_TRIG_REG                                    = 0x2D040013ull;

static const uint64_t P9N2_C_14_GXSTOP_TRIG_REG                                    = 0x2E040013ull;

static const uint64_t P9N2_C_15_GXSTOP_TRIG_REG                                    = 0x2F040013ull;

static const uint64_t P9N2_C_16_GXSTOP_TRIG_REG                                    = 0x30040013ull;

static const uint64_t P9N2_C_17_GXSTOP_TRIG_REG                                    = 0x31040013ull;

static const uint64_t P9N2_C_18_GXSTOP_TRIG_REG                                    = 0x32040013ull;

static const uint64_t P9N2_C_19_GXSTOP_TRIG_REG                                    = 0x33040013ull;

static const uint64_t P9N2_C_20_GXSTOP_TRIG_REG                                    = 0x34040013ull;

static const uint64_t P9N2_C_21_GXSTOP_TRIG_REG                                    = 0x35040013ull;

static const uint64_t P9N2_C_22_GXSTOP_TRIG_REG                                    = 0x36040013ull;

static const uint64_t P9N2_C_23_GXSTOP_TRIG_REG                                    = 0x37040013ull;

static const uint64_t P9N2_EQ_GXSTOP_TRIG_REG                                      = 0x10040013ull;

static const uint64_t P9N2_EQ_0_GXSTOP_TRIG_REG                                    = 0x10040013ull;

static const uint64_t P9N2_EQ_1_GXSTOP_TRIG_REG                                    = 0x11040013ull;

static const uint64_t P9N2_EQ_2_GXSTOP_TRIG_REG                                    = 0x12040013ull;

static const uint64_t P9N2_EQ_3_GXSTOP_TRIG_REG                                    = 0x13040013ull;

static const uint64_t P9N2_EQ_4_GXSTOP_TRIG_REG                                    = 0x14040013ull;

static const uint64_t P9N2_EQ_5_GXSTOP_TRIG_REG                                    = 0x15040013ull;

static const uint64_t P9N2_EX_GXSTOP_TRIG_REG                                      = 0x20040013ull;
//DUPS: 21040013,
static const uint64_t P9N2_EX_0_GXSTOP_TRIG_REG                                    = 0x20040013ull;
//DUPS: 21040013,
static const uint64_t P9N2_EX_1_GXSTOP_TRIG_REG                                    = 0x22040013ull;
//DUPS: 23040013,
static const uint64_t P9N2_EX_2_GXSTOP_TRIG_REG                                    = 0x24040013ull;
//DUPS: 25040013,
static const uint64_t P9N2_EX_3_GXSTOP_TRIG_REG                                    = 0x26040013ull;
//DUPS: 27040013,
static const uint64_t P9N2_EX_4_GXSTOP_TRIG_REG                                    = 0x28040013ull;
//DUPS: 29040013,
static const uint64_t P9N2_EX_5_GXSTOP_TRIG_REG                                    = 0x2A040013ull;
//DUPS: 2B040013,
static const uint64_t P9N2_EX_6_GXSTOP_TRIG_REG                                    = 0x2C040013ull;
//DUPS: 2D040013,
static const uint64_t P9N2_EX_7_GXSTOP_TRIG_REG                                    = 0x2F040013ull;
//DUPS: 2F040013,
static const uint64_t P9N2_EX_8_GXSTOP_TRIG_REG                                    = 0x30040013ull;
//DUPS: 31040013,
static const uint64_t P9N2_EX_9_GXSTOP_TRIG_REG                                    = 0x32040013ull;
//DUPS: 33040013,
static const uint64_t P9N2_EX_10_GXSTOP_TRIG_REG                                   = 0x34040013ull;
//DUPS: 35040013,
static const uint64_t P9N2_EX_11_GXSTOP_TRIG_REG                                   = 0x36040013ull;
//DUPS: 37040013,

static const uint64_t P9N2_C_HANG_CONTROL                                          = 0x20010A00ull;

static const uint64_t P9N2_C_0_HANG_CONTROL                                        = 0x20010A00ull;

static const uint64_t P9N2_C_1_HANG_CONTROL                                        = 0x21010A00ull;

static const uint64_t P9N2_C_2_HANG_CONTROL                                        = 0x22010A00ull;

static const uint64_t P9N2_C_3_HANG_CONTROL                                        = 0x23010A00ull;

static const uint64_t P9N2_C_4_HANG_CONTROL                                        = 0x24010A00ull;

static const uint64_t P9N2_C_5_HANG_CONTROL                                        = 0x25010A00ull;

static const uint64_t P9N2_C_6_HANG_CONTROL                                        = 0x26010A00ull;

static const uint64_t P9N2_C_7_HANG_CONTROL                                        = 0x27010A00ull;

static const uint64_t P9N2_C_8_HANG_CONTROL                                        = 0x28010A00ull;

static const uint64_t P9N2_C_9_HANG_CONTROL                                        = 0x29010A00ull;

static const uint64_t P9N2_C_10_HANG_CONTROL                                       = 0x2A010A00ull;

static const uint64_t P9N2_C_11_HANG_CONTROL                                       = 0x2B010A00ull;

static const uint64_t P9N2_C_12_HANG_CONTROL                                       = 0x2C010A00ull;

static const uint64_t P9N2_C_13_HANG_CONTROL                                       = 0x2D010A00ull;

static const uint64_t P9N2_C_14_HANG_CONTROL                                       = 0x2E010A00ull;

static const uint64_t P9N2_C_15_HANG_CONTROL                                       = 0x2F010A00ull;

static const uint64_t P9N2_C_16_HANG_CONTROL                                       = 0x30010A00ull;

static const uint64_t P9N2_C_17_HANG_CONTROL                                       = 0x31010A00ull;

static const uint64_t P9N2_C_18_HANG_CONTROL                                       = 0x32010A00ull;

static const uint64_t P9N2_C_19_HANG_CONTROL                                       = 0x33010A00ull;

static const uint64_t P9N2_C_20_HANG_CONTROL                                       = 0x34010A00ull;

static const uint64_t P9N2_C_21_HANG_CONTROL                                       = 0x35010A00ull;

static const uint64_t P9N2_C_22_HANG_CONTROL                                       = 0x36010A00ull;

static const uint64_t P9N2_C_23_HANG_CONTROL                                       = 0x37010A00ull;

static const uint64_t P9N2_EX_0_L2_HANG_CONTROL                                    = 0x20010A00ull;
//DUPS: 21010A00,
static const uint64_t P9N2_EX_10_L2_HANG_CONTROL                                   = 0x34010A00ull;
//DUPS: 35010A00,
static const uint64_t P9N2_EX_11_L2_HANG_CONTROL                                   = 0x36010A00ull;
//DUPS: 37010A00,
static const uint64_t P9N2_EX_1_L2_HANG_CONTROL                                    = 0x22010A00ull;
//DUPS: 23010A00,
static const uint64_t P9N2_EX_2_L2_HANG_CONTROL                                    = 0x24010A00ull;
//DUPS: 25010A00,
static const uint64_t P9N2_EX_3_L2_HANG_CONTROL                                    = 0x26010A00ull;
//DUPS: 27010A00,
static const uint64_t P9N2_EX_4_L2_HANG_CONTROL                                    = 0x28010A00ull;
//DUPS: 29010A00,
static const uint64_t P9N2_EX_5_L2_HANG_CONTROL                                    = 0x2A010A00ull;
//DUPS: 2B010A00,
static const uint64_t P9N2_EX_6_L2_HANG_CONTROL                                    = 0x2C010A00ull;
//DUPS: 2D010A00,
static const uint64_t P9N2_EX_7_L2_HANG_CONTROL                                    = 0x2F010A00ull;
//DUPS: 2F010A00,
static const uint64_t P9N2_EX_8_L2_HANG_CONTROL                                    = 0x30010A00ull;
//DUPS: 31010A00,
static const uint64_t P9N2_EX_9_L2_HANG_CONTROL                                    = 0x32010A00ull;
//DUPS: 33010A00,
static const uint64_t P9N2_EX_L2_HANG_CONTROL                                      = 0x20010A00ull;
//DUPS: 21010A00,

static const uint64_t P9N2_C_HANG_PULSE_0_REG                                      = 0x200F0020ull;

static const uint64_t P9N2_C_0_HANG_PULSE_0_REG                                    = 0x200F0020ull;

static const uint64_t P9N2_C_1_HANG_PULSE_0_REG                                    = 0x210F0020ull;

static const uint64_t P9N2_C_2_HANG_PULSE_0_REG                                    = 0x220F0020ull;

static const uint64_t P9N2_C_3_HANG_PULSE_0_REG                                    = 0x230F0020ull;

static const uint64_t P9N2_C_4_HANG_PULSE_0_REG                                    = 0x240F0020ull;

static const uint64_t P9N2_C_5_HANG_PULSE_0_REG                                    = 0x250F0020ull;

static const uint64_t P9N2_C_6_HANG_PULSE_0_REG                                    = 0x260F0020ull;

static const uint64_t P9N2_C_7_HANG_PULSE_0_REG                                    = 0x270F0020ull;

static const uint64_t P9N2_C_8_HANG_PULSE_0_REG                                    = 0x280F0020ull;

static const uint64_t P9N2_C_9_HANG_PULSE_0_REG                                    = 0x290F0020ull;

static const uint64_t P9N2_C_10_HANG_PULSE_0_REG                                   = 0x2A0F0020ull;

static const uint64_t P9N2_C_11_HANG_PULSE_0_REG                                   = 0x2B0F0020ull;

static const uint64_t P9N2_C_12_HANG_PULSE_0_REG                                   = 0x2C0F0020ull;

static const uint64_t P9N2_C_13_HANG_PULSE_0_REG                                   = 0x2D0F0020ull;

static const uint64_t P9N2_C_14_HANG_PULSE_0_REG                                   = 0x2E0F0020ull;

static const uint64_t P9N2_C_15_HANG_PULSE_0_REG                                   = 0x2F0F0020ull;

static const uint64_t P9N2_C_16_HANG_PULSE_0_REG                                   = 0x300F0020ull;

static const uint64_t P9N2_C_17_HANG_PULSE_0_REG                                   = 0x310F0020ull;

static const uint64_t P9N2_C_18_HANG_PULSE_0_REG                                   = 0x320F0020ull;

static const uint64_t P9N2_C_19_HANG_PULSE_0_REG                                   = 0x330F0020ull;

static const uint64_t P9N2_C_20_HANG_PULSE_0_REG                                   = 0x340F0020ull;

static const uint64_t P9N2_C_21_HANG_PULSE_0_REG                                   = 0x350F0020ull;

static const uint64_t P9N2_C_22_HANG_PULSE_0_REG                                   = 0x360F0020ull;

static const uint64_t P9N2_C_23_HANG_PULSE_0_REG                                   = 0x370F0020ull;

static const uint64_t P9N2_EQ_HANG_PULSE_0_REG                                     = 0x100F0020ull;

static const uint64_t P9N2_EQ_0_HANG_PULSE_0_REG                                   = 0x100F0020ull;

static const uint64_t P9N2_EQ_1_HANG_PULSE_0_REG                                   = 0x110F0020ull;

static const uint64_t P9N2_EQ_2_HANG_PULSE_0_REG                                   = 0x120F0020ull;

static const uint64_t P9N2_EQ_3_HANG_PULSE_0_REG                                   = 0x130F0020ull;

static const uint64_t P9N2_EQ_4_HANG_PULSE_0_REG                                   = 0x140F0020ull;

static const uint64_t P9N2_EQ_5_HANG_PULSE_0_REG                                   = 0x150F0020ull;

static const uint64_t P9N2_EX_HANG_PULSE_0_REG                                     = 0x200F0020ull;
//DUPS: 210F0020,
static const uint64_t P9N2_EX_0_HANG_PULSE_0_REG                                   = 0x200F0020ull;
//DUPS: 210F0020,
static const uint64_t P9N2_EX_1_HANG_PULSE_0_REG                                   = 0x220F0020ull;
//DUPS: 220F0020,
static const uint64_t P9N2_EX_2_HANG_PULSE_0_REG                                   = 0x240F0020ull;
//DUPS: 250F0020,
static const uint64_t P9N2_EX_3_HANG_PULSE_0_REG                                   = 0x260F0020ull;
//DUPS: 270F0020,
static const uint64_t P9N2_EX_4_HANG_PULSE_0_REG                                   = 0x280F0020ull;
//DUPS: 290F0020,
static const uint64_t P9N2_EX_5_HANG_PULSE_0_REG                                   = 0x2A0F0020ull;
//DUPS: 2B0F0020,
static const uint64_t P9N2_EX_6_HANG_PULSE_0_REG                                   = 0x2C0F0020ull;
//DUPS: 2D0F0020,
static const uint64_t P9N2_EX_7_HANG_PULSE_0_REG                                   = 0x2E0F0020ull;
//DUPS: 2F0F0020,
static const uint64_t P9N2_EX_8_HANG_PULSE_0_REG                                   = 0x300F0020ull;
//DUPS: 310F0020,
static const uint64_t P9N2_EX_9_HANG_PULSE_0_REG                                   = 0x320F0020ull;
//DUPS: 330F0020,
static const uint64_t P9N2_EX_10_HANG_PULSE_0_REG                                  = 0x340F0020ull;
//DUPS: 350F0020,
static const uint64_t P9N2_EX_11_HANG_PULSE_0_REG                                  = 0x360F0020ull;
//DUPS: 370F0020,

static const uint64_t P9N2_C_HANG_PULSE_1_REG                                      = 0x200F0021ull;

static const uint64_t P9N2_C_0_HANG_PULSE_1_REG                                    = 0x200F0021ull;

static const uint64_t P9N2_C_1_HANG_PULSE_1_REG                                    = 0x210F0021ull;

static const uint64_t P9N2_C_2_HANG_PULSE_1_REG                                    = 0x220F0021ull;

static const uint64_t P9N2_C_3_HANG_PULSE_1_REG                                    = 0x230F0021ull;

static const uint64_t P9N2_C_4_HANG_PULSE_1_REG                                    = 0x240F0021ull;

static const uint64_t P9N2_C_5_HANG_PULSE_1_REG                                    = 0x250F0021ull;

static const uint64_t P9N2_C_6_HANG_PULSE_1_REG                                    = 0x260F0021ull;

static const uint64_t P9N2_C_7_HANG_PULSE_1_REG                                    = 0x270F0021ull;

static const uint64_t P9N2_C_8_HANG_PULSE_1_REG                                    = 0x280F0021ull;

static const uint64_t P9N2_C_9_HANG_PULSE_1_REG                                    = 0x290F0021ull;

static const uint64_t P9N2_C_10_HANG_PULSE_1_REG                                   = 0x2A0F0021ull;

static const uint64_t P9N2_C_11_HANG_PULSE_1_REG                                   = 0x2B0F0021ull;

static const uint64_t P9N2_C_12_HANG_PULSE_1_REG                                   = 0x2C0F0021ull;

static const uint64_t P9N2_C_13_HANG_PULSE_1_REG                                   = 0x2D0F0021ull;

static const uint64_t P9N2_C_14_HANG_PULSE_1_REG                                   = 0x2E0F0021ull;

static const uint64_t P9N2_C_15_HANG_PULSE_1_REG                                   = 0x2F0F0021ull;

static const uint64_t P9N2_C_16_HANG_PULSE_1_REG                                   = 0x300F0021ull;

static const uint64_t P9N2_C_17_HANG_PULSE_1_REG                                   = 0x310F0021ull;

static const uint64_t P9N2_C_18_HANG_PULSE_1_REG                                   = 0x320F0021ull;

static const uint64_t P9N2_C_19_HANG_PULSE_1_REG                                   = 0x330F0021ull;

static const uint64_t P9N2_C_20_HANG_PULSE_1_REG                                   = 0x340F0021ull;

static const uint64_t P9N2_C_21_HANG_PULSE_1_REG                                   = 0x350F0021ull;

static const uint64_t P9N2_C_22_HANG_PULSE_1_REG                                   = 0x360F0021ull;

static const uint64_t P9N2_C_23_HANG_PULSE_1_REG                                   = 0x370F0021ull;

static const uint64_t P9N2_EQ_HANG_PULSE_1_REG                                     = 0x100F0021ull;

static const uint64_t P9N2_EQ_0_HANG_PULSE_1_REG                                   = 0x100F0021ull;

static const uint64_t P9N2_EQ_1_HANG_PULSE_1_REG                                   = 0x110F0021ull;

static const uint64_t P9N2_EQ_2_HANG_PULSE_1_REG                                   = 0x120F0021ull;

static const uint64_t P9N2_EQ_3_HANG_PULSE_1_REG                                   = 0x130F0021ull;

static const uint64_t P9N2_EQ_4_HANG_PULSE_1_REG                                   = 0x140F0021ull;

static const uint64_t P9N2_EQ_5_HANG_PULSE_1_REG                                   = 0x150F0021ull;

static const uint64_t P9N2_EX_HANG_PULSE_1_REG                                     = 0x200F0021ull;
//DUPS: 210F0021,
static const uint64_t P9N2_EX_0_HANG_PULSE_1_REG                                   = 0x200F0021ull;
//DUPS: 210F0021,
static const uint64_t P9N2_EX_1_HANG_PULSE_1_REG                                   = 0x220F0021ull;
//DUPS: 220F0021,
static const uint64_t P9N2_EX_2_HANG_PULSE_1_REG                                   = 0x240F0021ull;
//DUPS: 250F0021,
static const uint64_t P9N2_EX_3_HANG_PULSE_1_REG                                   = 0x260F0021ull;
//DUPS: 270F0021,
static const uint64_t P9N2_EX_4_HANG_PULSE_1_REG                                   = 0x280F0021ull;
//DUPS: 290F0021,
static const uint64_t P9N2_EX_5_HANG_PULSE_1_REG                                   = 0x2A0F0021ull;
//DUPS: 2B0F0021,
static const uint64_t P9N2_EX_6_HANG_PULSE_1_REG                                   = 0x2C0F0021ull;
//DUPS: 2D0F0021,
static const uint64_t P9N2_EX_7_HANG_PULSE_1_REG                                   = 0x2E0F0021ull;
//DUPS: 2F0F0021,
static const uint64_t P9N2_EX_8_HANG_PULSE_1_REG                                   = 0x300F0021ull;
//DUPS: 310F0021,
static const uint64_t P9N2_EX_9_HANG_PULSE_1_REG                                   = 0x320F0021ull;
//DUPS: 330F0021,
static const uint64_t P9N2_EX_10_HANG_PULSE_1_REG                                  = 0x340F0021ull;
//DUPS: 350F0021,
static const uint64_t P9N2_EX_11_HANG_PULSE_1_REG                                  = 0x360F0021ull;
//DUPS: 370F0021,

static const uint64_t P9N2_C_HANG_PULSE_2_REG                                      = 0x200F0022ull;

static const uint64_t P9N2_C_0_HANG_PULSE_2_REG                                    = 0x200F0022ull;

static const uint64_t P9N2_C_1_HANG_PULSE_2_REG                                    = 0x210F0022ull;

static const uint64_t P9N2_C_2_HANG_PULSE_2_REG                                    = 0x220F0022ull;

static const uint64_t P9N2_C_3_HANG_PULSE_2_REG                                    = 0x230F0022ull;

static const uint64_t P9N2_C_4_HANG_PULSE_2_REG                                    = 0x240F0022ull;

static const uint64_t P9N2_C_5_HANG_PULSE_2_REG                                    = 0x250F0022ull;

static const uint64_t P9N2_C_6_HANG_PULSE_2_REG                                    = 0x260F0022ull;

static const uint64_t P9N2_C_7_HANG_PULSE_2_REG                                    = 0x270F0022ull;

static const uint64_t P9N2_C_8_HANG_PULSE_2_REG                                    = 0x280F0022ull;

static const uint64_t P9N2_C_9_HANG_PULSE_2_REG                                    = 0x290F0022ull;

static const uint64_t P9N2_C_10_HANG_PULSE_2_REG                                   = 0x2A0F0022ull;

static const uint64_t P9N2_C_11_HANG_PULSE_2_REG                                   = 0x2B0F0022ull;

static const uint64_t P9N2_C_12_HANG_PULSE_2_REG                                   = 0x2C0F0022ull;

static const uint64_t P9N2_C_13_HANG_PULSE_2_REG                                   = 0x2D0F0022ull;

static const uint64_t P9N2_C_14_HANG_PULSE_2_REG                                   = 0x2E0F0022ull;

static const uint64_t P9N2_C_15_HANG_PULSE_2_REG                                   = 0x2F0F0022ull;

static const uint64_t P9N2_C_16_HANG_PULSE_2_REG                                   = 0x300F0022ull;

static const uint64_t P9N2_C_17_HANG_PULSE_2_REG                                   = 0x310F0022ull;

static const uint64_t P9N2_C_18_HANG_PULSE_2_REG                                   = 0x320F0022ull;

static const uint64_t P9N2_C_19_HANG_PULSE_2_REG                                   = 0x330F0022ull;

static const uint64_t P9N2_C_20_HANG_PULSE_2_REG                                   = 0x340F0022ull;

static const uint64_t P9N2_C_21_HANG_PULSE_2_REG                                   = 0x350F0022ull;

static const uint64_t P9N2_C_22_HANG_PULSE_2_REG                                   = 0x360F0022ull;

static const uint64_t P9N2_C_23_HANG_PULSE_2_REG                                   = 0x370F0022ull;

static const uint64_t P9N2_EQ_HANG_PULSE_2_REG                                     = 0x100F0022ull;

static const uint64_t P9N2_EQ_0_HANG_PULSE_2_REG                                   = 0x100F0022ull;

static const uint64_t P9N2_EQ_1_HANG_PULSE_2_REG                                   = 0x110F0022ull;

static const uint64_t P9N2_EQ_2_HANG_PULSE_2_REG                                   = 0x120F0022ull;

static const uint64_t P9N2_EQ_3_HANG_PULSE_2_REG                                   = 0x130F0022ull;

static const uint64_t P9N2_EQ_4_HANG_PULSE_2_REG                                   = 0x140F0022ull;

static const uint64_t P9N2_EQ_5_HANG_PULSE_2_REG                                   = 0x150F0022ull;

static const uint64_t P9N2_EX_HANG_PULSE_2_REG                                     = 0x200F0022ull;
//DUPS: 210F0022,
static const uint64_t P9N2_EX_0_HANG_PULSE_2_REG                                   = 0x200F0022ull;
//DUPS: 210F0022,
static const uint64_t P9N2_EX_1_HANG_PULSE_2_REG                                   = 0x220F0022ull;
//DUPS: 220F0022,
static const uint64_t P9N2_EX_2_HANG_PULSE_2_REG                                   = 0x240F0022ull;
//DUPS: 250F0022,
static const uint64_t P9N2_EX_3_HANG_PULSE_2_REG                                   = 0x260F0022ull;
//DUPS: 270F0022,
static const uint64_t P9N2_EX_4_HANG_PULSE_2_REG                                   = 0x280F0022ull;
//DUPS: 290F0022,
static const uint64_t P9N2_EX_5_HANG_PULSE_2_REG                                   = 0x2A0F0022ull;
//DUPS: 2B0F0022,
static const uint64_t P9N2_EX_6_HANG_PULSE_2_REG                                   = 0x2C0F0022ull;
//DUPS: 2D0F0022,
static const uint64_t P9N2_EX_7_HANG_PULSE_2_REG                                   = 0x2E0F0022ull;
//DUPS: 2F0F0022,
static const uint64_t P9N2_EX_8_HANG_PULSE_2_REG                                   = 0x300F0022ull;
//DUPS: 310F0022,
static const uint64_t P9N2_EX_9_HANG_PULSE_2_REG                                   = 0x320F0022ull;
//DUPS: 330F0022,
static const uint64_t P9N2_EX_10_HANG_PULSE_2_REG                                  = 0x340F0022ull;
//DUPS: 350F0022,
static const uint64_t P9N2_EX_11_HANG_PULSE_2_REG                                  = 0x360F0022ull;
//DUPS: 370F0022,

static const uint64_t P9N2_C_HANG_PULSE_3_REG                                      = 0x200F0023ull;

static const uint64_t P9N2_C_0_HANG_PULSE_3_REG                                    = 0x200F0023ull;

static const uint64_t P9N2_C_1_HANG_PULSE_3_REG                                    = 0x210F0023ull;

static const uint64_t P9N2_C_2_HANG_PULSE_3_REG                                    = 0x220F0023ull;

static const uint64_t P9N2_C_3_HANG_PULSE_3_REG                                    = 0x230F0023ull;

static const uint64_t P9N2_C_4_HANG_PULSE_3_REG                                    = 0x240F0023ull;

static const uint64_t P9N2_C_5_HANG_PULSE_3_REG                                    = 0x250F0023ull;

static const uint64_t P9N2_C_6_HANG_PULSE_3_REG                                    = 0x260F0023ull;

static const uint64_t P9N2_C_7_HANG_PULSE_3_REG                                    = 0x270F0023ull;

static const uint64_t P9N2_C_8_HANG_PULSE_3_REG                                    = 0x280F0023ull;

static const uint64_t P9N2_C_9_HANG_PULSE_3_REG                                    = 0x290F0023ull;

static const uint64_t P9N2_C_10_HANG_PULSE_3_REG                                   = 0x2A0F0023ull;

static const uint64_t P9N2_C_11_HANG_PULSE_3_REG                                   = 0x2B0F0023ull;

static const uint64_t P9N2_C_12_HANG_PULSE_3_REG                                   = 0x2C0F0023ull;

static const uint64_t P9N2_C_13_HANG_PULSE_3_REG                                   = 0x2D0F0023ull;

static const uint64_t P9N2_C_14_HANG_PULSE_3_REG                                   = 0x2E0F0023ull;

static const uint64_t P9N2_C_15_HANG_PULSE_3_REG                                   = 0x2F0F0023ull;

static const uint64_t P9N2_C_16_HANG_PULSE_3_REG                                   = 0x300F0023ull;

static const uint64_t P9N2_C_17_HANG_PULSE_3_REG                                   = 0x310F0023ull;

static const uint64_t P9N2_C_18_HANG_PULSE_3_REG                                   = 0x320F0023ull;

static const uint64_t P9N2_C_19_HANG_PULSE_3_REG                                   = 0x330F0023ull;

static const uint64_t P9N2_C_20_HANG_PULSE_3_REG                                   = 0x340F0023ull;

static const uint64_t P9N2_C_21_HANG_PULSE_3_REG                                   = 0x350F0023ull;

static const uint64_t P9N2_C_22_HANG_PULSE_3_REG                                   = 0x360F0023ull;

static const uint64_t P9N2_C_23_HANG_PULSE_3_REG                                   = 0x370F0023ull;

static const uint64_t P9N2_EQ_HANG_PULSE_3_REG                                     = 0x100F0023ull;

static const uint64_t P9N2_EQ_0_HANG_PULSE_3_REG                                   = 0x100F0023ull;

static const uint64_t P9N2_EQ_1_HANG_PULSE_3_REG                                   = 0x110F0023ull;

static const uint64_t P9N2_EQ_2_HANG_PULSE_3_REG                                   = 0x120F0023ull;

static const uint64_t P9N2_EQ_3_HANG_PULSE_3_REG                                   = 0x130F0023ull;

static const uint64_t P9N2_EQ_4_HANG_PULSE_3_REG                                   = 0x140F0023ull;

static const uint64_t P9N2_EQ_5_HANG_PULSE_3_REG                                   = 0x150F0023ull;

static const uint64_t P9N2_EX_HANG_PULSE_3_REG                                     = 0x200F0023ull;
//DUPS: 210F0023,
static const uint64_t P9N2_EX_0_HANG_PULSE_3_REG                                   = 0x200F0023ull;
//DUPS: 210F0023,
static const uint64_t P9N2_EX_1_HANG_PULSE_3_REG                                   = 0x220F0023ull;
//DUPS: 220F0023,
static const uint64_t P9N2_EX_2_HANG_PULSE_3_REG                                   = 0x240F0023ull;
//DUPS: 250F0023,
static const uint64_t P9N2_EX_3_HANG_PULSE_3_REG                                   = 0x260F0023ull;
//DUPS: 270F0023,
static const uint64_t P9N2_EX_4_HANG_PULSE_3_REG                                   = 0x280F0023ull;
//DUPS: 290F0023,
static const uint64_t P9N2_EX_5_HANG_PULSE_3_REG                                   = 0x2A0F0023ull;
//DUPS: 2B0F0023,
static const uint64_t P9N2_EX_6_HANG_PULSE_3_REG                                   = 0x2C0F0023ull;
//DUPS: 2D0F0023,
static const uint64_t P9N2_EX_7_HANG_PULSE_3_REG                                   = 0x2E0F0023ull;
//DUPS: 2F0F0023,
static const uint64_t P9N2_EX_8_HANG_PULSE_3_REG                                   = 0x300F0023ull;
//DUPS: 310F0023,
static const uint64_t P9N2_EX_9_HANG_PULSE_3_REG                                   = 0x320F0023ull;
//DUPS: 330F0023,
static const uint64_t P9N2_EX_10_HANG_PULSE_3_REG                                  = 0x340F0023ull;
//DUPS: 350F0023,
static const uint64_t P9N2_EX_11_HANG_PULSE_3_REG                                  = 0x360F0023ull;
//DUPS: 370F0023,

static const uint64_t P9N2_C_HANG_PULSE_4_REG                                      = 0x200F0024ull;

static const uint64_t P9N2_C_0_HANG_PULSE_4_REG                                    = 0x200F0024ull;

static const uint64_t P9N2_C_1_HANG_PULSE_4_REG                                    = 0x210F0024ull;

static const uint64_t P9N2_C_2_HANG_PULSE_4_REG                                    = 0x220F0024ull;

static const uint64_t P9N2_C_3_HANG_PULSE_4_REG                                    = 0x230F0024ull;

static const uint64_t P9N2_C_4_HANG_PULSE_4_REG                                    = 0x240F0024ull;

static const uint64_t P9N2_C_5_HANG_PULSE_4_REG                                    = 0x250F0024ull;

static const uint64_t P9N2_C_6_HANG_PULSE_4_REG                                    = 0x260F0024ull;

static const uint64_t P9N2_C_7_HANG_PULSE_4_REG                                    = 0x270F0024ull;

static const uint64_t P9N2_C_8_HANG_PULSE_4_REG                                    = 0x280F0024ull;

static const uint64_t P9N2_C_9_HANG_PULSE_4_REG                                    = 0x290F0024ull;

static const uint64_t P9N2_C_10_HANG_PULSE_4_REG                                   = 0x2A0F0024ull;

static const uint64_t P9N2_C_11_HANG_PULSE_4_REG                                   = 0x2B0F0024ull;

static const uint64_t P9N2_C_12_HANG_PULSE_4_REG                                   = 0x2C0F0024ull;

static const uint64_t P9N2_C_13_HANG_PULSE_4_REG                                   = 0x2D0F0024ull;

static const uint64_t P9N2_C_14_HANG_PULSE_4_REG                                   = 0x2E0F0024ull;

static const uint64_t P9N2_C_15_HANG_PULSE_4_REG                                   = 0x2F0F0024ull;

static const uint64_t P9N2_C_16_HANG_PULSE_4_REG                                   = 0x300F0024ull;

static const uint64_t P9N2_C_17_HANG_PULSE_4_REG                                   = 0x310F0024ull;

static const uint64_t P9N2_C_18_HANG_PULSE_4_REG                                   = 0x320F0024ull;

static const uint64_t P9N2_C_19_HANG_PULSE_4_REG                                   = 0x330F0024ull;

static const uint64_t P9N2_C_20_HANG_PULSE_4_REG                                   = 0x340F0024ull;

static const uint64_t P9N2_C_21_HANG_PULSE_4_REG                                   = 0x350F0024ull;

static const uint64_t P9N2_C_22_HANG_PULSE_4_REG                                   = 0x360F0024ull;

static const uint64_t P9N2_C_23_HANG_PULSE_4_REG                                   = 0x370F0024ull;

static const uint64_t P9N2_EQ_HANG_PULSE_4_REG                                     = 0x100F0024ull;

static const uint64_t P9N2_EQ_0_HANG_PULSE_4_REG                                   = 0x100F0024ull;

static const uint64_t P9N2_EQ_1_HANG_PULSE_4_REG                                   = 0x110F0024ull;

static const uint64_t P9N2_EQ_2_HANG_PULSE_4_REG                                   = 0x120F0024ull;

static const uint64_t P9N2_EQ_3_HANG_PULSE_4_REG                                   = 0x130F0024ull;

static const uint64_t P9N2_EQ_4_HANG_PULSE_4_REG                                   = 0x140F0024ull;

static const uint64_t P9N2_EQ_5_HANG_PULSE_4_REG                                   = 0x150F0024ull;

static const uint64_t P9N2_EX_HANG_PULSE_4_REG                                     = 0x200F0024ull;
//DUPS: 210F0024,
static const uint64_t P9N2_EX_0_HANG_PULSE_4_REG                                   = 0x200F0024ull;
//DUPS: 210F0024,
static const uint64_t P9N2_EX_1_HANG_PULSE_4_REG                                   = 0x220F0024ull;
//DUPS: 220F0024,
static const uint64_t P9N2_EX_2_HANG_PULSE_4_REG                                   = 0x240F0024ull;
//DUPS: 250F0024,
static const uint64_t P9N2_EX_3_HANG_PULSE_4_REG                                   = 0x260F0024ull;
//DUPS: 270F0024,
static const uint64_t P9N2_EX_4_HANG_PULSE_4_REG                                   = 0x280F0024ull;
//DUPS: 290F0024,
static const uint64_t P9N2_EX_5_HANG_PULSE_4_REG                                   = 0x2A0F0024ull;
//DUPS: 2B0F0024,
static const uint64_t P9N2_EX_6_HANG_PULSE_4_REG                                   = 0x2C0F0024ull;
//DUPS: 2D0F0024,
static const uint64_t P9N2_EX_7_HANG_PULSE_4_REG                                   = 0x2E0F0024ull;
//DUPS: 2F0F0024,
static const uint64_t P9N2_EX_8_HANG_PULSE_4_REG                                   = 0x300F0024ull;
//DUPS: 310F0024,
static const uint64_t P9N2_EX_9_HANG_PULSE_4_REG                                   = 0x320F0024ull;
//DUPS: 330F0024,
static const uint64_t P9N2_EX_10_HANG_PULSE_4_REG                                  = 0x340F0024ull;
//DUPS: 350F0024,
static const uint64_t P9N2_EX_11_HANG_PULSE_4_REG                                  = 0x360F0024ull;
//DUPS: 370F0024,

static const uint64_t P9N2_C_HANG_PULSE_5_REG                                      = 0x200F0025ull;

static const uint64_t P9N2_C_0_HANG_PULSE_5_REG                                    = 0x200F0025ull;

static const uint64_t P9N2_C_1_HANG_PULSE_5_REG                                    = 0x210F0025ull;

static const uint64_t P9N2_C_2_HANG_PULSE_5_REG                                    = 0x220F0025ull;

static const uint64_t P9N2_C_3_HANG_PULSE_5_REG                                    = 0x230F0025ull;

static const uint64_t P9N2_C_4_HANG_PULSE_5_REG                                    = 0x240F0025ull;

static const uint64_t P9N2_C_5_HANG_PULSE_5_REG                                    = 0x250F0025ull;

static const uint64_t P9N2_C_6_HANG_PULSE_5_REG                                    = 0x260F0025ull;

static const uint64_t P9N2_C_7_HANG_PULSE_5_REG                                    = 0x270F0025ull;

static const uint64_t P9N2_C_8_HANG_PULSE_5_REG                                    = 0x280F0025ull;

static const uint64_t P9N2_C_9_HANG_PULSE_5_REG                                    = 0x290F0025ull;

static const uint64_t P9N2_C_10_HANG_PULSE_5_REG                                   = 0x2A0F0025ull;

static const uint64_t P9N2_C_11_HANG_PULSE_5_REG                                   = 0x2B0F0025ull;

static const uint64_t P9N2_C_12_HANG_PULSE_5_REG                                   = 0x2C0F0025ull;

static const uint64_t P9N2_C_13_HANG_PULSE_5_REG                                   = 0x2D0F0025ull;

static const uint64_t P9N2_C_14_HANG_PULSE_5_REG                                   = 0x2E0F0025ull;

static const uint64_t P9N2_C_15_HANG_PULSE_5_REG                                   = 0x2F0F0025ull;

static const uint64_t P9N2_C_16_HANG_PULSE_5_REG                                   = 0x300F0025ull;

static const uint64_t P9N2_C_17_HANG_PULSE_5_REG                                   = 0x310F0025ull;

static const uint64_t P9N2_C_18_HANG_PULSE_5_REG                                   = 0x320F0025ull;

static const uint64_t P9N2_C_19_HANG_PULSE_5_REG                                   = 0x330F0025ull;

static const uint64_t P9N2_C_20_HANG_PULSE_5_REG                                   = 0x340F0025ull;

static const uint64_t P9N2_C_21_HANG_PULSE_5_REG                                   = 0x350F0025ull;

static const uint64_t P9N2_C_22_HANG_PULSE_5_REG                                   = 0x360F0025ull;

static const uint64_t P9N2_C_23_HANG_PULSE_5_REG                                   = 0x370F0025ull;

static const uint64_t P9N2_EQ_HANG_PULSE_5_REG                                     = 0x100F0025ull;

static const uint64_t P9N2_EQ_0_HANG_PULSE_5_REG                                   = 0x100F0025ull;

static const uint64_t P9N2_EQ_1_HANG_PULSE_5_REG                                   = 0x110F0025ull;

static const uint64_t P9N2_EQ_2_HANG_PULSE_5_REG                                   = 0x120F0025ull;

static const uint64_t P9N2_EQ_3_HANG_PULSE_5_REG                                   = 0x130F0025ull;

static const uint64_t P9N2_EQ_4_HANG_PULSE_5_REG                                   = 0x140F0025ull;

static const uint64_t P9N2_EQ_5_HANG_PULSE_5_REG                                   = 0x150F0025ull;

static const uint64_t P9N2_EX_HANG_PULSE_5_REG                                     = 0x200F0025ull;
//DUPS: 210F0025,
static const uint64_t P9N2_EX_0_HANG_PULSE_5_REG                                   = 0x200F0025ull;
//DUPS: 210F0025,
static const uint64_t P9N2_EX_1_HANG_PULSE_5_REG                                   = 0x220F0025ull;
//DUPS: 220F0025,
static const uint64_t P9N2_EX_2_HANG_PULSE_5_REG                                   = 0x240F0025ull;
//DUPS: 250F0025,
static const uint64_t P9N2_EX_3_HANG_PULSE_5_REG                                   = 0x260F0025ull;
//DUPS: 270F0025,
static const uint64_t P9N2_EX_4_HANG_PULSE_5_REG                                   = 0x280F0025ull;
//DUPS: 290F0025,
static const uint64_t P9N2_EX_5_HANG_PULSE_5_REG                                   = 0x2A0F0025ull;
//DUPS: 2B0F0025,
static const uint64_t P9N2_EX_6_HANG_PULSE_5_REG                                   = 0x2C0F0025ull;
//DUPS: 2D0F0025,
static const uint64_t P9N2_EX_7_HANG_PULSE_5_REG                                   = 0x2E0F0025ull;
//DUPS: 2F0F0025,
static const uint64_t P9N2_EX_8_HANG_PULSE_5_REG                                   = 0x300F0025ull;
//DUPS: 310F0025,
static const uint64_t P9N2_EX_9_HANG_PULSE_5_REG                                   = 0x320F0025ull;
//DUPS: 330F0025,
static const uint64_t P9N2_EX_10_HANG_PULSE_5_REG                                  = 0x340F0025ull;
//DUPS: 350F0025,
static const uint64_t P9N2_EX_11_HANG_PULSE_5_REG                                  = 0x360F0025ull;
//DUPS: 370F0025,

static const uint64_t P9N2_C_HANG_PULSE_6_REG                                      = 0x200F0026ull;

static const uint64_t P9N2_C_0_HANG_PULSE_6_REG                                    = 0x200F0026ull;

static const uint64_t P9N2_C_1_HANG_PULSE_6_REG                                    = 0x210F0026ull;

static const uint64_t P9N2_C_2_HANG_PULSE_6_REG                                    = 0x220F0026ull;

static const uint64_t P9N2_C_3_HANG_PULSE_6_REG                                    = 0x230F0026ull;

static const uint64_t P9N2_C_4_HANG_PULSE_6_REG                                    = 0x240F0026ull;

static const uint64_t P9N2_C_5_HANG_PULSE_6_REG                                    = 0x250F0026ull;

static const uint64_t P9N2_C_6_HANG_PULSE_6_REG                                    = 0x260F0026ull;

static const uint64_t P9N2_C_7_HANG_PULSE_6_REG                                    = 0x270F0026ull;

static const uint64_t P9N2_C_8_HANG_PULSE_6_REG                                    = 0x280F0026ull;

static const uint64_t P9N2_C_9_HANG_PULSE_6_REG                                    = 0x290F0026ull;

static const uint64_t P9N2_C_10_HANG_PULSE_6_REG                                   = 0x2A0F0026ull;

static const uint64_t P9N2_C_11_HANG_PULSE_6_REG                                   = 0x2B0F0026ull;

static const uint64_t P9N2_C_12_HANG_PULSE_6_REG                                   = 0x2C0F0026ull;

static const uint64_t P9N2_C_13_HANG_PULSE_6_REG                                   = 0x2D0F0026ull;

static const uint64_t P9N2_C_14_HANG_PULSE_6_REG                                   = 0x2E0F0026ull;

static const uint64_t P9N2_C_15_HANG_PULSE_6_REG                                   = 0x2F0F0026ull;

static const uint64_t P9N2_C_16_HANG_PULSE_6_REG                                   = 0x300F0026ull;

static const uint64_t P9N2_C_17_HANG_PULSE_6_REG                                   = 0x310F0026ull;

static const uint64_t P9N2_C_18_HANG_PULSE_6_REG                                   = 0x320F0026ull;

static const uint64_t P9N2_C_19_HANG_PULSE_6_REG                                   = 0x330F0026ull;

static const uint64_t P9N2_C_20_HANG_PULSE_6_REG                                   = 0x340F0026ull;

static const uint64_t P9N2_C_21_HANG_PULSE_6_REG                                   = 0x350F0026ull;

static const uint64_t P9N2_C_22_HANG_PULSE_6_REG                                   = 0x360F0026ull;

static const uint64_t P9N2_C_23_HANG_PULSE_6_REG                                   = 0x370F0026ull;

static const uint64_t P9N2_EQ_HANG_PULSE_6_REG                                     = 0x100F0026ull;

static const uint64_t P9N2_EQ_0_HANG_PULSE_6_REG                                   = 0x100F0026ull;

static const uint64_t P9N2_EQ_1_HANG_PULSE_6_REG                                   = 0x110F0026ull;

static const uint64_t P9N2_EQ_2_HANG_PULSE_6_REG                                   = 0x120F0026ull;

static const uint64_t P9N2_EQ_3_HANG_PULSE_6_REG                                   = 0x130F0026ull;

static const uint64_t P9N2_EQ_4_HANG_PULSE_6_REG                                   = 0x140F0026ull;

static const uint64_t P9N2_EQ_5_HANG_PULSE_6_REG                                   = 0x150F0026ull;

static const uint64_t P9N2_EX_HANG_PULSE_6_REG                                     = 0x200F0026ull;
//DUPS: 210F0026,
static const uint64_t P9N2_EX_0_HANG_PULSE_6_REG                                   = 0x200F0026ull;
//DUPS: 210F0026,
static const uint64_t P9N2_EX_1_HANG_PULSE_6_REG                                   = 0x220F0026ull;
//DUPS: 220F0026,
static const uint64_t P9N2_EX_2_HANG_PULSE_6_REG                                   = 0x240F0026ull;
//DUPS: 250F0026,
static const uint64_t P9N2_EX_3_HANG_PULSE_6_REG                                   = 0x260F0026ull;
//DUPS: 270F0026,
static const uint64_t P9N2_EX_4_HANG_PULSE_6_REG                                   = 0x280F0026ull;
//DUPS: 290F0026,
static const uint64_t P9N2_EX_5_HANG_PULSE_6_REG                                   = 0x2A0F0026ull;
//DUPS: 2B0F0026,
static const uint64_t P9N2_EX_6_HANG_PULSE_6_REG                                   = 0x2C0F0026ull;
//DUPS: 2D0F0026,
static const uint64_t P9N2_EX_7_HANG_PULSE_6_REG                                   = 0x2E0F0026ull;
//DUPS: 2F0F0026,
static const uint64_t P9N2_EX_8_HANG_PULSE_6_REG                                   = 0x300F0026ull;
//DUPS: 310F0026,
static const uint64_t P9N2_EX_9_HANG_PULSE_6_REG                                   = 0x320F0026ull;
//DUPS: 330F0026,
static const uint64_t P9N2_EX_10_HANG_PULSE_6_REG                                  = 0x340F0026ull;
//DUPS: 350F0026,
static const uint64_t P9N2_EX_11_HANG_PULSE_6_REG                                  = 0x360F0026ull;
//DUPS: 370F0026,

static const uint64_t P9N2_C_HEARTBEAT_REG                                         = 0x200F0018ull;

static const uint64_t P9N2_C_0_HEARTBEAT_REG                                       = 0x200F0018ull;

static const uint64_t P9N2_C_1_HEARTBEAT_REG                                       = 0x210F0018ull;

static const uint64_t P9N2_C_2_HEARTBEAT_REG                                       = 0x220F0018ull;

static const uint64_t P9N2_C_3_HEARTBEAT_REG                                       = 0x230F0018ull;

static const uint64_t P9N2_C_4_HEARTBEAT_REG                                       = 0x240F0018ull;

static const uint64_t P9N2_C_5_HEARTBEAT_REG                                       = 0x250F0018ull;

static const uint64_t P9N2_C_6_HEARTBEAT_REG                                       = 0x260F0018ull;

static const uint64_t P9N2_C_7_HEARTBEAT_REG                                       = 0x270F0018ull;

static const uint64_t P9N2_C_8_HEARTBEAT_REG                                       = 0x280F0018ull;

static const uint64_t P9N2_C_9_HEARTBEAT_REG                                       = 0x290F0018ull;

static const uint64_t P9N2_C_10_HEARTBEAT_REG                                      = 0x2A0F0018ull;

static const uint64_t P9N2_C_11_HEARTBEAT_REG                                      = 0x2B0F0018ull;

static const uint64_t P9N2_C_12_HEARTBEAT_REG                                      = 0x2C0F0018ull;

static const uint64_t P9N2_C_13_HEARTBEAT_REG                                      = 0x2D0F0018ull;

static const uint64_t P9N2_C_14_HEARTBEAT_REG                                      = 0x2E0F0018ull;

static const uint64_t P9N2_C_15_HEARTBEAT_REG                                      = 0x2F0F0018ull;

static const uint64_t P9N2_C_16_HEARTBEAT_REG                                      = 0x300F0018ull;

static const uint64_t P9N2_C_17_HEARTBEAT_REG                                      = 0x310F0018ull;

static const uint64_t P9N2_C_18_HEARTBEAT_REG                                      = 0x320F0018ull;

static const uint64_t P9N2_C_19_HEARTBEAT_REG                                      = 0x330F0018ull;

static const uint64_t P9N2_C_20_HEARTBEAT_REG                                      = 0x340F0018ull;

static const uint64_t P9N2_C_21_HEARTBEAT_REG                                      = 0x350F0018ull;

static const uint64_t P9N2_C_22_HEARTBEAT_REG                                      = 0x360F0018ull;

static const uint64_t P9N2_C_23_HEARTBEAT_REG                                      = 0x370F0018ull;

static const uint64_t P9N2_EQ_HEARTBEAT_REG                                        = 0x100F0018ull;

static const uint64_t P9N2_EQ_0_HEARTBEAT_REG                                      = 0x100F0018ull;

static const uint64_t P9N2_EQ_1_HEARTBEAT_REG                                      = 0x110F0018ull;

static const uint64_t P9N2_EQ_2_HEARTBEAT_REG                                      = 0x120F0018ull;

static const uint64_t P9N2_EQ_3_HEARTBEAT_REG                                      = 0x130F0018ull;

static const uint64_t P9N2_EQ_4_HEARTBEAT_REG                                      = 0x140F0018ull;

static const uint64_t P9N2_EQ_5_HEARTBEAT_REG                                      = 0x150F0018ull;

static const uint64_t P9N2_EX_HEARTBEAT_REG                                        = 0x200F0018ull;
//DUPS: 210F0018,
static const uint64_t P9N2_EX_0_HEARTBEAT_REG                                      = 0x200F0018ull;
//DUPS: 210F0018,
static const uint64_t P9N2_EX_1_HEARTBEAT_REG                                      = 0x220F0018ull;
//DUPS: 220F0018,
static const uint64_t P9N2_EX_2_HEARTBEAT_REG                                      = 0x240F0018ull;
//DUPS: 250F0018,
static const uint64_t P9N2_EX_3_HEARTBEAT_REG                                      = 0x260F0018ull;
//DUPS: 270F0018,
static const uint64_t P9N2_EX_4_HEARTBEAT_REG                                      = 0x280F0018ull;
//DUPS: 290F0018,
static const uint64_t P9N2_EX_5_HEARTBEAT_REG                                      = 0x2A0F0018ull;
//DUPS: 2B0F0018,
static const uint64_t P9N2_EX_6_HEARTBEAT_REG                                      = 0x2C0F0018ull;
//DUPS: 2D0F0018,
static const uint64_t P9N2_EX_7_HEARTBEAT_REG                                      = 0x2E0F0018ull;
//DUPS: 2F0F0018,
static const uint64_t P9N2_EX_8_HEARTBEAT_REG                                      = 0x300F0018ull;
//DUPS: 310F0018,
static const uint64_t P9N2_EX_9_HEARTBEAT_REG                                      = 0x320F0018ull;
//DUPS: 330F0018,
static const uint64_t P9N2_EX_10_HEARTBEAT_REG                                     = 0x340F0018ull;
//DUPS: 350F0018,
static const uint64_t P9N2_EX_11_HEARTBEAT_REG                                     = 0x360F0018ull;
//DUPS: 370F0018,

static const uint64_t P9N2_C_HID                                                   = 0x20010A01ull;

static const uint64_t P9N2_C_0_HID                                                 = 0x20010A01ull;

static const uint64_t P9N2_C_1_HID                                                 = 0x21010A01ull;

static const uint64_t P9N2_C_2_HID                                                 = 0x22010A01ull;

static const uint64_t P9N2_C_3_HID                                                 = 0x23010A01ull;

static const uint64_t P9N2_C_4_HID                                                 = 0x24010A01ull;

static const uint64_t P9N2_C_5_HID                                                 = 0x25010A01ull;

static const uint64_t P9N2_C_6_HID                                                 = 0x26010A01ull;

static const uint64_t P9N2_C_7_HID                                                 = 0x27010A01ull;

static const uint64_t P9N2_C_8_HID                                                 = 0x28010A01ull;

static const uint64_t P9N2_C_9_HID                                                 = 0x29010A01ull;

static const uint64_t P9N2_C_10_HID                                                = 0x2A010A01ull;

static const uint64_t P9N2_C_11_HID                                                = 0x2B010A01ull;

static const uint64_t P9N2_C_12_HID                                                = 0x2C010A01ull;

static const uint64_t P9N2_C_13_HID                                                = 0x2D010A01ull;

static const uint64_t P9N2_C_14_HID                                                = 0x2E010A01ull;

static const uint64_t P9N2_C_15_HID                                                = 0x2F010A01ull;

static const uint64_t P9N2_C_16_HID                                                = 0x30010A01ull;

static const uint64_t P9N2_C_17_HID                                                = 0x31010A01ull;

static const uint64_t P9N2_C_18_HID                                                = 0x32010A01ull;

static const uint64_t P9N2_C_19_HID                                                = 0x33010A01ull;

static const uint64_t P9N2_C_20_HID                                                = 0x34010A01ull;

static const uint64_t P9N2_C_21_HID                                                = 0x35010A01ull;

static const uint64_t P9N2_C_22_HID                                                = 0x36010A01ull;

static const uint64_t P9N2_C_23_HID                                                = 0x37010A01ull;

static const uint64_t P9N2_EX_0_L2_HID                                             = 0x20010A01ull;
//DUPS: 21010A01,
static const uint64_t P9N2_EX_10_L2_HID                                            = 0x34010A01ull;
//DUPS: 35010A01,
static const uint64_t P9N2_EX_11_L2_HID                                            = 0x36010A01ull;
//DUPS: 37010A01,
static const uint64_t P9N2_EX_1_L2_HID                                             = 0x22010A01ull;
//DUPS: 23010A01,
static const uint64_t P9N2_EX_2_L2_HID                                             = 0x24010A01ull;
//DUPS: 25010A01,
static const uint64_t P9N2_EX_3_L2_HID                                             = 0x26010A01ull;
//DUPS: 27010A01,
static const uint64_t P9N2_EX_4_L2_HID                                             = 0x28010A01ull;
//DUPS: 29010A01,
static const uint64_t P9N2_EX_5_L2_HID                                             = 0x2A010A01ull;
//DUPS: 2B010A01,
static const uint64_t P9N2_EX_6_L2_HID                                             = 0x2C010A01ull;
//DUPS: 2D010A01,
static const uint64_t P9N2_EX_7_L2_HID                                             = 0x2F010A01ull;
//DUPS: 2F010A01,
static const uint64_t P9N2_EX_8_L2_HID                                             = 0x30010A01ull;
//DUPS: 31010A01,
static const uint64_t P9N2_EX_9_L2_HID                                             = 0x32010A01ull;
//DUPS: 33010A01,
static const uint64_t P9N2_EX_L2_HID                                               = 0x20010A01ull;
//DUPS: 21010A01,

static const uint64_t P9N2_C_HMEER                                                 = 0x20010A96ull;

static const uint64_t P9N2_C_0_HMEER                                               = 0x20010A96ull;

static const uint64_t P9N2_C_1_HMEER                                               = 0x21010A96ull;

static const uint64_t P9N2_C_2_HMEER                                               = 0x22010A96ull;

static const uint64_t P9N2_C_3_HMEER                                               = 0x23010A96ull;

static const uint64_t P9N2_C_4_HMEER                                               = 0x24010A96ull;

static const uint64_t P9N2_C_5_HMEER                                               = 0x25010A96ull;

static const uint64_t P9N2_C_6_HMEER                                               = 0x26010A96ull;

static const uint64_t P9N2_C_7_HMEER                                               = 0x27010A96ull;

static const uint64_t P9N2_C_8_HMEER                                               = 0x28010A96ull;

static const uint64_t P9N2_C_9_HMEER                                               = 0x29010A96ull;

static const uint64_t P9N2_C_10_HMEER                                              = 0x2A010A96ull;

static const uint64_t P9N2_C_11_HMEER                                              = 0x2B010A96ull;

static const uint64_t P9N2_C_12_HMEER                                              = 0x2C010A96ull;

static const uint64_t P9N2_C_13_HMEER                                              = 0x2D010A96ull;

static const uint64_t P9N2_C_14_HMEER                                              = 0x2E010A96ull;

static const uint64_t P9N2_C_15_HMEER                                              = 0x2F010A96ull;

static const uint64_t P9N2_C_16_HMEER                                              = 0x30010A96ull;

static const uint64_t P9N2_C_17_HMEER                                              = 0x31010A96ull;

static const uint64_t P9N2_C_18_HMEER                                              = 0x32010A96ull;

static const uint64_t P9N2_C_19_HMEER                                              = 0x33010A96ull;

static const uint64_t P9N2_C_20_HMEER                                              = 0x34010A96ull;

static const uint64_t P9N2_C_21_HMEER                                              = 0x35010A96ull;

static const uint64_t P9N2_C_22_HMEER                                              = 0x36010A96ull;

static const uint64_t P9N2_C_23_HMEER                                              = 0x37010A96ull;

static const uint64_t P9N2_EX_0_L2_HMEER                                           = 0x20010A96ull;
//DUPS: 20010A96,
static const uint64_t P9N2_EX_10_L2_HMEER                                          = 0x34010A96ull;
//DUPS: 34010A96,
static const uint64_t P9N2_EX_11_L2_HMEER                                          = 0x36010A96ull;
//DUPS: 36010A96,
static const uint64_t P9N2_EX_1_L2_HMEER                                           = 0x22010A96ull;
//DUPS: 22010A96,
static const uint64_t P9N2_EX_2_L2_HMEER                                           = 0x24010A96ull;
//DUPS: 24010A96,
static const uint64_t P9N2_EX_3_L2_HMEER                                           = 0x26010A96ull;
//DUPS: 26010A96,
static const uint64_t P9N2_EX_4_L2_HMEER                                           = 0x28010A96ull;
//DUPS: 28010A96,
static const uint64_t P9N2_EX_5_L2_HMEER                                           = 0x2B010A96ull;
//DUPS: 2A010A96,
static const uint64_t P9N2_EX_6_L2_HMEER                                           = 0x2D010A96ull;
//DUPS: 2C010A96,
static const uint64_t P9N2_EX_7_L2_HMEER                                           = 0x2F010A96ull;
//DUPS: 2E010A96,
static const uint64_t P9N2_EX_8_L2_HMEER                                           = 0x30010A96ull;
//DUPS: 30010A96,
static const uint64_t P9N2_EX_9_L2_HMEER                                           = 0x32010A96ull;
//DUPS: 32010A96,
static const uint64_t P9N2_EX_L2_HMEER                                             = 0x20010A96ull;
//DUPS: 20010A96,

static const uint64_t P9N2_C_HOSTATTN                                              = 0x20040009ull;

static const uint64_t P9N2_C_0_HOSTATTN                                            = 0x20040009ull;

static const uint64_t P9N2_C_1_HOSTATTN                                            = 0x21040009ull;

static const uint64_t P9N2_C_2_HOSTATTN                                            = 0x22040009ull;

static const uint64_t P9N2_C_3_HOSTATTN                                            = 0x23040009ull;

static const uint64_t P9N2_C_4_HOSTATTN                                            = 0x24040009ull;

static const uint64_t P9N2_C_5_HOSTATTN                                            = 0x25040009ull;

static const uint64_t P9N2_C_6_HOSTATTN                                            = 0x26040009ull;

static const uint64_t P9N2_C_7_HOSTATTN                                            = 0x27040009ull;

static const uint64_t P9N2_C_8_HOSTATTN                                            = 0x28040009ull;

static const uint64_t P9N2_C_9_HOSTATTN                                            = 0x29040009ull;

static const uint64_t P9N2_C_10_HOSTATTN                                           = 0x2A040009ull;

static const uint64_t P9N2_C_11_HOSTATTN                                           = 0x2B040009ull;

static const uint64_t P9N2_C_12_HOSTATTN                                           = 0x2C040009ull;

static const uint64_t P9N2_C_13_HOSTATTN                                           = 0x2D040009ull;

static const uint64_t P9N2_C_14_HOSTATTN                                           = 0x2E040009ull;

static const uint64_t P9N2_C_15_HOSTATTN                                           = 0x2F040009ull;

static const uint64_t P9N2_C_16_HOSTATTN                                           = 0x30040009ull;

static const uint64_t P9N2_C_17_HOSTATTN                                           = 0x31040009ull;

static const uint64_t P9N2_C_18_HOSTATTN                                           = 0x32040009ull;

static const uint64_t P9N2_C_19_HOSTATTN                                           = 0x33040009ull;

static const uint64_t P9N2_C_20_HOSTATTN                                           = 0x34040009ull;

static const uint64_t P9N2_C_21_HOSTATTN                                           = 0x35040009ull;

static const uint64_t P9N2_C_22_HOSTATTN                                           = 0x36040009ull;

static const uint64_t P9N2_C_23_HOSTATTN                                           = 0x37040009ull;

static const uint64_t P9N2_EQ_HOSTATTN                                             = 0x10040009ull;

static const uint64_t P9N2_EQ_0_HOSTATTN                                           = 0x10040009ull;

static const uint64_t P9N2_EQ_1_HOSTATTN                                           = 0x11040009ull;

static const uint64_t P9N2_EQ_2_HOSTATTN                                           = 0x12040009ull;

static const uint64_t P9N2_EQ_3_HOSTATTN                                           = 0x13040009ull;

static const uint64_t P9N2_EQ_4_HOSTATTN                                           = 0x14040009ull;

static const uint64_t P9N2_EQ_5_HOSTATTN                                           = 0x15040009ull;

static const uint64_t P9N2_EX_HOSTATTN                                             = 0x20040009ull;
//DUPS: 21040009,
static const uint64_t P9N2_EX_0_HOSTATTN                                           = 0x20040009ull;
//DUPS: 21040009,
static const uint64_t P9N2_EX_1_HOSTATTN                                           = 0x22040009ull;
//DUPS: 23040009,
static const uint64_t P9N2_EX_2_HOSTATTN                                           = 0x24040009ull;
//DUPS: 25040009,
static const uint64_t P9N2_EX_3_HOSTATTN                                           = 0x26040009ull;
//DUPS: 27040009,
static const uint64_t P9N2_EX_4_HOSTATTN                                           = 0x28040009ull;
//DUPS: 29040009,
static const uint64_t P9N2_EX_5_HOSTATTN                                           = 0x2A040009ull;
//DUPS: 2B040009,
static const uint64_t P9N2_EX_6_HOSTATTN                                           = 0x2C040009ull;
//DUPS: 2D040009,
static const uint64_t P9N2_EX_7_HOSTATTN                                           = 0x2F040009ull;
//DUPS: 2F040009,
static const uint64_t P9N2_EX_8_HOSTATTN                                           = 0x30040009ull;
//DUPS: 31040009,
static const uint64_t P9N2_EX_9_HOSTATTN                                           = 0x32040009ull;
//DUPS: 33040009,
static const uint64_t P9N2_EX_10_HOSTATTN                                          = 0x34040009ull;
//DUPS: 35040009,
static const uint64_t P9N2_EX_11_HOSTATTN                                          = 0x36040009ull;
//DUPS: 37040009,

static const uint64_t P9N2_C_HOSTATTN_MASK                                         = 0x2004001Aull;

static const uint64_t P9N2_C_0_HOSTATTN_MASK                                       = 0x2004001Aull;

static const uint64_t P9N2_C_1_HOSTATTN_MASK                                       = 0x2104001Aull;

static const uint64_t P9N2_C_2_HOSTATTN_MASK                                       = 0x2204001Aull;

static const uint64_t P9N2_C_3_HOSTATTN_MASK                                       = 0x2304001Aull;

static const uint64_t P9N2_C_4_HOSTATTN_MASK                                       = 0x2404001Aull;

static const uint64_t P9N2_C_5_HOSTATTN_MASK                                       = 0x2504001Aull;

static const uint64_t P9N2_C_6_HOSTATTN_MASK                                       = 0x2604001Aull;

static const uint64_t P9N2_C_7_HOSTATTN_MASK                                       = 0x2704001Aull;

static const uint64_t P9N2_C_8_HOSTATTN_MASK                                       = 0x2804001Aull;

static const uint64_t P9N2_C_9_HOSTATTN_MASK                                       = 0x2904001Aull;

static const uint64_t P9N2_C_10_HOSTATTN_MASK                                      = 0x2A04001Aull;

static const uint64_t P9N2_C_11_HOSTATTN_MASK                                      = 0x2B04001Aull;

static const uint64_t P9N2_C_12_HOSTATTN_MASK                                      = 0x2C04001Aull;

static const uint64_t P9N2_C_13_HOSTATTN_MASK                                      = 0x2D04001Aull;

static const uint64_t P9N2_C_14_HOSTATTN_MASK                                      = 0x2E04001Aull;

static const uint64_t P9N2_C_15_HOSTATTN_MASK                                      = 0x2F04001Aull;

static const uint64_t P9N2_C_16_HOSTATTN_MASK                                      = 0x3004001Aull;

static const uint64_t P9N2_C_17_HOSTATTN_MASK                                      = 0x3104001Aull;

static const uint64_t P9N2_C_18_HOSTATTN_MASK                                      = 0x3204001Aull;

static const uint64_t P9N2_C_19_HOSTATTN_MASK                                      = 0x3304001Aull;

static const uint64_t P9N2_C_20_HOSTATTN_MASK                                      = 0x3404001Aull;

static const uint64_t P9N2_C_21_HOSTATTN_MASK                                      = 0x3504001Aull;

static const uint64_t P9N2_C_22_HOSTATTN_MASK                                      = 0x3604001Aull;

static const uint64_t P9N2_C_23_HOSTATTN_MASK                                      = 0x3704001Aull;

static const uint64_t P9N2_EQ_HOSTATTN_MASK                                        = 0x1004001Aull;

static const uint64_t P9N2_EQ_0_HOSTATTN_MASK                                      = 0x1004001Aull;

static const uint64_t P9N2_EQ_1_HOSTATTN_MASK                                      = 0x1104001Aull;

static const uint64_t P9N2_EQ_2_HOSTATTN_MASK                                      = 0x1204001Aull;

static const uint64_t P9N2_EQ_3_HOSTATTN_MASK                                      = 0x1304001Aull;

static const uint64_t P9N2_EQ_4_HOSTATTN_MASK                                      = 0x1404001Aull;

static const uint64_t P9N2_EQ_5_HOSTATTN_MASK                                      = 0x1504001Aull;

static const uint64_t P9N2_EX_HOSTATTN_MASK                                        = 0x2004001Aull;
//DUPS: 2104001A,
static const uint64_t P9N2_EX_0_HOSTATTN_MASK                                      = 0x2004001Aull;
//DUPS: 2104001A,
static const uint64_t P9N2_EX_1_HOSTATTN_MASK                                      = 0x2204001Aull;
//DUPS: 2304001A,
static const uint64_t P9N2_EX_2_HOSTATTN_MASK                                      = 0x2404001Aull;
//DUPS: 2504001A,
static const uint64_t P9N2_EX_3_HOSTATTN_MASK                                      = 0x2604001Aull;
//DUPS: 2704001A,
static const uint64_t P9N2_EX_4_HOSTATTN_MASK                                      = 0x2804001Aull;
//DUPS: 2904001A,
static const uint64_t P9N2_EX_5_HOSTATTN_MASK                                      = 0x2A04001Aull;
//DUPS: 2B04001A,
static const uint64_t P9N2_EX_6_HOSTATTN_MASK                                      = 0x2C04001Aull;
//DUPS: 2D04001A,
static const uint64_t P9N2_EX_7_HOSTATTN_MASK                                      = 0x2F04001Aull;
//DUPS: 2F04001A,
static const uint64_t P9N2_EX_8_HOSTATTN_MASK                                      = 0x3004001Aull;
//DUPS: 3104001A,
static const uint64_t P9N2_EX_9_HOSTATTN_MASK                                      = 0x3204001Aull;
//DUPS: 3304001A,
static const uint64_t P9N2_EX_10_HOSTATTN_MASK                                     = 0x3404001Aull;
//DUPS: 3504001A,
static const uint64_t P9N2_EX_11_HOSTATTN_MASK                                     = 0x3604001Aull;
//DUPS: 3704001A,

static const uint64_t P9N2_C_HRMOR                                                 = 0x20010AB9ull;

static const uint64_t P9N2_C_0_HRMOR                                               = 0x20010AB9ull;

static const uint64_t P9N2_C_1_HRMOR                                               = 0x21010AB9ull;

static const uint64_t P9N2_C_2_HRMOR                                               = 0x22010AB9ull;

static const uint64_t P9N2_C_3_HRMOR                                               = 0x23010AB9ull;

static const uint64_t P9N2_C_4_HRMOR                                               = 0x24010AB9ull;

static const uint64_t P9N2_C_5_HRMOR                                               = 0x25010AB9ull;

static const uint64_t P9N2_C_6_HRMOR                                               = 0x26010AB9ull;

static const uint64_t P9N2_C_7_HRMOR                                               = 0x27010AB9ull;

static const uint64_t P9N2_C_8_HRMOR                                               = 0x28010AB9ull;

static const uint64_t P9N2_C_9_HRMOR                                               = 0x29010AB9ull;

static const uint64_t P9N2_C_10_HRMOR                                              = 0x2A010AB9ull;

static const uint64_t P9N2_C_11_HRMOR                                              = 0x2B010AB9ull;

static const uint64_t P9N2_C_12_HRMOR                                              = 0x2C010AB9ull;

static const uint64_t P9N2_C_13_HRMOR                                              = 0x2D010AB9ull;

static const uint64_t P9N2_C_14_HRMOR                                              = 0x2E010AB9ull;

static const uint64_t P9N2_C_15_HRMOR                                              = 0x2F010AB9ull;

static const uint64_t P9N2_C_16_HRMOR                                              = 0x30010AB9ull;

static const uint64_t P9N2_C_17_HRMOR                                              = 0x31010AB9ull;

static const uint64_t P9N2_C_18_HRMOR                                              = 0x32010AB9ull;

static const uint64_t P9N2_C_19_HRMOR                                              = 0x33010AB9ull;

static const uint64_t P9N2_C_20_HRMOR                                              = 0x34010AB9ull;

static const uint64_t P9N2_C_21_HRMOR                                              = 0x35010AB9ull;

static const uint64_t P9N2_C_22_HRMOR                                              = 0x36010AB9ull;

static const uint64_t P9N2_C_23_HRMOR                                              = 0x37010AB9ull;

static const uint64_t P9N2_EX_HRMOR                                                = 0x20010AB9ull;
//DUPS: 21010AB9,
static const uint64_t P9N2_EX_0_HRMOR                                              = 0x20010AB9ull;
//DUPS: 21010AB9,
static const uint64_t P9N2_EX_1_HRMOR                                              = 0x22010AB9ull;
//DUPS: 23010AB9,
static const uint64_t P9N2_EX_2_HRMOR                                              = 0x24010AB9ull;
//DUPS: 25010AB9,
static const uint64_t P9N2_EX_3_HRMOR                                              = 0x26010AB9ull;
//DUPS: 27010AB9,
static const uint64_t P9N2_EX_4_HRMOR                                              = 0x28010AB9ull;
//DUPS: 29010AB9,
static const uint64_t P9N2_EX_5_HRMOR                                              = 0x2A010AB9ull;
//DUPS: 2B010AB9,
static const uint64_t P9N2_EX_6_HRMOR                                              = 0x2C010AB9ull;
//DUPS: 2D010AB9,
static const uint64_t P9N2_EX_7_HRMOR                                              = 0x2F010AB9ull;
//DUPS: 2F010AB9,
static const uint64_t P9N2_EX_8_HRMOR                                              = 0x30010AB9ull;
//DUPS: 31010AB9,
static const uint64_t P9N2_EX_9_HRMOR                                              = 0x32010AB9ull;
//DUPS: 33010AB9,
static const uint64_t P9N2_EX_10_HRMOR                                             = 0x34010AB9ull;
//DUPS: 35010AB9,
static const uint64_t P9N2_EX_11_HRMOR                                             = 0x36010AB9ull;
//DUPS: 37010AB9,

static const uint64_t P9N2_EQ_HTM_CSEL                                             = 0x10012207ull;
//DUPS: 10012707, 10012207, 10012307,
static const uint64_t P9N2_EQ_0_HTM_CSEL                                           = 0x10012207ull;
//DUPS: 10012707, 10012207, 10012307,
static const uint64_t P9N2_EQ_1_HTM_CSEL                                           = 0x11012207ull;
//DUPS: 11012707, 11012207, 11012307,
static const uint64_t P9N2_EQ_2_HTM_CSEL                                           = 0x12012207ull;
//DUPS: 12012707, 12012207, 12012307,
static const uint64_t P9N2_EQ_3_HTM_CSEL                                           = 0x13012207ull;
//DUPS: 13012707, 13012207, 13012307,
static const uint64_t P9N2_EQ_4_HTM_CSEL                                           = 0x14012207ull;
//DUPS: 14012707, 14012207, 14012307,
static const uint64_t P9N2_EQ_5_HTM_CSEL                                           = 0x15012207ull;
//DUPS: 15012707, 15012207, 15012307,
static const uint64_t P9N2_EX_HTM_CSEL                                             = 0x10012207ull;
//DUPS: 10012307,
static const uint64_t P9N2_EX_0_HTM_CSEL                                           = 0x10012207ull;
//DUPS: 10012307,
static const uint64_t P9N2_EX_2_HTM_CSEL                                           = 0x11012207ull;
//DUPS: 11012307,
static const uint64_t P9N2_EX_4_HTM_CSEL                                           = 0x12012207ull;
//DUPS: 12012307,
static const uint64_t P9N2_EX_6_HTM_CSEL                                           = 0x13012207ull;
//DUPS: 13012307,
static const uint64_t P9N2_EX_8_HTM_CSEL                                           = 0x14012207ull;
//DUPS: 14012307,
static const uint64_t P9N2_EX_10_HTM_CSEL                                          = 0x15012207ull;
//DUPS: 15012307,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_CSEL                                 = 0x15012607ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_CSEL                                 = 0x15012707ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_CSEL                                  = 0x10012607ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_CSEL                                  = 0x10012707ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_CSEL                                  = 0x11012607ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_CSEL                                  = 0x11012707ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_CSEL                                  = 0x12012607ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_CSEL                                  = 0x12012707ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_CSEL                                  = 0x13012607ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_CSEL                                  = 0x13012707ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_CSEL                                  = 0x14012607ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_CSEL                                  = 0x14012707ull;


static const uint64_t P9N2_EQ_HTM_CTRL                                             = 0x10012205ull;
//DUPS: 10012705, 10012205, 10012305,
static const uint64_t P9N2_EQ_0_HTM_CTRL                                           = 0x10012205ull;
//DUPS: 10012705, 10012205, 10012305,
static const uint64_t P9N2_EQ_1_HTM_CTRL                                           = 0x11012205ull;
//DUPS: 11012705, 11012205, 11012305,
static const uint64_t P9N2_EQ_2_HTM_CTRL                                           = 0x12012205ull;
//DUPS: 12012705, 12012205, 12012305,
static const uint64_t P9N2_EQ_3_HTM_CTRL                                           = 0x13012205ull;
//DUPS: 13012705, 13012205, 13012305,
static const uint64_t P9N2_EQ_4_HTM_CTRL                                           = 0x14012205ull;
//DUPS: 14012705, 14012205, 14012305,
static const uint64_t P9N2_EQ_5_HTM_CTRL                                           = 0x15012205ull;
//DUPS: 15012705, 15012205, 15012305,
static const uint64_t P9N2_EX_HTM_CTRL                                             = 0x10012205ull;
//DUPS: 10012305,
static const uint64_t P9N2_EX_0_HTM_CTRL                                           = 0x10012205ull;
//DUPS: 10012305,
static const uint64_t P9N2_EX_2_HTM_CTRL                                           = 0x11012205ull;
//DUPS: 11012305,
static const uint64_t P9N2_EX_4_HTM_CTRL                                           = 0x12012205ull;
//DUPS: 12012305,
static const uint64_t P9N2_EX_6_HTM_CTRL                                           = 0x13012205ull;
//DUPS: 13012305,
static const uint64_t P9N2_EX_8_HTM_CTRL                                           = 0x14012205ull;
//DUPS: 14012305,
static const uint64_t P9N2_EX_10_HTM_CTRL                                          = 0x15012205ull;
//DUPS: 15012305,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_CTRL                                 = 0x15012605ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_CTRL                                 = 0x15012705ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_CTRL                                  = 0x10012605ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_CTRL                                  = 0x10012705ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_CTRL                                  = 0x11012605ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_CTRL                                  = 0x11012705ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_CTRL                                  = 0x12012605ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_CTRL                                  = 0x12012705ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_CTRL                                  = 0x13012605ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_CTRL                                  = 0x13012705ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_CTRL                                  = 0x14012605ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_CTRL                                  = 0x14012705ull;


static const uint64_t P9N2_EQ_HTM_IMA_PDBAR                                        = 0x1001220Bull;
//DUPS: 1001270B, 1001220B, 1001230B,
static const uint64_t P9N2_EQ_0_HTM_IMA_PDBAR                                      = 0x1001220Bull;
//DUPS: 1001270B, 1001220B, 1001230B,
static const uint64_t P9N2_EQ_1_HTM_IMA_PDBAR                                      = 0x1101220Bull;
//DUPS: 1101270B, 1101220B, 1101230B,
static const uint64_t P9N2_EQ_2_HTM_IMA_PDBAR                                      = 0x1201220Bull;
//DUPS: 1201270B, 1201220B, 1201230B,
static const uint64_t P9N2_EQ_3_HTM_IMA_PDBAR                                      = 0x1301220Bull;
//DUPS: 1301270B, 1301220B, 1301230B,
static const uint64_t P9N2_EQ_4_HTM_IMA_PDBAR                                      = 0x1401220Bull;
//DUPS: 1401270B, 1401220B, 1401230B,
static const uint64_t P9N2_EQ_5_HTM_IMA_PDBAR                                      = 0x1501220Bull;
//DUPS: 1501270B, 1501220B, 1501230B,
static const uint64_t P9N2_EX_HTM_IMA_PDBAR                                        = 0x1001220Bull;
//DUPS: 1001230B,
static const uint64_t P9N2_EX_0_HTM_IMA_PDBAR                                      = 0x1001220Bull;
//DUPS: 1001230B,
static const uint64_t P9N2_EX_2_HTM_IMA_PDBAR                                      = 0x1101220Bull;
//DUPS: 1101230B,
static const uint64_t P9N2_EX_4_HTM_IMA_PDBAR                                      = 0x1201220Bull;
//DUPS: 1201230B,
static const uint64_t P9N2_EX_6_HTM_IMA_PDBAR                                      = 0x1301220Bull;
//DUPS: 1301230B,
static const uint64_t P9N2_EX_8_HTM_IMA_PDBAR                                      = 0x1401220Bull;
//DUPS: 1401230B,
static const uint64_t P9N2_EX_10_HTM_IMA_PDBAR                                     = 0x1501220Bull;
//DUPS: 1501230B,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_IMA_PDBAR                            = 0x1501260Bull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_IMA_PDBAR                            = 0x1501270Bull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_IMA_PDBAR                             = 0x1001260Bull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_IMA_PDBAR                             = 0x1001270Bull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_IMA_PDBAR                             = 0x1101260Bull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_IMA_PDBAR                             = 0x1101270Bull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_IMA_PDBAR                             = 0x1201260Bull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_IMA_PDBAR                             = 0x1201270Bull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_IMA_PDBAR                             = 0x1301260Bull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_IMA_PDBAR                             = 0x1301270Bull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_IMA_PDBAR                             = 0x1401260Bull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_IMA_PDBAR                             = 0x1401270Bull;


static const uint64_t P9N2_EQ_HTM_IMA_STATUS                                       = 0x1001220Aull;
//DUPS: 1001270A, 1001220A, 1001230A,
static const uint64_t P9N2_EQ_0_HTM_IMA_STATUS                                     = 0x1001220Aull;
//DUPS: 1001270A, 1001220A, 1001230A,
static const uint64_t P9N2_EQ_1_HTM_IMA_STATUS                                     = 0x1101220Aull;
//DUPS: 1101270A, 1101220A, 1101230A,
static const uint64_t P9N2_EQ_2_HTM_IMA_STATUS                                     = 0x1201220Aull;
//DUPS: 1201270A, 1201220A, 1201230A,
static const uint64_t P9N2_EQ_3_HTM_IMA_STATUS                                     = 0x1301220Aull;
//DUPS: 1301270A, 1301220A, 1301230A,
static const uint64_t P9N2_EQ_4_HTM_IMA_STATUS                                     = 0x1401220Aull;
//DUPS: 1401270A, 1401220A, 1401230A,
static const uint64_t P9N2_EQ_5_HTM_IMA_STATUS                                     = 0x1501220Aull;
//DUPS: 1501270A, 1501220A, 1501230A,
static const uint64_t P9N2_EX_HTM_IMA_STATUS                                       = 0x1001220Aull;
//DUPS: 1001230A,
static const uint64_t P9N2_EX_0_HTM_IMA_STATUS                                     = 0x1001220Aull;
//DUPS: 1001230A,
static const uint64_t P9N2_EX_2_HTM_IMA_STATUS                                     = 0x1101220Aull;
//DUPS: 1101230A,
static const uint64_t P9N2_EX_4_HTM_IMA_STATUS                                     = 0x1201220Aull;
//DUPS: 1201230A,
static const uint64_t P9N2_EX_6_HTM_IMA_STATUS                                     = 0x1301220Aull;
//DUPS: 1301230A,
static const uint64_t P9N2_EX_8_HTM_IMA_STATUS                                     = 0x1401220Aull;
//DUPS: 1401230A,
static const uint64_t P9N2_EX_10_HTM_IMA_STATUS                                    = 0x1501220Aull;
//DUPS: 1501230A,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_IMA_STATUS                           = 0x1501260Aull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_IMA_STATUS                           = 0x1501270Aull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_IMA_STATUS                            = 0x1001260Aull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_IMA_STATUS                            = 0x1001270Aull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_IMA_STATUS                            = 0x1101260Aull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_IMA_STATUS                            = 0x1101270Aull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_IMA_STATUS                            = 0x1201260Aull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_IMA_STATUS                            = 0x1201270Aull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_IMA_STATUS                            = 0x1301260Aull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_IMA_STATUS                            = 0x1301270Aull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_IMA_STATUS                            = 0x1401260Aull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_IMA_STATUS                            = 0x1401270Aull;


static const uint64_t P9N2_EQ_HTM_LAST                                             = 0x10012203ull;
//DUPS: 10012703, 10012203, 10012303,
static const uint64_t P9N2_EQ_0_HTM_LAST                                           = 0x10012203ull;
//DUPS: 10012703, 10012203, 10012303,
static const uint64_t P9N2_EQ_1_HTM_LAST                                           = 0x11012203ull;
//DUPS: 11012703, 11012203, 11012303,
static const uint64_t P9N2_EQ_2_HTM_LAST                                           = 0x12012203ull;
//DUPS: 12012703, 12012203, 12012303,
static const uint64_t P9N2_EQ_3_HTM_LAST                                           = 0x13012203ull;
//DUPS: 13012703, 13012203, 13012303,
static const uint64_t P9N2_EQ_4_HTM_LAST                                           = 0x14012203ull;
//DUPS: 14012703, 14012203, 14012303,
static const uint64_t P9N2_EQ_5_HTM_LAST                                           = 0x15012203ull;
//DUPS: 15012703, 15012203, 15012303,
static const uint64_t P9N2_EX_HTM_LAST                                             = 0x10012203ull;
//DUPS: 10012303,
static const uint64_t P9N2_EX_0_HTM_LAST                                           = 0x10012203ull;
//DUPS: 10012303,
static const uint64_t P9N2_EX_2_HTM_LAST                                           = 0x11012203ull;
//DUPS: 11012303,
static const uint64_t P9N2_EX_4_HTM_LAST                                           = 0x12012203ull;
//DUPS: 12012303,
static const uint64_t P9N2_EX_6_HTM_LAST                                           = 0x13012203ull;
//DUPS: 13012303,
static const uint64_t P9N2_EX_8_HTM_LAST                                           = 0x14012203ull;
//DUPS: 14012303,
static const uint64_t P9N2_EX_10_HTM_LAST                                          = 0x15012203ull;
//DUPS: 15012303,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_LAST                                 = 0x15012603ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_LAST                                 = 0x15012703ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_LAST                                  = 0x10012603ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_LAST                                  = 0x10012703ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_LAST                                  = 0x11012603ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_LAST                                  = 0x11012703ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_LAST                                  = 0x12012603ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_LAST                                  = 0x12012703ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_LAST                                  = 0x13012603ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_LAST                                  = 0x13012703ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_LAST                                  = 0x14012603ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_LAST                                  = 0x14012703ull;


static const uint64_t P9N2_EQ_HTM_MEM                                              = 0x10012201ull;
//DUPS: 10012701, 10012201, 10012301,
static const uint64_t P9N2_EQ_0_HTM_MEM                                            = 0x10012201ull;
//DUPS: 10012701, 10012201, 10012301,
static const uint64_t P9N2_EQ_1_HTM_MEM                                            = 0x11012201ull;
//DUPS: 11012701, 11012201, 11012301,
static const uint64_t P9N2_EQ_2_HTM_MEM                                            = 0x12012201ull;
//DUPS: 12012701, 12012201, 12012301,
static const uint64_t P9N2_EQ_3_HTM_MEM                                            = 0x13012201ull;
//DUPS: 13012701, 13012201, 13012301,
static const uint64_t P9N2_EQ_4_HTM_MEM                                            = 0x14012201ull;
//DUPS: 14012701, 14012201, 14012301,
static const uint64_t P9N2_EQ_5_HTM_MEM                                            = 0x15012201ull;
//DUPS: 15012701, 15012201, 15012301,
static const uint64_t P9N2_EX_HTM_MEM                                              = 0x10012201ull;
//DUPS: 10012301,
static const uint64_t P9N2_EX_0_HTM_MEM                                            = 0x10012201ull;
//DUPS: 10012301,
static const uint64_t P9N2_EX_2_HTM_MEM                                            = 0x11012201ull;
//DUPS: 11012301,
static const uint64_t P9N2_EX_4_HTM_MEM                                            = 0x12012201ull;
//DUPS: 12012301,
static const uint64_t P9N2_EX_6_HTM_MEM                                            = 0x13012201ull;
//DUPS: 13012301,
static const uint64_t P9N2_EX_8_HTM_MEM                                            = 0x14012201ull;
//DUPS: 14012301,
static const uint64_t P9N2_EX_10_HTM_MEM                                           = 0x15012201ull;
//DUPS: 15012301,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_MEM                                  = 0x15012601ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_MEM                                  = 0x15012701ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_MEM                                   = 0x10012601ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_MEM                                   = 0x10012701ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_MEM                                   = 0x11012601ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_MEM                                   = 0x11012701ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_MEM                                   = 0x12012601ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_MEM                                   = 0x12012701ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_MEM                                   = 0x13012601ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_MEM                                   = 0x13012701ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_MEM                                   = 0x14012601ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_MEM                                   = 0x14012701ull;


static const uint64_t P9N2_EQ_HTM_MODE                                             = 0x10012200ull;
//DUPS: 10012700, 10012200, 10012300,
static const uint64_t P9N2_EQ_0_HTM_MODE                                           = 0x10012200ull;
//DUPS: 10012700, 10012200, 10012300,
static const uint64_t P9N2_EQ_1_HTM_MODE                                           = 0x11012200ull;
//DUPS: 11012700, 11012200, 11012300,
static const uint64_t P9N2_EQ_2_HTM_MODE                                           = 0x12012200ull;
//DUPS: 12012700, 12012200, 12012300,
static const uint64_t P9N2_EQ_3_HTM_MODE                                           = 0x13012200ull;
//DUPS: 13012700, 13012200, 13012300,
static const uint64_t P9N2_EQ_4_HTM_MODE                                           = 0x14012200ull;
//DUPS: 14012700, 14012200, 14012300,
static const uint64_t P9N2_EQ_5_HTM_MODE                                           = 0x15012200ull;
//DUPS: 15012700, 15012200, 15012300,
static const uint64_t P9N2_EX_HTM_MODE                                             = 0x10012200ull;
//DUPS: 10012300,
static const uint64_t P9N2_EX_0_HTM_MODE                                           = 0x10012200ull;
//DUPS: 10012300,
static const uint64_t P9N2_EX_2_HTM_MODE                                           = 0x11012200ull;
//DUPS: 11012300,
static const uint64_t P9N2_EX_4_HTM_MODE                                           = 0x12012200ull;
//DUPS: 12012300,
static const uint64_t P9N2_EX_6_HTM_MODE                                           = 0x13012200ull;
//DUPS: 13012300,
static const uint64_t P9N2_EX_8_HTM_MODE                                           = 0x14012200ull;
//DUPS: 14012300,
static const uint64_t P9N2_EX_10_HTM_MODE                                          = 0x15012200ull;
//DUPS: 15012300,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_MODE                                 = 0x15012600ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_MODE                                 = 0x15012700ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_MODE                                  = 0x10012600ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_MODE                                  = 0x10012700ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_MODE                                  = 0x11012600ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_MODE                                  = 0x11012700ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_MODE                                  = 0x12012600ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_MODE                                  = 0x12012700ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_MODE                                  = 0x13012600ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_MODE                                  = 0x13012700ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_MODE                                  = 0x14012600ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_MODE                                  = 0x14012700ull;


static const uint64_t P9N2_EQ_HTM_PTRC                                             = 0x10012206ull;
//DUPS: 10012706, 10012206, 10012306,
static const uint64_t P9N2_EQ_0_HTM_PTRC                                           = 0x10012206ull;
//DUPS: 10012706, 10012206, 10012306,
static const uint64_t P9N2_EQ_1_HTM_PTRC                                           = 0x11012206ull;
//DUPS: 11012706, 11012206, 11012306,
static const uint64_t P9N2_EQ_2_HTM_PTRC                                           = 0x12012206ull;
//DUPS: 12012706, 12012206, 12012306,
static const uint64_t P9N2_EQ_3_HTM_PTRC                                           = 0x13012206ull;
//DUPS: 13012706, 13012206, 13012306,
static const uint64_t P9N2_EQ_4_HTM_PTRC                                           = 0x14012206ull;
//DUPS: 14012706, 14012206, 14012306,
static const uint64_t P9N2_EQ_5_HTM_PTRC                                           = 0x15012206ull;
//DUPS: 15012706, 15012206, 15012306,
static const uint64_t P9N2_EX_HTM_PTRC                                             = 0x10012206ull;
//DUPS: 10012306,
static const uint64_t P9N2_EX_0_HTM_PTRC                                           = 0x10012206ull;
//DUPS: 10012306,
static const uint64_t P9N2_EX_2_HTM_PTRC                                           = 0x11012206ull;
//DUPS: 11012306,
static const uint64_t P9N2_EX_4_HTM_PTRC                                           = 0x12012206ull;
//DUPS: 12012306,
static const uint64_t P9N2_EX_6_HTM_PTRC                                           = 0x13012206ull;
//DUPS: 13012306,
static const uint64_t P9N2_EX_8_HTM_PTRC                                           = 0x14012206ull;
//DUPS: 14012306,
static const uint64_t P9N2_EX_10_HTM_PTRC                                          = 0x15012206ull;
//DUPS: 15012306,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_PTRC                                 = 0x15012606ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_PTRC                                 = 0x15012706ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_PTRC                                  = 0x10012606ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_PTRC                                  = 0x10012706ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_PTRC                                  = 0x11012606ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_PTRC                                  = 0x11012706ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_PTRC                                  = 0x12012606ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_PTRC                                  = 0x12012706ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_PTRC                                  = 0x13012606ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_PTRC                                  = 0x13012706ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_PTRC                                  = 0x14012606ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_PTRC                                  = 0x14012706ull;


static const uint64_t P9N2_EQ_HTM_STAT                                             = 0x10012202ull;
//DUPS: 10012702, 10012202, 10012302,
static const uint64_t P9N2_EQ_0_HTM_STAT                                           = 0x10012202ull;
//DUPS: 10012702, 10012202, 10012302,
static const uint64_t P9N2_EQ_1_HTM_STAT                                           = 0x11012202ull;
//DUPS: 11012702, 11012202, 11012302,
static const uint64_t P9N2_EQ_2_HTM_STAT                                           = 0x12012202ull;
//DUPS: 12012702, 12012202, 12012302,
static const uint64_t P9N2_EQ_3_HTM_STAT                                           = 0x13012202ull;
//DUPS: 13012702, 13012202, 13012302,
static const uint64_t P9N2_EQ_4_HTM_STAT                                           = 0x14012202ull;
//DUPS: 14012702, 14012202, 14012302,
static const uint64_t P9N2_EQ_5_HTM_STAT                                           = 0x15012202ull;
//DUPS: 15012702, 15012202, 15012302,
static const uint64_t P9N2_EX_HTM_STAT                                             = 0x10012202ull;
//DUPS: 10012302,
static const uint64_t P9N2_EX_0_HTM_STAT                                           = 0x10012202ull;
//DUPS: 10012302,
static const uint64_t P9N2_EX_2_HTM_STAT                                           = 0x11012202ull;
//DUPS: 11012302,
static const uint64_t P9N2_EX_4_HTM_STAT                                           = 0x12012202ull;
//DUPS: 12012302,
static const uint64_t P9N2_EX_6_HTM_STAT                                           = 0x13012202ull;
//DUPS: 13012302,
static const uint64_t P9N2_EX_8_HTM_STAT                                           = 0x14012202ull;
//DUPS: 14012302,
static const uint64_t P9N2_EX_10_HTM_STAT                                          = 0x15012202ull;
//DUPS: 15012302,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_STAT                                 = 0x15012602ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_STAT                                 = 0x15012702ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_STAT                                  = 0x10012602ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_STAT                                  = 0x10012702ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_STAT                                  = 0x11012602ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_STAT                                  = 0x11012702ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_STAT                                  = 0x12012602ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_STAT                                  = 0x12012702ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_STAT                                  = 0x13012602ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_STAT                                  = 0x13012702ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_STAT                                  = 0x14012602ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_STAT                                  = 0x14012702ull;


static const uint64_t P9N2_EQ_HTM_TRIG                                             = 0x10012204ull;
//DUPS: 10012704, 10012204, 10012304,
static const uint64_t P9N2_EQ_0_HTM_TRIG                                           = 0x10012204ull;
//DUPS: 10012704, 10012204, 10012304,
static const uint64_t P9N2_EQ_1_HTM_TRIG                                           = 0x11012204ull;
//DUPS: 11012704, 11012204, 11012304,
static const uint64_t P9N2_EQ_2_HTM_TRIG                                           = 0x12012204ull;
//DUPS: 12012704, 12012204, 12012304,
static const uint64_t P9N2_EQ_3_HTM_TRIG                                           = 0x13012204ull;
//DUPS: 13012704, 13012204, 13012304,
static const uint64_t P9N2_EQ_4_HTM_TRIG                                           = 0x14012204ull;
//DUPS: 14012704, 14012204, 14012304,
static const uint64_t P9N2_EQ_5_HTM_TRIG                                           = 0x15012204ull;
//DUPS: 15012704, 15012204, 15012304,
static const uint64_t P9N2_EX_HTM_TRIG                                             = 0x10012204ull;
//DUPS: 10012304,
static const uint64_t P9N2_EX_0_HTM_TRIG                                           = 0x10012204ull;
//DUPS: 10012304,
static const uint64_t P9N2_EX_2_HTM_TRIG                                           = 0x11012204ull;
//DUPS: 11012304,
static const uint64_t P9N2_EX_4_HTM_TRIG                                           = 0x12012204ull;
//DUPS: 12012304,
static const uint64_t P9N2_EX_6_HTM_TRIG                                           = 0x13012204ull;
//DUPS: 13012304,
static const uint64_t P9N2_EX_8_HTM_TRIG                                           = 0x14012204ull;
//DUPS: 14012304,
static const uint64_t P9N2_EX_10_HTM_TRIG                                          = 0x15012204ull;
//DUPS: 15012304,
static const uint64_t P9N2_EX_11_CHTMLBS0_HTM_TRIG                                 = 0x15012604ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_HTM_TRIG                                 = 0x15012704ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_HTM_TRIG                                  = 0x10012604ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_HTM_TRIG                                  = 0x10012704ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_HTM_TRIG                                  = 0x11012604ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_HTM_TRIG                                  = 0x11012704ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_HTM_TRIG                                  = 0x12012604ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_HTM_TRIG                                  = 0x12012704ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_HTM_TRIG                                  = 0x13012604ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_HTM_TRIG                                  = 0x13012704ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_HTM_TRIG                                  = 0x14012604ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_HTM_TRIG                                  = 0x14012704ull;


static const uint64_t P9N2_C_HV_STATE                                              = 0x20010AA6ull;

static const uint64_t P9N2_C_0_HV_STATE                                            = 0x20010AA6ull;

static const uint64_t P9N2_C_1_HV_STATE                                            = 0x21010AA6ull;

static const uint64_t P9N2_C_2_HV_STATE                                            = 0x22010AA6ull;

static const uint64_t P9N2_C_3_HV_STATE                                            = 0x23010AA6ull;

static const uint64_t P9N2_C_4_HV_STATE                                            = 0x24010AA6ull;

static const uint64_t P9N2_C_5_HV_STATE                                            = 0x25010AA6ull;

static const uint64_t P9N2_C_6_HV_STATE                                            = 0x26010AA6ull;

static const uint64_t P9N2_C_7_HV_STATE                                            = 0x27010AA6ull;

static const uint64_t P9N2_C_8_HV_STATE                                            = 0x28010AA6ull;

static const uint64_t P9N2_C_9_HV_STATE                                            = 0x29010AA6ull;

static const uint64_t P9N2_C_10_HV_STATE                                           = 0x2A010AA6ull;

static const uint64_t P9N2_C_11_HV_STATE                                           = 0x2B010AA6ull;

static const uint64_t P9N2_C_12_HV_STATE                                           = 0x2C010AA6ull;

static const uint64_t P9N2_C_13_HV_STATE                                           = 0x2D010AA6ull;

static const uint64_t P9N2_C_14_HV_STATE                                           = 0x2E010AA6ull;

static const uint64_t P9N2_C_15_HV_STATE                                           = 0x2F010AA6ull;

static const uint64_t P9N2_C_16_HV_STATE                                           = 0x30010AA6ull;

static const uint64_t P9N2_C_17_HV_STATE                                           = 0x31010AA6ull;

static const uint64_t P9N2_C_18_HV_STATE                                           = 0x32010AA6ull;

static const uint64_t P9N2_C_19_HV_STATE                                           = 0x33010AA6ull;

static const uint64_t P9N2_C_20_HV_STATE                                           = 0x34010AA6ull;

static const uint64_t P9N2_C_21_HV_STATE                                           = 0x35010AA6ull;

static const uint64_t P9N2_C_22_HV_STATE                                           = 0x36010AA6ull;

static const uint64_t P9N2_C_23_HV_STATE                                           = 0x37010AA6ull;

static const uint64_t P9N2_EX_0_L2_HV_STATE                                        = 0x20010AA6ull;
//DUPS: 21010AA6,
static const uint64_t P9N2_EX_10_L2_HV_STATE                                       = 0x34010AA6ull;
//DUPS: 35010AA6,
static const uint64_t P9N2_EX_11_L2_HV_STATE                                       = 0x36010AA6ull;
//DUPS: 37010AA6,
static const uint64_t P9N2_EX_1_L2_HV_STATE                                        = 0x22010AA6ull;
//DUPS: 23010AA6,
static const uint64_t P9N2_EX_2_L2_HV_STATE                                        = 0x24010AA6ull;
//DUPS: 25010AA6,
static const uint64_t P9N2_EX_3_L2_HV_STATE                                        = 0x26010AA6ull;
//DUPS: 27010AA6,
static const uint64_t P9N2_EX_4_L2_HV_STATE                                        = 0x28010AA6ull;
//DUPS: 29010AA6,
static const uint64_t P9N2_EX_5_L2_HV_STATE                                        = 0x2A010AA6ull;
//DUPS: 2B010AA6,
static const uint64_t P9N2_EX_6_L2_HV_STATE                                        = 0x2C010AA6ull;
//DUPS: 2D010AA6,
static const uint64_t P9N2_EX_7_L2_HV_STATE                                        = 0x2F010AA6ull;
//DUPS: 2F010AA6,
static const uint64_t P9N2_EX_8_L2_HV_STATE                                        = 0x30010AA6ull;
//DUPS: 31010AA6,
static const uint64_t P9N2_EX_9_L2_HV_STATE                                        = 0x32010AA6ull;
//DUPS: 33010AA6,
static const uint64_t P9N2_EX_L2_HV_STATE                                          = 0x20010AA6ull;
//DUPS: 21010AA6,

static const uint64_t P9N2_C_IFU_HOLD_OUT_0                                        = 0x20010C00ull;

static const uint64_t P9N2_C_0_IFU_HOLD_OUT_0                                      = 0x20010C00ull;

static const uint64_t P9N2_C_1_IFU_HOLD_OUT_0                                      = 0x21010C00ull;

static const uint64_t P9N2_C_2_IFU_HOLD_OUT_0                                      = 0x22010C00ull;

static const uint64_t P9N2_C_3_IFU_HOLD_OUT_0                                      = 0x23010C00ull;

static const uint64_t P9N2_C_4_IFU_HOLD_OUT_0                                      = 0x24010C00ull;

static const uint64_t P9N2_C_5_IFU_HOLD_OUT_0                                      = 0x25010C00ull;

static const uint64_t P9N2_C_6_IFU_HOLD_OUT_0                                      = 0x26010C00ull;

static const uint64_t P9N2_C_7_IFU_HOLD_OUT_0                                      = 0x27010C00ull;

static const uint64_t P9N2_C_8_IFU_HOLD_OUT_0                                      = 0x28010C00ull;

static const uint64_t P9N2_C_9_IFU_HOLD_OUT_0                                      = 0x29010C00ull;

static const uint64_t P9N2_C_10_IFU_HOLD_OUT_0                                     = 0x2A010C00ull;

static const uint64_t P9N2_C_11_IFU_HOLD_OUT_0                                     = 0x2B010C00ull;

static const uint64_t P9N2_C_12_IFU_HOLD_OUT_0                                     = 0x2C010C00ull;

static const uint64_t P9N2_C_13_IFU_HOLD_OUT_0                                     = 0x2D010C00ull;

static const uint64_t P9N2_C_14_IFU_HOLD_OUT_0                                     = 0x2E010C00ull;

static const uint64_t P9N2_C_15_IFU_HOLD_OUT_0                                     = 0x2F010C00ull;

static const uint64_t P9N2_C_16_IFU_HOLD_OUT_0                                     = 0x30010C00ull;

static const uint64_t P9N2_C_17_IFU_HOLD_OUT_0                                     = 0x31010C00ull;

static const uint64_t P9N2_C_18_IFU_HOLD_OUT_0                                     = 0x32010C00ull;

static const uint64_t P9N2_C_19_IFU_HOLD_OUT_0                                     = 0x33010C00ull;

static const uint64_t P9N2_C_20_IFU_HOLD_OUT_0                                     = 0x34010C00ull;

static const uint64_t P9N2_C_21_IFU_HOLD_OUT_0                                     = 0x35010C00ull;

static const uint64_t P9N2_C_22_IFU_HOLD_OUT_0                                     = 0x36010C00ull;

static const uint64_t P9N2_C_23_IFU_HOLD_OUT_0                                     = 0x37010C00ull;

static const uint64_t P9N2_EX_0_L2_IFU_HOLD_OUT_0                                  = 0x20010C00ull;
//DUPS: 21010C00,
static const uint64_t P9N2_EX_10_L2_IFU_HOLD_OUT_0                                 = 0x34010C00ull;
//DUPS: 35010C00,
static const uint64_t P9N2_EX_11_L2_IFU_HOLD_OUT_0                                 = 0x36010C00ull;
//DUPS: 37010C00,
static const uint64_t P9N2_EX_1_L2_IFU_HOLD_OUT_0                                  = 0x22010C00ull;
//DUPS: 23010C00,
static const uint64_t P9N2_EX_2_L2_IFU_HOLD_OUT_0                                  = 0x24010C00ull;
//DUPS: 25010C00,
static const uint64_t P9N2_EX_3_L2_IFU_HOLD_OUT_0                                  = 0x26010C00ull;
//DUPS: 27010C00,
static const uint64_t P9N2_EX_4_L2_IFU_HOLD_OUT_0                                  = 0x28010C00ull;
//DUPS: 29010C00,
static const uint64_t P9N2_EX_5_L2_IFU_HOLD_OUT_0                                  = 0x2A010C00ull;
//DUPS: 2B010C00,
static const uint64_t P9N2_EX_6_L2_IFU_HOLD_OUT_0                                  = 0x2C010C00ull;
//DUPS: 2D010C00,
static const uint64_t P9N2_EX_7_L2_IFU_HOLD_OUT_0                                  = 0x2F010C00ull;
//DUPS: 2F010C00,
static const uint64_t P9N2_EX_8_L2_IFU_HOLD_OUT_0                                  = 0x30010C00ull;
//DUPS: 31010C00,
static const uint64_t P9N2_EX_9_L2_IFU_HOLD_OUT_0                                  = 0x32010C00ull;
//DUPS: 33010C00,
static const uint64_t P9N2_EX_L2_IFU_HOLD_OUT_0                                    = 0x20010C00ull;
//DUPS: 21010C00,

static const uint64_t P9N2_C_IFU_HOLD_OUT_1                                        = 0x20010C01ull;

static const uint64_t P9N2_C_0_IFU_HOLD_OUT_1                                      = 0x20010C01ull;

static const uint64_t P9N2_C_1_IFU_HOLD_OUT_1                                      = 0x21010C01ull;

static const uint64_t P9N2_C_2_IFU_HOLD_OUT_1                                      = 0x22010C01ull;

static const uint64_t P9N2_C_3_IFU_HOLD_OUT_1                                      = 0x23010C01ull;

static const uint64_t P9N2_C_4_IFU_HOLD_OUT_1                                      = 0x24010C01ull;

static const uint64_t P9N2_C_5_IFU_HOLD_OUT_1                                      = 0x25010C01ull;

static const uint64_t P9N2_C_6_IFU_HOLD_OUT_1                                      = 0x26010C01ull;

static const uint64_t P9N2_C_7_IFU_HOLD_OUT_1                                      = 0x27010C01ull;

static const uint64_t P9N2_C_8_IFU_HOLD_OUT_1                                      = 0x28010C01ull;

static const uint64_t P9N2_C_9_IFU_HOLD_OUT_1                                      = 0x29010C01ull;

static const uint64_t P9N2_C_10_IFU_HOLD_OUT_1                                     = 0x2A010C01ull;

static const uint64_t P9N2_C_11_IFU_HOLD_OUT_1                                     = 0x2B010C01ull;

static const uint64_t P9N2_C_12_IFU_HOLD_OUT_1                                     = 0x2C010C01ull;

static const uint64_t P9N2_C_13_IFU_HOLD_OUT_1                                     = 0x2D010C01ull;

static const uint64_t P9N2_C_14_IFU_HOLD_OUT_1                                     = 0x2E010C01ull;

static const uint64_t P9N2_C_15_IFU_HOLD_OUT_1                                     = 0x2F010C01ull;

static const uint64_t P9N2_C_16_IFU_HOLD_OUT_1                                     = 0x30010C01ull;

static const uint64_t P9N2_C_17_IFU_HOLD_OUT_1                                     = 0x31010C01ull;

static const uint64_t P9N2_C_18_IFU_HOLD_OUT_1                                     = 0x32010C01ull;

static const uint64_t P9N2_C_19_IFU_HOLD_OUT_1                                     = 0x33010C01ull;

static const uint64_t P9N2_C_20_IFU_HOLD_OUT_1                                     = 0x34010C01ull;

static const uint64_t P9N2_C_21_IFU_HOLD_OUT_1                                     = 0x35010C01ull;

static const uint64_t P9N2_C_22_IFU_HOLD_OUT_1                                     = 0x36010C01ull;

static const uint64_t P9N2_C_23_IFU_HOLD_OUT_1                                     = 0x37010C01ull;

static const uint64_t P9N2_EX_0_L2_IFU_HOLD_OUT_1                                  = 0x20010C01ull;
//DUPS: 21010C01,
static const uint64_t P9N2_EX_10_L2_IFU_HOLD_OUT_1                                 = 0x34010C01ull;
//DUPS: 35010C01,
static const uint64_t P9N2_EX_11_L2_IFU_HOLD_OUT_1                                 = 0x36010C01ull;
//DUPS: 37010C01,
static const uint64_t P9N2_EX_1_L2_IFU_HOLD_OUT_1                                  = 0x22010C01ull;
//DUPS: 23010C01,
static const uint64_t P9N2_EX_2_L2_IFU_HOLD_OUT_1                                  = 0x24010C01ull;
//DUPS: 25010C01,
static const uint64_t P9N2_EX_3_L2_IFU_HOLD_OUT_1                                  = 0x26010C01ull;
//DUPS: 27010C01,
static const uint64_t P9N2_EX_4_L2_IFU_HOLD_OUT_1                                  = 0x28010C01ull;
//DUPS: 29010C01,
static const uint64_t P9N2_EX_5_L2_IFU_HOLD_OUT_1                                  = 0x2A010C01ull;
//DUPS: 2B010C01,
static const uint64_t P9N2_EX_6_L2_IFU_HOLD_OUT_1                                  = 0x2C010C01ull;
//DUPS: 2D010C01,
static const uint64_t P9N2_EX_7_L2_IFU_HOLD_OUT_1                                  = 0x2F010C01ull;
//DUPS: 2F010C01,
static const uint64_t P9N2_EX_8_L2_IFU_HOLD_OUT_1                                  = 0x30010C01ull;
//DUPS: 31010C01,
static const uint64_t P9N2_EX_9_L2_IFU_HOLD_OUT_1                                  = 0x32010C01ull;
//DUPS: 33010C01,
static const uint64_t P9N2_EX_L2_IFU_HOLD_OUT_1                                    = 0x20010C01ull;
//DUPS: 21010C01,

static const uint64_t P9N2_C_IFU_HOLD_OUT_2                                        = 0x20010C02ull;

static const uint64_t P9N2_C_0_IFU_HOLD_OUT_2                                      = 0x20010C02ull;

static const uint64_t P9N2_C_1_IFU_HOLD_OUT_2                                      = 0x21010C02ull;

static const uint64_t P9N2_C_2_IFU_HOLD_OUT_2                                      = 0x22010C02ull;

static const uint64_t P9N2_C_3_IFU_HOLD_OUT_2                                      = 0x23010C02ull;

static const uint64_t P9N2_C_4_IFU_HOLD_OUT_2                                      = 0x24010C02ull;

static const uint64_t P9N2_C_5_IFU_HOLD_OUT_2                                      = 0x25010C02ull;

static const uint64_t P9N2_C_6_IFU_HOLD_OUT_2                                      = 0x26010C02ull;

static const uint64_t P9N2_C_7_IFU_HOLD_OUT_2                                      = 0x27010C02ull;

static const uint64_t P9N2_C_8_IFU_HOLD_OUT_2                                      = 0x28010C02ull;

static const uint64_t P9N2_C_9_IFU_HOLD_OUT_2                                      = 0x29010C02ull;

static const uint64_t P9N2_C_10_IFU_HOLD_OUT_2                                     = 0x2A010C02ull;

static const uint64_t P9N2_C_11_IFU_HOLD_OUT_2                                     = 0x2B010C02ull;

static const uint64_t P9N2_C_12_IFU_HOLD_OUT_2                                     = 0x2C010C02ull;

static const uint64_t P9N2_C_13_IFU_HOLD_OUT_2                                     = 0x2D010C02ull;

static const uint64_t P9N2_C_14_IFU_HOLD_OUT_2                                     = 0x2E010C02ull;

static const uint64_t P9N2_C_15_IFU_HOLD_OUT_2                                     = 0x2F010C02ull;

static const uint64_t P9N2_C_16_IFU_HOLD_OUT_2                                     = 0x30010C02ull;

static const uint64_t P9N2_C_17_IFU_HOLD_OUT_2                                     = 0x31010C02ull;

static const uint64_t P9N2_C_18_IFU_HOLD_OUT_2                                     = 0x32010C02ull;

static const uint64_t P9N2_C_19_IFU_HOLD_OUT_2                                     = 0x33010C02ull;

static const uint64_t P9N2_C_20_IFU_HOLD_OUT_2                                     = 0x34010C02ull;

static const uint64_t P9N2_C_21_IFU_HOLD_OUT_2                                     = 0x35010C02ull;

static const uint64_t P9N2_C_22_IFU_HOLD_OUT_2                                     = 0x36010C02ull;

static const uint64_t P9N2_C_23_IFU_HOLD_OUT_2                                     = 0x37010C02ull;

static const uint64_t P9N2_EX_0_L2_IFU_HOLD_OUT_2                                  = 0x20010C02ull;
//DUPS: 21010C02,
static const uint64_t P9N2_EX_10_L2_IFU_HOLD_OUT_2                                 = 0x34010C02ull;
//DUPS: 35010C02,
static const uint64_t P9N2_EX_11_L2_IFU_HOLD_OUT_2                                 = 0x36010C02ull;
//DUPS: 37010C02,
static const uint64_t P9N2_EX_1_L2_IFU_HOLD_OUT_2                                  = 0x22010C02ull;
//DUPS: 23010C02,
static const uint64_t P9N2_EX_2_L2_IFU_HOLD_OUT_2                                  = 0x24010C02ull;
//DUPS: 25010C02,
static const uint64_t P9N2_EX_3_L2_IFU_HOLD_OUT_2                                  = 0x26010C02ull;
//DUPS: 27010C02,
static const uint64_t P9N2_EX_4_L2_IFU_HOLD_OUT_2                                  = 0x28010C02ull;
//DUPS: 29010C02,
static const uint64_t P9N2_EX_5_L2_IFU_HOLD_OUT_2                                  = 0x2A010C02ull;
//DUPS: 2B010C02,
static const uint64_t P9N2_EX_6_L2_IFU_HOLD_OUT_2                                  = 0x2C010C02ull;
//DUPS: 2D010C02,
static const uint64_t P9N2_EX_7_L2_IFU_HOLD_OUT_2                                  = 0x2F010C02ull;
//DUPS: 2F010C02,
static const uint64_t P9N2_EX_8_L2_IFU_HOLD_OUT_2                                  = 0x30010C02ull;
//DUPS: 31010C02,
static const uint64_t P9N2_EX_9_L2_IFU_HOLD_OUT_2                                  = 0x32010C02ull;
//DUPS: 33010C02,
static const uint64_t P9N2_EX_L2_IFU_HOLD_OUT_2                                    = 0x20010C02ull;
//DUPS: 21010C02,

static const uint64_t P9N2_C_IFU_HOLD_OUT_3                                        = 0x20010C03ull;

static const uint64_t P9N2_C_0_IFU_HOLD_OUT_3                                      = 0x20010C03ull;

static const uint64_t P9N2_C_1_IFU_HOLD_OUT_3                                      = 0x21010C03ull;

static const uint64_t P9N2_C_2_IFU_HOLD_OUT_3                                      = 0x22010C03ull;

static const uint64_t P9N2_C_3_IFU_HOLD_OUT_3                                      = 0x23010C03ull;

static const uint64_t P9N2_C_4_IFU_HOLD_OUT_3                                      = 0x24010C03ull;

static const uint64_t P9N2_C_5_IFU_HOLD_OUT_3                                      = 0x25010C03ull;

static const uint64_t P9N2_C_6_IFU_HOLD_OUT_3                                      = 0x26010C03ull;

static const uint64_t P9N2_C_7_IFU_HOLD_OUT_3                                      = 0x27010C03ull;

static const uint64_t P9N2_C_8_IFU_HOLD_OUT_3                                      = 0x28010C03ull;

static const uint64_t P9N2_C_9_IFU_HOLD_OUT_3                                      = 0x29010C03ull;

static const uint64_t P9N2_C_10_IFU_HOLD_OUT_3                                     = 0x2A010C03ull;

static const uint64_t P9N2_C_11_IFU_HOLD_OUT_3                                     = 0x2B010C03ull;

static const uint64_t P9N2_C_12_IFU_HOLD_OUT_3                                     = 0x2C010C03ull;

static const uint64_t P9N2_C_13_IFU_HOLD_OUT_3                                     = 0x2D010C03ull;

static const uint64_t P9N2_C_14_IFU_HOLD_OUT_3                                     = 0x2E010C03ull;

static const uint64_t P9N2_C_15_IFU_HOLD_OUT_3                                     = 0x2F010C03ull;

static const uint64_t P9N2_C_16_IFU_HOLD_OUT_3                                     = 0x30010C03ull;

static const uint64_t P9N2_C_17_IFU_HOLD_OUT_3                                     = 0x31010C03ull;

static const uint64_t P9N2_C_18_IFU_HOLD_OUT_3                                     = 0x32010C03ull;

static const uint64_t P9N2_C_19_IFU_HOLD_OUT_3                                     = 0x33010C03ull;

static const uint64_t P9N2_C_20_IFU_HOLD_OUT_3                                     = 0x34010C03ull;

static const uint64_t P9N2_C_21_IFU_HOLD_OUT_3                                     = 0x35010C03ull;

static const uint64_t P9N2_C_22_IFU_HOLD_OUT_3                                     = 0x36010C03ull;

static const uint64_t P9N2_C_23_IFU_HOLD_OUT_3                                     = 0x37010C03ull;

static const uint64_t P9N2_EX_0_L2_IFU_HOLD_OUT_3                                  = 0x20010C03ull;
//DUPS: 21010C03,
static const uint64_t P9N2_EX_10_L2_IFU_HOLD_OUT_3                                 = 0x34010C03ull;
//DUPS: 35010C03,
static const uint64_t P9N2_EX_11_L2_IFU_HOLD_OUT_3                                 = 0x36010C03ull;
//DUPS: 37010C03,
static const uint64_t P9N2_EX_1_L2_IFU_HOLD_OUT_3                                  = 0x22010C03ull;
//DUPS: 23010C03,
static const uint64_t P9N2_EX_2_L2_IFU_HOLD_OUT_3                                  = 0x24010C03ull;
//DUPS: 25010C03,
static const uint64_t P9N2_EX_3_L2_IFU_HOLD_OUT_3                                  = 0x26010C03ull;
//DUPS: 27010C03,
static const uint64_t P9N2_EX_4_L2_IFU_HOLD_OUT_3                                  = 0x28010C03ull;
//DUPS: 29010C03,
static const uint64_t P9N2_EX_5_L2_IFU_HOLD_OUT_3                                  = 0x2A010C03ull;
//DUPS: 2B010C03,
static const uint64_t P9N2_EX_6_L2_IFU_HOLD_OUT_3                                  = 0x2C010C03ull;
//DUPS: 2D010C03,
static const uint64_t P9N2_EX_7_L2_IFU_HOLD_OUT_3                                  = 0x2F010C03ull;
//DUPS: 2F010C03,
static const uint64_t P9N2_EX_8_L2_IFU_HOLD_OUT_3                                  = 0x30010C03ull;
//DUPS: 31010C03,
static const uint64_t P9N2_EX_9_L2_IFU_HOLD_OUT_3                                  = 0x32010C03ull;
//DUPS: 33010C03,
static const uint64_t P9N2_EX_L2_IFU_HOLD_OUT_3                                    = 0x20010C03ull;
//DUPS: 21010C03,

static const uint64_t P9N2_C_IMA_EVENT_MASK                                        = 0x20010AA8ull;

static const uint64_t P9N2_C_0_IMA_EVENT_MASK                                      = 0x20010AA8ull;

static const uint64_t P9N2_C_1_IMA_EVENT_MASK                                      = 0x21010AA8ull;

static const uint64_t P9N2_C_2_IMA_EVENT_MASK                                      = 0x22010AA8ull;

static const uint64_t P9N2_C_3_IMA_EVENT_MASK                                      = 0x23010AA8ull;

static const uint64_t P9N2_C_4_IMA_EVENT_MASK                                      = 0x24010AA8ull;

static const uint64_t P9N2_C_5_IMA_EVENT_MASK                                      = 0x25010AA8ull;

static const uint64_t P9N2_C_6_IMA_EVENT_MASK                                      = 0x26010AA8ull;

static const uint64_t P9N2_C_7_IMA_EVENT_MASK                                      = 0x27010AA8ull;

static const uint64_t P9N2_C_8_IMA_EVENT_MASK                                      = 0x28010AA8ull;

static const uint64_t P9N2_C_9_IMA_EVENT_MASK                                      = 0x29010AA8ull;

static const uint64_t P9N2_C_10_IMA_EVENT_MASK                                     = 0x2A010AA8ull;

static const uint64_t P9N2_C_11_IMA_EVENT_MASK                                     = 0x2B010AA8ull;

static const uint64_t P9N2_C_12_IMA_EVENT_MASK                                     = 0x2C010AA8ull;

static const uint64_t P9N2_C_13_IMA_EVENT_MASK                                     = 0x2D010AA8ull;

static const uint64_t P9N2_C_14_IMA_EVENT_MASK                                     = 0x2E010AA8ull;

static const uint64_t P9N2_C_15_IMA_EVENT_MASK                                     = 0x2F010AA8ull;

static const uint64_t P9N2_C_16_IMA_EVENT_MASK                                     = 0x30010AA8ull;

static const uint64_t P9N2_C_17_IMA_EVENT_MASK                                     = 0x31010AA8ull;

static const uint64_t P9N2_C_18_IMA_EVENT_MASK                                     = 0x32010AA8ull;

static const uint64_t P9N2_C_19_IMA_EVENT_MASK                                     = 0x33010AA8ull;

static const uint64_t P9N2_C_20_IMA_EVENT_MASK                                     = 0x34010AA8ull;

static const uint64_t P9N2_C_21_IMA_EVENT_MASK                                     = 0x35010AA8ull;

static const uint64_t P9N2_C_22_IMA_EVENT_MASK                                     = 0x36010AA8ull;

static const uint64_t P9N2_C_23_IMA_EVENT_MASK                                     = 0x37010AA8ull;

static const uint64_t P9N2_EX_IMA_EVENT_MASK                                       = 0x20010AA8ull;
//DUPS: 21010AA8,
static const uint64_t P9N2_EX_0_IMA_EVENT_MASK                                     = 0x20010AA8ull;
//DUPS: 21010AA8,
static const uint64_t P9N2_EX_1_IMA_EVENT_MASK                                     = 0x22010AA8ull;
//DUPS: 23010AA8,
static const uint64_t P9N2_EX_2_IMA_EVENT_MASK                                     = 0x24010AA8ull;
//DUPS: 25010AA8,
static const uint64_t P9N2_EX_3_IMA_EVENT_MASK                                     = 0x26010AA8ull;
//DUPS: 27010AA8,
static const uint64_t P9N2_EX_4_IMA_EVENT_MASK                                     = 0x28010AA8ull;
//DUPS: 29010AA8,
static const uint64_t P9N2_EX_5_IMA_EVENT_MASK                                     = 0x2A010AA8ull;
//DUPS: 2B010AA8,
static const uint64_t P9N2_EX_6_IMA_EVENT_MASK                                     = 0x2C010AA8ull;
//DUPS: 2D010AA8,
static const uint64_t P9N2_EX_7_IMA_EVENT_MASK                                     = 0x2F010AA8ull;
//DUPS: 2F010AA8,
static const uint64_t P9N2_EX_8_IMA_EVENT_MASK                                     = 0x30010AA8ull;
//DUPS: 31010AA8,
static const uint64_t P9N2_EX_9_IMA_EVENT_MASK                                     = 0x32010AA8ull;
//DUPS: 33010AA8,
static const uint64_t P9N2_EX_10_IMA_EVENT_MASK                                    = 0x34010AA8ull;
//DUPS: 35010AA8,
static const uint64_t P9N2_EX_11_IMA_EVENT_MASK                                    = 0x36010AA8ull;
//DUPS: 37010AA8,

static const uint64_t P9N2_C_IMA_TRACE                                             = 0x20010AA9ull;

static const uint64_t P9N2_C_0_IMA_TRACE                                           = 0x20010AA9ull;

static const uint64_t P9N2_C_1_IMA_TRACE                                           = 0x21010AA9ull;

static const uint64_t P9N2_C_2_IMA_TRACE                                           = 0x22010AA9ull;

static const uint64_t P9N2_C_3_IMA_TRACE                                           = 0x23010AA9ull;

static const uint64_t P9N2_C_4_IMA_TRACE                                           = 0x24010AA9ull;

static const uint64_t P9N2_C_5_IMA_TRACE                                           = 0x25010AA9ull;

static const uint64_t P9N2_C_6_IMA_TRACE                                           = 0x26010AA9ull;

static const uint64_t P9N2_C_7_IMA_TRACE                                           = 0x27010AA9ull;

static const uint64_t P9N2_C_8_IMA_TRACE                                           = 0x28010AA9ull;

static const uint64_t P9N2_C_9_IMA_TRACE                                           = 0x29010AA9ull;

static const uint64_t P9N2_C_10_IMA_TRACE                                          = 0x2A010AA9ull;

static const uint64_t P9N2_C_11_IMA_TRACE                                          = 0x2B010AA9ull;

static const uint64_t P9N2_C_12_IMA_TRACE                                          = 0x2C010AA9ull;

static const uint64_t P9N2_C_13_IMA_TRACE                                          = 0x2D010AA9ull;

static const uint64_t P9N2_C_14_IMA_TRACE                                          = 0x2E010AA9ull;

static const uint64_t P9N2_C_15_IMA_TRACE                                          = 0x2F010AA9ull;

static const uint64_t P9N2_C_16_IMA_TRACE                                          = 0x30010AA9ull;

static const uint64_t P9N2_C_17_IMA_TRACE                                          = 0x31010AA9ull;

static const uint64_t P9N2_C_18_IMA_TRACE                                          = 0x32010AA9ull;

static const uint64_t P9N2_C_19_IMA_TRACE                                          = 0x33010AA9ull;

static const uint64_t P9N2_C_20_IMA_TRACE                                          = 0x34010AA9ull;

static const uint64_t P9N2_C_21_IMA_TRACE                                          = 0x35010AA9ull;

static const uint64_t P9N2_C_22_IMA_TRACE                                          = 0x36010AA9ull;

static const uint64_t P9N2_C_23_IMA_TRACE                                          = 0x37010AA9ull;

static const uint64_t P9N2_EX_IMA_TRACE                                            = 0x20010AA9ull;
//DUPS: 21010AA9,
static const uint64_t P9N2_EX_0_IMA_TRACE                                          = 0x20010AA9ull;
//DUPS: 21010AA9,
static const uint64_t P9N2_EX_1_IMA_TRACE                                          = 0x22010AA9ull;
//DUPS: 23010AA9,
static const uint64_t P9N2_EX_2_IMA_TRACE                                          = 0x24010AA9ull;
//DUPS: 25010AA9,
static const uint64_t P9N2_EX_3_IMA_TRACE                                          = 0x26010AA9ull;
//DUPS: 27010AA9,
static const uint64_t P9N2_EX_4_IMA_TRACE                                          = 0x28010AA9ull;
//DUPS: 29010AA9,
static const uint64_t P9N2_EX_5_IMA_TRACE                                          = 0x2A010AA9ull;
//DUPS: 2B010AA9,
static const uint64_t P9N2_EX_6_IMA_TRACE                                          = 0x2C010AA9ull;
//DUPS: 2D010AA9,
static const uint64_t P9N2_EX_7_IMA_TRACE                                          = 0x2F010AA9ull;
//DUPS: 2F010AA9,
static const uint64_t P9N2_EX_8_IMA_TRACE                                          = 0x30010AA9ull;
//DUPS: 31010AA9,
static const uint64_t P9N2_EX_9_IMA_TRACE                                          = 0x32010AA9ull;
//DUPS: 33010AA9,
static const uint64_t P9N2_EX_10_IMA_TRACE                                         = 0x34010AA9ull;
//DUPS: 35010AA9,
static const uint64_t P9N2_EX_11_IMA_TRACE                                         = 0x36010AA9ull;
//DUPS: 37010AA9,

static const uint64_t P9N2_C_INJECT_REG                                            = 0x20050011ull;

static const uint64_t P9N2_C_0_INJECT_REG                                          = 0x20050011ull;

static const uint64_t P9N2_C_1_INJECT_REG                                          = 0x21050011ull;

static const uint64_t P9N2_C_2_INJECT_REG                                          = 0x22050011ull;

static const uint64_t P9N2_C_3_INJECT_REG                                          = 0x23050011ull;

static const uint64_t P9N2_C_4_INJECT_REG                                          = 0x24050011ull;

static const uint64_t P9N2_C_5_INJECT_REG                                          = 0x25050011ull;

static const uint64_t P9N2_C_6_INJECT_REG                                          = 0x26050011ull;

static const uint64_t P9N2_C_7_INJECT_REG                                          = 0x27050011ull;

static const uint64_t P9N2_C_8_INJECT_REG                                          = 0x28050011ull;

static const uint64_t P9N2_C_9_INJECT_REG                                          = 0x29050011ull;

static const uint64_t P9N2_C_10_INJECT_REG                                         = 0x2A050011ull;

static const uint64_t P9N2_C_11_INJECT_REG                                         = 0x2B050011ull;

static const uint64_t P9N2_C_12_INJECT_REG                                         = 0x2C050011ull;

static const uint64_t P9N2_C_13_INJECT_REG                                         = 0x2D050011ull;

static const uint64_t P9N2_C_14_INJECT_REG                                         = 0x2E050011ull;

static const uint64_t P9N2_C_15_INJECT_REG                                         = 0x2F050011ull;

static const uint64_t P9N2_C_16_INJECT_REG                                         = 0x30050011ull;

static const uint64_t P9N2_C_17_INJECT_REG                                         = 0x31050011ull;

static const uint64_t P9N2_C_18_INJECT_REG                                         = 0x32050011ull;

static const uint64_t P9N2_C_19_INJECT_REG                                         = 0x33050011ull;

static const uint64_t P9N2_C_20_INJECT_REG                                         = 0x34050011ull;

static const uint64_t P9N2_C_21_INJECT_REG                                         = 0x35050011ull;

static const uint64_t P9N2_C_22_INJECT_REG                                         = 0x36050011ull;

static const uint64_t P9N2_C_23_INJECT_REG                                         = 0x37050011ull;

static const uint64_t P9N2_EQ_INJECT_REG                                           = 0x10050011ull;

static const uint64_t P9N2_EQ_0_INJECT_REG                                         = 0x10050011ull;

static const uint64_t P9N2_EQ_1_INJECT_REG                                         = 0x11050011ull;

static const uint64_t P9N2_EQ_2_INJECT_REG                                         = 0x12050011ull;

static const uint64_t P9N2_EQ_3_INJECT_REG                                         = 0x13050011ull;

static const uint64_t P9N2_EQ_4_INJECT_REG                                         = 0x14050011ull;

static const uint64_t P9N2_EQ_5_INJECT_REG                                         = 0x15050011ull;

static const uint64_t P9N2_EX_INJECT_REG                                           = 0x20050011ull;
//DUPS: 21050011,
static const uint64_t P9N2_EX_0_INJECT_REG                                         = 0x20050011ull;
//DUPS: 21050011,
static const uint64_t P9N2_EX_1_INJECT_REG                                         = 0x22050011ull;
//DUPS: 23050011,
static const uint64_t P9N2_EX_2_INJECT_REG                                         = 0x24050011ull;
//DUPS: 25050011,
static const uint64_t P9N2_EX_3_INJECT_REG                                         = 0x26050011ull;
//DUPS: 27050011,
static const uint64_t P9N2_EX_4_INJECT_REG                                         = 0x28050011ull;
//DUPS: 29050011,
static const uint64_t P9N2_EX_5_INJECT_REG                                         = 0x2A050011ull;
//DUPS: 2B050011,
static const uint64_t P9N2_EX_6_INJECT_REG                                         = 0x2C050011ull;
//DUPS: 2D050011,
static const uint64_t P9N2_EX_7_INJECT_REG                                         = 0x2F050011ull;
//DUPS: 2F050011,
static const uint64_t P9N2_EX_8_INJECT_REG                                         = 0x30050011ull;
//DUPS: 31050011,
static const uint64_t P9N2_EX_9_INJECT_REG                                         = 0x32050011ull;
//DUPS: 33050011,
static const uint64_t P9N2_EX_10_INJECT_REG                                        = 0x34050011ull;
//DUPS: 35050011,
static const uint64_t P9N2_EX_11_INJECT_REG                                        = 0x36050011ull;
//DUPS: 37050011,

static const uint64_t P9N2_EQ_INJ_REG                                              = 0x1001100Dull;
//DUPS: 1001140D,
static const uint64_t P9N2_EQ_0_INJ_REG                                            = 0x1001100Dull;
//DUPS: 1001140D,
static const uint64_t P9N2_EQ_1_INJ_REG                                            = 0x1101100Dull;
//DUPS: 1101140D,
static const uint64_t P9N2_EQ_2_INJ_REG                                            = 0x1201100Dull;
//DUPS: 1201140D,
static const uint64_t P9N2_EQ_3_INJ_REG                                            = 0x1301100Dull;
//DUPS: 1301140D,
static const uint64_t P9N2_EQ_4_INJ_REG                                            = 0x1401100Dull;
//DUPS: 1401140D,
static const uint64_t P9N2_EQ_5_INJ_REG                                            = 0x1501100Dull;
//DUPS: 1501140D,
static const uint64_t P9N2_EX_INJ_REG                                              = 0x1001100Dull;

static const uint64_t P9N2_EX_0_INJ_REG                                            = 0x1001100Dull;

static const uint64_t P9N2_EX_1_INJ_REG                                            = 0x1001140Dull;

static const uint64_t P9N2_EX_2_INJ_REG                                            = 0x1101100Dull;

static const uint64_t P9N2_EX_3_INJ_REG                                            = 0x1101140Dull;

static const uint64_t P9N2_EX_4_INJ_REG                                            = 0x1201100Dull;

static const uint64_t P9N2_EX_5_INJ_REG                                            = 0x1201140Dull;

static const uint64_t P9N2_EX_6_INJ_REG                                            = 0x1301100Dull;

static const uint64_t P9N2_EX_7_INJ_REG                                            = 0x1301140Dull;

static const uint64_t P9N2_EX_8_INJ_REG                                            = 0x1401100Dull;

static const uint64_t P9N2_EX_9_INJ_REG                                            = 0x1401140Dull;

static const uint64_t P9N2_EX_10_INJ_REG                                           = 0x1501100Dull;

static const uint64_t P9N2_EX_11_INJ_REG                                           = 0x1501140Dull;


static const uint64_t P9N2_C_INV_ERATE                                             = 0x20010AB4ull;

static const uint64_t P9N2_C_0_INV_ERATE                                           = 0x20010AB4ull;

static const uint64_t P9N2_C_1_INV_ERATE                                           = 0x21010AB4ull;

static const uint64_t P9N2_C_2_INV_ERATE                                           = 0x22010AB4ull;

static const uint64_t P9N2_C_3_INV_ERATE                                           = 0x23010AB4ull;

static const uint64_t P9N2_C_4_INV_ERATE                                           = 0x24010AB4ull;

static const uint64_t P9N2_C_5_INV_ERATE                                           = 0x25010AB4ull;

static const uint64_t P9N2_C_6_INV_ERATE                                           = 0x26010AB4ull;

static const uint64_t P9N2_C_7_INV_ERATE                                           = 0x27010AB4ull;

static const uint64_t P9N2_C_8_INV_ERATE                                           = 0x28010AB4ull;

static const uint64_t P9N2_C_9_INV_ERATE                                           = 0x29010AB4ull;

static const uint64_t P9N2_C_10_INV_ERATE                                          = 0x2A010AB4ull;

static const uint64_t P9N2_C_11_INV_ERATE                                          = 0x2B010AB4ull;

static const uint64_t P9N2_C_12_INV_ERATE                                          = 0x2C010AB4ull;

static const uint64_t P9N2_C_13_INV_ERATE                                          = 0x2D010AB4ull;

static const uint64_t P9N2_C_14_INV_ERATE                                          = 0x2E010AB4ull;

static const uint64_t P9N2_C_15_INV_ERATE                                          = 0x2F010AB4ull;

static const uint64_t P9N2_C_16_INV_ERATE                                          = 0x30010AB4ull;

static const uint64_t P9N2_C_17_INV_ERATE                                          = 0x31010AB4ull;

static const uint64_t P9N2_C_18_INV_ERATE                                          = 0x32010AB4ull;

static const uint64_t P9N2_C_19_INV_ERATE                                          = 0x33010AB4ull;

static const uint64_t P9N2_C_20_INV_ERATE                                          = 0x34010AB4ull;

static const uint64_t P9N2_C_21_INV_ERATE                                          = 0x35010AB4ull;

static const uint64_t P9N2_C_22_INV_ERATE                                          = 0x36010AB4ull;

static const uint64_t P9N2_C_23_INV_ERATE                                          = 0x37010AB4ull;

static const uint64_t P9N2_EX_0_L2_INV_ERATE                                       = 0x20010AB4ull;
//DUPS: 21010AB4,
static const uint64_t P9N2_EX_10_L2_INV_ERATE                                      = 0x34010AB4ull;
//DUPS: 35010AB4,
static const uint64_t P9N2_EX_11_L2_INV_ERATE                                      = 0x36010AB4ull;
//DUPS: 37010AB4,
static const uint64_t P9N2_EX_1_L2_INV_ERATE                                       = 0x22010AB4ull;
//DUPS: 23010AB4,
static const uint64_t P9N2_EX_2_L2_INV_ERATE                                       = 0x24010AB4ull;
//DUPS: 25010AB4,
static const uint64_t P9N2_EX_3_L2_INV_ERATE                                       = 0x26010AB4ull;
//DUPS: 27010AB4,
static const uint64_t P9N2_EX_4_L2_INV_ERATE                                       = 0x28010AB4ull;
//DUPS: 29010AB4,
static const uint64_t P9N2_EX_5_L2_INV_ERATE                                       = 0x2A010AB4ull;
//DUPS: 2B010AB4,
static const uint64_t P9N2_EX_6_L2_INV_ERATE                                       = 0x2C010AB4ull;
//DUPS: 2D010AB4,
static const uint64_t P9N2_EX_7_L2_INV_ERATE                                       = 0x2F010AB4ull;
//DUPS: 2F010AB4,
static const uint64_t P9N2_EX_8_L2_INV_ERATE                                       = 0x30010AB4ull;
//DUPS: 31010AB4,
static const uint64_t P9N2_EX_9_L2_INV_ERATE                                       = 0x32010AB4ull;
//DUPS: 33010AB4,
static const uint64_t P9N2_EX_L2_INV_ERATE                                         = 0x20010AB4ull;
//DUPS: 21010AB4,

static const uint64_t P9N2_C_ISU_DEBUG_CTRL                                        = 0x20010C46ull;

static const uint64_t P9N2_C_0_ISU_DEBUG_CTRL                                      = 0x20010C46ull;

static const uint64_t P9N2_C_1_ISU_DEBUG_CTRL                                      = 0x21010C46ull;

static const uint64_t P9N2_C_2_ISU_DEBUG_CTRL                                      = 0x22010C46ull;

static const uint64_t P9N2_C_3_ISU_DEBUG_CTRL                                      = 0x23010C46ull;

static const uint64_t P9N2_C_4_ISU_DEBUG_CTRL                                      = 0x24010C46ull;

static const uint64_t P9N2_C_5_ISU_DEBUG_CTRL                                      = 0x25010C46ull;

static const uint64_t P9N2_C_6_ISU_DEBUG_CTRL                                      = 0x26010C46ull;

static const uint64_t P9N2_C_7_ISU_DEBUG_CTRL                                      = 0x27010C46ull;

static const uint64_t P9N2_C_8_ISU_DEBUG_CTRL                                      = 0x28010C46ull;

static const uint64_t P9N2_C_9_ISU_DEBUG_CTRL                                      = 0x29010C46ull;

static const uint64_t P9N2_C_10_ISU_DEBUG_CTRL                                     = 0x2A010C46ull;

static const uint64_t P9N2_C_11_ISU_DEBUG_CTRL                                     = 0x2B010C46ull;

static const uint64_t P9N2_C_12_ISU_DEBUG_CTRL                                     = 0x2C010C46ull;

static const uint64_t P9N2_C_13_ISU_DEBUG_CTRL                                     = 0x2D010C46ull;

static const uint64_t P9N2_C_14_ISU_DEBUG_CTRL                                     = 0x2E010C46ull;

static const uint64_t P9N2_C_15_ISU_DEBUG_CTRL                                     = 0x2F010C46ull;

static const uint64_t P9N2_C_16_ISU_DEBUG_CTRL                                     = 0x30010C46ull;

static const uint64_t P9N2_C_17_ISU_DEBUG_CTRL                                     = 0x31010C46ull;

static const uint64_t P9N2_C_18_ISU_DEBUG_CTRL                                     = 0x32010C46ull;

static const uint64_t P9N2_C_19_ISU_DEBUG_CTRL                                     = 0x33010C46ull;

static const uint64_t P9N2_C_20_ISU_DEBUG_CTRL                                     = 0x34010C46ull;

static const uint64_t P9N2_C_21_ISU_DEBUG_CTRL                                     = 0x35010C46ull;

static const uint64_t P9N2_C_22_ISU_DEBUG_CTRL                                     = 0x36010C46ull;

static const uint64_t P9N2_C_23_ISU_DEBUG_CTRL                                     = 0x37010C46ull;

static const uint64_t P9N2_EX_0_L2_ISU_DEBUG_CTRL                                  = 0x20010C46ull;
//DUPS: 21010C46,
static const uint64_t P9N2_EX_10_L2_ISU_DEBUG_CTRL                                 = 0x34010C46ull;
//DUPS: 35010C46,
static const uint64_t P9N2_EX_11_L2_ISU_DEBUG_CTRL                                 = 0x36010C46ull;
//DUPS: 37010C46,
static const uint64_t P9N2_EX_1_L2_ISU_DEBUG_CTRL                                  = 0x22010C46ull;
//DUPS: 23010C46,
static const uint64_t P9N2_EX_2_L2_ISU_DEBUG_CTRL                                  = 0x24010C46ull;
//DUPS: 25010C46,
static const uint64_t P9N2_EX_3_L2_ISU_DEBUG_CTRL                                  = 0x26010C46ull;
//DUPS: 27010C46,
static const uint64_t P9N2_EX_4_L2_ISU_DEBUG_CTRL                                  = 0x28010C46ull;
//DUPS: 29010C46,
static const uint64_t P9N2_EX_5_L2_ISU_DEBUG_CTRL                                  = 0x2A010C46ull;
//DUPS: 2B010C46,
static const uint64_t P9N2_EX_6_L2_ISU_DEBUG_CTRL                                  = 0x2C010C46ull;
//DUPS: 2D010C46,
static const uint64_t P9N2_EX_7_L2_ISU_DEBUG_CTRL                                  = 0x2F010C46ull;
//DUPS: 2F010C46,
static const uint64_t P9N2_EX_8_L2_ISU_DEBUG_CTRL                                  = 0x30010C46ull;
//DUPS: 31010C46,
static const uint64_t P9N2_EX_9_L2_ISU_DEBUG_CTRL                                  = 0x32010C46ull;
//DUPS: 33010C46,
static const uint64_t P9N2_EX_L2_ISU_DEBUG_CTRL                                    = 0x20010C46ull;
//DUPS: 21010C46,

static const uint64_t P9N2_C_ISU_REG0_HOLD_OUT                                     = 0x20010C40ull;

static const uint64_t P9N2_C_0_ISU_REG0_HOLD_OUT                                   = 0x20010C40ull;

static const uint64_t P9N2_C_1_ISU_REG0_HOLD_OUT                                   = 0x21010C40ull;

static const uint64_t P9N2_C_2_ISU_REG0_HOLD_OUT                                   = 0x22010C40ull;

static const uint64_t P9N2_C_3_ISU_REG0_HOLD_OUT                                   = 0x23010C40ull;

static const uint64_t P9N2_C_4_ISU_REG0_HOLD_OUT                                   = 0x24010C40ull;

static const uint64_t P9N2_C_5_ISU_REG0_HOLD_OUT                                   = 0x25010C40ull;

static const uint64_t P9N2_C_6_ISU_REG0_HOLD_OUT                                   = 0x26010C40ull;

static const uint64_t P9N2_C_7_ISU_REG0_HOLD_OUT                                   = 0x27010C40ull;

static const uint64_t P9N2_C_8_ISU_REG0_HOLD_OUT                                   = 0x28010C40ull;

static const uint64_t P9N2_C_9_ISU_REG0_HOLD_OUT                                   = 0x29010C40ull;

static const uint64_t P9N2_C_10_ISU_REG0_HOLD_OUT                                  = 0x2A010C40ull;

static const uint64_t P9N2_C_11_ISU_REG0_HOLD_OUT                                  = 0x2B010C40ull;

static const uint64_t P9N2_C_12_ISU_REG0_HOLD_OUT                                  = 0x2C010C40ull;

static const uint64_t P9N2_C_13_ISU_REG0_HOLD_OUT                                  = 0x2D010C40ull;

static const uint64_t P9N2_C_14_ISU_REG0_HOLD_OUT                                  = 0x2E010C40ull;

static const uint64_t P9N2_C_15_ISU_REG0_HOLD_OUT                                  = 0x2F010C40ull;

static const uint64_t P9N2_C_16_ISU_REG0_HOLD_OUT                                  = 0x30010C40ull;

static const uint64_t P9N2_C_17_ISU_REG0_HOLD_OUT                                  = 0x31010C40ull;

static const uint64_t P9N2_C_18_ISU_REG0_HOLD_OUT                                  = 0x32010C40ull;

static const uint64_t P9N2_C_19_ISU_REG0_HOLD_OUT                                  = 0x33010C40ull;

static const uint64_t P9N2_C_20_ISU_REG0_HOLD_OUT                                  = 0x34010C40ull;

static const uint64_t P9N2_C_21_ISU_REG0_HOLD_OUT                                  = 0x35010C40ull;

static const uint64_t P9N2_C_22_ISU_REG0_HOLD_OUT                                  = 0x36010C40ull;

static const uint64_t P9N2_C_23_ISU_REG0_HOLD_OUT                                  = 0x37010C40ull;

static const uint64_t P9N2_EX_0_L2_ISU_REG0_HOLD_OUT                               = 0x20010C40ull;
//DUPS: 21010C40,
static const uint64_t P9N2_EX_10_L2_ISU_REG0_HOLD_OUT                              = 0x34010C40ull;
//DUPS: 35010C40,
static const uint64_t P9N2_EX_11_L2_ISU_REG0_HOLD_OUT                              = 0x36010C40ull;
//DUPS: 37010C40,
static const uint64_t P9N2_EX_1_L2_ISU_REG0_HOLD_OUT                               = 0x22010C40ull;
//DUPS: 23010C40,
static const uint64_t P9N2_EX_2_L2_ISU_REG0_HOLD_OUT                               = 0x24010C40ull;
//DUPS: 25010C40,
static const uint64_t P9N2_EX_3_L2_ISU_REG0_HOLD_OUT                               = 0x26010C40ull;
//DUPS: 27010C40,
static const uint64_t P9N2_EX_4_L2_ISU_REG0_HOLD_OUT                               = 0x28010C40ull;
//DUPS: 29010C40,
static const uint64_t P9N2_EX_5_L2_ISU_REG0_HOLD_OUT                               = 0x2A010C40ull;
//DUPS: 2B010C40,
static const uint64_t P9N2_EX_6_L2_ISU_REG0_HOLD_OUT                               = 0x2C010C40ull;
//DUPS: 2D010C40,
static const uint64_t P9N2_EX_7_L2_ISU_REG0_HOLD_OUT                               = 0x2F010C40ull;
//DUPS: 2F010C40,
static const uint64_t P9N2_EX_8_L2_ISU_REG0_HOLD_OUT                               = 0x30010C40ull;
//DUPS: 31010C40,
static const uint64_t P9N2_EX_9_L2_ISU_REG0_HOLD_OUT                               = 0x32010C40ull;
//DUPS: 33010C40,
static const uint64_t P9N2_EX_L2_ISU_REG0_HOLD_OUT                                 = 0x20010C40ull;
//DUPS: 21010C40,

static const uint64_t P9N2_C_ISU_REG1_HOLD_OUT                                     = 0x20010C41ull;

static const uint64_t P9N2_C_0_ISU_REG1_HOLD_OUT                                   = 0x20010C41ull;

static const uint64_t P9N2_C_1_ISU_REG1_HOLD_OUT                                   = 0x21010C41ull;

static const uint64_t P9N2_C_2_ISU_REG1_HOLD_OUT                                   = 0x22010C41ull;

static const uint64_t P9N2_C_3_ISU_REG1_HOLD_OUT                                   = 0x23010C41ull;

static const uint64_t P9N2_C_4_ISU_REG1_HOLD_OUT                                   = 0x24010C41ull;

static const uint64_t P9N2_C_5_ISU_REG1_HOLD_OUT                                   = 0x25010C41ull;

static const uint64_t P9N2_C_6_ISU_REG1_HOLD_OUT                                   = 0x26010C41ull;

static const uint64_t P9N2_C_7_ISU_REG1_HOLD_OUT                                   = 0x27010C41ull;

static const uint64_t P9N2_C_8_ISU_REG1_HOLD_OUT                                   = 0x28010C41ull;

static const uint64_t P9N2_C_9_ISU_REG1_HOLD_OUT                                   = 0x29010C41ull;

static const uint64_t P9N2_C_10_ISU_REG1_HOLD_OUT                                  = 0x2A010C41ull;

static const uint64_t P9N2_C_11_ISU_REG1_HOLD_OUT                                  = 0x2B010C41ull;

static const uint64_t P9N2_C_12_ISU_REG1_HOLD_OUT                                  = 0x2C010C41ull;

static const uint64_t P9N2_C_13_ISU_REG1_HOLD_OUT                                  = 0x2D010C41ull;

static const uint64_t P9N2_C_14_ISU_REG1_HOLD_OUT                                  = 0x2E010C41ull;

static const uint64_t P9N2_C_15_ISU_REG1_HOLD_OUT                                  = 0x2F010C41ull;

static const uint64_t P9N2_C_16_ISU_REG1_HOLD_OUT                                  = 0x30010C41ull;

static const uint64_t P9N2_C_17_ISU_REG1_HOLD_OUT                                  = 0x31010C41ull;

static const uint64_t P9N2_C_18_ISU_REG1_HOLD_OUT                                  = 0x32010C41ull;

static const uint64_t P9N2_C_19_ISU_REG1_HOLD_OUT                                  = 0x33010C41ull;

static const uint64_t P9N2_C_20_ISU_REG1_HOLD_OUT                                  = 0x34010C41ull;

static const uint64_t P9N2_C_21_ISU_REG1_HOLD_OUT                                  = 0x35010C41ull;

static const uint64_t P9N2_C_22_ISU_REG1_HOLD_OUT                                  = 0x36010C41ull;

static const uint64_t P9N2_C_23_ISU_REG1_HOLD_OUT                                  = 0x37010C41ull;

static const uint64_t P9N2_EX_0_L2_ISU_REG1_HOLD_OUT                               = 0x20010C41ull;
//DUPS: 21010C41,
static const uint64_t P9N2_EX_10_L2_ISU_REG1_HOLD_OUT                              = 0x34010C41ull;
//DUPS: 35010C41,
static const uint64_t P9N2_EX_11_L2_ISU_REG1_HOLD_OUT                              = 0x36010C41ull;
//DUPS: 37010C41,
static const uint64_t P9N2_EX_1_L2_ISU_REG1_HOLD_OUT                               = 0x22010C41ull;
//DUPS: 23010C41,
static const uint64_t P9N2_EX_2_L2_ISU_REG1_HOLD_OUT                               = 0x24010C41ull;
//DUPS: 25010C41,
static const uint64_t P9N2_EX_3_L2_ISU_REG1_HOLD_OUT                               = 0x26010C41ull;
//DUPS: 27010C41,
static const uint64_t P9N2_EX_4_L2_ISU_REG1_HOLD_OUT                               = 0x28010C41ull;
//DUPS: 29010C41,
static const uint64_t P9N2_EX_5_L2_ISU_REG1_HOLD_OUT                               = 0x2A010C41ull;
//DUPS: 2B010C41,
static const uint64_t P9N2_EX_6_L2_ISU_REG1_HOLD_OUT                               = 0x2C010C41ull;
//DUPS: 2D010C41,
static const uint64_t P9N2_EX_7_L2_ISU_REG1_HOLD_OUT                               = 0x2F010C41ull;
//DUPS: 2F010C41,
static const uint64_t P9N2_EX_8_L2_ISU_REG1_HOLD_OUT                               = 0x30010C41ull;
//DUPS: 31010C41,
static const uint64_t P9N2_EX_9_L2_ISU_REG1_HOLD_OUT                               = 0x32010C41ull;
//DUPS: 33010C41,
static const uint64_t P9N2_EX_L2_ISU_REG1_HOLD_OUT                                 = 0x20010C41ull;
//DUPS: 21010C41,

static const uint64_t P9N2_C_ISU_REG2_HOLD_OUT                                     = 0x20010C42ull;

static const uint64_t P9N2_C_0_ISU_REG2_HOLD_OUT                                   = 0x20010C42ull;

static const uint64_t P9N2_C_1_ISU_REG2_HOLD_OUT                                   = 0x21010C42ull;

static const uint64_t P9N2_C_2_ISU_REG2_HOLD_OUT                                   = 0x22010C42ull;

static const uint64_t P9N2_C_3_ISU_REG2_HOLD_OUT                                   = 0x23010C42ull;

static const uint64_t P9N2_C_4_ISU_REG2_HOLD_OUT                                   = 0x24010C42ull;

static const uint64_t P9N2_C_5_ISU_REG2_HOLD_OUT                                   = 0x25010C42ull;

static const uint64_t P9N2_C_6_ISU_REG2_HOLD_OUT                                   = 0x26010C42ull;

static const uint64_t P9N2_C_7_ISU_REG2_HOLD_OUT                                   = 0x27010C42ull;

static const uint64_t P9N2_C_8_ISU_REG2_HOLD_OUT                                   = 0x28010C42ull;

static const uint64_t P9N2_C_9_ISU_REG2_HOLD_OUT                                   = 0x29010C42ull;

static const uint64_t P9N2_C_10_ISU_REG2_HOLD_OUT                                  = 0x2A010C42ull;

static const uint64_t P9N2_C_11_ISU_REG2_HOLD_OUT                                  = 0x2B010C42ull;

static const uint64_t P9N2_C_12_ISU_REG2_HOLD_OUT                                  = 0x2C010C42ull;

static const uint64_t P9N2_C_13_ISU_REG2_HOLD_OUT                                  = 0x2D010C42ull;

static const uint64_t P9N2_C_14_ISU_REG2_HOLD_OUT                                  = 0x2E010C42ull;

static const uint64_t P9N2_C_15_ISU_REG2_HOLD_OUT                                  = 0x2F010C42ull;

static const uint64_t P9N2_C_16_ISU_REG2_HOLD_OUT                                  = 0x30010C42ull;

static const uint64_t P9N2_C_17_ISU_REG2_HOLD_OUT                                  = 0x31010C42ull;

static const uint64_t P9N2_C_18_ISU_REG2_HOLD_OUT                                  = 0x32010C42ull;

static const uint64_t P9N2_C_19_ISU_REG2_HOLD_OUT                                  = 0x33010C42ull;

static const uint64_t P9N2_C_20_ISU_REG2_HOLD_OUT                                  = 0x34010C42ull;

static const uint64_t P9N2_C_21_ISU_REG2_HOLD_OUT                                  = 0x35010C42ull;

static const uint64_t P9N2_C_22_ISU_REG2_HOLD_OUT                                  = 0x36010C42ull;

static const uint64_t P9N2_C_23_ISU_REG2_HOLD_OUT                                  = 0x37010C42ull;

static const uint64_t P9N2_EX_0_L2_ISU_REG2_HOLD_OUT                               = 0x20010C42ull;
//DUPS: 21010C42,
static const uint64_t P9N2_EX_10_L2_ISU_REG2_HOLD_OUT                              = 0x34010C42ull;
//DUPS: 35010C42,
static const uint64_t P9N2_EX_11_L2_ISU_REG2_HOLD_OUT                              = 0x36010C42ull;
//DUPS: 37010C42,
static const uint64_t P9N2_EX_1_L2_ISU_REG2_HOLD_OUT                               = 0x22010C42ull;
//DUPS: 23010C42,
static const uint64_t P9N2_EX_2_L2_ISU_REG2_HOLD_OUT                               = 0x24010C42ull;
//DUPS: 25010C42,
static const uint64_t P9N2_EX_3_L2_ISU_REG2_HOLD_OUT                               = 0x26010C42ull;
//DUPS: 27010C42,
static const uint64_t P9N2_EX_4_L2_ISU_REG2_HOLD_OUT                               = 0x28010C42ull;
//DUPS: 29010C42,
static const uint64_t P9N2_EX_5_L2_ISU_REG2_HOLD_OUT                               = 0x2A010C42ull;
//DUPS: 2B010C42,
static const uint64_t P9N2_EX_6_L2_ISU_REG2_HOLD_OUT                               = 0x2C010C42ull;
//DUPS: 2D010C42,
static const uint64_t P9N2_EX_7_L2_ISU_REG2_HOLD_OUT                               = 0x2F010C42ull;
//DUPS: 2F010C42,
static const uint64_t P9N2_EX_8_L2_ISU_REG2_HOLD_OUT                               = 0x30010C42ull;
//DUPS: 31010C42,
static const uint64_t P9N2_EX_9_L2_ISU_REG2_HOLD_OUT                               = 0x32010C42ull;
//DUPS: 33010C42,
static const uint64_t P9N2_EX_L2_ISU_REG2_HOLD_OUT                                 = 0x20010C42ull;
//DUPS: 21010C42,

static const uint64_t P9N2_C_ISU_REG3_HOLD_OUT                                     = 0x20010C43ull;

static const uint64_t P9N2_C_0_ISU_REG3_HOLD_OUT                                   = 0x20010C43ull;

static const uint64_t P9N2_C_1_ISU_REG3_HOLD_OUT                                   = 0x21010C43ull;

static const uint64_t P9N2_C_2_ISU_REG3_HOLD_OUT                                   = 0x22010C43ull;

static const uint64_t P9N2_C_3_ISU_REG3_HOLD_OUT                                   = 0x23010C43ull;

static const uint64_t P9N2_C_4_ISU_REG3_HOLD_OUT                                   = 0x24010C43ull;

static const uint64_t P9N2_C_5_ISU_REG3_HOLD_OUT                                   = 0x25010C43ull;

static const uint64_t P9N2_C_6_ISU_REG3_HOLD_OUT                                   = 0x26010C43ull;

static const uint64_t P9N2_C_7_ISU_REG3_HOLD_OUT                                   = 0x27010C43ull;

static const uint64_t P9N2_C_8_ISU_REG3_HOLD_OUT                                   = 0x28010C43ull;

static const uint64_t P9N2_C_9_ISU_REG3_HOLD_OUT                                   = 0x29010C43ull;

static const uint64_t P9N2_C_10_ISU_REG3_HOLD_OUT                                  = 0x2A010C43ull;

static const uint64_t P9N2_C_11_ISU_REG3_HOLD_OUT                                  = 0x2B010C43ull;

static const uint64_t P9N2_C_12_ISU_REG3_HOLD_OUT                                  = 0x2C010C43ull;

static const uint64_t P9N2_C_13_ISU_REG3_HOLD_OUT                                  = 0x2D010C43ull;

static const uint64_t P9N2_C_14_ISU_REG3_HOLD_OUT                                  = 0x2E010C43ull;

static const uint64_t P9N2_C_15_ISU_REG3_HOLD_OUT                                  = 0x2F010C43ull;

static const uint64_t P9N2_C_16_ISU_REG3_HOLD_OUT                                  = 0x30010C43ull;

static const uint64_t P9N2_C_17_ISU_REG3_HOLD_OUT                                  = 0x31010C43ull;

static const uint64_t P9N2_C_18_ISU_REG3_HOLD_OUT                                  = 0x32010C43ull;

static const uint64_t P9N2_C_19_ISU_REG3_HOLD_OUT                                  = 0x33010C43ull;

static const uint64_t P9N2_C_20_ISU_REG3_HOLD_OUT                                  = 0x34010C43ull;

static const uint64_t P9N2_C_21_ISU_REG3_HOLD_OUT                                  = 0x35010C43ull;

static const uint64_t P9N2_C_22_ISU_REG3_HOLD_OUT                                  = 0x36010C43ull;

static const uint64_t P9N2_C_23_ISU_REG3_HOLD_OUT                                  = 0x37010C43ull;

static const uint64_t P9N2_EX_0_L2_ISU_REG3_HOLD_OUT                               = 0x20010C43ull;
//DUPS: 21010C43,
static const uint64_t P9N2_EX_10_L2_ISU_REG3_HOLD_OUT                              = 0x34010C43ull;
//DUPS: 35010C43,
static const uint64_t P9N2_EX_11_L2_ISU_REG3_HOLD_OUT                              = 0x36010C43ull;
//DUPS: 37010C43,
static const uint64_t P9N2_EX_1_L2_ISU_REG3_HOLD_OUT                               = 0x22010C43ull;
//DUPS: 23010C43,
static const uint64_t P9N2_EX_2_L2_ISU_REG3_HOLD_OUT                               = 0x24010C43ull;
//DUPS: 25010C43,
static const uint64_t P9N2_EX_3_L2_ISU_REG3_HOLD_OUT                               = 0x26010C43ull;
//DUPS: 27010C43,
static const uint64_t P9N2_EX_4_L2_ISU_REG3_HOLD_OUT                               = 0x28010C43ull;
//DUPS: 29010C43,
static const uint64_t P9N2_EX_5_L2_ISU_REG3_HOLD_OUT                               = 0x2A010C43ull;
//DUPS: 2B010C43,
static const uint64_t P9N2_EX_6_L2_ISU_REG3_HOLD_OUT                               = 0x2C010C43ull;
//DUPS: 2D010C43,
static const uint64_t P9N2_EX_7_L2_ISU_REG3_HOLD_OUT                               = 0x2F010C43ull;
//DUPS: 2F010C43,
static const uint64_t P9N2_EX_8_L2_ISU_REG3_HOLD_OUT                               = 0x30010C43ull;
//DUPS: 31010C43,
static const uint64_t P9N2_EX_9_L2_ISU_REG3_HOLD_OUT                               = 0x32010C43ull;
//DUPS: 33010C43,
static const uint64_t P9N2_EX_L2_ISU_REG3_HOLD_OUT                                 = 0x20010C43ull;
//DUPS: 21010C43,

static const uint64_t P9N2_C_ISU_REG4_HOLD_OUT                                     = 0x20010C44ull;

static const uint64_t P9N2_C_0_ISU_REG4_HOLD_OUT                                   = 0x20010C44ull;

static const uint64_t P9N2_C_1_ISU_REG4_HOLD_OUT                                   = 0x21010C44ull;

static const uint64_t P9N2_C_2_ISU_REG4_HOLD_OUT                                   = 0x22010C44ull;

static const uint64_t P9N2_C_3_ISU_REG4_HOLD_OUT                                   = 0x23010C44ull;

static const uint64_t P9N2_C_4_ISU_REG4_HOLD_OUT                                   = 0x24010C44ull;

static const uint64_t P9N2_C_5_ISU_REG4_HOLD_OUT                                   = 0x25010C44ull;

static const uint64_t P9N2_C_6_ISU_REG4_HOLD_OUT                                   = 0x26010C44ull;

static const uint64_t P9N2_C_7_ISU_REG4_HOLD_OUT                                   = 0x27010C44ull;

static const uint64_t P9N2_C_8_ISU_REG4_HOLD_OUT                                   = 0x28010C44ull;

static const uint64_t P9N2_C_9_ISU_REG4_HOLD_OUT                                   = 0x29010C44ull;

static const uint64_t P9N2_C_10_ISU_REG4_HOLD_OUT                                  = 0x2A010C44ull;

static const uint64_t P9N2_C_11_ISU_REG4_HOLD_OUT                                  = 0x2B010C44ull;

static const uint64_t P9N2_C_12_ISU_REG4_HOLD_OUT                                  = 0x2C010C44ull;

static const uint64_t P9N2_C_13_ISU_REG4_HOLD_OUT                                  = 0x2D010C44ull;

static const uint64_t P9N2_C_14_ISU_REG4_HOLD_OUT                                  = 0x2E010C44ull;

static const uint64_t P9N2_C_15_ISU_REG4_HOLD_OUT                                  = 0x2F010C44ull;

static const uint64_t P9N2_C_16_ISU_REG4_HOLD_OUT                                  = 0x30010C44ull;

static const uint64_t P9N2_C_17_ISU_REG4_HOLD_OUT                                  = 0x31010C44ull;

static const uint64_t P9N2_C_18_ISU_REG4_HOLD_OUT                                  = 0x32010C44ull;

static const uint64_t P9N2_C_19_ISU_REG4_HOLD_OUT                                  = 0x33010C44ull;

static const uint64_t P9N2_C_20_ISU_REG4_HOLD_OUT                                  = 0x34010C44ull;

static const uint64_t P9N2_C_21_ISU_REG4_HOLD_OUT                                  = 0x35010C44ull;

static const uint64_t P9N2_C_22_ISU_REG4_HOLD_OUT                                  = 0x36010C44ull;

static const uint64_t P9N2_C_23_ISU_REG4_HOLD_OUT                                  = 0x37010C44ull;

static const uint64_t P9N2_EX_0_L2_ISU_REG4_HOLD_OUT                               = 0x20010C44ull;
//DUPS: 21010C44,
static const uint64_t P9N2_EX_10_L2_ISU_REG4_HOLD_OUT                              = 0x34010C44ull;
//DUPS: 35010C44,
static const uint64_t P9N2_EX_11_L2_ISU_REG4_HOLD_OUT                              = 0x36010C44ull;
//DUPS: 37010C44,
static const uint64_t P9N2_EX_1_L2_ISU_REG4_HOLD_OUT                               = 0x22010C44ull;
//DUPS: 23010C44,
static const uint64_t P9N2_EX_2_L2_ISU_REG4_HOLD_OUT                               = 0x24010C44ull;
//DUPS: 25010C44,
static const uint64_t P9N2_EX_3_L2_ISU_REG4_HOLD_OUT                               = 0x26010C44ull;
//DUPS: 27010C44,
static const uint64_t P9N2_EX_4_L2_ISU_REG4_HOLD_OUT                               = 0x28010C44ull;
//DUPS: 29010C44,
static const uint64_t P9N2_EX_5_L2_ISU_REG4_HOLD_OUT                               = 0x2A010C44ull;
//DUPS: 2B010C44,
static const uint64_t P9N2_EX_6_L2_ISU_REG4_HOLD_OUT                               = 0x2C010C44ull;
//DUPS: 2D010C44,
static const uint64_t P9N2_EX_7_L2_ISU_REG4_HOLD_OUT                               = 0x2F010C44ull;
//DUPS: 2F010C44,
static const uint64_t P9N2_EX_8_L2_ISU_REG4_HOLD_OUT                               = 0x30010C44ull;
//DUPS: 31010C44,
static const uint64_t P9N2_EX_9_L2_ISU_REG4_HOLD_OUT                               = 0x32010C44ull;
//DUPS: 33010C44,
static const uint64_t P9N2_EX_L2_ISU_REG4_HOLD_OUT                                 = 0x20010C44ull;
//DUPS: 21010C44,

static const uint64_t P9N2_C_ISU_REG5_HOLD_OUT                                     = 0x20010C45ull;

static const uint64_t P9N2_C_0_ISU_REG5_HOLD_OUT                                   = 0x20010C45ull;

static const uint64_t P9N2_C_1_ISU_REG5_HOLD_OUT                                   = 0x21010C45ull;

static const uint64_t P9N2_C_2_ISU_REG5_HOLD_OUT                                   = 0x22010C45ull;

static const uint64_t P9N2_C_3_ISU_REG5_HOLD_OUT                                   = 0x23010C45ull;

static const uint64_t P9N2_C_4_ISU_REG5_HOLD_OUT                                   = 0x24010C45ull;

static const uint64_t P9N2_C_5_ISU_REG5_HOLD_OUT                                   = 0x25010C45ull;

static const uint64_t P9N2_C_6_ISU_REG5_HOLD_OUT                                   = 0x26010C45ull;

static const uint64_t P9N2_C_7_ISU_REG5_HOLD_OUT                                   = 0x27010C45ull;

static const uint64_t P9N2_C_8_ISU_REG5_HOLD_OUT                                   = 0x28010C45ull;

static const uint64_t P9N2_C_9_ISU_REG5_HOLD_OUT                                   = 0x29010C45ull;

static const uint64_t P9N2_C_10_ISU_REG5_HOLD_OUT                                  = 0x2A010C45ull;

static const uint64_t P9N2_C_11_ISU_REG5_HOLD_OUT                                  = 0x2B010C45ull;

static const uint64_t P9N2_C_12_ISU_REG5_HOLD_OUT                                  = 0x2C010C45ull;

static const uint64_t P9N2_C_13_ISU_REG5_HOLD_OUT                                  = 0x2D010C45ull;

static const uint64_t P9N2_C_14_ISU_REG5_HOLD_OUT                                  = 0x2E010C45ull;

static const uint64_t P9N2_C_15_ISU_REG5_HOLD_OUT                                  = 0x2F010C45ull;

static const uint64_t P9N2_C_16_ISU_REG5_HOLD_OUT                                  = 0x30010C45ull;

static const uint64_t P9N2_C_17_ISU_REG5_HOLD_OUT                                  = 0x31010C45ull;

static const uint64_t P9N2_C_18_ISU_REG5_HOLD_OUT                                  = 0x32010C45ull;

static const uint64_t P9N2_C_19_ISU_REG5_HOLD_OUT                                  = 0x33010C45ull;

static const uint64_t P9N2_C_20_ISU_REG5_HOLD_OUT                                  = 0x34010C45ull;

static const uint64_t P9N2_C_21_ISU_REG5_HOLD_OUT                                  = 0x35010C45ull;

static const uint64_t P9N2_C_22_ISU_REG5_HOLD_OUT                                  = 0x36010C45ull;

static const uint64_t P9N2_C_23_ISU_REG5_HOLD_OUT                                  = 0x37010C45ull;

static const uint64_t P9N2_EX_0_L2_ISU_REG5_HOLD_OUT                               = 0x20010C45ull;
//DUPS: 21010C45,
static const uint64_t P9N2_EX_10_L2_ISU_REG5_HOLD_OUT                              = 0x34010C45ull;
//DUPS: 35010C45,
static const uint64_t P9N2_EX_11_L2_ISU_REG5_HOLD_OUT                              = 0x36010C45ull;
//DUPS: 37010C45,
static const uint64_t P9N2_EX_1_L2_ISU_REG5_HOLD_OUT                               = 0x22010C45ull;
//DUPS: 23010C45,
static const uint64_t P9N2_EX_2_L2_ISU_REG5_HOLD_OUT                               = 0x24010C45ull;
//DUPS: 25010C45,
static const uint64_t P9N2_EX_3_L2_ISU_REG5_HOLD_OUT                               = 0x26010C45ull;
//DUPS: 27010C45,
static const uint64_t P9N2_EX_4_L2_ISU_REG5_HOLD_OUT                               = 0x28010C45ull;
//DUPS: 29010C45,
static const uint64_t P9N2_EX_5_L2_ISU_REG5_HOLD_OUT                               = 0x2A010C45ull;
//DUPS: 2B010C45,
static const uint64_t P9N2_EX_6_L2_ISU_REG5_HOLD_OUT                               = 0x2C010C45ull;
//DUPS: 2D010C45,
static const uint64_t P9N2_EX_7_L2_ISU_REG5_HOLD_OUT                               = 0x2F010C45ull;
//DUPS: 2F010C45,
static const uint64_t P9N2_EX_8_L2_ISU_REG5_HOLD_OUT                               = 0x30010C45ull;
//DUPS: 31010C45,
static const uint64_t P9N2_EX_9_L2_ISU_REG5_HOLD_OUT                               = 0x32010C45ull;
//DUPS: 33010C45,
static const uint64_t P9N2_EX_L2_ISU_REG5_HOLD_OUT                                 = 0x20010C45ull;
//DUPS: 21010C45,

static const uint64_t P9N2_EQ_L3_ERR_RPT0_REG                                      = 0x10011C10ull;
//DUPS: 10011C10,
static const uint64_t P9N2_EQ_0_L3_ERR_RPT0_REG                                    = 0x10011C10ull;
//DUPS: 10011C10,
static const uint64_t P9N2_EQ_1_L3_ERR_RPT0_REG                                    = 0x11011C10ull;
//DUPS: 11011C10,
static const uint64_t P9N2_EQ_2_L3_ERR_RPT0_REG                                    = 0x12011C10ull;
//DUPS: 12011C10,
static const uint64_t P9N2_EQ_3_L3_ERR_RPT0_REG                                    = 0x13011C10ull;
//DUPS: 13011C10,
static const uint64_t P9N2_EQ_4_L3_ERR_RPT0_REG                                    = 0x14011C10ull;
//DUPS: 14011C10,
static const uint64_t P9N2_EQ_5_L3_ERR_RPT0_REG                                    = 0x15011C10ull;
//DUPS: 15011C10,
static const uint64_t P9N2_EX_0_L3_L3_ERR_RPT0_REG                                 = 0x10011810ull;

static const uint64_t P9N2_EX_10_L3_L3_ERR_RPT0_REG                                = 0x15011810ull;

static const uint64_t P9N2_EX_11_L3_L3_ERR_RPT0_REG                                = 0x15011C10ull;

static const uint64_t P9N2_EX_1_L3_L3_ERR_RPT0_REG                                 = 0x10011C10ull;

static const uint64_t P9N2_EX_2_L3_L3_ERR_RPT0_REG                                 = 0x11011810ull;

static const uint64_t P9N2_EX_3_L3_L3_ERR_RPT0_REG                                 = 0x11011C10ull;

static const uint64_t P9N2_EX_4_L3_L3_ERR_RPT0_REG                                 = 0x12011810ull;

static const uint64_t P9N2_EX_5_L3_L3_ERR_RPT0_REG                                 = 0x12011C10ull;

static const uint64_t P9N2_EX_6_L3_L3_ERR_RPT0_REG                                 = 0x13011810ull;

static const uint64_t P9N2_EX_7_L3_L3_ERR_RPT0_REG                                 = 0x13011C10ull;

static const uint64_t P9N2_EX_8_L3_L3_ERR_RPT0_REG                                 = 0x14011810ull;

static const uint64_t P9N2_EX_9_L3_L3_ERR_RPT0_REG                                 = 0x14011C10ull;

static const uint64_t P9N2_EX_L3_L3_ERR_RPT0_REG                                   = 0x10011810ull;


static const uint64_t P9N2_EQ_L3_ERR_RPT1_REG                                      = 0x10011C17ull;
//DUPS: 10011C17,
static const uint64_t P9N2_EQ_0_L3_ERR_RPT1_REG                                    = 0x10011C17ull;
//DUPS: 10011C17,
static const uint64_t P9N2_EQ_1_L3_ERR_RPT1_REG                                    = 0x11011C17ull;
//DUPS: 11011C17,
static const uint64_t P9N2_EQ_2_L3_ERR_RPT1_REG                                    = 0x12011C17ull;
//DUPS: 12011C17,
static const uint64_t P9N2_EQ_3_L3_ERR_RPT1_REG                                    = 0x13011C17ull;
//DUPS: 13011C17,
static const uint64_t P9N2_EQ_4_L3_ERR_RPT1_REG                                    = 0x14011C17ull;
//DUPS: 14011C17,
static const uint64_t P9N2_EQ_5_L3_ERR_RPT1_REG                                    = 0x15011C17ull;
//DUPS: 15011C17,
static const uint64_t P9N2_EX_0_L3_L3_ERR_RPT1_REG                                 = 0x10011817ull;

static const uint64_t P9N2_EX_10_L3_L3_ERR_RPT1_REG                                = 0x15011817ull;

static const uint64_t P9N2_EX_11_L3_L3_ERR_RPT1_REG                                = 0x15011C17ull;

static const uint64_t P9N2_EX_1_L3_L3_ERR_RPT1_REG                                 = 0x10011C17ull;

static const uint64_t P9N2_EX_2_L3_L3_ERR_RPT1_REG                                 = 0x11011817ull;

static const uint64_t P9N2_EX_3_L3_L3_ERR_RPT1_REG                                 = 0x11011C17ull;

static const uint64_t P9N2_EX_4_L3_L3_ERR_RPT1_REG                                 = 0x12011817ull;

static const uint64_t P9N2_EX_5_L3_L3_ERR_RPT1_REG                                 = 0x12011C17ull;

static const uint64_t P9N2_EX_6_L3_L3_ERR_RPT1_REG                                 = 0x13011817ull;

static const uint64_t P9N2_EX_7_L3_L3_ERR_RPT1_REG                                 = 0x13011C17ull;

static const uint64_t P9N2_EX_8_L3_L3_ERR_RPT1_REG                                 = 0x14011817ull;

static const uint64_t P9N2_EX_9_L3_L3_ERR_RPT1_REG                                 = 0x14011C17ull;

static const uint64_t P9N2_EX_L3_L3_ERR_RPT1_REG                                   = 0x10011817ull;


static const uint64_t P9N2_EQ_L3_RD_EPSILON_CFG_REG                                = 0x10011C29ull;
//DUPS: 10011C29,
static const uint64_t P9N2_EQ_0_L3_RD_EPSILON_CFG_REG                              = 0x10011C29ull;
//DUPS: 10011C29,
static const uint64_t P9N2_EQ_1_L3_RD_EPSILON_CFG_REG                              = 0x11011C29ull;
//DUPS: 11011C29,
static const uint64_t P9N2_EQ_2_L3_RD_EPSILON_CFG_REG                              = 0x12011C29ull;
//DUPS: 12011C29,
static const uint64_t P9N2_EQ_3_L3_RD_EPSILON_CFG_REG                              = 0x13011C29ull;
//DUPS: 13011C29,
static const uint64_t P9N2_EQ_4_L3_RD_EPSILON_CFG_REG                              = 0x14011C29ull;
//DUPS: 14011C29,
static const uint64_t P9N2_EQ_5_L3_RD_EPSILON_CFG_REG                              = 0x15011C29ull;
//DUPS: 15011C29,
static const uint64_t P9N2_EX_L3_RD_EPSILON_CFG_REG                                = 0x10011829ull;

static const uint64_t P9N2_EX_0_L3_RD_EPSILON_CFG_REG                              = 0x10011829ull;

static const uint64_t P9N2_EX_1_L3_RD_EPSILON_CFG_REG                              = 0x10011C29ull;

static const uint64_t P9N2_EX_2_L3_RD_EPSILON_CFG_REG                              = 0x11011829ull;

static const uint64_t P9N2_EX_3_L3_RD_EPSILON_CFG_REG                              = 0x11011C29ull;

static const uint64_t P9N2_EX_4_L3_RD_EPSILON_CFG_REG                              = 0x12011829ull;

static const uint64_t P9N2_EX_5_L3_RD_EPSILON_CFG_REG                              = 0x12011C29ull;

static const uint64_t P9N2_EX_6_L3_RD_EPSILON_CFG_REG                              = 0x13011829ull;

static const uint64_t P9N2_EX_7_L3_RD_EPSILON_CFG_REG                              = 0x13011C29ull;

static const uint64_t P9N2_EX_8_L3_RD_EPSILON_CFG_REG                              = 0x14011829ull;

static const uint64_t P9N2_EX_9_L3_RD_EPSILON_CFG_REG                              = 0x14011C29ull;

static const uint64_t P9N2_EX_10_L3_RD_EPSILON_CFG_REG                             = 0x15011829ull;

static const uint64_t P9N2_EX_11_L3_RD_EPSILON_CFG_REG                             = 0x15011C29ull;


static const uint64_t P9N2_EQ_L3_RTIM_PERIOD_MONITOR                               = 0x10011C12ull;
//DUPS: 10011C12,
static const uint64_t P9N2_EQ_0_L3_RTIM_PERIOD_MONITOR                             = 0x10011C12ull;
//DUPS: 10011C12,
static const uint64_t P9N2_EQ_1_L3_RTIM_PERIOD_MONITOR                             = 0x11011C12ull;
//DUPS: 11011C12,
static const uint64_t P9N2_EQ_2_L3_RTIM_PERIOD_MONITOR                             = 0x12011C12ull;
//DUPS: 12011C12,
static const uint64_t P9N2_EQ_3_L3_RTIM_PERIOD_MONITOR                             = 0x13011C12ull;
//DUPS: 13011C12,
static const uint64_t P9N2_EQ_4_L3_RTIM_PERIOD_MONITOR                             = 0x14011C12ull;
//DUPS: 14011C12,
static const uint64_t P9N2_EQ_5_L3_RTIM_PERIOD_MONITOR                             = 0x15011C12ull;
//DUPS: 15011C12,
static const uint64_t P9N2_EX_0_L3_L3_RTIM_PERIOD_MONITOR                          = 0x10011812ull;

static const uint64_t P9N2_EX_10_L3_L3_RTIM_PERIOD_MONITOR                         = 0x15011812ull;

static const uint64_t P9N2_EX_11_L3_L3_RTIM_PERIOD_MONITOR                         = 0x15011C12ull;

static const uint64_t P9N2_EX_1_L3_L3_RTIM_PERIOD_MONITOR                          = 0x10011C12ull;

static const uint64_t P9N2_EX_2_L3_L3_RTIM_PERIOD_MONITOR                          = 0x11011812ull;

static const uint64_t P9N2_EX_3_L3_L3_RTIM_PERIOD_MONITOR                          = 0x11011C12ull;

static const uint64_t P9N2_EX_4_L3_L3_RTIM_PERIOD_MONITOR                          = 0x12011812ull;

static const uint64_t P9N2_EX_5_L3_L3_RTIM_PERIOD_MONITOR                          = 0x12011C12ull;

static const uint64_t P9N2_EX_6_L3_L3_RTIM_PERIOD_MONITOR                          = 0x13011812ull;

static const uint64_t P9N2_EX_7_L3_L3_RTIM_PERIOD_MONITOR                          = 0x13011C12ull;

static const uint64_t P9N2_EX_8_L3_L3_RTIM_PERIOD_MONITOR                          = 0x14011812ull;

static const uint64_t P9N2_EX_9_L3_L3_RTIM_PERIOD_MONITOR                          = 0x14011C12ull;

static const uint64_t P9N2_EX_L3_L3_RTIM_PERIOD_MONITOR                            = 0x10011812ull;


static const uint64_t P9N2_EQ_L3_WR_EPSILON_CFG_REG                                = 0x10011C2Aull;
//DUPS: 10011C2A,
static const uint64_t P9N2_EQ_0_L3_WR_EPSILON_CFG_REG                              = 0x10011C2Aull;
//DUPS: 10011C2A,
static const uint64_t P9N2_EQ_1_L3_WR_EPSILON_CFG_REG                              = 0x11011C2Aull;
//DUPS: 11011C2A,
static const uint64_t P9N2_EQ_2_L3_WR_EPSILON_CFG_REG                              = 0x12011C2Aull;
//DUPS: 12011C2A,
static const uint64_t P9N2_EQ_3_L3_WR_EPSILON_CFG_REG                              = 0x13011C2Aull;
//DUPS: 13011C2A,
static const uint64_t P9N2_EQ_4_L3_WR_EPSILON_CFG_REG                              = 0x14011C2Aull;
//DUPS: 14011C2A,
static const uint64_t P9N2_EQ_5_L3_WR_EPSILON_CFG_REG                              = 0x15011C2Aull;
//DUPS: 15011C2A,
static const uint64_t P9N2_EX_0_L3_L3_WR_EPSILON_CFG_REG                           = 0x1001182Aull;

static const uint64_t P9N2_EX_10_L3_L3_WR_EPSILON_CFG_REG                          = 0x1501182Aull;

static const uint64_t P9N2_EX_11_L3_L3_WR_EPSILON_CFG_REG                          = 0x15011C2Aull;

static const uint64_t P9N2_EX_1_L3_L3_WR_EPSILON_CFG_REG                           = 0x10011C2Aull;

static const uint64_t P9N2_EX_2_L3_L3_WR_EPSILON_CFG_REG                           = 0x1101182Aull;

static const uint64_t P9N2_EX_3_L3_L3_WR_EPSILON_CFG_REG                           = 0x11011C2Aull;

static const uint64_t P9N2_EX_4_L3_L3_WR_EPSILON_CFG_REG                           = 0x1201182Aull;

static const uint64_t P9N2_EX_5_L3_L3_WR_EPSILON_CFG_REG                           = 0x12011C2Aull;

static const uint64_t P9N2_EX_6_L3_L3_WR_EPSILON_CFG_REG                           = 0x1301182Aull;

static const uint64_t P9N2_EX_7_L3_L3_WR_EPSILON_CFG_REG                           = 0x13011C2Aull;

static const uint64_t P9N2_EX_8_L3_L3_WR_EPSILON_CFG_REG                           = 0x1401182Aull;

static const uint64_t P9N2_EX_9_L3_L3_WR_EPSILON_CFG_REG                           = 0x14011C2Aull;

static const uint64_t P9N2_EX_L3_L3_WR_EPSILON_CFG_REG                             = 0x1001182Aull;


static const uint64_t P9N2_EQ_LINEDEL_TRIG_REG                                     = 0x10010C0Dull;
//DUPS: 10010C0D,
static const uint64_t P9N2_EQ_0_LINEDEL_TRIG_REG                                   = 0x10010C0Dull;
//DUPS: 10010C0D,
static const uint64_t P9N2_EQ_1_LINEDEL_TRIG_REG                                   = 0x11010C0Dull;
//DUPS: 11010C0D,
static const uint64_t P9N2_EQ_2_LINEDEL_TRIG_REG                                   = 0x12010C0Dull;
//DUPS: 12010C0D,
static const uint64_t P9N2_EQ_3_LINEDEL_TRIG_REG                                   = 0x13010C0Dull;
//DUPS: 13010C0D,
static const uint64_t P9N2_EQ_4_LINEDEL_TRIG_REG                                   = 0x14010C0Dull;
//DUPS: 14010C0D,
static const uint64_t P9N2_EQ_5_LINEDEL_TRIG_REG                                   = 0x15010C0Dull;
//DUPS: 15010C0D,
static const uint64_t P9N2_EX_0_L2_LINEDEL_TRIG_REG                                = 0x1001080Dull;

static const uint64_t P9N2_EX_10_L2_LINEDEL_TRIG_REG                               = 0x1501080Dull;

static const uint64_t P9N2_EX_11_L2_LINEDEL_TRIG_REG                               = 0x15010C0Dull;

static const uint64_t P9N2_EX_1_L2_LINEDEL_TRIG_REG                                = 0x10010C0Dull;

static const uint64_t P9N2_EX_2_L2_LINEDEL_TRIG_REG                                = 0x1101080Dull;

static const uint64_t P9N2_EX_3_L2_LINEDEL_TRIG_REG                                = 0x11010C0Dull;

static const uint64_t P9N2_EX_4_L2_LINEDEL_TRIG_REG                                = 0x1201080Dull;

static const uint64_t P9N2_EX_5_L2_LINEDEL_TRIG_REG                                = 0x12010C0Dull;

static const uint64_t P9N2_EX_6_L2_LINEDEL_TRIG_REG                                = 0x1301080Dull;

static const uint64_t P9N2_EX_7_L2_LINEDEL_TRIG_REG                                = 0x13010C0Dull;

static const uint64_t P9N2_EX_8_L2_LINEDEL_TRIG_REG                                = 0x1401080Dull;

static const uint64_t P9N2_EX_9_L2_LINEDEL_TRIG_REG                                = 0x14010C0Dull;

static const uint64_t P9N2_EX_L2_LINEDEL_TRIG_REG                                  = 0x1001080Dull;


static const uint64_t P9N2_EQ_LINE_DELETED_MEMBERS_REG                             = 0x10011C15ull;
//DUPS: 10011C15,
static const uint64_t P9N2_EQ_0_LINE_DELETED_MEMBERS_REG                           = 0x10011C15ull;
//DUPS: 10011C15,
static const uint64_t P9N2_EQ_1_LINE_DELETED_MEMBERS_REG                           = 0x11011C15ull;
//DUPS: 11011C15,
static const uint64_t P9N2_EQ_2_LINE_DELETED_MEMBERS_REG                           = 0x12011C15ull;
//DUPS: 12011C15,
static const uint64_t P9N2_EQ_3_LINE_DELETED_MEMBERS_REG                           = 0x13011C15ull;
//DUPS: 13011C15,
static const uint64_t P9N2_EQ_4_LINE_DELETED_MEMBERS_REG                           = 0x14011C15ull;
//DUPS: 14011C15,
static const uint64_t P9N2_EQ_5_LINE_DELETED_MEMBERS_REG                           = 0x15011C15ull;
//DUPS: 15011C15,
static const uint64_t P9N2_EX_0_L3_LINE_DELETED_MEMBERS_REG                        = 0x10011815ull;

static const uint64_t P9N2_EX_10_L3_LINE_DELETED_MEMBERS_REG                       = 0x15011815ull;

static const uint64_t P9N2_EX_11_L3_LINE_DELETED_MEMBERS_REG                       = 0x15011C15ull;

static const uint64_t P9N2_EX_1_L3_LINE_DELETED_MEMBERS_REG                        = 0x10011C15ull;

static const uint64_t P9N2_EX_2_L3_LINE_DELETED_MEMBERS_REG                        = 0x11011815ull;

static const uint64_t P9N2_EX_3_L3_LINE_DELETED_MEMBERS_REG                        = 0x11011C15ull;

static const uint64_t P9N2_EX_4_L3_LINE_DELETED_MEMBERS_REG                        = 0x12011815ull;

static const uint64_t P9N2_EX_5_L3_LINE_DELETED_MEMBERS_REG                        = 0x12011C15ull;

static const uint64_t P9N2_EX_6_L3_LINE_DELETED_MEMBERS_REG                        = 0x13011815ull;

static const uint64_t P9N2_EX_7_L3_LINE_DELETED_MEMBERS_REG                        = 0x13011C15ull;

static const uint64_t P9N2_EX_8_L3_LINE_DELETED_MEMBERS_REG                        = 0x14011815ull;

static const uint64_t P9N2_EX_9_L3_LINE_DELETED_MEMBERS_REG                        = 0x14011C15ull;

static const uint64_t P9N2_EX_L3_LINE_DELETED_MEMBERS_REG                          = 0x10011815ull;


static const uint64_t P9N2_C_LOCAL_FIR                                             = 0x2004000Aull;

static const uint64_t P9N2_C_LOCAL_FIR_AND                                         = 0x2004000Bull;

static const uint64_t P9N2_C_LOCAL_FIR_OR                                          = 0x2004000Cull;

static const uint64_t P9N2_C_0_LOCAL_FIR                                           = 0x2004000Aull;

static const uint64_t P9N2_C_0_LOCAL_FIR_AND                                       = 0x2004000Bull;

static const uint64_t P9N2_C_0_LOCAL_FIR_OR                                        = 0x2004000Cull;

static const uint64_t P9N2_C_1_LOCAL_FIR                                           = 0x2104000Aull;

static const uint64_t P9N2_C_1_LOCAL_FIR_AND                                       = 0x2104000Bull;

static const uint64_t P9N2_C_1_LOCAL_FIR_OR                                        = 0x2104000Cull;

static const uint64_t P9N2_C_2_LOCAL_FIR                                           = 0x2204000Aull;

static const uint64_t P9N2_C_2_LOCAL_FIR_AND                                       = 0x2204000Bull;

static const uint64_t P9N2_C_2_LOCAL_FIR_OR                                        = 0x2204000Cull;

static const uint64_t P9N2_C_3_LOCAL_FIR                                           = 0x2304000Aull;

static const uint64_t P9N2_C_3_LOCAL_FIR_AND                                       = 0x2304000Bull;

static const uint64_t P9N2_C_3_LOCAL_FIR_OR                                        = 0x2304000Cull;

static const uint64_t P9N2_C_4_LOCAL_FIR                                           = 0x2404000Aull;

static const uint64_t P9N2_C_4_LOCAL_FIR_AND                                       = 0x2404000Bull;

static const uint64_t P9N2_C_4_LOCAL_FIR_OR                                        = 0x2404000Cull;

static const uint64_t P9N2_C_5_LOCAL_FIR                                           = 0x2504000Aull;

static const uint64_t P9N2_C_5_LOCAL_FIR_AND                                       = 0x2504000Bull;

static const uint64_t P9N2_C_5_LOCAL_FIR_OR                                        = 0x2504000Cull;

static const uint64_t P9N2_C_6_LOCAL_FIR                                           = 0x2604000Aull;

static const uint64_t P9N2_C_6_LOCAL_FIR_AND                                       = 0x2604000Bull;

static const uint64_t P9N2_C_6_LOCAL_FIR_OR                                        = 0x2604000Cull;

static const uint64_t P9N2_C_7_LOCAL_FIR                                           = 0x2704000Aull;

static const uint64_t P9N2_C_7_LOCAL_FIR_AND                                       = 0x2704000Bull;

static const uint64_t P9N2_C_7_LOCAL_FIR_OR                                        = 0x2704000Cull;

static const uint64_t P9N2_C_8_LOCAL_FIR                                           = 0x2804000Aull;

static const uint64_t P9N2_C_8_LOCAL_FIR_AND                                       = 0x2804000Bull;

static const uint64_t P9N2_C_8_LOCAL_FIR_OR                                        = 0x2804000Cull;

static const uint64_t P9N2_C_9_LOCAL_FIR                                           = 0x2904000Aull;

static const uint64_t P9N2_C_9_LOCAL_FIR_AND                                       = 0x2904000Bull;

static const uint64_t P9N2_C_9_LOCAL_FIR_OR                                        = 0x2904000Cull;

static const uint64_t P9N2_C_10_LOCAL_FIR                                          = 0x2A04000Aull;

static const uint64_t P9N2_C_10_LOCAL_FIR_AND                                      = 0x2A04000Bull;

static const uint64_t P9N2_C_10_LOCAL_FIR_OR                                       = 0x2A04000Cull;

static const uint64_t P9N2_C_11_LOCAL_FIR                                          = 0x2B04000Aull;

static const uint64_t P9N2_C_11_LOCAL_FIR_AND                                      = 0x2B04000Bull;

static const uint64_t P9N2_C_11_LOCAL_FIR_OR                                       = 0x2B04000Cull;

static const uint64_t P9N2_C_12_LOCAL_FIR                                          = 0x2C04000Aull;

static const uint64_t P9N2_C_12_LOCAL_FIR_AND                                      = 0x2C04000Bull;

static const uint64_t P9N2_C_12_LOCAL_FIR_OR                                       = 0x2C04000Cull;

static const uint64_t P9N2_C_13_LOCAL_FIR                                          = 0x2D04000Aull;

static const uint64_t P9N2_C_13_LOCAL_FIR_AND                                      = 0x2D04000Bull;

static const uint64_t P9N2_C_13_LOCAL_FIR_OR                                       = 0x2D04000Cull;

static const uint64_t P9N2_C_14_LOCAL_FIR                                          = 0x2E04000Aull;

static const uint64_t P9N2_C_14_LOCAL_FIR_AND                                      = 0x2E04000Bull;

static const uint64_t P9N2_C_14_LOCAL_FIR_OR                                       = 0x2E04000Cull;

static const uint64_t P9N2_C_15_LOCAL_FIR                                          = 0x2F04000Aull;

static const uint64_t P9N2_C_15_LOCAL_FIR_AND                                      = 0x2F04000Bull;

static const uint64_t P9N2_C_15_LOCAL_FIR_OR                                       = 0x2F04000Cull;

static const uint64_t P9N2_C_16_LOCAL_FIR                                          = 0x3004000Aull;

static const uint64_t P9N2_C_16_LOCAL_FIR_AND                                      = 0x3004000Bull;

static const uint64_t P9N2_C_16_LOCAL_FIR_OR                                       = 0x3004000Cull;

static const uint64_t P9N2_C_17_LOCAL_FIR                                          = 0x3104000Aull;

static const uint64_t P9N2_C_17_LOCAL_FIR_AND                                      = 0x3104000Bull;

static const uint64_t P9N2_C_17_LOCAL_FIR_OR                                       = 0x3104000Cull;

static const uint64_t P9N2_C_18_LOCAL_FIR                                          = 0x3204000Aull;

static const uint64_t P9N2_C_18_LOCAL_FIR_AND                                      = 0x3204000Bull;

static const uint64_t P9N2_C_18_LOCAL_FIR_OR                                       = 0x3204000Cull;

static const uint64_t P9N2_C_19_LOCAL_FIR                                          = 0x3304000Aull;

static const uint64_t P9N2_C_19_LOCAL_FIR_AND                                      = 0x3304000Bull;

static const uint64_t P9N2_C_19_LOCAL_FIR_OR                                       = 0x3304000Cull;

static const uint64_t P9N2_C_20_LOCAL_FIR                                          = 0x3404000Aull;

static const uint64_t P9N2_C_20_LOCAL_FIR_AND                                      = 0x3404000Bull;

static const uint64_t P9N2_C_20_LOCAL_FIR_OR                                       = 0x3404000Cull;

static const uint64_t P9N2_C_21_LOCAL_FIR                                          = 0x3504000Aull;

static const uint64_t P9N2_C_21_LOCAL_FIR_AND                                      = 0x3504000Bull;

static const uint64_t P9N2_C_21_LOCAL_FIR_OR                                       = 0x3504000Cull;

static const uint64_t P9N2_C_22_LOCAL_FIR                                          = 0x3604000Aull;

static const uint64_t P9N2_C_22_LOCAL_FIR_AND                                      = 0x3604000Bull;

static const uint64_t P9N2_C_22_LOCAL_FIR_OR                                       = 0x3604000Cull;

static const uint64_t P9N2_C_23_LOCAL_FIR                                          = 0x3704000Aull;

static const uint64_t P9N2_C_23_LOCAL_FIR_AND                                      = 0x3704000Bull;

static const uint64_t P9N2_C_23_LOCAL_FIR_OR                                       = 0x3704000Cull;

static const uint64_t P9N2_EQ_LOCAL_FIR                                            = 0x1004000Aull;

static const uint64_t P9N2_EQ_LOCAL_FIR_AND                                        = 0x1004000Bull;

static const uint64_t P9N2_EQ_LOCAL_FIR_OR                                         = 0x1004000Cull;

static const uint64_t P9N2_EQ_0_LOCAL_FIR                                          = 0x1004000Aull;

static const uint64_t P9N2_EQ_0_LOCAL_FIR_AND                                      = 0x1004000Bull;

static const uint64_t P9N2_EQ_0_LOCAL_FIR_OR                                       = 0x1004000Cull;

static const uint64_t P9N2_EQ_1_LOCAL_FIR                                          = 0x1104000Aull;

static const uint64_t P9N2_EQ_1_LOCAL_FIR_AND                                      = 0x1104000Bull;

static const uint64_t P9N2_EQ_1_LOCAL_FIR_OR                                       = 0x1104000Cull;

static const uint64_t P9N2_EQ_2_LOCAL_FIR                                          = 0x1204000Aull;

static const uint64_t P9N2_EQ_2_LOCAL_FIR_AND                                      = 0x1204000Bull;

static const uint64_t P9N2_EQ_2_LOCAL_FIR_OR                                       = 0x1204000Cull;

static const uint64_t P9N2_EQ_3_LOCAL_FIR                                          = 0x1304000Aull;

static const uint64_t P9N2_EQ_3_LOCAL_FIR_AND                                      = 0x1304000Bull;

static const uint64_t P9N2_EQ_3_LOCAL_FIR_OR                                       = 0x1304000Cull;

static const uint64_t P9N2_EQ_4_LOCAL_FIR                                          = 0x1404000Aull;

static const uint64_t P9N2_EQ_4_LOCAL_FIR_AND                                      = 0x1404000Bull;

static const uint64_t P9N2_EQ_4_LOCAL_FIR_OR                                       = 0x1404000Cull;

static const uint64_t P9N2_EQ_5_LOCAL_FIR                                          = 0x1504000Aull;

static const uint64_t P9N2_EQ_5_LOCAL_FIR_AND                                      = 0x1504000Bull;

static const uint64_t P9N2_EQ_5_LOCAL_FIR_OR                                       = 0x1504000Cull;

static const uint64_t P9N2_EX_LOCAL_FIR                                            = 0x2004000Aull;
//DUPS: 2104000A,
static const uint64_t P9N2_EX_LOCAL_FIR_AND                                        = 0x2004000Bull;
//DUPS: 2104000B,
static const uint64_t P9N2_EX_LOCAL_FIR_OR                                         = 0x2004000Cull;
//DUPS: 2104000C,
static const uint64_t P9N2_EX_0_LOCAL_FIR                                          = 0x2004000Aull;
//DUPS: 2104000A,
static const uint64_t P9N2_EX_0_LOCAL_FIR_AND                                      = 0x2004000Bull;
//DUPS: 2104000B,
static const uint64_t P9N2_EX_0_LOCAL_FIR_OR                                       = 0x2004000Cull;
//DUPS: 2104000C,
static const uint64_t P9N2_EX_1_LOCAL_FIR                                          = 0x2204000Aull;
//DUPS: 2304000A,
static const uint64_t P9N2_EX_1_LOCAL_FIR_AND                                      = 0x2204000Bull;
//DUPS: 2304000B,
static const uint64_t P9N2_EX_1_LOCAL_FIR_OR                                       = 0x2204000Cull;
//DUPS: 2304000C,
static const uint64_t P9N2_EX_2_LOCAL_FIR                                          = 0x2404000Aull;
//DUPS: 2504000A,
static const uint64_t P9N2_EX_2_LOCAL_FIR_AND                                      = 0x2404000Bull;
//DUPS: 2504000B,
static const uint64_t P9N2_EX_2_LOCAL_FIR_OR                                       = 0x2404000Cull;
//DUPS: 2504000C,
static const uint64_t P9N2_EX_3_LOCAL_FIR                                          = 0x2604000Aull;
//DUPS: 2704000A,
static const uint64_t P9N2_EX_3_LOCAL_FIR_AND                                      = 0x2604000Bull;
//DUPS: 2704000B,
static const uint64_t P9N2_EX_3_LOCAL_FIR_OR                                       = 0x2604000Cull;
//DUPS: 2704000C,
static const uint64_t P9N2_EX_4_LOCAL_FIR                                          = 0x2804000Aull;
//DUPS: 2904000A,
static const uint64_t P9N2_EX_4_LOCAL_FIR_AND                                      = 0x2804000Bull;
//DUPS: 2904000B,
static const uint64_t P9N2_EX_4_LOCAL_FIR_OR                                       = 0x2804000Cull;
//DUPS: 2904000C,
static const uint64_t P9N2_EX_5_LOCAL_FIR                                          = 0x2A04000Aull;
//DUPS: 2B04000A,
static const uint64_t P9N2_EX_5_LOCAL_FIR_AND                                      = 0x2A04000Bull;
//DUPS: 2B04000B,
static const uint64_t P9N2_EX_5_LOCAL_FIR_OR                                       = 0x2A04000Cull;
//DUPS: 2B04000C,
static const uint64_t P9N2_EX_6_LOCAL_FIR                                          = 0x2C04000Aull;
//DUPS: 2D04000A,
static const uint64_t P9N2_EX_6_LOCAL_FIR_AND                                      = 0x2C04000Bull;
//DUPS: 2D04000B,
static const uint64_t P9N2_EX_6_LOCAL_FIR_OR                                       = 0x2C04000Cull;
//DUPS: 2D04000C,
static const uint64_t P9N2_EX_7_LOCAL_FIR                                          = 0x2F04000Aull;
//DUPS: 2F04000A,
static const uint64_t P9N2_EX_7_LOCAL_FIR_AND                                      = 0x2F04000Bull;
//DUPS: 2F04000B,
static const uint64_t P9N2_EX_7_LOCAL_FIR_OR                                       = 0x2F04000Cull;
//DUPS: 2F04000C,
static const uint64_t P9N2_EX_8_LOCAL_FIR                                          = 0x3004000Aull;
//DUPS: 3104000A,
static const uint64_t P9N2_EX_8_LOCAL_FIR_AND                                      = 0x3004000Bull;
//DUPS: 3104000B,
static const uint64_t P9N2_EX_8_LOCAL_FIR_OR                                       = 0x3004000Cull;
//DUPS: 3104000C,
static const uint64_t P9N2_EX_9_LOCAL_FIR                                          = 0x3204000Aull;
//DUPS: 3304000A,
static const uint64_t P9N2_EX_9_LOCAL_FIR_AND                                      = 0x3204000Bull;
//DUPS: 3304000B,
static const uint64_t P9N2_EX_9_LOCAL_FIR_OR                                       = 0x3204000Cull;
//DUPS: 3304000C,
static const uint64_t P9N2_EX_10_LOCAL_FIR                                         = 0x3404000Aull;
//DUPS: 3504000A,
static const uint64_t P9N2_EX_10_LOCAL_FIR_AND                                     = 0x3404000Bull;
//DUPS: 3504000B,
static const uint64_t P9N2_EX_10_LOCAL_FIR_OR                                      = 0x3404000Cull;
//DUPS: 3504000C,
static const uint64_t P9N2_EX_11_LOCAL_FIR                                         = 0x3604000Aull;
//DUPS: 3704000A,
static const uint64_t P9N2_EX_11_LOCAL_FIR_AND                                     = 0x3604000Bull;
//DUPS: 3704000B,
static const uint64_t P9N2_EX_11_LOCAL_FIR_OR                                      = 0x3604000Cull;
//DUPS: 3704000C,

static const uint64_t P9N2_C_LOCAL_FIR_ACTION0                                     = 0x20040010ull;

static const uint64_t P9N2_C_0_LOCAL_FIR_ACTION0                                   = 0x20040010ull;

static const uint64_t P9N2_C_1_LOCAL_FIR_ACTION0                                   = 0x21040010ull;

static const uint64_t P9N2_C_2_LOCAL_FIR_ACTION0                                   = 0x22040010ull;

static const uint64_t P9N2_C_3_LOCAL_FIR_ACTION0                                   = 0x23040010ull;

static const uint64_t P9N2_C_4_LOCAL_FIR_ACTION0                                   = 0x24040010ull;

static const uint64_t P9N2_C_5_LOCAL_FIR_ACTION0                                   = 0x25040010ull;

static const uint64_t P9N2_C_6_LOCAL_FIR_ACTION0                                   = 0x26040010ull;

static const uint64_t P9N2_C_7_LOCAL_FIR_ACTION0                                   = 0x27040010ull;

static const uint64_t P9N2_C_8_LOCAL_FIR_ACTION0                                   = 0x28040010ull;

static const uint64_t P9N2_C_9_LOCAL_FIR_ACTION0                                   = 0x29040010ull;

static const uint64_t P9N2_C_10_LOCAL_FIR_ACTION0                                  = 0x2A040010ull;

static const uint64_t P9N2_C_11_LOCAL_FIR_ACTION0                                  = 0x2B040010ull;

static const uint64_t P9N2_C_12_LOCAL_FIR_ACTION0                                  = 0x2C040010ull;

static const uint64_t P9N2_C_13_LOCAL_FIR_ACTION0                                  = 0x2D040010ull;

static const uint64_t P9N2_C_14_LOCAL_FIR_ACTION0                                  = 0x2E040010ull;

static const uint64_t P9N2_C_15_LOCAL_FIR_ACTION0                                  = 0x2F040010ull;

static const uint64_t P9N2_C_16_LOCAL_FIR_ACTION0                                  = 0x30040010ull;

static const uint64_t P9N2_C_17_LOCAL_FIR_ACTION0                                  = 0x31040010ull;

static const uint64_t P9N2_C_18_LOCAL_FIR_ACTION0                                  = 0x32040010ull;

static const uint64_t P9N2_C_19_LOCAL_FIR_ACTION0                                  = 0x33040010ull;

static const uint64_t P9N2_C_20_LOCAL_FIR_ACTION0                                  = 0x34040010ull;

static const uint64_t P9N2_C_21_LOCAL_FIR_ACTION0                                  = 0x35040010ull;

static const uint64_t P9N2_C_22_LOCAL_FIR_ACTION0                                  = 0x36040010ull;

static const uint64_t P9N2_C_23_LOCAL_FIR_ACTION0                                  = 0x37040010ull;

static const uint64_t P9N2_EQ_LOCAL_FIR_ACTION0                                    = 0x10040010ull;

static const uint64_t P9N2_EQ_0_LOCAL_FIR_ACTION0                                  = 0x10040010ull;

static const uint64_t P9N2_EQ_1_LOCAL_FIR_ACTION0                                  = 0x11040010ull;

static const uint64_t P9N2_EQ_2_LOCAL_FIR_ACTION0                                  = 0x12040010ull;

static const uint64_t P9N2_EQ_3_LOCAL_FIR_ACTION0                                  = 0x13040010ull;

static const uint64_t P9N2_EQ_4_LOCAL_FIR_ACTION0                                  = 0x14040010ull;

static const uint64_t P9N2_EQ_5_LOCAL_FIR_ACTION0                                  = 0x15040010ull;

static const uint64_t P9N2_EX_LOCAL_FIR_ACTION0                                    = 0x20040010ull;
//DUPS: 21040010,
static const uint64_t P9N2_EX_0_LOCAL_FIR_ACTION0                                  = 0x20040010ull;
//DUPS: 21040010,
static const uint64_t P9N2_EX_1_LOCAL_FIR_ACTION0                                  = 0x22040010ull;
//DUPS: 23040010,
static const uint64_t P9N2_EX_2_LOCAL_FIR_ACTION0                                  = 0x24040010ull;
//DUPS: 25040010,
static const uint64_t P9N2_EX_3_LOCAL_FIR_ACTION0                                  = 0x26040010ull;
//DUPS: 27040010,
static const uint64_t P9N2_EX_4_LOCAL_FIR_ACTION0                                  = 0x28040010ull;
//DUPS: 29040010,
static const uint64_t P9N2_EX_5_LOCAL_FIR_ACTION0                                  = 0x2A040010ull;
//DUPS: 2B040010,
static const uint64_t P9N2_EX_6_LOCAL_FIR_ACTION0                                  = 0x2C040010ull;
//DUPS: 2D040010,
static const uint64_t P9N2_EX_7_LOCAL_FIR_ACTION0                                  = 0x2F040010ull;
//DUPS: 2F040010,
static const uint64_t P9N2_EX_8_LOCAL_FIR_ACTION0                                  = 0x30040010ull;
//DUPS: 31040010,
static const uint64_t P9N2_EX_9_LOCAL_FIR_ACTION0                                  = 0x32040010ull;
//DUPS: 33040010,
static const uint64_t P9N2_EX_10_LOCAL_FIR_ACTION0                                 = 0x34040010ull;
//DUPS: 35040010,
static const uint64_t P9N2_EX_11_LOCAL_FIR_ACTION0                                 = 0x36040010ull;
//DUPS: 37040010,

static const uint64_t P9N2_C_LOCAL_FIR_ACTION1                                     = 0x20040011ull;

static const uint64_t P9N2_C_0_LOCAL_FIR_ACTION1                                   = 0x20040011ull;

static const uint64_t P9N2_C_1_LOCAL_FIR_ACTION1                                   = 0x21040011ull;

static const uint64_t P9N2_C_2_LOCAL_FIR_ACTION1                                   = 0x22040011ull;

static const uint64_t P9N2_C_3_LOCAL_FIR_ACTION1                                   = 0x23040011ull;

static const uint64_t P9N2_C_4_LOCAL_FIR_ACTION1                                   = 0x24040011ull;

static const uint64_t P9N2_C_5_LOCAL_FIR_ACTION1                                   = 0x25040011ull;

static const uint64_t P9N2_C_6_LOCAL_FIR_ACTION1                                   = 0x26040011ull;

static const uint64_t P9N2_C_7_LOCAL_FIR_ACTION1                                   = 0x27040011ull;

static const uint64_t P9N2_C_8_LOCAL_FIR_ACTION1                                   = 0x28040011ull;

static const uint64_t P9N2_C_9_LOCAL_FIR_ACTION1                                   = 0x29040011ull;

static const uint64_t P9N2_C_10_LOCAL_FIR_ACTION1                                  = 0x2A040011ull;

static const uint64_t P9N2_C_11_LOCAL_FIR_ACTION1                                  = 0x2B040011ull;

static const uint64_t P9N2_C_12_LOCAL_FIR_ACTION1                                  = 0x2C040011ull;

static const uint64_t P9N2_C_13_LOCAL_FIR_ACTION1                                  = 0x2D040011ull;

static const uint64_t P9N2_C_14_LOCAL_FIR_ACTION1                                  = 0x2E040011ull;

static const uint64_t P9N2_C_15_LOCAL_FIR_ACTION1                                  = 0x2F040011ull;

static const uint64_t P9N2_C_16_LOCAL_FIR_ACTION1                                  = 0x30040011ull;

static const uint64_t P9N2_C_17_LOCAL_FIR_ACTION1                                  = 0x31040011ull;

static const uint64_t P9N2_C_18_LOCAL_FIR_ACTION1                                  = 0x32040011ull;

static const uint64_t P9N2_C_19_LOCAL_FIR_ACTION1                                  = 0x33040011ull;

static const uint64_t P9N2_C_20_LOCAL_FIR_ACTION1                                  = 0x34040011ull;

static const uint64_t P9N2_C_21_LOCAL_FIR_ACTION1                                  = 0x35040011ull;

static const uint64_t P9N2_C_22_LOCAL_FIR_ACTION1                                  = 0x36040011ull;

static const uint64_t P9N2_C_23_LOCAL_FIR_ACTION1                                  = 0x37040011ull;

static const uint64_t P9N2_EQ_LOCAL_FIR_ACTION1                                    = 0x10040011ull;

static const uint64_t P9N2_EQ_0_LOCAL_FIR_ACTION1                                  = 0x10040011ull;

static const uint64_t P9N2_EQ_1_LOCAL_FIR_ACTION1                                  = 0x11040011ull;

static const uint64_t P9N2_EQ_2_LOCAL_FIR_ACTION1                                  = 0x12040011ull;

static const uint64_t P9N2_EQ_3_LOCAL_FIR_ACTION1                                  = 0x13040011ull;

static const uint64_t P9N2_EQ_4_LOCAL_FIR_ACTION1                                  = 0x14040011ull;

static const uint64_t P9N2_EQ_5_LOCAL_FIR_ACTION1                                  = 0x15040011ull;

static const uint64_t P9N2_EX_LOCAL_FIR_ACTION1                                    = 0x20040011ull;
//DUPS: 21040011,
static const uint64_t P9N2_EX_0_LOCAL_FIR_ACTION1                                  = 0x20040011ull;
//DUPS: 21040011,
static const uint64_t P9N2_EX_1_LOCAL_FIR_ACTION1                                  = 0x22040011ull;
//DUPS: 23040011,
static const uint64_t P9N2_EX_2_LOCAL_FIR_ACTION1                                  = 0x24040011ull;
//DUPS: 25040011,
static const uint64_t P9N2_EX_3_LOCAL_FIR_ACTION1                                  = 0x26040011ull;
//DUPS: 27040011,
static const uint64_t P9N2_EX_4_LOCAL_FIR_ACTION1                                  = 0x28040011ull;
//DUPS: 29040011,
static const uint64_t P9N2_EX_5_LOCAL_FIR_ACTION1                                  = 0x2A040011ull;
//DUPS: 2B040011,
static const uint64_t P9N2_EX_6_LOCAL_FIR_ACTION1                                  = 0x2C040011ull;
//DUPS: 2D040011,
static const uint64_t P9N2_EX_7_LOCAL_FIR_ACTION1                                  = 0x2F040011ull;
//DUPS: 2F040011,
static const uint64_t P9N2_EX_8_LOCAL_FIR_ACTION1                                  = 0x30040011ull;
//DUPS: 31040011,
static const uint64_t P9N2_EX_9_LOCAL_FIR_ACTION1                                  = 0x32040011ull;
//DUPS: 33040011,
static const uint64_t P9N2_EX_10_LOCAL_FIR_ACTION1                                 = 0x34040011ull;
//DUPS: 35040011,
static const uint64_t P9N2_EX_11_LOCAL_FIR_ACTION1                                 = 0x36040011ull;
//DUPS: 37040011,

static const uint64_t P9N2_C_LOCAL_FIR_MASK                                        = 0x2004000Dull;

static const uint64_t P9N2_C_LOCAL_FIR_MASK_AND                                    = 0x2004000Eull;

static const uint64_t P9N2_C_LOCAL_FIR_MASK_OR                                     = 0x2004000Full;

static const uint64_t P9N2_C_0_LOCAL_FIR_MASK                                      = 0x2004000Dull;

static const uint64_t P9N2_C_0_LOCAL_FIR_MASK_AND                                  = 0x2004000Eull;

static const uint64_t P9N2_C_0_LOCAL_FIR_MASK_OR                                   = 0x2004000Full;

static const uint64_t P9N2_C_1_LOCAL_FIR_MASK                                      = 0x2104000Dull;

static const uint64_t P9N2_C_1_LOCAL_FIR_MASK_AND                                  = 0x2104000Eull;

static const uint64_t P9N2_C_1_LOCAL_FIR_MASK_OR                                   = 0x2104000Full;

static const uint64_t P9N2_C_2_LOCAL_FIR_MASK                                      = 0x2204000Dull;

static const uint64_t P9N2_C_2_LOCAL_FIR_MASK_AND                                  = 0x2204000Eull;

static const uint64_t P9N2_C_2_LOCAL_FIR_MASK_OR                                   = 0x2204000Full;

static const uint64_t P9N2_C_3_LOCAL_FIR_MASK                                      = 0x2304000Dull;

static const uint64_t P9N2_C_3_LOCAL_FIR_MASK_AND                                  = 0x2304000Eull;

static const uint64_t P9N2_C_3_LOCAL_FIR_MASK_OR                                   = 0x2304000Full;

static const uint64_t P9N2_C_4_LOCAL_FIR_MASK                                      = 0x2404000Dull;

static const uint64_t P9N2_C_4_LOCAL_FIR_MASK_AND                                  = 0x2404000Eull;

static const uint64_t P9N2_C_4_LOCAL_FIR_MASK_OR                                   = 0x2404000Full;

static const uint64_t P9N2_C_5_LOCAL_FIR_MASK                                      = 0x2504000Dull;

static const uint64_t P9N2_C_5_LOCAL_FIR_MASK_AND                                  = 0x2504000Eull;

static const uint64_t P9N2_C_5_LOCAL_FIR_MASK_OR                                   = 0x2504000Full;

static const uint64_t P9N2_C_6_LOCAL_FIR_MASK                                      = 0x2604000Dull;

static const uint64_t P9N2_C_6_LOCAL_FIR_MASK_AND                                  = 0x2604000Eull;

static const uint64_t P9N2_C_6_LOCAL_FIR_MASK_OR                                   = 0x2604000Full;

static const uint64_t P9N2_C_7_LOCAL_FIR_MASK                                      = 0x2704000Dull;

static const uint64_t P9N2_C_7_LOCAL_FIR_MASK_AND                                  = 0x2704000Eull;

static const uint64_t P9N2_C_7_LOCAL_FIR_MASK_OR                                   = 0x2704000Full;

static const uint64_t P9N2_C_8_LOCAL_FIR_MASK                                      = 0x2804000Dull;

static const uint64_t P9N2_C_8_LOCAL_FIR_MASK_AND                                  = 0x2804000Eull;

static const uint64_t P9N2_C_8_LOCAL_FIR_MASK_OR                                   = 0x2804000Full;

static const uint64_t P9N2_C_9_LOCAL_FIR_MASK                                      = 0x2904000Dull;

static const uint64_t P9N2_C_9_LOCAL_FIR_MASK_AND                                  = 0x2904000Eull;

static const uint64_t P9N2_C_9_LOCAL_FIR_MASK_OR                                   = 0x2904000Full;

static const uint64_t P9N2_C_10_LOCAL_FIR_MASK                                     = 0x2A04000Dull;

static const uint64_t P9N2_C_10_LOCAL_FIR_MASK_AND                                 = 0x2A04000Eull;

static const uint64_t P9N2_C_10_LOCAL_FIR_MASK_OR                                  = 0x2A04000Full;

static const uint64_t P9N2_C_11_LOCAL_FIR_MASK                                     = 0x2B04000Dull;

static const uint64_t P9N2_C_11_LOCAL_FIR_MASK_AND                                 = 0x2B04000Eull;

static const uint64_t P9N2_C_11_LOCAL_FIR_MASK_OR                                  = 0x2B04000Full;

static const uint64_t P9N2_C_12_LOCAL_FIR_MASK                                     = 0x2C04000Dull;

static const uint64_t P9N2_C_12_LOCAL_FIR_MASK_AND                                 = 0x2C04000Eull;

static const uint64_t P9N2_C_12_LOCAL_FIR_MASK_OR                                  = 0x2C04000Full;

static const uint64_t P9N2_C_13_LOCAL_FIR_MASK                                     = 0x2D04000Dull;

static const uint64_t P9N2_C_13_LOCAL_FIR_MASK_AND                                 = 0x2D04000Eull;

static const uint64_t P9N2_C_13_LOCAL_FIR_MASK_OR                                  = 0x2D04000Full;

static const uint64_t P9N2_C_14_LOCAL_FIR_MASK                                     = 0x2E04000Dull;

static const uint64_t P9N2_C_14_LOCAL_FIR_MASK_AND                                 = 0x2E04000Eull;

static const uint64_t P9N2_C_14_LOCAL_FIR_MASK_OR                                  = 0x2E04000Full;

static const uint64_t P9N2_C_15_LOCAL_FIR_MASK                                     = 0x2F04000Dull;

static const uint64_t P9N2_C_15_LOCAL_FIR_MASK_AND                                 = 0x2F04000Eull;

static const uint64_t P9N2_C_15_LOCAL_FIR_MASK_OR                                  = 0x2F04000Full;

static const uint64_t P9N2_C_16_LOCAL_FIR_MASK                                     = 0x3004000Dull;

static const uint64_t P9N2_C_16_LOCAL_FIR_MASK_AND                                 = 0x3004000Eull;

static const uint64_t P9N2_C_16_LOCAL_FIR_MASK_OR                                  = 0x3004000Full;

static const uint64_t P9N2_C_17_LOCAL_FIR_MASK                                     = 0x3104000Dull;

static const uint64_t P9N2_C_17_LOCAL_FIR_MASK_AND                                 = 0x3104000Eull;

static const uint64_t P9N2_C_17_LOCAL_FIR_MASK_OR                                  = 0x3104000Full;

static const uint64_t P9N2_C_18_LOCAL_FIR_MASK                                     = 0x3204000Dull;

static const uint64_t P9N2_C_18_LOCAL_FIR_MASK_AND                                 = 0x3204000Eull;

static const uint64_t P9N2_C_18_LOCAL_FIR_MASK_OR                                  = 0x3204000Full;

static const uint64_t P9N2_C_19_LOCAL_FIR_MASK                                     = 0x3304000Dull;

static const uint64_t P9N2_C_19_LOCAL_FIR_MASK_AND                                 = 0x3304000Eull;

static const uint64_t P9N2_C_19_LOCAL_FIR_MASK_OR                                  = 0x3304000Full;

static const uint64_t P9N2_C_20_LOCAL_FIR_MASK                                     = 0x3404000Dull;

static const uint64_t P9N2_C_20_LOCAL_FIR_MASK_AND                                 = 0x3404000Eull;

static const uint64_t P9N2_C_20_LOCAL_FIR_MASK_OR                                  = 0x3404000Full;

static const uint64_t P9N2_C_21_LOCAL_FIR_MASK                                     = 0x3504000Dull;

static const uint64_t P9N2_C_21_LOCAL_FIR_MASK_AND                                 = 0x3504000Eull;

static const uint64_t P9N2_C_21_LOCAL_FIR_MASK_OR                                  = 0x3504000Full;

static const uint64_t P9N2_C_22_LOCAL_FIR_MASK                                     = 0x3604000Dull;

static const uint64_t P9N2_C_22_LOCAL_FIR_MASK_AND                                 = 0x3604000Eull;

static const uint64_t P9N2_C_22_LOCAL_FIR_MASK_OR                                  = 0x3604000Full;

static const uint64_t P9N2_C_23_LOCAL_FIR_MASK                                     = 0x3704000Dull;

static const uint64_t P9N2_C_23_LOCAL_FIR_MASK_AND                                 = 0x3704000Eull;

static const uint64_t P9N2_C_23_LOCAL_FIR_MASK_OR                                  = 0x3704000Full;

static const uint64_t P9N2_EQ_LOCAL_FIR_MASK                                       = 0x1004000Dull;

static const uint64_t P9N2_EQ_LOCAL_FIR_MASK_AND                                   = 0x1004000Eull;

static const uint64_t P9N2_EQ_LOCAL_FIR_MASK_OR                                    = 0x1004000Full;

static const uint64_t P9N2_EQ_0_LOCAL_FIR_MASK                                     = 0x1004000Dull;

static const uint64_t P9N2_EQ_0_LOCAL_FIR_MASK_AND                                 = 0x1004000Eull;

static const uint64_t P9N2_EQ_0_LOCAL_FIR_MASK_OR                                  = 0x1004000Full;

static const uint64_t P9N2_EQ_1_LOCAL_FIR_MASK                                     = 0x1104000Dull;

static const uint64_t P9N2_EQ_1_LOCAL_FIR_MASK_AND                                 = 0x1104000Eull;

static const uint64_t P9N2_EQ_1_LOCAL_FIR_MASK_OR                                  = 0x1104000Full;

static const uint64_t P9N2_EQ_2_LOCAL_FIR_MASK                                     = 0x1204000Dull;

static const uint64_t P9N2_EQ_2_LOCAL_FIR_MASK_AND                                 = 0x1204000Eull;

static const uint64_t P9N2_EQ_2_LOCAL_FIR_MASK_OR                                  = 0x1204000Full;

static const uint64_t P9N2_EQ_3_LOCAL_FIR_MASK                                     = 0x1304000Dull;

static const uint64_t P9N2_EQ_3_LOCAL_FIR_MASK_AND                                 = 0x1304000Eull;

static const uint64_t P9N2_EQ_3_LOCAL_FIR_MASK_OR                                  = 0x1304000Full;

static const uint64_t P9N2_EQ_4_LOCAL_FIR_MASK                                     = 0x1404000Dull;

static const uint64_t P9N2_EQ_4_LOCAL_FIR_MASK_AND                                 = 0x1404000Eull;

static const uint64_t P9N2_EQ_4_LOCAL_FIR_MASK_OR                                  = 0x1404000Full;

static const uint64_t P9N2_EQ_5_LOCAL_FIR_MASK                                     = 0x1504000Dull;

static const uint64_t P9N2_EQ_5_LOCAL_FIR_MASK_AND                                 = 0x1504000Eull;

static const uint64_t P9N2_EQ_5_LOCAL_FIR_MASK_OR                                  = 0x1504000Full;

static const uint64_t P9N2_EX_LOCAL_FIR_MASK                                       = 0x2004000Dull;
//DUPS: 2104000D,
static const uint64_t P9N2_EX_LOCAL_FIR_MASK_AND                                   = 0x2004000Eull;
//DUPS: 2104000E,
static const uint64_t P9N2_EX_LOCAL_FIR_MASK_OR                                    = 0x2004000Full;
//DUPS: 2104000F,
static const uint64_t P9N2_EX_0_LOCAL_FIR_MASK                                     = 0x2004000Dull;
//DUPS: 2104000D,
static const uint64_t P9N2_EX_0_LOCAL_FIR_MASK_AND                                 = 0x2004000Eull;
//DUPS: 2104000E,
static const uint64_t P9N2_EX_0_LOCAL_FIR_MASK_OR                                  = 0x2004000Full;
//DUPS: 2104000F,
static const uint64_t P9N2_EX_1_LOCAL_FIR_MASK                                     = 0x2204000Dull;
//DUPS: 2304000D,
static const uint64_t P9N2_EX_1_LOCAL_FIR_MASK_AND                                 = 0x2204000Eull;
//DUPS: 2304000E,
static const uint64_t P9N2_EX_1_LOCAL_FIR_MASK_OR                                  = 0x2204000Full;
//DUPS: 2304000F,
static const uint64_t P9N2_EX_2_LOCAL_FIR_MASK                                     = 0x2404000Dull;
//DUPS: 2504000D,
static const uint64_t P9N2_EX_2_LOCAL_FIR_MASK_AND                                 = 0x2404000Eull;
//DUPS: 2504000E,
static const uint64_t P9N2_EX_2_LOCAL_FIR_MASK_OR                                  = 0x2404000Full;
//DUPS: 2504000F,
static const uint64_t P9N2_EX_3_LOCAL_FIR_MASK                                     = 0x2604000Dull;
//DUPS: 2704000D,
static const uint64_t P9N2_EX_3_LOCAL_FIR_MASK_AND                                 = 0x2604000Eull;
//DUPS: 2704000E,
static const uint64_t P9N2_EX_3_LOCAL_FIR_MASK_OR                                  = 0x2604000Full;
//DUPS: 2704000F,
static const uint64_t P9N2_EX_4_LOCAL_FIR_MASK                                     = 0x2804000Dull;
//DUPS: 2904000D,
static const uint64_t P9N2_EX_4_LOCAL_FIR_MASK_AND                                 = 0x2804000Eull;
//DUPS: 2904000E,
static const uint64_t P9N2_EX_4_LOCAL_FIR_MASK_OR                                  = 0x2804000Full;
//DUPS: 2904000F,
static const uint64_t P9N2_EX_5_LOCAL_FIR_MASK                                     = 0x2A04000Dull;
//DUPS: 2B04000D,
static const uint64_t P9N2_EX_5_LOCAL_FIR_MASK_AND                                 = 0x2A04000Eull;
//DUPS: 2B04000E,
static const uint64_t P9N2_EX_5_LOCAL_FIR_MASK_OR                                  = 0x2A04000Full;
//DUPS: 2B04000F,
static const uint64_t P9N2_EX_6_LOCAL_FIR_MASK                                     = 0x2C04000Dull;
//DUPS: 2D04000D,
static const uint64_t P9N2_EX_6_LOCAL_FIR_MASK_AND                                 = 0x2C04000Eull;
//DUPS: 2D04000E,
static const uint64_t P9N2_EX_6_LOCAL_FIR_MASK_OR                                  = 0x2C04000Full;
//DUPS: 2D04000F,
static const uint64_t P9N2_EX_7_LOCAL_FIR_MASK                                     = 0x2F04000Dull;
//DUPS: 2F04000D,
static const uint64_t P9N2_EX_7_LOCAL_FIR_MASK_AND                                 = 0x2F04000Eull;
//DUPS: 2F04000E,
static const uint64_t P9N2_EX_7_LOCAL_FIR_MASK_OR                                  = 0x2F04000Full;
//DUPS: 2F04000F,
static const uint64_t P9N2_EX_8_LOCAL_FIR_MASK                                     = 0x3004000Dull;
//DUPS: 3104000D,
static const uint64_t P9N2_EX_8_LOCAL_FIR_MASK_AND                                 = 0x3004000Eull;
//DUPS: 3104000E,
static const uint64_t P9N2_EX_8_LOCAL_FIR_MASK_OR                                  = 0x3004000Full;
//DUPS: 3104000F,
static const uint64_t P9N2_EX_9_LOCAL_FIR_MASK                                     = 0x3204000Dull;
//DUPS: 3304000D,
static const uint64_t P9N2_EX_9_LOCAL_FIR_MASK_AND                                 = 0x3204000Eull;
//DUPS: 3304000E,
static const uint64_t P9N2_EX_9_LOCAL_FIR_MASK_OR                                  = 0x3204000Full;
//DUPS: 3304000F,
static const uint64_t P9N2_EX_10_LOCAL_FIR_MASK                                    = 0x3404000Dull;
//DUPS: 3504000D,
static const uint64_t P9N2_EX_10_LOCAL_FIR_MASK_AND                                = 0x3404000Eull;
//DUPS: 3504000E,
static const uint64_t P9N2_EX_10_LOCAL_FIR_MASK_OR                                 = 0x3404000Full;
//DUPS: 3504000F,
static const uint64_t P9N2_EX_11_LOCAL_FIR_MASK                                    = 0x3604000Dull;
//DUPS: 3704000D,
static const uint64_t P9N2_EX_11_LOCAL_FIR_MASK_AND                                = 0x3604000Eull;
//DUPS: 3704000E,
static const uint64_t P9N2_EX_11_LOCAL_FIR_MASK_OR                                 = 0x3604000Full;
//DUPS: 3704000F,

static const uint64_t P9N2_C_LOCAL_XSTOP_ERR                                       = 0x20040018ull;

static const uint64_t P9N2_C_0_LOCAL_XSTOP_ERR                                     = 0x20040018ull;

static const uint64_t P9N2_C_1_LOCAL_XSTOP_ERR                                     = 0x21040018ull;

static const uint64_t P9N2_C_2_LOCAL_XSTOP_ERR                                     = 0x22040018ull;

static const uint64_t P9N2_C_3_LOCAL_XSTOP_ERR                                     = 0x23040018ull;

static const uint64_t P9N2_C_4_LOCAL_XSTOP_ERR                                     = 0x24040018ull;

static const uint64_t P9N2_C_5_LOCAL_XSTOP_ERR                                     = 0x25040018ull;

static const uint64_t P9N2_C_6_LOCAL_XSTOP_ERR                                     = 0x26040018ull;

static const uint64_t P9N2_C_7_LOCAL_XSTOP_ERR                                     = 0x27040018ull;

static const uint64_t P9N2_C_8_LOCAL_XSTOP_ERR                                     = 0x28040018ull;

static const uint64_t P9N2_C_9_LOCAL_XSTOP_ERR                                     = 0x29040018ull;

static const uint64_t P9N2_C_10_LOCAL_XSTOP_ERR                                    = 0x2A040018ull;

static const uint64_t P9N2_C_11_LOCAL_XSTOP_ERR                                    = 0x2B040018ull;

static const uint64_t P9N2_C_12_LOCAL_XSTOP_ERR                                    = 0x2C040018ull;

static const uint64_t P9N2_C_13_LOCAL_XSTOP_ERR                                    = 0x2D040018ull;

static const uint64_t P9N2_C_14_LOCAL_XSTOP_ERR                                    = 0x2E040018ull;

static const uint64_t P9N2_C_15_LOCAL_XSTOP_ERR                                    = 0x2F040018ull;

static const uint64_t P9N2_C_16_LOCAL_XSTOP_ERR                                    = 0x30040018ull;

static const uint64_t P9N2_C_17_LOCAL_XSTOP_ERR                                    = 0x31040018ull;

static const uint64_t P9N2_C_18_LOCAL_XSTOP_ERR                                    = 0x32040018ull;

static const uint64_t P9N2_C_19_LOCAL_XSTOP_ERR                                    = 0x33040018ull;

static const uint64_t P9N2_C_20_LOCAL_XSTOP_ERR                                    = 0x34040018ull;

static const uint64_t P9N2_C_21_LOCAL_XSTOP_ERR                                    = 0x35040018ull;

static const uint64_t P9N2_C_22_LOCAL_XSTOP_ERR                                    = 0x36040018ull;

static const uint64_t P9N2_C_23_LOCAL_XSTOP_ERR                                    = 0x37040018ull;

static const uint64_t P9N2_EQ_LOCAL_XSTOP_ERR                                      = 0x10040018ull;

static const uint64_t P9N2_EQ_0_LOCAL_XSTOP_ERR                                    = 0x10040018ull;

static const uint64_t P9N2_EQ_1_LOCAL_XSTOP_ERR                                    = 0x11040018ull;

static const uint64_t P9N2_EQ_2_LOCAL_XSTOP_ERR                                    = 0x12040018ull;

static const uint64_t P9N2_EQ_3_LOCAL_XSTOP_ERR                                    = 0x13040018ull;

static const uint64_t P9N2_EQ_4_LOCAL_XSTOP_ERR                                    = 0x14040018ull;

static const uint64_t P9N2_EQ_5_LOCAL_XSTOP_ERR                                    = 0x15040018ull;

static const uint64_t P9N2_EX_LOCAL_XSTOP_ERR                                      = 0x20040018ull;
//DUPS: 21040018,
static const uint64_t P9N2_EX_0_LOCAL_XSTOP_ERR                                    = 0x20040018ull;
//DUPS: 21040018,
static const uint64_t P9N2_EX_1_LOCAL_XSTOP_ERR                                    = 0x22040018ull;
//DUPS: 23040018,
static const uint64_t P9N2_EX_2_LOCAL_XSTOP_ERR                                    = 0x24040018ull;
//DUPS: 25040018,
static const uint64_t P9N2_EX_3_LOCAL_XSTOP_ERR                                    = 0x26040018ull;
//DUPS: 27040018,
static const uint64_t P9N2_EX_4_LOCAL_XSTOP_ERR                                    = 0x28040018ull;
//DUPS: 29040018,
static const uint64_t P9N2_EX_5_LOCAL_XSTOP_ERR                                    = 0x2A040018ull;
//DUPS: 2B040018,
static const uint64_t P9N2_EX_6_LOCAL_XSTOP_ERR                                    = 0x2C040018ull;
//DUPS: 2D040018,
static const uint64_t P9N2_EX_7_LOCAL_XSTOP_ERR                                    = 0x2F040018ull;
//DUPS: 2F040018,
static const uint64_t P9N2_EX_8_LOCAL_XSTOP_ERR                                    = 0x30040018ull;
//DUPS: 31040018,
static const uint64_t P9N2_EX_9_LOCAL_XSTOP_ERR                                    = 0x32040018ull;
//DUPS: 33040018,
static const uint64_t P9N2_EX_10_LOCAL_XSTOP_ERR                                   = 0x34040018ull;
//DUPS: 35040018,
static const uint64_t P9N2_EX_11_LOCAL_XSTOP_ERR                                   = 0x36040018ull;
//DUPS: 37040018,

static const uint64_t P9N2_C_LOCAL_XSTOP_MASK                                      = 0x20040019ull;

static const uint64_t P9N2_C_0_LOCAL_XSTOP_MASK                                    = 0x20040019ull;

static const uint64_t P9N2_C_1_LOCAL_XSTOP_MASK                                    = 0x21040019ull;

static const uint64_t P9N2_C_2_LOCAL_XSTOP_MASK                                    = 0x22040019ull;

static const uint64_t P9N2_C_3_LOCAL_XSTOP_MASK                                    = 0x23040019ull;

static const uint64_t P9N2_C_4_LOCAL_XSTOP_MASK                                    = 0x24040019ull;

static const uint64_t P9N2_C_5_LOCAL_XSTOP_MASK                                    = 0x25040019ull;

static const uint64_t P9N2_C_6_LOCAL_XSTOP_MASK                                    = 0x26040019ull;

static const uint64_t P9N2_C_7_LOCAL_XSTOP_MASK                                    = 0x27040019ull;

static const uint64_t P9N2_C_8_LOCAL_XSTOP_MASK                                    = 0x28040019ull;

static const uint64_t P9N2_C_9_LOCAL_XSTOP_MASK                                    = 0x29040019ull;

static const uint64_t P9N2_C_10_LOCAL_XSTOP_MASK                                   = 0x2A040019ull;

static const uint64_t P9N2_C_11_LOCAL_XSTOP_MASK                                   = 0x2B040019ull;

static const uint64_t P9N2_C_12_LOCAL_XSTOP_MASK                                   = 0x2C040019ull;

static const uint64_t P9N2_C_13_LOCAL_XSTOP_MASK                                   = 0x2D040019ull;

static const uint64_t P9N2_C_14_LOCAL_XSTOP_MASK                                   = 0x2E040019ull;

static const uint64_t P9N2_C_15_LOCAL_XSTOP_MASK                                   = 0x2F040019ull;

static const uint64_t P9N2_C_16_LOCAL_XSTOP_MASK                                   = 0x30040019ull;

static const uint64_t P9N2_C_17_LOCAL_XSTOP_MASK                                   = 0x31040019ull;

static const uint64_t P9N2_C_18_LOCAL_XSTOP_MASK                                   = 0x32040019ull;

static const uint64_t P9N2_C_19_LOCAL_XSTOP_MASK                                   = 0x33040019ull;

static const uint64_t P9N2_C_20_LOCAL_XSTOP_MASK                                   = 0x34040019ull;

static const uint64_t P9N2_C_21_LOCAL_XSTOP_MASK                                   = 0x35040019ull;

static const uint64_t P9N2_C_22_LOCAL_XSTOP_MASK                                   = 0x36040019ull;

static const uint64_t P9N2_C_23_LOCAL_XSTOP_MASK                                   = 0x37040019ull;

static const uint64_t P9N2_EQ_LOCAL_XSTOP_MASK                                     = 0x10040019ull;

static const uint64_t P9N2_EQ_0_LOCAL_XSTOP_MASK                                   = 0x10040019ull;

static const uint64_t P9N2_EQ_1_LOCAL_XSTOP_MASK                                   = 0x11040019ull;

static const uint64_t P9N2_EQ_2_LOCAL_XSTOP_MASK                                   = 0x12040019ull;

static const uint64_t P9N2_EQ_3_LOCAL_XSTOP_MASK                                   = 0x13040019ull;

static const uint64_t P9N2_EQ_4_LOCAL_XSTOP_MASK                                   = 0x14040019ull;

static const uint64_t P9N2_EQ_5_LOCAL_XSTOP_MASK                                   = 0x15040019ull;

static const uint64_t P9N2_EX_LOCAL_XSTOP_MASK                                     = 0x20040019ull;
//DUPS: 21040019,
static const uint64_t P9N2_EX_0_LOCAL_XSTOP_MASK                                   = 0x20040019ull;
//DUPS: 21040019,
static const uint64_t P9N2_EX_1_LOCAL_XSTOP_MASK                                   = 0x22040019ull;
//DUPS: 23040019,
static const uint64_t P9N2_EX_2_LOCAL_XSTOP_MASK                                   = 0x24040019ull;
//DUPS: 25040019,
static const uint64_t P9N2_EX_3_LOCAL_XSTOP_MASK                                   = 0x26040019ull;
//DUPS: 27040019,
static const uint64_t P9N2_EX_4_LOCAL_XSTOP_MASK                                   = 0x28040019ull;
//DUPS: 29040019,
static const uint64_t P9N2_EX_5_LOCAL_XSTOP_MASK                                   = 0x2A040019ull;
//DUPS: 2B040019,
static const uint64_t P9N2_EX_6_LOCAL_XSTOP_MASK                                   = 0x2C040019ull;
//DUPS: 2D040019,
static const uint64_t P9N2_EX_7_LOCAL_XSTOP_MASK                                   = 0x2F040019ull;
//DUPS: 2F040019,
static const uint64_t P9N2_EX_8_LOCAL_XSTOP_MASK                                   = 0x30040019ull;
//DUPS: 31040019,
static const uint64_t P9N2_EX_9_LOCAL_XSTOP_MASK                                   = 0x32040019ull;
//DUPS: 33040019,
static const uint64_t P9N2_EX_10_LOCAL_XSTOP_MASK                                  = 0x34040019ull;
//DUPS: 35040019,
static const uint64_t P9N2_EX_11_LOCAL_XSTOP_MASK                                  = 0x36040019ull;
//DUPS: 37040019,

static const uint64_t P9N2_EQ_LRU_VIC_ALLOC_REG                                    = 0x10011C11ull;
//DUPS: 10011C11,
static const uint64_t P9N2_EQ_0_LRU_VIC_ALLOC_REG                                  = 0x10011C11ull;
//DUPS: 10011C11,
static const uint64_t P9N2_EQ_1_LRU_VIC_ALLOC_REG                                  = 0x11011C11ull;
//DUPS: 11011C11,
static const uint64_t P9N2_EQ_2_LRU_VIC_ALLOC_REG                                  = 0x12011C11ull;
//DUPS: 12011C11,
static const uint64_t P9N2_EQ_3_LRU_VIC_ALLOC_REG                                  = 0x13011C11ull;
//DUPS: 13011C11,
static const uint64_t P9N2_EQ_4_LRU_VIC_ALLOC_REG                                  = 0x14011C11ull;
//DUPS: 14011C11,
static const uint64_t P9N2_EQ_5_LRU_VIC_ALLOC_REG                                  = 0x15011C11ull;
//DUPS: 15011C11,
static const uint64_t P9N2_EX_0_L3_LRU_VIC_ALLOC_REG                               = 0x10011811ull;

static const uint64_t P9N2_EX_10_L3_LRU_VIC_ALLOC_REG                              = 0x15011811ull;

static const uint64_t P9N2_EX_11_L3_LRU_VIC_ALLOC_REG                              = 0x15011C11ull;

static const uint64_t P9N2_EX_1_L3_LRU_VIC_ALLOC_REG                               = 0x10011C11ull;

static const uint64_t P9N2_EX_2_L3_LRU_VIC_ALLOC_REG                               = 0x11011811ull;

static const uint64_t P9N2_EX_3_L3_LRU_VIC_ALLOC_REG                               = 0x11011C11ull;

static const uint64_t P9N2_EX_4_L3_LRU_VIC_ALLOC_REG                               = 0x12011811ull;

static const uint64_t P9N2_EX_5_L3_LRU_VIC_ALLOC_REG                               = 0x12011C11ull;

static const uint64_t P9N2_EX_6_L3_LRU_VIC_ALLOC_REG                               = 0x13011811ull;

static const uint64_t P9N2_EX_7_L3_LRU_VIC_ALLOC_REG                               = 0x13011C11ull;

static const uint64_t P9N2_EX_8_L3_LRU_VIC_ALLOC_REG                               = 0x14011811ull;

static const uint64_t P9N2_EX_9_L3_LRU_VIC_ALLOC_REG                               = 0x14011C11ull;

static const uint64_t P9N2_EX_L3_LRU_VIC_ALLOC_REG                                 = 0x10011811ull;


static const uint64_t P9N2_C_LSU_HOLD_OUT_REG0                                     = 0x20010C80ull;

static const uint64_t P9N2_C_0_LSU_HOLD_OUT_REG0                                   = 0x20010C80ull;

static const uint64_t P9N2_C_1_LSU_HOLD_OUT_REG0                                   = 0x21010C80ull;

static const uint64_t P9N2_C_2_LSU_HOLD_OUT_REG0                                   = 0x22010C80ull;

static const uint64_t P9N2_C_3_LSU_HOLD_OUT_REG0                                   = 0x23010C80ull;

static const uint64_t P9N2_C_4_LSU_HOLD_OUT_REG0                                   = 0x24010C80ull;

static const uint64_t P9N2_C_5_LSU_HOLD_OUT_REG0                                   = 0x25010C80ull;

static const uint64_t P9N2_C_6_LSU_HOLD_OUT_REG0                                   = 0x26010C80ull;

static const uint64_t P9N2_C_7_LSU_HOLD_OUT_REG0                                   = 0x27010C80ull;

static const uint64_t P9N2_C_8_LSU_HOLD_OUT_REG0                                   = 0x28010C80ull;

static const uint64_t P9N2_C_9_LSU_HOLD_OUT_REG0                                   = 0x29010C80ull;

static const uint64_t P9N2_C_10_LSU_HOLD_OUT_REG0                                  = 0x2A010C80ull;

static const uint64_t P9N2_C_11_LSU_HOLD_OUT_REG0                                  = 0x2B010C80ull;

static const uint64_t P9N2_C_12_LSU_HOLD_OUT_REG0                                  = 0x2C010C80ull;

static const uint64_t P9N2_C_13_LSU_HOLD_OUT_REG0                                  = 0x2D010C80ull;

static const uint64_t P9N2_C_14_LSU_HOLD_OUT_REG0                                  = 0x2E010C80ull;

static const uint64_t P9N2_C_15_LSU_HOLD_OUT_REG0                                  = 0x2F010C80ull;

static const uint64_t P9N2_C_16_LSU_HOLD_OUT_REG0                                  = 0x30010C80ull;

static const uint64_t P9N2_C_17_LSU_HOLD_OUT_REG0                                  = 0x31010C80ull;

static const uint64_t P9N2_C_18_LSU_HOLD_OUT_REG0                                  = 0x32010C80ull;

static const uint64_t P9N2_C_19_LSU_HOLD_OUT_REG0                                  = 0x33010C80ull;

static const uint64_t P9N2_C_20_LSU_HOLD_OUT_REG0                                  = 0x34010C80ull;

static const uint64_t P9N2_C_21_LSU_HOLD_OUT_REG0                                  = 0x35010C80ull;

static const uint64_t P9N2_C_22_LSU_HOLD_OUT_REG0                                  = 0x36010C80ull;

static const uint64_t P9N2_C_23_LSU_HOLD_OUT_REG0                                  = 0x37010C80ull;

static const uint64_t P9N2_EX_0_L2_LSU_HOLD_OUT_REG0                               = 0x20010C80ull;
//DUPS: 21010C80,
static const uint64_t P9N2_EX_10_L2_LSU_HOLD_OUT_REG0                              = 0x34010C80ull;
//DUPS: 35010C80,
static const uint64_t P9N2_EX_11_L2_LSU_HOLD_OUT_REG0                              = 0x36010C80ull;
//DUPS: 37010C80,
static const uint64_t P9N2_EX_1_L2_LSU_HOLD_OUT_REG0                               = 0x22010C80ull;
//DUPS: 23010C80,
static const uint64_t P9N2_EX_2_L2_LSU_HOLD_OUT_REG0                               = 0x24010C80ull;
//DUPS: 25010C80,
static const uint64_t P9N2_EX_3_L2_LSU_HOLD_OUT_REG0                               = 0x26010C80ull;
//DUPS: 27010C80,
static const uint64_t P9N2_EX_4_L2_LSU_HOLD_OUT_REG0                               = 0x28010C80ull;
//DUPS: 29010C80,
static const uint64_t P9N2_EX_5_L2_LSU_HOLD_OUT_REG0                               = 0x2A010C80ull;
//DUPS: 2B010C80,
static const uint64_t P9N2_EX_6_L2_LSU_HOLD_OUT_REG0                               = 0x2C010C80ull;
//DUPS: 2D010C80,
static const uint64_t P9N2_EX_7_L2_LSU_HOLD_OUT_REG0                               = 0x2F010C80ull;
//DUPS: 2F010C80,
static const uint64_t P9N2_EX_8_L2_LSU_HOLD_OUT_REG0                               = 0x30010C80ull;
//DUPS: 31010C80,
static const uint64_t P9N2_EX_9_L2_LSU_HOLD_OUT_REG0                               = 0x32010C80ull;
//DUPS: 33010C80,
static const uint64_t P9N2_EX_L2_LSU_HOLD_OUT_REG0                                 = 0x20010C80ull;
//DUPS: 21010C80,

static const uint64_t P9N2_C_LSU_HOLD_OUT_REG1                                     = 0x20010C81ull;

static const uint64_t P9N2_C_0_LSU_HOLD_OUT_REG1                                   = 0x20010C81ull;

static const uint64_t P9N2_C_1_LSU_HOLD_OUT_REG1                                   = 0x21010C81ull;

static const uint64_t P9N2_C_2_LSU_HOLD_OUT_REG1                                   = 0x22010C81ull;

static const uint64_t P9N2_C_3_LSU_HOLD_OUT_REG1                                   = 0x23010C81ull;

static const uint64_t P9N2_C_4_LSU_HOLD_OUT_REG1                                   = 0x24010C81ull;

static const uint64_t P9N2_C_5_LSU_HOLD_OUT_REG1                                   = 0x25010C81ull;

static const uint64_t P9N2_C_6_LSU_HOLD_OUT_REG1                                   = 0x26010C81ull;

static const uint64_t P9N2_C_7_LSU_HOLD_OUT_REG1                                   = 0x27010C81ull;

static const uint64_t P9N2_C_8_LSU_HOLD_OUT_REG1                                   = 0x28010C81ull;

static const uint64_t P9N2_C_9_LSU_HOLD_OUT_REG1                                   = 0x29010C81ull;

static const uint64_t P9N2_C_10_LSU_HOLD_OUT_REG1                                  = 0x2A010C81ull;

static const uint64_t P9N2_C_11_LSU_HOLD_OUT_REG1                                  = 0x2B010C81ull;

static const uint64_t P9N2_C_12_LSU_HOLD_OUT_REG1                                  = 0x2C010C81ull;

static const uint64_t P9N2_C_13_LSU_HOLD_OUT_REG1                                  = 0x2D010C81ull;

static const uint64_t P9N2_C_14_LSU_HOLD_OUT_REG1                                  = 0x2E010C81ull;

static const uint64_t P9N2_C_15_LSU_HOLD_OUT_REG1                                  = 0x2F010C81ull;

static const uint64_t P9N2_C_16_LSU_HOLD_OUT_REG1                                  = 0x30010C81ull;

static const uint64_t P9N2_C_17_LSU_HOLD_OUT_REG1                                  = 0x31010C81ull;

static const uint64_t P9N2_C_18_LSU_HOLD_OUT_REG1                                  = 0x32010C81ull;

static const uint64_t P9N2_C_19_LSU_HOLD_OUT_REG1                                  = 0x33010C81ull;

static const uint64_t P9N2_C_20_LSU_HOLD_OUT_REG1                                  = 0x34010C81ull;

static const uint64_t P9N2_C_21_LSU_HOLD_OUT_REG1                                  = 0x35010C81ull;

static const uint64_t P9N2_C_22_LSU_HOLD_OUT_REG1                                  = 0x36010C81ull;

static const uint64_t P9N2_C_23_LSU_HOLD_OUT_REG1                                  = 0x37010C81ull;

static const uint64_t P9N2_EX_0_L2_LSU_HOLD_OUT_REG1                               = 0x20010C81ull;
//DUPS: 21010C81,
static const uint64_t P9N2_EX_10_L2_LSU_HOLD_OUT_REG1                              = 0x34010C81ull;
//DUPS: 35010C81,
static const uint64_t P9N2_EX_11_L2_LSU_HOLD_OUT_REG1                              = 0x36010C81ull;
//DUPS: 37010C81,
static const uint64_t P9N2_EX_1_L2_LSU_HOLD_OUT_REG1                               = 0x22010C81ull;
//DUPS: 23010C81,
static const uint64_t P9N2_EX_2_L2_LSU_HOLD_OUT_REG1                               = 0x24010C81ull;
//DUPS: 25010C81,
static const uint64_t P9N2_EX_3_L2_LSU_HOLD_OUT_REG1                               = 0x26010C81ull;
//DUPS: 27010C81,
static const uint64_t P9N2_EX_4_L2_LSU_HOLD_OUT_REG1                               = 0x28010C81ull;
//DUPS: 29010C81,
static const uint64_t P9N2_EX_5_L2_LSU_HOLD_OUT_REG1                               = 0x2A010C81ull;
//DUPS: 2B010C81,
static const uint64_t P9N2_EX_6_L2_LSU_HOLD_OUT_REG1                               = 0x2C010C81ull;
//DUPS: 2D010C81,
static const uint64_t P9N2_EX_7_L2_LSU_HOLD_OUT_REG1                               = 0x2F010C81ull;
//DUPS: 2F010C81,
static const uint64_t P9N2_EX_8_L2_LSU_HOLD_OUT_REG1                               = 0x30010C81ull;
//DUPS: 31010C81,
static const uint64_t P9N2_EX_9_L2_LSU_HOLD_OUT_REG1                               = 0x32010C81ull;
//DUPS: 33010C81,
static const uint64_t P9N2_EX_L2_LSU_HOLD_OUT_REG1                                 = 0x20010C81ull;
//DUPS: 21010C81,

static const uint64_t P9N2_C_LSU_HOLD_OUT_REG2                                     = 0x20010C82ull;

static const uint64_t P9N2_C_0_LSU_HOLD_OUT_REG2                                   = 0x20010C82ull;

static const uint64_t P9N2_C_1_LSU_HOLD_OUT_REG2                                   = 0x21010C82ull;

static const uint64_t P9N2_C_2_LSU_HOLD_OUT_REG2                                   = 0x22010C82ull;

static const uint64_t P9N2_C_3_LSU_HOLD_OUT_REG2                                   = 0x23010C82ull;

static const uint64_t P9N2_C_4_LSU_HOLD_OUT_REG2                                   = 0x24010C82ull;

static const uint64_t P9N2_C_5_LSU_HOLD_OUT_REG2                                   = 0x25010C82ull;

static const uint64_t P9N2_C_6_LSU_HOLD_OUT_REG2                                   = 0x26010C82ull;

static const uint64_t P9N2_C_7_LSU_HOLD_OUT_REG2                                   = 0x27010C82ull;

static const uint64_t P9N2_C_8_LSU_HOLD_OUT_REG2                                   = 0x28010C82ull;

static const uint64_t P9N2_C_9_LSU_HOLD_OUT_REG2                                   = 0x29010C82ull;

static const uint64_t P9N2_C_10_LSU_HOLD_OUT_REG2                                  = 0x2A010C82ull;

static const uint64_t P9N2_C_11_LSU_HOLD_OUT_REG2                                  = 0x2B010C82ull;

static const uint64_t P9N2_C_12_LSU_HOLD_OUT_REG2                                  = 0x2C010C82ull;

static const uint64_t P9N2_C_13_LSU_HOLD_OUT_REG2                                  = 0x2D010C82ull;

static const uint64_t P9N2_C_14_LSU_HOLD_OUT_REG2                                  = 0x2E010C82ull;

static const uint64_t P9N2_C_15_LSU_HOLD_OUT_REG2                                  = 0x2F010C82ull;

static const uint64_t P9N2_C_16_LSU_HOLD_OUT_REG2                                  = 0x30010C82ull;

static const uint64_t P9N2_C_17_LSU_HOLD_OUT_REG2                                  = 0x31010C82ull;

static const uint64_t P9N2_C_18_LSU_HOLD_OUT_REG2                                  = 0x32010C82ull;

static const uint64_t P9N2_C_19_LSU_HOLD_OUT_REG2                                  = 0x33010C82ull;

static const uint64_t P9N2_C_20_LSU_HOLD_OUT_REG2                                  = 0x34010C82ull;

static const uint64_t P9N2_C_21_LSU_HOLD_OUT_REG2                                  = 0x35010C82ull;

static const uint64_t P9N2_C_22_LSU_HOLD_OUT_REG2                                  = 0x36010C82ull;

static const uint64_t P9N2_C_23_LSU_HOLD_OUT_REG2                                  = 0x37010C82ull;

static const uint64_t P9N2_EX_0_L2_LSU_HOLD_OUT_REG2                               = 0x20010C82ull;
//DUPS: 21010C82,
static const uint64_t P9N2_EX_10_L2_LSU_HOLD_OUT_REG2                              = 0x34010C82ull;
//DUPS: 35010C82,
static const uint64_t P9N2_EX_11_L2_LSU_HOLD_OUT_REG2                              = 0x36010C82ull;
//DUPS: 37010C82,
static const uint64_t P9N2_EX_1_L2_LSU_HOLD_OUT_REG2                               = 0x22010C82ull;
//DUPS: 23010C82,
static const uint64_t P9N2_EX_2_L2_LSU_HOLD_OUT_REG2                               = 0x24010C82ull;
//DUPS: 25010C82,
static const uint64_t P9N2_EX_3_L2_LSU_HOLD_OUT_REG2                               = 0x26010C82ull;
//DUPS: 27010C82,
static const uint64_t P9N2_EX_4_L2_LSU_HOLD_OUT_REG2                               = 0x28010C82ull;
//DUPS: 29010C82,
static const uint64_t P9N2_EX_5_L2_LSU_HOLD_OUT_REG2                               = 0x2A010C82ull;
//DUPS: 2B010C82,
static const uint64_t P9N2_EX_6_L2_LSU_HOLD_OUT_REG2                               = 0x2C010C82ull;
//DUPS: 2D010C82,
static const uint64_t P9N2_EX_7_L2_LSU_HOLD_OUT_REG2                               = 0x2F010C82ull;
//DUPS: 2F010C82,
static const uint64_t P9N2_EX_8_L2_LSU_HOLD_OUT_REG2                               = 0x30010C82ull;
//DUPS: 31010C82,
static const uint64_t P9N2_EX_9_L2_LSU_HOLD_OUT_REG2                               = 0x32010C82ull;
//DUPS: 33010C82,
static const uint64_t P9N2_EX_L2_LSU_HOLD_OUT_REG2                                 = 0x20010C82ull;
//DUPS: 21010C82,

static const uint64_t P9N2_C_LSU_HOLD_OUT_REG3                                     = 0x20010C83ull;

static const uint64_t P9N2_C_0_LSU_HOLD_OUT_REG3                                   = 0x20010C83ull;

static const uint64_t P9N2_C_1_LSU_HOLD_OUT_REG3                                   = 0x21010C83ull;

static const uint64_t P9N2_C_2_LSU_HOLD_OUT_REG3                                   = 0x22010C83ull;

static const uint64_t P9N2_C_3_LSU_HOLD_OUT_REG3                                   = 0x23010C83ull;

static const uint64_t P9N2_C_4_LSU_HOLD_OUT_REG3                                   = 0x24010C83ull;

static const uint64_t P9N2_C_5_LSU_HOLD_OUT_REG3                                   = 0x25010C83ull;

static const uint64_t P9N2_C_6_LSU_HOLD_OUT_REG3                                   = 0x26010C83ull;

static const uint64_t P9N2_C_7_LSU_HOLD_OUT_REG3                                   = 0x27010C83ull;

static const uint64_t P9N2_C_8_LSU_HOLD_OUT_REG3                                   = 0x28010C83ull;

static const uint64_t P9N2_C_9_LSU_HOLD_OUT_REG3                                   = 0x29010C83ull;

static const uint64_t P9N2_C_10_LSU_HOLD_OUT_REG3                                  = 0x2A010C83ull;

static const uint64_t P9N2_C_11_LSU_HOLD_OUT_REG3                                  = 0x2B010C83ull;

static const uint64_t P9N2_C_12_LSU_HOLD_OUT_REG3                                  = 0x2C010C83ull;

static const uint64_t P9N2_C_13_LSU_HOLD_OUT_REG3                                  = 0x2D010C83ull;

static const uint64_t P9N2_C_14_LSU_HOLD_OUT_REG3                                  = 0x2E010C83ull;

static const uint64_t P9N2_C_15_LSU_HOLD_OUT_REG3                                  = 0x2F010C83ull;

static const uint64_t P9N2_C_16_LSU_HOLD_OUT_REG3                                  = 0x30010C83ull;

static const uint64_t P9N2_C_17_LSU_HOLD_OUT_REG3                                  = 0x31010C83ull;

static const uint64_t P9N2_C_18_LSU_HOLD_OUT_REG3                                  = 0x32010C83ull;

static const uint64_t P9N2_C_19_LSU_HOLD_OUT_REG3                                  = 0x33010C83ull;

static const uint64_t P9N2_C_20_LSU_HOLD_OUT_REG3                                  = 0x34010C83ull;

static const uint64_t P9N2_C_21_LSU_HOLD_OUT_REG3                                  = 0x35010C83ull;

static const uint64_t P9N2_C_22_LSU_HOLD_OUT_REG3                                  = 0x36010C83ull;

static const uint64_t P9N2_C_23_LSU_HOLD_OUT_REG3                                  = 0x37010C83ull;

static const uint64_t P9N2_EX_0_L2_LSU_HOLD_OUT_REG3                               = 0x20010C83ull;
//DUPS: 21010C83,
static const uint64_t P9N2_EX_10_L2_LSU_HOLD_OUT_REG3                              = 0x34010C83ull;
//DUPS: 35010C83,
static const uint64_t P9N2_EX_11_L2_LSU_HOLD_OUT_REG3                              = 0x36010C83ull;
//DUPS: 37010C83,
static const uint64_t P9N2_EX_1_L2_LSU_HOLD_OUT_REG3                               = 0x22010C83ull;
//DUPS: 23010C83,
static const uint64_t P9N2_EX_2_L2_LSU_HOLD_OUT_REG3                               = 0x24010C83ull;
//DUPS: 25010C83,
static const uint64_t P9N2_EX_3_L2_LSU_HOLD_OUT_REG3                               = 0x26010C83ull;
//DUPS: 27010C83,
static const uint64_t P9N2_EX_4_L2_LSU_HOLD_OUT_REG3                               = 0x28010C83ull;
//DUPS: 29010C83,
static const uint64_t P9N2_EX_5_L2_LSU_HOLD_OUT_REG3                               = 0x2A010C83ull;
//DUPS: 2B010C83,
static const uint64_t P9N2_EX_6_L2_LSU_HOLD_OUT_REG3                               = 0x2C010C83ull;
//DUPS: 2D010C83,
static const uint64_t P9N2_EX_7_L2_LSU_HOLD_OUT_REG3                               = 0x2F010C83ull;
//DUPS: 2F010C83,
static const uint64_t P9N2_EX_8_L2_LSU_HOLD_OUT_REG3                               = 0x30010C83ull;
//DUPS: 31010C83,
static const uint64_t P9N2_EX_9_L2_LSU_HOLD_OUT_REG3                               = 0x32010C83ull;
//DUPS: 33010C83,
static const uint64_t P9N2_EX_L2_LSU_HOLD_OUT_REG3                                 = 0x20010C83ull;
//DUPS: 21010C83,

static const uint64_t P9N2_EQ_MEM_OP_CTR                                           = 0x10012208ull;
//DUPS: 10012708, 10012208, 10012308,
static const uint64_t P9N2_EQ_0_MEM_OP_CTR                                         = 0x10012208ull;
//DUPS: 10012708, 10012208, 10012308,
static const uint64_t P9N2_EQ_1_MEM_OP_CTR                                         = 0x11012208ull;
//DUPS: 11012708, 11012208, 11012308,
static const uint64_t P9N2_EQ_2_MEM_OP_CTR                                         = 0x12012208ull;
//DUPS: 12012708, 12012208, 12012308,
static const uint64_t P9N2_EQ_3_MEM_OP_CTR                                         = 0x13012208ull;
//DUPS: 13012708, 13012208, 13012308,
static const uint64_t P9N2_EQ_4_MEM_OP_CTR                                         = 0x14012208ull;
//DUPS: 14012708, 14012208, 14012308,
static const uint64_t P9N2_EQ_5_MEM_OP_CTR                                         = 0x15012208ull;
//DUPS: 15012708, 15012208, 15012308,
static const uint64_t P9N2_EX_MEM_OP_CTR                                           = 0x10012208ull;
//DUPS: 10012308,
static const uint64_t P9N2_EX_0_MEM_OP_CTR                                         = 0x10012208ull;
//DUPS: 10012308,
static const uint64_t P9N2_EX_2_MEM_OP_CTR                                         = 0x11012208ull;
//DUPS: 11012308,
static const uint64_t P9N2_EX_4_MEM_OP_CTR                                         = 0x12012208ull;
//DUPS: 12012308,
static const uint64_t P9N2_EX_6_MEM_OP_CTR                                         = 0x13012208ull;
//DUPS: 13012308,
static const uint64_t P9N2_EX_8_MEM_OP_CTR                                         = 0x14012208ull;
//DUPS: 14012308,
static const uint64_t P9N2_EX_10_MEM_OP_CTR                                        = 0x15012208ull;
//DUPS: 15012308,
static const uint64_t P9N2_EX_11_CHTMLBS0_MEM_OP_CTR                               = 0x15012608ull;

static const uint64_t P9N2_EX_11_CHTMLBS1_MEM_OP_CTR                               = 0x15012708ull;

static const uint64_t P9N2_EX_1_CHTMLBS0_MEM_OP_CTR                                = 0x10012608ull;

static const uint64_t P9N2_EX_1_CHTMLBS1_MEM_OP_CTR                                = 0x10012708ull;

static const uint64_t P9N2_EX_3_CHTMLBS0_MEM_OP_CTR                                = 0x11012608ull;

static const uint64_t P9N2_EX_3_CHTMLBS1_MEM_OP_CTR                                = 0x11012708ull;

static const uint64_t P9N2_EX_5_CHTMLBS0_MEM_OP_CTR                                = 0x12012608ull;

static const uint64_t P9N2_EX_5_CHTMLBS1_MEM_OP_CTR                                = 0x12012708ull;

static const uint64_t P9N2_EX_7_CHTMLBS0_MEM_OP_CTR                                = 0x13012608ull;

static const uint64_t P9N2_EX_7_CHTMLBS1_MEM_OP_CTR                                = 0x13012708ull;

static const uint64_t P9N2_EX_9_CHTMLBS0_MEM_OP_CTR                                = 0x14012608ull;

static const uint64_t P9N2_EX_9_CHTMLBS1_MEM_OP_CTR                                = 0x14012708ull;


static const uint64_t P9N2_EQ_MIB_XIICAC                                           = 0x10012019ull;
//DUPS: 10012019,
static const uint64_t P9N2_EQ_0_MIB_XIICAC                                         = 0x10012019ull;
//DUPS: 10012019,
static const uint64_t P9N2_EQ_1_MIB_XIICAC                                         = 0x11012019ull;
//DUPS: 11012019,
static const uint64_t P9N2_EQ_2_MIB_XIICAC                                         = 0x12012019ull;
//DUPS: 12012019,
static const uint64_t P9N2_EQ_3_MIB_XIICAC                                         = 0x13012019ull;
//DUPS: 13012019,
static const uint64_t P9N2_EQ_4_MIB_XIICAC                                         = 0x14012019ull;
//DUPS: 14012019,
static const uint64_t P9N2_EQ_5_MIB_XIICAC                                         = 0x15012019ull;
//DUPS: 15012019,
static const uint64_t P9N2_EX_MIB_XIICAC                                           = 0x10012019ull;

static const uint64_t P9N2_EX_0_MIB_XIICAC                                         = 0x10012019ull;

static const uint64_t P9N2_EX_1_MIB_XIICAC                                         = 0x10012419ull;

static const uint64_t P9N2_EX_2_MIB_XIICAC                                         = 0x11012019ull;

static const uint64_t P9N2_EX_3_MIB_XIICAC                                         = 0x11012419ull;

static const uint64_t P9N2_EX_4_MIB_XIICAC                                         = 0x12012019ull;

static const uint64_t P9N2_EX_5_MIB_XIICAC                                         = 0x12012419ull;

static const uint64_t P9N2_EX_6_MIB_XIICAC                                         = 0x13012019ull;

static const uint64_t P9N2_EX_7_MIB_XIICAC                                         = 0x13012419ull;

static const uint64_t P9N2_EX_8_MIB_XIICAC                                         = 0x14012019ull;

static const uint64_t P9N2_EX_9_MIB_XIICAC                                         = 0x14012419ull;

static const uint64_t P9N2_EX_10_MIB_XIICAC                                        = 0x15012019ull;

static const uint64_t P9N2_EX_11_MIB_XIICAC                                        = 0x15012419ull;


static const uint64_t P9N2_EQ_MIB_XIMEM                                            = 0x10012017ull;
//DUPS: 10012017,
static const uint64_t P9N2_EQ_0_MIB_XIMEM                                          = 0x10012017ull;
//DUPS: 10012017,
static const uint64_t P9N2_EQ_1_MIB_XIMEM                                          = 0x11012017ull;
//DUPS: 11012017,
static const uint64_t P9N2_EQ_2_MIB_XIMEM                                          = 0x12012017ull;
//DUPS: 12012017,
static const uint64_t P9N2_EQ_3_MIB_XIMEM                                          = 0x13012017ull;
//DUPS: 13012017,
static const uint64_t P9N2_EQ_4_MIB_XIMEM                                          = 0x14012017ull;
//DUPS: 14012017,
static const uint64_t P9N2_EQ_5_MIB_XIMEM                                          = 0x15012017ull;
//DUPS: 15012017,
static const uint64_t P9N2_EX_MIB_XIMEM                                            = 0x10012017ull;

static const uint64_t P9N2_EX_0_MIB_XIMEM                                          = 0x10012017ull;

static const uint64_t P9N2_EX_1_MIB_XIMEM                                          = 0x10012417ull;

static const uint64_t P9N2_EX_2_MIB_XIMEM                                          = 0x11012017ull;

static const uint64_t P9N2_EX_3_MIB_XIMEM                                          = 0x11012417ull;

static const uint64_t P9N2_EX_4_MIB_XIMEM                                          = 0x12012017ull;

static const uint64_t P9N2_EX_5_MIB_XIMEM                                          = 0x12012417ull;

static const uint64_t P9N2_EX_6_MIB_XIMEM                                          = 0x13012017ull;

static const uint64_t P9N2_EX_7_MIB_XIMEM                                          = 0x13012417ull;

static const uint64_t P9N2_EX_8_MIB_XIMEM                                          = 0x14012017ull;

static const uint64_t P9N2_EX_9_MIB_XIMEM                                          = 0x14012417ull;

static const uint64_t P9N2_EX_10_MIB_XIMEM                                         = 0x15012017ull;

static const uint64_t P9N2_EX_11_MIB_XIMEM                                         = 0x15012417ull;


static const uint64_t P9N2_EQ_MIB_XISGB                                            = 0x10012018ull;
//DUPS: 10012018,
static const uint64_t P9N2_EQ_0_MIB_XISGB                                          = 0x10012018ull;
//DUPS: 10012018,
static const uint64_t P9N2_EQ_1_MIB_XISGB                                          = 0x11012018ull;
//DUPS: 11012018,
static const uint64_t P9N2_EQ_2_MIB_XISGB                                          = 0x12012018ull;
//DUPS: 12012018,
static const uint64_t P9N2_EQ_3_MIB_XISGB                                          = 0x13012018ull;
//DUPS: 13012018,
static const uint64_t P9N2_EQ_4_MIB_XISGB                                          = 0x14012018ull;
//DUPS: 14012018,
static const uint64_t P9N2_EQ_5_MIB_XISGB                                          = 0x15012018ull;
//DUPS: 15012018,
static const uint64_t P9N2_EX_MIB_XISGB                                            = 0x10012018ull;

static const uint64_t P9N2_EX_0_MIB_XISGB                                          = 0x10012018ull;

static const uint64_t P9N2_EX_1_MIB_XISGB                                          = 0x10012418ull;

static const uint64_t P9N2_EX_2_MIB_XISGB                                          = 0x11012018ull;

static const uint64_t P9N2_EX_3_MIB_XISGB                                          = 0x11012418ull;

static const uint64_t P9N2_EX_4_MIB_XISGB                                          = 0x12012018ull;

static const uint64_t P9N2_EX_5_MIB_XISGB                                          = 0x12012418ull;

static const uint64_t P9N2_EX_6_MIB_XISGB                                          = 0x13012018ull;

static const uint64_t P9N2_EX_7_MIB_XISGB                                          = 0x13012418ull;

static const uint64_t P9N2_EX_8_MIB_XISGB                                          = 0x14012018ull;

static const uint64_t P9N2_EX_9_MIB_XISGB                                          = 0x14012418ull;

static const uint64_t P9N2_EX_10_MIB_XISGB                                         = 0x15012018ull;

static const uint64_t P9N2_EX_11_MIB_XISGB                                         = 0x15012418ull;


static const uint64_t P9N2_C_MODE_REG                                              = 0x20040008ull;

static const uint64_t P9N2_C_0_MODE_REG                                            = 0x20040008ull;

static const uint64_t P9N2_C_1_MODE_REG                                            = 0x21040008ull;

static const uint64_t P9N2_C_2_MODE_REG                                            = 0x22040008ull;

static const uint64_t P9N2_C_3_MODE_REG                                            = 0x23040008ull;

static const uint64_t P9N2_C_4_MODE_REG                                            = 0x24040008ull;

static const uint64_t P9N2_C_5_MODE_REG                                            = 0x25040008ull;

static const uint64_t P9N2_C_6_MODE_REG                                            = 0x26040008ull;

static const uint64_t P9N2_C_7_MODE_REG                                            = 0x27040008ull;

static const uint64_t P9N2_C_8_MODE_REG                                            = 0x28040008ull;

static const uint64_t P9N2_C_9_MODE_REG                                            = 0x29040008ull;

static const uint64_t P9N2_C_10_MODE_REG                                           = 0x2A040008ull;

static const uint64_t P9N2_C_11_MODE_REG                                           = 0x2B040008ull;

static const uint64_t P9N2_C_12_MODE_REG                                           = 0x2C040008ull;

static const uint64_t P9N2_C_13_MODE_REG                                           = 0x2D040008ull;

static const uint64_t P9N2_C_14_MODE_REG                                           = 0x2E040008ull;

static const uint64_t P9N2_C_15_MODE_REG                                           = 0x2F040008ull;

static const uint64_t P9N2_C_16_MODE_REG                                           = 0x30040008ull;

static const uint64_t P9N2_C_17_MODE_REG                                           = 0x31040008ull;

static const uint64_t P9N2_C_18_MODE_REG                                           = 0x32040008ull;

static const uint64_t P9N2_C_19_MODE_REG                                           = 0x33040008ull;

static const uint64_t P9N2_C_20_MODE_REG                                           = 0x34040008ull;

static const uint64_t P9N2_C_21_MODE_REG                                           = 0x35040008ull;

static const uint64_t P9N2_C_22_MODE_REG                                           = 0x36040008ull;

static const uint64_t P9N2_C_23_MODE_REG                                           = 0x37040008ull;

static const uint64_t P9N2_EQ_MODE_REG                                             = 0x10040008ull;

static const uint64_t P9N2_EQ_0_MODE_REG                                           = 0x10040008ull;

static const uint64_t P9N2_EQ_1_MODE_REG                                           = 0x11040008ull;

static const uint64_t P9N2_EQ_2_MODE_REG                                           = 0x12040008ull;

static const uint64_t P9N2_EQ_3_MODE_REG                                           = 0x13040008ull;

static const uint64_t P9N2_EQ_4_MODE_REG                                           = 0x14040008ull;

static const uint64_t P9N2_EQ_5_MODE_REG                                           = 0x15040008ull;

static const uint64_t P9N2_EX_MODE_REG                                             = 0x20040008ull;
//DUPS: 21040008,
static const uint64_t P9N2_EX_0_MODE_REG                                           = 0x20040008ull;
//DUPS: 21040008,
static const uint64_t P9N2_EX_1_MODE_REG                                           = 0x22040008ull;
//DUPS: 23040008,
static const uint64_t P9N2_EX_2_MODE_REG                                           = 0x24040008ull;
//DUPS: 25040008,
static const uint64_t P9N2_EX_3_MODE_REG                                           = 0x26040008ull;
//DUPS: 27040008,
static const uint64_t P9N2_EX_4_MODE_REG                                           = 0x28040008ull;
//DUPS: 29040008,
static const uint64_t P9N2_EX_5_MODE_REG                                           = 0x2A040008ull;
//DUPS: 2B040008,
static const uint64_t P9N2_EX_6_MODE_REG                                           = 0x2C040008ull;
//DUPS: 2D040008,
static const uint64_t P9N2_EX_7_MODE_REG                                           = 0x2F040008ull;
//DUPS: 2F040008,
static const uint64_t P9N2_EX_8_MODE_REG                                           = 0x30040008ull;
//DUPS: 31040008,
static const uint64_t P9N2_EX_9_MODE_REG                                           = 0x32040008ull;
//DUPS: 33040008,
static const uint64_t P9N2_EX_10_MODE_REG                                          = 0x34040008ull;
//DUPS: 35040008,
static const uint64_t P9N2_EX_11_MODE_REG                                          = 0x36040008ull;
//DUPS: 37040008,

static const uint64_t P9N2_EQ_MODE_REG0                                            = 0x10010C0Aull;
//DUPS: 1001182B, 10010C0A, 10011C2B,
static const uint64_t P9N2_EQ_0_MODE_REG0                                          = 0x10010C0Aull;
//DUPS: 1001182B, 10010C0A, 10011C2B,
static const uint64_t P9N2_EQ_1_MODE_REG0                                          = 0x11010C0Aull;
//DUPS: 1101182B, 11010C0A, 11011C2B,
static const uint64_t P9N2_EQ_2_MODE_REG0                                          = 0x12010C0Aull;
//DUPS: 1201182B, 12010C0A, 12011C2B,
static const uint64_t P9N2_EQ_3_MODE_REG0                                          = 0x13010C0Aull;
//DUPS: 1301182B, 13010C0A, 13011C2B,
static const uint64_t P9N2_EQ_4_MODE_REG0                                          = 0x14010C0Aull;
//DUPS: 1401182B, 14010C0A, 14011C2B,
static const uint64_t P9N2_EQ_5_MODE_REG0                                          = 0x15010C0Aull;
//DUPS: 1501182B, 15010C0A, 15011C2B,
static const uint64_t P9N2_EX_0_L2_MODE_REG0                                       = 0x1001080Aull;

static const uint64_t P9N2_EX_0_L3_MODE_REG0                                       = 0x1001182Bull;

static const uint64_t P9N2_EX_10_L2_MODE_REG0                                      = 0x1501080Aull;

static const uint64_t P9N2_EX_10_L3_MODE_REG0                                      = 0x1501182Bull;

static const uint64_t P9N2_EX_11_L2_MODE_REG0                                      = 0x15010C0Aull;

static const uint64_t P9N2_EX_11_L3_MODE_REG0                                      = 0x15011C2Bull;

static const uint64_t P9N2_EX_1_L2_MODE_REG0                                       = 0x10010C0Aull;

static const uint64_t P9N2_EX_1_L3_MODE_REG0                                       = 0x10011C2Bull;

static const uint64_t P9N2_EX_2_L2_MODE_REG0                                       = 0x1101080Aull;

static const uint64_t P9N2_EX_2_L3_MODE_REG0                                       = 0x1101182Bull;

static const uint64_t P9N2_EX_3_L2_MODE_REG0                                       = 0x11010C0Aull;

static const uint64_t P9N2_EX_3_L3_MODE_REG0                                       = 0x11011C2Bull;

static const uint64_t P9N2_EX_4_L2_MODE_REG0                                       = 0x1201080Aull;

static const uint64_t P9N2_EX_4_L3_MODE_REG0                                       = 0x1201182Bull;

static const uint64_t P9N2_EX_5_L2_MODE_REG0                                       = 0x12010C0Aull;

static const uint64_t P9N2_EX_5_L3_MODE_REG0                                       = 0x12011C2Bull;

static const uint64_t P9N2_EX_6_L2_MODE_REG0                                       = 0x1301080Aull;

static const uint64_t P9N2_EX_6_L3_MODE_REG0                                       = 0x1301182Bull;

static const uint64_t P9N2_EX_7_L2_MODE_REG0                                       = 0x13010C0Aull;

static const uint64_t P9N2_EX_7_L3_MODE_REG0                                       = 0x13011C2Bull;

static const uint64_t P9N2_EX_8_L2_MODE_REG0                                       = 0x1401080Aull;

static const uint64_t P9N2_EX_8_L3_MODE_REG0                                       = 0x1401182Bull;

static const uint64_t P9N2_EX_9_L2_MODE_REG0                                       = 0x14010C0Aull;

static const uint64_t P9N2_EX_9_L3_MODE_REG0                                       = 0x14011C2Bull;

static const uint64_t P9N2_EX_L2_MODE_REG0                                         = 0x1001080Aull;

static const uint64_t P9N2_EX_L3_MODE_REG0                                         = 0x1001182Bull;


static const uint64_t P9N2_EQ_MODE_REG1                                            = 0x10010C0Bull;
//DUPS: 1001180A, 10010C0B, 10011C0A,
static const uint64_t P9N2_EQ_0_MODE_REG1                                          = 0x10010C0Bull;
//DUPS: 1001180A, 10010C0B, 10011C0A,
static const uint64_t P9N2_EQ_1_MODE_REG1                                          = 0x11010C0Bull;
//DUPS: 1101180A, 11010C0B, 11011C0A,
static const uint64_t P9N2_EQ_2_MODE_REG1                                          = 0x12010C0Bull;
//DUPS: 1201180A, 12010C0B, 12011C0A,
static const uint64_t P9N2_EQ_3_MODE_REG1                                          = 0x13010C0Bull;
//DUPS: 1301180A, 13010C0B, 13011C0A,
static const uint64_t P9N2_EQ_4_MODE_REG1                                          = 0x14010C0Bull;
//DUPS: 1401180A, 14010C0B, 14011C0A,
static const uint64_t P9N2_EQ_5_MODE_REG1                                          = 0x15010C0Bull;
//DUPS: 1501180A, 15010C0B, 15011C0A,
static const uint64_t P9N2_EX_0_L2_MODE_REG1                                       = 0x1001080Bull;

static const uint64_t P9N2_EX_0_L3_MODE_REG1                                       = 0x1001180Aull;

static const uint64_t P9N2_EX_10_L2_MODE_REG1                                      = 0x1501080Bull;

static const uint64_t P9N2_EX_10_L3_MODE_REG1                                      = 0x1501180Aull;

static const uint64_t P9N2_EX_11_L2_MODE_REG1                                      = 0x15010C0Bull;

static const uint64_t P9N2_EX_11_L3_MODE_REG1                                      = 0x15011C0Aull;

static const uint64_t P9N2_EX_1_L2_MODE_REG1                                       = 0x10010C0Bull;

static const uint64_t P9N2_EX_1_L3_MODE_REG1                                       = 0x10011C0Aull;

static const uint64_t P9N2_EX_2_L2_MODE_REG1                                       = 0x1101080Bull;

static const uint64_t P9N2_EX_2_L3_MODE_REG1                                       = 0x1101180Aull;

static const uint64_t P9N2_EX_3_L2_MODE_REG1                                       = 0x11010C0Bull;

static const uint64_t P9N2_EX_3_L3_MODE_REG1                                       = 0x11011C0Aull;

static const uint64_t P9N2_EX_4_L2_MODE_REG1                                       = 0x1201080Bull;

static const uint64_t P9N2_EX_4_L3_MODE_REG1                                       = 0x1201180Aull;

static const uint64_t P9N2_EX_5_L2_MODE_REG1                                       = 0x12010C0Bull;

static const uint64_t P9N2_EX_5_L3_MODE_REG1                                       = 0x12011C0Aull;

static const uint64_t P9N2_EX_6_L2_MODE_REG1                                       = 0x1301080Bull;

static const uint64_t P9N2_EX_6_L3_MODE_REG1                                       = 0x1301180Aull;

static const uint64_t P9N2_EX_7_L2_MODE_REG1                                       = 0x13010C0Bull;

static const uint64_t P9N2_EX_7_L3_MODE_REG1                                       = 0x13011C0Aull;

static const uint64_t P9N2_EX_8_L2_MODE_REG1                                       = 0x1401080Bull;

static const uint64_t P9N2_EX_8_L3_MODE_REG1                                       = 0x1401180Aull;

static const uint64_t P9N2_EX_9_L2_MODE_REG1                                       = 0x14010C0Bull;

static const uint64_t P9N2_EX_9_L3_MODE_REG1                                       = 0x14011C0Aull;

static const uint64_t P9N2_EX_L2_MODE_REG1                                         = 0x1001080Bull;

static const uint64_t P9N2_EX_L3_MODE_REG1                                         = 0x1001180Aull;


static const uint64_t P9N2_C_MULTICAST_GROUP_1                                     = 0x200F0001ull;

static const uint64_t P9N2_C_0_MULTICAST_GROUP_1                                   = 0x200F0001ull;

static const uint64_t P9N2_C_1_MULTICAST_GROUP_1                                   = 0x210F0001ull;

static const uint64_t P9N2_C_2_MULTICAST_GROUP_1                                   = 0x220F0001ull;

static const uint64_t P9N2_C_3_MULTICAST_GROUP_1                                   = 0x230F0001ull;

static const uint64_t P9N2_C_4_MULTICAST_GROUP_1                                   = 0x240F0001ull;

static const uint64_t P9N2_C_5_MULTICAST_GROUP_1                                   = 0x250F0001ull;

static const uint64_t P9N2_C_6_MULTICAST_GROUP_1                                   = 0x260F0001ull;

static const uint64_t P9N2_C_7_MULTICAST_GROUP_1                                   = 0x270F0001ull;

static const uint64_t P9N2_C_8_MULTICAST_GROUP_1                                   = 0x280F0001ull;

static const uint64_t P9N2_C_9_MULTICAST_GROUP_1                                   = 0x290F0001ull;

static const uint64_t P9N2_C_10_MULTICAST_GROUP_1                                  = 0x2A0F0001ull;

static const uint64_t P9N2_C_11_MULTICAST_GROUP_1                                  = 0x2B0F0001ull;

static const uint64_t P9N2_C_12_MULTICAST_GROUP_1                                  = 0x2C0F0001ull;

static const uint64_t P9N2_C_13_MULTICAST_GROUP_1                                  = 0x2D0F0001ull;

static const uint64_t P9N2_C_14_MULTICAST_GROUP_1                                  = 0x2E0F0001ull;

static const uint64_t P9N2_C_15_MULTICAST_GROUP_1                                  = 0x2F0F0001ull;

static const uint64_t P9N2_C_16_MULTICAST_GROUP_1                                  = 0x300F0001ull;

static const uint64_t P9N2_C_17_MULTICAST_GROUP_1                                  = 0x310F0001ull;

static const uint64_t P9N2_C_18_MULTICAST_GROUP_1                                  = 0x320F0001ull;

static const uint64_t P9N2_C_19_MULTICAST_GROUP_1                                  = 0x330F0001ull;

static const uint64_t P9N2_C_20_MULTICAST_GROUP_1                                  = 0x340F0001ull;

static const uint64_t P9N2_C_21_MULTICAST_GROUP_1                                  = 0x350F0001ull;

static const uint64_t P9N2_C_22_MULTICAST_GROUP_1                                  = 0x360F0001ull;

static const uint64_t P9N2_C_23_MULTICAST_GROUP_1                                  = 0x370F0001ull;

static const uint64_t P9N2_EQ_MULTICAST_GROUP_1                                    = 0x100F0001ull;

static const uint64_t P9N2_EQ_0_MULTICAST_GROUP_1                                  = 0x100F0001ull;

static const uint64_t P9N2_EQ_1_MULTICAST_GROUP_1                                  = 0x110F0001ull;

static const uint64_t P9N2_EQ_2_MULTICAST_GROUP_1                                  = 0x120F0001ull;

static const uint64_t P9N2_EQ_3_MULTICAST_GROUP_1                                  = 0x130F0001ull;

static const uint64_t P9N2_EQ_4_MULTICAST_GROUP_1                                  = 0x140F0001ull;

static const uint64_t P9N2_EQ_5_MULTICAST_GROUP_1                                  = 0x150F0001ull;

static const uint64_t P9N2_EX_MULTICAST_GROUP_1                                    = 0x200F0001ull;
//DUPS: 210F0001,
static const uint64_t P9N2_EX_0_MULTICAST_GROUP_1                                  = 0x200F0001ull;
//DUPS: 210F0001,
static const uint64_t P9N2_EX_1_MULTICAST_GROUP_1                                  = 0x220F0001ull;
//DUPS: 220F0001,
static const uint64_t P9N2_EX_2_MULTICAST_GROUP_1                                  = 0x240F0001ull;
//DUPS: 250F0001,
static const uint64_t P9N2_EX_3_MULTICAST_GROUP_1                                  = 0x260F0001ull;
//DUPS: 270F0001,
static const uint64_t P9N2_EX_4_MULTICAST_GROUP_1                                  = 0x280F0001ull;
//DUPS: 290F0001,
static const uint64_t P9N2_EX_5_MULTICAST_GROUP_1                                  = 0x2A0F0001ull;
//DUPS: 2B0F0001,
static const uint64_t P9N2_EX_6_MULTICAST_GROUP_1                                  = 0x2C0F0001ull;
//DUPS: 2D0F0001,
static const uint64_t P9N2_EX_7_MULTICAST_GROUP_1                                  = 0x2E0F0001ull;
//DUPS: 2F0F0001,
static const uint64_t P9N2_EX_8_MULTICAST_GROUP_1                                  = 0x300F0001ull;
//DUPS: 310F0001,
static const uint64_t P9N2_EX_9_MULTICAST_GROUP_1                                  = 0x320F0001ull;
//DUPS: 330F0001,
static const uint64_t P9N2_EX_10_MULTICAST_GROUP_1                                 = 0x340F0001ull;
//DUPS: 350F0001,
static const uint64_t P9N2_EX_11_MULTICAST_GROUP_1                                 = 0x360F0001ull;
//DUPS: 370F0001,

static const uint64_t P9N2_C_MULTICAST_GROUP_2                                     = 0x200F0002ull;

static const uint64_t P9N2_C_0_MULTICAST_GROUP_2                                   = 0x200F0002ull;

static const uint64_t P9N2_C_1_MULTICAST_GROUP_2                                   = 0x210F0002ull;

static const uint64_t P9N2_C_2_MULTICAST_GROUP_2                                   = 0x220F0002ull;

static const uint64_t P9N2_C_3_MULTICAST_GROUP_2                                   = 0x230F0002ull;

static const uint64_t P9N2_C_4_MULTICAST_GROUP_2                                   = 0x240F0002ull;

static const uint64_t P9N2_C_5_MULTICAST_GROUP_2                                   = 0x250F0002ull;

static const uint64_t P9N2_C_6_MULTICAST_GROUP_2                                   = 0x260F0002ull;

static const uint64_t P9N2_C_7_MULTICAST_GROUP_2                                   = 0x270F0002ull;

static const uint64_t P9N2_C_8_MULTICAST_GROUP_2                                   = 0x280F0002ull;

static const uint64_t P9N2_C_9_MULTICAST_GROUP_2                                   = 0x290F0002ull;

static const uint64_t P9N2_C_10_MULTICAST_GROUP_2                                  = 0x2A0F0002ull;

static const uint64_t P9N2_C_11_MULTICAST_GROUP_2                                  = 0x2B0F0002ull;

static const uint64_t P9N2_C_12_MULTICAST_GROUP_2                                  = 0x2C0F0002ull;

static const uint64_t P9N2_C_13_MULTICAST_GROUP_2                                  = 0x2D0F0002ull;

static const uint64_t P9N2_C_14_MULTICAST_GROUP_2                                  = 0x2E0F0002ull;

static const uint64_t P9N2_C_15_MULTICAST_GROUP_2                                  = 0x2F0F0002ull;

static const uint64_t P9N2_C_16_MULTICAST_GROUP_2                                  = 0x300F0002ull;

static const uint64_t P9N2_C_17_MULTICAST_GROUP_2                                  = 0x310F0002ull;

static const uint64_t P9N2_C_18_MULTICAST_GROUP_2                                  = 0x320F0002ull;

static const uint64_t P9N2_C_19_MULTICAST_GROUP_2                                  = 0x330F0002ull;

static const uint64_t P9N2_C_20_MULTICAST_GROUP_2                                  = 0x340F0002ull;

static const uint64_t P9N2_C_21_MULTICAST_GROUP_2                                  = 0x350F0002ull;

static const uint64_t P9N2_C_22_MULTICAST_GROUP_2                                  = 0x360F0002ull;

static const uint64_t P9N2_C_23_MULTICAST_GROUP_2                                  = 0x370F0002ull;

static const uint64_t P9N2_EQ_MULTICAST_GROUP_2                                    = 0x100F0002ull;

static const uint64_t P9N2_EQ_0_MULTICAST_GROUP_2                                  = 0x100F0002ull;

static const uint64_t P9N2_EQ_1_MULTICAST_GROUP_2                                  = 0x110F0002ull;

static const uint64_t P9N2_EQ_2_MULTICAST_GROUP_2                                  = 0x120F0002ull;

static const uint64_t P9N2_EQ_3_MULTICAST_GROUP_2                                  = 0x130F0002ull;

static const uint64_t P9N2_EQ_4_MULTICAST_GROUP_2                                  = 0x140F0002ull;

static const uint64_t P9N2_EQ_5_MULTICAST_GROUP_2                                  = 0x150F0002ull;

static const uint64_t P9N2_EX_MULTICAST_GROUP_2                                    = 0x200F0002ull;
//DUPS: 210F0002,
static const uint64_t P9N2_EX_0_MULTICAST_GROUP_2                                  = 0x200F0002ull;
//DUPS: 210F0002,
static const uint64_t P9N2_EX_1_MULTICAST_GROUP_2                                  = 0x220F0002ull;
//DUPS: 220F0002,
static const uint64_t P9N2_EX_2_MULTICAST_GROUP_2                                  = 0x240F0002ull;
//DUPS: 250F0002,
static const uint64_t P9N2_EX_3_MULTICAST_GROUP_2                                  = 0x260F0002ull;
//DUPS: 270F0002,
static const uint64_t P9N2_EX_4_MULTICAST_GROUP_2                                  = 0x280F0002ull;
//DUPS: 290F0002,
static const uint64_t P9N2_EX_5_MULTICAST_GROUP_2                                  = 0x2A0F0002ull;
//DUPS: 2B0F0002,
static const uint64_t P9N2_EX_6_MULTICAST_GROUP_2                                  = 0x2C0F0002ull;
//DUPS: 2D0F0002,
static const uint64_t P9N2_EX_7_MULTICAST_GROUP_2                                  = 0x2E0F0002ull;
//DUPS: 2F0F0002,
static const uint64_t P9N2_EX_8_MULTICAST_GROUP_2                                  = 0x300F0002ull;
//DUPS: 310F0002,
static const uint64_t P9N2_EX_9_MULTICAST_GROUP_2                                  = 0x320F0002ull;
//DUPS: 330F0002,
static const uint64_t P9N2_EX_10_MULTICAST_GROUP_2                                 = 0x340F0002ull;
//DUPS: 350F0002,
static const uint64_t P9N2_EX_11_MULTICAST_GROUP_2                                 = 0x360F0002ull;
//DUPS: 370F0002,

static const uint64_t P9N2_C_MULTICAST_GROUP_3                                     = 0x200F0003ull;

static const uint64_t P9N2_C_0_MULTICAST_GROUP_3                                   = 0x200F0003ull;

static const uint64_t P9N2_C_1_MULTICAST_GROUP_3                                   = 0x210F0003ull;

static const uint64_t P9N2_C_2_MULTICAST_GROUP_3                                   = 0x220F0003ull;

static const uint64_t P9N2_C_3_MULTICAST_GROUP_3                                   = 0x230F0003ull;

static const uint64_t P9N2_C_4_MULTICAST_GROUP_3                                   = 0x240F0003ull;

static const uint64_t P9N2_C_5_MULTICAST_GROUP_3                                   = 0x250F0003ull;

static const uint64_t P9N2_C_6_MULTICAST_GROUP_3                                   = 0x260F0003ull;

static const uint64_t P9N2_C_7_MULTICAST_GROUP_3                                   = 0x270F0003ull;

static const uint64_t P9N2_C_8_MULTICAST_GROUP_3                                   = 0x280F0003ull;

static const uint64_t P9N2_C_9_MULTICAST_GROUP_3                                   = 0x290F0003ull;

static const uint64_t P9N2_C_10_MULTICAST_GROUP_3                                  = 0x2A0F0003ull;

static const uint64_t P9N2_C_11_MULTICAST_GROUP_3                                  = 0x2B0F0003ull;

static const uint64_t P9N2_C_12_MULTICAST_GROUP_3                                  = 0x2C0F0003ull;

static const uint64_t P9N2_C_13_MULTICAST_GROUP_3                                  = 0x2D0F0003ull;

static const uint64_t P9N2_C_14_MULTICAST_GROUP_3                                  = 0x2E0F0003ull;

static const uint64_t P9N2_C_15_MULTICAST_GROUP_3                                  = 0x2F0F0003ull;

static const uint64_t P9N2_C_16_MULTICAST_GROUP_3                                  = 0x300F0003ull;

static const uint64_t P9N2_C_17_MULTICAST_GROUP_3                                  = 0x310F0003ull;

static const uint64_t P9N2_C_18_MULTICAST_GROUP_3                                  = 0x320F0003ull;

static const uint64_t P9N2_C_19_MULTICAST_GROUP_3                                  = 0x330F0003ull;

static const uint64_t P9N2_C_20_MULTICAST_GROUP_3                                  = 0x340F0003ull;

static const uint64_t P9N2_C_21_MULTICAST_GROUP_3                                  = 0x350F0003ull;

static const uint64_t P9N2_C_22_MULTICAST_GROUP_3                                  = 0x360F0003ull;

static const uint64_t P9N2_C_23_MULTICAST_GROUP_3                                  = 0x370F0003ull;

static const uint64_t P9N2_EQ_MULTICAST_GROUP_3                                    = 0x100F0003ull;

static const uint64_t P9N2_EQ_0_MULTICAST_GROUP_3                                  = 0x100F0003ull;

static const uint64_t P9N2_EQ_1_MULTICAST_GROUP_3                                  = 0x110F0003ull;

static const uint64_t P9N2_EQ_2_MULTICAST_GROUP_3                                  = 0x120F0003ull;

static const uint64_t P9N2_EQ_3_MULTICAST_GROUP_3                                  = 0x130F0003ull;

static const uint64_t P9N2_EQ_4_MULTICAST_GROUP_3                                  = 0x140F0003ull;

static const uint64_t P9N2_EQ_5_MULTICAST_GROUP_3                                  = 0x150F0003ull;

static const uint64_t P9N2_EX_MULTICAST_GROUP_3                                    = 0x200F0003ull;
//DUPS: 210F0003,
static const uint64_t P9N2_EX_0_MULTICAST_GROUP_3                                  = 0x200F0003ull;
//DUPS: 210F0003,
static const uint64_t P9N2_EX_1_MULTICAST_GROUP_3                                  = 0x220F0003ull;
//DUPS: 220F0003,
static const uint64_t P9N2_EX_2_MULTICAST_GROUP_3                                  = 0x240F0003ull;
//DUPS: 250F0003,
static const uint64_t P9N2_EX_3_MULTICAST_GROUP_3                                  = 0x260F0003ull;
//DUPS: 270F0003,
static const uint64_t P9N2_EX_4_MULTICAST_GROUP_3                                  = 0x280F0003ull;
//DUPS: 290F0003,
static const uint64_t P9N2_EX_5_MULTICAST_GROUP_3                                  = 0x2A0F0003ull;
//DUPS: 2B0F0003,
static const uint64_t P9N2_EX_6_MULTICAST_GROUP_3                                  = 0x2C0F0003ull;
//DUPS: 2D0F0003,
static const uint64_t P9N2_EX_7_MULTICAST_GROUP_3                                  = 0x2E0F0003ull;
//DUPS: 2F0F0003,
static const uint64_t P9N2_EX_8_MULTICAST_GROUP_3                                  = 0x300F0003ull;
//DUPS: 310F0003,
static const uint64_t P9N2_EX_9_MULTICAST_GROUP_3                                  = 0x320F0003ull;
//DUPS: 330F0003,
static const uint64_t P9N2_EX_10_MULTICAST_GROUP_3                                 = 0x340F0003ull;
//DUPS: 350F0003,
static const uint64_t P9N2_EX_11_MULTICAST_GROUP_3                                 = 0x360F0003ull;
//DUPS: 370F0003,

static const uint64_t P9N2_C_MULTICAST_GROUP_4                                     = 0x200F0004ull;

static const uint64_t P9N2_C_0_MULTICAST_GROUP_4                                   = 0x200F0004ull;

static const uint64_t P9N2_C_1_MULTICAST_GROUP_4                                   = 0x210F0004ull;

static const uint64_t P9N2_C_2_MULTICAST_GROUP_4                                   = 0x220F0004ull;

static const uint64_t P9N2_C_3_MULTICAST_GROUP_4                                   = 0x230F0004ull;

static const uint64_t P9N2_C_4_MULTICAST_GROUP_4                                   = 0x240F0004ull;

static const uint64_t P9N2_C_5_MULTICAST_GROUP_4                                   = 0x250F0004ull;

static const uint64_t P9N2_C_6_MULTICAST_GROUP_4                                   = 0x260F0004ull;

static const uint64_t P9N2_C_7_MULTICAST_GROUP_4                                   = 0x270F0004ull;

static const uint64_t P9N2_C_8_MULTICAST_GROUP_4                                   = 0x280F0004ull;

static const uint64_t P9N2_C_9_MULTICAST_GROUP_4                                   = 0x290F0004ull;

static const uint64_t P9N2_C_10_MULTICAST_GROUP_4                                  = 0x2A0F0004ull;

static const uint64_t P9N2_C_11_MULTICAST_GROUP_4                                  = 0x2B0F0004ull;

static const uint64_t P9N2_C_12_MULTICAST_GROUP_4                                  = 0x2C0F0004ull;

static const uint64_t P9N2_C_13_MULTICAST_GROUP_4                                  = 0x2D0F0004ull;

static const uint64_t P9N2_C_14_MULTICAST_GROUP_4                                  = 0x2E0F0004ull;

static const uint64_t P9N2_C_15_MULTICAST_GROUP_4                                  = 0x2F0F0004ull;

static const uint64_t P9N2_C_16_MULTICAST_GROUP_4                                  = 0x300F0004ull;

static const uint64_t P9N2_C_17_MULTICAST_GROUP_4                                  = 0x310F0004ull;

static const uint64_t P9N2_C_18_MULTICAST_GROUP_4                                  = 0x320F0004ull;

static const uint64_t P9N2_C_19_MULTICAST_GROUP_4                                  = 0x330F0004ull;

static const uint64_t P9N2_C_20_MULTICAST_GROUP_4                                  = 0x340F0004ull;

static const uint64_t P9N2_C_21_MULTICAST_GROUP_4                                  = 0x350F0004ull;

static const uint64_t P9N2_C_22_MULTICAST_GROUP_4                                  = 0x360F0004ull;

static const uint64_t P9N2_C_23_MULTICAST_GROUP_4                                  = 0x370F0004ull;

static const uint64_t P9N2_EQ_MULTICAST_GROUP_4                                    = 0x100F0004ull;

static const uint64_t P9N2_EQ_0_MULTICAST_GROUP_4                                  = 0x100F0004ull;

static const uint64_t P9N2_EQ_1_MULTICAST_GROUP_4                                  = 0x110F0004ull;

static const uint64_t P9N2_EQ_2_MULTICAST_GROUP_4                                  = 0x120F0004ull;

static const uint64_t P9N2_EQ_3_MULTICAST_GROUP_4                                  = 0x130F0004ull;

static const uint64_t P9N2_EQ_4_MULTICAST_GROUP_4                                  = 0x140F0004ull;

static const uint64_t P9N2_EQ_5_MULTICAST_GROUP_4                                  = 0x150F0004ull;

static const uint64_t P9N2_EX_MULTICAST_GROUP_4                                    = 0x200F0004ull;
//DUPS: 210F0004,
static const uint64_t P9N2_EX_0_MULTICAST_GROUP_4                                  = 0x200F0004ull;
//DUPS: 210F0004,
static const uint64_t P9N2_EX_1_MULTICAST_GROUP_4                                  = 0x220F0004ull;
//DUPS: 220F0004,
static const uint64_t P9N2_EX_2_MULTICAST_GROUP_4                                  = 0x240F0004ull;
//DUPS: 250F0004,
static const uint64_t P9N2_EX_3_MULTICAST_GROUP_4                                  = 0x260F0004ull;
//DUPS: 270F0004,
static const uint64_t P9N2_EX_4_MULTICAST_GROUP_4                                  = 0x280F0004ull;
//DUPS: 290F0004,
static const uint64_t P9N2_EX_5_MULTICAST_GROUP_4                                  = 0x2A0F0004ull;
//DUPS: 2B0F0004,
static const uint64_t P9N2_EX_6_MULTICAST_GROUP_4                                  = 0x2C0F0004ull;
//DUPS: 2D0F0004,
static const uint64_t P9N2_EX_7_MULTICAST_GROUP_4                                  = 0x2E0F0004ull;
//DUPS: 2F0F0004,
static const uint64_t P9N2_EX_8_MULTICAST_GROUP_4                                  = 0x300F0004ull;
//DUPS: 310F0004,
static const uint64_t P9N2_EX_9_MULTICAST_GROUP_4                                  = 0x320F0004ull;
//DUPS: 330F0004,
static const uint64_t P9N2_EX_10_MULTICAST_GROUP_4                                 = 0x340F0004ull;
//DUPS: 350F0004,
static const uint64_t P9N2_EX_11_MULTICAST_GROUP_4                                 = 0x360F0004ull;
//DUPS: 370F0004,

static const uint64_t P9N2_EQ_NCU_DARN_BAR_REG                                     = 0x10011011ull;
//DUPS: 10011411,
static const uint64_t P9N2_EQ_0_NCU_DARN_BAR_REG                                   = 0x10011011ull;
//DUPS: 10011411,
static const uint64_t P9N2_EQ_1_NCU_DARN_BAR_REG                                   = 0x11011011ull;
//DUPS: 11011411,
static const uint64_t P9N2_EQ_2_NCU_DARN_BAR_REG                                   = 0x12011011ull;
//DUPS: 12011411,
static const uint64_t P9N2_EQ_3_NCU_DARN_BAR_REG                                   = 0x13011011ull;
//DUPS: 13011411,
static const uint64_t P9N2_EQ_4_NCU_DARN_BAR_REG                                   = 0x14011011ull;
//DUPS: 14011411,
static const uint64_t P9N2_EQ_5_NCU_DARN_BAR_REG                                   = 0x15011011ull;
//DUPS: 15011411,
static const uint64_t P9N2_EX_NCU_DARN_BAR_REG                                     = 0x10011011ull;

static const uint64_t P9N2_EX_0_NCU_DARN_BAR_REG                                   = 0x10011011ull;

static const uint64_t P9N2_EX_1_NCU_DARN_BAR_REG                                   = 0x10011411ull;

static const uint64_t P9N2_EX_2_NCU_DARN_BAR_REG                                   = 0x11011011ull;

static const uint64_t P9N2_EX_3_NCU_DARN_BAR_REG                                   = 0x11011411ull;

static const uint64_t P9N2_EX_4_NCU_DARN_BAR_REG                                   = 0x12011011ull;

static const uint64_t P9N2_EX_5_NCU_DARN_BAR_REG                                   = 0x12011411ull;

static const uint64_t P9N2_EX_6_NCU_DARN_BAR_REG                                   = 0x13011011ull;

static const uint64_t P9N2_EX_7_NCU_DARN_BAR_REG                                   = 0x13011411ull;

static const uint64_t P9N2_EX_8_NCU_DARN_BAR_REG                                   = 0x14011011ull;

static const uint64_t P9N2_EX_9_NCU_DARN_BAR_REG                                   = 0x14011411ull;

static const uint64_t P9N2_EX_10_NCU_DARN_BAR_REG                                  = 0x15011011ull;

static const uint64_t P9N2_EX_11_NCU_DARN_BAR_REG                                  = 0x15011411ull;


static const uint64_t P9N2_EQ_NCU_MODE_REG                                         = 0x1001100Aull;
//DUPS: 1001140A,
static const uint64_t P9N2_EQ_0_NCU_MODE_REG                                       = 0x1001100Aull;
//DUPS: 1001140A,
static const uint64_t P9N2_EQ_1_NCU_MODE_REG                                       = 0x1101100Aull;
//DUPS: 1101140A,
static const uint64_t P9N2_EQ_2_NCU_MODE_REG                                       = 0x1201100Aull;
//DUPS: 1201140A,
static const uint64_t P9N2_EQ_3_NCU_MODE_REG                                       = 0x1301100Aull;
//DUPS: 1301140A,
static const uint64_t P9N2_EQ_4_NCU_MODE_REG                                       = 0x1401100Aull;
//DUPS: 1401140A,
static const uint64_t P9N2_EQ_5_NCU_MODE_REG                                       = 0x1501100Aull;
//DUPS: 1501140A,
static const uint64_t P9N2_EX_NCU_MODE_REG                                         = 0x1001100Aull;

static const uint64_t P9N2_EX_0_NCU_MODE_REG                                       = 0x1001100Aull;

static const uint64_t P9N2_EX_1_NCU_MODE_REG                                       = 0x1001140Aull;

static const uint64_t P9N2_EX_2_NCU_MODE_REG                                       = 0x1101100Aull;

static const uint64_t P9N2_EX_3_NCU_MODE_REG                                       = 0x1101140Aull;

static const uint64_t P9N2_EX_4_NCU_MODE_REG                                       = 0x1201100Aull;

static const uint64_t P9N2_EX_5_NCU_MODE_REG                                       = 0x1201140Aull;

static const uint64_t P9N2_EX_6_NCU_MODE_REG                                       = 0x1301100Aull;

static const uint64_t P9N2_EX_7_NCU_MODE_REG                                       = 0x1301140Aull;

static const uint64_t P9N2_EX_8_NCU_MODE_REG                                       = 0x1401100Aull;

static const uint64_t P9N2_EX_9_NCU_MODE_REG                                       = 0x1401140Aull;

static const uint64_t P9N2_EX_10_NCU_MODE_REG                                      = 0x1501100Aull;

static const uint64_t P9N2_EX_11_NCU_MODE_REG                                      = 0x1501140Aull;


static const uint64_t P9N2_EQ_NCU_MODE_REG2                                        = 0x1001100Bull;
//DUPS: 1001140B,
static const uint64_t P9N2_EQ_0_NCU_MODE_REG2                                      = 0x1001100Bull;
//DUPS: 1001140B,
static const uint64_t P9N2_EQ_1_NCU_MODE_REG2                                      = 0x1101100Bull;
//DUPS: 1101140B,
static const uint64_t P9N2_EQ_2_NCU_MODE_REG2                                      = 0x1201100Bull;
//DUPS: 1201140B,
static const uint64_t P9N2_EQ_3_NCU_MODE_REG2                                      = 0x1301100Bull;
//DUPS: 1301140B,
static const uint64_t P9N2_EQ_4_NCU_MODE_REG2                                      = 0x1401100Bull;
//DUPS: 1401140B,
static const uint64_t P9N2_EQ_5_NCU_MODE_REG2                                      = 0x1501100Bull;
//DUPS: 1501140B,
static const uint64_t P9N2_EX_NCU_MODE_REG2                                        = 0x1001100Bull;

static const uint64_t P9N2_EX_0_NCU_MODE_REG2                                      = 0x1001100Bull;

static const uint64_t P9N2_EX_1_NCU_MODE_REG2                                      = 0x1001140Bull;

static const uint64_t P9N2_EX_2_NCU_MODE_REG2                                      = 0x1101100Bull;

static const uint64_t P9N2_EX_3_NCU_MODE_REG2                                      = 0x1101140Bull;

static const uint64_t P9N2_EX_4_NCU_MODE_REG2                                      = 0x1201100Bull;

static const uint64_t P9N2_EX_5_NCU_MODE_REG2                                      = 0x1201140Bull;

static const uint64_t P9N2_EX_6_NCU_MODE_REG2                                      = 0x1301100Bull;

static const uint64_t P9N2_EX_7_NCU_MODE_REG2                                      = 0x1301140Bull;

static const uint64_t P9N2_EX_8_NCU_MODE_REG2                                      = 0x1401100Bull;

static const uint64_t P9N2_EX_9_NCU_MODE_REG2                                      = 0x1401140Bull;

static const uint64_t P9N2_EX_10_NCU_MODE_REG2                                     = 0x1501100Bull;

static const uint64_t P9N2_EX_11_NCU_MODE_REG2                                     = 0x1501140Bull;


static const uint64_t P9N2_EQ_NCU_MODE_REG3                                        = 0x1001100Cull;
//DUPS: 1001140C,
static const uint64_t P9N2_EQ_0_NCU_MODE_REG3                                      = 0x1001100Cull;
//DUPS: 1001140C,
static const uint64_t P9N2_EQ_1_NCU_MODE_REG3                                      = 0x1101100Cull;
//DUPS: 1101140C,
static const uint64_t P9N2_EQ_2_NCU_MODE_REG3                                      = 0x1201100Cull;
//DUPS: 1201140C,
static const uint64_t P9N2_EQ_3_NCU_MODE_REG3                                      = 0x1301100Cull;
//DUPS: 1301140C,
static const uint64_t P9N2_EQ_4_NCU_MODE_REG3                                      = 0x1401100Cull;
//DUPS: 1401140C,
static const uint64_t P9N2_EQ_5_NCU_MODE_REG3                                      = 0x1501100Cull;
//DUPS: 1501140C,
static const uint64_t P9N2_EX_NCU_MODE_REG3                                        = 0x1001100Cull;

static const uint64_t P9N2_EX_0_NCU_MODE_REG3                                      = 0x1001100Cull;

static const uint64_t P9N2_EX_1_NCU_MODE_REG3                                      = 0x1001140Cull;

static const uint64_t P9N2_EX_2_NCU_MODE_REG3                                      = 0x1101100Cull;

static const uint64_t P9N2_EX_3_NCU_MODE_REG3                                      = 0x1101140Cull;

static const uint64_t P9N2_EX_4_NCU_MODE_REG3                                      = 0x1201100Cull;

static const uint64_t P9N2_EX_5_NCU_MODE_REG3                                      = 0x1201140Cull;

static const uint64_t P9N2_EX_6_NCU_MODE_REG3                                      = 0x1301100Cull;

static const uint64_t P9N2_EX_7_NCU_MODE_REG3                                      = 0x1301140Cull;

static const uint64_t P9N2_EX_8_NCU_MODE_REG3                                      = 0x1401100Cull;

static const uint64_t P9N2_EX_9_NCU_MODE_REG3                                      = 0x1401140Cull;

static const uint64_t P9N2_EX_10_NCU_MODE_REG3                                     = 0x1501100Cull;

static const uint64_t P9N2_EX_11_NCU_MODE_REG3                                     = 0x1501140Cull;


static const uint64_t P9N2_EQ_NCU_SLOW_LPAR_REG0                                   = 0x10011012ull;
//DUPS: 10011412,
static const uint64_t P9N2_EQ_0_NCU_SLOW_LPAR_REG0                                 = 0x10011012ull;
//DUPS: 10011412,
static const uint64_t P9N2_EQ_1_NCU_SLOW_LPAR_REG0                                 = 0x11011012ull;
//DUPS: 11011412,
static const uint64_t P9N2_EQ_2_NCU_SLOW_LPAR_REG0                                 = 0x12011012ull;
//DUPS: 12011412,
static const uint64_t P9N2_EQ_3_NCU_SLOW_LPAR_REG0                                 = 0x13011012ull;
//DUPS: 13011412,
static const uint64_t P9N2_EQ_4_NCU_SLOW_LPAR_REG0                                 = 0x14011012ull;
//DUPS: 14011412,
static const uint64_t P9N2_EQ_5_NCU_SLOW_LPAR_REG0                                 = 0x15011012ull;
//DUPS: 15011412,
static const uint64_t P9N2_EX_NCU_SLOW_LPAR_REG0                                   = 0x10011012ull;

static const uint64_t P9N2_EX_0_NCU_SLOW_LPAR_REG0                                 = 0x10011012ull;

static const uint64_t P9N2_EX_1_NCU_SLOW_LPAR_REG0                                 = 0x10011412ull;

static const uint64_t P9N2_EX_2_NCU_SLOW_LPAR_REG0                                 = 0x11011012ull;

static const uint64_t P9N2_EX_3_NCU_SLOW_LPAR_REG0                                 = 0x11011412ull;

static const uint64_t P9N2_EX_4_NCU_SLOW_LPAR_REG0                                 = 0x12011012ull;

static const uint64_t P9N2_EX_5_NCU_SLOW_LPAR_REG0                                 = 0x12011412ull;

static const uint64_t P9N2_EX_6_NCU_SLOW_LPAR_REG0                                 = 0x13011012ull;

static const uint64_t P9N2_EX_7_NCU_SLOW_LPAR_REG0                                 = 0x13011412ull;

static const uint64_t P9N2_EX_8_NCU_SLOW_LPAR_REG0                                 = 0x14011012ull;

static const uint64_t P9N2_EX_9_NCU_SLOW_LPAR_REG0                                 = 0x14011412ull;

static const uint64_t P9N2_EX_10_NCU_SLOW_LPAR_REG0                                = 0x15011012ull;

static const uint64_t P9N2_EX_11_NCU_SLOW_LPAR_REG0                                = 0x15011412ull;


static const uint64_t P9N2_EQ_NCU_SLOW_LPAR_REG1                                   = 0x10011013ull;
//DUPS: 10011413,
static const uint64_t P9N2_EQ_0_NCU_SLOW_LPAR_REG1                                 = 0x10011013ull;
//DUPS: 10011413,
static const uint64_t P9N2_EQ_1_NCU_SLOW_LPAR_REG1                                 = 0x11011013ull;
//DUPS: 11011413,
static const uint64_t P9N2_EQ_2_NCU_SLOW_LPAR_REG1                                 = 0x12011013ull;
//DUPS: 12011413,
static const uint64_t P9N2_EQ_3_NCU_SLOW_LPAR_REG1                                 = 0x13011013ull;
//DUPS: 13011413,
static const uint64_t P9N2_EQ_4_NCU_SLOW_LPAR_REG1                                 = 0x14011013ull;
//DUPS: 14011413,
static const uint64_t P9N2_EQ_5_NCU_SLOW_LPAR_REG1                                 = 0x15011013ull;
//DUPS: 15011413,
static const uint64_t P9N2_EX_NCU_SLOW_LPAR_REG1                                   = 0x10011013ull;

static const uint64_t P9N2_EX_0_NCU_SLOW_LPAR_REG1                                 = 0x10011013ull;

static const uint64_t P9N2_EX_1_NCU_SLOW_LPAR_REG1                                 = 0x10011413ull;

static const uint64_t P9N2_EX_2_NCU_SLOW_LPAR_REG1                                 = 0x11011013ull;

static const uint64_t P9N2_EX_3_NCU_SLOW_LPAR_REG1                                 = 0x11011413ull;

static const uint64_t P9N2_EX_4_NCU_SLOW_LPAR_REG1                                 = 0x12011013ull;

static const uint64_t P9N2_EX_5_NCU_SLOW_LPAR_REG1                                 = 0x12011413ull;

static const uint64_t P9N2_EX_6_NCU_SLOW_LPAR_REG1                                 = 0x13011013ull;

static const uint64_t P9N2_EX_7_NCU_SLOW_LPAR_REG1                                 = 0x13011413ull;

static const uint64_t P9N2_EX_8_NCU_SLOW_LPAR_REG1                                 = 0x14011013ull;

static const uint64_t P9N2_EX_9_NCU_SLOW_LPAR_REG1                                 = 0x14011413ull;

static const uint64_t P9N2_EX_10_NCU_SLOW_LPAR_REG1                                = 0x15011013ull;

static const uint64_t P9N2_EX_11_NCU_SLOW_LPAR_REG1                                = 0x15011413ull;


static const uint64_t P9N2_EQ_NCU_SPEC_BAR_REG                                     = 0x10011010ull;
//DUPS: 10011410,
static const uint64_t P9N2_EQ_0_NCU_SPEC_BAR_REG                                   = 0x10011010ull;
//DUPS: 10011410,
static const uint64_t P9N2_EQ_1_NCU_SPEC_BAR_REG                                   = 0x11011010ull;
//DUPS: 11011410,
static const uint64_t P9N2_EQ_2_NCU_SPEC_BAR_REG                                   = 0x12011010ull;
//DUPS: 12011410,
static const uint64_t P9N2_EQ_3_NCU_SPEC_BAR_REG                                   = 0x13011010ull;
//DUPS: 13011410,
static const uint64_t P9N2_EQ_4_NCU_SPEC_BAR_REG                                   = 0x14011010ull;
//DUPS: 14011410,
static const uint64_t P9N2_EQ_5_NCU_SPEC_BAR_REG                                   = 0x15011010ull;
//DUPS: 15011410,
static const uint64_t P9N2_EX_NCU_SPEC_BAR_REG                                     = 0x10011010ull;

static const uint64_t P9N2_EX_0_NCU_SPEC_BAR_REG                                   = 0x10011010ull;

static const uint64_t P9N2_EX_1_NCU_SPEC_BAR_REG                                   = 0x10011410ull;

static const uint64_t P9N2_EX_2_NCU_SPEC_BAR_REG                                   = 0x11011010ull;

static const uint64_t P9N2_EX_3_NCU_SPEC_BAR_REG                                   = 0x11011410ull;

static const uint64_t P9N2_EX_4_NCU_SPEC_BAR_REG                                   = 0x12011010ull;

static const uint64_t P9N2_EX_5_NCU_SPEC_BAR_REG                                   = 0x12011410ull;

static const uint64_t P9N2_EX_6_NCU_SPEC_BAR_REG                                   = 0x13011010ull;

static const uint64_t P9N2_EX_7_NCU_SPEC_BAR_REG                                   = 0x13011410ull;

static const uint64_t P9N2_EX_8_NCU_SPEC_BAR_REG                                   = 0x14011010ull;

static const uint64_t P9N2_EX_9_NCU_SPEC_BAR_REG                                   = 0x14011410ull;

static const uint64_t P9N2_EX_10_NCU_SPEC_BAR_REG                                  = 0x15011010ull;

static const uint64_t P9N2_EX_11_NCU_SPEC_BAR_REG                                  = 0x15011410ull;


static const uint64_t P9N2_EQ_NCU_STATUS_REG                                       = 0x1001100Full;
//DUPS: 1001140F,
static const uint64_t P9N2_EQ_0_NCU_STATUS_REG                                     = 0x1001100Full;
//DUPS: 1001140F,
static const uint64_t P9N2_EQ_1_NCU_STATUS_REG                                     = 0x1101100Full;
//DUPS: 1101140F,
static const uint64_t P9N2_EQ_2_NCU_STATUS_REG                                     = 0x1201100Full;
//DUPS: 1201140F,
static const uint64_t P9N2_EQ_3_NCU_STATUS_REG                                     = 0x1301100Full;
//DUPS: 1301140F,
static const uint64_t P9N2_EQ_4_NCU_STATUS_REG                                     = 0x1401100Full;
//DUPS: 1401140F,
static const uint64_t P9N2_EQ_5_NCU_STATUS_REG                                     = 0x1501100Full;
//DUPS: 1501140F,
static const uint64_t P9N2_EX_NCU_STATUS_REG                                       = 0x1001100Full;

static const uint64_t P9N2_EX_0_NCU_STATUS_REG                                     = 0x1001100Full;

static const uint64_t P9N2_EX_1_NCU_STATUS_REG                                     = 0x1001140Full;

static const uint64_t P9N2_EX_2_NCU_STATUS_REG                                     = 0x1101100Full;

static const uint64_t P9N2_EX_3_NCU_STATUS_REG                                     = 0x1101140Full;

static const uint64_t P9N2_EX_4_NCU_STATUS_REG                                     = 0x1201100Full;

static const uint64_t P9N2_EX_5_NCU_STATUS_REG                                     = 0x1201140Full;

static const uint64_t P9N2_EX_6_NCU_STATUS_REG                                     = 0x1301100Full;

static const uint64_t P9N2_EX_7_NCU_STATUS_REG                                     = 0x1301140Full;

static const uint64_t P9N2_EX_8_NCU_STATUS_REG                                     = 0x1401100Full;

static const uint64_t P9N2_EX_9_NCU_STATUS_REG                                     = 0x1401140Full;

static const uint64_t P9N2_EX_10_NCU_STATUS_REG                                    = 0x1501100Full;

static const uint64_t P9N2_EX_11_NCU_STATUS_REG                                    = 0x1501140Full;


static const uint64_t P9N2_C_NET_CTRL0                                             = 0x200F0040ull;

static const uint64_t P9N2_C_NET_CTRL0_WAND                                        = 0x200F0041ull;

static const uint64_t P9N2_C_NET_CTRL0_WOR                                         = 0x200F0042ull;

static const uint64_t P9N2_C_0_NET_CTRL0                                           = 0x200F0040ull;

static const uint64_t P9N2_C_0_NET_CTRL0_WAND                                      = 0x200F0041ull;

static const uint64_t P9N2_C_0_NET_CTRL0_WOR                                       = 0x200F0042ull;

static const uint64_t P9N2_C_1_NET_CTRL0                                           = 0x210F0040ull;

static const uint64_t P9N2_C_1_NET_CTRL0_WAND                                      = 0x210F0041ull;

static const uint64_t P9N2_C_1_NET_CTRL0_WOR                                       = 0x210F0042ull;

static const uint64_t P9N2_C_2_NET_CTRL0                                           = 0x220F0040ull;

static const uint64_t P9N2_C_2_NET_CTRL0_WAND                                      = 0x220F0041ull;

static const uint64_t P9N2_C_2_NET_CTRL0_WOR                                       = 0x220F0042ull;

static const uint64_t P9N2_C_3_NET_CTRL0                                           = 0x230F0040ull;

static const uint64_t P9N2_C_3_NET_CTRL0_WAND                                      = 0x230F0041ull;

static const uint64_t P9N2_C_3_NET_CTRL0_WOR                                       = 0x230F0042ull;

static const uint64_t P9N2_C_4_NET_CTRL0                                           = 0x240F0040ull;

static const uint64_t P9N2_C_4_NET_CTRL0_WAND                                      = 0x240F0041ull;

static const uint64_t P9N2_C_4_NET_CTRL0_WOR                                       = 0x240F0042ull;

static const uint64_t P9N2_C_5_NET_CTRL0                                           = 0x250F0040ull;

static const uint64_t P9N2_C_5_NET_CTRL0_WAND                                      = 0x250F0041ull;

static const uint64_t P9N2_C_5_NET_CTRL0_WOR                                       = 0x250F0042ull;

static const uint64_t P9N2_C_6_NET_CTRL0                                           = 0x260F0040ull;

static const uint64_t P9N2_C_6_NET_CTRL0_WAND                                      = 0x260F0041ull;

static const uint64_t P9N2_C_6_NET_CTRL0_WOR                                       = 0x260F0042ull;

static const uint64_t P9N2_C_7_NET_CTRL0                                           = 0x270F0040ull;

static const uint64_t P9N2_C_7_NET_CTRL0_WAND                                      = 0x270F0041ull;

static const uint64_t P9N2_C_7_NET_CTRL0_WOR                                       = 0x270F0042ull;

static const uint64_t P9N2_C_8_NET_CTRL0                                           = 0x280F0040ull;

static const uint64_t P9N2_C_8_NET_CTRL0_WAND                                      = 0x280F0041ull;

static const uint64_t P9N2_C_8_NET_CTRL0_WOR                                       = 0x280F0042ull;

static const uint64_t P9N2_C_9_NET_CTRL0                                           = 0x290F0040ull;

static const uint64_t P9N2_C_9_NET_CTRL0_WAND                                      = 0x290F0041ull;

static const uint64_t P9N2_C_9_NET_CTRL0_WOR                                       = 0x290F0042ull;

static const uint64_t P9N2_C_10_NET_CTRL0                                          = 0x2A0F0040ull;

static const uint64_t P9N2_C_10_NET_CTRL0_WAND                                     = 0x2A0F0041ull;

static const uint64_t P9N2_C_10_NET_CTRL0_WOR                                      = 0x2A0F0042ull;

static const uint64_t P9N2_C_11_NET_CTRL0                                          = 0x2B0F0040ull;

static const uint64_t P9N2_C_11_NET_CTRL0_WAND                                     = 0x2B0F0041ull;

static const uint64_t P9N2_C_11_NET_CTRL0_WOR                                      = 0x2B0F0042ull;

static const uint64_t P9N2_C_12_NET_CTRL0                                          = 0x2C0F0040ull;

static const uint64_t P9N2_C_12_NET_CTRL0_WAND                                     = 0x2C0F0041ull;

static const uint64_t P9N2_C_12_NET_CTRL0_WOR                                      = 0x2C0F0042ull;

static const uint64_t P9N2_C_13_NET_CTRL0                                          = 0x2D0F0040ull;

static const uint64_t P9N2_C_13_NET_CTRL0_WAND                                     = 0x2D0F0041ull;

static const uint64_t P9N2_C_13_NET_CTRL0_WOR                                      = 0x2D0F0042ull;

static const uint64_t P9N2_C_14_NET_CTRL0                                          = 0x2E0F0040ull;

static const uint64_t P9N2_C_14_NET_CTRL0_WAND                                     = 0x2E0F0041ull;

static const uint64_t P9N2_C_14_NET_CTRL0_WOR                                      = 0x2E0F0042ull;

static const uint64_t P9N2_C_15_NET_CTRL0                                          = 0x2F0F0040ull;

static const uint64_t P9N2_C_15_NET_CTRL0_WAND                                     = 0x2F0F0041ull;

static const uint64_t P9N2_C_15_NET_CTRL0_WOR                                      = 0x2F0F0042ull;

static const uint64_t P9N2_C_16_NET_CTRL0                                          = 0x300F0040ull;

static const uint64_t P9N2_C_16_NET_CTRL0_WAND                                     = 0x300F0041ull;

static const uint64_t P9N2_C_16_NET_CTRL0_WOR                                      = 0x300F0042ull;

static const uint64_t P9N2_C_17_NET_CTRL0                                          = 0x310F0040ull;

static const uint64_t P9N2_C_17_NET_CTRL0_WAND                                     = 0x310F0041ull;

static const uint64_t P9N2_C_17_NET_CTRL0_WOR                                      = 0x310F0042ull;

static const uint64_t P9N2_C_18_NET_CTRL0                                          = 0x320F0040ull;

static const uint64_t P9N2_C_18_NET_CTRL0_WAND                                     = 0x320F0041ull;

static const uint64_t P9N2_C_18_NET_CTRL0_WOR                                      = 0x320F0042ull;

static const uint64_t P9N2_C_19_NET_CTRL0                                          = 0x330F0040ull;

static const uint64_t P9N2_C_19_NET_CTRL0_WAND                                     = 0x330F0041ull;

static const uint64_t P9N2_C_19_NET_CTRL0_WOR                                      = 0x330F0042ull;

static const uint64_t P9N2_C_20_NET_CTRL0                                          = 0x340F0040ull;

static const uint64_t P9N2_C_20_NET_CTRL0_WAND                                     = 0x340F0041ull;

static const uint64_t P9N2_C_20_NET_CTRL0_WOR                                      = 0x340F0042ull;

static const uint64_t P9N2_C_21_NET_CTRL0                                          = 0x350F0040ull;

static const uint64_t P9N2_C_21_NET_CTRL0_WAND                                     = 0x350F0041ull;

static const uint64_t P9N2_C_21_NET_CTRL0_WOR                                      = 0x350F0042ull;

static const uint64_t P9N2_C_22_NET_CTRL0                                          = 0x360F0040ull;

static const uint64_t P9N2_C_22_NET_CTRL0_WAND                                     = 0x360F0041ull;

static const uint64_t P9N2_C_22_NET_CTRL0_WOR                                      = 0x360F0042ull;

static const uint64_t P9N2_C_23_NET_CTRL0                                          = 0x370F0040ull;

static const uint64_t P9N2_C_23_NET_CTRL0_WAND                                     = 0x370F0041ull;

static const uint64_t P9N2_C_23_NET_CTRL0_WOR                                      = 0x370F0042ull;

static const uint64_t P9N2_EQ_NET_CTRL0                                            = 0x100F0040ull;

static const uint64_t P9N2_EQ_NET_CTRL0_WAND                                       = 0x100F0041ull;

static const uint64_t P9N2_EQ_NET_CTRL0_WOR                                        = 0x100F0042ull;

static const uint64_t P9N2_EQ_0_NET_CTRL0                                          = 0x100F0040ull;

static const uint64_t P9N2_EQ_0_NET_CTRL0_WAND                                     = 0x100F0041ull;

static const uint64_t P9N2_EQ_0_NET_CTRL0_WOR                                      = 0x100F0042ull;

static const uint64_t P9N2_EQ_1_NET_CTRL0                                          = 0x110F0040ull;

static const uint64_t P9N2_EQ_1_NET_CTRL0_WAND                                     = 0x110F0041ull;

static const uint64_t P9N2_EQ_1_NET_CTRL0_WOR                                      = 0x110F0042ull;

static const uint64_t P9N2_EQ_2_NET_CTRL0                                          = 0x120F0040ull;

static const uint64_t P9N2_EQ_2_NET_CTRL0_WAND                                     = 0x120F0041ull;

static const uint64_t P9N2_EQ_2_NET_CTRL0_WOR                                      = 0x120F0042ull;

static const uint64_t P9N2_EQ_3_NET_CTRL0                                          = 0x130F0040ull;

static const uint64_t P9N2_EQ_3_NET_CTRL0_WAND                                     = 0x130F0041ull;

static const uint64_t P9N2_EQ_3_NET_CTRL0_WOR                                      = 0x130F0042ull;

static const uint64_t P9N2_EQ_4_NET_CTRL0                                          = 0x140F0040ull;

static const uint64_t P9N2_EQ_4_NET_CTRL0_WAND                                     = 0x140F0041ull;

static const uint64_t P9N2_EQ_4_NET_CTRL0_WOR                                      = 0x140F0042ull;

static const uint64_t P9N2_EQ_5_NET_CTRL0                                          = 0x150F0040ull;

static const uint64_t P9N2_EQ_5_NET_CTRL0_WAND                                     = 0x150F0041ull;

static const uint64_t P9N2_EQ_5_NET_CTRL0_WOR                                      = 0x150F0042ull;

static const uint64_t P9N2_EX_NET_CTRL0                                            = 0x200F0040ull;
//DUPS: 210F0040,
static const uint64_t P9N2_EX_NET_CTRL0_WAND                                       = 0x200F0041ull;
//DUPS: 210F0041,
static const uint64_t P9N2_EX_NET_CTRL0_WOR                                        = 0x200F0042ull;
//DUPS: 210F0042,
static const uint64_t P9N2_EX_0_NET_CTRL0                                          = 0x200F0040ull;
//DUPS: 210F0040,
static const uint64_t P9N2_EX_0_NET_CTRL0_WAND                                     = 0x200F0041ull;
//DUPS: 210F0041,
static const uint64_t P9N2_EX_0_NET_CTRL0_WOR                                      = 0x200F0042ull;
//DUPS: 210F0042,
static const uint64_t P9N2_EX_1_NET_CTRL0                                          = 0x220F0040ull;
//DUPS: 220F0040,
static const uint64_t P9N2_EX_1_NET_CTRL0_WAND                                     = 0x220F0041ull;
//DUPS: 220F0041,
static const uint64_t P9N2_EX_1_NET_CTRL0_WOR                                      = 0x220F0042ull;
//DUPS: 220F0042,
static const uint64_t P9N2_EX_2_NET_CTRL0                                          = 0x240F0040ull;
//DUPS: 250F0040,
static const uint64_t P9N2_EX_2_NET_CTRL0_WAND                                     = 0x240F0041ull;
//DUPS: 250F0041,
static const uint64_t P9N2_EX_2_NET_CTRL0_WOR                                      = 0x240F0042ull;
//DUPS: 250F0042,
static const uint64_t P9N2_EX_3_NET_CTRL0                                          = 0x260F0040ull;
//DUPS: 270F0040,
static const uint64_t P9N2_EX_3_NET_CTRL0_WAND                                     = 0x260F0041ull;
//DUPS: 270F0041,
static const uint64_t P9N2_EX_3_NET_CTRL0_WOR                                      = 0x260F0042ull;
//DUPS: 270F0042,
static const uint64_t P9N2_EX_4_NET_CTRL0                                          = 0x280F0040ull;
//DUPS: 290F0040,
static const uint64_t P9N2_EX_4_NET_CTRL0_WAND                                     = 0x280F0041ull;
//DUPS: 290F0041,
static const uint64_t P9N2_EX_4_NET_CTRL0_WOR                                      = 0x280F0042ull;
//DUPS: 290F0042,
static const uint64_t P9N2_EX_5_NET_CTRL0                                          = 0x2A0F0040ull;
//DUPS: 2B0F0040,
static const uint64_t P9N2_EX_5_NET_CTRL0_WAND                                     = 0x2A0F0041ull;
//DUPS: 2B0F0041,
static const uint64_t P9N2_EX_5_NET_CTRL0_WOR                                      = 0x2A0F0042ull;
//DUPS: 2B0F0042,
static const uint64_t P9N2_EX_6_NET_CTRL0                                          = 0x2C0F0040ull;
//DUPS: 2D0F0040,
static const uint64_t P9N2_EX_6_NET_CTRL0_WAND                                     = 0x2C0F0041ull;
//DUPS: 2D0F0041,
static const uint64_t P9N2_EX_6_NET_CTRL0_WOR                                      = 0x2C0F0042ull;
//DUPS: 2D0F0042,
static const uint64_t P9N2_EX_7_NET_CTRL0                                          = 0x2E0F0040ull;
//DUPS: 2F0F0040,
static const uint64_t P9N2_EX_7_NET_CTRL0_WAND                                     = 0x2E0F0041ull;
//DUPS: 2F0F0041,
static const uint64_t P9N2_EX_7_NET_CTRL0_WOR                                      = 0x2E0F0042ull;
//DUPS: 2F0F0042,
static const uint64_t P9N2_EX_8_NET_CTRL0                                          = 0x300F0040ull;
//DUPS: 310F0040,
static const uint64_t P9N2_EX_8_NET_CTRL0_WAND                                     = 0x300F0041ull;
//DUPS: 310F0041,
static const uint64_t P9N2_EX_8_NET_CTRL0_WOR                                      = 0x300F0042ull;
//DUPS: 310F0042,
static const uint64_t P9N2_EX_9_NET_CTRL0                                          = 0x320F0040ull;
//DUPS: 330F0040,
static const uint64_t P9N2_EX_9_NET_CTRL0_WAND                                     = 0x320F0041ull;
//DUPS: 330F0041,
static const uint64_t P9N2_EX_9_NET_CTRL0_WOR                                      = 0x320F0042ull;
//DUPS: 330F0042,
static const uint64_t P9N2_EX_10_NET_CTRL0                                         = 0x340F0040ull;
//DUPS: 350F0040,
static const uint64_t P9N2_EX_10_NET_CTRL0_WAND                                    = 0x340F0041ull;
//DUPS: 350F0041,
static const uint64_t P9N2_EX_10_NET_CTRL0_WOR                                     = 0x340F0042ull;
//DUPS: 350F0042,
static const uint64_t P9N2_EX_11_NET_CTRL0                                         = 0x360F0040ull;
//DUPS: 370F0040,
static const uint64_t P9N2_EX_11_NET_CTRL0_WAND                                    = 0x360F0041ull;
//DUPS: 370F0041,
static const uint64_t P9N2_EX_11_NET_CTRL0_WOR                                     = 0x360F0042ull;
//DUPS: 370F0042,

static const uint64_t P9N2_C_NET_CTRL1                                             = 0x200F0044ull;

static const uint64_t P9N2_C_NET_CTRL1_WAND                                        = 0x200F0045ull;

static const uint64_t P9N2_C_NET_CTRL1_WOR                                         = 0x200F0046ull;

static const uint64_t P9N2_C_0_NET_CTRL1                                           = 0x200F0044ull;

static const uint64_t P9N2_C_0_NET_CTRL1_WAND                                      = 0x200F0045ull;

static const uint64_t P9N2_C_0_NET_CTRL1_WOR                                       = 0x200F0046ull;

static const uint64_t P9N2_C_1_NET_CTRL1                                           = 0x210F0044ull;

static const uint64_t P9N2_C_1_NET_CTRL1_WAND                                      = 0x210F0045ull;

static const uint64_t P9N2_C_1_NET_CTRL1_WOR                                       = 0x210F0046ull;

static const uint64_t P9N2_C_2_NET_CTRL1                                           = 0x220F0044ull;

static const uint64_t P9N2_C_2_NET_CTRL1_WAND                                      = 0x220F0045ull;

static const uint64_t P9N2_C_2_NET_CTRL1_WOR                                       = 0x220F0046ull;

static const uint64_t P9N2_C_3_NET_CTRL1                                           = 0x230F0044ull;

static const uint64_t P9N2_C_3_NET_CTRL1_WAND                                      = 0x230F0045ull;

static const uint64_t P9N2_C_3_NET_CTRL1_WOR                                       = 0x230F0046ull;

static const uint64_t P9N2_C_4_NET_CTRL1                                           = 0x240F0044ull;

static const uint64_t P9N2_C_4_NET_CTRL1_WAND                                      = 0x240F0045ull;

static const uint64_t P9N2_C_4_NET_CTRL1_WOR                                       = 0x240F0046ull;

static const uint64_t P9N2_C_5_NET_CTRL1                                           = 0x250F0044ull;

static const uint64_t P9N2_C_5_NET_CTRL1_WAND                                      = 0x250F0045ull;

static const uint64_t P9N2_C_5_NET_CTRL1_WOR                                       = 0x250F0046ull;

static const uint64_t P9N2_C_6_NET_CTRL1                                           = 0x260F0044ull;

static const uint64_t P9N2_C_6_NET_CTRL1_WAND                                      = 0x260F0045ull;

static const uint64_t P9N2_C_6_NET_CTRL1_WOR                                       = 0x260F0046ull;

static const uint64_t P9N2_C_7_NET_CTRL1                                           = 0x270F0044ull;

static const uint64_t P9N2_C_7_NET_CTRL1_WAND                                      = 0x270F0045ull;

static const uint64_t P9N2_C_7_NET_CTRL1_WOR                                       = 0x270F0046ull;

static const uint64_t P9N2_C_8_NET_CTRL1                                           = 0x280F0044ull;

static const uint64_t P9N2_C_8_NET_CTRL1_WAND                                      = 0x280F0045ull;

static const uint64_t P9N2_C_8_NET_CTRL1_WOR                                       = 0x280F0046ull;

static const uint64_t P9N2_C_9_NET_CTRL1                                           = 0x290F0044ull;

static const uint64_t P9N2_C_9_NET_CTRL1_WAND                                      = 0x290F0045ull;

static const uint64_t P9N2_C_9_NET_CTRL1_WOR                                       = 0x290F0046ull;

static const uint64_t P9N2_C_10_NET_CTRL1                                          = 0x2A0F0044ull;

static const uint64_t P9N2_C_10_NET_CTRL1_WAND                                     = 0x2A0F0045ull;

static const uint64_t P9N2_C_10_NET_CTRL1_WOR                                      = 0x2A0F0046ull;

static const uint64_t P9N2_C_11_NET_CTRL1                                          = 0x2B0F0044ull;

static const uint64_t P9N2_C_11_NET_CTRL1_WAND                                     = 0x2B0F0045ull;

static const uint64_t P9N2_C_11_NET_CTRL1_WOR                                      = 0x2B0F0046ull;

static const uint64_t P9N2_C_12_NET_CTRL1                                          = 0x2C0F0044ull;

static const uint64_t P9N2_C_12_NET_CTRL1_WAND                                     = 0x2C0F0045ull;

static const uint64_t P9N2_C_12_NET_CTRL1_WOR                                      = 0x2C0F0046ull;

static const uint64_t P9N2_C_13_NET_CTRL1                                          = 0x2D0F0044ull;

static const uint64_t P9N2_C_13_NET_CTRL1_WAND                                     = 0x2D0F0045ull;

static const uint64_t P9N2_C_13_NET_CTRL1_WOR                                      = 0x2D0F0046ull;

static const uint64_t P9N2_C_14_NET_CTRL1                                          = 0x2E0F0044ull;

static const uint64_t P9N2_C_14_NET_CTRL1_WAND                                     = 0x2E0F0045ull;

static const uint64_t P9N2_C_14_NET_CTRL1_WOR                                      = 0x2E0F0046ull;

static const uint64_t P9N2_C_15_NET_CTRL1                                          = 0x2F0F0044ull;

static const uint64_t P9N2_C_15_NET_CTRL1_WAND                                     = 0x2F0F0045ull;

static const uint64_t P9N2_C_15_NET_CTRL1_WOR                                      = 0x2F0F0046ull;

static const uint64_t P9N2_C_16_NET_CTRL1                                          = 0x300F0044ull;

static const uint64_t P9N2_C_16_NET_CTRL1_WAND                                     = 0x300F0045ull;

static const uint64_t P9N2_C_16_NET_CTRL1_WOR                                      = 0x300F0046ull;

static const uint64_t P9N2_C_17_NET_CTRL1                                          = 0x310F0044ull;

static const uint64_t P9N2_C_17_NET_CTRL1_WAND                                     = 0x310F0045ull;

static const uint64_t P9N2_C_17_NET_CTRL1_WOR                                      = 0x310F0046ull;

static const uint64_t P9N2_C_18_NET_CTRL1                                          = 0x320F0044ull;

static const uint64_t P9N2_C_18_NET_CTRL1_WAND                                     = 0x320F0045ull;

static const uint64_t P9N2_C_18_NET_CTRL1_WOR                                      = 0x320F0046ull;

static const uint64_t P9N2_C_19_NET_CTRL1                                          = 0x330F0044ull;

static const uint64_t P9N2_C_19_NET_CTRL1_WAND                                     = 0x330F0045ull;

static const uint64_t P9N2_C_19_NET_CTRL1_WOR                                      = 0x330F0046ull;

static const uint64_t P9N2_C_20_NET_CTRL1                                          = 0x340F0044ull;

static const uint64_t P9N2_C_20_NET_CTRL1_WAND                                     = 0x340F0045ull;

static const uint64_t P9N2_C_20_NET_CTRL1_WOR                                      = 0x340F0046ull;

static const uint64_t P9N2_C_21_NET_CTRL1                                          = 0x350F0044ull;

static const uint64_t P9N2_C_21_NET_CTRL1_WAND                                     = 0x350F0045ull;

static const uint64_t P9N2_C_21_NET_CTRL1_WOR                                      = 0x350F0046ull;

static const uint64_t P9N2_C_22_NET_CTRL1                                          = 0x360F0044ull;

static const uint64_t P9N2_C_22_NET_CTRL1_WAND                                     = 0x360F0045ull;

static const uint64_t P9N2_C_22_NET_CTRL1_WOR                                      = 0x360F0046ull;

static const uint64_t P9N2_C_23_NET_CTRL1                                          = 0x370F0044ull;

static const uint64_t P9N2_C_23_NET_CTRL1_WAND                                     = 0x370F0045ull;

static const uint64_t P9N2_C_23_NET_CTRL1_WOR                                      = 0x370F0046ull;

static const uint64_t P9N2_EQ_NET_CTRL1                                            = 0x100F0044ull;

static const uint64_t P9N2_EQ_NET_CTRL1_WAND                                       = 0x100F0045ull;

static const uint64_t P9N2_EQ_NET_CTRL1_WOR                                        = 0x100F0046ull;

static const uint64_t P9N2_EQ_0_NET_CTRL1                                          = 0x100F0044ull;

static const uint64_t P9N2_EQ_0_NET_CTRL1_WAND                                     = 0x100F0045ull;

static const uint64_t P9N2_EQ_0_NET_CTRL1_WOR                                      = 0x100F0046ull;

static const uint64_t P9N2_EQ_1_NET_CTRL1                                          = 0x110F0044ull;

static const uint64_t P9N2_EQ_1_NET_CTRL1_WAND                                     = 0x110F0045ull;

static const uint64_t P9N2_EQ_1_NET_CTRL1_WOR                                      = 0x110F0046ull;

static const uint64_t P9N2_EQ_2_NET_CTRL1                                          = 0x120F0044ull;

static const uint64_t P9N2_EQ_2_NET_CTRL1_WAND                                     = 0x120F0045ull;

static const uint64_t P9N2_EQ_2_NET_CTRL1_WOR                                      = 0x120F0046ull;

static const uint64_t P9N2_EQ_3_NET_CTRL1                                          = 0x130F0044ull;

static const uint64_t P9N2_EQ_3_NET_CTRL1_WAND                                     = 0x130F0045ull;

static const uint64_t P9N2_EQ_3_NET_CTRL1_WOR                                      = 0x130F0046ull;

static const uint64_t P9N2_EQ_4_NET_CTRL1                                          = 0x140F0044ull;

static const uint64_t P9N2_EQ_4_NET_CTRL1_WAND                                     = 0x140F0045ull;

static const uint64_t P9N2_EQ_4_NET_CTRL1_WOR                                      = 0x140F0046ull;

static const uint64_t P9N2_EQ_5_NET_CTRL1                                          = 0x150F0044ull;

static const uint64_t P9N2_EQ_5_NET_CTRL1_WAND                                     = 0x150F0045ull;

static const uint64_t P9N2_EQ_5_NET_CTRL1_WOR                                      = 0x150F0046ull;

static const uint64_t P9N2_EX_NET_CTRL1                                            = 0x200F0044ull;
//DUPS: 210F0044,
static const uint64_t P9N2_EX_NET_CTRL1_WAND                                       = 0x200F0045ull;
//DUPS: 210F0045,
static const uint64_t P9N2_EX_NET_CTRL1_WOR                                        = 0x200F0046ull;
//DUPS: 210F0046,
static const uint64_t P9N2_EX_0_NET_CTRL1                                          = 0x200F0044ull;
//DUPS: 210F0044,
static const uint64_t P9N2_EX_0_NET_CTRL1_WAND                                     = 0x200F0045ull;
//DUPS: 210F0045,
static const uint64_t P9N2_EX_0_NET_CTRL1_WOR                                      = 0x200F0046ull;
//DUPS: 210F0046,
static const uint64_t P9N2_EX_1_NET_CTRL1                                          = 0x220F0044ull;
//DUPS: 220F0044,
static const uint64_t P9N2_EX_1_NET_CTRL1_WAND                                     = 0x220F0045ull;
//DUPS: 220F0045,
static const uint64_t P9N2_EX_1_NET_CTRL1_WOR                                      = 0x220F0046ull;
//DUPS: 220F0046,
static const uint64_t P9N2_EX_2_NET_CTRL1                                          = 0x240F0044ull;
//DUPS: 250F0044,
static const uint64_t P9N2_EX_2_NET_CTRL1_WAND                                     = 0x240F0045ull;
//DUPS: 250F0045,
static const uint64_t P9N2_EX_2_NET_CTRL1_WOR                                      = 0x240F0046ull;
//DUPS: 250F0046,
static const uint64_t P9N2_EX_3_NET_CTRL1                                          = 0x260F0044ull;
//DUPS: 270F0044,
static const uint64_t P9N2_EX_3_NET_CTRL1_WAND                                     = 0x260F0045ull;
//DUPS: 270F0045,
static const uint64_t P9N2_EX_3_NET_CTRL1_WOR                                      = 0x260F0046ull;
//DUPS: 270F0046,
static const uint64_t P9N2_EX_4_NET_CTRL1                                          = 0x280F0044ull;
//DUPS: 290F0044,
static const uint64_t P9N2_EX_4_NET_CTRL1_WAND                                     = 0x280F0045ull;
//DUPS: 290F0045,
static const uint64_t P9N2_EX_4_NET_CTRL1_WOR                                      = 0x280F0046ull;
//DUPS: 290F0046,
static const uint64_t P9N2_EX_5_NET_CTRL1                                          = 0x2A0F0044ull;
//DUPS: 2B0F0044,
static const uint64_t P9N2_EX_5_NET_CTRL1_WAND                                     = 0x2A0F0045ull;
//DUPS: 2B0F0045,
static const uint64_t P9N2_EX_5_NET_CTRL1_WOR                                      = 0x2A0F0046ull;
//DUPS: 2B0F0046,
static const uint64_t P9N2_EX_6_NET_CTRL1                                          = 0x2C0F0044ull;
//DUPS: 2D0F0044,
static const uint64_t P9N2_EX_6_NET_CTRL1_WAND                                     = 0x2C0F0045ull;
//DUPS: 2D0F0045,
static const uint64_t P9N2_EX_6_NET_CTRL1_WOR                                      = 0x2C0F0046ull;
//DUPS: 2D0F0046,
static const uint64_t P9N2_EX_7_NET_CTRL1                                          = 0x2E0F0044ull;
//DUPS: 2F0F0044,
static const uint64_t P9N2_EX_7_NET_CTRL1_WAND                                     = 0x2E0F0045ull;
//DUPS: 2F0F0045,
static const uint64_t P9N2_EX_7_NET_CTRL1_WOR                                      = 0x2E0F0046ull;
//DUPS: 2F0F0046,
static const uint64_t P9N2_EX_8_NET_CTRL1                                          = 0x300F0044ull;
//DUPS: 310F0044,
static const uint64_t P9N2_EX_8_NET_CTRL1_WAND                                     = 0x300F0045ull;
//DUPS: 310F0045,
static const uint64_t P9N2_EX_8_NET_CTRL1_WOR                                      = 0x300F0046ull;
//DUPS: 310F0046,
static const uint64_t P9N2_EX_9_NET_CTRL1                                          = 0x320F0044ull;
//DUPS: 330F0044,
static const uint64_t P9N2_EX_9_NET_CTRL1_WAND                                     = 0x320F0045ull;
//DUPS: 330F0045,
static const uint64_t P9N2_EX_9_NET_CTRL1_WOR                                      = 0x320F0046ull;
//DUPS: 330F0046,
static const uint64_t P9N2_EX_10_NET_CTRL1                                         = 0x340F0044ull;
//DUPS: 350F0044,
static const uint64_t P9N2_EX_10_NET_CTRL1_WAND                                    = 0x340F0045ull;
//DUPS: 350F0045,
static const uint64_t P9N2_EX_10_NET_CTRL1_WOR                                     = 0x340F0046ull;
//DUPS: 350F0046,
static const uint64_t P9N2_EX_11_NET_CTRL1                                         = 0x360F0044ull;
//DUPS: 370F0044,
static const uint64_t P9N2_EX_11_NET_CTRL1_WAND                                    = 0x360F0045ull;
//DUPS: 370F0045,
static const uint64_t P9N2_EX_11_NET_CTRL1_WOR                                     = 0x360F0046ull;
//DUPS: 370F0046,

static const uint64_t P9N2_C_OCC_SCOMC                                             = 0x20010A82ull;

static const uint64_t P9N2_C_0_OCC_SCOMC                                           = 0x20010A82ull;

static const uint64_t P9N2_C_1_OCC_SCOMC                                           = 0x21010A82ull;

static const uint64_t P9N2_C_2_OCC_SCOMC                                           = 0x22010A82ull;

static const uint64_t P9N2_C_3_OCC_SCOMC                                           = 0x23010A82ull;

static const uint64_t P9N2_C_4_OCC_SCOMC                                           = 0x24010A82ull;

static const uint64_t P9N2_C_5_OCC_SCOMC                                           = 0x25010A82ull;

static const uint64_t P9N2_C_6_OCC_SCOMC                                           = 0x26010A82ull;

static const uint64_t P9N2_C_7_OCC_SCOMC                                           = 0x27010A82ull;

static const uint64_t P9N2_C_8_OCC_SCOMC                                           = 0x28010A82ull;

static const uint64_t P9N2_C_9_OCC_SCOMC                                           = 0x29010A82ull;

static const uint64_t P9N2_C_10_OCC_SCOMC                                          = 0x2A010A82ull;

static const uint64_t P9N2_C_11_OCC_SCOMC                                          = 0x2B010A82ull;

static const uint64_t P9N2_C_12_OCC_SCOMC                                          = 0x2C010A82ull;

static const uint64_t P9N2_C_13_OCC_SCOMC                                          = 0x2D010A82ull;

static const uint64_t P9N2_C_14_OCC_SCOMC                                          = 0x2E010A82ull;

static const uint64_t P9N2_C_15_OCC_SCOMC                                          = 0x2F010A82ull;

static const uint64_t P9N2_C_16_OCC_SCOMC                                          = 0x30010A82ull;

static const uint64_t P9N2_C_17_OCC_SCOMC                                          = 0x31010A82ull;

static const uint64_t P9N2_C_18_OCC_SCOMC                                          = 0x32010A82ull;

static const uint64_t P9N2_C_19_OCC_SCOMC                                          = 0x33010A82ull;

static const uint64_t P9N2_C_20_OCC_SCOMC                                          = 0x34010A82ull;

static const uint64_t P9N2_C_21_OCC_SCOMC                                          = 0x35010A82ull;

static const uint64_t P9N2_C_22_OCC_SCOMC                                          = 0x36010A82ull;

static const uint64_t P9N2_C_23_OCC_SCOMC                                          = 0x37010A82ull;

static const uint64_t P9N2_EX_0_L2_OCC_SCOMC                                       = 0x20010A82ull;
//DUPS: 20010A82,
static const uint64_t P9N2_EX_10_L2_OCC_SCOMC                                      = 0x34010A82ull;
//DUPS: 34010A82,
static const uint64_t P9N2_EX_11_L2_OCC_SCOMC                                      = 0x36010A82ull;
//DUPS: 36010A82,
static const uint64_t P9N2_EX_1_L2_OCC_SCOMC                                       = 0x22010A82ull;
//DUPS: 22010A82,
static const uint64_t P9N2_EX_2_L2_OCC_SCOMC                                       = 0x24010A82ull;
//DUPS: 24010A82,
static const uint64_t P9N2_EX_3_L2_OCC_SCOMC                                       = 0x26010A82ull;
//DUPS: 26010A82,
static const uint64_t P9N2_EX_4_L2_OCC_SCOMC                                       = 0x28010A82ull;
//DUPS: 28010A82,
static const uint64_t P9N2_EX_5_L2_OCC_SCOMC                                       = 0x2B010A82ull;
//DUPS: 2A010A82,
static const uint64_t P9N2_EX_6_L2_OCC_SCOMC                                       = 0x2D010A82ull;
//DUPS: 2C010A82,
static const uint64_t P9N2_EX_7_L2_OCC_SCOMC                                       = 0x2F010A82ull;
//DUPS: 2E010A82,
static const uint64_t P9N2_EX_8_L2_OCC_SCOMC                                       = 0x30010A82ull;
//DUPS: 30010A82,
static const uint64_t P9N2_EX_9_L2_OCC_SCOMC                                       = 0x32010A82ull;
//DUPS: 32010A82,
static const uint64_t P9N2_EX_L2_OCC_SCOMC                                         = 0x20010A82ull;
//DUPS: 20010A82,

static const uint64_t P9N2_C_OCC_SCOMD                                             = 0x20010A83ull;

static const uint64_t P9N2_C_0_OCC_SCOMD                                           = 0x20010A83ull;

static const uint64_t P9N2_C_1_OCC_SCOMD                                           = 0x21010A83ull;

static const uint64_t P9N2_C_2_OCC_SCOMD                                           = 0x22010A83ull;

static const uint64_t P9N2_C_3_OCC_SCOMD                                           = 0x23010A83ull;

static const uint64_t P9N2_C_4_OCC_SCOMD                                           = 0x24010A83ull;

static const uint64_t P9N2_C_5_OCC_SCOMD                                           = 0x25010A83ull;

static const uint64_t P9N2_C_6_OCC_SCOMD                                           = 0x26010A83ull;

static const uint64_t P9N2_C_7_OCC_SCOMD                                           = 0x27010A83ull;

static const uint64_t P9N2_C_8_OCC_SCOMD                                           = 0x28010A83ull;

static const uint64_t P9N2_C_9_OCC_SCOMD                                           = 0x29010A83ull;

static const uint64_t P9N2_C_10_OCC_SCOMD                                          = 0x2A010A83ull;

static const uint64_t P9N2_C_11_OCC_SCOMD                                          = 0x2B010A83ull;

static const uint64_t P9N2_C_12_OCC_SCOMD                                          = 0x2C010A83ull;

static const uint64_t P9N2_C_13_OCC_SCOMD                                          = 0x2D010A83ull;

static const uint64_t P9N2_C_14_OCC_SCOMD                                          = 0x2E010A83ull;

static const uint64_t P9N2_C_15_OCC_SCOMD                                          = 0x2F010A83ull;

static const uint64_t P9N2_C_16_OCC_SCOMD                                          = 0x30010A83ull;

static const uint64_t P9N2_C_17_OCC_SCOMD                                          = 0x31010A83ull;

static const uint64_t P9N2_C_18_OCC_SCOMD                                          = 0x32010A83ull;

static const uint64_t P9N2_C_19_OCC_SCOMD                                          = 0x33010A83ull;

static const uint64_t P9N2_C_20_OCC_SCOMD                                          = 0x34010A83ull;

static const uint64_t P9N2_C_21_OCC_SCOMD                                          = 0x35010A83ull;

static const uint64_t P9N2_C_22_OCC_SCOMD                                          = 0x36010A83ull;

static const uint64_t P9N2_C_23_OCC_SCOMD                                          = 0x37010A83ull;

static const uint64_t P9N2_EX_0_L2_OCC_SCOMD                                       = 0x20010A83ull;
//DUPS: 20010A83,
static const uint64_t P9N2_EX_10_L2_OCC_SCOMD                                      = 0x34010A83ull;
//DUPS: 34010A83,
static const uint64_t P9N2_EX_11_L2_OCC_SCOMD                                      = 0x36010A83ull;
//DUPS: 36010A83,
static const uint64_t P9N2_EX_1_L2_OCC_SCOMD                                       = 0x22010A83ull;
//DUPS: 22010A83,
static const uint64_t P9N2_EX_2_L2_OCC_SCOMD                                       = 0x24010A83ull;
//DUPS: 24010A83,
static const uint64_t P9N2_EX_3_L2_OCC_SCOMD                                       = 0x26010A83ull;
//DUPS: 26010A83,
static const uint64_t P9N2_EX_4_L2_OCC_SCOMD                                       = 0x28010A83ull;
//DUPS: 28010A83,
static const uint64_t P9N2_EX_5_L2_OCC_SCOMD                                       = 0x2B010A83ull;
//DUPS: 2A010A83,
static const uint64_t P9N2_EX_6_L2_OCC_SCOMD                                       = 0x2D010A83ull;
//DUPS: 2C010A83,
static const uint64_t P9N2_EX_7_L2_OCC_SCOMD                                       = 0x2F010A83ull;
//DUPS: 2E010A83,
static const uint64_t P9N2_EX_8_L2_OCC_SCOMD                                       = 0x30010A83ull;
//DUPS: 30010A83,
static const uint64_t P9N2_EX_9_L2_OCC_SCOMD                                       = 0x32010A83ull;
//DUPS: 32010A83,
static const uint64_t P9N2_EX_L2_OCC_SCOMD                                         = 0x20010A83ull;
//DUPS: 20010A83,

static const uint64_t P9N2_C_OPCG_ALIGN                                            = 0x20030001ull;

static const uint64_t P9N2_C_0_OPCG_ALIGN                                          = 0x20030001ull;

static const uint64_t P9N2_C_1_OPCG_ALIGN                                          = 0x21030001ull;

static const uint64_t P9N2_C_2_OPCG_ALIGN                                          = 0x22030001ull;

static const uint64_t P9N2_C_3_OPCG_ALIGN                                          = 0x23030001ull;

static const uint64_t P9N2_C_4_OPCG_ALIGN                                          = 0x24030001ull;

static const uint64_t P9N2_C_5_OPCG_ALIGN                                          = 0x25030001ull;

static const uint64_t P9N2_C_6_OPCG_ALIGN                                          = 0x26030001ull;

static const uint64_t P9N2_C_7_OPCG_ALIGN                                          = 0x27030001ull;

static const uint64_t P9N2_C_8_OPCG_ALIGN                                          = 0x28030001ull;

static const uint64_t P9N2_C_9_OPCG_ALIGN                                          = 0x29030001ull;

static const uint64_t P9N2_C_10_OPCG_ALIGN                                         = 0x2A030001ull;

static const uint64_t P9N2_C_11_OPCG_ALIGN                                         = 0x2B030001ull;

static const uint64_t P9N2_C_12_OPCG_ALIGN                                         = 0x2C030001ull;

static const uint64_t P9N2_C_13_OPCG_ALIGN                                         = 0x2D030001ull;

static const uint64_t P9N2_C_14_OPCG_ALIGN                                         = 0x2E030001ull;

static const uint64_t P9N2_C_15_OPCG_ALIGN                                         = 0x2F030001ull;

static const uint64_t P9N2_C_16_OPCG_ALIGN                                         = 0x30030001ull;

static const uint64_t P9N2_C_17_OPCG_ALIGN                                         = 0x31030001ull;

static const uint64_t P9N2_C_18_OPCG_ALIGN                                         = 0x32030001ull;

static const uint64_t P9N2_C_19_OPCG_ALIGN                                         = 0x33030001ull;

static const uint64_t P9N2_C_20_OPCG_ALIGN                                         = 0x34030001ull;

static const uint64_t P9N2_C_21_OPCG_ALIGN                                         = 0x35030001ull;

static const uint64_t P9N2_C_22_OPCG_ALIGN                                         = 0x36030001ull;

static const uint64_t P9N2_C_23_OPCG_ALIGN                                         = 0x37030001ull;

static const uint64_t P9N2_EQ_OPCG_ALIGN                                           = 0x10030001ull;

static const uint64_t P9N2_EQ_0_OPCG_ALIGN                                         = 0x10030001ull;

static const uint64_t P9N2_EQ_1_OPCG_ALIGN                                         = 0x11030001ull;

static const uint64_t P9N2_EQ_2_OPCG_ALIGN                                         = 0x12030001ull;

static const uint64_t P9N2_EQ_3_OPCG_ALIGN                                         = 0x13030001ull;

static const uint64_t P9N2_EQ_4_OPCG_ALIGN                                         = 0x14030001ull;

static const uint64_t P9N2_EQ_5_OPCG_ALIGN                                         = 0x15030001ull;

static const uint64_t P9N2_EX_OPCG_ALIGN                                           = 0x20030001ull;
//DUPS: 21030001,
static const uint64_t P9N2_EX_0_OPCG_ALIGN                                         = 0x20030001ull;
//DUPS: 21030001,
static const uint64_t P9N2_EX_1_OPCG_ALIGN                                         = 0x22030001ull;
//DUPS: 23030001,
static const uint64_t P9N2_EX_2_OPCG_ALIGN                                         = 0x24030001ull;
//DUPS: 25030001,
static const uint64_t P9N2_EX_3_OPCG_ALIGN                                         = 0x26030001ull;
//DUPS: 27030001,
static const uint64_t P9N2_EX_4_OPCG_ALIGN                                         = 0x28030001ull;
//DUPS: 29030001,
static const uint64_t P9N2_EX_5_OPCG_ALIGN                                         = 0x2A030001ull;
//DUPS: 2B030001,
static const uint64_t P9N2_EX_6_OPCG_ALIGN                                         = 0x2C030001ull;
//DUPS: 2D030001,
static const uint64_t P9N2_EX_7_OPCG_ALIGN                                         = 0x2F030001ull;
//DUPS: 2F030001,
static const uint64_t P9N2_EX_8_OPCG_ALIGN                                         = 0x30030001ull;
//DUPS: 31030001,
static const uint64_t P9N2_EX_9_OPCG_ALIGN                                         = 0x32030001ull;
//DUPS: 33030001,
static const uint64_t P9N2_EX_10_OPCG_ALIGN                                        = 0x34030001ull;
//DUPS: 35030001,
static const uint64_t P9N2_EX_11_OPCG_ALIGN                                        = 0x36030001ull;
//DUPS: 37030001,

static const uint64_t P9N2_C_OPCG_CAPT1                                            = 0x20030010ull;

static const uint64_t P9N2_C_0_OPCG_CAPT1                                          = 0x20030010ull;

static const uint64_t P9N2_C_1_OPCG_CAPT1                                          = 0x21030010ull;

static const uint64_t P9N2_C_2_OPCG_CAPT1                                          = 0x22030010ull;

static const uint64_t P9N2_C_3_OPCG_CAPT1                                          = 0x23030010ull;

static const uint64_t P9N2_C_4_OPCG_CAPT1                                          = 0x24030010ull;

static const uint64_t P9N2_C_5_OPCG_CAPT1                                          = 0x25030010ull;

static const uint64_t P9N2_C_6_OPCG_CAPT1                                          = 0x26030010ull;

static const uint64_t P9N2_C_7_OPCG_CAPT1                                          = 0x27030010ull;

static const uint64_t P9N2_C_8_OPCG_CAPT1                                          = 0x28030010ull;

static const uint64_t P9N2_C_9_OPCG_CAPT1                                          = 0x29030010ull;

static const uint64_t P9N2_C_10_OPCG_CAPT1                                         = 0x2A030010ull;

static const uint64_t P9N2_C_11_OPCG_CAPT1                                         = 0x2B030010ull;

static const uint64_t P9N2_C_12_OPCG_CAPT1                                         = 0x2C030010ull;

static const uint64_t P9N2_C_13_OPCG_CAPT1                                         = 0x2D030010ull;

static const uint64_t P9N2_C_14_OPCG_CAPT1                                         = 0x2E030010ull;

static const uint64_t P9N2_C_15_OPCG_CAPT1                                         = 0x2F030010ull;

static const uint64_t P9N2_C_16_OPCG_CAPT1                                         = 0x30030010ull;

static const uint64_t P9N2_C_17_OPCG_CAPT1                                         = 0x31030010ull;

static const uint64_t P9N2_C_18_OPCG_CAPT1                                         = 0x32030010ull;

static const uint64_t P9N2_C_19_OPCG_CAPT1                                         = 0x33030010ull;

static const uint64_t P9N2_C_20_OPCG_CAPT1                                         = 0x34030010ull;

static const uint64_t P9N2_C_21_OPCG_CAPT1                                         = 0x35030010ull;

static const uint64_t P9N2_C_22_OPCG_CAPT1                                         = 0x36030010ull;

static const uint64_t P9N2_C_23_OPCG_CAPT1                                         = 0x37030010ull;

static const uint64_t P9N2_EQ_OPCG_CAPT1                                           = 0x10030010ull;

static const uint64_t P9N2_EQ_0_OPCG_CAPT1                                         = 0x10030010ull;

static const uint64_t P9N2_EQ_1_OPCG_CAPT1                                         = 0x11030010ull;

static const uint64_t P9N2_EQ_2_OPCG_CAPT1                                         = 0x12030010ull;

static const uint64_t P9N2_EQ_3_OPCG_CAPT1                                         = 0x13030010ull;

static const uint64_t P9N2_EQ_4_OPCG_CAPT1                                         = 0x14030010ull;

static const uint64_t P9N2_EQ_5_OPCG_CAPT1                                         = 0x15030010ull;

static const uint64_t P9N2_EX_OPCG_CAPT1                                           = 0x20030010ull;
//DUPS: 21030010,
static const uint64_t P9N2_EX_0_OPCG_CAPT1                                         = 0x20030010ull;
//DUPS: 21030010,
static const uint64_t P9N2_EX_1_OPCG_CAPT1                                         = 0x22030010ull;
//DUPS: 23030010,
static const uint64_t P9N2_EX_2_OPCG_CAPT1                                         = 0x24030010ull;
//DUPS: 25030010,
static const uint64_t P9N2_EX_3_OPCG_CAPT1                                         = 0x26030010ull;
//DUPS: 27030010,
static const uint64_t P9N2_EX_4_OPCG_CAPT1                                         = 0x28030010ull;
//DUPS: 29030010,
static const uint64_t P9N2_EX_5_OPCG_CAPT1                                         = 0x2A030010ull;
//DUPS: 2B030010,
static const uint64_t P9N2_EX_6_OPCG_CAPT1                                         = 0x2C030010ull;
//DUPS: 2D030010,
static const uint64_t P9N2_EX_7_OPCG_CAPT1                                         = 0x2F030010ull;
//DUPS: 2F030010,
static const uint64_t P9N2_EX_8_OPCG_CAPT1                                         = 0x30030010ull;
//DUPS: 31030010,
static const uint64_t P9N2_EX_9_OPCG_CAPT1                                         = 0x32030010ull;
//DUPS: 33030010,
static const uint64_t P9N2_EX_10_OPCG_CAPT1                                        = 0x34030010ull;
//DUPS: 35030010,
static const uint64_t P9N2_EX_11_OPCG_CAPT1                                        = 0x36030010ull;
//DUPS: 37030010,

static const uint64_t P9N2_C_OPCG_CAPT2                                            = 0x20030011ull;

static const uint64_t P9N2_C_0_OPCG_CAPT2                                          = 0x20030011ull;

static const uint64_t P9N2_C_1_OPCG_CAPT2                                          = 0x21030011ull;

static const uint64_t P9N2_C_2_OPCG_CAPT2                                          = 0x22030011ull;

static const uint64_t P9N2_C_3_OPCG_CAPT2                                          = 0x23030011ull;

static const uint64_t P9N2_C_4_OPCG_CAPT2                                          = 0x24030011ull;

static const uint64_t P9N2_C_5_OPCG_CAPT2                                          = 0x25030011ull;

static const uint64_t P9N2_C_6_OPCG_CAPT2                                          = 0x26030011ull;

static const uint64_t P9N2_C_7_OPCG_CAPT2                                          = 0x27030011ull;

static const uint64_t P9N2_C_8_OPCG_CAPT2                                          = 0x28030011ull;

static const uint64_t P9N2_C_9_OPCG_CAPT2                                          = 0x29030011ull;

static const uint64_t P9N2_C_10_OPCG_CAPT2                                         = 0x2A030011ull;

static const uint64_t P9N2_C_11_OPCG_CAPT2                                         = 0x2B030011ull;

static const uint64_t P9N2_C_12_OPCG_CAPT2                                         = 0x2C030011ull;

static const uint64_t P9N2_C_13_OPCG_CAPT2                                         = 0x2D030011ull;

static const uint64_t P9N2_C_14_OPCG_CAPT2                                         = 0x2E030011ull;

static const uint64_t P9N2_C_15_OPCG_CAPT2                                         = 0x2F030011ull;

static const uint64_t P9N2_C_16_OPCG_CAPT2                                         = 0x30030011ull;

static const uint64_t P9N2_C_17_OPCG_CAPT2                                         = 0x31030011ull;

static const uint64_t P9N2_C_18_OPCG_CAPT2                                         = 0x32030011ull;

static const uint64_t P9N2_C_19_OPCG_CAPT2                                         = 0x33030011ull;

static const uint64_t P9N2_C_20_OPCG_CAPT2                                         = 0x34030011ull;

static const uint64_t P9N2_C_21_OPCG_CAPT2                                         = 0x35030011ull;

static const uint64_t P9N2_C_22_OPCG_CAPT2                                         = 0x36030011ull;

static const uint64_t P9N2_C_23_OPCG_CAPT2                                         = 0x37030011ull;

static const uint64_t P9N2_EQ_OPCG_CAPT2                                           = 0x10030011ull;

static const uint64_t P9N2_EQ_0_OPCG_CAPT2                                         = 0x10030011ull;

static const uint64_t P9N2_EQ_1_OPCG_CAPT2                                         = 0x11030011ull;

static const uint64_t P9N2_EQ_2_OPCG_CAPT2                                         = 0x12030011ull;

static const uint64_t P9N2_EQ_3_OPCG_CAPT2                                         = 0x13030011ull;

static const uint64_t P9N2_EQ_4_OPCG_CAPT2                                         = 0x14030011ull;

static const uint64_t P9N2_EQ_5_OPCG_CAPT2                                         = 0x15030011ull;

static const uint64_t P9N2_EX_OPCG_CAPT2                                           = 0x20030011ull;
//DUPS: 21030011,
static const uint64_t P9N2_EX_0_OPCG_CAPT2                                         = 0x20030011ull;
//DUPS: 21030011,
static const uint64_t P9N2_EX_1_OPCG_CAPT2                                         = 0x22030011ull;
//DUPS: 23030011,
static const uint64_t P9N2_EX_2_OPCG_CAPT2                                         = 0x24030011ull;
//DUPS: 25030011,
static const uint64_t P9N2_EX_3_OPCG_CAPT2                                         = 0x26030011ull;
//DUPS: 27030011,
static const uint64_t P9N2_EX_4_OPCG_CAPT2                                         = 0x28030011ull;
//DUPS: 29030011,
static const uint64_t P9N2_EX_5_OPCG_CAPT2                                         = 0x2A030011ull;
//DUPS: 2B030011,
static const uint64_t P9N2_EX_6_OPCG_CAPT2                                         = 0x2C030011ull;
//DUPS: 2D030011,
static const uint64_t P9N2_EX_7_OPCG_CAPT2                                         = 0x2F030011ull;
//DUPS: 2F030011,
static const uint64_t P9N2_EX_8_OPCG_CAPT2                                         = 0x30030011ull;
//DUPS: 31030011,
static const uint64_t P9N2_EX_9_OPCG_CAPT2                                         = 0x32030011ull;
//DUPS: 33030011,
static const uint64_t P9N2_EX_10_OPCG_CAPT2                                        = 0x34030011ull;
//DUPS: 35030011,
static const uint64_t P9N2_EX_11_OPCG_CAPT2                                        = 0x36030011ull;
//DUPS: 37030011,

static const uint64_t P9N2_C_OPCG_CAPT3                                            = 0x20030012ull;

static const uint64_t P9N2_C_0_OPCG_CAPT3                                          = 0x20030012ull;

static const uint64_t P9N2_C_1_OPCG_CAPT3                                          = 0x21030012ull;

static const uint64_t P9N2_C_2_OPCG_CAPT3                                          = 0x22030012ull;

static const uint64_t P9N2_C_3_OPCG_CAPT3                                          = 0x23030012ull;

static const uint64_t P9N2_C_4_OPCG_CAPT3                                          = 0x24030012ull;

static const uint64_t P9N2_C_5_OPCG_CAPT3                                          = 0x25030012ull;

static const uint64_t P9N2_C_6_OPCG_CAPT3                                          = 0x26030012ull;

static const uint64_t P9N2_C_7_OPCG_CAPT3                                          = 0x27030012ull;

static const uint64_t P9N2_C_8_OPCG_CAPT3                                          = 0x28030012ull;

static const uint64_t P9N2_C_9_OPCG_CAPT3                                          = 0x29030012ull;

static const uint64_t P9N2_C_10_OPCG_CAPT3                                         = 0x2A030012ull;

static const uint64_t P9N2_C_11_OPCG_CAPT3                                         = 0x2B030012ull;

static const uint64_t P9N2_C_12_OPCG_CAPT3                                         = 0x2C030012ull;

static const uint64_t P9N2_C_13_OPCG_CAPT3                                         = 0x2D030012ull;

static const uint64_t P9N2_C_14_OPCG_CAPT3                                         = 0x2E030012ull;

static const uint64_t P9N2_C_15_OPCG_CAPT3                                         = 0x2F030012ull;

static const uint64_t P9N2_C_16_OPCG_CAPT3                                         = 0x30030012ull;

static const uint64_t P9N2_C_17_OPCG_CAPT3                                         = 0x31030012ull;

static const uint64_t P9N2_C_18_OPCG_CAPT3                                         = 0x32030012ull;

static const uint64_t P9N2_C_19_OPCG_CAPT3                                         = 0x33030012ull;

static const uint64_t P9N2_C_20_OPCG_CAPT3                                         = 0x34030012ull;

static const uint64_t P9N2_C_21_OPCG_CAPT3                                         = 0x35030012ull;

static const uint64_t P9N2_C_22_OPCG_CAPT3                                         = 0x36030012ull;

static const uint64_t P9N2_C_23_OPCG_CAPT3                                         = 0x37030012ull;

static const uint64_t P9N2_EQ_OPCG_CAPT3                                           = 0x10030012ull;

static const uint64_t P9N2_EQ_0_OPCG_CAPT3                                         = 0x10030012ull;

static const uint64_t P9N2_EQ_1_OPCG_CAPT3                                         = 0x11030012ull;

static const uint64_t P9N2_EQ_2_OPCG_CAPT3                                         = 0x12030012ull;

static const uint64_t P9N2_EQ_3_OPCG_CAPT3                                         = 0x13030012ull;

static const uint64_t P9N2_EQ_4_OPCG_CAPT3                                         = 0x14030012ull;

static const uint64_t P9N2_EQ_5_OPCG_CAPT3                                         = 0x15030012ull;

static const uint64_t P9N2_EX_OPCG_CAPT3                                           = 0x20030012ull;
//DUPS: 21030012,
static const uint64_t P9N2_EX_0_OPCG_CAPT3                                         = 0x20030012ull;
//DUPS: 21030012,
static const uint64_t P9N2_EX_1_OPCG_CAPT3                                         = 0x22030012ull;
//DUPS: 23030012,
static const uint64_t P9N2_EX_2_OPCG_CAPT3                                         = 0x24030012ull;
//DUPS: 25030012,
static const uint64_t P9N2_EX_3_OPCG_CAPT3                                         = 0x26030012ull;
//DUPS: 27030012,
static const uint64_t P9N2_EX_4_OPCG_CAPT3                                         = 0x28030012ull;
//DUPS: 29030012,
static const uint64_t P9N2_EX_5_OPCG_CAPT3                                         = 0x2A030012ull;
//DUPS: 2B030012,
static const uint64_t P9N2_EX_6_OPCG_CAPT3                                         = 0x2C030012ull;
//DUPS: 2D030012,
static const uint64_t P9N2_EX_7_OPCG_CAPT3                                         = 0x2F030012ull;
//DUPS: 2F030012,
static const uint64_t P9N2_EX_8_OPCG_CAPT3                                         = 0x30030012ull;
//DUPS: 31030012,
static const uint64_t P9N2_EX_9_OPCG_CAPT3                                         = 0x32030012ull;
//DUPS: 33030012,
static const uint64_t P9N2_EX_10_OPCG_CAPT3                                        = 0x34030012ull;
//DUPS: 35030012,
static const uint64_t P9N2_EX_11_OPCG_CAPT3                                        = 0x36030012ull;
//DUPS: 37030012,

static const uint64_t P9N2_C_OPCG_REG0                                             = 0x20030002ull;

static const uint64_t P9N2_C_0_OPCG_REG0                                           = 0x20030002ull;

static const uint64_t P9N2_C_1_OPCG_REG0                                           = 0x21030002ull;

static const uint64_t P9N2_C_2_OPCG_REG0                                           = 0x22030002ull;

static const uint64_t P9N2_C_3_OPCG_REG0                                           = 0x23030002ull;

static const uint64_t P9N2_C_4_OPCG_REG0                                           = 0x24030002ull;

static const uint64_t P9N2_C_5_OPCG_REG0                                           = 0x25030002ull;

static const uint64_t P9N2_C_6_OPCG_REG0                                           = 0x26030002ull;

static const uint64_t P9N2_C_7_OPCG_REG0                                           = 0x27030002ull;

static const uint64_t P9N2_C_8_OPCG_REG0                                           = 0x28030002ull;

static const uint64_t P9N2_C_9_OPCG_REG0                                           = 0x29030002ull;

static const uint64_t P9N2_C_10_OPCG_REG0                                          = 0x2A030002ull;

static const uint64_t P9N2_C_11_OPCG_REG0                                          = 0x2B030002ull;

static const uint64_t P9N2_C_12_OPCG_REG0                                          = 0x2C030002ull;

static const uint64_t P9N2_C_13_OPCG_REG0                                          = 0x2D030002ull;

static const uint64_t P9N2_C_14_OPCG_REG0                                          = 0x2E030002ull;

static const uint64_t P9N2_C_15_OPCG_REG0                                          = 0x2F030002ull;

static const uint64_t P9N2_C_16_OPCG_REG0                                          = 0x30030002ull;

static const uint64_t P9N2_C_17_OPCG_REG0                                          = 0x31030002ull;

static const uint64_t P9N2_C_18_OPCG_REG0                                          = 0x32030002ull;

static const uint64_t P9N2_C_19_OPCG_REG0                                          = 0x33030002ull;

static const uint64_t P9N2_C_20_OPCG_REG0                                          = 0x34030002ull;

static const uint64_t P9N2_C_21_OPCG_REG0                                          = 0x35030002ull;

static const uint64_t P9N2_C_22_OPCG_REG0                                          = 0x36030002ull;

static const uint64_t P9N2_C_23_OPCG_REG0                                          = 0x37030002ull;

static const uint64_t P9N2_EQ_OPCG_REG0                                            = 0x10030002ull;

static const uint64_t P9N2_EQ_0_OPCG_REG0                                          = 0x10030002ull;

static const uint64_t P9N2_EQ_1_OPCG_REG0                                          = 0x11030002ull;

static const uint64_t P9N2_EQ_2_OPCG_REG0                                          = 0x12030002ull;

static const uint64_t P9N2_EQ_3_OPCG_REG0                                          = 0x13030002ull;

static const uint64_t P9N2_EQ_4_OPCG_REG0                                          = 0x14030002ull;

static const uint64_t P9N2_EQ_5_OPCG_REG0                                          = 0x15030002ull;

static const uint64_t P9N2_EX_OPCG_REG0                                            = 0x20030002ull;
//DUPS: 21030002,
static const uint64_t P9N2_EX_0_OPCG_REG0                                          = 0x20030002ull;
//DUPS: 21030002,
static const uint64_t P9N2_EX_1_OPCG_REG0                                          = 0x22030002ull;
//DUPS: 23030002,
static const uint64_t P9N2_EX_2_OPCG_REG0                                          = 0x24030002ull;
//DUPS: 25030002,
static const uint64_t P9N2_EX_3_OPCG_REG0                                          = 0x26030002ull;
//DUPS: 27030002,
static const uint64_t P9N2_EX_4_OPCG_REG0                                          = 0x28030002ull;
//DUPS: 29030002,
static const uint64_t P9N2_EX_5_OPCG_REG0                                          = 0x2A030002ull;
//DUPS: 2B030002,
static const uint64_t P9N2_EX_6_OPCG_REG0                                          = 0x2C030002ull;
//DUPS: 2D030002,
static const uint64_t P9N2_EX_7_OPCG_REG0                                          = 0x2F030002ull;
//DUPS: 2F030002,
static const uint64_t P9N2_EX_8_OPCG_REG0                                          = 0x30030002ull;
//DUPS: 31030002,
static const uint64_t P9N2_EX_9_OPCG_REG0                                          = 0x32030002ull;
//DUPS: 33030002,
static const uint64_t P9N2_EX_10_OPCG_REG0                                         = 0x34030002ull;
//DUPS: 35030002,
static const uint64_t P9N2_EX_11_OPCG_REG0                                         = 0x36030002ull;
//DUPS: 37030002,

static const uint64_t P9N2_C_OPCG_REG1                                             = 0x20030003ull;

static const uint64_t P9N2_C_0_OPCG_REG1                                           = 0x20030003ull;

static const uint64_t P9N2_C_1_OPCG_REG1                                           = 0x21030003ull;

static const uint64_t P9N2_C_2_OPCG_REG1                                           = 0x22030003ull;

static const uint64_t P9N2_C_3_OPCG_REG1                                           = 0x23030003ull;

static const uint64_t P9N2_C_4_OPCG_REG1                                           = 0x24030003ull;

static const uint64_t P9N2_C_5_OPCG_REG1                                           = 0x25030003ull;

static const uint64_t P9N2_C_6_OPCG_REG1                                           = 0x26030003ull;

static const uint64_t P9N2_C_7_OPCG_REG1                                           = 0x27030003ull;

static const uint64_t P9N2_C_8_OPCG_REG1                                           = 0x28030003ull;

static const uint64_t P9N2_C_9_OPCG_REG1                                           = 0x29030003ull;

static const uint64_t P9N2_C_10_OPCG_REG1                                          = 0x2A030003ull;

static const uint64_t P9N2_C_11_OPCG_REG1                                          = 0x2B030003ull;

static const uint64_t P9N2_C_12_OPCG_REG1                                          = 0x2C030003ull;

static const uint64_t P9N2_C_13_OPCG_REG1                                          = 0x2D030003ull;

static const uint64_t P9N2_C_14_OPCG_REG1                                          = 0x2E030003ull;

static const uint64_t P9N2_C_15_OPCG_REG1                                          = 0x2F030003ull;

static const uint64_t P9N2_C_16_OPCG_REG1                                          = 0x30030003ull;

static const uint64_t P9N2_C_17_OPCG_REG1                                          = 0x31030003ull;

static const uint64_t P9N2_C_18_OPCG_REG1                                          = 0x32030003ull;

static const uint64_t P9N2_C_19_OPCG_REG1                                          = 0x33030003ull;

static const uint64_t P9N2_C_20_OPCG_REG1                                          = 0x34030003ull;

static const uint64_t P9N2_C_21_OPCG_REG1                                          = 0x35030003ull;

static const uint64_t P9N2_C_22_OPCG_REG1                                          = 0x36030003ull;

static const uint64_t P9N2_C_23_OPCG_REG1                                          = 0x37030003ull;

static const uint64_t P9N2_EQ_OPCG_REG1                                            = 0x10030003ull;

static const uint64_t P9N2_EQ_0_OPCG_REG1                                          = 0x10030003ull;

static const uint64_t P9N2_EQ_1_OPCG_REG1                                          = 0x11030003ull;

static const uint64_t P9N2_EQ_2_OPCG_REG1                                          = 0x12030003ull;

static const uint64_t P9N2_EQ_3_OPCG_REG1                                          = 0x13030003ull;

static const uint64_t P9N2_EQ_4_OPCG_REG1                                          = 0x14030003ull;

static const uint64_t P9N2_EQ_5_OPCG_REG1                                          = 0x15030003ull;

static const uint64_t P9N2_EX_OPCG_REG1                                            = 0x20030003ull;
//DUPS: 21030003,
static const uint64_t P9N2_EX_0_OPCG_REG1                                          = 0x20030003ull;
//DUPS: 21030003,
static const uint64_t P9N2_EX_1_OPCG_REG1                                          = 0x22030003ull;
//DUPS: 23030003,
static const uint64_t P9N2_EX_2_OPCG_REG1                                          = 0x24030003ull;
//DUPS: 25030003,
static const uint64_t P9N2_EX_3_OPCG_REG1                                          = 0x26030003ull;
//DUPS: 27030003,
static const uint64_t P9N2_EX_4_OPCG_REG1                                          = 0x28030003ull;
//DUPS: 29030003,
static const uint64_t P9N2_EX_5_OPCG_REG1                                          = 0x2A030003ull;
//DUPS: 2B030003,
static const uint64_t P9N2_EX_6_OPCG_REG1                                          = 0x2C030003ull;
//DUPS: 2D030003,
static const uint64_t P9N2_EX_7_OPCG_REG1                                          = 0x2F030003ull;
//DUPS: 2F030003,
static const uint64_t P9N2_EX_8_OPCG_REG1                                          = 0x30030003ull;
//DUPS: 31030003,
static const uint64_t P9N2_EX_9_OPCG_REG1                                          = 0x32030003ull;
//DUPS: 33030003,
static const uint64_t P9N2_EX_10_OPCG_REG1                                         = 0x34030003ull;
//DUPS: 35030003,
static const uint64_t P9N2_EX_11_OPCG_REG1                                         = 0x36030003ull;
//DUPS: 37030003,

static const uint64_t P9N2_C_OPCG_REG2                                             = 0x20030004ull;

static const uint64_t P9N2_C_0_OPCG_REG2                                           = 0x20030004ull;

static const uint64_t P9N2_C_1_OPCG_REG2                                           = 0x21030004ull;

static const uint64_t P9N2_C_2_OPCG_REG2                                           = 0x22030004ull;

static const uint64_t P9N2_C_3_OPCG_REG2                                           = 0x23030004ull;

static const uint64_t P9N2_C_4_OPCG_REG2                                           = 0x24030004ull;

static const uint64_t P9N2_C_5_OPCG_REG2                                           = 0x25030004ull;

static const uint64_t P9N2_C_6_OPCG_REG2                                           = 0x26030004ull;

static const uint64_t P9N2_C_7_OPCG_REG2                                           = 0x27030004ull;

static const uint64_t P9N2_C_8_OPCG_REG2                                           = 0x28030004ull;

static const uint64_t P9N2_C_9_OPCG_REG2                                           = 0x29030004ull;

static const uint64_t P9N2_C_10_OPCG_REG2                                          = 0x2A030004ull;

static const uint64_t P9N2_C_11_OPCG_REG2                                          = 0x2B030004ull;

static const uint64_t P9N2_C_12_OPCG_REG2                                          = 0x2C030004ull;

static const uint64_t P9N2_C_13_OPCG_REG2                                          = 0x2D030004ull;

static const uint64_t P9N2_C_14_OPCG_REG2                                          = 0x2E030004ull;

static const uint64_t P9N2_C_15_OPCG_REG2                                          = 0x2F030004ull;

static const uint64_t P9N2_C_16_OPCG_REG2                                          = 0x30030004ull;

static const uint64_t P9N2_C_17_OPCG_REG2                                          = 0x31030004ull;

static const uint64_t P9N2_C_18_OPCG_REG2                                          = 0x32030004ull;

static const uint64_t P9N2_C_19_OPCG_REG2                                          = 0x33030004ull;

static const uint64_t P9N2_C_20_OPCG_REG2                                          = 0x34030004ull;

static const uint64_t P9N2_C_21_OPCG_REG2                                          = 0x35030004ull;

static const uint64_t P9N2_C_22_OPCG_REG2                                          = 0x36030004ull;

static const uint64_t P9N2_C_23_OPCG_REG2                                          = 0x37030004ull;

static const uint64_t P9N2_EQ_OPCG_REG2                                            = 0x10030004ull;

static const uint64_t P9N2_EQ_0_OPCG_REG2                                          = 0x10030004ull;

static const uint64_t P9N2_EQ_1_OPCG_REG2                                          = 0x11030004ull;

static const uint64_t P9N2_EQ_2_OPCG_REG2                                          = 0x12030004ull;

static const uint64_t P9N2_EQ_3_OPCG_REG2                                          = 0x13030004ull;

static const uint64_t P9N2_EQ_4_OPCG_REG2                                          = 0x14030004ull;

static const uint64_t P9N2_EQ_5_OPCG_REG2                                          = 0x15030004ull;

static const uint64_t P9N2_EX_OPCG_REG2                                            = 0x20030004ull;
//DUPS: 21030004,
static const uint64_t P9N2_EX_0_OPCG_REG2                                          = 0x20030004ull;
//DUPS: 21030004,
static const uint64_t P9N2_EX_1_OPCG_REG2                                          = 0x22030004ull;
//DUPS: 23030004,
static const uint64_t P9N2_EX_2_OPCG_REG2                                          = 0x24030004ull;
//DUPS: 25030004,
static const uint64_t P9N2_EX_3_OPCG_REG2                                          = 0x26030004ull;
//DUPS: 27030004,
static const uint64_t P9N2_EX_4_OPCG_REG2                                          = 0x28030004ull;
//DUPS: 29030004,
static const uint64_t P9N2_EX_5_OPCG_REG2                                          = 0x2A030004ull;
//DUPS: 2B030004,
static const uint64_t P9N2_EX_6_OPCG_REG2                                          = 0x2C030004ull;
//DUPS: 2D030004,
static const uint64_t P9N2_EX_7_OPCG_REG2                                          = 0x2F030004ull;
//DUPS: 2F030004,
static const uint64_t P9N2_EX_8_OPCG_REG2                                          = 0x30030004ull;
//DUPS: 31030004,
static const uint64_t P9N2_EX_9_OPCG_REG2                                          = 0x32030004ull;
//DUPS: 33030004,
static const uint64_t P9N2_EX_10_OPCG_REG2                                         = 0x34030004ull;
//DUPS: 35030004,
static const uint64_t P9N2_EX_11_OPCG_REG2                                         = 0x36030004ull;
//DUPS: 37030004,

static const uint64_t P9N2_C_PCB_OPCG_GO                                           = 0x20030020ull;

static const uint64_t P9N2_C_0_PCB_OPCG_GO                                         = 0x20030020ull;

static const uint64_t P9N2_C_1_PCB_OPCG_GO                                         = 0x21030020ull;

static const uint64_t P9N2_C_2_PCB_OPCG_GO                                         = 0x22030020ull;

static const uint64_t P9N2_C_3_PCB_OPCG_GO                                         = 0x23030020ull;

static const uint64_t P9N2_C_4_PCB_OPCG_GO                                         = 0x24030020ull;

static const uint64_t P9N2_C_5_PCB_OPCG_GO                                         = 0x25030020ull;

static const uint64_t P9N2_C_6_PCB_OPCG_GO                                         = 0x26030020ull;

static const uint64_t P9N2_C_7_PCB_OPCG_GO                                         = 0x27030020ull;

static const uint64_t P9N2_C_8_PCB_OPCG_GO                                         = 0x28030020ull;

static const uint64_t P9N2_C_9_PCB_OPCG_GO                                         = 0x29030020ull;

static const uint64_t P9N2_C_10_PCB_OPCG_GO                                        = 0x2A030020ull;

static const uint64_t P9N2_C_11_PCB_OPCG_GO                                        = 0x2B030020ull;

static const uint64_t P9N2_C_12_PCB_OPCG_GO                                        = 0x2C030020ull;

static const uint64_t P9N2_C_13_PCB_OPCG_GO                                        = 0x2D030020ull;

static const uint64_t P9N2_C_14_PCB_OPCG_GO                                        = 0x2E030020ull;

static const uint64_t P9N2_C_15_PCB_OPCG_GO                                        = 0x2F030020ull;

static const uint64_t P9N2_C_16_PCB_OPCG_GO                                        = 0x30030020ull;

static const uint64_t P9N2_C_17_PCB_OPCG_GO                                        = 0x31030020ull;

static const uint64_t P9N2_C_18_PCB_OPCG_GO                                        = 0x32030020ull;

static const uint64_t P9N2_C_19_PCB_OPCG_GO                                        = 0x33030020ull;

static const uint64_t P9N2_C_20_PCB_OPCG_GO                                        = 0x34030020ull;

static const uint64_t P9N2_C_21_PCB_OPCG_GO                                        = 0x35030020ull;

static const uint64_t P9N2_C_22_PCB_OPCG_GO                                        = 0x36030020ull;

static const uint64_t P9N2_C_23_PCB_OPCG_GO                                        = 0x37030020ull;

static const uint64_t P9N2_EQ_PCB_OPCG_GO                                          = 0x10030020ull;

static const uint64_t P9N2_EQ_0_PCB_OPCG_GO                                        = 0x10030020ull;

static const uint64_t P9N2_EQ_1_PCB_OPCG_GO                                        = 0x11030020ull;

static const uint64_t P9N2_EQ_2_PCB_OPCG_GO                                        = 0x12030020ull;

static const uint64_t P9N2_EQ_3_PCB_OPCG_GO                                        = 0x13030020ull;

static const uint64_t P9N2_EQ_4_PCB_OPCG_GO                                        = 0x14030020ull;

static const uint64_t P9N2_EQ_5_PCB_OPCG_GO                                        = 0x15030020ull;

static const uint64_t P9N2_EX_PCB_OPCG_GO                                          = 0x20030020ull;
//DUPS: 21030020,
static const uint64_t P9N2_EX_0_PCB_OPCG_GO                                        = 0x20030020ull;
//DUPS: 21030020,
static const uint64_t P9N2_EX_1_PCB_OPCG_GO                                        = 0x22030020ull;
//DUPS: 23030020,
static const uint64_t P9N2_EX_2_PCB_OPCG_GO                                        = 0x24030020ull;
//DUPS: 25030020,
static const uint64_t P9N2_EX_3_PCB_OPCG_GO                                        = 0x26030020ull;
//DUPS: 27030020,
static const uint64_t P9N2_EX_4_PCB_OPCG_GO                                        = 0x28030020ull;
//DUPS: 29030020,
static const uint64_t P9N2_EX_5_PCB_OPCG_GO                                        = 0x2A030020ull;
//DUPS: 2B030020,
static const uint64_t P9N2_EX_6_PCB_OPCG_GO                                        = 0x2C030020ull;
//DUPS: 2D030020,
static const uint64_t P9N2_EX_7_PCB_OPCG_GO                                        = 0x2F030020ull;
//DUPS: 2F030020,
static const uint64_t P9N2_EX_8_PCB_OPCG_GO                                        = 0x30030020ull;
//DUPS: 31030020,
static const uint64_t P9N2_EX_9_PCB_OPCG_GO                                        = 0x32030020ull;
//DUPS: 33030020,
static const uint64_t P9N2_EX_10_PCB_OPCG_GO                                       = 0x34030020ull;
//DUPS: 35030020,
static const uint64_t P9N2_EX_11_PCB_OPCG_GO                                       = 0x36030020ull;
//DUPS: 37030020,

static const uint64_t P9N2_C_PCB_OPCG_STOP                                         = 0x20030030ull;

static const uint64_t P9N2_C_0_PCB_OPCG_STOP                                       = 0x20030030ull;

static const uint64_t P9N2_C_1_PCB_OPCG_STOP                                       = 0x21030030ull;

static const uint64_t P9N2_C_2_PCB_OPCG_STOP                                       = 0x22030030ull;

static const uint64_t P9N2_C_3_PCB_OPCG_STOP                                       = 0x23030030ull;

static const uint64_t P9N2_C_4_PCB_OPCG_STOP                                       = 0x24030030ull;

static const uint64_t P9N2_C_5_PCB_OPCG_STOP                                       = 0x25030030ull;

static const uint64_t P9N2_C_6_PCB_OPCG_STOP                                       = 0x26030030ull;

static const uint64_t P9N2_C_7_PCB_OPCG_STOP                                       = 0x27030030ull;

static const uint64_t P9N2_C_8_PCB_OPCG_STOP                                       = 0x28030030ull;

static const uint64_t P9N2_C_9_PCB_OPCG_STOP                                       = 0x29030030ull;

static const uint64_t P9N2_C_10_PCB_OPCG_STOP                                      = 0x2A030030ull;

static const uint64_t P9N2_C_11_PCB_OPCG_STOP                                      = 0x2B030030ull;

static const uint64_t P9N2_C_12_PCB_OPCG_STOP                                      = 0x2C030030ull;

static const uint64_t P9N2_C_13_PCB_OPCG_STOP                                      = 0x2D030030ull;

static const uint64_t P9N2_C_14_PCB_OPCG_STOP                                      = 0x2E030030ull;

static const uint64_t P9N2_C_15_PCB_OPCG_STOP                                      = 0x2F030030ull;

static const uint64_t P9N2_C_16_PCB_OPCG_STOP                                      = 0x30030030ull;

static const uint64_t P9N2_C_17_PCB_OPCG_STOP                                      = 0x31030030ull;

static const uint64_t P9N2_C_18_PCB_OPCG_STOP                                      = 0x32030030ull;

static const uint64_t P9N2_C_19_PCB_OPCG_STOP                                      = 0x33030030ull;

static const uint64_t P9N2_C_20_PCB_OPCG_STOP                                      = 0x34030030ull;

static const uint64_t P9N2_C_21_PCB_OPCG_STOP                                      = 0x35030030ull;

static const uint64_t P9N2_C_22_PCB_OPCG_STOP                                      = 0x36030030ull;

static const uint64_t P9N2_C_23_PCB_OPCG_STOP                                      = 0x37030030ull;

static const uint64_t P9N2_EQ_PCB_OPCG_STOP                                        = 0x10030030ull;

static const uint64_t P9N2_EQ_0_PCB_OPCG_STOP                                      = 0x10030030ull;

static const uint64_t P9N2_EQ_1_PCB_OPCG_STOP                                      = 0x11030030ull;

static const uint64_t P9N2_EQ_2_PCB_OPCG_STOP                                      = 0x12030030ull;

static const uint64_t P9N2_EQ_3_PCB_OPCG_STOP                                      = 0x13030030ull;

static const uint64_t P9N2_EQ_4_PCB_OPCG_STOP                                      = 0x14030030ull;

static const uint64_t P9N2_EQ_5_PCB_OPCG_STOP                                      = 0x15030030ull;

static const uint64_t P9N2_EX_PCB_OPCG_STOP                                        = 0x20030030ull;
//DUPS: 21030030,
static const uint64_t P9N2_EX_0_PCB_OPCG_STOP                                      = 0x20030030ull;
//DUPS: 21030030,
static const uint64_t P9N2_EX_1_PCB_OPCG_STOP                                      = 0x22030030ull;
//DUPS: 23030030,
static const uint64_t P9N2_EX_2_PCB_OPCG_STOP                                      = 0x24030030ull;
//DUPS: 25030030,
static const uint64_t P9N2_EX_3_PCB_OPCG_STOP                                      = 0x26030030ull;
//DUPS: 27030030,
static const uint64_t P9N2_EX_4_PCB_OPCG_STOP                                      = 0x28030030ull;
//DUPS: 29030030,
static const uint64_t P9N2_EX_5_PCB_OPCG_STOP                                      = 0x2A030030ull;
//DUPS: 2B030030,
static const uint64_t P9N2_EX_6_PCB_OPCG_STOP                                      = 0x2C030030ull;
//DUPS: 2D030030,
static const uint64_t P9N2_EX_7_PCB_OPCG_STOP                                      = 0x2F030030ull;
//DUPS: 2F030030,
static const uint64_t P9N2_EX_8_PCB_OPCG_STOP                                      = 0x30030030ull;
//DUPS: 31030030,
static const uint64_t P9N2_EX_9_PCB_OPCG_STOP                                      = 0x32030030ull;
//DUPS: 33030030,
static const uint64_t P9N2_EX_10_PCB_OPCG_STOP                                     = 0x34030030ull;
//DUPS: 35030030,
static const uint64_t P9N2_EX_11_PCB_OPCG_STOP                                     = 0x36030030ull;
//DUPS: 37030030,

static const uint64_t P9N2_EQ_PHYP_PURGE_CMD_REG                                   = 0x10010C0Full;
//DUPS: 10010C0F,
static const uint64_t P9N2_EQ_0_PHYP_PURGE_CMD_REG                                 = 0x10010C0Full;
//DUPS: 10010C0F,
static const uint64_t P9N2_EQ_1_PHYP_PURGE_CMD_REG                                 = 0x11010C0Full;
//DUPS: 11010C0F,
static const uint64_t P9N2_EQ_2_PHYP_PURGE_CMD_REG                                 = 0x12010C0Full;
//DUPS: 12010C0F,
static const uint64_t P9N2_EQ_3_PHYP_PURGE_CMD_REG                                 = 0x13010C0Full;
//DUPS: 13010C0F,
static const uint64_t P9N2_EQ_4_PHYP_PURGE_CMD_REG                                 = 0x14010C0Full;
//DUPS: 14010C0F,
static const uint64_t P9N2_EQ_5_PHYP_PURGE_CMD_REG                                 = 0x15010C0Full;
//DUPS: 15010C0F,
static const uint64_t P9N2_EX_PHYP_PURGE_CMD_REG                                   = 0x1001080Full;

static const uint64_t P9N2_EX_0_PHYP_PURGE_CMD_REG                                 = 0x1001080Full;

static const uint64_t P9N2_EX_1_PHYP_PURGE_CMD_REG                                 = 0x10010C0Full;

static const uint64_t P9N2_EX_2_PHYP_PURGE_CMD_REG                                 = 0x1101080Full;

static const uint64_t P9N2_EX_3_PHYP_PURGE_CMD_REG                                 = 0x11010C0Full;

static const uint64_t P9N2_EX_4_PHYP_PURGE_CMD_REG                                 = 0x1201080Full;

static const uint64_t P9N2_EX_5_PHYP_PURGE_CMD_REG                                 = 0x12010C0Full;

static const uint64_t P9N2_EX_6_PHYP_PURGE_CMD_REG                                 = 0x1301080Full;

static const uint64_t P9N2_EX_7_PHYP_PURGE_CMD_REG                                 = 0x13010C0Full;

static const uint64_t P9N2_EX_8_PHYP_PURGE_CMD_REG                                 = 0x1401080Full;

static const uint64_t P9N2_EX_9_PHYP_PURGE_CMD_REG                                 = 0x14010C0Full;

static const uint64_t P9N2_EX_10_PHYP_PURGE_CMD_REG                                = 0x1501080Full;

static const uint64_t P9N2_EX_11_PHYP_PURGE_CMD_REG                                = 0x15010C0Full;


static const uint64_t P9N2_EQ_PHYP_PURGE_REG                                       = 0x10011C14ull;
//DUPS: 10011C14,
static const uint64_t P9N2_EQ_0_PHYP_PURGE_REG                                     = 0x10011C14ull;
//DUPS: 10011C14,
static const uint64_t P9N2_EQ_1_PHYP_PURGE_REG                                     = 0x11011C14ull;
//DUPS: 11011C14,
static const uint64_t P9N2_EQ_2_PHYP_PURGE_REG                                     = 0x12011C14ull;
//DUPS: 12011C14,
static const uint64_t P9N2_EQ_3_PHYP_PURGE_REG                                     = 0x13011C14ull;
//DUPS: 13011C14,
static const uint64_t P9N2_EQ_4_PHYP_PURGE_REG                                     = 0x14011C14ull;
//DUPS: 14011C14,
static const uint64_t P9N2_EQ_5_PHYP_PURGE_REG                                     = 0x15011C14ull;
//DUPS: 15011C14,
static const uint64_t P9N2_EX_0_L3_PHYP_PURGE_REG                                  = 0x10011814ull;

static const uint64_t P9N2_EX_10_L3_PHYP_PURGE_REG                                 = 0x15011814ull;

static const uint64_t P9N2_EX_11_L3_PHYP_PURGE_REG                                 = 0x15011C14ull;

static const uint64_t P9N2_EX_1_L3_PHYP_PURGE_REG                                  = 0x10011C14ull;

static const uint64_t P9N2_EX_2_L3_PHYP_PURGE_REG                                  = 0x11011814ull;

static const uint64_t P9N2_EX_3_L3_PHYP_PURGE_REG                                  = 0x11011C14ull;

static const uint64_t P9N2_EX_4_L3_PHYP_PURGE_REG                                  = 0x12011814ull;

static const uint64_t P9N2_EX_5_L3_PHYP_PURGE_REG                                  = 0x12011C14ull;

static const uint64_t P9N2_EX_6_L3_PHYP_PURGE_REG                                  = 0x13011814ull;

static const uint64_t P9N2_EX_7_L3_PHYP_PURGE_REG                                  = 0x13011C14ull;

static const uint64_t P9N2_EX_8_L3_PHYP_PURGE_REG                                  = 0x14011814ull;

static const uint64_t P9N2_EX_9_L3_PHYP_PURGE_REG                                  = 0x14011C14ull;

static const uint64_t P9N2_EX_L3_PHYP_PURGE_REG                                    = 0x10011814ull;


static const uint64_t P9N2_C_PLL_LOCK_REG                                          = 0x200F0019ull;

static const uint64_t P9N2_C_0_PLL_LOCK_REG                                        = 0x200F0019ull;

static const uint64_t P9N2_C_1_PLL_LOCK_REG                                        = 0x210F0019ull;

static const uint64_t P9N2_C_2_PLL_LOCK_REG                                        = 0x220F0019ull;

static const uint64_t P9N2_C_3_PLL_LOCK_REG                                        = 0x230F0019ull;

static const uint64_t P9N2_C_4_PLL_LOCK_REG                                        = 0x240F0019ull;

static const uint64_t P9N2_C_5_PLL_LOCK_REG                                        = 0x250F0019ull;

static const uint64_t P9N2_C_6_PLL_LOCK_REG                                        = 0x260F0019ull;

static const uint64_t P9N2_C_7_PLL_LOCK_REG                                        = 0x270F0019ull;

static const uint64_t P9N2_C_8_PLL_LOCK_REG                                        = 0x280F0019ull;

static const uint64_t P9N2_C_9_PLL_LOCK_REG                                        = 0x290F0019ull;

static const uint64_t P9N2_C_10_PLL_LOCK_REG                                       = 0x2A0F0019ull;

static const uint64_t P9N2_C_11_PLL_LOCK_REG                                       = 0x2B0F0019ull;

static const uint64_t P9N2_C_12_PLL_LOCK_REG                                       = 0x2C0F0019ull;

static const uint64_t P9N2_C_13_PLL_LOCK_REG                                       = 0x2D0F0019ull;

static const uint64_t P9N2_C_14_PLL_LOCK_REG                                       = 0x2E0F0019ull;

static const uint64_t P9N2_C_15_PLL_LOCK_REG                                       = 0x2F0F0019ull;

static const uint64_t P9N2_C_16_PLL_LOCK_REG                                       = 0x300F0019ull;

static const uint64_t P9N2_C_17_PLL_LOCK_REG                                       = 0x310F0019ull;

static const uint64_t P9N2_C_18_PLL_LOCK_REG                                       = 0x320F0019ull;

static const uint64_t P9N2_C_19_PLL_LOCK_REG                                       = 0x330F0019ull;

static const uint64_t P9N2_C_20_PLL_LOCK_REG                                       = 0x340F0019ull;

static const uint64_t P9N2_C_21_PLL_LOCK_REG                                       = 0x350F0019ull;

static const uint64_t P9N2_C_22_PLL_LOCK_REG                                       = 0x360F0019ull;

static const uint64_t P9N2_C_23_PLL_LOCK_REG                                       = 0x370F0019ull;

static const uint64_t P9N2_EQ_PLL_LOCK_REG                                         = 0x100F0019ull;

static const uint64_t P9N2_EQ_0_PLL_LOCK_REG                                       = 0x100F0019ull;

static const uint64_t P9N2_EQ_1_PLL_LOCK_REG                                       = 0x110F0019ull;

static const uint64_t P9N2_EQ_2_PLL_LOCK_REG                                       = 0x120F0019ull;

static const uint64_t P9N2_EQ_3_PLL_LOCK_REG                                       = 0x130F0019ull;

static const uint64_t P9N2_EQ_4_PLL_LOCK_REG                                       = 0x140F0019ull;

static const uint64_t P9N2_EQ_5_PLL_LOCK_REG                                       = 0x150F0019ull;

static const uint64_t P9N2_EX_PLL_LOCK_REG                                         = 0x200F0019ull;
//DUPS: 210F0019,
static const uint64_t P9N2_EX_0_PLL_LOCK_REG                                       = 0x200F0019ull;
//DUPS: 210F0019,
static const uint64_t P9N2_EX_1_PLL_LOCK_REG                                       = 0x220F0019ull;
//DUPS: 220F0019,
static const uint64_t P9N2_EX_2_PLL_LOCK_REG                                       = 0x240F0019ull;
//DUPS: 250F0019,
static const uint64_t P9N2_EX_3_PLL_LOCK_REG                                       = 0x260F0019ull;
//DUPS: 270F0019,
static const uint64_t P9N2_EX_4_PLL_LOCK_REG                                       = 0x280F0019ull;
//DUPS: 290F0019,
static const uint64_t P9N2_EX_5_PLL_LOCK_REG                                       = 0x2A0F0019ull;
//DUPS: 2B0F0019,
static const uint64_t P9N2_EX_6_PLL_LOCK_REG                                       = 0x2C0F0019ull;
//DUPS: 2D0F0019,
static const uint64_t P9N2_EX_7_PLL_LOCK_REG                                       = 0x2E0F0019ull;
//DUPS: 2F0F0019,
static const uint64_t P9N2_EX_8_PLL_LOCK_REG                                       = 0x300F0019ull;
//DUPS: 310F0019,
static const uint64_t P9N2_EX_9_PLL_LOCK_REG                                       = 0x320F0019ull;
//DUPS: 330F0019,
static const uint64_t P9N2_EX_10_PLL_LOCK_REG                                      = 0x340F0019ull;
//DUPS: 350F0019,
static const uint64_t P9N2_EX_11_PLL_LOCK_REG                                      = 0x360F0019ull;
//DUPS: 370F0019,

static const uint64_t P9N2_C_PMU_HOLD_OUT                                          = 0x20010AB6ull;

static const uint64_t P9N2_C_0_PMU_HOLD_OUT                                        = 0x20010AB6ull;

static const uint64_t P9N2_C_1_PMU_HOLD_OUT                                        = 0x21010AB6ull;

static const uint64_t P9N2_C_2_PMU_HOLD_OUT                                        = 0x22010AB6ull;

static const uint64_t P9N2_C_3_PMU_HOLD_OUT                                        = 0x23010AB6ull;

static const uint64_t P9N2_C_4_PMU_HOLD_OUT                                        = 0x24010AB6ull;

static const uint64_t P9N2_C_5_PMU_HOLD_OUT                                        = 0x25010AB6ull;

static const uint64_t P9N2_C_6_PMU_HOLD_OUT                                        = 0x26010AB6ull;

static const uint64_t P9N2_C_7_PMU_HOLD_OUT                                        = 0x27010AB6ull;

static const uint64_t P9N2_C_8_PMU_HOLD_OUT                                        = 0x28010AB6ull;

static const uint64_t P9N2_C_9_PMU_HOLD_OUT                                        = 0x29010AB6ull;

static const uint64_t P9N2_C_10_PMU_HOLD_OUT                                       = 0x2A010AB6ull;

static const uint64_t P9N2_C_11_PMU_HOLD_OUT                                       = 0x2B010AB6ull;

static const uint64_t P9N2_C_12_PMU_HOLD_OUT                                       = 0x2C010AB6ull;

static const uint64_t P9N2_C_13_PMU_HOLD_OUT                                       = 0x2D010AB6ull;

static const uint64_t P9N2_C_14_PMU_HOLD_OUT                                       = 0x2E010AB6ull;

static const uint64_t P9N2_C_15_PMU_HOLD_OUT                                       = 0x2F010AB6ull;

static const uint64_t P9N2_C_16_PMU_HOLD_OUT                                       = 0x30010AB6ull;

static const uint64_t P9N2_C_17_PMU_HOLD_OUT                                       = 0x31010AB6ull;

static const uint64_t P9N2_C_18_PMU_HOLD_OUT                                       = 0x32010AB6ull;

static const uint64_t P9N2_C_19_PMU_HOLD_OUT                                       = 0x33010AB6ull;

static const uint64_t P9N2_C_20_PMU_HOLD_OUT                                       = 0x34010AB6ull;

static const uint64_t P9N2_C_21_PMU_HOLD_OUT                                       = 0x35010AB6ull;

static const uint64_t P9N2_C_22_PMU_HOLD_OUT                                       = 0x36010AB6ull;

static const uint64_t P9N2_C_23_PMU_HOLD_OUT                                       = 0x37010AB6ull;

static const uint64_t P9N2_EX_0_L2_PMU_HOLD_OUT                                    = 0x20010AB6ull;
//DUPS: 21010AB6,
static const uint64_t P9N2_EX_10_L2_PMU_HOLD_OUT                                   = 0x34010AB6ull;
//DUPS: 35010AB6,
static const uint64_t P9N2_EX_11_L2_PMU_HOLD_OUT                                   = 0x36010AB6ull;
//DUPS: 37010AB6,
static const uint64_t P9N2_EX_1_L2_PMU_HOLD_OUT                                    = 0x22010AB6ull;
//DUPS: 23010AB6,
static const uint64_t P9N2_EX_2_L2_PMU_HOLD_OUT                                    = 0x24010AB6ull;
//DUPS: 25010AB6,
static const uint64_t P9N2_EX_3_L2_PMU_HOLD_OUT                                    = 0x26010AB6ull;
//DUPS: 27010AB6,
static const uint64_t P9N2_EX_4_L2_PMU_HOLD_OUT                                    = 0x28010AB6ull;
//DUPS: 29010AB6,
static const uint64_t P9N2_EX_5_L2_PMU_HOLD_OUT                                    = 0x2A010AB6ull;
//DUPS: 2B010AB6,
static const uint64_t P9N2_EX_6_L2_PMU_HOLD_OUT                                    = 0x2C010AB6ull;
//DUPS: 2D010AB6,
static const uint64_t P9N2_EX_7_L2_PMU_HOLD_OUT                                    = 0x2F010AB6ull;
//DUPS: 2F010AB6,
static const uint64_t P9N2_EX_8_L2_PMU_HOLD_OUT                                    = 0x30010AB6ull;
//DUPS: 31010AB6,
static const uint64_t P9N2_EX_9_L2_PMU_HOLD_OUT                                    = 0x32010AB6ull;
//DUPS: 33010AB6,
static const uint64_t P9N2_EX_L2_PMU_HOLD_OUT                                      = 0x20010AB6ull;
//DUPS: 21010AB6,

static const uint64_t P9N2_C_PMU_SCOMC                                             = 0x20010AB0ull;

static const uint64_t P9N2_C_0_PMU_SCOMC                                           = 0x20010AB0ull;

static const uint64_t P9N2_C_1_PMU_SCOMC                                           = 0x21010AB0ull;

static const uint64_t P9N2_C_2_PMU_SCOMC                                           = 0x22010AB0ull;

static const uint64_t P9N2_C_3_PMU_SCOMC                                           = 0x23010AB0ull;

static const uint64_t P9N2_C_4_PMU_SCOMC                                           = 0x24010AB0ull;

static const uint64_t P9N2_C_5_PMU_SCOMC                                           = 0x25010AB0ull;

static const uint64_t P9N2_C_6_PMU_SCOMC                                           = 0x26010AB0ull;

static const uint64_t P9N2_C_7_PMU_SCOMC                                           = 0x27010AB0ull;

static const uint64_t P9N2_C_8_PMU_SCOMC                                           = 0x28010AB0ull;

static const uint64_t P9N2_C_9_PMU_SCOMC                                           = 0x29010AB0ull;

static const uint64_t P9N2_C_10_PMU_SCOMC                                          = 0x2A010AB0ull;

static const uint64_t P9N2_C_11_PMU_SCOMC                                          = 0x2B010AB0ull;

static const uint64_t P9N2_C_12_PMU_SCOMC                                          = 0x2C010AB0ull;

static const uint64_t P9N2_C_13_PMU_SCOMC                                          = 0x2D010AB0ull;

static const uint64_t P9N2_C_14_PMU_SCOMC                                          = 0x2E010AB0ull;

static const uint64_t P9N2_C_15_PMU_SCOMC                                          = 0x2F010AB0ull;

static const uint64_t P9N2_C_16_PMU_SCOMC                                          = 0x30010AB0ull;

static const uint64_t P9N2_C_17_PMU_SCOMC                                          = 0x31010AB0ull;

static const uint64_t P9N2_C_18_PMU_SCOMC                                          = 0x32010AB0ull;

static const uint64_t P9N2_C_19_PMU_SCOMC                                          = 0x33010AB0ull;

static const uint64_t P9N2_C_20_PMU_SCOMC                                          = 0x34010AB0ull;

static const uint64_t P9N2_C_21_PMU_SCOMC                                          = 0x35010AB0ull;

static const uint64_t P9N2_C_22_PMU_SCOMC                                          = 0x36010AB0ull;

static const uint64_t P9N2_C_23_PMU_SCOMC                                          = 0x37010AB0ull;

static const uint64_t P9N2_EX_0_L2_PMU_SCOMC                                       = 0x20010AB0ull;
//DUPS: 21010AB0,
static const uint64_t P9N2_EX_10_L2_PMU_SCOMC                                      = 0x34010AB0ull;
//DUPS: 35010AB0,
static const uint64_t P9N2_EX_11_L2_PMU_SCOMC                                      = 0x36010AB0ull;
//DUPS: 37010AB0,
static const uint64_t P9N2_EX_1_L2_PMU_SCOMC                                       = 0x22010AB0ull;
//DUPS: 23010AB0,
static const uint64_t P9N2_EX_2_L2_PMU_SCOMC                                       = 0x24010AB0ull;
//DUPS: 25010AB0,
static const uint64_t P9N2_EX_3_L2_PMU_SCOMC                                       = 0x26010AB0ull;
//DUPS: 27010AB0,
static const uint64_t P9N2_EX_4_L2_PMU_SCOMC                                       = 0x28010AB0ull;
//DUPS: 29010AB0,
static const uint64_t P9N2_EX_5_L2_PMU_SCOMC                                       = 0x2A010AB0ull;
//DUPS: 2B010AB0,
static const uint64_t P9N2_EX_6_L2_PMU_SCOMC                                       = 0x2C010AB0ull;
//DUPS: 2D010AB0,
static const uint64_t P9N2_EX_7_L2_PMU_SCOMC                                       = 0x2F010AB0ull;
//DUPS: 2F010AB0,
static const uint64_t P9N2_EX_8_L2_PMU_SCOMC                                       = 0x30010AB0ull;
//DUPS: 31010AB0,
static const uint64_t P9N2_EX_9_L2_PMU_SCOMC                                       = 0x32010AB0ull;
//DUPS: 33010AB0,
static const uint64_t P9N2_EX_L2_PMU_SCOMC                                         = 0x20010AB0ull;
//DUPS: 21010AB0,

static const uint64_t P9N2_C_PMU_SCOMC_EN                                          = 0x20010AB2ull;

static const uint64_t P9N2_C_0_PMU_SCOMC_EN                                        = 0x20010AB2ull;

static const uint64_t P9N2_C_1_PMU_SCOMC_EN                                        = 0x21010AB2ull;

static const uint64_t P9N2_C_2_PMU_SCOMC_EN                                        = 0x22010AB2ull;

static const uint64_t P9N2_C_3_PMU_SCOMC_EN                                        = 0x23010AB2ull;

static const uint64_t P9N2_C_4_PMU_SCOMC_EN                                        = 0x24010AB2ull;

static const uint64_t P9N2_C_5_PMU_SCOMC_EN                                        = 0x25010AB2ull;

static const uint64_t P9N2_C_6_PMU_SCOMC_EN                                        = 0x26010AB2ull;

static const uint64_t P9N2_C_7_PMU_SCOMC_EN                                        = 0x27010AB2ull;

static const uint64_t P9N2_C_8_PMU_SCOMC_EN                                        = 0x28010AB2ull;

static const uint64_t P9N2_C_9_PMU_SCOMC_EN                                        = 0x29010AB2ull;

static const uint64_t P9N2_C_10_PMU_SCOMC_EN                                       = 0x2A010AB2ull;

static const uint64_t P9N2_C_11_PMU_SCOMC_EN                                       = 0x2B010AB2ull;

static const uint64_t P9N2_C_12_PMU_SCOMC_EN                                       = 0x2C010AB2ull;

static const uint64_t P9N2_C_13_PMU_SCOMC_EN                                       = 0x2D010AB2ull;

static const uint64_t P9N2_C_14_PMU_SCOMC_EN                                       = 0x2E010AB2ull;

static const uint64_t P9N2_C_15_PMU_SCOMC_EN                                       = 0x2F010AB2ull;

static const uint64_t P9N2_C_16_PMU_SCOMC_EN                                       = 0x30010AB2ull;

static const uint64_t P9N2_C_17_PMU_SCOMC_EN                                       = 0x31010AB2ull;

static const uint64_t P9N2_C_18_PMU_SCOMC_EN                                       = 0x32010AB2ull;

static const uint64_t P9N2_C_19_PMU_SCOMC_EN                                       = 0x33010AB2ull;

static const uint64_t P9N2_C_20_PMU_SCOMC_EN                                       = 0x34010AB2ull;

static const uint64_t P9N2_C_21_PMU_SCOMC_EN                                       = 0x35010AB2ull;

static const uint64_t P9N2_C_22_PMU_SCOMC_EN                                       = 0x36010AB2ull;

static const uint64_t P9N2_C_23_PMU_SCOMC_EN                                       = 0x37010AB2ull;

static const uint64_t P9N2_EX_0_L2_PMU_SCOMC_EN                                    = 0x20010AB2ull;
//DUPS: 21010AB2,
static const uint64_t P9N2_EX_10_L2_PMU_SCOMC_EN                                   = 0x34010AB2ull;
//DUPS: 35010AB2,
static const uint64_t P9N2_EX_11_L2_PMU_SCOMC_EN                                   = 0x36010AB2ull;
//DUPS: 37010AB2,
static const uint64_t P9N2_EX_1_L2_PMU_SCOMC_EN                                    = 0x22010AB2ull;
//DUPS: 23010AB2,
static const uint64_t P9N2_EX_2_L2_PMU_SCOMC_EN                                    = 0x24010AB2ull;
//DUPS: 25010AB2,
static const uint64_t P9N2_EX_3_L2_PMU_SCOMC_EN                                    = 0x26010AB2ull;
//DUPS: 27010AB2,
static const uint64_t P9N2_EX_4_L2_PMU_SCOMC_EN                                    = 0x28010AB2ull;
//DUPS: 29010AB2,
static const uint64_t P9N2_EX_5_L2_PMU_SCOMC_EN                                    = 0x2A010AB2ull;
//DUPS: 2B010AB2,
static const uint64_t P9N2_EX_6_L2_PMU_SCOMC_EN                                    = 0x2C010AB2ull;
//DUPS: 2D010AB2,
static const uint64_t P9N2_EX_7_L2_PMU_SCOMC_EN                                    = 0x2F010AB2ull;
//DUPS: 2F010AB2,
static const uint64_t P9N2_EX_8_L2_PMU_SCOMC_EN                                    = 0x30010AB2ull;
//DUPS: 31010AB2,
static const uint64_t P9N2_EX_9_L2_PMU_SCOMC_EN                                    = 0x32010AB2ull;
//DUPS: 33010AB2,
static const uint64_t P9N2_EX_L2_PMU_SCOMC_EN                                      = 0x20010AB2ull;
//DUPS: 21010AB2,

static const uint64_t P9N2_EQ_PM_L2_RCMD_DIS_REG                                   = 0x10011C18ull;
//DUPS: 10011C18,
static const uint64_t P9N2_EQ_0_PM_L2_RCMD_DIS_REG                                 = 0x10011C18ull;
//DUPS: 10011C18,
static const uint64_t P9N2_EQ_1_PM_L2_RCMD_DIS_REG                                 = 0x11011C18ull;
//DUPS: 11011C18,
static const uint64_t P9N2_EQ_2_PM_L2_RCMD_DIS_REG                                 = 0x12011C18ull;
//DUPS: 12011C18,
static const uint64_t P9N2_EQ_3_PM_L2_RCMD_DIS_REG                                 = 0x13011C18ull;
//DUPS: 13011C18,
static const uint64_t P9N2_EQ_4_PM_L2_RCMD_DIS_REG                                 = 0x14011C18ull;
//DUPS: 14011C18,
static const uint64_t P9N2_EQ_5_PM_L2_RCMD_DIS_REG                                 = 0x15011C18ull;
//DUPS: 15011C18,
static const uint64_t P9N2_EX_PM_L2_RCMD_DIS_REG                                   = 0x10011818ull;

static const uint64_t P9N2_EX_0_PM_L2_RCMD_DIS_REG                                 = 0x10011818ull;

static const uint64_t P9N2_EX_1_PM_L2_RCMD_DIS_REG                                 = 0x10011C18ull;

static const uint64_t P9N2_EX_2_PM_L2_RCMD_DIS_REG                                 = 0x11011818ull;

static const uint64_t P9N2_EX_3_PM_L2_RCMD_DIS_REG                                 = 0x11011C18ull;

static const uint64_t P9N2_EX_4_PM_L2_RCMD_DIS_REG                                 = 0x12011818ull;

static const uint64_t P9N2_EX_5_PM_L2_RCMD_DIS_REG                                 = 0x12011C18ull;

static const uint64_t P9N2_EX_6_PM_L2_RCMD_DIS_REG                                 = 0x13011818ull;

static const uint64_t P9N2_EX_7_PM_L2_RCMD_DIS_REG                                 = 0x13011C18ull;

static const uint64_t P9N2_EX_8_PM_L2_RCMD_DIS_REG                                 = 0x14011818ull;

static const uint64_t P9N2_EX_9_PM_L2_RCMD_DIS_REG                                 = 0x14011C18ull;

static const uint64_t P9N2_EX_10_PM_L2_RCMD_DIS_REG                                = 0x15011818ull;

static const uint64_t P9N2_EX_11_PM_L2_RCMD_DIS_REG                                = 0x15011C18ull;


static const uint64_t P9N2_EQ_PM_LCO_DIS_REG                                       = 0x10011C16ull;
//DUPS: 10011C16,
static const uint64_t P9N2_EQ_0_PM_LCO_DIS_REG                                     = 0x10011C16ull;
//DUPS: 10011C16,
static const uint64_t P9N2_EQ_1_PM_LCO_DIS_REG                                     = 0x11011C16ull;
//DUPS: 11011C16,
static const uint64_t P9N2_EQ_2_PM_LCO_DIS_REG                                     = 0x12011C16ull;
//DUPS: 12011C16,
static const uint64_t P9N2_EQ_3_PM_LCO_DIS_REG                                     = 0x13011C16ull;
//DUPS: 13011C16,
static const uint64_t P9N2_EQ_4_PM_LCO_DIS_REG                                     = 0x14011C16ull;
//DUPS: 14011C16,
static const uint64_t P9N2_EQ_5_PM_LCO_DIS_REG                                     = 0x15011C16ull;
//DUPS: 15011C16,
static const uint64_t P9N2_EX_0_L3_PM_LCO_DIS_REG                                  = 0x10011816ull;

static const uint64_t P9N2_EX_10_L3_PM_LCO_DIS_REG                                 = 0x15011816ull;

static const uint64_t P9N2_EX_11_L3_PM_LCO_DIS_REG                                 = 0x15011C16ull;

static const uint64_t P9N2_EX_1_L3_PM_LCO_DIS_REG                                  = 0x10011C16ull;

static const uint64_t P9N2_EX_2_L3_PM_LCO_DIS_REG                                  = 0x11011816ull;

static const uint64_t P9N2_EX_3_L3_PM_LCO_DIS_REG                                  = 0x11011C16ull;

static const uint64_t P9N2_EX_4_L3_PM_LCO_DIS_REG                                  = 0x12011816ull;

static const uint64_t P9N2_EX_5_L3_PM_LCO_DIS_REG                                  = 0x12011C16ull;

static const uint64_t P9N2_EX_6_L3_PM_LCO_DIS_REG                                  = 0x13011816ull;

static const uint64_t P9N2_EX_7_L3_PM_LCO_DIS_REG                                  = 0x13011C16ull;

static const uint64_t P9N2_EX_8_L3_PM_LCO_DIS_REG                                  = 0x14011816ull;

static const uint64_t P9N2_EX_9_L3_PM_LCO_DIS_REG                                  = 0x14011C16ull;

static const uint64_t P9N2_EX_L3_PM_LCO_DIS_REG                                    = 0x10011816ull;


static const uint64_t P9N2_EQ_PM_PURGE_REG                                         = 0x10011C13ull;
//DUPS: 10011C13,
static const uint64_t P9N2_EQ_0_PM_PURGE_REG                                       = 0x10011C13ull;
//DUPS: 10011C13,
static const uint64_t P9N2_EQ_1_PM_PURGE_REG                                       = 0x11011C13ull;
//DUPS: 11011C13,
static const uint64_t P9N2_EQ_2_PM_PURGE_REG                                       = 0x12011C13ull;
//DUPS: 12011C13,
static const uint64_t P9N2_EQ_3_PM_PURGE_REG                                       = 0x13011C13ull;
//DUPS: 13011C13,
static const uint64_t P9N2_EQ_4_PM_PURGE_REG                                       = 0x14011C13ull;
//DUPS: 14011C13,
static const uint64_t P9N2_EQ_5_PM_PURGE_REG                                       = 0x15011C13ull;
//DUPS: 15011C13,
static const uint64_t P9N2_EX_0_L3_PM_PURGE_REG                                    = 0x10011813ull;

static const uint64_t P9N2_EX_10_L3_PM_PURGE_REG                                   = 0x15011813ull;

static const uint64_t P9N2_EX_11_L3_PM_PURGE_REG                                   = 0x15011C13ull;

static const uint64_t P9N2_EX_1_L3_PM_PURGE_REG                                    = 0x10011C13ull;

static const uint64_t P9N2_EX_2_L3_PM_PURGE_REG                                    = 0x11011813ull;

static const uint64_t P9N2_EX_3_L3_PM_PURGE_REG                                    = 0x11011C13ull;

static const uint64_t P9N2_EX_4_L3_PM_PURGE_REG                                    = 0x12011813ull;

static const uint64_t P9N2_EX_5_L3_PM_PURGE_REG                                    = 0x12011C13ull;

static const uint64_t P9N2_EX_6_L3_PM_PURGE_REG                                    = 0x13011813ull;

static const uint64_t P9N2_EX_7_L3_PM_PURGE_REG                                    = 0x13011C13ull;

static const uint64_t P9N2_EX_8_L3_PM_PURGE_REG                                    = 0x14011813ull;

static const uint64_t P9N2_EX_9_L3_PM_PURGE_REG                                    = 0x14011C13ull;

static const uint64_t P9N2_EX_L3_PM_PURGE_REG                                      = 0x10011813ull;


static const uint64_t P9N2_EQ_PPE_XIDBGPRO                                         = 0x10012015ull;
//DUPS: 10012015,
static const uint64_t P9N2_EQ_0_PPE_XIDBGPRO                                       = 0x10012015ull;
//DUPS: 10012015,
static const uint64_t P9N2_EQ_1_PPE_XIDBGPRO                                       = 0x11012015ull;
//DUPS: 11012015,
static const uint64_t P9N2_EQ_2_PPE_XIDBGPRO                                       = 0x12012015ull;
//DUPS: 12012015,
static const uint64_t P9N2_EQ_3_PPE_XIDBGPRO                                       = 0x13012015ull;
//DUPS: 13012015,
static const uint64_t P9N2_EQ_4_PPE_XIDBGPRO                                       = 0x14012015ull;
//DUPS: 14012015,
static const uint64_t P9N2_EQ_5_PPE_XIDBGPRO                                       = 0x15012015ull;
//DUPS: 15012015,
static const uint64_t P9N2_EX_PPE_XIDBGPRO                                         = 0x10012015ull;

static const uint64_t P9N2_EX_0_PPE_XIDBGPRO                                       = 0x10012015ull;

static const uint64_t P9N2_EX_1_PPE_XIDBGPRO                                       = 0x10012415ull;

static const uint64_t P9N2_EX_2_PPE_XIDBGPRO                                       = 0x11012015ull;

static const uint64_t P9N2_EX_3_PPE_XIDBGPRO                                       = 0x11012415ull;

static const uint64_t P9N2_EX_4_PPE_XIDBGPRO                                       = 0x12012015ull;

static const uint64_t P9N2_EX_5_PPE_XIDBGPRO                                       = 0x12012415ull;

static const uint64_t P9N2_EX_6_PPE_XIDBGPRO                                       = 0x13012015ull;

static const uint64_t P9N2_EX_7_PPE_XIDBGPRO                                       = 0x13012415ull;

static const uint64_t P9N2_EX_8_PPE_XIDBGPRO                                       = 0x14012015ull;

static const uint64_t P9N2_EX_9_PPE_XIDBGPRO                                       = 0x14012415ull;

static const uint64_t P9N2_EX_10_PPE_XIDBGPRO                                      = 0x15012015ull;

static const uint64_t P9N2_EX_11_PPE_XIDBGPRO                                      = 0x15012415ull;


static const uint64_t P9N2_EQ_PPE_XIRAMDBG                                         = 0x10012013ull;
//DUPS: 10012013,
static const uint64_t P9N2_EQ_0_PPE_XIRAMDBG                                       = 0x10012013ull;
//DUPS: 10012013,
static const uint64_t P9N2_EQ_1_PPE_XIRAMDBG                                       = 0x11012013ull;
//DUPS: 11012013,
static const uint64_t P9N2_EQ_2_PPE_XIRAMDBG                                       = 0x12012013ull;
//DUPS: 12012013,
static const uint64_t P9N2_EQ_3_PPE_XIRAMDBG                                       = 0x13012013ull;
//DUPS: 13012013,
static const uint64_t P9N2_EQ_4_PPE_XIRAMDBG                                       = 0x14012013ull;
//DUPS: 14012013,
static const uint64_t P9N2_EQ_5_PPE_XIRAMDBG                                       = 0x15012013ull;
//DUPS: 15012013,
static const uint64_t P9N2_EX_PPE_XIRAMDBG                                         = 0x10012013ull;

static const uint64_t P9N2_EX_0_PPE_XIRAMDBG                                       = 0x10012013ull;

static const uint64_t P9N2_EX_1_PPE_XIRAMDBG                                       = 0x10012413ull;

static const uint64_t P9N2_EX_2_PPE_XIRAMDBG                                       = 0x11012013ull;

static const uint64_t P9N2_EX_3_PPE_XIRAMDBG                                       = 0x11012413ull;

static const uint64_t P9N2_EX_4_PPE_XIRAMDBG                                       = 0x12012013ull;

static const uint64_t P9N2_EX_5_PPE_XIRAMDBG                                       = 0x12012413ull;

static const uint64_t P9N2_EX_6_PPE_XIRAMDBG                                       = 0x13012013ull;

static const uint64_t P9N2_EX_7_PPE_XIRAMDBG                                       = 0x13012413ull;

static const uint64_t P9N2_EX_8_PPE_XIRAMDBG                                       = 0x14012013ull;

static const uint64_t P9N2_EX_9_PPE_XIRAMDBG                                       = 0x14012413ull;

static const uint64_t P9N2_EX_10_PPE_XIRAMDBG                                      = 0x15012013ull;

static const uint64_t P9N2_EX_11_PPE_XIRAMDBG                                      = 0x15012413ull;


static const uint64_t P9N2_EQ_PPE_XIRAMEDR                                         = 0x10012014ull;
//DUPS: 10012014,
static const uint64_t P9N2_EQ_0_PPE_XIRAMEDR                                       = 0x10012014ull;
//DUPS: 10012014,
static const uint64_t P9N2_EQ_1_PPE_XIRAMEDR                                       = 0x11012014ull;
//DUPS: 11012014,
static const uint64_t P9N2_EQ_2_PPE_XIRAMEDR                                       = 0x12012014ull;
//DUPS: 12012014,
static const uint64_t P9N2_EQ_3_PPE_XIRAMEDR                                       = 0x13012014ull;
//DUPS: 13012014,
static const uint64_t P9N2_EQ_4_PPE_XIRAMEDR                                       = 0x14012014ull;
//DUPS: 14012014,
static const uint64_t P9N2_EQ_5_PPE_XIRAMEDR                                       = 0x15012014ull;
//DUPS: 15012014,
static const uint64_t P9N2_EX_PPE_XIRAMEDR                                         = 0x10012014ull;

static const uint64_t P9N2_EX_0_PPE_XIRAMEDR                                       = 0x10012014ull;

static const uint64_t P9N2_EX_1_PPE_XIRAMEDR                                       = 0x10012414ull;

static const uint64_t P9N2_EX_2_PPE_XIRAMEDR                                       = 0x11012014ull;

static const uint64_t P9N2_EX_3_PPE_XIRAMEDR                                       = 0x11012414ull;

static const uint64_t P9N2_EX_4_PPE_XIRAMEDR                                       = 0x12012014ull;

static const uint64_t P9N2_EX_5_PPE_XIRAMEDR                                       = 0x12012414ull;

static const uint64_t P9N2_EX_6_PPE_XIRAMEDR                                       = 0x13012014ull;

static const uint64_t P9N2_EX_7_PPE_XIRAMEDR                                       = 0x13012414ull;

static const uint64_t P9N2_EX_8_PPE_XIRAMEDR                                       = 0x14012014ull;

static const uint64_t P9N2_EX_9_PPE_XIRAMEDR                                       = 0x14012414ull;

static const uint64_t P9N2_EX_10_PPE_XIRAMEDR                                      = 0x15012014ull;

static const uint64_t P9N2_EX_11_PPE_XIRAMEDR                                      = 0x15012414ull;


static const uint64_t P9N2_EQ_PPE_XIRAMGA                                          = 0x10012012ull;
//DUPS: 10012012,
static const uint64_t P9N2_EQ_0_PPE_XIRAMGA                                        = 0x10012012ull;
//DUPS: 10012012,
static const uint64_t P9N2_EQ_1_PPE_XIRAMGA                                        = 0x11012012ull;
//DUPS: 11012012,
static const uint64_t P9N2_EQ_2_PPE_XIRAMGA                                        = 0x12012012ull;
//DUPS: 12012012,
static const uint64_t P9N2_EQ_3_PPE_XIRAMGA                                        = 0x13012012ull;
//DUPS: 13012012,
static const uint64_t P9N2_EQ_4_PPE_XIRAMGA                                        = 0x14012012ull;
//DUPS: 14012012,
static const uint64_t P9N2_EQ_5_PPE_XIRAMGA                                        = 0x15012012ull;
//DUPS: 15012012,
static const uint64_t P9N2_EX_PPE_XIRAMGA                                          = 0x10012012ull;

static const uint64_t P9N2_EX_0_PPE_XIRAMGA                                        = 0x10012012ull;

static const uint64_t P9N2_EX_1_PPE_XIRAMGA                                        = 0x10012412ull;

static const uint64_t P9N2_EX_2_PPE_XIRAMGA                                        = 0x11012012ull;

static const uint64_t P9N2_EX_3_PPE_XIRAMGA                                        = 0x11012412ull;

static const uint64_t P9N2_EX_4_PPE_XIRAMGA                                        = 0x12012012ull;

static const uint64_t P9N2_EX_5_PPE_XIRAMGA                                        = 0x12012412ull;

static const uint64_t P9N2_EX_6_PPE_XIRAMGA                                        = 0x13012012ull;

static const uint64_t P9N2_EX_7_PPE_XIRAMGA                                        = 0x13012412ull;

static const uint64_t P9N2_EX_8_PPE_XIRAMGA                                        = 0x14012012ull;

static const uint64_t P9N2_EX_9_PPE_XIRAMGA                                        = 0x14012412ull;

static const uint64_t P9N2_EX_10_PPE_XIRAMGA                                       = 0x15012012ull;

static const uint64_t P9N2_EX_11_PPE_XIRAMGA                                       = 0x15012412ull;


static const uint64_t P9N2_EQ_PPE_XIRAMRA                                          = 0x10012011ull;
//DUPS: 10012011,
static const uint64_t P9N2_EQ_0_PPE_XIRAMRA                                        = 0x10012011ull;
//DUPS: 10012011,
static const uint64_t P9N2_EQ_1_PPE_XIRAMRA                                        = 0x11012011ull;
//DUPS: 11012011,
static const uint64_t P9N2_EQ_2_PPE_XIRAMRA                                        = 0x12012011ull;
//DUPS: 12012011,
static const uint64_t P9N2_EQ_3_PPE_XIRAMRA                                        = 0x13012011ull;
//DUPS: 13012011,
static const uint64_t P9N2_EQ_4_PPE_XIRAMRA                                        = 0x14012011ull;
//DUPS: 14012011,
static const uint64_t P9N2_EQ_5_PPE_XIRAMRA                                        = 0x15012011ull;
//DUPS: 15012011,
static const uint64_t P9N2_EX_PPE_XIRAMRA                                          = 0x10012011ull;

static const uint64_t P9N2_EX_0_PPE_XIRAMRA                                        = 0x10012011ull;

static const uint64_t P9N2_EX_1_PPE_XIRAMRA                                        = 0x10012411ull;

static const uint64_t P9N2_EX_2_PPE_XIRAMRA                                        = 0x11012011ull;

static const uint64_t P9N2_EX_3_PPE_XIRAMRA                                        = 0x11012411ull;

static const uint64_t P9N2_EX_4_PPE_XIRAMRA                                        = 0x12012011ull;

static const uint64_t P9N2_EX_5_PPE_XIRAMRA                                        = 0x12012411ull;

static const uint64_t P9N2_EX_6_PPE_XIRAMRA                                        = 0x13012011ull;

static const uint64_t P9N2_EX_7_PPE_XIRAMRA                                        = 0x13012411ull;

static const uint64_t P9N2_EX_8_PPE_XIRAMRA                                        = 0x14012011ull;

static const uint64_t P9N2_EX_9_PPE_XIRAMRA                                        = 0x14012411ull;

static const uint64_t P9N2_EX_10_PPE_XIRAMRA                                       = 0x15012011ull;

static const uint64_t P9N2_EX_11_PPE_XIRAMRA                                       = 0x15012411ull;


static const uint64_t P9N2_EQ_PPE_XIXCR                                            = 0x10012010ull;
//DUPS: 10012010,
static const uint64_t P9N2_EQ_0_PPE_XIXCR                                          = 0x10012010ull;
//DUPS: 10012010,
static const uint64_t P9N2_EQ_1_PPE_XIXCR                                          = 0x11012010ull;
//DUPS: 11012010,
static const uint64_t P9N2_EQ_2_PPE_XIXCR                                          = 0x12012010ull;
//DUPS: 12012010,
static const uint64_t P9N2_EQ_3_PPE_XIXCR                                          = 0x13012010ull;
//DUPS: 13012010,
static const uint64_t P9N2_EQ_4_PPE_XIXCR                                          = 0x14012010ull;
//DUPS: 14012010,
static const uint64_t P9N2_EQ_5_PPE_XIXCR                                          = 0x15012010ull;
//DUPS: 15012010,
static const uint64_t P9N2_EX_PPE_XIXCR                                            = 0x10012010ull;

static const uint64_t P9N2_EX_0_PPE_XIXCR                                          = 0x10012010ull;

static const uint64_t P9N2_EX_1_PPE_XIXCR                                          = 0x10012410ull;

static const uint64_t P9N2_EX_2_PPE_XIXCR                                          = 0x11012010ull;

static const uint64_t P9N2_EX_3_PPE_XIXCR                                          = 0x11012410ull;

static const uint64_t P9N2_EX_4_PPE_XIXCR                                          = 0x12012010ull;

static const uint64_t P9N2_EX_5_PPE_XIXCR                                          = 0x12012410ull;

static const uint64_t P9N2_EX_6_PPE_XIXCR                                          = 0x13012010ull;

static const uint64_t P9N2_EX_7_PPE_XIXCR                                          = 0x13012410ull;

static const uint64_t P9N2_EX_8_PPE_XIXCR                                          = 0x14012010ull;

static const uint64_t P9N2_EX_9_PPE_XIXCR                                          = 0x14012410ull;

static const uint64_t P9N2_EX_10_PPE_XIXCR                                         = 0x15012010ull;

static const uint64_t P9N2_EX_11_PPE_XIXCR                                         = 0x15012410ull;


static const uint64_t P9N2_C_PPM_CGCR                                              = 0x200F0164ull;

static const uint64_t P9N2_C_0_PPM_CGCR                                            = 0x200F0164ull;

static const uint64_t P9N2_C_1_PPM_CGCR                                            = 0x210F0164ull;

static const uint64_t P9N2_C_2_PPM_CGCR                                            = 0x220F0164ull;

static const uint64_t P9N2_C_3_PPM_CGCR                                            = 0x230F0164ull;

static const uint64_t P9N2_C_4_PPM_CGCR                                            = 0x240F0164ull;

static const uint64_t P9N2_C_5_PPM_CGCR                                            = 0x250F0164ull;

static const uint64_t P9N2_C_6_PPM_CGCR                                            = 0x260F0164ull;

static const uint64_t P9N2_C_7_PPM_CGCR                                            = 0x270F0164ull;

static const uint64_t P9N2_C_8_PPM_CGCR                                            = 0x280F0164ull;

static const uint64_t P9N2_C_9_PPM_CGCR                                            = 0x290F0164ull;

static const uint64_t P9N2_C_10_PPM_CGCR                                           = 0x2A0F0164ull;

static const uint64_t P9N2_C_11_PPM_CGCR                                           = 0x2B0F0164ull;

static const uint64_t P9N2_C_12_PPM_CGCR                                           = 0x2C0F0164ull;

static const uint64_t P9N2_C_13_PPM_CGCR                                           = 0x2D0F0164ull;

static const uint64_t P9N2_C_14_PPM_CGCR                                           = 0x2E0F0164ull;

static const uint64_t P9N2_C_15_PPM_CGCR                                           = 0x2F0F0164ull;

static const uint64_t P9N2_C_16_PPM_CGCR                                           = 0x300F0164ull;

static const uint64_t P9N2_C_17_PPM_CGCR                                           = 0x310F0164ull;

static const uint64_t P9N2_C_18_PPM_CGCR                                           = 0x320F0164ull;

static const uint64_t P9N2_C_19_PPM_CGCR                                           = 0x330F0164ull;

static const uint64_t P9N2_C_20_PPM_CGCR                                           = 0x340F0164ull;

static const uint64_t P9N2_C_21_PPM_CGCR                                           = 0x350F0164ull;

static const uint64_t P9N2_C_22_PPM_CGCR                                           = 0x360F0164ull;

static const uint64_t P9N2_C_23_PPM_CGCR                                           = 0x370F0164ull;

static const uint64_t P9N2_EQ_PPM_CGCR                                             = 0x100F0164ull;

static const uint64_t P9N2_EQ_0_PPM_CGCR                                           = 0x100F0164ull;

static const uint64_t P9N2_EQ_1_PPM_CGCR                                           = 0x110F0164ull;

static const uint64_t P9N2_EQ_2_PPM_CGCR                                           = 0x120F0164ull;

static const uint64_t P9N2_EQ_3_PPM_CGCR                                           = 0x130F0164ull;

static const uint64_t P9N2_EQ_4_PPM_CGCR                                           = 0x140F0164ull;

static const uint64_t P9N2_EQ_5_PPM_CGCR                                           = 0x150F0164ull;

static const uint64_t P9N2_EX_PPM_CGCR                                             = 0x200F0164ull;
//DUPS: 210F0164,
static const uint64_t P9N2_EX_0_PPM_CGCR                                           = 0x200F0164ull;
//DUPS: 210F0164,
static const uint64_t P9N2_EX_1_PPM_CGCR                                           = 0x220F0164ull;
//DUPS: 220F0164,
static const uint64_t P9N2_EX_2_PPM_CGCR                                           = 0x240F0164ull;
//DUPS: 250F0164,
static const uint64_t P9N2_EX_3_PPM_CGCR                                           = 0x260F0164ull;
//DUPS: 270F0164,
static const uint64_t P9N2_EX_4_PPM_CGCR                                           = 0x280F0164ull;
//DUPS: 290F0164,
static const uint64_t P9N2_EX_5_PPM_CGCR                                           = 0x2A0F0164ull;
//DUPS: 2B0F0164,
static const uint64_t P9N2_EX_6_PPM_CGCR                                           = 0x2C0F0164ull;
//DUPS: 2D0F0164,
static const uint64_t P9N2_EX_7_PPM_CGCR                                           = 0x2E0F0164ull;
//DUPS: 2F0F0164,
static const uint64_t P9N2_EX_8_PPM_CGCR                                           = 0x300F0164ull;
//DUPS: 310F0164,
static const uint64_t P9N2_EX_9_PPM_CGCR                                           = 0x320F0164ull;
//DUPS: 330F0164,
static const uint64_t P9N2_EX_10_PPM_CGCR                                          = 0x340F0164ull;
//DUPS: 350F0164,
static const uint64_t P9N2_EX_11_PPM_CGCR                                          = 0x360F0164ull;
//DUPS: 370F0164,

static const uint64_t P9N2_C_PPM_GPMMR_SCOM                                        = 0x200F0100ull;

static const uint64_t P9N2_C_PPM_GPMMR_SCOM1                                       = 0x200F0101ull;

static const uint64_t P9N2_C_PPM_GPMMR_SCOM2                                       = 0x200F0102ull;

static const uint64_t P9N2_C_0_PPM_GPMMR_SCOM                                      = 0x200F0100ull;

static const uint64_t P9N2_C_0_PPM_GPMMR_SCOM1                                     = 0x200F0101ull;

static const uint64_t P9N2_C_0_PPM_GPMMR_SCOM2                                     = 0x200F0102ull;

static const uint64_t P9N2_C_1_PPM_GPMMR_SCOM                                      = 0x210F0100ull;

static const uint64_t P9N2_C_1_PPM_GPMMR_SCOM1                                     = 0x210F0101ull;

static const uint64_t P9N2_C_1_PPM_GPMMR_SCOM2                                     = 0x210F0102ull;

static const uint64_t P9N2_C_2_PPM_GPMMR_SCOM                                      = 0x220F0100ull;

static const uint64_t P9N2_C_2_PPM_GPMMR_SCOM1                                     = 0x220F0101ull;

static const uint64_t P9N2_C_2_PPM_GPMMR_SCOM2                                     = 0x220F0102ull;

static const uint64_t P9N2_C_3_PPM_GPMMR_SCOM                                      = 0x230F0100ull;

static const uint64_t P9N2_C_3_PPM_GPMMR_SCOM1                                     = 0x230F0101ull;

static const uint64_t P9N2_C_3_PPM_GPMMR_SCOM2                                     = 0x230F0102ull;

static const uint64_t P9N2_C_4_PPM_GPMMR_SCOM                                      = 0x240F0100ull;

static const uint64_t P9N2_C_4_PPM_GPMMR_SCOM1                                     = 0x240F0101ull;

static const uint64_t P9N2_C_4_PPM_GPMMR_SCOM2                                     = 0x240F0102ull;

static const uint64_t P9N2_C_5_PPM_GPMMR_SCOM                                      = 0x250F0100ull;

static const uint64_t P9N2_C_5_PPM_GPMMR_SCOM1                                     = 0x250F0101ull;

static const uint64_t P9N2_C_5_PPM_GPMMR_SCOM2                                     = 0x250F0102ull;

static const uint64_t P9N2_C_6_PPM_GPMMR_SCOM                                      = 0x260F0100ull;

static const uint64_t P9N2_C_6_PPM_GPMMR_SCOM1                                     = 0x260F0101ull;

static const uint64_t P9N2_C_6_PPM_GPMMR_SCOM2                                     = 0x260F0102ull;

static const uint64_t P9N2_C_7_PPM_GPMMR_SCOM                                      = 0x270F0100ull;

static const uint64_t P9N2_C_7_PPM_GPMMR_SCOM1                                     = 0x270F0101ull;

static const uint64_t P9N2_C_7_PPM_GPMMR_SCOM2                                     = 0x270F0102ull;

static const uint64_t P9N2_C_8_PPM_GPMMR_SCOM                                      = 0x280F0100ull;

static const uint64_t P9N2_C_8_PPM_GPMMR_SCOM1                                     = 0x280F0101ull;

static const uint64_t P9N2_C_8_PPM_GPMMR_SCOM2                                     = 0x280F0102ull;

static const uint64_t P9N2_C_9_PPM_GPMMR_SCOM                                      = 0x290F0100ull;

static const uint64_t P9N2_C_9_PPM_GPMMR_SCOM1                                     = 0x290F0101ull;

static const uint64_t P9N2_C_9_PPM_GPMMR_SCOM2                                     = 0x290F0102ull;

static const uint64_t P9N2_C_10_PPM_GPMMR_SCOM                                     = 0x2A0F0100ull;

static const uint64_t P9N2_C_10_PPM_GPMMR_SCOM1                                    = 0x2A0F0101ull;

static const uint64_t P9N2_C_10_PPM_GPMMR_SCOM2                                    = 0x2A0F0102ull;

static const uint64_t P9N2_C_11_PPM_GPMMR_SCOM                                     = 0x2B0F0100ull;

static const uint64_t P9N2_C_11_PPM_GPMMR_SCOM1                                    = 0x2B0F0101ull;

static const uint64_t P9N2_C_11_PPM_GPMMR_SCOM2                                    = 0x2B0F0102ull;

static const uint64_t P9N2_C_12_PPM_GPMMR_SCOM                                     = 0x2C0F0100ull;

static const uint64_t P9N2_C_12_PPM_GPMMR_SCOM1                                    = 0x2C0F0101ull;

static const uint64_t P9N2_C_12_PPM_GPMMR_SCOM2                                    = 0x2C0F0102ull;

static const uint64_t P9N2_C_13_PPM_GPMMR_SCOM                                     = 0x2D0F0100ull;

static const uint64_t P9N2_C_13_PPM_GPMMR_SCOM1                                    = 0x2D0F0101ull;

static const uint64_t P9N2_C_13_PPM_GPMMR_SCOM2                                    = 0x2D0F0102ull;

static const uint64_t P9N2_C_14_PPM_GPMMR_SCOM                                     = 0x2E0F0100ull;

static const uint64_t P9N2_C_14_PPM_GPMMR_SCOM1                                    = 0x2E0F0101ull;

static const uint64_t P9N2_C_14_PPM_GPMMR_SCOM2                                    = 0x2E0F0102ull;

static const uint64_t P9N2_C_15_PPM_GPMMR_SCOM                                     = 0x2F0F0100ull;

static const uint64_t P9N2_C_15_PPM_GPMMR_SCOM1                                    = 0x2F0F0101ull;

static const uint64_t P9N2_C_15_PPM_GPMMR_SCOM2                                    = 0x2F0F0102ull;

static const uint64_t P9N2_C_16_PPM_GPMMR_SCOM                                     = 0x300F0100ull;

static const uint64_t P9N2_C_16_PPM_GPMMR_SCOM1                                    = 0x300F0101ull;

static const uint64_t P9N2_C_16_PPM_GPMMR_SCOM2                                    = 0x300F0102ull;

static const uint64_t P9N2_C_17_PPM_GPMMR_SCOM                                     = 0x310F0100ull;

static const uint64_t P9N2_C_17_PPM_GPMMR_SCOM1                                    = 0x310F0101ull;

static const uint64_t P9N2_C_17_PPM_GPMMR_SCOM2                                    = 0x310F0102ull;

static const uint64_t P9N2_C_18_PPM_GPMMR_SCOM                                     = 0x320F0100ull;

static const uint64_t P9N2_C_18_PPM_GPMMR_SCOM1                                    = 0x320F0101ull;

static const uint64_t P9N2_C_18_PPM_GPMMR_SCOM2                                    = 0x320F0102ull;

static const uint64_t P9N2_C_19_PPM_GPMMR_SCOM                                     = 0x330F0100ull;

static const uint64_t P9N2_C_19_PPM_GPMMR_SCOM1                                    = 0x330F0101ull;

static const uint64_t P9N2_C_19_PPM_GPMMR_SCOM2                                    = 0x330F0102ull;

static const uint64_t P9N2_C_20_PPM_GPMMR_SCOM                                     = 0x340F0100ull;

static const uint64_t P9N2_C_20_PPM_GPMMR_SCOM1                                    = 0x340F0101ull;

static const uint64_t P9N2_C_20_PPM_GPMMR_SCOM2                                    = 0x340F0102ull;

static const uint64_t P9N2_C_21_PPM_GPMMR_SCOM                                     = 0x350F0100ull;

static const uint64_t P9N2_C_21_PPM_GPMMR_SCOM1                                    = 0x350F0101ull;

static const uint64_t P9N2_C_21_PPM_GPMMR_SCOM2                                    = 0x350F0102ull;

static const uint64_t P9N2_C_22_PPM_GPMMR_SCOM                                     = 0x360F0100ull;

static const uint64_t P9N2_C_22_PPM_GPMMR_SCOM1                                    = 0x360F0101ull;

static const uint64_t P9N2_C_22_PPM_GPMMR_SCOM2                                    = 0x360F0102ull;

static const uint64_t P9N2_C_23_PPM_GPMMR_SCOM                                     = 0x370F0100ull;

static const uint64_t P9N2_C_23_PPM_GPMMR_SCOM1                                    = 0x370F0101ull;

static const uint64_t P9N2_C_23_PPM_GPMMR_SCOM2                                    = 0x370F0102ull;

static const uint64_t P9N2_EQ_PPM_GPMMR_SCOM                                       = 0x100F0100ull;

static const uint64_t P9N2_EQ_PPM_GPMMR_SCOM1                                      = 0x100F0101ull;

static const uint64_t P9N2_EQ_PPM_GPMMR_SCOM2                                      = 0x100F0102ull;

static const uint64_t P9N2_EQ_0_PPM_GPMMR_SCOM                                     = 0x100F0100ull;

static const uint64_t P9N2_EQ_0_PPM_GPMMR_SCOM1                                    = 0x100F0101ull;

static const uint64_t P9N2_EQ_0_PPM_GPMMR_SCOM2                                    = 0x100F0102ull;

static const uint64_t P9N2_EQ_1_PPM_GPMMR_SCOM                                     = 0x110F0100ull;

static const uint64_t P9N2_EQ_1_PPM_GPMMR_SCOM1                                    = 0x110F0101ull;

static const uint64_t P9N2_EQ_1_PPM_GPMMR_SCOM2                                    = 0x110F0102ull;

static const uint64_t P9N2_EQ_2_PPM_GPMMR_SCOM                                     = 0x120F0100ull;

static const uint64_t P9N2_EQ_2_PPM_GPMMR_SCOM1                                    = 0x120F0101ull;

static const uint64_t P9N2_EQ_2_PPM_GPMMR_SCOM2                                    = 0x120F0102ull;

static const uint64_t P9N2_EQ_3_PPM_GPMMR_SCOM                                     = 0x130F0100ull;

static const uint64_t P9N2_EQ_3_PPM_GPMMR_SCOM1                                    = 0x130F0101ull;

static const uint64_t P9N2_EQ_3_PPM_GPMMR_SCOM2                                    = 0x130F0102ull;

static const uint64_t P9N2_EQ_4_PPM_GPMMR_SCOM                                     = 0x140F0100ull;

static const uint64_t P9N2_EQ_4_PPM_GPMMR_SCOM1                                    = 0x140F0101ull;

static const uint64_t P9N2_EQ_4_PPM_GPMMR_SCOM2                                    = 0x140F0102ull;

static const uint64_t P9N2_EQ_5_PPM_GPMMR_SCOM                                     = 0x150F0100ull;

static const uint64_t P9N2_EQ_5_PPM_GPMMR_SCOM1                                    = 0x150F0101ull;

static const uint64_t P9N2_EQ_5_PPM_GPMMR_SCOM2                                    = 0x150F0102ull;

static const uint64_t P9N2_EX_PPM_GPMMR_SCOM                                       = 0x200F0100ull;
//DUPS: 210F0100,
static const uint64_t P9N2_EX_PPM_GPMMR_SCOM1                                      = 0x200F0101ull;
//DUPS: 210F0101,
static const uint64_t P9N2_EX_PPM_GPMMR_SCOM2                                      = 0x200F0102ull;
//DUPS: 210F0102,
static const uint64_t P9N2_EX_0_PPM_GPMMR_SCOM                                     = 0x200F0100ull;
//DUPS: 210F0100,
static const uint64_t P9N2_EX_0_PPM_GPMMR_SCOM1                                    = 0x200F0101ull;
//DUPS: 210F0101,
static const uint64_t P9N2_EX_0_PPM_GPMMR_SCOM2                                    = 0x200F0102ull;
//DUPS: 210F0102,
static const uint64_t P9N2_EX_1_PPM_GPMMR_SCOM                                     = 0x220F0100ull;
//DUPS: 220F0100,
static const uint64_t P9N2_EX_1_PPM_GPMMR_SCOM1                                    = 0x220F0101ull;
//DUPS: 220F0101,
static const uint64_t P9N2_EX_1_PPM_GPMMR_SCOM2                                    = 0x220F0102ull;
//DUPS: 220F0102,
static const uint64_t P9N2_EX_2_PPM_GPMMR_SCOM                                     = 0x240F0100ull;
//DUPS: 250F0100,
static const uint64_t P9N2_EX_2_PPM_GPMMR_SCOM1                                    = 0x240F0101ull;
//DUPS: 250F0101,
static const uint64_t P9N2_EX_2_PPM_GPMMR_SCOM2                                    = 0x240F0102ull;
//DUPS: 250F0102,
static const uint64_t P9N2_EX_3_PPM_GPMMR_SCOM                                     = 0x260F0100ull;
//DUPS: 270F0100,
static const uint64_t P9N2_EX_3_PPM_GPMMR_SCOM1                                    = 0x260F0101ull;
//DUPS: 270F0101,
static const uint64_t P9N2_EX_3_PPM_GPMMR_SCOM2                                    = 0x260F0102ull;
//DUPS: 270F0102,
static const uint64_t P9N2_EX_4_PPM_GPMMR_SCOM                                     = 0x280F0100ull;
//DUPS: 290F0100,
static const uint64_t P9N2_EX_4_PPM_GPMMR_SCOM1                                    = 0x280F0101ull;
//DUPS: 290F0101,
static const uint64_t P9N2_EX_4_PPM_GPMMR_SCOM2                                    = 0x280F0102ull;
//DUPS: 290F0102,
static const uint64_t P9N2_EX_5_PPM_GPMMR_SCOM                                     = 0x2A0F0100ull;
//DUPS: 2B0F0100,
static const uint64_t P9N2_EX_5_PPM_GPMMR_SCOM1                                    = 0x2A0F0101ull;
//DUPS: 2B0F0101,
static const uint64_t P9N2_EX_5_PPM_GPMMR_SCOM2                                    = 0x2A0F0102ull;
//DUPS: 2B0F0102,
static const uint64_t P9N2_EX_6_PPM_GPMMR_SCOM                                     = 0x2C0F0100ull;
//DUPS: 2D0F0100,
static const uint64_t P9N2_EX_6_PPM_GPMMR_SCOM1                                    = 0x2C0F0101ull;
//DUPS: 2D0F0101,
static const uint64_t P9N2_EX_6_PPM_GPMMR_SCOM2                                    = 0x2C0F0102ull;
//DUPS: 2D0F0102,
static const uint64_t P9N2_EX_7_PPM_GPMMR_SCOM                                     = 0x2E0F0100ull;
//DUPS: 2F0F0100,
static const uint64_t P9N2_EX_7_PPM_GPMMR_SCOM1                                    = 0x2E0F0101ull;
//DUPS: 2F0F0101,
static const uint64_t P9N2_EX_7_PPM_GPMMR_SCOM2                                    = 0x2E0F0102ull;
//DUPS: 2F0F0102,
static const uint64_t P9N2_EX_8_PPM_GPMMR_SCOM                                     = 0x300F0100ull;
//DUPS: 310F0100,
static const uint64_t P9N2_EX_8_PPM_GPMMR_SCOM1                                    = 0x300F0101ull;
//DUPS: 310F0101,
static const uint64_t P9N2_EX_8_PPM_GPMMR_SCOM2                                    = 0x300F0102ull;
//DUPS: 310F0102,
static const uint64_t P9N2_EX_9_PPM_GPMMR_SCOM                                     = 0x320F0100ull;
//DUPS: 330F0100,
static const uint64_t P9N2_EX_9_PPM_GPMMR_SCOM1                                    = 0x320F0101ull;
//DUPS: 330F0101,
static const uint64_t P9N2_EX_9_PPM_GPMMR_SCOM2                                    = 0x320F0102ull;
//DUPS: 330F0102,
static const uint64_t P9N2_EX_10_PPM_GPMMR_SCOM                                    = 0x340F0100ull;
//DUPS: 350F0100,
static const uint64_t P9N2_EX_10_PPM_GPMMR_SCOM1                                   = 0x340F0101ull;
//DUPS: 350F0101,
static const uint64_t P9N2_EX_10_PPM_GPMMR_SCOM2                                   = 0x340F0102ull;
//DUPS: 350F0102,
static const uint64_t P9N2_EX_11_PPM_GPMMR_SCOM                                    = 0x360F0100ull;
//DUPS: 370F0100,
static const uint64_t P9N2_EX_11_PPM_GPMMR_SCOM1                                   = 0x360F0101ull;
//DUPS: 370F0101,
static const uint64_t P9N2_EX_11_PPM_GPMMR_SCOM2                                   = 0x360F0102ull;
//DUPS: 370F0102,

static const uint64_t P9N2_C_PPM_IVRMAVR                                           = 0x200F01B5ull;

static const uint64_t P9N2_C_0_PPM_IVRMAVR                                         = 0x200F01B5ull;

static const uint64_t P9N2_C_1_PPM_IVRMAVR                                         = 0x210F01B5ull;

static const uint64_t P9N2_C_2_PPM_IVRMAVR                                         = 0x220F01B5ull;

static const uint64_t P9N2_C_3_PPM_IVRMAVR                                         = 0x230F01B5ull;

static const uint64_t P9N2_C_4_PPM_IVRMAVR                                         = 0x240F01B5ull;

static const uint64_t P9N2_C_5_PPM_IVRMAVR                                         = 0x250F01B5ull;

static const uint64_t P9N2_C_6_PPM_IVRMAVR                                         = 0x260F01B5ull;

static const uint64_t P9N2_C_7_PPM_IVRMAVR                                         = 0x270F01B5ull;

static const uint64_t P9N2_C_8_PPM_IVRMAVR                                         = 0x280F01B5ull;

static const uint64_t P9N2_C_9_PPM_IVRMAVR                                         = 0x290F01B5ull;

static const uint64_t P9N2_C_10_PPM_IVRMAVR                                        = 0x2A0F01B5ull;

static const uint64_t P9N2_C_11_PPM_IVRMAVR                                        = 0x2B0F01B5ull;

static const uint64_t P9N2_C_12_PPM_IVRMAVR                                        = 0x2C0F01B5ull;

static const uint64_t P9N2_C_13_PPM_IVRMAVR                                        = 0x2D0F01B5ull;

static const uint64_t P9N2_C_14_PPM_IVRMAVR                                        = 0x2E0F01B5ull;

static const uint64_t P9N2_C_15_PPM_IVRMAVR                                        = 0x2F0F01B5ull;

static const uint64_t P9N2_C_16_PPM_IVRMAVR                                        = 0x300F01B5ull;

static const uint64_t P9N2_C_17_PPM_IVRMAVR                                        = 0x310F01B5ull;

static const uint64_t P9N2_C_18_PPM_IVRMAVR                                        = 0x320F01B5ull;

static const uint64_t P9N2_C_19_PPM_IVRMAVR                                        = 0x330F01B5ull;

static const uint64_t P9N2_C_20_PPM_IVRMAVR                                        = 0x340F01B5ull;

static const uint64_t P9N2_C_21_PPM_IVRMAVR                                        = 0x350F01B5ull;

static const uint64_t P9N2_C_22_PPM_IVRMAVR                                        = 0x360F01B5ull;

static const uint64_t P9N2_C_23_PPM_IVRMAVR                                        = 0x370F01B5ull;

static const uint64_t P9N2_EQ_PPM_IVRMAVR                                          = 0x100F01B5ull;

static const uint64_t P9N2_EQ_0_PPM_IVRMAVR                                        = 0x100F01B5ull;

static const uint64_t P9N2_EQ_1_PPM_IVRMAVR                                        = 0x110F01B5ull;

static const uint64_t P9N2_EQ_2_PPM_IVRMAVR                                        = 0x120F01B5ull;

static const uint64_t P9N2_EQ_3_PPM_IVRMAVR                                        = 0x130F01B5ull;

static const uint64_t P9N2_EQ_4_PPM_IVRMAVR                                        = 0x140F01B5ull;

static const uint64_t P9N2_EQ_5_PPM_IVRMAVR                                        = 0x150F01B5ull;

static const uint64_t P9N2_EX_PPM_IVRMAVR                                          = 0x200F01B5ull;
//DUPS: 210F01B5,
static const uint64_t P9N2_EX_0_PPM_IVRMAVR                                        = 0x200F01B5ull;
//DUPS: 210F01B5,
static const uint64_t P9N2_EX_1_PPM_IVRMAVR                                        = 0x220F01B5ull;
//DUPS: 220F01B5,
static const uint64_t P9N2_EX_2_PPM_IVRMAVR                                        = 0x240F01B5ull;
//DUPS: 250F01B5,
static const uint64_t P9N2_EX_3_PPM_IVRMAVR                                        = 0x260F01B5ull;
//DUPS: 270F01B5,
static const uint64_t P9N2_EX_4_PPM_IVRMAVR                                        = 0x280F01B5ull;
//DUPS: 290F01B5,
static const uint64_t P9N2_EX_5_PPM_IVRMAVR                                        = 0x2A0F01B5ull;
//DUPS: 2B0F01B5,
static const uint64_t P9N2_EX_6_PPM_IVRMAVR                                        = 0x2C0F01B5ull;
//DUPS: 2D0F01B5,
static const uint64_t P9N2_EX_7_PPM_IVRMAVR                                        = 0x2E0F01B5ull;
//DUPS: 2F0F01B5,
static const uint64_t P9N2_EX_8_PPM_IVRMAVR                                        = 0x300F01B5ull;
//DUPS: 310F01B5,
static const uint64_t P9N2_EX_9_PPM_IVRMAVR                                        = 0x320F01B5ull;
//DUPS: 330F01B5,
static const uint64_t P9N2_EX_10_PPM_IVRMAVR                                       = 0x340F01B5ull;
//DUPS: 350F01B5,
static const uint64_t P9N2_EX_11_PPM_IVRMAVR                                       = 0x360F01B5ull;
//DUPS: 370F01B5,

static const uint64_t P9N2_C_PPM_IVRMCR                                            = 0x200F01B0ull;

static const uint64_t P9N2_C_PPM_IVRMCR_CLEAR                                      = 0x200F01B1ull;

static const uint64_t P9N2_C_PPM_IVRMCR_OR                                         = 0x200F01B2ull;

static const uint64_t P9N2_C_0_PPM_IVRMCR                                          = 0x200F01B0ull;

static const uint64_t P9N2_C_0_PPM_IVRMCR_CLEAR                                    = 0x200F01B1ull;

static const uint64_t P9N2_C_0_PPM_IVRMCR_OR                                       = 0x200F01B2ull;

static const uint64_t P9N2_C_1_PPM_IVRMCR                                          = 0x210F01B0ull;

static const uint64_t P9N2_C_1_PPM_IVRMCR_CLEAR                                    = 0x210F01B1ull;

static const uint64_t P9N2_C_1_PPM_IVRMCR_OR                                       = 0x210F01B2ull;

static const uint64_t P9N2_C_2_PPM_IVRMCR                                          = 0x220F01B0ull;

static const uint64_t P9N2_C_2_PPM_IVRMCR_CLEAR                                    = 0x220F01B1ull;

static const uint64_t P9N2_C_2_PPM_IVRMCR_OR                                       = 0x220F01B2ull;

static const uint64_t P9N2_C_3_PPM_IVRMCR                                          = 0x230F01B0ull;

static const uint64_t P9N2_C_3_PPM_IVRMCR_CLEAR                                    = 0x230F01B1ull;

static const uint64_t P9N2_C_3_PPM_IVRMCR_OR                                       = 0x230F01B2ull;

static const uint64_t P9N2_C_4_PPM_IVRMCR                                          = 0x240F01B0ull;

static const uint64_t P9N2_C_4_PPM_IVRMCR_CLEAR                                    = 0x240F01B1ull;

static const uint64_t P9N2_C_4_PPM_IVRMCR_OR                                       = 0x240F01B2ull;

static const uint64_t P9N2_C_5_PPM_IVRMCR                                          = 0x250F01B0ull;

static const uint64_t P9N2_C_5_PPM_IVRMCR_CLEAR                                    = 0x250F01B1ull;

static const uint64_t P9N2_C_5_PPM_IVRMCR_OR                                       = 0x250F01B2ull;

static const uint64_t P9N2_C_6_PPM_IVRMCR                                          = 0x260F01B0ull;

static const uint64_t P9N2_C_6_PPM_IVRMCR_CLEAR                                    = 0x260F01B1ull;

static const uint64_t P9N2_C_6_PPM_IVRMCR_OR                                       = 0x260F01B2ull;

static const uint64_t P9N2_C_7_PPM_IVRMCR                                          = 0x270F01B0ull;

static const uint64_t P9N2_C_7_PPM_IVRMCR_CLEAR                                    = 0x270F01B1ull;

static const uint64_t P9N2_C_7_PPM_IVRMCR_OR                                       = 0x270F01B2ull;

static const uint64_t P9N2_C_8_PPM_IVRMCR                                          = 0x280F01B0ull;

static const uint64_t P9N2_C_8_PPM_IVRMCR_CLEAR                                    = 0x280F01B1ull;

static const uint64_t P9N2_C_8_PPM_IVRMCR_OR                                       = 0x280F01B2ull;

static const uint64_t P9N2_C_9_PPM_IVRMCR                                          = 0x290F01B0ull;

static const uint64_t P9N2_C_9_PPM_IVRMCR_CLEAR                                    = 0x290F01B1ull;

static const uint64_t P9N2_C_9_PPM_IVRMCR_OR                                       = 0x290F01B2ull;

static const uint64_t P9N2_C_10_PPM_IVRMCR                                         = 0x2A0F01B0ull;

static const uint64_t P9N2_C_10_PPM_IVRMCR_CLEAR                                   = 0x2A0F01B1ull;

static const uint64_t P9N2_C_10_PPM_IVRMCR_OR                                      = 0x2A0F01B2ull;

static const uint64_t P9N2_C_11_PPM_IVRMCR                                         = 0x2B0F01B0ull;

static const uint64_t P9N2_C_11_PPM_IVRMCR_CLEAR                                   = 0x2B0F01B1ull;

static const uint64_t P9N2_C_11_PPM_IVRMCR_OR                                      = 0x2B0F01B2ull;

static const uint64_t P9N2_C_12_PPM_IVRMCR                                         = 0x2C0F01B0ull;

static const uint64_t P9N2_C_12_PPM_IVRMCR_CLEAR                                   = 0x2C0F01B1ull;

static const uint64_t P9N2_C_12_PPM_IVRMCR_OR                                      = 0x2C0F01B2ull;

static const uint64_t P9N2_C_13_PPM_IVRMCR                                         = 0x2D0F01B0ull;

static const uint64_t P9N2_C_13_PPM_IVRMCR_CLEAR                                   = 0x2D0F01B1ull;

static const uint64_t P9N2_C_13_PPM_IVRMCR_OR                                      = 0x2D0F01B2ull;

static const uint64_t P9N2_C_14_PPM_IVRMCR                                         = 0x2E0F01B0ull;

static const uint64_t P9N2_C_14_PPM_IVRMCR_CLEAR                                   = 0x2E0F01B1ull;

static const uint64_t P9N2_C_14_PPM_IVRMCR_OR                                      = 0x2E0F01B2ull;

static const uint64_t P9N2_C_15_PPM_IVRMCR                                         = 0x2F0F01B0ull;

static const uint64_t P9N2_C_15_PPM_IVRMCR_CLEAR                                   = 0x2F0F01B1ull;

static const uint64_t P9N2_C_15_PPM_IVRMCR_OR                                      = 0x2F0F01B2ull;

static const uint64_t P9N2_C_16_PPM_IVRMCR                                         = 0x300F01B0ull;

static const uint64_t P9N2_C_16_PPM_IVRMCR_CLEAR                                   = 0x300F01B1ull;

static const uint64_t P9N2_C_16_PPM_IVRMCR_OR                                      = 0x300F01B2ull;

static const uint64_t P9N2_C_17_PPM_IVRMCR                                         = 0x310F01B0ull;

static const uint64_t P9N2_C_17_PPM_IVRMCR_CLEAR                                   = 0x310F01B1ull;

static const uint64_t P9N2_C_17_PPM_IVRMCR_OR                                      = 0x310F01B2ull;

static const uint64_t P9N2_C_18_PPM_IVRMCR                                         = 0x320F01B0ull;

static const uint64_t P9N2_C_18_PPM_IVRMCR_CLEAR                                   = 0x320F01B1ull;

static const uint64_t P9N2_C_18_PPM_IVRMCR_OR                                      = 0x320F01B2ull;

static const uint64_t P9N2_C_19_PPM_IVRMCR                                         = 0x330F01B0ull;

static const uint64_t P9N2_C_19_PPM_IVRMCR_CLEAR                                   = 0x330F01B1ull;

static const uint64_t P9N2_C_19_PPM_IVRMCR_OR                                      = 0x330F01B2ull;

static const uint64_t P9N2_C_20_PPM_IVRMCR                                         = 0x340F01B0ull;

static const uint64_t P9N2_C_20_PPM_IVRMCR_CLEAR                                   = 0x340F01B1ull;

static const uint64_t P9N2_C_20_PPM_IVRMCR_OR                                      = 0x340F01B2ull;

static const uint64_t P9N2_C_21_PPM_IVRMCR                                         = 0x350F01B0ull;

static const uint64_t P9N2_C_21_PPM_IVRMCR_CLEAR                                   = 0x350F01B1ull;

static const uint64_t P9N2_C_21_PPM_IVRMCR_OR                                      = 0x350F01B2ull;

static const uint64_t P9N2_C_22_PPM_IVRMCR                                         = 0x360F01B0ull;

static const uint64_t P9N2_C_22_PPM_IVRMCR_CLEAR                                   = 0x360F01B1ull;

static const uint64_t P9N2_C_22_PPM_IVRMCR_OR                                      = 0x360F01B2ull;

static const uint64_t P9N2_C_23_PPM_IVRMCR                                         = 0x370F01B0ull;

static const uint64_t P9N2_C_23_PPM_IVRMCR_CLEAR                                   = 0x370F01B1ull;

static const uint64_t P9N2_C_23_PPM_IVRMCR_OR                                      = 0x370F01B2ull;

static const uint64_t P9N2_EQ_PPM_IVRMCR                                           = 0x100F01B0ull;

static const uint64_t P9N2_EQ_PPM_IVRMCR_CLEAR                                     = 0x100F01B1ull;

static const uint64_t P9N2_EQ_PPM_IVRMCR_OR                                        = 0x100F01B2ull;

static const uint64_t P9N2_EQ_0_PPM_IVRMCR                                         = 0x100F01B0ull;

static const uint64_t P9N2_EQ_0_PPM_IVRMCR_CLEAR                                   = 0x100F01B1ull;

static const uint64_t P9N2_EQ_0_PPM_IVRMCR_OR                                      = 0x100F01B2ull;

static const uint64_t P9N2_EQ_1_PPM_IVRMCR                                         = 0x110F01B0ull;

static const uint64_t P9N2_EQ_1_PPM_IVRMCR_CLEAR                                   = 0x110F01B1ull;

static const uint64_t P9N2_EQ_1_PPM_IVRMCR_OR                                      = 0x110F01B2ull;

static const uint64_t P9N2_EQ_2_PPM_IVRMCR                                         = 0x120F01B0ull;

static const uint64_t P9N2_EQ_2_PPM_IVRMCR_CLEAR                                   = 0x120F01B1ull;

static const uint64_t P9N2_EQ_2_PPM_IVRMCR_OR                                      = 0x120F01B2ull;

static const uint64_t P9N2_EQ_3_PPM_IVRMCR                                         = 0x130F01B0ull;

static const uint64_t P9N2_EQ_3_PPM_IVRMCR_CLEAR                                   = 0x130F01B1ull;

static const uint64_t P9N2_EQ_3_PPM_IVRMCR_OR                                      = 0x130F01B2ull;

static const uint64_t P9N2_EQ_4_PPM_IVRMCR                                         = 0x140F01B0ull;

static const uint64_t P9N2_EQ_4_PPM_IVRMCR_CLEAR                                   = 0x140F01B1ull;

static const uint64_t P9N2_EQ_4_PPM_IVRMCR_OR                                      = 0x140F01B2ull;

static const uint64_t P9N2_EQ_5_PPM_IVRMCR                                         = 0x150F01B0ull;

static const uint64_t P9N2_EQ_5_PPM_IVRMCR_CLEAR                                   = 0x150F01B1ull;

static const uint64_t P9N2_EQ_5_PPM_IVRMCR_OR                                      = 0x150F01B2ull;

static const uint64_t P9N2_EX_PPM_IVRMCR                                           = 0x200F01B0ull;
//DUPS: 210F01B0,
static const uint64_t P9N2_EX_PPM_IVRMCR_CLEAR                                     = 0x200F01B1ull;
//DUPS: 210F01B1,
static const uint64_t P9N2_EX_PPM_IVRMCR_OR                                        = 0x200F01B2ull;
//DUPS: 210F01B2,
static const uint64_t P9N2_EX_0_PPM_IVRMCR                                         = 0x200F01B0ull;
//DUPS: 210F01B0,
static const uint64_t P9N2_EX_0_PPM_IVRMCR_CLEAR                                   = 0x200F01B1ull;
//DUPS: 210F01B1,
static const uint64_t P9N2_EX_0_PPM_IVRMCR_OR                                      = 0x200F01B2ull;
//DUPS: 210F01B2,
static const uint64_t P9N2_EX_1_PPM_IVRMCR                                         = 0x220F01B0ull;
//DUPS: 220F01B0,
static const uint64_t P9N2_EX_1_PPM_IVRMCR_CLEAR                                   = 0x220F01B1ull;
//DUPS: 220F01B1,
static const uint64_t P9N2_EX_1_PPM_IVRMCR_OR                                      = 0x220F01B2ull;
//DUPS: 220F01B2,
static const uint64_t P9N2_EX_2_PPM_IVRMCR                                         = 0x240F01B0ull;
//DUPS: 250F01B0,
static const uint64_t P9N2_EX_2_PPM_IVRMCR_CLEAR                                   = 0x240F01B1ull;
//DUPS: 250F01B1,
static const uint64_t P9N2_EX_2_PPM_IVRMCR_OR                                      = 0x240F01B2ull;
//DUPS: 250F01B2,
static const uint64_t P9N2_EX_3_PPM_IVRMCR                                         = 0x260F01B0ull;
//DUPS: 270F01B0,
static const uint64_t P9N2_EX_3_PPM_IVRMCR_CLEAR                                   = 0x260F01B1ull;
//DUPS: 270F01B1,
static const uint64_t P9N2_EX_3_PPM_IVRMCR_OR                                      = 0x260F01B2ull;
//DUPS: 270F01B2,
static const uint64_t P9N2_EX_4_PPM_IVRMCR                                         = 0x280F01B0ull;
//DUPS: 290F01B0,
static const uint64_t P9N2_EX_4_PPM_IVRMCR_CLEAR                                   = 0x280F01B1ull;
//DUPS: 290F01B1,
static const uint64_t P9N2_EX_4_PPM_IVRMCR_OR                                      = 0x280F01B2ull;
//DUPS: 290F01B2,
static const uint64_t P9N2_EX_5_PPM_IVRMCR                                         = 0x2A0F01B0ull;
//DUPS: 2B0F01B0,
static const uint64_t P9N2_EX_5_PPM_IVRMCR_CLEAR                                   = 0x2A0F01B1ull;
//DUPS: 2B0F01B1,
static const uint64_t P9N2_EX_5_PPM_IVRMCR_OR                                      = 0x2A0F01B2ull;
//DUPS: 2B0F01B2,
static const uint64_t P9N2_EX_6_PPM_IVRMCR                                         = 0x2C0F01B0ull;
//DUPS: 2D0F01B0,
static const uint64_t P9N2_EX_6_PPM_IVRMCR_CLEAR                                   = 0x2C0F01B1ull;
//DUPS: 2D0F01B1,
static const uint64_t P9N2_EX_6_PPM_IVRMCR_OR                                      = 0x2C0F01B2ull;
//DUPS: 2D0F01B2,
static const uint64_t P9N2_EX_7_PPM_IVRMCR                                         = 0x2E0F01B0ull;
//DUPS: 2F0F01B0,
static const uint64_t P9N2_EX_7_PPM_IVRMCR_CLEAR                                   = 0x2E0F01B1ull;
//DUPS: 2F0F01B1,
static const uint64_t P9N2_EX_7_PPM_IVRMCR_OR                                      = 0x2E0F01B2ull;
//DUPS: 2F0F01B2,
static const uint64_t P9N2_EX_8_PPM_IVRMCR                                         = 0x300F01B0ull;
//DUPS: 310F01B0,
static const uint64_t P9N2_EX_8_PPM_IVRMCR_CLEAR                                   = 0x300F01B1ull;
//DUPS: 310F01B1,
static const uint64_t P9N2_EX_8_PPM_IVRMCR_OR                                      = 0x300F01B2ull;
//DUPS: 310F01B2,
static const uint64_t P9N2_EX_9_PPM_IVRMCR                                         = 0x320F01B0ull;
//DUPS: 330F01B0,
static const uint64_t P9N2_EX_9_PPM_IVRMCR_CLEAR                                   = 0x320F01B1ull;
//DUPS: 330F01B1,
static const uint64_t P9N2_EX_9_PPM_IVRMCR_OR                                      = 0x320F01B2ull;
//DUPS: 330F01B2,
static const uint64_t P9N2_EX_10_PPM_IVRMCR                                        = 0x340F01B0ull;
//DUPS: 350F01B0,
static const uint64_t P9N2_EX_10_PPM_IVRMCR_CLEAR                                  = 0x340F01B1ull;
//DUPS: 350F01B1,
static const uint64_t P9N2_EX_10_PPM_IVRMCR_OR                                     = 0x340F01B2ull;
//DUPS: 350F01B2,
static const uint64_t P9N2_EX_11_PPM_IVRMCR                                        = 0x360F01B0ull;
//DUPS: 370F01B0,
static const uint64_t P9N2_EX_11_PPM_IVRMCR_CLEAR                                  = 0x360F01B1ull;
//DUPS: 370F01B1,
static const uint64_t P9N2_EX_11_PPM_IVRMCR_OR                                     = 0x360F01B2ull;
//DUPS: 370F01B2,

static const uint64_t P9N2_C_PPM_IVRMDVR                                           = 0x200F01B4ull;

static const uint64_t P9N2_C_0_PPM_IVRMDVR                                         = 0x200F01B4ull;

static const uint64_t P9N2_C_1_PPM_IVRMDVR                                         = 0x210F01B4ull;

static const uint64_t P9N2_C_2_PPM_IVRMDVR                                         = 0x220F01B4ull;

static const uint64_t P9N2_C_3_PPM_IVRMDVR                                         = 0x230F01B4ull;

static const uint64_t P9N2_C_4_PPM_IVRMDVR                                         = 0x240F01B4ull;

static const uint64_t P9N2_C_5_PPM_IVRMDVR                                         = 0x250F01B4ull;

static const uint64_t P9N2_C_6_PPM_IVRMDVR                                         = 0x260F01B4ull;

static const uint64_t P9N2_C_7_PPM_IVRMDVR                                         = 0x270F01B4ull;

static const uint64_t P9N2_C_8_PPM_IVRMDVR                                         = 0x280F01B4ull;

static const uint64_t P9N2_C_9_PPM_IVRMDVR                                         = 0x290F01B4ull;

static const uint64_t P9N2_C_10_PPM_IVRMDVR                                        = 0x2A0F01B4ull;

static const uint64_t P9N2_C_11_PPM_IVRMDVR                                        = 0x2B0F01B4ull;

static const uint64_t P9N2_C_12_PPM_IVRMDVR                                        = 0x2C0F01B4ull;

static const uint64_t P9N2_C_13_PPM_IVRMDVR                                        = 0x2D0F01B4ull;

static const uint64_t P9N2_C_14_PPM_IVRMDVR                                        = 0x2E0F01B4ull;

static const uint64_t P9N2_C_15_PPM_IVRMDVR                                        = 0x2F0F01B4ull;

static const uint64_t P9N2_C_16_PPM_IVRMDVR                                        = 0x300F01B4ull;

static const uint64_t P9N2_C_17_PPM_IVRMDVR                                        = 0x310F01B4ull;

static const uint64_t P9N2_C_18_PPM_IVRMDVR                                        = 0x320F01B4ull;

static const uint64_t P9N2_C_19_PPM_IVRMDVR                                        = 0x330F01B4ull;

static const uint64_t P9N2_C_20_PPM_IVRMDVR                                        = 0x340F01B4ull;

static const uint64_t P9N2_C_21_PPM_IVRMDVR                                        = 0x350F01B4ull;

static const uint64_t P9N2_C_22_PPM_IVRMDVR                                        = 0x360F01B4ull;

static const uint64_t P9N2_C_23_PPM_IVRMDVR                                        = 0x370F01B4ull;

static const uint64_t P9N2_EQ_PPM_IVRMDVR                                          = 0x100F01B4ull;

static const uint64_t P9N2_EQ_0_PPM_IVRMDVR                                        = 0x100F01B4ull;

static const uint64_t P9N2_EQ_1_PPM_IVRMDVR                                        = 0x110F01B4ull;

static const uint64_t P9N2_EQ_2_PPM_IVRMDVR                                        = 0x120F01B4ull;

static const uint64_t P9N2_EQ_3_PPM_IVRMDVR                                        = 0x130F01B4ull;

static const uint64_t P9N2_EQ_4_PPM_IVRMDVR                                        = 0x140F01B4ull;

static const uint64_t P9N2_EQ_5_PPM_IVRMDVR                                        = 0x150F01B4ull;

static const uint64_t P9N2_EX_PPM_IVRMDVR                                          = 0x200F01B4ull;
//DUPS: 210F01B4,
static const uint64_t P9N2_EX_0_PPM_IVRMDVR                                        = 0x200F01B4ull;
//DUPS: 210F01B4,
static const uint64_t P9N2_EX_1_PPM_IVRMDVR                                        = 0x220F01B4ull;
//DUPS: 220F01B4,
static const uint64_t P9N2_EX_2_PPM_IVRMDVR                                        = 0x240F01B4ull;
//DUPS: 250F01B4,
static const uint64_t P9N2_EX_3_PPM_IVRMDVR                                        = 0x260F01B4ull;
//DUPS: 270F01B4,
static const uint64_t P9N2_EX_4_PPM_IVRMDVR                                        = 0x280F01B4ull;
//DUPS: 290F01B4,
static const uint64_t P9N2_EX_5_PPM_IVRMDVR                                        = 0x2A0F01B4ull;
//DUPS: 2B0F01B4,
static const uint64_t P9N2_EX_6_PPM_IVRMDVR                                        = 0x2C0F01B4ull;
//DUPS: 2D0F01B4,
static const uint64_t P9N2_EX_7_PPM_IVRMDVR                                        = 0x2E0F01B4ull;
//DUPS: 2F0F01B4,
static const uint64_t P9N2_EX_8_PPM_IVRMDVR                                        = 0x300F01B4ull;
//DUPS: 310F01B4,
static const uint64_t P9N2_EX_9_PPM_IVRMDVR                                        = 0x320F01B4ull;
//DUPS: 330F01B4,
static const uint64_t P9N2_EX_10_PPM_IVRMDVR                                       = 0x340F01B4ull;
//DUPS: 350F01B4,
static const uint64_t P9N2_EX_11_PPM_IVRMDVR                                       = 0x360F01B4ull;
//DUPS: 370F01B4,

static const uint64_t P9N2_C_PPM_IVRMST                                            = 0x200F01B3ull;

static const uint64_t P9N2_C_0_PPM_IVRMST                                          = 0x200F01B3ull;

static const uint64_t P9N2_C_1_PPM_IVRMST                                          = 0x210F01B3ull;

static const uint64_t P9N2_C_2_PPM_IVRMST                                          = 0x220F01B3ull;

static const uint64_t P9N2_C_3_PPM_IVRMST                                          = 0x230F01B3ull;

static const uint64_t P9N2_C_4_PPM_IVRMST                                          = 0x240F01B3ull;

static const uint64_t P9N2_C_5_PPM_IVRMST                                          = 0x250F01B3ull;

static const uint64_t P9N2_C_6_PPM_IVRMST                                          = 0x260F01B3ull;

static const uint64_t P9N2_C_7_PPM_IVRMST                                          = 0x270F01B3ull;

static const uint64_t P9N2_C_8_PPM_IVRMST                                          = 0x280F01B3ull;

static const uint64_t P9N2_C_9_PPM_IVRMST                                          = 0x290F01B3ull;

static const uint64_t P9N2_C_10_PPM_IVRMST                                         = 0x2A0F01B3ull;

static const uint64_t P9N2_C_11_PPM_IVRMST                                         = 0x2B0F01B3ull;

static const uint64_t P9N2_C_12_PPM_IVRMST                                         = 0x2C0F01B3ull;

static const uint64_t P9N2_C_13_PPM_IVRMST                                         = 0x2D0F01B3ull;

static const uint64_t P9N2_C_14_PPM_IVRMST                                         = 0x2E0F01B3ull;

static const uint64_t P9N2_C_15_PPM_IVRMST                                         = 0x2F0F01B3ull;

static const uint64_t P9N2_C_16_PPM_IVRMST                                         = 0x300F01B3ull;

static const uint64_t P9N2_C_17_PPM_IVRMST                                         = 0x310F01B3ull;

static const uint64_t P9N2_C_18_PPM_IVRMST                                         = 0x320F01B3ull;

static const uint64_t P9N2_C_19_PPM_IVRMST                                         = 0x330F01B3ull;

static const uint64_t P9N2_C_20_PPM_IVRMST                                         = 0x340F01B3ull;

static const uint64_t P9N2_C_21_PPM_IVRMST                                         = 0x350F01B3ull;

static const uint64_t P9N2_C_22_PPM_IVRMST                                         = 0x360F01B3ull;

static const uint64_t P9N2_C_23_PPM_IVRMST                                         = 0x370F01B3ull;

static const uint64_t P9N2_EQ_PPM_IVRMST                                           = 0x100F01B3ull;

static const uint64_t P9N2_EQ_0_PPM_IVRMST                                         = 0x100F01B3ull;

static const uint64_t P9N2_EQ_1_PPM_IVRMST                                         = 0x110F01B3ull;

static const uint64_t P9N2_EQ_2_PPM_IVRMST                                         = 0x120F01B3ull;

static const uint64_t P9N2_EQ_3_PPM_IVRMST                                         = 0x130F01B3ull;

static const uint64_t P9N2_EQ_4_PPM_IVRMST                                         = 0x140F01B3ull;

static const uint64_t P9N2_EQ_5_PPM_IVRMST                                         = 0x150F01B3ull;

static const uint64_t P9N2_EX_PPM_IVRMST                                           = 0x200F01B3ull;
//DUPS: 210F01B3,
static const uint64_t P9N2_EX_0_PPM_IVRMST                                         = 0x200F01B3ull;
//DUPS: 210F01B3,
static const uint64_t P9N2_EX_1_PPM_IVRMST                                         = 0x220F01B3ull;
//DUPS: 220F01B3,
static const uint64_t P9N2_EX_2_PPM_IVRMST                                         = 0x240F01B3ull;
//DUPS: 250F01B3,
static const uint64_t P9N2_EX_3_PPM_IVRMST                                         = 0x260F01B3ull;
//DUPS: 270F01B3,
static const uint64_t P9N2_EX_4_PPM_IVRMST                                         = 0x280F01B3ull;
//DUPS: 290F01B3,
static const uint64_t P9N2_EX_5_PPM_IVRMST                                         = 0x2A0F01B3ull;
//DUPS: 2B0F01B3,
static const uint64_t P9N2_EX_6_PPM_IVRMST                                         = 0x2C0F01B3ull;
//DUPS: 2D0F01B3,
static const uint64_t P9N2_EX_7_PPM_IVRMST                                         = 0x2E0F01B3ull;
//DUPS: 2F0F01B3,
static const uint64_t P9N2_EX_8_PPM_IVRMST                                         = 0x300F01B3ull;
//DUPS: 310F01B3,
static const uint64_t P9N2_EX_9_PPM_IVRMST                                         = 0x320F01B3ull;
//DUPS: 330F01B3,
static const uint64_t P9N2_EX_10_PPM_IVRMST                                        = 0x340F01B3ull;
//DUPS: 350F01B3,
static const uint64_t P9N2_EX_11_PPM_IVRMST                                        = 0x360F01B3ull;
//DUPS: 370F01B3,

static const uint64_t P9N2_C_PPM_PFCS_SCOM                                         = 0x200F0118ull;

static const uint64_t P9N2_C_PPM_PFCS_SCOM1                                        = 0x200F0119ull;

static const uint64_t P9N2_C_PPM_PFCS_SCOM2                                        = 0x200F011Aull;

static const uint64_t P9N2_C_0_PPM_PFCS_SCOM                                       = 0x200F0118ull;

static const uint64_t P9N2_C_0_PPM_PFCS_SCOM1                                      = 0x200F0119ull;

static const uint64_t P9N2_C_0_PPM_PFCS_SCOM2                                      = 0x200F011Aull;

static const uint64_t P9N2_C_1_PPM_PFCS_SCOM                                       = 0x210F0118ull;

static const uint64_t P9N2_C_1_PPM_PFCS_SCOM1                                      = 0x210F0119ull;

static const uint64_t P9N2_C_1_PPM_PFCS_SCOM2                                      = 0x210F011Aull;

static const uint64_t P9N2_C_2_PPM_PFCS_SCOM                                       = 0x220F0118ull;

static const uint64_t P9N2_C_2_PPM_PFCS_SCOM1                                      = 0x220F0119ull;

static const uint64_t P9N2_C_2_PPM_PFCS_SCOM2                                      = 0x220F011Aull;

static const uint64_t P9N2_C_3_PPM_PFCS_SCOM                                       = 0x230F0118ull;

static const uint64_t P9N2_C_3_PPM_PFCS_SCOM1                                      = 0x230F0119ull;

static const uint64_t P9N2_C_3_PPM_PFCS_SCOM2                                      = 0x230F011Aull;

static const uint64_t P9N2_C_4_PPM_PFCS_SCOM                                       = 0x240F0118ull;

static const uint64_t P9N2_C_4_PPM_PFCS_SCOM1                                      = 0x240F0119ull;

static const uint64_t P9N2_C_4_PPM_PFCS_SCOM2                                      = 0x240F011Aull;

static const uint64_t P9N2_C_5_PPM_PFCS_SCOM                                       = 0x250F0118ull;

static const uint64_t P9N2_C_5_PPM_PFCS_SCOM1                                      = 0x250F0119ull;

static const uint64_t P9N2_C_5_PPM_PFCS_SCOM2                                      = 0x250F011Aull;

static const uint64_t P9N2_C_6_PPM_PFCS_SCOM                                       = 0x260F0118ull;

static const uint64_t P9N2_C_6_PPM_PFCS_SCOM1                                      = 0x260F0119ull;

static const uint64_t P9N2_C_6_PPM_PFCS_SCOM2                                      = 0x260F011Aull;

static const uint64_t P9N2_C_7_PPM_PFCS_SCOM                                       = 0x270F0118ull;

static const uint64_t P9N2_C_7_PPM_PFCS_SCOM1                                      = 0x270F0119ull;

static const uint64_t P9N2_C_7_PPM_PFCS_SCOM2                                      = 0x270F011Aull;

static const uint64_t P9N2_C_8_PPM_PFCS_SCOM                                       = 0x280F0118ull;

static const uint64_t P9N2_C_8_PPM_PFCS_SCOM1                                      = 0x280F0119ull;

static const uint64_t P9N2_C_8_PPM_PFCS_SCOM2                                      = 0x280F011Aull;

static const uint64_t P9N2_C_9_PPM_PFCS_SCOM                                       = 0x290F0118ull;

static const uint64_t P9N2_C_9_PPM_PFCS_SCOM1                                      = 0x290F0119ull;

static const uint64_t P9N2_C_9_PPM_PFCS_SCOM2                                      = 0x290F011Aull;

static const uint64_t P9N2_C_10_PPM_PFCS_SCOM                                      = 0x2A0F0118ull;

static const uint64_t P9N2_C_10_PPM_PFCS_SCOM1                                     = 0x2A0F0119ull;

static const uint64_t P9N2_C_10_PPM_PFCS_SCOM2                                     = 0x2A0F011Aull;

static const uint64_t P9N2_C_11_PPM_PFCS_SCOM                                      = 0x2B0F0118ull;

static const uint64_t P9N2_C_11_PPM_PFCS_SCOM1                                     = 0x2B0F0119ull;

static const uint64_t P9N2_C_11_PPM_PFCS_SCOM2                                     = 0x2B0F011Aull;

static const uint64_t P9N2_C_12_PPM_PFCS_SCOM                                      = 0x2C0F0118ull;

static const uint64_t P9N2_C_12_PPM_PFCS_SCOM1                                     = 0x2C0F0119ull;

static const uint64_t P9N2_C_12_PPM_PFCS_SCOM2                                     = 0x2C0F011Aull;

static const uint64_t P9N2_C_13_PPM_PFCS_SCOM                                      = 0x2D0F0118ull;

static const uint64_t P9N2_C_13_PPM_PFCS_SCOM1                                     = 0x2D0F0119ull;

static const uint64_t P9N2_C_13_PPM_PFCS_SCOM2                                     = 0x2D0F011Aull;

static const uint64_t P9N2_C_14_PPM_PFCS_SCOM                                      = 0x2E0F0118ull;

static const uint64_t P9N2_C_14_PPM_PFCS_SCOM1                                     = 0x2E0F0119ull;

static const uint64_t P9N2_C_14_PPM_PFCS_SCOM2                                     = 0x2E0F011Aull;

static const uint64_t P9N2_C_15_PPM_PFCS_SCOM                                      = 0x2F0F0118ull;

static const uint64_t P9N2_C_15_PPM_PFCS_SCOM1                                     = 0x2F0F0119ull;

static const uint64_t P9N2_C_15_PPM_PFCS_SCOM2                                     = 0x2F0F011Aull;

static const uint64_t P9N2_C_16_PPM_PFCS_SCOM                                      = 0x300F0118ull;

static const uint64_t P9N2_C_16_PPM_PFCS_SCOM1                                     = 0x300F0119ull;

static const uint64_t P9N2_C_16_PPM_PFCS_SCOM2                                     = 0x300F011Aull;

static const uint64_t P9N2_C_17_PPM_PFCS_SCOM                                      = 0x310F0118ull;

static const uint64_t P9N2_C_17_PPM_PFCS_SCOM1                                     = 0x310F0119ull;

static const uint64_t P9N2_C_17_PPM_PFCS_SCOM2                                     = 0x310F011Aull;

static const uint64_t P9N2_C_18_PPM_PFCS_SCOM                                      = 0x320F0118ull;

static const uint64_t P9N2_C_18_PPM_PFCS_SCOM1                                     = 0x320F0119ull;

static const uint64_t P9N2_C_18_PPM_PFCS_SCOM2                                     = 0x320F011Aull;

static const uint64_t P9N2_C_19_PPM_PFCS_SCOM                                      = 0x330F0118ull;

static const uint64_t P9N2_C_19_PPM_PFCS_SCOM1                                     = 0x330F0119ull;

static const uint64_t P9N2_C_19_PPM_PFCS_SCOM2                                     = 0x330F011Aull;

static const uint64_t P9N2_C_20_PPM_PFCS_SCOM                                      = 0x340F0118ull;

static const uint64_t P9N2_C_20_PPM_PFCS_SCOM1                                     = 0x340F0119ull;

static const uint64_t P9N2_C_20_PPM_PFCS_SCOM2                                     = 0x340F011Aull;

static const uint64_t P9N2_C_21_PPM_PFCS_SCOM                                      = 0x350F0118ull;

static const uint64_t P9N2_C_21_PPM_PFCS_SCOM1                                     = 0x350F0119ull;

static const uint64_t P9N2_C_21_PPM_PFCS_SCOM2                                     = 0x350F011Aull;

static const uint64_t P9N2_C_22_PPM_PFCS_SCOM                                      = 0x360F0118ull;

static const uint64_t P9N2_C_22_PPM_PFCS_SCOM1                                     = 0x360F0119ull;

static const uint64_t P9N2_C_22_PPM_PFCS_SCOM2                                     = 0x360F011Aull;

static const uint64_t P9N2_C_23_PPM_PFCS_SCOM                                      = 0x370F0118ull;

static const uint64_t P9N2_C_23_PPM_PFCS_SCOM1                                     = 0x370F0119ull;

static const uint64_t P9N2_C_23_PPM_PFCS_SCOM2                                     = 0x370F011Aull;

static const uint64_t P9N2_EQ_PPM_PFCS_SCOM                                        = 0x100F0118ull;

static const uint64_t P9N2_EQ_PPM_PFCS_SCOM1                                       = 0x100F0119ull;

static const uint64_t P9N2_EQ_PPM_PFCS_SCOM2                                       = 0x100F011Aull;

static const uint64_t P9N2_EQ_0_PPM_PFCS_SCOM                                      = 0x100F0118ull;

static const uint64_t P9N2_EQ_0_PPM_PFCS_SCOM1                                     = 0x100F0119ull;

static const uint64_t P9N2_EQ_0_PPM_PFCS_SCOM2                                     = 0x100F011Aull;

static const uint64_t P9N2_EQ_1_PPM_PFCS_SCOM                                      = 0x110F0118ull;

static const uint64_t P9N2_EQ_1_PPM_PFCS_SCOM1                                     = 0x110F0119ull;

static const uint64_t P9N2_EQ_1_PPM_PFCS_SCOM2                                     = 0x110F011Aull;

static const uint64_t P9N2_EQ_2_PPM_PFCS_SCOM                                      = 0x120F0118ull;

static const uint64_t P9N2_EQ_2_PPM_PFCS_SCOM1                                     = 0x120F0119ull;

static const uint64_t P9N2_EQ_2_PPM_PFCS_SCOM2                                     = 0x120F011Aull;

static const uint64_t P9N2_EQ_3_PPM_PFCS_SCOM                                      = 0x130F0118ull;

static const uint64_t P9N2_EQ_3_PPM_PFCS_SCOM1                                     = 0x130F0119ull;

static const uint64_t P9N2_EQ_3_PPM_PFCS_SCOM2                                     = 0x130F011Aull;

static const uint64_t P9N2_EQ_4_PPM_PFCS_SCOM                                      = 0x140F0118ull;

static const uint64_t P9N2_EQ_4_PPM_PFCS_SCOM1                                     = 0x140F0119ull;

static const uint64_t P9N2_EQ_4_PPM_PFCS_SCOM2                                     = 0x140F011Aull;

static const uint64_t P9N2_EQ_5_PPM_PFCS_SCOM                                      = 0x150F0118ull;

static const uint64_t P9N2_EQ_5_PPM_PFCS_SCOM1                                     = 0x150F0119ull;

static const uint64_t P9N2_EQ_5_PPM_PFCS_SCOM2                                     = 0x150F011Aull;

static const uint64_t P9N2_EX_PPM_PFCS_SCOM                                        = 0x200F0118ull;
//DUPS: 210F0118,
static const uint64_t P9N2_EX_PPM_PFCS_SCOM1                                       = 0x200F0119ull;
//DUPS: 210F0119,
static const uint64_t P9N2_EX_PPM_PFCS_SCOM2                                       = 0x200F011Aull;
//DUPS: 210F011A,
static const uint64_t P9N2_EX_0_PPM_PFCS_SCOM                                      = 0x200F0118ull;
//DUPS: 210F0118,
static const uint64_t P9N2_EX_0_PPM_PFCS_SCOM1                                     = 0x200F0119ull;
//DUPS: 210F0119,
static const uint64_t P9N2_EX_0_PPM_PFCS_SCOM2                                     = 0x200F011Aull;
//DUPS: 210F011A,
static const uint64_t P9N2_EX_1_PPM_PFCS_SCOM                                      = 0x220F0118ull;
//DUPS: 220F0118,
static const uint64_t P9N2_EX_1_PPM_PFCS_SCOM1                                     = 0x220F0119ull;
//DUPS: 220F0119,
static const uint64_t P9N2_EX_1_PPM_PFCS_SCOM2                                     = 0x220F011Aull;
//DUPS: 220F011A,
static const uint64_t P9N2_EX_2_PPM_PFCS_SCOM                                      = 0x240F0118ull;
//DUPS: 250F0118,
static const uint64_t P9N2_EX_2_PPM_PFCS_SCOM1                                     = 0x240F0119ull;
//DUPS: 250F0119,
static const uint64_t P9N2_EX_2_PPM_PFCS_SCOM2                                     = 0x240F011Aull;
//DUPS: 250F011A,
static const uint64_t P9N2_EX_3_PPM_PFCS_SCOM                                      = 0x260F0118ull;
//DUPS: 270F0118,
static const uint64_t P9N2_EX_3_PPM_PFCS_SCOM1                                     = 0x260F0119ull;
//DUPS: 270F0119,
static const uint64_t P9N2_EX_3_PPM_PFCS_SCOM2                                     = 0x260F011Aull;
//DUPS: 270F011A,
static const uint64_t P9N2_EX_4_PPM_PFCS_SCOM                                      = 0x280F0118ull;
//DUPS: 290F0118,
static const uint64_t P9N2_EX_4_PPM_PFCS_SCOM1                                     = 0x280F0119ull;
//DUPS: 290F0119,
static const uint64_t P9N2_EX_4_PPM_PFCS_SCOM2                                     = 0x280F011Aull;
//DUPS: 290F011A,
static const uint64_t P9N2_EX_5_PPM_PFCS_SCOM                                      = 0x2A0F0118ull;
//DUPS: 2B0F0118,
static const uint64_t P9N2_EX_5_PPM_PFCS_SCOM1                                     = 0x2A0F0119ull;
//DUPS: 2B0F0119,
static const uint64_t P9N2_EX_5_PPM_PFCS_SCOM2                                     = 0x2A0F011Aull;
//DUPS: 2B0F011A,
static const uint64_t P9N2_EX_6_PPM_PFCS_SCOM                                      = 0x2C0F0118ull;
//DUPS: 2D0F0118,
static const uint64_t P9N2_EX_6_PPM_PFCS_SCOM1                                     = 0x2C0F0119ull;
//DUPS: 2D0F0119,
static const uint64_t P9N2_EX_6_PPM_PFCS_SCOM2                                     = 0x2C0F011Aull;
//DUPS: 2D0F011A,
static const uint64_t P9N2_EX_7_PPM_PFCS_SCOM                                      = 0x2E0F0118ull;
//DUPS: 2F0F0118,
static const uint64_t P9N2_EX_7_PPM_PFCS_SCOM1                                     = 0x2E0F0119ull;
//DUPS: 2F0F0119,
static const uint64_t P9N2_EX_7_PPM_PFCS_SCOM2                                     = 0x2E0F011Aull;
//DUPS: 2F0F011A,
static const uint64_t P9N2_EX_8_PPM_PFCS_SCOM                                      = 0x300F0118ull;
//DUPS: 310F0118,
static const uint64_t P9N2_EX_8_PPM_PFCS_SCOM1                                     = 0x300F0119ull;
//DUPS: 310F0119,
static const uint64_t P9N2_EX_8_PPM_PFCS_SCOM2                                     = 0x300F011Aull;
//DUPS: 310F011A,
static const uint64_t P9N2_EX_9_PPM_PFCS_SCOM                                      = 0x320F0118ull;
//DUPS: 330F0118,
static const uint64_t P9N2_EX_9_PPM_PFCS_SCOM1                                     = 0x320F0119ull;
//DUPS: 330F0119,
static const uint64_t P9N2_EX_9_PPM_PFCS_SCOM2                                     = 0x320F011Aull;
//DUPS: 330F011A,
static const uint64_t P9N2_EX_10_PPM_PFCS_SCOM                                     = 0x340F0118ull;
//DUPS: 350F0118,
static const uint64_t P9N2_EX_10_PPM_PFCS_SCOM1                                    = 0x340F0119ull;
//DUPS: 350F0119,
static const uint64_t P9N2_EX_10_PPM_PFCS_SCOM2                                    = 0x340F011Aull;
//DUPS: 350F011A,
static const uint64_t P9N2_EX_11_PPM_PFCS_SCOM                                     = 0x360F0118ull;
//DUPS: 370F0118,
static const uint64_t P9N2_EX_11_PPM_PFCS_SCOM1                                    = 0x360F0119ull;
//DUPS: 370F0119,
static const uint64_t P9N2_EX_11_PPM_PFCS_SCOM2                                    = 0x360F011Aull;
//DUPS: 370F011A,

static const uint64_t P9N2_C_PPM_PFDLY                                             = 0x200F011Bull;

static const uint64_t P9N2_C_0_PPM_PFDLY                                           = 0x200F011Bull;

static const uint64_t P9N2_C_1_PPM_PFDLY                                           = 0x210F011Bull;

static const uint64_t P9N2_C_2_PPM_PFDLY                                           = 0x220F011Bull;

static const uint64_t P9N2_C_3_PPM_PFDLY                                           = 0x230F011Bull;

static const uint64_t P9N2_C_4_PPM_PFDLY                                           = 0x240F011Bull;

static const uint64_t P9N2_C_5_PPM_PFDLY                                           = 0x250F011Bull;

static const uint64_t P9N2_C_6_PPM_PFDLY                                           = 0x260F011Bull;

static const uint64_t P9N2_C_7_PPM_PFDLY                                           = 0x270F011Bull;

static const uint64_t P9N2_C_8_PPM_PFDLY                                           = 0x280F011Bull;

static const uint64_t P9N2_C_9_PPM_PFDLY                                           = 0x290F011Bull;

static const uint64_t P9N2_C_10_PPM_PFDLY                                          = 0x2A0F011Bull;

static const uint64_t P9N2_C_11_PPM_PFDLY                                          = 0x2B0F011Bull;

static const uint64_t P9N2_C_12_PPM_PFDLY                                          = 0x2C0F011Bull;

static const uint64_t P9N2_C_13_PPM_PFDLY                                          = 0x2D0F011Bull;

static const uint64_t P9N2_C_14_PPM_PFDLY                                          = 0x2E0F011Bull;

static const uint64_t P9N2_C_15_PPM_PFDLY                                          = 0x2F0F011Bull;

static const uint64_t P9N2_C_16_PPM_PFDLY                                          = 0x300F011Bull;

static const uint64_t P9N2_C_17_PPM_PFDLY                                          = 0x310F011Bull;

static const uint64_t P9N2_C_18_PPM_PFDLY                                          = 0x320F011Bull;

static const uint64_t P9N2_C_19_PPM_PFDLY                                          = 0x330F011Bull;

static const uint64_t P9N2_C_20_PPM_PFDLY                                          = 0x340F011Bull;

static const uint64_t P9N2_C_21_PPM_PFDLY                                          = 0x350F011Bull;

static const uint64_t P9N2_C_22_PPM_PFDLY                                          = 0x360F011Bull;

static const uint64_t P9N2_C_23_PPM_PFDLY                                          = 0x370F011Bull;

static const uint64_t P9N2_EQ_PPM_PFDLY                                            = 0x100F011Bull;

static const uint64_t P9N2_EQ_0_PPM_PFDLY                                          = 0x100F011Bull;

static const uint64_t P9N2_EQ_1_PPM_PFDLY                                          = 0x110F011Bull;

static const uint64_t P9N2_EQ_2_PPM_PFDLY                                          = 0x120F011Bull;

static const uint64_t P9N2_EQ_3_PPM_PFDLY                                          = 0x130F011Bull;

static const uint64_t P9N2_EQ_4_PPM_PFDLY                                          = 0x140F011Bull;

static const uint64_t P9N2_EQ_5_PPM_PFDLY                                          = 0x150F011Bull;

static const uint64_t P9N2_EX_PPM_PFDLY                                            = 0x200F011Bull;
//DUPS: 210F011B,
static const uint64_t P9N2_EX_0_PPM_PFDLY                                          = 0x200F011Bull;
//DUPS: 210F011B,
static const uint64_t P9N2_EX_1_PPM_PFDLY                                          = 0x220F011Bull;
//DUPS: 220F011B,
static const uint64_t P9N2_EX_2_PPM_PFDLY                                          = 0x240F011Bull;
//DUPS: 250F011B,
static const uint64_t P9N2_EX_3_PPM_PFDLY                                          = 0x260F011Bull;
//DUPS: 270F011B,
static const uint64_t P9N2_EX_4_PPM_PFDLY                                          = 0x280F011Bull;
//DUPS: 290F011B,
static const uint64_t P9N2_EX_5_PPM_PFDLY                                          = 0x2A0F011Bull;
//DUPS: 2B0F011B,
static const uint64_t P9N2_EX_6_PPM_PFDLY                                          = 0x2C0F011Bull;
//DUPS: 2D0F011B,
static const uint64_t P9N2_EX_7_PPM_PFDLY                                          = 0x2E0F011Bull;
//DUPS: 2F0F011B,
static const uint64_t P9N2_EX_8_PPM_PFDLY                                          = 0x300F011Bull;
//DUPS: 310F011B,
static const uint64_t P9N2_EX_9_PPM_PFDLY                                          = 0x320F011Bull;
//DUPS: 330F011B,
static const uint64_t P9N2_EX_10_PPM_PFDLY                                         = 0x340F011Bull;
//DUPS: 350F011B,
static const uint64_t P9N2_EX_11_PPM_PFDLY                                         = 0x360F011Bull;
//DUPS: 370F011B,

static const uint64_t P9N2_C_PPM_PFOFF                                             = 0x200F011Dull;

static const uint64_t P9N2_C_0_PPM_PFOFF                                           = 0x200F011Dull;

static const uint64_t P9N2_C_1_PPM_PFOFF                                           = 0x210F011Dull;

static const uint64_t P9N2_C_2_PPM_PFOFF                                           = 0x220F011Dull;

static const uint64_t P9N2_C_3_PPM_PFOFF                                           = 0x230F011Dull;

static const uint64_t P9N2_C_4_PPM_PFOFF                                           = 0x240F011Dull;

static const uint64_t P9N2_C_5_PPM_PFOFF                                           = 0x250F011Dull;

static const uint64_t P9N2_C_6_PPM_PFOFF                                           = 0x260F011Dull;

static const uint64_t P9N2_C_7_PPM_PFOFF                                           = 0x270F011Dull;

static const uint64_t P9N2_C_8_PPM_PFOFF                                           = 0x280F011Dull;

static const uint64_t P9N2_C_9_PPM_PFOFF                                           = 0x290F011Dull;

static const uint64_t P9N2_C_10_PPM_PFOFF                                          = 0x2A0F011Dull;

static const uint64_t P9N2_C_11_PPM_PFOFF                                          = 0x2B0F011Dull;

static const uint64_t P9N2_C_12_PPM_PFOFF                                          = 0x2C0F011Dull;

static const uint64_t P9N2_C_13_PPM_PFOFF                                          = 0x2D0F011Dull;

static const uint64_t P9N2_C_14_PPM_PFOFF                                          = 0x2E0F011Dull;

static const uint64_t P9N2_C_15_PPM_PFOFF                                          = 0x2F0F011Dull;

static const uint64_t P9N2_C_16_PPM_PFOFF                                          = 0x300F011Dull;

static const uint64_t P9N2_C_17_PPM_PFOFF                                          = 0x310F011Dull;

static const uint64_t P9N2_C_18_PPM_PFOFF                                          = 0x320F011Dull;

static const uint64_t P9N2_C_19_PPM_PFOFF                                          = 0x330F011Dull;

static const uint64_t P9N2_C_20_PPM_PFOFF                                          = 0x340F011Dull;

static const uint64_t P9N2_C_21_PPM_PFOFF                                          = 0x350F011Dull;

static const uint64_t P9N2_C_22_PPM_PFOFF                                          = 0x360F011Dull;

static const uint64_t P9N2_C_23_PPM_PFOFF                                          = 0x370F011Dull;

static const uint64_t P9N2_EQ_PPM_PFOFF                                            = 0x100F011Dull;

static const uint64_t P9N2_EQ_0_PPM_PFOFF                                          = 0x100F011Dull;

static const uint64_t P9N2_EQ_1_PPM_PFOFF                                          = 0x110F011Dull;

static const uint64_t P9N2_EQ_2_PPM_PFOFF                                          = 0x120F011Dull;

static const uint64_t P9N2_EQ_3_PPM_PFOFF                                          = 0x130F011Dull;

static const uint64_t P9N2_EQ_4_PPM_PFOFF                                          = 0x140F011Dull;

static const uint64_t P9N2_EQ_5_PPM_PFOFF                                          = 0x150F011Dull;

static const uint64_t P9N2_EX_PPM_PFOFF                                            = 0x200F011Dull;
//DUPS: 210F011D,
static const uint64_t P9N2_EX_0_PPM_PFOFF                                          = 0x200F011Dull;
//DUPS: 210F011D,
static const uint64_t P9N2_EX_1_PPM_PFOFF                                          = 0x220F011Dull;
//DUPS: 220F011D,
static const uint64_t P9N2_EX_2_PPM_PFOFF                                          = 0x240F011Dull;
//DUPS: 250F011D,
static const uint64_t P9N2_EX_3_PPM_PFOFF                                          = 0x260F011Dull;
//DUPS: 270F011D,
static const uint64_t P9N2_EX_4_PPM_PFOFF                                          = 0x280F011Dull;
//DUPS: 290F011D,
static const uint64_t P9N2_EX_5_PPM_PFOFF                                          = 0x2A0F011Dull;
//DUPS: 2B0F011D,
static const uint64_t P9N2_EX_6_PPM_PFOFF                                          = 0x2C0F011Dull;
//DUPS: 2D0F011D,
static const uint64_t P9N2_EX_7_PPM_PFOFF                                          = 0x2E0F011Dull;
//DUPS: 2F0F011D,
static const uint64_t P9N2_EX_8_PPM_PFOFF                                          = 0x300F011Dull;
//DUPS: 310F011D,
static const uint64_t P9N2_EX_9_PPM_PFOFF                                          = 0x320F011Dull;
//DUPS: 330F011D,
static const uint64_t P9N2_EX_10_PPM_PFOFF                                         = 0x340F011Dull;
//DUPS: 350F011D,
static const uint64_t P9N2_EX_11_PPM_PFOFF                                         = 0x360F011Dull;
//DUPS: 370F011D,

static const uint64_t P9N2_C_PPM_PFSNS                                             = 0x200F011Cull;

static const uint64_t P9N2_C_0_PPM_PFSNS                                           = 0x200F011Cull;

static const uint64_t P9N2_C_1_PPM_PFSNS                                           = 0x210F011Cull;

static const uint64_t P9N2_C_2_PPM_PFSNS                                           = 0x220F011Cull;

static const uint64_t P9N2_C_3_PPM_PFSNS                                           = 0x230F011Cull;

static const uint64_t P9N2_C_4_PPM_PFSNS                                           = 0x240F011Cull;

static const uint64_t P9N2_C_5_PPM_PFSNS                                           = 0x250F011Cull;

static const uint64_t P9N2_C_6_PPM_PFSNS                                           = 0x260F011Cull;

static const uint64_t P9N2_C_7_PPM_PFSNS                                           = 0x270F011Cull;

static const uint64_t P9N2_C_8_PPM_PFSNS                                           = 0x280F011Cull;

static const uint64_t P9N2_C_9_PPM_PFSNS                                           = 0x290F011Cull;

static const uint64_t P9N2_C_10_PPM_PFSNS                                          = 0x2A0F011Cull;

static const uint64_t P9N2_C_11_PPM_PFSNS                                          = 0x2B0F011Cull;

static const uint64_t P9N2_C_12_PPM_PFSNS                                          = 0x2C0F011Cull;

static const uint64_t P9N2_C_13_PPM_PFSNS                                          = 0x2D0F011Cull;

static const uint64_t P9N2_C_14_PPM_PFSNS                                          = 0x2E0F011Cull;

static const uint64_t P9N2_C_15_PPM_PFSNS                                          = 0x2F0F011Cull;

static const uint64_t P9N2_C_16_PPM_PFSNS                                          = 0x300F011Cull;

static const uint64_t P9N2_C_17_PPM_PFSNS                                          = 0x310F011Cull;

static const uint64_t P9N2_C_18_PPM_PFSNS                                          = 0x320F011Cull;

static const uint64_t P9N2_C_19_PPM_PFSNS                                          = 0x330F011Cull;

static const uint64_t P9N2_C_20_PPM_PFSNS                                          = 0x340F011Cull;

static const uint64_t P9N2_C_21_PPM_PFSNS                                          = 0x350F011Cull;

static const uint64_t P9N2_C_22_PPM_PFSNS                                          = 0x360F011Cull;

static const uint64_t P9N2_C_23_PPM_PFSNS                                          = 0x370F011Cull;

static const uint64_t P9N2_EQ_PPM_PFSNS                                            = 0x100F011Cull;

static const uint64_t P9N2_EQ_0_PPM_PFSNS                                          = 0x100F011Cull;

static const uint64_t P9N2_EQ_1_PPM_PFSNS                                          = 0x110F011Cull;

static const uint64_t P9N2_EQ_2_PPM_PFSNS                                          = 0x120F011Cull;

static const uint64_t P9N2_EQ_3_PPM_PFSNS                                          = 0x130F011Cull;

static const uint64_t P9N2_EQ_4_PPM_PFSNS                                          = 0x140F011Cull;

static const uint64_t P9N2_EQ_5_PPM_PFSNS                                          = 0x150F011Cull;

static const uint64_t P9N2_EX_PPM_PFSNS                                            = 0x200F011Cull;
//DUPS: 210F011C,
static const uint64_t P9N2_EX_0_PPM_PFSNS                                          = 0x200F011Cull;
//DUPS: 210F011C,
static const uint64_t P9N2_EX_1_PPM_PFSNS                                          = 0x220F011Cull;
//DUPS: 220F011C,
static const uint64_t P9N2_EX_2_PPM_PFSNS                                          = 0x240F011Cull;
//DUPS: 250F011C,
static const uint64_t P9N2_EX_3_PPM_PFSNS                                          = 0x260F011Cull;
//DUPS: 270F011C,
static const uint64_t P9N2_EX_4_PPM_PFSNS                                          = 0x280F011Cull;
//DUPS: 290F011C,
static const uint64_t P9N2_EX_5_PPM_PFSNS                                          = 0x2A0F011Cull;
//DUPS: 2B0F011C,
static const uint64_t P9N2_EX_6_PPM_PFSNS                                          = 0x2C0F011Cull;
//DUPS: 2D0F011C,
static const uint64_t P9N2_EX_7_PPM_PFSNS                                          = 0x2E0F011Cull;
//DUPS: 2F0F011C,
static const uint64_t P9N2_EX_8_PPM_PFSNS                                          = 0x300F011Cull;
//DUPS: 310F011C,
static const uint64_t P9N2_EX_9_PPM_PFSNS                                          = 0x320F011Cull;
//DUPS: 330F011C,
static const uint64_t P9N2_EX_10_PPM_PFSNS                                         = 0x340F011Cull;
//DUPS: 350F011C,
static const uint64_t P9N2_EX_11_PPM_PFSNS                                         = 0x360F011Cull;
//DUPS: 370F011C,

static const uint64_t P9N2_C_PPM_PIG                                               = 0x200F0180ull;

static const uint64_t P9N2_C_0_PPM_PIG                                             = 0x200F0180ull;

static const uint64_t P9N2_C_1_PPM_PIG                                             = 0x210F0180ull;

static const uint64_t P9N2_C_2_PPM_PIG                                             = 0x220F0180ull;

static const uint64_t P9N2_C_3_PPM_PIG                                             = 0x230F0180ull;

static const uint64_t P9N2_C_4_PPM_PIG                                             = 0x240F0180ull;

static const uint64_t P9N2_C_5_PPM_PIG                                             = 0x250F0180ull;

static const uint64_t P9N2_C_6_PPM_PIG                                             = 0x260F0180ull;

static const uint64_t P9N2_C_7_PPM_PIG                                             = 0x270F0180ull;

static const uint64_t P9N2_C_8_PPM_PIG                                             = 0x280F0180ull;

static const uint64_t P9N2_C_9_PPM_PIG                                             = 0x290F0180ull;

static const uint64_t P9N2_C_10_PPM_PIG                                            = 0x2A0F0180ull;

static const uint64_t P9N2_C_11_PPM_PIG                                            = 0x2B0F0180ull;

static const uint64_t P9N2_C_12_PPM_PIG                                            = 0x2C0F0180ull;

static const uint64_t P9N2_C_13_PPM_PIG                                            = 0x2D0F0180ull;

static const uint64_t P9N2_C_14_PPM_PIG                                            = 0x2E0F0180ull;

static const uint64_t P9N2_C_15_PPM_PIG                                            = 0x2F0F0180ull;

static const uint64_t P9N2_C_16_PPM_PIG                                            = 0x300F0180ull;

static const uint64_t P9N2_C_17_PPM_PIG                                            = 0x310F0180ull;

static const uint64_t P9N2_C_18_PPM_PIG                                            = 0x320F0180ull;

static const uint64_t P9N2_C_19_PPM_PIG                                            = 0x330F0180ull;

static const uint64_t P9N2_C_20_PPM_PIG                                            = 0x340F0180ull;

static const uint64_t P9N2_C_21_PPM_PIG                                            = 0x350F0180ull;

static const uint64_t P9N2_C_22_PPM_PIG                                            = 0x360F0180ull;

static const uint64_t P9N2_C_23_PPM_PIG                                            = 0x370F0180ull;

static const uint64_t P9N2_EQ_PPM_PIG                                              = 0x100F0180ull;

static const uint64_t P9N2_EQ_0_PPM_PIG                                            = 0x100F0180ull;

static const uint64_t P9N2_EQ_1_PPM_PIG                                            = 0x110F0180ull;

static const uint64_t P9N2_EQ_2_PPM_PIG                                            = 0x120F0180ull;

static const uint64_t P9N2_EQ_3_PPM_PIG                                            = 0x130F0180ull;

static const uint64_t P9N2_EQ_4_PPM_PIG                                            = 0x140F0180ull;

static const uint64_t P9N2_EQ_5_PPM_PIG                                            = 0x150F0180ull;

static const uint64_t P9N2_EX_PPM_PIG                                              = 0x200F0180ull;
//DUPS: 210F0180,
static const uint64_t P9N2_EX_0_PPM_PIG                                            = 0x200F0180ull;
//DUPS: 210F0180,
static const uint64_t P9N2_EX_1_PPM_PIG                                            = 0x220F0180ull;
//DUPS: 220F0180,
static const uint64_t P9N2_EX_2_PPM_PIG                                            = 0x240F0180ull;
//DUPS: 250F0180,
static const uint64_t P9N2_EX_3_PPM_PIG                                            = 0x260F0180ull;
//DUPS: 270F0180,
static const uint64_t P9N2_EX_4_PPM_PIG                                            = 0x280F0180ull;
//DUPS: 290F0180,
static const uint64_t P9N2_EX_5_PPM_PIG                                            = 0x2A0F0180ull;
//DUPS: 2B0F0180,
static const uint64_t P9N2_EX_6_PPM_PIG                                            = 0x2C0F0180ull;
//DUPS: 2D0F0180,
static const uint64_t P9N2_EX_7_PPM_PIG                                            = 0x2E0F0180ull;
//DUPS: 2F0F0180,
static const uint64_t P9N2_EX_8_PPM_PIG                                            = 0x300F0180ull;
//DUPS: 310F0180,
static const uint64_t P9N2_EX_9_PPM_PIG                                            = 0x320F0180ull;
//DUPS: 330F0180,
static const uint64_t P9N2_EX_10_PPM_PIG                                           = 0x340F0180ull;
//DUPS: 350F0180,
static const uint64_t P9N2_EX_11_PPM_PIG                                           = 0x360F0180ull;
//DUPS: 370F0180,

static const uint64_t P9N2_C_PPM_SCRATCH0                                          = 0x200F011Eull;

static const uint64_t P9N2_C_0_PPM_SCRATCH0                                        = 0x200F011Eull;

static const uint64_t P9N2_C_1_PPM_SCRATCH0                                        = 0x210F011Eull;

static const uint64_t P9N2_C_2_PPM_SCRATCH0                                        = 0x220F011Eull;

static const uint64_t P9N2_C_3_PPM_SCRATCH0                                        = 0x230F011Eull;

static const uint64_t P9N2_C_4_PPM_SCRATCH0                                        = 0x240F011Eull;

static const uint64_t P9N2_C_5_PPM_SCRATCH0                                        = 0x250F011Eull;

static const uint64_t P9N2_C_6_PPM_SCRATCH0                                        = 0x260F011Eull;

static const uint64_t P9N2_C_7_PPM_SCRATCH0                                        = 0x270F011Eull;

static const uint64_t P9N2_C_8_PPM_SCRATCH0                                        = 0x280F011Eull;

static const uint64_t P9N2_C_9_PPM_SCRATCH0                                        = 0x290F011Eull;

static const uint64_t P9N2_C_10_PPM_SCRATCH0                                       = 0x2A0F011Eull;

static const uint64_t P9N2_C_11_PPM_SCRATCH0                                       = 0x2B0F011Eull;

static const uint64_t P9N2_C_12_PPM_SCRATCH0                                       = 0x2C0F011Eull;

static const uint64_t P9N2_C_13_PPM_SCRATCH0                                       = 0x2D0F011Eull;

static const uint64_t P9N2_C_14_PPM_SCRATCH0                                       = 0x2E0F011Eull;

static const uint64_t P9N2_C_15_PPM_SCRATCH0                                       = 0x2F0F011Eull;

static const uint64_t P9N2_C_16_PPM_SCRATCH0                                       = 0x300F011Eull;

static const uint64_t P9N2_C_17_PPM_SCRATCH0                                       = 0x310F011Eull;

static const uint64_t P9N2_C_18_PPM_SCRATCH0                                       = 0x320F011Eull;

static const uint64_t P9N2_C_19_PPM_SCRATCH0                                       = 0x330F011Eull;

static const uint64_t P9N2_C_20_PPM_SCRATCH0                                       = 0x340F011Eull;

static const uint64_t P9N2_C_21_PPM_SCRATCH0                                       = 0x350F011Eull;

static const uint64_t P9N2_C_22_PPM_SCRATCH0                                       = 0x360F011Eull;

static const uint64_t P9N2_C_23_PPM_SCRATCH0                                       = 0x370F011Eull;

static const uint64_t P9N2_EQ_PPM_SCRATCH0                                         = 0x100F011Eull;

static const uint64_t P9N2_EQ_0_PPM_SCRATCH0                                       = 0x100F011Eull;

static const uint64_t P9N2_EQ_1_PPM_SCRATCH0                                       = 0x110F011Eull;

static const uint64_t P9N2_EQ_2_PPM_SCRATCH0                                       = 0x120F011Eull;

static const uint64_t P9N2_EQ_3_PPM_SCRATCH0                                       = 0x130F011Eull;

static const uint64_t P9N2_EQ_4_PPM_SCRATCH0                                       = 0x140F011Eull;

static const uint64_t P9N2_EQ_5_PPM_SCRATCH0                                       = 0x150F011Eull;

static const uint64_t P9N2_EX_PPM_SCRATCH0                                         = 0x200F011Eull;
//DUPS: 210F011E,
static const uint64_t P9N2_EX_0_PPM_SCRATCH0                                       = 0x200F011Eull;
//DUPS: 210F011E,
static const uint64_t P9N2_EX_1_PPM_SCRATCH0                                       = 0x220F011Eull;
//DUPS: 220F011E,
static const uint64_t P9N2_EX_2_PPM_SCRATCH0                                       = 0x240F011Eull;
//DUPS: 250F011E,
static const uint64_t P9N2_EX_3_PPM_SCRATCH0                                       = 0x260F011Eull;
//DUPS: 270F011E,
static const uint64_t P9N2_EX_4_PPM_SCRATCH0                                       = 0x280F011Eull;
//DUPS: 290F011E,
static const uint64_t P9N2_EX_5_PPM_SCRATCH0                                       = 0x2A0F011Eull;
//DUPS: 2B0F011E,
static const uint64_t P9N2_EX_6_PPM_SCRATCH0                                       = 0x2C0F011Eull;
//DUPS: 2D0F011E,
static const uint64_t P9N2_EX_7_PPM_SCRATCH0                                       = 0x2E0F011Eull;
//DUPS: 2F0F011E,
static const uint64_t P9N2_EX_8_PPM_SCRATCH0                                       = 0x300F011Eull;
//DUPS: 310F011E,
static const uint64_t P9N2_EX_9_PPM_SCRATCH0                                       = 0x320F011Eull;
//DUPS: 330F011E,
static const uint64_t P9N2_EX_10_PPM_SCRATCH0                                      = 0x340F011Eull;
//DUPS: 350F011E,
static const uint64_t P9N2_EX_11_PPM_SCRATCH0                                      = 0x360F011Eull;
//DUPS: 370F011E,

static const uint64_t P9N2_C_PPM_SCRATCH1                                          = 0x200F011Full;

static const uint64_t P9N2_C_0_PPM_SCRATCH1                                        = 0x200F011Full;

static const uint64_t P9N2_C_1_PPM_SCRATCH1                                        = 0x210F011Full;

static const uint64_t P9N2_C_2_PPM_SCRATCH1                                        = 0x220F011Full;

static const uint64_t P9N2_C_3_PPM_SCRATCH1                                        = 0x230F011Full;

static const uint64_t P9N2_C_4_PPM_SCRATCH1                                        = 0x240F011Full;

static const uint64_t P9N2_C_5_PPM_SCRATCH1                                        = 0x250F011Full;

static const uint64_t P9N2_C_6_PPM_SCRATCH1                                        = 0x260F011Full;

static const uint64_t P9N2_C_7_PPM_SCRATCH1                                        = 0x270F011Full;

static const uint64_t P9N2_C_8_PPM_SCRATCH1                                        = 0x280F011Full;

static const uint64_t P9N2_C_9_PPM_SCRATCH1                                        = 0x290F011Full;

static const uint64_t P9N2_C_10_PPM_SCRATCH1                                       = 0x2A0F011Full;

static const uint64_t P9N2_C_11_PPM_SCRATCH1                                       = 0x2B0F011Full;

static const uint64_t P9N2_C_12_PPM_SCRATCH1                                       = 0x2C0F011Full;

static const uint64_t P9N2_C_13_PPM_SCRATCH1                                       = 0x2D0F011Full;

static const uint64_t P9N2_C_14_PPM_SCRATCH1                                       = 0x2E0F011Full;

static const uint64_t P9N2_C_15_PPM_SCRATCH1                                       = 0x2F0F011Full;

static const uint64_t P9N2_C_16_PPM_SCRATCH1                                       = 0x300F011Full;

static const uint64_t P9N2_C_17_PPM_SCRATCH1                                       = 0x310F011Full;

static const uint64_t P9N2_C_18_PPM_SCRATCH1                                       = 0x320F011Full;

static const uint64_t P9N2_C_19_PPM_SCRATCH1                                       = 0x330F011Full;

static const uint64_t P9N2_C_20_PPM_SCRATCH1                                       = 0x340F011Full;

static const uint64_t P9N2_C_21_PPM_SCRATCH1                                       = 0x350F011Full;

static const uint64_t P9N2_C_22_PPM_SCRATCH1                                       = 0x360F011Full;

static const uint64_t P9N2_C_23_PPM_SCRATCH1                                       = 0x370F011Full;

static const uint64_t P9N2_EQ_PPM_SCRATCH1                                         = 0x100F011Full;

static const uint64_t P9N2_EQ_0_PPM_SCRATCH1                                       = 0x100F011Full;

static const uint64_t P9N2_EQ_1_PPM_SCRATCH1                                       = 0x110F011Full;

static const uint64_t P9N2_EQ_2_PPM_SCRATCH1                                       = 0x120F011Full;

static const uint64_t P9N2_EQ_3_PPM_SCRATCH1                                       = 0x130F011Full;

static const uint64_t P9N2_EQ_4_PPM_SCRATCH1                                       = 0x140F011Full;

static const uint64_t P9N2_EQ_5_PPM_SCRATCH1                                       = 0x150F011Full;

static const uint64_t P9N2_EX_PPM_SCRATCH1                                         = 0x200F011Full;
//DUPS: 210F011F,
static const uint64_t P9N2_EX_0_PPM_SCRATCH1                                       = 0x200F011Full;
//DUPS: 210F011F,
static const uint64_t P9N2_EX_1_PPM_SCRATCH1                                       = 0x220F011Full;
//DUPS: 220F011F,
static const uint64_t P9N2_EX_2_PPM_SCRATCH1                                       = 0x240F011Full;
//DUPS: 250F011F,
static const uint64_t P9N2_EX_3_PPM_SCRATCH1                                       = 0x260F011Full;
//DUPS: 270F011F,
static const uint64_t P9N2_EX_4_PPM_SCRATCH1                                       = 0x280F011Full;
//DUPS: 290F011F,
static const uint64_t P9N2_EX_5_PPM_SCRATCH1                                       = 0x2A0F011Full;
//DUPS: 2B0F011F,
static const uint64_t P9N2_EX_6_PPM_SCRATCH1                                       = 0x2C0F011Full;
//DUPS: 2D0F011F,
static const uint64_t P9N2_EX_7_PPM_SCRATCH1                                       = 0x2E0F011Full;
//DUPS: 2F0F011F,
static const uint64_t P9N2_EX_8_PPM_SCRATCH1                                       = 0x300F011Full;
//DUPS: 310F011F,
static const uint64_t P9N2_EX_9_PPM_SCRATCH1                                       = 0x320F011Full;
//DUPS: 330F011F,
static const uint64_t P9N2_EX_10_PPM_SCRATCH1                                      = 0x340F011Full;
//DUPS: 350F011F,
static const uint64_t P9N2_EX_11_PPM_SCRATCH1                                      = 0x360F011Full;
//DUPS: 370F011F,

static const uint64_t P9N2_C_PPM_SPWKUP_FSP                                        = 0x200F010Bull;

static const uint64_t P9N2_C_0_PPM_SPWKUP_FSP                                      = 0x200F010Bull;

static const uint64_t P9N2_C_1_PPM_SPWKUP_FSP                                      = 0x210F010Bull;

static const uint64_t P9N2_C_2_PPM_SPWKUP_FSP                                      = 0x220F010Bull;

static const uint64_t P9N2_C_3_PPM_SPWKUP_FSP                                      = 0x230F010Bull;

static const uint64_t P9N2_C_4_PPM_SPWKUP_FSP                                      = 0x240F010Bull;

static const uint64_t P9N2_C_5_PPM_SPWKUP_FSP                                      = 0x250F010Bull;

static const uint64_t P9N2_C_6_PPM_SPWKUP_FSP                                      = 0x260F010Bull;

static const uint64_t P9N2_C_7_PPM_SPWKUP_FSP                                      = 0x270F010Bull;

static const uint64_t P9N2_C_8_PPM_SPWKUP_FSP                                      = 0x280F010Bull;

static const uint64_t P9N2_C_9_PPM_SPWKUP_FSP                                      = 0x290F010Bull;

static const uint64_t P9N2_C_10_PPM_SPWKUP_FSP                                     = 0x2A0F010Bull;

static const uint64_t P9N2_C_11_PPM_SPWKUP_FSP                                     = 0x2B0F010Bull;

static const uint64_t P9N2_C_12_PPM_SPWKUP_FSP                                     = 0x2C0F010Bull;

static const uint64_t P9N2_C_13_PPM_SPWKUP_FSP                                     = 0x2D0F010Bull;

static const uint64_t P9N2_C_14_PPM_SPWKUP_FSP                                     = 0x2E0F010Bull;

static const uint64_t P9N2_C_15_PPM_SPWKUP_FSP                                     = 0x2F0F010Bull;

static const uint64_t P9N2_C_16_PPM_SPWKUP_FSP                                     = 0x300F010Bull;

static const uint64_t P9N2_C_17_PPM_SPWKUP_FSP                                     = 0x310F010Bull;

static const uint64_t P9N2_C_18_PPM_SPWKUP_FSP                                     = 0x320F010Bull;

static const uint64_t P9N2_C_19_PPM_SPWKUP_FSP                                     = 0x330F010Bull;

static const uint64_t P9N2_C_20_PPM_SPWKUP_FSP                                     = 0x340F010Bull;

static const uint64_t P9N2_C_21_PPM_SPWKUP_FSP                                     = 0x350F010Bull;

static const uint64_t P9N2_C_22_PPM_SPWKUP_FSP                                     = 0x360F010Bull;

static const uint64_t P9N2_C_23_PPM_SPWKUP_FSP                                     = 0x370F010Bull;

static const uint64_t P9N2_EQ_PPM_SPWKUP_FSP                                       = 0x100F010Bull;

static const uint64_t P9N2_EQ_0_PPM_SPWKUP_FSP                                     = 0x100F010Bull;

static const uint64_t P9N2_EQ_1_PPM_SPWKUP_FSP                                     = 0x110F010Bull;

static const uint64_t P9N2_EQ_2_PPM_SPWKUP_FSP                                     = 0x120F010Bull;

static const uint64_t P9N2_EQ_3_PPM_SPWKUP_FSP                                     = 0x130F010Bull;

static const uint64_t P9N2_EQ_4_PPM_SPWKUP_FSP                                     = 0x140F010Bull;

static const uint64_t P9N2_EQ_5_PPM_SPWKUP_FSP                                     = 0x150F010Bull;

static const uint64_t P9N2_EX_PPM_SPWKUP_FSP                                       = 0x200F010Bull;
//DUPS: 210F010B,
static const uint64_t P9N2_EX_0_PPM_SPWKUP_FSP                                     = 0x200F010Bull;
//DUPS: 210F010B,
static const uint64_t P9N2_EX_1_PPM_SPWKUP_FSP                                     = 0x220F010Bull;
//DUPS: 220F010B,
static const uint64_t P9N2_EX_2_PPM_SPWKUP_FSP                                     = 0x240F010Bull;
//DUPS: 250F010B,
static const uint64_t P9N2_EX_3_PPM_SPWKUP_FSP                                     = 0x260F010Bull;
//DUPS: 270F010B,
static const uint64_t P9N2_EX_4_PPM_SPWKUP_FSP                                     = 0x280F010Bull;
//DUPS: 290F010B,
static const uint64_t P9N2_EX_5_PPM_SPWKUP_FSP                                     = 0x2A0F010Bull;
//DUPS: 2B0F010B,
static const uint64_t P9N2_EX_6_PPM_SPWKUP_FSP                                     = 0x2C0F010Bull;
//DUPS: 2D0F010B,
static const uint64_t P9N2_EX_7_PPM_SPWKUP_FSP                                     = 0x2E0F010Bull;
//DUPS: 2F0F010B,
static const uint64_t P9N2_EX_8_PPM_SPWKUP_FSP                                     = 0x300F010Bull;
//DUPS: 310F010B,
static const uint64_t P9N2_EX_9_PPM_SPWKUP_FSP                                     = 0x320F010Bull;
//DUPS: 330F010B,
static const uint64_t P9N2_EX_10_PPM_SPWKUP_FSP                                    = 0x340F010Bull;
//DUPS: 350F010B,
static const uint64_t P9N2_EX_11_PPM_SPWKUP_FSP                                    = 0x360F010Bull;
//DUPS: 370F010B,

static const uint64_t P9N2_C_PPM_SPWKUP_HYP                                        = 0x200F010Dull;

static const uint64_t P9N2_C_0_PPM_SPWKUP_HYP                                      = 0x200F010Dull;

static const uint64_t P9N2_C_1_PPM_SPWKUP_HYP                                      = 0x210F010Dull;

static const uint64_t P9N2_C_2_PPM_SPWKUP_HYP                                      = 0x220F010Dull;

static const uint64_t P9N2_C_3_PPM_SPWKUP_HYP                                      = 0x230F010Dull;

static const uint64_t P9N2_C_4_PPM_SPWKUP_HYP                                      = 0x240F010Dull;

static const uint64_t P9N2_C_5_PPM_SPWKUP_HYP                                      = 0x250F010Dull;

static const uint64_t P9N2_C_6_PPM_SPWKUP_HYP                                      = 0x260F010Dull;

static const uint64_t P9N2_C_7_PPM_SPWKUP_HYP                                      = 0x270F010Dull;

static const uint64_t P9N2_C_8_PPM_SPWKUP_HYP                                      = 0x280F010Dull;

static const uint64_t P9N2_C_9_PPM_SPWKUP_HYP                                      = 0x290F010Dull;

static const uint64_t P9N2_C_10_PPM_SPWKUP_HYP                                     = 0x2A0F010Dull;

static const uint64_t P9N2_C_11_PPM_SPWKUP_HYP                                     = 0x2B0F010Dull;

static const uint64_t P9N2_C_12_PPM_SPWKUP_HYP                                     = 0x2C0F010Dull;

static const uint64_t P9N2_C_13_PPM_SPWKUP_HYP                                     = 0x2D0F010Dull;

static const uint64_t P9N2_C_14_PPM_SPWKUP_HYP                                     = 0x2E0F010Dull;

static const uint64_t P9N2_C_15_PPM_SPWKUP_HYP                                     = 0x2F0F010Dull;

static const uint64_t P9N2_C_16_PPM_SPWKUP_HYP                                     = 0x300F010Dull;

static const uint64_t P9N2_C_17_PPM_SPWKUP_HYP                                     = 0x310F010Dull;

static const uint64_t P9N2_C_18_PPM_SPWKUP_HYP                                     = 0x320F010Dull;

static const uint64_t P9N2_C_19_PPM_SPWKUP_HYP                                     = 0x330F010Dull;

static const uint64_t P9N2_C_20_PPM_SPWKUP_HYP                                     = 0x340F010Dull;

static const uint64_t P9N2_C_21_PPM_SPWKUP_HYP                                     = 0x350F010Dull;

static const uint64_t P9N2_C_22_PPM_SPWKUP_HYP                                     = 0x360F010Dull;

static const uint64_t P9N2_C_23_PPM_SPWKUP_HYP                                     = 0x370F010Dull;

static const uint64_t P9N2_EQ_PPM_SPWKUP_HYP                                       = 0x100F010Dull;

static const uint64_t P9N2_EQ_0_PPM_SPWKUP_HYP                                     = 0x100F010Dull;

static const uint64_t P9N2_EQ_1_PPM_SPWKUP_HYP                                     = 0x110F010Dull;

static const uint64_t P9N2_EQ_2_PPM_SPWKUP_HYP                                     = 0x120F010Dull;

static const uint64_t P9N2_EQ_3_PPM_SPWKUP_HYP                                     = 0x130F010Dull;

static const uint64_t P9N2_EQ_4_PPM_SPWKUP_HYP                                     = 0x140F010Dull;

static const uint64_t P9N2_EQ_5_PPM_SPWKUP_HYP                                     = 0x150F010Dull;

static const uint64_t P9N2_EX_PPM_SPWKUP_HYP                                       = 0x200F010Dull;
//DUPS: 210F010D,
static const uint64_t P9N2_EX_0_PPM_SPWKUP_HYP                                     = 0x200F010Dull;
//DUPS: 210F010D,
static const uint64_t P9N2_EX_1_PPM_SPWKUP_HYP                                     = 0x220F010Dull;
//DUPS: 220F010D,
static const uint64_t P9N2_EX_2_PPM_SPWKUP_HYP                                     = 0x240F010Dull;
//DUPS: 250F010D,
static const uint64_t P9N2_EX_3_PPM_SPWKUP_HYP                                     = 0x260F010Dull;
//DUPS: 270F010D,
static const uint64_t P9N2_EX_4_PPM_SPWKUP_HYP                                     = 0x280F010Dull;
//DUPS: 290F010D,
static const uint64_t P9N2_EX_5_PPM_SPWKUP_HYP                                     = 0x2A0F010Dull;
//DUPS: 2B0F010D,
static const uint64_t P9N2_EX_6_PPM_SPWKUP_HYP                                     = 0x2C0F010Dull;
//DUPS: 2D0F010D,
static const uint64_t P9N2_EX_7_PPM_SPWKUP_HYP                                     = 0x2E0F010Dull;
//DUPS: 2F0F010D,
static const uint64_t P9N2_EX_8_PPM_SPWKUP_HYP                                     = 0x300F010Dull;
//DUPS: 310F010D,
static const uint64_t P9N2_EX_9_PPM_SPWKUP_HYP                                     = 0x320F010Dull;
//DUPS: 330F010D,
static const uint64_t P9N2_EX_10_PPM_SPWKUP_HYP                                    = 0x340F010Dull;
//DUPS: 350F010D,
static const uint64_t P9N2_EX_11_PPM_SPWKUP_HYP                                    = 0x360F010Dull;
//DUPS: 370F010D,

static const uint64_t P9N2_C_PPM_SPWKUP_OCC                                        = 0x200F010Cull;

static const uint64_t P9N2_C_0_PPM_SPWKUP_OCC                                      = 0x200F010Cull;

static const uint64_t P9N2_C_1_PPM_SPWKUP_OCC                                      = 0x210F010Cull;

static const uint64_t P9N2_C_2_PPM_SPWKUP_OCC                                      = 0x220F010Cull;

static const uint64_t P9N2_C_3_PPM_SPWKUP_OCC                                      = 0x230F010Cull;

static const uint64_t P9N2_C_4_PPM_SPWKUP_OCC                                      = 0x240F010Cull;

static const uint64_t P9N2_C_5_PPM_SPWKUP_OCC                                      = 0x250F010Cull;

static const uint64_t P9N2_C_6_PPM_SPWKUP_OCC                                      = 0x260F010Cull;

static const uint64_t P9N2_C_7_PPM_SPWKUP_OCC                                      = 0x270F010Cull;

static const uint64_t P9N2_C_8_PPM_SPWKUP_OCC                                      = 0x280F010Cull;

static const uint64_t P9N2_C_9_PPM_SPWKUP_OCC                                      = 0x290F010Cull;

static const uint64_t P9N2_C_10_PPM_SPWKUP_OCC                                     = 0x2A0F010Cull;

static const uint64_t P9N2_C_11_PPM_SPWKUP_OCC                                     = 0x2B0F010Cull;

static const uint64_t P9N2_C_12_PPM_SPWKUP_OCC                                     = 0x2C0F010Cull;

static const uint64_t P9N2_C_13_PPM_SPWKUP_OCC                                     = 0x2D0F010Cull;

static const uint64_t P9N2_C_14_PPM_SPWKUP_OCC                                     = 0x2E0F010Cull;

static const uint64_t P9N2_C_15_PPM_SPWKUP_OCC                                     = 0x2F0F010Cull;

static const uint64_t P9N2_C_16_PPM_SPWKUP_OCC                                     = 0x300F010Cull;

static const uint64_t P9N2_C_17_PPM_SPWKUP_OCC                                     = 0x310F010Cull;

static const uint64_t P9N2_C_18_PPM_SPWKUP_OCC                                     = 0x320F010Cull;

static const uint64_t P9N2_C_19_PPM_SPWKUP_OCC                                     = 0x330F010Cull;

static const uint64_t P9N2_C_20_PPM_SPWKUP_OCC                                     = 0x340F010Cull;

static const uint64_t P9N2_C_21_PPM_SPWKUP_OCC                                     = 0x350F010Cull;

static const uint64_t P9N2_C_22_PPM_SPWKUP_OCC                                     = 0x360F010Cull;

static const uint64_t P9N2_C_23_PPM_SPWKUP_OCC                                     = 0x370F010Cull;

static const uint64_t P9N2_EQ_PPM_SPWKUP_OCC                                       = 0x100F010Cull;

static const uint64_t P9N2_EQ_0_PPM_SPWKUP_OCC                                     = 0x100F010Cull;

static const uint64_t P9N2_EQ_1_PPM_SPWKUP_OCC                                     = 0x110F010Cull;

static const uint64_t P9N2_EQ_2_PPM_SPWKUP_OCC                                     = 0x120F010Cull;

static const uint64_t P9N2_EQ_3_PPM_SPWKUP_OCC                                     = 0x130F010Cull;

static const uint64_t P9N2_EQ_4_PPM_SPWKUP_OCC                                     = 0x140F010Cull;

static const uint64_t P9N2_EQ_5_PPM_SPWKUP_OCC                                     = 0x150F010Cull;

static const uint64_t P9N2_EX_PPM_SPWKUP_OCC                                       = 0x200F010Cull;
//DUPS: 210F010C,
static const uint64_t P9N2_EX_0_PPM_SPWKUP_OCC                                     = 0x200F010Cull;
//DUPS: 210F010C,
static const uint64_t P9N2_EX_1_PPM_SPWKUP_OCC                                     = 0x220F010Cull;
//DUPS: 220F010C,
static const uint64_t P9N2_EX_2_PPM_SPWKUP_OCC                                     = 0x240F010Cull;
//DUPS: 250F010C,
static const uint64_t P9N2_EX_3_PPM_SPWKUP_OCC                                     = 0x260F010Cull;
//DUPS: 270F010C,
static const uint64_t P9N2_EX_4_PPM_SPWKUP_OCC                                     = 0x280F010Cull;
//DUPS: 290F010C,
static const uint64_t P9N2_EX_5_PPM_SPWKUP_OCC                                     = 0x2A0F010Cull;
//DUPS: 2B0F010C,
static const uint64_t P9N2_EX_6_PPM_SPWKUP_OCC                                     = 0x2C0F010Cull;
//DUPS: 2D0F010C,
static const uint64_t P9N2_EX_7_PPM_SPWKUP_OCC                                     = 0x2E0F010Cull;
//DUPS: 2F0F010C,
static const uint64_t P9N2_EX_8_PPM_SPWKUP_OCC                                     = 0x300F010Cull;
//DUPS: 310F010C,
static const uint64_t P9N2_EX_9_PPM_SPWKUP_OCC                                     = 0x320F010Cull;
//DUPS: 330F010C,
static const uint64_t P9N2_EX_10_PPM_SPWKUP_OCC                                    = 0x340F010Cull;
//DUPS: 350F010C,
static const uint64_t P9N2_EX_11_PPM_SPWKUP_OCC                                    = 0x360F010Cull;
//DUPS: 370F010C,

static const uint64_t P9N2_C_PPM_SPWKUP_OTR                                        = 0x200F010Aull;

static const uint64_t P9N2_C_0_PPM_SPWKUP_OTR                                      = 0x200F010Aull;

static const uint64_t P9N2_C_1_PPM_SPWKUP_OTR                                      = 0x210F010Aull;

static const uint64_t P9N2_C_2_PPM_SPWKUP_OTR                                      = 0x220F010Aull;

static const uint64_t P9N2_C_3_PPM_SPWKUP_OTR                                      = 0x230F010Aull;

static const uint64_t P9N2_C_4_PPM_SPWKUP_OTR                                      = 0x240F010Aull;

static const uint64_t P9N2_C_5_PPM_SPWKUP_OTR                                      = 0x250F010Aull;

static const uint64_t P9N2_C_6_PPM_SPWKUP_OTR                                      = 0x260F010Aull;

static const uint64_t P9N2_C_7_PPM_SPWKUP_OTR                                      = 0x270F010Aull;

static const uint64_t P9N2_C_8_PPM_SPWKUP_OTR                                      = 0x280F010Aull;

static const uint64_t P9N2_C_9_PPM_SPWKUP_OTR                                      = 0x290F010Aull;

static const uint64_t P9N2_C_10_PPM_SPWKUP_OTR                                     = 0x2A0F010Aull;

static const uint64_t P9N2_C_11_PPM_SPWKUP_OTR                                     = 0x2B0F010Aull;

static const uint64_t P9N2_C_12_PPM_SPWKUP_OTR                                     = 0x2C0F010Aull;

static const uint64_t P9N2_C_13_PPM_SPWKUP_OTR                                     = 0x2D0F010Aull;

static const uint64_t P9N2_C_14_PPM_SPWKUP_OTR                                     = 0x2E0F010Aull;

static const uint64_t P9N2_C_15_PPM_SPWKUP_OTR                                     = 0x2F0F010Aull;

static const uint64_t P9N2_C_16_PPM_SPWKUP_OTR                                     = 0x300F010Aull;

static const uint64_t P9N2_C_17_PPM_SPWKUP_OTR                                     = 0x310F010Aull;

static const uint64_t P9N2_C_18_PPM_SPWKUP_OTR                                     = 0x320F010Aull;

static const uint64_t P9N2_C_19_PPM_SPWKUP_OTR                                     = 0x330F010Aull;

static const uint64_t P9N2_C_20_PPM_SPWKUP_OTR                                     = 0x340F010Aull;

static const uint64_t P9N2_C_21_PPM_SPWKUP_OTR                                     = 0x350F010Aull;

static const uint64_t P9N2_C_22_PPM_SPWKUP_OTR                                     = 0x360F010Aull;

static const uint64_t P9N2_C_23_PPM_SPWKUP_OTR                                     = 0x370F010Aull;

static const uint64_t P9N2_EQ_PPM_SPWKUP_OTR                                       = 0x100F010Aull;

static const uint64_t P9N2_EQ_0_PPM_SPWKUP_OTR                                     = 0x100F010Aull;

static const uint64_t P9N2_EQ_1_PPM_SPWKUP_OTR                                     = 0x110F010Aull;

static const uint64_t P9N2_EQ_2_PPM_SPWKUP_OTR                                     = 0x120F010Aull;

static const uint64_t P9N2_EQ_3_PPM_SPWKUP_OTR                                     = 0x130F010Aull;

static const uint64_t P9N2_EQ_4_PPM_SPWKUP_OTR                                     = 0x140F010Aull;

static const uint64_t P9N2_EQ_5_PPM_SPWKUP_OTR                                     = 0x150F010Aull;

static const uint64_t P9N2_EX_PPM_SPWKUP_OTR                                       = 0x200F010Aull;
//DUPS: 210F010A,
static const uint64_t P9N2_EX_0_PPM_SPWKUP_OTR                                     = 0x200F010Aull;
//DUPS: 210F010A,
static const uint64_t P9N2_EX_1_PPM_SPWKUP_OTR                                     = 0x220F010Aull;
//DUPS: 220F010A,
static const uint64_t P9N2_EX_2_PPM_SPWKUP_OTR                                     = 0x240F010Aull;
//DUPS: 250F010A,
static const uint64_t P9N2_EX_3_PPM_SPWKUP_OTR                                     = 0x260F010Aull;
//DUPS: 270F010A,
static const uint64_t P9N2_EX_4_PPM_SPWKUP_OTR                                     = 0x280F010Aull;
//DUPS: 290F010A,
static const uint64_t P9N2_EX_5_PPM_SPWKUP_OTR                                     = 0x2A0F010Aull;
//DUPS: 2B0F010A,
static const uint64_t P9N2_EX_6_PPM_SPWKUP_OTR                                     = 0x2C0F010Aull;
//DUPS: 2D0F010A,
static const uint64_t P9N2_EX_7_PPM_SPWKUP_OTR                                     = 0x2E0F010Aull;
//DUPS: 2F0F010A,
static const uint64_t P9N2_EX_8_PPM_SPWKUP_OTR                                     = 0x300F010Aull;
//DUPS: 310F010A,
static const uint64_t P9N2_EX_9_PPM_SPWKUP_OTR                                     = 0x320F010Aull;
//DUPS: 330F010A,
static const uint64_t P9N2_EX_10_PPM_SPWKUP_OTR                                    = 0x340F010Aull;
//DUPS: 350F010A,
static const uint64_t P9N2_EX_11_PPM_SPWKUP_OTR                                    = 0x360F010Aull;
//DUPS: 370F010A,

static const uint64_t P9N2_C_PPM_SSHFSP                                            = 0x200F0111ull;

static const uint64_t P9N2_C_0_PPM_SSHFSP                                          = 0x200F0111ull;

static const uint64_t P9N2_C_1_PPM_SSHFSP                                          = 0x210F0111ull;

static const uint64_t P9N2_C_2_PPM_SSHFSP                                          = 0x220F0111ull;

static const uint64_t P9N2_C_3_PPM_SSHFSP                                          = 0x230F0111ull;

static const uint64_t P9N2_C_4_PPM_SSHFSP                                          = 0x240F0111ull;

static const uint64_t P9N2_C_5_PPM_SSHFSP                                          = 0x250F0111ull;

static const uint64_t P9N2_C_6_PPM_SSHFSP                                          = 0x260F0111ull;

static const uint64_t P9N2_C_7_PPM_SSHFSP                                          = 0x270F0111ull;

static const uint64_t P9N2_C_8_PPM_SSHFSP                                          = 0x280F0111ull;

static const uint64_t P9N2_C_9_PPM_SSHFSP                                          = 0x290F0111ull;

static const uint64_t P9N2_C_10_PPM_SSHFSP                                         = 0x2A0F0111ull;

static const uint64_t P9N2_C_11_PPM_SSHFSP                                         = 0x2B0F0111ull;

static const uint64_t P9N2_C_12_PPM_SSHFSP                                         = 0x2C0F0111ull;

static const uint64_t P9N2_C_13_PPM_SSHFSP                                         = 0x2D0F0111ull;

static const uint64_t P9N2_C_14_PPM_SSHFSP                                         = 0x2E0F0111ull;

static const uint64_t P9N2_C_15_PPM_SSHFSP                                         = 0x2F0F0111ull;

static const uint64_t P9N2_C_16_PPM_SSHFSP                                         = 0x300F0111ull;

static const uint64_t P9N2_C_17_PPM_SSHFSP                                         = 0x310F0111ull;

static const uint64_t P9N2_C_18_PPM_SSHFSP                                         = 0x320F0111ull;

static const uint64_t P9N2_C_19_PPM_SSHFSP                                         = 0x330F0111ull;

static const uint64_t P9N2_C_20_PPM_SSHFSP                                         = 0x340F0111ull;

static const uint64_t P9N2_C_21_PPM_SSHFSP                                         = 0x350F0111ull;

static const uint64_t P9N2_C_22_PPM_SSHFSP                                         = 0x360F0111ull;

static const uint64_t P9N2_C_23_PPM_SSHFSP                                         = 0x370F0111ull;

static const uint64_t P9N2_EQ_PPM_SSHFSP                                           = 0x100F0111ull;

static const uint64_t P9N2_EQ_0_PPM_SSHFSP                                         = 0x100F0111ull;

static const uint64_t P9N2_EQ_1_PPM_SSHFSP                                         = 0x110F0111ull;

static const uint64_t P9N2_EQ_2_PPM_SSHFSP                                         = 0x120F0111ull;

static const uint64_t P9N2_EQ_3_PPM_SSHFSP                                         = 0x130F0111ull;

static const uint64_t P9N2_EQ_4_PPM_SSHFSP                                         = 0x140F0111ull;

static const uint64_t P9N2_EQ_5_PPM_SSHFSP                                         = 0x150F0111ull;

static const uint64_t P9N2_EX_PPM_SSHFSP                                           = 0x200F0111ull;
//DUPS: 210F0111,
static const uint64_t P9N2_EX_0_PPM_SSHFSP                                         = 0x200F0111ull;
//DUPS: 210F0111,
static const uint64_t P9N2_EX_1_PPM_SSHFSP                                         = 0x220F0111ull;
//DUPS: 220F0111,
static const uint64_t P9N2_EX_2_PPM_SSHFSP                                         = 0x240F0111ull;
//DUPS: 250F0111,
static const uint64_t P9N2_EX_3_PPM_SSHFSP                                         = 0x260F0111ull;
//DUPS: 270F0111,
static const uint64_t P9N2_EX_4_PPM_SSHFSP                                         = 0x280F0111ull;
//DUPS: 290F0111,
static const uint64_t P9N2_EX_5_PPM_SSHFSP                                         = 0x2A0F0111ull;
//DUPS: 2B0F0111,
static const uint64_t P9N2_EX_6_PPM_SSHFSP                                         = 0x2C0F0111ull;
//DUPS: 2D0F0111,
static const uint64_t P9N2_EX_7_PPM_SSHFSP                                         = 0x2E0F0111ull;
//DUPS: 2F0F0111,
static const uint64_t P9N2_EX_8_PPM_SSHFSP                                         = 0x300F0111ull;
//DUPS: 310F0111,
static const uint64_t P9N2_EX_9_PPM_SSHFSP                                         = 0x320F0111ull;
//DUPS: 330F0111,
static const uint64_t P9N2_EX_10_PPM_SSHFSP                                        = 0x340F0111ull;
//DUPS: 350F0111,
static const uint64_t P9N2_EX_11_PPM_SSHFSP                                        = 0x360F0111ull;
//DUPS: 370F0111,

static const uint64_t P9N2_C_PPM_SSHHYP                                            = 0x200F0114ull;

static const uint64_t P9N2_C_0_PPM_SSHHYP                                          = 0x200F0114ull;

static const uint64_t P9N2_C_1_PPM_SSHHYP                                          = 0x210F0114ull;

static const uint64_t P9N2_C_2_PPM_SSHHYP                                          = 0x220F0114ull;

static const uint64_t P9N2_C_3_PPM_SSHHYP                                          = 0x230F0114ull;

static const uint64_t P9N2_C_4_PPM_SSHHYP                                          = 0x240F0114ull;

static const uint64_t P9N2_C_5_PPM_SSHHYP                                          = 0x250F0114ull;

static const uint64_t P9N2_C_6_PPM_SSHHYP                                          = 0x260F0114ull;

static const uint64_t P9N2_C_7_PPM_SSHHYP                                          = 0x270F0114ull;

static const uint64_t P9N2_C_8_PPM_SSHHYP                                          = 0x280F0114ull;

static const uint64_t P9N2_C_9_PPM_SSHHYP                                          = 0x290F0114ull;

static const uint64_t P9N2_C_10_PPM_SSHHYP                                         = 0x2A0F0114ull;

static const uint64_t P9N2_C_11_PPM_SSHHYP                                         = 0x2B0F0114ull;

static const uint64_t P9N2_C_12_PPM_SSHHYP                                         = 0x2C0F0114ull;

static const uint64_t P9N2_C_13_PPM_SSHHYP                                         = 0x2D0F0114ull;

static const uint64_t P9N2_C_14_PPM_SSHHYP                                         = 0x2E0F0114ull;

static const uint64_t P9N2_C_15_PPM_SSHHYP                                         = 0x2F0F0114ull;

static const uint64_t P9N2_C_16_PPM_SSHHYP                                         = 0x300F0114ull;

static const uint64_t P9N2_C_17_PPM_SSHHYP                                         = 0x310F0114ull;

static const uint64_t P9N2_C_18_PPM_SSHHYP                                         = 0x320F0114ull;

static const uint64_t P9N2_C_19_PPM_SSHHYP                                         = 0x330F0114ull;

static const uint64_t P9N2_C_20_PPM_SSHHYP                                         = 0x340F0114ull;

static const uint64_t P9N2_C_21_PPM_SSHHYP                                         = 0x350F0114ull;

static const uint64_t P9N2_C_22_PPM_SSHHYP                                         = 0x360F0114ull;

static const uint64_t P9N2_C_23_PPM_SSHHYP                                         = 0x370F0114ull;

static const uint64_t P9N2_EQ_PPM_SSHHYP                                           = 0x100F0114ull;

static const uint64_t P9N2_EQ_0_PPM_SSHHYP                                         = 0x100F0114ull;

static const uint64_t P9N2_EQ_1_PPM_SSHHYP                                         = 0x110F0114ull;

static const uint64_t P9N2_EQ_2_PPM_SSHHYP                                         = 0x120F0114ull;

static const uint64_t P9N2_EQ_3_PPM_SSHHYP                                         = 0x130F0114ull;

static const uint64_t P9N2_EQ_4_PPM_SSHHYP                                         = 0x140F0114ull;

static const uint64_t P9N2_EQ_5_PPM_SSHHYP                                         = 0x150F0114ull;

static const uint64_t P9N2_EX_PPM_SSHHYP                                           = 0x200F0114ull;
//DUPS: 210F0114,
static const uint64_t P9N2_EX_0_PPM_SSHHYP                                         = 0x200F0114ull;
//DUPS: 210F0114,
static const uint64_t P9N2_EX_1_PPM_SSHHYP                                         = 0x220F0114ull;
//DUPS: 220F0114,
static const uint64_t P9N2_EX_2_PPM_SSHHYP                                         = 0x240F0114ull;
//DUPS: 250F0114,
static const uint64_t P9N2_EX_3_PPM_SSHHYP                                         = 0x260F0114ull;
//DUPS: 270F0114,
static const uint64_t P9N2_EX_4_PPM_SSHHYP                                         = 0x280F0114ull;
//DUPS: 290F0114,
static const uint64_t P9N2_EX_5_PPM_SSHHYP                                         = 0x2A0F0114ull;
//DUPS: 2B0F0114,
static const uint64_t P9N2_EX_6_PPM_SSHHYP                                         = 0x2C0F0114ull;
//DUPS: 2D0F0114,
static const uint64_t P9N2_EX_7_PPM_SSHHYP                                         = 0x2E0F0114ull;
//DUPS: 2F0F0114,
static const uint64_t P9N2_EX_8_PPM_SSHHYP                                         = 0x300F0114ull;
//DUPS: 310F0114,
static const uint64_t P9N2_EX_9_PPM_SSHHYP                                         = 0x320F0114ull;
//DUPS: 330F0114,
static const uint64_t P9N2_EX_10_PPM_SSHHYP                                        = 0x340F0114ull;
//DUPS: 350F0114,
static const uint64_t P9N2_EX_11_PPM_SSHHYP                                        = 0x360F0114ull;
//DUPS: 370F0114,

static const uint64_t P9N2_C_PPM_SSHOCC                                            = 0x200F0112ull;

static const uint64_t P9N2_C_0_PPM_SSHOCC                                          = 0x200F0112ull;

static const uint64_t P9N2_C_1_PPM_SSHOCC                                          = 0x210F0112ull;

static const uint64_t P9N2_C_2_PPM_SSHOCC                                          = 0x220F0112ull;

static const uint64_t P9N2_C_3_PPM_SSHOCC                                          = 0x230F0112ull;

static const uint64_t P9N2_C_4_PPM_SSHOCC                                          = 0x240F0112ull;

static const uint64_t P9N2_C_5_PPM_SSHOCC                                          = 0x250F0112ull;

static const uint64_t P9N2_C_6_PPM_SSHOCC                                          = 0x260F0112ull;

static const uint64_t P9N2_C_7_PPM_SSHOCC                                          = 0x270F0112ull;

static const uint64_t P9N2_C_8_PPM_SSHOCC                                          = 0x280F0112ull;

static const uint64_t P9N2_C_9_PPM_SSHOCC                                          = 0x290F0112ull;

static const uint64_t P9N2_C_10_PPM_SSHOCC                                         = 0x2A0F0112ull;

static const uint64_t P9N2_C_11_PPM_SSHOCC                                         = 0x2B0F0112ull;

static const uint64_t P9N2_C_12_PPM_SSHOCC                                         = 0x2C0F0112ull;

static const uint64_t P9N2_C_13_PPM_SSHOCC                                         = 0x2D0F0112ull;

static const uint64_t P9N2_C_14_PPM_SSHOCC                                         = 0x2E0F0112ull;

static const uint64_t P9N2_C_15_PPM_SSHOCC                                         = 0x2F0F0112ull;

static const uint64_t P9N2_C_16_PPM_SSHOCC                                         = 0x300F0112ull;

static const uint64_t P9N2_C_17_PPM_SSHOCC                                         = 0x310F0112ull;

static const uint64_t P9N2_C_18_PPM_SSHOCC                                         = 0x320F0112ull;

static const uint64_t P9N2_C_19_PPM_SSHOCC                                         = 0x330F0112ull;

static const uint64_t P9N2_C_20_PPM_SSHOCC                                         = 0x340F0112ull;

static const uint64_t P9N2_C_21_PPM_SSHOCC                                         = 0x350F0112ull;

static const uint64_t P9N2_C_22_PPM_SSHOCC                                         = 0x360F0112ull;

static const uint64_t P9N2_C_23_PPM_SSHOCC                                         = 0x370F0112ull;

static const uint64_t P9N2_EQ_PPM_SSHOCC                                           = 0x100F0112ull;

static const uint64_t P9N2_EQ_0_PPM_SSHOCC                                         = 0x100F0112ull;

static const uint64_t P9N2_EQ_1_PPM_SSHOCC                                         = 0x110F0112ull;

static const uint64_t P9N2_EQ_2_PPM_SSHOCC                                         = 0x120F0112ull;

static const uint64_t P9N2_EQ_3_PPM_SSHOCC                                         = 0x130F0112ull;

static const uint64_t P9N2_EQ_4_PPM_SSHOCC                                         = 0x140F0112ull;

static const uint64_t P9N2_EQ_5_PPM_SSHOCC                                         = 0x150F0112ull;

static const uint64_t P9N2_EX_PPM_SSHOCC                                           = 0x200F0112ull;
//DUPS: 210F0112,
static const uint64_t P9N2_EX_0_PPM_SSHOCC                                         = 0x200F0112ull;
//DUPS: 210F0112,
static const uint64_t P9N2_EX_1_PPM_SSHOCC                                         = 0x220F0112ull;
//DUPS: 220F0112,
static const uint64_t P9N2_EX_2_PPM_SSHOCC                                         = 0x240F0112ull;
//DUPS: 250F0112,
static const uint64_t P9N2_EX_3_PPM_SSHOCC                                         = 0x260F0112ull;
//DUPS: 270F0112,
static const uint64_t P9N2_EX_4_PPM_SSHOCC                                         = 0x280F0112ull;
//DUPS: 290F0112,
static const uint64_t P9N2_EX_5_PPM_SSHOCC                                         = 0x2A0F0112ull;
//DUPS: 2B0F0112,
static const uint64_t P9N2_EX_6_PPM_SSHOCC                                         = 0x2C0F0112ull;
//DUPS: 2D0F0112,
static const uint64_t P9N2_EX_7_PPM_SSHOCC                                         = 0x2E0F0112ull;
//DUPS: 2F0F0112,
static const uint64_t P9N2_EX_8_PPM_SSHOCC                                         = 0x300F0112ull;
//DUPS: 310F0112,
static const uint64_t P9N2_EX_9_PPM_SSHOCC                                         = 0x320F0112ull;
//DUPS: 330F0112,
static const uint64_t P9N2_EX_10_PPM_SSHOCC                                        = 0x340F0112ull;
//DUPS: 350F0112,
static const uint64_t P9N2_EX_11_PPM_SSHOCC                                        = 0x360F0112ull;
//DUPS: 370F0112,

static const uint64_t P9N2_C_PPM_SSHOTR                                            = 0x200F0113ull;

static const uint64_t P9N2_C_0_PPM_SSHOTR                                          = 0x200F0113ull;

static const uint64_t P9N2_C_1_PPM_SSHOTR                                          = 0x210F0113ull;

static const uint64_t P9N2_C_2_PPM_SSHOTR                                          = 0x220F0113ull;

static const uint64_t P9N2_C_3_PPM_SSHOTR                                          = 0x230F0113ull;

static const uint64_t P9N2_C_4_PPM_SSHOTR                                          = 0x240F0113ull;

static const uint64_t P9N2_C_5_PPM_SSHOTR                                          = 0x250F0113ull;

static const uint64_t P9N2_C_6_PPM_SSHOTR                                          = 0x260F0113ull;

static const uint64_t P9N2_C_7_PPM_SSHOTR                                          = 0x270F0113ull;

static const uint64_t P9N2_C_8_PPM_SSHOTR                                          = 0x280F0113ull;

static const uint64_t P9N2_C_9_PPM_SSHOTR                                          = 0x290F0113ull;

static const uint64_t P9N2_C_10_PPM_SSHOTR                                         = 0x2A0F0113ull;

static const uint64_t P9N2_C_11_PPM_SSHOTR                                         = 0x2B0F0113ull;

static const uint64_t P9N2_C_12_PPM_SSHOTR                                         = 0x2C0F0113ull;

static const uint64_t P9N2_C_13_PPM_SSHOTR                                         = 0x2D0F0113ull;

static const uint64_t P9N2_C_14_PPM_SSHOTR                                         = 0x2E0F0113ull;

static const uint64_t P9N2_C_15_PPM_SSHOTR                                         = 0x2F0F0113ull;

static const uint64_t P9N2_C_16_PPM_SSHOTR                                         = 0x300F0113ull;

static const uint64_t P9N2_C_17_PPM_SSHOTR                                         = 0x310F0113ull;

static const uint64_t P9N2_C_18_PPM_SSHOTR                                         = 0x320F0113ull;

static const uint64_t P9N2_C_19_PPM_SSHOTR                                         = 0x330F0113ull;

static const uint64_t P9N2_C_20_PPM_SSHOTR                                         = 0x340F0113ull;

static const uint64_t P9N2_C_21_PPM_SSHOTR                                         = 0x350F0113ull;

static const uint64_t P9N2_C_22_PPM_SSHOTR                                         = 0x360F0113ull;

static const uint64_t P9N2_C_23_PPM_SSHOTR                                         = 0x370F0113ull;

static const uint64_t P9N2_EQ_PPM_SSHOTR                                           = 0x100F0113ull;

static const uint64_t P9N2_EQ_0_PPM_SSHOTR                                         = 0x100F0113ull;

static const uint64_t P9N2_EQ_1_PPM_SSHOTR                                         = 0x110F0113ull;

static const uint64_t P9N2_EQ_2_PPM_SSHOTR                                         = 0x120F0113ull;

static const uint64_t P9N2_EQ_3_PPM_SSHOTR                                         = 0x130F0113ull;

static const uint64_t P9N2_EQ_4_PPM_SSHOTR                                         = 0x140F0113ull;

static const uint64_t P9N2_EQ_5_PPM_SSHOTR                                         = 0x150F0113ull;

static const uint64_t P9N2_EX_PPM_SSHOTR                                           = 0x200F0113ull;
//DUPS: 210F0113,
static const uint64_t P9N2_EX_0_PPM_SSHOTR                                         = 0x200F0113ull;
//DUPS: 210F0113,
static const uint64_t P9N2_EX_1_PPM_SSHOTR                                         = 0x220F0113ull;
//DUPS: 220F0113,
static const uint64_t P9N2_EX_2_PPM_SSHOTR                                         = 0x240F0113ull;
//DUPS: 250F0113,
static const uint64_t P9N2_EX_3_PPM_SSHOTR                                         = 0x260F0113ull;
//DUPS: 270F0113,
static const uint64_t P9N2_EX_4_PPM_SSHOTR                                         = 0x280F0113ull;
//DUPS: 290F0113,
static const uint64_t P9N2_EX_5_PPM_SSHOTR                                         = 0x2A0F0113ull;
//DUPS: 2B0F0113,
static const uint64_t P9N2_EX_6_PPM_SSHOTR                                         = 0x2C0F0113ull;
//DUPS: 2D0F0113,
static const uint64_t P9N2_EX_7_PPM_SSHOTR                                         = 0x2E0F0113ull;
//DUPS: 2F0F0113,
static const uint64_t P9N2_EX_8_PPM_SSHOTR                                         = 0x300F0113ull;
//DUPS: 310F0113,
static const uint64_t P9N2_EX_9_PPM_SSHOTR                                         = 0x320F0113ull;
//DUPS: 330F0113,
static const uint64_t P9N2_EX_10_PPM_SSHOTR                                        = 0x340F0113ull;
//DUPS: 350F0113,
static const uint64_t P9N2_EX_11_PPM_SSHOTR                                        = 0x360F0113ull;
//DUPS: 370F0113,

static const uint64_t P9N2_C_PPM_SSHSRC                                            = 0x200F0110ull;

static const uint64_t P9N2_C_0_PPM_SSHSRC                                          = 0x200F0110ull;

static const uint64_t P9N2_C_1_PPM_SSHSRC                                          = 0x210F0110ull;

static const uint64_t P9N2_C_2_PPM_SSHSRC                                          = 0x220F0110ull;

static const uint64_t P9N2_C_3_PPM_SSHSRC                                          = 0x230F0110ull;

static const uint64_t P9N2_C_4_PPM_SSHSRC                                          = 0x240F0110ull;

static const uint64_t P9N2_C_5_PPM_SSHSRC                                          = 0x250F0110ull;

static const uint64_t P9N2_C_6_PPM_SSHSRC                                          = 0x260F0110ull;

static const uint64_t P9N2_C_7_PPM_SSHSRC                                          = 0x270F0110ull;

static const uint64_t P9N2_C_8_PPM_SSHSRC                                          = 0x280F0110ull;

static const uint64_t P9N2_C_9_PPM_SSHSRC                                          = 0x290F0110ull;

static const uint64_t P9N2_C_10_PPM_SSHSRC                                         = 0x2A0F0110ull;

static const uint64_t P9N2_C_11_PPM_SSHSRC                                         = 0x2B0F0110ull;

static const uint64_t P9N2_C_12_PPM_SSHSRC                                         = 0x2C0F0110ull;

static const uint64_t P9N2_C_13_PPM_SSHSRC                                         = 0x2D0F0110ull;

static const uint64_t P9N2_C_14_PPM_SSHSRC                                         = 0x2E0F0110ull;

static const uint64_t P9N2_C_15_PPM_SSHSRC                                         = 0x2F0F0110ull;

static const uint64_t P9N2_C_16_PPM_SSHSRC                                         = 0x300F0110ull;

static const uint64_t P9N2_C_17_PPM_SSHSRC                                         = 0x310F0110ull;

static const uint64_t P9N2_C_18_PPM_SSHSRC                                         = 0x320F0110ull;

static const uint64_t P9N2_C_19_PPM_SSHSRC                                         = 0x330F0110ull;

static const uint64_t P9N2_C_20_PPM_SSHSRC                                         = 0x340F0110ull;

static const uint64_t P9N2_C_21_PPM_SSHSRC                                         = 0x350F0110ull;

static const uint64_t P9N2_C_22_PPM_SSHSRC                                         = 0x360F0110ull;

static const uint64_t P9N2_C_23_PPM_SSHSRC                                         = 0x370F0110ull;

static const uint64_t P9N2_EQ_PPM_SSHSRC                                           = 0x100F0110ull;

static const uint64_t P9N2_EQ_0_PPM_SSHSRC                                         = 0x100F0110ull;

static const uint64_t P9N2_EQ_1_PPM_SSHSRC                                         = 0x110F0110ull;

static const uint64_t P9N2_EQ_2_PPM_SSHSRC                                         = 0x120F0110ull;

static const uint64_t P9N2_EQ_3_PPM_SSHSRC                                         = 0x130F0110ull;

static const uint64_t P9N2_EQ_4_PPM_SSHSRC                                         = 0x140F0110ull;

static const uint64_t P9N2_EQ_5_PPM_SSHSRC                                         = 0x150F0110ull;

static const uint64_t P9N2_EX_PPM_SSHSRC                                           = 0x200F0110ull;
//DUPS: 210F0110,
static const uint64_t P9N2_EX_0_PPM_SSHSRC                                         = 0x200F0110ull;
//DUPS: 210F0110,
static const uint64_t P9N2_EX_1_PPM_SSHSRC                                         = 0x220F0110ull;
//DUPS: 220F0110,
static const uint64_t P9N2_EX_2_PPM_SSHSRC                                         = 0x240F0110ull;
//DUPS: 250F0110,
static const uint64_t P9N2_EX_3_PPM_SSHSRC                                         = 0x260F0110ull;
//DUPS: 270F0110,
static const uint64_t P9N2_EX_4_PPM_SSHSRC                                         = 0x280F0110ull;
//DUPS: 290F0110,
static const uint64_t P9N2_EX_5_PPM_SSHSRC                                         = 0x2A0F0110ull;
//DUPS: 2B0F0110,
static const uint64_t P9N2_EX_6_PPM_SSHSRC                                         = 0x2C0F0110ull;
//DUPS: 2D0F0110,
static const uint64_t P9N2_EX_7_PPM_SSHSRC                                         = 0x2E0F0110ull;
//DUPS: 2F0F0110,
static const uint64_t P9N2_EX_8_PPM_SSHSRC                                         = 0x300F0110ull;
//DUPS: 310F0110,
static const uint64_t P9N2_EX_9_PPM_SSHSRC                                         = 0x320F0110ull;
//DUPS: 330F0110,
static const uint64_t P9N2_EX_10_PPM_SSHSRC                                        = 0x340F0110ull;
//DUPS: 350F0110,
static const uint64_t P9N2_EX_11_PPM_SSHSRC                                        = 0x360F0110ull;
//DUPS: 370F0110,

static const uint64_t P9N2_C_PPM_VDMCR                                             = 0x200F01B8ull;

static const uint64_t P9N2_C_PPM_VDMCR_CLEAR                                       = 0x200F01B9ull;

static const uint64_t P9N2_C_PPM_VDMCR_OR                                          = 0x200F01BAull;

static const uint64_t P9N2_C_0_PPM_VDMCR                                           = 0x200F01B8ull;

static const uint64_t P9N2_C_0_PPM_VDMCR_CLEAR                                     = 0x200F01B9ull;

static const uint64_t P9N2_C_0_PPM_VDMCR_OR                                        = 0x200F01BAull;

static const uint64_t P9N2_C_1_PPM_VDMCR                                           = 0x210F01B8ull;

static const uint64_t P9N2_C_1_PPM_VDMCR_CLEAR                                     = 0x210F01B9ull;

static const uint64_t P9N2_C_1_PPM_VDMCR_OR                                        = 0x210F01BAull;

static const uint64_t P9N2_C_2_PPM_VDMCR                                           = 0x220F01B8ull;

static const uint64_t P9N2_C_2_PPM_VDMCR_CLEAR                                     = 0x220F01B9ull;

static const uint64_t P9N2_C_2_PPM_VDMCR_OR                                        = 0x220F01BAull;

static const uint64_t P9N2_C_3_PPM_VDMCR                                           = 0x230F01B8ull;

static const uint64_t P9N2_C_3_PPM_VDMCR_CLEAR                                     = 0x230F01B9ull;

static const uint64_t P9N2_C_3_PPM_VDMCR_OR                                        = 0x230F01BAull;

static const uint64_t P9N2_C_4_PPM_VDMCR                                           = 0x240F01B8ull;

static const uint64_t P9N2_C_4_PPM_VDMCR_CLEAR                                     = 0x240F01B9ull;

static const uint64_t P9N2_C_4_PPM_VDMCR_OR                                        = 0x240F01BAull;

static const uint64_t P9N2_C_5_PPM_VDMCR                                           = 0x250F01B8ull;

static const uint64_t P9N2_C_5_PPM_VDMCR_CLEAR                                     = 0x250F01B9ull;

static const uint64_t P9N2_C_5_PPM_VDMCR_OR                                        = 0x250F01BAull;

static const uint64_t P9N2_C_6_PPM_VDMCR                                           = 0x260F01B8ull;

static const uint64_t P9N2_C_6_PPM_VDMCR_CLEAR                                     = 0x260F01B9ull;

static const uint64_t P9N2_C_6_PPM_VDMCR_OR                                        = 0x260F01BAull;

static const uint64_t P9N2_C_7_PPM_VDMCR                                           = 0x270F01B8ull;

static const uint64_t P9N2_C_7_PPM_VDMCR_CLEAR                                     = 0x270F01B9ull;

static const uint64_t P9N2_C_7_PPM_VDMCR_OR                                        = 0x270F01BAull;

static const uint64_t P9N2_C_8_PPM_VDMCR                                           = 0x280F01B8ull;

static const uint64_t P9N2_C_8_PPM_VDMCR_CLEAR                                     = 0x280F01B9ull;

static const uint64_t P9N2_C_8_PPM_VDMCR_OR                                        = 0x280F01BAull;

static const uint64_t P9N2_C_9_PPM_VDMCR                                           = 0x290F01B8ull;

static const uint64_t P9N2_C_9_PPM_VDMCR_CLEAR                                     = 0x290F01B9ull;

static const uint64_t P9N2_C_9_PPM_VDMCR_OR                                        = 0x290F01BAull;

static const uint64_t P9N2_C_10_PPM_VDMCR                                          = 0x2A0F01B8ull;

static const uint64_t P9N2_C_10_PPM_VDMCR_CLEAR                                    = 0x2A0F01B9ull;

static const uint64_t P9N2_C_10_PPM_VDMCR_OR                                       = 0x2A0F01BAull;

static const uint64_t P9N2_C_11_PPM_VDMCR                                          = 0x2B0F01B8ull;

static const uint64_t P9N2_C_11_PPM_VDMCR_CLEAR                                    = 0x2B0F01B9ull;

static const uint64_t P9N2_C_11_PPM_VDMCR_OR                                       = 0x2B0F01BAull;

static const uint64_t P9N2_C_12_PPM_VDMCR                                          = 0x2C0F01B8ull;

static const uint64_t P9N2_C_12_PPM_VDMCR_CLEAR                                    = 0x2C0F01B9ull;

static const uint64_t P9N2_C_12_PPM_VDMCR_OR                                       = 0x2C0F01BAull;

static const uint64_t P9N2_C_13_PPM_VDMCR                                          = 0x2D0F01B8ull;

static const uint64_t P9N2_C_13_PPM_VDMCR_CLEAR                                    = 0x2D0F01B9ull;

static const uint64_t P9N2_C_13_PPM_VDMCR_OR                                       = 0x2D0F01BAull;

static const uint64_t P9N2_C_14_PPM_VDMCR                                          = 0x2E0F01B8ull;

static const uint64_t P9N2_C_14_PPM_VDMCR_CLEAR                                    = 0x2E0F01B9ull;

static const uint64_t P9N2_C_14_PPM_VDMCR_OR                                       = 0x2E0F01BAull;

static const uint64_t P9N2_C_15_PPM_VDMCR                                          = 0x2F0F01B8ull;

static const uint64_t P9N2_C_15_PPM_VDMCR_CLEAR                                    = 0x2F0F01B9ull;

static const uint64_t P9N2_C_15_PPM_VDMCR_OR                                       = 0x2F0F01BAull;

static const uint64_t P9N2_C_16_PPM_VDMCR                                          = 0x300F01B8ull;

static const uint64_t P9N2_C_16_PPM_VDMCR_CLEAR                                    = 0x300F01B9ull;

static const uint64_t P9N2_C_16_PPM_VDMCR_OR                                       = 0x300F01BAull;

static const uint64_t P9N2_C_17_PPM_VDMCR                                          = 0x310F01B8ull;

static const uint64_t P9N2_C_17_PPM_VDMCR_CLEAR                                    = 0x310F01B9ull;

static const uint64_t P9N2_C_17_PPM_VDMCR_OR                                       = 0x310F01BAull;

static const uint64_t P9N2_C_18_PPM_VDMCR                                          = 0x320F01B8ull;

static const uint64_t P9N2_C_18_PPM_VDMCR_CLEAR                                    = 0x320F01B9ull;

static const uint64_t P9N2_C_18_PPM_VDMCR_OR                                       = 0x320F01BAull;

static const uint64_t P9N2_C_19_PPM_VDMCR                                          = 0x330F01B8ull;

static const uint64_t P9N2_C_19_PPM_VDMCR_CLEAR                                    = 0x330F01B9ull;

static const uint64_t P9N2_C_19_PPM_VDMCR_OR                                       = 0x330F01BAull;

static const uint64_t P9N2_C_20_PPM_VDMCR                                          = 0x340F01B8ull;

static const uint64_t P9N2_C_20_PPM_VDMCR_CLEAR                                    = 0x340F01B9ull;

static const uint64_t P9N2_C_20_PPM_VDMCR_OR                                       = 0x340F01BAull;

static const uint64_t P9N2_C_21_PPM_VDMCR                                          = 0x350F01B8ull;

static const uint64_t P9N2_C_21_PPM_VDMCR_CLEAR                                    = 0x350F01B9ull;

static const uint64_t P9N2_C_21_PPM_VDMCR_OR                                       = 0x350F01BAull;

static const uint64_t P9N2_C_22_PPM_VDMCR                                          = 0x360F01B8ull;

static const uint64_t P9N2_C_22_PPM_VDMCR_CLEAR                                    = 0x360F01B9ull;

static const uint64_t P9N2_C_22_PPM_VDMCR_OR                                       = 0x360F01BAull;

static const uint64_t P9N2_C_23_PPM_VDMCR                                          = 0x370F01B8ull;

static const uint64_t P9N2_C_23_PPM_VDMCR_CLEAR                                    = 0x370F01B9ull;

static const uint64_t P9N2_C_23_PPM_VDMCR_OR                                       = 0x370F01BAull;

static const uint64_t P9N2_EQ_PPM_VDMCR                                            = 0x100F01B8ull;

static const uint64_t P9N2_EQ_PPM_VDMCR_CLEAR                                      = 0x100F01B9ull;

static const uint64_t P9N2_EQ_PPM_VDMCR_OR                                         = 0x100F01BAull;

static const uint64_t P9N2_EQ_0_PPM_VDMCR                                          = 0x100F01B8ull;

static const uint64_t P9N2_EQ_0_PPM_VDMCR_CLEAR                                    = 0x100F01B9ull;

static const uint64_t P9N2_EQ_0_PPM_VDMCR_OR                                       = 0x100F01BAull;

static const uint64_t P9N2_EQ_1_PPM_VDMCR                                          = 0x110F01B8ull;

static const uint64_t P9N2_EQ_1_PPM_VDMCR_CLEAR                                    = 0x110F01B9ull;

static const uint64_t P9N2_EQ_1_PPM_VDMCR_OR                                       = 0x110F01BAull;

static const uint64_t P9N2_EQ_2_PPM_VDMCR                                          = 0x120F01B8ull;

static const uint64_t P9N2_EQ_2_PPM_VDMCR_CLEAR                                    = 0x120F01B9ull;

static const uint64_t P9N2_EQ_2_PPM_VDMCR_OR                                       = 0x120F01BAull;

static const uint64_t P9N2_EQ_3_PPM_VDMCR                                          = 0x130F01B8ull;

static const uint64_t P9N2_EQ_3_PPM_VDMCR_CLEAR                                    = 0x130F01B9ull;

static const uint64_t P9N2_EQ_3_PPM_VDMCR_OR                                       = 0x130F01BAull;

static const uint64_t P9N2_EQ_4_PPM_VDMCR                                          = 0x140F01B8ull;

static const uint64_t P9N2_EQ_4_PPM_VDMCR_CLEAR                                    = 0x140F01B9ull;

static const uint64_t P9N2_EQ_4_PPM_VDMCR_OR                                       = 0x140F01BAull;

static const uint64_t P9N2_EQ_5_PPM_VDMCR                                          = 0x150F01B8ull;

static const uint64_t P9N2_EQ_5_PPM_VDMCR_CLEAR                                    = 0x150F01B9ull;

static const uint64_t P9N2_EQ_5_PPM_VDMCR_OR                                       = 0x150F01BAull;

static const uint64_t P9N2_EX_PPM_VDMCR                                            = 0x200F01B8ull;
//DUPS: 210F01B8,
static const uint64_t P9N2_EX_PPM_VDMCR_CLEAR                                      = 0x200F01B9ull;
//DUPS: 210F01B9,
static const uint64_t P9N2_EX_PPM_VDMCR_OR                                         = 0x200F01BAull;
//DUPS: 210F01BA,
static const uint64_t P9N2_EX_0_PPM_VDMCR                                          = 0x200F01B8ull;
//DUPS: 210F01B8,
static const uint64_t P9N2_EX_0_PPM_VDMCR_CLEAR                                    = 0x200F01B9ull;
//DUPS: 210F01B9,
static const uint64_t P9N2_EX_0_PPM_VDMCR_OR                                       = 0x200F01BAull;
//DUPS: 210F01BA,
static const uint64_t P9N2_EX_1_PPM_VDMCR                                          = 0x220F01B8ull;
//DUPS: 220F01B8,
static const uint64_t P9N2_EX_1_PPM_VDMCR_CLEAR                                    = 0x220F01B9ull;
//DUPS: 220F01B9,
static const uint64_t P9N2_EX_1_PPM_VDMCR_OR                                       = 0x220F01BAull;
//DUPS: 220F01BA,
static const uint64_t P9N2_EX_2_PPM_VDMCR                                          = 0x240F01B8ull;
//DUPS: 250F01B8,
static const uint64_t P9N2_EX_2_PPM_VDMCR_CLEAR                                    = 0x240F01B9ull;
//DUPS: 250F01B9,
static const uint64_t P9N2_EX_2_PPM_VDMCR_OR                                       = 0x240F01BAull;
//DUPS: 250F01BA,
static const uint64_t P9N2_EX_3_PPM_VDMCR                                          = 0x260F01B8ull;
//DUPS: 270F01B8,
static const uint64_t P9N2_EX_3_PPM_VDMCR_CLEAR                                    = 0x260F01B9ull;
//DUPS: 270F01B9,
static const uint64_t P9N2_EX_3_PPM_VDMCR_OR                                       = 0x260F01BAull;
//DUPS: 270F01BA,
static const uint64_t P9N2_EX_4_PPM_VDMCR                                          = 0x280F01B8ull;
//DUPS: 290F01B8,
static const uint64_t P9N2_EX_4_PPM_VDMCR_CLEAR                                    = 0x280F01B9ull;
//DUPS: 290F01B9,
static const uint64_t P9N2_EX_4_PPM_VDMCR_OR                                       = 0x280F01BAull;
//DUPS: 290F01BA,
static const uint64_t P9N2_EX_5_PPM_VDMCR                                          = 0x2A0F01B8ull;
//DUPS: 2B0F01B8,
static const uint64_t P9N2_EX_5_PPM_VDMCR_CLEAR                                    = 0x2A0F01B9ull;
//DUPS: 2B0F01B9,
static const uint64_t P9N2_EX_5_PPM_VDMCR_OR                                       = 0x2A0F01BAull;
//DUPS: 2B0F01BA,
static const uint64_t P9N2_EX_6_PPM_VDMCR                                          = 0x2C0F01B8ull;
//DUPS: 2D0F01B8,
static const uint64_t P9N2_EX_6_PPM_VDMCR_CLEAR                                    = 0x2C0F01B9ull;
//DUPS: 2D0F01B9,
static const uint64_t P9N2_EX_6_PPM_VDMCR_OR                                       = 0x2C0F01BAull;
//DUPS: 2D0F01BA,
static const uint64_t P9N2_EX_7_PPM_VDMCR                                          = 0x2E0F01B8ull;
//DUPS: 2F0F01B8,
static const uint64_t P9N2_EX_7_PPM_VDMCR_CLEAR                                    = 0x2E0F01B9ull;
//DUPS: 2F0F01B9,
static const uint64_t P9N2_EX_7_PPM_VDMCR_OR                                       = 0x2E0F01BAull;
//DUPS: 2F0F01BA,
static const uint64_t P9N2_EX_8_PPM_VDMCR                                          = 0x300F01B8ull;
//DUPS: 310F01B8,
static const uint64_t P9N2_EX_8_PPM_VDMCR_CLEAR                                    = 0x300F01B9ull;
//DUPS: 310F01B9,
static const uint64_t P9N2_EX_8_PPM_VDMCR_OR                                       = 0x300F01BAull;
//DUPS: 310F01BA,
static const uint64_t P9N2_EX_9_PPM_VDMCR                                          = 0x320F01B8ull;
//DUPS: 330F01B8,
static const uint64_t P9N2_EX_9_PPM_VDMCR_CLEAR                                    = 0x320F01B9ull;
//DUPS: 330F01B9,
static const uint64_t P9N2_EX_9_PPM_VDMCR_OR                                       = 0x320F01BAull;
//DUPS: 330F01BA,
static const uint64_t P9N2_EX_10_PPM_VDMCR                                         = 0x340F01B8ull;
//DUPS: 350F01B8,
static const uint64_t P9N2_EX_10_PPM_VDMCR_CLEAR                                   = 0x340F01B9ull;
//DUPS: 350F01B9,
static const uint64_t P9N2_EX_10_PPM_VDMCR_OR                                      = 0x340F01BAull;
//DUPS: 350F01BA,
static const uint64_t P9N2_EX_11_PPM_VDMCR                                         = 0x360F01B8ull;
//DUPS: 370F01B8,
static const uint64_t P9N2_EX_11_PPM_VDMCR_CLEAR                                   = 0x360F01B9ull;
//DUPS: 370F01B9,
static const uint64_t P9N2_EX_11_PPM_VDMCR_OR                                      = 0x360F01BAull;
//DUPS: 370F01BA,

static const uint64_t P9N2_EQ_PRD_PURGE_CMD_REG                                    = 0x10010C0Eull;
//DUPS: 10010C0E,
static const uint64_t P9N2_EQ_0_PRD_PURGE_CMD_REG                                  = 0x10010C0Eull;
//DUPS: 10010C0E,
static const uint64_t P9N2_EQ_1_PRD_PURGE_CMD_REG                                  = 0x11010C0Eull;
//DUPS: 11010C0E,
static const uint64_t P9N2_EQ_2_PRD_PURGE_CMD_REG                                  = 0x12010C0Eull;
//DUPS: 12010C0E,
static const uint64_t P9N2_EQ_3_PRD_PURGE_CMD_REG                                  = 0x13010C0Eull;
//DUPS: 13010C0E,
static const uint64_t P9N2_EQ_4_PRD_PURGE_CMD_REG                                  = 0x14010C0Eull;
//DUPS: 14010C0E,
static const uint64_t P9N2_EQ_5_PRD_PURGE_CMD_REG                                  = 0x15010C0Eull;
//DUPS: 15010C0E,
static const uint64_t P9N2_EX_PRD_PURGE_CMD_REG                                    = 0x1001080Eull;

static const uint64_t P9N2_EX_0_PRD_PURGE_CMD_REG                                  = 0x1001080Eull;

static const uint64_t P9N2_EX_1_PRD_PURGE_CMD_REG                                  = 0x10010C0Eull;

static const uint64_t P9N2_EX_2_PRD_PURGE_CMD_REG                                  = 0x1101080Eull;

static const uint64_t P9N2_EX_3_PRD_PURGE_CMD_REG                                  = 0x11010C0Eull;

static const uint64_t P9N2_EX_4_PRD_PURGE_CMD_REG                                  = 0x1201080Eull;

static const uint64_t P9N2_EX_5_PRD_PURGE_CMD_REG                                  = 0x12010C0Eull;

static const uint64_t P9N2_EX_6_PRD_PURGE_CMD_REG                                  = 0x1301080Eull;

static const uint64_t P9N2_EX_7_PRD_PURGE_CMD_REG                                  = 0x13010C0Eull;

static const uint64_t P9N2_EX_8_PRD_PURGE_CMD_REG                                  = 0x1401080Eull;

static const uint64_t P9N2_EX_9_PRD_PURGE_CMD_REG                                  = 0x14010C0Eull;

static const uint64_t P9N2_EX_10_PRD_PURGE_CMD_REG                                 = 0x1501080Eull;

static const uint64_t P9N2_EX_11_PRD_PURGE_CMD_REG                                 = 0x15010C0Eull;


static const uint64_t P9N2_EQ_PRD_PURGE_REG                                        = 0x10011C0Eull;
//DUPS: 10011C0E,
static const uint64_t P9N2_EQ_0_PRD_PURGE_REG                                      = 0x10011C0Eull;
//DUPS: 10011C0E,
static const uint64_t P9N2_EQ_1_PRD_PURGE_REG                                      = 0x11011C0Eull;
//DUPS: 11011C0E,
static const uint64_t P9N2_EQ_2_PRD_PURGE_REG                                      = 0x12011C0Eull;
//DUPS: 12011C0E,
static const uint64_t P9N2_EQ_3_PRD_PURGE_REG                                      = 0x13011C0Eull;
//DUPS: 13011C0E,
static const uint64_t P9N2_EQ_4_PRD_PURGE_REG                                      = 0x14011C0Eull;
//DUPS: 14011C0E,
static const uint64_t P9N2_EQ_5_PRD_PURGE_REG                                      = 0x15011C0Eull;
//DUPS: 15011C0E,
static const uint64_t P9N2_EX_PRD_PURGE_REG                                        = 0x1001180Eull;

static const uint64_t P9N2_EX_0_PRD_PURGE_REG                                      = 0x1001180Eull;

static const uint64_t P9N2_EX_1_PRD_PURGE_REG                                      = 0x10011C0Eull;

static const uint64_t P9N2_EX_2_PRD_PURGE_REG                                      = 0x1101180Eull;

static const uint64_t P9N2_EX_3_PRD_PURGE_REG                                      = 0x11011C0Eull;

static const uint64_t P9N2_EX_4_PRD_PURGE_REG                                      = 0x1201180Eull;

static const uint64_t P9N2_EX_5_PRD_PURGE_REG                                      = 0x12011C0Eull;

static const uint64_t P9N2_EX_6_PRD_PURGE_REG                                      = 0x1301180Eull;

static const uint64_t P9N2_EX_7_PRD_PURGE_REG                                      = 0x13011C0Eull;

static const uint64_t P9N2_EX_8_PRD_PURGE_REG                                      = 0x1401180Eull;

static const uint64_t P9N2_EX_9_PRD_PURGE_REG                                      = 0x14011C0Eull;

static const uint64_t P9N2_EX_10_PRD_PURGE_REG                                     = 0x1501180Eull;

static const uint64_t P9N2_EX_11_PRD_PURGE_REG                                     = 0x15011C0Eull;


static const uint64_t P9N2_C_PRE_COUNTER_REG                                       = 0x200F0028ull;

static const uint64_t P9N2_C_0_PRE_COUNTER_REG                                     = 0x200F0028ull;

static const uint64_t P9N2_C_1_PRE_COUNTER_REG                                     = 0x210F0028ull;

static const uint64_t P9N2_C_2_PRE_COUNTER_REG                                     = 0x220F0028ull;

static const uint64_t P9N2_C_3_PRE_COUNTER_REG                                     = 0x230F0028ull;

static const uint64_t P9N2_C_4_PRE_COUNTER_REG                                     = 0x240F0028ull;

static const uint64_t P9N2_C_5_PRE_COUNTER_REG                                     = 0x250F0028ull;

static const uint64_t P9N2_C_6_PRE_COUNTER_REG                                     = 0x260F0028ull;

static const uint64_t P9N2_C_7_PRE_COUNTER_REG                                     = 0x270F0028ull;

static const uint64_t P9N2_C_8_PRE_COUNTER_REG                                     = 0x280F0028ull;

static const uint64_t P9N2_C_9_PRE_COUNTER_REG                                     = 0x290F0028ull;

static const uint64_t P9N2_C_10_PRE_COUNTER_REG                                    = 0x2A0F0028ull;

static const uint64_t P9N2_C_11_PRE_COUNTER_REG                                    = 0x2B0F0028ull;

static const uint64_t P9N2_C_12_PRE_COUNTER_REG                                    = 0x2C0F0028ull;

static const uint64_t P9N2_C_13_PRE_COUNTER_REG                                    = 0x2D0F0028ull;

static const uint64_t P9N2_C_14_PRE_COUNTER_REG                                    = 0x2E0F0028ull;

static const uint64_t P9N2_C_15_PRE_COUNTER_REG                                    = 0x2F0F0028ull;

static const uint64_t P9N2_C_16_PRE_COUNTER_REG                                    = 0x300F0028ull;

static const uint64_t P9N2_C_17_PRE_COUNTER_REG                                    = 0x310F0028ull;

static const uint64_t P9N2_C_18_PRE_COUNTER_REG                                    = 0x320F0028ull;

static const uint64_t P9N2_C_19_PRE_COUNTER_REG                                    = 0x330F0028ull;

static const uint64_t P9N2_C_20_PRE_COUNTER_REG                                    = 0x340F0028ull;

static const uint64_t P9N2_C_21_PRE_COUNTER_REG                                    = 0x350F0028ull;

static const uint64_t P9N2_C_22_PRE_COUNTER_REG                                    = 0x360F0028ull;

static const uint64_t P9N2_C_23_PRE_COUNTER_REG                                    = 0x370F0028ull;

static const uint64_t P9N2_EQ_PRE_COUNTER_REG                                      = 0x100F0028ull;

static const uint64_t P9N2_EQ_0_PRE_COUNTER_REG                                    = 0x100F0028ull;

static const uint64_t P9N2_EQ_1_PRE_COUNTER_REG                                    = 0x110F0028ull;

static const uint64_t P9N2_EQ_2_PRE_COUNTER_REG                                    = 0x120F0028ull;

static const uint64_t P9N2_EQ_3_PRE_COUNTER_REG                                    = 0x130F0028ull;

static const uint64_t P9N2_EQ_4_PRE_COUNTER_REG                                    = 0x140F0028ull;

static const uint64_t P9N2_EQ_5_PRE_COUNTER_REG                                    = 0x150F0028ull;

static const uint64_t P9N2_EX_PRE_COUNTER_REG                                      = 0x200F0028ull;
//DUPS: 210F0028,
static const uint64_t P9N2_EX_0_PRE_COUNTER_REG                                    = 0x200F0028ull;
//DUPS: 210F0028,
static const uint64_t P9N2_EX_1_PRE_COUNTER_REG                                    = 0x220F0028ull;
//DUPS: 220F0028,
static const uint64_t P9N2_EX_2_PRE_COUNTER_REG                                    = 0x240F0028ull;
//DUPS: 250F0028,
static const uint64_t P9N2_EX_3_PRE_COUNTER_REG                                    = 0x260F0028ull;
//DUPS: 270F0028,
static const uint64_t P9N2_EX_4_PRE_COUNTER_REG                                    = 0x280F0028ull;
//DUPS: 290F0028,
static const uint64_t P9N2_EX_5_PRE_COUNTER_REG                                    = 0x2A0F0028ull;
//DUPS: 2B0F0028,
static const uint64_t P9N2_EX_6_PRE_COUNTER_REG                                    = 0x2C0F0028ull;
//DUPS: 2D0F0028,
static const uint64_t P9N2_EX_7_PRE_COUNTER_REG                                    = 0x2E0F0028ull;
//DUPS: 2F0F0028,
static const uint64_t P9N2_EX_8_PRE_COUNTER_REG                                    = 0x300F0028ull;
//DUPS: 310F0028,
static const uint64_t P9N2_EX_9_PRE_COUNTER_REG                                    = 0x320F0028ull;
//DUPS: 330F0028,
static const uint64_t P9N2_EX_10_PRE_COUNTER_REG                                   = 0x340F0028ull;
//DUPS: 350F0028,
static const uint64_t P9N2_EX_11_PRE_COUNTER_REG                                   = 0x360F0028ull;
//DUPS: 370F0028,

static const uint64_t P9N2_C_PRIMARY_ADDRESS_REG                                   = 0x200F0000ull;

static const uint64_t P9N2_C_0_PRIMARY_ADDRESS_REG                                 = 0x200F0000ull;

static const uint64_t P9N2_C_1_PRIMARY_ADDRESS_REG                                 = 0x210F0000ull;

static const uint64_t P9N2_C_2_PRIMARY_ADDRESS_REG                                 = 0x220F0000ull;

static const uint64_t P9N2_C_3_PRIMARY_ADDRESS_REG                                 = 0x230F0000ull;

static const uint64_t P9N2_C_4_PRIMARY_ADDRESS_REG                                 = 0x240F0000ull;

static const uint64_t P9N2_C_5_PRIMARY_ADDRESS_REG                                 = 0x250F0000ull;

static const uint64_t P9N2_C_6_PRIMARY_ADDRESS_REG                                 = 0x260F0000ull;

static const uint64_t P9N2_C_7_PRIMARY_ADDRESS_REG                                 = 0x270F0000ull;

static const uint64_t P9N2_C_8_PRIMARY_ADDRESS_REG                                 = 0x280F0000ull;

static const uint64_t P9N2_C_9_PRIMARY_ADDRESS_REG                                 = 0x290F0000ull;

static const uint64_t P9N2_C_10_PRIMARY_ADDRESS_REG                                = 0x2A0F0000ull;

static const uint64_t P9N2_C_11_PRIMARY_ADDRESS_REG                                = 0x2B0F0000ull;

static const uint64_t P9N2_C_12_PRIMARY_ADDRESS_REG                                = 0x2C0F0000ull;

static const uint64_t P9N2_C_13_PRIMARY_ADDRESS_REG                                = 0x2D0F0000ull;

static const uint64_t P9N2_C_14_PRIMARY_ADDRESS_REG                                = 0x2E0F0000ull;

static const uint64_t P9N2_C_15_PRIMARY_ADDRESS_REG                                = 0x2F0F0000ull;

static const uint64_t P9N2_C_16_PRIMARY_ADDRESS_REG                                = 0x300F0000ull;

static const uint64_t P9N2_C_17_PRIMARY_ADDRESS_REG                                = 0x310F0000ull;

static const uint64_t P9N2_C_18_PRIMARY_ADDRESS_REG                                = 0x320F0000ull;

static const uint64_t P9N2_C_19_PRIMARY_ADDRESS_REG                                = 0x330F0000ull;

static const uint64_t P9N2_C_20_PRIMARY_ADDRESS_REG                                = 0x340F0000ull;

static const uint64_t P9N2_C_21_PRIMARY_ADDRESS_REG                                = 0x350F0000ull;

static const uint64_t P9N2_C_22_PRIMARY_ADDRESS_REG                                = 0x360F0000ull;

static const uint64_t P9N2_C_23_PRIMARY_ADDRESS_REG                                = 0x370F0000ull;

static const uint64_t P9N2_EQ_PRIMARY_ADDRESS_REG                                  = 0x100F0000ull;

static const uint64_t P9N2_EQ_0_PRIMARY_ADDRESS_REG                                = 0x100F0000ull;

static const uint64_t P9N2_EQ_1_PRIMARY_ADDRESS_REG                                = 0x110F0000ull;

static const uint64_t P9N2_EQ_2_PRIMARY_ADDRESS_REG                                = 0x120F0000ull;

static const uint64_t P9N2_EQ_3_PRIMARY_ADDRESS_REG                                = 0x130F0000ull;

static const uint64_t P9N2_EQ_4_PRIMARY_ADDRESS_REG                                = 0x140F0000ull;

static const uint64_t P9N2_EQ_5_PRIMARY_ADDRESS_REG                                = 0x150F0000ull;

static const uint64_t P9N2_EX_PRIMARY_ADDRESS_REG                                  = 0x200F0000ull;
//DUPS: 210F0000,
static const uint64_t P9N2_EX_0_PRIMARY_ADDRESS_REG                                = 0x200F0000ull;
//DUPS: 210F0000,
static const uint64_t P9N2_EX_1_PRIMARY_ADDRESS_REG                                = 0x220F0000ull;
//DUPS: 220F0000,
static const uint64_t P9N2_EX_2_PRIMARY_ADDRESS_REG                                = 0x240F0000ull;
//DUPS: 250F0000,
static const uint64_t P9N2_EX_3_PRIMARY_ADDRESS_REG                                = 0x260F0000ull;
//DUPS: 270F0000,
static const uint64_t P9N2_EX_4_PRIMARY_ADDRESS_REG                                = 0x280F0000ull;
//DUPS: 290F0000,
static const uint64_t P9N2_EX_5_PRIMARY_ADDRESS_REG                                = 0x2A0F0000ull;
//DUPS: 2B0F0000,
static const uint64_t P9N2_EX_6_PRIMARY_ADDRESS_REG                                = 0x2C0F0000ull;
//DUPS: 2D0F0000,
static const uint64_t P9N2_EX_7_PRIMARY_ADDRESS_REG                                = 0x2E0F0000ull;
//DUPS: 2F0F0000,
static const uint64_t P9N2_EX_8_PRIMARY_ADDRESS_REG                                = 0x300F0000ull;
//DUPS: 310F0000,
static const uint64_t P9N2_EX_9_PRIMARY_ADDRESS_REG                                = 0x320F0000ull;
//DUPS: 330F0000,
static const uint64_t P9N2_EX_10_PRIMARY_ADDRESS_REG                               = 0x340F0000ull;
//DUPS: 350F0000,
static const uint64_t P9N2_EX_11_PRIMARY_ADDRESS_REG                               = 0x360F0000ull;
//DUPS: 370F0000,

static const uint64_t P9N2_C_PROTECT_MODE_REG                                      = 0x200F03FEull;

static const uint64_t P9N2_C_0_PROTECT_MODE_REG                                    = 0x200F03FEull;

static const uint64_t P9N2_C_1_PROTECT_MODE_REG                                    = 0x210F03FEull;

static const uint64_t P9N2_C_2_PROTECT_MODE_REG                                    = 0x220F03FEull;

static const uint64_t P9N2_C_3_PROTECT_MODE_REG                                    = 0x230F03FEull;

static const uint64_t P9N2_C_4_PROTECT_MODE_REG                                    = 0x240F03FEull;

static const uint64_t P9N2_C_5_PROTECT_MODE_REG                                    = 0x250F03FEull;

static const uint64_t P9N2_C_6_PROTECT_MODE_REG                                    = 0x260F03FEull;

static const uint64_t P9N2_C_7_PROTECT_MODE_REG                                    = 0x270F03FEull;

static const uint64_t P9N2_C_8_PROTECT_MODE_REG                                    = 0x280F03FEull;

static const uint64_t P9N2_C_9_PROTECT_MODE_REG                                    = 0x290F03FEull;

static const uint64_t P9N2_C_10_PROTECT_MODE_REG                                   = 0x2A0F03FEull;

static const uint64_t P9N2_C_11_PROTECT_MODE_REG                                   = 0x2B0F03FEull;

static const uint64_t P9N2_C_12_PROTECT_MODE_REG                                   = 0x2C0F03FEull;

static const uint64_t P9N2_C_13_PROTECT_MODE_REG                                   = 0x2D0F03FEull;

static const uint64_t P9N2_C_14_PROTECT_MODE_REG                                   = 0x2E0F03FEull;

static const uint64_t P9N2_C_15_PROTECT_MODE_REG                                   = 0x2F0F03FEull;

static const uint64_t P9N2_C_16_PROTECT_MODE_REG                                   = 0x300F03FEull;

static const uint64_t P9N2_C_17_PROTECT_MODE_REG                                   = 0x310F03FEull;

static const uint64_t P9N2_C_18_PROTECT_MODE_REG                                   = 0x320F03FEull;

static const uint64_t P9N2_C_19_PROTECT_MODE_REG                                   = 0x330F03FEull;

static const uint64_t P9N2_C_20_PROTECT_MODE_REG                                   = 0x340F03FEull;

static const uint64_t P9N2_C_21_PROTECT_MODE_REG                                   = 0x350F03FEull;

static const uint64_t P9N2_C_22_PROTECT_MODE_REG                                   = 0x360F03FEull;

static const uint64_t P9N2_C_23_PROTECT_MODE_REG                                   = 0x370F03FEull;

static const uint64_t P9N2_EQ_PROTECT_MODE_REG                                     = 0x100F03FEull;

static const uint64_t P9N2_EQ_0_PROTECT_MODE_REG                                   = 0x100F03FEull;

static const uint64_t P9N2_EQ_1_PROTECT_MODE_REG                                   = 0x110F03FEull;

static const uint64_t P9N2_EQ_2_PROTECT_MODE_REG                                   = 0x120F03FEull;

static const uint64_t P9N2_EQ_3_PROTECT_MODE_REG                                   = 0x130F03FEull;

static const uint64_t P9N2_EQ_4_PROTECT_MODE_REG                                   = 0x140F03FEull;

static const uint64_t P9N2_EQ_5_PROTECT_MODE_REG                                   = 0x150F03FEull;

static const uint64_t P9N2_EX_PROTECT_MODE_REG                                     = 0x200F03FEull;
//DUPS: 210F03FE,
static const uint64_t P9N2_EX_0_PROTECT_MODE_REG                                   = 0x200F03FEull;
//DUPS: 210F03FE,
static const uint64_t P9N2_EX_1_PROTECT_MODE_REG                                   = 0x220F03FEull;
//DUPS: 220F03FE,
static const uint64_t P9N2_EX_2_PROTECT_MODE_REG                                   = 0x240F03FEull;
//DUPS: 250F03FE,
static const uint64_t P9N2_EX_3_PROTECT_MODE_REG                                   = 0x260F03FEull;
//DUPS: 270F03FE,
static const uint64_t P9N2_EX_4_PROTECT_MODE_REG                                   = 0x280F03FEull;
//DUPS: 290F03FE,
static const uint64_t P9N2_EX_5_PROTECT_MODE_REG                                   = 0x2A0F03FEull;
//DUPS: 2B0F03FE,
static const uint64_t P9N2_EX_6_PROTECT_MODE_REG                                   = 0x2C0F03FEull;
//DUPS: 2D0F03FE,
static const uint64_t P9N2_EX_7_PROTECT_MODE_REG                                   = 0x2E0F03FEull;
//DUPS: 2F0F03FE,
static const uint64_t P9N2_EX_8_PROTECT_MODE_REG                                   = 0x300F03FEull;
//DUPS: 310F03FE,
static const uint64_t P9N2_EX_9_PROTECT_MODE_REG                                   = 0x320F03FEull;
//DUPS: 330F03FE,
static const uint64_t P9N2_EX_10_PROTECT_MODE_REG                                  = 0x340F03FEull;
//DUPS: 350F03FE,
static const uint64_t P9N2_EX_11_PROTECT_MODE_REG                                  = 0x360F03FEull;
//DUPS: 370F03FE,

static const uint64_t P9N2_C_PSCOM_ERROR_MASK                                      = 0x20010002ull;

static const uint64_t P9N2_C_0_PSCOM_ERROR_MASK                                    = 0x20010002ull;

static const uint64_t P9N2_C_1_PSCOM_ERROR_MASK                                    = 0x21010002ull;

static const uint64_t P9N2_C_2_PSCOM_ERROR_MASK                                    = 0x22010002ull;

static const uint64_t P9N2_C_3_PSCOM_ERROR_MASK                                    = 0x23010002ull;

static const uint64_t P9N2_C_4_PSCOM_ERROR_MASK                                    = 0x24010002ull;

static const uint64_t P9N2_C_5_PSCOM_ERROR_MASK                                    = 0x25010002ull;

static const uint64_t P9N2_C_6_PSCOM_ERROR_MASK                                    = 0x26010002ull;

static const uint64_t P9N2_C_7_PSCOM_ERROR_MASK                                    = 0x27010002ull;

static const uint64_t P9N2_C_8_PSCOM_ERROR_MASK                                    = 0x28010002ull;

static const uint64_t P9N2_C_9_PSCOM_ERROR_MASK                                    = 0x29010002ull;

static const uint64_t P9N2_C_10_PSCOM_ERROR_MASK                                   = 0x2A010002ull;

static const uint64_t P9N2_C_11_PSCOM_ERROR_MASK                                   = 0x2B010002ull;

static const uint64_t P9N2_C_12_PSCOM_ERROR_MASK                                   = 0x2C010002ull;

static const uint64_t P9N2_C_13_PSCOM_ERROR_MASK                                   = 0x2D010002ull;

static const uint64_t P9N2_C_14_PSCOM_ERROR_MASK                                   = 0x2E010002ull;

static const uint64_t P9N2_C_15_PSCOM_ERROR_MASK                                   = 0x2F010002ull;

static const uint64_t P9N2_C_16_PSCOM_ERROR_MASK                                   = 0x30010002ull;

static const uint64_t P9N2_C_17_PSCOM_ERROR_MASK                                   = 0x31010002ull;

static const uint64_t P9N2_C_18_PSCOM_ERROR_MASK                                   = 0x32010002ull;

static const uint64_t P9N2_C_19_PSCOM_ERROR_MASK                                   = 0x33010002ull;

static const uint64_t P9N2_C_20_PSCOM_ERROR_MASK                                   = 0x34010002ull;

static const uint64_t P9N2_C_21_PSCOM_ERROR_MASK                                   = 0x35010002ull;

static const uint64_t P9N2_C_22_PSCOM_ERROR_MASK                                   = 0x36010002ull;

static const uint64_t P9N2_C_23_PSCOM_ERROR_MASK                                   = 0x37010002ull;

static const uint64_t P9N2_EQ_PSCOM_ERROR_MASK                                     = 0x10010002ull;

static const uint64_t P9N2_EQ_0_PSCOM_ERROR_MASK                                   = 0x10010002ull;

static const uint64_t P9N2_EQ_1_PSCOM_ERROR_MASK                                   = 0x11010002ull;

static const uint64_t P9N2_EQ_2_PSCOM_ERROR_MASK                                   = 0x12010002ull;

static const uint64_t P9N2_EQ_3_PSCOM_ERROR_MASK                                   = 0x13010002ull;

static const uint64_t P9N2_EQ_4_PSCOM_ERROR_MASK                                   = 0x14010002ull;

static const uint64_t P9N2_EQ_5_PSCOM_ERROR_MASK                                   = 0x15010002ull;

static const uint64_t P9N2_EX_PSCOM_ERROR_MASK                                     = 0x20010002ull;
//DUPS: 21010002,
static const uint64_t P9N2_EX_0_PSCOM_ERROR_MASK                                   = 0x20010002ull;
//DUPS: 21010002,
static const uint64_t P9N2_EX_1_PSCOM_ERROR_MASK                                   = 0x22010002ull;
//DUPS: 23010002,
static const uint64_t P9N2_EX_2_PSCOM_ERROR_MASK                                   = 0x24010002ull;
//DUPS: 25010002,
static const uint64_t P9N2_EX_3_PSCOM_ERROR_MASK                                   = 0x26010002ull;
//DUPS: 27010002,
static const uint64_t P9N2_EX_4_PSCOM_ERROR_MASK                                   = 0x28010002ull;
//DUPS: 29010002,
static const uint64_t P9N2_EX_5_PSCOM_ERROR_MASK                                   = 0x2A010002ull;
//DUPS: 2B010002,
static const uint64_t P9N2_EX_6_PSCOM_ERROR_MASK                                   = 0x2C010002ull;
//DUPS: 2D010002,
static const uint64_t P9N2_EX_7_PSCOM_ERROR_MASK                                   = 0x2F010002ull;
//DUPS: 2F010002,
static const uint64_t P9N2_EX_8_PSCOM_ERROR_MASK                                   = 0x30010002ull;
//DUPS: 31010002,
static const uint64_t P9N2_EX_9_PSCOM_ERROR_MASK                                   = 0x32010002ull;
//DUPS: 33010002,
static const uint64_t P9N2_EX_10_PSCOM_ERROR_MASK                                  = 0x34010002ull;
//DUPS: 35010002,
static const uint64_t P9N2_EX_11_PSCOM_ERROR_MASK                                  = 0x36010002ull;
//DUPS: 37010002,

static const uint64_t P9N2_C_PSCOM_MODE_REG                                        = 0x20010000ull;

static const uint64_t P9N2_C_0_PSCOM_MODE_REG                                      = 0x20010000ull;

static const uint64_t P9N2_C_1_PSCOM_MODE_REG                                      = 0x21010000ull;

static const uint64_t P9N2_C_2_PSCOM_MODE_REG                                      = 0x22010000ull;

static const uint64_t P9N2_C_3_PSCOM_MODE_REG                                      = 0x23010000ull;

static const uint64_t P9N2_C_4_PSCOM_MODE_REG                                      = 0x24010000ull;

static const uint64_t P9N2_C_5_PSCOM_MODE_REG                                      = 0x25010000ull;

static const uint64_t P9N2_C_6_PSCOM_MODE_REG                                      = 0x26010000ull;

static const uint64_t P9N2_C_7_PSCOM_MODE_REG                                      = 0x27010000ull;

static const uint64_t P9N2_C_8_PSCOM_MODE_REG                                      = 0x28010000ull;

static const uint64_t P9N2_C_9_PSCOM_MODE_REG                                      = 0x29010000ull;

static const uint64_t P9N2_C_10_PSCOM_MODE_REG                                     = 0x2A010000ull;

static const uint64_t P9N2_C_11_PSCOM_MODE_REG                                     = 0x2B010000ull;

static const uint64_t P9N2_C_12_PSCOM_MODE_REG                                     = 0x2C010000ull;

static const uint64_t P9N2_C_13_PSCOM_MODE_REG                                     = 0x2D010000ull;

static const uint64_t P9N2_C_14_PSCOM_MODE_REG                                     = 0x2E010000ull;

static const uint64_t P9N2_C_15_PSCOM_MODE_REG                                     = 0x2F010000ull;

static const uint64_t P9N2_C_16_PSCOM_MODE_REG                                     = 0x30010000ull;

static const uint64_t P9N2_C_17_PSCOM_MODE_REG                                     = 0x31010000ull;

static const uint64_t P9N2_C_18_PSCOM_MODE_REG                                     = 0x32010000ull;

static const uint64_t P9N2_C_19_PSCOM_MODE_REG                                     = 0x33010000ull;

static const uint64_t P9N2_C_20_PSCOM_MODE_REG                                     = 0x34010000ull;

static const uint64_t P9N2_C_21_PSCOM_MODE_REG                                     = 0x35010000ull;

static const uint64_t P9N2_C_22_PSCOM_MODE_REG                                     = 0x36010000ull;

static const uint64_t P9N2_C_23_PSCOM_MODE_REG                                     = 0x37010000ull;

static const uint64_t P9N2_EQ_PSCOM_MODE_REG                                       = 0x10010000ull;

static const uint64_t P9N2_EQ_0_PSCOM_MODE_REG                                     = 0x10010000ull;

static const uint64_t P9N2_EQ_1_PSCOM_MODE_REG                                     = 0x11010000ull;

static const uint64_t P9N2_EQ_2_PSCOM_MODE_REG                                     = 0x12010000ull;

static const uint64_t P9N2_EQ_3_PSCOM_MODE_REG                                     = 0x13010000ull;

static const uint64_t P9N2_EQ_4_PSCOM_MODE_REG                                     = 0x14010000ull;

static const uint64_t P9N2_EQ_5_PSCOM_MODE_REG                                     = 0x15010000ull;

static const uint64_t P9N2_EX_PSCOM_MODE_REG                                       = 0x20010000ull;
//DUPS: 21010000,
static const uint64_t P9N2_EX_0_PSCOM_MODE_REG                                     = 0x20010000ull;
//DUPS: 21010000,
static const uint64_t P9N2_EX_1_PSCOM_MODE_REG                                     = 0x22010000ull;
//DUPS: 23010000,
static const uint64_t P9N2_EX_2_PSCOM_MODE_REG                                     = 0x24010000ull;
//DUPS: 25010000,
static const uint64_t P9N2_EX_3_PSCOM_MODE_REG                                     = 0x26010000ull;
//DUPS: 27010000,
static const uint64_t P9N2_EX_4_PSCOM_MODE_REG                                     = 0x28010000ull;
//DUPS: 29010000,
static const uint64_t P9N2_EX_5_PSCOM_MODE_REG                                     = 0x2A010000ull;
//DUPS: 2B010000,
static const uint64_t P9N2_EX_6_PSCOM_MODE_REG                                     = 0x2C010000ull;
//DUPS: 2D010000,
static const uint64_t P9N2_EX_7_PSCOM_MODE_REG                                     = 0x2F010000ull;
//DUPS: 2F010000,
static const uint64_t P9N2_EX_8_PSCOM_MODE_REG                                     = 0x30010000ull;
//DUPS: 31010000,
static const uint64_t P9N2_EX_9_PSCOM_MODE_REG                                     = 0x32010000ull;
//DUPS: 33010000,
static const uint64_t P9N2_EX_10_PSCOM_MODE_REG                                    = 0x34010000ull;
//DUPS: 35010000,
static const uint64_t P9N2_EX_11_PSCOM_MODE_REG                                    = 0x36010000ull;
//DUPS: 37010000,

static const uint64_t P9N2_C_PSCOM_STATUS_ERROR_REG                                = 0x20010001ull;

static const uint64_t P9N2_C_0_PSCOM_STATUS_ERROR_REG                              = 0x20010001ull;

static const uint64_t P9N2_C_1_PSCOM_STATUS_ERROR_REG                              = 0x21010001ull;

static const uint64_t P9N2_C_2_PSCOM_STATUS_ERROR_REG                              = 0x22010001ull;

static const uint64_t P9N2_C_3_PSCOM_STATUS_ERROR_REG                              = 0x23010001ull;

static const uint64_t P9N2_C_4_PSCOM_STATUS_ERROR_REG                              = 0x24010001ull;

static const uint64_t P9N2_C_5_PSCOM_STATUS_ERROR_REG                              = 0x25010001ull;

static const uint64_t P9N2_C_6_PSCOM_STATUS_ERROR_REG                              = 0x26010001ull;

static const uint64_t P9N2_C_7_PSCOM_STATUS_ERROR_REG                              = 0x27010001ull;

static const uint64_t P9N2_C_8_PSCOM_STATUS_ERROR_REG                              = 0x28010001ull;

static const uint64_t P9N2_C_9_PSCOM_STATUS_ERROR_REG                              = 0x29010001ull;

static const uint64_t P9N2_C_10_PSCOM_STATUS_ERROR_REG                             = 0x2A010001ull;

static const uint64_t P9N2_C_11_PSCOM_STATUS_ERROR_REG                             = 0x2B010001ull;

static const uint64_t P9N2_C_12_PSCOM_STATUS_ERROR_REG                             = 0x2C010001ull;

static const uint64_t P9N2_C_13_PSCOM_STATUS_ERROR_REG                             = 0x2D010001ull;

static const uint64_t P9N2_C_14_PSCOM_STATUS_ERROR_REG                             = 0x2E010001ull;

static const uint64_t P9N2_C_15_PSCOM_STATUS_ERROR_REG                             = 0x2F010001ull;

static const uint64_t P9N2_C_16_PSCOM_STATUS_ERROR_REG                             = 0x30010001ull;

static const uint64_t P9N2_C_17_PSCOM_STATUS_ERROR_REG                             = 0x31010001ull;

static const uint64_t P9N2_C_18_PSCOM_STATUS_ERROR_REG                             = 0x32010001ull;

static const uint64_t P9N2_C_19_PSCOM_STATUS_ERROR_REG                             = 0x33010001ull;

static const uint64_t P9N2_C_20_PSCOM_STATUS_ERROR_REG                             = 0x34010001ull;

static const uint64_t P9N2_C_21_PSCOM_STATUS_ERROR_REG                             = 0x35010001ull;

static const uint64_t P9N2_C_22_PSCOM_STATUS_ERROR_REG                             = 0x36010001ull;

static const uint64_t P9N2_C_23_PSCOM_STATUS_ERROR_REG                             = 0x37010001ull;

static const uint64_t P9N2_EQ_PSCOM_STATUS_ERROR_REG                               = 0x10010001ull;

static const uint64_t P9N2_EQ_0_PSCOM_STATUS_ERROR_REG                             = 0x10010001ull;

static const uint64_t P9N2_EQ_1_PSCOM_STATUS_ERROR_REG                             = 0x11010001ull;

static const uint64_t P9N2_EQ_2_PSCOM_STATUS_ERROR_REG                             = 0x12010001ull;

static const uint64_t P9N2_EQ_3_PSCOM_STATUS_ERROR_REG                             = 0x13010001ull;

static const uint64_t P9N2_EQ_4_PSCOM_STATUS_ERROR_REG                             = 0x14010001ull;

static const uint64_t P9N2_EQ_5_PSCOM_STATUS_ERROR_REG                             = 0x15010001ull;

static const uint64_t P9N2_EX_PSCOM_STATUS_ERROR_REG                               = 0x20010001ull;
//DUPS: 21010001,
static const uint64_t P9N2_EX_0_PSCOM_STATUS_ERROR_REG                             = 0x20010001ull;
//DUPS: 21010001,
static const uint64_t P9N2_EX_1_PSCOM_STATUS_ERROR_REG                             = 0x22010001ull;
//DUPS: 23010001,
static const uint64_t P9N2_EX_2_PSCOM_STATUS_ERROR_REG                             = 0x24010001ull;
//DUPS: 25010001,
static const uint64_t P9N2_EX_3_PSCOM_STATUS_ERROR_REG                             = 0x26010001ull;
//DUPS: 27010001,
static const uint64_t P9N2_EX_4_PSCOM_STATUS_ERROR_REG                             = 0x28010001ull;
//DUPS: 29010001,
static const uint64_t P9N2_EX_5_PSCOM_STATUS_ERROR_REG                             = 0x2A010001ull;
//DUPS: 2B010001,
static const uint64_t P9N2_EX_6_PSCOM_STATUS_ERROR_REG                             = 0x2C010001ull;
//DUPS: 2D010001,
static const uint64_t P9N2_EX_7_PSCOM_STATUS_ERROR_REG                             = 0x2F010001ull;
//DUPS: 2F010001,
static const uint64_t P9N2_EX_8_PSCOM_STATUS_ERROR_REG                             = 0x30010001ull;
//DUPS: 31010001,
static const uint64_t P9N2_EX_9_PSCOM_STATUS_ERROR_REG                             = 0x32010001ull;
//DUPS: 33010001,
static const uint64_t P9N2_EX_10_PSCOM_STATUS_ERROR_REG                            = 0x34010001ull;
//DUPS: 35010001,
static const uint64_t P9N2_EX_11_PSCOM_STATUS_ERROR_REG                            = 0x36010001ull;
//DUPS: 37010001,

static const uint64_t P9N2_C_PWM_EVENTS                                            = 0x20010AA2ull;

static const uint64_t P9N2_C_0_PWM_EVENTS                                          = 0x20010AA2ull;

static const uint64_t P9N2_C_1_PWM_EVENTS                                          = 0x21010AA2ull;

static const uint64_t P9N2_C_2_PWM_EVENTS                                          = 0x22010AA2ull;

static const uint64_t P9N2_C_3_PWM_EVENTS                                          = 0x23010AA2ull;

static const uint64_t P9N2_C_4_PWM_EVENTS                                          = 0x24010AA2ull;

static const uint64_t P9N2_C_5_PWM_EVENTS                                          = 0x25010AA2ull;

static const uint64_t P9N2_C_6_PWM_EVENTS                                          = 0x26010AA2ull;

static const uint64_t P9N2_C_7_PWM_EVENTS                                          = 0x27010AA2ull;

static const uint64_t P9N2_C_8_PWM_EVENTS                                          = 0x28010AA2ull;

static const uint64_t P9N2_C_9_PWM_EVENTS                                          = 0x29010AA2ull;

static const uint64_t P9N2_C_10_PWM_EVENTS                                         = 0x2A010AA2ull;

static const uint64_t P9N2_C_11_PWM_EVENTS                                         = 0x2B010AA2ull;

static const uint64_t P9N2_C_12_PWM_EVENTS                                         = 0x2C010AA2ull;

static const uint64_t P9N2_C_13_PWM_EVENTS                                         = 0x2D010AA2ull;

static const uint64_t P9N2_C_14_PWM_EVENTS                                         = 0x2E010AA2ull;

static const uint64_t P9N2_C_15_PWM_EVENTS                                         = 0x2F010AA2ull;

static const uint64_t P9N2_C_16_PWM_EVENTS                                         = 0x30010AA2ull;

static const uint64_t P9N2_C_17_PWM_EVENTS                                         = 0x31010AA2ull;

static const uint64_t P9N2_C_18_PWM_EVENTS                                         = 0x32010AA2ull;

static const uint64_t P9N2_C_19_PWM_EVENTS                                         = 0x33010AA2ull;

static const uint64_t P9N2_C_20_PWM_EVENTS                                         = 0x34010AA2ull;

static const uint64_t P9N2_C_21_PWM_EVENTS                                         = 0x35010AA2ull;

static const uint64_t P9N2_C_22_PWM_EVENTS                                         = 0x36010AA2ull;

static const uint64_t P9N2_C_23_PWM_EVENTS                                         = 0x37010AA2ull;

static const uint64_t P9N2_EX_0_L2_PWM_EVENTS                                      = 0x20010AA2ull;
//DUPS: 20010AA2,
static const uint64_t P9N2_EX_10_L2_PWM_EVENTS                                     = 0x34010AA2ull;
//DUPS: 34010AA2,
static const uint64_t P9N2_EX_11_L2_PWM_EVENTS                                     = 0x36010AA2ull;
//DUPS: 36010AA2,
static const uint64_t P9N2_EX_1_L2_PWM_EVENTS                                      = 0x22010AA2ull;
//DUPS: 22010AA2,
static const uint64_t P9N2_EX_2_L2_PWM_EVENTS                                      = 0x24010AA2ull;
//DUPS: 24010AA2,
static const uint64_t P9N2_EX_3_L2_PWM_EVENTS                                      = 0x26010AA2ull;
//DUPS: 26010AA2,
static const uint64_t P9N2_EX_4_L2_PWM_EVENTS                                      = 0x28010AA2ull;
//DUPS: 28010AA2,
static const uint64_t P9N2_EX_5_L2_PWM_EVENTS                                      = 0x2B010AA2ull;
//DUPS: 2A010AA2,
static const uint64_t P9N2_EX_6_L2_PWM_EVENTS                                      = 0x2D010AA2ull;
//DUPS: 2C010AA2,
static const uint64_t P9N2_EX_7_L2_PWM_EVENTS                                      = 0x2F010AA2ull;
//DUPS: 2E010AA2,
static const uint64_t P9N2_EX_8_L2_PWM_EVENTS                                      = 0x30010AA2ull;
//DUPS: 30010AA2,
static const uint64_t P9N2_EX_9_L2_PWM_EVENTS                                      = 0x32010AA2ull;
//DUPS: 32010AA2,
static const uint64_t P9N2_EX_L2_PWM_EVENTS                                        = 0x20010AA2ull;
//DUPS: 20010AA2,

static const uint64_t P9N2_EQ_QPPM_DPLL_CTRL                                       = 0x100F0152ull;

static const uint64_t P9N2_EQ_QPPM_DPLL_CTRL_CLEAR                                 = 0x100F0153ull;

static const uint64_t P9N2_EQ_QPPM_DPLL_CTRL_OR                                    = 0x100F0154ull;

static const uint64_t P9N2_EQ_0_QPPM_DPLL_CTRL                                     = 0x100F0152ull;

static const uint64_t P9N2_EQ_0_QPPM_DPLL_CTRL_CLEAR                               = 0x100F0153ull;

static const uint64_t P9N2_EQ_0_QPPM_DPLL_CTRL_OR                                  = 0x100F0154ull;

static const uint64_t P9N2_EQ_1_QPPM_DPLL_CTRL                                     = 0x110F0152ull;

static const uint64_t P9N2_EQ_1_QPPM_DPLL_CTRL_CLEAR                               = 0x110F0153ull;

static const uint64_t P9N2_EQ_1_QPPM_DPLL_CTRL_OR                                  = 0x110F0154ull;

static const uint64_t P9N2_EQ_2_QPPM_DPLL_CTRL                                     = 0x120F0152ull;

static const uint64_t P9N2_EQ_2_QPPM_DPLL_CTRL_CLEAR                               = 0x120F0153ull;

static const uint64_t P9N2_EQ_2_QPPM_DPLL_CTRL_OR                                  = 0x120F0154ull;

static const uint64_t P9N2_EQ_3_QPPM_DPLL_CTRL                                     = 0x130F0152ull;

static const uint64_t P9N2_EQ_3_QPPM_DPLL_CTRL_CLEAR                               = 0x130F0153ull;

static const uint64_t P9N2_EQ_3_QPPM_DPLL_CTRL_OR                                  = 0x130F0154ull;

static const uint64_t P9N2_EQ_4_QPPM_DPLL_CTRL                                     = 0x140F0152ull;

static const uint64_t P9N2_EQ_4_QPPM_DPLL_CTRL_CLEAR                               = 0x140F0153ull;

static const uint64_t P9N2_EQ_4_QPPM_DPLL_CTRL_OR                                  = 0x140F0154ull;

static const uint64_t P9N2_EQ_5_QPPM_DPLL_CTRL                                     = 0x150F0152ull;

static const uint64_t P9N2_EQ_5_QPPM_DPLL_CTRL_CLEAR                               = 0x150F0153ull;

static const uint64_t P9N2_EQ_5_QPPM_DPLL_CTRL_OR                                  = 0x150F0154ull;


static const uint64_t P9N2_EQ_QPPM_DPLL_FREQ                                       = 0x100F0151ull;

static const uint64_t P9N2_EQ_0_QPPM_DPLL_FREQ                                     = 0x100F0151ull;

static const uint64_t P9N2_EQ_1_QPPM_DPLL_FREQ                                     = 0x110F0151ull;

static const uint64_t P9N2_EQ_2_QPPM_DPLL_FREQ                                     = 0x120F0151ull;

static const uint64_t P9N2_EQ_3_QPPM_DPLL_FREQ                                     = 0x130F0151ull;

static const uint64_t P9N2_EQ_4_QPPM_DPLL_FREQ                                     = 0x140F0151ull;

static const uint64_t P9N2_EQ_5_QPPM_DPLL_FREQ                                     = 0x150F0151ull;


static const uint64_t P9N2_EQ_QPPM_DPLL_ICHAR                                      = 0x100F0157ull;

static const uint64_t P9N2_EQ_0_QPPM_DPLL_ICHAR                                    = 0x100F0157ull;

static const uint64_t P9N2_EQ_1_QPPM_DPLL_ICHAR                                    = 0x110F0157ull;

static const uint64_t P9N2_EQ_2_QPPM_DPLL_ICHAR                                    = 0x120F0157ull;

static const uint64_t P9N2_EQ_3_QPPM_DPLL_ICHAR                                    = 0x130F0157ull;

static const uint64_t P9N2_EQ_4_QPPM_DPLL_ICHAR                                    = 0x140F0157ull;

static const uint64_t P9N2_EQ_5_QPPM_DPLL_ICHAR                                    = 0x150F0157ull;


static const uint64_t P9N2_EQ_QPPM_DPLL_OCHAR                                      = 0x100F0156ull;

static const uint64_t P9N2_EQ_0_QPPM_DPLL_OCHAR                                    = 0x100F0156ull;

static const uint64_t P9N2_EQ_1_QPPM_DPLL_OCHAR                                    = 0x110F0156ull;

static const uint64_t P9N2_EQ_2_QPPM_DPLL_OCHAR                                    = 0x120F0156ull;

static const uint64_t P9N2_EQ_3_QPPM_DPLL_OCHAR                                    = 0x130F0156ull;

static const uint64_t P9N2_EQ_4_QPPM_DPLL_OCHAR                                    = 0x140F0156ull;

static const uint64_t P9N2_EQ_5_QPPM_DPLL_OCHAR                                    = 0x150F0156ull;


static const uint64_t P9N2_EQ_QPPM_DPLL_STAT                                       = 0x100F0155ull;

static const uint64_t P9N2_EQ_0_QPPM_DPLL_STAT                                     = 0x100F0155ull;

static const uint64_t P9N2_EQ_1_QPPM_DPLL_STAT                                     = 0x110F0155ull;

static const uint64_t P9N2_EQ_2_QPPM_DPLL_STAT                                     = 0x120F0155ull;

static const uint64_t P9N2_EQ_3_QPPM_DPLL_STAT                                     = 0x130F0155ull;

static const uint64_t P9N2_EQ_4_QPPM_DPLL_STAT                                     = 0x140F0155ull;

static const uint64_t P9N2_EQ_5_QPPM_DPLL_STAT                                     = 0x150F0155ull;


static const uint64_t P9N2_EQ_QPPM_ERR                                             = 0x100F0121ull;

static const uint64_t P9N2_EQ_0_QPPM_ERR                                           = 0x100F0121ull;

static const uint64_t P9N2_EQ_1_QPPM_ERR                                           = 0x110F0121ull;

static const uint64_t P9N2_EQ_2_QPPM_ERR                                           = 0x120F0121ull;

static const uint64_t P9N2_EQ_3_QPPM_ERR                                           = 0x130F0121ull;

static const uint64_t P9N2_EQ_4_QPPM_ERR                                           = 0x140F0121ull;

static const uint64_t P9N2_EQ_5_QPPM_ERR                                           = 0x150F0121ull;


static const uint64_t P9N2_EQ_QPPM_ERRMSK                                          = 0x100F0122ull;

static const uint64_t P9N2_EQ_0_QPPM_ERRMSK                                        = 0x100F0122ull;

static const uint64_t P9N2_EQ_1_QPPM_ERRMSK                                        = 0x110F0122ull;

static const uint64_t P9N2_EQ_2_QPPM_ERRMSK                                        = 0x120F0122ull;

static const uint64_t P9N2_EQ_3_QPPM_ERRMSK                                        = 0x130F0122ull;

static const uint64_t P9N2_EQ_4_QPPM_ERRMSK                                        = 0x140F0122ull;

static const uint64_t P9N2_EQ_5_QPPM_ERRMSK                                        = 0x150F0122ull;


static const uint64_t P9N2_EQ_QPPM_ERRSUM                                          = 0x100F0120ull;

static const uint64_t P9N2_EQ_0_QPPM_ERRSUM                                        = 0x100F0120ull;

static const uint64_t P9N2_EQ_1_QPPM_ERRSUM                                        = 0x110F0120ull;

static const uint64_t P9N2_EQ_2_QPPM_ERRSUM                                        = 0x120F0120ull;

static const uint64_t P9N2_EQ_3_QPPM_ERRSUM                                        = 0x130F0120ull;

static const uint64_t P9N2_EQ_4_QPPM_ERRSUM                                        = 0x140F0120ull;

static const uint64_t P9N2_EQ_5_QPPM_ERRSUM                                        = 0x150F0120ull;


static const uint64_t P9N2_EQ_QPPM_EXCGCR                                          = 0x100F0165ull;

static const uint64_t P9N2_EQ_QPPM_EXCGCR_CLEAR                                    = 0x100F0166ull;

static const uint64_t P9N2_EQ_QPPM_EXCGCR_OR                                       = 0x100F0167ull;

static const uint64_t P9N2_EQ_0_QPPM_EXCGCR                                        = 0x100F0165ull;

static const uint64_t P9N2_EQ_0_QPPM_EXCGCR_CLEAR                                  = 0x100F0166ull;

static const uint64_t P9N2_EQ_0_QPPM_EXCGCR_OR                                     = 0x100F0167ull;

static const uint64_t P9N2_EQ_1_QPPM_EXCGCR                                        = 0x110F0165ull;

static const uint64_t P9N2_EQ_1_QPPM_EXCGCR_CLEAR                                  = 0x110F0166ull;

static const uint64_t P9N2_EQ_1_QPPM_EXCGCR_OR                                     = 0x110F0167ull;

static const uint64_t P9N2_EQ_2_QPPM_EXCGCR                                        = 0x120F0165ull;

static const uint64_t P9N2_EQ_2_QPPM_EXCGCR_CLEAR                                  = 0x120F0166ull;

static const uint64_t P9N2_EQ_2_QPPM_EXCGCR_OR                                     = 0x120F0167ull;

static const uint64_t P9N2_EQ_3_QPPM_EXCGCR                                        = 0x130F0165ull;

static const uint64_t P9N2_EQ_3_QPPM_EXCGCR_CLEAR                                  = 0x130F0166ull;

static const uint64_t P9N2_EQ_3_QPPM_EXCGCR_OR                                     = 0x130F0167ull;

static const uint64_t P9N2_EQ_4_QPPM_EXCGCR                                        = 0x140F0165ull;

static const uint64_t P9N2_EQ_4_QPPM_EXCGCR_CLEAR                                  = 0x140F0166ull;

static const uint64_t P9N2_EQ_4_QPPM_EXCGCR_OR                                     = 0x140F0167ull;

static const uint64_t P9N2_EQ_5_QPPM_EXCGCR                                        = 0x150F0165ull;

static const uint64_t P9N2_EQ_5_QPPM_EXCGCR_CLEAR                                  = 0x150F0166ull;

static const uint64_t P9N2_EQ_5_QPPM_EXCGCR_OR                                     = 0x150F0167ull;


static const uint64_t P9N2_EQ_QPPM_OCCHB                                           = 0x100F015Full;

static const uint64_t P9N2_EQ_0_QPPM_OCCHB                                         = 0x100F015Full;

static const uint64_t P9N2_EQ_1_QPPM_OCCHB                                         = 0x110F015Full;

static const uint64_t P9N2_EQ_2_QPPM_OCCHB                                         = 0x120F015Full;

static const uint64_t P9N2_EQ_3_QPPM_OCCHB                                         = 0x130F015Full;

static const uint64_t P9N2_EQ_4_QPPM_OCCHB                                         = 0x140F015Full;

static const uint64_t P9N2_EQ_5_QPPM_OCCHB                                         = 0x150F015Full;


static const uint64_t P9N2_EQ_QPPM_QACCR                                           = 0x100F0160ull;

static const uint64_t P9N2_EQ_QPPM_QACCR_CLEAR                                     = 0x100F0161ull;

static const uint64_t P9N2_EQ_QPPM_QACCR_OR                                        = 0x100F0162ull;

static const uint64_t P9N2_EQ_0_QPPM_QACCR                                         = 0x100F0160ull;

static const uint64_t P9N2_EQ_0_QPPM_QACCR_CLEAR                                   = 0x100F0161ull;

static const uint64_t P9N2_EQ_0_QPPM_QACCR_OR                                      = 0x100F0162ull;

static const uint64_t P9N2_EQ_1_QPPM_QACCR                                         = 0x110F0160ull;

static const uint64_t P9N2_EQ_1_QPPM_QACCR_CLEAR                                   = 0x110F0161ull;

static const uint64_t P9N2_EQ_1_QPPM_QACCR_OR                                      = 0x110F0162ull;

static const uint64_t P9N2_EQ_2_QPPM_QACCR                                         = 0x120F0160ull;

static const uint64_t P9N2_EQ_2_QPPM_QACCR_CLEAR                                   = 0x120F0161ull;

static const uint64_t P9N2_EQ_2_QPPM_QACCR_OR                                      = 0x120F0162ull;

static const uint64_t P9N2_EQ_3_QPPM_QACCR                                         = 0x130F0160ull;

static const uint64_t P9N2_EQ_3_QPPM_QACCR_CLEAR                                   = 0x130F0161ull;

static const uint64_t P9N2_EQ_3_QPPM_QACCR_OR                                      = 0x130F0162ull;

static const uint64_t P9N2_EQ_4_QPPM_QACCR                                         = 0x140F0160ull;

static const uint64_t P9N2_EQ_4_QPPM_QACCR_CLEAR                                   = 0x140F0161ull;

static const uint64_t P9N2_EQ_4_QPPM_QACCR_OR                                      = 0x140F0162ull;

static const uint64_t P9N2_EQ_5_QPPM_QACCR                                         = 0x150F0160ull;

static const uint64_t P9N2_EQ_5_QPPM_QACCR_CLEAR                                   = 0x150F0161ull;

static const uint64_t P9N2_EQ_5_QPPM_QACCR_OR                                      = 0x150F0162ull;


static const uint64_t P9N2_EQ_QPPM_QACSR                                           = 0x100F0163ull;

static const uint64_t P9N2_EQ_0_QPPM_QACSR                                         = 0x100F0163ull;

static const uint64_t P9N2_EQ_1_QPPM_QACSR                                         = 0x110F0163ull;

static const uint64_t P9N2_EQ_2_QPPM_QACSR                                         = 0x120F0163ull;

static const uint64_t P9N2_EQ_3_QPPM_QACSR                                         = 0x130F0163ull;

static const uint64_t P9N2_EQ_4_QPPM_QACSR                                         = 0x140F0163ull;

static const uint64_t P9N2_EQ_5_QPPM_QACSR                                         = 0x150F0163ull;


static const uint64_t P9N2_EQ_QPPM_QCCR_SCOM                                       = 0x100F01BDull;

static const uint64_t P9N2_EQ_QPPM_QCCR_SCOM1                                      = 0x100F01BEull;

static const uint64_t P9N2_EQ_QPPM_QCCR_SCOM2                                      = 0x100F01BFull;

static const uint64_t P9N2_EQ_0_QPPM_QCCR_SCOM                                     = 0x100F01BDull;

static const uint64_t P9N2_EQ_0_QPPM_QCCR_SCOM1                                    = 0x100F01BEull;

static const uint64_t P9N2_EQ_0_QPPM_QCCR_SCOM2                                    = 0x100F01BFull;

static const uint64_t P9N2_EQ_1_QPPM_QCCR_SCOM                                     = 0x110F01BDull;

static const uint64_t P9N2_EQ_1_QPPM_QCCR_SCOM1                                    = 0x110F01BEull;

static const uint64_t P9N2_EQ_1_QPPM_QCCR_SCOM2                                    = 0x110F01BFull;

static const uint64_t P9N2_EQ_2_QPPM_QCCR_SCOM                                     = 0x120F01BDull;

static const uint64_t P9N2_EQ_2_QPPM_QCCR_SCOM1                                    = 0x120F01BEull;

static const uint64_t P9N2_EQ_2_QPPM_QCCR_SCOM2                                    = 0x120F01BFull;

static const uint64_t P9N2_EQ_3_QPPM_QCCR_SCOM                                     = 0x130F01BDull;

static const uint64_t P9N2_EQ_3_QPPM_QCCR_SCOM1                                    = 0x130F01BEull;

static const uint64_t P9N2_EQ_3_QPPM_QCCR_SCOM2                                    = 0x130F01BFull;

static const uint64_t P9N2_EQ_4_QPPM_QCCR_SCOM                                     = 0x140F01BDull;

static const uint64_t P9N2_EQ_4_QPPM_QCCR_SCOM1                                    = 0x140F01BEull;

static const uint64_t P9N2_EQ_4_QPPM_QCCR_SCOM2                                    = 0x140F01BFull;

static const uint64_t P9N2_EQ_5_QPPM_QCCR_SCOM                                     = 0x150F01BDull;

static const uint64_t P9N2_EQ_5_QPPM_QCCR_SCOM1                                    = 0x150F01BEull;

static const uint64_t P9N2_EQ_5_QPPM_QCCR_SCOM2                                    = 0x150F01BFull;


static const uint64_t P9N2_EQ_QPPM_QPMMR                                           = 0x100F0103ull;

static const uint64_t P9N2_EQ_QPPM_QPMMR_CLEAR                                     = 0x100F0104ull;

static const uint64_t P9N2_EQ_QPPM_QPMMR_OR                                        = 0x100F0105ull;

static const uint64_t P9N2_EQ_0_QPPM_QPMMR                                         = 0x100F0103ull;

static const uint64_t P9N2_EQ_0_QPPM_QPMMR_CLEAR                                   = 0x100F0104ull;

static const uint64_t P9N2_EQ_0_QPPM_QPMMR_OR                                      = 0x100F0105ull;

static const uint64_t P9N2_EQ_1_QPPM_QPMMR                                         = 0x110F0103ull;

static const uint64_t P9N2_EQ_1_QPPM_QPMMR_CLEAR                                   = 0x110F0104ull;

static const uint64_t P9N2_EQ_1_QPPM_QPMMR_OR                                      = 0x110F0105ull;

static const uint64_t P9N2_EQ_2_QPPM_QPMMR                                         = 0x120F0103ull;

static const uint64_t P9N2_EQ_2_QPPM_QPMMR_CLEAR                                   = 0x120F0104ull;

static const uint64_t P9N2_EQ_2_QPPM_QPMMR_OR                                      = 0x120F0105ull;

static const uint64_t P9N2_EQ_3_QPPM_QPMMR                                         = 0x130F0103ull;

static const uint64_t P9N2_EQ_3_QPPM_QPMMR_CLEAR                                   = 0x130F0104ull;

static const uint64_t P9N2_EQ_3_QPPM_QPMMR_OR                                      = 0x130F0105ull;

static const uint64_t P9N2_EQ_4_QPPM_QPMMR                                         = 0x140F0103ull;

static const uint64_t P9N2_EQ_4_QPPM_QPMMR_CLEAR                                   = 0x140F0104ull;

static const uint64_t P9N2_EQ_4_QPPM_QPMMR_OR                                      = 0x140F0105ull;

static const uint64_t P9N2_EQ_5_QPPM_QPMMR                                         = 0x150F0103ull;

static const uint64_t P9N2_EQ_5_QPPM_QPMMR_CLEAR                                   = 0x150F0104ull;

static const uint64_t P9N2_EQ_5_QPPM_QPMMR_OR                                      = 0x150F0105ull;


static const uint64_t P9N2_EQ_QPPM_VDMCFGR                                         = 0x100F01B6ull;

static const uint64_t P9N2_EQ_0_QPPM_VDMCFGR                                       = 0x100F01B6ull;

static const uint64_t P9N2_EQ_1_QPPM_VDMCFGR                                       = 0x110F01B6ull;

static const uint64_t P9N2_EQ_2_QPPM_VDMCFGR                                       = 0x120F01B6ull;

static const uint64_t P9N2_EQ_3_QPPM_VDMCFGR                                       = 0x130F01B6ull;

static const uint64_t P9N2_EQ_4_QPPM_VDMCFGR                                       = 0x140F01B6ull;

static const uint64_t P9N2_EQ_5_QPPM_VDMCFGR                                       = 0x150F01B6ull;


static const uint64_t P9N2_EQ_QPPM_VOLT_CHAR                                       = 0x100F01BBull;

static const uint64_t P9N2_EQ_0_QPPM_VOLT_CHAR                                     = 0x100F01BBull;

static const uint64_t P9N2_EQ_1_QPPM_VOLT_CHAR                                     = 0x110F01BBull;

static const uint64_t P9N2_EQ_2_QPPM_VOLT_CHAR                                     = 0x120F01BBull;

static const uint64_t P9N2_EQ_3_QPPM_VOLT_CHAR                                     = 0x130F01BBull;

static const uint64_t P9N2_EQ_4_QPPM_VOLT_CHAR                                     = 0x140F01BBull;

static const uint64_t P9N2_EQ_5_QPPM_VOLT_CHAR                                     = 0x150F01BBull;


static const uint64_t P9N2_C_RAM_CTRL                                              = 0x20010A4Full;

static const uint64_t P9N2_C_0_RAM_CTRL                                            = 0x20010A4Full;

static const uint64_t P9N2_C_1_RAM_CTRL                                            = 0x21010A4Full;

static const uint64_t P9N2_C_2_RAM_CTRL                                            = 0x22010A4Full;

static const uint64_t P9N2_C_3_RAM_CTRL                                            = 0x23010A4Full;

static const uint64_t P9N2_C_4_RAM_CTRL                                            = 0x24010A4Full;

static const uint64_t P9N2_C_5_RAM_CTRL                                            = 0x25010A4Full;

static const uint64_t P9N2_C_6_RAM_CTRL                                            = 0x26010A4Full;

static const uint64_t P9N2_C_7_RAM_CTRL                                            = 0x27010A4Full;

static const uint64_t P9N2_C_8_RAM_CTRL                                            = 0x28010A4Full;

static const uint64_t P9N2_C_9_RAM_CTRL                                            = 0x29010A4Full;

static const uint64_t P9N2_C_10_RAM_CTRL                                           = 0x2A010A4Full;

static const uint64_t P9N2_C_11_RAM_CTRL                                           = 0x2B010A4Full;

static const uint64_t P9N2_C_12_RAM_CTRL                                           = 0x2C010A4Full;

static const uint64_t P9N2_C_13_RAM_CTRL                                           = 0x2D010A4Full;

static const uint64_t P9N2_C_14_RAM_CTRL                                           = 0x2E010A4Full;

static const uint64_t P9N2_C_15_RAM_CTRL                                           = 0x2F010A4Full;

static const uint64_t P9N2_C_16_RAM_CTRL                                           = 0x30010A4Full;

static const uint64_t P9N2_C_17_RAM_CTRL                                           = 0x31010A4Full;

static const uint64_t P9N2_C_18_RAM_CTRL                                           = 0x32010A4Full;

static const uint64_t P9N2_C_19_RAM_CTRL                                           = 0x33010A4Full;

static const uint64_t P9N2_C_20_RAM_CTRL                                           = 0x34010A4Full;

static const uint64_t P9N2_C_21_RAM_CTRL                                           = 0x35010A4Full;

static const uint64_t P9N2_C_22_RAM_CTRL                                           = 0x36010A4Full;

static const uint64_t P9N2_C_23_RAM_CTRL                                           = 0x37010A4Full;

static const uint64_t P9N2_EX_RAM_CTRL                                             = 0x20010A4Full;
//DUPS: 21010A4F,
static const uint64_t P9N2_EX_0_RAM_CTRL                                           = 0x20010A4Full;
//DUPS: 21010A4F,
static const uint64_t P9N2_EX_1_RAM_CTRL                                           = 0x22010A4Full;
//DUPS: 23010A4F,
static const uint64_t P9N2_EX_2_RAM_CTRL                                           = 0x24010A4Full;
//DUPS: 25010A4F,
static const uint64_t P9N2_EX_3_RAM_CTRL                                           = 0x26010A4Full;
//DUPS: 27010A4F,
static const uint64_t P9N2_EX_4_RAM_CTRL                                           = 0x28010A4Full;
//DUPS: 29010A4F,
static const uint64_t P9N2_EX_5_RAM_CTRL                                           = 0x2A010A4Full;
//DUPS: 2B010A4F,
static const uint64_t P9N2_EX_6_RAM_CTRL                                           = 0x2C010A4Full;
//DUPS: 2D010A4F,
static const uint64_t P9N2_EX_7_RAM_CTRL                                           = 0x2F010A4Full;
//DUPS: 2F010A4F,
static const uint64_t P9N2_EX_8_RAM_CTRL                                           = 0x30010A4Full;
//DUPS: 31010A4F,
static const uint64_t P9N2_EX_9_RAM_CTRL                                           = 0x32010A4Full;
//DUPS: 33010A4F,
static const uint64_t P9N2_EX_10_RAM_CTRL                                          = 0x34010A4Full;
//DUPS: 35010A4F,
static const uint64_t P9N2_EX_11_RAM_CTRL                                          = 0x36010A4Full;
//DUPS: 37010A4F,

static const uint64_t P9N2_C_RAM_MODEREG                                           = 0x20010A4Eull;

static const uint64_t P9N2_C_0_RAM_MODEREG                                         = 0x20010A4Eull;

static const uint64_t P9N2_C_1_RAM_MODEREG                                         = 0x21010A4Eull;

static const uint64_t P9N2_C_2_RAM_MODEREG                                         = 0x22010A4Eull;

static const uint64_t P9N2_C_3_RAM_MODEREG                                         = 0x23010A4Eull;

static const uint64_t P9N2_C_4_RAM_MODEREG                                         = 0x24010A4Eull;

static const uint64_t P9N2_C_5_RAM_MODEREG                                         = 0x25010A4Eull;

static const uint64_t P9N2_C_6_RAM_MODEREG                                         = 0x26010A4Eull;

static const uint64_t P9N2_C_7_RAM_MODEREG                                         = 0x27010A4Eull;

static const uint64_t P9N2_C_8_RAM_MODEREG                                         = 0x28010A4Eull;

static const uint64_t P9N2_C_9_RAM_MODEREG                                         = 0x29010A4Eull;

static const uint64_t P9N2_C_10_RAM_MODEREG                                        = 0x2A010A4Eull;

static const uint64_t P9N2_C_11_RAM_MODEREG                                        = 0x2B010A4Eull;

static const uint64_t P9N2_C_12_RAM_MODEREG                                        = 0x2C010A4Eull;

static const uint64_t P9N2_C_13_RAM_MODEREG                                        = 0x2D010A4Eull;

static const uint64_t P9N2_C_14_RAM_MODEREG                                        = 0x2E010A4Eull;

static const uint64_t P9N2_C_15_RAM_MODEREG                                        = 0x2F010A4Eull;

static const uint64_t P9N2_C_16_RAM_MODEREG                                        = 0x30010A4Eull;

static const uint64_t P9N2_C_17_RAM_MODEREG                                        = 0x31010A4Eull;

static const uint64_t P9N2_C_18_RAM_MODEREG                                        = 0x32010A4Eull;

static const uint64_t P9N2_C_19_RAM_MODEREG                                        = 0x33010A4Eull;

static const uint64_t P9N2_C_20_RAM_MODEREG                                        = 0x34010A4Eull;

static const uint64_t P9N2_C_21_RAM_MODEREG                                        = 0x35010A4Eull;

static const uint64_t P9N2_C_22_RAM_MODEREG                                        = 0x36010A4Eull;

static const uint64_t P9N2_C_23_RAM_MODEREG                                        = 0x37010A4Eull;

static const uint64_t P9N2_EX_RAM_MODEREG                                          = 0x20010A4Eull;
//DUPS: 21010A4E,
static const uint64_t P9N2_EX_0_RAM_MODEREG                                        = 0x20010A4Eull;
//DUPS: 21010A4E,
static const uint64_t P9N2_EX_1_RAM_MODEREG                                        = 0x22010A4Eull;
//DUPS: 23010A4E,
static const uint64_t P9N2_EX_2_RAM_MODEREG                                        = 0x24010A4Eull;
//DUPS: 25010A4E,
static const uint64_t P9N2_EX_3_RAM_MODEREG                                        = 0x26010A4Eull;
//DUPS: 27010A4E,
static const uint64_t P9N2_EX_4_RAM_MODEREG                                        = 0x28010A4Eull;
//DUPS: 29010A4E,
static const uint64_t P9N2_EX_5_RAM_MODEREG                                        = 0x2A010A4Eull;
//DUPS: 2B010A4E,
static const uint64_t P9N2_EX_6_RAM_MODEREG                                        = 0x2C010A4Eull;
//DUPS: 2D010A4E,
static const uint64_t P9N2_EX_7_RAM_MODEREG                                        = 0x2F010A4Eull;
//DUPS: 2F010A4E,
static const uint64_t P9N2_EX_8_RAM_MODEREG                                        = 0x30010A4Eull;
//DUPS: 31010A4E,
static const uint64_t P9N2_EX_9_RAM_MODEREG                                        = 0x32010A4Eull;
//DUPS: 33010A4E,
static const uint64_t P9N2_EX_10_RAM_MODEREG                                       = 0x34010A4Eull;
//DUPS: 35010A4E,
static const uint64_t P9N2_EX_11_RAM_MODEREG                                       = 0x36010A4Eull;
//DUPS: 37010A4E,

static const uint64_t P9N2_C_RAM_STATUS                                            = 0x20010A50ull;

static const uint64_t P9N2_C_0_RAM_STATUS                                          = 0x20010A50ull;

static const uint64_t P9N2_C_1_RAM_STATUS                                          = 0x21010A50ull;

static const uint64_t P9N2_C_2_RAM_STATUS                                          = 0x22010A50ull;

static const uint64_t P9N2_C_3_RAM_STATUS                                          = 0x23010A50ull;

static const uint64_t P9N2_C_4_RAM_STATUS                                          = 0x24010A50ull;

static const uint64_t P9N2_C_5_RAM_STATUS                                          = 0x25010A50ull;

static const uint64_t P9N2_C_6_RAM_STATUS                                          = 0x26010A50ull;

static const uint64_t P9N2_C_7_RAM_STATUS                                          = 0x27010A50ull;

static const uint64_t P9N2_C_8_RAM_STATUS                                          = 0x28010A50ull;

static const uint64_t P9N2_C_9_RAM_STATUS                                          = 0x29010A50ull;

static const uint64_t P9N2_C_10_RAM_STATUS                                         = 0x2A010A50ull;

static const uint64_t P9N2_C_11_RAM_STATUS                                         = 0x2B010A50ull;

static const uint64_t P9N2_C_12_RAM_STATUS                                         = 0x2C010A50ull;

static const uint64_t P9N2_C_13_RAM_STATUS                                         = 0x2D010A50ull;

static const uint64_t P9N2_C_14_RAM_STATUS                                         = 0x2E010A50ull;

static const uint64_t P9N2_C_15_RAM_STATUS                                         = 0x2F010A50ull;

static const uint64_t P9N2_C_16_RAM_STATUS                                         = 0x30010A50ull;

static const uint64_t P9N2_C_17_RAM_STATUS                                         = 0x31010A50ull;

static const uint64_t P9N2_C_18_RAM_STATUS                                         = 0x32010A50ull;

static const uint64_t P9N2_C_19_RAM_STATUS                                         = 0x33010A50ull;

static const uint64_t P9N2_C_20_RAM_STATUS                                         = 0x34010A50ull;

static const uint64_t P9N2_C_21_RAM_STATUS                                         = 0x35010A50ull;

static const uint64_t P9N2_C_22_RAM_STATUS                                         = 0x36010A50ull;

static const uint64_t P9N2_C_23_RAM_STATUS                                         = 0x37010A50ull;

static const uint64_t P9N2_EX_0_L2_RAM_STATUS                                      = 0x20010A50ull;
//DUPS: 21010A50,
static const uint64_t P9N2_EX_10_L2_RAM_STATUS                                     = 0x34010A50ull;
//DUPS: 35010A50,
static const uint64_t P9N2_EX_11_L2_RAM_STATUS                                     = 0x36010A50ull;
//DUPS: 37010A50,
static const uint64_t P9N2_EX_1_L2_RAM_STATUS                                      = 0x22010A50ull;
//DUPS: 23010A50,
static const uint64_t P9N2_EX_2_L2_RAM_STATUS                                      = 0x24010A50ull;
//DUPS: 25010A50,
static const uint64_t P9N2_EX_3_L2_RAM_STATUS                                      = 0x26010A50ull;
//DUPS: 27010A50,
static const uint64_t P9N2_EX_4_L2_RAM_STATUS                                      = 0x28010A50ull;
//DUPS: 29010A50,
static const uint64_t P9N2_EX_5_L2_RAM_STATUS                                      = 0x2A010A50ull;
//DUPS: 2B010A50,
static const uint64_t P9N2_EX_6_L2_RAM_STATUS                                      = 0x2C010A50ull;
//DUPS: 2D010A50,
static const uint64_t P9N2_EX_7_L2_RAM_STATUS                                      = 0x2F010A50ull;
//DUPS: 2F010A50,
static const uint64_t P9N2_EX_8_L2_RAM_STATUS                                      = 0x30010A50ull;
//DUPS: 31010A50,
static const uint64_t P9N2_EX_9_L2_RAM_STATUS                                      = 0x32010A50ull;
//DUPS: 33010A50,
static const uint64_t P9N2_EX_L2_RAM_STATUS                                        = 0x20010A50ull;
//DUPS: 21010A50,

static const uint64_t P9N2_C_RAS_MODEREG                                           = 0x20010A9Dull;

static const uint64_t P9N2_C_0_RAS_MODEREG                                         = 0x20010A9Dull;

static const uint64_t P9N2_C_1_RAS_MODEREG                                         = 0x21010A9Dull;

static const uint64_t P9N2_C_2_RAS_MODEREG                                         = 0x22010A9Dull;

static const uint64_t P9N2_C_3_RAS_MODEREG                                         = 0x23010A9Dull;

static const uint64_t P9N2_C_4_RAS_MODEREG                                         = 0x24010A9Dull;

static const uint64_t P9N2_C_5_RAS_MODEREG                                         = 0x25010A9Dull;

static const uint64_t P9N2_C_6_RAS_MODEREG                                         = 0x26010A9Dull;

static const uint64_t P9N2_C_7_RAS_MODEREG                                         = 0x27010A9Dull;

static const uint64_t P9N2_C_8_RAS_MODEREG                                         = 0x28010A9Dull;

static const uint64_t P9N2_C_9_RAS_MODEREG                                         = 0x29010A9Dull;

static const uint64_t P9N2_C_10_RAS_MODEREG                                        = 0x2A010A9Dull;

static const uint64_t P9N2_C_11_RAS_MODEREG                                        = 0x2B010A9Dull;

static const uint64_t P9N2_C_12_RAS_MODEREG                                        = 0x2C010A9Dull;

static const uint64_t P9N2_C_13_RAS_MODEREG                                        = 0x2D010A9Dull;

static const uint64_t P9N2_C_14_RAS_MODEREG                                        = 0x2E010A9Dull;

static const uint64_t P9N2_C_15_RAS_MODEREG                                        = 0x2F010A9Dull;

static const uint64_t P9N2_C_16_RAS_MODEREG                                        = 0x30010A9Dull;

static const uint64_t P9N2_C_17_RAS_MODEREG                                        = 0x31010A9Dull;

static const uint64_t P9N2_C_18_RAS_MODEREG                                        = 0x32010A9Dull;

static const uint64_t P9N2_C_19_RAS_MODEREG                                        = 0x33010A9Dull;

static const uint64_t P9N2_C_20_RAS_MODEREG                                        = 0x34010A9Dull;

static const uint64_t P9N2_C_21_RAS_MODEREG                                        = 0x35010A9Dull;

static const uint64_t P9N2_C_22_RAS_MODEREG                                        = 0x36010A9Dull;

static const uint64_t P9N2_C_23_RAS_MODEREG                                        = 0x37010A9Dull;

static const uint64_t P9N2_EX_0_L2_RAS_MODEREG                                     = 0x20010A9Dull;
//DUPS: 21010A9D,
static const uint64_t P9N2_EX_10_L2_RAS_MODEREG                                    = 0x34010A9Dull;
//DUPS: 35010A9D,
static const uint64_t P9N2_EX_11_L2_RAS_MODEREG                                    = 0x36010A9Dull;
//DUPS: 37010A9D,
static const uint64_t P9N2_EX_1_L2_RAS_MODEREG                                     = 0x22010A9Dull;
//DUPS: 23010A9D,
static const uint64_t P9N2_EX_2_L2_RAS_MODEREG                                     = 0x24010A9Dull;
//DUPS: 25010A9D,
static const uint64_t P9N2_EX_3_L2_RAS_MODEREG                                     = 0x26010A9Dull;
//DUPS: 27010A9D,
static const uint64_t P9N2_EX_4_L2_RAS_MODEREG                                     = 0x28010A9Dull;
//DUPS: 29010A9D,
static const uint64_t P9N2_EX_5_L2_RAS_MODEREG                                     = 0x2A010A9Dull;
//DUPS: 2B010A9D,
static const uint64_t P9N2_EX_6_L2_RAS_MODEREG                                     = 0x2C010A9Dull;
//DUPS: 2D010A9D,
static const uint64_t P9N2_EX_7_L2_RAS_MODEREG                                     = 0x2F010A9Dull;
//DUPS: 2F010A9D,
static const uint64_t P9N2_EX_8_L2_RAS_MODEREG                                     = 0x30010A9Dull;
//DUPS: 31010A9D,
static const uint64_t P9N2_EX_9_L2_RAS_MODEREG                                     = 0x32010A9Dull;
//DUPS: 33010A9D,
static const uint64_t P9N2_EX_L2_RAS_MODEREG                                       = 0x20010A9Dull;
//DUPS: 21010A9D,

static const uint64_t P9N2_C_RAS_STATUS                                            = 0x20010A02ull;

static const uint64_t P9N2_C_0_RAS_STATUS                                          = 0x20010A02ull;

static const uint64_t P9N2_C_1_RAS_STATUS                                          = 0x21010A02ull;

static const uint64_t P9N2_C_2_RAS_STATUS                                          = 0x22010A02ull;

static const uint64_t P9N2_C_3_RAS_STATUS                                          = 0x23010A02ull;

static const uint64_t P9N2_C_4_RAS_STATUS                                          = 0x24010A02ull;

static const uint64_t P9N2_C_5_RAS_STATUS                                          = 0x25010A02ull;

static const uint64_t P9N2_C_6_RAS_STATUS                                          = 0x26010A02ull;

static const uint64_t P9N2_C_7_RAS_STATUS                                          = 0x27010A02ull;

static const uint64_t P9N2_C_8_RAS_STATUS                                          = 0x28010A02ull;

static const uint64_t P9N2_C_9_RAS_STATUS                                          = 0x29010A02ull;

static const uint64_t P9N2_C_10_RAS_STATUS                                         = 0x2A010A02ull;

static const uint64_t P9N2_C_11_RAS_STATUS                                         = 0x2B010A02ull;

static const uint64_t P9N2_C_12_RAS_STATUS                                         = 0x2C010A02ull;

static const uint64_t P9N2_C_13_RAS_STATUS                                         = 0x2D010A02ull;

static const uint64_t P9N2_C_14_RAS_STATUS                                         = 0x2E010A02ull;

static const uint64_t P9N2_C_15_RAS_STATUS                                         = 0x2F010A02ull;

static const uint64_t P9N2_C_16_RAS_STATUS                                         = 0x30010A02ull;

static const uint64_t P9N2_C_17_RAS_STATUS                                         = 0x31010A02ull;

static const uint64_t P9N2_C_18_RAS_STATUS                                         = 0x32010A02ull;

static const uint64_t P9N2_C_19_RAS_STATUS                                         = 0x33010A02ull;

static const uint64_t P9N2_C_20_RAS_STATUS                                         = 0x34010A02ull;

static const uint64_t P9N2_C_21_RAS_STATUS                                         = 0x35010A02ull;

static const uint64_t P9N2_C_22_RAS_STATUS                                         = 0x36010A02ull;

static const uint64_t P9N2_C_23_RAS_STATUS                                         = 0x37010A02ull;

static const uint64_t P9N2_EX_0_L2_RAS_STATUS                                      = 0x20010A02ull;
//DUPS: 21010A02,
static const uint64_t P9N2_EX_10_L2_RAS_STATUS                                     = 0x34010A02ull;
//DUPS: 35010A02,
static const uint64_t P9N2_EX_11_L2_RAS_STATUS                                     = 0x36010A02ull;
//DUPS: 37010A02,
static const uint64_t P9N2_EX_1_L2_RAS_STATUS                                      = 0x22010A02ull;
//DUPS: 23010A02,
static const uint64_t P9N2_EX_2_L2_RAS_STATUS                                      = 0x24010A02ull;
//DUPS: 25010A02,
static const uint64_t P9N2_EX_3_L2_RAS_STATUS                                      = 0x26010A02ull;
//DUPS: 27010A02,
static const uint64_t P9N2_EX_4_L2_RAS_STATUS                                      = 0x28010A02ull;
//DUPS: 29010A02,
static const uint64_t P9N2_EX_5_L2_RAS_STATUS                                      = 0x2A010A02ull;
//DUPS: 2B010A02,
static const uint64_t P9N2_EX_6_L2_RAS_STATUS                                      = 0x2C010A02ull;
//DUPS: 2D010A02,
static const uint64_t P9N2_EX_7_L2_RAS_STATUS                                      = 0x2F010A02ull;
//DUPS: 2F010A02,
static const uint64_t P9N2_EX_8_L2_RAS_STATUS                                      = 0x30010A02ull;
//DUPS: 31010A02,
static const uint64_t P9N2_EX_9_L2_RAS_STATUS                                      = 0x32010A02ull;
//DUPS: 33010A02,
static const uint64_t P9N2_EX_L2_RAS_STATUS                                        = 0x20010A02ull;
//DUPS: 21010A02,

static const uint64_t P9N2_EQ_RD_EPS_REG                                           = 0x10010C10ull;
//DUPS: 10010C10,
static const uint64_t P9N2_EQ_0_RD_EPS_REG                                         = 0x10010C10ull;
//DUPS: 10010C10,
static const uint64_t P9N2_EQ_1_RD_EPS_REG                                         = 0x11010C10ull;
//DUPS: 11010C10,
static const uint64_t P9N2_EQ_2_RD_EPS_REG                                         = 0x12010C10ull;
//DUPS: 12010C10,
static const uint64_t P9N2_EQ_3_RD_EPS_REG                                         = 0x13010C10ull;
//DUPS: 13010C10,
static const uint64_t P9N2_EQ_4_RD_EPS_REG                                         = 0x14010C10ull;
//DUPS: 14010C10,
static const uint64_t P9N2_EQ_5_RD_EPS_REG                                         = 0x15010C10ull;
//DUPS: 15010C10,
static const uint64_t P9N2_EX_0_L2_RD_EPS_REG                                      = 0x10010810ull;

static const uint64_t P9N2_EX_10_L2_RD_EPS_REG                                     = 0x15010810ull;

static const uint64_t P9N2_EX_11_L2_RD_EPS_REG                                     = 0x15010C10ull;

static const uint64_t P9N2_EX_1_L2_RD_EPS_REG                                      = 0x10010C10ull;

static const uint64_t P9N2_EX_2_L2_RD_EPS_REG                                      = 0x11010810ull;

static const uint64_t P9N2_EX_3_L2_RD_EPS_REG                                      = 0x11010C10ull;

static const uint64_t P9N2_EX_4_L2_RD_EPS_REG                                      = 0x12010810ull;

static const uint64_t P9N2_EX_5_L2_RD_EPS_REG                                      = 0x12010C10ull;

static const uint64_t P9N2_EX_6_L2_RD_EPS_REG                                      = 0x13010810ull;

static const uint64_t P9N2_EX_7_L2_RD_EPS_REG                                      = 0x13010C10ull;

static const uint64_t P9N2_EX_8_L2_RD_EPS_REG                                      = 0x14010810ull;

static const uint64_t P9N2_EX_9_L2_RD_EPS_REG                                      = 0x14010C10ull;

static const uint64_t P9N2_EX_L2_RD_EPS_REG                                        = 0x10010810ull;


static const uint64_t P9N2_C_RECOV_FWD_PROG_CTRL                                   = 0x20010A4Bull;

static const uint64_t P9N2_C_0_RECOV_FWD_PROG_CTRL                                 = 0x20010A4Bull;

static const uint64_t P9N2_C_1_RECOV_FWD_PROG_CTRL                                 = 0x21010A4Bull;

static const uint64_t P9N2_C_2_RECOV_FWD_PROG_CTRL                                 = 0x22010A4Bull;

static const uint64_t P9N2_C_3_RECOV_FWD_PROG_CTRL                                 = 0x23010A4Bull;

static const uint64_t P9N2_C_4_RECOV_FWD_PROG_CTRL                                 = 0x24010A4Bull;

static const uint64_t P9N2_C_5_RECOV_FWD_PROG_CTRL                                 = 0x25010A4Bull;

static const uint64_t P9N2_C_6_RECOV_FWD_PROG_CTRL                                 = 0x26010A4Bull;

static const uint64_t P9N2_C_7_RECOV_FWD_PROG_CTRL                                 = 0x27010A4Bull;

static const uint64_t P9N2_C_8_RECOV_FWD_PROG_CTRL                                 = 0x28010A4Bull;

static const uint64_t P9N2_C_9_RECOV_FWD_PROG_CTRL                                 = 0x29010A4Bull;

static const uint64_t P9N2_C_10_RECOV_FWD_PROG_CTRL                                = 0x2A010A4Bull;

static const uint64_t P9N2_C_11_RECOV_FWD_PROG_CTRL                                = 0x2B010A4Bull;

static const uint64_t P9N2_C_12_RECOV_FWD_PROG_CTRL                                = 0x2C010A4Bull;

static const uint64_t P9N2_C_13_RECOV_FWD_PROG_CTRL                                = 0x2D010A4Bull;

static const uint64_t P9N2_C_14_RECOV_FWD_PROG_CTRL                                = 0x2E010A4Bull;

static const uint64_t P9N2_C_15_RECOV_FWD_PROG_CTRL                                = 0x2F010A4Bull;

static const uint64_t P9N2_C_16_RECOV_FWD_PROG_CTRL                                = 0x30010A4Bull;

static const uint64_t P9N2_C_17_RECOV_FWD_PROG_CTRL                                = 0x31010A4Bull;

static const uint64_t P9N2_C_18_RECOV_FWD_PROG_CTRL                                = 0x32010A4Bull;

static const uint64_t P9N2_C_19_RECOV_FWD_PROG_CTRL                                = 0x33010A4Bull;

static const uint64_t P9N2_C_20_RECOV_FWD_PROG_CTRL                                = 0x34010A4Bull;

static const uint64_t P9N2_C_21_RECOV_FWD_PROG_CTRL                                = 0x35010A4Bull;

static const uint64_t P9N2_C_22_RECOV_FWD_PROG_CTRL                                = 0x36010A4Bull;

static const uint64_t P9N2_C_23_RECOV_FWD_PROG_CTRL                                = 0x37010A4Bull;

static const uint64_t P9N2_EX_0_L2_RECOV_FWD_PROG_CTRL                             = 0x20010A4Bull;
//DUPS: 21010A4B,
static const uint64_t P9N2_EX_10_L2_RECOV_FWD_PROG_CTRL                            = 0x34010A4Bull;
//DUPS: 35010A4B,
static const uint64_t P9N2_EX_11_L2_RECOV_FWD_PROG_CTRL                            = 0x36010A4Bull;
//DUPS: 37010A4B,
static const uint64_t P9N2_EX_1_L2_RECOV_FWD_PROG_CTRL                             = 0x22010A4Bull;
//DUPS: 23010A4B,
static const uint64_t P9N2_EX_2_L2_RECOV_FWD_PROG_CTRL                             = 0x24010A4Bull;
//DUPS: 25010A4B,
static const uint64_t P9N2_EX_3_L2_RECOV_FWD_PROG_CTRL                             = 0x26010A4Bull;
//DUPS: 27010A4B,
static const uint64_t P9N2_EX_4_L2_RECOV_FWD_PROG_CTRL                             = 0x28010A4Bull;
//DUPS: 29010A4B,
static const uint64_t P9N2_EX_5_L2_RECOV_FWD_PROG_CTRL                             = 0x2A010A4Bull;
//DUPS: 2B010A4B,
static const uint64_t P9N2_EX_6_L2_RECOV_FWD_PROG_CTRL                             = 0x2C010A4Bull;
//DUPS: 2D010A4B,
static const uint64_t P9N2_EX_7_L2_RECOV_FWD_PROG_CTRL                             = 0x2F010A4Bull;
//DUPS: 2F010A4B,
static const uint64_t P9N2_EX_8_L2_RECOV_FWD_PROG_CTRL                             = 0x30010A4Bull;
//DUPS: 31010A4B,
static const uint64_t P9N2_EX_9_L2_RECOV_FWD_PROG_CTRL                             = 0x32010A4Bull;
//DUPS: 33010A4B,
static const uint64_t P9N2_EX_L2_RECOV_FWD_PROG_CTRL                               = 0x20010A4Bull;
//DUPS: 21010A4B,

static const uint64_t P9N2_C_RECOV_INTERRUPT_REG                                   = 0x200F001Bull;

static const uint64_t P9N2_C_0_RECOV_INTERRUPT_REG                                 = 0x200F001Bull;

static const uint64_t P9N2_C_1_RECOV_INTERRUPT_REG                                 = 0x210F001Bull;

static const uint64_t P9N2_C_2_RECOV_INTERRUPT_REG                                 = 0x220F001Bull;

static const uint64_t P9N2_C_3_RECOV_INTERRUPT_REG                                 = 0x230F001Bull;

static const uint64_t P9N2_C_4_RECOV_INTERRUPT_REG                                 = 0x240F001Bull;

static const uint64_t P9N2_C_5_RECOV_INTERRUPT_REG                                 = 0x250F001Bull;

static const uint64_t P9N2_C_6_RECOV_INTERRUPT_REG                                 = 0x260F001Bull;

static const uint64_t P9N2_C_7_RECOV_INTERRUPT_REG                                 = 0x270F001Bull;

static const uint64_t P9N2_C_8_RECOV_INTERRUPT_REG                                 = 0x280F001Bull;

static const uint64_t P9N2_C_9_RECOV_INTERRUPT_REG                                 = 0x290F001Bull;

static const uint64_t P9N2_C_10_RECOV_INTERRUPT_REG                                = 0x2A0F001Bull;

static const uint64_t P9N2_C_11_RECOV_INTERRUPT_REG                                = 0x2B0F001Bull;

static const uint64_t P9N2_C_12_RECOV_INTERRUPT_REG                                = 0x2C0F001Bull;

static const uint64_t P9N2_C_13_RECOV_INTERRUPT_REG                                = 0x2D0F001Bull;

static const uint64_t P9N2_C_14_RECOV_INTERRUPT_REG                                = 0x2E0F001Bull;

static const uint64_t P9N2_C_15_RECOV_INTERRUPT_REG                                = 0x2F0F001Bull;

static const uint64_t P9N2_C_16_RECOV_INTERRUPT_REG                                = 0x300F001Bull;

static const uint64_t P9N2_C_17_RECOV_INTERRUPT_REG                                = 0x310F001Bull;

static const uint64_t P9N2_C_18_RECOV_INTERRUPT_REG                                = 0x320F001Bull;

static const uint64_t P9N2_C_19_RECOV_INTERRUPT_REG                                = 0x330F001Bull;

static const uint64_t P9N2_C_20_RECOV_INTERRUPT_REG                                = 0x340F001Bull;

static const uint64_t P9N2_C_21_RECOV_INTERRUPT_REG                                = 0x350F001Bull;

static const uint64_t P9N2_C_22_RECOV_INTERRUPT_REG                                = 0x360F001Bull;

static const uint64_t P9N2_C_23_RECOV_INTERRUPT_REG                                = 0x370F001Bull;

static const uint64_t P9N2_EQ_RECOV_INTERRUPT_REG                                  = 0x100F001Bull;

static const uint64_t P9N2_EQ_0_RECOV_INTERRUPT_REG                                = 0x100F001Bull;

static const uint64_t P9N2_EQ_1_RECOV_INTERRUPT_REG                                = 0x110F001Bull;

static const uint64_t P9N2_EQ_2_RECOV_INTERRUPT_REG                                = 0x120F001Bull;

static const uint64_t P9N2_EQ_3_RECOV_INTERRUPT_REG                                = 0x130F001Bull;

static const uint64_t P9N2_EQ_4_RECOV_INTERRUPT_REG                                = 0x140F001Bull;

static const uint64_t P9N2_EQ_5_RECOV_INTERRUPT_REG                                = 0x150F001Bull;

static const uint64_t P9N2_EX_RECOV_INTERRUPT_REG                                  = 0x200F001Bull;
//DUPS: 210F001B,
static const uint64_t P9N2_EX_0_RECOV_INTERRUPT_REG                                = 0x200F001Bull;
//DUPS: 210F001B,
static const uint64_t P9N2_EX_1_RECOV_INTERRUPT_REG                                = 0x220F001Bull;
//DUPS: 220F001B,
static const uint64_t P9N2_EX_2_RECOV_INTERRUPT_REG                                = 0x240F001Bull;
//DUPS: 250F001B,
static const uint64_t P9N2_EX_3_RECOV_INTERRUPT_REG                                = 0x260F001Bull;
//DUPS: 270F001B,
static const uint64_t P9N2_EX_4_RECOV_INTERRUPT_REG                                = 0x280F001Bull;
//DUPS: 290F001B,
static const uint64_t P9N2_EX_5_RECOV_INTERRUPT_REG                                = 0x2A0F001Bull;
//DUPS: 2B0F001B,
static const uint64_t P9N2_EX_6_RECOV_INTERRUPT_REG                                = 0x2C0F001Bull;
//DUPS: 2D0F001B,
static const uint64_t P9N2_EX_7_RECOV_INTERRUPT_REG                                = 0x2E0F001Bull;
//DUPS: 2F0F001B,
static const uint64_t P9N2_EX_8_RECOV_INTERRUPT_REG                                = 0x300F001Bull;
//DUPS: 310F001B,
static const uint64_t P9N2_EX_9_RECOV_INTERRUPT_REG                                = 0x320F001Bull;
//DUPS: 330F001B,
static const uint64_t P9N2_EX_10_RECOV_INTERRUPT_REG                               = 0x340F001Bull;
//DUPS: 350F001B,
static const uint64_t P9N2_EX_11_RECOV_INTERRUPT_REG                               = 0x360F001Bull;
//DUPS: 370F001B,

static const uint64_t P9N2_C_RECOV_THOLD                                           = 0x20010A4Cull;

static const uint64_t P9N2_C_0_RECOV_THOLD                                         = 0x20010A4Cull;

static const uint64_t P9N2_C_1_RECOV_THOLD                                         = 0x21010A4Cull;

static const uint64_t P9N2_C_2_RECOV_THOLD                                         = 0x22010A4Cull;

static const uint64_t P9N2_C_3_RECOV_THOLD                                         = 0x23010A4Cull;

static const uint64_t P9N2_C_4_RECOV_THOLD                                         = 0x24010A4Cull;

static const uint64_t P9N2_C_5_RECOV_THOLD                                         = 0x25010A4Cull;

static const uint64_t P9N2_C_6_RECOV_THOLD                                         = 0x26010A4Cull;

static const uint64_t P9N2_C_7_RECOV_THOLD                                         = 0x27010A4Cull;

static const uint64_t P9N2_C_8_RECOV_THOLD                                         = 0x28010A4Cull;

static const uint64_t P9N2_C_9_RECOV_THOLD                                         = 0x29010A4Cull;

static const uint64_t P9N2_C_10_RECOV_THOLD                                        = 0x2A010A4Cull;

static const uint64_t P9N2_C_11_RECOV_THOLD                                        = 0x2B010A4Cull;

static const uint64_t P9N2_C_12_RECOV_THOLD                                        = 0x2C010A4Cull;

static const uint64_t P9N2_C_13_RECOV_THOLD                                        = 0x2D010A4Cull;

static const uint64_t P9N2_C_14_RECOV_THOLD                                        = 0x2E010A4Cull;

static const uint64_t P9N2_C_15_RECOV_THOLD                                        = 0x2F010A4Cull;

static const uint64_t P9N2_C_16_RECOV_THOLD                                        = 0x30010A4Cull;

static const uint64_t P9N2_C_17_RECOV_THOLD                                        = 0x31010A4Cull;

static const uint64_t P9N2_C_18_RECOV_THOLD                                        = 0x32010A4Cull;

static const uint64_t P9N2_C_19_RECOV_THOLD                                        = 0x33010A4Cull;

static const uint64_t P9N2_C_20_RECOV_THOLD                                        = 0x34010A4Cull;

static const uint64_t P9N2_C_21_RECOV_THOLD                                        = 0x35010A4Cull;

static const uint64_t P9N2_C_22_RECOV_THOLD                                        = 0x36010A4Cull;

static const uint64_t P9N2_C_23_RECOV_THOLD                                        = 0x37010A4Cull;

static const uint64_t P9N2_EX_0_L2_RECOV_THOLD                                     = 0x20010A4Cull;
//DUPS: 21010A4C,
static const uint64_t P9N2_EX_10_L2_RECOV_THOLD                                    = 0x34010A4Cull;
//DUPS: 35010A4C,
static const uint64_t P9N2_EX_11_L2_RECOV_THOLD                                    = 0x36010A4Cull;
//DUPS: 37010A4C,
static const uint64_t P9N2_EX_1_L2_RECOV_THOLD                                     = 0x22010A4Cull;
//DUPS: 23010A4C,
static const uint64_t P9N2_EX_2_L2_RECOV_THOLD                                     = 0x24010A4Cull;
//DUPS: 25010A4C,
static const uint64_t P9N2_EX_3_L2_RECOV_THOLD                                     = 0x26010A4Cull;
//DUPS: 27010A4C,
static const uint64_t P9N2_EX_4_L2_RECOV_THOLD                                     = 0x28010A4Cull;
//DUPS: 29010A4C,
static const uint64_t P9N2_EX_5_L2_RECOV_THOLD                                     = 0x2A010A4Cull;
//DUPS: 2B010A4C,
static const uint64_t P9N2_EX_6_L2_RECOV_THOLD                                     = 0x2C010A4Cull;
//DUPS: 2D010A4C,
static const uint64_t P9N2_EX_7_L2_RECOV_THOLD                                     = 0x2F010A4Cull;
//DUPS: 2F010A4C,
static const uint64_t P9N2_EX_8_L2_RECOV_THOLD                                     = 0x30010A4Cull;
//DUPS: 31010A4C,
static const uint64_t P9N2_EX_9_L2_RECOV_THOLD                                     = 0x32010A4Cull;
//DUPS: 33010A4C,
static const uint64_t P9N2_EX_L2_RECOV_THOLD                                       = 0x20010A4Cull;
//DUPS: 21010A4C,

static const uint64_t P9N2_C_RESET_KEEPER                                          = 0x20010A4Aull;

static const uint64_t P9N2_C_0_RESET_KEEPER                                        = 0x20010A4Aull;

static const uint64_t P9N2_C_1_RESET_KEEPER                                        = 0x21010A4Aull;

static const uint64_t P9N2_C_2_RESET_KEEPER                                        = 0x22010A4Aull;

static const uint64_t P9N2_C_3_RESET_KEEPER                                        = 0x23010A4Aull;

static const uint64_t P9N2_C_4_RESET_KEEPER                                        = 0x24010A4Aull;

static const uint64_t P9N2_C_5_RESET_KEEPER                                        = 0x25010A4Aull;

static const uint64_t P9N2_C_6_RESET_KEEPER                                        = 0x26010A4Aull;

static const uint64_t P9N2_C_7_RESET_KEEPER                                        = 0x27010A4Aull;

static const uint64_t P9N2_C_8_RESET_KEEPER                                        = 0x28010A4Aull;

static const uint64_t P9N2_C_9_RESET_KEEPER                                        = 0x29010A4Aull;

static const uint64_t P9N2_C_10_RESET_KEEPER                                       = 0x2A010A4Aull;

static const uint64_t P9N2_C_11_RESET_KEEPER                                       = 0x2B010A4Aull;

static const uint64_t P9N2_C_12_RESET_KEEPER                                       = 0x2C010A4Aull;

static const uint64_t P9N2_C_13_RESET_KEEPER                                       = 0x2D010A4Aull;

static const uint64_t P9N2_C_14_RESET_KEEPER                                       = 0x2E010A4Aull;

static const uint64_t P9N2_C_15_RESET_KEEPER                                       = 0x2F010A4Aull;

static const uint64_t P9N2_C_16_RESET_KEEPER                                       = 0x30010A4Aull;

static const uint64_t P9N2_C_17_RESET_KEEPER                                       = 0x31010A4Aull;

static const uint64_t P9N2_C_18_RESET_KEEPER                                       = 0x32010A4Aull;

static const uint64_t P9N2_C_19_RESET_KEEPER                                       = 0x33010A4Aull;

static const uint64_t P9N2_C_20_RESET_KEEPER                                       = 0x34010A4Aull;

static const uint64_t P9N2_C_21_RESET_KEEPER                                       = 0x35010A4Aull;

static const uint64_t P9N2_C_22_RESET_KEEPER                                       = 0x36010A4Aull;

static const uint64_t P9N2_C_23_RESET_KEEPER                                       = 0x37010A4Aull;

static const uint64_t P9N2_EX_0_L2_RESET_KEEPER                                    = 0x20010A4Aull;
//DUPS: 21010A4A,
static const uint64_t P9N2_EX_10_L2_RESET_KEEPER                                   = 0x34010A4Aull;
//DUPS: 35010A4A,
static const uint64_t P9N2_EX_11_L2_RESET_KEEPER                                   = 0x36010A4Aull;
//DUPS: 37010A4A,
static const uint64_t P9N2_EX_1_L2_RESET_KEEPER                                    = 0x22010A4Aull;
//DUPS: 23010A4A,
static const uint64_t P9N2_EX_2_L2_RESET_KEEPER                                    = 0x24010A4Aull;
//DUPS: 25010A4A,
static const uint64_t P9N2_EX_3_L2_RESET_KEEPER                                    = 0x26010A4Aull;
//DUPS: 27010A4A,
static const uint64_t P9N2_EX_4_L2_RESET_KEEPER                                    = 0x28010A4Aull;
//DUPS: 29010A4A,
static const uint64_t P9N2_EX_5_L2_RESET_KEEPER                                    = 0x2A010A4Aull;
//DUPS: 2B010A4A,
static const uint64_t P9N2_EX_6_L2_RESET_KEEPER                                    = 0x2C010A4Aull;
//DUPS: 2D010A4A,
static const uint64_t P9N2_EX_7_L2_RESET_KEEPER                                    = 0x2F010A4Aull;
//DUPS: 2F010A4A,
static const uint64_t P9N2_EX_8_L2_RESET_KEEPER                                    = 0x30010A4Aull;
//DUPS: 31010A4A,
static const uint64_t P9N2_EX_9_L2_RESET_KEEPER                                    = 0x32010A4Aull;
//DUPS: 33010A4A,
static const uint64_t P9N2_EX_L2_RESET_KEEPER                                      = 0x20010A4Aull;
//DUPS: 21010A4A,

static const uint64_t P9N2_C_RFIR                                                  = 0x20040001ull;

static const uint64_t P9N2_C_0_RFIR                                                = 0x20040001ull;

static const uint64_t P9N2_C_1_RFIR                                                = 0x21040001ull;

static const uint64_t P9N2_C_2_RFIR                                                = 0x22040001ull;

static const uint64_t P9N2_C_3_RFIR                                                = 0x23040001ull;

static const uint64_t P9N2_C_4_RFIR                                                = 0x24040001ull;

static const uint64_t P9N2_C_5_RFIR                                                = 0x25040001ull;

static const uint64_t P9N2_C_6_RFIR                                                = 0x26040001ull;

static const uint64_t P9N2_C_7_RFIR                                                = 0x27040001ull;

static const uint64_t P9N2_C_8_RFIR                                                = 0x28040001ull;

static const uint64_t P9N2_C_9_RFIR                                                = 0x29040001ull;

static const uint64_t P9N2_C_10_RFIR                                               = 0x2A040001ull;

static const uint64_t P9N2_C_11_RFIR                                               = 0x2B040001ull;

static const uint64_t P9N2_C_12_RFIR                                               = 0x2C040001ull;

static const uint64_t P9N2_C_13_RFIR                                               = 0x2D040001ull;

static const uint64_t P9N2_C_14_RFIR                                               = 0x2E040001ull;

static const uint64_t P9N2_C_15_RFIR                                               = 0x2F040001ull;

static const uint64_t P9N2_C_16_RFIR                                               = 0x30040001ull;

static const uint64_t P9N2_C_17_RFIR                                               = 0x31040001ull;

static const uint64_t P9N2_C_18_RFIR                                               = 0x32040001ull;

static const uint64_t P9N2_C_19_RFIR                                               = 0x33040001ull;

static const uint64_t P9N2_C_20_RFIR                                               = 0x34040001ull;

static const uint64_t P9N2_C_21_RFIR                                               = 0x35040001ull;

static const uint64_t P9N2_C_22_RFIR                                               = 0x36040001ull;

static const uint64_t P9N2_C_23_RFIR                                               = 0x37040001ull;

static const uint64_t P9N2_EQ_RFIR                                                 = 0x10040001ull;

static const uint64_t P9N2_EQ_0_RFIR                                               = 0x10040001ull;

static const uint64_t P9N2_EQ_1_RFIR                                               = 0x11040001ull;

static const uint64_t P9N2_EQ_2_RFIR                                               = 0x12040001ull;

static const uint64_t P9N2_EQ_3_RFIR                                               = 0x13040001ull;

static const uint64_t P9N2_EQ_4_RFIR                                               = 0x14040001ull;

static const uint64_t P9N2_EQ_5_RFIR                                               = 0x15040001ull;

static const uint64_t P9N2_EX_RFIR                                                 = 0x20040001ull;
//DUPS: 21040001,
static const uint64_t P9N2_EX_0_RFIR                                               = 0x20040001ull;
//DUPS: 21040001,
static const uint64_t P9N2_EX_1_RFIR                                               = 0x22040001ull;
//DUPS: 23040001,
static const uint64_t P9N2_EX_2_RFIR                                               = 0x24040001ull;
//DUPS: 25040001,
static const uint64_t P9N2_EX_3_RFIR                                               = 0x26040001ull;
//DUPS: 27040001,
static const uint64_t P9N2_EX_4_RFIR                                               = 0x28040001ull;
//DUPS: 29040001,
static const uint64_t P9N2_EX_5_RFIR                                               = 0x2A040001ull;
//DUPS: 2B040001,
static const uint64_t P9N2_EX_6_RFIR                                               = 0x2C040001ull;
//DUPS: 2D040001,
static const uint64_t P9N2_EX_7_RFIR                                               = 0x2F040001ull;
//DUPS: 2F040001,
static const uint64_t P9N2_EX_8_RFIR                                               = 0x30040001ull;
//DUPS: 31040001,
static const uint64_t P9N2_EX_9_RFIR                                               = 0x32040001ull;
//DUPS: 33040001,
static const uint64_t P9N2_EX_10_RFIR                                              = 0x34040001ull;
//DUPS: 35040001,
static const uint64_t P9N2_EX_11_RFIR                                              = 0x36040001ull;
//DUPS: 37040001,

static const uint64_t P9N2_C_RING_FENCE_MASK_LATCH_REG                             = 0x20010008ull;

static const uint64_t P9N2_C_0_RING_FENCE_MASK_LATCH_REG                           = 0x20010008ull;

static const uint64_t P9N2_C_1_RING_FENCE_MASK_LATCH_REG                           = 0x21010008ull;

static const uint64_t P9N2_C_2_RING_FENCE_MASK_LATCH_REG                           = 0x22010008ull;

static const uint64_t P9N2_C_3_RING_FENCE_MASK_LATCH_REG                           = 0x23010008ull;

static const uint64_t P9N2_C_4_RING_FENCE_MASK_LATCH_REG                           = 0x24010008ull;

static const uint64_t P9N2_C_5_RING_FENCE_MASK_LATCH_REG                           = 0x25010008ull;

static const uint64_t P9N2_C_6_RING_FENCE_MASK_LATCH_REG                           = 0x26010008ull;

static const uint64_t P9N2_C_7_RING_FENCE_MASK_LATCH_REG                           = 0x27010008ull;

static const uint64_t P9N2_C_8_RING_FENCE_MASK_LATCH_REG                           = 0x28010008ull;

static const uint64_t P9N2_C_9_RING_FENCE_MASK_LATCH_REG                           = 0x29010008ull;

static const uint64_t P9N2_C_10_RING_FENCE_MASK_LATCH_REG                          = 0x2A010008ull;

static const uint64_t P9N2_C_11_RING_FENCE_MASK_LATCH_REG                          = 0x2B010008ull;

static const uint64_t P9N2_C_12_RING_FENCE_MASK_LATCH_REG                          = 0x2C010008ull;

static const uint64_t P9N2_C_13_RING_FENCE_MASK_LATCH_REG                          = 0x2D010008ull;

static const uint64_t P9N2_C_14_RING_FENCE_MASK_LATCH_REG                          = 0x2E010008ull;

static const uint64_t P9N2_C_15_RING_FENCE_MASK_LATCH_REG                          = 0x2F010008ull;

static const uint64_t P9N2_C_16_RING_FENCE_MASK_LATCH_REG                          = 0x30010008ull;

static const uint64_t P9N2_C_17_RING_FENCE_MASK_LATCH_REG                          = 0x31010008ull;

static const uint64_t P9N2_C_18_RING_FENCE_MASK_LATCH_REG                          = 0x32010008ull;

static const uint64_t P9N2_C_19_RING_FENCE_MASK_LATCH_REG                          = 0x33010008ull;

static const uint64_t P9N2_C_20_RING_FENCE_MASK_LATCH_REG                          = 0x34010008ull;

static const uint64_t P9N2_C_21_RING_FENCE_MASK_LATCH_REG                          = 0x35010008ull;

static const uint64_t P9N2_C_22_RING_FENCE_MASK_LATCH_REG                          = 0x36010008ull;

static const uint64_t P9N2_C_23_RING_FENCE_MASK_LATCH_REG                          = 0x37010008ull;

static const uint64_t P9N2_EQ_RING_FENCE_MASK_LATCH_REG                            = 0x10010008ull;

static const uint64_t P9N2_EQ_0_RING_FENCE_MASK_LATCH_REG                          = 0x10010008ull;

static const uint64_t P9N2_EQ_1_RING_FENCE_MASK_LATCH_REG                          = 0x11010008ull;

static const uint64_t P9N2_EQ_2_RING_FENCE_MASK_LATCH_REG                          = 0x12010008ull;

static const uint64_t P9N2_EQ_3_RING_FENCE_MASK_LATCH_REG                          = 0x13010008ull;

static const uint64_t P9N2_EQ_4_RING_FENCE_MASK_LATCH_REG                          = 0x14010008ull;

static const uint64_t P9N2_EQ_5_RING_FENCE_MASK_LATCH_REG                          = 0x15010008ull;

static const uint64_t P9N2_EX_RING_FENCE_MASK_LATCH_REG                            = 0x20010008ull;
//DUPS: 21010008,
static const uint64_t P9N2_EX_0_RING_FENCE_MASK_LATCH_REG                          = 0x20010008ull;
//DUPS: 21010008,
static const uint64_t P9N2_EX_1_RING_FENCE_MASK_LATCH_REG                          = 0x22010008ull;
//DUPS: 23010008,
static const uint64_t P9N2_EX_2_RING_FENCE_MASK_LATCH_REG                          = 0x24010008ull;
//DUPS: 25010008,
static const uint64_t P9N2_EX_3_RING_FENCE_MASK_LATCH_REG                          = 0x26010008ull;
//DUPS: 27010008,
static const uint64_t P9N2_EX_4_RING_FENCE_MASK_LATCH_REG                          = 0x28010008ull;
//DUPS: 29010008,
static const uint64_t P9N2_EX_5_RING_FENCE_MASK_LATCH_REG                          = 0x2A010008ull;
//DUPS: 2B010008,
static const uint64_t P9N2_EX_6_RING_FENCE_MASK_LATCH_REG                          = 0x2C010008ull;
//DUPS: 2D010008,
static const uint64_t P9N2_EX_7_RING_FENCE_MASK_LATCH_REG                          = 0x2F010008ull;
//DUPS: 2F010008,
static const uint64_t P9N2_EX_8_RING_FENCE_MASK_LATCH_REG                          = 0x30010008ull;
//DUPS: 31010008,
static const uint64_t P9N2_EX_9_RING_FENCE_MASK_LATCH_REG                          = 0x32010008ull;
//DUPS: 33010008,
static const uint64_t P9N2_EX_10_RING_FENCE_MASK_LATCH_REG                         = 0x34010008ull;
//DUPS: 35010008,
static const uint64_t P9N2_EX_11_RING_FENCE_MASK_LATCH_REG                         = 0x36010008ull;
//DUPS: 37010008,

static const uint64_t P9N2_C_SCAN32                                                = 0x20038000ull;

static const uint64_t P9N2_C_0_SCAN32                                              = 0x20038000ull;

static const uint64_t P9N2_C_1_SCAN32                                              = 0x21038000ull;

static const uint64_t P9N2_C_2_SCAN32                                              = 0x22038000ull;

static const uint64_t P9N2_C_3_SCAN32                                              = 0x23038000ull;

static const uint64_t P9N2_C_4_SCAN32                                              = 0x24038000ull;

static const uint64_t P9N2_C_5_SCAN32                                              = 0x25038000ull;

static const uint64_t P9N2_C_6_SCAN32                                              = 0x26038000ull;

static const uint64_t P9N2_C_7_SCAN32                                              = 0x27038000ull;

static const uint64_t P9N2_C_8_SCAN32                                              = 0x28038000ull;

static const uint64_t P9N2_C_9_SCAN32                                              = 0x29038000ull;

static const uint64_t P9N2_C_10_SCAN32                                             = 0x2A038000ull;

static const uint64_t P9N2_C_11_SCAN32                                             = 0x2B038000ull;

static const uint64_t P9N2_C_12_SCAN32                                             = 0x2C038000ull;

static const uint64_t P9N2_C_13_SCAN32                                             = 0x2D038000ull;

static const uint64_t P9N2_C_14_SCAN32                                             = 0x2E038000ull;

static const uint64_t P9N2_C_15_SCAN32                                             = 0x2F038000ull;

static const uint64_t P9N2_C_16_SCAN32                                             = 0x30038000ull;

static const uint64_t P9N2_C_17_SCAN32                                             = 0x31038000ull;

static const uint64_t P9N2_C_18_SCAN32                                             = 0x32038000ull;

static const uint64_t P9N2_C_19_SCAN32                                             = 0x33038000ull;

static const uint64_t P9N2_C_20_SCAN32                                             = 0x34038000ull;

static const uint64_t P9N2_C_21_SCAN32                                             = 0x35038000ull;

static const uint64_t P9N2_C_22_SCAN32                                             = 0x36038000ull;

static const uint64_t P9N2_C_23_SCAN32                                             = 0x37038000ull;

static const uint64_t P9N2_EQ_SCAN32                                               = 0x10038000ull;

static const uint64_t P9N2_EQ_0_SCAN32                                             = 0x10038000ull;

static const uint64_t P9N2_EQ_1_SCAN32                                             = 0x11038000ull;

static const uint64_t P9N2_EQ_2_SCAN32                                             = 0x12038000ull;

static const uint64_t P9N2_EQ_3_SCAN32                                             = 0x13038000ull;

static const uint64_t P9N2_EQ_4_SCAN32                                             = 0x14038000ull;

static const uint64_t P9N2_EQ_5_SCAN32                                             = 0x15038000ull;

static const uint64_t P9N2_EX_SCAN32                                               = 0x20038000ull;
//DUPS: 21038000,
static const uint64_t P9N2_EX_0_SCAN32                                             = 0x20038000ull;
//DUPS: 21038000,
static const uint64_t P9N2_EX_1_SCAN32                                             = 0x22038000ull;
//DUPS: 23038000,
static const uint64_t P9N2_EX_2_SCAN32                                             = 0x24038000ull;
//DUPS: 25038000,
static const uint64_t P9N2_EX_3_SCAN32                                             = 0x26038000ull;
//DUPS: 27038000,
static const uint64_t P9N2_EX_4_SCAN32                                             = 0x28038000ull;
//DUPS: 29038000,
static const uint64_t P9N2_EX_5_SCAN32                                             = 0x2A038000ull;
//DUPS: 2B038000,
static const uint64_t P9N2_EX_6_SCAN32                                             = 0x2C038000ull;
//DUPS: 2D038000,
static const uint64_t P9N2_EX_7_SCAN32                                             = 0x2F038000ull;
//DUPS: 2F038000,
static const uint64_t P9N2_EX_8_SCAN32                                             = 0x30038000ull;
//DUPS: 31038000,
static const uint64_t P9N2_EX_9_SCAN32                                             = 0x32038000ull;
//DUPS: 33038000,
static const uint64_t P9N2_EX_10_SCAN32                                            = 0x34038000ull;
//DUPS: 35038000,
static const uint64_t P9N2_EX_11_SCAN32                                            = 0x36038000ull;
//DUPS: 37038000,

static const uint64_t P9N2_C_SCAN64                                                = 0x2003E000ull;

static const uint64_t P9N2_C_0_SCAN64                                              = 0x2003E000ull;

static const uint64_t P9N2_C_1_SCAN64                                              = 0x2103E000ull;

static const uint64_t P9N2_C_2_SCAN64                                              = 0x2203E000ull;

static const uint64_t P9N2_C_3_SCAN64                                              = 0x2303E000ull;

static const uint64_t P9N2_C_4_SCAN64                                              = 0x2403E000ull;

static const uint64_t P9N2_C_5_SCAN64                                              = 0x2503E000ull;

static const uint64_t P9N2_C_6_SCAN64                                              = 0x2603E000ull;

static const uint64_t P9N2_C_7_SCAN64                                              = 0x2703E000ull;

static const uint64_t P9N2_C_8_SCAN64                                              = 0x2803E000ull;

static const uint64_t P9N2_C_9_SCAN64                                              = 0x2903E000ull;

static const uint64_t P9N2_C_10_SCAN64                                             = 0x2A03E000ull;

static const uint64_t P9N2_C_11_SCAN64                                             = 0x2B03E000ull;

static const uint64_t P9N2_C_12_SCAN64                                             = 0x2C03E000ull;

static const uint64_t P9N2_C_13_SCAN64                                             = 0x2D03E000ull;

static const uint64_t P9N2_C_14_SCAN64                                             = 0x2E03E000ull;

static const uint64_t P9N2_C_15_SCAN64                                             = 0x2F03E000ull;

static const uint64_t P9N2_C_16_SCAN64                                             = 0x3003E000ull;

static const uint64_t P9N2_C_17_SCAN64                                             = 0x3103E000ull;

static const uint64_t P9N2_C_18_SCAN64                                             = 0x3203E000ull;

static const uint64_t P9N2_C_19_SCAN64                                             = 0x3303E000ull;

static const uint64_t P9N2_C_20_SCAN64                                             = 0x3403E000ull;

static const uint64_t P9N2_C_21_SCAN64                                             = 0x3503E000ull;

static const uint64_t P9N2_C_22_SCAN64                                             = 0x3603E000ull;

static const uint64_t P9N2_C_23_SCAN64                                             = 0x3703E000ull;

static const uint64_t P9N2_EQ_SCAN64                                               = 0x1003E000ull;

static const uint64_t P9N2_EQ_0_SCAN64                                             = 0x1003E000ull;

static const uint64_t P9N2_EQ_1_SCAN64                                             = 0x1103E000ull;

static const uint64_t P9N2_EQ_2_SCAN64                                             = 0x1203E000ull;

static const uint64_t P9N2_EQ_3_SCAN64                                             = 0x1303E000ull;

static const uint64_t P9N2_EQ_4_SCAN64                                             = 0x1403E000ull;

static const uint64_t P9N2_EQ_5_SCAN64                                             = 0x1503E000ull;

static const uint64_t P9N2_EX_SCAN64                                               = 0x2003E000ull;
//DUPS: 2103E000,
static const uint64_t P9N2_EX_0_SCAN64                                             = 0x2003E000ull;
//DUPS: 2103E000,
static const uint64_t P9N2_EX_1_SCAN64                                             = 0x2203E000ull;
//DUPS: 2303E000,
static const uint64_t P9N2_EX_2_SCAN64                                             = 0x2403E000ull;
//DUPS: 2503E000,
static const uint64_t P9N2_EX_3_SCAN64                                             = 0x2603E000ull;
//DUPS: 2703E000,
static const uint64_t P9N2_EX_4_SCAN64                                             = 0x2803E000ull;
//DUPS: 2903E000,
static const uint64_t P9N2_EX_5_SCAN64                                             = 0x2A03E000ull;
//DUPS: 2B03E000,
static const uint64_t P9N2_EX_6_SCAN64                                             = 0x2C03E000ull;
//DUPS: 2D03E000,
static const uint64_t P9N2_EX_7_SCAN64                                             = 0x2F03E000ull;
//DUPS: 2F03E000,
static const uint64_t P9N2_EX_8_SCAN64                                             = 0x3003E000ull;
//DUPS: 3103E000,
static const uint64_t P9N2_EX_9_SCAN64                                             = 0x3203E000ull;
//DUPS: 3303E000,
static const uint64_t P9N2_EX_10_SCAN64                                            = 0x3403E000ull;
//DUPS: 3503E000,
static const uint64_t P9N2_EX_11_SCAN64                                            = 0x3603E000ull;
//DUPS: 3703E000,

static const uint64_t P9N2_C_SCAN_CAPTUREDR                                        = 0x2003C000ull;

static const uint64_t P9N2_C_0_SCAN_CAPTUREDR                                      = 0x2003C000ull;

static const uint64_t P9N2_C_1_SCAN_CAPTUREDR                                      = 0x2103C000ull;

static const uint64_t P9N2_C_2_SCAN_CAPTUREDR                                      = 0x2203C000ull;

static const uint64_t P9N2_C_3_SCAN_CAPTUREDR                                      = 0x2303C000ull;

static const uint64_t P9N2_C_4_SCAN_CAPTUREDR                                      = 0x2403C000ull;

static const uint64_t P9N2_C_5_SCAN_CAPTUREDR                                      = 0x2503C000ull;

static const uint64_t P9N2_C_6_SCAN_CAPTUREDR                                      = 0x2603C000ull;

static const uint64_t P9N2_C_7_SCAN_CAPTUREDR                                      = 0x2703C000ull;

static const uint64_t P9N2_C_8_SCAN_CAPTUREDR                                      = 0x2803C000ull;

static const uint64_t P9N2_C_9_SCAN_CAPTUREDR                                      = 0x2903C000ull;

static const uint64_t P9N2_C_10_SCAN_CAPTUREDR                                     = 0x2A03C000ull;

static const uint64_t P9N2_C_11_SCAN_CAPTUREDR                                     = 0x2B03C000ull;

static const uint64_t P9N2_C_12_SCAN_CAPTUREDR                                     = 0x2C03C000ull;

static const uint64_t P9N2_C_13_SCAN_CAPTUREDR                                     = 0x2D03C000ull;

static const uint64_t P9N2_C_14_SCAN_CAPTUREDR                                     = 0x2E03C000ull;

static const uint64_t P9N2_C_15_SCAN_CAPTUREDR                                     = 0x2F03C000ull;

static const uint64_t P9N2_C_16_SCAN_CAPTUREDR                                     = 0x3003C000ull;

static const uint64_t P9N2_C_17_SCAN_CAPTUREDR                                     = 0x3103C000ull;

static const uint64_t P9N2_C_18_SCAN_CAPTUREDR                                     = 0x3203C000ull;

static const uint64_t P9N2_C_19_SCAN_CAPTUREDR                                     = 0x3303C000ull;

static const uint64_t P9N2_C_20_SCAN_CAPTUREDR                                     = 0x3403C000ull;

static const uint64_t P9N2_C_21_SCAN_CAPTUREDR                                     = 0x3503C000ull;

static const uint64_t P9N2_C_22_SCAN_CAPTUREDR                                     = 0x3603C000ull;

static const uint64_t P9N2_C_23_SCAN_CAPTUREDR                                     = 0x3703C000ull;

static const uint64_t P9N2_EQ_SCAN_CAPTUREDR                                       = 0x1003C000ull;

static const uint64_t P9N2_EQ_0_SCAN_CAPTUREDR                                     = 0x1003C000ull;

static const uint64_t P9N2_EQ_1_SCAN_CAPTUREDR                                     = 0x1103C000ull;

static const uint64_t P9N2_EQ_2_SCAN_CAPTUREDR                                     = 0x1203C000ull;

static const uint64_t P9N2_EQ_3_SCAN_CAPTUREDR                                     = 0x1303C000ull;

static const uint64_t P9N2_EQ_4_SCAN_CAPTUREDR                                     = 0x1403C000ull;

static const uint64_t P9N2_EQ_5_SCAN_CAPTUREDR                                     = 0x1503C000ull;

static const uint64_t P9N2_EX_SCAN_CAPTUREDR                                       = 0x2003C000ull;
//DUPS: 2103C000,
static const uint64_t P9N2_EX_0_SCAN_CAPTUREDR                                     = 0x2003C000ull;
//DUPS: 2103C000,
static const uint64_t P9N2_EX_1_SCAN_CAPTUREDR                                     = 0x2203C000ull;
//DUPS: 2303C000,
static const uint64_t P9N2_EX_2_SCAN_CAPTUREDR                                     = 0x2403C000ull;
//DUPS: 2503C000,
static const uint64_t P9N2_EX_3_SCAN_CAPTUREDR                                     = 0x2603C000ull;
//DUPS: 2703C000,
static const uint64_t P9N2_EX_4_SCAN_CAPTUREDR                                     = 0x2803C000ull;
//DUPS: 2903C000,
static const uint64_t P9N2_EX_5_SCAN_CAPTUREDR                                     = 0x2A03C000ull;
//DUPS: 2B03C000,
static const uint64_t P9N2_EX_6_SCAN_CAPTUREDR                                     = 0x2C03C000ull;
//DUPS: 2D03C000,
static const uint64_t P9N2_EX_7_SCAN_CAPTUREDR                                     = 0x2F03C000ull;
//DUPS: 2F03C000,
static const uint64_t P9N2_EX_8_SCAN_CAPTUREDR                                     = 0x3003C000ull;
//DUPS: 3103C000,
static const uint64_t P9N2_EX_9_SCAN_CAPTUREDR                                     = 0x3203C000ull;
//DUPS: 3303C000,
static const uint64_t P9N2_EX_10_SCAN_CAPTUREDR                                    = 0x3403C000ull;
//DUPS: 3503C000,
static const uint64_t P9N2_EX_11_SCAN_CAPTUREDR                                    = 0x3603C000ull;
//DUPS: 3703C000,

static const uint64_t P9N2_C_SCAN_CAPTUREDR_LONG                                   = 0x2003D000ull;

static const uint64_t P9N2_C_0_SCAN_CAPTUREDR_LONG                                 = 0x2003D000ull;

static const uint64_t P9N2_C_1_SCAN_CAPTUREDR_LONG                                 = 0x2103D000ull;

static const uint64_t P9N2_C_2_SCAN_CAPTUREDR_LONG                                 = 0x2203D000ull;

static const uint64_t P9N2_C_3_SCAN_CAPTUREDR_LONG                                 = 0x2303D000ull;

static const uint64_t P9N2_C_4_SCAN_CAPTUREDR_LONG                                 = 0x2403D000ull;

static const uint64_t P9N2_C_5_SCAN_CAPTUREDR_LONG                                 = 0x2503D000ull;

static const uint64_t P9N2_C_6_SCAN_CAPTUREDR_LONG                                 = 0x2603D000ull;

static const uint64_t P9N2_C_7_SCAN_CAPTUREDR_LONG                                 = 0x2703D000ull;

static const uint64_t P9N2_C_8_SCAN_CAPTUREDR_LONG                                 = 0x2803D000ull;

static const uint64_t P9N2_C_9_SCAN_CAPTUREDR_LONG                                 = 0x2903D000ull;

static const uint64_t P9N2_C_10_SCAN_CAPTUREDR_LONG                                = 0x2A03D000ull;

static const uint64_t P9N2_C_11_SCAN_CAPTUREDR_LONG                                = 0x2B03D000ull;

static const uint64_t P9N2_C_12_SCAN_CAPTUREDR_LONG                                = 0x2C03D000ull;

static const uint64_t P9N2_C_13_SCAN_CAPTUREDR_LONG                                = 0x2D03D000ull;

static const uint64_t P9N2_C_14_SCAN_CAPTUREDR_LONG                                = 0x2E03D000ull;

static const uint64_t P9N2_C_15_SCAN_CAPTUREDR_LONG                                = 0x2F03D000ull;

static const uint64_t P9N2_C_16_SCAN_CAPTUREDR_LONG                                = 0x3003D000ull;

static const uint64_t P9N2_C_17_SCAN_CAPTUREDR_LONG                                = 0x3103D000ull;

static const uint64_t P9N2_C_18_SCAN_CAPTUREDR_LONG                                = 0x3203D000ull;

static const uint64_t P9N2_C_19_SCAN_CAPTUREDR_LONG                                = 0x3303D000ull;

static const uint64_t P9N2_C_20_SCAN_CAPTUREDR_LONG                                = 0x3403D000ull;

static const uint64_t P9N2_C_21_SCAN_CAPTUREDR_LONG                                = 0x3503D000ull;

static const uint64_t P9N2_C_22_SCAN_CAPTUREDR_LONG                                = 0x3603D000ull;

static const uint64_t P9N2_C_23_SCAN_CAPTUREDR_LONG                                = 0x3703D000ull;

static const uint64_t P9N2_EQ_SCAN_CAPTUREDR_LONG                                  = 0x1003D000ull;

static const uint64_t P9N2_EQ_0_SCAN_CAPTUREDR_LONG                                = 0x1003D000ull;

static const uint64_t P9N2_EQ_1_SCAN_CAPTUREDR_LONG                                = 0x1103D000ull;

static const uint64_t P9N2_EQ_2_SCAN_CAPTUREDR_LONG                                = 0x1203D000ull;

static const uint64_t P9N2_EQ_3_SCAN_CAPTUREDR_LONG                                = 0x1303D000ull;

static const uint64_t P9N2_EQ_4_SCAN_CAPTUREDR_LONG                                = 0x1403D000ull;

static const uint64_t P9N2_EQ_5_SCAN_CAPTUREDR_LONG                                = 0x1503D000ull;

static const uint64_t P9N2_EX_SCAN_CAPTUREDR_LONG                                  = 0x2003D000ull;
//DUPS: 2103D000,
static const uint64_t P9N2_EX_0_SCAN_CAPTUREDR_LONG                                = 0x2003D000ull;
//DUPS: 2103D000,
static const uint64_t P9N2_EX_1_SCAN_CAPTUREDR_LONG                                = 0x2203D000ull;
//DUPS: 2303D000,
static const uint64_t P9N2_EX_2_SCAN_CAPTUREDR_LONG                                = 0x2403D000ull;
//DUPS: 2503D000,
static const uint64_t P9N2_EX_3_SCAN_CAPTUREDR_LONG                                = 0x2603D000ull;
//DUPS: 2703D000,
static const uint64_t P9N2_EX_4_SCAN_CAPTUREDR_LONG                                = 0x2803D000ull;
//DUPS: 2903D000,
static const uint64_t P9N2_EX_5_SCAN_CAPTUREDR_LONG                                = 0x2A03D000ull;
//DUPS: 2B03D000,
static const uint64_t P9N2_EX_6_SCAN_CAPTUREDR_LONG                                = 0x2C03D000ull;
//DUPS: 2D03D000,
static const uint64_t P9N2_EX_7_SCAN_CAPTUREDR_LONG                                = 0x2F03D000ull;
//DUPS: 2F03D000,
static const uint64_t P9N2_EX_8_SCAN_CAPTUREDR_LONG                                = 0x3003D000ull;
//DUPS: 3103D000,
static const uint64_t P9N2_EX_9_SCAN_CAPTUREDR_LONG                                = 0x3203D000ull;
//DUPS: 3303D000,
static const uint64_t P9N2_EX_10_SCAN_CAPTUREDR_LONG                               = 0x3403D000ull;
//DUPS: 3503D000,
static const uint64_t P9N2_EX_11_SCAN_CAPTUREDR_LONG                               = 0x3603D000ull;
//DUPS: 3703D000,

static const uint64_t P9N2_C_SCAN_LONG_ROTATE                                      = 0x20039000ull;

static const uint64_t P9N2_C_0_SCAN_LONG_ROTATE                                    = 0x20039000ull;

static const uint64_t P9N2_C_1_SCAN_LONG_ROTATE                                    = 0x21039000ull;

static const uint64_t P9N2_C_2_SCAN_LONG_ROTATE                                    = 0x22039000ull;

static const uint64_t P9N2_C_3_SCAN_LONG_ROTATE                                    = 0x23039000ull;

static const uint64_t P9N2_C_4_SCAN_LONG_ROTATE                                    = 0x24039000ull;

static const uint64_t P9N2_C_5_SCAN_LONG_ROTATE                                    = 0x25039000ull;

static const uint64_t P9N2_C_6_SCAN_LONG_ROTATE                                    = 0x26039000ull;

static const uint64_t P9N2_C_7_SCAN_LONG_ROTATE                                    = 0x27039000ull;

static const uint64_t P9N2_C_8_SCAN_LONG_ROTATE                                    = 0x28039000ull;

static const uint64_t P9N2_C_9_SCAN_LONG_ROTATE                                    = 0x29039000ull;

static const uint64_t P9N2_C_10_SCAN_LONG_ROTATE                                   = 0x2A039000ull;

static const uint64_t P9N2_C_11_SCAN_LONG_ROTATE                                   = 0x2B039000ull;

static const uint64_t P9N2_C_12_SCAN_LONG_ROTATE                                   = 0x2C039000ull;

static const uint64_t P9N2_C_13_SCAN_LONG_ROTATE                                   = 0x2D039000ull;

static const uint64_t P9N2_C_14_SCAN_LONG_ROTATE                                   = 0x2E039000ull;

static const uint64_t P9N2_C_15_SCAN_LONG_ROTATE                                   = 0x2F039000ull;

static const uint64_t P9N2_C_16_SCAN_LONG_ROTATE                                   = 0x30039000ull;

static const uint64_t P9N2_C_17_SCAN_LONG_ROTATE                                   = 0x31039000ull;

static const uint64_t P9N2_C_18_SCAN_LONG_ROTATE                                   = 0x32039000ull;

static const uint64_t P9N2_C_19_SCAN_LONG_ROTATE                                   = 0x33039000ull;

static const uint64_t P9N2_C_20_SCAN_LONG_ROTATE                                   = 0x34039000ull;

static const uint64_t P9N2_C_21_SCAN_LONG_ROTATE                                   = 0x35039000ull;

static const uint64_t P9N2_C_22_SCAN_LONG_ROTATE                                   = 0x36039000ull;

static const uint64_t P9N2_C_23_SCAN_LONG_ROTATE                                   = 0x37039000ull;

static const uint64_t P9N2_EQ_SCAN_LONG_ROTATE                                     = 0x10039000ull;

static const uint64_t P9N2_EQ_0_SCAN_LONG_ROTATE                                   = 0x10039000ull;

static const uint64_t P9N2_EQ_1_SCAN_LONG_ROTATE                                   = 0x11039000ull;

static const uint64_t P9N2_EQ_2_SCAN_LONG_ROTATE                                   = 0x12039000ull;

static const uint64_t P9N2_EQ_3_SCAN_LONG_ROTATE                                   = 0x13039000ull;

static const uint64_t P9N2_EQ_4_SCAN_LONG_ROTATE                                   = 0x14039000ull;

static const uint64_t P9N2_EQ_5_SCAN_LONG_ROTATE                                   = 0x15039000ull;

static const uint64_t P9N2_EX_SCAN_LONG_ROTATE                                     = 0x20039000ull;
//DUPS: 21039000,
static const uint64_t P9N2_EX_0_SCAN_LONG_ROTATE                                   = 0x20039000ull;
//DUPS: 21039000,
static const uint64_t P9N2_EX_1_SCAN_LONG_ROTATE                                   = 0x22039000ull;
//DUPS: 23039000,
static const uint64_t P9N2_EX_2_SCAN_LONG_ROTATE                                   = 0x24039000ull;
//DUPS: 25039000,
static const uint64_t P9N2_EX_3_SCAN_LONG_ROTATE                                   = 0x26039000ull;
//DUPS: 27039000,
static const uint64_t P9N2_EX_4_SCAN_LONG_ROTATE                                   = 0x28039000ull;
//DUPS: 29039000,
static const uint64_t P9N2_EX_5_SCAN_LONG_ROTATE                                   = 0x2A039000ull;
//DUPS: 2B039000,
static const uint64_t P9N2_EX_6_SCAN_LONG_ROTATE                                   = 0x2C039000ull;
//DUPS: 2D039000,
static const uint64_t P9N2_EX_7_SCAN_LONG_ROTATE                                   = 0x2F039000ull;
//DUPS: 2F039000,
static const uint64_t P9N2_EX_8_SCAN_LONG_ROTATE                                   = 0x30039000ull;
//DUPS: 31039000,
static const uint64_t P9N2_EX_9_SCAN_LONG_ROTATE                                   = 0x32039000ull;
//DUPS: 33039000,
static const uint64_t P9N2_EX_10_SCAN_LONG_ROTATE                                  = 0x34039000ull;
//DUPS: 35039000,
static const uint64_t P9N2_EX_11_SCAN_LONG_ROTATE                                  = 0x36039000ull;
//DUPS: 37039000,

static const uint64_t P9N2_C_SCAN_REGION_TYPE                                      = 0x20030005ull;

static const uint64_t P9N2_C_0_SCAN_REGION_TYPE                                    = 0x20030005ull;

static const uint64_t P9N2_C_1_SCAN_REGION_TYPE                                    = 0x21030005ull;

static const uint64_t P9N2_C_2_SCAN_REGION_TYPE                                    = 0x22030005ull;

static const uint64_t P9N2_C_3_SCAN_REGION_TYPE                                    = 0x23030005ull;

static const uint64_t P9N2_C_4_SCAN_REGION_TYPE                                    = 0x24030005ull;

static const uint64_t P9N2_C_5_SCAN_REGION_TYPE                                    = 0x25030005ull;

static const uint64_t P9N2_C_6_SCAN_REGION_TYPE                                    = 0x26030005ull;

static const uint64_t P9N2_C_7_SCAN_REGION_TYPE                                    = 0x27030005ull;

static const uint64_t P9N2_C_8_SCAN_REGION_TYPE                                    = 0x28030005ull;

static const uint64_t P9N2_C_9_SCAN_REGION_TYPE                                    = 0x29030005ull;

static const uint64_t P9N2_C_10_SCAN_REGION_TYPE                                   = 0x2A030005ull;

static const uint64_t P9N2_C_11_SCAN_REGION_TYPE                                   = 0x2B030005ull;

static const uint64_t P9N2_C_12_SCAN_REGION_TYPE                                   = 0x2C030005ull;

static const uint64_t P9N2_C_13_SCAN_REGION_TYPE                                   = 0x2D030005ull;

static const uint64_t P9N2_C_14_SCAN_REGION_TYPE                                   = 0x2E030005ull;

static const uint64_t P9N2_C_15_SCAN_REGION_TYPE                                   = 0x2F030005ull;

static const uint64_t P9N2_C_16_SCAN_REGION_TYPE                                   = 0x30030005ull;

static const uint64_t P9N2_C_17_SCAN_REGION_TYPE                                   = 0x31030005ull;

static const uint64_t P9N2_C_18_SCAN_REGION_TYPE                                   = 0x32030005ull;

static const uint64_t P9N2_C_19_SCAN_REGION_TYPE                                   = 0x33030005ull;

static const uint64_t P9N2_C_20_SCAN_REGION_TYPE                                   = 0x34030005ull;

static const uint64_t P9N2_C_21_SCAN_REGION_TYPE                                   = 0x35030005ull;

static const uint64_t P9N2_C_22_SCAN_REGION_TYPE                                   = 0x36030005ull;

static const uint64_t P9N2_C_23_SCAN_REGION_TYPE                                   = 0x37030005ull;

static const uint64_t P9N2_EQ_SCAN_REGION_TYPE                                     = 0x10030005ull;

static const uint64_t P9N2_EQ_0_SCAN_REGION_TYPE                                   = 0x10030005ull;

static const uint64_t P9N2_EQ_1_SCAN_REGION_TYPE                                   = 0x11030005ull;

static const uint64_t P9N2_EQ_2_SCAN_REGION_TYPE                                   = 0x12030005ull;

static const uint64_t P9N2_EQ_3_SCAN_REGION_TYPE                                   = 0x13030005ull;

static const uint64_t P9N2_EQ_4_SCAN_REGION_TYPE                                   = 0x14030005ull;

static const uint64_t P9N2_EQ_5_SCAN_REGION_TYPE                                   = 0x15030005ull;

static const uint64_t P9N2_EX_SCAN_REGION_TYPE                                     = 0x20030005ull;
//DUPS: 21030005,
static const uint64_t P9N2_EX_0_SCAN_REGION_TYPE                                   = 0x20030005ull;
//DUPS: 21030005,
static const uint64_t P9N2_EX_1_SCAN_REGION_TYPE                                   = 0x22030005ull;
//DUPS: 23030005,
static const uint64_t P9N2_EX_2_SCAN_REGION_TYPE                                   = 0x24030005ull;
//DUPS: 25030005,
static const uint64_t P9N2_EX_3_SCAN_REGION_TYPE                                   = 0x26030005ull;
//DUPS: 27030005,
static const uint64_t P9N2_EX_4_SCAN_REGION_TYPE                                   = 0x28030005ull;
//DUPS: 29030005,
static const uint64_t P9N2_EX_5_SCAN_REGION_TYPE                                   = 0x2A030005ull;
//DUPS: 2B030005,
static const uint64_t P9N2_EX_6_SCAN_REGION_TYPE                                   = 0x2C030005ull;
//DUPS: 2D030005,
static const uint64_t P9N2_EX_7_SCAN_REGION_TYPE                                   = 0x2F030005ull;
//DUPS: 2F030005,
static const uint64_t P9N2_EX_8_SCAN_REGION_TYPE                                   = 0x30030005ull;
//DUPS: 31030005,
static const uint64_t P9N2_EX_9_SCAN_REGION_TYPE                                   = 0x32030005ull;
//DUPS: 33030005,
static const uint64_t P9N2_EX_10_SCAN_REGION_TYPE                                  = 0x34030005ull;
//DUPS: 35030005,
static const uint64_t P9N2_EX_11_SCAN_REGION_TYPE                                  = 0x36030005ull;
//DUPS: 37030005,

static const uint64_t P9N2_C_SCAN_UPDATEDR                                         = 0x2003A000ull;

static const uint64_t P9N2_C_0_SCAN_UPDATEDR                                       = 0x2003A000ull;

static const uint64_t P9N2_C_1_SCAN_UPDATEDR                                       = 0x2103A000ull;

static const uint64_t P9N2_C_2_SCAN_UPDATEDR                                       = 0x2203A000ull;

static const uint64_t P9N2_C_3_SCAN_UPDATEDR                                       = 0x2303A000ull;

static const uint64_t P9N2_C_4_SCAN_UPDATEDR                                       = 0x2403A000ull;

static const uint64_t P9N2_C_5_SCAN_UPDATEDR                                       = 0x2503A000ull;

static const uint64_t P9N2_C_6_SCAN_UPDATEDR                                       = 0x2603A000ull;

static const uint64_t P9N2_C_7_SCAN_UPDATEDR                                       = 0x2703A000ull;

static const uint64_t P9N2_C_8_SCAN_UPDATEDR                                       = 0x2803A000ull;

static const uint64_t P9N2_C_9_SCAN_UPDATEDR                                       = 0x2903A000ull;

static const uint64_t P9N2_C_10_SCAN_UPDATEDR                                      = 0x2A03A000ull;

static const uint64_t P9N2_C_11_SCAN_UPDATEDR                                      = 0x2B03A000ull;

static const uint64_t P9N2_C_12_SCAN_UPDATEDR                                      = 0x2C03A000ull;

static const uint64_t P9N2_C_13_SCAN_UPDATEDR                                      = 0x2D03A000ull;

static const uint64_t P9N2_C_14_SCAN_UPDATEDR                                      = 0x2E03A000ull;

static const uint64_t P9N2_C_15_SCAN_UPDATEDR                                      = 0x2F03A000ull;

static const uint64_t P9N2_C_16_SCAN_UPDATEDR                                      = 0x3003A000ull;

static const uint64_t P9N2_C_17_SCAN_UPDATEDR                                      = 0x3103A000ull;

static const uint64_t P9N2_C_18_SCAN_UPDATEDR                                      = 0x3203A000ull;

static const uint64_t P9N2_C_19_SCAN_UPDATEDR                                      = 0x3303A000ull;

static const uint64_t P9N2_C_20_SCAN_UPDATEDR                                      = 0x3403A000ull;

static const uint64_t P9N2_C_21_SCAN_UPDATEDR                                      = 0x3503A000ull;

static const uint64_t P9N2_C_22_SCAN_UPDATEDR                                      = 0x3603A000ull;

static const uint64_t P9N2_C_23_SCAN_UPDATEDR                                      = 0x3703A000ull;

static const uint64_t P9N2_EQ_SCAN_UPDATEDR                                        = 0x1003A000ull;

static const uint64_t P9N2_EQ_0_SCAN_UPDATEDR                                      = 0x1003A000ull;

static const uint64_t P9N2_EQ_1_SCAN_UPDATEDR                                      = 0x1103A000ull;

static const uint64_t P9N2_EQ_2_SCAN_UPDATEDR                                      = 0x1203A000ull;

static const uint64_t P9N2_EQ_3_SCAN_UPDATEDR                                      = 0x1303A000ull;

static const uint64_t P9N2_EQ_4_SCAN_UPDATEDR                                      = 0x1403A000ull;

static const uint64_t P9N2_EQ_5_SCAN_UPDATEDR                                      = 0x1503A000ull;

static const uint64_t P9N2_EX_SCAN_UPDATEDR                                        = 0x2003A000ull;
//DUPS: 2103A000,
static const uint64_t P9N2_EX_0_SCAN_UPDATEDR                                      = 0x2003A000ull;
//DUPS: 2103A000,
static const uint64_t P9N2_EX_1_SCAN_UPDATEDR                                      = 0x2203A000ull;
//DUPS: 2303A000,
static const uint64_t P9N2_EX_2_SCAN_UPDATEDR                                      = 0x2403A000ull;
//DUPS: 2503A000,
static const uint64_t P9N2_EX_3_SCAN_UPDATEDR                                      = 0x2603A000ull;
//DUPS: 2703A000,
static const uint64_t P9N2_EX_4_SCAN_UPDATEDR                                      = 0x2803A000ull;
//DUPS: 2903A000,
static const uint64_t P9N2_EX_5_SCAN_UPDATEDR                                      = 0x2A03A000ull;
//DUPS: 2B03A000,
static const uint64_t P9N2_EX_6_SCAN_UPDATEDR                                      = 0x2C03A000ull;
//DUPS: 2D03A000,
static const uint64_t P9N2_EX_7_SCAN_UPDATEDR                                      = 0x2F03A000ull;
//DUPS: 2F03A000,
static const uint64_t P9N2_EX_8_SCAN_UPDATEDR                                      = 0x3003A000ull;
//DUPS: 3103A000,
static const uint64_t P9N2_EX_9_SCAN_UPDATEDR                                      = 0x3203A000ull;
//DUPS: 3303A000,
static const uint64_t P9N2_EX_10_SCAN_UPDATEDR                                     = 0x3403A000ull;
//DUPS: 3503A000,
static const uint64_t P9N2_EX_11_SCAN_UPDATEDR                                     = 0x3603A000ull;
//DUPS: 3703A000,

static const uint64_t P9N2_C_SCAN_UPDATEDR_LONG                                    = 0x2003B000ull;

static const uint64_t P9N2_C_0_SCAN_UPDATEDR_LONG                                  = 0x2003B000ull;

static const uint64_t P9N2_C_1_SCAN_UPDATEDR_LONG                                  = 0x2103B000ull;

static const uint64_t P9N2_C_2_SCAN_UPDATEDR_LONG                                  = 0x2203B000ull;

static const uint64_t P9N2_C_3_SCAN_UPDATEDR_LONG                                  = 0x2303B000ull;

static const uint64_t P9N2_C_4_SCAN_UPDATEDR_LONG                                  = 0x2403B000ull;

static const uint64_t P9N2_C_5_SCAN_UPDATEDR_LONG                                  = 0x2503B000ull;

static const uint64_t P9N2_C_6_SCAN_UPDATEDR_LONG                                  = 0x2603B000ull;

static const uint64_t P9N2_C_7_SCAN_UPDATEDR_LONG                                  = 0x2703B000ull;

static const uint64_t P9N2_C_8_SCAN_UPDATEDR_LONG                                  = 0x2803B000ull;

static const uint64_t P9N2_C_9_SCAN_UPDATEDR_LONG                                  = 0x2903B000ull;

static const uint64_t P9N2_C_10_SCAN_UPDATEDR_LONG                                 = 0x2A03B000ull;

static const uint64_t P9N2_C_11_SCAN_UPDATEDR_LONG                                 = 0x2B03B000ull;

static const uint64_t P9N2_C_12_SCAN_UPDATEDR_LONG                                 = 0x2C03B000ull;

static const uint64_t P9N2_C_13_SCAN_UPDATEDR_LONG                                 = 0x2D03B000ull;

static const uint64_t P9N2_C_14_SCAN_UPDATEDR_LONG                                 = 0x2E03B000ull;

static const uint64_t P9N2_C_15_SCAN_UPDATEDR_LONG                                 = 0x2F03B000ull;

static const uint64_t P9N2_C_16_SCAN_UPDATEDR_LONG                                 = 0x3003B000ull;

static const uint64_t P9N2_C_17_SCAN_UPDATEDR_LONG                                 = 0x3103B000ull;

static const uint64_t P9N2_C_18_SCAN_UPDATEDR_LONG                                 = 0x3203B000ull;

static const uint64_t P9N2_C_19_SCAN_UPDATEDR_LONG                                 = 0x3303B000ull;

static const uint64_t P9N2_C_20_SCAN_UPDATEDR_LONG                                 = 0x3403B000ull;

static const uint64_t P9N2_C_21_SCAN_UPDATEDR_LONG                                 = 0x3503B000ull;

static const uint64_t P9N2_C_22_SCAN_UPDATEDR_LONG                                 = 0x3603B000ull;

static const uint64_t P9N2_C_23_SCAN_UPDATEDR_LONG                                 = 0x3703B000ull;

static const uint64_t P9N2_EQ_SCAN_UPDATEDR_LONG                                   = 0x1003B000ull;

static const uint64_t P9N2_EQ_0_SCAN_UPDATEDR_LONG                                 = 0x1003B000ull;

static const uint64_t P9N2_EQ_1_SCAN_UPDATEDR_LONG                                 = 0x1103B000ull;

static const uint64_t P9N2_EQ_2_SCAN_UPDATEDR_LONG                                 = 0x1203B000ull;

static const uint64_t P9N2_EQ_3_SCAN_UPDATEDR_LONG                                 = 0x1303B000ull;

static const uint64_t P9N2_EQ_4_SCAN_UPDATEDR_LONG                                 = 0x1403B000ull;

static const uint64_t P9N2_EQ_5_SCAN_UPDATEDR_LONG                                 = 0x1503B000ull;

static const uint64_t P9N2_EX_SCAN_UPDATEDR_LONG                                   = 0x2003B000ull;
//DUPS: 2103B000,
static const uint64_t P9N2_EX_0_SCAN_UPDATEDR_LONG                                 = 0x2003B000ull;
//DUPS: 2103B000,
static const uint64_t P9N2_EX_1_SCAN_UPDATEDR_LONG                                 = 0x2203B000ull;
//DUPS: 2303B000,
static const uint64_t P9N2_EX_2_SCAN_UPDATEDR_LONG                                 = 0x2403B000ull;
//DUPS: 2503B000,
static const uint64_t P9N2_EX_3_SCAN_UPDATEDR_LONG                                 = 0x2603B000ull;
//DUPS: 2703B000,
static const uint64_t P9N2_EX_4_SCAN_UPDATEDR_LONG                                 = 0x2803B000ull;
//DUPS: 2903B000,
static const uint64_t P9N2_EX_5_SCAN_UPDATEDR_LONG                                 = 0x2A03B000ull;
//DUPS: 2B03B000,
static const uint64_t P9N2_EX_6_SCAN_UPDATEDR_LONG                                 = 0x2C03B000ull;
//DUPS: 2D03B000,
static const uint64_t P9N2_EX_7_SCAN_UPDATEDR_LONG                                 = 0x2F03B000ull;
//DUPS: 2F03B000,
static const uint64_t P9N2_EX_8_SCAN_UPDATEDR_LONG                                 = 0x3003B000ull;
//DUPS: 3103B000,
static const uint64_t P9N2_EX_9_SCAN_UPDATEDR_LONG                                 = 0x3203B000ull;
//DUPS: 3303B000,
static const uint64_t P9N2_EX_10_SCAN_UPDATEDR_LONG                                = 0x3403B000ull;
//DUPS: 3503B000,
static const uint64_t P9N2_EX_11_SCAN_UPDATEDR_LONG                                = 0x3603B000ull;
//DUPS: 3703B000,

static const uint64_t P9N2_C_SCOMC                                                 = 0x20010A80ull;

static const uint64_t P9N2_C_0_SCOMC                                               = 0x20010A80ull;

static const uint64_t P9N2_C_1_SCOMC                                               = 0x21010A80ull;

static const uint64_t P9N2_C_2_SCOMC                                               = 0x22010A80ull;

static const uint64_t P9N2_C_3_SCOMC                                               = 0x23010A80ull;

static const uint64_t P9N2_C_4_SCOMC                                               = 0x24010A80ull;

static const uint64_t P9N2_C_5_SCOMC                                               = 0x25010A80ull;

static const uint64_t P9N2_C_6_SCOMC                                               = 0x26010A80ull;

static const uint64_t P9N2_C_7_SCOMC                                               = 0x27010A80ull;

static const uint64_t P9N2_C_8_SCOMC                                               = 0x28010A80ull;

static const uint64_t P9N2_C_9_SCOMC                                               = 0x29010A80ull;

static const uint64_t P9N2_C_10_SCOMC                                              = 0x2A010A80ull;

static const uint64_t P9N2_C_11_SCOMC                                              = 0x2B010A80ull;

static const uint64_t P9N2_C_12_SCOMC                                              = 0x2C010A80ull;

static const uint64_t P9N2_C_13_SCOMC                                              = 0x2D010A80ull;

static const uint64_t P9N2_C_14_SCOMC                                              = 0x2E010A80ull;

static const uint64_t P9N2_C_15_SCOMC                                              = 0x2F010A80ull;

static const uint64_t P9N2_C_16_SCOMC                                              = 0x30010A80ull;

static const uint64_t P9N2_C_17_SCOMC                                              = 0x31010A80ull;

static const uint64_t P9N2_C_18_SCOMC                                              = 0x32010A80ull;

static const uint64_t P9N2_C_19_SCOMC                                              = 0x33010A80ull;

static const uint64_t P9N2_C_20_SCOMC                                              = 0x34010A80ull;

static const uint64_t P9N2_C_21_SCOMC                                              = 0x35010A80ull;

static const uint64_t P9N2_C_22_SCOMC                                              = 0x36010A80ull;

static const uint64_t P9N2_C_23_SCOMC                                              = 0x37010A80ull;

static const uint64_t P9N2_EX_0_L2_SCOMC                                           = 0x20010A80ull;
//DUPS: 20010A80,
static const uint64_t P9N2_EX_10_L2_SCOMC                                          = 0x34010A80ull;
//DUPS: 34010A80,
static const uint64_t P9N2_EX_11_L2_SCOMC                                          = 0x36010A80ull;
//DUPS: 36010A80,
static const uint64_t P9N2_EX_1_L2_SCOMC                                           = 0x22010A80ull;
//DUPS: 22010A80,
static const uint64_t P9N2_EX_2_L2_SCOMC                                           = 0x24010A80ull;
//DUPS: 24010A80,
static const uint64_t P9N2_EX_3_L2_SCOMC                                           = 0x26010A80ull;
//DUPS: 26010A80,
static const uint64_t P9N2_EX_4_L2_SCOMC                                           = 0x28010A80ull;
//DUPS: 28010A80,
static const uint64_t P9N2_EX_5_L2_SCOMC                                           = 0x2B010A80ull;
//DUPS: 2A010A80,
static const uint64_t P9N2_EX_6_L2_SCOMC                                           = 0x2D010A80ull;
//DUPS: 2C010A80,
static const uint64_t P9N2_EX_7_L2_SCOMC                                           = 0x2F010A80ull;
//DUPS: 2E010A80,
static const uint64_t P9N2_EX_8_L2_SCOMC                                           = 0x30010A80ull;
//DUPS: 30010A80,
static const uint64_t P9N2_EX_9_L2_SCOMC                                           = 0x32010A80ull;
//DUPS: 32010A80,
static const uint64_t P9N2_EX_L2_SCOMC                                             = 0x20010A80ull;
//DUPS: 20010A80,

static const uint64_t P9N2_C_SCOMD                                                 = 0x20010A81ull;

static const uint64_t P9N2_C_0_SCOMD                                               = 0x20010A81ull;

static const uint64_t P9N2_C_1_SCOMD                                               = 0x21010A81ull;

static const uint64_t P9N2_C_2_SCOMD                                               = 0x22010A81ull;

static const uint64_t P9N2_C_3_SCOMD                                               = 0x23010A81ull;

static const uint64_t P9N2_C_4_SCOMD                                               = 0x24010A81ull;

static const uint64_t P9N2_C_5_SCOMD                                               = 0x25010A81ull;

static const uint64_t P9N2_C_6_SCOMD                                               = 0x26010A81ull;

static const uint64_t P9N2_C_7_SCOMD                                               = 0x27010A81ull;

static const uint64_t P9N2_C_8_SCOMD                                               = 0x28010A81ull;

static const uint64_t P9N2_C_9_SCOMD                                               = 0x29010A81ull;

static const uint64_t P9N2_C_10_SCOMD                                              = 0x2A010A81ull;

static const uint64_t P9N2_C_11_SCOMD                                              = 0x2B010A81ull;

static const uint64_t P9N2_C_12_SCOMD                                              = 0x2C010A81ull;

static const uint64_t P9N2_C_13_SCOMD                                              = 0x2D010A81ull;

static const uint64_t P9N2_C_14_SCOMD                                              = 0x2E010A81ull;

static const uint64_t P9N2_C_15_SCOMD                                              = 0x2F010A81ull;

static const uint64_t P9N2_C_16_SCOMD                                              = 0x30010A81ull;

static const uint64_t P9N2_C_17_SCOMD                                              = 0x31010A81ull;

static const uint64_t P9N2_C_18_SCOMD                                              = 0x32010A81ull;

static const uint64_t P9N2_C_19_SCOMD                                              = 0x33010A81ull;

static const uint64_t P9N2_C_20_SCOMD                                              = 0x34010A81ull;

static const uint64_t P9N2_C_21_SCOMD                                              = 0x35010A81ull;

static const uint64_t P9N2_C_22_SCOMD                                              = 0x36010A81ull;

static const uint64_t P9N2_C_23_SCOMD                                              = 0x37010A81ull;

static const uint64_t P9N2_EX_0_L2_SCOMD                                           = 0x20010A81ull;
//DUPS: 20010A81,
static const uint64_t P9N2_EX_10_L2_SCOMD                                          = 0x34010A81ull;
//DUPS: 34010A81,
static const uint64_t P9N2_EX_11_L2_SCOMD                                          = 0x36010A81ull;
//DUPS: 36010A81,
static const uint64_t P9N2_EX_1_L2_SCOMD                                           = 0x22010A81ull;
//DUPS: 22010A81,
static const uint64_t P9N2_EX_2_L2_SCOMD                                           = 0x24010A81ull;
//DUPS: 24010A81,
static const uint64_t P9N2_EX_3_L2_SCOMD                                           = 0x26010A81ull;
//DUPS: 26010A81,
static const uint64_t P9N2_EX_4_L2_SCOMD                                           = 0x28010A81ull;
//DUPS: 28010A81,
static const uint64_t P9N2_EX_5_L2_SCOMD                                           = 0x2B010A81ull;
//DUPS: 2A010A81,
static const uint64_t P9N2_EX_6_L2_SCOMD                                           = 0x2D010A81ull;
//DUPS: 2C010A81,
static const uint64_t P9N2_EX_7_L2_SCOMD                                           = 0x2F010A81ull;
//DUPS: 2E010A81,
static const uint64_t P9N2_EX_8_L2_SCOMD                                           = 0x30010A81ull;
//DUPS: 30010A81,
static const uint64_t P9N2_EX_9_L2_SCOMD                                           = 0x32010A81ull;
//DUPS: 32010A81,
static const uint64_t P9N2_EX_L2_SCOMD                                             = 0x20010A81ull;
//DUPS: 20010A81,

static const uint64_t P9N2_C_SCR0                                                  = 0x20010A86ull;

static const uint64_t P9N2_C_0_SCR0                                                = 0x20010A86ull;

static const uint64_t P9N2_C_1_SCR0                                                = 0x21010A86ull;

static const uint64_t P9N2_C_2_SCR0                                                = 0x22010A86ull;

static const uint64_t P9N2_C_3_SCR0                                                = 0x23010A86ull;

static const uint64_t P9N2_C_4_SCR0                                                = 0x24010A86ull;

static const uint64_t P9N2_C_5_SCR0                                                = 0x25010A86ull;

static const uint64_t P9N2_C_6_SCR0                                                = 0x26010A86ull;

static const uint64_t P9N2_C_7_SCR0                                                = 0x27010A86ull;

static const uint64_t P9N2_C_8_SCR0                                                = 0x28010A86ull;

static const uint64_t P9N2_C_9_SCR0                                                = 0x29010A86ull;

static const uint64_t P9N2_C_10_SCR0                                               = 0x2A010A86ull;

static const uint64_t P9N2_C_11_SCR0                                               = 0x2B010A86ull;

static const uint64_t P9N2_C_12_SCR0                                               = 0x2C010A86ull;

static const uint64_t P9N2_C_13_SCR0                                               = 0x2D010A86ull;

static const uint64_t P9N2_C_14_SCR0                                               = 0x2E010A86ull;

static const uint64_t P9N2_C_15_SCR0                                               = 0x2F010A86ull;

static const uint64_t P9N2_C_16_SCR0                                               = 0x30010A86ull;

static const uint64_t P9N2_C_17_SCR0                                               = 0x31010A86ull;

static const uint64_t P9N2_C_18_SCR0                                               = 0x32010A86ull;

static const uint64_t P9N2_C_19_SCR0                                               = 0x33010A86ull;

static const uint64_t P9N2_C_20_SCR0                                               = 0x34010A86ull;

static const uint64_t P9N2_C_21_SCR0                                               = 0x35010A86ull;

static const uint64_t P9N2_C_22_SCR0                                               = 0x36010A86ull;

static const uint64_t P9N2_C_23_SCR0                                               = 0x37010A86ull;

static const uint64_t P9N2_EX_0_L2_SCR0                                            = 0x20010A86ull;
//DUPS: 20010A86,
static const uint64_t P9N2_EX_10_L2_SCR0                                           = 0x34010A86ull;
//DUPS: 34010A86,
static const uint64_t P9N2_EX_11_L2_SCR0                                           = 0x36010A86ull;
//DUPS: 36010A86,
static const uint64_t P9N2_EX_1_L2_SCR0                                            = 0x22010A86ull;
//DUPS: 22010A86,
static const uint64_t P9N2_EX_2_L2_SCR0                                            = 0x24010A86ull;
//DUPS: 24010A86,
static const uint64_t P9N2_EX_3_L2_SCR0                                            = 0x26010A86ull;
//DUPS: 26010A86,
static const uint64_t P9N2_EX_4_L2_SCR0                                            = 0x28010A86ull;
//DUPS: 28010A86,
static const uint64_t P9N2_EX_5_L2_SCR0                                            = 0x2B010A86ull;
//DUPS: 2A010A86,
static const uint64_t P9N2_EX_6_L2_SCR0                                            = 0x2D010A86ull;
//DUPS: 2C010A86,
static const uint64_t P9N2_EX_7_L2_SCR0                                            = 0x2F010A86ull;
//DUPS: 2E010A86,
static const uint64_t P9N2_EX_8_L2_SCR0                                            = 0x30010A86ull;
//DUPS: 30010A86,
static const uint64_t P9N2_EX_9_L2_SCR0                                            = 0x32010A86ull;
//DUPS: 32010A86,
static const uint64_t P9N2_EX_L2_SCR0                                              = 0x20010A86ull;
//DUPS: 20010A86,

static const uint64_t P9N2_C_SCR1                                                  = 0x20010A87ull;

static const uint64_t P9N2_C_0_SCR1                                                = 0x20010A87ull;

static const uint64_t P9N2_C_1_SCR1                                                = 0x21010A87ull;

static const uint64_t P9N2_C_2_SCR1                                                = 0x22010A87ull;

static const uint64_t P9N2_C_3_SCR1                                                = 0x23010A87ull;

static const uint64_t P9N2_C_4_SCR1                                                = 0x24010A87ull;

static const uint64_t P9N2_C_5_SCR1                                                = 0x25010A87ull;

static const uint64_t P9N2_C_6_SCR1                                                = 0x26010A87ull;

static const uint64_t P9N2_C_7_SCR1                                                = 0x27010A87ull;

static const uint64_t P9N2_C_8_SCR1                                                = 0x28010A87ull;

static const uint64_t P9N2_C_9_SCR1                                                = 0x29010A87ull;

static const uint64_t P9N2_C_10_SCR1                                               = 0x2A010A87ull;

static const uint64_t P9N2_C_11_SCR1                                               = 0x2B010A87ull;

static const uint64_t P9N2_C_12_SCR1                                               = 0x2C010A87ull;

static const uint64_t P9N2_C_13_SCR1                                               = 0x2D010A87ull;

static const uint64_t P9N2_C_14_SCR1                                               = 0x2E010A87ull;

static const uint64_t P9N2_C_15_SCR1                                               = 0x2F010A87ull;

static const uint64_t P9N2_C_16_SCR1                                               = 0x30010A87ull;

static const uint64_t P9N2_C_17_SCR1                                               = 0x31010A87ull;

static const uint64_t P9N2_C_18_SCR1                                               = 0x32010A87ull;

static const uint64_t P9N2_C_19_SCR1                                               = 0x33010A87ull;

static const uint64_t P9N2_C_20_SCR1                                               = 0x34010A87ull;

static const uint64_t P9N2_C_21_SCR1                                               = 0x35010A87ull;

static const uint64_t P9N2_C_22_SCR1                                               = 0x36010A87ull;

static const uint64_t P9N2_C_23_SCR1                                               = 0x37010A87ull;

static const uint64_t P9N2_EX_0_L2_SCR1                                            = 0x20010A87ull;
//DUPS: 20010A87,
static const uint64_t P9N2_EX_10_L2_SCR1                                           = 0x34010A87ull;
//DUPS: 34010A87,
static const uint64_t P9N2_EX_11_L2_SCR1                                           = 0x36010A87ull;
//DUPS: 36010A87,
static const uint64_t P9N2_EX_1_L2_SCR1                                            = 0x22010A87ull;
//DUPS: 22010A87,
static const uint64_t P9N2_EX_2_L2_SCR1                                            = 0x24010A87ull;
//DUPS: 24010A87,
static const uint64_t P9N2_EX_3_L2_SCR1                                            = 0x26010A87ull;
//DUPS: 26010A87,
static const uint64_t P9N2_EX_4_L2_SCR1                                            = 0x28010A87ull;
//DUPS: 28010A87,
static const uint64_t P9N2_EX_5_L2_SCR1                                            = 0x2B010A87ull;
//DUPS: 2A010A87,
static const uint64_t P9N2_EX_6_L2_SCR1                                            = 0x2D010A87ull;
//DUPS: 2C010A87,
static const uint64_t P9N2_EX_7_L2_SCR1                                            = 0x2F010A87ull;
//DUPS: 2E010A87,
static const uint64_t P9N2_EX_8_L2_SCR1                                            = 0x30010A87ull;
//DUPS: 30010A87,
static const uint64_t P9N2_EX_9_L2_SCR1                                            = 0x32010A87ull;
//DUPS: 32010A87,
static const uint64_t P9N2_EX_L2_SCR1                                              = 0x20010A87ull;
//DUPS: 20010A87,

static const uint64_t P9N2_C_SCR2                                                  = 0x20010A88ull;

static const uint64_t P9N2_C_0_SCR2                                                = 0x20010A88ull;

static const uint64_t P9N2_C_1_SCR2                                                = 0x21010A88ull;

static const uint64_t P9N2_C_2_SCR2                                                = 0x22010A88ull;

static const uint64_t P9N2_C_3_SCR2                                                = 0x23010A88ull;

static const uint64_t P9N2_C_4_SCR2                                                = 0x24010A88ull;

static const uint64_t P9N2_C_5_SCR2                                                = 0x25010A88ull;

static const uint64_t P9N2_C_6_SCR2                                                = 0x26010A88ull;

static const uint64_t P9N2_C_7_SCR2                                                = 0x27010A88ull;

static const uint64_t P9N2_C_8_SCR2                                                = 0x28010A88ull;

static const uint64_t P9N2_C_9_SCR2                                                = 0x29010A88ull;

static const uint64_t P9N2_C_10_SCR2                                               = 0x2A010A88ull;

static const uint64_t P9N2_C_11_SCR2                                               = 0x2B010A88ull;

static const uint64_t P9N2_C_12_SCR2                                               = 0x2C010A88ull;

static const uint64_t P9N2_C_13_SCR2                                               = 0x2D010A88ull;

static const uint64_t P9N2_C_14_SCR2                                               = 0x2E010A88ull;

static const uint64_t P9N2_C_15_SCR2                                               = 0x2F010A88ull;

static const uint64_t P9N2_C_16_SCR2                                               = 0x30010A88ull;

static const uint64_t P9N2_C_17_SCR2                                               = 0x31010A88ull;

static const uint64_t P9N2_C_18_SCR2                                               = 0x32010A88ull;

static const uint64_t P9N2_C_19_SCR2                                               = 0x33010A88ull;

static const uint64_t P9N2_C_20_SCR2                                               = 0x34010A88ull;

static const uint64_t P9N2_C_21_SCR2                                               = 0x35010A88ull;

static const uint64_t P9N2_C_22_SCR2                                               = 0x36010A88ull;

static const uint64_t P9N2_C_23_SCR2                                               = 0x37010A88ull;

static const uint64_t P9N2_EX_SCR2                                                 = 0x20010A88ull;
//DUPS: 20010A88,
static const uint64_t P9N2_EX_0_SCR2                                               = 0x20010A88ull;
//DUPS: 20010A88,
static const uint64_t P9N2_EX_1_SCR2                                               = 0x22010A88ull;
//DUPS: 22010A88,
static const uint64_t P9N2_EX_2_SCR2                                               = 0x24010A88ull;
//DUPS: 24010A88,
static const uint64_t P9N2_EX_3_SCR2                                               = 0x26010A88ull;
//DUPS: 26010A88,
static const uint64_t P9N2_EX_4_SCR2                                               = 0x28010A88ull;
//DUPS: 28010A88,
static const uint64_t P9N2_EX_5_SCR2                                               = 0x2B010A88ull;
//DUPS: 2A010A88,
static const uint64_t P9N2_EX_6_SCR2                                               = 0x2D010A88ull;
//DUPS: 2C010A88,
static const uint64_t P9N2_EX_7_SCR2                                               = 0x2F010A88ull;
//DUPS: 2E010A88,
static const uint64_t P9N2_EX_8_SCR2                                               = 0x30010A88ull;
//DUPS: 30010A88,
static const uint64_t P9N2_EX_9_SCR2                                               = 0x32010A88ull;
//DUPS: 32010A88,
static const uint64_t P9N2_EX_10_SCR2                                              = 0x34010A88ull;
//DUPS: 34010A88,
static const uint64_t P9N2_EX_11_SCR2                                              = 0x36010A88ull;
//DUPS: 36010A88,

static const uint64_t P9N2_C_SCR3                                                  = 0x20010A89ull;

static const uint64_t P9N2_C_0_SCR3                                                = 0x20010A89ull;

static const uint64_t P9N2_C_1_SCR3                                                = 0x21010A89ull;

static const uint64_t P9N2_C_2_SCR3                                                = 0x22010A89ull;

static const uint64_t P9N2_C_3_SCR3                                                = 0x23010A89ull;

static const uint64_t P9N2_C_4_SCR3                                                = 0x24010A89ull;

static const uint64_t P9N2_C_5_SCR3                                                = 0x25010A89ull;

static const uint64_t P9N2_C_6_SCR3                                                = 0x26010A89ull;

static const uint64_t P9N2_C_7_SCR3                                                = 0x27010A89ull;

static const uint64_t P9N2_C_8_SCR3                                                = 0x28010A89ull;

static const uint64_t P9N2_C_9_SCR3                                                = 0x29010A89ull;

static const uint64_t P9N2_C_10_SCR3                                               = 0x2A010A89ull;

static const uint64_t P9N2_C_11_SCR3                                               = 0x2B010A89ull;

static const uint64_t P9N2_C_12_SCR3                                               = 0x2C010A89ull;

static const uint64_t P9N2_C_13_SCR3                                               = 0x2D010A89ull;

static const uint64_t P9N2_C_14_SCR3                                               = 0x2E010A89ull;

static const uint64_t P9N2_C_15_SCR3                                               = 0x2F010A89ull;

static const uint64_t P9N2_C_16_SCR3                                               = 0x30010A89ull;

static const uint64_t P9N2_C_17_SCR3                                               = 0x31010A89ull;

static const uint64_t P9N2_C_18_SCR3                                               = 0x32010A89ull;

static const uint64_t P9N2_C_19_SCR3                                               = 0x33010A89ull;

static const uint64_t P9N2_C_20_SCR3                                               = 0x34010A89ull;

static const uint64_t P9N2_C_21_SCR3                                               = 0x35010A89ull;

static const uint64_t P9N2_C_22_SCR3                                               = 0x36010A89ull;

static const uint64_t P9N2_C_23_SCR3                                               = 0x37010A89ull;

static const uint64_t P9N2_EX_SCR3                                                 = 0x20010A89ull;
//DUPS: 20010A89,
static const uint64_t P9N2_EX_0_SCR3                                               = 0x20010A89ull;
//DUPS: 20010A89,
static const uint64_t P9N2_EX_1_SCR3                                               = 0x22010A89ull;
//DUPS: 22010A89,
static const uint64_t P9N2_EX_2_SCR3                                               = 0x24010A89ull;
//DUPS: 24010A89,
static const uint64_t P9N2_EX_3_SCR3                                               = 0x26010A89ull;
//DUPS: 26010A89,
static const uint64_t P9N2_EX_4_SCR3                                               = 0x28010A89ull;
//DUPS: 28010A89,
static const uint64_t P9N2_EX_5_SCR3                                               = 0x2B010A89ull;
//DUPS: 2A010A89,
static const uint64_t P9N2_EX_6_SCR3                                               = 0x2D010A89ull;
//DUPS: 2C010A89,
static const uint64_t P9N2_EX_7_SCR3                                               = 0x2F010A89ull;
//DUPS: 2E010A89,
static const uint64_t P9N2_EX_8_SCR3                                               = 0x30010A89ull;
//DUPS: 30010A89,
static const uint64_t P9N2_EX_9_SCR3                                               = 0x32010A89ull;
//DUPS: 32010A89,
static const uint64_t P9N2_EX_10_SCR3                                              = 0x34010A89ull;
//DUPS: 34010A89,
static const uint64_t P9N2_EX_11_SCR3                                              = 0x36010A89ull;
//DUPS: 36010A89,

static const uint64_t P9N2_C_SHID0                                                 = 0x20010AA5ull;

static const uint64_t P9N2_C_0_SHID0                                               = 0x20010AA5ull;

static const uint64_t P9N2_C_1_SHID0                                               = 0x21010AA5ull;

static const uint64_t P9N2_C_2_SHID0                                               = 0x22010AA5ull;

static const uint64_t P9N2_C_3_SHID0                                               = 0x23010AA5ull;

static const uint64_t P9N2_C_4_SHID0                                               = 0x24010AA5ull;

static const uint64_t P9N2_C_5_SHID0                                               = 0x25010AA5ull;

static const uint64_t P9N2_C_6_SHID0                                               = 0x26010AA5ull;

static const uint64_t P9N2_C_7_SHID0                                               = 0x27010AA5ull;

static const uint64_t P9N2_C_8_SHID0                                               = 0x28010AA5ull;

static const uint64_t P9N2_C_9_SHID0                                               = 0x29010AA5ull;

static const uint64_t P9N2_C_10_SHID0                                              = 0x2A010AA5ull;

static const uint64_t P9N2_C_11_SHID0                                              = 0x2B010AA5ull;

static const uint64_t P9N2_C_12_SHID0                                              = 0x2C010AA5ull;

static const uint64_t P9N2_C_13_SHID0                                              = 0x2D010AA5ull;

static const uint64_t P9N2_C_14_SHID0                                              = 0x2E010AA5ull;

static const uint64_t P9N2_C_15_SHID0                                              = 0x2F010AA5ull;

static const uint64_t P9N2_C_16_SHID0                                              = 0x30010AA5ull;

static const uint64_t P9N2_C_17_SHID0                                              = 0x31010AA5ull;

static const uint64_t P9N2_C_18_SHID0                                              = 0x32010AA5ull;

static const uint64_t P9N2_C_19_SHID0                                              = 0x33010AA5ull;

static const uint64_t P9N2_C_20_SHID0                                              = 0x34010AA5ull;

static const uint64_t P9N2_C_21_SHID0                                              = 0x35010AA5ull;

static const uint64_t P9N2_C_22_SHID0                                              = 0x36010AA5ull;

static const uint64_t P9N2_C_23_SHID0                                              = 0x37010AA5ull;

static const uint64_t P9N2_EX_0_L2_SHID0                                           = 0x20010AA5ull;
//DUPS: 21010AA5,
static const uint64_t P9N2_EX_10_L2_SHID0                                          = 0x34010AA5ull;
//DUPS: 35010AA5,
static const uint64_t P9N2_EX_11_L2_SHID0                                          = 0x36010AA5ull;
//DUPS: 37010AA5,
static const uint64_t P9N2_EX_1_L2_SHID0                                           = 0x22010AA5ull;
//DUPS: 23010AA5,
static const uint64_t P9N2_EX_2_L2_SHID0                                           = 0x24010AA5ull;
//DUPS: 25010AA5,
static const uint64_t P9N2_EX_3_L2_SHID0                                           = 0x26010AA5ull;
//DUPS: 27010AA5,
static const uint64_t P9N2_EX_4_L2_SHID0                                           = 0x28010AA5ull;
//DUPS: 29010AA5,
static const uint64_t P9N2_EX_5_L2_SHID0                                           = 0x2A010AA5ull;
//DUPS: 2B010AA5,
static const uint64_t P9N2_EX_6_L2_SHID0                                           = 0x2C010AA5ull;
//DUPS: 2D010AA5,
static const uint64_t P9N2_EX_7_L2_SHID0                                           = 0x2F010AA5ull;
//DUPS: 2F010AA5,
static const uint64_t P9N2_EX_8_L2_SHID0                                           = 0x30010AA5ull;
//DUPS: 31010AA5,
static const uint64_t P9N2_EX_9_L2_SHID0                                           = 0x32010AA5ull;
//DUPS: 33010AA5,
static const uint64_t P9N2_EX_L2_SHID0                                             = 0x20010AA5ull;
//DUPS: 21010AA5,

static const uint64_t P9N2_C_SIER_MASK                                             = 0x20010AAEull;

static const uint64_t P9N2_C_0_SIER_MASK                                           = 0x20010AAEull;

static const uint64_t P9N2_C_1_SIER_MASK                                           = 0x21010AAEull;

static const uint64_t P9N2_C_2_SIER_MASK                                           = 0x22010AAEull;

static const uint64_t P9N2_C_3_SIER_MASK                                           = 0x23010AAEull;

static const uint64_t P9N2_C_4_SIER_MASK                                           = 0x24010AAEull;

static const uint64_t P9N2_C_5_SIER_MASK                                           = 0x25010AAEull;

static const uint64_t P9N2_C_6_SIER_MASK                                           = 0x26010AAEull;

static const uint64_t P9N2_C_7_SIER_MASK                                           = 0x27010AAEull;

static const uint64_t P9N2_C_8_SIER_MASK                                           = 0x28010AAEull;

static const uint64_t P9N2_C_9_SIER_MASK                                           = 0x29010AAEull;

static const uint64_t P9N2_C_10_SIER_MASK                                          = 0x2A010AAEull;

static const uint64_t P9N2_C_11_SIER_MASK                                          = 0x2B010AAEull;

static const uint64_t P9N2_C_12_SIER_MASK                                          = 0x2C010AAEull;

static const uint64_t P9N2_C_13_SIER_MASK                                          = 0x2D010AAEull;

static const uint64_t P9N2_C_14_SIER_MASK                                          = 0x2E010AAEull;

static const uint64_t P9N2_C_15_SIER_MASK                                          = 0x2F010AAEull;

static const uint64_t P9N2_C_16_SIER_MASK                                          = 0x30010AAEull;

static const uint64_t P9N2_C_17_SIER_MASK                                          = 0x31010AAEull;

static const uint64_t P9N2_C_18_SIER_MASK                                          = 0x32010AAEull;

static const uint64_t P9N2_C_19_SIER_MASK                                          = 0x33010AAEull;

static const uint64_t P9N2_C_20_SIER_MASK                                          = 0x34010AAEull;

static const uint64_t P9N2_C_21_SIER_MASK                                          = 0x35010AAEull;

static const uint64_t P9N2_C_22_SIER_MASK                                          = 0x36010AAEull;

static const uint64_t P9N2_C_23_SIER_MASK                                          = 0x37010AAEull;

static const uint64_t P9N2_EX_SIER_MASK                                            = 0x20010AAEull;
//DUPS: 21010AAE,
static const uint64_t P9N2_EX_0_SIER_MASK                                          = 0x20010AAEull;
//DUPS: 21010AAE,
static const uint64_t P9N2_EX_1_SIER_MASK                                          = 0x22010AAEull;
//DUPS: 23010AAE,
static const uint64_t P9N2_EX_2_SIER_MASK                                          = 0x24010AAEull;
//DUPS: 25010AAE,
static const uint64_t P9N2_EX_3_SIER_MASK                                          = 0x26010AAEull;
//DUPS: 27010AAE,
static const uint64_t P9N2_EX_4_SIER_MASK                                          = 0x28010AAEull;
//DUPS: 29010AAE,
static const uint64_t P9N2_EX_5_SIER_MASK                                          = 0x2A010AAEull;
//DUPS: 2B010AAE,
static const uint64_t P9N2_EX_6_SIER_MASK                                          = 0x2C010AAEull;
//DUPS: 2D010AAE,
static const uint64_t P9N2_EX_7_SIER_MASK                                          = 0x2F010AAEull;
//DUPS: 2F010AAE,
static const uint64_t P9N2_EX_8_SIER_MASK                                          = 0x30010AAEull;
//DUPS: 31010AAE,
static const uint64_t P9N2_EX_9_SIER_MASK                                          = 0x32010AAEull;
//DUPS: 33010AAE,
static const uint64_t P9N2_EX_10_SIER_MASK                                         = 0x34010AAEull;
//DUPS: 35010AAE,
static const uint64_t P9N2_EX_11_SIER_MASK                                         = 0x36010AAEull;
//DUPS: 37010AAE,

static const uint64_t P9N2_C_SKITTER_CLKSRC_REG                                    = 0x20050016ull;

static const uint64_t P9N2_C_0_SKITTER_CLKSRC_REG                                  = 0x20050016ull;

static const uint64_t P9N2_C_1_SKITTER_CLKSRC_REG                                  = 0x21050016ull;

static const uint64_t P9N2_C_2_SKITTER_CLKSRC_REG                                  = 0x22050016ull;

static const uint64_t P9N2_C_3_SKITTER_CLKSRC_REG                                  = 0x23050016ull;

static const uint64_t P9N2_C_4_SKITTER_CLKSRC_REG                                  = 0x24050016ull;

static const uint64_t P9N2_C_5_SKITTER_CLKSRC_REG                                  = 0x25050016ull;

static const uint64_t P9N2_C_6_SKITTER_CLKSRC_REG                                  = 0x26050016ull;

static const uint64_t P9N2_C_7_SKITTER_CLKSRC_REG                                  = 0x27050016ull;

static const uint64_t P9N2_C_8_SKITTER_CLKSRC_REG                                  = 0x28050016ull;

static const uint64_t P9N2_C_9_SKITTER_CLKSRC_REG                                  = 0x29050016ull;

static const uint64_t P9N2_C_10_SKITTER_CLKSRC_REG                                 = 0x2A050016ull;

static const uint64_t P9N2_C_11_SKITTER_CLKSRC_REG                                 = 0x2B050016ull;

static const uint64_t P9N2_C_12_SKITTER_CLKSRC_REG                                 = 0x2C050016ull;

static const uint64_t P9N2_C_13_SKITTER_CLKSRC_REG                                 = 0x2D050016ull;

static const uint64_t P9N2_C_14_SKITTER_CLKSRC_REG                                 = 0x2E050016ull;

static const uint64_t P9N2_C_15_SKITTER_CLKSRC_REG                                 = 0x2F050016ull;

static const uint64_t P9N2_C_16_SKITTER_CLKSRC_REG                                 = 0x30050016ull;

static const uint64_t P9N2_C_17_SKITTER_CLKSRC_REG                                 = 0x31050016ull;

static const uint64_t P9N2_C_18_SKITTER_CLKSRC_REG                                 = 0x32050016ull;

static const uint64_t P9N2_C_19_SKITTER_CLKSRC_REG                                 = 0x33050016ull;

static const uint64_t P9N2_C_20_SKITTER_CLKSRC_REG                                 = 0x34050016ull;

static const uint64_t P9N2_C_21_SKITTER_CLKSRC_REG                                 = 0x35050016ull;

static const uint64_t P9N2_C_22_SKITTER_CLKSRC_REG                                 = 0x36050016ull;

static const uint64_t P9N2_C_23_SKITTER_CLKSRC_REG                                 = 0x37050016ull;

static const uint64_t P9N2_EQ_SKITTER_CLKSRC_REG                                   = 0x10050016ull;

static const uint64_t P9N2_EQ_0_SKITTER_CLKSRC_REG                                 = 0x10050016ull;

static const uint64_t P9N2_EQ_1_SKITTER_CLKSRC_REG                                 = 0x11050016ull;

static const uint64_t P9N2_EQ_2_SKITTER_CLKSRC_REG                                 = 0x12050016ull;

static const uint64_t P9N2_EQ_3_SKITTER_CLKSRC_REG                                 = 0x13050016ull;

static const uint64_t P9N2_EQ_4_SKITTER_CLKSRC_REG                                 = 0x14050016ull;

static const uint64_t P9N2_EQ_5_SKITTER_CLKSRC_REG                                 = 0x15050016ull;

static const uint64_t P9N2_EX_SKITTER_CLKSRC_REG                                   = 0x20050016ull;
//DUPS: 21050016,
static const uint64_t P9N2_EX_0_SKITTER_CLKSRC_REG                                 = 0x20050016ull;
//DUPS: 21050016,
static const uint64_t P9N2_EX_1_SKITTER_CLKSRC_REG                                 = 0x22050016ull;
//DUPS: 23050016,
static const uint64_t P9N2_EX_2_SKITTER_CLKSRC_REG                                 = 0x24050016ull;
//DUPS: 25050016,
static const uint64_t P9N2_EX_3_SKITTER_CLKSRC_REG                                 = 0x26050016ull;
//DUPS: 27050016,
static const uint64_t P9N2_EX_4_SKITTER_CLKSRC_REG                                 = 0x28050016ull;
//DUPS: 29050016,
static const uint64_t P9N2_EX_5_SKITTER_CLKSRC_REG                                 = 0x2A050016ull;
//DUPS: 2B050016,
static const uint64_t P9N2_EX_6_SKITTER_CLKSRC_REG                                 = 0x2C050016ull;
//DUPS: 2D050016,
static const uint64_t P9N2_EX_7_SKITTER_CLKSRC_REG                                 = 0x2F050016ull;
//DUPS: 2F050016,
static const uint64_t P9N2_EX_8_SKITTER_CLKSRC_REG                                 = 0x30050016ull;
//DUPS: 31050016,
static const uint64_t P9N2_EX_9_SKITTER_CLKSRC_REG                                 = 0x32050016ull;
//DUPS: 33050016,
static const uint64_t P9N2_EX_10_SKITTER_CLKSRC_REG                                = 0x34050016ull;
//DUPS: 35050016,
static const uint64_t P9N2_EX_11_SKITTER_CLKSRC_REG                                = 0x36050016ull;
//DUPS: 37050016,

static const uint64_t P9N2_C_SKITTER_DATA0                                         = 0x20050019ull;

static const uint64_t P9N2_C_0_SKITTER_DATA0                                       = 0x20050019ull;

static const uint64_t P9N2_C_1_SKITTER_DATA0                                       = 0x21050019ull;

static const uint64_t P9N2_C_2_SKITTER_DATA0                                       = 0x22050019ull;

static const uint64_t P9N2_C_3_SKITTER_DATA0                                       = 0x23050019ull;

static const uint64_t P9N2_C_4_SKITTER_DATA0                                       = 0x24050019ull;

static const uint64_t P9N2_C_5_SKITTER_DATA0                                       = 0x25050019ull;

static const uint64_t P9N2_C_6_SKITTER_DATA0                                       = 0x26050019ull;

static const uint64_t P9N2_C_7_SKITTER_DATA0                                       = 0x27050019ull;

static const uint64_t P9N2_C_8_SKITTER_DATA0                                       = 0x28050019ull;

static const uint64_t P9N2_C_9_SKITTER_DATA0                                       = 0x29050019ull;

static const uint64_t P9N2_C_10_SKITTER_DATA0                                      = 0x2A050019ull;

static const uint64_t P9N2_C_11_SKITTER_DATA0                                      = 0x2B050019ull;

static const uint64_t P9N2_C_12_SKITTER_DATA0                                      = 0x2C050019ull;

static const uint64_t P9N2_C_13_SKITTER_DATA0                                      = 0x2D050019ull;

static const uint64_t P9N2_C_14_SKITTER_DATA0                                      = 0x2E050019ull;

static const uint64_t P9N2_C_15_SKITTER_DATA0                                      = 0x2F050019ull;

static const uint64_t P9N2_C_16_SKITTER_DATA0                                      = 0x30050019ull;

static const uint64_t P9N2_C_17_SKITTER_DATA0                                      = 0x31050019ull;

static const uint64_t P9N2_C_18_SKITTER_DATA0                                      = 0x32050019ull;

static const uint64_t P9N2_C_19_SKITTER_DATA0                                      = 0x33050019ull;

static const uint64_t P9N2_C_20_SKITTER_DATA0                                      = 0x34050019ull;

static const uint64_t P9N2_C_21_SKITTER_DATA0                                      = 0x35050019ull;

static const uint64_t P9N2_C_22_SKITTER_DATA0                                      = 0x36050019ull;

static const uint64_t P9N2_C_23_SKITTER_DATA0                                      = 0x37050019ull;

static const uint64_t P9N2_EQ_SKITTER_DATA0                                        = 0x10050019ull;

static const uint64_t P9N2_EQ_0_SKITTER_DATA0                                      = 0x10050019ull;

static const uint64_t P9N2_EQ_1_SKITTER_DATA0                                      = 0x11050019ull;

static const uint64_t P9N2_EQ_2_SKITTER_DATA0                                      = 0x12050019ull;

static const uint64_t P9N2_EQ_3_SKITTER_DATA0                                      = 0x13050019ull;

static const uint64_t P9N2_EQ_4_SKITTER_DATA0                                      = 0x14050019ull;

static const uint64_t P9N2_EQ_5_SKITTER_DATA0                                      = 0x15050019ull;

static const uint64_t P9N2_EX_SKITTER_DATA0                                        = 0x20050019ull;
//DUPS: 21050019,
static const uint64_t P9N2_EX_0_SKITTER_DATA0                                      = 0x20050019ull;
//DUPS: 21050019,
static const uint64_t P9N2_EX_1_SKITTER_DATA0                                      = 0x22050019ull;
//DUPS: 23050019,
static const uint64_t P9N2_EX_2_SKITTER_DATA0                                      = 0x24050019ull;
//DUPS: 25050019,
static const uint64_t P9N2_EX_3_SKITTER_DATA0                                      = 0x26050019ull;
//DUPS: 27050019,
static const uint64_t P9N2_EX_4_SKITTER_DATA0                                      = 0x28050019ull;
//DUPS: 29050019,
static const uint64_t P9N2_EX_5_SKITTER_DATA0                                      = 0x2A050019ull;
//DUPS: 2B050019,
static const uint64_t P9N2_EX_6_SKITTER_DATA0                                      = 0x2C050019ull;
//DUPS: 2D050019,
static const uint64_t P9N2_EX_7_SKITTER_DATA0                                      = 0x2F050019ull;
//DUPS: 2F050019,
static const uint64_t P9N2_EX_8_SKITTER_DATA0                                      = 0x30050019ull;
//DUPS: 31050019,
static const uint64_t P9N2_EX_9_SKITTER_DATA0                                      = 0x32050019ull;
//DUPS: 33050019,
static const uint64_t P9N2_EX_10_SKITTER_DATA0                                     = 0x34050019ull;
//DUPS: 35050019,
static const uint64_t P9N2_EX_11_SKITTER_DATA0                                     = 0x36050019ull;
//DUPS: 37050019,

static const uint64_t P9N2_C_SKITTER_DATA1                                         = 0x2005001Aull;

static const uint64_t P9N2_C_0_SKITTER_DATA1                                       = 0x2005001Aull;

static const uint64_t P9N2_C_1_SKITTER_DATA1                                       = 0x2105001Aull;

static const uint64_t P9N2_C_2_SKITTER_DATA1                                       = 0x2205001Aull;

static const uint64_t P9N2_C_3_SKITTER_DATA1                                       = 0x2305001Aull;

static const uint64_t P9N2_C_4_SKITTER_DATA1                                       = 0x2405001Aull;

static const uint64_t P9N2_C_5_SKITTER_DATA1                                       = 0x2505001Aull;

static const uint64_t P9N2_C_6_SKITTER_DATA1                                       = 0x2605001Aull;

static const uint64_t P9N2_C_7_SKITTER_DATA1                                       = 0x2705001Aull;

static const uint64_t P9N2_C_8_SKITTER_DATA1                                       = 0x2805001Aull;

static const uint64_t P9N2_C_9_SKITTER_DATA1                                       = 0x2905001Aull;

static const uint64_t P9N2_C_10_SKITTER_DATA1                                      = 0x2A05001Aull;

static const uint64_t P9N2_C_11_SKITTER_DATA1                                      = 0x2B05001Aull;

static const uint64_t P9N2_C_12_SKITTER_DATA1                                      = 0x2C05001Aull;

static const uint64_t P9N2_C_13_SKITTER_DATA1                                      = 0x2D05001Aull;

static const uint64_t P9N2_C_14_SKITTER_DATA1                                      = 0x2E05001Aull;

static const uint64_t P9N2_C_15_SKITTER_DATA1                                      = 0x2F05001Aull;

static const uint64_t P9N2_C_16_SKITTER_DATA1                                      = 0x3005001Aull;

static const uint64_t P9N2_C_17_SKITTER_DATA1                                      = 0x3105001Aull;

static const uint64_t P9N2_C_18_SKITTER_DATA1                                      = 0x3205001Aull;

static const uint64_t P9N2_C_19_SKITTER_DATA1                                      = 0x3305001Aull;

static const uint64_t P9N2_C_20_SKITTER_DATA1                                      = 0x3405001Aull;

static const uint64_t P9N2_C_21_SKITTER_DATA1                                      = 0x3505001Aull;

static const uint64_t P9N2_C_22_SKITTER_DATA1                                      = 0x3605001Aull;

static const uint64_t P9N2_C_23_SKITTER_DATA1                                      = 0x3705001Aull;

static const uint64_t P9N2_EQ_SKITTER_DATA1                                        = 0x1005001Aull;

static const uint64_t P9N2_EQ_0_SKITTER_DATA1                                      = 0x1005001Aull;

static const uint64_t P9N2_EQ_1_SKITTER_DATA1                                      = 0x1105001Aull;

static const uint64_t P9N2_EQ_2_SKITTER_DATA1                                      = 0x1205001Aull;

static const uint64_t P9N2_EQ_3_SKITTER_DATA1                                      = 0x1305001Aull;

static const uint64_t P9N2_EQ_4_SKITTER_DATA1                                      = 0x1405001Aull;

static const uint64_t P9N2_EQ_5_SKITTER_DATA1                                      = 0x1505001Aull;

static const uint64_t P9N2_EX_SKITTER_DATA1                                        = 0x2005001Aull;
//DUPS: 2105001A,
static const uint64_t P9N2_EX_0_SKITTER_DATA1                                      = 0x2005001Aull;
//DUPS: 2105001A,
static const uint64_t P9N2_EX_1_SKITTER_DATA1                                      = 0x2205001Aull;
//DUPS: 2305001A,
static const uint64_t P9N2_EX_2_SKITTER_DATA1                                      = 0x2405001Aull;
//DUPS: 2505001A,
static const uint64_t P9N2_EX_3_SKITTER_DATA1                                      = 0x2605001Aull;
//DUPS: 2705001A,
static const uint64_t P9N2_EX_4_SKITTER_DATA1                                      = 0x2805001Aull;
//DUPS: 2905001A,
static const uint64_t P9N2_EX_5_SKITTER_DATA1                                      = 0x2A05001Aull;
//DUPS: 2B05001A,
static const uint64_t P9N2_EX_6_SKITTER_DATA1                                      = 0x2C05001Aull;
//DUPS: 2D05001A,
static const uint64_t P9N2_EX_7_SKITTER_DATA1                                      = 0x2F05001Aull;
//DUPS: 2F05001A,
static const uint64_t P9N2_EX_8_SKITTER_DATA1                                      = 0x3005001Aull;
//DUPS: 3105001A,
static const uint64_t P9N2_EX_9_SKITTER_DATA1                                      = 0x3205001Aull;
//DUPS: 3305001A,
static const uint64_t P9N2_EX_10_SKITTER_DATA1                                     = 0x3405001Aull;
//DUPS: 3505001A,
static const uint64_t P9N2_EX_11_SKITTER_DATA1                                     = 0x3605001Aull;
//DUPS: 3705001A,

static const uint64_t P9N2_C_SKITTER_DATA2                                         = 0x2005001Bull;

static const uint64_t P9N2_C_0_SKITTER_DATA2                                       = 0x2005001Bull;

static const uint64_t P9N2_C_1_SKITTER_DATA2                                       = 0x2105001Bull;

static const uint64_t P9N2_C_2_SKITTER_DATA2                                       = 0x2205001Bull;

static const uint64_t P9N2_C_3_SKITTER_DATA2                                       = 0x2305001Bull;

static const uint64_t P9N2_C_4_SKITTER_DATA2                                       = 0x2405001Bull;

static const uint64_t P9N2_C_5_SKITTER_DATA2                                       = 0x2505001Bull;

static const uint64_t P9N2_C_6_SKITTER_DATA2                                       = 0x2605001Bull;

static const uint64_t P9N2_C_7_SKITTER_DATA2                                       = 0x2705001Bull;

static const uint64_t P9N2_C_8_SKITTER_DATA2                                       = 0x2805001Bull;

static const uint64_t P9N2_C_9_SKITTER_DATA2                                       = 0x2905001Bull;

static const uint64_t P9N2_C_10_SKITTER_DATA2                                      = 0x2A05001Bull;

static const uint64_t P9N2_C_11_SKITTER_DATA2                                      = 0x2B05001Bull;

static const uint64_t P9N2_C_12_SKITTER_DATA2                                      = 0x2C05001Bull;

static const uint64_t P9N2_C_13_SKITTER_DATA2                                      = 0x2D05001Bull;

static const uint64_t P9N2_C_14_SKITTER_DATA2                                      = 0x2E05001Bull;

static const uint64_t P9N2_C_15_SKITTER_DATA2                                      = 0x2F05001Bull;

static const uint64_t P9N2_C_16_SKITTER_DATA2                                      = 0x3005001Bull;

static const uint64_t P9N2_C_17_SKITTER_DATA2                                      = 0x3105001Bull;

static const uint64_t P9N2_C_18_SKITTER_DATA2                                      = 0x3205001Bull;

static const uint64_t P9N2_C_19_SKITTER_DATA2                                      = 0x3305001Bull;

static const uint64_t P9N2_C_20_SKITTER_DATA2                                      = 0x3405001Bull;

static const uint64_t P9N2_C_21_SKITTER_DATA2                                      = 0x3505001Bull;

static const uint64_t P9N2_C_22_SKITTER_DATA2                                      = 0x3605001Bull;

static const uint64_t P9N2_C_23_SKITTER_DATA2                                      = 0x3705001Bull;

static const uint64_t P9N2_EQ_SKITTER_DATA2                                        = 0x1005001Bull;

static const uint64_t P9N2_EQ_0_SKITTER_DATA2                                      = 0x1005001Bull;

static const uint64_t P9N2_EQ_1_SKITTER_DATA2                                      = 0x1105001Bull;

static const uint64_t P9N2_EQ_2_SKITTER_DATA2                                      = 0x1205001Bull;

static const uint64_t P9N2_EQ_3_SKITTER_DATA2                                      = 0x1305001Bull;

static const uint64_t P9N2_EQ_4_SKITTER_DATA2                                      = 0x1405001Bull;

static const uint64_t P9N2_EQ_5_SKITTER_DATA2                                      = 0x1505001Bull;

static const uint64_t P9N2_EX_SKITTER_DATA2                                        = 0x2005001Bull;
//DUPS: 2105001B,
static const uint64_t P9N2_EX_0_SKITTER_DATA2                                      = 0x2005001Bull;
//DUPS: 2105001B,
static const uint64_t P9N2_EX_1_SKITTER_DATA2                                      = 0x2205001Bull;
//DUPS: 2305001B,
static const uint64_t P9N2_EX_2_SKITTER_DATA2                                      = 0x2405001Bull;
//DUPS: 2505001B,
static const uint64_t P9N2_EX_3_SKITTER_DATA2                                      = 0x2605001Bull;
//DUPS: 2705001B,
static const uint64_t P9N2_EX_4_SKITTER_DATA2                                      = 0x2805001Bull;
//DUPS: 2905001B,
static const uint64_t P9N2_EX_5_SKITTER_DATA2                                      = 0x2A05001Bull;
//DUPS: 2B05001B,
static const uint64_t P9N2_EX_6_SKITTER_DATA2                                      = 0x2C05001Bull;
//DUPS: 2D05001B,
static const uint64_t P9N2_EX_7_SKITTER_DATA2                                      = 0x2F05001Bull;
//DUPS: 2F05001B,
static const uint64_t P9N2_EX_8_SKITTER_DATA2                                      = 0x3005001Bull;
//DUPS: 3105001B,
static const uint64_t P9N2_EX_9_SKITTER_DATA2                                      = 0x3205001Bull;
//DUPS: 3305001B,
static const uint64_t P9N2_EX_10_SKITTER_DATA2                                     = 0x3405001Bull;
//DUPS: 3505001B,
static const uint64_t P9N2_EX_11_SKITTER_DATA2                                     = 0x3605001Bull;
//DUPS: 3705001B,

static const uint64_t P9N2_C_SKITTER_FORCE_REG                                     = 0x20050014ull;

static const uint64_t P9N2_C_0_SKITTER_FORCE_REG                                   = 0x20050014ull;

static const uint64_t P9N2_C_1_SKITTER_FORCE_REG                                   = 0x21050014ull;

static const uint64_t P9N2_C_2_SKITTER_FORCE_REG                                   = 0x22050014ull;

static const uint64_t P9N2_C_3_SKITTER_FORCE_REG                                   = 0x23050014ull;

static const uint64_t P9N2_C_4_SKITTER_FORCE_REG                                   = 0x24050014ull;

static const uint64_t P9N2_C_5_SKITTER_FORCE_REG                                   = 0x25050014ull;

static const uint64_t P9N2_C_6_SKITTER_FORCE_REG                                   = 0x26050014ull;

static const uint64_t P9N2_C_7_SKITTER_FORCE_REG                                   = 0x27050014ull;

static const uint64_t P9N2_C_8_SKITTER_FORCE_REG                                   = 0x28050014ull;

static const uint64_t P9N2_C_9_SKITTER_FORCE_REG                                   = 0x29050014ull;

static const uint64_t P9N2_C_10_SKITTER_FORCE_REG                                  = 0x2A050014ull;

static const uint64_t P9N2_C_11_SKITTER_FORCE_REG                                  = 0x2B050014ull;

static const uint64_t P9N2_C_12_SKITTER_FORCE_REG                                  = 0x2C050014ull;

static const uint64_t P9N2_C_13_SKITTER_FORCE_REG                                  = 0x2D050014ull;

static const uint64_t P9N2_C_14_SKITTER_FORCE_REG                                  = 0x2E050014ull;

static const uint64_t P9N2_C_15_SKITTER_FORCE_REG                                  = 0x2F050014ull;

static const uint64_t P9N2_C_16_SKITTER_FORCE_REG                                  = 0x30050014ull;

static const uint64_t P9N2_C_17_SKITTER_FORCE_REG                                  = 0x31050014ull;

static const uint64_t P9N2_C_18_SKITTER_FORCE_REG                                  = 0x32050014ull;

static const uint64_t P9N2_C_19_SKITTER_FORCE_REG                                  = 0x33050014ull;

static const uint64_t P9N2_C_20_SKITTER_FORCE_REG                                  = 0x34050014ull;

static const uint64_t P9N2_C_21_SKITTER_FORCE_REG                                  = 0x35050014ull;

static const uint64_t P9N2_C_22_SKITTER_FORCE_REG                                  = 0x36050014ull;

static const uint64_t P9N2_C_23_SKITTER_FORCE_REG                                  = 0x37050014ull;

static const uint64_t P9N2_EQ_SKITTER_FORCE_REG                                    = 0x10050014ull;

static const uint64_t P9N2_EQ_0_SKITTER_FORCE_REG                                  = 0x10050014ull;

static const uint64_t P9N2_EQ_1_SKITTER_FORCE_REG                                  = 0x11050014ull;

static const uint64_t P9N2_EQ_2_SKITTER_FORCE_REG                                  = 0x12050014ull;

static const uint64_t P9N2_EQ_3_SKITTER_FORCE_REG                                  = 0x13050014ull;

static const uint64_t P9N2_EQ_4_SKITTER_FORCE_REG                                  = 0x14050014ull;

static const uint64_t P9N2_EQ_5_SKITTER_FORCE_REG                                  = 0x15050014ull;

static const uint64_t P9N2_EX_SKITTER_FORCE_REG                                    = 0x20050014ull;
//DUPS: 21050014,
static const uint64_t P9N2_EX_0_SKITTER_FORCE_REG                                  = 0x20050014ull;
//DUPS: 21050014,
static const uint64_t P9N2_EX_1_SKITTER_FORCE_REG                                  = 0x22050014ull;
//DUPS: 23050014,
static const uint64_t P9N2_EX_2_SKITTER_FORCE_REG                                  = 0x24050014ull;
//DUPS: 25050014,
static const uint64_t P9N2_EX_3_SKITTER_FORCE_REG                                  = 0x26050014ull;
//DUPS: 27050014,
static const uint64_t P9N2_EX_4_SKITTER_FORCE_REG                                  = 0x28050014ull;
//DUPS: 29050014,
static const uint64_t P9N2_EX_5_SKITTER_FORCE_REG                                  = 0x2A050014ull;
//DUPS: 2B050014,
static const uint64_t P9N2_EX_6_SKITTER_FORCE_REG                                  = 0x2C050014ull;
//DUPS: 2D050014,
static const uint64_t P9N2_EX_7_SKITTER_FORCE_REG                                  = 0x2F050014ull;
//DUPS: 2F050014,
static const uint64_t P9N2_EX_8_SKITTER_FORCE_REG                                  = 0x30050014ull;
//DUPS: 31050014,
static const uint64_t P9N2_EX_9_SKITTER_FORCE_REG                                  = 0x32050014ull;
//DUPS: 33050014,
static const uint64_t P9N2_EX_10_SKITTER_FORCE_REG                                 = 0x34050014ull;
//DUPS: 35050014,
static const uint64_t P9N2_EX_11_SKITTER_FORCE_REG                                 = 0x36050014ull;
//DUPS: 37050014,

static const uint64_t P9N2_C_SKITTER_MODE_REG                                      = 0x20050010ull;

static const uint64_t P9N2_C_0_SKITTER_MODE_REG                                    = 0x20050010ull;

static const uint64_t P9N2_C_1_SKITTER_MODE_REG                                    = 0x21050010ull;

static const uint64_t P9N2_C_2_SKITTER_MODE_REG                                    = 0x22050010ull;

static const uint64_t P9N2_C_3_SKITTER_MODE_REG                                    = 0x23050010ull;

static const uint64_t P9N2_C_4_SKITTER_MODE_REG                                    = 0x24050010ull;

static const uint64_t P9N2_C_5_SKITTER_MODE_REG                                    = 0x25050010ull;

static const uint64_t P9N2_C_6_SKITTER_MODE_REG                                    = 0x26050010ull;

static const uint64_t P9N2_C_7_SKITTER_MODE_REG                                    = 0x27050010ull;

static const uint64_t P9N2_C_8_SKITTER_MODE_REG                                    = 0x28050010ull;

static const uint64_t P9N2_C_9_SKITTER_MODE_REG                                    = 0x29050010ull;

static const uint64_t P9N2_C_10_SKITTER_MODE_REG                                   = 0x2A050010ull;

static const uint64_t P9N2_C_11_SKITTER_MODE_REG                                   = 0x2B050010ull;

static const uint64_t P9N2_C_12_SKITTER_MODE_REG                                   = 0x2C050010ull;

static const uint64_t P9N2_C_13_SKITTER_MODE_REG                                   = 0x2D050010ull;

static const uint64_t P9N2_C_14_SKITTER_MODE_REG                                   = 0x2E050010ull;

static const uint64_t P9N2_C_15_SKITTER_MODE_REG                                   = 0x2F050010ull;

static const uint64_t P9N2_C_16_SKITTER_MODE_REG                                   = 0x30050010ull;

static const uint64_t P9N2_C_17_SKITTER_MODE_REG                                   = 0x31050010ull;

static const uint64_t P9N2_C_18_SKITTER_MODE_REG                                   = 0x32050010ull;

static const uint64_t P9N2_C_19_SKITTER_MODE_REG                                   = 0x33050010ull;

static const uint64_t P9N2_C_20_SKITTER_MODE_REG                                   = 0x34050010ull;

static const uint64_t P9N2_C_21_SKITTER_MODE_REG                                   = 0x35050010ull;

static const uint64_t P9N2_C_22_SKITTER_MODE_REG                                   = 0x36050010ull;

static const uint64_t P9N2_C_23_SKITTER_MODE_REG                                   = 0x37050010ull;

static const uint64_t P9N2_EQ_SKITTER_MODE_REG                                     = 0x10050010ull;

static const uint64_t P9N2_EQ_0_SKITTER_MODE_REG                                   = 0x10050010ull;

static const uint64_t P9N2_EQ_1_SKITTER_MODE_REG                                   = 0x11050010ull;

static const uint64_t P9N2_EQ_2_SKITTER_MODE_REG                                   = 0x12050010ull;

static const uint64_t P9N2_EQ_3_SKITTER_MODE_REG                                   = 0x13050010ull;

static const uint64_t P9N2_EQ_4_SKITTER_MODE_REG                                   = 0x14050010ull;

static const uint64_t P9N2_EQ_5_SKITTER_MODE_REG                                   = 0x15050010ull;

static const uint64_t P9N2_EX_SKITTER_MODE_REG                                     = 0x20050010ull;
//DUPS: 21050010,
static const uint64_t P9N2_EX_0_SKITTER_MODE_REG                                   = 0x20050010ull;
//DUPS: 21050010,
static const uint64_t P9N2_EX_1_SKITTER_MODE_REG                                   = 0x22050010ull;
//DUPS: 23050010,
static const uint64_t P9N2_EX_2_SKITTER_MODE_REG                                   = 0x24050010ull;
//DUPS: 25050010,
static const uint64_t P9N2_EX_3_SKITTER_MODE_REG                                   = 0x26050010ull;
//DUPS: 27050010,
static const uint64_t P9N2_EX_4_SKITTER_MODE_REG                                   = 0x28050010ull;
//DUPS: 29050010,
static const uint64_t P9N2_EX_5_SKITTER_MODE_REG                                   = 0x2A050010ull;
//DUPS: 2B050010,
static const uint64_t P9N2_EX_6_SKITTER_MODE_REG                                   = 0x2C050010ull;
//DUPS: 2D050010,
static const uint64_t P9N2_EX_7_SKITTER_MODE_REG                                   = 0x2F050010ull;
//DUPS: 2F050010,
static const uint64_t P9N2_EX_8_SKITTER_MODE_REG                                   = 0x30050010ull;
//DUPS: 31050010,
static const uint64_t P9N2_EX_9_SKITTER_MODE_REG                                   = 0x32050010ull;
//DUPS: 33050010,
static const uint64_t P9N2_EX_10_SKITTER_MODE_REG                                  = 0x34050010ull;
//DUPS: 35050010,
static const uint64_t P9N2_EX_11_SKITTER_MODE_REG                                  = 0x36050010ull;
//DUPS: 37050010,

static const uint64_t P9N2_C_SLAVE_CONFIG_REG                                      = 0x200F001Eull;

static const uint64_t P9N2_C_0_SLAVE_CONFIG_REG                                    = 0x200F001Eull;

static const uint64_t P9N2_C_1_SLAVE_CONFIG_REG                                    = 0x210F001Eull;

static const uint64_t P9N2_C_2_SLAVE_CONFIG_REG                                    = 0x220F001Eull;

static const uint64_t P9N2_C_3_SLAVE_CONFIG_REG                                    = 0x230F001Eull;

static const uint64_t P9N2_C_4_SLAVE_CONFIG_REG                                    = 0x240F001Eull;

static const uint64_t P9N2_C_5_SLAVE_CONFIG_REG                                    = 0x250F001Eull;

static const uint64_t P9N2_C_6_SLAVE_CONFIG_REG                                    = 0x260F001Eull;

static const uint64_t P9N2_C_7_SLAVE_CONFIG_REG                                    = 0x270F001Eull;

static const uint64_t P9N2_C_8_SLAVE_CONFIG_REG                                    = 0x280F001Eull;

static const uint64_t P9N2_C_9_SLAVE_CONFIG_REG                                    = 0x290F001Eull;

static const uint64_t P9N2_C_10_SLAVE_CONFIG_REG                                   = 0x2A0F001Eull;

static const uint64_t P9N2_C_11_SLAVE_CONFIG_REG                                   = 0x2B0F001Eull;

static const uint64_t P9N2_C_12_SLAVE_CONFIG_REG                                   = 0x2C0F001Eull;

static const uint64_t P9N2_C_13_SLAVE_CONFIG_REG                                   = 0x2D0F001Eull;

static const uint64_t P9N2_C_14_SLAVE_CONFIG_REG                                   = 0x2E0F001Eull;

static const uint64_t P9N2_C_15_SLAVE_CONFIG_REG                                   = 0x2F0F001Eull;

static const uint64_t P9N2_C_16_SLAVE_CONFIG_REG                                   = 0x300F001Eull;

static const uint64_t P9N2_C_17_SLAVE_CONFIG_REG                                   = 0x310F001Eull;

static const uint64_t P9N2_C_18_SLAVE_CONFIG_REG                                   = 0x320F001Eull;

static const uint64_t P9N2_C_19_SLAVE_CONFIG_REG                                   = 0x330F001Eull;

static const uint64_t P9N2_C_20_SLAVE_CONFIG_REG                                   = 0x340F001Eull;

static const uint64_t P9N2_C_21_SLAVE_CONFIG_REG                                   = 0x350F001Eull;

static const uint64_t P9N2_C_22_SLAVE_CONFIG_REG                                   = 0x360F001Eull;

static const uint64_t P9N2_C_23_SLAVE_CONFIG_REG                                   = 0x370F001Eull;

static const uint64_t P9N2_EQ_SLAVE_CONFIG_REG                                     = 0x100F001Eull;

static const uint64_t P9N2_EQ_0_SLAVE_CONFIG_REG                                   = 0x100F001Eull;

static const uint64_t P9N2_EQ_1_SLAVE_CONFIG_REG                                   = 0x110F001Eull;

static const uint64_t P9N2_EQ_2_SLAVE_CONFIG_REG                                   = 0x120F001Eull;

static const uint64_t P9N2_EQ_3_SLAVE_CONFIG_REG                                   = 0x130F001Eull;

static const uint64_t P9N2_EQ_4_SLAVE_CONFIG_REG                                   = 0x140F001Eull;

static const uint64_t P9N2_EQ_5_SLAVE_CONFIG_REG                                   = 0x150F001Eull;

static const uint64_t P9N2_EX_SLAVE_CONFIG_REG                                     = 0x200F001Eull;
//DUPS: 210F001E,
static const uint64_t P9N2_EX_0_SLAVE_CONFIG_REG                                   = 0x200F001Eull;
//DUPS: 210F001E,
static const uint64_t P9N2_EX_1_SLAVE_CONFIG_REG                                   = 0x220F001Eull;
//DUPS: 220F001E,
static const uint64_t P9N2_EX_2_SLAVE_CONFIG_REG                                   = 0x240F001Eull;
//DUPS: 250F001E,
static const uint64_t P9N2_EX_3_SLAVE_CONFIG_REG                                   = 0x260F001Eull;
//DUPS: 270F001E,
static const uint64_t P9N2_EX_4_SLAVE_CONFIG_REG                                   = 0x280F001Eull;
//DUPS: 290F001E,
static const uint64_t P9N2_EX_5_SLAVE_CONFIG_REG                                   = 0x2A0F001Eull;
//DUPS: 2B0F001E,
static const uint64_t P9N2_EX_6_SLAVE_CONFIG_REG                                   = 0x2C0F001Eull;
//DUPS: 2D0F001E,
static const uint64_t P9N2_EX_7_SLAVE_CONFIG_REG                                   = 0x2E0F001Eull;
//DUPS: 2F0F001E,
static const uint64_t P9N2_EX_8_SLAVE_CONFIG_REG                                   = 0x300F001Eull;
//DUPS: 310F001E,
static const uint64_t P9N2_EX_9_SLAVE_CONFIG_REG                                   = 0x320F001Eull;
//DUPS: 330F001E,
static const uint64_t P9N2_EX_10_SLAVE_CONFIG_REG                                  = 0x340F001Eull;
//DUPS: 350F001E,
static const uint64_t P9N2_EX_11_SLAVE_CONFIG_REG                                  = 0x360F001Eull;
//DUPS: 370F001E,

static const uint64_t P9N2_C_SPATTN_SCOM                                           = 0x20010A99ull;
//DUPS: 20010A99,
static const uint64_t P9N2_C_SPATTN_SCOM1                                          = 0x20010A98ull;
//DUPS: 20010A98,
static const uint64_t P9N2_C_SPATTN_SCOM2                                          = 0x20010A97ull;
//DUPS: 20010A97,
static const uint64_t P9N2_C_0_SPATTN_SCOM                                         = 0x20010A99ull;
//DUPS: 20010A99,
static const uint64_t P9N2_C_0_SPATTN_SCOM1                                        = 0x20010A98ull;
//DUPS: 20010A98,
static const uint64_t P9N2_C_0_SPATTN_SCOM2                                        = 0x20010A97ull;
//DUPS: 20010A97,
static const uint64_t P9N2_C_1_SPATTN_SCOM                                         = 0x21010A99ull;
//DUPS: 21010A99,
static const uint64_t P9N2_C_1_SPATTN_SCOM1                                        = 0x21010A98ull;
//DUPS: 21010A98,
static const uint64_t P9N2_C_1_SPATTN_SCOM2                                        = 0x21010A97ull;
//DUPS: 21010A97,
static const uint64_t P9N2_C_2_SPATTN_SCOM                                         = 0x22010A99ull;
//DUPS: 22010A99,
static const uint64_t P9N2_C_2_SPATTN_SCOM1                                        = 0x22010A98ull;
//DUPS: 22010A98,
static const uint64_t P9N2_C_2_SPATTN_SCOM2                                        = 0x22010A97ull;
//DUPS: 22010A97,
static const uint64_t P9N2_C_3_SPATTN_SCOM                                         = 0x23010A99ull;
//DUPS: 23010A99,
static const uint64_t P9N2_C_3_SPATTN_SCOM1                                        = 0x23010A98ull;
//DUPS: 23010A98,
static const uint64_t P9N2_C_3_SPATTN_SCOM2                                        = 0x23010A97ull;
//DUPS: 23010A97,
static const uint64_t P9N2_C_4_SPATTN_SCOM                                         = 0x24010A99ull;
//DUPS: 24010A99,
static const uint64_t P9N2_C_4_SPATTN_SCOM1                                        = 0x24010A98ull;
//DUPS: 24010A98,
static const uint64_t P9N2_C_4_SPATTN_SCOM2                                        = 0x24010A97ull;
//DUPS: 24010A97,
static const uint64_t P9N2_C_5_SPATTN_SCOM                                         = 0x25010A99ull;
//DUPS: 25010A99,
static const uint64_t P9N2_C_5_SPATTN_SCOM1                                        = 0x25010A98ull;
//DUPS: 25010A98,
static const uint64_t P9N2_C_5_SPATTN_SCOM2                                        = 0x25010A97ull;
//DUPS: 25010A97,
static const uint64_t P9N2_C_6_SPATTN_SCOM                                         = 0x26010A99ull;
//DUPS: 26010A99,
static const uint64_t P9N2_C_6_SPATTN_SCOM1                                        = 0x26010A98ull;
//DUPS: 26010A98,
static const uint64_t P9N2_C_6_SPATTN_SCOM2                                        = 0x26010A97ull;
//DUPS: 26010A97,
static const uint64_t P9N2_C_7_SPATTN_SCOM                                         = 0x27010A99ull;
//DUPS: 27010A99,
static const uint64_t P9N2_C_7_SPATTN_SCOM1                                        = 0x27010A98ull;
//DUPS: 27010A98,
static const uint64_t P9N2_C_7_SPATTN_SCOM2                                        = 0x27010A97ull;
//DUPS: 27010A97,
static const uint64_t P9N2_C_8_SPATTN_SCOM                                         = 0x28010A99ull;
//DUPS: 28010A99,
static const uint64_t P9N2_C_8_SPATTN_SCOM1                                        = 0x28010A98ull;
//DUPS: 28010A98,
static const uint64_t P9N2_C_8_SPATTN_SCOM2                                        = 0x28010A97ull;
//DUPS: 28010A97,
static const uint64_t P9N2_C_9_SPATTN_SCOM                                         = 0x29010A99ull;
//DUPS: 29010A99,
static const uint64_t P9N2_C_9_SPATTN_SCOM1                                        = 0x29010A98ull;
//DUPS: 29010A98,
static const uint64_t P9N2_C_9_SPATTN_SCOM2                                        = 0x29010A97ull;
//DUPS: 29010A97,
static const uint64_t P9N2_C_10_SPATTN_SCOM                                        = 0x2A040004ull;
//DUPS: 2A010A99,
static const uint64_t P9N2_C_10_SPATTN_SCOM1                                       = 0x2A040005ull;
//DUPS: 2A010A98,
static const uint64_t P9N2_C_10_SPATTN_SCOM2                                       = 0x2A040006ull;
//DUPS: 2A010A97,
static const uint64_t P9N2_C_11_SPATTN_SCOM                                        = 0x2B040004ull;
//DUPS: 2B010A99,
static const uint64_t P9N2_C_11_SPATTN_SCOM1                                       = 0x2B040005ull;
//DUPS: 2B010A98,
static const uint64_t P9N2_C_11_SPATTN_SCOM2                                       = 0x2B040006ull;
//DUPS: 2B010A97,
static const uint64_t P9N2_C_12_SPATTN_SCOM                                        = 0x2C040004ull;
//DUPS: 2C010A99,
static const uint64_t P9N2_C_12_SPATTN_SCOM1                                       = 0x2C040005ull;
//DUPS: 2C010A98,
static const uint64_t P9N2_C_12_SPATTN_SCOM2                                       = 0x2C040006ull;
//DUPS: 2C010A97,
static const uint64_t P9N2_C_13_SPATTN_SCOM                                        = 0x2D040004ull;
//DUPS: 2D010A99,
static const uint64_t P9N2_C_13_SPATTN_SCOM1                                       = 0x2D040005ull;
//DUPS: 2D010A98,
static const uint64_t P9N2_C_13_SPATTN_SCOM2                                       = 0x2D040006ull;
//DUPS: 2D010A97,
static const uint64_t P9N2_C_14_SPATTN_SCOM                                        = 0x2E010A99ull;
//DUPS: 2E010A99,
static const uint64_t P9N2_C_14_SPATTN_SCOM1                                       = 0x2E010A98ull;
//DUPS: 2E010A98,
static const uint64_t P9N2_C_14_SPATTN_SCOM2                                       = 0x2E010A97ull;
//DUPS: 2E010A97,
static const uint64_t P9N2_C_15_SPATTN_SCOM                                        = 0x2F040004ull;
//DUPS: 2F010A99,
static const uint64_t P9N2_C_15_SPATTN_SCOM1                                       = 0x2F040005ull;
//DUPS: 2F010A98,
static const uint64_t P9N2_C_15_SPATTN_SCOM2                                       = 0x2F040006ull;
//DUPS: 2F010A97,
static const uint64_t P9N2_C_16_SPATTN_SCOM                                        = 0x30010A99ull;
//DUPS: 30010A99,
static const uint64_t P9N2_C_16_SPATTN_SCOM1                                       = 0x30010A98ull;
//DUPS: 30010A98,
static const uint64_t P9N2_C_16_SPATTN_SCOM2                                       = 0x30010A97ull;
//DUPS: 30010A97,
static const uint64_t P9N2_C_17_SPATTN_SCOM                                        = 0x31010A99ull;
//DUPS: 31010A99,
static const uint64_t P9N2_C_17_SPATTN_SCOM1                                       = 0x31010A98ull;
//DUPS: 31010A98,
static const uint64_t P9N2_C_17_SPATTN_SCOM2                                       = 0x31010A97ull;
//DUPS: 31010A97,
static const uint64_t P9N2_C_18_SPATTN_SCOM                                        = 0x32010A99ull;
//DUPS: 32010A99,
static const uint64_t P9N2_C_18_SPATTN_SCOM1                                       = 0x32010A98ull;
//DUPS: 32010A98,
static const uint64_t P9N2_C_18_SPATTN_SCOM2                                       = 0x32010A97ull;
//DUPS: 32010A97,
static const uint64_t P9N2_C_19_SPATTN_SCOM                                        = 0x33010A99ull;
//DUPS: 33010A99,
static const uint64_t P9N2_C_19_SPATTN_SCOM1                                       = 0x33010A98ull;
//DUPS: 33010A98,
static const uint64_t P9N2_C_19_SPATTN_SCOM2                                       = 0x33010A97ull;
//DUPS: 33010A97,
static const uint64_t P9N2_C_20_SPATTN_SCOM                                        = 0x34010A99ull;
//DUPS: 34010A99,
static const uint64_t P9N2_C_20_SPATTN_SCOM1                                       = 0x34010A98ull;
//DUPS: 34010A98,
static const uint64_t P9N2_C_20_SPATTN_SCOM2                                       = 0x34010A97ull;
//DUPS: 34010A97,
static const uint64_t P9N2_C_21_SPATTN_SCOM                                        = 0x35010A99ull;
//DUPS: 35010A99,
static const uint64_t P9N2_C_21_SPATTN_SCOM1                                       = 0x35010A98ull;
//DUPS: 35010A98,
static const uint64_t P9N2_C_21_SPATTN_SCOM2                                       = 0x35010A97ull;
//DUPS: 35010A97,
static const uint64_t P9N2_C_22_SPATTN_SCOM                                        = 0x36010A99ull;
//DUPS: 36010A99,
static const uint64_t P9N2_C_22_SPATTN_SCOM1                                       = 0x36010A98ull;
//DUPS: 36010A98,
static const uint64_t P9N2_C_22_SPATTN_SCOM2                                       = 0x36010A97ull;
//DUPS: 36010A97,
static const uint64_t P9N2_C_23_SPATTN_SCOM                                        = 0x37010A99ull;
//DUPS: 37010A99,
static const uint64_t P9N2_C_23_SPATTN_SCOM1                                       = 0x37010A98ull;
//DUPS: 37010A98,
static const uint64_t P9N2_C_23_SPATTN_SCOM2                                       = 0x37010A97ull;
//DUPS: 37010A97,
static const uint64_t P9N2_EQ_SPATTN_SCOM                                          = 0x10040004ull;

static const uint64_t P9N2_EQ_SPATTN_SCOM1                                         = 0x10040005ull;

static const uint64_t P9N2_EQ_SPATTN_SCOM2                                         = 0x10040006ull;

static const uint64_t P9N2_EQ_0_SPATTN_SCOM                                        = 0x10040004ull;

static const uint64_t P9N2_EQ_0_SPATTN_SCOM1                                       = 0x10040005ull;

static const uint64_t P9N2_EQ_0_SPATTN_SCOM2                                       = 0x10040006ull;

static const uint64_t P9N2_EQ_1_SPATTN_SCOM                                        = 0x11040004ull;

static const uint64_t P9N2_EQ_1_SPATTN_SCOM1                                       = 0x11040005ull;

static const uint64_t P9N2_EQ_1_SPATTN_SCOM2                                       = 0x11040006ull;

static const uint64_t P9N2_EQ_2_SPATTN_SCOM                                        = 0x12040004ull;

static const uint64_t P9N2_EQ_2_SPATTN_SCOM1                                       = 0x12040005ull;

static const uint64_t P9N2_EQ_2_SPATTN_SCOM2                                       = 0x12040006ull;

static const uint64_t P9N2_EQ_3_SPATTN_SCOM                                        = 0x13040004ull;

static const uint64_t P9N2_EQ_3_SPATTN_SCOM1                                       = 0x13040005ull;

static const uint64_t P9N2_EQ_3_SPATTN_SCOM2                                       = 0x13040006ull;

static const uint64_t P9N2_EQ_4_SPATTN_SCOM                                        = 0x14040004ull;

static const uint64_t P9N2_EQ_4_SPATTN_SCOM1                                       = 0x14040005ull;

static const uint64_t P9N2_EQ_4_SPATTN_SCOM2                                       = 0x14040006ull;

static const uint64_t P9N2_EQ_5_SPATTN_SCOM                                        = 0x15040004ull;

static const uint64_t P9N2_EQ_5_SPATTN_SCOM1                                       = 0x15040005ull;

static const uint64_t P9N2_EQ_5_SPATTN_SCOM2                                       = 0x15040006ull;

static const uint64_t P9N2_EX_SPATTN_SCOM                                          = 0x20010A99ull;
//DUPS: 21040004, 21010A99, 20010A99,
static const uint64_t P9N2_EX_SPATTN_SCOM1                                         = 0x20010A98ull;
//DUPS: 21040005, 21010A98, 20010A98,
static const uint64_t P9N2_EX_SPATTN_SCOM2                                         = 0x20040006ull;
//DUPS: 21040006,
static const uint64_t P9N2_EX_0_SPATTN_SCOM                                        = 0x20010A99ull;
//DUPS: 21040004, 21010A99, 20010A99,
static const uint64_t P9N2_EX_0_SPATTN_SCOM1                                       = 0x20010A98ull;
//DUPS: 21040005, 21010A98, 20010A98,
static const uint64_t P9N2_EX_0_SPATTN_SCOM2                                       = 0x20040006ull;
//DUPS: 21040006,
static const uint64_t P9N2_EX_1_SPATTN_SCOM                                        = 0x22010A99ull;
//DUPS: 23040004, 23010A99, 22010A99,
static const uint64_t P9N2_EX_1_SPATTN_SCOM1                                       = 0x22010A98ull;
//DUPS: 23040005, 23010A98, 22010A98,
static const uint64_t P9N2_EX_1_SPATTN_SCOM2                                       = 0x22040006ull;
//DUPS: 23040006,
static const uint64_t P9N2_EX_2_SPATTN_SCOM                                        = 0x24010A99ull;
//DUPS: 25040004, 25010A99, 24010A99,
static const uint64_t P9N2_EX_2_SPATTN_SCOM1                                       = 0x24010A98ull;
//DUPS: 25040005, 25010A98, 24010A98,
static const uint64_t P9N2_EX_2_SPATTN_SCOM2                                       = 0x24040006ull;
//DUPS: 25040006,
static const uint64_t P9N2_EX_3_SPATTN_SCOM                                        = 0x26010A99ull;
//DUPS: 27040004, 27010A99, 26010A99,
static const uint64_t P9N2_EX_3_SPATTN_SCOM1                                       = 0x26010A98ull;
//DUPS: 27040005, 27010A98, 26010A98,
static const uint64_t P9N2_EX_3_SPATTN_SCOM2                                       = 0x26040006ull;
//DUPS: 27040006,
static const uint64_t P9N2_EX_4_SPATTN_SCOM                                        = 0x28010A99ull;
//DUPS: 29040004, 29010A99, 28010A99,
static const uint64_t P9N2_EX_4_SPATTN_SCOM1                                       = 0x28010A98ull;
//DUPS: 29040005, 29010A98, 28010A98,
static const uint64_t P9N2_EX_4_SPATTN_SCOM2                                       = 0x28040006ull;
//DUPS: 29040006,
static const uint64_t P9N2_EX_5_SPATTN_SCOM                                        = 0x2A040004ull;
//DUPS: 2B040004, 2B010A99, 2A010A99,
static const uint64_t P9N2_EX_5_SPATTN_SCOM1                                       = 0x2A040005ull;
//DUPS: 2B040005, 2B010A98, 2A010A98,
static const uint64_t P9N2_EX_5_SPATTN_SCOM2                                       = 0x2A040006ull;
//DUPS: 2B040006,
static const uint64_t P9N2_EX_6_SPATTN_SCOM                                        = 0x2C040004ull;
//DUPS: 2D040004, 2D010A99, 2C010A99,
static const uint64_t P9N2_EX_6_SPATTN_SCOM1                                       = 0x2C040005ull;
//DUPS: 2D040005, 2D010A98, 2C010A98,
static const uint64_t P9N2_EX_6_SPATTN_SCOM2                                       = 0x2C040006ull;
//DUPS: 2D040006,
static const uint64_t P9N2_EX_7_SPATTN_SCOM                                        = 0x2F040004ull;
//DUPS: 2F040004, 2F010A99, 2E010A99,
static const uint64_t P9N2_EX_7_SPATTN_SCOM1                                       = 0x2F040005ull;
//DUPS: 2F040005, 2F010A98, 2E010A98,
static const uint64_t P9N2_EX_7_SPATTN_SCOM2                                       = 0x2F040006ull;
//DUPS: 2F040006,
static const uint64_t P9N2_EX_8_SPATTN_SCOM                                        = 0x30010A99ull;
//DUPS: 31040004, 31010A99, 30010A99,
static const uint64_t P9N2_EX_8_SPATTN_SCOM1                                       = 0x30010A98ull;
//DUPS: 31040005, 31010A98, 30010A98,
static const uint64_t P9N2_EX_8_SPATTN_SCOM2                                       = 0x30040006ull;
//DUPS: 31040006,
static const uint64_t P9N2_EX_9_SPATTN_SCOM                                        = 0x32010A99ull;
//DUPS: 33040004, 33010A99, 32010A99,
static const uint64_t P9N2_EX_9_SPATTN_SCOM1                                       = 0x32010A98ull;
//DUPS: 33040005, 33010A98, 32010A98,
static const uint64_t P9N2_EX_9_SPATTN_SCOM2                                       = 0x32040006ull;
//DUPS: 33040006,
static const uint64_t P9N2_EX_0_L2_SPATTN                                          = 0x20010A97ull;
//DUPS: 20010A97,
static const uint64_t P9N2_EX_10_SPATTN_SCOM                                       = 0x34010A99ull;
//DUPS: 35040004, 35010A99, 34010A99,
static const uint64_t P9N2_EX_10_SPATTN_SCOM1                                      = 0x34010A98ull;
//DUPS: 35040005, 35010A98, 34010A98,
static const uint64_t P9N2_EX_10_SPATTN_SCOM2                                      = 0x34040006ull;
//DUPS: 35040006,
static const uint64_t P9N2_EX_11_SPATTN_SCOM                                       = 0x36010A99ull;
//DUPS: 37040004, 37010A99, 36010A99,
static const uint64_t P9N2_EX_11_SPATTN_SCOM1                                      = 0x36010A98ull;
//DUPS: 37040005, 37010A98, 36010A98,
static const uint64_t P9N2_EX_11_SPATTN_SCOM2                                      = 0x36040006ull;
//DUPS: 37040006,
static const uint64_t P9N2_EX_10_L2_SPATTN                                         = 0x34010A97ull;
//DUPS: 34010A97,
static const uint64_t P9N2_EX_11_L2_SPATTN                                         = 0x36010A97ull;
//DUPS: 36010A97,
static const uint64_t P9N2_EX_1_L2_SPATTN                                          = 0x22010A97ull;
//DUPS: 22010A97,
static const uint64_t P9N2_EX_2_L2_SPATTN                                          = 0x24010A97ull;
//DUPS: 24010A97,
static const uint64_t P9N2_EX_3_L2_SPATTN                                          = 0x26010A97ull;
//DUPS: 26010A97,
static const uint64_t P9N2_EX_4_L2_SPATTN                                          = 0x28010A97ull;
//DUPS: 28010A97,
static const uint64_t P9N2_EX_5_L2_SPATTN                                          = 0x2B010A97ull;
//DUPS: 2A010A97,
static const uint64_t P9N2_EX_6_L2_SPATTN                                          = 0x2D010A97ull;
//DUPS: 2C010A97,
static const uint64_t P9N2_EX_7_L2_SPATTN                                          = 0x2F010A97ull;
//DUPS: 2E010A97,
static const uint64_t P9N2_EX_8_L2_SPATTN                                          = 0x30010A97ull;
//DUPS: 30010A97,
static const uint64_t P9N2_EX_9_L2_SPATTN                                          = 0x32010A97ull;
//DUPS: 32010A97,
static const uint64_t P9N2_EX_L2_SPATTN                                            = 0x20010A97ull;
//DUPS: 20010A97,

static const uint64_t P9N2_C_SPATTN_MASK                                           = 0x20010A9Aull;

static const uint64_t P9N2_C_0_SPATTN_MASK                                         = 0x20010A9Aull;

static const uint64_t P9N2_C_1_SPATTN_MASK                                         = 0x21010A9Aull;

static const uint64_t P9N2_C_2_SPATTN_MASK                                         = 0x22010A9Aull;

static const uint64_t P9N2_C_3_SPATTN_MASK                                         = 0x23010A9Aull;

static const uint64_t P9N2_C_4_SPATTN_MASK                                         = 0x24010A9Aull;

static const uint64_t P9N2_C_5_SPATTN_MASK                                         = 0x25010A9Aull;

static const uint64_t P9N2_C_6_SPATTN_MASK                                         = 0x26010A9Aull;

static const uint64_t P9N2_C_7_SPATTN_MASK                                         = 0x27010A9Aull;

static const uint64_t P9N2_C_8_SPATTN_MASK                                         = 0x28010A9Aull;

static const uint64_t P9N2_C_9_SPATTN_MASK                                         = 0x29010A9Aull;

static const uint64_t P9N2_C_10_SPATTN_MASK                                        = 0x2A010A9Aull;

static const uint64_t P9N2_C_11_SPATTN_MASK                                        = 0x2B010A9Aull;

static const uint64_t P9N2_C_12_SPATTN_MASK                                        = 0x2C010A9Aull;

static const uint64_t P9N2_C_13_SPATTN_MASK                                        = 0x2D010A9Aull;

static const uint64_t P9N2_C_14_SPATTN_MASK                                        = 0x2E010A9Aull;

static const uint64_t P9N2_C_15_SPATTN_MASK                                        = 0x2F010A9Aull;

static const uint64_t P9N2_C_16_SPATTN_MASK                                        = 0x30010A9Aull;

static const uint64_t P9N2_C_17_SPATTN_MASK                                        = 0x31010A9Aull;

static const uint64_t P9N2_C_18_SPATTN_MASK                                        = 0x32010A9Aull;

static const uint64_t P9N2_C_19_SPATTN_MASK                                        = 0x33010A9Aull;

static const uint64_t P9N2_C_20_SPATTN_MASK                                        = 0x34010A9Aull;

static const uint64_t P9N2_C_21_SPATTN_MASK                                        = 0x35010A9Aull;

static const uint64_t P9N2_C_22_SPATTN_MASK                                        = 0x36010A9Aull;

static const uint64_t P9N2_C_23_SPATTN_MASK                                        = 0x37010A9Aull;

static const uint64_t P9N2_EX_0_L2_SPATTN_MASK                                     = 0x20010A9Aull;
//DUPS: 20010A9A,
static const uint64_t P9N2_EX_10_L2_SPATTN_MASK                                    = 0x34010A9Aull;
//DUPS: 34010A9A,
static const uint64_t P9N2_EX_11_L2_SPATTN_MASK                                    = 0x36010A9Aull;
//DUPS: 36010A9A,
static const uint64_t P9N2_EX_1_L2_SPATTN_MASK                                     = 0x22010A9Aull;
//DUPS: 22010A9A,
static const uint64_t P9N2_EX_2_L2_SPATTN_MASK                                     = 0x24010A9Aull;
//DUPS: 24010A9A,
static const uint64_t P9N2_EX_3_L2_SPATTN_MASK                                     = 0x26010A9Aull;
//DUPS: 26010A9A,
static const uint64_t P9N2_EX_4_L2_SPATTN_MASK                                     = 0x28010A9Aull;
//DUPS: 28010A9A,
static const uint64_t P9N2_EX_5_L2_SPATTN_MASK                                     = 0x2B010A9Aull;
//DUPS: 2A010A9A,
static const uint64_t P9N2_EX_6_L2_SPATTN_MASK                                     = 0x2D010A9Aull;
//DUPS: 2C010A9A,
static const uint64_t P9N2_EX_7_L2_SPATTN_MASK                                     = 0x2F010A9Aull;
//DUPS: 2E010A9A,
static const uint64_t P9N2_EX_8_L2_SPATTN_MASK                                     = 0x30010A9Aull;
//DUPS: 30010A9A,
static const uint64_t P9N2_EX_9_L2_SPATTN_MASK                                     = 0x32010A9Aull;
//DUPS: 32010A9A,
static const uint64_t P9N2_EX_L2_SPATTN_MASK                                       = 0x20010A9Aull;
//DUPS: 20010A9A,

static const uint64_t P9N2_C_SPA_MASK                                              = 0x20040007ull;

static const uint64_t P9N2_C_0_SPA_MASK                                            = 0x20040007ull;

static const uint64_t P9N2_C_1_SPA_MASK                                            = 0x21040007ull;

static const uint64_t P9N2_C_2_SPA_MASK                                            = 0x22040007ull;

static const uint64_t P9N2_C_3_SPA_MASK                                            = 0x23040007ull;

static const uint64_t P9N2_C_4_SPA_MASK                                            = 0x24040007ull;

static const uint64_t P9N2_C_5_SPA_MASK                                            = 0x25040007ull;

static const uint64_t P9N2_C_6_SPA_MASK                                            = 0x26040007ull;

static const uint64_t P9N2_C_7_SPA_MASK                                            = 0x27040007ull;

static const uint64_t P9N2_C_8_SPA_MASK                                            = 0x28040007ull;

static const uint64_t P9N2_C_9_SPA_MASK                                            = 0x29040007ull;

static const uint64_t P9N2_C_10_SPA_MASK                                           = 0x2A040007ull;

static const uint64_t P9N2_C_11_SPA_MASK                                           = 0x2B040007ull;

static const uint64_t P9N2_C_12_SPA_MASK                                           = 0x2C040007ull;

static const uint64_t P9N2_C_13_SPA_MASK                                           = 0x2D040007ull;

static const uint64_t P9N2_C_14_SPA_MASK                                           = 0x2E040007ull;

static const uint64_t P9N2_C_15_SPA_MASK                                           = 0x2F040007ull;

static const uint64_t P9N2_C_16_SPA_MASK                                           = 0x30040007ull;

static const uint64_t P9N2_C_17_SPA_MASK                                           = 0x31040007ull;

static const uint64_t P9N2_C_18_SPA_MASK                                           = 0x32040007ull;

static const uint64_t P9N2_C_19_SPA_MASK                                           = 0x33040007ull;

static const uint64_t P9N2_C_20_SPA_MASK                                           = 0x34040007ull;

static const uint64_t P9N2_C_21_SPA_MASK                                           = 0x35040007ull;

static const uint64_t P9N2_C_22_SPA_MASK                                           = 0x36040007ull;

static const uint64_t P9N2_C_23_SPA_MASK                                           = 0x37040007ull;

static const uint64_t P9N2_EQ_SPA_MASK                                             = 0x10040007ull;

static const uint64_t P9N2_EQ_0_SPA_MASK                                           = 0x10040007ull;

static const uint64_t P9N2_EQ_1_SPA_MASK                                           = 0x11040007ull;

static const uint64_t P9N2_EQ_2_SPA_MASK                                           = 0x12040007ull;

static const uint64_t P9N2_EQ_3_SPA_MASK                                           = 0x13040007ull;

static const uint64_t P9N2_EQ_4_SPA_MASK                                           = 0x14040007ull;

static const uint64_t P9N2_EQ_5_SPA_MASK                                           = 0x15040007ull;

static const uint64_t P9N2_EX_SPA_MASK                                             = 0x20040007ull;
//DUPS: 21040007,
static const uint64_t P9N2_EX_0_SPA_MASK                                           = 0x20040007ull;
//DUPS: 21040007,
static const uint64_t P9N2_EX_1_SPA_MASK                                           = 0x22040007ull;
//DUPS: 23040007,
static const uint64_t P9N2_EX_2_SPA_MASK                                           = 0x24040007ull;
//DUPS: 25040007,
static const uint64_t P9N2_EX_3_SPA_MASK                                           = 0x26040007ull;
//DUPS: 27040007,
static const uint64_t P9N2_EX_4_SPA_MASK                                           = 0x28040007ull;
//DUPS: 29040007,
static const uint64_t P9N2_EX_5_SPA_MASK                                           = 0x2A040007ull;
//DUPS: 2B040007,
static const uint64_t P9N2_EX_6_SPA_MASK                                           = 0x2C040007ull;
//DUPS: 2D040007,
static const uint64_t P9N2_EX_7_SPA_MASK                                           = 0x2F040007ull;
//DUPS: 2F040007,
static const uint64_t P9N2_EX_8_SPA_MASK                                           = 0x30040007ull;
//DUPS: 31040007,
static const uint64_t P9N2_EX_9_SPA_MASK                                           = 0x32040007ull;
//DUPS: 33040007,
static const uint64_t P9N2_EX_10_SPA_MASK                                          = 0x34040007ull;
//DUPS: 35040007,
static const uint64_t P9N2_EX_11_SPA_MASK                                          = 0x36040007ull;
//DUPS: 37040007,

static const uint64_t P9N2_C_SPR_COMMON_HOLD_OUT                                   = 0x20010AB8ull;

static const uint64_t P9N2_C_0_SPR_COMMON_HOLD_OUT                                 = 0x20010AB8ull;

static const uint64_t P9N2_C_1_SPR_COMMON_HOLD_OUT                                 = 0x21010AB8ull;

static const uint64_t P9N2_C_2_SPR_COMMON_HOLD_OUT                                 = 0x22010AB8ull;

static const uint64_t P9N2_C_3_SPR_COMMON_HOLD_OUT                                 = 0x23010AB8ull;

static const uint64_t P9N2_C_4_SPR_COMMON_HOLD_OUT                                 = 0x24010AB8ull;

static const uint64_t P9N2_C_5_SPR_COMMON_HOLD_OUT                                 = 0x25010AB8ull;

static const uint64_t P9N2_C_6_SPR_COMMON_HOLD_OUT                                 = 0x26010AB8ull;

static const uint64_t P9N2_C_7_SPR_COMMON_HOLD_OUT                                 = 0x27010AB8ull;

static const uint64_t P9N2_C_8_SPR_COMMON_HOLD_OUT                                 = 0x28010AB8ull;

static const uint64_t P9N2_C_9_SPR_COMMON_HOLD_OUT                                 = 0x29010AB8ull;

static const uint64_t P9N2_C_10_SPR_COMMON_HOLD_OUT                                = 0x2A010AB8ull;

static const uint64_t P9N2_C_11_SPR_COMMON_HOLD_OUT                                = 0x2B010AB8ull;

static const uint64_t P9N2_C_12_SPR_COMMON_HOLD_OUT                                = 0x2C010AB8ull;

static const uint64_t P9N2_C_13_SPR_COMMON_HOLD_OUT                                = 0x2D010AB8ull;

static const uint64_t P9N2_C_14_SPR_COMMON_HOLD_OUT                                = 0x2E010AB8ull;

static const uint64_t P9N2_C_15_SPR_COMMON_HOLD_OUT                                = 0x2F010AB8ull;

static const uint64_t P9N2_C_16_SPR_COMMON_HOLD_OUT                                = 0x30010AB8ull;

static const uint64_t P9N2_C_17_SPR_COMMON_HOLD_OUT                                = 0x31010AB8ull;

static const uint64_t P9N2_C_18_SPR_COMMON_HOLD_OUT                                = 0x32010AB8ull;

static const uint64_t P9N2_C_19_SPR_COMMON_HOLD_OUT                                = 0x33010AB8ull;

static const uint64_t P9N2_C_20_SPR_COMMON_HOLD_OUT                                = 0x34010AB8ull;

static const uint64_t P9N2_C_21_SPR_COMMON_HOLD_OUT                                = 0x35010AB8ull;

static const uint64_t P9N2_C_22_SPR_COMMON_HOLD_OUT                                = 0x36010AB8ull;

static const uint64_t P9N2_C_23_SPR_COMMON_HOLD_OUT                                = 0x37010AB8ull;

static const uint64_t P9N2_EX_SPR_COMMON_HOLD_OUT                                  = 0x20010AB8ull;
//DUPS: 20010AB8,
static const uint64_t P9N2_EX_0_SPR_COMMON_HOLD_OUT                                = 0x20010AB8ull;
//DUPS: 20010AB8,
static const uint64_t P9N2_EX_1_SPR_COMMON_HOLD_OUT                                = 0x22010AB8ull;
//DUPS: 22010AB8,
static const uint64_t P9N2_EX_2_SPR_COMMON_HOLD_OUT                                = 0x24010AB8ull;
//DUPS: 24010AB8,
static const uint64_t P9N2_EX_3_SPR_COMMON_HOLD_OUT                                = 0x26010AB8ull;
//DUPS: 26010AB8,
static const uint64_t P9N2_EX_4_SPR_COMMON_HOLD_OUT                                = 0x28010AB8ull;
//DUPS: 28010AB8,
static const uint64_t P9N2_EX_5_SPR_COMMON_HOLD_OUT                                = 0x2B010AB8ull;
//DUPS: 2A010AB8,
static const uint64_t P9N2_EX_6_SPR_COMMON_HOLD_OUT                                = 0x2D010AB8ull;
//DUPS: 2C010AB8,
static const uint64_t P9N2_EX_7_SPR_COMMON_HOLD_OUT                                = 0x2F010AB8ull;
//DUPS: 2E010AB8,
static const uint64_t P9N2_EX_8_SPR_COMMON_HOLD_OUT                                = 0x30010AB8ull;
//DUPS: 30010AB8,
static const uint64_t P9N2_EX_9_SPR_COMMON_HOLD_OUT                                = 0x32010AB8ull;
//DUPS: 32010AB8,
static const uint64_t P9N2_EX_10_SPR_COMMON_HOLD_OUT                               = 0x34010AB8ull;
//DUPS: 34010AB8,
static const uint64_t P9N2_EX_11_SPR_COMMON_HOLD_OUT                               = 0x36010AB8ull;
//DUPS: 36010AB8,

static const uint64_t P9N2_C_SPR_CORE_HOLD_OUT                                     = 0x20010AB5ull;

static const uint64_t P9N2_C_0_SPR_CORE_HOLD_OUT                                   = 0x20010AB5ull;

static const uint64_t P9N2_C_1_SPR_CORE_HOLD_OUT                                   = 0x21010AB5ull;

static const uint64_t P9N2_C_2_SPR_CORE_HOLD_OUT                                   = 0x22010AB5ull;

static const uint64_t P9N2_C_3_SPR_CORE_HOLD_OUT                                   = 0x23010AB5ull;

static const uint64_t P9N2_C_4_SPR_CORE_HOLD_OUT                                   = 0x24010AB5ull;

static const uint64_t P9N2_C_5_SPR_CORE_HOLD_OUT                                   = 0x25010AB5ull;

static const uint64_t P9N2_C_6_SPR_CORE_HOLD_OUT                                   = 0x26010AB5ull;

static const uint64_t P9N2_C_7_SPR_CORE_HOLD_OUT                                   = 0x27010AB5ull;

static const uint64_t P9N2_C_8_SPR_CORE_HOLD_OUT                                   = 0x28010AB5ull;

static const uint64_t P9N2_C_9_SPR_CORE_HOLD_OUT                                   = 0x29010AB5ull;

static const uint64_t P9N2_C_10_SPR_CORE_HOLD_OUT                                  = 0x2A010AB5ull;

static const uint64_t P9N2_C_11_SPR_CORE_HOLD_OUT                                  = 0x2B010AB5ull;

static const uint64_t P9N2_C_12_SPR_CORE_HOLD_OUT                                  = 0x2C010AB5ull;

static const uint64_t P9N2_C_13_SPR_CORE_HOLD_OUT                                  = 0x2D010AB5ull;

static const uint64_t P9N2_C_14_SPR_CORE_HOLD_OUT                                  = 0x2E010AB5ull;

static const uint64_t P9N2_C_15_SPR_CORE_HOLD_OUT                                  = 0x2F010AB5ull;

static const uint64_t P9N2_C_16_SPR_CORE_HOLD_OUT                                  = 0x30010AB5ull;

static const uint64_t P9N2_C_17_SPR_CORE_HOLD_OUT                                  = 0x31010AB5ull;

static const uint64_t P9N2_C_18_SPR_CORE_HOLD_OUT                                  = 0x32010AB5ull;

static const uint64_t P9N2_C_19_SPR_CORE_HOLD_OUT                                  = 0x33010AB5ull;

static const uint64_t P9N2_C_20_SPR_CORE_HOLD_OUT                                  = 0x34010AB5ull;

static const uint64_t P9N2_C_21_SPR_CORE_HOLD_OUT                                  = 0x35010AB5ull;

static const uint64_t P9N2_C_22_SPR_CORE_HOLD_OUT                                  = 0x36010AB5ull;

static const uint64_t P9N2_C_23_SPR_CORE_HOLD_OUT                                  = 0x37010AB5ull;

static const uint64_t P9N2_EX_0_L2_SPR_CORE_HOLD_OUT                               = 0x20010AB5ull;
//DUPS: 21010AB5,
static const uint64_t P9N2_EX_10_L2_SPR_CORE_HOLD_OUT                              = 0x34010AB5ull;
//DUPS: 35010AB5,
static const uint64_t P9N2_EX_11_L2_SPR_CORE_HOLD_OUT                              = 0x36010AB5ull;
//DUPS: 37010AB5,
static const uint64_t P9N2_EX_1_L2_SPR_CORE_HOLD_OUT                               = 0x22010AB5ull;
//DUPS: 23010AB5,
static const uint64_t P9N2_EX_2_L2_SPR_CORE_HOLD_OUT                               = 0x24010AB5ull;
//DUPS: 25010AB5,
static const uint64_t P9N2_EX_3_L2_SPR_CORE_HOLD_OUT                               = 0x26010AB5ull;
//DUPS: 27010AB5,
static const uint64_t P9N2_EX_4_L2_SPR_CORE_HOLD_OUT                               = 0x28010AB5ull;
//DUPS: 29010AB5,
static const uint64_t P9N2_EX_5_L2_SPR_CORE_HOLD_OUT                               = 0x2A010AB5ull;
//DUPS: 2B010AB5,
static const uint64_t P9N2_EX_6_L2_SPR_CORE_HOLD_OUT                               = 0x2C010AB5ull;
//DUPS: 2D010AB5,
static const uint64_t P9N2_EX_7_L2_SPR_CORE_HOLD_OUT                               = 0x2F010AB5ull;
//DUPS: 2F010AB5,
static const uint64_t P9N2_EX_8_L2_SPR_CORE_HOLD_OUT                               = 0x30010AB5ull;
//DUPS: 31010AB5,
static const uint64_t P9N2_EX_9_L2_SPR_CORE_HOLD_OUT                               = 0x32010AB5ull;
//DUPS: 33010AB5,
static const uint64_t P9N2_EX_L2_SPR_CORE_HOLD_OUT                                 = 0x20010AB5ull;
//DUPS: 21010AB5,

static const uint64_t P9N2_C_SPR_MODE                                              = 0x20010A84ull;

static const uint64_t P9N2_C_0_SPR_MODE                                            = 0x20010A84ull;

static const uint64_t P9N2_C_1_SPR_MODE                                            = 0x21010A84ull;

static const uint64_t P9N2_C_2_SPR_MODE                                            = 0x22010A84ull;

static const uint64_t P9N2_C_3_SPR_MODE                                            = 0x23010A84ull;

static const uint64_t P9N2_C_4_SPR_MODE                                            = 0x24010A84ull;

static const uint64_t P9N2_C_5_SPR_MODE                                            = 0x25010A84ull;

static const uint64_t P9N2_C_6_SPR_MODE                                            = 0x26010A84ull;

static const uint64_t P9N2_C_7_SPR_MODE                                            = 0x27010A84ull;

static const uint64_t P9N2_C_8_SPR_MODE                                            = 0x28010A84ull;

static const uint64_t P9N2_C_9_SPR_MODE                                            = 0x29010A84ull;

static const uint64_t P9N2_C_10_SPR_MODE                                           = 0x2A010A84ull;

static const uint64_t P9N2_C_11_SPR_MODE                                           = 0x2B010A84ull;

static const uint64_t P9N2_C_12_SPR_MODE                                           = 0x2C010A84ull;

static const uint64_t P9N2_C_13_SPR_MODE                                           = 0x2D010A84ull;

static const uint64_t P9N2_C_14_SPR_MODE                                           = 0x2E010A84ull;

static const uint64_t P9N2_C_15_SPR_MODE                                           = 0x2F010A84ull;

static const uint64_t P9N2_C_16_SPR_MODE                                           = 0x30010A84ull;

static const uint64_t P9N2_C_17_SPR_MODE                                           = 0x31010A84ull;

static const uint64_t P9N2_C_18_SPR_MODE                                           = 0x32010A84ull;

static const uint64_t P9N2_C_19_SPR_MODE                                           = 0x33010A84ull;

static const uint64_t P9N2_C_20_SPR_MODE                                           = 0x34010A84ull;

static const uint64_t P9N2_C_21_SPR_MODE                                           = 0x35010A84ull;

static const uint64_t P9N2_C_22_SPR_MODE                                           = 0x36010A84ull;

static const uint64_t P9N2_C_23_SPR_MODE                                           = 0x37010A84ull;

static const uint64_t P9N2_EX_0_L2_SPR_MODE                                        = 0x20010A84ull;
//DUPS: 20010A84,
static const uint64_t P9N2_EX_10_L2_SPR_MODE                                       = 0x34010A84ull;
//DUPS: 34010A84,
static const uint64_t P9N2_EX_11_L2_SPR_MODE                                       = 0x36010A84ull;
//DUPS: 36010A84,
static const uint64_t P9N2_EX_1_L2_SPR_MODE                                        = 0x22010A84ull;
//DUPS: 22010A84,
static const uint64_t P9N2_EX_2_L2_SPR_MODE                                        = 0x24010A84ull;
//DUPS: 24010A84,
static const uint64_t P9N2_EX_3_L2_SPR_MODE                                        = 0x26010A84ull;
//DUPS: 26010A84,
static const uint64_t P9N2_EX_4_L2_SPR_MODE                                        = 0x28010A84ull;
//DUPS: 28010A84,
static const uint64_t P9N2_EX_5_L2_SPR_MODE                                        = 0x2B010A84ull;
//DUPS: 2A010A84,
static const uint64_t P9N2_EX_6_L2_SPR_MODE                                        = 0x2D010A84ull;
//DUPS: 2C010A84,
static const uint64_t P9N2_EX_7_L2_SPR_MODE                                        = 0x2F010A84ull;
//DUPS: 2E010A84,
static const uint64_t P9N2_EX_8_L2_SPR_MODE                                        = 0x30010A84ull;
//DUPS: 30010A84,
static const uint64_t P9N2_EX_9_L2_SPR_MODE                                        = 0x32010A84ull;
//DUPS: 32010A84,
static const uint64_t P9N2_EX_L2_SPR_MODE                                          = 0x20010A84ull;
//DUPS: 20010A84,

static const uint64_t P9N2_C_SPURR_FREQ_DETECT_CYC_CNT                             = 0x20010A9Full;

static const uint64_t P9N2_C_0_SPURR_FREQ_DETECT_CYC_CNT                           = 0x20010A9Full;

static const uint64_t P9N2_C_1_SPURR_FREQ_DETECT_CYC_CNT                           = 0x21010A9Full;

static const uint64_t P9N2_C_2_SPURR_FREQ_DETECT_CYC_CNT                           = 0x22010A9Full;

static const uint64_t P9N2_C_3_SPURR_FREQ_DETECT_CYC_CNT                           = 0x23010A9Full;

static const uint64_t P9N2_C_4_SPURR_FREQ_DETECT_CYC_CNT                           = 0x24010A9Full;

static const uint64_t P9N2_C_5_SPURR_FREQ_DETECT_CYC_CNT                           = 0x25010A9Full;

static const uint64_t P9N2_C_6_SPURR_FREQ_DETECT_CYC_CNT                           = 0x26010A9Full;

static const uint64_t P9N2_C_7_SPURR_FREQ_DETECT_CYC_CNT                           = 0x27010A9Full;

static const uint64_t P9N2_C_8_SPURR_FREQ_DETECT_CYC_CNT                           = 0x28010A9Full;

static const uint64_t P9N2_C_9_SPURR_FREQ_DETECT_CYC_CNT                           = 0x29010A9Full;

static const uint64_t P9N2_C_10_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2A010A9Full;

static const uint64_t P9N2_C_11_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2B010A9Full;

static const uint64_t P9N2_C_12_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2C010A9Full;

static const uint64_t P9N2_C_13_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2D010A9Full;

static const uint64_t P9N2_C_14_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2E010A9Full;

static const uint64_t P9N2_C_15_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2F010A9Full;

static const uint64_t P9N2_C_16_SPURR_FREQ_DETECT_CYC_CNT                          = 0x30010A9Full;

static const uint64_t P9N2_C_17_SPURR_FREQ_DETECT_CYC_CNT                          = 0x31010A9Full;

static const uint64_t P9N2_C_18_SPURR_FREQ_DETECT_CYC_CNT                          = 0x32010A9Full;

static const uint64_t P9N2_C_19_SPURR_FREQ_DETECT_CYC_CNT                          = 0x33010A9Full;

static const uint64_t P9N2_C_20_SPURR_FREQ_DETECT_CYC_CNT                          = 0x34010A9Full;

static const uint64_t P9N2_C_21_SPURR_FREQ_DETECT_CYC_CNT                          = 0x35010A9Full;

static const uint64_t P9N2_C_22_SPURR_FREQ_DETECT_CYC_CNT                          = 0x36010A9Full;

static const uint64_t P9N2_C_23_SPURR_FREQ_DETECT_CYC_CNT                          = 0x37010A9Full;

static const uint64_t P9N2_EX_SPURR_FREQ_DETECT_CYC_CNT                            = 0x20010A9Full;
//DUPS: 20010A9F,
static const uint64_t P9N2_EX_0_SPURR_FREQ_DETECT_CYC_CNT                          = 0x20010A9Full;
//DUPS: 20010A9F,
static const uint64_t P9N2_EX_1_SPURR_FREQ_DETECT_CYC_CNT                          = 0x22010A9Full;
//DUPS: 22010A9F,
static const uint64_t P9N2_EX_2_SPURR_FREQ_DETECT_CYC_CNT                          = 0x24010A9Full;
//DUPS: 24010A9F,
static const uint64_t P9N2_EX_3_SPURR_FREQ_DETECT_CYC_CNT                          = 0x26010A9Full;
//DUPS: 26010A9F,
static const uint64_t P9N2_EX_4_SPURR_FREQ_DETECT_CYC_CNT                          = 0x28010A9Full;
//DUPS: 28010A9F,
static const uint64_t P9N2_EX_5_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2B010A9Full;
//DUPS: 2A010A9F,
static const uint64_t P9N2_EX_6_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2D010A9Full;
//DUPS: 2C010A9F,
static const uint64_t P9N2_EX_7_SPURR_FREQ_DETECT_CYC_CNT                          = 0x2F010A9Full;
//DUPS: 2E010A9F,
static const uint64_t P9N2_EX_8_SPURR_FREQ_DETECT_CYC_CNT                          = 0x30010A9Full;
//DUPS: 30010A9F,
static const uint64_t P9N2_EX_9_SPURR_FREQ_DETECT_CYC_CNT                          = 0x32010A9Full;
//DUPS: 32010A9F,
static const uint64_t P9N2_EX_10_SPURR_FREQ_DETECT_CYC_CNT                         = 0x34010A9Full;
//DUPS: 34010A9F,
static const uint64_t P9N2_EX_11_SPURR_FREQ_DETECT_CYC_CNT                         = 0x36010A9Full;
//DUPS: 36010A9F,

static const uint64_t P9N2_C_SPURR_FREQ_REF                                        = 0x20010AA1ull;

static const uint64_t P9N2_C_0_SPURR_FREQ_REF                                      = 0x20010AA1ull;

static const uint64_t P9N2_C_1_SPURR_FREQ_REF                                      = 0x21010AA1ull;

static const uint64_t P9N2_C_2_SPURR_FREQ_REF                                      = 0x22010AA1ull;

static const uint64_t P9N2_C_3_SPURR_FREQ_REF                                      = 0x23010AA1ull;

static const uint64_t P9N2_C_4_SPURR_FREQ_REF                                      = 0x24010AA1ull;

static const uint64_t P9N2_C_5_SPURR_FREQ_REF                                      = 0x25010AA1ull;

static const uint64_t P9N2_C_6_SPURR_FREQ_REF                                      = 0x26010AA1ull;

static const uint64_t P9N2_C_7_SPURR_FREQ_REF                                      = 0x27010AA1ull;

static const uint64_t P9N2_C_8_SPURR_FREQ_REF                                      = 0x28010AA1ull;

static const uint64_t P9N2_C_9_SPURR_FREQ_REF                                      = 0x29010AA1ull;

static const uint64_t P9N2_C_10_SPURR_FREQ_REF                                     = 0x2A010AA1ull;

static const uint64_t P9N2_C_11_SPURR_FREQ_REF                                     = 0x2B010AA1ull;

static const uint64_t P9N2_C_12_SPURR_FREQ_REF                                     = 0x2C010AA1ull;

static const uint64_t P9N2_C_13_SPURR_FREQ_REF                                     = 0x2D010AA1ull;

static const uint64_t P9N2_C_14_SPURR_FREQ_REF                                     = 0x2E010AA1ull;

static const uint64_t P9N2_C_15_SPURR_FREQ_REF                                     = 0x2F010AA1ull;

static const uint64_t P9N2_C_16_SPURR_FREQ_REF                                     = 0x30010AA1ull;

static const uint64_t P9N2_C_17_SPURR_FREQ_REF                                     = 0x31010AA1ull;

static const uint64_t P9N2_C_18_SPURR_FREQ_REF                                     = 0x32010AA1ull;

static const uint64_t P9N2_C_19_SPURR_FREQ_REF                                     = 0x33010AA1ull;

static const uint64_t P9N2_C_20_SPURR_FREQ_REF                                     = 0x34010AA1ull;

static const uint64_t P9N2_C_21_SPURR_FREQ_REF                                     = 0x35010AA1ull;

static const uint64_t P9N2_C_22_SPURR_FREQ_REF                                     = 0x36010AA1ull;

static const uint64_t P9N2_C_23_SPURR_FREQ_REF                                     = 0x37010AA1ull;

static const uint64_t P9N2_EX_0_L2_SPURR_FREQ_REF                                  = 0x20010AA1ull;
//DUPS: 20010AA1,
static const uint64_t P9N2_EX_10_L2_SPURR_FREQ_REF                                 = 0x34010AA1ull;
//DUPS: 34010AA1,
static const uint64_t P9N2_EX_11_L2_SPURR_FREQ_REF                                 = 0x36010AA1ull;
//DUPS: 36010AA1,
static const uint64_t P9N2_EX_1_L2_SPURR_FREQ_REF                                  = 0x22010AA1ull;
//DUPS: 22010AA1,
static const uint64_t P9N2_EX_2_L2_SPURR_FREQ_REF                                  = 0x24010AA1ull;
//DUPS: 24010AA1,
static const uint64_t P9N2_EX_3_L2_SPURR_FREQ_REF                                  = 0x26010AA1ull;
//DUPS: 26010AA1,
static const uint64_t P9N2_EX_4_L2_SPURR_FREQ_REF                                  = 0x28010AA1ull;
//DUPS: 28010AA1,
static const uint64_t P9N2_EX_5_L2_SPURR_FREQ_REF                                  = 0x2B010AA1ull;
//DUPS: 2A010AA1,
static const uint64_t P9N2_EX_6_L2_SPURR_FREQ_REF                                  = 0x2D010AA1ull;
//DUPS: 2C010AA1,
static const uint64_t P9N2_EX_7_L2_SPURR_FREQ_REF                                  = 0x2F010AA1ull;
//DUPS: 2E010AA1,
static const uint64_t P9N2_EX_8_L2_SPURR_FREQ_REF                                  = 0x30010AA1ull;
//DUPS: 30010AA1,
static const uint64_t P9N2_EX_9_L2_SPURR_FREQ_REF                                  = 0x32010AA1ull;
//DUPS: 32010AA1,
static const uint64_t P9N2_EX_L2_SPURR_FREQ_REF                                    = 0x20010AA1ull;
//DUPS: 20010AA1,

static const uint64_t P9N2_C_SPURR_FREQ_SCALE                                      = 0x20010AA0ull;

static const uint64_t P9N2_C_0_SPURR_FREQ_SCALE                                    = 0x20010AA0ull;

static const uint64_t P9N2_C_1_SPURR_FREQ_SCALE                                    = 0x21010AA0ull;

static const uint64_t P9N2_C_2_SPURR_FREQ_SCALE                                    = 0x22010AA0ull;

static const uint64_t P9N2_C_3_SPURR_FREQ_SCALE                                    = 0x23010AA0ull;

static const uint64_t P9N2_C_4_SPURR_FREQ_SCALE                                    = 0x24010AA0ull;

static const uint64_t P9N2_C_5_SPURR_FREQ_SCALE                                    = 0x25010AA0ull;

static const uint64_t P9N2_C_6_SPURR_FREQ_SCALE                                    = 0x26010AA0ull;

static const uint64_t P9N2_C_7_SPURR_FREQ_SCALE                                    = 0x27010AA0ull;

static const uint64_t P9N2_C_8_SPURR_FREQ_SCALE                                    = 0x28010AA0ull;

static const uint64_t P9N2_C_9_SPURR_FREQ_SCALE                                    = 0x29010AA0ull;

static const uint64_t P9N2_C_10_SPURR_FREQ_SCALE                                   = 0x2A010AA0ull;

static const uint64_t P9N2_C_11_SPURR_FREQ_SCALE                                   = 0x2B010AA0ull;

static const uint64_t P9N2_C_12_SPURR_FREQ_SCALE                                   = 0x2C010AA0ull;

static const uint64_t P9N2_C_13_SPURR_FREQ_SCALE                                   = 0x2D010AA0ull;

static const uint64_t P9N2_C_14_SPURR_FREQ_SCALE                                   = 0x2E010AA0ull;

static const uint64_t P9N2_C_15_SPURR_FREQ_SCALE                                   = 0x2F010AA0ull;

static const uint64_t P9N2_C_16_SPURR_FREQ_SCALE                                   = 0x30010AA0ull;

static const uint64_t P9N2_C_17_SPURR_FREQ_SCALE                                   = 0x31010AA0ull;

static const uint64_t P9N2_C_18_SPURR_FREQ_SCALE                                   = 0x32010AA0ull;

static const uint64_t P9N2_C_19_SPURR_FREQ_SCALE                                   = 0x33010AA0ull;

static const uint64_t P9N2_C_20_SPURR_FREQ_SCALE                                   = 0x34010AA0ull;

static const uint64_t P9N2_C_21_SPURR_FREQ_SCALE                                   = 0x35010AA0ull;

static const uint64_t P9N2_C_22_SPURR_FREQ_SCALE                                   = 0x36010AA0ull;

static const uint64_t P9N2_C_23_SPURR_FREQ_SCALE                                   = 0x37010AA0ull;

static const uint64_t P9N2_EX_0_L2_SPURR_FREQ_SCALE                                = 0x20010AA0ull;
//DUPS: 20010AA0,
static const uint64_t P9N2_EX_10_L2_SPURR_FREQ_SCALE                               = 0x34010AA0ull;
//DUPS: 34010AA0,
static const uint64_t P9N2_EX_11_L2_SPURR_FREQ_SCALE                               = 0x36010AA0ull;
//DUPS: 36010AA0,
static const uint64_t P9N2_EX_1_L2_SPURR_FREQ_SCALE                                = 0x22010AA0ull;
//DUPS: 22010AA0,
static const uint64_t P9N2_EX_2_L2_SPURR_FREQ_SCALE                                = 0x24010AA0ull;
//DUPS: 24010AA0,
static const uint64_t P9N2_EX_3_L2_SPURR_FREQ_SCALE                                = 0x26010AA0ull;
//DUPS: 26010AA0,
static const uint64_t P9N2_EX_4_L2_SPURR_FREQ_SCALE                                = 0x28010AA0ull;
//DUPS: 28010AA0,
static const uint64_t P9N2_EX_5_L2_SPURR_FREQ_SCALE                                = 0x2B010AA0ull;
//DUPS: 2A010AA0,
static const uint64_t P9N2_EX_6_L2_SPURR_FREQ_SCALE                                = 0x2D010AA0ull;
//DUPS: 2C010AA0,
static const uint64_t P9N2_EX_7_L2_SPURR_FREQ_SCALE                                = 0x2F010AA0ull;
//DUPS: 2E010AA0,
static const uint64_t P9N2_EX_8_L2_SPURR_FREQ_SCALE                                = 0x30010AA0ull;
//DUPS: 30010AA0,
static const uint64_t P9N2_EX_9_L2_SPURR_FREQ_SCALE                                = 0x32010AA0ull;
//DUPS: 32010AA0,
static const uint64_t P9N2_EX_L2_SPURR_FREQ_SCALE                                  = 0x20010AA0ull;
//DUPS: 20010AA0,

static const uint64_t P9N2_C_SRC_MASK                                              = 0x20010AAFull;

static const uint64_t P9N2_C_0_SRC_MASK                                            = 0x20010AAFull;

static const uint64_t P9N2_C_1_SRC_MASK                                            = 0x21010AAFull;

static const uint64_t P9N2_C_2_SRC_MASK                                            = 0x22010AAFull;

static const uint64_t P9N2_C_3_SRC_MASK                                            = 0x23010AAFull;

static const uint64_t P9N2_C_4_SRC_MASK                                            = 0x24010AAFull;

static const uint64_t P9N2_C_5_SRC_MASK                                            = 0x25010AAFull;

static const uint64_t P9N2_C_6_SRC_MASK                                            = 0x26010AAFull;

static const uint64_t P9N2_C_7_SRC_MASK                                            = 0x27010AAFull;

static const uint64_t P9N2_C_8_SRC_MASK                                            = 0x28010AAFull;

static const uint64_t P9N2_C_9_SRC_MASK                                            = 0x29010AAFull;

static const uint64_t P9N2_C_10_SRC_MASK                                           = 0x2A010AAFull;

static const uint64_t P9N2_C_11_SRC_MASK                                           = 0x2B010AAFull;

static const uint64_t P9N2_C_12_SRC_MASK                                           = 0x2C010AAFull;

static const uint64_t P9N2_C_13_SRC_MASK                                           = 0x2D010AAFull;

static const uint64_t P9N2_C_14_SRC_MASK                                           = 0x2E010AAFull;

static const uint64_t P9N2_C_15_SRC_MASK                                           = 0x2F010AAFull;

static const uint64_t P9N2_C_16_SRC_MASK                                           = 0x30010AAFull;

static const uint64_t P9N2_C_17_SRC_MASK                                           = 0x31010AAFull;

static const uint64_t P9N2_C_18_SRC_MASK                                           = 0x32010AAFull;

static const uint64_t P9N2_C_19_SRC_MASK                                           = 0x33010AAFull;

static const uint64_t P9N2_C_20_SRC_MASK                                           = 0x34010AAFull;

static const uint64_t P9N2_C_21_SRC_MASK                                           = 0x35010AAFull;

static const uint64_t P9N2_C_22_SRC_MASK                                           = 0x36010AAFull;

static const uint64_t P9N2_C_23_SRC_MASK                                           = 0x37010AAFull;

static const uint64_t P9N2_EX_SRC_MASK                                             = 0x20010AAFull;
//DUPS: 21010AAF,
static const uint64_t P9N2_EX_0_SRC_MASK                                           = 0x20010AAFull;
//DUPS: 21010AAF,
static const uint64_t P9N2_EX_1_SRC_MASK                                           = 0x22010AAFull;
//DUPS: 23010AAF,
static const uint64_t P9N2_EX_2_SRC_MASK                                           = 0x24010AAFull;
//DUPS: 25010AAF,
static const uint64_t P9N2_EX_3_SRC_MASK                                           = 0x26010AAFull;
//DUPS: 27010AAF,
static const uint64_t P9N2_EX_4_SRC_MASK                                           = 0x28010AAFull;
//DUPS: 29010AAF,
static const uint64_t P9N2_EX_5_SRC_MASK                                           = 0x2A010AAFull;
//DUPS: 2B010AAF,
static const uint64_t P9N2_EX_6_SRC_MASK                                           = 0x2C010AAFull;
//DUPS: 2D010AAF,
static const uint64_t P9N2_EX_7_SRC_MASK                                           = 0x2F010AAFull;
//DUPS: 2F010AAF,
static const uint64_t P9N2_EX_8_SRC_MASK                                           = 0x30010AAFull;
//DUPS: 31010AAF,
static const uint64_t P9N2_EX_9_SRC_MASK                                           = 0x32010AAFull;
//DUPS: 33010AAF,
static const uint64_t P9N2_EX_10_SRC_MASK                                          = 0x34010AAFull;
//DUPS: 35010AAF,
static const uint64_t P9N2_EX_11_SRC_MASK                                          = 0x36010AAFull;
//DUPS: 37010AAF,

static const uint64_t P9N2_C_SUM_MASK_REG                                          = 0x20040017ull;

static const uint64_t P9N2_C_0_SUM_MASK_REG                                        = 0x20040017ull;

static const uint64_t P9N2_C_1_SUM_MASK_REG                                        = 0x21040017ull;

static const uint64_t P9N2_C_2_SUM_MASK_REG                                        = 0x22040017ull;

static const uint64_t P9N2_C_3_SUM_MASK_REG                                        = 0x23040017ull;

static const uint64_t P9N2_C_4_SUM_MASK_REG                                        = 0x24040017ull;

static const uint64_t P9N2_C_5_SUM_MASK_REG                                        = 0x25040017ull;

static const uint64_t P9N2_C_6_SUM_MASK_REG                                        = 0x26040017ull;

static const uint64_t P9N2_C_7_SUM_MASK_REG                                        = 0x27040017ull;

static const uint64_t P9N2_C_8_SUM_MASK_REG                                        = 0x28040017ull;

static const uint64_t P9N2_C_9_SUM_MASK_REG                                        = 0x29040017ull;

static const uint64_t P9N2_C_10_SUM_MASK_REG                                       = 0x2A040017ull;

static const uint64_t P9N2_C_11_SUM_MASK_REG                                       = 0x2B040017ull;

static const uint64_t P9N2_C_12_SUM_MASK_REG                                       = 0x2C040017ull;

static const uint64_t P9N2_C_13_SUM_MASK_REG                                       = 0x2D040017ull;

static const uint64_t P9N2_C_14_SUM_MASK_REG                                       = 0x2E040017ull;

static const uint64_t P9N2_C_15_SUM_MASK_REG                                       = 0x2F040017ull;

static const uint64_t P9N2_C_16_SUM_MASK_REG                                       = 0x30040017ull;

static const uint64_t P9N2_C_17_SUM_MASK_REG                                       = 0x31040017ull;

static const uint64_t P9N2_C_18_SUM_MASK_REG                                       = 0x32040017ull;

static const uint64_t P9N2_C_19_SUM_MASK_REG                                       = 0x33040017ull;

static const uint64_t P9N2_C_20_SUM_MASK_REG                                       = 0x34040017ull;

static const uint64_t P9N2_C_21_SUM_MASK_REG                                       = 0x35040017ull;

static const uint64_t P9N2_C_22_SUM_MASK_REG                                       = 0x36040017ull;

static const uint64_t P9N2_C_23_SUM_MASK_REG                                       = 0x37040017ull;

static const uint64_t P9N2_EQ_SUM_MASK_REG                                         = 0x10040017ull;

static const uint64_t P9N2_EQ_0_SUM_MASK_REG                                       = 0x10040017ull;

static const uint64_t P9N2_EQ_1_SUM_MASK_REG                                       = 0x11040017ull;

static const uint64_t P9N2_EQ_2_SUM_MASK_REG                                       = 0x12040017ull;

static const uint64_t P9N2_EQ_3_SUM_MASK_REG                                       = 0x13040017ull;

static const uint64_t P9N2_EQ_4_SUM_MASK_REG                                       = 0x14040017ull;

static const uint64_t P9N2_EQ_5_SUM_MASK_REG                                       = 0x15040017ull;

static const uint64_t P9N2_EX_SUM_MASK_REG                                         = 0x20040017ull;
//DUPS: 21040017,
static const uint64_t P9N2_EX_0_SUM_MASK_REG                                       = 0x20040017ull;
//DUPS: 21040017,
static const uint64_t P9N2_EX_1_SUM_MASK_REG                                       = 0x22040017ull;
//DUPS: 23040017,
static const uint64_t P9N2_EX_2_SUM_MASK_REG                                       = 0x24040017ull;
//DUPS: 25040017,
static const uint64_t P9N2_EX_3_SUM_MASK_REG                                       = 0x26040017ull;
//DUPS: 27040017,
static const uint64_t P9N2_EX_4_SUM_MASK_REG                                       = 0x28040017ull;
//DUPS: 29040017,
static const uint64_t P9N2_EX_5_SUM_MASK_REG                                       = 0x2A040017ull;
//DUPS: 2B040017,
static const uint64_t P9N2_EX_6_SUM_MASK_REG                                       = 0x2C040017ull;
//DUPS: 2D040017,
static const uint64_t P9N2_EX_7_SUM_MASK_REG                                       = 0x2F040017ull;
//DUPS: 2F040017,
static const uint64_t P9N2_EX_8_SUM_MASK_REG                                       = 0x30040017ull;
//DUPS: 31040017,
static const uint64_t P9N2_EX_9_SUM_MASK_REG                                       = 0x32040017ull;
//DUPS: 33040017,
static const uint64_t P9N2_EX_10_SUM_MASK_REG                                      = 0x34040017ull;
//DUPS: 35040017,
static const uint64_t P9N2_EX_11_SUM_MASK_REG                                      = 0x36040017ull;
//DUPS: 37040017,

static const uint64_t P9N2_C_SYNC_CONFIG                                           = 0x20030000ull;

static const uint64_t P9N2_C_0_SYNC_CONFIG                                         = 0x20030000ull;

static const uint64_t P9N2_C_1_SYNC_CONFIG                                         = 0x21030000ull;

static const uint64_t P9N2_C_2_SYNC_CONFIG                                         = 0x22030000ull;

static const uint64_t P9N2_C_3_SYNC_CONFIG                                         = 0x23030000ull;

static const uint64_t P9N2_C_4_SYNC_CONFIG                                         = 0x24030000ull;

static const uint64_t P9N2_C_5_SYNC_CONFIG                                         = 0x25030000ull;

static const uint64_t P9N2_C_6_SYNC_CONFIG                                         = 0x26030000ull;

static const uint64_t P9N2_C_7_SYNC_CONFIG                                         = 0x27030000ull;

static const uint64_t P9N2_C_8_SYNC_CONFIG                                         = 0x28030000ull;

static const uint64_t P9N2_C_9_SYNC_CONFIG                                         = 0x29030000ull;

static const uint64_t P9N2_C_10_SYNC_CONFIG                                        = 0x2A030000ull;

static const uint64_t P9N2_C_11_SYNC_CONFIG                                        = 0x2B030000ull;

static const uint64_t P9N2_C_12_SYNC_CONFIG                                        = 0x2C030000ull;

static const uint64_t P9N2_C_13_SYNC_CONFIG                                        = 0x2D030000ull;

static const uint64_t P9N2_C_14_SYNC_CONFIG                                        = 0x2E030000ull;

static const uint64_t P9N2_C_15_SYNC_CONFIG                                        = 0x2F030000ull;

static const uint64_t P9N2_C_16_SYNC_CONFIG                                        = 0x30030000ull;

static const uint64_t P9N2_C_17_SYNC_CONFIG                                        = 0x31030000ull;

static const uint64_t P9N2_C_18_SYNC_CONFIG                                        = 0x32030000ull;

static const uint64_t P9N2_C_19_SYNC_CONFIG                                        = 0x33030000ull;

static const uint64_t P9N2_C_20_SYNC_CONFIG                                        = 0x34030000ull;

static const uint64_t P9N2_C_21_SYNC_CONFIG                                        = 0x35030000ull;

static const uint64_t P9N2_C_22_SYNC_CONFIG                                        = 0x36030000ull;

static const uint64_t P9N2_C_23_SYNC_CONFIG                                        = 0x37030000ull;

static const uint64_t P9N2_EQ_SYNC_CONFIG                                          = 0x10030000ull;

static const uint64_t P9N2_EQ_0_SYNC_CONFIG                                        = 0x10030000ull;

static const uint64_t P9N2_EQ_1_SYNC_CONFIG                                        = 0x11030000ull;

static const uint64_t P9N2_EQ_2_SYNC_CONFIG                                        = 0x12030000ull;

static const uint64_t P9N2_EQ_3_SYNC_CONFIG                                        = 0x13030000ull;

static const uint64_t P9N2_EQ_4_SYNC_CONFIG                                        = 0x14030000ull;

static const uint64_t P9N2_EQ_5_SYNC_CONFIG                                        = 0x15030000ull;

static const uint64_t P9N2_EX_SYNC_CONFIG                                          = 0x20030000ull;
//DUPS: 21030000,
static const uint64_t P9N2_EX_0_SYNC_CONFIG                                        = 0x20030000ull;
//DUPS: 21030000,
static const uint64_t P9N2_EX_1_SYNC_CONFIG                                        = 0x22030000ull;
//DUPS: 23030000,
static const uint64_t P9N2_EX_2_SYNC_CONFIG                                        = 0x24030000ull;
//DUPS: 25030000,
static const uint64_t P9N2_EX_3_SYNC_CONFIG                                        = 0x26030000ull;
//DUPS: 27030000,
static const uint64_t P9N2_EX_4_SYNC_CONFIG                                        = 0x28030000ull;
//DUPS: 29030000,
static const uint64_t P9N2_EX_5_SYNC_CONFIG                                        = 0x2A030000ull;
//DUPS: 2B030000,
static const uint64_t P9N2_EX_6_SYNC_CONFIG                                        = 0x2C030000ull;
//DUPS: 2D030000,
static const uint64_t P9N2_EX_7_SYNC_CONFIG                                        = 0x2F030000ull;
//DUPS: 2F030000,
static const uint64_t P9N2_EX_8_SYNC_CONFIG                                        = 0x30030000ull;
//DUPS: 31030000,
static const uint64_t P9N2_EX_9_SYNC_CONFIG                                        = 0x32030000ull;
//DUPS: 33030000,
static const uint64_t P9N2_EX_10_SYNC_CONFIG                                       = 0x34030000ull;
//DUPS: 35030000,
static const uint64_t P9N2_EX_11_SYNC_CONFIG                                       = 0x36030000ull;
//DUPS: 37030000,

static const uint64_t P9N2_C_T0_PMU_SCOM                                           = 0x20010AAAull;

static const uint64_t P9N2_C_0_T0_PMU_SCOM                                         = 0x20010AAAull;

static const uint64_t P9N2_C_1_T0_PMU_SCOM                                         = 0x21010AAAull;

static const uint64_t P9N2_C_2_T0_PMU_SCOM                                         = 0x22010AAAull;

static const uint64_t P9N2_C_3_T0_PMU_SCOM                                         = 0x23010AAAull;

static const uint64_t P9N2_C_4_T0_PMU_SCOM                                         = 0x24010AAAull;

static const uint64_t P9N2_C_5_T0_PMU_SCOM                                         = 0x25010AAAull;

static const uint64_t P9N2_C_6_T0_PMU_SCOM                                         = 0x26010AAAull;

static const uint64_t P9N2_C_7_T0_PMU_SCOM                                         = 0x27010AAAull;

static const uint64_t P9N2_C_8_T0_PMU_SCOM                                         = 0x28010AAAull;

static const uint64_t P9N2_C_9_T0_PMU_SCOM                                         = 0x29010AAAull;

static const uint64_t P9N2_C_10_T0_PMU_SCOM                                        = 0x2A010AAAull;

static const uint64_t P9N2_C_11_T0_PMU_SCOM                                        = 0x2B010AAAull;

static const uint64_t P9N2_C_12_T0_PMU_SCOM                                        = 0x2C010AAAull;

static const uint64_t P9N2_C_13_T0_PMU_SCOM                                        = 0x2D010AAAull;

static const uint64_t P9N2_C_14_T0_PMU_SCOM                                        = 0x2E010AAAull;

static const uint64_t P9N2_C_15_T0_PMU_SCOM                                        = 0x2F010AAAull;

static const uint64_t P9N2_C_16_T0_PMU_SCOM                                        = 0x30010AAAull;

static const uint64_t P9N2_C_17_T0_PMU_SCOM                                        = 0x31010AAAull;

static const uint64_t P9N2_C_18_T0_PMU_SCOM                                        = 0x32010AAAull;

static const uint64_t P9N2_C_19_T0_PMU_SCOM                                        = 0x33010AAAull;

static const uint64_t P9N2_C_20_T0_PMU_SCOM                                        = 0x34010AAAull;

static const uint64_t P9N2_C_21_T0_PMU_SCOM                                        = 0x35010AAAull;

static const uint64_t P9N2_C_22_T0_PMU_SCOM                                        = 0x36010AAAull;

static const uint64_t P9N2_C_23_T0_PMU_SCOM                                        = 0x37010AAAull;

static const uint64_t P9N2_EX_0_L2_T0_PMU_SCOM                                     = 0x20010AAAull;
//DUPS: 21010AAA,
static const uint64_t P9N2_EX_10_L2_T0_PMU_SCOM                                    = 0x34010AAAull;
//DUPS: 35010AAA,
static const uint64_t P9N2_EX_11_L2_T0_PMU_SCOM                                    = 0x36010AAAull;
//DUPS: 37010AAA,
static const uint64_t P9N2_EX_1_L2_T0_PMU_SCOM                                     = 0x22010AAAull;
//DUPS: 23010AAA,
static const uint64_t P9N2_EX_2_L2_T0_PMU_SCOM                                     = 0x24010AAAull;
//DUPS: 25010AAA,
static const uint64_t P9N2_EX_3_L2_T0_PMU_SCOM                                     = 0x26010AAAull;
//DUPS: 27010AAA,
static const uint64_t P9N2_EX_4_L2_T0_PMU_SCOM                                     = 0x28010AAAull;
//DUPS: 29010AAA,
static const uint64_t P9N2_EX_5_L2_T0_PMU_SCOM                                     = 0x2A010AAAull;
//DUPS: 2B010AAA,
static const uint64_t P9N2_EX_6_L2_T0_PMU_SCOM                                     = 0x2C010AAAull;
//DUPS: 2D010AAA,
static const uint64_t P9N2_EX_7_L2_T0_PMU_SCOM                                     = 0x2F010AAAull;
//DUPS: 2F010AAA,
static const uint64_t P9N2_EX_8_L2_T0_PMU_SCOM                                     = 0x30010AAAull;
//DUPS: 31010AAA,
static const uint64_t P9N2_EX_9_L2_T0_PMU_SCOM                                     = 0x32010AAAull;
//DUPS: 33010AAA,
static const uint64_t P9N2_EX_L2_T0_PMU_SCOM                                       = 0x20010AAAull;
//DUPS: 21010AAA,

static const uint64_t P9N2_C_T1_PMU_SCOM                                           = 0x20010AABull;

static const uint64_t P9N2_C_0_T1_PMU_SCOM                                         = 0x20010AABull;

static const uint64_t P9N2_C_1_T1_PMU_SCOM                                         = 0x21010AABull;

static const uint64_t P9N2_C_2_T1_PMU_SCOM                                         = 0x22010AABull;

static const uint64_t P9N2_C_3_T1_PMU_SCOM                                         = 0x23010AABull;

static const uint64_t P9N2_C_4_T1_PMU_SCOM                                         = 0x24010AABull;

static const uint64_t P9N2_C_5_T1_PMU_SCOM                                         = 0x25010AABull;

static const uint64_t P9N2_C_6_T1_PMU_SCOM                                         = 0x26010AABull;

static const uint64_t P9N2_C_7_T1_PMU_SCOM                                         = 0x27010AABull;

static const uint64_t P9N2_C_8_T1_PMU_SCOM                                         = 0x28010AABull;

static const uint64_t P9N2_C_9_T1_PMU_SCOM                                         = 0x29010AABull;

static const uint64_t P9N2_C_10_T1_PMU_SCOM                                        = 0x2A010AABull;

static const uint64_t P9N2_C_11_T1_PMU_SCOM                                        = 0x2B010AABull;

static const uint64_t P9N2_C_12_T1_PMU_SCOM                                        = 0x2C010AABull;

static const uint64_t P9N2_C_13_T1_PMU_SCOM                                        = 0x2D010AABull;

static const uint64_t P9N2_C_14_T1_PMU_SCOM                                        = 0x2E010AABull;

static const uint64_t P9N2_C_15_T1_PMU_SCOM                                        = 0x2F010AABull;

static const uint64_t P9N2_C_16_T1_PMU_SCOM                                        = 0x30010AABull;

static const uint64_t P9N2_C_17_T1_PMU_SCOM                                        = 0x31010AABull;

static const uint64_t P9N2_C_18_T1_PMU_SCOM                                        = 0x32010AABull;

static const uint64_t P9N2_C_19_T1_PMU_SCOM                                        = 0x33010AABull;

static const uint64_t P9N2_C_20_T1_PMU_SCOM                                        = 0x34010AABull;

static const uint64_t P9N2_C_21_T1_PMU_SCOM                                        = 0x35010AABull;

static const uint64_t P9N2_C_22_T1_PMU_SCOM                                        = 0x36010AABull;

static const uint64_t P9N2_C_23_T1_PMU_SCOM                                        = 0x37010AABull;

static const uint64_t P9N2_EX_0_L2_T1_PMU_SCOM                                     = 0x20010AABull;
//DUPS: 21010AAB,
static const uint64_t P9N2_EX_10_L2_T1_PMU_SCOM                                    = 0x34010AABull;
//DUPS: 35010AAB,
static const uint64_t P9N2_EX_11_L2_T1_PMU_SCOM                                    = 0x36010AABull;
//DUPS: 37010AAB,
static const uint64_t P9N2_EX_1_L2_T1_PMU_SCOM                                     = 0x22010AABull;
//DUPS: 23010AAB,
static const uint64_t P9N2_EX_2_L2_T1_PMU_SCOM                                     = 0x24010AABull;
//DUPS: 25010AAB,
static const uint64_t P9N2_EX_3_L2_T1_PMU_SCOM                                     = 0x26010AABull;
//DUPS: 27010AAB,
static const uint64_t P9N2_EX_4_L2_T1_PMU_SCOM                                     = 0x28010AABull;
//DUPS: 29010AAB,
static const uint64_t P9N2_EX_5_L2_T1_PMU_SCOM                                     = 0x2A010AABull;
//DUPS: 2B010AAB,
static const uint64_t P9N2_EX_6_L2_T1_PMU_SCOM                                     = 0x2C010AABull;
//DUPS: 2D010AAB,
static const uint64_t P9N2_EX_7_L2_T1_PMU_SCOM                                     = 0x2F010AABull;
//DUPS: 2F010AAB,
static const uint64_t P9N2_EX_8_L2_T1_PMU_SCOM                                     = 0x30010AABull;
//DUPS: 31010AAB,
static const uint64_t P9N2_EX_9_L2_T1_PMU_SCOM                                     = 0x32010AABull;
//DUPS: 33010AAB,
static const uint64_t P9N2_EX_L2_T1_PMU_SCOM                                       = 0x20010AABull;
//DUPS: 21010AAB,

static const uint64_t P9N2_C_T2_PMU_SCOM                                           = 0x20010AACull;

static const uint64_t P9N2_C_0_T2_PMU_SCOM                                         = 0x20010AACull;

static const uint64_t P9N2_C_1_T2_PMU_SCOM                                         = 0x21010AACull;

static const uint64_t P9N2_C_2_T2_PMU_SCOM                                         = 0x22010AACull;

static const uint64_t P9N2_C_3_T2_PMU_SCOM                                         = 0x23010AACull;

static const uint64_t P9N2_C_4_T2_PMU_SCOM                                         = 0x24010AACull;

static const uint64_t P9N2_C_5_T2_PMU_SCOM                                         = 0x25010AACull;

static const uint64_t P9N2_C_6_T2_PMU_SCOM                                         = 0x26010AACull;

static const uint64_t P9N2_C_7_T2_PMU_SCOM                                         = 0x27010AACull;

static const uint64_t P9N2_C_8_T2_PMU_SCOM                                         = 0x28010AACull;

static const uint64_t P9N2_C_9_T2_PMU_SCOM                                         = 0x29010AACull;

static const uint64_t P9N2_C_10_T2_PMU_SCOM                                        = 0x2A010AACull;

static const uint64_t P9N2_C_11_T2_PMU_SCOM                                        = 0x2B010AACull;

static const uint64_t P9N2_C_12_T2_PMU_SCOM                                        = 0x2C010AACull;

static const uint64_t P9N2_C_13_T2_PMU_SCOM                                        = 0x2D010AACull;

static const uint64_t P9N2_C_14_T2_PMU_SCOM                                        = 0x2E010AACull;

static const uint64_t P9N2_C_15_T2_PMU_SCOM                                        = 0x2F010AACull;

static const uint64_t P9N2_C_16_T2_PMU_SCOM                                        = 0x30010AACull;

static const uint64_t P9N2_C_17_T2_PMU_SCOM                                        = 0x31010AACull;

static const uint64_t P9N2_C_18_T2_PMU_SCOM                                        = 0x32010AACull;

static const uint64_t P9N2_C_19_T2_PMU_SCOM                                        = 0x33010AACull;

static const uint64_t P9N2_C_20_T2_PMU_SCOM                                        = 0x34010AACull;

static const uint64_t P9N2_C_21_T2_PMU_SCOM                                        = 0x35010AACull;

static const uint64_t P9N2_C_22_T2_PMU_SCOM                                        = 0x36010AACull;

static const uint64_t P9N2_C_23_T2_PMU_SCOM                                        = 0x37010AACull;

static const uint64_t P9N2_EX_0_L2_T2_PMU_SCOM                                     = 0x20010AACull;
//DUPS: 21010AAC,
static const uint64_t P9N2_EX_10_L2_T2_PMU_SCOM                                    = 0x34010AACull;
//DUPS: 35010AAC,
static const uint64_t P9N2_EX_11_L2_T2_PMU_SCOM                                    = 0x36010AACull;
//DUPS: 37010AAC,
static const uint64_t P9N2_EX_1_L2_T2_PMU_SCOM                                     = 0x22010AACull;
//DUPS: 23010AAC,
static const uint64_t P9N2_EX_2_L2_T2_PMU_SCOM                                     = 0x24010AACull;
//DUPS: 25010AAC,
static const uint64_t P9N2_EX_3_L2_T2_PMU_SCOM                                     = 0x26010AACull;
//DUPS: 27010AAC,
static const uint64_t P9N2_EX_4_L2_T2_PMU_SCOM                                     = 0x28010AACull;
//DUPS: 29010AAC,
static const uint64_t P9N2_EX_5_L2_T2_PMU_SCOM                                     = 0x2A010AACull;
//DUPS: 2B010AAC,
static const uint64_t P9N2_EX_6_L2_T2_PMU_SCOM                                     = 0x2C010AACull;
//DUPS: 2D010AAC,
static const uint64_t P9N2_EX_7_L2_T2_PMU_SCOM                                     = 0x2F010AACull;
//DUPS: 2F010AAC,
static const uint64_t P9N2_EX_8_L2_T2_PMU_SCOM                                     = 0x30010AACull;
//DUPS: 31010AAC,
static const uint64_t P9N2_EX_9_L2_T2_PMU_SCOM                                     = 0x32010AACull;
//DUPS: 33010AAC,
static const uint64_t P9N2_EX_L2_T2_PMU_SCOM                                       = 0x20010AACull;
//DUPS: 21010AAC,

static const uint64_t P9N2_C_T3_PMU_SCOM                                           = 0x20010AADull;

static const uint64_t P9N2_C_0_T3_PMU_SCOM                                         = 0x20010AADull;

static const uint64_t P9N2_C_1_T3_PMU_SCOM                                         = 0x21010AADull;

static const uint64_t P9N2_C_2_T3_PMU_SCOM                                         = 0x22010AADull;

static const uint64_t P9N2_C_3_T3_PMU_SCOM                                         = 0x23010AADull;

static const uint64_t P9N2_C_4_T3_PMU_SCOM                                         = 0x24010AADull;

static const uint64_t P9N2_C_5_T3_PMU_SCOM                                         = 0x25010AADull;

static const uint64_t P9N2_C_6_T3_PMU_SCOM                                         = 0x26010AADull;

static const uint64_t P9N2_C_7_T3_PMU_SCOM                                         = 0x27010AADull;

static const uint64_t P9N2_C_8_T3_PMU_SCOM                                         = 0x28010AADull;

static const uint64_t P9N2_C_9_T3_PMU_SCOM                                         = 0x29010AADull;

static const uint64_t P9N2_C_10_T3_PMU_SCOM                                        = 0x2A010AADull;

static const uint64_t P9N2_C_11_T3_PMU_SCOM                                        = 0x2B010AADull;

static const uint64_t P9N2_C_12_T3_PMU_SCOM                                        = 0x2C010AADull;

static const uint64_t P9N2_C_13_T3_PMU_SCOM                                        = 0x2D010AADull;

static const uint64_t P9N2_C_14_T3_PMU_SCOM                                        = 0x2E010AADull;

static const uint64_t P9N2_C_15_T3_PMU_SCOM                                        = 0x2F010AADull;

static const uint64_t P9N2_C_16_T3_PMU_SCOM                                        = 0x30010AADull;

static const uint64_t P9N2_C_17_T3_PMU_SCOM                                        = 0x31010AADull;

static const uint64_t P9N2_C_18_T3_PMU_SCOM                                        = 0x32010AADull;

static const uint64_t P9N2_C_19_T3_PMU_SCOM                                        = 0x33010AADull;

static const uint64_t P9N2_C_20_T3_PMU_SCOM                                        = 0x34010AADull;

static const uint64_t P9N2_C_21_T3_PMU_SCOM                                        = 0x35010AADull;

static const uint64_t P9N2_C_22_T3_PMU_SCOM                                        = 0x36010AADull;

static const uint64_t P9N2_C_23_T3_PMU_SCOM                                        = 0x37010AADull;

static const uint64_t P9N2_EX_0_L2_T3_PMU_SCOM                                     = 0x20010AADull;
//DUPS: 21010AAD,
static const uint64_t P9N2_EX_10_L2_T3_PMU_SCOM                                    = 0x34010AADull;
//DUPS: 35010AAD,
static const uint64_t P9N2_EX_11_L2_T3_PMU_SCOM                                    = 0x36010AADull;
//DUPS: 37010AAD,
static const uint64_t P9N2_EX_1_L2_T3_PMU_SCOM                                     = 0x22010AADull;
//DUPS: 23010AAD,
static const uint64_t P9N2_EX_2_L2_T3_PMU_SCOM                                     = 0x24010AADull;
//DUPS: 25010AAD,
static const uint64_t P9N2_EX_3_L2_T3_PMU_SCOM                                     = 0x26010AADull;
//DUPS: 27010AAD,
static const uint64_t P9N2_EX_4_L2_T3_PMU_SCOM                                     = 0x28010AADull;
//DUPS: 29010AAD,
static const uint64_t P9N2_EX_5_L2_T3_PMU_SCOM                                     = 0x2A010AADull;
//DUPS: 2B010AAD,
static const uint64_t P9N2_EX_6_L2_T3_PMU_SCOM                                     = 0x2C010AADull;
//DUPS: 2D010AAD,
static const uint64_t P9N2_EX_7_L2_T3_PMU_SCOM                                     = 0x2F010AADull;
//DUPS: 2F010AAD,
static const uint64_t P9N2_EX_8_L2_T3_PMU_SCOM                                     = 0x30010AADull;
//DUPS: 31010AAD,
static const uint64_t P9N2_EX_9_L2_T3_PMU_SCOM                                     = 0x32010AADull;
//DUPS: 33010AAD,
static const uint64_t P9N2_EX_L2_T3_PMU_SCOM                                       = 0x20010AADull;
//DUPS: 21010AAD,

static const uint64_t P9N2_C_TFAC_HOLD_OUT                                         = 0x20010AB7ull;

static const uint64_t P9N2_C_0_TFAC_HOLD_OUT                                       = 0x20010AB7ull;

static const uint64_t P9N2_C_1_TFAC_HOLD_OUT                                       = 0x21010AB7ull;

static const uint64_t P9N2_C_2_TFAC_HOLD_OUT                                       = 0x22010AB7ull;

static const uint64_t P9N2_C_3_TFAC_HOLD_OUT                                       = 0x23010AB7ull;

static const uint64_t P9N2_C_4_TFAC_HOLD_OUT                                       = 0x24010AB7ull;

static const uint64_t P9N2_C_5_TFAC_HOLD_OUT                                       = 0x25010AB7ull;

static const uint64_t P9N2_C_6_TFAC_HOLD_OUT                                       = 0x26010AB7ull;

static const uint64_t P9N2_C_7_TFAC_HOLD_OUT                                       = 0x27010AB7ull;

static const uint64_t P9N2_C_8_TFAC_HOLD_OUT                                       = 0x28010AB7ull;

static const uint64_t P9N2_C_9_TFAC_HOLD_OUT                                       = 0x29010AB7ull;

static const uint64_t P9N2_C_10_TFAC_HOLD_OUT                                      = 0x2A010AB7ull;

static const uint64_t P9N2_C_11_TFAC_HOLD_OUT                                      = 0x2B010AB7ull;

static const uint64_t P9N2_C_12_TFAC_HOLD_OUT                                      = 0x2C010AB7ull;

static const uint64_t P9N2_C_13_TFAC_HOLD_OUT                                      = 0x2D010AB7ull;

static const uint64_t P9N2_C_14_TFAC_HOLD_OUT                                      = 0x2E010AB7ull;

static const uint64_t P9N2_C_15_TFAC_HOLD_OUT                                      = 0x2F010AB7ull;

static const uint64_t P9N2_C_16_TFAC_HOLD_OUT                                      = 0x30010AB7ull;

static const uint64_t P9N2_C_17_TFAC_HOLD_OUT                                      = 0x31010AB7ull;

static const uint64_t P9N2_C_18_TFAC_HOLD_OUT                                      = 0x32010AB7ull;

static const uint64_t P9N2_C_19_TFAC_HOLD_OUT                                      = 0x33010AB7ull;

static const uint64_t P9N2_C_20_TFAC_HOLD_OUT                                      = 0x34010AB7ull;

static const uint64_t P9N2_C_21_TFAC_HOLD_OUT                                      = 0x35010AB7ull;

static const uint64_t P9N2_C_22_TFAC_HOLD_OUT                                      = 0x36010AB7ull;

static const uint64_t P9N2_C_23_TFAC_HOLD_OUT                                      = 0x37010AB7ull;

static const uint64_t P9N2_EX_0_L2_TFAC_HOLD_OUT                                   = 0x20010AB7ull;
//DUPS: 20010AB7,
static const uint64_t P9N2_EX_10_L2_TFAC_HOLD_OUT                                  = 0x34010AB7ull;
//DUPS: 34010AB7,
static const uint64_t P9N2_EX_11_L2_TFAC_HOLD_OUT                                  = 0x36010AB7ull;
//DUPS: 36010AB7,
static const uint64_t P9N2_EX_1_L2_TFAC_HOLD_OUT                                   = 0x22010AB7ull;
//DUPS: 22010AB7,
static const uint64_t P9N2_EX_2_L2_TFAC_HOLD_OUT                                   = 0x24010AB7ull;
//DUPS: 24010AB7,
static const uint64_t P9N2_EX_3_L2_TFAC_HOLD_OUT                                   = 0x26010AB7ull;
//DUPS: 26010AB7,
static const uint64_t P9N2_EX_4_L2_TFAC_HOLD_OUT                                   = 0x28010AB7ull;
//DUPS: 28010AB7,
static const uint64_t P9N2_EX_5_L2_TFAC_HOLD_OUT                                   = 0x2B010AB7ull;
//DUPS: 2A010AB7,
static const uint64_t P9N2_EX_6_L2_TFAC_HOLD_OUT                                   = 0x2D010AB7ull;
//DUPS: 2C010AB7,
static const uint64_t P9N2_EX_7_L2_TFAC_HOLD_OUT                                   = 0x2F010AB7ull;
//DUPS: 2E010AB7,
static const uint64_t P9N2_EX_8_L2_TFAC_HOLD_OUT                                   = 0x30010AB7ull;
//DUPS: 30010AB7,
static const uint64_t P9N2_EX_9_L2_TFAC_HOLD_OUT                                   = 0x32010AB7ull;
//DUPS: 32010AB7,
static const uint64_t P9N2_EX_L2_TFAC_HOLD_OUT                                     = 0x20010AB7ull;
//DUPS: 20010AB7,

static const uint64_t P9N2_C_THERM_MODE_REG                                        = 0x2005000Full;

static const uint64_t P9N2_C_0_THERM_MODE_REG                                      = 0x2005000Full;

static const uint64_t P9N2_C_1_THERM_MODE_REG                                      = 0x2105000Full;

static const uint64_t P9N2_C_2_THERM_MODE_REG                                      = 0x2205000Full;

static const uint64_t P9N2_C_3_THERM_MODE_REG                                      = 0x2305000Full;

static const uint64_t P9N2_C_4_THERM_MODE_REG                                      = 0x2405000Full;

static const uint64_t P9N2_C_5_THERM_MODE_REG                                      = 0x2505000Full;

static const uint64_t P9N2_C_6_THERM_MODE_REG                                      = 0x2605000Full;

static const uint64_t P9N2_C_7_THERM_MODE_REG                                      = 0x2705000Full;

static const uint64_t P9N2_C_8_THERM_MODE_REG                                      = 0x2805000Full;

static const uint64_t P9N2_C_9_THERM_MODE_REG                                      = 0x2905000Full;

static const uint64_t P9N2_C_10_THERM_MODE_REG                                     = 0x2A05000Full;

static const uint64_t P9N2_C_11_THERM_MODE_REG                                     = 0x2B05000Full;

static const uint64_t P9N2_C_12_THERM_MODE_REG                                     = 0x2C05000Full;

static const uint64_t P9N2_C_13_THERM_MODE_REG                                     = 0x2D05000Full;

static const uint64_t P9N2_C_14_THERM_MODE_REG                                     = 0x2E05000Full;

static const uint64_t P9N2_C_15_THERM_MODE_REG                                     = 0x2F05000Full;

static const uint64_t P9N2_C_16_THERM_MODE_REG                                     = 0x3005000Full;

static const uint64_t P9N2_C_17_THERM_MODE_REG                                     = 0x3105000Full;

static const uint64_t P9N2_C_18_THERM_MODE_REG                                     = 0x3205000Full;

static const uint64_t P9N2_C_19_THERM_MODE_REG                                     = 0x3305000Full;

static const uint64_t P9N2_C_20_THERM_MODE_REG                                     = 0x3405000Full;

static const uint64_t P9N2_C_21_THERM_MODE_REG                                     = 0x3505000Full;

static const uint64_t P9N2_C_22_THERM_MODE_REG                                     = 0x3605000Full;

static const uint64_t P9N2_C_23_THERM_MODE_REG                                     = 0x3705000Full;

static const uint64_t P9N2_EQ_THERM_MODE_REG                                       = 0x1005000Full;

static const uint64_t P9N2_EQ_0_THERM_MODE_REG                                     = 0x1005000Full;

static const uint64_t P9N2_EQ_1_THERM_MODE_REG                                     = 0x1105000Full;

static const uint64_t P9N2_EQ_2_THERM_MODE_REG                                     = 0x1205000Full;

static const uint64_t P9N2_EQ_3_THERM_MODE_REG                                     = 0x1305000Full;

static const uint64_t P9N2_EQ_4_THERM_MODE_REG                                     = 0x1405000Full;

static const uint64_t P9N2_EQ_5_THERM_MODE_REG                                     = 0x1505000Full;

static const uint64_t P9N2_EX_THERM_MODE_REG                                       = 0x2005000Full;
//DUPS: 2105000F,
static const uint64_t P9N2_EX_0_THERM_MODE_REG                                     = 0x2005000Full;
//DUPS: 2105000F,
static const uint64_t P9N2_EX_1_THERM_MODE_REG                                     = 0x2205000Full;
//DUPS: 2305000F,
static const uint64_t P9N2_EX_2_THERM_MODE_REG                                     = 0x2405000Full;
//DUPS: 2505000F,
static const uint64_t P9N2_EX_3_THERM_MODE_REG                                     = 0x2605000Full;
//DUPS: 2705000F,
static const uint64_t P9N2_EX_4_THERM_MODE_REG                                     = 0x2805000Full;
//DUPS: 2905000F,
static const uint64_t P9N2_EX_5_THERM_MODE_REG                                     = 0x2A05000Full;
//DUPS: 2B05000F,
static const uint64_t P9N2_EX_6_THERM_MODE_REG                                     = 0x2C05000Full;
//DUPS: 2D05000F,
static const uint64_t P9N2_EX_7_THERM_MODE_REG                                     = 0x2F05000Full;
//DUPS: 2F05000F,
static const uint64_t P9N2_EX_8_THERM_MODE_REG                                     = 0x3005000Full;
//DUPS: 3105000F,
static const uint64_t P9N2_EX_9_THERM_MODE_REG                                     = 0x3205000Full;
//DUPS: 3305000F,
static const uint64_t P9N2_EX_10_THERM_MODE_REG                                    = 0x3405000Full;
//DUPS: 3505000F,
static const uint64_t P9N2_EX_11_THERM_MODE_REG                                    = 0x3605000Full;
//DUPS: 3705000F,

static const uint64_t P9N2_C_THRCTL_HOLD_OUT                                       = 0x20010A03ull;

static const uint64_t P9N2_C_0_THRCTL_HOLD_OUT                                     = 0x20010A03ull;

static const uint64_t P9N2_C_1_THRCTL_HOLD_OUT                                     = 0x21010A03ull;

static const uint64_t P9N2_C_2_THRCTL_HOLD_OUT                                     = 0x22010A03ull;

static const uint64_t P9N2_C_3_THRCTL_HOLD_OUT                                     = 0x23010A03ull;

static const uint64_t P9N2_C_4_THRCTL_HOLD_OUT                                     = 0x24010A03ull;

static const uint64_t P9N2_C_5_THRCTL_HOLD_OUT                                     = 0x25010A03ull;

static const uint64_t P9N2_C_6_THRCTL_HOLD_OUT                                     = 0x26010A03ull;

static const uint64_t P9N2_C_7_THRCTL_HOLD_OUT                                     = 0x27010A03ull;

static const uint64_t P9N2_C_8_THRCTL_HOLD_OUT                                     = 0x28010A03ull;

static const uint64_t P9N2_C_9_THRCTL_HOLD_OUT                                     = 0x29010A03ull;

static const uint64_t P9N2_C_10_THRCTL_HOLD_OUT                                    = 0x2A010A03ull;

static const uint64_t P9N2_C_11_THRCTL_HOLD_OUT                                    = 0x2B010A03ull;

static const uint64_t P9N2_C_12_THRCTL_HOLD_OUT                                    = 0x2C010A03ull;

static const uint64_t P9N2_C_13_THRCTL_HOLD_OUT                                    = 0x2D010A03ull;

static const uint64_t P9N2_C_14_THRCTL_HOLD_OUT                                    = 0x2E010A03ull;

static const uint64_t P9N2_C_15_THRCTL_HOLD_OUT                                    = 0x2F010A03ull;

static const uint64_t P9N2_C_16_THRCTL_HOLD_OUT                                    = 0x30010A03ull;

static const uint64_t P9N2_C_17_THRCTL_HOLD_OUT                                    = 0x31010A03ull;

static const uint64_t P9N2_C_18_THRCTL_HOLD_OUT                                    = 0x32010A03ull;

static const uint64_t P9N2_C_19_THRCTL_HOLD_OUT                                    = 0x33010A03ull;

static const uint64_t P9N2_C_20_THRCTL_HOLD_OUT                                    = 0x34010A03ull;

static const uint64_t P9N2_C_21_THRCTL_HOLD_OUT                                    = 0x35010A03ull;

static const uint64_t P9N2_C_22_THRCTL_HOLD_OUT                                    = 0x36010A03ull;

static const uint64_t P9N2_C_23_THRCTL_HOLD_OUT                                    = 0x37010A03ull;

static const uint64_t P9N2_EX_0_L2_THRCTL_HOLD_OUT                                 = 0x20010A03ull;
//DUPS: 21010A03,
static const uint64_t P9N2_EX_10_L2_THRCTL_HOLD_OUT                                = 0x34010A03ull;
//DUPS: 35010A03,
static const uint64_t P9N2_EX_11_L2_THRCTL_HOLD_OUT                                = 0x36010A03ull;
//DUPS: 37010A03,
static const uint64_t P9N2_EX_1_L2_THRCTL_HOLD_OUT                                 = 0x22010A03ull;
//DUPS: 23010A03,
static const uint64_t P9N2_EX_2_L2_THRCTL_HOLD_OUT                                 = 0x24010A03ull;
//DUPS: 25010A03,
static const uint64_t P9N2_EX_3_L2_THRCTL_HOLD_OUT                                 = 0x26010A03ull;
//DUPS: 27010A03,
static const uint64_t P9N2_EX_4_L2_THRCTL_HOLD_OUT                                 = 0x28010A03ull;
//DUPS: 29010A03,
static const uint64_t P9N2_EX_5_L2_THRCTL_HOLD_OUT                                 = 0x2A010A03ull;
//DUPS: 2B010A03,
static const uint64_t P9N2_EX_6_L2_THRCTL_HOLD_OUT                                 = 0x2C010A03ull;
//DUPS: 2D010A03,
static const uint64_t P9N2_EX_7_L2_THRCTL_HOLD_OUT                                 = 0x2F010A03ull;
//DUPS: 2F010A03,
static const uint64_t P9N2_EX_8_L2_THRCTL_HOLD_OUT                                 = 0x30010A03ull;
//DUPS: 31010A03,
static const uint64_t P9N2_EX_9_L2_THRCTL_HOLD_OUT                                 = 0x32010A03ull;
//DUPS: 33010A03,
static const uint64_t P9N2_EX_L2_THRCTL_HOLD_OUT                                   = 0x20010A03ull;
//DUPS: 21010A03,

static const uint64_t P9N2_C_THREAD_INFO                                           = 0x20010A9Bull;

static const uint64_t P9N2_C_0_THREAD_INFO                                         = 0x20010A9Bull;

static const uint64_t P9N2_C_1_THREAD_INFO                                         = 0x21010A9Bull;

static const uint64_t P9N2_C_2_THREAD_INFO                                         = 0x22010A9Bull;

static const uint64_t P9N2_C_3_THREAD_INFO                                         = 0x23010A9Bull;

static const uint64_t P9N2_C_4_THREAD_INFO                                         = 0x24010A9Bull;

static const uint64_t P9N2_C_5_THREAD_INFO                                         = 0x25010A9Bull;

static const uint64_t P9N2_C_6_THREAD_INFO                                         = 0x26010A9Bull;

static const uint64_t P9N2_C_7_THREAD_INFO                                         = 0x27010A9Bull;

static const uint64_t P9N2_C_8_THREAD_INFO                                         = 0x28010A9Bull;

static const uint64_t P9N2_C_9_THREAD_INFO                                         = 0x29010A9Bull;

static const uint64_t P9N2_C_10_THREAD_INFO                                        = 0x2A010A9Bull;

static const uint64_t P9N2_C_11_THREAD_INFO                                        = 0x2B010A9Bull;

static const uint64_t P9N2_C_12_THREAD_INFO                                        = 0x2C010A9Bull;

static const uint64_t P9N2_C_13_THREAD_INFO                                        = 0x2D010A9Bull;

static const uint64_t P9N2_C_14_THREAD_INFO                                        = 0x2E010A9Bull;

static const uint64_t P9N2_C_15_THREAD_INFO                                        = 0x2F010A9Bull;

static const uint64_t P9N2_C_16_THREAD_INFO                                        = 0x30010A9Bull;

static const uint64_t P9N2_C_17_THREAD_INFO                                        = 0x31010A9Bull;

static const uint64_t P9N2_C_18_THREAD_INFO                                        = 0x32010A9Bull;

static const uint64_t P9N2_C_19_THREAD_INFO                                        = 0x33010A9Bull;

static const uint64_t P9N2_C_20_THREAD_INFO                                        = 0x34010A9Bull;

static const uint64_t P9N2_C_21_THREAD_INFO                                        = 0x35010A9Bull;

static const uint64_t P9N2_C_22_THREAD_INFO                                        = 0x36010A9Bull;

static const uint64_t P9N2_C_23_THREAD_INFO                                        = 0x37010A9Bull;

static const uint64_t P9N2_EX_0_L2_THREAD_INFO                                     = 0x20010A9Bull;
//DUPS: 20010A9B,
static const uint64_t P9N2_EX_10_L2_THREAD_INFO                                    = 0x34010A9Bull;
//DUPS: 34010A9B,
static const uint64_t P9N2_EX_11_L2_THREAD_INFO                                    = 0x36010A9Bull;
//DUPS: 36010A9B,
static const uint64_t P9N2_EX_1_L2_THREAD_INFO                                     = 0x22010A9Bull;
//DUPS: 22010A9B,
static const uint64_t P9N2_EX_2_L2_THREAD_INFO                                     = 0x24010A9Bull;
//DUPS: 24010A9B,
static const uint64_t P9N2_EX_3_L2_THREAD_INFO                                     = 0x26010A9Bull;
//DUPS: 26010A9B,
static const uint64_t P9N2_EX_4_L2_THREAD_INFO                                     = 0x28010A9Bull;
//DUPS: 28010A9B,
static const uint64_t P9N2_EX_5_L2_THREAD_INFO                                     = 0x2B010A9Bull;
//DUPS: 2A010A9B,
static const uint64_t P9N2_EX_6_L2_THREAD_INFO                                     = 0x2D010A9Bull;
//DUPS: 2C010A9B,
static const uint64_t P9N2_EX_7_L2_THREAD_INFO                                     = 0x2F010A9Bull;
//DUPS: 2E010A9B,
static const uint64_t P9N2_EX_8_L2_THREAD_INFO                                     = 0x30010A9Bull;
//DUPS: 30010A9B,
static const uint64_t P9N2_EX_9_L2_THREAD_INFO                                     = 0x32010A9Bull;
//DUPS: 32010A9B,
static const uint64_t P9N2_EX_L2_THREAD_INFO                                       = 0x20010A9Bull;
//DUPS: 20010A9B,

static const uint64_t P9N2_C_THROTTLE_CONTROL                                      = 0x20010A9Eull;

static const uint64_t P9N2_C_0_THROTTLE_CONTROL                                    = 0x20010A9Eull;

static const uint64_t P9N2_C_1_THROTTLE_CONTROL                                    = 0x21010A9Eull;

static const uint64_t P9N2_C_2_THROTTLE_CONTROL                                    = 0x22010A9Eull;

static const uint64_t P9N2_C_3_THROTTLE_CONTROL                                    = 0x23010A9Eull;

static const uint64_t P9N2_C_4_THROTTLE_CONTROL                                    = 0x24010A9Eull;

static const uint64_t P9N2_C_5_THROTTLE_CONTROL                                    = 0x25010A9Eull;

static const uint64_t P9N2_C_6_THROTTLE_CONTROL                                    = 0x26010A9Eull;

static const uint64_t P9N2_C_7_THROTTLE_CONTROL                                    = 0x27010A9Eull;

static const uint64_t P9N2_C_8_THROTTLE_CONTROL                                    = 0x28010A9Eull;

static const uint64_t P9N2_C_9_THROTTLE_CONTROL                                    = 0x29010A9Eull;

static const uint64_t P9N2_C_10_THROTTLE_CONTROL                                   = 0x2A010A9Eull;

static const uint64_t P9N2_C_11_THROTTLE_CONTROL                                   = 0x2B010A9Eull;

static const uint64_t P9N2_C_12_THROTTLE_CONTROL                                   = 0x2C010A9Eull;

static const uint64_t P9N2_C_13_THROTTLE_CONTROL                                   = 0x2D010A9Eull;

static const uint64_t P9N2_C_14_THROTTLE_CONTROL                                   = 0x2E010A9Eull;

static const uint64_t P9N2_C_15_THROTTLE_CONTROL                                   = 0x2F010A9Eull;

static const uint64_t P9N2_C_16_THROTTLE_CONTROL                                   = 0x30010A9Eull;

static const uint64_t P9N2_C_17_THROTTLE_CONTROL                                   = 0x31010A9Eull;

static const uint64_t P9N2_C_18_THROTTLE_CONTROL                                   = 0x32010A9Eull;

static const uint64_t P9N2_C_19_THROTTLE_CONTROL                                   = 0x33010A9Eull;

static const uint64_t P9N2_C_20_THROTTLE_CONTROL                                   = 0x34010A9Eull;

static const uint64_t P9N2_C_21_THROTTLE_CONTROL                                   = 0x35010A9Eull;

static const uint64_t P9N2_C_22_THROTTLE_CONTROL                                   = 0x36010A9Eull;

static const uint64_t P9N2_C_23_THROTTLE_CONTROL                                   = 0x37010A9Eull;

static const uint64_t P9N2_EX_THROTTLE_CONTROL                                     = 0x20010A9Eull;
//DUPS: 20010A9E,
static const uint64_t P9N2_EX_0_THROTTLE_CONTROL                                   = 0x20010A9Eull;
//DUPS: 20010A9E,
static const uint64_t P9N2_EX_1_THROTTLE_CONTROL                                   = 0x22010A9Eull;
//DUPS: 22010A9E,
static const uint64_t P9N2_EX_2_THROTTLE_CONTROL                                   = 0x24010A9Eull;
//DUPS: 24010A9E,
static const uint64_t P9N2_EX_3_THROTTLE_CONTROL                                   = 0x26010A9Eull;
//DUPS: 26010A9E,
static const uint64_t P9N2_EX_4_THROTTLE_CONTROL                                   = 0x28010A9Eull;
//DUPS: 28010A9E,
static const uint64_t P9N2_EX_5_THROTTLE_CONTROL                                   = 0x2B010A9Eull;
//DUPS: 2A010A9E,
static const uint64_t P9N2_EX_6_THROTTLE_CONTROL                                   = 0x2D010A9Eull;
//DUPS: 2C010A9E,
static const uint64_t P9N2_EX_7_THROTTLE_CONTROL                                   = 0x2F010A9Eull;
//DUPS: 2E010A9E,
static const uint64_t P9N2_EX_8_THROTTLE_CONTROL                                   = 0x30010A9Eull;
//DUPS: 30010A9E,
static const uint64_t P9N2_EX_9_THROTTLE_CONTROL                                   = 0x32010A9Eull;
//DUPS: 32010A9E,
static const uint64_t P9N2_EX_10_THROTTLE_CONTROL                                  = 0x34010A9Eull;
//DUPS: 34010A9E,
static const uint64_t P9N2_EX_11_THROTTLE_CONTROL                                  = 0x36010A9Eull;
//DUPS: 36010A9E,

static const uint64_t P9N2_C_TIMEOUT_REG                                           = 0x200F0010ull;

static const uint64_t P9N2_C_0_TIMEOUT_REG                                         = 0x200F0010ull;

static const uint64_t P9N2_C_1_TIMEOUT_REG                                         = 0x210F0010ull;

static const uint64_t P9N2_C_2_TIMEOUT_REG                                         = 0x220F0010ull;

static const uint64_t P9N2_C_3_TIMEOUT_REG                                         = 0x230F0010ull;

static const uint64_t P9N2_C_4_TIMEOUT_REG                                         = 0x240F0010ull;

static const uint64_t P9N2_C_5_TIMEOUT_REG                                         = 0x250F0010ull;

static const uint64_t P9N2_C_6_TIMEOUT_REG                                         = 0x260F0010ull;

static const uint64_t P9N2_C_7_TIMEOUT_REG                                         = 0x270F0010ull;

static const uint64_t P9N2_C_8_TIMEOUT_REG                                         = 0x280F0010ull;

static const uint64_t P9N2_C_9_TIMEOUT_REG                                         = 0x290F0010ull;

static const uint64_t P9N2_C_10_TIMEOUT_REG                                        = 0x2A0F0010ull;

static const uint64_t P9N2_C_11_TIMEOUT_REG                                        = 0x2B0F0010ull;

static const uint64_t P9N2_C_12_TIMEOUT_REG                                        = 0x2C0F0010ull;

static const uint64_t P9N2_C_13_TIMEOUT_REG                                        = 0x2D0F0010ull;

static const uint64_t P9N2_C_14_TIMEOUT_REG                                        = 0x2E0F0010ull;

static const uint64_t P9N2_C_15_TIMEOUT_REG                                        = 0x2F0F0010ull;

static const uint64_t P9N2_C_16_TIMEOUT_REG                                        = 0x300F0010ull;

static const uint64_t P9N2_C_17_TIMEOUT_REG                                        = 0x310F0010ull;

static const uint64_t P9N2_C_18_TIMEOUT_REG                                        = 0x320F0010ull;

static const uint64_t P9N2_C_19_TIMEOUT_REG                                        = 0x330F0010ull;

static const uint64_t P9N2_C_20_TIMEOUT_REG                                        = 0x340F0010ull;

static const uint64_t P9N2_C_21_TIMEOUT_REG                                        = 0x350F0010ull;

static const uint64_t P9N2_C_22_TIMEOUT_REG                                        = 0x360F0010ull;

static const uint64_t P9N2_C_23_TIMEOUT_REG                                        = 0x370F0010ull;

static const uint64_t P9N2_EQ_TIMEOUT_REG                                          = 0x100F0010ull;

static const uint64_t P9N2_EQ_0_TIMEOUT_REG                                        = 0x100F0010ull;

static const uint64_t P9N2_EQ_1_TIMEOUT_REG                                        = 0x110F0010ull;

static const uint64_t P9N2_EQ_2_TIMEOUT_REG                                        = 0x120F0010ull;

static const uint64_t P9N2_EQ_3_TIMEOUT_REG                                        = 0x130F0010ull;

static const uint64_t P9N2_EQ_4_TIMEOUT_REG                                        = 0x140F0010ull;

static const uint64_t P9N2_EQ_5_TIMEOUT_REG                                        = 0x150F0010ull;

static const uint64_t P9N2_EX_TIMEOUT_REG                                          = 0x200F0010ull;
//DUPS: 210F0010,
static const uint64_t P9N2_EX_0_TIMEOUT_REG                                        = 0x200F0010ull;
//DUPS: 210F0010,
static const uint64_t P9N2_EX_1_TIMEOUT_REG                                        = 0x220F0010ull;
//DUPS: 220F0010,
static const uint64_t P9N2_EX_2_TIMEOUT_REG                                        = 0x240F0010ull;
//DUPS: 250F0010,
static const uint64_t P9N2_EX_3_TIMEOUT_REG                                        = 0x260F0010ull;
//DUPS: 270F0010,
static const uint64_t P9N2_EX_4_TIMEOUT_REG                                        = 0x280F0010ull;
//DUPS: 290F0010,
static const uint64_t P9N2_EX_5_TIMEOUT_REG                                        = 0x2A0F0010ull;
//DUPS: 2B0F0010,
static const uint64_t P9N2_EX_6_TIMEOUT_REG                                        = 0x2C0F0010ull;
//DUPS: 2D0F0010,
static const uint64_t P9N2_EX_7_TIMEOUT_REG                                        = 0x2E0F0010ull;
//DUPS: 2F0F0010,
static const uint64_t P9N2_EX_8_TIMEOUT_REG                                        = 0x300F0010ull;
//DUPS: 310F0010,
static const uint64_t P9N2_EX_9_TIMEOUT_REG                                        = 0x320F0010ull;
//DUPS: 330F0010,
static const uint64_t P9N2_EX_10_TIMEOUT_REG                                       = 0x340F0010ull;
//DUPS: 350F0010,
static const uint64_t P9N2_EX_11_TIMEOUT_REG                                       = 0x360F0010ull;
//DUPS: 370F0010,

static const uint64_t P9N2_C_TIMESTAMP_COUNTER_READ                                = 0x2005001Cull;

static const uint64_t P9N2_C_0_TIMESTAMP_COUNTER_READ                              = 0x2005001Cull;

static const uint64_t P9N2_C_1_TIMESTAMP_COUNTER_READ                              = 0x2105001Cull;

static const uint64_t P9N2_C_2_TIMESTAMP_COUNTER_READ                              = 0x2205001Cull;

static const uint64_t P9N2_C_3_TIMESTAMP_COUNTER_READ                              = 0x2305001Cull;

static const uint64_t P9N2_C_4_TIMESTAMP_COUNTER_READ                              = 0x2405001Cull;

static const uint64_t P9N2_C_5_TIMESTAMP_COUNTER_READ                              = 0x2505001Cull;

static const uint64_t P9N2_C_6_TIMESTAMP_COUNTER_READ                              = 0x2605001Cull;

static const uint64_t P9N2_C_7_TIMESTAMP_COUNTER_READ                              = 0x2705001Cull;

static const uint64_t P9N2_C_8_TIMESTAMP_COUNTER_READ                              = 0x2805001Cull;

static const uint64_t P9N2_C_9_TIMESTAMP_COUNTER_READ                              = 0x2905001Cull;

static const uint64_t P9N2_C_10_TIMESTAMP_COUNTER_READ                             = 0x2A05001Cull;

static const uint64_t P9N2_C_11_TIMESTAMP_COUNTER_READ                             = 0x2B05001Cull;

static const uint64_t P9N2_C_12_TIMESTAMP_COUNTER_READ                             = 0x2C05001Cull;

static const uint64_t P9N2_C_13_TIMESTAMP_COUNTER_READ                             = 0x2D05001Cull;

static const uint64_t P9N2_C_14_TIMESTAMP_COUNTER_READ                             = 0x2E05001Cull;

static const uint64_t P9N2_C_15_TIMESTAMP_COUNTER_READ                             = 0x2F05001Cull;

static const uint64_t P9N2_C_16_TIMESTAMP_COUNTER_READ                             = 0x3005001Cull;

static const uint64_t P9N2_C_17_TIMESTAMP_COUNTER_READ                             = 0x3105001Cull;

static const uint64_t P9N2_C_18_TIMESTAMP_COUNTER_READ                             = 0x3205001Cull;

static const uint64_t P9N2_C_19_TIMESTAMP_COUNTER_READ                             = 0x3305001Cull;

static const uint64_t P9N2_C_20_TIMESTAMP_COUNTER_READ                             = 0x3405001Cull;

static const uint64_t P9N2_C_21_TIMESTAMP_COUNTER_READ                             = 0x3505001Cull;

static const uint64_t P9N2_C_22_TIMESTAMP_COUNTER_READ                             = 0x3605001Cull;

static const uint64_t P9N2_C_23_TIMESTAMP_COUNTER_READ                             = 0x3705001Cull;

static const uint64_t P9N2_EQ_TIMESTAMP_COUNTER_READ                               = 0x1005001Cull;

static const uint64_t P9N2_EQ_0_TIMESTAMP_COUNTER_READ                             = 0x1005001Cull;

static const uint64_t P9N2_EQ_1_TIMESTAMP_COUNTER_READ                             = 0x1105001Cull;

static const uint64_t P9N2_EQ_2_TIMESTAMP_COUNTER_READ                             = 0x1205001Cull;

static const uint64_t P9N2_EQ_3_TIMESTAMP_COUNTER_READ                             = 0x1305001Cull;

static const uint64_t P9N2_EQ_4_TIMESTAMP_COUNTER_READ                             = 0x1405001Cull;

static const uint64_t P9N2_EQ_5_TIMESTAMP_COUNTER_READ                             = 0x1505001Cull;

static const uint64_t P9N2_EX_TIMESTAMP_COUNTER_READ                               = 0x2005001Cull;
//DUPS: 2105001C,
static const uint64_t P9N2_EX_0_TIMESTAMP_COUNTER_READ                             = 0x2005001Cull;
//DUPS: 2105001C,
static const uint64_t P9N2_EX_1_TIMESTAMP_COUNTER_READ                             = 0x2205001Cull;
//DUPS: 2305001C,
static const uint64_t P9N2_EX_2_TIMESTAMP_COUNTER_READ                             = 0x2405001Cull;
//DUPS: 2505001C,
static const uint64_t P9N2_EX_3_TIMESTAMP_COUNTER_READ                             = 0x2605001Cull;
//DUPS: 2705001C,
static const uint64_t P9N2_EX_4_TIMESTAMP_COUNTER_READ                             = 0x2805001Cull;
//DUPS: 2905001C,
static const uint64_t P9N2_EX_5_TIMESTAMP_COUNTER_READ                             = 0x2A05001Cull;
//DUPS: 2B05001C,
static const uint64_t P9N2_EX_6_TIMESTAMP_COUNTER_READ                             = 0x2C05001Cull;
//DUPS: 2D05001C,
static const uint64_t P9N2_EX_7_TIMESTAMP_COUNTER_READ                             = 0x2F05001Cull;
//DUPS: 2F05001C,
static const uint64_t P9N2_EX_8_TIMESTAMP_COUNTER_READ                             = 0x3005001Cull;
//DUPS: 3105001C,
static const uint64_t P9N2_EX_9_TIMESTAMP_COUNTER_READ                             = 0x3205001Cull;
//DUPS: 3305001C,
static const uint64_t P9N2_EX_10_TIMESTAMP_COUNTER_READ                            = 0x3405001Cull;
//DUPS: 3505001C,
static const uint64_t P9N2_EX_11_TIMESTAMP_COUNTER_READ                            = 0x3605001Cull;
//DUPS: 3705001C,

static const uint64_t P9N2_C_TOD_READ                                              = 0x20010AA3ull;

static const uint64_t P9N2_C_0_TOD_READ                                            = 0x20010AA3ull;

static const uint64_t P9N2_C_1_TOD_READ                                            = 0x21010AA3ull;

static const uint64_t P9N2_C_2_TOD_READ                                            = 0x22010AA3ull;

static const uint64_t P9N2_C_3_TOD_READ                                            = 0x23010AA3ull;

static const uint64_t P9N2_C_4_TOD_READ                                            = 0x24010AA3ull;

static const uint64_t P9N2_C_5_TOD_READ                                            = 0x25010AA3ull;

static const uint64_t P9N2_C_6_TOD_READ                                            = 0x26010AA3ull;

static const uint64_t P9N2_C_7_TOD_READ                                            = 0x27010AA3ull;

static const uint64_t P9N2_C_8_TOD_READ                                            = 0x28010AA3ull;

static const uint64_t P9N2_C_9_TOD_READ                                            = 0x29010AA3ull;

static const uint64_t P9N2_C_10_TOD_READ                                           = 0x2A010AA3ull;

static const uint64_t P9N2_C_11_TOD_READ                                           = 0x2B010AA3ull;

static const uint64_t P9N2_C_12_TOD_READ                                           = 0x2C010AA3ull;

static const uint64_t P9N2_C_13_TOD_READ                                           = 0x2D010AA3ull;

static const uint64_t P9N2_C_14_TOD_READ                                           = 0x2E010AA3ull;

static const uint64_t P9N2_C_15_TOD_READ                                           = 0x2F010AA3ull;

static const uint64_t P9N2_C_16_TOD_READ                                           = 0x30010AA3ull;

static const uint64_t P9N2_C_17_TOD_READ                                           = 0x31010AA3ull;

static const uint64_t P9N2_C_18_TOD_READ                                           = 0x32010AA3ull;

static const uint64_t P9N2_C_19_TOD_READ                                           = 0x33010AA3ull;

static const uint64_t P9N2_C_20_TOD_READ                                           = 0x34010AA3ull;

static const uint64_t P9N2_C_21_TOD_READ                                           = 0x35010AA3ull;

static const uint64_t P9N2_C_22_TOD_READ                                           = 0x36010AA3ull;

static const uint64_t P9N2_C_23_TOD_READ                                           = 0x37010AA3ull;

static const uint64_t P9N2_EX_0_L2_TOD_READ                                        = 0x20010AA3ull;
//DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_READ                                       = 0x34010AA3ull;
//DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_READ                                       = 0x36010AA3ull;
//DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_READ                                        = 0x22010AA3ull;
//DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_READ                                        = 0x24010AA3ull;
//DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_READ                                        = 0x26010AA3ull;
//DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_READ                                        = 0x28010AA3ull;
//DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_READ                                        = 0x2B010AA3ull;
//DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_READ                                        = 0x2D010AA3ull;
//DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_READ                                        = 0x2F010AA3ull;
//DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_READ                                        = 0x30010AA3ull;
//DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_READ                                        = 0x32010AA3ull;
//DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_READ                                          = 0x20010AA3ull;
//DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_STEP_CHECK                                        = 0x20010AA4ull;

static const uint64_t P9N2_C_0_TOD_STEP_CHECK                                      = 0x20010AA4ull;

static const uint64_t P9N2_C_1_TOD_STEP_CHECK                                      = 0x21010AA4ull;

static const uint64_t P9N2_C_2_TOD_STEP_CHECK                                      = 0x22010AA4ull;

static const uint64_t P9N2_C_3_TOD_STEP_CHECK                                      = 0x23010AA4ull;

static const uint64_t P9N2_C_4_TOD_STEP_CHECK                                      = 0x24010AA4ull;

static const uint64_t P9N2_C_5_TOD_STEP_CHECK                                      = 0x25010AA4ull;

static const uint64_t P9N2_C_6_TOD_STEP_CHECK                                      = 0x26010AA4ull;

static const uint64_t P9N2_C_7_TOD_STEP_CHECK                                      = 0x27010AA4ull;

static const uint64_t P9N2_C_8_TOD_STEP_CHECK                                      = 0x28010AA4ull;

static const uint64_t P9N2_C_9_TOD_STEP_CHECK                                      = 0x29010AA4ull;

static const uint64_t P9N2_C_10_TOD_STEP_CHECK                                     = 0x2A010AA4ull;

static const uint64_t P9N2_C_11_TOD_STEP_CHECK                                     = 0x2B010AA4ull;

static const uint64_t P9N2_C_12_TOD_STEP_CHECK                                     = 0x2C010AA4ull;

static const uint64_t P9N2_C_13_TOD_STEP_CHECK                                     = 0x2D010AA4ull;

static const uint64_t P9N2_C_14_TOD_STEP_CHECK                                     = 0x2E010AA4ull;

static const uint64_t P9N2_C_15_TOD_STEP_CHECK                                     = 0x2F010AA4ull;

static const uint64_t P9N2_C_16_TOD_STEP_CHECK                                     = 0x30010AA4ull;

static const uint64_t P9N2_C_17_TOD_STEP_CHECK                                     = 0x31010AA4ull;

static const uint64_t P9N2_C_18_TOD_STEP_CHECK                                     = 0x32010AA4ull;

static const uint64_t P9N2_C_19_TOD_STEP_CHECK                                     = 0x33010AA4ull;

static const uint64_t P9N2_C_20_TOD_STEP_CHECK                                     = 0x34010AA4ull;

static const uint64_t P9N2_C_21_TOD_STEP_CHECK                                     = 0x35010AA4ull;

static const uint64_t P9N2_C_22_TOD_STEP_CHECK                                     = 0x36010AA4ull;

static const uint64_t P9N2_C_23_TOD_STEP_CHECK                                     = 0x37010AA4ull;

static const uint64_t P9N2_EX_0_L2_TOD_STEP_CHECK                                  = 0x20010AA4ull;
//DUPS: 20010AA4,
static const uint64_t P9N2_EX_10_L2_TOD_STEP_CHECK                                 = 0x34010AA4ull;
//DUPS: 34010AA4,
static const uint64_t P9N2_EX_11_L2_TOD_STEP_CHECK                                 = 0x36010AA4ull;
//DUPS: 36010AA4,
static const uint64_t P9N2_EX_1_L2_TOD_STEP_CHECK                                  = 0x22010AA4ull;
//DUPS: 22010AA4,
static const uint64_t P9N2_EX_2_L2_TOD_STEP_CHECK                                  = 0x24010AA4ull;
//DUPS: 24010AA4,
static const uint64_t P9N2_EX_3_L2_TOD_STEP_CHECK                                  = 0x26010AA4ull;
//DUPS: 26010AA4,
static const uint64_t P9N2_EX_4_L2_TOD_STEP_CHECK                                  = 0x28010AA4ull;
//DUPS: 28010AA4,
static const uint64_t P9N2_EX_5_L2_TOD_STEP_CHECK                                  = 0x2B010AA4ull;
//DUPS: 2A010AA4,
static const uint64_t P9N2_EX_6_L2_TOD_STEP_CHECK                                  = 0x2D010AA4ull;
//DUPS: 2C010AA4,
static const uint64_t P9N2_EX_7_L2_TOD_STEP_CHECK                                  = 0x2F010AA4ull;
//DUPS: 2E010AA4,
static const uint64_t P9N2_EX_8_L2_TOD_STEP_CHECK                                  = 0x30010AA4ull;
//DUPS: 30010AA4,
static const uint64_t P9N2_EX_9_L2_TOD_STEP_CHECK                                  = 0x32010AA4ull;
//DUPS: 32010AA4,
static const uint64_t P9N2_EX_L2_TOD_STEP_CHECK                                    = 0x20010AA4ull;
//DUPS: 20010AA4,

static const uint64_t P9N2_C_TOD_SYNC000                                           = 0x20010AA3ull;


static const uint64_t P9N2_C_0_TOD_SYNC000                                         = 0x20010AA3ull;

static const uint64_t P9N2_C_1_TOD_SYNC000                                         = 0x21010AA3ull;

static const uint64_t P9N2_C_2_TOD_SYNC000                                         = 0x22010AA3ull;

static const uint64_t P9N2_C_3_TOD_SYNC000                                         = 0x23010AA3ull;

static const uint64_t P9N2_C_4_TOD_SYNC000                                         = 0x24010AA3ull;

static const uint64_t P9N2_C_5_TOD_SYNC000                                         = 0x25010AA3ull;

static const uint64_t P9N2_C_6_TOD_SYNC000                                         = 0x26010AA3ull;

static const uint64_t P9N2_C_7_TOD_SYNC000                                         = 0x27010AA3ull;

static const uint64_t P9N2_C_8_TOD_SYNC000                                         = 0x28010AA3ull;

static const uint64_t P9N2_C_9_TOD_SYNC000                                         = 0x29010AA3ull;

static const uint64_t P9N2_C_10_TOD_SYNC000                                        = 0x2A010AA3ull;

static const uint64_t P9N2_C_11_TOD_SYNC000                                        = 0x2B010AA3ull;

static const uint64_t P9N2_C_12_TOD_SYNC000                                        = 0x2C010AA3ull;

static const uint64_t P9N2_C_13_TOD_SYNC000                                        = 0x2D010AA3ull;

static const uint64_t P9N2_C_14_TOD_SYNC000                                        = 0x2E010AA3ull;

static const uint64_t P9N2_C_15_TOD_SYNC000                                        = 0x2F010AA3ull;

static const uint64_t P9N2_C_16_TOD_SYNC000                                        = 0x30010AA3ull;

static const uint64_t P9N2_C_17_TOD_SYNC000                                        = 0x31010AA3ull;

static const uint64_t P9N2_C_18_TOD_SYNC000                                        = 0x32010AA3ull;

static const uint64_t P9N2_C_19_TOD_SYNC000                                        = 0x33010AA3ull;

static const uint64_t P9N2_C_20_TOD_SYNC000                                        = 0x34010AA3ull;

static const uint64_t P9N2_C_21_TOD_SYNC000                                        = 0x35010AA3ull;

static const uint64_t P9N2_C_22_TOD_SYNC000                                        = 0x36010AA3ull;

static const uint64_t P9N2_C_23_TOD_SYNC000                                        = 0x37010AA3ull;

static const uint64_t P9N2_EX_0_L2_TOD_SYNC000                                     = 0x20010AA3ull;
//DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC000                                    = 0x34010AA3ull;
//DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC000                                    = 0x36010AA3ull;
//DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC000                                     = 0x22010AA3ull;
//DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC000                                     = 0x24010AA3ull;
//DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC000                                     = 0x26010AA3ull;
//DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC000                                     = 0x28010AA3ull;
//DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC000                                     = 0x2B010AA3ull;
//DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC000                                     = 0x2D010AA3ull;
//DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC000                                     = 0x2F010AA3ull;
//DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC000                                     = 0x30010AA3ull;
//DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC000                                     = 0x32010AA3ull;
//DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC000                                       = 0x20010AA3ull;
//DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_SYNC001                                           = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_0_TOD_SYNC001                                         = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_1_TOD_SYNC001                                         = 0x21010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_2_TOD_SYNC001                                         = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_3_TOD_SYNC001                                         = 0x23010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_4_TOD_SYNC001                                         = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_5_TOD_SYNC001                                         = 0x25010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_6_TOD_SYNC001                                         = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_7_TOD_SYNC001                                         = 0x27010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_8_TOD_SYNC001                                         = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_9_TOD_SYNC001                                         = 0x29010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_10_TOD_SYNC001                                        = 0x2A010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_11_TOD_SYNC001                                        = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_12_TOD_SYNC001                                        = 0x2C010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_13_TOD_SYNC001                                        = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_14_TOD_SYNC001                                        = 0x2E010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_15_TOD_SYNC001                                        = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_16_TOD_SYNC001                                        = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_17_TOD_SYNC001                                        = 0x31010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_18_TOD_SYNC001                                        = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_19_TOD_SYNC001                                        = 0x33010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_20_TOD_SYNC001                                        = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_21_TOD_SYNC001                                        = 0x35010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_22_TOD_SYNC001                                        = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_23_TOD_SYNC001                                        = 0x37010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_EX_0_L2_TOD_SYNC001                                     = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC001                                    = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC001                                    = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC001                                     = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC001                                     = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC001                                     = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC001                                     = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC001                                     = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC001                                     = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC001                                     = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC001                                     = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC001                                     = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC001                                       = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_SYNC010                                           = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_0_TOD_SYNC010                                         = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_1_TOD_SYNC010                                         = 0x21010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_2_TOD_SYNC010                                         = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_3_TOD_SYNC010                                         = 0x23010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_4_TOD_SYNC010                                         = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_5_TOD_SYNC010                                         = 0x25010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_6_TOD_SYNC010                                         = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_7_TOD_SYNC010                                         = 0x27010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_8_TOD_SYNC010                                         = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_9_TOD_SYNC010                                         = 0x29010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_10_TOD_SYNC010                                        = 0x2A010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_11_TOD_SYNC010                                        = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_12_TOD_SYNC010                                        = 0x2C010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_13_TOD_SYNC010                                        = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_14_TOD_SYNC010                                        = 0x2E010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_15_TOD_SYNC010                                        = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_16_TOD_SYNC010                                        = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_17_TOD_SYNC010                                        = 0x31010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_18_TOD_SYNC010                                        = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_19_TOD_SYNC010                                        = 0x33010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_20_TOD_SYNC010                                        = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_21_TOD_SYNC010                                        = 0x35010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_22_TOD_SYNC010                                        = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_23_TOD_SYNC010                                        = 0x37010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_EX_0_L2_TOD_SYNC010                                     = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC010                                    = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC010                                    = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC010                                     = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC010                                     = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC010                                     = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC010                                     = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC010                                     = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC010                                     = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC010                                     = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC010                                     = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC010                                     = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC010                                       = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_SYNC011                                           = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_0_TOD_SYNC011                                         = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_1_TOD_SYNC011                                         = 0x21010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_2_TOD_SYNC011                                         = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_3_TOD_SYNC011                                         = 0x23010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_4_TOD_SYNC011                                         = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_5_TOD_SYNC011                                         = 0x25010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_6_TOD_SYNC011                                         = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_7_TOD_SYNC011                                         = 0x27010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_8_TOD_SYNC011                                         = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_9_TOD_SYNC011                                         = 0x29010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_10_TOD_SYNC011                                        = 0x2A010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_11_TOD_SYNC011                                        = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_12_TOD_SYNC011                                        = 0x2C010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_13_TOD_SYNC011                                        = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_14_TOD_SYNC011                                        = 0x2E010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_15_TOD_SYNC011                                        = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_16_TOD_SYNC011                                        = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_17_TOD_SYNC011                                        = 0x31010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_18_TOD_SYNC011                                        = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_19_TOD_SYNC011                                        = 0x33010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_20_TOD_SYNC011                                        = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_21_TOD_SYNC011                                        = 0x35010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_22_TOD_SYNC011                                        = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_23_TOD_SYNC011                                        = 0x37010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_EX_0_L2_TOD_SYNC011                                     = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC011                                    = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC011                                    = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC011                                     = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC011                                     = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC011                                     = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC011                                     = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC011                                     = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC011                                     = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC011                                     = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC011                                     = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC011                                     = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC011                                       = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_SYNC100                                           = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_0_TOD_SYNC100                                         = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_1_TOD_SYNC100                                         = 0x21010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_2_TOD_SYNC100                                         = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_3_TOD_SYNC100                                         = 0x23010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_4_TOD_SYNC100                                         = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_5_TOD_SYNC100                                         = 0x25010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_6_TOD_SYNC100                                         = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_7_TOD_SYNC100                                         = 0x27010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_8_TOD_SYNC100                                         = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_9_TOD_SYNC100                                         = 0x29010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_10_TOD_SYNC100                                        = 0x2A010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_11_TOD_SYNC100                                        = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_12_TOD_SYNC100                                        = 0x2C010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_13_TOD_SYNC100                                        = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_14_TOD_SYNC100                                        = 0x2E010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_15_TOD_SYNC100                                        = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_16_TOD_SYNC100                                        = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_17_TOD_SYNC100                                        = 0x31010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_18_TOD_SYNC100                                        = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_19_TOD_SYNC100                                        = 0x33010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_20_TOD_SYNC100                                        = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_21_TOD_SYNC100                                        = 0x35010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_22_TOD_SYNC100                                        = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_23_TOD_SYNC100                                        = 0x37010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_EX_0_L2_TOD_SYNC100                                     = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC100                                    = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC100                                    = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC100                                     = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC100                                     = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC100                                     = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC100                                     = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC100                                     = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC100                                     = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC100                                     = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC100                                     = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC100                                     = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC100                                       = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_SYNC101                                           = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_0_TOD_SYNC101                                         = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_1_TOD_SYNC101                                         = 0x21010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_2_TOD_SYNC101                                         = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_3_TOD_SYNC101                                         = 0x23010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_4_TOD_SYNC101                                         = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_5_TOD_SYNC101                                         = 0x25010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_6_TOD_SYNC101                                         = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_7_TOD_SYNC101                                         = 0x27010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_8_TOD_SYNC101                                         = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_9_TOD_SYNC101                                         = 0x29010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_10_TOD_SYNC101                                        = 0x2A010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_11_TOD_SYNC101                                        = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_12_TOD_SYNC101                                        = 0x2C010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_13_TOD_SYNC101                                        = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_14_TOD_SYNC101                                        = 0x2E010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_15_TOD_SYNC101                                        = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_16_TOD_SYNC101                                        = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_17_TOD_SYNC101                                        = 0x31010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_18_TOD_SYNC101                                        = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_19_TOD_SYNC101                                        = 0x33010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_20_TOD_SYNC101                                        = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_21_TOD_SYNC101                                        = 0x35010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_22_TOD_SYNC101                                        = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_23_TOD_SYNC101                                        = 0x37010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_EX_0_L2_TOD_SYNC101                                     = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC101                                    = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC101                                    = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC101                                     = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC101                                     = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC101                                     = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC101                                     = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC101                                     = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC101                                     = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC101                                     = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC101                                     = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC101                                     = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC101                                       = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_SYNC110                                           = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_0_TOD_SYNC110                                         = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_1_TOD_SYNC110                                         = 0x21010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_2_TOD_SYNC110                                         = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_3_TOD_SYNC110                                         = 0x23010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_4_TOD_SYNC110                                         = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_5_TOD_SYNC110                                         = 0x25010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_6_TOD_SYNC110                                         = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_7_TOD_SYNC110                                         = 0x27010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_8_TOD_SYNC110                                         = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_9_TOD_SYNC110                                         = 0x29010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_10_TOD_SYNC110                                        = 0x2A010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_11_TOD_SYNC110                                        = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_12_TOD_SYNC110                                        = 0x2C010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_13_TOD_SYNC110                                        = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_14_TOD_SYNC110                                        = 0x2E010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_15_TOD_SYNC110                                        = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_16_TOD_SYNC110                                        = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_17_TOD_SYNC110                                        = 0x31010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_18_TOD_SYNC110                                        = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_19_TOD_SYNC110                                        = 0x33010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_20_TOD_SYNC110                                        = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_21_TOD_SYNC110                                        = 0x35010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_22_TOD_SYNC110                                        = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_23_TOD_SYNC110                                        = 0x37010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_EX_0_L2_TOD_SYNC110                                     = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC110                                    = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC110                                    = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC110                                     = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC110                                     = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC110                                     = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC110                                     = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC110                                     = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC110                                     = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC110                                     = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC110                                     = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC110                                     = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC110                                       = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,

static const uint64_t P9N2_C_TOD_SYNC111                                           = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_0_TOD_SYNC111                                         = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_1_TOD_SYNC111                                         = 0x21010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_2_TOD_SYNC111                                         = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_3_TOD_SYNC111                                         = 0x23010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_4_TOD_SYNC111                                         = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_5_TOD_SYNC111                                         = 0x25010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_6_TOD_SYNC111                                         = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_7_TOD_SYNC111                                         = 0x27010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_8_TOD_SYNC111                                         = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_9_TOD_SYNC111                                         = 0x29010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_10_TOD_SYNC111                                        = 0x2A010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_11_TOD_SYNC111                                        = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_12_TOD_SYNC111                                        = 0x2C010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_13_TOD_SYNC111                                        = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_14_TOD_SYNC111                                        = 0x2E010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_15_TOD_SYNC111                                        = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_16_TOD_SYNC111                                        = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_17_TOD_SYNC111                                        = 0x31010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_18_TOD_SYNC111                                        = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_19_TOD_SYNC111                                        = 0x33010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_20_TOD_SYNC111                                        = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_21_TOD_SYNC111                                        = 0x35010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_22_TOD_SYNC111                                        = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_C_23_TOD_SYNC111                                        = 0x37010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG
static const uint64_t P9N2_EX_0_L2_TOD_SYNC111                                     = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,
static const uint64_t P9N2_EX_10_L2_TOD_SYNC111                                    = 0x34010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 34010AA3,
static const uint64_t P9N2_EX_11_L2_TOD_SYNC111                                    = 0x36010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 36010AA3,
static const uint64_t P9N2_EX_1_L2_TOD_SYNC111                                     = 0x22010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 22010AA3,
static const uint64_t P9N2_EX_2_L2_TOD_SYNC111                                     = 0x24010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 24010AA3,
static const uint64_t P9N2_EX_3_L2_TOD_SYNC111                                     = 0x26010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 26010AA3,
static const uint64_t P9N2_EX_4_L2_TOD_SYNC111                                     = 0x28010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 28010AA3,
static const uint64_t P9N2_EX_5_L2_TOD_SYNC111                                     = 0x2B010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2A010AA3,
static const uint64_t P9N2_EX_6_L2_TOD_SYNC111                                     = 0x2D010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2C010AA3,
static const uint64_t P9N2_EX_7_L2_TOD_SYNC111                                     = 0x2F010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 2E010AA3,
static const uint64_t P9N2_EX_8_L2_TOD_SYNC111                                     = 0x30010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 30010AA3,
static const uint64_t P9N2_EX_9_L2_TOD_SYNC111                                     = 0x32010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 32010AA3,
static const uint64_t P9N2_EX_L2_TOD_SYNC111                                       = 0x20010AA3ull;
//WARNING - VALUE SET SAME AS ANOTHER REG //DUPS: 20010AA3,

static const uint64_t P9N2_C_TRACE_HI_DATA_REG                                     = 0x20011400ull;
//DUPS: 20011440, 20011400,
static const uint64_t P9N2_C_0_TRACE_HI_DATA_REG                                   = 0x20011400ull;
//DUPS: 20011440, 20011400,
static const uint64_t P9N2_C_1_TRACE_HI_DATA_REG                                   = 0x21011400ull;
//DUPS: 21011440, 21011400,
static const uint64_t P9N2_C_2_TRACE_HI_DATA_REG                                   = 0x22011400ull;
//DUPS: 22011440, 22011400,
static const uint64_t P9N2_C_3_TRACE_HI_DATA_REG                                   = 0x23011400ull;
//DUPS: 23011440, 23011400,
static const uint64_t P9N2_C_4_TRACE_HI_DATA_REG                                   = 0x24011400ull;
//DUPS: 24011440, 24011400,
static const uint64_t P9N2_C_5_TRACE_HI_DATA_REG                                   = 0x25011400ull;
//DUPS: 25011440, 25011400,
static const uint64_t P9N2_C_6_TRACE_HI_DATA_REG                                   = 0x26011400ull;
//DUPS: 26011440, 26011400,
static const uint64_t P9N2_C_7_TRACE_HI_DATA_REG                                   = 0x27011400ull;
//DUPS: 27011440, 27011400,
static const uint64_t P9N2_C_8_TRACE_HI_DATA_REG                                   = 0x28011400ull;
//DUPS: 28011440, 28011400,
static const uint64_t P9N2_C_9_TRACE_HI_DATA_REG                                   = 0x29011400ull;
//DUPS: 29011440, 29011400,
static const uint64_t P9N2_C_10_TRACE_HI_DATA_REG                                  = 0x2A011480ull;
//DUPS: 2A011440, 2A011400,
static const uint64_t P9N2_C_11_TRACE_HI_DATA_REG                                  = 0x2B011480ull;
//DUPS: 2B011440, 2B011400,
static const uint64_t P9N2_C_12_TRACE_HI_DATA_REG                                  = 0x2C011480ull;
//DUPS: 2C011440, 2C011400,
static const uint64_t P9N2_C_13_TRACE_HI_DATA_REG                                  = 0x2D011480ull;
//DUPS: 2D011440, 2D011400,
static const uint64_t P9N2_C_14_TRACE_HI_DATA_REG                                  = 0x2E011480ull;
//DUPS: 2E011440, 2E011400,
static const uint64_t P9N2_C_15_TRACE_HI_DATA_REG                                  = 0x2F011480ull;
//DUPS: 2F011440, 2F011400,
static const uint64_t P9N2_C_16_TRACE_HI_DATA_REG                                  = 0x30011400ull;
//DUPS: 30011440, 30011400,
static const uint64_t P9N2_C_17_TRACE_HI_DATA_REG                                  = 0x31011400ull;
//DUPS: 31011440, 31011400,
static const uint64_t P9N2_C_18_TRACE_HI_DATA_REG                                  = 0x32011400ull;
//DUPS: 32011440, 32011400,
static const uint64_t P9N2_C_19_TRACE_HI_DATA_REG                                  = 0x33011400ull;
//DUPS: 33011440, 33011400,
static const uint64_t P9N2_C_20_TRACE_HI_DATA_REG                                  = 0x34011400ull;
//DUPS: 34011440, 34011400,
static const uint64_t P9N2_C_21_TRACE_HI_DATA_REG                                  = 0x35011400ull;
//DUPS: 35011440, 35011400,
static const uint64_t P9N2_C_22_TRACE_HI_DATA_REG                                  = 0x36011400ull;
//DUPS: 36011440, 36011400,
static const uint64_t P9N2_C_23_TRACE_HI_DATA_REG                                  = 0x37011400ull;
//DUPS: 37011440, 37011400,
static const uint64_t P9N2_EQ_TRACE_HI_DATA_REG                                    = 0x10012D40ull;
//DUPS: 10010400, 100104C0, 10010480, 10012940, 10012900, 10012D40, 10012D00,
static const uint64_t P9N2_EQ_0_TRACE_HI_DATA_REG                                  = 0x10012D40ull;
//DUPS: 10010400, 100104C0, 10010480, 10012940, 10012900, 10012D40, 10012D00,
static const uint64_t P9N2_EQ_1_TRACE_HI_DATA_REG                                  = 0x11012D40ull;
//DUPS: 11010400, 110104C0, 11010480, 11012940, 11012900, 11012D40, 11012D00,
static const uint64_t P9N2_EQ_2_TRACE_HI_DATA_REG                                  = 0x12012D40ull;
//DUPS: 12010400, 120104C0, 12010480, 12012940, 12012900, 12012D40, 12012D00,
static const uint64_t P9N2_EQ_3_TRACE_HI_DATA_REG                                  = 0x13012D40ull;
//DUPS: 13010400, 130104C0, 13010480, 13012940, 13012900, 13012D40, 13012D00,
static const uint64_t P9N2_EQ_4_TRACE_HI_DATA_REG                                  = 0x14012D40ull;
//DUPS: 14010400, 140104C0, 14010480, 14012940, 14012900, 14012D40, 14012D00,
static const uint64_t P9N2_EQ_5_TRACE_HI_DATA_REG                                  = 0x15012D40ull;
//DUPS: 15010400, 150104C0, 15010480, 15012940, 15012900, 15012D40, 15012D00,
static const uint64_t P9N2_EX_TRACE_HI_DATA_REG                                    = 0x10012900ull;
//DUPS: 10012900, 20011480, 20011440, 20011400, 21011480, 21011440, 21011400,
static const uint64_t P9N2_EX_0_TRACE_HI_DATA_REG                                  = 0x10012900ull;
//DUPS: 10012900, 20011480, 20011440, 20011400, 21011480, 21011440, 21011400,
static const uint64_t P9N2_EX_1_TRACE_HI_DATA_REG                                  = 0x10012D40ull;
//DUPS: 10012D00, 22011480, 22011440, 22011400, 23011480, 23011440, 23011400,
static const uint64_t P9N2_EX_2_TRACE_HI_DATA_REG                                  = 0x11012900ull;
//DUPS: 11012900, 24011480, 24011440, 24011400, 25011480, 25011440, 25011400,
static const uint64_t P9N2_EX_3_TRACE_HI_DATA_REG                                  = 0x11012D40ull;
//DUPS: 11012D00, 26011480, 26011440, 26011400, 27011480, 27011440, 27011400,
static const uint64_t P9N2_EX_4_TRACE_HI_DATA_REG                                  = 0x12012900ull;
//DUPS: 12012900, 28011480, 28011440, 28011400, 29011480, 29011440, 29011400,
static const uint64_t P9N2_EX_5_TRACE_HI_DATA_REG                                  = 0x2A011480ull;
//DUPS: 12012D00, 2A011480, 2A011440, 2A011400, 2B011480, 2B011440, 2B011400,
static const uint64_t P9N2_EX_6_TRACE_HI_DATA_REG                                  = 0x2C011480ull;
//DUPS: 13012900, 2C011480, 2C011440, 2C011400, 2D011480, 2D011440, 2D011400,
static const uint64_t P9N2_EX_7_TRACE_HI_DATA_REG                                  = 0x2F011480ull;
//DUPS: 13012D00, 2E011480, 2E011440, 2E011400, 2F011480, 2F011440, 2F011400,
static const uint64_t P9N2_EX_8_TRACE_HI_DATA_REG                                  = 0x14012900ull;
//DUPS: 14012900, 30011480, 30011440, 30011400, 31011480, 31011440, 31011400,
static const uint64_t P9N2_EX_9_TRACE_HI_DATA_REG                                  = 0x14012D40ull;
//DUPS: 14012D00, 32011480, 32011440, 32011400, 33011480, 33011440, 33011400,
static const uint64_t P9N2_EX_10_TRACE_HI_DATA_REG                                 = 0x15012900ull;
//DUPS: 15012900, 34011480, 34011440, 34011400, 35011480, 35011440, 35011400,
static const uint64_t P9N2_EX_11_TRACE_HI_DATA_REG                                 = 0x15012D40ull;
//DUPS: 15012D00, 36011480, 36011440, 36011400, 37011480, 37011440, 37011400,

static const uint64_t P9N2_C_TRACE_LO_DATA_REG                                     = 0x20011401ull;
//DUPS: 20011441, 20011401,
static const uint64_t P9N2_C_0_TRACE_LO_DATA_REG                                   = 0x20011401ull;
//DUPS: 20011441, 20011401,
static const uint64_t P9N2_C_1_TRACE_LO_DATA_REG                                   = 0x21011401ull;
//DUPS: 21011441, 21011401,
static const uint64_t P9N2_C_2_TRACE_LO_DATA_REG                                   = 0x22011401ull;
//DUPS: 22011441, 22011401,
static const uint64_t P9N2_C_3_TRACE_LO_DATA_REG                                   = 0x23011401ull;
//DUPS: 23011441, 23011401,
static const uint64_t P9N2_C_4_TRACE_LO_DATA_REG                                   = 0x24011401ull;
//DUPS: 24011441, 24011401,
static const uint64_t P9N2_C_5_TRACE_LO_DATA_REG                                   = 0x25011401ull;
//DUPS: 25011441, 25011401,
static const uint64_t P9N2_C_6_TRACE_LO_DATA_REG                                   = 0x26011401ull;
//DUPS: 26011441, 26011401,
static const uint64_t P9N2_C_7_TRACE_LO_DATA_REG                                   = 0x27011401ull;
//DUPS: 27011441, 27011401,
static const uint64_t P9N2_C_8_TRACE_LO_DATA_REG                                   = 0x28011401ull;
//DUPS: 28011441, 28011401,
static const uint64_t P9N2_C_9_TRACE_LO_DATA_REG                                   = 0x29011401ull;
//DUPS: 29011441, 29011401,
static const uint64_t P9N2_C_10_TRACE_LO_DATA_REG                                  = 0x2A011481ull;
//DUPS: 2A011441, 2A011401,
static const uint64_t P9N2_C_11_TRACE_LO_DATA_REG                                  = 0x2B011481ull;
//DUPS: 2B011441, 2B011401,
static const uint64_t P9N2_C_12_TRACE_LO_DATA_REG                                  = 0x2C011481ull;
//DUPS: 2C011441, 2C011401,
static const uint64_t P9N2_C_13_TRACE_LO_DATA_REG                                  = 0x2D011481ull;
//DUPS: 2D011441, 2D011401,
static const uint64_t P9N2_C_14_TRACE_LO_DATA_REG                                  = 0x2E011481ull;
//DUPS: 2E011441, 2E011401,
static const uint64_t P9N2_C_15_TRACE_LO_DATA_REG                                  = 0x2F011481ull;
//DUPS: 2F011441, 2F011401,
static const uint64_t P9N2_C_16_TRACE_LO_DATA_REG                                  = 0x30011401ull;
//DUPS: 30011441, 30011401,
static const uint64_t P9N2_C_17_TRACE_LO_DATA_REG                                  = 0x31011401ull;
//DUPS: 31011441, 31011401,
static const uint64_t P9N2_C_18_TRACE_LO_DATA_REG                                  = 0x32011401ull;
//DUPS: 32011441, 32011401,
static const uint64_t P9N2_C_19_TRACE_LO_DATA_REG                                  = 0x33011401ull;
//DUPS: 33011441, 33011401,
static const uint64_t P9N2_C_20_TRACE_LO_DATA_REG                                  = 0x34011401ull;
//DUPS: 34011441, 34011401,
static const uint64_t P9N2_C_21_TRACE_LO_DATA_REG                                  = 0x35011401ull;
//DUPS: 35011441, 35011401,
static const uint64_t P9N2_C_22_TRACE_LO_DATA_REG                                  = 0x36011401ull;
//DUPS: 36011441, 36011401,
static const uint64_t P9N2_C_23_TRACE_LO_DATA_REG                                  = 0x37011401ull;
//DUPS: 37011441, 37011401,
static const uint64_t P9N2_EQ_TRACE_LO_DATA_REG                                    = 0x10012D41ull;
//DUPS: 10010401, 100104C1, 10010481, 10012941, 10012901, 10012D41, 10012D01,
static const uint64_t P9N2_EQ_0_TRACE_LO_DATA_REG                                  = 0x10012D41ull;
//DUPS: 10010401, 100104C1, 10010481, 10012941, 10012901, 10012D41, 10012D01,
static const uint64_t P9N2_EQ_1_TRACE_LO_DATA_REG                                  = 0x11012D41ull;
//DUPS: 11010401, 110104C1, 11010481, 11012941, 11012901, 11012D41, 11012D01,
static const uint64_t P9N2_EQ_2_TRACE_LO_DATA_REG                                  = 0x12012D41ull;
//DUPS: 12010401, 120104C1, 12010481, 12012941, 12012901, 12012D41, 12012D01,
static const uint64_t P9N2_EQ_3_TRACE_LO_DATA_REG                                  = 0x13012D41ull;
//DUPS: 13010401, 130104C1, 13010481, 13012941, 13012901, 13012D41, 13012D01,
static const uint64_t P9N2_EQ_4_TRACE_LO_DATA_REG                                  = 0x14012D41ull;
//DUPS: 14010401, 140104C1, 14010481, 14012941, 14012901, 14012D41, 14012D01,
static const uint64_t P9N2_EQ_5_TRACE_LO_DATA_REG                                  = 0x15012D41ull;
//DUPS: 15010401, 150104C1, 15010481, 15012941, 15012901, 15012D41, 15012D01,
static const uint64_t P9N2_EX_TRACE_LO_DATA_REG                                    = 0x10012901ull;
//DUPS: 10012901, 20011481, 20011441, 20011401, 21011481, 21011441, 21011401,
static const uint64_t P9N2_EX_0_TRACE_LO_DATA_REG                                  = 0x10012901ull;
//DUPS: 10012901, 20011481, 20011441, 20011401, 21011481, 21011441, 21011401,
static const uint64_t P9N2_EX_1_TRACE_LO_DATA_REG                                  = 0x10012D41ull;
//DUPS: 10012D01, 22011481, 22011441, 22011401, 23011481, 23011441, 23011401,
static const uint64_t P9N2_EX_2_TRACE_LO_DATA_REG                                  = 0x11012901ull;
//DUPS: 11012901, 24011481, 24011441, 24011401, 25011481, 25011441, 25011401,
static const uint64_t P9N2_EX_3_TRACE_LO_DATA_REG                                  = 0x11012D41ull;
//DUPS: 11012D01, 26011481, 26011441, 26011401, 27011481, 27011441, 27011401,
static const uint64_t P9N2_EX_4_TRACE_LO_DATA_REG                                  = 0x12012901ull;
//DUPS: 12012901, 28011481, 28011441, 28011401, 29011481, 29011441, 29011401,
static const uint64_t P9N2_EX_5_TRACE_LO_DATA_REG                                  = 0x2A011481ull;
//DUPS: 12012D01, 2A011481, 2A011441, 2A011401, 2B011481, 2B011441, 2B011401,
static const uint64_t P9N2_EX_6_TRACE_LO_DATA_REG                                  = 0x2C011481ull;
//DUPS: 13012901, 2C011481, 2C011441, 2C011401, 2D011481, 2D011441, 2D011401,
static const uint64_t P9N2_EX_7_TRACE_LO_DATA_REG                                  = 0x2F011481ull;
//DUPS: 13012D01, 2E011481, 2E011441, 2E011401, 2F011481, 2F011441, 2F011401,
static const uint64_t P9N2_EX_8_TRACE_LO_DATA_REG                                  = 0x14012901ull;
//DUPS: 14012901, 30011481, 30011441, 30011401, 31011481, 31011441, 31011401,
static const uint64_t P9N2_EX_9_TRACE_LO_DATA_REG                                  = 0x14012D41ull;
//DUPS: 14012D01, 32011481, 32011441, 32011401, 33011481, 33011441, 33011401,
static const uint64_t P9N2_EX_10_TRACE_LO_DATA_REG                                 = 0x15012901ull;
//DUPS: 15012901, 34011481, 34011441, 34011401, 35011481, 35011441, 35011401,
static const uint64_t P9N2_EX_11_TRACE_LO_DATA_REG                                 = 0x15012D41ull;
//DUPS: 15012D01, 36011481, 36011441, 36011401, 37011481, 37011441, 37011401,

static const uint64_t P9N2_C_TRACE_TRCTRL_CONFIG                                   = 0x20011402ull;
//DUPS: 20011442, 20011402,
static const uint64_t P9N2_C_0_TRACE_TRCTRL_CONFIG                                 = 0x20011402ull;
//DUPS: 20011442, 20011402,
static const uint64_t P9N2_C_1_TRACE_TRCTRL_CONFIG                                 = 0x21011402ull;
//DUPS: 21011442, 21011402,
static const uint64_t P9N2_C_2_TRACE_TRCTRL_CONFIG                                 = 0x22011402ull;
//DUPS: 22011442, 22011402,
static const uint64_t P9N2_C_3_TRACE_TRCTRL_CONFIG                                 = 0x23011402ull;
//DUPS: 23011442, 23011402,
static const uint64_t P9N2_C_4_TRACE_TRCTRL_CONFIG                                 = 0x24011402ull;
//DUPS: 24011442, 24011402,
static const uint64_t P9N2_C_5_TRACE_TRCTRL_CONFIG                                 = 0x25011402ull;
//DUPS: 25011442, 25011402,
static const uint64_t P9N2_C_6_TRACE_TRCTRL_CONFIG                                 = 0x26011402ull;
//DUPS: 26011442, 26011402,
static const uint64_t P9N2_C_7_TRACE_TRCTRL_CONFIG                                 = 0x27011402ull;
//DUPS: 27011442, 27011402,
static const uint64_t P9N2_C_8_TRACE_TRCTRL_CONFIG                                 = 0x28011402ull;
//DUPS: 28011442, 28011402,
static const uint64_t P9N2_C_9_TRACE_TRCTRL_CONFIG                                 = 0x29011402ull;
//DUPS: 29011442, 29011402,
static const uint64_t P9N2_C_10_TRACE_TRCTRL_CONFIG                                = 0x2A011482ull;
//DUPS: 2A011442, 2A011402,
static const uint64_t P9N2_C_11_TRACE_TRCTRL_CONFIG                                = 0x2B011482ull;
//DUPS: 2B011442, 2B011402,
static const uint64_t P9N2_C_12_TRACE_TRCTRL_CONFIG                                = 0x2C011482ull;
//DUPS: 2C011442, 2C011402,
static const uint64_t P9N2_C_13_TRACE_TRCTRL_CONFIG                                = 0x2D011482ull;
//DUPS: 2D011442, 2D011402,
static const uint64_t P9N2_C_14_TRACE_TRCTRL_CONFIG                                = 0x2E011482ull;
//DUPS: 2E011442, 2E011402,
static const uint64_t P9N2_C_15_TRACE_TRCTRL_CONFIG                                = 0x2F011482ull;
//DUPS: 2F011442, 2F011402,
static const uint64_t P9N2_C_16_TRACE_TRCTRL_CONFIG                                = 0x30011402ull;
//DUPS: 30011442, 30011402,
static const uint64_t P9N2_C_17_TRACE_TRCTRL_CONFIG                                = 0x31011402ull;
//DUPS: 31011442, 31011402,
static const uint64_t P9N2_C_18_TRACE_TRCTRL_CONFIG                                = 0x32011402ull;
//DUPS: 32011442, 32011402,
static const uint64_t P9N2_C_19_TRACE_TRCTRL_CONFIG                                = 0x33011402ull;
//DUPS: 33011442, 33011402,
static const uint64_t P9N2_C_20_TRACE_TRCTRL_CONFIG                                = 0x34011402ull;
//DUPS: 34011442, 34011402,
static const uint64_t P9N2_C_21_TRACE_TRCTRL_CONFIG                                = 0x35011402ull;
//DUPS: 35011442, 35011402,
static const uint64_t P9N2_C_22_TRACE_TRCTRL_CONFIG                                = 0x36011402ull;
//DUPS: 36011442, 36011402,
static const uint64_t P9N2_C_23_TRACE_TRCTRL_CONFIG                                = 0x37011402ull;
//DUPS: 37011442, 37011402,
static const uint64_t P9N2_EQ_TRACE_TRCTRL_CONFIG                                  = 0x10012D42ull;
//DUPS: 10010402, 100104C2, 10010482, 10012942, 10012902, 10012D42, 10012D02,
static const uint64_t P9N2_EQ_0_TRACE_TRCTRL_CONFIG                                = 0x10012D42ull;
//DUPS: 10010402, 100104C2, 10010482, 10012942, 10012902, 10012D42, 10012D02,
static const uint64_t P9N2_EQ_1_TRACE_TRCTRL_CONFIG                                = 0x11012D42ull;
//DUPS: 11010402, 110104C2, 11010482, 11012942, 11012902, 11012D42, 11012D02,
static const uint64_t P9N2_EQ_2_TRACE_TRCTRL_CONFIG                                = 0x12012D42ull;
//DUPS: 12010402, 120104C2, 12010482, 12012942, 12012902, 12012D42, 12012D02,
static const uint64_t P9N2_EQ_3_TRACE_TRCTRL_CONFIG                                = 0x13012D42ull;
//DUPS: 13010402, 130104C2, 13010482, 13012942, 13012902, 13012D42, 13012D02,
static const uint64_t P9N2_EQ_4_TRACE_TRCTRL_CONFIG                                = 0x14012D42ull;
//DUPS: 14010402, 140104C2, 14010482, 14012942, 14012902, 14012D42, 14012D02,
static const uint64_t P9N2_EQ_5_TRACE_TRCTRL_CONFIG                                = 0x15012D42ull;
//DUPS: 15010402, 150104C2, 15010482, 15012942, 15012902, 15012D42, 15012D02,
static const uint64_t P9N2_EX_TRACE_TRCTRL_CONFIG                                  = 0x10012902ull;
//DUPS: 10012902, 20011482, 20011442, 20011402, 21011482, 21011442, 21011402,
static const uint64_t P9N2_EX_0_TRACE_TRCTRL_CONFIG                                = 0x10012902ull;
//DUPS: 10012902, 20011482, 20011442, 20011402, 21011482, 21011442, 21011402,
static const uint64_t P9N2_EX_1_TRACE_TRCTRL_CONFIG                                = 0x10012D42ull;
//DUPS: 10012D02, 22011482, 22011442, 22011402, 23011482, 23011442, 23011402,
static const uint64_t P9N2_EX_2_TRACE_TRCTRL_CONFIG                                = 0x11012902ull;
//DUPS: 11012902, 24011482, 24011442, 24011402, 25011482, 25011442, 25011402,
static const uint64_t P9N2_EX_3_TRACE_TRCTRL_CONFIG                                = 0x11012D42ull;
//DUPS: 11012D02, 26011482, 26011442, 26011402, 27011482, 27011442, 27011402,
static const uint64_t P9N2_EX_4_TRACE_TRCTRL_CONFIG                                = 0x12012902ull;
//DUPS: 12012902, 28011482, 28011442, 28011402, 29011482, 29011442, 29011402,
static const uint64_t P9N2_EX_5_TRACE_TRCTRL_CONFIG                                = 0x2A011482ull;
//DUPS: 12012D02, 2A011482, 2A011442, 2A011402, 2B011482, 2B011442, 2B011402,
static const uint64_t P9N2_EX_6_TRACE_TRCTRL_CONFIG                                = 0x2C011482ull;
//DUPS: 13012902, 2C011482, 2C011442, 2C011402, 2D011482, 2D011442, 2D011402,
static const uint64_t P9N2_EX_7_TRACE_TRCTRL_CONFIG                                = 0x2F011482ull;
//DUPS: 13012D02, 2E011482, 2E011442, 2E011402, 2F011482, 2F011442, 2F011402,
static const uint64_t P9N2_EX_8_TRACE_TRCTRL_CONFIG                                = 0x14012902ull;
//DUPS: 14012902, 30011482, 30011442, 30011402, 31011482, 31011442, 31011402,
static const uint64_t P9N2_EX_9_TRACE_TRCTRL_CONFIG                                = 0x14012D42ull;
//DUPS: 14012D02, 32011482, 32011442, 32011402, 33011482, 33011442, 33011402,
static const uint64_t P9N2_EX_10_TRACE_TRCTRL_CONFIG                               = 0x15012902ull;
//DUPS: 15012902, 34011482, 34011442, 34011402, 35011482, 35011442, 35011402,
static const uint64_t P9N2_EX_11_TRACE_TRCTRL_CONFIG                               = 0x15012D42ull;
//DUPS: 15012D02, 36011482, 36011442, 36011402, 37011482, 37011442, 37011402,

static const uint64_t P9N2_C_TRACE_TRDATA_CONFIG_0                                 = 0x20011403ull;
//DUPS: 20011443, 20011403,
static const uint64_t P9N2_C_0_TRACE_TRDATA_CONFIG_0                               = 0x20011403ull;
//DUPS: 20011443, 20011403,
static const uint64_t P9N2_C_1_TRACE_TRDATA_CONFIG_0                               = 0x21011403ull;
//DUPS: 21011443, 21011403,
static const uint64_t P9N2_C_2_TRACE_TRDATA_CONFIG_0                               = 0x22011403ull;
//DUPS: 22011443, 22011403,
static const uint64_t P9N2_C_3_TRACE_TRDATA_CONFIG_0                               = 0x23011403ull;
//DUPS: 23011443, 23011403,
static const uint64_t P9N2_C_4_TRACE_TRDATA_CONFIG_0                               = 0x24011403ull;
//DUPS: 24011443, 24011403,
static const uint64_t P9N2_C_5_TRACE_TRDATA_CONFIG_0                               = 0x25011403ull;
//DUPS: 25011443, 25011403,
static const uint64_t P9N2_C_6_TRACE_TRDATA_CONFIG_0                               = 0x26011403ull;
//DUPS: 26011443, 26011403,
static const uint64_t P9N2_C_7_TRACE_TRDATA_CONFIG_0                               = 0x27011403ull;
//DUPS: 27011443, 27011403,
static const uint64_t P9N2_C_8_TRACE_TRDATA_CONFIG_0                               = 0x28011403ull;
//DUPS: 28011443, 28011403,
static const uint64_t P9N2_C_9_TRACE_TRDATA_CONFIG_0                               = 0x29011403ull;
//DUPS: 29011443, 29011403,
static const uint64_t P9N2_C_10_TRACE_TRDATA_CONFIG_0                              = 0x2A011483ull;
//DUPS: 2A011443, 2A011403,
static const uint64_t P9N2_C_11_TRACE_TRDATA_CONFIG_0                              = 0x2B011483ull;
//DUPS: 2B011443, 2B011403,
static const uint64_t P9N2_C_12_TRACE_TRDATA_CONFIG_0                              = 0x2C011483ull;
//DUPS: 2C011443, 2C011403,
static const uint64_t P9N2_C_13_TRACE_TRDATA_CONFIG_0                              = 0x2D011483ull;
//DUPS: 2D011443, 2D011403,
static const uint64_t P9N2_C_14_TRACE_TRDATA_CONFIG_0                              = 0x2E011483ull;
//DUPS: 2E011443, 2E011403,
static const uint64_t P9N2_C_15_TRACE_TRDATA_CONFIG_0                              = 0x2F011483ull;
//DUPS: 2F011443, 2F011403,
static const uint64_t P9N2_C_16_TRACE_TRDATA_CONFIG_0                              = 0x30011403ull;
//DUPS: 30011443, 30011403,
static const uint64_t P9N2_C_17_TRACE_TRDATA_CONFIG_0                              = 0x31011403ull;
//DUPS: 31011443, 31011403,
static const uint64_t P9N2_C_18_TRACE_TRDATA_CONFIG_0                              = 0x32011403ull;
//DUPS: 32011443, 32011403,
static const uint64_t P9N2_C_19_TRACE_TRDATA_CONFIG_0                              = 0x33011403ull;
//DUPS: 33011443, 33011403,
static const uint64_t P9N2_C_20_TRACE_TRDATA_CONFIG_0                              = 0x34011403ull;
//DUPS: 34011443, 34011403,
static const uint64_t P9N2_C_21_TRACE_TRDATA_CONFIG_0                              = 0x35011403ull;
//DUPS: 35011443, 35011403,
static const uint64_t P9N2_C_22_TRACE_TRDATA_CONFIG_0                              = 0x36011403ull;
//DUPS: 36011443, 36011403,
static const uint64_t P9N2_C_23_TRACE_TRDATA_CONFIG_0                              = 0x37011403ull;
//DUPS: 37011443, 37011403,
static const uint64_t P9N2_EQ_TRACE_TRDATA_CONFIG_0                                = 0x10012D43ull;
//DUPS: 10010403, 100104C3, 10010483, 10012943, 10012903, 10012D43, 10012D03,
static const uint64_t P9N2_EQ_0_TRACE_TRDATA_CONFIG_0                              = 0x10012D43ull;
//DUPS: 10010403, 100104C3, 10010483, 10012943, 10012903, 10012D43, 10012D03,
static const uint64_t P9N2_EQ_1_TRACE_TRDATA_CONFIG_0                              = 0x11012D43ull;
//DUPS: 11010403, 110104C3, 11010483, 11012943, 11012903, 11012D43, 11012D03,
static const uint64_t P9N2_EQ_2_TRACE_TRDATA_CONFIG_0                              = 0x12012D43ull;
//DUPS: 12010403, 120104C3, 12010483, 12012943, 12012903, 12012D43, 12012D03,
static const uint64_t P9N2_EQ_3_TRACE_TRDATA_CONFIG_0                              = 0x13012D43ull;
//DUPS: 13010403, 130104C3, 13010483, 13012943, 13012903, 13012D43, 13012D03,
static const uint64_t P9N2_EQ_4_TRACE_TRDATA_CONFIG_0                              = 0x14012D43ull;
//DUPS: 14010403, 140104C3, 14010483, 14012943, 14012903, 14012D43, 14012D03,
static const uint64_t P9N2_EQ_5_TRACE_TRDATA_CONFIG_0                              = 0x15012D43ull;
//DUPS: 15010403, 150104C3, 15010483, 15012943, 15012903, 15012D43, 15012D03,
static const uint64_t P9N2_EX_TRACE_TRDATA_CONFIG_0                                = 0x10012903ull;
//DUPS: 10012903, 20011483, 20011443, 20011403, 21011483, 21011443, 21011403,
static const uint64_t P9N2_EX_0_TRACE_TRDATA_CONFIG_0                              = 0x10012903ull;
//DUPS: 10012903, 20011483, 20011443, 20011403, 21011483, 21011443, 21011403,
static const uint64_t P9N2_EX_1_TRACE_TRDATA_CONFIG_0                              = 0x10012D43ull;
//DUPS: 10012D03, 22011483, 22011443, 22011403, 23011483, 23011443, 23011403,
static const uint64_t P9N2_EX_2_TRACE_TRDATA_CONFIG_0                              = 0x11012903ull;
//DUPS: 11012903, 24011483, 24011443, 24011403, 25011483, 25011443, 25011403,
static const uint64_t P9N2_EX_3_TRACE_TRDATA_CONFIG_0                              = 0x11012D43ull;
//DUPS: 11012D03, 26011483, 26011443, 26011403, 27011483, 27011443, 27011403,
static const uint64_t P9N2_EX_4_TRACE_TRDATA_CONFIG_0                              = 0x12012903ull;
//DUPS: 12012903, 28011483, 28011443, 28011403, 29011483, 29011443, 29011403,
static const uint64_t P9N2_EX_5_TRACE_TRDATA_CONFIG_0                              = 0x2A011483ull;
//DUPS: 12012D03, 2A011483, 2A011443, 2A011403, 2B011483, 2B011443, 2B011403,
static const uint64_t P9N2_EX_6_TRACE_TRDATA_CONFIG_0                              = 0x2C011483ull;
//DUPS: 13012903, 2C011483, 2C011443, 2C011403, 2D011483, 2D011443, 2D011403,
static const uint64_t P9N2_EX_7_TRACE_TRDATA_CONFIG_0                              = 0x2F011483ull;
//DUPS: 13012D03, 2E011483, 2E011443, 2E011403, 2F011483, 2F011443, 2F011403,
static const uint64_t P9N2_EX_8_TRACE_TRDATA_CONFIG_0                              = 0x14012903ull;
//DUPS: 14012903, 30011483, 30011443, 30011403, 31011483, 31011443, 31011403,
static const uint64_t P9N2_EX_9_TRACE_TRDATA_CONFIG_0                              = 0x14012D43ull;
//DUPS: 14012D03, 32011483, 32011443, 32011403, 33011483, 33011443, 33011403,
static const uint64_t P9N2_EX_10_TRACE_TRDATA_CONFIG_0                             = 0x15012903ull;
//DUPS: 15012903, 34011483, 34011443, 34011403, 35011483, 35011443, 35011403,
static const uint64_t P9N2_EX_11_TRACE_TRDATA_CONFIG_0                             = 0x15012D43ull;
//DUPS: 15012D03, 36011483, 36011443, 36011403, 37011483, 37011443, 37011403,

static const uint64_t P9N2_C_TRACE_TRDATA_CONFIG_1                                 = 0x20011404ull;
//DUPS: 20011444, 20011404,
static const uint64_t P9N2_C_0_TRACE_TRDATA_CONFIG_1                               = 0x20011404ull;
//DUPS: 20011444, 20011404,
static const uint64_t P9N2_C_1_TRACE_TRDATA_CONFIG_1                               = 0x21011404ull;
//DUPS: 21011444, 21011404,
static const uint64_t P9N2_C_2_TRACE_TRDATA_CONFIG_1                               = 0x22011404ull;
//DUPS: 22011444, 22011404,
static const uint64_t P9N2_C_3_TRACE_TRDATA_CONFIG_1                               = 0x23011404ull;
//DUPS: 23011444, 23011404,
static const uint64_t P9N2_C_4_TRACE_TRDATA_CONFIG_1                               = 0x24011404ull;
//DUPS: 24011444, 24011404,
static const uint64_t P9N2_C_5_TRACE_TRDATA_CONFIG_1                               = 0x25011404ull;
//DUPS: 25011444, 25011404,
static const uint64_t P9N2_C_6_TRACE_TRDATA_CONFIG_1                               = 0x26011404ull;
//DUPS: 26011444, 26011404,
static const uint64_t P9N2_C_7_TRACE_TRDATA_CONFIG_1                               = 0x27011404ull;
//DUPS: 27011444, 27011404,
static const uint64_t P9N2_C_8_TRACE_TRDATA_CONFIG_1                               = 0x28011404ull;
//DUPS: 28011444, 28011404,
static const uint64_t P9N2_C_9_TRACE_TRDATA_CONFIG_1                               = 0x29011404ull;
//DUPS: 29011444, 29011404,
static const uint64_t P9N2_C_10_TRACE_TRDATA_CONFIG_1                              = 0x2A011484ull;
//DUPS: 2A011444, 2A011404,
static const uint64_t P9N2_C_11_TRACE_TRDATA_CONFIG_1                              = 0x2B011484ull;
//DUPS: 2B011444, 2B011404,
static const uint64_t P9N2_C_12_TRACE_TRDATA_CONFIG_1                              = 0x2C011484ull;
//DUPS: 2C011444, 2C011404,
static const uint64_t P9N2_C_13_TRACE_TRDATA_CONFIG_1                              = 0x2D011484ull;
//DUPS: 2D011444, 2D011404,
static const uint64_t P9N2_C_14_TRACE_TRDATA_CONFIG_1                              = 0x2E011484ull;
//DUPS: 2E011444, 2E011404,
static const uint64_t P9N2_C_15_TRACE_TRDATA_CONFIG_1                              = 0x2F011484ull;
//DUPS: 2F011444, 2F011404,
static const uint64_t P9N2_C_16_TRACE_TRDATA_CONFIG_1                              = 0x30011404ull;
//DUPS: 30011444, 30011404,
static const uint64_t P9N2_C_17_TRACE_TRDATA_CONFIG_1                              = 0x31011404ull;
//DUPS: 31011444, 31011404,
static const uint64_t P9N2_C_18_TRACE_TRDATA_CONFIG_1                              = 0x32011404ull;
//DUPS: 32011444, 32011404,
static const uint64_t P9N2_C_19_TRACE_TRDATA_CONFIG_1                              = 0x33011404ull;
//DUPS: 33011444, 33011404,
static const uint64_t P9N2_C_20_TRACE_TRDATA_CONFIG_1                              = 0x34011404ull;
//DUPS: 34011444, 34011404,
static const uint64_t P9N2_C_21_TRACE_TRDATA_CONFIG_1                              = 0x35011404ull;
//DUPS: 35011444, 35011404,
static const uint64_t P9N2_C_22_TRACE_TRDATA_CONFIG_1                              = 0x36011404ull;
//DUPS: 36011444, 36011404,
static const uint64_t P9N2_C_23_TRACE_TRDATA_CONFIG_1                              = 0x37011404ull;
//DUPS: 37011444, 37011404,
static const uint64_t P9N2_EQ_TRACE_TRDATA_CONFIG_1                                = 0x10012D44ull;
//DUPS: 10010404, 100104C4, 10010484, 10012944, 10012904, 10012D44, 10012D04,
static const uint64_t P9N2_EQ_0_TRACE_TRDATA_CONFIG_1                              = 0x10012D44ull;
//DUPS: 10010404, 100104C4, 10010484, 10012944, 10012904, 10012D44, 10012D04,
static const uint64_t P9N2_EQ_1_TRACE_TRDATA_CONFIG_1                              = 0x11012D44ull;
//DUPS: 11010404, 110104C4, 11010484, 11012944, 11012904, 11012D44, 11012D04,
static const uint64_t P9N2_EQ_2_TRACE_TRDATA_CONFIG_1                              = 0x12012D44ull;
//DUPS: 12010404, 120104C4, 12010484, 12012944, 12012904, 12012D44, 12012D04,
static const uint64_t P9N2_EQ_3_TRACE_TRDATA_CONFIG_1                              = 0x13012D44ull;
//DUPS: 13010404, 130104C4, 13010484, 13012944, 13012904, 13012D44, 13012D04,
static const uint64_t P9N2_EQ_4_TRACE_TRDATA_CONFIG_1                              = 0x14012D44ull;
//DUPS: 14010404, 140104C4, 14010484, 14012944, 14012904, 14012D44, 14012D04,
static const uint64_t P9N2_EQ_5_TRACE_TRDATA_CONFIG_1                              = 0x15012D44ull;
//DUPS: 15010404, 150104C4, 15010484, 15012944, 15012904, 15012D44, 15012D04,
static const uint64_t P9N2_EX_TRACE_TRDATA_CONFIG_1                                = 0x10012904ull;
//DUPS: 10012904, 20011484, 20011444, 20011404, 21011484, 21011444, 21011404,
static const uint64_t P9N2_EX_0_TRACE_TRDATA_CONFIG_1                              = 0x10012904ull;
//DUPS: 10012904, 20011484, 20011444, 20011404, 21011484, 21011444, 21011404,
static const uint64_t P9N2_EX_1_TRACE_TRDATA_CONFIG_1                              = 0x10012D44ull;
//DUPS: 10012D04, 22011484, 22011444, 22011404, 23011484, 23011444, 23011404,
static const uint64_t P9N2_EX_2_TRACE_TRDATA_CONFIG_1                              = 0x11012904ull;
//DUPS: 11012904, 24011484, 24011444, 24011404, 25011484, 25011444, 25011404,
static const uint64_t P9N2_EX_3_TRACE_TRDATA_CONFIG_1                              = 0x11012D44ull;
//DUPS: 11012D04, 26011484, 26011444, 26011404, 27011484, 27011444, 27011404,
static const uint64_t P9N2_EX_4_TRACE_TRDATA_CONFIG_1                              = 0x12012904ull;
//DUPS: 12012904, 28011484, 28011444, 28011404, 29011484, 29011444, 29011404,
static const uint64_t P9N2_EX_5_TRACE_TRDATA_CONFIG_1                              = 0x2A011484ull;
//DUPS: 12012D04, 2A011484, 2A011444, 2A011404, 2B011484, 2B011444, 2B011404,
static const uint64_t P9N2_EX_6_TRACE_TRDATA_CONFIG_1                              = 0x2C011484ull;
//DUPS: 13012904, 2C011484, 2C011444, 2C011404, 2D011484, 2D011444, 2D011404,
static const uint64_t P9N2_EX_7_TRACE_TRDATA_CONFIG_1                              = 0x2F011484ull;
//DUPS: 13012D04, 2E011484, 2E011444, 2E011404, 2F011484, 2F011444, 2F011404,
static const uint64_t P9N2_EX_8_TRACE_TRDATA_CONFIG_1                              = 0x14012904ull;
//DUPS: 14012904, 30011484, 30011444, 30011404, 31011484, 31011444, 31011404,
static const uint64_t P9N2_EX_9_TRACE_TRDATA_CONFIG_1                              = 0x14012D44ull;
//DUPS: 14012D04, 32011484, 32011444, 32011404, 33011484, 33011444, 33011404,
static const uint64_t P9N2_EX_10_TRACE_TRDATA_CONFIG_1                             = 0x15012904ull;
//DUPS: 15012904, 34011484, 34011444, 34011404, 35011484, 35011444, 35011404,
static const uint64_t P9N2_EX_11_TRACE_TRDATA_CONFIG_1                             = 0x15012D44ull;
//DUPS: 15012D04, 36011484, 36011444, 36011404, 37011484, 37011444, 37011404,

static const uint64_t P9N2_C_TRACE_TRDATA_CONFIG_2                                 = 0x20011405ull;
//DUPS: 20011445, 20011405,
static const uint64_t P9N2_C_0_TRACE_TRDATA_CONFIG_2                               = 0x20011405ull;
//DUPS: 20011445, 20011405,
static const uint64_t P9N2_C_1_TRACE_TRDATA_CONFIG_2                               = 0x21011405ull;
//DUPS: 21011445, 21011405,
static const uint64_t P9N2_C_2_TRACE_TRDATA_CONFIG_2                               = 0x22011405ull;
//DUPS: 22011445, 22011405,
static const uint64_t P9N2_C_3_TRACE_TRDATA_CONFIG_2                               = 0x23011405ull;
//DUPS: 23011445, 23011405,
static const uint64_t P9N2_C_4_TRACE_TRDATA_CONFIG_2                               = 0x24011405ull;
//DUPS: 24011445, 24011405,
static const uint64_t P9N2_C_5_TRACE_TRDATA_CONFIG_2                               = 0x25011405ull;
//DUPS: 25011445, 25011405,
static const uint64_t P9N2_C_6_TRACE_TRDATA_CONFIG_2                               = 0x26011405ull;
//DUPS: 26011445, 26011405,
static const uint64_t P9N2_C_7_TRACE_TRDATA_CONFIG_2                               = 0x27011405ull;
//DUPS: 27011445, 27011405,
static const uint64_t P9N2_C_8_TRACE_TRDATA_CONFIG_2                               = 0x28011405ull;
//DUPS: 28011445, 28011405,
static const uint64_t P9N2_C_9_TRACE_TRDATA_CONFIG_2                               = 0x29011405ull;
//DUPS: 29011445, 29011405,
static const uint64_t P9N2_C_10_TRACE_TRDATA_CONFIG_2                              = 0x2A011485ull;
//DUPS: 2A011445, 2A011405,
static const uint64_t P9N2_C_11_TRACE_TRDATA_CONFIG_2                              = 0x2B011485ull;
//DUPS: 2B011445, 2B011405,
static const uint64_t P9N2_C_12_TRACE_TRDATA_CONFIG_2                              = 0x2C011485ull;
//DUPS: 2C011445, 2C011405,
static const uint64_t P9N2_C_13_TRACE_TRDATA_CONFIG_2                              = 0x2D011485ull;
//DUPS: 2D011445, 2D011405,
static const uint64_t P9N2_C_14_TRACE_TRDATA_CONFIG_2                              = 0x2E011485ull;
//DUPS: 2E011445, 2E011405,
static const uint64_t P9N2_C_15_TRACE_TRDATA_CONFIG_2                              = 0x2F011485ull;
//DUPS: 2F011445, 2F011405,
static const uint64_t P9N2_C_16_TRACE_TRDATA_CONFIG_2                              = 0x30011405ull;
//DUPS: 30011445, 30011405,
static const uint64_t P9N2_C_17_TRACE_TRDATA_CONFIG_2                              = 0x31011405ull;
//DUPS: 31011445, 31011405,
static const uint64_t P9N2_C_18_TRACE_TRDATA_CONFIG_2                              = 0x32011405ull;
//DUPS: 32011445, 32011405,
static const uint64_t P9N2_C_19_TRACE_TRDATA_CONFIG_2                              = 0x33011405ull;
//DUPS: 33011445, 33011405,
static const uint64_t P9N2_C_20_TRACE_TRDATA_CONFIG_2                              = 0x34011405ull;
//DUPS: 34011445, 34011405,
static const uint64_t P9N2_C_21_TRACE_TRDATA_CONFIG_2                              = 0x35011405ull;
//DUPS: 35011445, 35011405,
static const uint64_t P9N2_C_22_TRACE_TRDATA_CONFIG_2                              = 0x36011405ull;
//DUPS: 36011445, 36011405,
static const uint64_t P9N2_C_23_TRACE_TRDATA_CONFIG_2                              = 0x37011405ull;
//DUPS: 37011445, 37011405,
static const uint64_t P9N2_EQ_TRACE_TRDATA_CONFIG_2                                = 0x10012D45ull;
//DUPS: 10010405, 100104C5, 10010485, 10012945, 10012905, 10012D45, 10012D05,
static const uint64_t P9N2_EQ_0_TRACE_TRDATA_CONFIG_2                              = 0x10012D45ull;
//DUPS: 10010405, 100104C5, 10010485, 10012945, 10012905, 10012D45, 10012D05,
static const uint64_t P9N2_EQ_1_TRACE_TRDATA_CONFIG_2                              = 0x11012D45ull;
//DUPS: 11010405, 110104C5, 11010485, 11012945, 11012905, 11012D45, 11012D05,
static const uint64_t P9N2_EQ_2_TRACE_TRDATA_CONFIG_2                              = 0x12012D45ull;
//DUPS: 12010405, 120104C5, 12010485, 12012945, 12012905, 12012D45, 12012D05,
static const uint64_t P9N2_EQ_3_TRACE_TRDATA_CONFIG_2                              = 0x13012D45ull;
//DUPS: 13010405, 130104C5, 13010485, 13012945, 13012905, 13012D45, 13012D05,
static const uint64_t P9N2_EQ_4_TRACE_TRDATA_CONFIG_2                              = 0x14012D45ull;
//DUPS: 14010405, 140104C5, 14010485, 14012945, 14012905, 14012D45, 14012D05,
static const uint64_t P9N2_EQ_5_TRACE_TRDATA_CONFIG_2                              = 0x15012D45ull;
//DUPS: 15010405, 150104C5, 15010485, 15012945, 15012905, 15012D45, 15012D05,
static const uint64_t P9N2_EX_TRACE_TRDATA_CONFIG_2                                = 0x10012905ull;
//DUPS: 10012905, 20011485, 20011445, 20011405, 21011485, 21011445, 21011405,
static const uint64_t P9N2_EX_0_TRACE_TRDATA_CONFIG_2                              = 0x10012905ull;
//DUPS: 10012905, 20011485, 20011445, 20011405, 21011485, 21011445, 21011405,
static const uint64_t P9N2_EX_1_TRACE_TRDATA_CONFIG_2                              = 0x10012D45ull;
//DUPS: 10012D05, 22011485, 22011445, 22011405, 23011485, 23011445, 23011405,
static const uint64_t P9N2_EX_2_TRACE_TRDATA_CONFIG_2                              = 0x11012905ull;
//DUPS: 11012905, 24011485, 24011445, 24011405, 25011485, 25011445, 25011405,
static const uint64_t P9N2_EX_3_TRACE_TRDATA_CONFIG_2                              = 0x11012D45ull;
//DUPS: 11012D05, 26011485, 26011445, 26011405, 27011485, 27011445, 27011405,
static const uint64_t P9N2_EX_4_TRACE_TRDATA_CONFIG_2                              = 0x12012905ull;
//DUPS: 12012905, 28011485, 28011445, 28011405, 29011485, 29011445, 29011405,
static const uint64_t P9N2_EX_5_TRACE_TRDATA_CONFIG_2                              = 0x2A011485ull;
//DUPS: 12012D05, 2A011485, 2A011445, 2A011405, 2B011485, 2B011445, 2B011405,
static const uint64_t P9N2_EX_6_TRACE_TRDATA_CONFIG_2                              = 0x2C011485ull;
//DUPS: 13012905, 2C011485, 2C011445, 2C011405, 2D011485, 2D011445, 2D011405,
static const uint64_t P9N2_EX_7_TRACE_TRDATA_CONFIG_2                              = 0x2F011485ull;
//DUPS: 13012D05, 2E011485, 2E011445, 2E011405, 2F011485, 2F011445, 2F011405,
static const uint64_t P9N2_EX_8_TRACE_TRDATA_CONFIG_2                              = 0x14012905ull;
//DUPS: 14012905, 30011485, 30011445, 30011405, 31011485, 31011445, 31011405,
static const uint64_t P9N2_EX_9_TRACE_TRDATA_CONFIG_2                              = 0x14012D45ull;
//DUPS: 14012D05, 32011485, 32011445, 32011405, 33011485, 33011445, 33011405,
static const uint64_t P9N2_EX_10_TRACE_TRDATA_CONFIG_2                             = 0x15012905ull;
//DUPS: 15012905, 34011485, 34011445, 34011405, 35011485, 35011445, 35011405,
static const uint64_t P9N2_EX_11_TRACE_TRDATA_CONFIG_2                             = 0x15012D45ull;
//DUPS: 15012D05, 36011485, 36011445, 36011405, 37011485, 37011445, 37011405,

static const uint64_t P9N2_C_TRACE_TRDATA_CONFIG_3                                 = 0x20011406ull;
//DUPS: 20011446, 20011406,
static const uint64_t P9N2_C_0_TRACE_TRDATA_CONFIG_3                               = 0x20011406ull;
//DUPS: 20011446, 20011406,
static const uint64_t P9N2_C_1_TRACE_TRDATA_CONFIG_3                               = 0x21011406ull;
//DUPS: 21011446, 21011406,
static const uint64_t P9N2_C_2_TRACE_TRDATA_CONFIG_3                               = 0x22011406ull;
//DUPS: 22011446, 22011406,
static const uint64_t P9N2_C_3_TRACE_TRDATA_CONFIG_3                               = 0x23011406ull;
//DUPS: 23011446, 23011406,
static const uint64_t P9N2_C_4_TRACE_TRDATA_CONFIG_3                               = 0x24011406ull;
//DUPS: 24011446, 24011406,
static const uint64_t P9N2_C_5_TRACE_TRDATA_CONFIG_3                               = 0x25011406ull;
//DUPS: 25011446, 25011406,
static const uint64_t P9N2_C_6_TRACE_TRDATA_CONFIG_3                               = 0x26011406ull;
//DUPS: 26011446, 26011406,
static const uint64_t P9N2_C_7_TRACE_TRDATA_CONFIG_3                               = 0x27011406ull;
//DUPS: 27011446, 27011406,
static const uint64_t P9N2_C_8_TRACE_TRDATA_CONFIG_3                               = 0x28011406ull;
//DUPS: 28011446, 28011406,
static const uint64_t P9N2_C_9_TRACE_TRDATA_CONFIG_3                               = 0x29011406ull;
//DUPS: 29011446, 29011406,
static const uint64_t P9N2_C_10_TRACE_TRDATA_CONFIG_3                              = 0x2A011486ull;
//DUPS: 2A011446, 2A011406,
static const uint64_t P9N2_C_11_TRACE_TRDATA_CONFIG_3                              = 0x2B011486ull;
//DUPS: 2B011446, 2B011406,
static const uint64_t P9N2_C_12_TRACE_TRDATA_CONFIG_3                              = 0x2C011486ull;
//DUPS: 2C011446, 2C011406,
static const uint64_t P9N2_C_13_TRACE_TRDATA_CONFIG_3                              = 0x2D011486ull;
//DUPS: 2D011446, 2D011406,
static const uint64_t P9N2_C_14_TRACE_TRDATA_CONFIG_3                              = 0x2E011486ull;
//DUPS: 2E011446, 2E011406,
static const uint64_t P9N2_C_15_TRACE_TRDATA_CONFIG_3                              = 0x2F011486ull;
//DUPS: 2F011446, 2F011406,
static const uint64_t P9N2_C_16_TRACE_TRDATA_CONFIG_3                              = 0x30011406ull;
//DUPS: 30011446, 30011406,
static const uint64_t P9N2_C_17_TRACE_TRDATA_CONFIG_3                              = 0x31011406ull;
//DUPS: 31011446, 31011406,
static const uint64_t P9N2_C_18_TRACE_TRDATA_CONFIG_3                              = 0x32011406ull;
//DUPS: 32011446, 32011406,
static const uint64_t P9N2_C_19_TRACE_TRDATA_CONFIG_3                              = 0x33011406ull;
//DUPS: 33011446, 33011406,
static const uint64_t P9N2_C_20_TRACE_TRDATA_CONFIG_3                              = 0x34011406ull;
//DUPS: 34011446, 34011406,
static const uint64_t P9N2_C_21_TRACE_TRDATA_CONFIG_3                              = 0x35011406ull;
//DUPS: 35011446, 35011406,
static const uint64_t P9N2_C_22_TRACE_TRDATA_CONFIG_3                              = 0x36011406ull;
//DUPS: 36011446, 36011406,
static const uint64_t P9N2_C_23_TRACE_TRDATA_CONFIG_3                              = 0x37011406ull;
//DUPS: 37011446, 37011406,
static const uint64_t P9N2_EQ_TRACE_TRDATA_CONFIG_3                                = 0x10012D46ull;
//DUPS: 10010406, 100104C6, 10010486, 10012946, 10012906, 10012D46, 10012D06,
static const uint64_t P9N2_EQ_0_TRACE_TRDATA_CONFIG_3                              = 0x10012D46ull;
//DUPS: 10010406, 100104C6, 10010486, 10012946, 10012906, 10012D46, 10012D06,
static const uint64_t P9N2_EQ_1_TRACE_TRDATA_CONFIG_3                              = 0x11012D46ull;
//DUPS: 11010406, 110104C6, 11010486, 11012946, 11012906, 11012D46, 11012D06,
static const uint64_t P9N2_EQ_2_TRACE_TRDATA_CONFIG_3                              = 0x12012D46ull;
//DUPS: 12010406, 120104C6, 12010486, 12012946, 12012906, 12012D46, 12012D06,
static const uint64_t P9N2_EQ_3_TRACE_TRDATA_CONFIG_3                              = 0x13012D46ull;
//DUPS: 13010406, 130104C6, 13010486, 13012946, 13012906, 13012D46, 13012D06,
static const uint64_t P9N2_EQ_4_TRACE_TRDATA_CONFIG_3                              = 0x14012D46ull;
//DUPS: 14010406, 140104C6, 14010486, 14012946, 14012906, 14012D46, 14012D06,
static const uint64_t P9N2_EQ_5_TRACE_TRDATA_CONFIG_3                              = 0x15012D46ull;
//DUPS: 15010406, 150104C6, 15010486, 15012946, 15012906, 15012D46, 15012D06,
static const uint64_t P9N2_EX_TRACE_TRDATA_CONFIG_3                                = 0x10012906ull;
//DUPS: 10012906, 20011486, 20011446, 20011406, 21011486, 21011446, 21011406,
static const uint64_t P9N2_EX_0_TRACE_TRDATA_CONFIG_3                              = 0x10012906ull;
//DUPS: 10012906, 20011486, 20011446, 20011406, 21011486, 21011446, 21011406,
static const uint64_t P9N2_EX_1_TRACE_TRDATA_CONFIG_3                              = 0x10012D46ull;
//DUPS: 10012D06, 22011486, 22011446, 22011406, 23011486, 23011446, 23011406,
static const uint64_t P9N2_EX_2_TRACE_TRDATA_CONFIG_3                              = 0x11012906ull;
//DUPS: 11012906, 24011486, 24011446, 24011406, 25011486, 25011446, 25011406,
static const uint64_t P9N2_EX_3_TRACE_TRDATA_CONFIG_3                              = 0x11012D46ull;
//DUPS: 11012D06, 26011486, 26011446, 26011406, 27011486, 27011446, 27011406,
static const uint64_t P9N2_EX_4_TRACE_TRDATA_CONFIG_3                              = 0x12012906ull;
//DUPS: 12012906, 28011486, 28011446, 28011406, 29011486, 29011446, 29011406,
static const uint64_t P9N2_EX_5_TRACE_TRDATA_CONFIG_3                              = 0x2A011486ull;
//DUPS: 12012D06, 2A011486, 2A011446, 2A011406, 2B011486, 2B011446, 2B011406,
static const uint64_t P9N2_EX_6_TRACE_TRDATA_CONFIG_3                              = 0x2C011486ull;
//DUPS: 13012906, 2C011486, 2C011446, 2C011406, 2D011486, 2D011446, 2D011406,
static const uint64_t P9N2_EX_7_TRACE_TRDATA_CONFIG_3                              = 0x2F011486ull;
//DUPS: 13012D06, 2E011486, 2E011446, 2E011406, 2F011486, 2F011446, 2F011406,
static const uint64_t P9N2_EX_8_TRACE_TRDATA_CONFIG_3                              = 0x14012906ull;
//DUPS: 14012906, 30011486, 30011446, 30011406, 31011486, 31011446, 31011406,
static const uint64_t P9N2_EX_9_TRACE_TRDATA_CONFIG_3                              = 0x14012D46ull;
//DUPS: 14012D06, 32011486, 32011446, 32011406, 33011486, 33011446, 33011406,
static const uint64_t P9N2_EX_10_TRACE_TRDATA_CONFIG_3                             = 0x15012906ull;
//DUPS: 15012906, 34011486, 34011446, 34011406, 35011486, 35011446, 35011406,
static const uint64_t P9N2_EX_11_TRACE_TRDATA_CONFIG_3                             = 0x15012D46ull;
//DUPS: 15012D06, 36011486, 36011446, 36011406, 37011486, 37011446, 37011406,

static const uint64_t P9N2_C_TRACE_TRDATA_CONFIG_4                                 = 0x20011407ull;
//DUPS: 20011447, 20011407,
static const uint64_t P9N2_C_0_TRACE_TRDATA_CONFIG_4                               = 0x20011407ull;
//DUPS: 20011447, 20011407,
static const uint64_t P9N2_C_1_TRACE_TRDATA_CONFIG_4                               = 0x21011407ull;
//DUPS: 21011447, 21011407,
static const uint64_t P9N2_C_2_TRACE_TRDATA_CONFIG_4                               = 0x22011407ull;
//DUPS: 22011447, 22011407,
static const uint64_t P9N2_C_3_TRACE_TRDATA_CONFIG_4                               = 0x23011407ull;
//DUPS: 23011447, 23011407,
static const uint64_t P9N2_C_4_TRACE_TRDATA_CONFIG_4                               = 0x24011407ull;
//DUPS: 24011447, 24011407,
static const uint64_t P9N2_C_5_TRACE_TRDATA_CONFIG_4                               = 0x25011407ull;
//DUPS: 25011447, 25011407,
static const uint64_t P9N2_C_6_TRACE_TRDATA_CONFIG_4                               = 0x26011407ull;
//DUPS: 26011447, 26011407,
static const uint64_t P9N2_C_7_TRACE_TRDATA_CONFIG_4                               = 0x27011407ull;
//DUPS: 27011447, 27011407,
static const uint64_t P9N2_C_8_TRACE_TRDATA_CONFIG_4                               = 0x28011407ull;
//DUPS: 28011447, 28011407,
static const uint64_t P9N2_C_9_TRACE_TRDATA_CONFIG_4                               = 0x29011407ull;
//DUPS: 29011447, 29011407,
static const uint64_t P9N2_C_10_TRACE_TRDATA_CONFIG_4                              = 0x2A011487ull;
//DUPS: 2A011447, 2A011407,
static const uint64_t P9N2_C_11_TRACE_TRDATA_CONFIG_4                              = 0x2B011487ull;
//DUPS: 2B011447, 2B011407,
static const uint64_t P9N2_C_12_TRACE_TRDATA_CONFIG_4                              = 0x2C011487ull;
//DUPS: 2C011447, 2C011407,
static const uint64_t P9N2_C_13_TRACE_TRDATA_CONFIG_4                              = 0x2D011487ull;
//DUPS: 2D011447, 2D011407,
static const uint64_t P9N2_C_14_TRACE_TRDATA_CONFIG_4                              = 0x2E011487ull;
//DUPS: 2E011447, 2E011407,
static const uint64_t P9N2_C_15_TRACE_TRDATA_CONFIG_4                              = 0x2F011487ull;
//DUPS: 2F011447, 2F011407,
static const uint64_t P9N2_C_16_TRACE_TRDATA_CONFIG_4                              = 0x30011407ull;
//DUPS: 30011447, 30011407,
static const uint64_t P9N2_C_17_TRACE_TRDATA_CONFIG_4                              = 0x31011407ull;
//DUPS: 31011447, 31011407,
static const uint64_t P9N2_C_18_TRACE_TRDATA_CONFIG_4                              = 0x32011407ull;
//DUPS: 32011447, 32011407,
static const uint64_t P9N2_C_19_TRACE_TRDATA_CONFIG_4                              = 0x33011407ull;
//DUPS: 33011447, 33011407,
static const uint64_t P9N2_C_20_TRACE_TRDATA_CONFIG_4                              = 0x34011407ull;
//DUPS: 34011447, 34011407,
static const uint64_t P9N2_C_21_TRACE_TRDATA_CONFIG_4                              = 0x35011407ull;
//DUPS: 35011447, 35011407,
static const uint64_t P9N2_C_22_TRACE_TRDATA_CONFIG_4                              = 0x36011407ull;
//DUPS: 36011447, 36011407,
static const uint64_t P9N2_C_23_TRACE_TRDATA_CONFIG_4                              = 0x37011407ull;
//DUPS: 37011447, 37011407,
static const uint64_t P9N2_EQ_TRACE_TRDATA_CONFIG_4                                = 0x10012D47ull;
//DUPS: 10010407, 100104C7, 10010487, 10012947, 10012907, 10012D47, 10012D07,
static const uint64_t P9N2_EQ_0_TRACE_TRDATA_CONFIG_4                              = 0x10012D47ull;
//DUPS: 10010407, 100104C7, 10010487, 10012947, 10012907, 10012D47, 10012D07,
static const uint64_t P9N2_EQ_1_TRACE_TRDATA_CONFIG_4                              = 0x11012D47ull;
//DUPS: 11010407, 110104C7, 11010487, 11012947, 11012907, 11012D47, 11012D07,
static const uint64_t P9N2_EQ_2_TRACE_TRDATA_CONFIG_4                              = 0x12012D47ull;
//DUPS: 12010407, 120104C7, 12010487, 12012947, 12012907, 12012D47, 12012D07,
static const uint64_t P9N2_EQ_3_TRACE_TRDATA_CONFIG_4                              = 0x13012D47ull;
//DUPS: 13010407, 130104C7, 13010487, 13012947, 13012907, 13012D47, 13012D07,
static const uint64_t P9N2_EQ_4_TRACE_TRDATA_CONFIG_4                              = 0x14012D47ull;
//DUPS: 14010407, 140104C7, 14010487, 14012947, 14012907, 14012D47, 14012D07,
static const uint64_t P9N2_EQ_5_TRACE_TRDATA_CONFIG_4                              = 0x15012D47ull;
//DUPS: 15010407, 150104C7, 15010487, 15012947, 15012907, 15012D47, 15012D07,
static const uint64_t P9N2_EX_TRACE_TRDATA_CONFIG_4                                = 0x10012907ull;
//DUPS: 10012907, 20011487, 20011447, 20011407, 21011487, 21011447, 21011407,
static const uint64_t P9N2_EX_0_TRACE_TRDATA_CONFIG_4                              = 0x10012907ull;
//DUPS: 10012907, 20011487, 20011447, 20011407, 21011487, 21011447, 21011407,
static const uint64_t P9N2_EX_1_TRACE_TRDATA_CONFIG_4                              = 0x10012D47ull;
//DUPS: 10012D07, 22011487, 22011447, 22011407, 23011487, 23011447, 23011407,
static const uint64_t P9N2_EX_2_TRACE_TRDATA_CONFIG_4                              = 0x11012907ull;
//DUPS: 11012907, 24011487, 24011447, 24011407, 25011487, 25011447, 25011407,
static const uint64_t P9N2_EX_3_TRACE_TRDATA_CONFIG_4                              = 0x11012D47ull;
//DUPS: 11012D07, 26011487, 26011447, 26011407, 27011487, 27011447, 27011407,
static const uint64_t P9N2_EX_4_TRACE_TRDATA_CONFIG_4                              = 0x12012907ull;
//DUPS: 12012907, 28011487, 28011447, 28011407, 29011487, 29011447, 29011407,
static const uint64_t P9N2_EX_5_TRACE_TRDATA_CONFIG_4                              = 0x2A011487ull;
//DUPS: 12012D07, 2A011487, 2A011447, 2A011407, 2B011487, 2B011447, 2B011407,
static const uint64_t P9N2_EX_6_TRACE_TRDATA_CONFIG_4                              = 0x2C011487ull;
//DUPS: 13012907, 2C011487, 2C011447, 2C011407, 2D011487, 2D011447, 2D011407,
static const uint64_t P9N2_EX_7_TRACE_TRDATA_CONFIG_4                              = 0x2F011487ull;
//DUPS: 13012D07, 2E011487, 2E011447, 2E011407, 2F011487, 2F011447, 2F011407,
static const uint64_t P9N2_EX_8_TRACE_TRDATA_CONFIG_4                              = 0x14012907ull;
//DUPS: 14012907, 30011487, 30011447, 30011407, 31011487, 31011447, 31011407,
static const uint64_t P9N2_EX_9_TRACE_TRDATA_CONFIG_4                              = 0x14012D47ull;
//DUPS: 14012D07, 32011487, 32011447, 32011407, 33011487, 33011447, 33011407,
static const uint64_t P9N2_EX_10_TRACE_TRDATA_CONFIG_4                             = 0x15012907ull;
//DUPS: 15012907, 34011487, 34011447, 34011407, 35011487, 35011447, 35011407,
static const uint64_t P9N2_EX_11_TRACE_TRDATA_CONFIG_4                             = 0x15012D47ull;
//DUPS: 15012D07, 36011487, 36011447, 36011407, 37011487, 37011447, 37011407,

static const uint64_t P9N2_C_TRACE_TRDATA_CONFIG_5                                 = 0x20011408ull;
//DUPS: 20011448, 20011408,
static const uint64_t P9N2_C_0_TRACE_TRDATA_CONFIG_5                               = 0x20011408ull;
//DUPS: 20011448, 20011408,
static const uint64_t P9N2_C_1_TRACE_TRDATA_CONFIG_5                               = 0x21011408ull;
//DUPS: 21011448, 21011408,
static const uint64_t P9N2_C_2_TRACE_TRDATA_CONFIG_5                               = 0x22011408ull;
//DUPS: 22011448, 22011408,
static const uint64_t P9N2_C_3_TRACE_TRDATA_CONFIG_5                               = 0x23011408ull;
//DUPS: 23011448, 23011408,
static const uint64_t P9N2_C_4_TRACE_TRDATA_CONFIG_5                               = 0x24011408ull;
//DUPS: 24011448, 24011408,
static const uint64_t P9N2_C_5_TRACE_TRDATA_CONFIG_5                               = 0x25011408ull;
//DUPS: 25011448, 25011408,
static const uint64_t P9N2_C_6_TRACE_TRDATA_CONFIG_5                               = 0x26011408ull;
//DUPS: 26011448, 26011408,
static const uint64_t P9N2_C_7_TRACE_TRDATA_CONFIG_5                               = 0x27011408ull;
//DUPS: 27011448, 27011408,
static const uint64_t P9N2_C_8_TRACE_TRDATA_CONFIG_5                               = 0x28011408ull;
//DUPS: 28011448, 28011408,
static const uint64_t P9N2_C_9_TRACE_TRDATA_CONFIG_5                               = 0x29011408ull;
//DUPS: 29011448, 29011408,
static const uint64_t P9N2_C_10_TRACE_TRDATA_CONFIG_5                              = 0x2A011488ull;
//DUPS: 2A011448, 2A011408,
static const uint64_t P9N2_C_11_TRACE_TRDATA_CONFIG_5                              = 0x2B011488ull;
//DUPS: 2B011448, 2B011408,
static const uint64_t P9N2_C_12_TRACE_TRDATA_CONFIG_5                              = 0x2C011488ull;
//DUPS: 2C011448, 2C011408,
static const uint64_t P9N2_C_13_TRACE_TRDATA_CONFIG_5                              = 0x2D011488ull;
//DUPS: 2D011448, 2D011408,
static const uint64_t P9N2_C_14_TRACE_TRDATA_CONFIG_5                              = 0x2E011488ull;
//DUPS: 2E011448, 2E011408,
static const uint64_t P9N2_C_15_TRACE_TRDATA_CONFIG_5                              = 0x2F011488ull;
//DUPS: 2F011448, 2F011408,
static const uint64_t P9N2_C_16_TRACE_TRDATA_CONFIG_5                              = 0x30011408ull;
//DUPS: 30011448, 30011408,
static const uint64_t P9N2_C_17_TRACE_TRDATA_CONFIG_5                              = 0x31011408ull;
//DUPS: 31011448, 31011408,
static const uint64_t P9N2_C_18_TRACE_TRDATA_CONFIG_5                              = 0x32011408ull;
//DUPS: 32011448, 32011408,
static const uint64_t P9N2_C_19_TRACE_TRDATA_CONFIG_5                              = 0x33011408ull;
//DUPS: 33011448, 33011408,
static const uint64_t P9N2_C_20_TRACE_TRDATA_CONFIG_5                              = 0x34011408ull;
//DUPS: 34011448, 34011408,
static const uint64_t P9N2_C_21_TRACE_TRDATA_CONFIG_5                              = 0x35011408ull;
//DUPS: 35011448, 35011408,
static const uint64_t P9N2_C_22_TRACE_TRDATA_CONFIG_5                              = 0x36011408ull;
//DUPS: 36011448, 36011408,
static const uint64_t P9N2_C_23_TRACE_TRDATA_CONFIG_5                              = 0x37011408ull;
//DUPS: 37011448, 37011408,
static const uint64_t P9N2_EQ_TRACE_TRDATA_CONFIG_5                                = 0x10012D48ull;
//DUPS: 10010408, 100104C8, 10010488, 10012948, 10012908, 10012D48, 10012D08,
static const uint64_t P9N2_EQ_0_TRACE_TRDATA_CONFIG_5                              = 0x10012D48ull;
//DUPS: 10010408, 100104C8, 10010488, 10012948, 10012908, 10012D48, 10012D08,
static const uint64_t P9N2_EQ_1_TRACE_TRDATA_CONFIG_5                              = 0x11012D48ull;
//DUPS: 11010408, 110104C8, 11010488, 11012948, 11012908, 11012D48, 11012D08,
static const uint64_t P9N2_EQ_2_TRACE_TRDATA_CONFIG_5                              = 0x12012D48ull;
//DUPS: 12010408, 120104C8, 12010488, 12012948, 12012908, 12012D48, 12012D08,
static const uint64_t P9N2_EQ_3_TRACE_TRDATA_CONFIG_5                              = 0x13012D48ull;
//DUPS: 13010408, 130104C8, 13010488, 13012948, 13012908, 13012D48, 13012D08,
static const uint64_t P9N2_EQ_4_TRACE_TRDATA_CONFIG_5                              = 0x14012D48ull;
//DUPS: 14010408, 140104C8, 14010488, 14012948, 14012908, 14012D48, 14012D08,
static const uint64_t P9N2_EQ_5_TRACE_TRDATA_CONFIG_5                              = 0x15012D48ull;
//DUPS: 15010408, 150104C8, 15010488, 15012948, 15012908, 15012D48, 15012D08,
static const uint64_t P9N2_EX_TRACE_TRDATA_CONFIG_5                                = 0x10012908ull;
//DUPS: 10012908, 20011488, 20011448, 20011408, 21011488, 21011448, 21011408,
static const uint64_t P9N2_EX_0_TRACE_TRDATA_CONFIG_5                              = 0x10012908ull;
//DUPS: 10012908, 20011488, 20011448, 20011408, 21011488, 21011448, 21011408,
static const uint64_t P9N2_EX_1_TRACE_TRDATA_CONFIG_5                              = 0x10012D48ull;
//DUPS: 10012D08, 22011488, 22011448, 22011408, 23011488, 23011448, 23011408,
static const uint64_t P9N2_EX_2_TRACE_TRDATA_CONFIG_5                              = 0x11012908ull;
//DUPS: 11012908, 24011488, 24011448, 24011408, 25011488, 25011448, 25011408,
static const uint64_t P9N2_EX_3_TRACE_TRDATA_CONFIG_5                              = 0x11012D48ull;
//DUPS: 11012D08, 26011488, 26011448, 26011408, 27011488, 27011448, 27011408,
static const uint64_t P9N2_EX_4_TRACE_TRDATA_CONFIG_5                              = 0x12012908ull;
//DUPS: 12012908, 28011488, 28011448, 28011408, 29011488, 29011448, 29011408,
static const uint64_t P9N2_EX_5_TRACE_TRDATA_CONFIG_5                              = 0x2A011488ull;
//DUPS: 12012D08, 2A011488, 2A011448, 2A011408, 2B011488, 2B011448, 2B011408,
static const uint64_t P9N2_EX_6_TRACE_TRDATA_CONFIG_5                              = 0x2C011488ull;
//DUPS: 13012908, 2C011488, 2C011448, 2C011408, 2D011488, 2D011448, 2D011408,
static const uint64_t P9N2_EX_7_TRACE_TRDATA_CONFIG_5                              = 0x2F011488ull;
//DUPS: 13012D08, 2E011488, 2E011448, 2E011408, 2F011488, 2F011448, 2F011408,
static const uint64_t P9N2_EX_8_TRACE_TRDATA_CONFIG_5                              = 0x14012908ull;
//DUPS: 14012908, 30011488, 30011448, 30011408, 31011488, 31011448, 31011408,
static const uint64_t P9N2_EX_9_TRACE_TRDATA_CONFIG_5                              = 0x14012D48ull;
//DUPS: 14012D08, 32011488, 32011448, 32011408, 33011488, 33011448, 33011408,
static const uint64_t P9N2_EX_10_TRACE_TRDATA_CONFIG_5                             = 0x15012908ull;
//DUPS: 15012908, 34011488, 34011448, 34011408, 35011488, 35011448, 35011408,
static const uint64_t P9N2_EX_11_TRACE_TRDATA_CONFIG_5                             = 0x15012D48ull;
//DUPS: 15012D08, 36011488, 36011448, 36011408, 37011488, 37011448, 37011408,

static const uint64_t P9N2_C_TRACE_TRDATA_CONFIG_9                                 = 0x20011409ull;
//DUPS: 20011449, 20011409,
static const uint64_t P9N2_C_0_TRACE_TRDATA_CONFIG_9                               = 0x20011409ull;
//DUPS: 20011449, 20011409,
static const uint64_t P9N2_C_1_TRACE_TRDATA_CONFIG_9                               = 0x21011409ull;
//DUPS: 21011449, 21011409,
static const uint64_t P9N2_C_2_TRACE_TRDATA_CONFIG_9                               = 0x22011409ull;
//DUPS: 22011449, 22011409,
static const uint64_t P9N2_C_3_TRACE_TRDATA_CONFIG_9                               = 0x23011409ull;
//DUPS: 23011449, 23011409,
static const uint64_t P9N2_C_4_TRACE_TRDATA_CONFIG_9                               = 0x24011409ull;
//DUPS: 24011449, 24011409,
static const uint64_t P9N2_C_5_TRACE_TRDATA_CONFIG_9                               = 0x25011409ull;
//DUPS: 25011449, 25011409,
static const uint64_t P9N2_C_6_TRACE_TRDATA_CONFIG_9                               = 0x26011409ull;
//DUPS: 26011449, 26011409,
static const uint64_t P9N2_C_7_TRACE_TRDATA_CONFIG_9                               = 0x27011409ull;
//DUPS: 27011449, 27011409,
static const uint64_t P9N2_C_8_TRACE_TRDATA_CONFIG_9                               = 0x28011409ull;
//DUPS: 28011449, 28011409,
static const uint64_t P9N2_C_9_TRACE_TRDATA_CONFIG_9                               = 0x29011409ull;
//DUPS: 29011449, 29011409,
static const uint64_t P9N2_C_10_TRACE_TRDATA_CONFIG_9                              = 0x2A011489ull;
//DUPS: 2A011449, 2A011409,
static const uint64_t P9N2_C_11_TRACE_TRDATA_CONFIG_9                              = 0x2B011489ull;
//DUPS: 2B011449, 2B011409,
static const uint64_t P9N2_C_12_TRACE_TRDATA_CONFIG_9                              = 0x2C011489ull;
//DUPS: 2C011449, 2C011409,
static const uint64_t P9N2_C_13_TRACE_TRDATA_CONFIG_9                              = 0x2D011489ull;
//DUPS: 2D011449, 2D011409,
static const uint64_t P9N2_C_14_TRACE_TRDATA_CONFIG_9                              = 0x2E011489ull;
//DUPS: 2E011449, 2E011409,
static const uint64_t P9N2_C_15_TRACE_TRDATA_CONFIG_9                              = 0x2F011489ull;
//DUPS: 2F011449, 2F011409,
static const uint64_t P9N2_C_16_TRACE_TRDATA_CONFIG_9                              = 0x30011409ull;
//DUPS: 30011449, 30011409,
static const uint64_t P9N2_C_17_TRACE_TRDATA_CONFIG_9                              = 0x31011409ull;
//DUPS: 31011449, 31011409,
static const uint64_t P9N2_C_18_TRACE_TRDATA_CONFIG_9                              = 0x32011409ull;
//DUPS: 32011449, 32011409,
static const uint64_t P9N2_C_19_TRACE_TRDATA_CONFIG_9                              = 0x33011409ull;
//DUPS: 33011449, 33011409,
static const uint64_t P9N2_C_20_TRACE_TRDATA_CONFIG_9                              = 0x34011409ull;
//DUPS: 34011449, 34011409,
static const uint64_t P9N2_C_21_TRACE_TRDATA_CONFIG_9                              = 0x35011409ull;
//DUPS: 35011449, 35011409,
static const uint64_t P9N2_C_22_TRACE_TRDATA_CONFIG_9                              = 0x36011409ull;
//DUPS: 36011449, 36011409,
static const uint64_t P9N2_C_23_TRACE_TRDATA_CONFIG_9                              = 0x37011409ull;
//DUPS: 37011449, 37011409,
static const uint64_t P9N2_EQ_TRACE_TRDATA_CONFIG_9                                = 0x10012D49ull;
//DUPS: 10010409, 100104C9, 10010489, 10012949, 10012909, 10012D49, 10012D09,
static const uint64_t P9N2_EQ_0_TRACE_TRDATA_CONFIG_9                              = 0x10012D49ull;
//DUPS: 10010409, 100104C9, 10010489, 10012949, 10012909, 10012D49, 10012D09,
static const uint64_t P9N2_EQ_1_TRACE_TRDATA_CONFIG_9                              = 0x11012D49ull;
//DUPS: 11010409, 110104C9, 11010489, 11012949, 11012909, 11012D49, 11012D09,
static const uint64_t P9N2_EQ_2_TRACE_TRDATA_CONFIG_9                              = 0x12012D49ull;
//DUPS: 12010409, 120104C9, 12010489, 12012949, 12012909, 12012D49, 12012D09,
static const uint64_t P9N2_EQ_3_TRACE_TRDATA_CONFIG_9                              = 0x13012D49ull;
//DUPS: 13010409, 130104C9, 13010489, 13012949, 13012909, 13012D49, 13012D09,
static const uint64_t P9N2_EQ_4_TRACE_TRDATA_CONFIG_9                              = 0x14012D49ull;
//DUPS: 14010409, 140104C9, 14010489, 14012949, 14012909, 14012D49, 14012D09,
static const uint64_t P9N2_EQ_5_TRACE_TRDATA_CONFIG_9                              = 0x15012D49ull;
//DUPS: 15010409, 150104C9, 15010489, 15012949, 15012909, 15012D49, 15012D09,
static const uint64_t P9N2_EX_TRACE_TRDATA_CONFIG_9                                = 0x10012909ull;
//DUPS: 10012909, 20011489, 20011449, 20011409, 21011489, 21011449, 21011409,
static const uint64_t P9N2_EX_0_TRACE_TRDATA_CONFIG_9                              = 0x10012909ull;
//DUPS: 10012909, 20011489, 20011449, 20011409, 21011489, 21011449, 21011409,
static const uint64_t P9N2_EX_1_TRACE_TRDATA_CONFIG_9                              = 0x10012D49ull;
//DUPS: 10012D09, 22011489, 22011449, 22011409, 23011489, 23011449, 23011409,
static const uint64_t P9N2_EX_2_TRACE_TRDATA_CONFIG_9                              = 0x11012909ull;
//DUPS: 11012909, 24011489, 24011449, 24011409, 25011489, 25011449, 25011409,
static const uint64_t P9N2_EX_3_TRACE_TRDATA_CONFIG_9                              = 0x11012D49ull;
//DUPS: 11012D09, 26011489, 26011449, 26011409, 27011489, 27011449, 27011409,
static const uint64_t P9N2_EX_4_TRACE_TRDATA_CONFIG_9                              = 0x12012909ull;
//DUPS: 12012909, 28011489, 28011449, 28011409, 29011489, 29011449, 29011409,
static const uint64_t P9N2_EX_5_TRACE_TRDATA_CONFIG_9                              = 0x2A011489ull;
//DUPS: 12012D09, 2A011489, 2A011449, 2A011409, 2B011489, 2B011449, 2B011409,
static const uint64_t P9N2_EX_6_TRACE_TRDATA_CONFIG_9                              = 0x2C011489ull;
//DUPS: 13012909, 2C011489, 2C011449, 2C011409, 2D011489, 2D011449, 2D011409,
static const uint64_t P9N2_EX_7_TRACE_TRDATA_CONFIG_9                              = 0x2F011489ull;
//DUPS: 13012D09, 2E011489, 2E011449, 2E011409, 2F011489, 2F011449, 2F011409,
static const uint64_t P9N2_EX_8_TRACE_TRDATA_CONFIG_9                              = 0x14012909ull;
//DUPS: 14012909, 30011489, 30011449, 30011409, 31011489, 31011449, 31011409,
static const uint64_t P9N2_EX_9_TRACE_TRDATA_CONFIG_9                              = 0x14012D49ull;
//DUPS: 14012D09, 32011489, 32011449, 32011409, 33011489, 33011449, 33011409,
static const uint64_t P9N2_EX_10_TRACE_TRDATA_CONFIG_9                             = 0x15012909ull;
//DUPS: 15012909, 34011489, 34011449, 34011409, 35011489, 35011449, 35011409,
static const uint64_t P9N2_EX_11_TRACE_TRDATA_CONFIG_9                             = 0x15012D49ull;
//DUPS: 15012D09, 36011489, 36011449, 36011409, 37011489, 37011449, 37011409,

static const uint64_t P9N2_C_URMOR                                                 = 0x20010ABAull;

static const uint64_t P9N2_C_0_URMOR                                               = 0x20010ABAull;

static const uint64_t P9N2_C_1_URMOR                                               = 0x21010ABAull;

static const uint64_t P9N2_C_2_URMOR                                               = 0x22010ABAull;

static const uint64_t P9N2_C_3_URMOR                                               = 0x23010ABAull;

static const uint64_t P9N2_C_4_URMOR                                               = 0x24010ABAull;

static const uint64_t P9N2_C_5_URMOR                                               = 0x25010ABAull;

static const uint64_t P9N2_C_6_URMOR                                               = 0x26010ABAull;

static const uint64_t P9N2_C_7_URMOR                                               = 0x27010ABAull;

static const uint64_t P9N2_C_8_URMOR                                               = 0x28010ABAull;

static const uint64_t P9N2_C_9_URMOR                                               = 0x29010ABAull;

static const uint64_t P9N2_C_10_URMOR                                              = 0x2A010ABAull;

static const uint64_t P9N2_C_11_URMOR                                              = 0x2B010ABAull;

static const uint64_t P9N2_C_12_URMOR                                              = 0x2C010ABAull;

static const uint64_t P9N2_C_13_URMOR                                              = 0x2D010ABAull;

static const uint64_t P9N2_C_14_URMOR                                              = 0x2E010ABAull;

static const uint64_t P9N2_C_15_URMOR                                              = 0x2F010ABAull;

static const uint64_t P9N2_C_16_URMOR                                              = 0x30010ABAull;

static const uint64_t P9N2_C_17_URMOR                                              = 0x31010ABAull;

static const uint64_t P9N2_C_18_URMOR                                              = 0x32010ABAull;

static const uint64_t P9N2_C_19_URMOR                                              = 0x33010ABAull;

static const uint64_t P9N2_C_20_URMOR                                              = 0x34010ABAull;

static const uint64_t P9N2_C_21_URMOR                                              = 0x35010ABAull;

static const uint64_t P9N2_C_22_URMOR                                              = 0x36010ABAull;

static const uint64_t P9N2_C_23_URMOR                                              = 0x37010ABAull;

static const uint64_t P9N2_EX_0_L2_URMOR                                           = 0x20010ABAull;
//DUPS: 21010ABA,
static const uint64_t P9N2_EX_10_L2_URMOR                                          = 0x34010ABAull;
//DUPS: 35010ABA,
static const uint64_t P9N2_EX_11_L2_URMOR                                          = 0x36010ABAull;
//DUPS: 37010ABA,
static const uint64_t P9N2_EX_1_L2_URMOR                                           = 0x22010ABAull;
//DUPS: 23010ABA,
static const uint64_t P9N2_EX_2_L2_URMOR                                           = 0x24010ABAull;
//DUPS: 25010ABA,
static const uint64_t P9N2_EX_3_L2_URMOR                                           = 0x26010ABAull;
//DUPS: 27010ABA,
static const uint64_t P9N2_EX_4_L2_URMOR                                           = 0x28010ABAull;
//DUPS: 29010ABA,
static const uint64_t P9N2_EX_5_L2_URMOR                                           = 0x2A010ABAull;
//DUPS: 2B010ABA,
static const uint64_t P9N2_EX_6_L2_URMOR                                           = 0x2C010ABAull;
//DUPS: 2D010ABA,
static const uint64_t P9N2_EX_7_L2_URMOR                                           = 0x2F010ABAull;
//DUPS: 2F010ABA,
static const uint64_t P9N2_EX_8_L2_URMOR                                           = 0x30010ABAull;
//DUPS: 31010ABA,
static const uint64_t P9N2_EX_9_L2_URMOR                                           = 0x32010ABAull;
//DUPS: 33010ABA,
static const uint64_t P9N2_EX_L2_URMOR                                             = 0x20010ABAull;
//DUPS: 21010ABA,

static const uint64_t P9N2_C_V0_HMER_WAND                                          = 0x20010A92ull;

static const uint64_t P9N2_C_V0_HMER_OR                                            = 0x20010A8Eull;

static const uint64_t P9N2_C_0_V0_HMER_WAND                                        = 0x20010A92ull;

static const uint64_t P9N2_C_0_V0_HMER_OR                                          = 0x20010A8Eull;

static const uint64_t P9N2_C_1_V0_HMER_WAND                                        = 0x21010A92ull;

static const uint64_t P9N2_C_1_V0_HMER_OR                                          = 0x21010A8Eull;

static const uint64_t P9N2_C_2_V0_HMER_WAND                                        = 0x22010A92ull;

static const uint64_t P9N2_C_2_V0_HMER_OR                                          = 0x22010A8Eull;

static const uint64_t P9N2_C_3_V0_HMER_WAND                                        = 0x23010A92ull;

static const uint64_t P9N2_C_3_V0_HMER_OR                                          = 0x23010A8Eull;

static const uint64_t P9N2_C_4_V0_HMER_WAND                                        = 0x24010A92ull;

static const uint64_t P9N2_C_4_V0_HMER_OR                                          = 0x24010A8Eull;

static const uint64_t P9N2_C_5_V0_HMER_WAND                                        = 0x25010A92ull;

static const uint64_t P9N2_C_5_V0_HMER_OR                                          = 0x25010A8Eull;

static const uint64_t P9N2_C_6_V0_HMER_WAND                                        = 0x26010A92ull;

static const uint64_t P9N2_C_6_V0_HMER_OR                                          = 0x26010A8Eull;

static const uint64_t P9N2_C_7_V0_HMER_WAND                                        = 0x27010A92ull;

static const uint64_t P9N2_C_7_V0_HMER_OR                                          = 0x27010A8Eull;

static const uint64_t P9N2_C_8_V0_HMER_WAND                                        = 0x28010A92ull;

static const uint64_t P9N2_C_8_V0_HMER_OR                                          = 0x28010A8Eull;

static const uint64_t P9N2_C_9_V0_HMER_WAND                                        = 0x29010A92ull;

static const uint64_t P9N2_C_9_V0_HMER_OR                                          = 0x29010A8Eull;

static const uint64_t P9N2_C_10_V0_HMER_WAND                                       = 0x2A010A92ull;

static const uint64_t P9N2_C_10_V0_HMER_OR                                         = 0x2A010A8Eull;

static const uint64_t P9N2_C_11_V0_HMER_WAND                                       = 0x2B010A92ull;

static const uint64_t P9N2_C_11_V0_HMER_OR                                         = 0x2B010A8Eull;

static const uint64_t P9N2_C_12_V0_HMER_WAND                                       = 0x2C010A92ull;

static const uint64_t P9N2_C_12_V0_HMER_OR                                         = 0x2C010A8Eull;

static const uint64_t P9N2_C_13_V0_HMER_WAND                                       = 0x2D010A92ull;

static const uint64_t P9N2_C_13_V0_HMER_OR                                         = 0x2D010A8Eull;

static const uint64_t P9N2_C_14_V0_HMER_WAND                                       = 0x2E010A92ull;

static const uint64_t P9N2_C_14_V0_HMER_OR                                         = 0x2E010A8Eull;

static const uint64_t P9N2_C_15_V0_HMER_WAND                                       = 0x2F010A92ull;

static const uint64_t P9N2_C_15_V0_HMER_OR                                         = 0x2F010A8Eull;

static const uint64_t P9N2_C_16_V0_HMER_WAND                                       = 0x30010A92ull;

static const uint64_t P9N2_C_16_V0_HMER_OR                                         = 0x30010A8Eull;

static const uint64_t P9N2_C_17_V0_HMER_WAND                                       = 0x31010A92ull;

static const uint64_t P9N2_C_17_V0_HMER_OR                                         = 0x31010A8Eull;

static const uint64_t P9N2_C_18_V0_HMER_WAND                                       = 0x32010A92ull;

static const uint64_t P9N2_C_18_V0_HMER_OR                                         = 0x32010A8Eull;

static const uint64_t P9N2_C_19_V0_HMER_WAND                                       = 0x33010A92ull;

static const uint64_t P9N2_C_19_V0_HMER_OR                                         = 0x33010A8Eull;

static const uint64_t P9N2_C_20_V0_HMER_WAND                                       = 0x34010A92ull;

static const uint64_t P9N2_C_20_V0_HMER_OR                                         = 0x34010A8Eull;

static const uint64_t P9N2_C_21_V0_HMER_WAND                                       = 0x35010A92ull;

static const uint64_t P9N2_C_21_V0_HMER_OR                                         = 0x35010A8Eull;

static const uint64_t P9N2_C_22_V0_HMER_WAND                                       = 0x36010A92ull;

static const uint64_t P9N2_C_22_V0_HMER_OR                                         = 0x36010A8Eull;

static const uint64_t P9N2_C_23_V0_HMER_WAND                                       = 0x37010A92ull;

static const uint64_t P9N2_C_23_V0_HMER_OR                                         = 0x37010A8Eull;

static const uint64_t P9N2_EX_V0_HMER                                              = 0x20010A8Eull;
//DUPS: 20010A8E,
static const uint64_t P9N2_EX_0_V0_HMER                                            = 0x20010A8Eull;
//DUPS: 20010A8E,
static const uint64_t P9N2_EX_1_V0_HMER                                            = 0x22010A8Eull;
//DUPS: 22010A8E,
static const uint64_t P9N2_EX_2_V0_HMER                                            = 0x24010A8Eull;
//DUPS: 24010A8E,
static const uint64_t P9N2_EX_3_V0_HMER                                            = 0x26010A8Eull;
//DUPS: 26010A8E,
static const uint64_t P9N2_EX_4_V0_HMER                                            = 0x28010A8Eull;
//DUPS: 28010A8E,
static const uint64_t P9N2_EX_5_V0_HMER                                            = 0x2B010A8Eull;
//DUPS: 2A010A8E,
static const uint64_t P9N2_EX_6_V0_HMER                                            = 0x2D010A8Eull;
//DUPS: 2C010A8E,
static const uint64_t P9N2_EX_7_V0_HMER                                            = 0x2F010A8Eull;
//DUPS: 2E010A8E,
static const uint64_t P9N2_EX_8_V0_HMER                                            = 0x30010A8Eull;
//DUPS: 30010A8E,
static const uint64_t P9N2_EX_9_V0_HMER                                            = 0x32010A8Eull;
//DUPS: 32010A8E,
static const uint64_t P9N2_EX_0_L2_V0_HMER                                         = 0x20010A92ull;
//DUPS: 20010A92,
static const uint64_t P9N2_EX_10_V0_HMER                                           = 0x34010A8Eull;
//DUPS: 34010A8E,
static const uint64_t P9N2_EX_11_V0_HMER                                           = 0x36010A8Eull;
//DUPS: 36010A8E,
static const uint64_t P9N2_EX_10_L2_V0_HMER                                        = 0x34010A92ull;
//DUPS: 34010A92,
static const uint64_t P9N2_EX_11_L2_V0_HMER                                        = 0x36010A92ull;
//DUPS: 36010A92,
static const uint64_t P9N2_EX_1_L2_V0_HMER                                         = 0x22010A92ull;
//DUPS: 22010A92,
static const uint64_t P9N2_EX_2_L2_V0_HMER                                         = 0x24010A92ull;
//DUPS: 24010A92,
static const uint64_t P9N2_EX_3_L2_V0_HMER                                         = 0x26010A92ull;
//DUPS: 26010A92,
static const uint64_t P9N2_EX_4_L2_V0_HMER                                         = 0x28010A92ull;
//DUPS: 28010A92,
static const uint64_t P9N2_EX_5_L2_V0_HMER                                         = 0x2B010A92ull;
//DUPS: 2A010A92,
static const uint64_t P9N2_EX_6_L2_V0_HMER                                         = 0x2D010A92ull;
//DUPS: 2C010A92,
static const uint64_t P9N2_EX_7_L2_V0_HMER                                         = 0x2F010A92ull;
//DUPS: 2E010A92,
static const uint64_t P9N2_EX_8_L2_V0_HMER                                         = 0x30010A92ull;
//DUPS: 30010A92,
static const uint64_t P9N2_EX_9_L2_V0_HMER                                         = 0x32010A92ull;
//DUPS: 32010A92,
static const uint64_t P9N2_EX_L2_V0_HMER                                           = 0x20010A92ull;
//DUPS: 20010A92,

static const uint64_t P9N2_C_V1_HMER_WAND                                          = 0x20010A93ull;

static const uint64_t P9N2_C_V1_HMER_OR                                            = 0x20010A8Full;

static const uint64_t P9N2_C_0_V1_HMER_WAND                                        = 0x20010A93ull;

static const uint64_t P9N2_C_0_V1_HMER_OR                                          = 0x20010A8Full;

static const uint64_t P9N2_C_1_V1_HMER_WAND                                        = 0x21010A93ull;

static const uint64_t P9N2_C_1_V1_HMER_OR                                          = 0x21010A8Full;

static const uint64_t P9N2_C_2_V1_HMER_WAND                                        = 0x22010A93ull;

static const uint64_t P9N2_C_2_V1_HMER_OR                                          = 0x22010A8Full;

static const uint64_t P9N2_C_3_V1_HMER_WAND                                        = 0x23010A93ull;

static const uint64_t P9N2_C_3_V1_HMER_OR                                          = 0x23010A8Full;

static const uint64_t P9N2_C_4_V1_HMER_WAND                                        = 0x24010A93ull;

static const uint64_t P9N2_C_4_V1_HMER_OR                                          = 0x24010A8Full;

static const uint64_t P9N2_C_5_V1_HMER_WAND                                        = 0x25010A93ull;

static const uint64_t P9N2_C_5_V1_HMER_OR                                          = 0x25010A8Full;

static const uint64_t P9N2_C_6_V1_HMER_WAND                                        = 0x26010A93ull;

static const uint64_t P9N2_C_6_V1_HMER_OR                                          = 0x26010A8Full;

static const uint64_t P9N2_C_7_V1_HMER_WAND                                        = 0x27010A93ull;

static const uint64_t P9N2_C_7_V1_HMER_OR                                          = 0x27010A8Full;

static const uint64_t P9N2_C_8_V1_HMER_WAND                                        = 0x28010A93ull;

static const uint64_t P9N2_C_8_V1_HMER_OR                                          = 0x28010A8Full;

static const uint64_t P9N2_C_9_V1_HMER_WAND                                        = 0x29010A93ull;

static const uint64_t P9N2_C_9_V1_HMER_OR                                          = 0x29010A8Full;

static const uint64_t P9N2_C_10_V1_HMER_WAND                                       = 0x2A010A93ull;

static const uint64_t P9N2_C_10_V1_HMER_OR                                         = 0x2A010A8Full;

static const uint64_t P9N2_C_11_V1_HMER_WAND                                       = 0x2B010A93ull;

static const uint64_t P9N2_C_11_V1_HMER_OR                                         = 0x2B010A8Full;

static const uint64_t P9N2_C_12_V1_HMER_WAND                                       = 0x2C010A93ull;

static const uint64_t P9N2_C_12_V1_HMER_OR                                         = 0x2C010A8Full;

static const uint64_t P9N2_C_13_V1_HMER_WAND                                       = 0x2D010A93ull;

static const uint64_t P9N2_C_13_V1_HMER_OR                                         = 0x2D010A8Full;

static const uint64_t P9N2_C_14_V1_HMER_WAND                                       = 0x2E010A93ull;

static const uint64_t P9N2_C_14_V1_HMER_OR                                         = 0x2E010A8Full;

static const uint64_t P9N2_C_15_V1_HMER_WAND                                       = 0x2F010A93ull;

static const uint64_t P9N2_C_15_V1_HMER_OR                                         = 0x2F010A8Full;

static const uint64_t P9N2_C_16_V1_HMER_WAND                                       = 0x30010A93ull;

static const uint64_t P9N2_C_16_V1_HMER_OR                                         = 0x30010A8Full;

static const uint64_t P9N2_C_17_V1_HMER_WAND                                       = 0x31010A93ull;

static const uint64_t P9N2_C_17_V1_HMER_OR                                         = 0x31010A8Full;

static const uint64_t P9N2_C_18_V1_HMER_WAND                                       = 0x32010A93ull;

static const uint64_t P9N2_C_18_V1_HMER_OR                                         = 0x32010A8Full;

static const uint64_t P9N2_C_19_V1_HMER_WAND                                       = 0x33010A93ull;

static const uint64_t P9N2_C_19_V1_HMER_OR                                         = 0x33010A8Full;

static const uint64_t P9N2_C_20_V1_HMER_WAND                                       = 0x34010A93ull;

static const uint64_t P9N2_C_20_V1_HMER_OR                                         = 0x34010A8Full;

static const uint64_t P9N2_C_21_V1_HMER_WAND                                       = 0x35010A93ull;

static const uint64_t P9N2_C_21_V1_HMER_OR                                         = 0x35010A8Full;

static const uint64_t P9N2_C_22_V1_HMER_WAND                                       = 0x36010A93ull;

static const uint64_t P9N2_C_22_V1_HMER_OR                                         = 0x36010A8Full;

static const uint64_t P9N2_C_23_V1_HMER_WAND                                       = 0x37010A93ull;

static const uint64_t P9N2_C_23_V1_HMER_OR                                         = 0x37010A8Full;

static const uint64_t P9N2_EX_V1_HMER                                              = 0x20010A8Full;
//DUPS: 20010A8F,
static const uint64_t P9N2_EX_0_V1_HMER                                            = 0x20010A8Full;
//DUPS: 20010A8F,
static const uint64_t P9N2_EX_1_V1_HMER                                            = 0x22010A8Full;
//DUPS: 22010A8F,
static const uint64_t P9N2_EX_2_V1_HMER                                            = 0x24010A8Full;
//DUPS: 24010A8F,
static const uint64_t P9N2_EX_3_V1_HMER                                            = 0x26010A8Full;
//DUPS: 26010A8F,
static const uint64_t P9N2_EX_4_V1_HMER                                            = 0x28010A8Full;
//DUPS: 28010A8F,
static const uint64_t P9N2_EX_5_V1_HMER                                            = 0x2B010A8Full;
//DUPS: 2A010A8F,
static const uint64_t P9N2_EX_6_V1_HMER                                            = 0x2D010A8Full;
//DUPS: 2C010A8F,
static const uint64_t P9N2_EX_7_V1_HMER                                            = 0x2F010A8Full;
//DUPS: 2E010A8F,
static const uint64_t P9N2_EX_8_V1_HMER                                            = 0x30010A8Full;
//DUPS: 30010A8F,
static const uint64_t P9N2_EX_9_V1_HMER                                            = 0x32010A8Full;
//DUPS: 32010A8F,
static const uint64_t P9N2_EX_0_L2_V1_HMER                                         = 0x20010A93ull;
//DUPS: 20010A93,
static const uint64_t P9N2_EX_10_V1_HMER                                           = 0x34010A8Full;
//DUPS: 34010A8F,
static const uint64_t P9N2_EX_11_V1_HMER                                           = 0x36010A8Full;
//DUPS: 36010A8F,
static const uint64_t P9N2_EX_10_L2_V1_HMER                                        = 0x34010A93ull;
//DUPS: 34010A93,
static const uint64_t P9N2_EX_11_L2_V1_HMER                                        = 0x36010A93ull;
//DUPS: 36010A93,
static const uint64_t P9N2_EX_1_L2_V1_HMER                                         = 0x22010A93ull;
//DUPS: 22010A93,
static const uint64_t P9N2_EX_2_L2_V1_HMER                                         = 0x24010A93ull;
//DUPS: 24010A93,
static const uint64_t P9N2_EX_3_L2_V1_HMER                                         = 0x26010A93ull;
//DUPS: 26010A93,
static const uint64_t P9N2_EX_4_L2_V1_HMER                                         = 0x28010A93ull;
//DUPS: 28010A93,
static const uint64_t P9N2_EX_5_L2_V1_HMER                                         = 0x2B010A93ull;
//DUPS: 2A010A93,
static const uint64_t P9N2_EX_6_L2_V1_HMER                                         = 0x2D010A93ull;
//DUPS: 2C010A93,
static const uint64_t P9N2_EX_7_L2_V1_HMER                                         = 0x2F010A93ull;
//DUPS: 2E010A93,
static const uint64_t P9N2_EX_8_L2_V1_HMER                                         = 0x30010A93ull;
//DUPS: 30010A93,
static const uint64_t P9N2_EX_9_L2_V1_HMER                                         = 0x32010A93ull;
//DUPS: 32010A93,
static const uint64_t P9N2_EX_L2_V1_HMER                                           = 0x20010A93ull;
//DUPS: 20010A93,

static const uint64_t P9N2_C_V2_HMER_WAND                                          = 0x20010A94ull;

static const uint64_t P9N2_C_V2_HMER_OR                                            = 0x20010A90ull;

static const uint64_t P9N2_C_0_V2_HMER_WAND                                        = 0x20010A94ull;

static const uint64_t P9N2_C_0_V2_HMER_OR                                          = 0x20010A90ull;

static const uint64_t P9N2_C_1_V2_HMER_WAND                                        = 0x21010A94ull;

static const uint64_t P9N2_C_1_V2_HMER_OR                                          = 0x21010A90ull;

static const uint64_t P9N2_C_2_V2_HMER_WAND                                        = 0x22010A94ull;

static const uint64_t P9N2_C_2_V2_HMER_OR                                          = 0x22010A90ull;

static const uint64_t P9N2_C_3_V2_HMER_WAND                                        = 0x23010A94ull;

static const uint64_t P9N2_C_3_V2_HMER_OR                                          = 0x23010A90ull;

static const uint64_t P9N2_C_4_V2_HMER_WAND                                        = 0x24010A94ull;

static const uint64_t P9N2_C_4_V2_HMER_OR                                          = 0x24010A90ull;

static const uint64_t P9N2_C_5_V2_HMER_WAND                                        = 0x25010A94ull;

static const uint64_t P9N2_C_5_V2_HMER_OR                                          = 0x25010A90ull;

static const uint64_t P9N2_C_6_V2_HMER_WAND                                        = 0x26010A94ull;

static const uint64_t P9N2_C_6_V2_HMER_OR                                          = 0x26010A90ull;

static const uint64_t P9N2_C_7_V2_HMER_WAND                                        = 0x27010A94ull;

static const uint64_t P9N2_C_7_V2_HMER_OR                                          = 0x27010A90ull;

static const uint64_t P9N2_C_8_V2_HMER_WAND                                        = 0x28010A94ull;

static const uint64_t P9N2_C_8_V2_HMER_OR                                          = 0x28010A90ull;

static const uint64_t P9N2_C_9_V2_HMER_WAND                                        = 0x29010A94ull;

static const uint64_t P9N2_C_9_V2_HMER_OR                                          = 0x29010A90ull;

static const uint64_t P9N2_C_10_V2_HMER_WAND                                       = 0x2A010A94ull;

static const uint64_t P9N2_C_10_V2_HMER_OR                                         = 0x2A010A90ull;

static const uint64_t P9N2_C_11_V2_HMER_WAND                                       = 0x2B010A94ull;

static const uint64_t P9N2_C_11_V2_HMER_OR                                         = 0x2B010A90ull;

static const uint64_t P9N2_C_12_V2_HMER_WAND                                       = 0x2C010A94ull;

static const uint64_t P9N2_C_12_V2_HMER_OR                                         = 0x2C010A90ull;

static const uint64_t P9N2_C_13_V2_HMER_WAND                                       = 0x2D010A94ull;

static const uint64_t P9N2_C_13_V2_HMER_OR                                         = 0x2D010A90ull;

static const uint64_t P9N2_C_14_V2_HMER_WAND                                       = 0x2E010A94ull;

static const uint64_t P9N2_C_14_V2_HMER_OR                                         = 0x2E010A90ull;

static const uint64_t P9N2_C_15_V2_HMER_WAND                                       = 0x2F010A94ull;

static const uint64_t P9N2_C_15_V2_HMER_OR                                         = 0x2F010A90ull;

static const uint64_t P9N2_C_16_V2_HMER_WAND                                       = 0x30010A94ull;

static const uint64_t P9N2_C_16_V2_HMER_OR                                         = 0x30010A90ull;

static const uint64_t P9N2_C_17_V2_HMER_WAND                                       = 0x31010A94ull;

static const uint64_t P9N2_C_17_V2_HMER_OR                                         = 0x31010A90ull;

static const uint64_t P9N2_C_18_V2_HMER_WAND                                       = 0x32010A94ull;

static const uint64_t P9N2_C_18_V2_HMER_OR                                         = 0x32010A90ull;

static const uint64_t P9N2_C_19_V2_HMER_WAND                                       = 0x33010A94ull;

static const uint64_t P9N2_C_19_V2_HMER_OR                                         = 0x33010A90ull;

static const uint64_t P9N2_C_20_V2_HMER_WAND                                       = 0x34010A94ull;

static const uint64_t P9N2_C_20_V2_HMER_OR                                         = 0x34010A90ull;

static const uint64_t P9N2_C_21_V2_HMER_WAND                                       = 0x35010A94ull;

static const uint64_t P9N2_C_21_V2_HMER_OR                                         = 0x35010A90ull;

static const uint64_t P9N2_C_22_V2_HMER_WAND                                       = 0x36010A94ull;

static const uint64_t P9N2_C_22_V2_HMER_OR                                         = 0x36010A90ull;

static const uint64_t P9N2_C_23_V2_HMER_WAND                                       = 0x37010A94ull;

static const uint64_t P9N2_C_23_V2_HMER_OR                                         = 0x37010A90ull;

static const uint64_t P9N2_EX_0_L2_V2_HMER_WAND                                    = 0x20010A94ull;
//DUPS: 20010A94,
static const uint64_t P9N2_EX_0_L2_V2_HMER_OR                                      = 0x20010A90ull;
//DUPS: 20010A90,
static const uint64_t P9N2_EX_10_L2_V2_HMER_WAND                                   = 0x34010A94ull;
//DUPS: 34010A94,
static const uint64_t P9N2_EX_10_L2_V2_HMER_OR                                     = 0x34010A90ull;
//DUPS: 34010A90,
static const uint64_t P9N2_EX_11_L2_V2_HMER_WAND                                   = 0x36010A94ull;
//DUPS: 36010A94,
static const uint64_t P9N2_EX_11_L2_V2_HMER_OR                                     = 0x36010A90ull;
//DUPS: 36010A90,
static const uint64_t P9N2_EX_1_L2_V2_HMER_WAND                                    = 0x22010A94ull;
//DUPS: 22010A94,
static const uint64_t P9N2_EX_1_L2_V2_HMER_OR                                      = 0x22010A90ull;
//DUPS: 22010A90,
static const uint64_t P9N2_EX_2_L2_V2_HMER_WAND                                    = 0x24010A94ull;
//DUPS: 24010A94,
static const uint64_t P9N2_EX_2_L2_V2_HMER_OR                                      = 0x24010A90ull;
//DUPS: 24010A90,
static const uint64_t P9N2_EX_3_L2_V2_HMER_WAND                                    = 0x26010A94ull;
//DUPS: 26010A94,
static const uint64_t P9N2_EX_3_L2_V2_HMER_OR                                      = 0x26010A90ull;
//DUPS: 26010A90,
static const uint64_t P9N2_EX_4_L2_V2_HMER_WAND                                    = 0x28010A94ull;
//DUPS: 28010A94,
static const uint64_t P9N2_EX_4_L2_V2_HMER_OR                                      = 0x28010A90ull;
//DUPS: 28010A90,
static const uint64_t P9N2_EX_5_L2_V2_HMER_WAND                                    = 0x2B010A94ull;
//DUPS: 2A010A94,
static const uint64_t P9N2_EX_5_L2_V2_HMER_OR                                      = 0x2B010A90ull;
//DUPS: 2A010A90,
static const uint64_t P9N2_EX_6_L2_V2_HMER_WAND                                    = 0x2D010A94ull;
//DUPS: 2C010A94,
static const uint64_t P9N2_EX_6_L2_V2_HMER_OR                                      = 0x2D010A90ull;
//DUPS: 2C010A90,
static const uint64_t P9N2_EX_7_L2_V2_HMER_WAND                                    = 0x2F010A94ull;
//DUPS: 2E010A94,
static const uint64_t P9N2_EX_7_L2_V2_HMER_OR                                      = 0x2F010A90ull;
//DUPS: 2E010A90,
static const uint64_t P9N2_EX_8_L2_V2_HMER_WAND                                    = 0x30010A94ull;
//DUPS: 30010A94,
static const uint64_t P9N2_EX_8_L2_V2_HMER_OR                                      = 0x30010A90ull;
//DUPS: 30010A90,
static const uint64_t P9N2_EX_9_L2_V2_HMER_WAND                                    = 0x32010A94ull;
//DUPS: 32010A94,
static const uint64_t P9N2_EX_9_L2_V2_HMER_OR                                      = 0x32010A90ull;
//DUPS: 32010A90,
static const uint64_t P9N2_EX_L2_V2_HMER_WAND                                      = 0x20010A94ull;
//DUPS: 20010A94,
static const uint64_t P9N2_EX_L2_V2_HMER_OR                                        = 0x20010A90ull;
//DUPS: 20010A90,

static const uint64_t P9N2_C_V3_HMER_WAND                                          = 0x20010A95ull;

static const uint64_t P9N2_C_V3_HMER_OR                                            = 0x20010A91ull;

static const uint64_t P9N2_C_0_V3_HMER_WAND                                        = 0x20010A95ull;

static const uint64_t P9N2_C_0_V3_HMER_OR                                          = 0x20010A91ull;

static const uint64_t P9N2_C_1_V3_HMER_WAND                                        = 0x21010A95ull;

static const uint64_t P9N2_C_1_V3_HMER_OR                                          = 0x21010A91ull;

static const uint64_t P9N2_C_2_V3_HMER_WAND                                        = 0x22010A95ull;

static const uint64_t P9N2_C_2_V3_HMER_OR                                          = 0x22010A91ull;

static const uint64_t P9N2_C_3_V3_HMER_WAND                                        = 0x23010A95ull;

static const uint64_t P9N2_C_3_V3_HMER_OR                                          = 0x23010A91ull;

static const uint64_t P9N2_C_4_V3_HMER_WAND                                        = 0x24010A95ull;

static const uint64_t P9N2_C_4_V3_HMER_OR                                          = 0x24010A91ull;

static const uint64_t P9N2_C_5_V3_HMER_WAND                                        = 0x25010A95ull;

static const uint64_t P9N2_C_5_V3_HMER_OR                                          = 0x25010A91ull;

static const uint64_t P9N2_C_6_V3_HMER_WAND                                        = 0x26010A95ull;

static const uint64_t P9N2_C_6_V3_HMER_OR                                          = 0x26010A91ull;

static const uint64_t P9N2_C_7_V3_HMER_WAND                                        = 0x27010A95ull;

static const uint64_t P9N2_C_7_V3_HMER_OR                                          = 0x27010A91ull;

static const uint64_t P9N2_C_8_V3_HMER_WAND                                        = 0x28010A95ull;

static const uint64_t P9N2_C_8_V3_HMER_OR                                          = 0x28010A91ull;

static const uint64_t P9N2_C_9_V3_HMER_WAND                                        = 0x29010A95ull;

static const uint64_t P9N2_C_9_V3_HMER_OR                                          = 0x29010A91ull;

static const uint64_t P9N2_C_10_V3_HMER_WAND                                       = 0x2A010A95ull;

static const uint64_t P9N2_C_10_V3_HMER_OR                                         = 0x2A010A91ull;

static const uint64_t P9N2_C_11_V3_HMER_WAND                                       = 0x2B010A95ull;

static const uint64_t P9N2_C_11_V3_HMER_OR                                         = 0x2B010A91ull;

static const uint64_t P9N2_C_12_V3_HMER_WAND                                       = 0x2C010A95ull;

static const uint64_t P9N2_C_12_V3_HMER_OR                                         = 0x2C010A91ull;

static const uint64_t P9N2_C_13_V3_HMER_WAND                                       = 0x2D010A95ull;

static const uint64_t P9N2_C_13_V3_HMER_OR                                         = 0x2D010A91ull;

static const uint64_t P9N2_C_14_V3_HMER_WAND                                       = 0x2E010A95ull;

static const uint64_t P9N2_C_14_V3_HMER_OR                                         = 0x2E010A91ull;

static const uint64_t P9N2_C_15_V3_HMER_WAND                                       = 0x2F010A95ull;

static const uint64_t P9N2_C_15_V3_HMER_OR                                         = 0x2F010A91ull;

static const uint64_t P9N2_C_16_V3_HMER_WAND                                       = 0x30010A95ull;

static const uint64_t P9N2_C_16_V3_HMER_OR                                         = 0x30010A91ull;

static const uint64_t P9N2_C_17_V3_HMER_WAND                                       = 0x31010A95ull;

static const uint64_t P9N2_C_17_V3_HMER_OR                                         = 0x31010A91ull;

static const uint64_t P9N2_C_18_V3_HMER_WAND                                       = 0x32010A95ull;

static const uint64_t P9N2_C_18_V3_HMER_OR                                         = 0x32010A91ull;

static const uint64_t P9N2_C_19_V3_HMER_WAND                                       = 0x33010A95ull;

static const uint64_t P9N2_C_19_V3_HMER_OR                                         = 0x33010A91ull;

static const uint64_t P9N2_C_20_V3_HMER_WAND                                       = 0x34010A95ull;

static const uint64_t P9N2_C_20_V3_HMER_OR                                         = 0x34010A91ull;

static const uint64_t P9N2_C_21_V3_HMER_WAND                                       = 0x35010A95ull;

static const uint64_t P9N2_C_21_V3_HMER_OR                                         = 0x35010A91ull;

static const uint64_t P9N2_C_22_V3_HMER_WAND                                       = 0x36010A95ull;

static const uint64_t P9N2_C_22_V3_HMER_OR                                         = 0x36010A91ull;

static const uint64_t P9N2_C_23_V3_HMER_WAND                                       = 0x37010A95ull;

static const uint64_t P9N2_C_23_V3_HMER_OR                                         = 0x37010A91ull;

static const uint64_t P9N2_EX_0_L2_V3_HMER_WAND                                    = 0x20010A95ull;
//DUPS: 20010A95,
static const uint64_t P9N2_EX_0_L2_V3_HMER_OR                                      = 0x20010A91ull;
//DUPS: 20010A91,
static const uint64_t P9N2_EX_10_L2_V3_HMER_WAND                                   = 0x34010A95ull;
//DUPS: 34010A95,
static const uint64_t P9N2_EX_10_L2_V3_HMER_OR                                     = 0x34010A91ull;
//DUPS: 34010A91,
static const uint64_t P9N2_EX_11_L2_V3_HMER_WAND                                   = 0x36010A95ull;
//DUPS: 36010A95,
static const uint64_t P9N2_EX_11_L2_V3_HMER_OR                                     = 0x36010A91ull;
//DUPS: 36010A91,
static const uint64_t P9N2_EX_1_L2_V3_HMER_WAND                                    = 0x22010A95ull;
//DUPS: 22010A95,
static const uint64_t P9N2_EX_1_L2_V3_HMER_OR                                      = 0x22010A91ull;
//DUPS: 22010A91,
static const uint64_t P9N2_EX_2_L2_V3_HMER_WAND                                    = 0x24010A95ull;
//DUPS: 24010A95,
static const uint64_t P9N2_EX_2_L2_V3_HMER_OR                                      = 0x24010A91ull;
//DUPS: 24010A91,
static const uint64_t P9N2_EX_3_L2_V3_HMER_WAND                                    = 0x26010A95ull;
//DUPS: 26010A95,
static const uint64_t P9N2_EX_3_L2_V3_HMER_OR                                      = 0x26010A91ull;
//DUPS: 26010A91,
static const uint64_t P9N2_EX_4_L2_V3_HMER_WAND                                    = 0x28010A95ull;
//DUPS: 28010A95,
static const uint64_t P9N2_EX_4_L2_V3_HMER_OR                                      = 0x28010A91ull;
//DUPS: 28010A91,
static const uint64_t P9N2_EX_5_L2_V3_HMER_WAND                                    = 0x2B010A95ull;
//DUPS: 2A010A95,
static const uint64_t P9N2_EX_5_L2_V3_HMER_OR                                      = 0x2B010A91ull;
//DUPS: 2A010A91,
static const uint64_t P9N2_EX_6_L2_V3_HMER_WAND                                    = 0x2D010A95ull;
//DUPS: 2C010A95,
static const uint64_t P9N2_EX_6_L2_V3_HMER_OR                                      = 0x2D010A91ull;
//DUPS: 2C010A91,
static const uint64_t P9N2_EX_7_L2_V3_HMER_WAND                                    = 0x2F010A95ull;
//DUPS: 2E010A95,
static const uint64_t P9N2_EX_7_L2_V3_HMER_OR                                      = 0x2F010A91ull;
//DUPS: 2E010A91,
static const uint64_t P9N2_EX_8_L2_V3_HMER_WAND                                    = 0x30010A95ull;
//DUPS: 30010A95,
static const uint64_t P9N2_EX_8_L2_V3_HMER_OR                                      = 0x30010A91ull;
//DUPS: 30010A91,
static const uint64_t P9N2_EX_9_L2_V3_HMER_WAND                                    = 0x32010A95ull;
//DUPS: 32010A95,
static const uint64_t P9N2_EX_9_L2_V3_HMER_OR                                      = 0x32010A91ull;
//DUPS: 32010A91,
static const uint64_t P9N2_EX_L2_V3_HMER_WAND                                      = 0x20010A95ull;
//DUPS: 20010A95,
static const uint64_t P9N2_EX_L2_V3_HMER_OR                                        = 0x20010A91ull;
//DUPS: 20010A91,

static const uint64_t P9N2_C_VITAL_SCAN_OUT                                        = 0x200F0017ull;

static const uint64_t P9N2_C_0_VITAL_SCAN_OUT                                      = 0x200F0017ull;

static const uint64_t P9N2_C_1_VITAL_SCAN_OUT                                      = 0x210F0017ull;

static const uint64_t P9N2_C_2_VITAL_SCAN_OUT                                      = 0x220F0017ull;

static const uint64_t P9N2_C_3_VITAL_SCAN_OUT                                      = 0x230F0017ull;

static const uint64_t P9N2_C_4_VITAL_SCAN_OUT                                      = 0x240F0017ull;

static const uint64_t P9N2_C_5_VITAL_SCAN_OUT                                      = 0x250F0017ull;

static const uint64_t P9N2_C_6_VITAL_SCAN_OUT                                      = 0x260F0017ull;

static const uint64_t P9N2_C_7_VITAL_SCAN_OUT                                      = 0x270F0017ull;

static const uint64_t P9N2_C_8_VITAL_SCAN_OUT                                      = 0x280F0017ull;

static const uint64_t P9N2_C_9_VITAL_SCAN_OUT                                      = 0x290F0017ull;

static const uint64_t P9N2_C_10_VITAL_SCAN_OUT                                     = 0x2A0F0017ull;

static const uint64_t P9N2_C_11_VITAL_SCAN_OUT                                     = 0x2B0F0017ull;

static const uint64_t P9N2_C_12_VITAL_SCAN_OUT                                     = 0x2C0F0017ull;

static const uint64_t P9N2_C_13_VITAL_SCAN_OUT                                     = 0x2D0F0017ull;

static const uint64_t P9N2_C_14_VITAL_SCAN_OUT                                     = 0x2E0F0017ull;

static const uint64_t P9N2_C_15_VITAL_SCAN_OUT                                     = 0x2F0F0017ull;

static const uint64_t P9N2_C_16_VITAL_SCAN_OUT                                     = 0x300F0017ull;

static const uint64_t P9N2_C_17_VITAL_SCAN_OUT                                     = 0x310F0017ull;

static const uint64_t P9N2_C_18_VITAL_SCAN_OUT                                     = 0x320F0017ull;

static const uint64_t P9N2_C_19_VITAL_SCAN_OUT                                     = 0x330F0017ull;

static const uint64_t P9N2_C_20_VITAL_SCAN_OUT                                     = 0x340F0017ull;

static const uint64_t P9N2_C_21_VITAL_SCAN_OUT                                     = 0x350F0017ull;

static const uint64_t P9N2_C_22_VITAL_SCAN_OUT                                     = 0x360F0017ull;

static const uint64_t P9N2_C_23_VITAL_SCAN_OUT                                     = 0x370F0017ull;

static const uint64_t P9N2_EQ_VITAL_SCAN_OUT                                       = 0x100F0017ull;

static const uint64_t P9N2_EQ_0_VITAL_SCAN_OUT                                     = 0x100F0017ull;

static const uint64_t P9N2_EQ_1_VITAL_SCAN_OUT                                     = 0x110F0017ull;

static const uint64_t P9N2_EQ_2_VITAL_SCAN_OUT                                     = 0x120F0017ull;

static const uint64_t P9N2_EQ_3_VITAL_SCAN_OUT                                     = 0x130F0017ull;

static const uint64_t P9N2_EQ_4_VITAL_SCAN_OUT                                     = 0x140F0017ull;

static const uint64_t P9N2_EQ_5_VITAL_SCAN_OUT                                     = 0x150F0017ull;

static const uint64_t P9N2_EX_VITAL_SCAN_OUT                                       = 0x200F0017ull;
//DUPS: 210F0017,
static const uint64_t P9N2_EX_0_VITAL_SCAN_OUT                                     = 0x200F0017ull;
//DUPS: 210F0017,
static const uint64_t P9N2_EX_1_VITAL_SCAN_OUT                                     = 0x220F0017ull;
//DUPS: 220F0017,
static const uint64_t P9N2_EX_2_VITAL_SCAN_OUT                                     = 0x240F0017ull;
//DUPS: 250F0017,
static const uint64_t P9N2_EX_3_VITAL_SCAN_OUT                                     = 0x260F0017ull;
//DUPS: 270F0017,
static const uint64_t P9N2_EX_4_VITAL_SCAN_OUT                                     = 0x280F0017ull;
//DUPS: 290F0017,
static const uint64_t P9N2_EX_5_VITAL_SCAN_OUT                                     = 0x2A0F0017ull;
//DUPS: 2B0F0017,
static const uint64_t P9N2_EX_6_VITAL_SCAN_OUT                                     = 0x2C0F0017ull;
//DUPS: 2D0F0017,
static const uint64_t P9N2_EX_7_VITAL_SCAN_OUT                                     = 0x2E0F0017ull;
//DUPS: 2F0F0017,
static const uint64_t P9N2_EX_8_VITAL_SCAN_OUT                                     = 0x300F0017ull;
//DUPS: 310F0017,
static const uint64_t P9N2_EX_9_VITAL_SCAN_OUT                                     = 0x320F0017ull;
//DUPS: 330F0017,
static const uint64_t P9N2_EX_10_VITAL_SCAN_OUT                                    = 0x340F0017ull;
//DUPS: 350F0017,
static const uint64_t P9N2_EX_11_VITAL_SCAN_OUT                                    = 0x360F0017ull;
//DUPS: 370F0017,

static const uint64_t P9N2_C_WRITE_PROTECT_ENABLE_REG                              = 0x20010005ull;

static const uint64_t P9N2_C_0_WRITE_PROTECT_ENABLE_REG                            = 0x20010005ull;

static const uint64_t P9N2_C_1_WRITE_PROTECT_ENABLE_REG                            = 0x21010005ull;

static const uint64_t P9N2_C_2_WRITE_PROTECT_ENABLE_REG                            = 0x22010005ull;

static const uint64_t P9N2_C_3_WRITE_PROTECT_ENABLE_REG                            = 0x23010005ull;

static const uint64_t P9N2_C_4_WRITE_PROTECT_ENABLE_REG                            = 0x24010005ull;

static const uint64_t P9N2_C_5_WRITE_PROTECT_ENABLE_REG                            = 0x25010005ull;

static const uint64_t P9N2_C_6_WRITE_PROTECT_ENABLE_REG                            = 0x26010005ull;

static const uint64_t P9N2_C_7_WRITE_PROTECT_ENABLE_REG                            = 0x27010005ull;

static const uint64_t P9N2_C_8_WRITE_PROTECT_ENABLE_REG                            = 0x28010005ull;

static const uint64_t P9N2_C_9_WRITE_PROTECT_ENABLE_REG                            = 0x29010005ull;

static const uint64_t P9N2_C_10_WRITE_PROTECT_ENABLE_REG                           = 0x2A010005ull;

static const uint64_t P9N2_C_11_WRITE_PROTECT_ENABLE_REG                           = 0x2B010005ull;

static const uint64_t P9N2_C_12_WRITE_PROTECT_ENABLE_REG                           = 0x2C010005ull;

static const uint64_t P9N2_C_13_WRITE_PROTECT_ENABLE_REG                           = 0x2D010005ull;

static const uint64_t P9N2_C_14_WRITE_PROTECT_ENABLE_REG                           = 0x2E010005ull;

static const uint64_t P9N2_C_15_WRITE_PROTECT_ENABLE_REG                           = 0x2F010005ull;

static const uint64_t P9N2_C_16_WRITE_PROTECT_ENABLE_REG                           = 0x30010005ull;

static const uint64_t P9N2_C_17_WRITE_PROTECT_ENABLE_REG                           = 0x31010005ull;

static const uint64_t P9N2_C_18_WRITE_PROTECT_ENABLE_REG                           = 0x32010005ull;

static const uint64_t P9N2_C_19_WRITE_PROTECT_ENABLE_REG                           = 0x33010005ull;

static const uint64_t P9N2_C_20_WRITE_PROTECT_ENABLE_REG                           = 0x34010005ull;

static const uint64_t P9N2_C_21_WRITE_PROTECT_ENABLE_REG                           = 0x35010005ull;

static const uint64_t P9N2_C_22_WRITE_PROTECT_ENABLE_REG                           = 0x36010005ull;

static const uint64_t P9N2_C_23_WRITE_PROTECT_ENABLE_REG                           = 0x37010005ull;

static const uint64_t P9N2_EQ_WRITE_PROTECT_ENABLE_REG                             = 0x10010005ull;

static const uint64_t P9N2_EQ_0_WRITE_PROTECT_ENABLE_REG                           = 0x10010005ull;

static const uint64_t P9N2_EQ_1_WRITE_PROTECT_ENABLE_REG                           = 0x11010005ull;

static const uint64_t P9N2_EQ_2_WRITE_PROTECT_ENABLE_REG                           = 0x12010005ull;

static const uint64_t P9N2_EQ_3_WRITE_PROTECT_ENABLE_REG                           = 0x13010005ull;

static const uint64_t P9N2_EQ_4_WRITE_PROTECT_ENABLE_REG                           = 0x14010005ull;

static const uint64_t P9N2_EQ_5_WRITE_PROTECT_ENABLE_REG                           = 0x15010005ull;

static const uint64_t P9N2_EX_WRITE_PROTECT_ENABLE_REG                             = 0x20010005ull;
//DUPS: 21010005,
static const uint64_t P9N2_EX_0_WRITE_PROTECT_ENABLE_REG                           = 0x20010005ull;
//DUPS: 21010005,
static const uint64_t P9N2_EX_1_WRITE_PROTECT_ENABLE_REG                           = 0x22010005ull;
//DUPS: 23010005,
static const uint64_t P9N2_EX_2_WRITE_PROTECT_ENABLE_REG                           = 0x24010005ull;
//DUPS: 25010005,
static const uint64_t P9N2_EX_3_WRITE_PROTECT_ENABLE_REG                           = 0x26010005ull;
//DUPS: 27010005,
static const uint64_t P9N2_EX_4_WRITE_PROTECT_ENABLE_REG                           = 0x28010005ull;
//DUPS: 29010005,
static const uint64_t P9N2_EX_5_WRITE_PROTECT_ENABLE_REG                           = 0x2A010005ull;
//DUPS: 2B010005,
static const uint64_t P9N2_EX_6_WRITE_PROTECT_ENABLE_REG                           = 0x2C010005ull;
//DUPS: 2D010005,
static const uint64_t P9N2_EX_7_WRITE_PROTECT_ENABLE_REG                           = 0x2F010005ull;
//DUPS: 2F010005,
static const uint64_t P9N2_EX_8_WRITE_PROTECT_ENABLE_REG                           = 0x30010005ull;
//DUPS: 31010005,
static const uint64_t P9N2_EX_9_WRITE_PROTECT_ENABLE_REG                           = 0x32010005ull;
//DUPS: 33010005,
static const uint64_t P9N2_EX_10_WRITE_PROTECT_ENABLE_REG                          = 0x34010005ull;
//DUPS: 35010005,
static const uint64_t P9N2_EX_11_WRITE_PROTECT_ENABLE_REG                          = 0x36010005ull;
//DUPS: 37010005,

static const uint64_t P9N2_C_WRITE_PROTECT_RINGS_REG                               = 0x20010006ull;

static const uint64_t P9N2_C_0_WRITE_PROTECT_RINGS_REG                             = 0x20010006ull;

static const uint64_t P9N2_C_1_WRITE_PROTECT_RINGS_REG                             = 0x21010006ull;

static const uint64_t P9N2_C_2_WRITE_PROTECT_RINGS_REG                             = 0x22010006ull;

static const uint64_t P9N2_C_3_WRITE_PROTECT_RINGS_REG                             = 0x23010006ull;

static const uint64_t P9N2_C_4_WRITE_PROTECT_RINGS_REG                             = 0x24010006ull;

static const uint64_t P9N2_C_5_WRITE_PROTECT_RINGS_REG                             = 0x25010006ull;

static const uint64_t P9N2_C_6_WRITE_PROTECT_RINGS_REG                             = 0x26010006ull;

static const uint64_t P9N2_C_7_WRITE_PROTECT_RINGS_REG                             = 0x27010006ull;

static const uint64_t P9N2_C_8_WRITE_PROTECT_RINGS_REG                             = 0x28010006ull;

static const uint64_t P9N2_C_9_WRITE_PROTECT_RINGS_REG                             = 0x29010006ull;

static const uint64_t P9N2_C_10_WRITE_PROTECT_RINGS_REG                            = 0x2A010006ull;

static const uint64_t P9N2_C_11_WRITE_PROTECT_RINGS_REG                            = 0x2B010006ull;

static const uint64_t P9N2_C_12_WRITE_PROTECT_RINGS_REG                            = 0x2C010006ull;

static const uint64_t P9N2_C_13_WRITE_PROTECT_RINGS_REG                            = 0x2D010006ull;

static const uint64_t P9N2_C_14_WRITE_PROTECT_RINGS_REG                            = 0x2E010006ull;

static const uint64_t P9N2_C_15_WRITE_PROTECT_RINGS_REG                            = 0x2F010006ull;

static const uint64_t P9N2_C_16_WRITE_PROTECT_RINGS_REG                            = 0x30010006ull;

static const uint64_t P9N2_C_17_WRITE_PROTECT_RINGS_REG                            = 0x31010006ull;

static const uint64_t P9N2_C_18_WRITE_PROTECT_RINGS_REG                            = 0x32010006ull;

static const uint64_t P9N2_C_19_WRITE_PROTECT_RINGS_REG                            = 0x33010006ull;

static const uint64_t P9N2_C_20_WRITE_PROTECT_RINGS_REG                            = 0x34010006ull;

static const uint64_t P9N2_C_21_WRITE_PROTECT_RINGS_REG                            = 0x35010006ull;

static const uint64_t P9N2_C_22_WRITE_PROTECT_RINGS_REG                            = 0x36010006ull;

static const uint64_t P9N2_C_23_WRITE_PROTECT_RINGS_REG                            = 0x37010006ull;

static const uint64_t P9N2_EQ_WRITE_PROTECT_RINGS_REG                              = 0x10010006ull;

static const uint64_t P9N2_EQ_0_WRITE_PROTECT_RINGS_REG                            = 0x10010006ull;

static const uint64_t P9N2_EQ_1_WRITE_PROTECT_RINGS_REG                            = 0x11010006ull;

static const uint64_t P9N2_EQ_2_WRITE_PROTECT_RINGS_REG                            = 0x12010006ull;

static const uint64_t P9N2_EQ_3_WRITE_PROTECT_RINGS_REG                            = 0x13010006ull;

static const uint64_t P9N2_EQ_4_WRITE_PROTECT_RINGS_REG                            = 0x14010006ull;

static const uint64_t P9N2_EQ_5_WRITE_PROTECT_RINGS_REG                            = 0x15010006ull;

static const uint64_t P9N2_EX_WRITE_PROTECT_RINGS_REG                              = 0x20010006ull;
//DUPS: 21010006,
static const uint64_t P9N2_EX_0_WRITE_PROTECT_RINGS_REG                            = 0x20010006ull;
//DUPS: 21010006,
static const uint64_t P9N2_EX_1_WRITE_PROTECT_RINGS_REG                            = 0x22010006ull;
//DUPS: 23010006,
static const uint64_t P9N2_EX_2_WRITE_PROTECT_RINGS_REG                            = 0x24010006ull;
//DUPS: 25010006,
static const uint64_t P9N2_EX_3_WRITE_PROTECT_RINGS_REG                            = 0x26010006ull;
//DUPS: 27010006,
static const uint64_t P9N2_EX_4_WRITE_PROTECT_RINGS_REG                            = 0x28010006ull;
//DUPS: 29010006,
static const uint64_t P9N2_EX_5_WRITE_PROTECT_RINGS_REG                            = 0x2A010006ull;
//DUPS: 2B010006,
static const uint64_t P9N2_EX_6_WRITE_PROTECT_RINGS_REG                            = 0x2C010006ull;
//DUPS: 2D010006,
static const uint64_t P9N2_EX_7_WRITE_PROTECT_RINGS_REG                            = 0x2F010006ull;
//DUPS: 2F010006,
static const uint64_t P9N2_EX_8_WRITE_PROTECT_RINGS_REG                            = 0x30010006ull;
//DUPS: 31010006,
static const uint64_t P9N2_EX_9_WRITE_PROTECT_RINGS_REG                            = 0x32010006ull;
//DUPS: 33010006,
static const uint64_t P9N2_EX_10_WRITE_PROTECT_RINGS_REG                           = 0x34010006ull;
//DUPS: 35010006,
static const uint64_t P9N2_EX_11_WRITE_PROTECT_RINGS_REG                           = 0x36010006ull;
//DUPS: 37010006,

static const uint64_t P9N2_EQ_WR_EPS_REG                                           = 0x10010C11ull;
//DUPS: 10010C11,
static const uint64_t P9N2_EQ_0_WR_EPS_REG                                         = 0x10010C11ull;
//DUPS: 10010C11,
static const uint64_t P9N2_EQ_1_WR_EPS_REG                                         = 0x11010C11ull;
//DUPS: 11010C11,
static const uint64_t P9N2_EQ_2_WR_EPS_REG                                         = 0x12010C11ull;
//DUPS: 12010C11,
static const uint64_t P9N2_EQ_3_WR_EPS_REG                                         = 0x13010C11ull;
//DUPS: 13010C11,
static const uint64_t P9N2_EQ_4_WR_EPS_REG                                         = 0x14010C11ull;
//DUPS: 14010C11,
static const uint64_t P9N2_EQ_5_WR_EPS_REG                                         = 0x15010C11ull;
//DUPS: 15010C11,
static const uint64_t P9N2_EX_0_L2_WR_EPS_REG                                      = 0x10010811ull;

static const uint64_t P9N2_EX_10_L2_WR_EPS_REG                                     = 0x15010811ull;

static const uint64_t P9N2_EX_11_L2_WR_EPS_REG                                     = 0x15010C11ull;

static const uint64_t P9N2_EX_1_L2_WR_EPS_REG                                      = 0x10010C11ull;

static const uint64_t P9N2_EX_2_L2_WR_EPS_REG                                      = 0x11010811ull;

static const uint64_t P9N2_EX_3_L2_WR_EPS_REG                                      = 0x11010C11ull;

static const uint64_t P9N2_EX_4_L2_WR_EPS_REG                                      = 0x12010811ull;

static const uint64_t P9N2_EX_5_L2_WR_EPS_REG                                      = 0x12010C11ull;

static const uint64_t P9N2_EX_6_L2_WR_EPS_REG                                      = 0x13010811ull;

static const uint64_t P9N2_EX_7_L2_WR_EPS_REG                                      = 0x13010C11ull;

static const uint64_t P9N2_EX_8_L2_WR_EPS_REG                                      = 0x14010811ull;

static const uint64_t P9N2_EX_9_L2_WR_EPS_REG                                      = 0x14010C11ull;

static const uint64_t P9N2_EX_L2_WR_EPS_REG                                        = 0x10010811ull;


static const uint64_t P9N2_C_XFIR                                                  = 0x20040000ull;

static const uint64_t P9N2_C_0_XFIR                                                = 0x20040000ull;

static const uint64_t P9N2_C_1_XFIR                                                = 0x21040000ull;

static const uint64_t P9N2_C_2_XFIR                                                = 0x22040000ull;

static const uint64_t P9N2_C_3_XFIR                                                = 0x23040000ull;

static const uint64_t P9N2_C_4_XFIR                                                = 0x24040000ull;

static const uint64_t P9N2_C_5_XFIR                                                = 0x25040000ull;

static const uint64_t P9N2_C_6_XFIR                                                = 0x26040000ull;

static const uint64_t P9N2_C_7_XFIR                                                = 0x27040000ull;

static const uint64_t P9N2_C_8_XFIR                                                = 0x28040000ull;

static const uint64_t P9N2_C_9_XFIR                                                = 0x29040000ull;

static const uint64_t P9N2_C_10_XFIR                                               = 0x2A040000ull;

static const uint64_t P9N2_C_11_XFIR                                               = 0x2B040000ull;

static const uint64_t P9N2_C_12_XFIR                                               = 0x2C040000ull;

static const uint64_t P9N2_C_13_XFIR                                               = 0x2D040000ull;

static const uint64_t P9N2_C_14_XFIR                                               = 0x2E040000ull;

static const uint64_t P9N2_C_15_XFIR                                               = 0x2F040000ull;

static const uint64_t P9N2_C_16_XFIR                                               = 0x30040000ull;

static const uint64_t P9N2_C_17_XFIR                                               = 0x31040000ull;

static const uint64_t P9N2_C_18_XFIR                                               = 0x32040000ull;

static const uint64_t P9N2_C_19_XFIR                                               = 0x33040000ull;

static const uint64_t P9N2_C_20_XFIR                                               = 0x34040000ull;

static const uint64_t P9N2_C_21_XFIR                                               = 0x35040000ull;

static const uint64_t P9N2_C_22_XFIR                                               = 0x36040000ull;

static const uint64_t P9N2_C_23_XFIR                                               = 0x37040000ull;

static const uint64_t P9N2_EQ_XFIR                                                 = 0x10040000ull;

static const uint64_t P9N2_EQ_0_XFIR                                               = 0x10040000ull;

static const uint64_t P9N2_EQ_1_XFIR                                               = 0x11040000ull;

static const uint64_t P9N2_EQ_2_XFIR                                               = 0x12040000ull;

static const uint64_t P9N2_EQ_3_XFIR                                               = 0x13040000ull;

static const uint64_t P9N2_EQ_4_XFIR                                               = 0x14040000ull;

static const uint64_t P9N2_EQ_5_XFIR                                               = 0x15040000ull;

static const uint64_t P9N2_EX_XFIR                                                 = 0x20040000ull;
//DUPS: 21040000,
static const uint64_t P9N2_EX_0_XFIR                                               = 0x20040000ull;
//DUPS: 21040000,
static const uint64_t P9N2_EX_1_XFIR                                               = 0x22040000ull;
//DUPS: 23040000,
static const uint64_t P9N2_EX_2_XFIR                                               = 0x24040000ull;
//DUPS: 25040000,
static const uint64_t P9N2_EX_3_XFIR                                               = 0x26040000ull;
//DUPS: 27040000,
static const uint64_t P9N2_EX_4_XFIR                                               = 0x28040000ull;
//DUPS: 29040000,
static const uint64_t P9N2_EX_5_XFIR                                               = 0x2A040000ull;
//DUPS: 2B040000,
static const uint64_t P9N2_EX_6_XFIR                                               = 0x2C040000ull;
//DUPS: 2D040000,
static const uint64_t P9N2_EX_7_XFIR                                               = 0x2F040000ull;
//DUPS: 2F040000,
static const uint64_t P9N2_EX_8_XFIR                                               = 0x30040000ull;
//DUPS: 31040000,
static const uint64_t P9N2_EX_9_XFIR                                               = 0x32040000ull;
//DUPS: 33040000,
static const uint64_t P9N2_EX_10_XFIR                                              = 0x34040000ull;
//DUPS: 35040000,
static const uint64_t P9N2_EX_11_XFIR                                              = 0x36040000ull;
//DUPS: 37040000,

static const uint64_t P9N2_C_XSTOP1                                                = 0x2003000Cull;

static const uint64_t P9N2_C_0_XSTOP1                                              = 0x2003000Cull;

static const uint64_t P9N2_C_1_XSTOP1                                              = 0x2103000Cull;

static const uint64_t P9N2_C_2_XSTOP1                                              = 0x2203000Cull;

static const uint64_t P9N2_C_3_XSTOP1                                              = 0x2303000Cull;

static const uint64_t P9N2_C_4_XSTOP1                                              = 0x2403000Cull;

static const uint64_t P9N2_C_5_XSTOP1                                              = 0x2503000Cull;

static const uint64_t P9N2_C_6_XSTOP1                                              = 0x2603000Cull;

static const uint64_t P9N2_C_7_XSTOP1                                              = 0x2703000Cull;

static const uint64_t P9N2_C_8_XSTOP1                                              = 0x2803000Cull;

static const uint64_t P9N2_C_9_XSTOP1                                              = 0x2903000Cull;

static const uint64_t P9N2_C_10_XSTOP1                                             = 0x2A03000Cull;

static const uint64_t P9N2_C_11_XSTOP1                                             = 0x2B03000Cull;

static const uint64_t P9N2_C_12_XSTOP1                                             = 0x2C03000Cull;

static const uint64_t P9N2_C_13_XSTOP1                                             = 0x2D03000Cull;

static const uint64_t P9N2_C_14_XSTOP1                                             = 0x2E03000Cull;

static const uint64_t P9N2_C_15_XSTOP1                                             = 0x2F03000Cull;

static const uint64_t P9N2_C_16_XSTOP1                                             = 0x3003000Cull;

static const uint64_t P9N2_C_17_XSTOP1                                             = 0x3103000Cull;

static const uint64_t P9N2_C_18_XSTOP1                                             = 0x3203000Cull;

static const uint64_t P9N2_C_19_XSTOP1                                             = 0x3303000Cull;

static const uint64_t P9N2_C_20_XSTOP1                                             = 0x3403000Cull;

static const uint64_t P9N2_C_21_XSTOP1                                             = 0x3503000Cull;

static const uint64_t P9N2_C_22_XSTOP1                                             = 0x3603000Cull;

static const uint64_t P9N2_C_23_XSTOP1                                             = 0x3703000Cull;

static const uint64_t P9N2_EQ_XSTOP1                                               = 0x1003000Cull;

static const uint64_t P9N2_EQ_0_XSTOP1                                             = 0x1003000Cull;

static const uint64_t P9N2_EQ_1_XSTOP1                                             = 0x1103000Cull;

static const uint64_t P9N2_EQ_2_XSTOP1                                             = 0x1203000Cull;

static const uint64_t P9N2_EQ_3_XSTOP1                                             = 0x1303000Cull;

static const uint64_t P9N2_EQ_4_XSTOP1                                             = 0x1403000Cull;

static const uint64_t P9N2_EQ_5_XSTOP1                                             = 0x1503000Cull;

static const uint64_t P9N2_EX_XSTOP1                                               = 0x2003000Cull;
//DUPS: 2103000C,
static const uint64_t P9N2_EX_0_XSTOP1                                             = 0x2003000Cull;
//DUPS: 2103000C,
static const uint64_t P9N2_EX_1_XSTOP1                                             = 0x2203000Cull;
//DUPS: 2303000C,
static const uint64_t P9N2_EX_2_XSTOP1                                             = 0x2403000Cull;
//DUPS: 2503000C,
static const uint64_t P9N2_EX_3_XSTOP1                                             = 0x2603000Cull;
//DUPS: 2703000C,
static const uint64_t P9N2_EX_4_XSTOP1                                             = 0x2803000Cull;
//DUPS: 2903000C,
static const uint64_t P9N2_EX_5_XSTOP1                                             = 0x2A03000Cull;
//DUPS: 2B03000C,
static const uint64_t P9N2_EX_6_XSTOP1                                             = 0x2C03000Cull;
//DUPS: 2D03000C,
static const uint64_t P9N2_EX_7_XSTOP1                                             = 0x2F03000Cull;
//DUPS: 2F03000C,
static const uint64_t P9N2_EX_8_XSTOP1                                             = 0x3003000Cull;
//DUPS: 3103000C,
static const uint64_t P9N2_EX_9_XSTOP1                                             = 0x3203000Cull;
//DUPS: 3303000C,
static const uint64_t P9N2_EX_10_XSTOP1                                            = 0x3403000Cull;
//DUPS: 3503000C,
static const uint64_t P9N2_EX_11_XSTOP1                                            = 0x3603000Cull;
//DUPS: 3703000C,

static const uint64_t P9N2_C_XSTOP2                                                = 0x2003000Dull;

static const uint64_t P9N2_C_0_XSTOP2                                              = 0x2003000Dull;

static const uint64_t P9N2_C_1_XSTOP2                                              = 0x2103000Dull;

static const uint64_t P9N2_C_2_XSTOP2                                              = 0x2203000Dull;

static const uint64_t P9N2_C_3_XSTOP2                                              = 0x2303000Dull;

static const uint64_t P9N2_C_4_XSTOP2                                              = 0x2403000Dull;

static const uint64_t P9N2_C_5_XSTOP2                                              = 0x2503000Dull;

static const uint64_t P9N2_C_6_XSTOP2                                              = 0x2603000Dull;

static const uint64_t P9N2_C_7_XSTOP2                                              = 0x2703000Dull;

static const uint64_t P9N2_C_8_XSTOP2                                              = 0x2803000Dull;

static const uint64_t P9N2_C_9_XSTOP2                                              = 0x2903000Dull;

static const uint64_t P9N2_C_10_XSTOP2                                             = 0x2A03000Dull;

static const uint64_t P9N2_C_11_XSTOP2                                             = 0x2B03000Dull;

static const uint64_t P9N2_C_12_XSTOP2                                             = 0x2C03000Dull;

static const uint64_t P9N2_C_13_XSTOP2                                             = 0x2D03000Dull;

static const uint64_t P9N2_C_14_XSTOP2                                             = 0x2E03000Dull;

static const uint64_t P9N2_C_15_XSTOP2                                             = 0x2F03000Dull;

static const uint64_t P9N2_C_16_XSTOP2                                             = 0x3003000Dull;

static const uint64_t P9N2_C_17_XSTOP2                                             = 0x3103000Dull;

static const uint64_t P9N2_C_18_XSTOP2                                             = 0x3203000Dull;

static const uint64_t P9N2_C_19_XSTOP2                                             = 0x3303000Dull;

static const uint64_t P9N2_C_20_XSTOP2                                             = 0x3403000Dull;

static const uint64_t P9N2_C_21_XSTOP2                                             = 0x3503000Dull;

static const uint64_t P9N2_C_22_XSTOP2                                             = 0x3603000Dull;

static const uint64_t P9N2_C_23_XSTOP2                                             = 0x3703000Dull;

static const uint64_t P9N2_EQ_XSTOP2                                               = 0x1003000Dull;

static const uint64_t P9N2_EQ_0_XSTOP2                                             = 0x1003000Dull;

static const uint64_t P9N2_EQ_1_XSTOP2                                             = 0x1103000Dull;

static const uint64_t P9N2_EQ_2_XSTOP2                                             = 0x1203000Dull;

static const uint64_t P9N2_EQ_3_XSTOP2                                             = 0x1303000Dull;

static const uint64_t P9N2_EQ_4_XSTOP2                                             = 0x1403000Dull;

static const uint64_t P9N2_EQ_5_XSTOP2                                             = 0x1503000Dull;

static const uint64_t P9N2_EX_XSTOP2                                               = 0x2003000Dull;
//DUPS: 2103000D,
static const uint64_t P9N2_EX_0_XSTOP2                                             = 0x2003000Dull;
//DUPS: 2103000D,
static const uint64_t P9N2_EX_1_XSTOP2                                             = 0x2203000Dull;
//DUPS: 2303000D,
static const uint64_t P9N2_EX_2_XSTOP2                                             = 0x2403000Dull;
//DUPS: 2503000D,
static const uint64_t P9N2_EX_3_XSTOP2                                             = 0x2603000Dull;
//DUPS: 2703000D,
static const uint64_t P9N2_EX_4_XSTOP2                                             = 0x2803000Dull;
//DUPS: 2903000D,
static const uint64_t P9N2_EX_5_XSTOP2                                             = 0x2A03000Dull;
//DUPS: 2B03000D,
static const uint64_t P9N2_EX_6_XSTOP2                                             = 0x2C03000Dull;
//DUPS: 2D03000D,
static const uint64_t P9N2_EX_7_XSTOP2                                             = 0x2F03000Dull;
//DUPS: 2F03000D,
static const uint64_t P9N2_EX_8_XSTOP2                                             = 0x3003000Dull;
//DUPS: 3103000D,
static const uint64_t P9N2_EX_9_XSTOP2                                             = 0x3203000Dull;
//DUPS: 3303000D,
static const uint64_t P9N2_EX_10_XSTOP2                                            = 0x3403000Dull;
//DUPS: 3503000D,
static const uint64_t P9N2_EX_11_XSTOP2                                            = 0x3603000Dull;
//DUPS: 3703000D,

static const uint64_t P9N2_C_XSTOP3                                                = 0x2003000Eull;

static const uint64_t P9N2_C_0_XSTOP3                                              = 0x2003000Eull;

static const uint64_t P9N2_C_1_XSTOP3                                              = 0x2103000Eull;

static const uint64_t P9N2_C_2_XSTOP3                                              = 0x2203000Eull;

static const uint64_t P9N2_C_3_XSTOP3                                              = 0x2303000Eull;

static const uint64_t P9N2_C_4_XSTOP3                                              = 0x2403000Eull;

static const uint64_t P9N2_C_5_XSTOP3                                              = 0x2503000Eull;

static const uint64_t P9N2_C_6_XSTOP3                                              = 0x2603000Eull;

static const uint64_t P9N2_C_7_XSTOP3                                              = 0x2703000Eull;

static const uint64_t P9N2_C_8_XSTOP3                                              = 0x2803000Eull;

static const uint64_t P9N2_C_9_XSTOP3                                              = 0x2903000Eull;

static const uint64_t P9N2_C_10_XSTOP3                                             = 0x2A03000Eull;

static const uint64_t P9N2_C_11_XSTOP3                                             = 0x2B03000Eull;

static const uint64_t P9N2_C_12_XSTOP3                                             = 0x2C03000Eull;

static const uint64_t P9N2_C_13_XSTOP3                                             = 0x2D03000Eull;

static const uint64_t P9N2_C_14_XSTOP3                                             = 0x2E03000Eull;

static const uint64_t P9N2_C_15_XSTOP3                                             = 0x2F03000Eull;

static const uint64_t P9N2_C_16_XSTOP3                                             = 0x3003000Eull;

static const uint64_t P9N2_C_17_XSTOP3                                             = 0x3103000Eull;

static const uint64_t P9N2_C_18_XSTOP3                                             = 0x3203000Eull;

static const uint64_t P9N2_C_19_XSTOP3                                             = 0x3303000Eull;

static const uint64_t P9N2_C_20_XSTOP3                                             = 0x3403000Eull;

static const uint64_t P9N2_C_21_XSTOP3                                             = 0x3503000Eull;

static const uint64_t P9N2_C_22_XSTOP3                                             = 0x3603000Eull;

static const uint64_t P9N2_C_23_XSTOP3                                             = 0x3703000Eull;

static const uint64_t P9N2_EQ_XSTOP3                                               = 0x1003000Eull;

static const uint64_t P9N2_EQ_0_XSTOP3                                             = 0x1003000Eull;

static const uint64_t P9N2_EQ_1_XSTOP3                                             = 0x1103000Eull;

static const uint64_t P9N2_EQ_2_XSTOP3                                             = 0x1203000Eull;

static const uint64_t P9N2_EQ_3_XSTOP3                                             = 0x1303000Eull;

static const uint64_t P9N2_EQ_4_XSTOP3                                             = 0x1403000Eull;

static const uint64_t P9N2_EQ_5_XSTOP3                                             = 0x1503000Eull;

static const uint64_t P9N2_EX_XSTOP3                                               = 0x2003000Eull;
//DUPS: 2103000E,
static const uint64_t P9N2_EX_0_XSTOP3                                             = 0x2003000Eull;
//DUPS: 2103000E,
static const uint64_t P9N2_EX_1_XSTOP3                                             = 0x2203000Eull;
//DUPS: 2303000E,
static const uint64_t P9N2_EX_2_XSTOP3                                             = 0x2403000Eull;
//DUPS: 2503000E,
static const uint64_t P9N2_EX_3_XSTOP3                                             = 0x2603000Eull;
//DUPS: 2703000E,
static const uint64_t P9N2_EX_4_XSTOP3                                             = 0x2803000Eull;
//DUPS: 2903000E,
static const uint64_t P9N2_EX_5_XSTOP3                                             = 0x2A03000Eull;
//DUPS: 2B03000E,
static const uint64_t P9N2_EX_6_XSTOP3                                             = 0x2C03000Eull;
//DUPS: 2D03000E,
static const uint64_t P9N2_EX_7_XSTOP3                                             = 0x2F03000Eull;
//DUPS: 2F03000E,
static const uint64_t P9N2_EX_8_XSTOP3                                             = 0x3003000Eull;
//DUPS: 3103000E,
static const uint64_t P9N2_EX_9_XSTOP3                                             = 0x3203000Eull;
//DUPS: 3303000E,
static const uint64_t P9N2_EX_10_XSTOP3                                            = 0x3403000Eull;
//DUPS: 3503000E,
static const uint64_t P9N2_EX_11_XSTOP3                                            = 0x3603000Eull;
//DUPS: 3703000E,

static const uint64_t P9N2_C_XSTOP_INTERRUPT_REG                                   = 0x200F001Cull;

static const uint64_t P9N2_C_0_XSTOP_INTERRUPT_REG                                 = 0x200F001Cull;

static const uint64_t P9N2_C_1_XSTOP_INTERRUPT_REG                                 = 0x210F001Cull;

static const uint64_t P9N2_C_2_XSTOP_INTERRUPT_REG                                 = 0x220F001Cull;

static const uint64_t P9N2_C_3_XSTOP_INTERRUPT_REG                                 = 0x230F001Cull;

static const uint64_t P9N2_C_4_XSTOP_INTERRUPT_REG                                 = 0x240F001Cull;

static const uint64_t P9N2_C_5_XSTOP_INTERRUPT_REG                                 = 0x250F001Cull;

static const uint64_t P9N2_C_6_XSTOP_INTERRUPT_REG                                 = 0x260F001Cull;

static const uint64_t P9N2_C_7_XSTOP_INTERRUPT_REG                                 = 0x270F001Cull;

static const uint64_t P9N2_C_8_XSTOP_INTERRUPT_REG                                 = 0x280F001Cull;

static const uint64_t P9N2_C_9_XSTOP_INTERRUPT_REG                                 = 0x290F001Cull;

static const uint64_t P9N2_C_10_XSTOP_INTERRUPT_REG                                = 0x2A0F001Cull;

static const uint64_t P9N2_C_11_XSTOP_INTERRUPT_REG                                = 0x2B0F001Cull;

static const uint64_t P9N2_C_12_XSTOP_INTERRUPT_REG                                = 0x2C0F001Cull;

static const uint64_t P9N2_C_13_XSTOP_INTERRUPT_REG                                = 0x2D0F001Cull;

static const uint64_t P9N2_C_14_XSTOP_INTERRUPT_REG                                = 0x2E0F001Cull;

static const uint64_t P9N2_C_15_XSTOP_INTERRUPT_REG                                = 0x2F0F001Cull;

static const uint64_t P9N2_C_16_XSTOP_INTERRUPT_REG                                = 0x300F001Cull;

static const uint64_t P9N2_C_17_XSTOP_INTERRUPT_REG                                = 0x310F001Cull;

static const uint64_t P9N2_C_18_XSTOP_INTERRUPT_REG                                = 0x320F001Cull;

static const uint64_t P9N2_C_19_XSTOP_INTERRUPT_REG                                = 0x330F001Cull;

static const uint64_t P9N2_C_20_XSTOP_INTERRUPT_REG                                = 0x340F001Cull;

static const uint64_t P9N2_C_21_XSTOP_INTERRUPT_REG                                = 0x350F001Cull;

static const uint64_t P9N2_C_22_XSTOP_INTERRUPT_REG                                = 0x360F001Cull;

static const uint64_t P9N2_C_23_XSTOP_INTERRUPT_REG                                = 0x370F001Cull;

static const uint64_t P9N2_EQ_XSTOP_INTERRUPT_REG                                  = 0x100F001Cull;

static const uint64_t P9N2_EQ_0_XSTOP_INTERRUPT_REG                                = 0x100F001Cull;

static const uint64_t P9N2_EQ_1_XSTOP_INTERRUPT_REG                                = 0x110F001Cull;

static const uint64_t P9N2_EQ_2_XSTOP_INTERRUPT_REG                                = 0x120F001Cull;

static const uint64_t P9N2_EQ_3_XSTOP_INTERRUPT_REG                                = 0x130F001Cull;

static const uint64_t P9N2_EQ_4_XSTOP_INTERRUPT_REG                                = 0x140F001Cull;

static const uint64_t P9N2_EQ_5_XSTOP_INTERRUPT_REG                                = 0x150F001Cull;

static const uint64_t P9N2_EX_XSTOP_INTERRUPT_REG                                  = 0x200F001Cull;
//DUPS: 210F001C,
static const uint64_t P9N2_EX_0_XSTOP_INTERRUPT_REG                                = 0x200F001Cull;
//DUPS: 210F001C,
static const uint64_t P9N2_EX_1_XSTOP_INTERRUPT_REG                                = 0x220F001Cull;
//DUPS: 220F001C,
static const uint64_t P9N2_EX_2_XSTOP_INTERRUPT_REG                                = 0x240F001Cull;
//DUPS: 250F001C,
static const uint64_t P9N2_EX_3_XSTOP_INTERRUPT_REG                                = 0x260F001Cull;
//DUPS: 270F001C,
static const uint64_t P9N2_EX_4_XSTOP_INTERRUPT_REG                                = 0x280F001Cull;
//DUPS: 290F001C,
static const uint64_t P9N2_EX_5_XSTOP_INTERRUPT_REG                                = 0x2A0F001Cull;
//DUPS: 2B0F001C,
static const uint64_t P9N2_EX_6_XSTOP_INTERRUPT_REG                                = 0x2C0F001Cull;
//DUPS: 2D0F001C,
static const uint64_t P9N2_EX_7_XSTOP_INTERRUPT_REG                                = 0x2E0F001Cull;
//DUPS: 2F0F001C,
static const uint64_t P9N2_EX_8_XSTOP_INTERRUPT_REG                                = 0x300F001Cull;
//DUPS: 310F001C,
static const uint64_t P9N2_EX_9_XSTOP_INTERRUPT_REG                                = 0x320F001Cull;
//DUPS: 330F001C,
static const uint64_t P9N2_EX_10_XSTOP_INTERRUPT_REG                               = 0x340F001Cull;
//DUPS: 350F001C,
static const uint64_t P9N2_EX_11_XSTOP_INTERRUPT_REG                               = 0x360F001Cull;
//DUPS: 370F001C,

static const uint64_t P9N2_C_XTRA_TRACE_MODE                                       = 0x200107D1ull;

static const uint64_t P9N2_C_0_XTRA_TRACE_MODE                                     = 0x200107D1ull;

static const uint64_t P9N2_C_1_XTRA_TRACE_MODE                                     = 0x210107D1ull;

static const uint64_t P9N2_C_2_XTRA_TRACE_MODE                                     = 0x220107D1ull;

static const uint64_t P9N2_C_3_XTRA_TRACE_MODE                                     = 0x230107D1ull;

static const uint64_t P9N2_C_4_XTRA_TRACE_MODE                                     = 0x240107D1ull;

static const uint64_t P9N2_C_5_XTRA_TRACE_MODE                                     = 0x250107D1ull;

static const uint64_t P9N2_C_6_XTRA_TRACE_MODE                                     = 0x260107D1ull;

static const uint64_t P9N2_C_7_XTRA_TRACE_MODE                                     = 0x270107D1ull;

static const uint64_t P9N2_C_8_XTRA_TRACE_MODE                                     = 0x280107D1ull;

static const uint64_t P9N2_C_9_XTRA_TRACE_MODE                                     = 0x290107D1ull;

static const uint64_t P9N2_C_10_XTRA_TRACE_MODE                                    = 0x2A0107D1ull;

static const uint64_t P9N2_C_11_XTRA_TRACE_MODE                                    = 0x2B0107D1ull;

static const uint64_t P9N2_C_12_XTRA_TRACE_MODE                                    = 0x2C0107D1ull;

static const uint64_t P9N2_C_13_XTRA_TRACE_MODE                                    = 0x2D0107D1ull;

static const uint64_t P9N2_C_14_XTRA_TRACE_MODE                                    = 0x2E0107D1ull;

static const uint64_t P9N2_C_15_XTRA_TRACE_MODE                                    = 0x2F0107D1ull;

static const uint64_t P9N2_C_16_XTRA_TRACE_MODE                                    = 0x300107D1ull;

static const uint64_t P9N2_C_17_XTRA_TRACE_MODE                                    = 0x310107D1ull;

static const uint64_t P9N2_C_18_XTRA_TRACE_MODE                                    = 0x320107D1ull;

static const uint64_t P9N2_C_19_XTRA_TRACE_MODE                                    = 0x330107D1ull;

static const uint64_t P9N2_C_20_XTRA_TRACE_MODE                                    = 0x340107D1ull;

static const uint64_t P9N2_C_21_XTRA_TRACE_MODE                                    = 0x350107D1ull;

static const uint64_t P9N2_C_22_XTRA_TRACE_MODE                                    = 0x360107D1ull;

static const uint64_t P9N2_C_23_XTRA_TRACE_MODE                                    = 0x370107D1ull;

static const uint64_t P9N2_EQ_XTRA_TRACE_MODE                                      = 0x100107D1ull;

static const uint64_t P9N2_EQ_0_XTRA_TRACE_MODE                                    = 0x100107D1ull;

static const uint64_t P9N2_EQ_1_XTRA_TRACE_MODE                                    = 0x110107D1ull;

static const uint64_t P9N2_EQ_2_XTRA_TRACE_MODE                                    = 0x120107D1ull;

static const uint64_t P9N2_EQ_3_XTRA_TRACE_MODE                                    = 0x130107D1ull;

static const uint64_t P9N2_EQ_4_XTRA_TRACE_MODE                                    = 0x140107D1ull;

static const uint64_t P9N2_EQ_5_XTRA_TRACE_MODE                                    = 0x150107D1ull;

static const uint64_t P9N2_EX_XTRA_TRACE_MODE                                      = 0x200107D1ull;
//DUPS: 210107D1,
static const uint64_t P9N2_EX_0_XTRA_TRACE_MODE                                    = 0x200107D1ull;
//DUPS: 210107D1,
static const uint64_t P9N2_EX_1_XTRA_TRACE_MODE                                    = 0x220107D1ull;
//DUPS: 230107D1,
static const uint64_t P9N2_EX_2_XTRA_TRACE_MODE                                    = 0x240107D1ull;
//DUPS: 250107D1,
static const uint64_t P9N2_EX_3_XTRA_TRACE_MODE                                    = 0x260107D1ull;
//DUPS: 270107D1,
static const uint64_t P9N2_EX_4_XTRA_TRACE_MODE                                    = 0x280107D1ull;
//DUPS: 290107D1,
static const uint64_t P9N2_EX_5_XTRA_TRACE_MODE                                    = 0x2A0107D1ull;
//DUPS: 2B0107D1,
static const uint64_t P9N2_EX_6_XTRA_TRACE_MODE                                    = 0x2C0107D1ull;
//DUPS: 2D0107D1,
static const uint64_t P9N2_EX_7_XTRA_TRACE_MODE                                    = 0x2F0107D1ull;
//DUPS: 2F0107D1,
static const uint64_t P9N2_EX_8_XTRA_TRACE_MODE                                    = 0x300107D1ull;
//DUPS: 310107D1,
static const uint64_t P9N2_EX_9_XTRA_TRACE_MODE                                    = 0x320107D1ull;
//DUPS: 330107D1,
static const uint64_t P9N2_EX_10_XTRA_TRACE_MODE                                   = 0x340107D1ull;
//DUPS: 350107D1,
static const uint64_t P9N2_EX_11_XTRA_TRACE_MODE                                   = 0x360107D1ull;
//DUPS: 370107D1,
#endif

